Dim oCluster, oGroup
Dim sClusterName, sCluterGroup, sResourceName, sServiceName

QuitWithErrorIfNotCSript()
if WScript.Arguments.Count < 4 then 
	WScript.Echo "Wrong number of command line arguments. Please provide cluster name, cluster group, resource name and VBECS service name"
	WScript.Quit(1)
end if


WScript.Quit( DoProcess() )


private function DoProcess()
    On Error Resume Next
    
    sClusterName = WScript.Arguments(0)
    sCluterGroup = WScript.Arguments(1)
    sResourceName = WScript.Arguments(2)
    sServiceName = WScript.Arguments(3)
	' Create the Cluster object.
	Set oCluster = CreateObject( "MSCluster.Cluster" )
	' Open the cluster. Empty string means open the local cluster.
	oCluster.Open( sClusterName )
    ' Get Cluster group.
    Set oGroup = oCluster.ResourceGroups.Item( sCluterGroup )
    If oGroup is Nothing Then
        WScript.Echo "Error: cluster group wasn't found ["& sCluterGroup &"]"
        Set oCluster = Nothing
        DoProcess = 1
        exit function
    End If
    ' Get Cluster resource.
    Dim oGroupResources, oResource, oProperties
    Set oGroupResources = oGroup.Resources
    Set oResource = oGroupResources.Item( sResourceName ) 
    If err.number <> 0 Then
        WScript.Echo "Error: cluster resource wasn't found ["& sResourceName &"]"
        Set oGroup = Nothing
        Set oCluster = Nothing
        DoProcess = 1
        exit function
    End If

    ' Set the Private Properties
    Set oProperties = oResource.PrivateProperties
    oProperties.Item("ServiceName") = sServiceName
    oProperties.SaveChanges
    
    ' Release objects
    Set oProperties = Nothing
    Set oResource = Nothing
    Set oGroup = Nothing
	Set oCluster = Nothing
end function

private sub QuitWithErrorIfNotCSript()
	If IsCscript() Then exit sub
	WScript.Echo "Please run this script from a command line using cscript."
	WScript.Quit(1)	
end sub

private function IsCscript()
  IsCscript = False

  If InStrRev(LCase(WScript.FullName), "cscript.exe", -1) Then
    IsCscript = True
  End If
end function    