Dim oGroup
Dim oCluster, oClusterName, oEnv
Dim testsrvs, prodsrvs, smon, i
smon = "VBECS Service Monitor"
prodsrvs = Array("VBECS Scheduled Report Runner", "VBECS HL7 Multi Listener", "VBECS CPRS HL7 Client Monitor", "VBECS VistALink RPC XML Listener")
testsrvs = Array("VBECS Test Scheduled Report Runner", "VBECS Test HL7 Multi Listener", "VBECS Test CPRS HL7 Client Monitor", "VBECS Test VistALink RPC XML Listener")

On Error Goto 0 

QuitWithErrorIfNotCSript()
if WScript.Arguments.Count < 2 then 
	WScript.Echo "Wrong number of command line arguments. Please provide cluster name and VBECS environment"
	WScript.Quit(1)
end if


WScript.Quit( DoProcessClusterGroupCreation() )


private function DoProcessClusterGroupCreation()
  Dim srvs
	oClusterName = WScript.Arguments(0)
  if IsNull(WScript.Arguments(1)) = true then
	  	WScript.Echo "Wrong VBECS environment specifyed. Please specify prod, test or sm"
	  	return 1
	end if
	oEnv = UCase(WScript.Arguments(1))
	if oEnv = "PROD" then
	  srvs = prodsrvs
	end if
	if oEnv = "TEST" then
	  srvs = testsrvs
	end if
  if oEnv = "SM" or oEnv = "SERVICEMONITOR" then
    oEnv = "SM"
	  srvs = Array(smon)
	end if
	
	' Create the Cluster object.
	Set oCluster = CreateObject( "MSCluster.Cluster" )
	' Open the cluster. Empty string means open the local cluster.
	oCluster.Open( oClusterName )
	' Create or open the group.
	Set oGroup = Nothing	
  GetGroup oCluster, oEnv, oGroup
  If oGroup is Nothing Then
    ' The Cluster group wasn't found
    DoProcessClusterGroupCreation = 0
    Exit Function
  End If
  
	For i = 0 To UBound(srvs)
        ' remove the resource.
        RemoveResource oGroup, srvs( i )
	Next
	
	RemoveGroup oCluster, oEnv, oGroup
	Set oGroup = Nothing
	Set oCluster = Nothing
end function

Sub GetGroup( oCluster, oEnv, oGroup )
    On Error Resume Next
    Set oGroup = oCluster.ResourceGroups.Item( "VBECS Group " & oEnv )
    If oGroup is Nothing Then
      WScript.Echo "Group wasn't found - skip it [err: " & Err.number & "]"
    Else
      'bring cluster group off line
      oGroup.Offline 120
    End If
End Sub

Sub RemoveGroup( oCluster, oEnv, oGroup )
    If oGroup.Resources.Count <> 0 Then
      WScript.Echo "warning: cluster group is not empty [VBECS Group " & oEnv & "]"
      WScript.Quit(1)
    End If
    oCluster.ResourceGroups.DeleteItem( "VBECS Group " & oEnv )
End Sub

Sub RemoveResource( oGroup, Service )
    On Error Resume Next
    Dim oGroupResources
    Dim oResource

    Set oGroupResources = oGroup.Resources
    Set oResource = oGroupResources.Item( Service ) 
    
    If Err.Number <> 0 Then
      WScript.Echo "warning: resource doesn't exist ["& Service &"]"
    Else
      oGroupResources.DeleteItem( Service )
    End If
    
    Set oGroupResources = Nothing
    Set oResource = Nothing
End Sub

private sub QuitWithErrorIfNotCSript()
	If IsCscript() Then exit sub
	WScript.Echo "Please run this script from a command line using cscript."
	WScript.Quit(1)	
end sub

private function IsCscript()
  IsCscript = False

  If InStrRev(LCase(WScript.FullName), "cscript.exe", -1) Then
    IsCscript = True
  End If
end function    