/*****************************************************************************************
* VBECS Patch        (Build 1.6.0.7 01) Combined 1.5.2.2 to 1.6.0.6 and 1.6.0.6 to 1.6.0.7
******************************************************************************************/


/*****************************************************************************************
* VBECS Patch        (Build 1.6.0.7 01 - from 1.5.2.2 to 1.6.0.6)
*****************************************************************************************/
USE VBECS_V1_PROD
GO

/*****************************************************************************************
*         NEW TABLE
*****************************************************************************************/
/*****************************************************************************************
   Create the new ApplicationOfRecord table
*****************************************************************************************/
CREATE TABLE dbo.ApplicationOfRecord
        (
        ApplicationOfRecordId tinyint NOT NULL IDENTITY(1, 1),
        ApplicationName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] [timestamp] NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_ApplicationOfRecord_LastUpdateFunctionId DEFAULT (0)
        ) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'The application that originally sent data to VBECS.', 'USER', N'dbo', 'TABLE', N'ApplicationOfRecord', NULL, NULL
GO
sp_addextendedproperty N'MS_Description', N'Identifies the application that recorded an entry in VBECS.', 'USER', N'dbo', 'TABLE', N'ApplicationOfRecord', 'COLUMN', N'ApplicationOfRecordId'
GO
sp_addextendedproperty N'MS_Description', N'The name of the application that recorded the record into VBECS.', 'USER', N'dbo', 'TABLE', N'ApplicationOfRecord', 'COLUMN', N'ApplicationName'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'ApplicationOfRecord', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'ApplicationOfRecord', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'ApplicationOfRecord', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'ApplicationOfRecord', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.ApplicationOfRecord ADD 
        CONSTRAINT PK_ApplicationOfRecord PRIMARY KEY CLUSTERED 
        (
                ApplicationOfRecordId
        ) ON [PRIMARY] 
GO

/*****************************************************************************************
   Create the new BceStatus table
*****************************************************************************************/
CREATE TABLE dbo.BceStatus
        (
        BceStatusCode char (2) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        BceStatusText varchar (75) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_BceStatus_LastUpdateFunctionId DEFAULT (0)
        ) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'The current state of the ordered unit in BCE.', 'USER', N'dbo', 'TABLE', N'BceStatus', 'COLUMN', N'BceStatusCode'
GO
sp_addextendedproperty N'MS_Description', N'Describes the BCE status code.', 'USER', N'dbo', 'TABLE', N'BceStatus', 'COLUMN', N'BceStatusText'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'BceStatus', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'BceStatus', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'BceStatus', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'BceStatus', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.BceStatus ADD 
        CONSTRAINT PK_BceStatus PRIMARY KEY CLUSTERED 
        (
                BceStatusCode
        ) ON [PRIMARY] 
GO

/*****************************************************************************************
   Create the new BloodProductModification table
*****************************************************************************************/
CREATE TABLE dbo.BloodProductModification
(
BloodProductModificationGuid uniqueidentifier NOT NULL,
ProductModificationCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
FromBloodProductGuid uniqueidentifier NOT NULL,
ToBloodProductGuid uniqueidentifier NOT NULL,
MethodSelect bit NOT NULL,
ExpirationDateRule int NOT NULL,
LastUpdateDate datetime NOT NULL,
LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
[RowVersion] timestamp NOT NULL,
LastUpdateFunctionId int NOT NULL CONSTRAINT DF_BloodProductModification_LastUpdateFunctionId DEFAULT (0)
) ON [PRIMARY]

GO

sp_addextendedproperty N'MS_Description', N'Identifies a specific instance of a modification that is allowed for a specific blood product.', 'USER', N'dbo', 'TABLE', N'BloodProductModification', 'COLUMN', N'BloodProductModificationGuid'
GO
sp_addextendedproperty N'MS_Description', N'Describes a specific modification that is allowed for the associated blood unit.', 'USER', N'dbo', 'TABLE', N'BloodProductModification', 'COLUMN', N'ProductModificationCode'
GO
sp_addextendedproperty N'MS_Description', N'The uniqueidentifier for the blood product to be modified.', 'USER', N'dbo', 'TABLE', N'BloodProductModification', 'COLUMN', N'FromBloodProductGuid'
GO
sp_addextendedproperty N'MS_Description', N'The uniqueidentifier for the blood product that results from the modification.', 'USER', N'dbo', 'TABLE', N'BloodProductModification', 'COLUMN', N'ToBloodProductGuid'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the product to be modified is open or closed.', 'USER', N'dbo', 'TABLE', N'BloodProductModification', 'COLUMN', N'MethodSelect'
GO
sp_addextendedproperty N'MS_Description', N'The rule for calculating the expiration date for the blood unit that was created from the modification.', 'USER', N'dbo', 'TABLE', N'BloodProductModification', 'COLUMN', N'ExpirationDateRule'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'BloodProductModification', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'BloodProductModification', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'BloodProductModification', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'BloodProductModification', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.BloodProductModification ADD 
        CONSTRAINT PK_BloodProductModification PRIMARY KEY NONCLUSTERED 
        (
                BloodProductModificationGuid
        ) ON [PRIMARY] 
GO

CREATE CLUSTERED INDEX IX_BloodProductModification ON dbo.BloodProductModification (ProductModificationCode, FromBloodProductGuid) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_BloodProductModification_FromBloodProductGuid ON dbo.BloodProductModification (FromBloodProductGuid) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_BloodProductModification_ProductModificationCode ON dbo.BloodProductModification (ProductModificationCode) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_BloodProductModification_ToBloodProductGuid ON dbo.BloodProductModification (ToBloodProductGuid) ON [PRIMARY]
GO

/*****************************************************************************************
   Create the new ExceptionElectronicTransfusion table
*****************************************************************************************/
CREATE TABLE dbo.ExceptionElectronicTransfusion
        (
        ExceptionElectronicTransfusionGuid uniqueidentifier NOT NULL,
        ExceptionTypeId int NOT NULL,
        PatientId varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        PatientName varchar (60) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        UnitId varchar (13) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        UnitProductCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        PatientTransfusionGuid uniqueidentifier NOT NULL,
        BedsideVerificationDate datetime NULL,
        BedsideVerificationUnitManualEntryReason varchar (2000) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TransfusionStartDateTime datetime NULL,
        Transfusionist1Id varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        Transfusionist2Id varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TransfusionEndDateTime datetime NULL,
        TransfusionLocation varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TransfusedVolume int NULL,
        PatientTransfusionComment varchar (1000) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InterruptionIndicator bit NULL,
        ReactionIndicator bit NULL,
        ReactionSymptoms varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ExceptionUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        ExceptionDate datetime NOT NULL,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
        ) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'Identifies an instance of an electronic transfusion exception.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'ExceptionElectronicTransfusionGuid'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a classification of exceptions.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'ExceptionTypeId'
GO
sp_addextendedproperty N'MS_Description', N'The VistA identifier of the patient who was transfused.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'PatientId'
GO
sp_addextendedproperty N'MS_Description', N'The name of the patient who was transfused.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'PatientName'
GO
sp_addextendedproperty N'MS_Description', N'The logical identifier of a specific blood unit.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'UnitId'
GO
sp_addextendedproperty N'MS_Description', N'A standard 4-digit code for the blood product type.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'UnitProductCode'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific blood transfusion for a patient.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'PatientTransfusionGuid'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the transfusionists verified the patient and unit compatibility at the bedside prior to the transfusion.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'BedsideVerificationDate'
GO
sp_addextendedproperty N'MS_Description', N'The reason for manual bedside verification of the unit.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'BedsideVerificationUnitManualEntryReason'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the transfusion of the associated unit was started.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'TransfusionStartDateTime'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the first bedside verifier.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'Transfusionist1Id'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the second bedside verifier.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'Transfusionist2Id'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the transfusion of the associated unit was completed.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'TransfusionEndDateTime'
GO
sp_addextendedproperty N'MS_Description', N'The physical location of the patient when the transfusion occurred.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'TransfusionLocation'
GO
sp_addextendedproperty N'MS_Description', N'The amount of blood transfused for this transfusion.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'TransfusedVolume'
GO
sp_addextendedproperty N'MS_Description', N'General comments pertaining to the transfusion.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'PatientTransfusionComment'
GO
sp_addextendedproperty N'MS_Description', N'Indicates that the transfusion was stopped before it was complete.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'InterruptionIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Indicates that the patient did or was suspected to have a reaction to the transfusion.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'ReactionIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Details of the indications associated with the patient''s reaction to the transfusion.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'ReactionSymptoms'
GO
sp_addextendedproperty N'MS_Description', N'The user that created the exception event.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'ExceptionUser'
GO
sp_addextendedproperty N'MS_Description', N'The date of the exception event.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'ExceptionDate'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the division in which the exception event took place.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'DivisionCode'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'ExceptionElectronicTransfusion', 'COLUMN', N'LastUpdateUser'
GO

ALTER TABLE dbo.ExceptionElectronicTransfusion ADD 
        CONSTRAINT PK_ExceptionElectronicTransfusion PRIMARY KEY CLUSTERED 
        (
                ExceptionElectronicTransfusionGuid
        ) ON [PRIMARY] 
GO

CREATE NONCLUSTERED INDEX IX_ExceptionElectronicTransfusion_ExceptionTypeId ON dbo.ExceptionElectronicTransfusion (ExceptionTypeId) ON [PRIMARY]
GO

/*****************************************************************************************
   Create the new PatientLocation table
*****************************************************************************************/
CREATE TABLE dbo.PatientLocation
        (
        PatientLocationGuid uniqueidentifier NOT NULL,
        PatientGuid uniqueidentifier NOT NULL,
        LocationName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LocationRoomBed varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InPatientIndicator bit NULL,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_PatientLocation_LastUpdateFunctionId DEFAULT (0)
        ) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'A unique identifier for a patient location generated by VBECS.', 'USER', N'dbo', 'TABLE', N'PatientLocation', 'COLUMN', N'PatientLocationGuid'
GO
sp_addextendedproperty N'MS_Description', N'A unique identifier for a patient generated by VBECS.', 'USER', N'dbo', 'TABLE', N'PatientLocation', 'COLUMN', N'PatientGuid'
GO
sp_addextendedproperty N'MS_Description', N'The name of the hospital location.', 'USER', N'dbo', 'TABLE', N'PatientLocation', 'COLUMN', N'LocationName'
GO
sp_addextendedproperty N'MS_Description', N'The most current room and bed the patient was in.', 'USER', N'dbo', 'TABLE', N'PatientLocation', 'COLUMN', N'LocationRoomBed'
GO
sp_addextendedproperty N'MS_Description', N'Indicates that the patient is admitted or is an out patient.', 'USER', N'dbo', 'TABLE', N'PatientLocation', 'COLUMN', N'InPatientIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Identifies an organizational unit of a VA Medical Center.', 'USER', N'dbo', 'TABLE', N'PatientLocation', 'COLUMN', N'DivisionCode'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'PatientLocation', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'PatientLocation', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'PatientLocation', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'PatientLocation', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.PatientLocation ADD 
        CONSTRAINT PK_PatientLocation PRIMARY KEY CLUSTERED 
        (
                PatientLocationGuid
        ) ON [PRIMARY] 
GO

CREATE NONCLUSTERED INDEX IX_PatientLocation_PatientGuid ON dbo.PatientLocation (PatientGuid) ON [PRIMARY]
GO

/*****************************************************************************************
   Create the new ProductModificationAttribute table
*****************************************************************************************/
CREATE TABLE dbo.ProductModificationAttribute
(
ProductModificationAttributeId int NOT NULL IDENTITY(1, 1),
ProductModificationCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
OptionalAttribute char (2) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
LastUpdateDate datetime NOT NULL,
LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
[RowVersion] timestamp NOT NULL,
LastUpdateFunctionId int NOT NULL CONSTRAINT DF_ProductModificationAttribute_LastUpdateFunctionId DEFAULT (0)
) ON [PRIMARY]

GO

sp_addextendedproperty N'MS_Description', N'Identifies a specific optional attribute for a blood product modification.', 'USER', N'dbo', 'TABLE', N'ProductModificationAttribute', 'COLUMN', N'ProductModificationAttributeId'
GO
sp_addextendedproperty N'MS_Description', N'Describes a specific modification that is allowed for the associated blood unit.', 'USER', N'dbo', 'TABLE', N'ProductModificationAttribute', 'COLUMN', N'ProductModificationCode'
GO
sp_addextendedproperty N'MS_Description', N'This is used to add optional attributes to modifiable blood product targets.  You can either add a specific optional attribute or an attribute group.  Attribute groups have the attribute group code followed by a "$".', 'USER', N'dbo', 'TABLE', N'ProductModificationAttribute', 'COLUMN', N'OptionalAttribute'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'ProductModificationAttribute', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'ProductModificationAttribute', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'ProductModificationAttribute', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'ProductModificationAttribute', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.ProductModificationAttribute ADD 
        CONSTRAINT PK_ProductModificationAttribute PRIMARY KEY NONCLUSTERED 
        (
                ProductModificationAttributeId
        ) ON [PRIMARY] 
GO

CREATE UNIQUE CLUSTERED INDEX IX_ProductModificationAttribute_ProductModificationCode ON dbo.ProductModificationAttribute (ProductModificationCode, OptionalAttribute) ON [PRIMARY]
GO

/*****************************************************************************************
*         TABLE CHANGES
*****************************************************************************************/
/*****************************************************************************************
   Create a temporary AntigenType table and save the original data
*****************************************************************************************/
IF OBJECT_ID(N'tempdb..#AntigenType') IS NOT NULL
        DROP TABLE #AntigenType
GO

CREATE TABLE dbo.#AntigenType
        (
        AntigenTypeId int NOT NULL,
        AntigenTypeName varchar (12) COLLATE SQL_Latin1_General_CP1_CS_AS NOT NULL,
        SortColumn smallint NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        LastUpdateFunctionId int NOT NULL
        )  ON [PRIMARY]
GO

INSERT INTO #AntigenType 
        (AntigenTypeId, AntigenTypeName, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          AntigenTypeId, AntigenTypeName, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.AntigenType
GO

/*****************************************************************************************
   Drop the constraints from the AntigenType table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_AntibodyAntigen_AntigenType') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.AntibodyAntigen DROP CONSTRAINT FK_AntibodyAntigen_AntigenType
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_AntigenTest_AntigenType') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.AntigenTest DROP CONSTRAINT FK_AntigenTest_AntigenType
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_BloodUnitAntigen_AntigenType') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.BloodUnitAntigen DROP CONSTRAINT FK_BloodUnitAntigen_AntigenType
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PatientTransfusionRequirement_AntigenType') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PatientTransfusionRequirement DROP CONSTRAINT FK_PatientTransfusionRequirement_AntigenType
GO

/*****************************************************************************************
   Create the updated AntigenType table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.AntigenType') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.AntigenType
GO

CREATE TABLE dbo.AntigenType 
        (
        AntigenTypeId int NOT NULL,
        AntigenTypeName varchar (12) COLLATE SQL_Latin1_General_CP1_CS_AS NOT NULL,
        SortColumn smallint NOT NULL,
        BceSortColumn smallint NOT NULL CONSTRAINT DF_AntigenType_BceSortColumn DEFAULT (0),
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_AntigenType_LastUpdateFunctionId DEFAULT(0)
        ) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'Identifies a specific blood antigen.', 'USER', N'dbo', 'TABLE', N'AntigenType', 'COLUMN', N'AntigenTypeId'
GO
sp_addextendedproperty N'MS_Description', N'The name of a specific blood antigen.', 'USER', N'dbo', 'TABLE', N'AntigenType', 'COLUMN', N'AntigenTypeName'
GO
sp_addextendedproperty N'MS_Description', N'A number that facilitates presenting values in a specified order.', 'USER', N'dbo', 'TABLE', N'AntigenType', 'COLUMN', N'SortColumn'
GO
sp_addextendedproperty N'MS_Description', N'A number that facilitates sending values to the BCE interface in a specified order.', 'USER', N'dbo', 'TABLE', N'AntigenType', 'COLUMN', N'BceSortColumn'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'AntigenType', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'AntigenType', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'AntigenType', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'AntigenType', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.AntigenType ADD 
        CONSTRAINT PK_AntigenType PRIMARY KEY CLUSTERED 
        (
                AntigenTypeId
        ) ON [PRIMARY] 
GO

ALTER TABLE dbo.AntigenType ADD 
        CONSTRAINT UCK_AntigenType UNIQUE NONCLUSTERED  
        (
                AntigenTypeName
        ) ON [PRIMARY]
GO


/*****************************************************************************************
   Reload the updated AntigenType table 
*****************************************************************************************/
INSERT INTO AntigenType 
        (AntigenTypeId, AntigenTypeName, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          AntigenTypeId, AntigenTypeName, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.#AntigenType
GO
IF OBJECT_ID(N'tempdb..#AntigenType') IS NOT NULL
        DROP TABLE #AntigenType
GO


/*****************************************************************************************
   Fix the default constraint for the LastUpdateFunctionId on the AntibodyType table 
*****************************************************************************************/
ALTER TABLE dbo.AntibodyType DROP CONSTRAINT DF__AntibodyT__LastU__1BA066B0
GO
ALTER TABLE dbo.AntibodyType ADD CONSTRAINT DF_AntibodyType_LastUpdateFunctionId DEFAULT (0) FOR LastUpdateFunctionId
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'AntibodyType', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'AntibodyType', 'COLUMN', N'LastUpdateFunctionId'
GO

/*****************************************************************************************
   Create a temporary BloodProduct table and save the original data
*****************************************************************************************/
IF OBJECT_ID(N'tempdb..#BloodProduct') IS NOT NULL
        DROP TABLE #BloodProduct
GO

CREATE TABLE dbo.#BloodProduct
        (
        BloodProductGuid uniqueidentifier NOT NULL,
        ProductName varchar(175) NOT NULL,
        ProductShortName varchar(100) NOT NULL,
        ProductTypeCode char(4) NOT NULL,
        ProductAttributeForm varchar(40) NOT NULL,
        ProductVolume smallint NULL,
        ProductCode char(5) NOT NULL,
        MaximumStorageTime decimal(9, 0) NOT NULL,
        CrossmatchRequiredIndicator bit NOT NULL,
        ProductModificationIndicator bit NOT NULL,
        ProductCodeIndicator  bit  NOT NULL,
        RetireDate datetime NULL,
        RecordStatusCode char(1) NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        LastUpdateFunctionId int NOT NULL
        )  ON [PRIMARY]
GO

INSERT INTO #BloodProduct 
        (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, 
         MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, RetireDate,
         RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, 
         MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, RetireDate,
         RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.BloodProduct
GO

/*****************************************************************************************
   Drop the constraints from the BloodProduct table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_BloodUnit_BloodProduct') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.BloodUnit DROP CONSTRAINT FK_BloodUnit_BloodProduct
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_BloodUnitShipment_BloodProduct') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.BloodUnitShipment DROP CONSTRAINT FK_BloodUnitShipment_BloodProduct
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_HcpcsAssignment_BloodProduct') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.HcpcsAssignment DROP CONSTRAINT FK_HcpcsAssignment_BloodProduct
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ProductShipper_BloodProduct') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ProductShipper DROP CONSTRAINT FK_ProductShipper_BloodProduct
GO


/*****************************************************************************************
   Create the updated BloodProduct table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.BloodProduct') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.BloodProduct
GO

CREATE TABLE dbo.BloodProduct (
        BloodProductGuid uniqueidentifier NOT NULL,
        ProductName varchar(175) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        ProductShortName varchar(50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        ProductTypeCode char(4) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        ProductAttributeForm varchar(40) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        ProductVolume smallint NULL,
        ProductCode char(5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        MaximumStorageTime decimal(9, 0) NOT NULL,
        CrossmatchRequiredIndicator bit NOT NULL,
        ProductModificationIndicator bit NOT NULL,
        ProductCodeIndicator bit NOT NULL,
        OriginalProductTypeCode char(4) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        RetireDate datetime NULL,
        RecordStatusCode char(1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_BloodProduct_LastUpdateFunctionId DEFAULT(0)
) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'Identifies a specific instance of a blood product.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'BloodProductGuid'
GO
sp_addextendedproperty N'MS_Description', N'The specifically formatted, full text name of a blood product.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'ProductName'
GO
sp_addextendedproperty N'MS_Description', N'A shortened version of the full name of a blood product.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'ProductShortName'
GO
sp_addextendedproperty N'MS_Description', N'A classification of blood products. Also known as Blood Component.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'ProductTypeCode'
GO
sp_addextendedproperty N'MS_Description', N'Abbreviated attribute codes that identify core conditions and other attributes for the blood product.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'ProductAttributeForm'
GO
sp_addextendedproperty N'MS_Description', N'The average amount of a unit of this blood product measured in milliliters.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'ProductVolume'
GO
sp_addextendedproperty N'MS_Description', N'The standard 5-digit code for the blood product.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'ProductCode'
GO
sp_addextendedproperty N'MS_Description', N'The maximum number of hours that a unit of this blood product can remain in storage.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'MaximumStorageTime'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether units of this blood product type require crossmatching.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'CrossmatchRequiredIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the blood product can be modified.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'ProductModificationIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the record is for an ISBT128 product code or a Codabar product code.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'ProductCodeIndicator'
GO
sp_addextendedproperty N'MS_Description', N'This is the original product type code for a blood product before DR 3010 changes.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'OriginalProductTypeCode'
GO
sp_addextendedproperty N'MS_Description', N'The date the blood product was retired from use.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'RetireDate'
GO
sp_addextendedproperty N'MS_Description', N'Indicates the state of the associated record.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'RecordStatusCode'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'BloodProduct', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.BloodProduct ADD 
        CONSTRAINT PK_BloodProduct PRIMARY KEY CLUSTERED 
        (
                BloodProductGuid
        ) ON [PRIMARY] 
GO
CREATE UNIQUE NONCLUSTERED INDEX CK_BloodProduct ON dbo.BloodProduct (ProductTypeCode, ProductCode)
GO
CREATE NONCLUSTERED INDEX IX_BloodProduct_ProductTypeCode ON dbo.BloodProduct (ProductTypeCode)
GO


/*****************************************************************************************
   Reload the updated BloodProduct table 
*****************************************************************************************/
INSERT INTO dbo.BloodProduct 
        (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, 
         MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode,
         RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, 
         MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, '',
         RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM #BloodProduct
GO
IF OBJECT_ID(N'tempdb..#BloodProduct') IS NOT NULL
        DROP TABLE #BloodProduct
GO

/*****************************************************************************************
   Update the LastUpdateDate description on the BloodUnit table 
*****************************************************************************************/
sp_updateextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'BloodUnit', 'COLUMN', N'LastUpdateDate'
GO
ALTER TABLE dbo.BloodUnit DROP CONSTRAINT CK_BloodUnit
GO

/*****************************************************************************************
   Create a temporary ComponentRequirement table and save the original data
*****************************************************************************************/
IF OBJECT_ID(N'tempdb..#ComponentRequirement') IS NOT NULL
        DROP TABLE #ComponentRequirement
GO

CREATE TABLE dbo.#ComponentRequirement
        (
        ComponentRequirementId tinyint NOT NULL,
        ComponentRequirementText varchar (50) NOT NULL,
        SortColumn smallint NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        LastUpdateFunctionId int NOT NULL
        )  ON [PRIMARY]
GO

INSERT INTO #ComponentRequirement 
        (ComponentRequirementId, ComponentRequirementText, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          ComponentRequirementId, ComponentRequirementText, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.ComponentRequirement
GO

/*****************************************************************************************
   Drop the constraints from the ComponentRequirement table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PatientTransfusionRequirement_ComponentRequirement') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PatientTransfusionRequirement DROP CONSTRAINT FK_PatientTransfusionRequirement_ComponentRequirement
GO

/*****************************************************************************************
   Create the updated ComponentRequirement table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.ComponentRequirement') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.ComponentRequirement
GO

CREATE TABLE dbo.ComponentRequirement 
        (
        ComponentRequirementId tinyint NOT NULL,
        ComponentRequirementText varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        ComponentRequirementAbbreviation char (4) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        SortColumn smallint NOT NULL,
        BceSortColumn smallint NOT NULL CONSTRAINT DF_ComponentRequirement_BceSortColumn DEFAULT (0),
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_ComponentRequirement_LastUpdateFunctionId DEFAULT(0)
        ) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'Identifies a specific requirement for a patient component transfusion.', 'USER', N'dbo', 'TABLE', N'ComponentRequirement', 'COLUMN', N'ComponentRequirementId'
GO
sp_addextendedproperty N'MS_Description', N'The text describing the transfusion requirement for a component.', 'USER', N'dbo', 'TABLE', N'ComponentRequirement', 'COLUMN', N'ComponentRequirementText'
GO
sp_addextendedproperty N'MS_Description', N'The abbreviation that is sent to BCE system.', 'USER', N'dbo', 'TABLE', N'ComponentRequirement', 'COLUMN', N'ComponentRequirementAbbreviation'
GO
sp_addextendedproperty N'MS_Description', N'A number that facilitates presenting values in a specified order.', 'USER', N'dbo', 'TABLE', N'ComponentRequirement', 'COLUMN', N'SortColumn'
GO
sp_addextendedproperty N'MS_Description', N'A number that facilitates sending values to the BCE interface in a specified order.', 'USER', N'dbo', 'TABLE', N'ComponentRequirement', 'COLUMN', N'BceSortColumn'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'ComponentRequirement', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'ComponentRequirement', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'ComponentRequirement', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'ComponentRequirement', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.ComponentRequirement ADD 
        CONSTRAINT PK_ComponentRequirement PRIMARY KEY CLUSTERED 
        (
                ComponentRequirementId
        ) ON [PRIMARY] 
GO

/*****************************************************************************************
   Reload the updated ComponentRequirement table 
*****************************************************************************************/
INSERT INTO dbo.ComponentRequirement 
        (ComponentRequirementId, ComponentRequirementText, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          ComponentRequirementId, ComponentRequirementText, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.#ComponentRequirement
GO
IF OBJECT_ID(N'tempdb..#ComponentRequirement') IS NOT NULL
        DROP TABLE #ComponentRequirement
GO

/*****************************************************************************************
   Create a temporary DailyQcWorklist table and save the original data
*****************************************************************************************/
IF OBJECT_ID(N'tempdb..#DailyQcWorklist') IS NOT NULL
        DROP TABLE #DailyQcWorklist
GO

CREATE TABLE dbo.#DailyQcWorklist
        (
        DailyQcWorklistGuid uniqueidentifier NOT NULL,
        DailyQcExpirationDate datetime NULL,
        DailyUseIndicator bit NOT NULL,
        PartiallyTestedIndicator bit NOT NULL,
        RackGuid uniqueidentifier NULL,
        DivisionCode char(5) NOT NULL,
        RecordStatusCode char(1) NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        LastUpdateFunctionId int NOT NULL
        )  ON [PRIMARY]
GO

INSERT INTO #DailyQcWorklist 
        (DailyQcWorklistGuid, DailyQcExpirationDate, DailyUseIndicator, PartiallyTestedIndicator, RackGuid, DivisionCode,
         RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          DailyQcWorklistGuid, DailyQcExpirationDate, DailyUseIndicator, PartiallyTestedIndicator, RackGuid, DivisionCode,
         RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.DailyQcWorklist
GO

/*****************************************************************************************
   Drop the constraints from the DailyQcWorklist table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_RackLot_DailyQcWorklist') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.RackLot DROP CONSTRAINT FK_RackLot_DailyQcWorklist
GO

/*****************************************************************************************
   Create the updated DailyQcWorklist table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.DailyQcWorklist') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.DailyQcWorklist
GO

CREATE TABLE dbo.DailyQcWorklist (
        DailyQcWorklistGuid uniqueidentifier NOT NULL,
        DailyQcExpirationDate datetime NULL,
        DailyUseIndicator bit NOT NULL CONSTRAINT DF_DailyQcWorklist_DailyUseIndicator DEFAULT (1),
        PartiallyTestedIndicator bit NOT NULL CONSTRAINT DF_DailyQcWorklist_PartiallyTestedIndicator DEFAULT (0),
        RackGuid uniqueidentifier NULL,
        QCOfflineIndicator bit NOT NULL CONSTRAINT DF_DailyQcWorklist_QCOfflineIndicator DEFAULT (0),
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        RecordStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_DailyQcWorklist_LastUpdateFunctionId DEFAULT (0)
) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'Identifies an instance of a rack test result for a specific date.', 'USER', N'dbo', 'TABLE', N'DailyQcWorklist', 'COLUMN', N'DailyQcWorklistGuid'
GO
sp_addextendedproperty N'MS_Description', N'The actual date and time  the rack was tested.', 'USER', N'dbo', 'TABLE', N'DailyQcWorklist', 'COLUMN', N'DailyQcExpirationDate'
GO
sp_addextendedproperty N'MS_Description', N'Indicates the daily use status of the rack.', 'USER', N'dbo', 'TABLE', N'DailyQcWorklist', 'COLUMN', N'DailyUseIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Indicates that the test was not completed and need further data entry.', 'USER', N'dbo', 'TABLE', N'DailyQcWorklist', 'COLUMN', N'PartiallyTestedIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific QC testing rack for a division.', 'USER', N'dbo', 'TABLE', N'DailyQcWorklist', 'COLUMN', N'RackGuid'
GO
sp_addextendedproperty N'MS_Description', N'Indicates that the rack was QC tested offline.', 'USER', N'dbo', 'TABLE', N'DailyQcWorklist', 'COLUMN', N'QCOfflineIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Identifies an organizational unit of a VA Medical Center.', 'USER', N'dbo', 'TABLE', N'DailyQcWorklist', 'COLUMN', N'DivisionCode'
GO
sp_addextendedproperty N'MS_Description', N'Indicates the state of the associated record.', 'USER', N'dbo', 'TABLE', N'DailyQcWorklist', 'COLUMN', N'RecordStatusCode'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'DailyQcWorklist', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'DailyQcWorklist', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'DailyQcWorklist', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'DailyQcWorklist', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.DailyQcWorklist ADD 
        CONSTRAINT PK_DailyQcWorklist PRIMARY KEY CLUSTERED 
        (
                DailyQcWorklistGuid
        ) ON [PRIMARY] 
GO
CREATE NONCLUSTERED INDEX IX_DailyQcWorklist_RackGuid ON dbo.DailyQcWorklist (RackGuid)
GO

/*****************************************************************************************
   Reload the updated DailyQcWorklist table 
*****************************************************************************************/
INSERT INTO dbo.DailyQcWorklist 
        (DailyQcWorklistGuid, DailyQcExpirationDate, DailyUseIndicator, PartiallyTestedIndicator, RackGuid, DivisionCode,
         RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          DailyQcWorklistGuid, DailyQcExpirationDate, DailyUseIndicator, PartiallyTestedIndicator, RackGuid, DivisionCode,
         RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM #DailyQcWorklist
GO
IF OBJECT_ID(N'tempdb..#DailyQcWorklist') IS NOT NULL
        DROP TABLE #DailyQcWorklist
GO

/*****************************************************************************************
   Make the DateWanted column on the ExceptionExpiredTask table nullable and
   add the column descriptions
*****************************************************************************************/
ALTER TABLE dbo.ExceptionExpiredTask ALTER COLUMN DateWanted datetime NULL
GO

sp_addextendedproperty N'MS_Description', N'Identifies an instance of an exception for processing an expired task.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'ExceptionExpiredTaskGuid'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a classification of exceptions.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'ExceptionTypeId'
GO
sp_addextendedproperty N'MS_Description', N'The full name of the patient.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'PatientName'
GO
sp_addextendedproperty N'MS_Description', N'The displayed VistA patient identifier.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'PatientId'
GO
sp_addextendedproperty N'MS_Description', N'The identifying order number from CPRS.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'CprsOrderNumber'
GO
sp_addextendedproperty N'MS_Description', N'The specimen unit identifier from VistA.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'SpecimenUid'
GO
sp_addextendedproperty N'MS_Description', N'The short name of the component class.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'ComponentClassOrdered'
GO
sp_addextendedproperty N'MS_Description', N'The number of components ordered on an expired order.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'Quantity'
GO
sp_addextendedproperty N'MS_Description', N'The datetime the order was wanted.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'DateWanted'
GO
sp_addextendedproperty N'MS_Description', N'The name of the technologist who logged the unit into the blood bank.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'LoginTechName'
GO
sp_addextendedproperty N'MS_Description', N'The user that created the exception event.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'ExceptionUser'
GO
sp_addextendedproperty N'MS_Description', N'Details of the exception event.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'ExceptionComment'
GO
sp_addextendedproperty N'MS_Description', N'The date of the exception event.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'ExceptionDate'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the division in which the exception event took place.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'DivisionCode'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'ExceptionExpiredTask', 'COLUMN', N'LastUpdateUser'
GO

/*****************************************************************************************
   Update the column descriptions on the Facility table 
*****************************************************************************************/
sp_updateextendedproperty N'MS_Description', N'Identifies a specific facility that collects or supplies human blood.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'FacilityGuid'
GO
sp_updateextendedproperty N'MS_Description', N'The name of a facility that collects or supplies blood.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'FacilityName'
GO
sp_updateextendedproperty N'MS_Description', N'The FDA-assigned identifier of a blood collection facility.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'FdaRegistrationNumber'
GO
sp_addextendedproperty N'MS_Description', N'The ICCBBA-assigned identifier of a blood collection facility.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'IccbbaRegistrationNumber'
GO
sp_updateextendedproperty N'MS_Description', N'A short identifier for a facility used on Codabar blood labels.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'FacilityPrefix'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific instance of a postal address.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'AddressGuid'
GO
sp_updateextendedproperty N'MS_Description', N'Indicates whether the UnitId that is scanned on a Codabar label shipped from this facility contains alpha characters and therefore needs to be trimmed before being stored as LabelUnitId in the BloodUnit table.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'LabelUnitIdTrimIndicator'
GO
sp_addextendedproperty N'MS_Description', N'The primary telephone number of the facility.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'PhoneNumber'
GO
sp_addextendedproperty N'MS_Description', N'The FAX telephone number of the facility.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'FaxNumber'
GO
sp_updateextendedproperty N'MS_Description', N'Indicates that the facility tests blood.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'TestingIndicator'
GO
sp_updateextendedproperty N'MS_Description', N'Indicates that the facility collects blood.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'CollectionIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Indicates the state of the associated record.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'RecordStatusCode'
GO
sp_updateextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'LastUpdateDate'
GO
sp_updateextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'Facility', 'COLUMN', N'LastUpdateFunctionId'
GO

/*****************************************************************************************
   Create a temporary InterfaceControl table and save the original data
*****************************************************************************************/
IF OBJECT_ID(N'tempdb..#InterfaceControl') IS NOT NULL
        DROP TABLE #InterfaceControl
GO

CREATE TABLE dbo.#InterfaceControl
        (
        InterfaceControlId int NOT NULL,
        InterfaceId tinyint NOT NULL,
        InterfaceFacilityId varchar (20) NULL,
        InterfacePortNumber int NULL,
        InterfaceIPAddress char (15) NULL,
        InterfaceDomainName varchar (100) NULL,
        VbecsFacilityId varchar (20) NULL,
        ProcessingId char (1) NOT NULL,
        VbecsPortNumber int NULL,
        VbecsIPAddress char (15) NULL,
        AckTimeout int NOT NULL,
        ReTransmitAttempts tinyint NOT NULL,
        InterfaceAdministratorName varchar (90) NOT NULL,
        PurgeSuccessfulMessage tinyint NOT NULL,
        PurgeUnSuccessfulMessage tinyint NOT NULL,
        LogEventsIndicator bit NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        LastUpdateFunctionId int NOT NULL
        )  ON [PRIMARY]
GO

INSERT INTO #InterfaceControl
        (InterfaceControlId, InterfaceId, InterfaceFacilityId, InterfacePortNumber, InterfaceIPAddress, InterfaceDomainName, VbecsFacilityId,
         ProcessingId, VbecsPortNumber, VbecsIPAddress, AckTimeout, ReTransmitAttempts, InterfaceAdministratorName, PurgeSuccessfulMessage,
         PurgeUnSuccessfulMessage, LogEventsIndicator, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          InterfaceControlId, InterfaceId, InterfaceFacilityId, InterfacePortNumber, InterfaceIPAddress, InterfaceDomainName, VbecsFacilityId,
         ProcessingId, VbecsPortNumber, VbecsIPAddress, AckTimeout, ReTransmitAttempts, InterfaceAdministratorName, PurgeSuccessfulMessage,
         PurgeUnSuccessfulMessage, LogEventsIndicator, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.InterfaceControl
GO

/*****************************************************************************************
   Drop the constraints from the InterfaceControl table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_MessageLog_InterfaceControl') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.MessageLog DROP CONSTRAINT FK_MessageLog_InterfaceControl
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_MessageType_InterfaceControl') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.MessageType DROP CONSTRAINT FK_MessageType_InterfaceControl
GO

/*****************************************************************************************
   Create the updated InterfaceControl table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.InterfaceControl') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.InterfaceControl
GO

CREATE TABLE dbo.InterfaceControl
        (
        InterfaceControlId int NOT NULL,
        InterfaceId tinyint NOT NULL,
        InterfaceFacilityId varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InterfacePortNumber int NULL,
        InterfaceIPAddress char (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InterfaceDomainName varchar (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        VbecsFacilityId varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ProcessingId char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        VbecsPortNumber int NULL,
        VbecsIPAddress char (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        AckTimeout int NOT NULL CONSTRAINT DF_InterfaceControl_AckTimeout DEFAULT (10),
        ReTransmitAttempts tinyint NOT NULL CONSTRAINT DF_InterfaceControl_ReTransmitAttempts DEFAULT (5),
        InterfaceAdministratorName varchar (90) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        PurgeSuccessfulMessage tinyint NOT NULL CONSTRAINT DF_InterfaceControl_PurgeSuccessfulMessage DEFAULT (7),
        PurgeUnSuccessfulMessage tinyint NOT NULL CONSTRAINT DF_InterfaceControl_PurgeUnSuccessfulMessage DEFAULT (7),
        LogEventsIndicator bit NOT NULL CONSTRAINT DF_InterfaceControl_LogEventsIndicator DEFAULT (1),
        InterfaceActiveIndicator bit NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_InterfaceControl_LastUpdateFunctionId DEFAULT (0)
) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'Identifies a specific interface control record.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'InterfaceControlId'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific interface in VBECS.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'InterfaceId'
GO
sp_addextendedproperty N'MS_Description', N'The division number of the Sending Application', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'InterfaceFacilityId'
GO
sp_addextendedproperty N'MS_Description', N'The port number of the Sending Application.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'InterfacePortNumber'
GO
sp_addextendedproperty N'MS_Description', N'The IP address of the Sending Application.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'InterfaceIPAddress'
GO
sp_addextendedproperty N'MS_Description', N'The fully qualified server name of the Sending Application.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'InterfaceDomainName'
GO
sp_addextendedproperty N'MS_Description', N'The division number of the Receiving Application.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'VbecsFacilityId'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the current status of the interface.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'ProcessingId'
GO
sp_addextendedproperty N'MS_Description', N'The TCP/IP Port Number for the VBECS interface.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'VbecsPortNumber'
GO
sp_addextendedproperty N'MS_Description', N'The IP address of the VBECS interface.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'VbecsIPAddress'
GO
sp_addextendedproperty N'MS_Description', N'The elapsed time of no activity, in seconds, that will cause the application to drop the interface connection.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'AckTimeout'
GO
sp_addextendedproperty N'MS_Description', N'The number of times the interface will attempt to retransmit a message before it quits.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'ReTransmitAttempts'
GO
sp_addextendedproperty N'MS_Description', N'The name of the interface administrator.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'InterfaceAdministratorName'
GO
sp_addextendedproperty N'MS_Description', N'The Purge criteria for successful HL7 messages.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'PurgeSuccessfulMessage'
GO
sp_addextendedproperty N'MS_Description', N'The Purge criteria for unsuccessful HL7 messages.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'PurgeUnSuccessfulMessage'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the interface will enter events in the event log.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'LogEventsIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether or not the interface is active.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'InterfaceActiveIndicator'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'InterfaceControl', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.InterfaceControl ADD 
        CONSTRAINT PK_InterfaceControl PRIMARY KEY CLUSTERED 
        (
                InterfaceControlId
        ) ON [PRIMARY] 
GO
CREATE NONCLUSTERED INDEX IX_InterfaceControl_InterfaceId ON dbo.InterfaceControl (InterfaceId)
GO

/*****************************************************************************************
   Reload the updated InterfaceControl table 
*****************************************************************************************/
INSERT INTO dbo.InterfaceControl 
        (InterfaceControlId, InterfaceId, InterfaceFacilityId, InterfacePortNumber, InterfaceIPAddress, InterfaceDomainName,
         VbecsFacilityId, ProcessingId, VbecsPortNumber, VbecsIPAddress, AckTimeout, ReTransmitAttempts, InterfaceAdministratorName,
         PurgeSuccessfulMessage, PurgeUnSuccessfulMessage, LogEventsIndicator, InterfaceActiveIndicator, LastUpdateDate, 
         LastUpdateUser, LastUpdateFunctionId)
SELECT          InterfaceControlId, InterfaceId, InterfaceFacilityId, InterfacePortNumber, InterfaceIPAddress, InterfaceDomainName,
         VbecsFacilityId, ProcessingId, VbecsPortNumber, VbecsIPAddress, AckTimeout, ReTransmitAttempts, InterfaceAdministratorName,
         PurgeSuccessfulMessage, PurgeUnSuccessfulMessage, LogEventsIndicator, 1, LastUpdateDate, 
         LastUpdateUser, LastUpdateFunctionId
  FROM #InterfaceControl
GO
IF OBJECT_ID(N'tempdb..#InterfaceControl') IS NOT NULL
        DROP TABLE #InterfaceControl
GO

/*****************************************************************************************
   Create a temporary MessageLog table and save the original data
*****************************************************************************************/
IF OBJECT_ID(N'tempdb..#MessageLog') IS NOT NULL
        DROP TABLE #MessageLog
GO

CREATE TABLE dbo.#MessageLog
        (
        MessageLogId int NOT NULL,
        MessageStatusCode int NOT NULL,
        MessageControlId varchar (20) NOT NULL,
        MessageType varchar (13) NOT NULL,
        DateTimeOfMessage datetime NOT NULL,
        SendingApplication varchar (50) NOT NULL,
        ReceivingApplication varchar (50) NOT NULL,
        MessageStream varchar (3500) NOT NULL,
        AckMessageControlId varchar (20) NULL,
        InterfaceControlId int NOT NULL,
        ErrorText varchar (3500) NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        LastUpdateFunctionId int NOT NULL
        )  ON [PRIMARY]
GO

INSERT INTO #MessageLog
        (MessageLogId, MessageStatusCode, MessageControlId, MessageType, DateTimeOfMessage, SendingApplication, ReceivingApplication,
         MessageStream, AckMessageControlId, InterfaceControlId, ErrorText, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          MessageLogId, MessageStatusCode, MessageControlId, MessageType, DateTimeOfMessage, SendingApplication, ReceivingApplication,
         MessageStream, AckMessageControlId, InterfaceControlId, ErrorText, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.MessageLog
GO
        
/*****************************************************************************************
   Create the updated MessageLog table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.MessageLog') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.MessageLog
GO

CREATE TABLE dbo.MessageLog
        (
        MessageLogId int NOT NULL IDENTITY(1, 1),
        MessageStatusCode int NOT NULL,
        MessageControlId varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        MessageType varchar (13) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        DateTimeOfMessage datetime NOT NULL,
        SendingApplication varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        ReceivingApplication varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        MessageStream varchar (3500) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        AckMessageControlId varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InterfaceControlId int NOT NULL,
        ErrorText varchar (3500) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TransmitCount tinyint NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_MessageLog_LastUpdateFunctionId DEFAULT (0)
) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'Identifies an entry in the HL7 message log.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'MessageLogId'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific state for an interface message.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'MessageStatusCode'
GO
sp_addextendedproperty N'MS_Description', N'Identifies an HL7 message control.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'MessageControlId'
GO
sp_addextendedproperty N'MS_Description', N'The name of a message type record in VBECS.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'MessageType'
GO
sp_addextendedproperty N'MS_Description', N'This field contains the date/time that the sending system created the message.  If the time zone is specified, it will be used throughout the message as the default time zone.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'DateTimeOfMessage'
GO
sp_addextendedproperty N'MS_Description', N'Uniquely identifies the sending application among all other applications within the network enterprise.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'SendingApplication'
GO
sp_addextendedproperty N'MS_Description', N'Uniquely identifies the receiving application among all other applications within the network enterprise.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'ReceivingApplication'
GO
sp_addextendedproperty N'MS_Description', N'A copy of the entire XML/HL7 message that was sent or received.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'MessageStream'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the acknowledgement message sent or received in response to a VBECS initiated message. It is necessary to keep track of messages that have been acknowledged.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'AckMessageControlId'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific interface in VBECS.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'InterfaceControlId'
GO
sp_addextendedproperty N'MS_Description', N'The details of any error associated with the message entry.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'ErrorText'
GO
sp_addextendedproperty N'MS_Description', N'The number of attempts to send the message.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'TransmitCount'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'MessageLog', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.MessageLog ADD 
        CONSTRAINT PK_MessageLog PRIMARY KEY CLUSTERED 
        (
                MessageLogId
        ) ON [PRIMARY] 
GO
CREATE NONCLUSTERED INDEX IX_MessageLog_InterfaceControlId ON dbo.MessageLog (InterfaceControlId)
GO
CREATE NONCLUSTERED INDEX IX_MessageLog_MessageStatusCode ON dbo.MessageLog (MessageStatusCode)
GO

/*****************************************************************************************
   Reload the updated MessageLog table 
*****************************************************************************************/
SET IDENTITY_INSERT MessageLog ON
GO
INSERT INTO dbo.MessageLog
        (MessageLogId, MessageStatusCode, MessageControlId, MessageType, DateTimeOfMessage, SendingApplication, ReceivingApplication,
         MessageStream, AckMessageControlId, InterfaceControlId, ErrorText, LastUpdateDate, LastUpdateUser, 
         LastUpdateFunctionId)
SELECT          MessageLogId, MessageStatusCode, MessageControlId, MessageType, DateTimeOfMessage, SendingApplication, ReceivingApplication,
         MessageStream, AckMessageControlId, InterfaceControlId, ErrorText, LastUpdateDate, LastUpdateUser, 
         LastUpdateFunctionId
  FROM #MessageLog
GO
SET IDENTITY_INSERT MessageLog OFF
GO
IF OBJECT_ID(N'tempdb..#MessageLog') IS NOT NULL
        DROP TABLE #MessageLog
GO

/*****************************************************************************************
   Create a temporary OrderedComponent table and save the original data
*****************************************************************************************/
IF OBJECT_ID(N'tempdb..#OrderedComponent') IS NOT NULL
        DROP TABLE #OrderedComponent
GO

CREATE TABLE dbo.#OrderedComponent
        (
        OrderedComponentGuid uniqueidentifier NOT NULL,
        PatientOrderGuid uniqueidentifier NOT NULL,
        ComponentClassId int NOT NULL,
        CprsOrderNumber varchar (20) NOT NULL,
        VbecsOrderNumber int NULL,
        RequiredUnitQuantity decimal (3, 0) NOT NULL,
        SpecimenRequiredIndicator bit NULL,
        SpecimenAccessionNumber varchar (20) NULL,
        SpecimenWorkloadUid varchar (15) NULL,
        PatientSpecimenGuid uniqueidentifier NULL,
        SpecimenStatusCode char (1) NULL,
        PreOpIndicator bit NULL,
        OrderStatusCode char (1) NULL,
        OrderUrgencyCode char (1) NULL,
        RequiredDatetime datetime NOT NULL,
        OrderSpecialInstructions varchar (510) NULL,
        ImmediateTransfusionIndicator bit NULL,
        OrderedComponentComments varchar (510) NULL,
        InappropriateRequestIndicator bit NULL,
        NoInappropriateReportText varchar (510) NULL,
        TaskStatusCode char (1) NULL,
        CancellationCannedCommentGuid uniqueidentifier NULL,
        CancellationText varchar (510) NULL,
        LabOrderNumber varchar (20) NULL,
        LabTestId char (15) NULL,
        EmergencyOrderIndicator bit NOT NULL,
        DivisionCode char (5) NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        LastUpdateFunctionId int NOT NULL
        )  ON [PRIMARY]
GO

INSERT INTO #OrderedComponent
        (OrderedComponentGuid, PatientOrderGuid, ComponentClassId, CprsOrderNumber, VbecsOrderNumber, RequiredUnitQuantity,
         SpecimenRequiredIndicator, SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, SpecimenStatusCode,
         PreOpIndicator, OrderStatusCode, OrderUrgencyCode, RequiredDatetime, OrderSpecialInstructions, ImmediateTransfusionIndicator,
         OrderedComponentComments, InappropriateRequestIndicator, NoInappropriateReportText, TaskStatusCode, CancellationCannedCommentGuid,
         CancellationText, LabOrderNumber, LabTestId, EmergencyOrderIndicator, DivisionCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          OrderedComponentGuid, PatientOrderGuid, ComponentClassId, CprsOrderNumber, VbecsOrderNumber, RequiredUnitQuantity,
         SpecimenRequiredIndicator, SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, SpecimenStatusCode,
         PreOpIndicator, OrderStatusCode, OrderUrgencyCode, RequiredDatetime, OrderSpecialInstructions, ImmediateTransfusionIndicator,
         OrderedComponentComments, InappropriateRequestIndicator, NoInappropriateReportText, TaskStatusCode, CancellationCannedCommentGuid,
         CancellationText, LabOrderNumber, LabTestId, EmergencyOrderIndicator, DivisionCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.OrderedComponent
GO

/*****************************************************************************************
   Drop the constraints from the OrderedComponent table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_BloodUnitTest_OrderedComponent') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.BloodUnitTest DROP CONSTRAINT FK_BloodUnitTest_OrderedComponent
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_OrderedTest_OrderedComponent') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.OrderedTest DROP CONSTRAINT FK_OrderedTest_OrderedComponent
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_OrderedUnit_OrderedComponent') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.OrderedUnit DROP CONSTRAINT FK_OrderedUnit_OrderedComponent
GO

/*****************************************************************************************
   Create the updated OrderedComponent table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.OrderedComponent') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.OrderedComponent
GO

CREATE TABLE dbo.OrderedComponent
        (
        OrderedComponentGuid uniqueidentifier NOT NULL,
        PatientOrderGuid uniqueidentifier NOT NULL,
        ComponentClassId int NOT NULL,
        CprsOrderNumber varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        VbecsOrderNumber int NULL,
        RequiredUnitQuantity decimal (3, 0) NOT NULL,
        SpecimenRequiredIndicator bit NULL,
        SpecimenAccessionNumber varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        SpecimenWorkloadUid varchar (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PatientSpecimenGuid uniqueidentifier NULL,
        SpecimenStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PreOpIndicator bit NULL,
        OrderStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        OrderUrgencyCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RequiredDatetime datetime NOT NULL,
        OrderSpecialInstructions varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ImmediateTransfusionIndicator bit NULL,
        OrderedComponentComments varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InappropriateRequestIndicator bit NULL CONSTRAINT DF_OrderedComponent_InappropriateRequestIndicator DEFAULT (0),
        NoInappropriateReportText varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TaskStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        CancellationCannedCommentGuid uniqueidentifier NULL,
        CancellationText varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LabOrderNumber varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LabTestId char (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        EmergencyOrderIndicator bit NOT NULL CONSTRAINT DF_OrderedComponent_EmergencyOrderIndicator DEFAULT (0),
        OrderAcceptanceDate datetime NULL,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_OrderedComponent_LastUpdateFunctionId DEFAULT (0)
) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'Identifies an individual request for a CPRS orderable component class for a patient.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'OrderedComponentGuid'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific request for blood for a patient.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'PatientOrderGuid'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a higher-level blood component.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'ComponentClassId'
GO
sp_addextendedproperty N'MS_Description', N'The identifying order number from CPRS.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'CprsOrderNumber'
GO
sp_addextendedproperty N'MS_Description', N'The identifying order number in VBECS.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'VbecsOrderNumber'
GO
sp_addextendedproperty N'MS_Description', N'The initial number of units of blood of the specified component class requested.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'RequiredUnitQuantity'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the ordered component requires a specimen for processing.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'SpecimenRequiredIndicator'
GO
sp_addextendedproperty N'MS_Description', N'The Accession Number from VistA.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'SpecimenAccessionNumber'
GO
sp_addextendedproperty N'MS_Description', N'The UID of the specimen associated with the order for workload processing.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'SpecimenWorkloadUid'
GO
sp_addextendedproperty N'MS_Description', N'A unique identifier for a patient specimen.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'PatientSpecimenGuid'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific state for a specimen.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'SpecimenStatusCode'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the patient needs blood prior to a scheduled operation.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'PreOpIndicator'
GO
sp_addextendedproperty N'MS_Description', N'The current state of the order.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'OrderStatusCode'
GO
sp_addextendedproperty N'MS_Description', N'Indicates the level of urgency to be associated with the component order.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'OrderUrgencyCode'
GO
sp_addextendedproperty N'MS_Description', N'The date the blood requested is needed.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'RequiredDatetime'
GO
sp_addextendedproperty N'MS_Description', N'An optional message from CPRS indicating requirements, like modifications, etc, for the ordered blood.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'OrderSpecialInstructions'
GO
sp_addextendedproperty N'MS_Description', N'Indicates the blood ordered is for immediate transfusion.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'ImmediateTransfusionIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Details about an ordered component.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'OrderedComponentComments'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the ordered component has exceeded MSBOS quantities for the division .', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'InappropriateRequestIndicator'
GO
sp_addextendedproperty N'MS_Description', N'The reason the user does not want the inappropriate order to show up on the inappropriate request report.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'NoInappropriateReportText'
GO
sp_addextendedproperty N'MS_Description', N'The current state of the task to fill an order.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'TaskStatusCode'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a standardized text entry for order cancellation.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'CancellationCannedCommentGuid'
GO
sp_addextendedproperty N'MS_Description', N'Details about a cancelled order.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'CancellationText'
GO
sp_addextendedproperty N'MS_Description', N'The identifying order number from the Lab.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'LabOrderNumber'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the lab test.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'LabTestId'
GO
sp_addextendedproperty N'MS_Description', N'Indicates if this is part of an emergency order.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'EmergencyOrderIndicator'
GO
sp_addextendedproperty N'MS_Description', N'The date the component order was accepted into VBECS.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'OrderAcceptanceDate'
GO
sp_addextendedproperty N'MS_Description', N'Identifies an organizational unit of a VA Medical Center.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'DivisionCode'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'OrderedComponent', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.OrderedComponent ADD 
        CONSTRAINT PK_OrderedComponent PRIMARY KEY CLUSTERED 
        (
                OrderedComponentGuid
        ) ON [PRIMARY] 
GO
CREATE NONCLUSTERED INDEX IX_OrderedComponent_ComponentClassId ON dbo.OrderedComponent (ComponentClassId)
GO
CREATE NONCLUSTERED INDEX IX_OrderedComponent_OrderStatusCode ON dbo.OrderedComponent (OrderStatusCode)
GO
CREATE NONCLUSTERED INDEX IX_OrderedComponent_OrderUrgencyCode ON dbo.OrderedComponent (OrderUrgencyCode)
GO
CREATE NONCLUSTERED INDEX IX_OrderedComponent_PatientOrderGuid ON dbo.OrderedComponent (PatientOrderGuid)
GO
CREATE NONCLUSTERED INDEX IX_OrderedComponent_PatientSpecimenGuid ON dbo.OrderedComponent (PatientSpecimenGuid)
GO
CREATE NONCLUSTERED INDEX IX_OrderedComponent_SpecimenStatusCode ON dbo.OrderedComponent (SpecimenStatusCode)
GO
CREATE NONCLUSTERED INDEX IX_OrderedComponent_TaskStatusCode ON dbo.OrderedComponent (TaskStatusCode)
GO

/*****************************************************************************************
   Reload the updated OrderedComponent table 
*****************************************************************************************/
INSERT INTO dbo.OrderedComponent
        (OrderedComponentGuid, PatientOrderGuid, ComponentClassId, CprsOrderNumber, VbecsOrderNumber, RequiredUnitQuantity,
         SpecimenRequiredIndicator, SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, SpecimenStatusCode, PreOpIndicator,
         OrderStatusCode, OrderUrgencyCode, RequiredDatetime, OrderSpecialInstructions, ImmediateTransfusionIndicator, OrderedComponentComments,
         InappropriateRequestIndicator, NoInappropriateReportText, TaskStatusCode, CancellationCannedCommentGuid, CancellationText,
         LabOrderNumber, LabTestId, EmergencyOrderIndicator, DivisionCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          OrderedComponentGuid, PatientOrderGuid, ComponentClassId, CprsOrderNumber, VbecsOrderNumber, RequiredUnitQuantity,
         SpecimenRequiredIndicator, SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, SpecimenStatusCode, PreOpIndicator,
         OrderStatusCode, OrderUrgencyCode, RequiredDatetime, OrderSpecialInstructions, ImmediateTransfusionIndicator, OrderedComponentComments,
         InappropriateRequestIndicator, NoInappropriateReportText, TaskStatusCode, CancellationCannedCommentGuid, CancellationText,
         LabOrderNumber, LabTestId, EmergencyOrderIndicator, DivisionCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM #OrderedComponent

GO

/*****************************************************************************************
   Update the OrderAcceptanceDate on the OrderedComponent table 
*****************************************************************************************/
UPDATE OrderedComponent
   SET OrderAcceptanceDate = MOC.MirrorDate
  FROM OrderedComponent
        JOIN (SELECT OrderedComponentGuid, MIN(MirrorDate) AS MirrorDate
                FROM VBECS_V1_PROD_MIRROR.dbo.V_OrderedComponent 
               WHERE OrderStatusCode = 'A'
               GROUP BY OrderedComponentGuid) MOC
                ON OrderedComponent.OrderedComponentGuid = MOC.OrderedComponentGuid
 WHERE OrderStatusCode <> 'P'
GO
IF OBJECT_ID(N'tempdb..#OrderedComponent') IS NOT NULL
        DROP TABLE #OrderedComponent
GO

/*****************************************************************************************
   Create a temporary OrderedTest table and save the original data
*****************************************************************************************/
IF OBJECT_ID(N'tempdb..#OrderedTest') IS NOT NULL
        DROP TABLE #OrderedTest
GO

CREATE TABLE dbo.#OrderedTest
        (
        OrderedTestGuid uniqueidentifier NOT NULL,
        PatientOrderGuid uniqueidentifier NOT NULL,
        CprsOrderNumber varchar (20) NULL,
        VbecsOrderNumber int NULL,
        RelatedComponentGuid uniqueidentifier NULL,
        SpecimenRequiredIndicator bit NULL,
        SpecimenAccessionNumber varchar (20) NULL,
        SpecimenWorkloadUid varchar (15) NULL,
        PatientSpecimenGuid uniqueidentifier NULL,
        OrderStatusCode char (1) NULL,
        OrderUrgencyCode char (1) NULL,
        OrderedTestComments varchar (510) NULL,
        RequiredResultsDate datetime NULL,
        OrderableTestId int NULL,
        TestInterpretation char (3) NULL,
        TestInterpretationComments varchar (510) NULL,
        AutoInstrumentName varchar (50) NULL,
        TaskStatusCode char (1) NULL,
        RelatedTestGuid uniqueidentifier NULL,
        CancellationCannedCommentGuid uniqueidentifier NULL,
        CancellationText varchar (510) NULL,
        LabOrderNumber varchar (20) NULL,
        LabTestId char (15) NULL,
        DivisionCode char (5) NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        LastUpdateFunctionId int NOT NULL
        )  ON [PRIMARY]
GO

INSERT INTO #OrderedTest
        (OrderedTestGuid, PatientOrderGuid, CprsOrderNumber, VbecsOrderNumber, RelatedComponentGuid, SpecimenRequiredIndicator, 
         SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, OrderStatusCode, OrderUrgencyCode, OrderedTestComments, 
         RequiredResultsDate, OrderableTestId, TestInterpretation, TestInterpretationComments, AutoInstrumentName, TaskStatusCode, 
         RelatedTestGuid, CancellationCannedCommentGuid, CancellationText, LabOrderNumber, LabTestId, DivisionCode, 
         LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          OrderedTestGuid, PatientOrderGuid, CprsOrderNumber, VbecsOrderNumber, RelatedComponentGuid, SpecimenRequiredIndicator, 
         SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, OrderStatusCode, OrderUrgencyCode, OrderedTestComments, 
         RequiredResultsDate, OrderableTestId, TestInterpretation, TestInterpretationComments, AutoInstrumentName, TaskStatusCode, 
         RelatedTestGuid, CancellationCannedCommentGuid, CancellationText, LabOrderNumber, LabTestId, DivisionCode, 
         LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.OrderedTest
GO

/*****************************************************************************************
   Drop the constraints from the OrderedTest table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_AntiseraOrderedTest_OrderedTest') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.AntiseraOrderedTest DROP CONSTRAINT FK_AntiseraOrderedTest_OrderedTest
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_BloodUnitTest_OrderedTest') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.BloodUnitTest DROP CONSTRAINT FK_BloodUnitTest_OrderedTest
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_OrderedTest_OrderedTest') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.OrderedTest DROP CONSTRAINT FK_OrderedTest_OrderedTest
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_OrderedUnit_OrderedTest') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.OrderedUnit DROP CONSTRAINT FK_OrderedUnit_OrderedTest
GO        
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PatientTransfusionReaction_OrderedTest') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PatientTransfusionReaction DROP CONSTRAINT FK_PatientTransfusionReaction_OrderedTest
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_SpecimenTest_OrderedTest') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.SpecimenTest DROP CONSTRAINT FK_SpecimenTest_OrderedTest
GO

/*****************************************************************************************
   Create the updated OrderedTest table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.OrderedTest') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.OrderedTest
GO

CREATE TABLE dbo.OrderedTest
        (
        OrderedTestGuid uniqueidentifier NOT NULL,
        PatientOrderGuid uniqueidentifier NOT NULL,
        CprsOrderNumber varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        VbecsOrderNumber int NULL,
        RelatedComponentGuid uniqueidentifier NULL,
        SpecimenRequiredIndicator bit NULL,
        SpecimenAccessionNumber varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        SpecimenWorkloadUid varchar (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PatientSpecimenGuid uniqueidentifier NULL,
        OrderStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        OrderUrgencyCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        OrderedTestComments varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RequiredResultsDate datetime NULL,
        OrderableTestId int NULL,
        TestInterpretation char (3) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TestInterpretationComments varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        AutoInstrumentName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TaskStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RelatedTestGuid uniqueidentifier NULL,
        CancellationCannedCommentGuid uniqueidentifier NULL,
        CancellationText varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LabOrderNumber varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LabTestId char (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        OrderAcceptanceDate datetime NULL,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_OrderedTest_LastUpdateFunctionId DEFAULT (0)
) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'Identifies an individual request for a diagnostic test on a specimen for a patient.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'OrderedTestGuid'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific request for blood for a patient.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'PatientOrderGuid'
GO
sp_addextendedproperty N'MS_Description', N'The identifying order number from CPRS.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'CprsOrderNumber'
GO
sp_addextendedproperty N'MS_Description', N'The identifying order number in VBECS.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'VbecsOrderNumber'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the original component that was the trigger for the ordered  test.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'RelatedComponentGuid'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the patient needs a current blood specimen.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'SpecimenRequiredIndicator'
GO
sp_addextendedproperty N'MS_Description', N'The Accession Number from VistA.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'SpecimenAccessionNumber'
GO
sp_addextendedproperty N'MS_Description', N'The UID of the specimen associated with the order for workload processing.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'SpecimenWorkloadUid'
GO
sp_addextendedproperty N'MS_Description', N'A unique identifier for a patient specimen.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'PatientSpecimenGuid'
GO
sp_addextendedproperty N'MS_Description', N'The current state of the order.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'OrderStatusCode'
GO
sp_addextendedproperty N'MS_Description', N'Indicates the level of urgency to be associated with the component order.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'OrderUrgencyCode'
GO
sp_addextendedproperty N'MS_Description', N'Details about an ordered test.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'OrderedTestComments'
GO
sp_addextendedproperty N'MS_Description', N'The date the results of the ordered test are needed.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'RequiredResultsDate'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific ordered blood test.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'OrderableTestId'
GO
sp_addextendedproperty N'MS_Description', N'A valid result for a specific blood test group.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'TestInterpretation'
GO
sp_addextendedproperty N'MS_Description', N'Details about a completed ordered test.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'TestInterpretationComments'
GO
sp_addextendedproperty N'MS_Description', N'The name of the automated instrument if one was used to record test results.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'AutoInstrumentName'
GO
sp_addextendedproperty N'MS_Description', N'The current state of the task to fill an order.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'TaskStatusCode'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the original ordered test that was the trigger for this  test order.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'RelatedTestGuid'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a standardized text entry for order cancellation.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'CancellationCannedCommentGuid'
GO
sp_addextendedproperty N'MS_Description', N'Details about a cancelled order.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'CancellationText'
GO
sp_addextendedproperty N'MS_Description', N'The identifying order number from the Lab.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'LabOrderNumber'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the lab test.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'LabTestId'
GO
sp_addextendedproperty N'MS_Description', N'The date the test order was accepted into VBECS.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'OrderAcceptanceDate'
GO
sp_addextendedproperty N'MS_Description', N'Identifies an organizational unit of a VA Medical Center.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'DivisionCode'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'OrderedTest', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.OrderedTest ADD 
        CONSTRAINT PK_OrderedTest PRIMARY KEY CLUSTERED 
        (
                OrderedTestGuid
        ) ON [PRIMARY] 
GO
CREATE NONCLUSTERED INDEX IX_OrderedTest_OrderableTestId ON dbo.OrderedTest (OrderableTestId)
GO
CREATE NONCLUSTERED INDEX IX_OrderedTest_OrderStatusCode ON dbo.OrderedTest (OrderStatusCode)
GO
CREATE NONCLUSTERED INDEX IX_OrderedTest_OrderUrgencyCode ON dbo.OrderedTest (OrderUrgencyCode)
GO
CREATE NONCLUSTERED INDEX IX_OrderedTest_PatientOrderGuid ON dbo.OrderedTest (PatientOrderGuid)
GO
CREATE NONCLUSTERED INDEX IX_OrderedTest_PatientSpecimenGuid ON dbo.OrderedTest (PatientSpecimenGuid)
GO
CREATE NONCLUSTERED INDEX IX_OrderedTest_RelatedComponentGuid ON dbo.OrderedTest (RelatedComponentGuid)
GO
CREATE NONCLUSTERED INDEX IX_OrderedTest_RelatedTestGuid ON dbo.OrderedTest (RelatedTestGuid)
GO
CREATE NONCLUSTERED INDEX IX_OrderedTest_TaskStatusCode ON dbo.OrderedTest (TaskStatusCode)
GO

/*****************************************************************************************
   Reload the updated OrderedTest table 
*****************************************************************************************/
INSERT INTO dbo.OrderedTest
        (OrderedTestGuid, PatientOrderGuid, CprsOrderNumber, VbecsOrderNumber, RelatedComponentGuid, SpecimenRequiredIndicator, 
         SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, OrderStatusCode, OrderUrgencyCode, OrderedTestComments, 
         RequiredResultsDate, OrderableTestId, TestInterpretation, TestInterpretationComments, AutoInstrumentName, TaskStatusCode, 
         RelatedTestGuid, CancellationCannedCommentGuid, CancellationText, LabOrderNumber, LabTestId, DivisionCode, 
         LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          OrderedTestGuid, PatientOrderGuid, CprsOrderNumber, VbecsOrderNumber, RelatedComponentGuid, SpecimenRequiredIndicator, 
         SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, OrderStatusCode, OrderUrgencyCode, OrderedTestComments, 
         RequiredResultsDate, OrderableTestId, TestInterpretation, TestInterpretationComments, AutoInstrumentName, TaskStatusCode, 
         RelatedTestGuid, CancellationCannedCommentGuid, CancellationText, LabOrderNumber, LabTestId, DivisionCode, 
         LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM #OrderedTest

GO

/*****************************************************************************************
   Update the OrderAcceptanceDate on the OrderedTest table 
*****************************************************************************************/
UPDATE OrderedTest
   SET OrderAcceptanceDate = MOT.MirrorDate
  FROM OrderedTest
        JOIN (SELECT OrderedTestGuid, MIN(MirrorDate) AS MirrorDate
                FROM VBECS_V1_PROD_MIRROR.dbo.V_OrderedTest 
               WHERE OrderStatusCode = 'A'
               GROUP BY OrderedTestGuid) MOT
                ON OrderedTest.OrderedTestGuid = MOT.OrderedTestGuid
 WHERE OrderStatusCode <> 'P'

GO
IF OBJECT_ID(N'tempdb..#OrderedTest') IS NOT NULL
        DROP TABLE #OrderedTest
GO

/*****************************************************************************************
   Create a temporary PatientTransfusion table and save the original data
*****************************************************************************************/
IF OBJECT_ID(N'tempdb..#PatientTransfusion') IS NOT NULL
        DROP TABLE #PatientTransfusion
GO

CREATE TABLE dbo.#PatientTransfusion
        (
        PatientTransfusionGuid uniqueidentifier NOT NULL,
        PatientGuid uniqueidentifier NOT NULL,
        PatientSpecimenGuid uniqueidentifier NULL,
        TransfusionLocation varchar (30) NULL,
        LocationIen char (8) NULL,
        TransfusionStartDateTime datetime NULL,
        TransfusionEndDateTime datetime NULL,
        BloodUnitGuid uniqueidentifier NULL,
        BedsideVerificationDate datetime NULL,
        Transfusionist1Id varchar (30) NULL,
        Transfusionist2Id varchar (30) NULL,
        TransfusedVolume int NULL,
        TransfusionPooledUnitsCount smallint NULL,
        PhlebotomistId varchar (30) NULL,
        InterruptionIndicator bit NULL,
        InterruptionDateTime datetime NULL,
        InterruptionComment varchar (510) NULL,
        ReactionIndicator bit NOT NULL,
        ReactionSymptoms varchar (510) NULL,
        OtherDifficultyIndicator bit NOT NULL,
        OtherDifficultyText varchar (50) NULL,
        DssExtractSuccessIndicator bit NOT NULL,
        DivisionCode char (5) NULL,
        RecordStatusCode char (1) NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        LastUpdateFunctionId int NOT NULL
        )  ON [PRIMARY]
GO

INSERT INTO #PatientTransfusion
        (PatientTransfusionGuid, PatientGuid, PatientSpecimenGuid, TransfusionLocation, LocationIen, TransfusionStartDateTime, 
         TransfusionEndDateTime, BloodUnitGuid, BedsideVerificationDate, Transfusionist1Id, Transfusionist2Id, TransfusedVolume, 
         TransfusionPooledUnitsCount, PhlebotomistId, InterruptionIndicator, InterruptionDateTime, InterruptionComment, 
         ReactionIndicator, ReactionSymptoms, OtherDifficultyIndicator, OtherDifficultyText, DssExtractSuccessIndicator, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          PatientTransfusionGuid, PatientGuid, PatientSpecimenGuid, TransfusionLocation, LocationIen, TransfusionStartDateTime, 
         TransfusionEndDateTime, BloodUnitGuid, BedsideVerificationDate, Transfusionist1Id, Transfusionist2Id, TransfusedVolume, 
         TransfusionPooledUnitsCount, PhlebotomistId, InterruptionIndicator, InterruptionDateTime, InterruptionComment, 
         ReactionIndicator, ReactionSymptoms, OtherDifficultyIndicator, OtherDifficultyText, DssExtractSuccessIndicator, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.PatientTransfusion
GO

/*****************************************************************************************
   Drop the constraints from the PatientTransfusion table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PatientTransfusionComment_PatientTransfusion') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PatientTransfusionComment DROP CONSTRAINT FK_PatientTransfusionComment_PatientTransfusion
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_TransfusionReaction_PatientTransfusion') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.TransfusionReaction DROP CONSTRAINT FK_TransfusionReaction_PatientTransfusion
GO

/*****************************************************************************************
   Create the updated PatientTransfusion table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.PatientTransfusion') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.PatientTransfusion
GO

CREATE TABLE dbo.PatientTransfusion
        (
        PatientTransfusionGuid uniqueidentifier NOT NULL,
        PatientGuid uniqueidentifier NOT NULL,
        PatientSpecimenGuid uniqueidentifier NULL,
        TransfusionLocation varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LocationIen char (8) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TransfusionStartDateTime datetime NULL,
        TransfusionEndDateTime datetime NULL,
        BloodUnitGuid uniqueidentifier NULL,
        BedsideVerificationDate datetime NULL,
        Transfusionist1Id varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        Transfusionist2Id varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TransfusedVolume int NULL,
        TransfusionPooledUnitsCount smallint NULL,
        PhlebotomistId varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InterruptionIndicator bit NULL,
        InterruptionDateTime datetime NULL,
        InterruptionComment varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ReactionIndicator bit NOT NULL CONSTRAINT DF_PatientTransfusion_TransfusionReactionIndicator DEFAULT (0),
        ReactionSymptoms varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        OtherDifficultyIndicator bit NOT NULL CONSTRAINT DF_PatientTransfusion_OtherDifficultyIndicator DEFAULT (0),
        OtherDifficultyText varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        DssExtractSuccessIndicator bit NOT NULL CONSTRAINT DF_PatientTransfusion_DssExtractSuccessIndicator DEFAULT (0),
        BedsideVerificationUnitManualEntryReason varchar (200) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ApplicationOfRecordId tinyint NOT NULL CONSTRAINT DF_PatientTransfusion_ApplicationOfRecordId DEFAULT (1),
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RecordStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL CONSTRAINT DF_PatientTransfusion_RecordStatusCode DEFAULT ('A'),
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_PatientTransfusion_LastUpdateFunctionId DEFAULT (0)
) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'Identifies a specific blood transfusion for a patient.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'PatientTransfusionGuid'
GO
sp_addextendedproperty N'MS_Description', N'A unique identifier for a patient generated by VBECS.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'PatientGuid'
GO
sp_addextendedproperty N'MS_Description', N'A unique identifier for a patient specimen.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'PatientSpecimenGuid'
GO
sp_addextendedproperty N'MS_Description', N'The physical location of the patient when the transfusion occurred.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'TransfusionLocation'
GO
sp_addextendedproperty N'MS_Description', N'The unique identifier for the Hospital Location in the Hospital Location file #44 in VistA.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'LocationIen'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the transfusion of the associated unit was started.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'TransfusionStartDateTime'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the transfusion of the associated unit was completed.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'TransfusionEndDateTime'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the transfused unit.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'BloodUnitGuid'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the transfusionists verified the patient and unit compatibility at the bedside prior to the transfusion.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'BedsideVerificationDate'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the first bedside verifier.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'Transfusionist1Id'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the second bedside verifier.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'Transfusionist2Id'
GO
sp_addextendedproperty N'MS_Description', N'The amont of blood transfused for this transfusion.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'TransfusedVolume'
GO
sp_addextendedproperty N'MS_Description', N'The number of units pooled if the transfusion unit was a pooled unit.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'TransfusionPooledUnitsCount'
GO
sp_addextendedproperty N'MS_Description', N'The name or logon id of the technologist that collected the specimen.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'PhlebotomistId'
GO
sp_addextendedproperty N'MS_Description', N'Indicates that the transfusion was stopped before it was complete.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'InterruptionIndicator'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the transfusion was stopped.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'InterruptionDateTime'
GO
sp_addextendedproperty N'MS_Description', N'The details surrounding the transfusion interruption.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'InterruptionComment'
GO
sp_addextendedproperty N'MS_Description', N'Indicates that the patient did or was suspected to have a reaction to the transfusion.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'ReactionIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Details of the indications associated with the patient''s reaction to the transfusion.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'ReactionSymptoms'
GO
sp_addextendedproperty N'MS_Description', N'Indicates that the patient experienced some difficulty with the transfusion other than a reaction.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'OtherDifficultyIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Details of any other difficulty the patient experienced after the transfusion.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'OtherDifficultyText'
GO
sp_addextendedproperty N'MS_Description', N'Indicates that an extract record has been successfully sent.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'DssExtractSuccessIndicator'
GO
sp_addextendedproperty N'MS_Description', N'The reason for manual bedside verification of the unit.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'BedsideVerificationUnitManualEntryReason'
GO
sp_addextendedproperty N'MS_Description', N'The application that originally entered the record into VBECS.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'ApplicationOfRecordId'
GO
sp_addextendedproperty N'MS_Description', N'The VA medical center division where the patient test was performed.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'DivisionCode'
GO
sp_addextendedproperty N'MS_Description', N'Indicates the state of the associated record.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'RecordStatusCode'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'PatientTransfusion', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.PatientTransfusion ADD 
        CONSTRAINT PK_PatientTransfusion PRIMARY KEY CLUSTERED 
        (
                PatientTransfusionGuid
        ) ON [PRIMARY] 
GO
CREATE NONCLUSTERED INDEX IX_PatientTransfusion_BloodUnitGuid ON dbo.PatientTransfusion (BloodUnitGuid)
GO
CREATE NONCLUSTERED INDEX IX_PatientTransfusion_PatientGuid ON dbo.PatientTransfusion (PatientGuid)
GO
CREATE NONCLUSTERED INDEX IX_PatientTransfusion_PatientSpecimenGuid ON dbo.PatientTransfusion (PatientSpecimenGuid)
GO

/*****************************************************************************************
   Reload the updated PatientTransfusion table 
*****************************************************************************************/
INSERT INTO dbo.PatientTransfusion
        (PatientTransfusionGuid, PatientGuid, PatientSpecimenGuid, TransfusionLocation, LocationIen, TransfusionStartDateTime, 
         TransfusionEndDateTime, BloodUnitGuid, BedsideVerificationDate, Transfusionist1Id, Transfusionist2Id, TransfusedVolume, 
         TransfusionPooledUnitsCount, PhlebotomistId, InterruptionIndicator, InterruptionDateTime, InterruptionComment, 
         ReactionIndicator, ReactionSymptoms, OtherDifficultyIndicator, OtherDifficultyText, DssExtractSuccessIndicator, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          PatientTransfusionGuid, PatientGuid, PatientSpecimenGuid, TransfusionLocation, LocationIen, TransfusionStartDateTime, 
         TransfusionEndDateTime, BloodUnitGuid, BedsideVerificationDate, Transfusionist1Id, Transfusionist2Id, TransfusedVolume, 
         TransfusionPooledUnitsCount, PhlebotomistId, InterruptionIndicator, InterruptionDateTime, InterruptionComment, 
         ReactionIndicator, ReactionSymptoms, OtherDifficultyIndicator, OtherDifficultyText, DssExtractSuccessIndicator, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM #PatientTransfusion
GO
IF OBJECT_ID(N'tempdb..#PatientTransfusion') IS NOT NULL
        DROP TABLE #PatientTransfusion
GO

/*****************************************************************************************
   Modify unique IX_PermittedProductModification on the PermittedProductModification table 
*****************************************************************************************/
if exists (select * from dbo.sysindexes where name = N'IX_PermittedProductModification')
DROP INDEX dbo.PermittedProductModification.IX_PermittedProductModification
GO        

CREATE UNIQUE CLUSTERED INDEX IX_PermittedProductModification 
        ON dbo.PermittedProductModification
                (ProductModificationCode, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, MethodSelect)
        ON [PRIMARY]
GO

/*****************************************************************************************
   Create a temporary RackTest table and save the original data
*****************************************************************************************/
IF OBJECT_ID(N'tempdb..#RackTest') IS NOT NULL
        DROP TABLE #RackTest
GO

CREATE TABLE dbo.#RackTest
        (
        RackTestGuid uniqueidentifier NOT NULL,
        RackLotGuid uniqueidentifier NOT NULL,
        TestDate datetime NOT NULL,
        TestTechId varchar (30) NULL,
        RackTestResultTypeCode char (5) NULL,
        RackTestResult char (3) NULL,
        ReagentAmount tinyint NULL,
        DivisionCode char (5) NOT NULL,
        RecordStatusCode char (1) NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        LastUpdateFunctionId int NOT NULL
        )  ON [PRIMARY]
GO

INSERT INTO #RackTest
        (RackTestGuid, RackLotGuid, TestDate, TestTechId, RackTestResultTypeCode, RackTestResult, ReagentAmount, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          RackTestGuid, RackLotGuid, TestDate, TestTechId, RackTestResultTypeCode, RackTestResult, ReagentAmount, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.RackTest
GO

/*****************************************************************************************
   Create the updated RackTest table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.RackTest') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.RackTest
GO

CREATE TABLE dbo.RackTest
        (
        RackTestGuid uniqueidentifier NOT NULL,
        RackLotGuid uniqueidentifier NOT NULL,
        TestDate datetime NOT NULL,
        TestTechId varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RackTestResultTypeCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RackTestResult char (3) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ReagentAmount tinyint NULL,
        TestWithReagentGuid uniqueidentifier NULL,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        RecordStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_RackTest_LastUpdateFunctionId DEFAULT (0)
) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'Identifies a specific unit quality control test of a reagent/antisera product.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'RackTestGuid'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific reagent/antisera product lot.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'RackLotGuid'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the control test was performed.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'TestDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the technologist who performed the test.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'TestTechId'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific result reagent rack QC test type.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'RackTestResultTypeCode'
GO
sp_addextendedproperty N'MS_Description', N'The result of the Indirect Antiglobulin Test (IAT) control test.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'RackTestResult'
GO
sp_addextendedproperty N'MS_Description', N'The amount of ReagentAntisera used in performing the control test.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'ReagentAmount'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific shipment lot of a reagent/antisera product that this rack was tested with.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'TestWithReagentGuid'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the division associated with this test.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'DivisionCode'
GO
sp_addextendedproperty N'MS_Description', N'Indicates the state of the associated record.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'RecordStatusCode'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'RackTest', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.RackTest ADD 
        CONSTRAINT PK_RackTest PRIMARY KEY CLUSTERED 
        (
                RackTestGuid
        ) ON [PRIMARY] 
GO
CREATE NONCLUSTERED INDEX IX_RackTest_DivisionCode ON dbo.RackTest (DivisionCode)
GO
CREATE NONCLUSTERED INDEX IX_RackTest_RackLotGuid ON dbo.RackTest (RackLotGuid)
GO
CREATE NONCLUSTERED INDEX IX_RackTest_RackTestResultTypeCode ON dbo.RackTest (RackTestResultTypeCode)
GO
CREATE NONCLUSTERED INDEX IX_RackTest_TestWithReagentGuid ON dbo.RackTest (TestWithReagentGuid)
GO

/*****************************************************************************************
   Reload the updated RackTest table 
*****************************************************************************************/
INSERT INTO dbo.RackTest
        (RackTestGuid, RackLotGuid, TestDate, TestTechId, RackTestResultTypeCode, RackTestResult, ReagentAmount, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          RackTestGuid, RackLotGuid, TestDate, TestTechId, RackTestResultTypeCode, RackTestResult, ReagentAmount, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM #RackTest
GO
IF OBJECT_ID(N'tempdb..#RackTest') IS NOT NULL
        DROP TABLE #RackTest
GO

/*****************************************************************************************
   Create a temporary VamcDivision table and save the original data
*****************************************************************************************/
IF OBJECT_ID(N'tempdb..#VamcDivision') IS NOT NULL
        DROP TABLE #VamcDivision
GO

CREATE TABLE dbo.#VamcDivision
        (
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        DivisionGuid uniqueidentifier NOT NULL,
        DivisionName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        ServiceTypeIndicator bit NOT NULL CONSTRAINT DF_VamcDivision_ServiceTypeIndicator DEFAULT (1),
        IccbbaRegistrationNumber char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ElectronicCrossmatchIndicator bit NULL CONSTRAINT DF_VamcDivision_ElectronicCrossmatchIndicator DEFAULT (0),
        FacilityGuid uniqueidentifier NULL,
        LocalSupplierGuid uniqueidentifier NULL,
        AntibodyScreenDisplayCode int NULL,
        MaximumSpecimenExpirationDays smallint NULL,
        AutomatedInstrumentIndicator bit NULL,
        LabelPrinterUseIndicator bit NOT NULL,
        LabelPrinterComPortNumber tinyint NULL,
        LabelPrinterIPAddress varchar (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LabelPrinterTcpPortNumber int NULL,
        TimeZoneId char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        DaylightSavingsTypeId smallint NOT NULL CONSTRAINT DF_VamcDivision_TimeZoneChangeIndicator DEFAULT (1),
        PrinterName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PrinterAlertsIndicator bit NOT NULL CONSTRAINT DF_VamcDivision_PrinterAlertsIndicator DEFAULT (0),
        PrinterAlertsPrinterName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PrinterOrderAlertTypeCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PrinterOrdersNeededHours smallint NULL,
        IconAlertsIndicator bit NULL,
        IconOrderAlertTypeCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        IconOrdersNeededHours smallint NULL,
        IconRefreshRate int NULL,
        LoginMessageText varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InvoiceTemplateText varchar (1000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        MedicalDirectorName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        UsaIndicator bit NOT NULL CONSTRAINT DF_VamcDivision_UsaIndicator DEFAULT (1),
        LockInactivityTimeoutMin int NOT NULL,
        AccessionAreaId int NULL,
        DaylightSavingsStartDate datetime NULL,
        DaylightSavingsEndDate datetime NULL,
        RecordStatusCode char (1) NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        LastUpdateFunctionId int NOT NULL
        )  ON [PRIMARY]
GO

INSERT INTO #VamcDivision
        (DivisionCode, DivisionGuid, DivisionName, ServiceTypeIndicator, IccbbaRegistrationNumber, 
         ElectronicCrossmatchIndicator, FacilityGuid, LocalSupplierGuid, AntibodyScreenDisplayCode, 
         MaximumSpecimenExpirationDays, AutomatedInstrumentIndicator, LabelPrinterUseIndicator, 
         LabelPrinterComPortNumber, LabelPrinterIPAddress, LabelPrinterTcpPortNumber, TimeZoneId, 
         DaylightSavingsTypeId, PrinterName, PrinterAlertsIndicator, PrinterAlertsPrinterName, 
         PrinterOrderAlertTypeCode, PrinterOrdersNeededHours, IconAlertsIndicator, IconOrderAlertTypeCode, 
         IconOrdersNeededHours, IconRefreshRate, LoginMessageText, InvoiceTemplateText, MedicalDirectorName, 
         UsaIndicator, LockInactivityTimeoutMin, AccessionAreaId, DaylightSavingsStartDate, DaylightSavingsEndDate,
         RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          DivisionCode, DivisionGuid, DivisionName, ServiceTypeIndicator, IccbbaRegistrationNumber, 
         ElectronicCrossmatchIndicator, FacilityGuid, LocalSupplierGuid, AntibodyScreenDisplayCode, 
         MaximumSpecimenExpirationDays, AutomatedInstrumentIndicator, LabelPrinterUseIndicator, 
         LabelPrinterComPortNumber, LabelPrinterIPAddress, LabelPrinterTcpPortNumber, TimeZoneId, 
         DaylightSavingsTypeId, PrinterName, PrinterAlertsIndicator, PrinterAlertsPrinterName, 
         PrinterOrderAlertTypeCode, PrinterOrdersNeededHours, IconAlertsIndicator, IconOrderAlertTypeCode, 
         IconOrdersNeededHours, IconRefreshRate, LoginMessageText, InvoiceTemplateText, MedicalDirectorName, 
         UsaIndicator, LockInactivityTimeoutMin, AccessionAreaId, DaylightSavingsStartDate, DaylightSavingsEndDate,
         RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM dbo.VamcDivision
GO

/*****************************************************************************************
   Drop the constraints from the VamcDivision table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_AntibodyParameter_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.AntibodyParameter DROP CONSTRAINT FK_AntibodyParameter_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_AntiseraWorklist_VamcDivision ') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.AntiseraWorklist DROP CONSTRAINT FK_AntiseraWorklist_VamcDivision 
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_AssociatedInstitution_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.AssociatedInstitution DROP CONSTRAINT FK_AssociatedInstitution_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_BloodUnit_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.BloodUnit DROP CONSTRAINT FK_BloodUnit_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_BloodUnitAntigen_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.BloodUnitAntigen DROP CONSTRAINT FK_BloodUnitAntigen_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_BloodUnitModification_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.BloodUnitModification DROP CONSTRAINT FK_BloodUnitModification_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_BloodUnitTest_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.BloodUnitTest DROP CONSTRAINT FK_BloodUnitTest_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_CannedComment_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.CannedComment DROP CONSTRAINT FK_CannedComment_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ComponentClassParameter_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ComponentClassParameter DROP CONSTRAINT FK_ComponentClassParameter_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_DailyControl_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.DailyControl DROP CONSTRAINT FK_DailyControl_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_Equipment_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.Equipment DROP CONSTRAINT FK_Equipment_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionAntigenTest_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionAntigenTest DROP CONSTRAINT FK_ExceptionAntigenTest_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionCautionTag_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionCautionTag DROP CONSTRAINT FK_ExceptionCautionTag_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionEmergencyIssueOrder_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionEmergencyIssueOrder DROP CONSTRAINT FK_ExceptionEmergencyIssueOrder_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionEmergencyIssueUnitTest_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionEmergencyIssueUnitTest DROP CONSTRAINT FK_ExceptionEmergencyIssueUnitTest_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionExpiredTask_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionExpiredTask DROP CONSTRAINT FK_ExceptionExpiredTask_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionExpiredUnitReceived_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionExpiredUnitReceived DROP CONSTRAINT FK_ExceptionExpiredUnitReceived_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionInconclusiveCrossmatch_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionInconclusiveCrossmatch DROP CONSTRAINT FK_ExceptionInconclusiveCrossmatch_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionLabelMismatch_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionLabelMismatch DROP CONSTRAINT FK_ExceptionLabelMismatch_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionPatientAboRh_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionPatientAboRh DROP CONSTRAINT FK_ExceptionPatientAboRh_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionPatientAboRhDiscrepancy_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionPatientAboRhDiscrepancy DROP CONSTRAINT FK_ExceptionPatientAboRhDiscrepancy_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionPatientAntigenDiscrepancy_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionPatientAntigenDiscrepancy DROP CONSTRAINT FK_ExceptionPatientAntigenDiscrepancy_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionPatientRestriction_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionPatientRestriction DROP CONSTRAINT FK_ExceptionPatientRestriction_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionPatientTest_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionPatientTest DROP CONSTRAINT FK_ExceptionPatientTest_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionPatientTestInactivated_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionPatientTestInactivated DROP CONSTRAINT FK_ExceptionPatientTestInactivated_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionQc_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionQc DROP CONSTRAINT FK_ExceptionQc_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionQcInactivation_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionQcInactivation DROP CONSTRAINT FK_ExceptionQcInactivation_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionQcNotPerformed_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionQcNotPerformed DROP CONSTRAINT FK_ExceptionQcNotPerformed_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionQuarantine_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionQuarantine DROP CONSTRAINT FK_ExceptionQuarantine_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionRackTest_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionRackTest DROP CONSTRAINT FK_ExceptionRackTest_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionReflexTest_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionReflexTest DROP CONSTRAINT FK_ExceptionReflexTest_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionRemoveFinalUnitStatus_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionRemoveFinalUnitStatus DROP CONSTRAINT FK_ExceptionRemoveFinalUnitStatus_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionReturnedUnit_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionReturnedUnit DROP CONSTRAINT FK_ExceptionReturnedUnit_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionSpecimen_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionSpecimen DROP CONSTRAINT FK_ExceptionSpecimen_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionTransfusion_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionTransfusion DROP CONSTRAINT FK_ExceptionTransfusion_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionTransfusionReactionWorkup_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionTransfusionReactionWorkup DROP CONSTRAINT FK_ExceptionTransfusionReactionWorkup_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionTrwSpecimen_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionTrwSpecimen DROP CONSTRAINT FK_ExceptionTrwSpecimen_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionUnitAboRh_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionUnitAboRh DROP CONSTRAINT FK_ExceptionUnitAboRh_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionUnitIssue_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionUnitIssue DROP CONSTRAINT FK_ExceptionUnitIssue_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionUnitModification_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionUnitModification DROP CONSTRAINT FK_ExceptionUnitModification_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ExceptionUnitSelection_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ExceptionUnitSelection DROP CONSTRAINT FK_ExceptionUnitSelection_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_HcpcsAssignment_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.HcpcsAssignment DROP CONSTRAINT FK_HcpcsAssignment_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_IssuedUnitComment_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.IssuedUnitComment DROP CONSTRAINT FK_IssuedUnitComment_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_LocalSupplier_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.LocalSupplier DROP CONSTRAINT FK_LocalSupplier_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_LoginMessage_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.LoginMessage DROP CONSTRAINT FK_LoginMessage_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_Msbos_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.Msbos DROP CONSTRAINT FK_Msbos_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_OrderedUnit_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.OrderedUnit DROP CONSTRAINT FK_OrderedUnit_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PatientOrder_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PatientOrder DROP CONSTRAINT FK_PatientOrder_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PatientSpecialInstruction_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PatientSpecialInstruction DROP CONSTRAINT FK_PatientSpecialInstruction_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PatientSpecimen_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PatientSpecimen DROP CONSTRAINT FK_PatientSpecimen_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PatientTest_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PatientTest DROP CONSTRAINT FK_PatientTest_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PatientTransfusionComment_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PatientTransfusionComment DROP CONSTRAINT FK_PatientTransfusionComment_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PatientTransfusionReaction_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PatientTransfusionReaction DROP CONSTRAINT FK_PatientTransfusionReaction_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PatientTransfusionRequirement_CreateDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PatientTransfusionRequirement DROP CONSTRAINT FK_PatientTransfusionRequirement_CreateDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PatientTransfusionRequirement_InactivateDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PatientTransfusionRequirement DROP CONSTRAINT FK_PatientTransfusionRequirement_InactivateDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_PoolCounter_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.PoolCounter DROP CONSTRAINT FK_PoolCounter_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ProductModificationParameter_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ProductModificationParameter DROP CONSTRAINT FK_ProductModificationParameter_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ProductShipper_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ProductShipper DROP CONSTRAINT FK_ProductShipper_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_Rack_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.Rack DROP CONSTRAINT FK_Rack_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_RackLot_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.RackLot DROP CONSTRAINT FK_RackLot_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_Reagent_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.Reagent DROP CONSTRAINT FK_Reagent_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ReagentTestParameter_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ReagentTestParameter DROP CONSTRAINT FK_ReagentTestParameter_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_ReagentTypeParameter_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.ReagentTypeParameter DROP CONSTRAINT FK_ReagentTypeParameter_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_Shipment_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.Shipment DROP CONSTRAINT FK_Shipment_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_SpecimenTest_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.SpecimenTest DROP CONSTRAINT FK_SpecimenTest_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_SpecimenTestThreshold_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.SpecimenTestThreshold DROP CONSTRAINT FK_SpecimenTestThreshold_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_Supply_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.Supply DROP CONSTRAINT FK_Supply_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_VBECSLock_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.VBECSLock DROP CONSTRAINT FK_VBECSLock_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_VbecsUserDivisionRole_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.VbecsUserDivisionRole DROP CONSTRAINT FK_VbecsUserDivisionRole_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_WorkloadEvent_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.WorkloadEvent DROP CONSTRAINT FK_WorkloadEvent_VamcDivision
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.FK_WorkloadProcess_VamcDivision') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE dbo.WorkloadProcess DROP CONSTRAINT FK_WorkloadProcess_VamcDivision
GO

/*****************************************************************************************
   Create the updated VamcDivision table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.VamcDivision') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.VamcDivision
GO

CREATE TABLE dbo.VamcDivision
        (
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        DivisionGuid uniqueidentifier NOT NULL,
        DivisionName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        ServiceTypeIndicator bit NOT NULL CONSTRAINT DF_VamcDivision_ServiceTypeIndicator DEFAULT (1),
        IccbbaRegistrationNumber char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ElectronicCrossmatchIndicator bit NULL CONSTRAINT DF_VamcDivision_ElectronicCrossmatchIndicator DEFAULT (0),
        FacilityGuid uniqueidentifier NULL,
        LocalSupplierGuid uniqueidentifier NULL,
        AntibodyScreenDisplayCode int NULL,
        MaximumSpecimenExpirationDays smallint NULL,
        AutomatedInstrumentIndicator bit NULL,
        LabelPrinterUseIndicator bit NOT NULL,
        LabelPrinterComPortNumber tinyint NULL,
        LabelPrinterIPAddress varchar (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LabelPrinterTcpPortNumber int NULL,
        TimeZoneId char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        DaylightSavingsTypeId smallint NOT NULL CONSTRAINT DF_VamcDivision_TimeZoneChangeIndicator DEFAULT (1),
        PrinterName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PrinterAlertsIndicator bit NOT NULL CONSTRAINT DF_VamcDivision_PrinterAlertsIndicator DEFAULT (0),
        PrinterAlertsPrinterName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PrinterOrderAlertTypeCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PrinterOrdersNeededHours smallint NULL,
        IconAlertsIndicator bit NULL,
        IconOrderAlertTypeCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        IconOrdersNeededHours smallint NULL,
        IconRefreshRate int NULL,
        LoginMessageText varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InvoiceTemplateText varchar (1000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        MedicalDirectorName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        UsaIndicator bit NOT NULL CONSTRAINT DF_VamcDivision_UsaIndicator DEFAULT (1),
        LockInactivityTimeoutMin int NOT NULL,
        AccessionAreaId int NULL,
        DaylightSavingsStartDate datetime NULL,
        DaylightSavingsEndDate datetime NULL,
        ReactivityPhaseCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL CONSTRAINT DF_VamcDivision_ReactivityPhaseCode DEFAULT ('9'),
        RecordStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] timestamp NOT NULL,
        LastUpdateFunctionId int NOT NULL CONSTRAINT DF_VamcDivision_LastUpdateFunctionId DEFAULT (0)
) ON [PRIMARY]
GO

sp_addextendedproperty N'MS_Description', N'Identifies an organizational unit of a VA Medical Center.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'DivisionCode'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a unique instance of an organizational unit of a VA Medical Center.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'DivisionGuid'
GO
sp_addextendedproperty N'MS_Description', N'The name of a VA Medical Center organizational unit.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'DivisionName'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the VAMC division is a standard "full service" configured facility.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'ServiceTypeIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the division as an original blood collection facility.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'IccbbaRegistrationNumber'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the VAMC division has enabled electronic crossmatching.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'ElectronicCrossmatchIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Links to the division''s record in the Facility table to enable getting the address for the division.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'FacilityGuid'
GO
sp_addextendedproperty N'MS_Description', N'Links to the division''s record in the LocalSupplier table to enable getting the address for the division.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'LocalSupplierGuid'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific display option for antibody screen tests.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'AntibodyScreenDisplayCode'
GO
sp_addextendedproperty N'MS_Description', N'Indicates the maximum number of days a specimen can exist before it expires for the VAMC division.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'MaximumSpecimenExpirationDays'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the VAMC division has enabled automated instrument processing.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'AutomatedInstrumentIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the division uses a designated label printer.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'LabelPrinterUseIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the COM port for the division''s label printer.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'LabelPrinterComPortNumber'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the IP Address for the division''s label printer.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'LabelPrinterIPAddress'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the TCP/IP port for the division''s label printer.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'LabelPrinterTcpPortNumber'
GO
sp_addextendedproperty N'MS_Description', N'The standard time zone id for the division.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'TimeZoneId'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific option for changing from standard time to daylight saving time.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'DaylightSavingsTypeId'
GO
sp_addextendedproperty N'MS_Description', N'Default report printer name for the division.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'PrinterName'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the division has activated printer alerts for incoming orders.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'PrinterAlertsIndicator'
GO
sp_addextendedproperty N'MS_Description', N'The name of the printer that will print order alerts.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'PrinterAlertsPrinterName'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a type of order alert.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'PrinterOrderAlertTypeCode'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a time interval, in hours, in which orders received by VBECS need to be filled.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'PrinterOrdersNeededHours'
GO
sp_addextendedproperty N'MS_Description', N'Indicates whether the division has activated an icon for order alerts.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'IconAlertsIndicator'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a type of order alert.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'IconOrderAlertTypeCode'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a time interval, in hours, in which orders received by VBECS need to be filled.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'IconOrdersNeededHours'
GO
sp_addextendedproperty N'MS_Description', N'The frequency, in seconds, with which the system will check for order updates.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'IconRefreshRate'
GO
sp_addextendedproperty N'MS_Description', N'The text of the message to be displayed at login.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'LoginMessageText'
GO
sp_addextendedproperty N'MS_Description', N'The detailed text for a VBECS shipping invoice template.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'InvoiceTemplateText'
GO
sp_addextendedproperty N'MS_Description', N'The name of a blood bank medical director.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'MedicalDirectorName'
GO
sp_addextendedproperty N'MS_Description', N'Indicates that the division is located in the USA.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'UsaIndicator'
GO
sp_addextendedproperty N'MS_Description', N'The interval of inactivity, in minutes, after which the system will lock a current function.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'LockInactivityTimeoutMin'
GO
sp_addextendedproperty N'MS_Description', N'Identifies the Lab accession area for the division.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'AccessionAreaId'
GO
sp_addextendedproperty N'MS_Description', N'The date daylight savings time starts.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'DaylightSavingsStartDate'
GO
sp_addextendedproperty N'MS_Description', N'The date daylight savings time ends.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'DaylightSavingsEndDate'
GO
sp_addextendedproperty N'MS_Description', N'Identifies a specific reactivity phase for testing a reagent.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'ReactivityPhaseCode'
GO
sp_addextendedproperty N'MS_Description', N'Indicates the state of the associated record.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'RecordStatusCode'
GO
sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'LastUpdateDate'
GO
sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'LastUpdateUser'
GO
sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'RowVersion'
GO
sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', 'USER', N'dbo', 'TABLE', N'VamcDivision', 'COLUMN', N'LastUpdateFunctionId'
GO

ALTER TABLE dbo.VamcDivision ADD 
        CONSTRAINT PK_VamcDivision PRIMARY KEY CLUSTERED 
        (
                DivisionCode
        ) ON [PRIMARY] 
GO
CREATE NONCLUSTERED INDEX IX_VamcDivision_AntibodyScreenDisplayCode ON dbo.VamcDivision (AntibodyScreenDisplayCode)
GO
CREATE NONCLUSTERED INDEX IX_VamcDivision_DaylightSavingsTypeId ON dbo.VamcDivision (DaylightSavingsTypeId)
GO
CREATE NONCLUSTERED INDEX IX_VamcDivision_FacilityGuid ON dbo.VamcDivision (FacilityGuid)
GO
CREATE NONCLUSTERED INDEX IX_VamcDivision_IconOrderAlertTypeCode ON dbo.VamcDivision (IconOrderAlertTypeCode)
GO
CREATE NONCLUSTERED INDEX IX_VamcDivision_PrinterOrderAlertTypeCode ON dbo.VamcDivision (PrinterOrderAlertTypeCode)
GO
CREATE NONCLUSTERED INDEX IX_VamcDivision_ReactivityPhaseCode ON dbo.VamcDivision (ReactivityPhaseCode)
GO
CREATE NONCLUSTERED INDEX IX_VamcDivision_TimeZoneId ON dbo.VamcDivision (TimeZoneId)
GO

/*****************************************************************************************
   Reload the updated VamcDivision table 
*****************************************************************************************/
INSERT INTO dbo.VamcDivision
        (DivisionCode, DivisionGuid, DivisionName, ServiceTypeIndicator, IccbbaRegistrationNumber, 
         ElectronicCrossmatchIndicator, FacilityGuid, LocalSupplierGuid, AntibodyScreenDisplayCode, 
         MaximumSpecimenExpirationDays, AutomatedInstrumentIndicator, LabelPrinterUseIndicator, 
         LabelPrinterComPortNumber, LabelPrinterIPAddress, LabelPrinterTcpPortNumber, TimeZoneId, 
         DaylightSavingsTypeId, PrinterName, PrinterAlertsIndicator, PrinterAlertsPrinterName, 
         PrinterOrderAlertTypeCode, PrinterOrdersNeededHours, IconAlertsIndicator, IconOrderAlertTypeCode, 
         IconOrdersNeededHours, IconRefreshRate, LoginMessageText, InvoiceTemplateText, MedicalDirectorName, 
         UsaIndicator, LockInactivityTimeoutMin, AccessionAreaId, DaylightSavingsStartDate, DaylightSavingsEndDate,
         RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId)
SELECT          DivisionCode, DivisionGuid, DivisionName, ServiceTypeIndicator, IccbbaRegistrationNumber, 
         ElectronicCrossmatchIndicator, FacilityGuid, LocalSupplierGuid, AntibodyScreenDisplayCode, 
         MaximumSpecimenExpirationDays, AutomatedInstrumentIndicator, LabelPrinterUseIndicator, 
         LabelPrinterComPortNumber, LabelPrinterIPAddress, LabelPrinterTcpPortNumber, TimeZoneId, 
         DaylightSavingsTypeId, PrinterName, PrinterAlertsIndicator, PrinterAlertsPrinterName, 
         PrinterOrderAlertTypeCode, PrinterOrdersNeededHours, IconAlertsIndicator, IconOrderAlertTypeCode, 
         IconOrdersNeededHours, IconRefreshRate, LoginMessageText, InvoiceTemplateText, MedicalDirectorName, 
         UsaIndicator, LockInactivityTimeoutMin, AccessionAreaId, DaylightSavingsStartDate, DaylightSavingsEndDate,
         RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
  FROM #VamcDivision
GO
IF OBJECT_ID(N'tempdb..#VamcDivision') IS NOT NULL
        DROP TABLE #VamcDivision
GO

/*****************************************************************************************
   Add the foreign keys
*****************************************************************************************/
ALTER TABLE dbo.AntibodyAntigen WITH NOCHECK ADD CONSTRAINT FK_AntibodyAntigen_AntigenType FOREIGN KEY (AntigenTypeId) REFERENCES dbo.AntigenType (AntigenTypeId)
GO
ALTER TABLE dbo.AntibodyParameter WITH NOCHECK ADD CONSTRAINT FK_AntibodyParameter_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.AntigenTest WITH NOCHECK ADD CONSTRAINT FK_AntigenTest_AntigenType FOREIGN KEY (AntigenTypeId) REFERENCES dbo.AntigenType (AntigenTypeId)
GO
ALTER TABLE dbo.AntiseraOrderedTest WITH NOCHECK ADD CONSTRAINT FK_AntiseraOrderedTest_OrderedTest FOREIGN KEY (OrderedTestGuid) REFERENCES dbo.OrderedTest (OrderedTestGuid)
GO
ALTER TABLE dbo.AntiseraWorklist WITH NOCHECK ADD CONSTRAINT FK_AntiseraWorklist_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.AssociatedInstitution ADD CONSTRAINT FK_AssociatedInstitution_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.BloodProduct ADD CONSTRAINT FK_BloodProduct_ProductType FOREIGN KEY (ProductTypeCode) REFERENCES dbo.ProductType (ProductTypeCode)
GO
ALTER TABLE dbo.BloodProductModification ADD CONSTRAINT FK_BloodProductModification_FromBloodProduct FOREIGN KEY (FromBloodProductGuid) REFERENCES dbo.BloodProduct (BloodProductGuid)
GO
ALTER TABLE dbo.BloodProductModification ADD CONSTRAINT FK_BloodProductModification_ProductModification FOREIGN KEY (ProductModificationCode) REFERENCES dbo.ProductModification (ProductModificationCode)
GO
ALTER TABLE dbo.BloodProductModification ADD CONSTRAINT FK_BloodProductModification_ToBloodProductGuid FOREIGN KEY (ToBloodProductGuid) REFERENCES dbo.BloodProduct (BloodProductGuid)
GO
ALTER TABLE dbo.BloodUnit WITH NOCHECK ADD CONSTRAINT FK_BloodUnit_BloodProduct FOREIGN KEY (BloodProductGuid) REFERENCES dbo.BloodProduct (BloodProductGuid)
GO
ALTER TABLE dbo.BloodUnit WITH NOCHECK ADD CONSTRAINT FK_BloodUnit_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.BloodUnitAntigen WITH NOCHECK ADD CONSTRAINT FK_BloodUnitAntigen_AntigenType FOREIGN KEY (AntigenTypeId) REFERENCES dbo.AntigenType (AntigenTypeId)
GO
ALTER TABLE dbo.BloodUnitAntigen WITH NOCHECK ADD CONSTRAINT FK_BloodUnitAntigen_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.BloodUnitModification ADD CONSTRAINT FK_BloodUnitModification_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.BloodUnitShipment WITH NOCHECK ADD CONSTRAINT FK_BloodUnitShipment_BloodProduct FOREIGN KEY (LoginBloodProductGuid) REFERENCES dbo.BloodProduct (BloodProductGuid)
GO
ALTER TABLE dbo.BloodUnitTest WITH NOCHECK ADD CONSTRAINT FK_BloodUnitTest_OrderedComponent FOREIGN KEY (OrderedComponentGuid) REFERENCES dbo.OrderedComponent (OrderedComponentGuid)
GO
ALTER TABLE dbo.BloodUnitTest WITH NOCHECK ADD CONSTRAINT FK_BloodUnitTest_OrderedTest FOREIGN KEY (OrderedTestGuid) REFERENCES dbo.OrderedTest (OrderedTestGuid)
GO
ALTER TABLE dbo.BloodUnitTest WITH NOCHECK ADD CONSTRAINT FK_BloodUnitTest_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.CannedComment WITH NOCHECK ADD CONSTRAINT FK_CannedComment_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ComponentClassParameter WITH NOCHECK ADD CONSTRAINT FK_ComponentClassParameter_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.DailyControl WITH NOCHECK ADD CONSTRAINT FK_DailyControl_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.DailyQcWorklist WITH NOCHECK ADD CONSTRAINT FK_DailyQcWorklist_Rack FOREIGN KEY (RackGuid) REFERENCES dbo.Rack (RackGuid)
GO
ALTER TABLE dbo.DailyQcWorklist WITH NOCHECK ADD CONSTRAINT FK_DailyQcWorklist_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.Equipment WITH NOCHECK ADD CONSTRAINT FK_Equipment_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionAntigenTest WITH NOCHECK ADD CONSTRAINT FK_ExceptionAntigenTest_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionCautionTag WITH NOCHECK ADD CONSTRAINT FK_ExceptionCautionTag_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionElectronicTransfusion ADD CONSTRAINT FK_ExceptionElectronicTransfusion_ExceptionType FOREIGN KEY (ExceptionTypeId) REFERENCES dbo.ExceptionType (ExceptionTypeId)
GO
ALTER TABLE dbo.ExceptionElectronicTransfusion ADD CONSTRAINT FK_ExceptionElectronicTransfusion_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionEmergencyIssueOrder WITH NOCHECK ADD CONSTRAINT FK_ExceptionEmergencyIssueOrder_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionEmergencyIssueUnitTest WITH NOCHECK ADD CONSTRAINT FK_ExceptionEmergencyIssueUnitTest_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionExpiredTask WITH NOCHECK ADD CONSTRAINT FK_ExceptionExpiredTask_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionExpiredUnitReceived WITH NOCHECK ADD CONSTRAINT FK_ExceptionExpiredUnitReceived_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionInconclusiveCrossmatch WITH NOCHECK ADD CONSTRAINT FK_ExceptionInconclusiveCrossmatch_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionLabelMismatch WITH NOCHECK ADD CONSTRAINT FK_ExceptionLabelMismatch_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionPatientAboRh WITH NOCHECK ADD CONSTRAINT FK_ExceptionPatientAboRh_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionPatientAboRhDiscrepancy WITH NOCHECK ADD CONSTRAINT FK_ExceptionPatientAboRhDiscrepancy_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionPatientAntigenDiscrepancy WITH NOCHECK ADD CONSTRAINT FK_ExceptionPatientAntigenDiscrepancy_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionPatientRestriction WITH NOCHECK ADD CONSTRAINT FK_ExceptionPatientRestriction_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionPatientTest WITH NOCHECK ADD CONSTRAINT FK_ExceptionPatientTest_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionPatientTestInactivated WITH NOCHECK ADD CONSTRAINT FK_ExceptionPatientTestInactivated_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionQc WITH NOCHECK ADD CONSTRAINT FK_ExceptionQc_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionQcInactivation WITH NOCHECK ADD CONSTRAINT FK_ExceptionQcInactivation_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionQcNotPerformed WITH NOCHECK ADD CONSTRAINT FK_ExceptionQcNotPerformed_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionQuarantine WITH NOCHECK ADD CONSTRAINT FK_ExceptionQuarantine_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionRackTest WITH NOCHECK ADD CONSTRAINT FK_ExceptionRackTest_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionReflexTest WITH NOCHECK ADD CONSTRAINT FK_ExceptionReflexTest_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionRemoveFinalUnitStatus WITH NOCHECK ADD CONSTRAINT FK_ExceptionRemoveFinalUnitStatus_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionReturnedUnit WITH NOCHECK ADD CONSTRAINT FK_ExceptionReturnedUnit_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionSpecimen WITH NOCHECK ADD CONSTRAINT FK_ExceptionSpecimen_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionTransfusion WITH NOCHECK ADD CONSTRAINT FK_ExceptionTransfusion_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionTransfusionReactionWorkup WITH NOCHECK ADD CONSTRAINT FK_ExceptionTransfusionReactionWorkup_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionTrwSpecimen WITH NOCHECK ADD CONSTRAINT FK_ExceptionTrwSpecimen_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionUnitAboRh WITH NOCHECK ADD CONSTRAINT FK_ExceptionUnitAboRh_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionUnitIssue WITH NOCHECK ADD CONSTRAINT FK_ExceptionUnitIssue_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionUnitModification WITH NOCHECK ADD CONSTRAINT FK_ExceptionUnitModification_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ExceptionUnitSelection WITH NOCHECK ADD CONSTRAINT FK_ExceptionUnitSelection_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.HcpcsAssignment WITH NOCHECK ADD CONSTRAINT FK_HcpcsAssignment_BloodProduct FOREIGN KEY (BloodProductGuid) REFERENCES dbo.BloodProduct (BloodProductGuid)
GO
ALTER TABLE dbo.HcpcsAssignment WITH NOCHECK ADD CONSTRAINT FK_HcpcsAssignment_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.InterfaceControl ADD CONSTRAINT FK_InterfaceControl_Interface FOREIGN KEY (InterfaceId) REFERENCES dbo.Interface (InterfaceId)
GO
ALTER TABLE dbo.IssuedUnitComment WITH NOCHECK ADD CONSTRAINT FK_IssuedUnitComment_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.LocalSupplier WITH NOCHECK ADD CONSTRAINT FK_LocalSupplier_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.LoginMessage WITH NOCHECK ADD CONSTRAINT FK_LoginMessage_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.MessageLog ADD CONSTRAINT FK_MessageLog_InterfaceControl FOREIGN KEY (InterfaceControlId) REFERENCES dbo.InterfaceControl (InterfaceControlId)
GO
ALTER TABLE dbo.MessageLog ADD CONSTRAINT FK_MessageLog_MessageStatus FOREIGN KEY (MessageStatusCode) REFERENCES dbo.MessageStatus (MessageStatusCode)
GO
ALTER TABLE dbo.MessageType WITH NOCHECK ADD CONSTRAINT FK_MessageType_InterfaceControl FOREIGN KEY (InterfaceControlId) REFERENCES dbo.InterfaceControl (InterfaceControlId)
GO
ALTER TABLE dbo.Msbos WITH NOCHECK ADD CONSTRAINT FK_Msbos_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.OrderedComponent WITH NOCHECK ADD CONSTRAINT FK_OrderedComponent_ComponentClass FOREIGN KEY (ComponentClassId) REFERENCES dbo.ComponentClass (ComponentClassId)
GO
ALTER TABLE dbo.OrderedComponent WITH NOCHECK ADD CONSTRAINT FK_OrderedComponent_OrderStatus FOREIGN KEY (OrderStatusCode) REFERENCES dbo.OrderStatus (OrderStatusCode)
GO
ALTER TABLE dbo.OrderedComponent WITH NOCHECK ADD CONSTRAINT FK_OrderedComponent_OrderUrgency FOREIGN KEY (OrderUrgencyCode) REFERENCES dbo.OrderUrgency (OrderUrgencyCode)
GO
ALTER TABLE dbo.OrderedComponent WITH NOCHECK ADD CONSTRAINT FK_OrderedComponent_PatientOrder FOREIGN KEY (PatientOrderGuid) REFERENCES dbo.PatientOrder (PatientOrderGuid)
GO
ALTER TABLE dbo.OrderedComponent WITH NOCHECK ADD CONSTRAINT FK_OrderedComponent_PatientSpecimen FOREIGN KEY (PatientSpecimenGuid) REFERENCES dbo.PatientSpecimen (PatientSpecimenGuid)
GO
ALTER TABLE dbo.OrderedComponent WITH NOCHECK ADD CONSTRAINT FK_OrderedComponent_SpecimenStatus FOREIGN KEY (SpecimenStatusCode) REFERENCES dbo.SpecimenStatus (SpecimenStatusCode)
GO
ALTER TABLE dbo.OrderedComponent WITH NOCHECK ADD CONSTRAINT FK_OrderedComponent_TaskStatus FOREIGN KEY (TaskStatusCode) REFERENCES dbo.TaskStatus (TaskStatusCode)
GO
ALTER TABLE dbo.OrderedComponent WITH NOCHECK ADD CONSTRAINT FK_OrderedComponent_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.OrderedTest WITH NOCHECK ADD CONSTRAINT FK_OrderedTest_OrderableTest FOREIGN KEY (OrderableTestId) REFERENCES dbo.OrderableTest (OrderableTestId)
GO
ALTER TABLE dbo.OrderedTest WITH NOCHECK ADD CONSTRAINT FK_OrderedTest_OrderedComponent FOREIGN KEY (RelatedComponentGuid) REFERENCES dbo.OrderedComponent (OrderedComponentGuid)
GO
ALTER TABLE dbo.OrderedTest WITH NOCHECK ADD CONSTRAINT FK_OrderedTest_OrderedTest FOREIGN KEY (RelatedTestGuid) REFERENCES dbo.OrderedTest (OrderedTestGuid)
GO
ALTER TABLE dbo.OrderedTest WITH NOCHECK ADD CONSTRAINT FK_OrderedTest_OrderStatus FOREIGN KEY (OrderStatusCode) REFERENCES dbo.OrderStatus (OrderStatusCode)
GO
ALTER TABLE dbo.OrderedTest WITH NOCHECK ADD CONSTRAINT FK_OrderedTest_OrderUrgency FOREIGN KEY (OrderUrgencyCode) REFERENCES dbo.OrderUrgency (OrderUrgencyCode)
GO
ALTER TABLE dbo.OrderedTest WITH NOCHECK ADD CONSTRAINT FK_OrderedTest_PatientOrder FOREIGN KEY (PatientOrderGuid) REFERENCES dbo.PatientOrder (PatientOrderGuid)
GO
ALTER TABLE dbo.OrderedTest WITH NOCHECK ADD CONSTRAINT FK_OrderedTest_PatientSpecimen FOREIGN KEY (PatientSpecimenGuid) REFERENCES dbo.PatientSpecimen (PatientSpecimenGuid)
GO
ALTER TABLE dbo.OrderedTest WITH NOCHECK ADD CONSTRAINT FK_OrderedTest_TaskStatus FOREIGN KEY (TaskStatusCode) REFERENCES dbo.TaskStatus (TaskStatusCode)
GO
ALTER TABLE dbo.OrderedTest WITH NOCHECK ADD CONSTRAINT FK_OrderedTest_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.OrderedUnit WITH NOCHECK ADD CONSTRAINT FK_OrderedUnit_OrderedComponent FOREIGN KEY (OrderedComponentGuid) REFERENCES dbo.OrderedComponent (OrderedComponentGuid)
GO
ALTER TABLE dbo.OrderedUnit WITH NOCHECK ADD CONSTRAINT FK_OrderedUnit_OrderedTest FOREIGN KEY (OrderedTestGuid) REFERENCES dbo.OrderedTest (OrderedTestGuid)
GO
ALTER TABLE dbo.OrderedUnit WITH NOCHECK ADD CONSTRAINT FK_OrderedUnit_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.PatientLocation ADD CONSTRAINT FK_PatientLocation_Patient FOREIGN KEY (PatientGuid) REFERENCES dbo.Patient (PatientGuid)
GO
ALTER TABLE dbo.PatientOrder ADD CONSTRAINT FK_PatientOrder_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.PatientSpecialInstruction WITH NOCHECK ADD CONSTRAINT FK_PatientSpecialInstruction_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.PatientSpecimen WITH NOCHECK ADD CONSTRAINT FK_PatientSpecimen_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.PatientTest WITH NOCHECK ADD CONSTRAINT FK_PatientTest_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.PatientTransfusion ADD CONSTRAINT FK_PatientTransfusion_BloodUnit FOREIGN KEY (BloodUnitGuid) REFERENCES dbo.BloodUnit (BloodUnitGuid)
GO
ALTER TABLE dbo.PatientTransfusion ADD CONSTRAINT FK_PatientTransfusion_Patient FOREIGN KEY (PatientGuid) REFERENCES dbo.Patient (PatientGuid)
GO
ALTER TABLE dbo.PatientTransfusion ADD CONSTRAINT FK_PatientTransfusion_PatientSpecimen FOREIGN KEY (PatientSpecimenGuid) REFERENCES dbo.PatientSpecimen (PatientSpecimenGuid)
GO
ALTER TABLE dbo.PatientTransfusion ADD CONSTRAINT FK_PatientTransfusion_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.PatientTransfusionComment WITH NOCHECK ADD CONSTRAINT FK_PatientTransfusionComment_PatientTransfusion FOREIGN KEY (PatientTransfusionGuid) REFERENCES dbo.PatientTransfusion (PatientTransfusionGuid)
GO
ALTER TABLE dbo.PatientTransfusionComment WITH NOCHECK ADD CONSTRAINT FK_PatientTransfusionComment_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.PatientTransfusionReaction WITH NOCHECK ADD CONSTRAINT FK_PatientTransfusionReaction_OrderedTest FOREIGN KEY (OrderedTestGuid) REFERENCES dbo.OrderedTest (OrderedTestGuid)
GO
ALTER TABLE dbo.PatientTransfusionReaction WITH NOCHECK ADD CONSTRAINT FK_PatientTransfusionReaction_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.PatientTransfusionRequirement ADD CONSTRAINT FK_PatientTransfusionRequirement_AntigenType FOREIGN KEY (AntigenTypeId) REFERENCES dbo.AntigenType (AntigenTypeId)
GO
ALTER TABLE dbo.PatientTransfusionRequirement ADD CONSTRAINT FK_PatientTransfusionRequirement_ComponentRequirement FOREIGN KEY (ComponentRequirementId) REFERENCES dbo.ComponentRequirement (ComponentRequirementId)
GO
ALTER TABLE dbo.PatientTransfusionRequirement ADD CONSTRAINT FK_PatientTransfusionRequirement_CreateDivision FOREIGN KEY (CreateDivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.PatientTransfusionRequirement ADD CONSTRAINT FK_PatientTransfusionRequirement_InactivateDivision FOREIGN KEY (InactivateDivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.PoolCounter WITH NOCHECK ADD CONSTRAINT FK_PoolCounter_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ProductModificationAttribute ADD CONSTRAINT FK_ProductModificationAttribute_ProductModification FOREIGN KEY (ProductModificationCode) REFERENCES dbo.ProductModification (ProductModificationCode)
GO
ALTER TABLE dbo.ProductModificationParameter WITH NOCHECK ADD CONSTRAINT FK_ProductModificationParameter_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ProductShipper WITH NOCHECK ADD CONSTRAINT FK_ProductShipper_BloodProduct FOREIGN KEY (BloodProductGuid) REFERENCES dbo.BloodProduct (BloodProductGuid)
GO
ALTER TABLE dbo.ProductShipper WITH NOCHECK ADD CONSTRAINT FK_ProductShipper_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.Rack WITH NOCHECK ADD CONSTRAINT FK_Rack_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.RackLot WITH NOCHECK ADD CONSTRAINT FK_RackLot_DailyQcWorklist FOREIGN KEY (DailyQcWorklistGuid) REFERENCES dbo.DailyQcWorklist (DailyQcWorklistGuid)
GO
ALTER TABLE dbo.RackLot WITH NOCHECK ADD CONSTRAINT FK_RackLot_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.RackTest ADD CONSTRAINT FK_RackTest_RackLot FOREIGN KEY (RackLotGuid) REFERENCES dbo.RackLot (RackLotGuid) ON DELETE CASCADE
GO
ALTER TABLE dbo.RackTest ADD CONSTRAINT FK_RackTest_RackTestResultType FOREIGN KEY (RackTestResultTypeCode) REFERENCES dbo.RackTestResultType (RackTestResultTypeCode)
GO
ALTER TABLE dbo.RackTest ADD CONSTRAINT FK_RackTest_Reagent FOREIGN KEY (TestWithReagentGuid) REFERENCES dbo.Reagent (ReagentGuid)
GO
ALTER TABLE dbo.RackTest ADD CONSTRAINT FK_RackTest_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.Reagent WITH NOCHECK ADD CONSTRAINT FK_Reagent_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ReagentTestParameter WITH NOCHECK ADD CONSTRAINT FK_ReagentTestParameter_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.ReagentTypeParameter WITH NOCHECK ADD CONSTRAINT FK_ReagentTypeParameter_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.Shipment WITH NOCHECK ADD CONSTRAINT FK_Shipment_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.SpecimenTest WITH NOCHECK ADD CONSTRAINT FK_SpecimenTest_OrderedTest FOREIGN KEY (OrderedTestGuid) REFERENCES dbo.OrderedTest (OrderedTestGuid)
GO
ALTER TABLE dbo.SpecimenTest WITH NOCHECK ADD CONSTRAINT FK_SpecimenTest_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.SpecimenTestThreshold WITH NOCHECK ADD CONSTRAINT FK_SpecimenTestThreshold_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.Supply WITH NOCHECK ADD CONSTRAINT FK_Supply_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.TransfusionReaction WITH NOCHECK ADD CONSTRAINT FK_TransfusionReaction_PatientTransfusion FOREIGN KEY (PatientTransfusionGuid) REFERENCES dbo.PatientTransfusion (PatientTransfusionGuid)
GO
ALTER TABLE dbo.VamcDivision ADD CONSTRAINT FK_VamcDivision_AntibodyScreenDisplay FOREIGN KEY (AntibodyScreenDisplayCode) REFERENCES dbo.AntibodyScreenDisplay (AntibodyScreenDisplayCode)
GO
ALTER TABLE dbo.VamcDivision ADD CONSTRAINT [FK_VamcDivision_DaylightSavingsType ] FOREIGN KEY (DaylightSavingsTypeId) REFERENCES dbo.[DaylightSavingsType ] (DaylightSavingsTypeId)
GO
ALTER TABLE dbo.VamcDivision ADD CONSTRAINT FK_VamcDivision_Facility FOREIGN KEY (FacilityGuid) REFERENCES dbo.Facility (FacilityGuid)
GO
ALTER TABLE dbo.VamcDivision ADD CONSTRAINT FK_VamcDivision_IconOrderAlertType FOREIGN KEY (IconOrderAlertTypeCode) REFERENCES dbo.OrderAlertType (OrderAlertTypeCode)
GO
ALTER TABLE dbo.VamcDivision ADD CONSTRAINT FK_VamcDivision_PrinterOrderAlertType FOREIGN KEY (PrinterOrderAlertTypeCode) REFERENCES dbo.OrderAlertType (OrderAlertTypeCode)
GO
ALTER TABLE dbo.VamcDivision ADD CONSTRAINT FK_VamcDivision_TimeZone FOREIGN KEY (TimeZoneId) REFERENCES dbo.TimeZone (TimeZoneId)
GO
ALTER TABLE dbo.VbecsLock WITH NOCHECK ADD CONSTRAINT FK_VBECSLock_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.VbecsUserDivisionRole WITH NOCHECK ADD CONSTRAINT FK_VbecsUserDivisionRole_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.WorkloadEvent WITH NOCHECK ADD CONSTRAINT FK_WorkloadEvent_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO
ALTER TABLE dbo.WorkloadProcess WITH NOCHECK ADD CONSTRAINT FK_WorkloadProcess_VamcDivision FOREIGN KEY (DivisionCode) REFERENCES dbo.VamcDivision (DivisionCode)
GO

/*****************************************************************************************
   Create a temporary PatientChange table and save the original data
*****************************************************************************************/
if object_id(N'tempdb..#tmpPatientChange') IS NOT NULL
        DROP TABLE #tmpPatientChange
GO

CREATE TABLE #tmpPatientChange (
        PatientChangeGuid uniqueidentifier NOT NULL ,
        FromPatientGuid uniqueidentifier NULL ,
        FromPatientSsn char (9) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        FromSsnPseudoIndicator bit NULL ,
        FromPatientIcn varchar (23) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        FromPatientLastName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        FromPatientFirstName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        FromPatientMIddleName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        FromPatientDob datetime NULL ,
        FromPatientDeathDate datetime NULL ,
        FromPatientSexCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        ToPatientGuid uniqueidentifier NULL ,
        ToPatientSsn char (9) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        ToSsnPseudoIndicator bit NULL ,
        ToPatientIcn varchar (23) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        ToPatientLastName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        ToPatientFirstName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        ToPatientMIddleName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        ToPatientDob datetime NULL ,
        ToPatientDeathDate datetime NULL ,
        ToPatientSexCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        MergeFromVistaPatientId bigint NULL ,
        MergeToVistaPatientId bigint NULL ,
        PatientChangeStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        NotificationReceivedDate datetime NOT NULL,
        LastUpdateDate datetime NOT NULL ,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
        LastUpdateFunctionId int NOT NULL
)
GO

INSERT INTO #tmpPatientChange
SELECT PC1.PatientChangeGuid, FromPatientGuid, FromPatientSsn, FromSsnPseudoIndicator, FromPatientIcn, FromPatientLastName, FromPatientFirstName, FromPatientMIddleName, FromPatientDob,
        FromPatientDeathDate, FromPatientSexCode, ToPatientGuid, ToPatientSsn, ToSsnPseudoIndicator, ToPatientIcn, ToPatientLastName, ToPatientFirstName, ToPatientMIddleName, 
        ToPatientDob, ToPatientDeathDate, ToPatientSexCode, MergeFromVistaPatientId, MergeToVistaPatientId, PatientChangeStatusCode, PC2.LastUpdateDate, PC1.LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
FROM VBECS_V1_PROD.dbo.PatientChange PC1
        JOIN (SELECT PatientChangeGuid, MIN(LastUpdateDate) LastUpdateDate
                FROM VBECS_V1_PROD_MIRROR.dbo.V_PatientChange
                GROUP BY PatientChangeGuid) PC2
                ON PC1.PatientChangeGuid = PC2.PatientChangeGuid
GO

/*****************************************************************************************
*         Create the new PatientChange table
*****************************************************************************************/

ALTER TABLE dbo.PatientChange
        DROP CONSTRAINT PK_PatientChange
GO

DROP TRIGGER dbo.trMirrorPatientChange
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[PatientChange]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[PatientChange]
GO

CREATE TABLE [dbo].[PatientChange] (
        [PatientChangeGuid] [uniqueidentifier] NOT NULL ,
        [FromPatientGuid] [uniqueidentifier] NULL ,
        [FromPatientSsn] [char] (9) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [FromSsnPseudoIndicator] [bit] NULL ,
        [FromPatientIcn] [varchar] (23) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [FromPatientLastName] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [FromPatientFirstName] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [FromPatientMIddleName] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [FromPatientDob] [datetime] NULL ,
        [FromPatientDeathDate] [datetime] NULL ,
        [FromPatientSexCode] [char] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [ToPatientGuid] [uniqueidentifier] NULL ,
        [ToPatientSsn] [char] (9) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [ToSsnPseudoIndicator] [bit] NULL ,
        [ToPatientIcn] [varchar] (23) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [ToPatientLastName] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [ToPatientFirstName] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [ToPatientMIddleName] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [ToPatientDob] [datetime] NULL ,
        [ToPatientDeathDate] [datetime] NULL ,
        [ToPatientSexCode] [char] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [MergeFromVistaPatientId] [bigint] NULL ,
        [MergeToVistaPatientId] [bigint] NULL ,
        [PatientChangeStatusCode] [char] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
        [NotificationReceivedDate] [datetime] NOT NULL ,
        [ActiveDivisionsAlertViewed] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [LastUpdateDate] [datetime] NOT NULL ,
        [LastUpdateUser] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
        [RowVersion] [timestamp] NOT NULL ,
        [LastUpdateFunctionId] [int] NOT NULL 
) ON [PRIMARY]
GO


exec sp_addextendedproperty N'MS_Description', N'Stores a string of DivisionCodes delimited by "^" that have viewed the patient alert.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'ActiveDivisionsAlertViewed'
GO
exec sp_addextendedproperty N'MS_Description', N'The date of death for a deceased patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'FromPatientDeathDate'
GO
exec sp_addextendedproperty N'MS_Description', N'The birth date of the patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'FromPatientDob'
GO
exec sp_addextendedproperty N'MS_Description', N'The first name of the patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'FromPatientFirstName'
GO
exec sp_addextendedproperty N'MS_Description', N'A unique identifier for a patient generated by VBECS.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'FromPatientGuid'
GO
exec sp_addextendedproperty N'MS_Description', N'An integration control number (ICN) for the patient inherited from the VistA system.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'FromPatientIcn'
GO
exec sp_addextendedproperty N'MS_Description', N'The last name of the patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'FromPatientLastName'
GO
exec sp_addextendedproperty N'MS_Description', N'The middle name of the patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'FromPatientMIddleName'
GO
exec sp_addextendedproperty N'MS_Description', N'The gender of the patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'FromPatientSexCode'
GO
exec sp_addextendedproperty N'MS_Description', N'The social security number of the merge-from patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'FromPatientSsn'
GO
exec sp_addextendedproperty N'MS_Description', N'Indicates that a pseudo character, P, has been added to the SSN when displayed.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'FromSsnPseudoIndicator'
GO
exec sp_addextendedproperty N'MS_Description', N'The date and time the record was last updated.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'LastUpdateDate'
GO
exec sp_addextendedproperty N'MS_Description', N'The identifier of the VBECS function that performed the last update.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'LastUpdateFunctionId'
GO
exec sp_addextendedproperty N'MS_Description', N'The logon id of the user who performed the last update.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'LastUpdateUser'
GO
exec sp_addextendedproperty N'MS_Description', N'The old patient ID in VistA in a merge.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'MergeFromVistaPatientId'
GO
exec sp_addextendedproperty N'MS_Description', N'The new patient ID in VistA in a merge.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'MergeToVistaPatientId'
GO
exec sp_addextendedproperty N'MS_Description', N'The date and time the notification record was processed in VBECS.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'NotificationReceivedDate'
GO
exec sp_addextendedproperty N'MS_Description', N'Identifies one patient change from VistA.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'PatientChangeGuid'
GO
exec sp_addextendedproperty N'MS_Description', N'Describes a state of processing a patient merge or update.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'PatientChangeStatusCode'
GO
exec sp_addextendedproperty N'MS_Description', N'This is used in the C# code as a mechanism for version-stamping table rows, which provides a means for concurrency control.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'RowVersion'
GO
exec sp_addextendedproperty N'MS_Description', N'The date of death for a deceased patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'ToPatientDeathDate'
GO
exec sp_addextendedproperty N'MS_Description', N'The birth date of the patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'ToPatientDob'
GO
exec sp_addextendedproperty N'MS_Description', N'The first name of the patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'ToPatientFirstName'
GO
exec sp_addextendedproperty N'MS_Description', N'A unique identifier for a patient generated by VBECS.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'ToPatientGuid'
GO
exec sp_addextendedproperty N'MS_Description', N'An integration control number (ICN) for the patient inherited from the VistA system.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'ToPatientIcn'
GO
exec sp_addextendedproperty N'MS_Description', N'The last name of the patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'ToPatientLastName'
GO
exec sp_addextendedproperty N'MS_Description', N'The middle name of the patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'ToPatientMIddleName'
GO
exec sp_addextendedproperty N'MS_Description', N'The gender of the patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'ToPatientSexCode'
GO
exec sp_addextendedproperty N'MS_Description', N'The social security number of the merge-to patient.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'ToPatientSsn'
GO
exec sp_addextendedproperty N'MS_Description', N'Indicates that a pseudo character, P, has been added to the SSN when displayed.', N'user', N'dbo', N'table', N'PatientChange', N'column', N'ToSsnPseudoIndicator'

/*****************************************************************************************
*        Reload the original PatientChange data into the updated table
*****************************************************************************************/
INSERT INTO dbo.PatientChange
(
        PatientChangeGuid, FromPatientGuid, FromPatientSsn, FromSsnPseudoIndicator, FromPatientIcn, FromPatientLastName, FromPatientFirstName, FromPatientMIddleName, FromPatientDob,
        FromPatientDeathDate, FromPatientSexCode, ToPatientGuid, ToPatientSsn, ToSsnPseudoIndicator, ToPatientIcn, ToPatientLastName, ToPatientFirstName, ToPatientMIddleName, ToPatientDob, 
        ToPatientDeathDate, ToPatientSexCode, MergeFromVistaPatientId, MergeToVistaPatientId, PatientChangeStatusCode, NotificationReceivedDate, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId
)
SELECT PatientChangeGuid, FromPatientGuid, FromPatientSsn, FromSsnPseudoIndicator, FromPatientIcn, FromPatientLastName, FromPatientFirstName, FromPatientMIddleName, FromPatientDob,
        FromPatientDeathDate, FromPatientSexCode, ToPatientGuid, ToPatientSsn, ToSsnPseudoIndicator, ToPatientIcn, ToPatientLastName, ToPatientFirstName, ToPatientMIddleName, ToPatientDob, 
        ToPatientDeathDate, ToPatientSexCode, MergeFromVistaPatientId, MergeToVistaPatientId, PatientChangeStatusCode, NotificationReceivedDate, LastUpdateDate, LastUpdateUser, ISNULL(LastUpdateFunctionId, 0)
FROM #tmpPatientChange
GO

DROP TABLE #tmpPatientChange
GO


/*****************************************************************************************
*        Add the PatientChange constraints
*****************************************************************************************/
ALTER TABLE [dbo].[PatientChange] ADD 
        CONSTRAINT [PK_PatientChange] PRIMARY KEY  CLUSTERED 
        (
                [PatientChangeGuid]
        ) WITH  FILLFACTOR = 90  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[PatientChange] ADD 
        CONSTRAINT [DF_PatientChange_LastUpdateFunctionId] DEFAULT (0) FOR [LastUpdateFunctionId]
GO

/*****************************************************************************************
   Apply the changes to the PatientChange table to allow NULL in the FromPatientGuid
   and ToPatientGuid columns.
*****************************************************************************************/
CREATE  INDEX [IX_PatientChange_FromPatientGuid] ON [dbo].[PatientChange]([FromPatientGuid]) WITH  FILLFACTOR = 90 ON [PRIMARY]
GO

 CREATE  INDEX [IX_PatientChange_PatientChangeStatusCode] ON [dbo].[PatientChange]([PatientChangeStatusCode]) WITH  FILLFACTOR = 90 ON [PRIMARY]
GO

 CREATE  INDEX [IX_PatientChange_ToPatientGuid] ON [dbo].[PatientChange]([ToPatientGuid]) WITH  FILLFACTOR = 90 ON [PRIMARY]
GO

ALTER TABLE [dbo].[PatientChange] ADD 
        CONSTRAINT [FK_PatientChange_FromPatient] FOREIGN KEY 
        (
                [FromPatientGuid]
        ) REFERENCES [dbo].[Patient] (
                [PatientGuid]
        ),
        CONSTRAINT [FK_PatientChange_PatientChangeStatus] FOREIGN KEY 
        (
                [PatientChangeStatusCode]
        ) REFERENCES [dbo].[PatientChangeStatus] (
                [PatientChangeStatusCode]
        ),
        CONSTRAINT [FK_PatientChange_ToPatient] FOREIGN KEY 
        (
                [ToPatientGuid]
        ) REFERENCES [dbo].[Patient] (
                [PatientGuid]
        )
GO


USE VBECS_V1_PROD_MIRROR
GO
/*****************************************************************************************
*         MIRROR TABLE CHANGES
*****************************************************************************************/
/*****************************************************************************************
*        Create a temporary AntigenType Mirror table and save the original data
*****************************************************************************************/
if object_id(N'tempdb..#tmpMirrorAntigenType') IS NOT NULL
        DROP TABLE #tmpMirrorAntigenType
GO

CREATE TABLE dbo.#tmpMirrorAntigenType
        (
        MirrorId int NOT NULL ,
        AntigenTypeId int NOT NULL,
        AntigenTypeName varchar (12) COLLATE SQL_Latin1_General_CP1_CS_AS NOT NULL,
        SortColumn smallint NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        )  ON [PRIMARY]
GO

INSERT INTO #tmpMirrorAntigenType 
        (MirrorId, AntigenTypeId, AntigenTypeName, SortColumn, LastUpdateDate, LastUpdateUser, [RowVersion], 
         LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, AntigenTypeId, AntigenTypeName, SortColumn, LastUpdateDate, LastUpdateUser, [RowVersion],
         LastUpdateFunctionId, MirrorDate
  FROM dbo.AntigenType
GO

/*****************************************************************************************
   Create the updated AntigenType Mirror table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.AntigenType') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.AntigenType
GO

CREATE TABLE dbo.AntigenType 
        (
        MirrorId int IDENTITY (1, 1) NOT NULL,
        AntigenTypeId int NOT NULL,
        AntigenTypeName varchar (12) COLLATE SQL_Latin1_General_CP1_CS_AS NOT NULL,
        SortColumn smallint NOT NULL,
        BceSortColumn smallint NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        ) ON [PRIMARY]
GO

ALTER TABLE dbo.AntigenType ADD 
        CONSTRAINT PK_AntigenType PRIMARY KEY CLUSTERED 
        (
                MirrorId
        ) ON [PRIMARY] 
GO

/*****************************************************************************************
   Reload the updated AntigenType Mirror table 
*****************************************************************************************/
SET IDENTITY_INSERT AntigenType ON
GO
INSERT INTO AntigenType 
        (MirrorId, AntigenTypeId, AntigenTypeName, SortColumn, LastUpdateDate, LastUpdateUser, [RowVersion], 
         LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, AntigenTypeId, AntigenTypeName, SortColumn, LastUpdateDate, LastUpdateUser, [RowVersion],
         LastUpdateFunctionId, MirrorDate
  FROM dbo.#tmpMirrorAntigenType
GO
SET IDENTITY_INSERT AntigenType OFF
GO
if object_id(N'tempdb..#tmpMirrorAntigenType') IS NOT NULL
        DROP TABLE #tmpMirrorAntigenType
GO

/*****************************************************************************************
   Create the updated V_AntigenType view 
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[V_AntigenType]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view dbo.V_AntigenType
GO


SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS OFF
GO
CREATE VIEW dbo.V_AntigenType
AS
SELECT Source = 'MIRROR', MirrorId, AntigenTypeId, AntigenTypeName, SortColumn, BceSortColumn, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, MirrorDate
FROM dbo.AntigenType
UNION ALL
SELECT Source = 'ACTIVE', 0, AntigenTypeId, AntigenTypeName, SortColumn, BceSortColumn, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, LastUpdateDate AS MirrorDate
FROM VBECS_V1_PROD.dbo.AntigenType
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO


/*****************************************************************************************
*        Create a temporary ComponentRequirement Mirror table and save the original data
*****************************************************************************************/
if object_id(N'tempdb..#tmpMirrorComponentRequirement') IS NOT NULL
        DROP TABLE #tmpMirrorComponentRequirement
GO

CREATE TABLE dbo.#tmpMirrorComponentRequirement
        (
        MirrorId int NOT NULL ,
        ComponentRequirementId tinyint NOT NULL,
        ComponentRequirementText varchar (50) NOT NULL,
        SortColumn smallint NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        )  ON [PRIMARY]
GO

INSERT INTO #tmpMirrorComponentRequirement 
        (MirrorId, ComponentRequirementId, ComponentRequirementText, SortColumn, LastUpdateDate, LastUpdateUser, [RowVersion], 
         LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, ComponentRequirementId, ComponentRequirementText, SortColumn, LastUpdateDate, LastUpdateUser, [RowVersion],
         LastUpdateFunctionId, MirrorDate
  FROM dbo.ComponentRequirement
GO

/*****************************************************************************************
   Create the updated ComponentRequirement Mirror table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.ComponentRequirement') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.ComponentRequirement
GO

CREATE TABLE dbo.ComponentRequirement 
        (
        MirrorId int IDENTITY (1, 1) NOT NULL,
        ComponentRequirementId tinyint NOT NULL,
        ComponentRequirementText varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        ComponentRequirementAbbreviation char (4) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        SortColumn smallint NOT NULL,
        BceSortColumn smallint NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        ) ON [PRIMARY]
GO

ALTER TABLE dbo.ComponentRequirement ADD 
        CONSTRAINT PK_ComponentRequirement PRIMARY KEY CLUSTERED 
        (
                MirrorId
        ) ON [PRIMARY] 
GO

/*****************************************************************************************
   Reload the updated ComponentRequirement Mirror table 
*****************************************************************************************/
SET IDENTITY_INSERT ComponentRequirement ON
GO
INSERT INTO ComponentRequirement 
        (MirrorId, ComponentRequirementId, ComponentRequirementText, SortColumn, LastUpdateDate, LastUpdateUser, [RowVersion], 
         LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, ComponentRequirementId, ComponentRequirementText, SortColumn, LastUpdateDate, LastUpdateUser, [RowVersion],
         LastUpdateFunctionId, MirrorDate
  FROM dbo.#tmpMirrorComponentRequirement
GO
SET IDENTITY_INSERT ComponentRequirement OFF
GO
if object_id(N'tempdb..#tmpMirrorComponentRequirement') IS NOT NULL
        DROP TABLE #tmpMirrorComponentRequirement
GO

/*****************************************************************************************
   Create the updated V_ComponentRequirement view 
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[V_ComponentRequirement]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view dbo.V_ComponentRequirement
GO


SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS OFF
GO
CREATE VIEW dbo.V_ComponentRequirement
AS
SELECT Source = 'MIRROR', MirrorId, ComponentRequirementId, ComponentRequirementText, ComponentRequirementAbbreviation, SortColumn, BceSortColumn, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, MirrorDate
FROM dbo.ComponentRequirement
UNION ALL
SELECT Source = 'ACTIVE', 0, ComponentRequirementId, ComponentRequirementText, ComponentRequirementAbbreviation, SortColumn, BceSortColumn, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, LastUpdateDate AS MirrorDate
FROM VBECS_V1_PROD.dbo.ComponentRequirement
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO


/*****************************************************************************************
*        Create a temporary DailyQcWorklist Mirror table and save the original data
*****************************************************************************************/
if object_id(N'tempdb..#tmpMirrorDailyQcWorklist') IS NOT NULL
        DROP TABLE #tmpMirrorDailyQcWorklist
GO

CREATE TABLE dbo.#tmpMirrorDailyQcWorklist
        (
        MirrorId int NOT NULL ,
        DailyQcWorklistGuid uniqueidentifier NOT NULL,
        DailyQcExpirationDate datetime NULL,
        DailyUseIndicator bit NOT NULL,
        PartiallyTestedIndicator bit NOT NULL,
        RackGuid uniqueidentifier NULL,
        DivisionCode char(5) NOT NULL,
        RecordStatusCode char(1) NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        )  ON [PRIMARY]
GO

INSERT INTO #tmpMirrorDailyQcWorklist 
        (MirrorId, DailyQcWorklistGuid, DailyQcExpirationDate, DailyUseIndicator, PartiallyTestedIndicator, RackGuid,
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, DailyQcWorklistGuid, DailyQcExpirationDate, DailyUseIndicator, PartiallyTestedIndicator, RackGuid,
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.DailyQcWorklist
GO

/*****************************************************************************************
   Create the updated DailyQcWorklist Mirror table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.DailyQcWorklist') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.DailyQcWorklist
GO

CREATE TABLE dbo.DailyQcWorklist 
        (
        MirrorId int IDENTITY (1, 1) NOT NULL,
        DailyQcWorklistGuid uniqueidentifier NOT NULL,
        DailyQcExpirationDate datetime NULL,
        DailyUseIndicator bit NOT NULL,
        PartiallyTestedIndicator bit NOT NULL,
        RackGuid uniqueidentifier NULL,
        QCOfflineIndicator bit NOT NULL,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        RecordStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        ) ON [PRIMARY]
GO

ALTER TABLE dbo.DailyQcWorklist ADD 
        CONSTRAINT PK_DailyQcWorklist PRIMARY KEY CLUSTERED 
        (
                MirrorId
        ) ON [PRIMARY] 
GO

/*****************************************************************************************
   Reload the updated DailyQcWorklist Mirror table 
*****************************************************************************************/
SET IDENTITY_INSERT DailyQcWorklist ON
GO

INSERT INTO DailyQcWorklist 
        (MirrorId, DailyQcWorklistGuid, DailyQcExpirationDate, DailyUseIndicator, PartiallyTestedIndicator, RackGuid, QCOfflineIndicator,
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, DailyQcWorklistGuid, DailyQcExpirationDate, DailyUseIndicator, PartiallyTestedIndicator, RackGuid, 0,
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.#tmpMirrorDailyQcWorklist
GO
SET IDENTITY_INSERT DailyQcWorklist OFF
GO
if object_id(N'tempdb..#tmpMirrorDailyQcWorklist') IS NOT NULL
        DROP TABLE #tmpMirrorDailyQcWorklist
GO

/*****************************************************************************************
   Create the updated V_DailyQcWorklist view 
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[V_DailyQcWorklist]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view dbo.V_DailyQcWorklist
GO


SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS OFF
GO
CREATE VIEW dbo.V_DailyQcWorklist
AS 
SELECT Source='MIRROR', MirrorId, DailyQcWorklistGuid, DailyQcExpirationDate, DailyUseIndicator, PartiallyTestedIndicator, RackGuid, QCOfflineIndicator, DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, MirrorDate
FROM dbo.DailyQcWorklist
UNION ALL 
SELECT Source='ACTIVE', 0, DailyQcWorklistGuid, DailyQcExpirationDate, DailyUseIndicator, PartiallyTestedIndicator, RackGuid, QCOfflineIndicator, DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, LastUpdateDate AS MirrorDate 
FROM VBECS_V1_PROD.dbo.DailyQcWorklist
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO


/*****************************************************************************************
*        Create a temporary InterfaceControl Mirror table and save the original data
*****************************************************************************************/
if object_id(N'tempdb..#tmpMirrorInterfaceControl') IS NOT NULL
        DROP TABLE #tmpMirrorInterfaceControl
GO

CREATE TABLE dbo.#tmpMirrorInterfaceControl
        (
        MirrorId int NOT NULL ,
        InterfaceControlId int NOT NULL,
        InterfaceId tinyint NOT NULL,
        InterfaceFacilityId varchar (20) NULL,
        InterfacePortNumber int NULL,
        InterfaceIPAddress char (15) NULL,
        InterfaceDomainName varchar (100) NULL,
        VbecsFacilityId varchar (20) NULL,
        ProcessingId char (1) NOT NULL,
        VbecsPortNumber int NULL,
        VbecsIPAddress char (15) NULL,
        AckTimeout int NOT NULL,
        ReTransmitAttempts tinyint NOT NULL,
        InterfaceAdministratorName varchar (90) NOT NULL,
        PurgeSuccessfulMessage tinyint NOT NULL,
        PurgeUnSuccessfulMessage tinyint NOT NULL,
        LogEventsIndicator bit NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        )  ON [PRIMARY]
GO

INSERT INTO #tmpMirrorInterfaceControl 
        (MirrorId, InterfaceControlId, InterfaceId, InterfaceFacilityId, InterfacePortNumber, InterfaceIPAddress,
         InterfaceDomainName, VbecsFacilityId, ProcessingId, VbecsPortNumber, VbecsIPAddress, AckTimeout, ReTransmitAttempts,
         InterfaceAdministratorName, PurgeSuccessfulMessage, PurgeUnSuccessfulMessage, LogEventsIndicator, LastUpdateDate,
         LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, InterfaceControlId, InterfaceId, InterfaceFacilityId, InterfacePortNumber, InterfaceIPAddress,
         InterfaceDomainName, VbecsFacilityId, ProcessingId, VbecsPortNumber, VbecsIPAddress, AckTimeout, ReTransmitAttempts,
         InterfaceAdministratorName, PurgeSuccessfulMessage, PurgeUnSuccessfulMessage, LogEventsIndicator, LastUpdateDate,
         LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.InterfaceControl
GO

/*****************************************************************************************
   Create the updated InterfaceControl Mirror table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.InterfaceControl') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.InterfaceControl
GO

CREATE TABLE dbo.InterfaceControl 
        (
        MirrorId int IDENTITY (1, 1) NOT NULL,
        InterfaceControlId int NOT NULL,
        InterfaceId tinyint NOT NULL,
        InterfaceFacilityId varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InterfacePortNumber int NULL,
        InterfaceIPAddress char (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InterfaceDomainName varchar (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        VbecsFacilityId varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ProcessingId char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        VbecsPortNumber int NULL,
        VbecsIPAddress char (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        AckTimeout int NOT NULL,
        ReTransmitAttempts tinyint NOT NULL,
        InterfaceAdministratorName varchar (90) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        PurgeSuccessfulMessage tinyint NOT NULL,
        PurgeUnSuccessfulMessage tinyint NOT NULL,
        LogEventsIndicator bit NOT NULL,
        InterfaceActiveIndicator bit NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        ) ON [PRIMARY]
GO

ALTER TABLE dbo.InterfaceControl ADD 
        CONSTRAINT PK_InterfaceControl PRIMARY KEY CLUSTERED 
        (
                MirrorId
        ) ON [PRIMARY] 
GO

/*****************************************************************************************
   Reload the updated InterfaceControl Mirror table 
*****************************************************************************************/
SET IDENTITY_INSERT InterfaceControl ON
GO
INSERT INTO InterfaceControl 
        (MirrorId, InterfaceControlId, InterfaceId, InterfaceFacilityId, InterfacePortNumber, InterfaceIPAddress,
         InterfaceDomainName, VbecsFacilityId, ProcessingId, VbecsPortNumber, VbecsIPAddress, AckTimeout, ReTransmitAttempts,
         InterfaceAdministratorName, PurgeSuccessfulMessage, PurgeUnSuccessfulMessage, LogEventsIndicator, InterfaceActiveIndicator,
         LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, InterfaceControlId, InterfaceId, InterfaceFacilityId, InterfacePortNumber, InterfaceIPAddress,
         InterfaceDomainName, VbecsFacilityId, ProcessingId, VbecsPortNumber, VbecsIPAddress, AckTimeout, ReTransmitAttempts,
         InterfaceAdministratorName, PurgeSuccessfulMessage, PurgeUnSuccessfulMessage, LogEventsIndicator, 1,
         LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.#tmpMirrorInterfaceControl
GO
SET IDENTITY_INSERT InterfaceControl OFF
GO
if object_id(N'tempdb..#tmpMirrorInterfaceControl') IS NOT NULL
        DROP TABLE #tmpMirrorInterfaceControl
GO

/*****************************************************************************************
   Create the updated V_InterfaceControl view 
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[V_InterfaceControl]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view dbo.V_InterfaceControl
GO


SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS OFF
GO
CREATE VIEW dbo.V_InterfaceControl
AS
SELECT Source = 'MIRROR', MirrorId, InterfaceControlId, InterfaceId, InterfaceFacilityId, InterfacePortNumber, InterfaceIPAddress, InterfaceDomainName, VbecsFacilityId, ProcessingId, VbecsPortNumber, VbecsIPAddress, AckTimeout, ReTransmitAttempts, InterfaceAdministratorName, 
                PurgeSuccessfulMessage, PurgeUnSuccessfulMessage, LogEventsIndicator, InterfaceActiveIndicator, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, MirrorDate
FROM dbo.InterfaceControl
UNION ALL
SELECT Source = 'ACTIVE', 0, InterfaceControlId, InterfaceId, InterfaceFacilityId, InterfacePortNumber, InterfaceIPAddress, InterfaceDomainName, VbecsFacilityId, ProcessingId, VbecsPortNumber, VbecsIPAddress, AckTimeout, ReTransmitAttempts, InterfaceAdministratorName, 
                PurgeSuccessfulMessage, PurgeUnSuccessfulMessage, LogEventsIndicator, InterfaceActiveIndicator, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, LastUpdateDate AS MirrorDate
FROM VBECS_V1_PROD.dbo.InterfaceControl
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO


/*****************************************************************************************
*        Create a temporary OrderedComponent Mirror table and save the original data
*****************************************************************************************/
if object_id(N'tempdb..#tmpMirrorOrderedComponent') IS NOT NULL
        DROP TABLE #tmpMirrorOrderedComponent
GO

CREATE TABLE dbo.#tmpMirrorOrderedComponent
        (
        MirrorId int NOT NULL ,
        OrderedComponentGuid uniqueidentifier NOT NULL,
        PatientOrderGuid uniqueidentifier NOT NULL,
        ComponentClassId int NOT NULL,
        CprsOrderNumber varchar (20) NOT NULL,
        VbecsOrderNumber int NULL,
        RequiredUnitQuantity decimal (3, 0) NOT NULL,
        SpecimenRequiredIndicator bit NULL,
        SpecimenAccessionNumber varchar (20) NULL,
        SpecimenWorkloadUid varchar (15) NULL,
        PatientSpecimenGuid uniqueidentifier NULL,
        SpecimenStatusCode char (1) NULL,
        PreOpIndicator bit NULL,
        OrderStatusCode char (1) NULL,
        OrderUrgencyCode char (1) NULL,
        RequiredDatetime datetime NOT NULL,
        OrderSpecialInstructions varchar (510) NULL,
        ImmediateTransfusionIndicator bit NULL,
        OrderedComponentComments varchar (510) NULL,
        InappropriateRequestIndicator bit NULL,
        NoInappropriateReportText varchar (510) NULL,
        TaskStatusCode char (1) NULL,
        CancellationCannedCommentGuid uniqueidentifier NULL,
        CancellationText varchar (510) NULL,
        LabOrderNumber varchar (20) NULL,
        LabTestId char (15) NULL,
        EmergencyOrderIndicator bit NOT NULL,
        DivisionCode char (5) NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        )  ON [PRIMARY]
GO

INSERT INTO #tmpMirrorOrderedComponent 
        (MirrorId, OrderedComponentGuid, PatientOrderGuid, ComponentClassId, CprsOrderNumber, VbecsOrderNumber, RequiredUnitQuantity,
         SpecimenRequiredIndicator, SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, SpecimenStatusCode,
         PreOpIndicator, OrderStatusCode, OrderUrgencyCode, RequiredDatetime, OrderSpecialInstructions, ImmediateTransfusionIndicator,
         OrderedComponentComments, InappropriateRequestIndicator, NoInappropriateReportText, TaskStatusCode, CancellationCannedCommentGuid,
         CancellationText, LabOrderNumber, LabTestId, EmergencyOrderIndicator, DivisionCode, LastUpdateDate, LastUpdateUser, [RowVersion],
         LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, OrderedComponentGuid, PatientOrderGuid, ComponentClassId, CprsOrderNumber, VbecsOrderNumber, RequiredUnitQuantity,
         SpecimenRequiredIndicator, SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, SpecimenStatusCode,
         PreOpIndicator, OrderStatusCode, OrderUrgencyCode, RequiredDatetime, OrderSpecialInstructions, ImmediateTransfusionIndicator,
         OrderedComponentComments, InappropriateRequestIndicator, NoInappropriateReportText, TaskStatusCode, CancellationCannedCommentGuid,
         CancellationText, LabOrderNumber, LabTestId, EmergencyOrderIndicator, DivisionCode, LastUpdateDate, LastUpdateUser, [RowVersion],
         LastUpdateFunctionId, MirrorDate
  FROM dbo.OrderedComponent
GO

/*****************************************************************************************
   Create the updated OrderedComponent Mirror table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.OrderedComponent') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.OrderedComponent
GO

CREATE TABLE dbo.OrderedComponent 
        (
        MirrorId int IDENTITY (1, 1) NOT NULL,
        OrderedComponentGuid uniqueidentifier NOT NULL,
        PatientOrderGuid uniqueidentifier NOT NULL,
        ComponentClassId int NOT NULL,
        CprsOrderNumber varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        VbecsOrderNumber int NULL,
        RequiredUnitQuantity decimal (3, 0) NOT NULL,
        SpecimenRequiredIndicator bit NULL,
        SpecimenAccessionNumber varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        SpecimenWorkloadUid varchar (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PatientSpecimenGuid uniqueidentifier NULL,
        SpecimenStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PreOpIndicator bit NULL,
        OrderStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        OrderUrgencyCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RequiredDatetime datetime NOT NULL,
        OrderSpecialInstructions varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ImmediateTransfusionIndicator bit NULL,
        OrderedComponentComments varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InappropriateRequestIndicator bit NULL,
        NoInappropriateReportText varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TaskStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        CancellationCannedCommentGuid uniqueidentifier NULL,
        CancellationText varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LabOrderNumber varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LabTestId char (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        EmergencyOrderIndicator bit NOT NULL,
        OrderAcceptanceDate datetime NULL,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        ) ON [PRIMARY]
GO

ALTER TABLE dbo.OrderedComponent ADD 
        CONSTRAINT PK_OrderedComponent PRIMARY KEY NONCLUSTERED 
        (
                MirrorId
        ) ON [PRIMARY] 
GO
CREATE CLUSTERED INDEX IX_OrderedComponent ON dbo.OrderedComponent (OrderedComponentGuid) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_OrderedComponent_MirrorDate ON dbo.OrderedComponent (MirrorDate) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_OrderedComponent_OrderStatusCode ON dbo.OrderedComponent (OrderStatusCode) ON [PRIMARY]
GO

/*****************************************************************************************
   Reload the updated OrderedComponent Mirror table 
*****************************************************************************************/
SET IDENTITY_INSERT OrderedComponent ON
GO
INSERT INTO OrderedComponent 
        (MirrorId, OrderedComponentGuid, PatientOrderGuid, ComponentClassId, CprsOrderNumber, VbecsOrderNumber, RequiredUnitQuantity,
         SpecimenRequiredIndicator, SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, SpecimenStatusCode, PreOpIndicator,
         OrderStatusCode, OrderUrgencyCode, RequiredDatetime, OrderSpecialInstructions, ImmediateTransfusionIndicator, OrderedComponentComments,
         InappropriateRequestIndicator, NoInappropriateReportText, TaskStatusCode, CancellationCannedCommentGuid, CancellationText,
         LabOrderNumber, LabTestId, EmergencyOrderIndicator, DivisionCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, OrderedComponentGuid, PatientOrderGuid, ComponentClassId, CprsOrderNumber, VbecsOrderNumber, RequiredUnitQuantity,
         SpecimenRequiredIndicator, SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, SpecimenStatusCode, PreOpIndicator,
         OrderStatusCode, OrderUrgencyCode, RequiredDatetime, OrderSpecialInstructions, ImmediateTransfusionIndicator, OrderedComponentComments,
         InappropriateRequestIndicator, NoInappropriateReportText, TaskStatusCode, CancellationCannedCommentGuid, CancellationText,
         LabOrderNumber, LabTestId, EmergencyOrderIndicator, DivisionCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.#tmpMirrorOrderedComponent
GO
SET IDENTITY_INSERT OrderedComponent OFF
GO
if object_id(N'tempdb..#tmpMirrorOrderedComponent') IS NOT NULL
        DROP TABLE #tmpMirrorOrderedComponent
GO

/*****************************************************************************************
   Create the updated V_OrderedComponent view 
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[V_OrderedComponent]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view dbo.V_OrderedComponent
GO


SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS OFF
GO
CREATE VIEW dbo.V_OrderedComponent
AS
SELECT        Source='MIRROR', MirrorId, OrderedComponentGuid, PatientOrderGuid, ComponentClassId, CprsOrderNumber, VbecsOrderNumber, RequiredUnitQuantity, SpecimenRequiredIndicator, SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, SpecimenStatusCode, PreOpIndicator, OrderStatusCode, OrderUrgencyCode, RequiredDatetime, OrderSpecialInstructions, ImmediateTransfusionIndicator, OrderedComponentComments, InappropriateRequestIndicator, NoInappropriateReportText, TaskStatusCode, CancellationCannedCommentGuid, CancellationText, LabOrderNumber, LabTestId, EmergencyOrderIndicator, OrderAcceptanceDate, DivisionCode, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, MirrorDate
FROM dbo.OrderedComponent
UNION ALL
SELECT        Source='ACTIVE', 0, OrderedComponentGuid, PatientOrderGuid, ComponentClassId, CprsOrderNumber, VbecsOrderNumber, RequiredUnitQuantity, SpecimenRequiredIndicator, SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, SpecimenStatusCode, PreOpIndicator, OrderStatusCode, OrderUrgencyCode, RequiredDatetime, OrderSpecialInstructions, ImmediateTransfusionIndicator, OrderedComponentComments, InappropriateRequestIndicator, NoInappropriateReportText, TaskStatusCode, CancellationCannedCommentGuid, CancellationText, LabOrderNumber, LabTestId, EmergencyOrderIndicator, OrderAcceptanceDate, DivisionCode, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, LastUpdateDate AS MirrorDate
FROM VBECS_V1_PROD.dbo.OrderedComponent
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO

/*****************************************************************************************
   Update the OrderAcceptanceDate on the OrderedComponent table 
*****************************************************************************************/
UPDATE OrderedComponent
   SET OrderAcceptanceDate = MOC.MirrorDate
  FROM OrderedComponent
        JOIN (SELECT OrderedComponentGuid, MIN(MirrorDate) AS MirrorDate
                FROM V_OrderedComponent 
               WHERE OrderStatusCode = 'A'
               GROUP BY OrderedComponentGuid) MOC
                ON OrderedComponent.OrderedComponentGuid = MOC.OrderedComponentGuid
 WHERE OrderStatusCode <> 'P'
GO

/*****************************************************************************************
*        Create a temporary OrderedTest Mirror table and save the original data
*****************************************************************************************/
if object_id(N'tempdb..#tmpMirrorOrderedTest') IS NOT NULL
        DROP TABLE #tmpMirrorOrderedTest
GO

CREATE TABLE dbo.#tmpMirrorOrderedTest
        (
        MirrorId int NOT NULL ,
        OrderedTestGuid uniqueidentifier NOT NULL,
        PatientOrderGuid uniqueidentifier NOT NULL,
        CprsOrderNumber varchar (20) NULL,
        VbecsOrderNumber int NULL,
        RelatedComponentGuid uniqueidentifier NULL,
        SpecimenRequiredIndicator bit NULL,
        SpecimenAccessionNumber varchar (20) NULL,
        SpecimenWorkloadUid varchar (15) NULL,
        PatientSpecimenGuid uniqueidentifier NULL,
        OrderStatusCode char (1) NULL,
        OrderUrgencyCode char (1) NULL,
        OrderedTestComments varchar (510) NULL,
        RequiredResultsDate datetime NULL,
        OrderableTestId int NULL,
        TestInterpretation char (3) NULL,
        TestInterpretationComments varchar (510) NULL,
        AutoInstrumentName varchar (50) NULL,
        TaskStatusCode char (1) NULL,
        RelatedTestGuid uniqueidentifier NULL,
        CancellationCannedCommentGuid uniqueidentifier NULL,
        CancellationText varchar (510) NULL,
        LabOrderNumber varchar (20) NULL,
        LabTestId char (15) NULL,
        DivisionCode char (5) NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        )  ON [PRIMARY]
GO

INSERT INTO #tmpMirrorOrderedTest 
        (MirrorId, OrderedTestGuid, PatientOrderGuid, CprsOrderNumber, VbecsOrderNumber, RelatedComponentGuid, SpecimenRequiredIndicator, 
         SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, OrderStatusCode, OrderUrgencyCode, OrderedTestComments, 
         RequiredResultsDate, OrderableTestId, TestInterpretation, TestInterpretationComments, AutoInstrumentName, TaskStatusCode, 
         RelatedTestGuid, CancellationCannedCommentGuid, CancellationText, LabOrderNumber, LabTestId, DivisionCode, 
         LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, OrderedTestGuid, PatientOrderGuid, CprsOrderNumber, VbecsOrderNumber, RelatedComponentGuid, SpecimenRequiredIndicator, 
         SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, OrderStatusCode, OrderUrgencyCode, OrderedTestComments, 
         RequiredResultsDate, OrderableTestId, TestInterpretation, TestInterpretationComments, AutoInstrumentName, TaskStatusCode, 
         RelatedTestGuid, CancellationCannedCommentGuid, CancellationText, LabOrderNumber, LabTestId, DivisionCode, 
         LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.OrderedTest
GO

/*****************************************************************************************
   Create the updated OrderedTest Mirror table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.OrderedTest') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.OrderedTest
GO

CREATE TABLE dbo.OrderedTest 
        (
        MirrorId int IDENTITY (1, 1) NOT NULL,
        OrderedTestGuid uniqueidentifier NOT NULL,
        PatientOrderGuid uniqueidentifier NOT NULL,
        CprsOrderNumber varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        VbecsOrderNumber int NULL,
        RelatedComponentGuid uniqueidentifier NULL,
        SpecimenRequiredIndicator bit NULL,
        SpecimenAccessionNumber varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        SpecimenWorkloadUid varchar (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PatientSpecimenGuid uniqueidentifier NULL,
        OrderStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        OrderUrgencyCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        OrderedTestComments varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RequiredResultsDate datetime NULL,
        OrderableTestId int NULL,
        TestInterpretation char (3) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TestInterpretationComments varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        AutoInstrumentName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TaskStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RelatedTestGuid uniqueidentifier NULL,
        CancellationCannedCommentGuid uniqueidentifier NULL,
        CancellationText varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LabOrderNumber varchar (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LabTestId char (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        OrderAcceptanceDate datetime NULL,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        ) ON [PRIMARY]
GO

ALTER TABLE dbo.OrderedTest ADD 
        CONSTRAINT PK_OrderedTest PRIMARY KEY CLUSTERED 
        (
                MirrorId
        ) ON [PRIMARY] 
GO

/*****************************************************************************************
   Reload the updated OrderedTest Mirror table 
*****************************************************************************************/
SET IDENTITY_INSERT OrderedTest ON
GO
INSERT INTO OrderedTest 
        (MirrorId, OrderedTestGuid, PatientOrderGuid, CprsOrderNumber, VbecsOrderNumber, RelatedComponentGuid, SpecimenRequiredIndicator, 
         SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, OrderStatusCode, OrderUrgencyCode, OrderedTestComments, 
         RequiredResultsDate, OrderableTestId, TestInterpretation, TestInterpretationComments, AutoInstrumentName, TaskStatusCode, 
         RelatedTestGuid, CancellationCannedCommentGuid, CancellationText, LabOrderNumber, LabTestId, DivisionCode, LastUpdateDate, 
         LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, OrderedTestGuid, PatientOrderGuid, CprsOrderNumber, VbecsOrderNumber, RelatedComponentGuid, SpecimenRequiredIndicator, 
         SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, OrderStatusCode, OrderUrgencyCode, OrderedTestComments, 
         RequiredResultsDate, OrderableTestId, TestInterpretation, TestInterpretationComments, AutoInstrumentName, TaskStatusCode, 
         RelatedTestGuid, CancellationCannedCommentGuid, CancellationText, LabOrderNumber, LabTestId, DivisionCode, LastUpdateDate, 
         LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.#tmpMirrorOrderedTest
GO
SET IDENTITY_INSERT OrderedTest OFF
GO
if object_id(N'tempdb..#tmpMirrorOrderedTest') IS NOT NULL
        DROP TABLE #tmpMirrorOrderedTest
GO

/*****************************************************************************************
   Create the updated V_OrderedTest view 
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[V_OrderedTest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view dbo.V_OrderedTest
GO


SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS OFF
GO
CREATE VIEW dbo.V_OrderedTest
AS
SELECT Source='MIRROR', MirrorId, OrderedTestGuid, PatientOrderGuid, CprsOrderNumber, VbecsOrderNumber, RelatedComponentGuid, SpecimenRequiredIndicator, SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, OrderStatusCode, OrderUrgencyCode, OrderedTestComments, RequiredResultsDate, OrderableTestId, TestInterpretation, TestInterpretationComments, AutoInstrumentName, TaskStatusCode, RelatedTestGuid, CancellationCannedCommentGuid, CancellationText, LabOrderNumber, LabTestId, OrderAcceptanceDate, DivisionCode, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, MirrorDate
FROM dbo.OrderedTest
UNION ALL
SELECT Source='ACTIVE', 0, OrderedTestGuid, PatientOrderGuid, CprsOrderNumber, VbecsOrderNumber, RelatedComponentGuid, SpecimenRequiredIndicator, SpecimenAccessionNumber, SpecimenWorkloadUid, PatientSpecimenGuid, OrderStatusCode, OrderUrgencyCode, OrderedTestComments, RequiredResultsDate, OrderableTestId, TestInterpretation, TestInterpretationComments, AutoInstrumentName, TaskStatusCode, RelatedTestGuid, CancellationCannedCommentGuid, CancellationText, LabOrderNumber, LabTestId, OrderAcceptanceDate, DivisionCode, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, LastUpdateDate AS MirrorDate
FROM VBECS_V1_PROD.dbo.OrderedTest
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO

/*****************************************************************************************
   Update the OrderAcceptanceDate on the OrderedTest table 
*****************************************************************************************/
UPDATE OrderedTest
   SET OrderAcceptanceDate = MOT.MirrorDate
  FROM OrderedTest
        JOIN (SELECT OrderedTestGuid, MIN(MirrorDate) AS MirrorDate
                FROM V_OrderedTest 
               WHERE OrderStatusCode = 'A'
               GROUP BY OrderedTestGuid) MOT
                ON OrderedTest.OrderedTestGuid = MOT.OrderedTestGuid
 WHERE OrderStatusCode <> 'P'
GO

/*****************************************************************************************
*        Create a temporary PatientTransfusion Mirror table and save the original data
*****************************************************************************************/
if object_id(N'tempdb..#tmpMirrorPatientTransfusion') IS NOT NULL
        DROP TABLE #tmpMirrorPatientTransfusion
GO

CREATE TABLE dbo.#tmpMirrorPatientTransfusion
        (
        MirrorId int NOT NULL ,
        PatientTransfusionGuid uniqueidentifier NOT NULL,
        PatientGuid uniqueidentifier NOT NULL,
        PatientSpecimenGuid uniqueidentifier NULL,
        TransfusionLocation varchar (30) NULL,
        LocationIen char (8) NULL,
        TransfusionStartDateTime datetime NULL,
        TransfusionEndDateTime datetime NULL,
        BloodUnitGuid uniqueidentifier NULL,
        BedsideVerificationDate datetime NULL,
        Transfusionist1Id varchar (30) NULL,
        Transfusionist2Id varchar (30) NULL,
        TransfusedVolume int NULL,
        TransfusionPooledUnitsCount smallint NULL,
        PhlebotomistId varchar (30) NULL,
        InterruptionIndicator bit NULL,
        InterruptionDateTime datetime NULL,
        InterruptionComment varchar (510) NULL,
        ReactionIndicator bit NOT NULL,
        ReactionSymptoms varchar (510) NULL,
        OtherDifficultyIndicator bit NOT NULL,
        OtherDifficultyText varchar (50) NULL,
        DssExtractSuccessIndicator bit NOT NULL,
        DivisionCode char (5) NULL,
        RecordStatusCode char (1) NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        )  ON [PRIMARY]
GO

INSERT INTO #tmpMirrorPatientTransfusion 
        (MirrorId, PatientTransfusionGuid, PatientGuid, PatientSpecimenGuid, TransfusionLocation, LocationIen, TransfusionStartDateTime, 
         TransfusionEndDateTime, BloodUnitGuid, BedsideVerificationDate, Transfusionist1Id, Transfusionist2Id, TransfusedVolume, 
         TransfusionPooledUnitsCount, PhlebotomistId, InterruptionIndicator, InterruptionDateTime, InterruptionComment, 
         ReactionIndicator, ReactionSymptoms, OtherDifficultyIndicator, OtherDifficultyText, DssExtractSuccessIndicator, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, PatientTransfusionGuid, PatientGuid, PatientSpecimenGuid, TransfusionLocation, LocationIen, TransfusionStartDateTime, 
         TransfusionEndDateTime, BloodUnitGuid, BedsideVerificationDate, Transfusionist1Id, Transfusionist2Id, TransfusedVolume, 
         TransfusionPooledUnitsCount, PhlebotomistId, InterruptionIndicator, InterruptionDateTime, InterruptionComment, 
         ReactionIndicator, ReactionSymptoms, OtherDifficultyIndicator, OtherDifficultyText, DssExtractSuccessIndicator, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.PatientTransfusion
GO

/*****************************************************************************************
   Create the updated PatientTransfusion Mirror table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.PatientTransfusion') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.PatientTransfusion
GO

CREATE TABLE dbo.PatientTransfusion 
        (
        MirrorId int IDENTITY (1, 1) NOT NULL,
        PatientTransfusionGuid uniqueidentifier NOT NULL,
        PatientGuid uniqueidentifier NOT NULL,
        PatientSpecimenGuid uniqueidentifier NULL,
        TransfusionLocation varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LocationIen char (8) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TransfusionStartDateTime datetime NULL,
        TransfusionEndDateTime datetime NULL,
        BloodUnitGuid uniqueidentifier NULL,
        BedsideVerificationDate datetime NULL,
        Transfusionist1Id varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        Transfusionist2Id varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        TransfusedVolume int NULL,
        TransfusionPooledUnitsCount smallint NULL,
        PhlebotomistId varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InterruptionIndicator bit NULL,
        InterruptionDateTime datetime NULL,
        InterruptionComment varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ReactionIndicator bit NOT NULL,
        ReactionSymptoms varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        OtherDifficultyIndicator bit NOT NULL,
        OtherDifficultyText varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        DssExtractSuccessIndicator bit NOT NULL,
        BedsideVerificationUnitManualEntryReason varchar (200) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ApplicationOfRecordId tinyint NOT NULL,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RecordStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        ) ON [PRIMARY]
GO

ALTER TABLE dbo.PatientTransfusion ADD 
        CONSTRAINT PK_PatientTransfusion PRIMARY KEY NONCLUSTERED 
        (
                MirrorId
        ) ON [PRIMARY] 
GO

CREATE CLUSTERED INDEX IX_PatientTransfusion ON dbo.PatientTransfusion (PatientTransfusionGuid) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_PatientTransfusion_BloodUnitGuid ON dbo.PatientTransfusion (BloodUnitGuid) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_PatientTransfusion_DivisionCode ON dbo.PatientTransfusion (DivisionCode) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_PatientTransfusion_LastUpdateUser ON dbo.PatientTransfusion (LastUpdateUser) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_PatientTransfusion_PatientGuid ON dbo.PatientTransfusion (PatientGuid) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_PatientTransfusion_TransfusionEndDateTime ON dbo.PatientTransfusion (TransfusionEndDateTime) ON [PRIMARY]
GO

/*****************************************************************************************
   Reload the updated PatientTransfusion Mirror table 
*****************************************************************************************/
SET IDENTITY_INSERT PatientTransfusion ON
GO
INSERT INTO PatientTransfusion 
        (MirrorId, PatientTransfusionGuid, PatientGuid, PatientSpecimenGuid, TransfusionLocation, LocationIen, TransfusionStartDateTime, 
         TransfusionEndDateTime, BloodUnitGuid, BedsideVerificationDate, Transfusionist1Id, Transfusionist2Id, TransfusedVolume, 
         TransfusionPooledUnitsCount, PhlebotomistId, InterruptionIndicator, InterruptionDateTime, InterruptionComment, 
         ReactionIndicator, ReactionSymptoms, OtherDifficultyIndicator, OtherDifficultyText, DssExtractSuccessIndicator, ApplicationOfRecordId,
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, PatientTransfusionGuid, PatientGuid, PatientSpecimenGuid, TransfusionLocation, LocationIen, TransfusionStartDateTime, 
         TransfusionEndDateTime, BloodUnitGuid, BedsideVerificationDate, Transfusionist1Id, Transfusionist2Id, TransfusedVolume, 
         TransfusionPooledUnitsCount, PhlebotomistId, InterruptionIndicator, InterruptionDateTime, InterruptionComment, 
         ReactionIndicator, ReactionSymptoms, OtherDifficultyIndicator, OtherDifficultyText, DssExtractSuccessIndicator, 1,
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.#tmpMirrorPatientTransfusion
GO
SET IDENTITY_INSERT PatientTransfusion OFF
GO
if object_id(N'tempdb..#tmpMirrorPatientTransfusion') IS NOT NULL
        DROP TABLE #tmpMirrorPatientTransfusion
GO

/*****************************************************************************************
   Create the updated V_PatientTransfusion view 
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[V_PatientTransfusion]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view dbo.V_PatientTransfusion
GO


SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS OFF
GO
CREATE VIEW dbo.V_PatientTransfusion
AS 
SELECT        Source='MIRROR', MirrorId, PatientTransfusionGuid, PatientGuid, PatientSpecimenGuid, TransfusionLocation, LocationIen, TransfusionStartDateTime, TransfusionEndDateTime, BloodUnitGuid, BedsideVerificationDate, Transfusionist1Id, Transfusionist2Id, TransfusedVolume, TransfusionPooledUnitsCount, PhlebotomistId, InterruptionIndicator, InterruptionDateTime, InterruptionComment, ReactionIndicator, ReactionSymptoms, OtherDifficultyIndicator, OtherDifficultyText, DssExtractSuccessIndicator, BedsideVerificationUnitManualEntryReason, ApplicationOfRecordId, DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, MirrorDate
FROM dbo.PatientTransfusion
UNION ALL 
SELECT        Source='ACTIVE', 0, PatientTransfusionGuid, PatientGuid, PatientSpecimenGuid, TransfusionLocation, LocationIen, TransfusionStartDateTime, TransfusionEndDateTime, BloodUnitGuid, BedsideVerificationDate, Transfusionist1Id, Transfusionist2Id, TransfusedVolume, TransfusionPooledUnitsCount, PhlebotomistId, InterruptionIndicator, InterruptionDateTime, InterruptionComment, ReactionIndicator, ReactionSymptoms, OtherDifficultyIndicator, OtherDifficultyText, DssExtractSuccessIndicator, BedsideVerificationUnitManualEntryReason, ApplicationOfRecordId, DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, LastUpdateDate AS MirrorDate 
FROM VBECS_V1_PROD.dbo.PatientTransfusion
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO

/*****************************************************************************************
*        Create a temporary RackTest Mirror table and save the original data
*****************************************************************************************/
if object_id(N'tempdb..#tmpMirrorRackTest') IS NOT NULL
        DROP TABLE #tmpMirrorRackTest
GO

CREATE TABLE dbo.#tmpMirrorRackTest
        (
        MirrorId int NOT NULL ,
        RackTestGuid uniqueidentifier NOT NULL,
        RackLotGuid uniqueidentifier NOT NULL,
        TestDate datetime NOT NULL,
        TestTechId varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RackTestResultTypeCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RackTestResult char (3) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ReagentAmount tinyint NULL,
        TestWithReagentGuid uniqueidentifier NULL,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        RecordStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        )  ON [PRIMARY]
GO

INSERT INTO #tmpMirrorRackTest 
        (MirrorId, RackTestGuid, RackLotGuid, TestDate, TestTechId, RackTestResultTypeCode, RackTestResult, ReagentAmount, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, RackTestGuid, RackLotGuid, TestDate, TestTechId, RackTestResultTypeCode, RackTestResult, ReagentAmount, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.RackTest
GO

/*****************************************************************************************
   Create the updated RackTest Mirror table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.RackTest') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.RackTest
GO

CREATE TABLE dbo.RackTest 
        (
        MirrorId int IDENTITY (1, 1) NOT NULL,
        RackTestGuid uniqueidentifier NOT NULL,
        RackLotGuid uniqueidentifier NOT NULL,
        TestDate datetime NOT NULL,
        TestTechId varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RackTestResultTypeCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        RackTestResult char (3) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ReagentAmount tinyint NULL,
        TestWithReagentGuid uniqueidentifier NULL,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        RecordStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        ) ON [PRIMARY]
GO

ALTER TABLE dbo.RackTest ADD 
        CONSTRAINT PK_RackTest PRIMARY KEY CLUSTERED 
        (
                MirrorId
        ) ON [PRIMARY] 
GO

/*****************************************************************************************
   Reload the updated RackTest Mirror table 
*****************************************************************************************/
SET IDENTITY_INSERT RackTest ON
GO
INSERT INTO RackTest 
        (MirrorId, RackTestGuid, RackLotGuid, TestDate, TestTechId, RackTestResultTypeCode, RackTestResult, ReagentAmount, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, RackTestGuid, RackLotGuid, TestDate, TestTechId, RackTestResultTypeCode, RackTestResult, ReagentAmount, 
         DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.#tmpMirrorRackTest
GO
SET IDENTITY_INSERT RackTest OFF
GO
if object_id(N'tempdb..#tmpMirrorRackTest') IS NOT NULL
        DROP TABLE #tmpMirrorRackTest
GO

/*****************************************************************************************
   Create the updated V_RackTest view 
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[V_RackTest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view dbo.V_RackTest
GO


SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS OFF
GO
CREATE VIEW dbo.V_RackTest
AS 
SELECT Source='MIRROR', MirrorId, RackTestGuid, RackLotGuid, TestDate, TestTechId, RackTestResultTypeCode, RackTestResult, ReagentAmount, TestWithReagentGuid, DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, MirrorDate
FROM dbo.RackTest
UNION ALL 
SELECT Source='ACTIVE', 0, RackTestGuid, RackLotGuid, TestDate, TestTechId, RackTestResultTypeCode, RackTestResult, ReagentAmount, TestWithReagentGuid, DivisionCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, LastUpdateDate AS MirrorDate 
FROM VBECS_V1_PROD.dbo.RackTest
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO

/*****************************************************************************************
*        Create a temporary VamcDivision Mirror table and save the original data
*****************************************************************************************/
if object_id(N'tempdb..#tmpMirrorVamcDivision') IS NOT NULL
        DROP TABLE #tmpMirrorVamcDivision
GO

CREATE TABLE dbo.#tmpMirrorVamcDivision
        (
        MirrorId int NOT NULL ,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        DivisionGuid uniqueidentifier NOT NULL,
        DivisionName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        ServiceTypeIndicator bit NOT NULL CONSTRAINT DF_VamcDivision_ServiceTypeIndicator DEFAULT (1),
        IccbbaRegistrationNumber char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ElectronicCrossmatchIndicator bit NULL CONSTRAINT DF_VamcDivision_ElectronicCrossmatchIndicator DEFAULT (0),
        FacilityGuid uniqueidentifier NULL,
        LocalSupplierGuid uniqueidentifier NULL,
        AntibodyScreenDisplayCode int NULL,
        MaximumSpecimenExpirationDays smallint NULL,
        AutomatedInstrumentIndicator bit NULL,
        LabelPrinterUseIndicator bit NOT NULL,
        LabelPrinterComPortNumber tinyint NULL,
        LabelPrinterIPAddress varchar (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LabelPrinterTcpPortNumber int NULL,
        TimeZoneId char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        DaylightSavingsTypeId smallint NOT NULL CONSTRAINT DF_VamcDivision_TimeZoneChangeIndicator DEFAULT (1),
        PrinterName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PrinterAlertsIndicator bit NOT NULL CONSTRAINT DF_VamcDivision_PrinterAlertsIndicator DEFAULT (0),
        PrinterAlertsPrinterName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PrinterOrderAlertTypeCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PrinterOrdersNeededHours smallint NULL,
        IconAlertsIndicator bit NULL,
        IconOrderAlertTypeCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        IconOrdersNeededHours smallint NULL,
        IconRefreshRate int NULL,
        LoginMessageText varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InvoiceTemplateText varchar (1000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        MedicalDirectorName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        UsaIndicator bit NOT NULL CONSTRAINT DF_VamcDivision_UsaIndicator DEFAULT (1),
        LockInactivityTimeoutMin int NOT NULL,
        AccessionAreaId int NULL,
        DaylightSavingsStartDate datetime NULL,
        DaylightSavingsEndDate datetime NULL,
        RecordStatusCode char (1) NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        )  ON [PRIMARY]
GO

INSERT INTO #tmpMirrorVamcDivision 
        (MirrorId, DivisionCode, DivisionGuid, DivisionName, ServiceTypeIndicator, IccbbaRegistrationNumber, 
         ElectronicCrossmatchIndicator, FacilityGuid, LocalSupplierGuid, AntibodyScreenDisplayCode, 
         MaximumSpecimenExpirationDays, AutomatedInstrumentIndicator, LabelPrinterUseIndicator, 
         LabelPrinterComPortNumber, LabelPrinterIPAddress, LabelPrinterTcpPortNumber, TimeZoneId, 
         DaylightSavingsTypeId, PrinterName, PrinterAlertsIndicator, PrinterAlertsPrinterName, 
         PrinterOrderAlertTypeCode, PrinterOrdersNeededHours, IconAlertsIndicator, IconOrderAlertTypeCode, 
         IconOrdersNeededHours, IconRefreshRate, LoginMessageText, InvoiceTemplateText, MedicalDirectorName, 
         UsaIndicator, LockInactivityTimeoutMin, AccessionAreaId, DaylightSavingsStartDate, DaylightSavingsEndDate,
         RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, DivisionCode, DivisionGuid, DivisionName, ServiceTypeIndicator, IccbbaRegistrationNumber, 
         ElectronicCrossmatchIndicator, FacilityGuid, LocalSupplierGuid, AntibodyScreenDisplayCode, 
         MaximumSpecimenExpirationDays, AutomatedInstrumentIndicator, LabelPrinterUseIndicator, 
         LabelPrinterComPortNumber, LabelPrinterIPAddress, LabelPrinterTcpPortNumber, TimeZoneId, 
         DaylightSavingsTypeId, PrinterName, PrinterAlertsIndicator, PrinterAlertsPrinterName, 
         PrinterOrderAlertTypeCode, PrinterOrdersNeededHours, IconAlertsIndicator, IconOrderAlertTypeCode, 
         IconOrdersNeededHours, IconRefreshRate, LoginMessageText, InvoiceTemplateText, MedicalDirectorName, 
         UsaIndicator, LockInactivityTimeoutMin, AccessionAreaId, DaylightSavingsStartDate, DaylightSavingsEndDate,
         RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.VamcDivision
GO

/*****************************************************************************************
   Create the updated VamcDivision Mirror table
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.VamcDivision') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.VamcDivision
GO

CREATE TABLE dbo.VamcDivision 
        (
        MirrorId int IDENTITY (1, 1) NOT NULL,
        DivisionCode char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        DivisionGuid uniqueidentifier NOT NULL,
        DivisionName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        ServiceTypeIndicator bit NOT NULL,
        IccbbaRegistrationNumber char (5) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        ElectronicCrossmatchIndicator bit NULL,
        FacilityGuid uniqueidentifier NULL,
        LocalSupplierGuid uniqueidentifier NULL,
        AntibodyScreenDisplayCode int NULL,
        MaximumSpecimenExpirationDays smallint NULL,
        AutomatedInstrumentIndicator bit NULL,
        LabelPrinterUseIndicator bit NOT NULL,
        LabelPrinterComPortNumber tinyint NULL,
        LabelPrinterIPAddress varchar (15) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        LabelPrinterTcpPortNumber int NULL,
        TimeZoneId char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        DaylightSavingsTypeId smallint NOT NULL,
        PrinterName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PrinterAlertsIndicator bit NOT NULL,
        PrinterAlertsPrinterName varchar (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PrinterOrderAlertTypeCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        PrinterOrdersNeededHours smallint NULL,
        IconAlertsIndicator bit NULL,
        IconOrderAlertTypeCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        IconOrdersNeededHours smallint NULL,
        IconRefreshRate int NULL,
        LoginMessageText varchar (510) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        InvoiceTemplateText varchar (1000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        MedicalDirectorName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
        UsaIndicator bit NOT NULL,
        LockInactivityTimeoutMin int NOT NULL,
        AccessionAreaId int NULL,
        DaylightSavingsStartDate datetime NULL,
        DaylightSavingsEndDate datetime NULL,
        ReactivityPhaseCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        RecordStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        LastUpdateDate datetime NOT NULL,
        LastUpdateUser varchar(30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
        ) ON [PRIMARY]
GO

ALTER TABLE dbo.VamcDivision ADD 
        CONSTRAINT PK_VamcDivision PRIMARY KEY NONCLUSTERED 
        (
                MirrorId
        ) ON [PRIMARY] 
GO
CREATE CLUSTERED INDEX IX_VamcDivision ON dbo.VamcDivision (DivisionCode) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_VamcDivision_AntibodyScreenDisplayCode ON dbo.VamcDivision (AntibodyScreenDisplayCode) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_VamcDivision_FacilityGuid ON dbo.VamcDivision (FacilityGuid) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_VamcDivision_MedicalDirectorName ON dbo.VamcDivision (MedicalDirectorName) ON [PRIMARY]
GO
CREATE NONCLUSTERED INDEX IX_VamcDivision_MirrorDate ON dbo.VamcDivision (MirrorDate) ON [PRIMARY]
GO

/*****************************************************************************************
   Reload the updated VamcDivision Mirror table 
*****************************************************************************************/
SET IDENTITY_INSERT VamcDivision ON
GO
INSERT INTO VamcDivision 
        (MirrorId, DivisionCode, DivisionGuid, DivisionName, ServiceTypeIndicator, IccbbaRegistrationNumber, 
         ElectronicCrossmatchIndicator, FacilityGuid, LocalSupplierGuid, AntibodyScreenDisplayCode, 
         MaximumSpecimenExpirationDays, AutomatedInstrumentIndicator, LabelPrinterUseIndicator, 
         LabelPrinterComPortNumber, LabelPrinterIPAddress, LabelPrinterTcpPortNumber, TimeZoneId, 
         DaylightSavingsTypeId, PrinterName, PrinterAlertsIndicator, PrinterAlertsPrinterName, 
         PrinterOrderAlertTypeCode, PrinterOrdersNeededHours, IconAlertsIndicator, IconOrderAlertTypeCode, 
         IconOrdersNeededHours, IconRefreshRate, LoginMessageText, InvoiceTemplateText, MedicalDirectorName, 
         UsaIndicator, LockInactivityTimeoutMin, AccessionAreaId, DaylightSavingsStartDate, DaylightSavingsEndDate,
         ReactivityPhaseCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate)
SELECT          MirrorId, DivisionCode, DivisionGuid, DivisionName, ServiceTypeIndicator, IccbbaRegistrationNumber, 
         ElectronicCrossmatchIndicator, FacilityGuid, LocalSupplierGuid, AntibodyScreenDisplayCode, 
         MaximumSpecimenExpirationDays, AutomatedInstrumentIndicator, LabelPrinterUseIndicator, 
         LabelPrinterComPortNumber, LabelPrinterIPAddress, LabelPrinterTcpPortNumber, TimeZoneId, 
         DaylightSavingsTypeId, PrinterName, PrinterAlertsIndicator, PrinterAlertsPrinterName, 
         PrinterOrderAlertTypeCode, PrinterOrdersNeededHours, IconAlertsIndicator, IconOrderAlertTypeCode, 
         IconOrdersNeededHours, IconRefreshRate, LoginMessageText, InvoiceTemplateText, MedicalDirectorName, 
         UsaIndicator, LockInactivityTimeoutMin, AccessionAreaId, DaylightSavingsStartDate, DaylightSavingsEndDate,
         '9', RecordStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
  FROM dbo.#tmpMirrorVamcDivision
GO
SET IDENTITY_INSERT VamcDivision OFF
GO
if object_id(N'tempdb..#tmpMirrorVamcDivision') IS NOT NULL
        DROP TABLE #tmpMirrorVamcDivision
GO

/*****************************************************************************************
   Create the updated V_VamcDivision view 
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[V_VamcDivision]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view dbo.V_VamcDivision
GO


SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS OFF
GO
CREATE VIEW dbo.V_VamcDivision
AS 
SELECT Source='MIRROR', MirrorId, DivisionCode, DivisionGuid, DivisionName, ServiceTypeIndicator, IccbbaRegistrationNumber, ElectronicCrossmatchIndicator, FacilityGuid, LocalSupplierGuid, AntibodyScreenDisplayCode, MaximumSpecimenExpirationDays, AutomatedInstrumentIndicator, LabelPrinterUseIndicator, LabelPrinterComPortNumber, LabelPrinterIPAddress, LabelPrinterTcpPortNumber, TimeZoneId, DaylightSavingsTypeId, PrinterName, PrinterAlertsIndicator, PrinterAlertsPrinterName, PrinterOrderAlertTypeCode, PrinterOrdersNeededHours, IconAlertsIndicator, IconOrderAlertTypeCode, IconOrdersNeededHours, IconRefreshRate, LoginMessageText, InvoiceTemplateText, MedicalDirectorName, UsaIndicator, LockInactivityTimeoutMin, AccessionAreaId, DaylightSavingsStartDate, DaylightSavingsEndDate, ReactivityPhaseCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, MirrorDate
FROM dbo.VamcDivision
UNION ALL 
SELECT Source='ACTIVE', 0, DivisionCode, DivisionGuid, DivisionName, ServiceTypeIndicator, IccbbaRegistrationNumber, ElectronicCrossmatchIndicator, FacilityGuid, LocalSupplierGuid, AntibodyScreenDisplayCode, MaximumSpecimenExpirationDays, AutomatedInstrumentIndicator, LabelPrinterUseIndicator, LabelPrinterComPortNumber, LabelPrinterIPAddress, LabelPrinterTcpPortNumber, TimeZoneId, DaylightSavingsTypeId, PrinterName, PrinterAlertsIndicator, PrinterAlertsPrinterName, PrinterOrderAlertTypeCode, PrinterOrdersNeededHours, IconAlertsIndicator, IconOrderAlertTypeCode, IconOrdersNeededHours, IconRefreshRate, LoginMessageText, InvoiceTemplateText, MedicalDirectorName, UsaIndicator, LockInactivityTimeoutMin, AccessionAreaId, DaylightSavingsStartDate, DaylightSavingsEndDate, ReactivityPhaseCode, RecordStatusCode, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, LastUpdateDate AS MirrorDate 
FROM VBECS_V1_PROD.dbo.VamcDivision
GO
SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO




/*****************************************************************************************
*        Create a temporary PatientChange Mirror table and save the original data
*****************************************************************************************/
if object_id(N'tempdb..#tmpMirrorPatientChange') IS NOT NULL
        DROP TABLE #tmpMirrorPatientChange
GO

CREATE TABLE #tmpMirrorPatientChange (
        MirrorId int NOT NULL ,
        PatientChangeGuid uniqueidentifier NOT NULL ,
        FromPatientGuid uniqueidentifier NULL ,
        FromPatientSsn char (9) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        FromSsnPseudoIndicator bit NULL ,
        FromPatientIcn varchar (23) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        FromPatientLastName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        FromPatientFirstName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        FromPatientMIddleName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        FromPatientDob datetime NULL ,
        FromPatientDeathDate datetime NULL ,
        FromPatientSexCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        ToPatientGuid uniqueidentifier NULL ,
        ToPatientSsn char (9) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        ToSsnPseudoIndicator bit NULL ,
        ToPatientIcn varchar (23) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        ToPatientLastName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        ToPatientFirstName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        ToPatientMIddleName varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        ToPatientDob datetime NULL ,
        ToPatientDeathDate datetime NULL ,
        ToPatientSexCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        MergeFromVistaPatientId bigint NULL ,
        MergeToVistaPatientId bigint NULL ,
        PatientChangeStatusCode char (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
        LastUpdateDate datetime NOT NULL ,
        LastUpdateUser varchar (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
        [RowVersion] binary (8) NULL ,
        LastUpdateFunctionId int NOT NULL ,
        MirrorDate datetime NOT NULL 
)
GO

INSERT INTO #tmpMirrorPatientChange
SELECT MirrorId, PatientChangeGuid, FromPatientGuid, FromPatientSsn, FromSsnPseudoIndicator, FromPatientIcn, FromPatientLastName, FromPatientFirstName, FromPatientMIddleName, FromPatientDob,
        FromPatientDeathDate, FromPatientSexCode, ToPatientGuid, ToPatientSsn, ToSsnPseudoIndicator, ToPatientIcn, ToPatientLastName, ToPatientFirstName, ToPatientMIddleName, ToPatientDob, 
        ToPatientDeathDate, ToPatientSexCode, MergeFromVistaPatientId, MergeToVistaPatientId, PatientChangeStatusCode, LastUpdateDate, LastUpdateUser, [RowVersion], LastUpdateFunctionId, MirrorDate
FROM PatientChange
GO

/*****************************************************************************************
*         Create the new PatientChange Mirror table
*****************************************************************************************/

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[PatientChange]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[PatientChange]
GO

CREATE TABLE [dbo].[PatientChange] (
        [MirrorId] [int] IDENTITY (1, 1) NOT NULL ,
        [PatientChangeGuid] [uniqueidentifier] NOT NULL ,
        [FromPatientGuid] [uniqueidentifier] NULL ,
        [FromPatientSsn] [char] (9) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [FromSsnPseudoIndicator] [bit] NULL ,
        [FromPatientIcn] [varchar] (23) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [FromPatientLastName] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [FromPatientFirstName] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [FromPatientMIddleName] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [FromPatientDob] [datetime] NULL ,
        [FromPatientDeathDate] [datetime] NULL ,
        [FromPatientSexCode] [char] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [ToPatientGuid] [uniqueidentifier] NULL ,
        [ToPatientSsn] [char] (9) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [ToSsnPseudoIndicator] [bit] NULL ,
        [ToPatientIcn] [varchar] (23) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [ToPatientLastName] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [ToPatientFirstName] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [ToPatientMIddleName] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [ToPatientDob] [datetime] NULL ,
        [ToPatientDeathDate] [datetime] NULL ,
        [ToPatientSexCode] [char] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [MergeFromVistaPatientId] [bigint] NULL ,
        [MergeToVistaPatientId] [bigint] NULL ,
        [PatientChangeStatusCode] [char] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
        [NotificationReceivedDate] [datetime] NOT NULL ,
        [ActiveDivisionsAlertViewed] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
        [LastUpdateDate] [datetime] NOT NULL ,
        [LastUpdateUser] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
        [RowVersion] [binary] (8) NULL ,
        [LastUpdateFunctionId] [int] NOT NULL ,
        [MirrorDate] [datetime] NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[PatientChange] ADD 
        CONSTRAINT [PK_PatientChange] PRIMARY KEY  CLUSTERED 
        (
                [MirrorId]
        )  ON [PRIMARY] 
GO

/*****************************************************************************************
*        Reload the original PatientChange Mirror data into the updated table
*****************************************************************************************/

SET IDENTITY_INSERT PatientChange ON

INSERT INTO dbo.PatientChange
(
        MirrorId, PatientChangeGuid, FromPatientGuid, FromPatientSsn, FromSsnPseudoIndicator, FromPatientIcn, FromPatientLastName, FromPatientFirstName, FromPatientMIddleName, FromPatientDob,
        FromPatientDeathDate, FromPatientSexCode, ToPatientGuid, ToPatientSsn, ToSsnPseudoIndicator, ToPatientIcn, ToPatientLastName, ToPatientFirstName, ToPatientMIddleName, ToPatientDob, 
        ToPatientDeathDate, ToPatientSexCode, MergeFromVistaPatientId, MergeToVistaPatientId, PatientChangeStatusCode, NotificationReceivedDate, LastUpdateDate, LastUpdateUser, [RowVersion], 
        LastUpdateFunctionId, MirrorDate
)
SELECT MirrorId, PC1.PatientChangeGuid, FromPatientGuid, FromPatientSsn, FromSsnPseudoIndicator, FromPatientIcn, FromPatientLastName, FromPatientFirstName, FromPatientMIddleName, FromPatientDob,
        FromPatientDeathDate, FromPatientSexCode, ToPatientGuid, ToPatientSsn, ToSsnPseudoIndicator, ToPatientIcn, ToPatientLastName, ToPatientFirstName, ToPatientMIddleName, ToPatientDob, 
        ToPatientDeathDate, ToPatientSexCode, MergeFromVistaPatientId, MergeToVistaPatientId, PatientChangeStatusCode, PC2.LastUpdateDate, PC1.LastUpdateDate, LastUpdateUser, [RowVersion], 
        LastUpdateFunctionId, MirrorDate
FROM #tmpMirrorPatientChange PC1
        JOIN (SELECT PatientChangeGuid, MIN(LastUpdateDate) LastUpdateDate
                FROM #tmpMirrorPatientChange
                GROUP BY PatientChangeGuid) PC2
                ON PC1.PatientChangeGuid = PC2.PatientChangeGuid
GO

SET IDENTITY_INSERT PatientChange OFF
GO

DROP TABLE #tmpMirrorPatientChange
GO

/*****************************************************************************************
   Create the updated V_PatientChange view 
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[V_PatientChange]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[V_PatientChange]
GO


SET QUOTED_IDENTIFIER OFF
GO

CREATE VIEW dbo.V_PatientChange
AS 
SELECT Source='MIRROR', MirrorId, PatientChangeGuid, FromPatientGuid, FromPatientSsn, FromSsnPseudoIndicator, FromPatientIcn, FromPatientLastName, FromPatientFirstName, FromPatientMIddleName, FromPatientDob, FromPatientDeathDate, FromPatientSexCode, ToPatientGuid, ToPatientSsn, ToSsnPseudoIndicator, ToPatientIcn, ToPatientLastName, ToPatientFirstName, ToPatientMIddleName, ToPatientDob, ToPatientDeathDate, ToPatientSexCode, MergeFromVistaPatientId, MergeToVistaPatientId, PatientChangeStatusCode, NotificationReceivedDate, ActiveDivisionsAlertViewed, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, MirrorDate
FROM dbo.PatientChange
UNION ALL 
SELECT Source='ACTIVE', 0, PatientChangeGuid, FromPatientGuid, FromPatientSsn, FromSsnPseudoIndicator, FromPatientIcn, FromPatientLastName, FromPatientFirstName, FromPatientMIddleName, FromPatientDob, FromPatientDeathDate, FromPatientSexCode, ToPatientGuid, ToPatientSsn, ToSsnPseudoIndicator, ToPatientIcn, ToPatientLastName, ToPatientFirstName, ToPatientMIddleName, ToPatientDob, ToPatientDeathDate, ToPatientSexCode, MergeFromVistaPatientId, MergeToVistaPatientId, PatientChangeStatusCode, NotificationReceivedDate, ActiveDivisionsAlertViewed, LastUpdateDate, LastUpdateUser, [ROWVERSION], LastUpdateFunctionId, LastUpdateDate AS MirrorDate 
FROM VBECS_V1_PROD.dbo.PatientChange
GO

SET QUOTED_IDENTIFIER ON
GO



/*****************************************************************************************
   Add primary key to BloodUnitStatusCodeCurrent
*****************************************************************************************/
ALTER TABLE dbo.BloodUnitStatusCodeCurrent
        ADD CONSTRAINT PK_BloodUnitStatusCodeCurrent PRIMARY KEY CLUSTERED 
        (
                MirrorId
        ) ON [PRIMARY]
GO
/*****************************************************************************************
   Change the RowVersion column from binary(1) to binary(8) and making the column nullable
*****************************************************************************************/
ALTER TABLE [dbo].[BloodUnitStatusCodeCurrent]
      ALTER COLUMN [RowVersion] [binary] (8) NULL
GO
/*****************************************************************************************
*        Grant permissions on tables
*****************************************************************************************/
GRANT SELECT, INSERT ON dbo.AntigenType TO VbecsAppMirrorUser
GRANT SELECT, INSERT ON dbo.ComponentRequirement TO VbecsAppMirrorUser
GRANT SELECT, INSERT ON dbo.DailyQcWorklist TO VbecsAppMirrorUser
GRANT SELECT, INSERT ON dbo.InterfaceControl TO VbecsAppMirrorUser
GRANT SELECT, INSERT ON dbo.OrderedComponent TO VbecsAppMirrorUser
GRANT SELECT, INSERT ON dbo.OrderedTest TO VbecsAppMirrorUser
GRANT SELECT, INSERT ON dbo.PatientTransfusion TO VbecsAppMirrorUser
GRANT SELECT, INSERT ON dbo.RackTest TO VbecsAppMirrorUser
GRANT SELECT, INSERT ON dbo.VamcDivision TO VbecsAppMirrorUser
GRANT SELECT, INSERT ON dbo.PatientChange TO VbecsAppMirrorUser

GO

/*****************************************************************************************
*        Grant permissions on views
*****************************************************************************************/
GRANT SELECT ON dbo.V_AntigenType TO VbecsAppMirrorUser
GRANT SELECT ON dbo.V_ComponentRequirement TO VbecsAppMirrorUser
GRANT SELECT ON dbo.V_DailyQcWorklist TO VbecsAppMirrorUser
GRANT SELECT ON dbo.V_InterfaceControl TO VbecsAppMirrorUser
GRANT SELECT ON dbo.V_OrderedComponent TO VbecsAppMirrorUser
GRANT SELECT ON dbo.V_OrderedTest TO VbecsAppMirrorUser
GRANT SELECT ON dbo.V_PatientTransfusion TO VbecsAppMirrorUser
GRANT SELECT ON dbo.V_RackTest TO VbecsAppMirrorUser
GRANT SELECT ON dbo.V_VamcDivision TO VbecsAppMirrorUser
GRANT SELECT ON dbo.V_PatientChange TO VbecsAppMirrorUser
GO

USE VBECS_V1_PROD
GO

/*****************************************************************************************
*         Function changes
*****************************************************************************************/
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.fnAddAttributeToProductAttributeForm') and OBJECTPROPERTY(id, N'IsScalarFunction') = 1)
drop function dbo.fnAddAttributeToProductAttributeForm
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*********************************************************************************************************************
**
**  Desc:   Returns an updated ProductAttributeForm
**
**  Author: Dan McHugh
**
**  Date:   10/14/2004
**
**********************************************************************************************************************
**  Modified:
**          Date                Name                Description
**          10/14/04        Dan McHugh          Created
**          03/23/05        Dan McHugh        Changed to be a function, removed cursors, added code to change 'E' attributes
**          07/07/05        S. Antropov         ** Reviewed for compliance with database standards and recommendations **
**                                                  reformatted SQL, updated comment header to correspond to the standard. 
**          09/29/05          D. McHugh           Fixed problem when adding an E5 attribute to a PAF with a different E attribute (CR1189)
**        09/22/10        M. Smith        Changed the addition of "E" attributes (CR 2612)
**          05/18/11        K. Adu-Poku         ** Reviewed for compliance with database standards and recommendations **
*********************************************************************************************************************/
CREATE FUNCTION dbo.fnAddAttributeToProductAttributeForm 
(
    @AttributeToAdd       CHAR(2),          --In the form of 'B2'
    @ProductAttributeForm VARCHAR(40)       --In the form '@17 A1 C5'
)
RETURNS VARCHAR(40)

AS

/***************************************************************************************

        Just a helper function, called by spSingleBloodProductModification

        Goal is to produce a new ProductAttributeForm based on the AttributeToAdd.
        Examples...
                Add 'B2' to '@55 C2 F2' should return '@55 B2 C2 F2'
                Add 'B2' to '@17' should return '@17 B2'
                Add 'B2' to '@77 B2 C2 H8' should return '@77 B2 C2 H8' (doesn't add the B2 again)

        So the attributes are in alphabetical order within ProductAttributeForm, and no
        attribute is repeated.        If the incoming @ProductAttributeForm is not in alphabetic order... that ain't good

        Very little validation done here, it's assuming a valid ProductAttributeForm and
        valid Attribute to add are passed in.

***************************************************************************************/

BEGIN

DECLARE @Attribute VARCHAR(2)
DECLARE @NewProductAttributeForm VARCHAR(40)

--Didn't pass in any attributes to add?  Then just return the other parameter
IF @AttributeToAdd = ''        
        RETURN @ProductAttributeForm

-- Extract the Core Condition & put it to the destination ProductAttributeForm
SET @NewProductAttributeForm = LEFT(@ProductAttributeForm, 3)
SET @ProductAttributeForm = SUBSTRING(@ProductAttributeForm, 5, LEN(@ProductAttributeForm))

WHILE LEN(@ProductAttributeForm) > 0
        BEGIN
                --Get the current attribute from the incoming ProductAttributeForm 
                SET @Attribute = LEFT(@ProductAttributeForm, 2)

                --Remove it from the PAF
                SET @ProductAttributeForm = LTRIM(REPLACE(@ProductAttributeForm, @Attribute, ''))

                --Compare the current attribute with the attribute being added
                IF LEFT(@AttributeToAdd, 1) = LEFT(@Attribute, 1)

                        --Most of the time, only one of each type of attribute can be used
                        -- (like if B2 is in the ProductAttributeForm, then cannot add B1)
                        --This is to handle the special cases on that rule
                        IF @AttributeToAdd = 'E5' 
                                RETURN RTRIM(@NewProductAttributeForm + ' ' + @AttributeToAdd + ' ' + @ProductAttributeForm)
                        ELSE
                                RETURN RTRIM(@NewProductAttributeForm + ' ' + @Attribute + ' ' + @ProductAttributeForm)

                ELSE IF LEFT(@AttributeToAdd, 1) < LEFT(@Attribute, 1)
                        --Time to use that attribute to add
                        RETURN RTRIM(@NewProductAttributeForm + ' ' + @AttributeToAdd + ' ' + @Attribute + ' ' + @ProductAttributeForm)
                ELSE
                        --Add the current attribute to the newPAF, continue cycling through
                        SET @NewProductAttributeForm = @NewProductAttributeForm + ' ' + @Attribute                                                
        END

--The original ProductAttributeForm is depleted.  Slap on the attribute to add, return away
RETURN RTRIM(@NewProductAttributeForm + ' ' + @AttributeToAdd)

END

GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.fnBloodUnitLogicalKey') and OBJECTPROPERTY(id, N'IsScalarFunction') = 1)
drop function dbo.fnBloodUnitLogicalKey
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*********************************************************************************************************************
**
**  Desc:   Returns count of blood units with a given set of parameters. 
**          Used in a check constraint on the BloodUnit table. 
**
**  Author: Mike Smith
**
**  Date:   Unknown
**
**********************************************************************************************************************
**          Modified:
**          Date                Name                Description
**        ---------                ----------                ------------------
**        07/07/2005        S. Antropov        ** Reviewed for compliance with database standards and recommendations **
**                                        removed unnecessary local INT variable, reformatted SQL, added object owner 
**                                        prefix to table reference, added comment header
**        08/14/2005        S. Antropov        Updated WHERE clause for nullable fields
**        12/12/2005        Lohse                Added NOLOCK option to prevent Deadlocks during simultaionus unit entry
**        1/20/06                Van Stedum        Added check for donationtype id for the check constraint because it defines 
                                        the uniqueness of a unit
**        01/23/2006        M Smith                ** Reviewed for compliance with database standards and recommendations **
**        10/23/2009        M. Smith        Add check for BloodTypeCode, RhFactorCode, and UnitExpirationDate to define 
**                                        the uniqueness of a unit.
**        06/24/11        M. Smith        Removed the check for UnitFdaRegistrationNumber. (CR 2741).
**        06/24/11        M. Smith        Added UnitDivisionId to uniqueness check and removed BloodTypeCode, 
**                                        RhFactorCode, and UnitExpirationDate from uniqueness check (CR 3068).
*********************************************************************************************************************/
CREATE FUNCTION dbo.fnBloodUnitLogicalKey 
(
      @divisioncode      VARCHAR(5),
      @labelunitid       VARCHAR(13),
      @eyereadableunitid VARCHAR(13),
      @bloodproductguid  UNIQUEIDENTIFIER,
      @donationtypeid          INT,
      @UnitDivisionId         CHAR(2),
      @BloodUnitGuid         UNIQUEIDENTIFIER
)
RETURNS INT 
AS
BEGIN

    RETURN
    (
            SELECT  
                COUNT(1) 
        FROM    
                dbo.BloodUnit BU WITH (NOLOCK)
                        JOIN dbo.BloodUnitMedia BUM WITH (NOLOCK)
                                ON BU.BloodUnitGuid = BUM.BloodUnitGuid
            WHERE        
                LabelUnitId = @labelunitid 
            AND ( 
                     EyeReadableUnitId IS NULL 
                  OR @eyereadableunitid IS NULL 
                  OR EyeReadableUnitId = @eyereadableunitid 
                ) 
            AND BloodProductGuid  = @bloodproductguid 
            AND DivisionCode = @divisioncode 
            AND ((LabelTypeCode = 'I'
                  AND DonationTypeID = @donationtypeid
            AND (UnitDivisionId IS NULL 
                              OR @UnitDivisionId IS NULL 
                              OR UnitDivisionId = @UnitDivisionId ))
             OR  LabelTypeCode = 'C')
            AND RecordStatusCode = 'A'                
    )
END

GO


/*****************************************************************************************
*         Add constraint to the BloodUnit table
*****************************************************************************************/
GO
ALTER TABLE dbo.BloodUnit  WITH NOCHECK ADD CONSTRAINT CK_BloodUnit CHECK ((dbo.fnBloodUnitLogicalKey(DivisionCode, LabelUnitId, EyeReadableUnitId, BloodProductGuid, DonationTypeID, UnitDivisionId, BloodUnitGuid) < 2))
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.fnExpandOptionalProductAttributes') and OBJECTPROPERTY(id, N'IsScalarFunction') = 1)
drop function dbo.fnExpandOptionalProductAttributes
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Create temporary product attribute forms which contain all possibilities of attribute classes
**                        that are optional
**
**        Author: Dan McHugh
**
**        Date:   08/31/2009
**
**        Example:        Incoming parameter is @84 B2 D_ J$ (the J attribute is optional)
**                        Outgoing table includes @84 B2 D_ and @84 B2 D_ J_
**        
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        ----------                ----------                ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        08/04/11        M. Smith        Changed to add optional attribute on the target product without consideration of the from product. (CR 3109)
*******************************************************************************************************************************************************************************/
CREATE FUNCTION dbo.fnExpandOptionalProductAttributes
        (
        @ProductAttributeForm AS VARCHAR(40)
        )

RETURNS @ProductAttributeFormTable TABLE (
        ProductAttributeForm VARCHAR(40)
        )

AS

BEGIN

        DECLARE @Attribute AS VARCHAR(5)

        DECLARE AttributeCursor CURSOR FAST_FORWARD FOR
                SELECT Item FROM dbo.fnSplit(@ProductAttributeForm, ' ')


        OPEN AttributeCursor

        FETCH NEXT FROM AttributeCursor INTO @Attribute

        WHILE @@FETCH_STATUS = 0
        BEGIN

                IF @Attribute LIKE '@%'
                        INSERT INTO @ProductAttributeFormTable VALUES(@Attribute)
                ELSE IF @Attribute LIKE '%$%'
                        BEGIN
                        IF  SUBSTRING(@Attribute, 2, 1) = '$'
                                INSERT INTO @ProductAttributeFormTable 
                                        SELECT ProductAttributeForm + ' ' + REPLACE(@Attribute, '$', '_') FROM @ProductAttributeFormTable
                        ELSE
                                INSERT INTO @ProductAttributeFormTable 
                                        SELECT ProductAttributeForm + ' ' + REPLACE(@Attribute, '$', '') FROM @ProductAttributeFormTable
                        END

                ELSE
                        UPDATE @ProductAttributeFormTable
                                SET ProductAttributeForm = ProductAttributeForm + ' ' + @Attribute

                FETCH NEXT FROM AttributeCursor INTO @Attribute
        END

        CLOSE AttributeCursor
        DEALLOCATE AttributeCursor

RETURN

END



GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.fnGetAntibodyScreenTestResults') and OBJECTPROPERTY(id, N'IsScalarFunction') = 1)
drop function dbo.fnGetAntibodyScreenTestResults
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**
**        Desc:                Returns ABS results for a patient (CR 2941)
**
**        Use Case(s):        
**
**        Author:                 K. Dobranowski
**
**        Date:                 03/17/2011
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        ------------------        -------------------------------------------------------------------------------------------------------------------------------------------------
**        04/13/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE FUNCTION dbo.fnGetAntibodyScreenTestResults
(
    @patientguid UNIQUEIDENTIFIER
)

RETURNS VARCHAR(55)

AS

BEGIN

    RETURN 
( 
        -- Antibody Screen Test Results

        SELECT TOP 1 TR.TestResultText

        FROM         dbo.SpecimenTest ST

        JOIN        dbo.PatientSpecimen PS         ON PS.PatientSpecimenGuid = ST.PatientSpecimenGuid
        JOIN        dbo.TestResult TR                 ON TR.TestResultId = ST.TestResultId

        WHERE         PS.PatientGuid  = @patientguid
                        AND ST.RecordStatusCode = 'A'
                        AND ST.BloodTestTypeId IN (52, 92, 107, 152)

        ORDER BY ST.LastUpdateDate DESC
)
END

GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.fnIsABORhTestComplete') and OBJECTPROPERTY(id, N'IsScalarFunction') = 1)
drop function dbo.fnIsABORhTestComplete
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*********************************************************************************************************************
**
**  Desc:   Only completed ABO/Rh tests should be retrieved.  Completed means that both the 
**          ABO and Rh interpretations have been done.  This function allows users to pass in 
**          an OrderedTestGuid and BloodTestTypeID belonging to an ABO/Rh test.  It then returns 
**          either the date that the corresponding interpretation was entered or NULL if it has not been recorded.
**
**  Author: Carl Jensen
**
**  Date:   12/8/2004
**
**********************************************************************************************************************
**  Modified:
**  Date        Name            Description
**  07/07/2005        S. Antropov     ** Reviewed for compliance with database standards and recommendations **
**                              reformatted SQL, added object owner, updated header comment
**  08/16/2005  S. Antropov     Added explanatory comment for IF blocks (instead of CASE..WHEN)
** 09/17/2009        K.Dobranowski Added check for RecordStatusCode to make sure that invalidated test results are not being checked (CR 2576)
** 08/18/2010        K. Adu-Poku     ** Reviewed for compliance with database standards and recommendations **
*********************************************************************************************************************/
CREATE FUNCTION dbo.fnIsABORhTestComplete
(
        @orderedtestguid         UNIQUEIDENTIFIER,
        @bloodtesttypeid         INT
)
RETURNS DATETIME
AS
BEGIN
    IF @orderedtestguid IS NULL OR @bloodtesttypeid IS NULL 
        RETURN NULL

    DECLARE @retval DATETIME

    -- Blocks of IF statement are used instead of CASE..WHEN because of the performance reasons:
    -- repetitive ad hoc testing of this particular function indicated that IF is faster in this case

    IF @bloodtesttypeid = 18 
    BEGIN
        SET @retval = ( SELECT TOP 1 TestDate FROM dbo.SpecimenTest WHERE OrderedTestGuid = @orderedtestguid AND BloodTestTypeId = 21 AND TestResultId IS NOT NULL AND RecordStatusCode = 'A')
        RETURN @retval
    END
   
    IF @bloodtesttypeid = 21
    BEGIN
        SET @retval = ( SELECT TOP 1 TestDate FROM dbo.SpecimenTest WHERE OrderedTestGuid = @orderedtestguid AND BloodTestTypeId = 18 AND TestResultId IS NOT NULL AND RecordStatusCode = 'A')
        RETURN @retval
    END

    IF @bloodtesttypeid = 65
    BEGIN
        SET @retval = ( SELECT TOP 1 TestDate FROM dbo.SpecimenTest WHERE OrderedTestGuid = @orderedtestguid AND BloodTestTypeId = 68 AND TestResultId IS NOT NULL AND RecordStatusCode = 'A')
        RETURN @retval
    END

    IF @bloodtesttypeid = 68
    BEGIN
        SET @retval = ( SELECT TOP 1 TestDate FROM dbo.SpecimenTest WHERE OrderedTestGuid = @orderedtestguid AND BloodTestTypeId = 65 AND TestResultId IS NOT NULL AND RecordStatusCode = 'A')
        RETURN @retval
    END

    IF @bloodtesttypeid = 118
    BEGIN
        SET @retval = ( SELECT TOP 1 TestDate FROM dbo.SpecimenTest WHERE OrderedTestGuid = @orderedtestguid AND BloodTestTypeId = 121 AND TestResultId IS NOT NULL AND RecordStatusCode = 'A')
        RETURN @retval
    END

    IF @bloodtesttypeid = 121
    BEGIN
        SET @retval = ( SELECT TOP 1 TestDate FROM dbo.SpecimenTest WHERE OrderedTestGuid = @orderedtestguid AND BloodTestTypeId = 118 AND TestResultId IS NOT NULL AND RecordStatusCode = 'A')
        RETURN @retval
    END

    RETURN NULL
END

GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.fnRemoveAttributes') and OBJECTPROPERTY(id, N'IsScalarFunction') = 1)
drop function dbo.fnRemoveAttributes
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*********************************************************************************************************************
**
**  Desc:   Remove any optional attributes from the ProductAttributeForm string
**
**  Author: Dan McHugh
**
**  Date:   02/09/2005
**
**********************************************************************************************************************
**  Modified:
**          Date                Name            Description
**          07/07/2005        S. Antropov     ** Reviewed for compliance with database standards and recommendations **
**                                                      Reformatted SQL, added object owners, added FAST_FORWARD attribute to cursor,         
**                                                      restructured WHILE loop for performance and readability.
**        08/23/10        M. Smith        Changed @pProductAttributeForm to VARCHAR(40) (CR2765)
**         09/28/10        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*********************************************************************************************************************/
CREATE FUNCTION dbo.fnRemoveAttributes
(
        @pProductAttributeForm VARCHAR(40),
        @pProductModificationCode CHAR(1)
)
RETURNS VARCHAR(20)
AS
BEGIN

    IF @pProductModificationCode NOT IN ('P', 'U')
        RETURN @pProductAttributeForm
    
    DECLARE @retval VARCHAR(20)
    DECLARE @attribute VARCHAR(3)
    
    SET @retval = @pProductAttributeForm
    
    -- Usage of the cursor is justified here - table variable method decreases the performance (Stas)
    DECLARE AttCursor CURSOR LOCAL FAST_FORWARD FOR
            SELECT  RTRIM(ProductAttributeId) 
            FROM    dbo.ProductAttribute 
            WHERE   ProductAttributeId LIKE '[FGHJKL]_'
    
    OPEN AttCursor
    
    WHILE 1 = 1
    BEGIN        
        FETCH NEXT FROM AttCursor INTO @attribute
        
        IF @@FETCH_STATUS <> 0 BREAK

        SET @retval = REPLACE(@retval, ' ' + @attribute, '')
    END
    
    CLOSE AttCursor
    DEALLOCATE AttCursor
    
    RETURN @retval

END

GO

/*****************************************************************************************
*         New Function
*****************************************************************************************/

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.fnDivisionsWithActiveOrders') and OBJECTPROPERTY(id, N'IsScalarFunction') = 1)
drop function dbo.fnDivisionsWithActiveOrders
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**
**        Desc:                Returns string consisting of division codes for which there are active orders (test and component), delimited by '^' (CR 3164)
**
**        Use Case(s):        108
**
**        Author:                 D. Askew and M. Smith
**
**        Date:                 11/09/2011
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        --------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**         12/01/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE  FUNCTION dbo.fnDivisionsWithActiveOrders
( 
          @PatientGuid                                        UNIQUEIDENTIFIER,
        @CurrentDate                                        DATETIME,
        @PatientChangeNotificationReceivedDate        DATETIME
)  

RETURNS VARCHAR(255)

AS

BEGIN

        DECLARE @ReturnValue VARCHAR(255)

        -- Used to determine if order is expired
        DECLARE @DaysStillCurrent INT
        SET @DaysStillCurrent = 10

        -- This value is used to separate division codes
        DECLARE @Delimiter CHAR(1)
        SET @Delimiter = '^'

        -- Used to store division codes for active test orders
        DECLARE @OrderedTestDivisionTable TABLE
                (DivisionCode CHAR(5))

        -- Used to store division codes for active component orders
        DECLARE @OrderedComponentDivisionTable TABLE
                ( DivisionCode CHAR(5), 
                 RequiredUnitQuantity INT, 
                 TransfusedAndIssuedUnits INT)

        -- ********************************************************
        -- Part I. Get test order division codes
        -- ********************************************************

        INSERT INTO @OrderedTestDivisionTable

        SELECT DISTINCT OT.DivisionCode
        FROM 
                dbo.OrderedTest OT

                JOIN dbo.PatientOrder PO                 
                        ON PO.PatientOrderGuid = OT.PatientOrderGuid

                JOIN dbo.PatientTreatment PT                 
                        ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid

                LEFT JOIN dbo.PatientSpecimen PS        
                        ON PS.PatientSpecimenGuid = OT.PatientSpecimenGuid
        WHERE 
                PT.PatientGuid = @PatientGuid

                AND 
                (
                        (
                                -- Pending
                                OT.OrderStatusCode = 'P'

                                AND PO.OrderReceivedDatetime < @PatientChangeNotificationReceivedDate
                        )

                        OR 
                        (
                                -- A = Accepted, V = Active
                                OT.OrderStatusCode IN ('A', 'V')

                                -- I = In Progress, N = Not Started, P = Partially Completed, R = Correction
                                AND OT.TaskStatusCode IN ('I', 'N', 'P', 'R') 

                                -- If there's no specimen, try OrderAcceptanceDate first and then OrderReceivedDatetime
                                AND ISNULL(SpecimenExpirationDate, DATEADD(DAY, @DaysStillCurrent, ISNULL(OT.OrderAcceptanceDate, PO.OrderReceivedDatetime))) >= @CurrentDate

                                AND ISNULL(OT.OrderAcceptanceDate, PO.OrderReceivedDatetime) < @PatientChangeNotificationReceivedDate
                        )
                )

        -- Build return string
        SELECT @ReturnValue = ISNULL(@ReturnValue + @Delimiter, '') + RTRIM(DivisionCode)

        FROM @OrderedTestDivisionTable

        -- *******************************************************************
        -- Part II. Get component order division codes
        -- *******************************************************************

        INSERT INTO @OrderedComponentDivisionTable
        SELECT DISTINCT
                OC.DivisionCode,
                OC.RequiredUnitQuantity,
                (        
                        SELECT COUNT(1)

                        FROM 

                                dbo.OrderedUnit OU
                                JOIN dbo.BloodUnitStatusCodeCurrent BUSCC ON OU.BloodUnitGuid = BUSCC.BloodUnitGuid

                        WHERE 

                                OU.OrderedComponentGUID = OC.OrderedComponentGuid
                                AND RecordStatusCode = 'A'
                                AND BUSCC.UnitStatusCode IN ('I','T')
                                AND OU.ReleaseDate IS NULL

                ) AS TransfusedAndIssuedUnits

        FROM 
                dbo.OrderedComponent OC

                JOIN dbo.PatientOrder PO                
                        ON PO.PatientOrderGuid = OC.PatientOrderGuid

                JOIN dbo.PatientTreatment PT                
                        ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid

                LEFT JOIN dbo.PatientSpecimen PS        
                        ON PS.PatientSpecimenGuid = OC.PatientSpecimenGuid

        WHERE 
                PT.PatientGuid = @PatientGuid

                AND 
                (
                        (
                                -- Pending
                                OC.OrderStatusCode = 'P'

                                AND PO.OrderReceivedDatetime < @PatientChangeNotificationReceivedDate
                        )

                        OR         
                        (
                                -- A = Accepted, V = Active
                                OC.OrderStatusCode IN ('A', 'V')

                                -- If there's no specimen, try OrderAcceptanceDate first and then OrderReceivedDatetime
                                AND ISNULL(SpecimenExpirationDate, DATEADD(DAY, @DaysStillCurrent, ISNULL(OC.OrderAcceptanceDate, PO.OrderReceivedDatetime))) >= @CurrentDate

                                AND ISNULL(OC.OrderAcceptanceDate, PO.OrderReceivedDatetime) < @PatientChangeNotificationReceivedDate
                        )
                )

        -- Build return string
        SELECT @ReturnValue = ISNULL(@ReturnValue + @Delimiter, '') + RTRIM(DivisionCode)

        FROM @OrderedComponentDivisionTable

        WHERE  
                -- TransfusedAndIssuedUnits >= RequiredUnitQuantity == > filled (we don't want filled orders)
                TransfusedAndIssuedUnits < RequiredUnitQuantity

                AND DivisionCode NOT IN (SELECT DivisionCode FROM @OrderedTestDivisionTable)

        RETURN @ReturnValue
END

GO

/*****************************************************************************************
*         Deleted Functions
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.fnCurrentPatientOrderReceivedDateTime') and OBJECTPROPERTY(id, N'IsScalarFunction') = 1)
drop function dbo.fnCurrentPatientOrderReceivedDateTime

GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.fnFromPatientPendingOrdersCount') and OBJECTPROPERTY(id, N'IsScalarFunction') = 1)
drop function dbo.fnFromPatientPendingOrdersCount

GO

/*****************************************************************************************
*         View changes
*****************************************************************************************/
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.vw_GetAdminReportBase') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view dbo.vw_GetAdminReportBase
GO


SET QUOTED_IDENTIFIER ON
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Several Stored Procedures ( i.e. spGetAdminReportBloodUnits?????) used for Admin Report Generation use this common dataset
**        Table        BloodUnitModification,BloodUnitShipment, PatientTransfusion  can be joined on .BloodUnitGuid
**        Table         ProductModification can be joined on ProductModificationCode
**
**        Author: Norm Paterson
**
**        Date:   07/15/2005
**
*******************************************************************************************************************************************************************************
**        Modified:
**         Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        01/04/10        M. Smith        Changed to get UnitStatusCode from the BloodUnitStatusCodeCurrent table. (CR 1174)
**        01/21/10        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/02/10        D. Askew        Cleaned up SQL; added AND TestResultId IS NOT NULL to CMVNegative and SCNegative CASE
**                                        statements. (CR 2105)
**        08/18/10        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        07/20/11        D. Askew        Replaced TestResultId IS NOT NULL with TestResultID = 'N' in LEFT JOIN on BloodUnitTest (CR 2105)
**        07/26/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE VIEW dbo.vw_GetAdminReportBase

AS

        SELECT     
                BU.DivisionCode, 
                BU.BloodUnitGuid, 
                BU.DonationTypeId, 
                BU.UnitDivisionId, 
                BU.LabelTypeCode, 
                BU.EyeReadableUnitId, 
                BU.DiscardedPlasmaVolume, 
                PT.ComponentClassId, 
                CC.ComponentClassName, 
                BU.UnitProductCode, 
                BP.ProductTypeCode, 
                BP.ProductAttributeForm,
                BUSCC.UnitStatusCode,
                BUS.UnitStatusDate,
                BU.UnitInDate,
                BUT.CMVNegative,
                BUT.SCNegative
        
        FROM         dbo.BloodUnit BU

                JOIN dbo.BloodUnitStatus BUS 
                        ON BU.BloodUnitGuid = BUS.BloodUnitGuid

                 JOIN dbo.BloodUnitStatusCodeCurrent BUSCC
                        ON BU.BloodUnitGuid = BUSCC.BloodUnitGuid

                JOIN dbo.BloodProduct BP 
                        ON BU.BloodProductGuid = BP.BloodProductGuid 

                JOIN dbo.ProductType PT 
                        ON BP.ProductTypeCode = PT.ProductTypeCode 

                JOIN dbo.ComponentClass CC 
                        ON PT.ComponentClassId = CC.ComponentClassId
        
                LEFT JOIN 
                (        SELECT 
                                BloodUnitGuid, 
                                DivisionCode, 
                                MAX(CASE WHEN BloodTestTypeId = 103 AND TestResultID = 'N' THEN 1 ELSE 0 END) AS CMVNegative,
                                MAX(CASE WHEN BloodTestTypeId = 104 AND TestResultID = 'N' THEN 1 ELSE 0 END) AS SCNegative

                        FROM         dbo.BloodUnitTest 

                        WHERE RecordStatusCode != 'X' AND BloodTestTypeId IN (103, 104)

                        GROUP BY BloodUnitGuid, DivisionCode
                ) BUT
                        ON BU.BloodUnitGuid = BUT.BloodUnitGuid AND BU.DivisionCode = BUT.DivisionCode




GO

SET QUOTED_IDENTIFIER OFF
GO


/*****************************************************************************************
*         Refresh the view based on table changes
*****************************************************************************************/
GO
exec sp_refreshview N'dbo.V_BloodUnit'
exec sp_refreshview N'dbo.vw_BloodUnitsWithAntigensIdentified'
exec sp_refreshview N'dbo.vw_ActiveAndInactiveBloodUnits'
exec sp_refreshview N'dbo.vw_ActiveAndInactiveBloodUnitsWithCurrentStatus'
exec sp_refreshview N'dbo.vw_BloodShipAllCurrent'
exec sp_refreshview N'dbo.vw_BloodShipFinanceAllCurrent'
exec sp_refreshview N'dbo.vw_BloodShipPatientAllCurrent'
GO

/*****************************************************************************************
*         Mirror Triggers
*****************************************************************************************/
GO

SET QUOTED_IDENTIFIER ON
GO
CREATE TRIGGER dbo.trMirrorAntigenType
ON dbo.AntigenType
FOR UPDATE 
AS 
BEGIN
        INSERT INTO VBECS_V1_PROD_MIRROR.dbo.AntigenType
        SELECT *, GETUTCDATE()
        FROM DELETED
END

GO

SET QUOTED_IDENTIFIER ON
GO
CREATE TRIGGER dbo.trMirrorComponentRequirement
ON dbo.ComponentRequirement
FOR UPDATE 
AS 
BEGIN
        INSERT INTO VBECS_V1_PROD_MIRROR.dbo.ComponentRequirement
        SELECT *, GETUTCDATE()
        FROM DELETED
END

GO

SET QUOTED_IDENTIFIER ON
GO
CREATE TRIGGER dbo.trMirrorDailyQcWorklist
ON dbo.DailyQcWorklist
FOR UPDATE 
AS 
BEGIN
        INSERT INTO VBECS_V1_PROD_MIRROR.dbo.DailyQcWorklist
        SELECT *, GETUTCDATE()
        FROM DELETED
END

GO

SET QUOTED_IDENTIFIER ON
GO
CREATE TRIGGER dbo.trMirrorInterfaceControl
ON dbo.InterfaceControl
FOR UPDATE 
AS 
BEGIN
        INSERT INTO VBECS_V1_PROD_MIRROR.dbo.InterfaceControl
        SELECT *, GETUTCDATE()
        FROM DELETED
END

GO
SET QUOTED_IDENTIFIER OFF
GO

SET QUOTED_IDENTIFIER ON
GO
CREATE TRIGGER dbo.trMirrorOrderedComponent
ON dbo.OrderedComponent
FOR UPDATE 
AS 
BEGIN
        INSERT INTO VBECS_V1_PROD_MIRROR.dbo.OrderedComponent
        SELECT *, GETUTCDATE()
        FROM DELETED
END

GO

SET QUOTED_IDENTIFIER ON
GO
CREATE TRIGGER dbo.trMirrorOrderedTest
ON dbo.OrderedTest
FOR UPDATE 
AS 
BEGIN
        INSERT INTO VBECS_V1_PROD_MIRROR.dbo.OrderedTest
        SELECT *, GETUTCDATE()
        FROM DELETED
END

GO
SET QUOTED_IDENTIFIER OFF
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TRIGGER dbo.trMirrorPatientTransfusion
ON dbo.PatientTransfusion
FOR UPDATE 
AS 
BEGIN
        INSERT INTO VBECS_V1_PROD_MIRROR.dbo.PatientTransfusion
        SELECT *, GETUTCDATE()
        FROM DELETED
END

GO

SET QUOTED_IDENTIFIER ON
GO
CREATE TRIGGER dbo.trMirrorRackTest
ON dbo.RackTest
FOR UPDATE 
AS 
BEGIN
        INSERT INTO VBECS_V1_PROD_MIRROR.dbo.RackTest
        SELECT *, GETUTCDATE()
        FROM DELETED
END

GO

SET QUOTED_IDENTIFIER ON
GO
CREATE TRIGGER dbo.trMirrorVamcDivision
ON dbo.VamcDivision
FOR UPDATE 
AS 
BEGIN
        INSERT INTO VBECS_V1_PROD_MIRROR.dbo.VamcDivision
        SELECT *, GETUTCDATE()
        FROM DELETED
END

GO

SET QUOTED_IDENTIFIER OFF 
GO


CREATE TRIGGER dbo.trMirrorPatientChange
ON dbo.PatientChange
FOR UPDATE 
AS 
BEGIN
        INSERT INTO VBECS_V1_PROD_MIRROR.dbo.PatientChange
        SELECT *, GETUTCDATE()
        FROM DELETED
END

GO
SET QUOTED_IDENTIFIER ON
GO


SET QUOTED_IDENTIFIER OFF
GO

/*****************************************************************************************
*         Triggers
*****************************************************************************************/
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Creates HL7 Component Order Update Message (CR 2368)
**
**        Author:        David Askew
**
**        Date:         10/28/2009
**        
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        08/15/11        M. Smith        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE TRIGGER dbo.trCreateExpiredOrderedComponentMessage 

ON dbo.OrderedComponent 

FOR UPDATE 

AS 

IF EXISTS (SELECT OrderedComponentGuid FROM Inserted WHERE OrderStatusCode = 'X' AND TaskStatusCode = 'E') 

BEGIN        

        DECLARE @messageStream                 VARCHAR(3500)

        DECLARE @carriageReturn                 VARCHAR(5)        
        DECLARE @currentTime                DATETIME
        DECLARE @currentUtcTime                DATETIME
        DECLARE @hl7CurrentTime                VARCHAR(100)
        
        DECLARE @msh                         VARCHAR(875)
        DECLARE @pid                         VARCHAR(875)
        DECLARE @orc                         VARCHAR(875)
        DECLARE @obr                         VARCHAR(875)
        
        DECLARE @fieldSeparator                 CHAR(1)                -- Interface
        DECLARE @encodingCharacters                CHAR(4)                -- Interface
        DECLARE @interfaceApplicationId        VARCHAR(50)                -- Interface
        DECLARE @vbecsApplicationId                VARCHAR(50)                -- Interface
        DECLARE @versionId                        VARCHAR(8)                -- Interface
        DECLARE @interfaceFacilityId                VARCHAR(20)                -- InterfaceControl
        DECLARE @processingId                CHAR(1)                -- InterfaceControl
        DECLARE @vbecsFacilityId                VARCHAR(20)                -- InterfaceControl
        
        DECLARE @componentSeparator        CHAR(1)
        DECLARE @messageControlId                VARCHAR(50)
        DECLARE @messageType                VARCHAR(13)
        DECLARE @orderControlCode                CHAR(2)         
        DECLARE @namespaceId                VARCHAR(5)
        DECLARE @orderStatus                        CHAR(2)
        DECLARE @orderComments                VARCHAR(255)
        
        DECLARE @patientLastName                VARCHAR(30)
        DECLARE @patientFirstName                 VARCHAR(30)
        DECLARE @patientMiddleName                VARCHAR(30)
        DECLARE @patientSexCode                CHAR(1)
        DECLARE @patientDob                        VARCHAR(100)
        DECLARE @vistaPatientId                 VARCHAR(50)
        
        DECLARE @cprsOrderNumber                VARCHAR(20)
        DECLARE @vbecsOrderNumber                VARCHAR(25)
        DECLARE @orderGroupNumber                VARCHAR(30)
        DECLARE @orderStatusCode                CHAR(1)
        DECLARE @orderSpecialInstructions        VARCHAR(510)
        DECLARE @labOrderNumber                VARCHAR(20)
        DECLARE @labTestId                        CHAR(15)
        DECLARE @cprsOrderableItemID        CHAR(2)
        DECLARE @componentClassName        VARCHAR(35)
        
        -- Get interface data for message
        SELECT 
                @fieldSeparator                         = I.FieldSeparator,
                @encodingCharacters                 = I.EncodingCharacters,
                @interfaceApplicationId                 = I.InterfaceApplicationId,
                @vbecsApplicationId                 = I.VbecsApplicationId,
                @versionId                         = I.VersionId,
                @interfaceFacilityId                 = IC.InterfaceFacilityId,
                @processingId                         = IC.ProcessingId,
                @vbecsFacilityId                 = IC.VbecsFacilityId
        FROM
                dbo.Interface I
                JOIN dbo.InterfaceControl IC         ON I.InterfaceId = IC.InterfaceId
        WHERE
                I.InterfaceId = 1
        
        -- Get patient order data for message
        SELECT 
                @patientLastName                 = P.PatientLastName, 
                @patientFirstName                = P.PatientFirstName, 
                @patientMiddleName                = ISNULL(P.PatientMiddleName, ''), 
                @patientSexCode                = ISNULL(P.PatientSexCode, ''),
                @patientDob                        = ISNULL(SUBSTRING(dbo.fnDateTimeConversionToHL7DateTime(P.PatientDob),0, 9), ''),
                @vistaPatientId                        = CAST(P.VistaPatientId AS VARCHAR(50)), 
                @cprsOrderNumber                = OC.CprsOrderNumber,
                @vbecsOrderNumber                = CAST(OC.VbecsOrderNumber AS VARCHAR(25)), 
                @orderGroupNumber                = PO.OrderGroupNumber,
                @orderStatusCode                = OC.OrderStatusCode,
                @orderSpecialInstructions        = ISNULL(OC.OrderSpecialInstructions, ''),
                @labOrderNumber                = OC.LabOrderNumber,
                @labTestId                        = OC.LabTestId,
                @cprsOrderableItemID                = CCLASS.CprsOrderableItemID, 
                @componentClassName                = CCLASS.ComponentClassName
        FROM 
                dbo.Patient P 
                JOIN dbo.PatientTreatment PT                 ON P.PatientGuid                 = PT.PatientGuid
                JOIN dbo.PatientOrder PO                 ON PT.PatientTreatmentGuid         = PO.PatientTreatmentGuid
                JOIN dbo.OrderedComponent OC         ON PO.PatientOrderGuid         = OC.PatientOrderGuid
                JOIN dbo.ComponentClass CCLASS         ON OC.ComponentClassId         = CCLASS.ComponentClassId 
        WHERE 
                OC.OrderedComponentGuid         = (SELECT OrderedComponentGuid FROM Inserted)
                AND OC.OrderStatusCode         = 'X'
                AND TaskStatusCode                 = 'E'

        -- Set the variables values
        SET @carriageReturn                 = CHAR(13)
        SET @componentSeparator         = SUBSTRING(@encodingCharacters, 1, 1)
        SET @currentUtcTime                = GETUTCDATE()
        -- Only used to calculate the time zone differential
        SET @currentTime                = GETDATE()                                                                                                                 

        SET @hl7CurrentTime                 = REPLACE(REPLACE(REPLACE(CONVERT(VARCHAR(36), @currentUtcTime, 20), ' ',''),'-',''),':','')                                 -- yyyyMMddhhss
                                         + '-0' + CONVERT( VARCHAR(10), ABS(DATEPART(HOUR,@currentTime) - DATEPART(HOUR,@currentUtcTime))) + '00'        -- Get time zone in -0500 format, where 5 is hrs from UTC

        SET @messageControlId                = 'VBECS' + REPLACE(REPLACE(REPLACE(REPLACE(CONVERT( VARCHAR(36), @currentUtcTime, 21 ),'-',''),' ',''),':',''),'.','')        -- yyyyMMddhhssccc (c = milliseconds)

        SET @messageType                 = 'OMG^O19' 
        SET @namespaceId                = 'VBEC'
        SET @orderStatus                = 'ZE'
        SET @orderComments                = 'Expired by background job'

        -- ***************************************************************************************************************************************************************************************************************************************************************************** 
        --                         MSH SEGMENT        
        SET @msh = 
                'MSH' 
                + @fieldSeparator 
                + @encodingCharacters 
                + @fieldSeparator 
                + @vbecsApplicationId 
                + @fieldSeparator 
                + @vbecsFacilityId 
                + @fieldSeparator 
                + @interfaceApplicationId 
                + @fieldSeparator 
                + @interfaceFacilityId 
                + @fieldSeparator 
                + @hl7CurrentTime
                + @fieldSeparator 
                + @fieldSeparator 
                + @messageType
                + @fieldSeparator 
                + @messageControlId
                + @fieldSeparator 
                + @processingId 
                + @fieldSeparator 
                + @versionId 
                + @carriageReturn

        -- ***************************************************************************************************************************************************************************************************************************************************************************** 
        --                         PID SEGMENT        
        SET @pid = 
                'PID' 
                + @fieldSeparator 
                + @fieldSeparator 
                + @fieldSeparator 
                + @vistaPatientId
                + @fieldSeparator 
                + @fieldSeparator 
                + @patientLastName
                + @componentSeparator
                + @patientFirstName
                + @componentSeparator
                + @patientMiddleName
                + @fieldSeparator 
                + @fieldSeparator 
                + @patientDob
                + @fieldSeparator 
                + @patientSexCode
                + @carriageReturn
        
        -- ***************************************************************************************************************************************************************************************************************************************************************************** 
        --                         ORC SEGMENT        
        SET @orc = 
                'ORC'
                + @fieldSeparator
                + 'SC'                                 -- Always send a Status Change Order Control code
                + @fieldSeparator
                + @cprsOrderNumber
                + @componentSeparator
                + 'OR'
                + @fieldSeparator
                + @vbecsOrderNumber
                + @componentSeparator
                + @namespaceId
                + @fieldSeparator
                + @orderGroupNumber
                + @fieldSeparator
                + @orderStatus
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @componentSeparator
                + @orderComments
                + @carriageReturn
        
        -- ***************************************************************************************************************************************************************************************************************************************************************************** 
        --                         OBR SEGMENT        
        SET @obr = 
                'OBR'
                + @fieldSeparator
                + '1'                                -- Set ID
                + @fieldSeparator
                + @cprsOrderNumber
                + @componentSeparator
                + 'OR'
                + @fieldSeparator
                + @vbecsOrderNumber
                + @componentSeparator
                + @namespaceId
                + @fieldSeparator
                + @cprsOrderableItemID
                + @componentSeparator
                + @componentClassName
                + @componentSeparator
                + '99VBC'
                + @componentSeparator
                + @componentSeparator
                + @orderSpecialInstructions
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @labOrderNumber
                + ';;;'
                + @labTestId
                + @carriageReturn
        
        -- ***************************************************************************************************************************************************************************************************************************************************************************** 
        -- Create HL7 message
        SET @messageStream = @msh + @pid + @orc + @obr
        
        -- Insert HL7 into MessageLog table for transmission to CPRS (via Client Monitor Service)
        EXEC spHL7InsertMessageLog
                1, 
                @messageControlId,
                @messageType,
                @currentUtcTime,
                @vbecsApplicationId,
                @interfaceApplicationId,
                @messageStream,
                1,
                NULL,
                'System',
                -1,
                @currentUtcTime

END

GO
SET QUOTED_IDENTIFIER OFF
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Sets the OrderAcceptanceDate
**
**        Author:        Krzysztof Dobranowski
**
**        Date:         11/9/2009
**        
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        11/9/2009        Krzysztof Dobranowski        Initial creation (CR 2368)
**        08/15/11        M. Smith        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE TRIGGER dbo.trSetOrderAcceptanceDateForOrderedComponent
ON dbo.OrderedComponent
FOR UPDATE 
AS 
        DECLARE @statusbeforeupdate CHAR
        DECLARE @statusafterupdate CHAR
        DECLARE @orderedcomponentguid UNIQUEIDENTIFIER

        SELECT @statusbeforeupdate = OrderStatusCode FROM DELETED
        SELECT @statusafterupdate = OrderStatusCode FROM INSERTED

IF (@statusbeforeupdate = 'P' AND @statusafterupdate = 'A')
BEGIN
        SELECT @orderedcomponentguid = OrderedComponentGuid FROM INSERTED

        UPDATE
                OrderedComponent
        SET
                OrderAcceptanceDate = GETUTCDATE()
        WHERE
                OrderedComponentGuid = @orderedcomponentguid

END





GO
SET QUOTED_IDENTIFIER OFF
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Creates HL7 Component Order Update Message (CR 2368)
**
**        Author:        David Askew
**
**        Date:         11/2/2009
**        
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        08/15/11        M. Smith        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE TRIGGER dbo.trCreateExpiredOrderedTestMessage 

ON dbo.OrderedTest 

FOR UPDATE 

AS 

IF EXISTS (SELECT OrderedTestGuid FROM Inserted WHERE OrderStatusCode = 'X' AND TaskStatusCode = 'E') 

BEGIN        

        DECLARE @messageStream                 VARCHAR(3500)
        
        DECLARE @carriageReturn                 VARCHAR(5)        
        DECLARE @currentTime                DATETIME
        DECLARE @currentUtcTime                DATETIME
        DECLARE @hl7CurrentTime                VARCHAR(100)
        
        DECLARE @msh                         VARCHAR(875)
        DECLARE @pid                         VARCHAR(875)
        DECLARE @orc                         VARCHAR(875)
        DECLARE @obr                         VARCHAR(875)
        
        DECLARE @fieldSeparator                 CHAR(1)                -- Interface
        DECLARE @encodingCharacters                CHAR(4)                -- Interface
        DECLARE @interfaceApplicationId        VARCHAR(50)                -- Interface
        DECLARE @vbecsApplicationId                VARCHAR(50)                -- Interface
        DECLARE @versionId                        VARCHAR(8)                -- Interface
        DECLARE @interfaceFacilityId                VARCHAR(20)                -- InterfaceControl
        DECLARE @processingId                CHAR(1)                -- InterfaceControl
        DECLARE @vbecsFacilityId                VARCHAR(20)                -- InterfaceControl
        
        DECLARE @componentSeparator        CHAR(1)
        DECLARE @messageControlId                VARCHAR(50)
        DECLARE @messageType                VARCHAR(13)
        DECLARE @orderControlCode                CHAR(2)         
        DECLARE @namespaceId                VARCHAR(5)
        DECLARE @orderStatus                        CHAR(2)
        DECLARE @orderComments                VARCHAR(255)
        
        DECLARE @patientLastName                VARCHAR(30)
        DECLARE @patientFirstName                 VARCHAR(30)
        DECLARE @patientMiddleName                VARCHAR(30)
        DECLARE @patientSexCode                CHAR(1)
        DECLARE @patientDob                        VARCHAR(100)
        DECLARE @vistaPatientId                 VARCHAR(50)
        
        DECLARE @cprsOrderNumber                VARCHAR(20)
        DECLARE @vbecsOrderNumber                VARCHAR(25)
        DECLARE @orderGroupNumber                VARCHAR(30)
        DECLARE @orderStatusCode                CHAR(1)
        DECLARE @orderSpecialInstructions        VARCHAR(510)
        DECLARE @labOrderNumber                VARCHAR(20)
        DECLARE @labTestId                        CHAR(15)
        DECLARE @cprsOrderableItemID        CHAR(2)
        DECLARE @orderableTestName                VARCHAR(35)
        
        -- Get interface data for message
        SELECT 
                @fieldSeparator                         = I.FieldSeparator,
                @encodingCharacters                 = I.EncodingCharacters,
                @interfaceApplicationId                 = I.InterfaceApplicationId,
                @vbecsApplicationId                 = I.VbecsApplicationId,
                @versionId                         = I.VersionId,
                @interfaceFacilityId                 = IC.InterfaceFacilityId,
                @processingId                         = IC.ProcessingId,
                @vbecsFacilityId                 = IC.VbecsFacilityId
        FROM
                dbo.Interface I
                JOIN dbo.InterfaceControl IC         ON I.InterfaceId = IC.InterfaceId
        WHERE
                I.InterfaceId = 1
        
        -- Get patient order data for message
        SELECT 
                @patientLastName                 = P.PatientLastName, 
                @patientFirstName                = P.PatientFirstName, 
                @patientMiddleName                = ISNULL(P.PatientMiddleName, ''), 
                @patientSexCode                = ISNULL(P.PatientSexCode, ''),
                @patientDob                        = ISNULL(SUBSTRING(dbo.fnDateTimeConversionToHL7DateTime(P.PatientDob),0, 9), ''),
                @vistaPatientId                        = CAST(P.VistaPatientId AS VARCHAR(50)), 
                @cprsOrderNumber                = OT.CprsOrderNumber,
                @vbecsOrderNumber                = CAST(OT.VbecsOrderNumber AS VARCHAR(25)), 
                @orderGroupNumber                = PO.OrderGroupNumber,
                @orderStatusCode                = OT.OrderStatusCode,
                @orderableTestName                = ORT.OrderableTestName,
                @labOrderNumber                = OT.LabOrderNumber,
                @labTestId                        = OT.LabTestId,
                @cprsOrderableItemID                = ORT.CprsOrderableItemID
        FROM 
                dbo.Patient P 
                JOIN dbo.PatientTreatment PT                 ON P.PatientGuid                 = PT.PatientGuid
                JOIN dbo.PatientOrder PO                 ON PT.PatientTreatmentGuid        = PO.PatientTreatmentGuid
                JOIN dbo.OrderedTest OT                 ON PO.PatientOrderGuid         = OT.PatientOrderGuid
                JOIN dbo.OrderableTest ORT                 ON OT.OrderableTestId                 = ORT.OrderableTestId
        WHERE 
                OT.OrderedTestGuid                 = (SELECT OrderedTestGuid FROM Inserted)
                AND OT.OrderStatusCode         = 'X'
                AND OT.TaskStatusCode         = 'E'
        
        -- Set the variables values
        SET @carriageReturn                 = CHAR(13)
        SET @componentSeparator         = SUBSTRING(@encodingCharacters, 1, 1)
        SET @currentUtcTime                = GETUTCDATE()
        -- Only used to calculate the time zone differential
        SET @currentTime                = GETDATE()                                                                                                                
        
        SET @hl7CurrentTime                 = REPLACE(REPLACE(REPLACE(CONVERT(VARCHAR(36), @currentUtcTime, 20), ' ',''),'-',''),':','')                                 -- yyyyMMddhhss
                                         + '-0' + CONVERT( VARCHAR(10), ABS(DATEPART(HOUR,@currentTime) - DATEPART(HOUR,@currentUtcTime))) + '00'        -- Get time zone in -0500 format, where 5 is hrs from UTC
        
        SET @messageControlId                = 'VBECS' + REPLACE(REPLACE(REPLACE(REPLACE(CONVERT( VARCHAR(36), @currentUtcTime, 21 ),'-',''),' ',''),':',''),'.','')        -- yyyyMMddhhssccc (c = milliseconds)
        
        SET @messageType                 = 'OMG^O19' 
        SET @namespaceId                = 'VBEC'
        SET @orderStatus                = 'ZE'
        SET @orderComments                = 'Expired by background job'
        
        -- ***************************************************************************************************************************************************************************************************************************************************************************** 
        --                         MSH SEGMENT        
        SET @msh = 
                'MSH' 
                + @fieldSeparator 
                + @encodingCharacters 
                + @fieldSeparator 
                + @vbecsApplicationId 
                + @fieldSeparator 
                + @vbecsFacilityId 
                + @fieldSeparator 
                + @interfaceApplicationId 
                + @fieldSeparator 
                + @interfaceFacilityId 
                + @fieldSeparator 
                + @hl7CurrentTime
                + @fieldSeparator 
                + @fieldSeparator 
                + @messageType
                + @fieldSeparator 
                + @messageControlId
                + @fieldSeparator 
                + @processingId 
                + @fieldSeparator 
                + @versionId 
                + @carriageReturn
        
        -- ***************************************************************************************************************************************************************************************************************************************************************************** 
        --                         PID SEGMENT        
        SET @pid = 
                'PID' 
                + @fieldSeparator 
                + @fieldSeparator 
                + @fieldSeparator 
                + @vistaPatientId
                + @fieldSeparator 
                + @fieldSeparator 
                + @patientLastName
                + @componentSeparator
                + @patientFirstName
                + @componentSeparator
                + @patientMiddleName
                + @fieldSeparator 
                + @fieldSeparator 
                + @patientDob
                + @fieldSeparator 
                + @patientSexCode
                + @carriageReturn
        
        -- ***************************************************************************************************************************************************************************************************************************************************************************** 
        --                         ORC SEGMENT        
        SET @orc = 
                'ORC'
                + @fieldSeparator
                + 'SC'                                 -- Always send a Status Change Order Control code
                + @fieldSeparator
                + @cprsOrderNumber
                + @componentSeparator
                + 'OR'
                + @fieldSeparator
                + @vbecsOrderNumber
                + @componentSeparator
                + @namespaceId
                + @fieldSeparator
                + @orderGroupNumber
                + @fieldSeparator
                + @orderStatus
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @componentSeparator
                + @orderComments
                + @carriageReturn
        
        -- ***************************************************************************************************************************************************************************************************************************************************************************** 
        --                         OBR SEGMENT        
        SET @obr = 
                'OBR'
                + @fieldSeparator
                + '1'                                -- Set ID
                + @fieldSeparator
                + @cprsOrderNumber
                + @componentSeparator
                + 'OR'
                + @fieldSeparator
                + @vbecsOrderNumber
                + @componentSeparator
                + @namespaceId
                + @fieldSeparator
                + @cprsOrderableItemID
                + @componentSeparator
                + @orderableTestName
                + @componentSeparator
                + '99VBC'
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @fieldSeparator
                + @labOrderNumber
                + ';;;'
                + @labTestId
                + @carriageReturn
        
        -- ***************************************************************************************************************************************************************************************************************************************************************************** 
        -- Create HL7 message
        SET @messageStream = @msh + @pid + @orc + @obr
        
        -- Insert HL7 into MessageLog table for transmission to CPRS (via Client Monitor Service)
        EXEC spHL7InsertMessageLog
                1, 
                @messageControlId,
                @messageType,
                @currentUtcTime,
                @vbecsApplicationId,
                @interfaceApplicationId,
                @messageStream,
                1,
                NULL,
                'System',
                -1,
                @currentUtcTime

END


GO
SET QUOTED_IDENTIFIER ON
GO
SET QUOTED_IDENTIFIER OFF
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Sets the OrderAcceptanceDate
**
**        Author:        Krzysztof Dobranowski
**
**        Date:         11/9/2009
**        
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        08/15/11        M. Smith        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE TRIGGER dbo.trSetOrderAcceptanceDateForOrderedTest
ON dbo.OrderedTest
FOR UPDATE 
AS 
        DECLARE @statusbeforeupdate CHAR
        DECLARE @statusafterupdate CHAR
        DECLARE @orderedtestguid UNIQUEIDENTIFIER

        SELECT @statusbeforeupdate = OrderStatusCode FROM DELETED
        SELECT @statusafterupdate = OrderStatusCode FROM INSERTED

IF (@statusbeforeupdate = 'P' AND @statusafterupdate = 'A')
BEGIN
        SELECT @orderedtestguid = OrderedTestGuid FROM INSERTED

        UPDATE
                OrderedTest
        SET
                OrderAcceptanceDate = GETUTCDATE()
        WHERE
                OrderedTestGuid = @orderedtestguid

END

GO

SET QUOTED_IDENTIFIER OFF 
GO
/******************************************************************************************************
**        Desc:         Trigger to update BloodUnitStatusCodeCurrent table. (CR 1174)
**
**        Author: Mike Smith
**
**        Date:         01/04/10
*******************************************************************************************************
**        Modified:
**        Date                Name                Description
**        --------        -------------        ------------------------------------------------------------
******************************************************************************************************/
CREATE TRIGGER dbo.trPatientTransfusionUnitStatusCode
         ON dbo.PatientTransfusion 
FOR INSERT, UPDATE 
AS

UPDATE BUS
   SET UnitStatusCode = dbo.fnUnitStatusCode (Inserted.BloodUnitGuid, 0),
        LastUpdateDate = Inserted.LastUpdateDate,
        LastUpdateUser = Inserted.LastUpdateUser,
        LastUpdateFunctionId = Inserted.LastUpdateFunctionId
 FROM dbo.BloodUnitStatusCodeCurrent BUS
        JOIN Inserted 
                ON BUS.BloodUnitGuid = Inserted.BloodUnitGuid
WHERE UnitStatusCode <> dbo.fnUnitStatusCode (Inserted.BloodUnitGuid, 0)

GO

/*****************************************************************************************
*        Stored procedure updates
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[batchspRunExpireComponentOrders]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[batchspRunExpireComponentOrders]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         R.E. BR_16.16 Author 3.2.4.5.2
**                Script that will determine all orders that will be expired.
**                This script will lock all the orders, call background job that marks Task Status Code of
**                 Component Order as 'E'-Expired and unlock records after the update is done.  
**
**        Author: Margaret Jablonski
**
**        Date:         07/21/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        TODO: Change PO.OrderReceivedDatetime to new column for order acceptance date in part 2
**        02/08/2005        Stas Antropov        Changed BACKGROUNDJOB user name to VBECS
**        04/19/2005        Dan McHugh        Removed cursor logic, consolidated with batchspExpireComponentOrders
**        04/21/2005        Stas Antropov        Removed debug print statements, added division code to locking
**        06/29/2005        Dan McHugh        Added OrderStatusCode, OrderedComponentComments to UPDATE of table OrderedComponent, added dbo prefix to objects
**        07/25/2005        NPaterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name, input/output from comment header, Added NOCOUNT OFF, Specified table owners, spaced out SQL,
**                                        Placed TRANSACTIONS in areas that do actual Inserts/Updates/Deletes and gave Transactions names to clarify
**        09/29/2005        D McHugh        CR1194 - Updated check for SpecimenRequiredIndicator to use COALESCE
**                                        Updated check on TaskStatusCode to include comparing against NULL
**                                        Reformatted WHERE clause for easier reading
**        12/06/2005        Lohse                Adding SessionGuid required parameter for spInsertLock
**        01/22/2006        M Smith                ** Reviewed for compliance with database standards and recommendations **
**        11/10/2009        K.Dobranowski        Fixed the inintial SELECT to take only Accepted orders, replaced OrderedReceivedDate with OrderAcceptanceDate, simplified  WHERE clause
**                                        in the first SELECT statement (CR 2368)
**        08/15/11        M. Smith        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.batchspRunExpireComponentOrders

AS

SET NOCOUNT ON

DECLARE 

        @orderedComponentGuid         UNIQUEIDENTIFIER,
        @divisionCode                         CHAR(5),
        @message                         VARCHAR(80),
        @formInstanceGuid                UNIQUEIDENTIFIER,
        @lastError                        INT,
        @expiredOrdersCount                INT,
        @currentOrderedComponentId         INT,
        @sessionguid                        UNIQUEIDENTIFIER

DECLARE @ExpiredOrders TABLE 
(        

        [Id]                         INT IDENTITY(1,1) NOT NULL PRIMARY KEY,
        OrderedComponentGuid         UNIQUEIDENTIFIER,
        DivisionCode                 CHAR(5) 

);


        SET @formInstanceGuid = NEWID()
        SET @sessionguid = NEWID()
                
        INSERT INTO @ExpiredOrders( OrderedComponentGuid, DivisionCode )

                SELECT 

                        OC.OrderedComponentGuid,
                        OC.DivisionCode

                FROM 

                        dbo.OrderedComponent OC

                        JOIN dbo.PatientOrder PO ON PO.PatientOrderGUID = OC.PatientOrderGUID

                        LEFT JOIN dbo.PatientSpecimen PS ON PS.PatientSpecimenGUID = OC.PatientSpecimenGUID

                WHERE 

                        OC.OrderStatusCode = 'A' AND
                        (OC.TaskStatusCode != 'E' OR OC.TaskStatusCode IS NULL) AND

                        (

                        /*If there is no specimen the expiration date is 10 days from AcceptanceDate*/
                        (PS.SpecimenExpirationDate IS NULL AND
                        GETUTCDATE() > DATEADD(DAY, 10, OC.OrderAcceptanceDate))

                        OR

                        /*If specimen exists the expiration date of the order is the same as expiration date of associated specimen*/
                        (PS.SpecimenExpirationDate IS NOT NULL AND
                        PS.SpecimenExpirationDate < GETUTCDATE())

                        )        
        
        SELECT @expiredOrdersCount = @@ROWCOUNT, @lastError = @@ERROR 

        IF @lastError <> 0 

                BEGIN 
        
                        RETURN @lastError 
        
                END

        SET @currentOrderedComponentId = 1
        
/*=========================================================> B E G I N  L O O P  <=====================================================*/
        WHILE @currentOrderedComponentId <= @expiredOrdersCount

        BEGIN

                
        
                        
                                SELECT        @orderedComponentGuid = OrderedComponentGuid,
                                                @divisionCode = DivisionCode
                
                                FROM        @ExpiredOrders
                
                                WHERE        [Id] = @currentOrderedComponentId

                
        BEGIN TRANSACTION Comp



                                EXECUTE @lastError =  dbo.spInsertLock @orderedComponentGuid, @formInstanceGuid, 998, 'VBECS', 998, @divisionCode, @sessionguid

                                SELECT @lastError = COALESCE(NULLIF(@lastError, 0), @@ERROR)
                        
                                IF @lastError <> 0 
                        
                                        BEGIN 
                        
                                                ROLLBACK TRANSACTION Comp
                                                RETURN @lastError 
                        
                                        END
        /*        =============================  THE LOCK HAS BEEN PLACED NOW DO THE UPDATE ==========================================================*/
        
                                
        
                                UPDATE 
                        
                                        dbo.OrderedComponent
                        
                                SET 
                                        OrderStatusCode = 'X',
                                        OrderedComponentComments = 'Canceled by background job',
                                        TaskStatusCode = 'E',
                                        LastUpdateDate = GETUTCDATE(),
                                        LastUpdateUser = 'VBECS'        
                        
                                FROM 
                        
                                        dbo.OrderedComponent
                        
                                        JOIN
                                                @ExpiredOrders ExpOrders ON ExpOrders.OrderedComponentGuid = dbo.OrderedComponent.OrderedComponentGuid
                                
                                        JOIN
                                
                                                dbo.VbecsLock ON dbo.VbecsLock.RecordGuid = dbo.OrderedComponent.OrderedComponentGuid 
                                
                                                          AND FormInstanceGuid = @formInstanceGuid
                        
                                WHERE ExpOrders.OrderedComponentGuid = @orderedComponentGuid AND FormInstanceGuid=@formInstanceGuid
                        
                                SET @lastError = @@ERROR
                        
                                IF @lastError <> 0 
                        
                                        BEGIN 
                        
                                                ROLLBACK TRANSACTION Comp
                                                RETURN @lastError 
                        
                                        END
                
        
        /*        ========================================= UPDATE COMPLETED =========================================================================*/
        
        /*        ========================================= RELEASE THE LOCK  =========================================================================*/
        
                                EXECUTE @lastError = dbo.spDeleteLock @orderedComponentGuid, @formInstanceGuid, -1, 'VBECS', NULL, @divisioncode, @sessionguid
                        
                                SELECT @lastError = COALESCE(NULLIF(@lastError, 0), @@ERROR)
                        
                                IF @lastError <> 0 
                        
                                        BEGIN 
                        
                                                ROLLBACK TRANSACTION Comp
                                                RETURN @lastError 
                        
                                        END
                                
                                ELSE
                
                        /* All of our actions have NOT resulted in an error - so commit the transaction:  */
                
                                        BEGIN
                        
                                                COMMIT TRANSACTION Comp
                        
                                        END
        /*        ========================================= LOCK RELEASE  COMPLETED ==================================================================*/
                                /* Increment @currentOrderedComponentId  by one until <= @expiredOrdersCount : */
                                SET @currentOrderedComponentId = @currentOrderedComponentId + 1;
        
        END


/*=========================================================> END  L O O P  <=====================================================*/

        

SET NOCOUNT OFF

RETURN(@lastError)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[batchspRunExpireTestOrders]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[batchspRunExpireTestOrders]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:  This sp is used to expire TAS orders, it is part of Expire Orders background job
**
**        Author: Krzysztof Dobranowski
**
**        Date:         11/10/2009
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        11/10/2009        K.Dobranowski        Initial creation (CR 2368)
**        08/15/2011        M. Smith        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.batchspRunExpireTestOrders

AS

SET NOCOUNT ON

DECLARE 

        @orderedTestGuid                 UNIQUEIDENTIFIER,
        @divisionCode                         CHAR(5),
        @message                         VARCHAR(80),
        @formInstanceGuid                UNIQUEIDENTIFIER,
        @lastError                        INT,
        @expiredOrdersCount                INT,
        @currentOrderedTestId                 INT,
        @sessionguid                        UNIQUEIDENTIFIER

DECLARE @ExpiredOrders TABLE 
(        

        [Id]                         INT IDENTITY(1,1) NOT NULL PRIMARY KEY,
        OrderedTestGuid         UNIQUEIDENTIFIER,
        DivisionCode                 CHAR(5) 

);


        SET @formInstanceGuid = NEWID()
        SET @sessionguid = NEWID()
                
        INSERT INTO @ExpiredOrders( OrderedTestGuid, DivisionCode )

                SELECT 

                        OT.OrderedTestGuid,
                        OT.DivisionCode

                FROM 

                        dbo.OrderedTest OT

                        JOIN dbo.PatientOrder PO ON PO.PatientOrderGUID = OT.PatientOrderGUID

                        LEFT JOIN dbo.PatientSpecimen PS ON PS.PatientSpecimenGUID = OT.PatientSpecimenGUID

                WHERE 

                        OT.OrderStatusCode = 'A' AND
                        (OT.TaskStatusCode != 'E' OR OT.TaskStatusCode IS NULL) AND
                        OT.OrderableTestId = 7 AND

                        (

                        /*If there is no specimen the expiration date is 10 days from AcceptanceDate*/
                        (PS.SpecimenExpirationDate IS NULL AND
                        GETUTCDATE() > DATEADD(DAY, 10, OT.OrderAcceptanceDate))

                        OR

                        /*If specimen exists the expiration date of the order is the same as expiration date of associated specimen*/
                        (PS.SpecimenExpirationDate IS NOT NULL AND
                        PS.SpecimenExpirationDate < GETUTCDATE())

                        )        
        
        SELECT @expiredOrdersCount = @@ROWCOUNT, @lastError = @@ERROR 

        IF @lastError <> 0 

                BEGIN 
        
                        RETURN @lastError 
        
                END

        SET @currentOrderedTestId = 1
        
/*=========================================================> B E G I N  L O O P  <=====================================================*/
        WHILE @currentOrderedTestId <= @expiredOrdersCount

        BEGIN

                
        
                        
                                SELECT        @orderedTestGuid = OrderedTestGuid,
                                                @divisionCode = DivisionCode
                
                                FROM        @ExpiredOrders
                
                                WHERE        [Id] = @currentOrderedTestId

                
        BEGIN TRANSACTION Comp



                                EXECUTE @lastError =  dbo.spInsertLock @orderedTestGuid, @formInstanceGuid, 998, 'VBECS', 998, @divisionCode, @sessionguid

                                SELECT @lastError = COALESCE(NULLIF(@lastError, 0), @@ERROR)
                        
                                IF @lastError <> 0 
                        
                                        BEGIN 
                        
                                                ROLLBACK TRANSACTION Comp
                                                RETURN @lastError 
                        
                                        END
        /*        =============================  THE LOCK HAS BEEN PLACED NOW DO THE UPDATE ==========================================================*/
        
                                
        
                                UPDATE 
                        
                                        dbo.OrderedTest
                        
                                SET 
                                        OrderStatusCode = 'X',
                                        OrderedTestComments = 'Canceled by background job',
                                        TaskStatusCode = 'E',
                                        LastUpdateDate = GETUTCDATE(),
                                        LastUpdateUser = 'VBECS'        
                        
                                FROM 
                        
                                        dbo.OrderedTest
                        
                                        JOIN
                                                @ExpiredOrders ExpOrders ON ExpOrders.OrderedTestGuid = dbo.OrderedTest.OrderedTestGuid
                                
                                        JOIN
                                
                                                dbo.VbecsLock ON dbo.VbecsLock.RecordGuid = dbo.OrderedTest.OrderedTestGuid 
                                
                                                          AND FormInstanceGuid = @formInstanceGuid
                        
                                WHERE ExpOrders.OrderedTestGuid = @orderedTestGuid AND FormInstanceGuid=@formInstanceGuid
                        
                                SET @lastError = @@ERROR
                        
                                IF @lastError <> 0 
                        
                                        BEGIN 
                        
                                                ROLLBACK TRANSACTION Comp
                                                RETURN @lastError 
                        
                                        END
                
        
        /*        ========================================= UPDATE COMPLETED =========================================================================*/
        
        /*        ========================================= RELEASE THE LOCK  =========================================================================*/
        
                                EXECUTE @lastError = dbo.spDeleteLock @orderedTestGuid, @formInstanceGuid, -1, 'VBECS', NULL, @divisioncode, @sessionguid
                        
                                SELECT @lastError = COALESCE(NULLIF(@lastError, 0), @@ERROR)
                        
                                IF @lastError <> 0 
                        
                                        BEGIN 
                        
                                                ROLLBACK TRANSACTION Comp
                                                RETURN @lastError 
                        
                                        END
                                
                                ELSE
                
                        /* All of our actions have NOT resulted in an error - so commit the transaction:  */
                
                                        BEGIN
                        
                                                COMMIT TRANSACTION Comp
                        
                                        END
        /*        ========================================= LOCK RELEASE  COMPLETED ==================================================================*/
                                /* Increment @currentOrderedTestId  by one until <= @expiredOrdersCount : */
                                SET @currentOrderedTestId = @currentOrderedTestId + 1;
        
        END


/*=========================================================> END  L O O P  <=====================================================*/

        

SET NOCOUNT OFF

RETURN(@lastError)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spBloodProductModificationPool]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spBloodProductModificationPool]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/*******************************************************************************************************************************************************************************
**        Desc:         Returns all possible target BloodProducts for pool and thaw/pool modifications
**
**        Author: Mike Smith        
**
**        Date:         8/4/10
**
*******************************************************************************************************************************************************************************
**        Modified:
**         Date                Name                Description
**        ------------------        ------------                ------------------------------------------------------------------------------------------------------------------------------
**        08/12/10        M. Smith        Initial version (CR 2678).
**        05/18/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spBloodProductModificationPool
(
        @pFromBloodProductGuidList            VARCHAR(1014),           --Allowing for 26 copies of (38-character guid + 1-char delimiter)
        @pProductModificationCode         CHAR(1),                -- The modification being done
        @pMethodSelect                 INTEGER = -1                -- 1 = opened, 0 = closed, -1 = either
)
        
AS
DECLARE @ERROR INT

SET @ERROR = 0

DECLARE @ProductModificationCode CHAR(1)        --From TT
DECLARE @MethodSelect INTEGER                        --From TT
DECLARE @AddTargetAttribute VARCHAR(20)                --From TT, must be empty, or formatted like '__ __ __ __ ...etc...'
DECLARE @FromBloodProductGuid UNIQUEIDENTIFIER        --From BP
DECLARE @FromProductTypeCode VARCHAR(4)                --From TT
DECLARE @FromProductCode VARCHAR(5)                --From BP
DECLARE @FromCoreCondition VARCHAR(3)                --From TT
DECLARE @FromProductAttributeForm VARCHAR(40)        --From BP
DECLARE @ToProductTypeCode VARCHAR(4)                --From TT
DECLARE @ToProductCode VARCHAR(5)                --Calculated from TT/BP
DECLARE @ToCoreCondition VARCHAR(3)                --From TT
DECLARE @ToProductAttributeForm VARCHAR(40)        --Calculated from TT/BP
DECLARE @ExpirationDateRule INT                        -- From TT

DECLARE @DoNotIncludeIrradiate         BIT,
         @DoNotIncludeLukoPoor         BIT,
        @IncludeOpen                        BIT,
        @HasExcludedAttribute                 BIT,
        @TargetLabelType                 VARCHAR(20)

DECLARE @BPTemp        TABLE(BloodProductGuid        UNIQUEIDENTIFIER)

Declare @BPMTemp TABLE (
        ProductModificationCode CHAR(1),        --From TT
        MethodSelect                 INTEGER,                        --From TT
        AddTargetAttribute         VARCHAR(20),                --From TT
        FromBloodProductGuid         UNIQUEIDENTIFIER,        --From BP
        FromProductTypeCode         VARCHAR(4),                --From TT
        FromProductCode         VARCHAR(5),                --From BP
        FromCoreCondition         VARCHAR(3),                --From BP
        FromProductAttributeForm VARCHAR(40),        --From BP
        ToBloodProductGuid         UNIQUEIDENTIFIER,        --From BP
        ToProductTypeCode         VARCHAR(4),                --From TT
        ToProductCode                 VARCHAR(5),                --From BP based on ToProductAttributeForm
        ToCoreCondition         VARCHAR(3),                --From TT
        ToProductAttributeForm         VARCHAR(40),        --Calculated from FromProductAttributeForm, ToCoreCondition, AddTargetAttribute
        ExpirationDateRule         INTEGER                --From TT
)

SET @HasExcludedAttribute = 0

INSERT INTO @BPTemp
SELECT Item FROM dbo.fnSplit(@pFromBloodProductGuidList, ',')

SELECT TOP 1 @TargetLabelType =
              (CASE WHEN ProductCodeIndicator = 1
                        THEN  'ISBT'
                        ELSE 'Codabar'
               END)
  FROM @BPTemp BPT
        JOIN BloodProduct BP
                ON BPT.BloodProductGuid = BP.BloodProductGuid

SELECT DISTINCT @ToProductTypeCode = ToProductTypeCode,
                @ToCoreCondition = CASE WHEN FromCoreCondition = 'Any'
                                        THEN 'Any'
                                        ELSE ToCoreCondition
                                   END
  FROM BloodProduct BP
        JOIN @BPTemp BPT
                ON BP.BloodProductGuid = BPT.BloodProductGuid
        JOIN PermittedProductModification
                ON OriginalProductTypeCode = FromProductTypeCode
 WHERE (LEFT(ProductAttributeForm, 3) = FromCoreCondition OR FromCoreCondition = 'Any')
   AND @pProductModificationCode = ProductModificationCode
   AND (@pMethodSelect = MethodSelect OR @pMethodSelect = -1)
   AND BP.RecordStatusCode IN ('A', 'L')


IF @@ROWCOUNT = 1
BEGIN

        IF EXISTS(SELECT 1
                FROM         dbo.BloodProduct BP
                        JOIN @BPTemp BPT
                                ON BP.BloodProductGuid = BPT.BloodProductGuid
                        LEFT JOIN PermittedProductModification TT 
                                ON BP.OriginalProductTypeCode = TT.FromProductTypeCode
                                AND (LEFT(BP.ProductAttributeForm, 3) = TT.FromCoreCondition OR TT.FromCoreCondition = 'Any')
                                AND TT.ProductModificationCode = @pProductModificationCode
                                AND (TT.MethodSelect = @pMethodSelect OR @pMethodSelect = -1)
                WHERE BP.RecordStatusCode IN ('A', 'L')
                        AND TT.FromProductTypeCode IS NULL)

        BEGIN
--                PRINT 'All products not included in pool'
                RETURN 0
        END
        ELSE
        BEGIN

                SELECT @IncludeOpen = MAX(CASE 
                                WHEN ProductAttributeForm LIKE '% B2%'
                                        THEN 1
                                ELSE 0
                           END),
                        @DoNotIncludeIrradiate = MAX(CASE 
                                WHEN ProductAttributeForm LIKE '% C2%'
                                        THEN 0
                                ELSE 1
                           END),
                        @DoNotIncludeLukoPoor = MAX(CASE 
                                WHEN ProductAttributeForm LIKE '% D_%'
                                        THEN 0
                                ELSE 1
                           END)
                    FROM BloodProduct BP
                JOIN @BPTemp BPT
                        ON BP.BloodProductGuid = BPT.BloodProductGuid
                JOIN PermittedProductModification
                        ON OriginalProductTypeCode = FromProductTypeCode
                 WHERE (LEFT(ProductAttributeForm, 3) = FromCoreCondition OR FromCoreCondition = 'Any')
                   AND @pProductModificationCode = ProductModificationCode
                   AND (@pMethodSelect = MethodSelect OR @pMethodSelect = -1)
                   AND BP.RecordStatusCode IN ('A', 'L')
        
                DECLARE BPCursor CURSOR FAST_FORWARD
                FOR SELECT         TT.ProductModificationCode,
                                TT.MethodSelect,
                                ISNULL(TT.AddTargetAttribute, '') AddTargetAttribute, 
                                BP.BloodProductGuid,
                                TT.FromProductTypeCode,
                                BP.ProductCode,
                                Left(BP.ProductAttributeForm, 3),
                                BP.ProductAttributeForm,
                                TT.ToProductTypeCode,
                                '', --still need more info before calculating ToProductCode
                                TT.ToCoreCondition,
                                ToCoreCondition + ISNULL(' ' + AddTargetAttribute, '') AS ToProductAttributeForm,
                                TT.ExpirationDateRule
        
                        FROM         dbo.BloodProduct BP
                                JOIN @BPTemp BPT
                                        ON BP.BloodProductGuid = BPT.BloodProductGuid
                                JOIN PermittedProductModification TT 
                                        ON BP.OriginalProductTypeCode = TT.FromProductTypeCode
        
                        WHERE         (LEFT(BP.ProductAttributeForm, 3) = TT.FromCoreCondition OR TT.FromCoreCondition = 'Any')
                                AND TT.ProductModificationCode = @pProductModificationCode
                                AND (TT.MethodSelect = @pMethodSelect OR @pMethodSelect = -1)
                                AND BP.RecordStatusCode IN ('A', 'L')
        
                OPEN BPCursor
                FETCH NEXT FROM BPCursor INTO @ProductModificationCode, @MethodSelect, @AddTargetAttribute, @FromBloodProductGuid, @FromProductTypeCode, @FromProductCode, 
                                                @FromCoreCondition, @FromProductAttributeForm, @ToProductTypeCode, @ToProductCode, @ToCoreCondition, 
                                                @ToProductAttributeForm, @ExpirationDateRule
                WHILE @@FETCH_STATUS = 0 AND @HasExcludedAttribute = 0
                BEGIN
        
                        IF EXISTS (SELECT * FROM ProductAttribute 
                                        JOIN dbo.fnSplit(@FromProductAttributeForm, ' ') 
                                                ON ProductAttributeId = Item
                                                  AND ModificationAllowedIndicator = 0)
                        BEGIN
                                SET @HasExcludedAttribute = 1
                        END
                        ELSE
                        BEGIN        
                                --Add B2 if any of the products are open
                                IF @IncludeOpen = 1 AND @ToProductAttributeForm NOT LIKE '% B2%'
                                BEGIN
                                        SET @ToProductAttributeForm = dbo.fnAddAttributeToProductAttributeForm('B2', @ToProductAttributeForm)
                                END
                
                                --Add C2 if all of the products are irradiated
                                IF @DoNotIncludeIrradiate = 0
                                BEGIN
                                        SET @ToProductAttributeForm = dbo.fnAddAttributeToProductAttributeForm('C2', @ToProductAttributeForm)
                                END
                        
                                --Add D_ if all of the products are luko reduced
                                IF @DoNotIncludeLukoPoor = 0
                                BEGIN
                                        SET @ToProductAttributeForm = dbo.fnAddAttributeToProductAttributeForm('D_', @ToProductAttributeForm)
                                END
                
                                IF NOT EXISTS (SELECT * FROM ProductAttribute 
                                                JOIN dbo.fnSplit(@FromProductAttributeForm, ' ') 
                                                        ON ProductAttributeId = Item
                                                          AND ModificationAllowedIndicator = 0)
                        
                                   AND NOT EXISTS (SELECT * FROM ProductAttribute 
                                                JOIN dbo.fnSplit(@ToProductAttributeForm, ' ') 
                                                        ON ProductAttributeId = Item
                                                          AND ModificationAllowedIndicator = 0)
                                           
                                BEGIN
                        
                                        INSERT INTO @BPMTemp
                                                (ProductModificationCode, MethodSelect, AddTargetAttribute, FromBloodProductGuid, FromProductTypeCode, FromProductCode, 
                                                FromCoreCondition, FromProductAttributeForm, ToProductTypeCode, ToProductCode, ToCoreCondition, ToProductAttributeForm, 
                                                ExpirationDateRule)
                                        VALUES  (@ProductModificationCode, @MethodSelect, @AddTargetAttribute, @FromBloodProductGuid, @FromProductTypeCode, @FromProductCode, 
                                                @FromCoreCondition, @FromProductAttributeForm, @ToProductTypeCode, @ToProductCode, @ToCoreCondition, @ToProductAttributeForm, 
                                                @ExpirationDateRule)
                                END
                        END                        

                        FETCH NEXT FROM BPCursor INTO @ProductModificationCode, @MethodSelect, @AddTargetAttribute, @FromBloodProductGuid, @FromProductTypeCode, 
                                                @FromProductCode, @FromCoreCondition, @FromProductAttributeForm, @ToProductTypeCode, @ToProductCode, @ToCoreCondition, 
                                                @ToProductAttributeForm, @ExpirationDateRule
                END
                
                CLOSE BPCursor
                DEALLOCATE BPCursor

                IF (SELECT COUNT(1) FROM @BPMTemp) = 0
                BEGIN
--                        PRINT 'No match'
                        RETURN 0
                END

                IF @HasExcludedAttribute = 1
                BEGIN
--                        PRINT 'All products not included in pool'
                        RETURN 0
                END        
        
                UPDATE @BPMTemp
                SET ToProductCode = BP.ProductCode,
                        ToBloodProductGuid = BP.BloodProductGuid
                FROM @BPMTemp TT JOIN dbo.BloodProduct BP
                ON        TT.ToProductTypeCode = BP.OriginalProductTypeCode
                WHERE dbo.fnCompareProductAttributeForms(TT.ToProductAttributeForm, BP.ProductAttributeForm) = 1 
                  AND        ((@TargetLabelType = 'ISBT' AND ProductCodeIndicator = 1)
                   OR        (@TargetLabelType = 'Codabar' AND ProductCodeIndicator = 0))
        
                DELETE FROM @BPMTemp WHERE ToProductCode = ''
        
                --Insert any other matches
                INSERT INTO @BPMTemp
                SELECT TT.ProductModificationCode, TT.MethodSelect, TT.AddTargetAttribute, 
                        TT.FromBloodProductGuid, TT.FromProductTypeCode, TT.FromProductCode, TT.FromCoreCondition, TT.FromProductAttributeForm,
                        BP.BloodProductGuid, TT.ToProductTypeCode, BP.ProductCode, TT.ToCoreCondition, TT.ToProductAttributeForm,
                        TT.ExpirationDateRule
                FROM @BPMTemp TT JOIN dbo.BloodProduct BP
                ON        TT.ToProductTypeCode = BP.ProductTypeCode
                WHERE         dbo.fnCompareProductAttributeForms(TT.ToProductAttributeForm, BP.ProductAttributeForm) = 1 AND
                                TT.ToProductCode <> BP.ProductCode 
                  AND        ((@TargetLabelType = 'ISBT' AND ProductCodeIndicator = 1)
                   OR        (@TargetLabelType = 'Codabar' AND ProductCodeIndicator = 0))
        
                SELECT ProductModificationCode, MethodSelect, AddTargetAttribute, FromBloodProductGuid, FromProductTypeCode, FromProductCode, FromCoreCondition, 
                        FromProductAttributeForm, ToBloodProductGuid, ToProductTypeCode, ToProductCode, ToCoreCondition, ToProductAttributeForm, ExpirationDateRule
                 FROM @BPMTemp
        END

END
ELSE
BEGIN
--        PRINT 'Can not pool: there are multiple ToProductTypeCodes or ToCoreConditions'
        RETURN 0
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetBloodUnitAndPatientData]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetBloodUnitAndPatientData]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF
GO
/*******************************************************************************************************************************************************************************
**        Desc:                Retrieves blood unit and patient data to be sent to the BCE COTS system (CR 2941)
**
**        Use Case(s):        109, MUC_04
**
**        Author(s):        David Askew, Mike Smith
**
**        Date:                 3/17/2011
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ----------------------------------------------------------------------------------------------------------------------------------------------------------
**        03/21/11        K. Dobranowski        Added IF clause for units that have not yet been assigned; added IF clause for [now] optional
**                                        blood unit guid. (CR 2941)
**        04/05/11        K. Dobranowski        Added JOIN statements to the first IF condition to get the ComponentClassId and ComponentClassName 
**                                        for BloodUnit. (CR 2941)
**        04/13/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/02/11        D. Askew        Added @orderedcomponentguid parameter; updated to split the patient and blood data into 3 recordsets: 
**                                        patient, unit and other.  The 'other' data requires OrderedComponent (for all message types) and 
**                                        OrderedUnit information (if available, to return crossmatch results, if any exist). (CR 3015)
**                                        Removed Unit Status check (CR 3032)
**        07/26/11        D. Askew        Added dbo.fnTimeZoneConversionDateTime to UnitExpirationDate. (CR 3084)
**        08/15/11        M. Smith        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetBloodUnitAndPatientData
(
        @patientguid                        UNIQUEIDENTIFIER,
        @bloodunitguid                        UNIQUEIDENTIFIER,
        @orderedcomponentguid         UNIQUEIDENTIFIER
)

AS
        
DECLARE        @ERROR                 INT,
                @TestResultText        VARCHAR(55),
                @PatientAbo                CHAR(2),
                @PatientRh                CHAR(1),
                @OrderedUnitGuid         UNIQUEIDENTIFIER

SET @ERROR = 0

SET NOCOUNT ON        
        
        SELECT 
                @PatientAbo = ISNULL(ABO, 'NR'), 
                @PatientRh = Rh
        FROM 
                dbo.fnGetABORhTable(@patientguid)
        WHERE 
                TestDate IS NOT NULL
                AND TestDivision IS NOT NULL
                AND PatientSpecimenGuid IS NOT NULL
        
        IF @PatientAbo IS NULL
        SET @PatientAbo = 'NR'
        
        IF @PatientRh IS NULL
        SET @PatientRh = 'U'
        
        SET @TestResultText = dbo.fnGetAntibodyScreenTestResults(@patientguid)

        SET @OrderedUnitGuid = 
        (
                SELECT 
                        OrderedUnitGuid 
                FROM 
                        OrderedUnit 
                WHERE 
                        BloodUnitGuid = @bloodunitguid 
                        AND OrderedComponentGuid = @orderedcomponentguid 
                        AND RecordStatusCode = 'A' 
                        AND ReleaseTechId is NULL
        )

        -- **********************************************************
        -- ******* Patient Information *******
        -- *******************************************************
                SELECT
                                P.PatientSsn,
                                P.VistaPatientId,
                                P.PatientIcn,
                                P.PatientLastName,
                                P.PatientFirstName,
                                P.PatientMiddleName,
                                P.PatientDob,
                                P.PatientSexCode,
                                @PatientAbo                                                               AS PatientAbo,
                                RHF.RhFactorText                                                           AS PatientRh,
                                @TestResultText                                                                 AS TestResultText
                FROM
                                dbo.Patient P

                                LEFT JOIN dbo.RhFactor RHF
                                                ON RHF.RhFactorCode = @PatientRh

                WHERE 
                                P.PatientGuid = @patientguid

        -- *******************************************************
        -- ******* Unit Information *******
        -- *******************************************************
                SELECT
                                BU.DivisionCode,
                                BU.EyeReadableUnitId,
                                CC.ComponentClassId,
                                CC.ComponentClassName,

                                CASE BU.LabelTypeCode
                                WHEN 'I' THEN 
                                                BU.UnitProductCode 
                                                + DT.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS 
                                                + BU.UnitDivisionId 
                                ELSE 
                                                BU.UnitProductCode
                                END                                                                                        AS UnitProductCode,

                               dbo.fnTimeZoneConversionDateTime(BU.DivisionCode, 0, BUM.UnitExpirationDate)         AS UnitExpirationDate, 
                                BT.BloodTypeCode + ' ' + RH.RhFactorText                                                AS UnitAboRh

                FROM
                                dbo.BloodUnit BU
                
                                JOIN dbo.BloodUnitMedia BUM
                                                ON BU.BloodUnitGuid = BUM.BloodUnitGuid
                
                                JOIN dbo.BloodType BT 
                                                ON BUM.BloodTypeCode = BT.BloodTypeCode
                                                
                                JOIN dbo.RhFactor RH 
                                                ON BUM.RhFactorCode = RH.RhFactorCode
                
                                JOIN dbo.DonationType DT 
                                                ON BU.DonationTypeId = DT.DonationTypeId

                                JOIN dbo.BloodProduct BP
                                                ON BP.BloodProductGuid = BU.BloodProductGuid

                                JOIN dbo.ProductType PRDTYP
                                                ON PRDTYP.ProductTypeCode = BP.ProductTypeCode
                                
                                JOIN dbo.ComponentClass CC
                                                ON CC.ComponentClassId = PRDTYP.ComponentClassId
                WHERE 
                                BU.BloodUnitGuid = @bloodunitguid

        -- ********************************************************
        -- ******* Other Information *******
        -- *******************************************************
                SELECT
                                PT.TreatingSpecialtyCode,
                                OC.RequiredUnitQuantity,
                                OC.CprsOrderNumber,
                                PO.OrderingProviderId,
                                PO.OrderingProviderLastName,
                                PO.OrderingProviderFirstName,
                                PO.OrderingProviderMiddleInitial,
                                CMR.CrossmatchResultText

                FROM
                                dbo.OrderedComponent OC
                
                                JOIN dbo.PatientOrder PO
                            ON OC.PatientOrderGuid = PO.PatientOrderGuid
                
                                JOIN dbo.PatientTreatment PT
                                         ON PO.PatientTreatmentGuid = PT.PatientTreatmentGuid 

                                LEFT JOIN dbo.CrossmatchResult CMR
                                        ON CMR.CrossmatchResultCode = (SELECT dbo.fnOrderedUnitCrossmatchResultCode(@orderedunitguid))

                WHERE 
                                OC.OrderedComponentGuid = @orderedcomponentguid

        -- ***********************************************************
        -- ******* Patient Transfusion Requirements *******
        -- *******************************************************
        SELECT DISTINCT
                        CAST(CR.ComponentRequirementAbbreviation AS CHAR(10)) COLLATE SQL_Latin1_General_CP1_CS_AS AS PatientTransfusionRequirement,
                        CR.BceSortColumn 
                FROM
                        dbo.PatientTransfusionRequirement PTR 
                
                        JOIN dbo.ComponentRequirement CR
                                ON PTR.ComponentRequirementId = CR.ComponentRequirementId
                WHERE
                        PTR.PatientGuid  = @patientguid
                        AND PTR.TransfusionRequirementCategoryCode = 'CR'
                        AND PTR.RecordStatusCode = 'A'
        
        UNION
        
                SELECT DISTINCT
                        CAST((AGTYP.AntigenTypeName + '=') AS CHAR(10)) COLLATE SQL_Latin1_General_CP1_CS_AS AS PatientTransfusionRequirement,
                        AGTYP.BceSortColumn
                FROM
                        dbo.PatientTransfusionRequirement PTR 
                
                        JOIN dbo.AntigenType AGTYP
                                ON PTR.AntigenTypeId = AGTYP.AntigenTypeId
                WHERE
                        PTR.PatientGuid  = @patientguid
                        AND PTR.TransfusionRequirementCategoryCode = 'AN'
                        AND PTR.RecordStatusCode = 'A'
        
        UNION
        
                SELECT DISTINCT
                        CAST((AGTYP.AntigenTypeName + '=') AS CHAR(10)) COLLATE SQL_Latin1_General_CP1_CS_AS AS PatientTransfusionRequirement,
                        AGTYP.BceSortColumn
                FROM
                        dbo.PatientTransfusionRequirement PTR 
                
                        JOIN dbo.AntibodyType ABTYP
                                ON PTR.AntibodyTypeId = ABTYP.AntibodyTypeId
        
                        JOIN dbo.AntibodyAntigen AA
                                ON ABTYP.AntibodyTypeId = AA.AntibodyTypeId
        
                        JOIN dbo.AntigenType AGTYP
                                ON AA.AntigenTypeId = AGTYP.AntigenTypeId

                        LEFT JOIN dbo.AntibodyParameter ABPRM
                                ON ABTYP.AntibodyTypeId = ABPRM.AntibodyTypeId
        
                WHERE
                        PTR.PatientGuid  = @patientguid
                        AND PTR.TransfusionRequirementCategoryCode = 'AS'
                        AND PTR.RecordStatusCode = 'A'
                        AND ( ABTYP.ClinicallySignificantIndicator = 1 OR ABPRM.HigherLevelOverrideIndicator = 1 )
        
        ORDER BY BceSortColumn
        

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO

SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetAdminReportBloodUnitsReceived]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetAdminReportBloodUnitsReceived]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:        This stored procedure is used for UC_107 Administrative Data Report.
**                For the selected date range and a division or all divisions, it returns all
**                blood units received during incoming shipment for each component class and its subdivisions.  
**
**        Author:        Margaret Jablonski        
**
**        Date:         10/21/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**         Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        07/12/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed Name/input/output from comment header, added SET NOCOUNT, formatted SQL
**                                        Changed date query from  >= @startdate <= @enddate  to BETWEEN
**        07/18/05        N. Paterson        Modified to use a new view
**        08/02/05        N. Paterson        Modified per mike smith to use modified view to rid sub queries.
**        09/27/05        D. Askew        Added AND condition to exclude modified-from units; these will be show in the modification section
**        12/19/05        G. Lohse        Changing UnitInDate to ShipmentDate -- ShipmentDate is the time of the invoice.
**        01/22/06        M. Smith        ** Reviewed for compliance with database standards and recommendations **
**        06/02/10        D. Askew        Cleaned up SQL; removed dead code; added AND ToBloodUnitGuid <> FromBloodUnitGuid to final 
**                                        AND condition in WHERE clause. (CR 2797)
**        07/19/10        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetAdminReportBloodUnitsReceived
(
        @startdate        DATETIME,
        @enddate        DATETIME,
        @divisioncode        VARCHAR(5),
        @ismultidivision         BIT
)
AS

/*        @ERROR VARIABLE  USED BECAUSE SET NOCOUNT OFF RESETS THE @@ERROR TO ZERO         */
DECLARE @ERROR INT

SET NOCOUNT ON

        --Since all the dates are saved in UTC, start and end data has to be adjusted first for correct comparison
        SET @startdate = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @startdate)

        SET @enddate = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @enddate)

        SELECT

                BU.DivisionCode,
                BU.BloodUnitGuid,
                BU.DonationTypeID,
                BU.UnitDivisionId,
                BU.LabelTypeCode,
                BU.EyeReadableUnitId,
                BU.DiscardedPlasmaVolume, 
                BU.ComponentClassID,
                BU.ComponentClassName, 
                BU.UnitProductCode,
                BU.ProductTypeCode,
                BU.ProductAttributeForm,
                BU.CMVNegative,
                BU.SCNegative

        FROM

                dbo.vw_GetAdminReportBase BU
        
                JOIN dbo.BloodUnitShipment BUS ON BU.BloodUnitGuid = BUS.BloodUnitGuid AND BUS.IncomingShipmentGuid IS NOT NULL AND BUS.RecordStatusCode = 'A'
        
                JOIN dbo.Shipment S ON BUS.IncomingShipmentGuid = S.ShipmentGuid

        WHERE

                S.ShipmentDate BETWEEN @startdate AND @enddate

                AND BU.DonationTypeID > 1 --2-20 only (max is 20)

                AND ( (@ismultidivision = 0 AND BU.DivisionCode = @divisioncode) OR @ismultidivision = 1 ) -- one division

                -- we exclude modified-from units
                AND BU.BloodUnitGuid NOT IN (SELECT FromBloodUnitGuid FROM dbo.BloodUnitModification WHERE FromBloodUnitGuid = BU.BloodUnitGuid AND ToBloodUnitGuid <> FromBloodUnitGuid)

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetAdminReportBloodUnitsShipped]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetAdminReportBloodUnitsShipped]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:        This stored procedure is used for UC_107 Administrative Data Report.
**                For the selected date range and a division or all divisions, it returns all
**                blood units in transfered blood unit status for each component class and its subdivisions.  
**
**        Author:        Margaret Jablonski        
**
**        Date:         10/21/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**         Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        04/12/05        D. Askew           Changed joins for BloodUnitShipment and Shipment
**        05/25/05        G. Lohse        PooledUnitsCount is now a function.
**        07/12/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed Name/input/output from comment header, added SET NOCOUNT, formatted SQL
**                                        Changed date filter from => <= to BETWEEN
**        07/18/05        N. Paterson        Modified to use a new view
**        08/02/05        N. Paterson        Modified per mike smith to use modified view to rid sub queries.
**        06/02/10        D. Askew        Cleaned up SQL; removed BU.UnitStatusCode = 'X' from WHERE clause. (CR 2797)
**        07/19/10        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetAdminReportBloodUnitsShipped
(
        @startdate        DATETIME,
        @enddate        DATETIME,
        @divisioncode        VARCHAR(5),
        @ismultidivision         BIT
)
AS

/*        @ERROR VARIABLE  USED BECAUSE SET NOCOUNT OFF RESETS THE @@ERROR TO ZERO         */
DECLARE @ERROR INT

SET NOCOUNT ON
        --Since all the dates are saved in UTC, start and end data has to be adjusted first for correct comparison
        SET @startdate = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @startdate)

        SET @enddate = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @enddate)

        SELECT

                BU.DivisionCode,
                BU.BloodUnitGuid,
                BU.DonationTypeID,
                BU.UnitDivisionId,
                BU.LabelTypeCode,
                BU.EyeReadableUnitId,
                BU.DiscardedPlasmaVolume, 
                BU.ComponentClassID,
                BU.ComponentClassName, 
                BU.UnitProductCode,
                BU.ProductTypeCode,
                BU.ProductAttributeForm,

                dbo.fnGetPooledUnitsCount(BU.BloodUnitGuid) AS PooledUnitsCount,
                BU.CMVNegative,
                BU.SCNegative
        
        FROM
                        
                dbo.vw_GetAdminReportBase BU

                JOIN dbo.BloodUnitFinance BUF ON BUF.BloodUnitGuid = BU.BloodUnitGuid
        
                JOIN dbo.BloodUnitShipment BS ON BU.BloodUnitGuid = BS.BloodUnitGuid
        
                JOIN dbo.Shipment S ON BS.OutgoingShipmentGuid = S.ShipmentGuid AND BS.RecordStatusCode = 'A' AND S.ShipmentDate IS NOT NULL


        
        WHERE

                BU.DonationTypeID > 1 --2-20 only (max is 20)

                AND S.ShipmentDate BETWEEN @startdate AND @enddate

                AND ((@ismultidivision = 0 AND BU.DivisionCode = @divisioncode) 

                OR @ismultidivision = 1) -- one division
        
SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetAuditDivision]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetAuditDivision]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Get Division audit information
**
**        Author: Krzysztof Dobranowski
**
**        Date:   02/13/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        --------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        04/27/2004        M. Jablonski                Call fnTimeZoneConversionDateTime function on all dates
**        07/13/2005        N.Paterson        ** Reviewed for compliance with database standards and recommendations **
                                        Removed Name/input/output from comment header, added SET NOCOUNT, formatted SQL
                                        Changed date filter from => <= to using BETWEEN, placed input paramerters in brackets, error check input dates
**        08/18/2005        N.Paterson        Implemented differences between Review_Start and DEV before porting changes to DEV
**        10/24/2007        K. Dobranowski Changed all JOINS to LEFT JOINS (CR 2312)
**        10/25/2007        K. Dobranowski Added PrinterName to SELECT statement (CR 2320)
**        10/02/2009        K.Dobranowski Added ReactivityPhaseCode to SELECT statement (CR 2717)
**        08/18/2010        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/

CREATE PROCEDURE dbo.spGetAuditDivision
(
        @startdate         DATETIME,
        @enddate        DATETIME,
        @divisioncode        CHAR(5)
)
 AS

/*        @ERROR VARIABLE  USED BECAUSE SET NOCOUNT OFF RESETS THE @@ERROR TO ZERO         */
DECLARE @ERROR INT

SET NOCOUNT ON
--Since all the dates are saved in UTC, start and end data has to be adjusted first for correct comparison
SET @startdate = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @startdate)

SET @ERROR = @@ERROR
        IF @ERROR !=0 GOTO SPROC_EXIT

SET @enddate = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @enddate)

SET @ERROR = @@ERROR
        IF @ERROR !=0 GOTO SPROC_EXIT

        SELECT

                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.DivisionCode,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.DivisionName,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.ServiceTypeIndicator,
                dbo.Facility.FacilityName,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.RecordStatusCode,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.LabelPrinterUseIndicator,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.LabelPrinterTcpPortNumber,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.LabelPrinterIPAddress,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.LabelPrinterComPortNumber,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.AccessionAreaId,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.LockInactivityTimeoutMin,
                dbo.TimeZone.TimeZoneName,
                dbo.DaylightSavingsType.DaylightSavingsTypeText,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.ElectronicCrossmatchIndicator,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.IccbbaRegistrationNumber,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.MaximumSpecimenExpirationDays,
        
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.MedicalDirectorName,
        
        
        
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.LoginMessageText,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.InvoiceTemplateText,
                dbo.AntibodyScreenDisplay.AntibodyScreenDisplayText,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.MirrorId,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.LastUpdateDate) AS MirrorDate,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.LastUpdateUser,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.DaylightSavingsStartDate,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.DaylightSavingsEndDate,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.PrinterName,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.ReactivityPhaseCode

        FROM

                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision

        LEFT JOIN dbo.Facility ON dbo.Facility.FacilityGuid = VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.FacilityGuid

        LEFT JOIN dbo.TimeZone ON dbo.TimeZone.TimeZoneId = VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.TimeZoneId
        LEFT JOIN dbo.AntibodyScreenDisplay ON dbo.AntibodyScreenDisplay.AntibodyScreenDisplayCode = VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.AntibodyScreenDisplayCode
        LEFT JOIN dbo.DaylightSavingsType ON dbo.DaylightSavingsType.DaylightSavingsTypeId = VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.DaylightSavingsTypeId
        
        WHERE

                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.MirrorDate BETWEEN @startdate  AND  @enddate

        AND

                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.DivisionCode = @divisioncode
        
        ORDER BY

                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.DivisionCode,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.Source,
                VBECS_V1_PROD_MIRROR.dbo.V_VamcDivision.MirrorId DESC

SET @ERROR = @@ERROR


SPROC_EXIT:

        SET NOCOUNT OFF
        RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetAuditInterfaceControl]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetAuditInterfaceControl]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Get Interface Control audit information
**
**        Author: Krzysztof Dobranowski
**
**        Date:   03/18/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        --------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        04/27/2004        M. Jablonski                Call fnTimeZoneConversionDateTime function on all dates
**        07/13/2005        N.Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed Name/input/output from comment header, added SET NOCOUNT, formatted SQL
**                                        Changed date filter from => <= to using BETWEEN, placed input paramerters in brackets, error check input dates
**        08/18/2005        N.Paterson        Implemented differences between Review_Start and DEV before porting changes to DEV
**        07/17/2007        K. Dobranowski  Fixed names of two columns InterfaceFacilityId and VbecsFacilityId (was InterfaceFacilityID and VbecsFacilityID) CR 1979
**        07/17/2007        K. Dobranowski        Added InterfaceDomainName to SELECT statement CR 2267
**        11/14/2008        M. Smith        Changed to get the InterfaceName from the new Interface reference table.  CR 2516
**        12/17/2008        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        03/16/2010        K. Dobranowski        Added InterfaceActiveIndicator (CR 2940)
**        04/04/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/

CREATE PROCEDURE dbo.spGetAuditInterfaceControl
(
        @startdate         DATETIME,
        @enddate        DATETIME,
        @divisioncode        CHAR(5)
)
 AS

/*        @ERROR VARIABLE  USED BECAUSE SET NOCOUNT OFF RESETS THE @@ERROR TO ZERO         */
DECLARE @ERROR INT

SET NOCOUNT ON
--Since all the dates are saved in UTC, start and end data has to be adjusted first for correct comparison
SET @startdate = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @startdate)

SET @ERROR = @@ERROR
        IF @ERROR !=0 GOTO SPROC_EXIT

SET @enddate = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @enddate)

SET @ERROR = @@ERROR
        IF @ERROR !=0 GOTO SPROC_EXIT


        SELECT

                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.InterfaceControlID,
                I.InterfaceName,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.InterfaceIPAddress,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.InterfacePortNumber,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.InterfaceDomainName,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.InterfaceFacilityId,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.VbecsIPAddress,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.VbecsPortNumber,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.VbecsFacilityId,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.PurgeSuccessfulMessage,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.PurgeUnSuccessfulMessage,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.LogEventsIndicator,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.AckTimeout,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.ReTransmitAttempts,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.InterfaceAdministratorName,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.InterfaceActiveIndicator,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.MirrorId,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.LastUpdateDate) AS MirrorDate,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.LastUpdateUser
        
        FROM
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl
                        JOIN dbo.Interface I 
                                ON VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.InterfaceId = I.InterfaceId
        WHERE

                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.MirrorDate BETWEEN @startdate  AND  @enddate
                
        ORDER BY
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.InterfaceControlID,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.Source,
                VBECS_V1_PROD_MIRROR.dbo.V_InterfaceControl.MirrorId DESC

SET @ERROR = @@ERROR



SPROC_EXIT:

        SET NOCOUNT OFF
        RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetBloodUnitAndPatientGuids]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetBloodUnitAndPatientGuids]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:                Retrieves blood unit and patient guids and the unit's status code to be used for sending updates to the BCE COTS 
**                        system.  This stored procedure will only be called once, when the BCE COTS interface is initially activated (CR 2940).
**
**        Use Case(s):        109, MUC_04
**
**        Author:                Krzysztof Dobranowski
**
**        Date:                 3/16/2011
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        04/04/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/02/11        D. Askew        Added OrderedComponentGuid and IssueToLocationName. (CR 3015)
**        08/15/11        M. Smith        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetBloodUnitAndPatientGuids

AS
        
DECLARE @ERROR INT

SET @ERROR = 0

SET NOCOUNT ON        
        
        SELECT DISTINCT  
                BU.BloodUnitGuid, 
                PT.PatientGuid, 
                OC.OrderedComponentGuid,
                IU.IssueToLocationName,
                UnitStatusCode
        
        FROM 
                dbo.BloodUnit BU
                
                JOIN dbo.OrderedUnit OU 
                        ON BU.BloodUnitGuid = OU.BloodUnitGuid
                
                JOIN dbo.OrderedComponent OC         
                        ON OU.OrderedComponentGuid = OC.OrderedComponentGuid
                
                JOIN dbo.PatientOrder PO 
                        ON OC.PatientOrderGuid = PO.PatientOrderGuid
                
                JOIN dbo.PatientTreatment PT 
                        ON PO.PatientTreatmentGuid = PT.PatientTreatmentGuid
        
                JOIN dbo.BloodUnitStatusCodeCurrent BUSCC
                        ON BU.BloodUnitGuid = BUSCC.BloodUnitGuid
        
                LEFT JOIN dbo.IssuedUnit IU
                        ON BU.BloodUnitGuid = IU.BloodUnitGuid
        
        WHERE 
                UnitStatusCode IN ('I', 'C', 'S')


SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetBloodUnitIdAndProductCodeForBloodUnitGuid]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetBloodUnitIdAndProductCodeForBloodUnitGuid]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Returns blood unit ID and Product for a blood unit guid (CR 2959)
**
**        Author:        David Askew
**
**        Date:         3/16/2011
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        4/08/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetBloodUnitIdAndProductCodeForBloodUnitGuid
(
        @bloodunitguid        UNIQUEIDENTIFIER
)

AS
        
DECLARE @ERROR INT

SET @ERROR = 0

SET NOCOUNT ON

        SELECT DISTINCT

                BU.EyeReadableUnitId,
                CASE BU.LabelTypeCode
                        WHEN 'I' THEN 
                                BU.UnitProductCode + DT.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS + BU.UnitDivisionId 
                        ELSE 
                                BU.UnitProductCode
                        END                                                                                                                                 AS UnitProductCode

        FROM
                dbo.BloodUnit BU
                
                LEFT OUTER JOIN dbo.DonationType DT 
                        ON BU.DonationTypeId = DT.DonationTypeId

        WHERE         
                BU.BloodUnitGuid = @bloodunitguid

        SET @ERROR = @@ERROR


SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetComponentTaskList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetComponentTaskList]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**
**        Desc:         Get the list of pending component tasks
**
**        Author:         Krzysztof Dobranowski
**
**        Date:         04/23/2003
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------                ---------                        -----------------
**        04/23/2003        Krzysztof Dobranowski        Initial creation.
**        06/27/2003        C. Jensen                Added more fields for UC03
**        01/13/2004        C Taylor                        Added DisplayVistaPatientId
**        02/25/04        C. Taylor                Removed ExtendedExpirationDate - no longer needed (use mirror tables to see original 
**                                                expiration date)
**        03/02/2004        M.Jablonski                Added row version to SELECT
**        04/23/2004        M. Jablonski                Call fnTimeZoneConversionDateTime function on all dates
**        04/23/2004        C.Taylor                        Added TaskStatus of 'R' to WHERE clause
**        05/05/2004        C. Taylor                Replaced SpecimenAccessionNumber with Specimenuid
**        06/08/2004        C. Taylor                Replaced PatientGuid join with function fnGetPatientGuid to ensure latest patient details returned
**        07/01/2004        C. Jensen                Added SpecimenAccessionNumber and LabTestId
**        09/21/2004        C. Jensen                Added PatientSpecimenGuid
**        01/06/2004        C. Taylor                Added OrderGroupNumber
**        01/18/2005        C. Jensen                Added TreatingSpecialtyName
**        04/11/2005        Lohse                        Removed InappropriateLabTestIndicator -- field dropped
**        07/17/2005         D. Askew                ** Reviewed for compliance with database standards and recommendations **
**                                                NO COUNT set ON/OFF; comments updated; changed formatting slightly for readability
**        08/19/2005        N.Paterson                Implemented differences between Review_Start and DEV before porting changes to DEV 
**                                                see commented lines
**                                                Added PatientTreatment.PatientTreatmentGuid and PatientOrder.OrderingProviderMiddleInitial
**        09/09/2005        D. Askew                Changed JOIN on Patient to select either the FinalMergeToPatient if the patient has one or more
**                                                merges (choosing the final merge record) or simply the patient guid if there are none;
**                                                removed commented-out code
**        09/29/2005        K. Dobranowski                Changed the expiration date to be 10 days not 3 days from Order Received date per CR 1164
**        11/10/2009        K. Dobranowski                Removed check for expiration date from WHERE clause (CR 2368)
**        08/15/2011        M. Smith                ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetComponentTaskList
(
        @divisioncode        VARCHAR(5),
        @ordergroupnumber VARCHAR(20) = NULL
)

AS

SET NOCOUNT ON

        SELECT
                OrderUrgency.OrderUrgencyText,
                OrderedComponent.OrderUrgencyCode,
                OrderedComponent.OrderedComponentGUID,
                OrderedComponent.OrderedComponentComments,
                OrderedComponent.SpecimenAccessionNumber,
                OrderedComponent.SpecimenWorkloadUid,
                OrderedComponent.SpecimenRequiredIndicator,
                OrderedComponent.LabTestId,
                OrderedComponent.PatientSpecimenGuid,
                OrderedComponent.InappropriateRequestIndicator,
                OrderedComponent.[RowVersion],
                PatientTreatment.PatientGUID,
                Patient.PatientFirstName,
                Patient.PatientLastName,
                Patient.PatientMiddleName,
                Patient.VistaPatientID,
                Patient.PatientSSN,
                Patient.DisplayVistaPatientId,
                PatientTreatment.PatientLocation,
                Patient.BloodTypeCode,
                Patient.RhFactorCode,
                PatientTreatment.PatientTreatingFacility,
                PatientTreatment.PatientAdmittingDiagnosis,
                PatientTreatment.PatientTreatmentGuid,
                Patient.PatientServiceBranch,
                PatientOrder.PatientOrderGUID,
                PatientOrder.OrderingProviderFirstName,
                PatientOrder.OrderingProviderLastName,
                PatientOrder.OrderingProviderMiddleInitial,
                PatientOrder.OrderEnteredByFirstName,
                PatientOrder.OrderEnteredByLastName,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PatientOrder.OrderReceivedDateTime) AS OrderReceivedDateTime,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PatientOrder.OrderPlacedDateTime) AS OrderPlacedDateTime,
                PatientOrder.SurgeryName,
                PatientOrder.RequestReason,
                PatientOrder.OrderComments,
                PatientOrder.OrderingHospitalLocation,
                PatientOrder.InformedConsentIndicator,
                PatientSpecimen.PatientSpecimenGUID,
                PatientSpecimen.Specimenuid,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PatientSpecimen.SpecimenExpirationDate) AS SpecimenExpirationDate,
                ComponentClass.ComponentClassID,
                ComponentClass.ComponentClassShortName,
                ComponentClass.ComponentClassName,
                OrderedComponent.RequiredUnitQuantity,
                OrderedComponent.OrderedComponentComments,
                OrderedComponent.OrderSpecialInstructions,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, OrderedComponent.RequiredDateTime) AS RequiredDateTime,
                OrderedComponent.CprsOrderNumber,
                OrderedComponent.VbecsOrderNumber,
                OrderedComponent.DivisionCode,
                TaskStatus.TaskStatusText,
                OrderedComponent.TaskStatusCode,
                OrderUrgency.SortColumn,
                PatientOrder.OrderGroupNumber,
                TreatingSpecialty.TreatingSpecialtyName
        
        FROM OrderedComponent
        
        JOIN PatientOrder ON PatientOrder.PatientOrderGUID = OrderedComponent.PatientOrderGUID
        LEFT JOIN OrderUrgency ON OrderUrgency.OrderUrgencyCode = OrderedComponent.OrderUrgencyCode
        LEFT JOIN PatientSpecimen ON PatientSpecimen.PatientSpecimenGUID = OrderedComponent.PatientSpecimenGUID
        LEFT JOIN PatientTreatment ON PatientTreatment.PatientTreatmentGUID = PatientOrder.PatientTreatmentGUID
        LEFT JOIN dbo.Patient ON PatientTreatment.PatientGuid = COALESCE(Patient.FinalMergeToPatient, Patient.PatientGuid)
        LEFT JOIN ComponentClass ON ComponentClass.ComponentClassID = OrderedComponent.ComponentClassID
        LEFT JOIN TaskStatus ON TaskStatus.TaskStatusCode = OrderedComponent.TaskStatusCode
        LEFT JOIN TreatingSpecialty ON PatientTreatment.TreatingSpecialtyCode = TreatingSpecialty.TreatingSpecialtyCode
        
        WHERE OrderedComponent.DivisionCode = @divisioncode
                AND (@ordergroupnumber IS NOT NULL OR OrderedComponent.OrderStatusCode = 'A')

                /*if searching for ordergroupnumber include orders that are expired*/
                AND (@ordergroupnumber IS NULL OR ((OrderedComponent.OrderStatusCode = 'A' OR (OrderedComponent.OrderStatusCode = 'X' AND OrderedComponent.TaskStatusCode = 'E')) 
                                                        AND PatientOrder.OrderGroupNumber = @ordergroupnumber))
        
        ORDER BY OrderUrgency.SortColumn,
                 Patient.PatientLastName

RETURN (@@ERROR)

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetCurrentPatientLocation]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetCurrentPatientLocation]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Returns the location data for a particular patient (CR 2960)
**
**        Author:        David Askew
**
**        Date:         3/16/2011
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        3/16/11        D. Askew        Room and Bed are now stored in one field (CR 2970)
**        4/04/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetCurrentPatientLocation
(
        @PatientGuid        UNIQUEIDENTIFIER
)

AS

DECLARE @ERROR        INT

SET NOCOUNT ON


IF EXISTS (SELECT 1 FROM dbo.PatientLocation WHERE PatientGuid = @PatientGuid)
        BEGIN
                SELECT
                        InPatientIndicator,
                        HPLC.LocationIen,
                        PL.LocationName,
                        LocationRoomBed,
                        CASE WHEN PL.DivisionCode IS NULL 
                                THEN HPLC_DIV.DivisionCode 
                                ELSE PL.DivisionCode 
                        END                                                 AS DivisionCode,
                        CASE WHEN PL.DivisionCode IS NULL 
                                THEN HPLC_DIV.DivisionName 
                                ELSE PL_DIV.DivisionName 
                        END                                                 AS DivisionName
        
                FROM        dbo.PatientLocation PL

                LEFT JOIN dbo.HospitalLocationCache HPLC
                        ON PL.LocationName = HPLC.LocationName

                LEFT JOIN dbo.VamcDivision HPLC_DIV
                        ON HPLC.LocationDivision = HPLC_DIV.DivisionCode

                LEFT JOIN dbo.VamcDivision PL_DIV
                        ON PL.DivisionCode = PL_DIV.DivisionCode
                
                WHERE
                        PatientGuid = @PatientGuid
        END
        ELSE
        BEGIN
                SELECT TOP 1
                        PT.InPatientIndicator,
                        HPLC.LocationIen,
                        PT.PatientLocation        AS LocationName,
                        PT.PatientRoomBed        AS LocationRoomBed,
                        PO.DivisionCode,
                        DIV.DivisionName
        
                FROM
                        dbo.PatientTreatment PT

                        JOIN dbo.PatientOrder PO
                                ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid

                        JOIN dbo.VamcDivision DIV
                                ON PO.DivisionCode = DIV.DivisionCode

                        LEFT  JOIN dbo.HospitalLocationCache HPLC
                                ON PT.PatientLocation = HPLC.LocationName
                
                WHERE
                        PatientGuid = @PatientGuid

                ORDER BY
                        PO.LastUpdateDate DESC
        END

        SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN (@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetDailyQCRacks]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetDailyQCRacks]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Get the list of racks for daily QC
**
**        Author:         Krzysztof Dobranowski
**
**        Date:         01/06/2003
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        ------------                ---------                        ------------------
**        01/06/2003        Krzysztof Dobranowski        Initial creation.
**        04/21/2004        M. Jablonski                Call fnTimeZoneConversionDateTime function on all dates
**        07/17/2005         D. Askew                ** Reviewed for compliance with database standards and recommendations **
**                                                NO COUNT set OFF; comments updated; capitalized SQL statements;
**                                                removed unused code                        
**        08/19/2005        N.Paterson        Specified object owners, aliased tables
**        11/04/2009        K.Dobranowski        Added QCOfflineIndicator (CR 2718)
**        08/18/2010        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetDailyQCRacks
(
        @divisioncode                        VARCHAR(5),
        @testdatetime                        DATETIME
)

AS

SET NOCOUNT ON

        SELECT
                R.RackGuid,
                R.RackName,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, DCW.DailyQcExpirationDate) AS DailyQcExpirationDate,
                DCW.DailyQcWorklistGuid,
                DCW.PartiallyTestedIndicator,
                DCW.DailyUseIndicator,
                DCW.QCOfflineIndicator,
                DCW.[RowVersion],
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, DCW.LastUpdateDate) AS LastUpdateDate,
                R.DivisionCode,
                R.LastUpdateUser,
                DC.DailyControlGuid,
                DC.RackNamesIndicator,
                DC.CommercialTemplateIndicator,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, DC.DailyAlertTime) AS DailyAlertTime

           FROM dbo.Rack R

        JOIN dbo.DailyControl DC ON R.DailyControlGUID = DC.DailyControlGuid

        LEFT JOIN dbo.DailyQcWorklist DCW ON DCW.RackGuid = R.RackGuid 
                AND ( ((DATEDIFF(SECOND, @testdatetime, dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, DCW.DailyQcExpirationDate)) <= 86400) 
                        AND (DATEDIFF(SECOND, @testdatetime, dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, DCW.DailyQcExpirationDate)) >= -0)) )
                AND DCW.RecordStatusCode = 'A'
        WHERE
                DC.DivisionCode = @divisioncode
        AND
                DC.RecordStatusCode = 'A'
        AND
                R.RecordStatusCode = 'A'
        
        ORDER BY R.SortColumn, DCW.DailyQcExpirationDate

RETURN (@@ERROR)

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetDivision]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetDivision]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**
**        Desc:         Selects records from the VamcDivision table based on the primary key.
**
**        Author:        Cameron Taylor
**
**        Date:         10/30/2002
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                        Name                Description
**        4/8/2003                LMeyer                Added ServiceTypeIndicator, AntibodyScreenDisplayCode, AutoAboRhIndicator,
**                                                MaximumSpecimenExpirationDays
**        1/14/2004                C. Jensen        Added fields from pertaining to DivisionAlerts.
**        3/4/2004                C. Taylor        Added MedicalDirectorName.
**        04/08/2004                Greg Lohse        Adding DivisionGUID field
**        04/15/2004                C. Jensne        Added FacilityGUID
**         06/25/2004                S. Antropov        Updatred list of columns
**        09/09/2004                S. Antropov        Added VamcDivision.AccessionAreaId
**        07/18/2005                 D. Askew        ** Reviewed for compliance with database standards and recommendations **
**                                                NO COUNT set OFF; comments updated; capitalized SQL statements; 
**                                                changed formatting slightly for readability
**        08/10/2005                J. Engstrom        Modified procedure to get DaylighSavingsStartDate and DayLightSavingsEndDate from VamcDivision 
**                                                table.  Removed Left Outer Join on DaylighSavings table.
**        10/18/2007                C. Jensen        Added PrinterName field to accomodate retrieval of reports printer (CR 2320).
**        10/01/2009                K. Dobranowski        Added ReactivityPhaseCode (CR 2717)
**        08/18/2010                K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetDivision
(
        @divisioncode        CHAR(5)
)

AS

SET NOCOUNT ON

        SELECT         VamcDivision.DivisionCode, 
                        DivisionGuid, 
                        DivisionName, 
                        ServiceTypeIndicator, 
                        VamcDivision.IccbbaRegistrationNumber, 
                        ElectronicCrossmatchIndicator, 
                        VamcDivision.FacilityGuid, 
                        VamcDivision.AccessionAreaId,
                        Facility.FacilityName,
                        VamcDivision.LocalSupplierGuid, 
                        AntibodyScreenDisplayCode, 
                        MaximumSpecimenExpirationDays, 
                        AutomatedInstrumentIndicator, 
                        LabelPrinterUseIndicator, 
                        LabelPrinterComPortNumber, 
                        LabelPrinterIPAddress, 
                        LabelPrinterTcpPortNumber,
                        PrinterName,
                        TimeZoneId, 
                        DaylightSavingsTypeId, 
                        DaylightSavingsStartDate, 
                        DaylightSavingsEndDate,
                        PrinterAlertsIndicator, 
                        PrinterAlertsPrinterName, 
                        PrinterOrderAlertTypeCode, 
                        PrinterOrdersNeededHours, 
                        IconAlertsIndicator, 
                        IconOrderAlertTypeCode, 
                        IconOrdersNeededHours, 
                        IconRefreshRate, 
                        LoginMessageText, 
                        InvoiceTemplateText, 
                        MedicalDirectorName, 
                        LockInactivityTimeoutMin, 
                        VamcDivision.RecordStatusCode,
                        VamcDivision.[RowVersion],
                        ReactivityPhaseCode
        FROM                 VamcDivision 
                LEFT OUTER JOIN Facility ON Facility.FacilityGuid = VamcDivision.FacilityGuid
        WHERE
                VamcDivision.DivisionCode = @divisionCode;        

RETURN @@ERROR

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetExceptionReportElectronicTransfusion]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetExceptionReportElectronicTransfusion]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:        Gets Exception Report data (CR 2942)
**
**        Author:        Krzysztof Dobranowski
**
**        Date:         03/10/2011
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        04/13/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetExceptionReportElectronicTransfusion
(
        @startdate                DATETIME,
        @enddate                DATETIME,
        @divisioncode                VARCHAR(5)
)
AS

SET NOCOUNT ON

DECLARE @ERROR INT

SET @ERROR = 0
        --Since all the dates are saved in UTC, start and end data has to be adjusted first for correct comparison
        SET @startdate = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @startdate)

        SET @ERROR = @@ERROR
                IF @ERROR != 0 GOTO ERR_HANDLER

        SET @enddate = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @enddate)

        SET @ERROR = @@ERROR
                IF @ERROR != 0 GOTO ERR_HANDLER

        SELECT
                ExceptionElectronicTransfusionGuid,
                PatientTransfusionGuid,
                ExceptionType.ExceptionTypeName,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, BedsideVerificationDate) AS BedsideVerificationDate,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, TransfusionStartDateTime) AS TransfusionStartDateTime,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, TransfusionEndDateTime) AS TransfusionEndDateTime,
                BedsideVerificationUnitManualEntryReason,
                InterruptionIndicator,
                ReactionIndicator,
                ReactionSymptoms,
                TransfusedVolume,
                Transfusionist1Id,
                Transfusionist2Id,
                TransfusionLocation,
                PatientName,
                PatientId,
                UnitId,
                UnitProductCode,
                PatientTransfusionComment,
                ExceptionUser,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, ExceptionDate) AS ExceptionDate
        FROM
                dbo.ExceptionElectronicTransfusion

                JOIN dbo.ExceptionType ON 

                        dbo.ExceptionType.ExceptionTypeId = dbo.ExceptionElectronicTransfusion.ExceptionTypeId
        WHERE
                DivisionCode = @divisioncode

        AND ExceptionDate BETWEEN @startdate AND @enddate

        ORDER BY ExceptionDate DESC

        SET @ERROR = @@ERROR
                IF @ERROR != 0 GOTO ERR_HANDLER

SET NOCOUNT OFF

        RETURN(0)

ERR_HANDLER:
        SET NOCOUNT OFF
        RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetInterfaceActiveIndicator]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetInterfaceActiveIndicator]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:                Retreives the InterfaceActiveIndicator for the supplied interface name (CR 2940)
**
**        Use Case(s):        109, MUC_04
**
**        Author:                Krzysztof Dobranowski
**
**        Date:                 3/16/2011
**
*********************************************************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        3/16/11        D. Askew        Added JOIN to new Interface table (CR 2968)
**        4/04/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations ** Added SET NOCOUNT ON and SET NOCOUNT OFF
**********************************************************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetInterfaceActiveIndicator
(
        @interfacename                VARCHAR(50)
)

AS

SET NOCOUNT ON

        SELECT 
                InterfaceActiveIndicator
        FROM
                dbo.InterfaceControl IC

                JOIN dbo.Interface I ON IC.InterfaceId = I.InterfaceId

        WHERE
                InterfaceName = @interfacename

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetIssuedAndTransfusedUnitsForPatient]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetIssuedAndTransfusedUnitsForPatient]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Find all units issued and transfused  to a given patient at the supplied division
**
**        Author:         Carl Jensen
**
**        Date:         3/29/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        --------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        04/21/04        M. Jablonski        Call fnTimeZoneConversionDateTime function on all dates
**        05/06/04        C. Jensen        Added IssueTechID
**        06/07/04        C. Taylor        Replaced PatientGuid clause with fnWherePatientGuid function, to include possible merged patients
**        12/03/04        C. Taylor        Added PresumedTransfusedIndicator
**        01/30/04        Lohse                Adding BloodUnitStatusGuid
**        01/31/05        D. Askew        Added RemoteStorageIndicator, MaximumTransfusionTime
**        06/17/05        Npaterson        Changed to use new view to increase performance
**        07/20/05        N.Paterson        ** Reviewed for compliance with database standards and recommendations **
                                        Removed Name/input/output from comment header, added SET NOCOUNT OFF, formatted SQL
**        09/09/05        D. Askew        Removed fnWherePatientGuid via sub-query using new PatientMergeGroup
**        01/03/06        C. Jensen        Added UnitDivisionId and DonationTypeCode (CR 1473).
**        01/11/06        C. Taylor        Added LabelTypeCode (DR1729)
**        01/23/06        Lohse                Removing dead code
**        01/23/06        M Smith                ** Reviewed for compliance with database standards and recommendations **
**         03/18/11        K. Dobranowski        Added ApplicationOfRecordId (CR 2941)
**        03/18/11        D. Askew        Added AND ( PT.ApplicationOfRecordId IS NULL OR PT.ApplicationOfRecordId = 1 ) to
**                                        WHERE clause to filter out BCE COTS updates (CR 2983)
**        03/29/11        M Smith                ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetIssuedAndTransfusedUnitsForPatient
(
        @patientguid                UNIQUEIDENTIFIER,
        @divisioncode                CHAR(5)
)

AS

DECLARE @ERROR INT

        SET NOCOUNT ON

--Transfused units
        SELECT DISTINCT

                IU.IssuedUnitGUID,
                IU.IssueTechID,
                ISNULL(IU.RemoteStorageIndicator, 0)                                                         AS RemoteStorageIndicator,
                BU.BloodUnitGUID,
                BU.BloodUnitStatusGuid,
                BU.EyeReadableUnitID,
                BU.ProductShortName,
                BU.ProductTypeName,
                BU.RhFactorText,
                BU.BloodTypeCode + ' ' + RhFactorText                                                         AS AboRh,
                BU.UnitStatusCode,
                BU.OriginalVolume,
                BU.UnitProductCode,
                BU.PresumedTransfusedIndicator,
                BU.UnitDivisionId,
                BU.DonationTypeCode,
                ISNULL(CCP.MaximumTransfusionTime, -1)                                                 AS MaximumTransfusionTime,

                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0,  BU.UnitExpirationDate)                 AS UnitExpirationDate,

                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0,  IU.IssueDateTime)                 AS IssueDateTime,

                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0,  PT.TransfusionEndDateTime)         AS TransfusionEndDateTime,
                BU.LabelTypeCode,

                PT.ApplicationOfRecordId                                                                AS ApplicationOfRecordId

        FROM
                dbo.PatientTransfusion PT

                JOIN dbo.vw_BloodShipAllCurrent BU ON BU.BloodUnitGuid = PT.BloodUnitGuid AND BU.UnitStatusCode = 'T'
        
                --For AboIncompatible transfusions, this may not exist!!
                LEFT OUTER JOIN dbo.IssuedUnit IU ON IU.BloodUnitGuid = PT.BloodUnitGuid AND IU.ReturnDateTime IS NULL
                
                LEFT JOIN dbo.ComponentClassParameter CCP ON CCP.ComponentClassId = BU.ComponentClassId AND CCP.DivisionCode = @divisioncode AND CCP.RecordStatusCode = 'A'

        WHERE

                PT.PatientGUID = @patientguid

                AND BU.DivisionCode = @divisioncode

                AND PT.RecordStatusCode = 'A'

                -- CR 2565
                AND ( PT.ApplicationOfRecordId IS NULL OR PT.ApplicationOfRecordId = 1 )


UNION
--Issued Units
        SELECT DISTINCT

                IU.IssuedUnitGUID,
                IU.IssueTechID,
                ISNULL(IU.RemoteStorageIndicator, 0)                                                 AS RemoteStorageIndicator,
                BU.BloodUnitGUID,
                BU.BloodUnitStatusGuid,
                BU.EyeReadableUnitID,
                BU.ProductShortName,
                BU.ProductTypeName,
                BU.RhFactorText,
                BU.BloodTypeCode + ' ' + RhFactorText                                                 AS AboRh,
                BU.UnitStatusCode,
                BU.OriginalVolume,
                BU.UnitProductCode,
                BU.PresumedTransfusedIndicator,
                BU.UnitDivisionId,
                BU.DonationTypeCode,
                ISNULL(CCP.MaximumTransfusionTime, -1)                                         AS MaximumTransfusionTime,

                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0,  BU.UnitExpirationDate)         AS UnitExpirationDate,

                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0,  IU.IssueDateTime)         AS IssueDateTime,

                NULL                                                                                 AS TransfusionEndDateTime,
                BU.LabelTypeCode,

                0 AS ApplicationOfRecordId

        FROM

                dbo.IssuedUnit IU

                JOIN dbo.vw_BloodShipAllCurrent BU ON BU.BloodUnitGuid = IU.BloodUnitGuid AND BU.UnitStatusCode ='I'
        
                JOIN dbo.OrderedUnit OU ON IU.BloodUnitGUID = OU.BloodUnitGUID AND OU.ReleaseDate IS NULL AND OU.RecordStatusCode = 'A'

                LEFT JOIN dbo.ComponentClassParameter CCP ON CCP.ComponentClassId = BU.ComponentClassId AND CCP.DivisionCode = @divisioncode AND CCP.RecordStatusCode = 'A'
                
                JOIN dbo.OrderedComponent OC ON OU.OrderedComponentGUID = OC.OrderedComponentGUID
                
                JOIN dbo.PatientOrder PO ON OC.PatientOrderGUID = PO.PatientOrderGUID
                
                JOIN dbo.PatientTreatment PT ON PO.PatientTreatmentGUID = PT.PatientTreatmentGUID

        WHERE

                PT.PatientGuid  = @patientguid

                AND BU.DivisionCode = @divisioncode
        
                AND IU.ReturnDateTime IS NULL        
        
                AND OU.ReleaseDate IS NULL 
        
                AND OU.RecordStatusCode = 'A'
        
        ORDER BY UnitExpirationDate DESC

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN (@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetModifiableBloodUnits]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetModifiableBloodUnits]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Selects blood units eligible for supplied modification type.
**
**        Author: Cameron Taylor        
**        Date:         2/7/2003
**
*******************************************************************************************************************************************************************************
**        Modified:
**         Date                Name                Description
**        --------------        ---------                ------------------
**        11/04/2003        Lohse                All Units are able to be "split" according to SMEs.
**        11/05/2003        Lohse                Adding LabelTypeCode to the select -- for BloodUnit datarow constructor
**        01/13/2004        C. Taylor        Added DisplayVistaPatientId
**        02/09/2004        Greg Lohse        Adding UnitDivisionId - to find child alloQUATS. Adding FullProductCode
**        04/27/2004        M. Jablonski        Call fnTimeZoneConversionDateTime function on all dates
**        08/04/2004        Greg Lohse        Adding PT.SplitAllowedIndicator - needed to implement TT26.02 correctly
**        09/14/2004        C. Taylor        Added ShipmentDate, to be used instead of UnitInDate
**        10/20/2004        D. McHugh        Replaced BloodProductTable with call to BloodProduct joined with PermittedProductModification
**        12/03/2004        C. Taylor        Added PresumedTransfusedIndicator
**        01/23/2004        Lohse                Changed DiscardDetailCode to DiscardCannedCommentGuid
**        03/07/2005        D. McHugh        For non-pooling, added logic to determine the actual target products
**        05/31/2005        Lohse                Adding logic for BR_11.04.  Can't select units that are on outgoing shipment (unconfirmed)
**        06/07/2005        Lohse                Adding AND/OR logic at end of WHERE clause to restrict split units to be split again
**        06/17/2005        Npaterson        Changed to use new view to increase performance
**        07/20/2005        Lohse                Adding @includeallstatus to help distinguish rejection of manual unit entries
**        07/21/2005        Lohse                Adding ORDER BY EyeReadableUnitId, FullProductCode
**        07/20/2005        N.Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed Name/input/output from comment header, added SET NOCOUNT, formatted SQL, specified object owners
**                                        NOTE: productmodificationcode,UnitStatusCode,LabelTypeCode are hard coded in WHERE clause, consider using subquery
**                                        ALSO: ProductAttributeForm,FromCoreCondition are hard coded
**        08/22/2005        S.Antropov        Resolved a bug caused by missed BEGIN/END statements in IF block
**        03/09/2006        Lohse                Swapped PendingTransfer logic to use PendingTransferIndicator now being returned in vw_BloodShipPatientAllCurrent
**        07/16/2010        M. Smith        Check the ModificationAllowedIndicator on the ProductAttribute table to filter out modifiable products. (CR2744)
**        08/16/2010        M. Smith        Changed to use OriginalProductTypeCode from the BloodProduct table when determining target
**                                        products (CR 2735)
**        08/20/2010        M. Smith        Changed @ProductAttributeForm to VARCHAR(40) (CR 2765)
**        07/15/2011        M. Smith        Added logic to use the new BloodProductModification table for thawed modifications (CR 2691).
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetModifiableBloodUnits
(
        @divisioncode                        CHAR(5),
        @productmodificationcode        CHAR(1),
        @modificationmethod                INTEGER,                --1 = opened, 0 = closed
        @includeallstatus                BIT = 0
)
AS


DECLARE @ERROR INT

SET NOCOUNT ON


IF @ProductModificationCode = 'T'
BEGIN

        SELECT DISTINCT
        
                VW.BloodUnitGUID, 
                VW.EyeReadableUnitID, 
                VW.DirectedPatientGuid, 
                VW.UnitProductCode, 
                VW.RhFactorCode, 
        
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, VW.UnitExpirationDate)                                 AS UnitExpirationDate, 
        
                VW.DonationTypeID, 
                VW.BloodProductGUID,
        
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, VW.UnitInDate)                                         AS UnitInDate, 
        
                VW.DivisionCode, 
                VW.BloodTypeCode, 
                VW.UnitFdaRegistrationNumber, 
                VW.LabelUnitID, 
                VW.ProductTypeCode, 
                VW.ProductName, 
                VW.ProductShortName, 
                VW.BiohazardousWarningIndicator,
                VW.DonationTypeText, 
                VW.ProductTypeName, 
                VW.RhFactorText, 
                VW.FacilityName, 
                VW.PatientFirstName, 
                VW.PatientMiddleName, 
                VW.PatientLastName, 
                VW.MaximumStorageTime,
                VW.VistaPatientID, 
                VW.PatientSSN, 
                VW.DisplayVistaPatientId,
                VW.UnitStatusComments, 
                VW.DiscardCannedCommentGuid, 
                VW.UnitStatusCode, 
                VW.UnitStatusText, 
                VW.QuarantineIndicator, 
                VW.TestingStatusId, 
                VW.OriginalVolume,
                VW.[RowVersion], 
                VW.Comments, 
                VW.IncomingShipmentGUID,
                RTRIM(VW.BloodTypeCode) + ' ' + VW.RhFactorText                                                         AS AboRh,
                VW.LabelTypeCode,
                VW.UnitDivisionID,
        
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, VW.ShipmentDate)                                 AS ShipmentDate,
        
                PresumedTransfusedIndicator,
        
                CASE LabelTypeCode
        
                        WHEN 'I' THEN 
        
                                VW.UnitProductCode + VW.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS + VW.UnitDivisionId 
        
                        ELSE 
                                VW.UnitProductCode
                END                                                                                                         AS FullProductCode,
        
                VW.UnitContainerLotNumber
        
        FROM        dbo.vw_BloodShipPatientAllCurrent VW
                JOIN BloodProductModification BPM
                        ON BloodProductGuid = FromBloodProductGuid

         WHERE        VW.DivisionCode = @divisioncode
           AND        (VW.UnitStatusCode IN ('L', 'A', 'S', 'C') OR @includeallstatus = 1)
           AND        BPM.ProductModificationCode = @ProductModificationCode
           AND        BPM.MethodSelect = @ModificationMethod
           AND         PendingTransferIndicator = 0
        
        ORDER BY EyeReadableUnitId, FullProductCode

END
ELSE
BEGIN
        DECLARE @BloodProductGuid UNIQUEIDENTIFIER
        DECLARE @ProductAttributeForm VARCHAR(40)
        DECLARE @Rows INT
        
        DECLARE @BPTemp TABLE (
                BloodProductGuid UNIQUEIDENTIFIER
                )

        DECLARE BPCursor CURSOR FAST_FORWARD
        FOR SELECT DISTINCT
                VW.BloodProductGUID, ProductAttributeForm
        FROM        
                dbo.vw_BloodShipAllCurrent VW
        JOIN        (
                        SELECT DISTINCT BP.BloodProductGuid
                        FROM dbo.BloodProduct BP 
                                JOIN PermittedProductModification TT 
                                        ON BP.OriginalProductTypeCode = TT.FromProductTypeCode
        
                        WHERE (LEFT(BP.ProductAttributeForm, 3) = TT.FromCoreCondition OR TT.FromCoreCondition = 'Any')
                                AND TT.ProductModificationCode = @ProductModificationCode
                                AND TT.MethodSelect = @ModificationMethod
                )  AS BP
                ON        VW.BloodProductGuid = BP.BloodProductGuid                
        WHERE
                VW.DivisionCode = @divisioncode
                AND        (VW.UnitStatusCode IN  ('L', 'A', 'S', 'C') OR @includeallstatus = 1)
        
        OPEN BPCursor
        FETCH NEXT FROM BPCursor INTO @BloodProductGuid, @ProductAttributeForm
        
        WHILE @@FETCH_STATUS = 0
        BEGIN
        IF NOT EXISTS (SELECT * FROM ProductAttribute 
                        JOIN dbo.fnSplit(@ProductAttributeForm, ' ') 
                                ON ProductAttributeId = Item
                                        AND ModificationAllowedIndicator = 0)
        BEGIN
                IF @ProductModificationCode IN ('P', 'U')
                BEGIN
                        INSERT INTO @BPTemp
                        VALUES(@BloodProductGuid)
                END
                ELSE
                BEGIN
        
                        EXEC @Rows = dbo.spSingleBloodProductModification @BloodProductGuid, @ProductModificationCode, @ModificationMethod, 0
        
                        SET @ERROR = @@ERROR
                        IF @ERROR !=0 GOTO SPROC_EXIT
        
                        IF @Rows <> 0
                        BEGIN
                                INSERT INTO @BPTemp
                                VALUES(@BloodProductGuid)
                        END
                END
        END
        
        FETCH NEXT FROM BPCursor INTO @BloodProductGuid, @ProductAttributeForm
        END
        
        CLOSE BPCursor
        DEALLOCATE BPCursor
        
        SET @ERROR = @@ERROR
        IF @ERROR !=0 GOTO SPROC_EXIT
        
        SELECT DISTINCT
        
                VW.BloodUnitGUID, 
                VW.EyeReadableUnitID, 
                VW.DirectedPatientGuid, 
                VW.UnitProductCode, 
                VW.RhFactorCode, 
        
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, VW.UnitExpirationDate)                                 AS UnitExpirationDate, 
        
                VW.DonationTypeID, 
                VW.BloodProductGUID,
        
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, VW.UnitInDate)                                         AS UnitInDate, 
        
                VW.DivisionCode, 
                VW.BloodTypeCode, 
                VW.UnitFdaRegistrationNumber, 
                VW.LabelUnitID, 
                VW.ProductTypeCode, 
                VW.ProductName, 
                VW.ProductShortName, 
                VW.BiohazardousWarningIndicator,
                VW.DonationTypeText, 
                VW.ProductTypeName, 
                VW.RhFactorText, 
                VW.FacilityName, 
                VW.PatientFirstName, 
                VW.PatientMiddleName, 
                VW.PatientLastName, 
                VW.MaximumStorageTime,
                VW.VistaPatientID, 
                VW.PatientSSN, 
                VW.DisplayVistaPatientId,
                VW.UnitStatusComments, 
                VW.DiscardCannedCommentGuid, 
                VW.UnitStatusCode, 
                VW.UnitStatusText, 
                VW.QuarantineIndicator, 
                VW.TestingStatusId, 
                VW.OriginalVolume,
                VW.[RowVersion], 
                VW.Comments, 
                VW.IncomingShipmentGUID,
                RTRIM(VW.BloodTypeCode) + ' ' + VW.RhFactorText                                                         AS AboRh,
                VW.LabelTypeCode,
                VW.UnitDivisionID,
        
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, VW.ShipmentDate)                                 AS ShipmentDate,
        
                PresumedTransfusedIndicator,
        
                CASE LabelTypeCode
        
                        WHEN 'I' THEN 
        
                                VW.UnitProductCode + VW.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS + VW.UnitDivisionId 
        
                        ELSE 
        
                                VW.UnitProductCode
        
                END                                                                                                         AS FullProductCode,
        
                VW.UnitContainerLotNumber
        
        FROM        
        
                dbo.vw_BloodShipPatientAllCurrent VW
        
        JOIN        @BPTemp BU ON
        
                VW.BloodProductGuid = BU.BloodProductGuid
        
        WHERE
        
                VW.DivisionCode = @divisioncode
        
                AND        ((VW.UnitStatusCode IN ('L', 'A', 'S', 'C') AND @includeallstatus = 0) OR @includeallstatus = 1)
        
                AND         PendingTransferIndicator = 0
        
                AND        (@productmodificationcode NOT IN ('S', 'C')

                OR        (@productmodificationcode IN ('S', 'C')

                AND        (ISNUMERIC(RIGHT(VW.EyeReadableUnitId, 1)) = 1 AND VW.LabelTypeCode = 'C')

                OR         (VW.UnitDivisionId = '00' AND VW.LabelTypeCode = 'I')))
        
        ORDER BY EyeReadableUnitId, FullProductCode
END
                
SET @ERROR = @@ERROR

SPROC_EXIT:

        SET NOCOUNT OFF
        RETURN(@ERROR)
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetPatientForOrderedUnit]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetPatientForOrderedUnit]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**
**        Desc:        Gets patient guid for orderedunitguid (CR 2941)
**
**        Author:        Krzysztof Dobranowski
**
**        Date:         03/18/2011
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        04/13/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.spGetPatientForOrderedUnit
(
        @orderedunitguid        UNIQUEIDENTIFIER
)

AS

SET NOCOUNT ON

        SELECT 
                PatientGuid
        
        FROM
                dbo.OrderedUnit
        
        JOIN        dbo.OrderedComponent ON dbo.OrderedComponent.OrderedComponentGuid = dbo.OrderedUnit.OrderedComponentGuid
        JOIN        dbo.PatientOrder ON dbo.PatientOrder.PatientOrderGuid = dbo.OrderedComponent.PatientOrderGuid
        JOIN        dbo.PatientTreatment ON dbo.PatientTreatment.PatientTreatmentGuid = dbo.PatientOrder.PatientTreatmentGuid

        WHERE
                dbo.OrderedUnit.OrderedUnitGuid = @orderedunitguid
                
SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetPatientGuidForPatient]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetPatientGuidForPatient]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:                Used to retrieve a patient's guid based on SSN and DFN
**
**        Use Case(s):        69 (BCE COTS - CR 2959)
**
**        Author:                David Askew
**
**        Date:                 3/16/2011
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        4/08/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetPatientGuidForPatient
(
        @vistapatientid        BIGINT,
        @patientssn        CHAR(9) = NULL
)

AS
        
DECLARE @ERROR INT

SET @ERROR = 0

SET NOCOUNT ON        

        IF @patientssn IS NOT NULL 

                  --Search by PatientSsn and VistaPatientID
                BEGIN
                        SELECT 
                                PatientGuid
                          FROM 
                                dbo.Patient 
                        WHERE 
                                PatientSsn = @patientssn
                                AND VistaPatientId = @VistaPatientId
                END
        ELSE

                  --Search by VistaPatientID
                BEGIN
                        SELECT 
                                PatientGuid
                          FROM 
                                dbo.Patient 
                        WHERE 
                                VistaPatientId = @vistapatientid
                END


SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetPatientOrderbyOrderGroupNumber]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetPatientOrderbyOrderGroupNumber]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Searches PatientOrder table for matching entries.  Used in sending VISTA information to/from VBECS.
**
**        Author:        Luke Meyer
**
**        Date:         5/8/2003
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        07/06/2005        NPaterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name,input/output descriptions from comment header, Added NOCOUNT, Specified table owners, 
                                        spaced out SQL, added brackets around input parameter
**        01/20/2011        K. Dobranowski  Added ORDER BY to make sure that original order is always returned on top. (CR 1843 added code that will save
**                                        OrderGroupNumber for Reflex tests. It will result in this stored procedure returning more than 1 row for orders
**                                        that have Reflex tests associated with them. The original CPRS order needs to be returned as the first row 
**                                        otherwise VBECS code might throw exceptions).
**        06/01/2011        K.Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/

CREATE PROCEDURE dbo.spGetPatientOrderbyOrderGroupNumber 
(
        @OrderGroupNumber VARCHAR(20)
)
AS

SET NOCOUNT ON

        SELECT 

                PatientOrderGUID, 
                PatientGUID, 
                RequestReason,
                DivisionCode

        FROM dbo.PatientOrder 

                JOIN dbo.PatientTreatment ON dbo.PatientOrder.PatientTreatmentGUID = dbo.PatientTreatment.PatientTreatmentGUID

        WHERE OrderGroupNumber = @OrderGroupNumber
        ORDER BY OrderReceivedDatetime ASC

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetPatientTransfusionRecord]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetPatientTransfusionRecord]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:        Get the information about a specific patient transfusion
**
**        Author:         Carl Jensen
**        Date:         03/30/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**         Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        04/21/04        M. Jablonski        Call fnTimeZoneConversionDateTime function on all dates; Added divisioncode
**        06/03/04        M. Jablonski        Added BedsideVerificationDate to SELECT
**        06/07/04        C. Taylor        Replaced PatientGuid clause with fnWherePatientGuid function, to include possible merged patients
**        06/14/04        D. Askew        Added some columns
**        07/20/04        M. Jablonski        Deleted columns added by David (per changes to DB model)
**        09/03/04        C. Taylor        Made PatientGuid optional
**        07/06/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name, input/output from comment header, Added NOCOUNT, Specified table owners, spaced out SQL
                                        Placed rowversion in brackets
**        09/09/05        D. Askew        Removed fnWherePatientGuid via sub-query using new PatientMergeGroup
**        03/18/11        K. Dobranowski        Added ApplicationOfRecordId (CR 2941)
**        03/18/11        D. Askew        Added InterruptionComment and BedsideVerificationUnitManualEntryReason (CR 2959)
**        04/08/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetPatientTransfusionRecord
        
        @patientguid                 AS UNIQUEIDENTIFIER = NULL,
        @bloodunitguid                 AS UNIQUEIDENTIFIER,
        @divisioncode                AS CHAR(5)
AS

SET NOCOUNT ON

IF @patientguid IS NOT NULL

        BEGIN

                SELECT 
                        PatientTransfusionGuid,
                        PatientGuid,
                        TransfusionLocation,
                        LocationIen,
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, TransfusionStartDateTime) AS TransfusionStartDateTime,
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, TransfusionEndDateTime) AS  TransfusionEndDateTime,
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, BedsideVerificationDate) AS  BedsideVerificationDate,
                        BedsideVerificationUnitManualEntryReason,
                        BloodUnitGuid,
                        Transfusionist1id,
                        Transfusionist2id,
                        TransfusedVolume,
                        InterruptionIndicator,
                        InterruptionComment,
                        ReactionIndicator,
                        ReactionSymptoms,
                        ApplicationOfRecordId,
                        DivisionCode,
                        LastUpdateUser,
                        LastUpdateFunctionId,
                        [RowVersion]
        
                FROM 
                        dbo.PatientTransfusion
                        
                WHERE

                        PatientGuid  = @patientguid

                        AND BloodUnitGuid = @bloodunitguid

                        AND RecordStatusCode = 'A'
        END

ELSE

        BEGIN

                SELECT 

                        PatientTransfusionGuid,
                        PatientGuid,
                        TransfusionLocation,
                        LocationIen,
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, TransfusionStartDateTime) AS TransfusionStartDateTime,
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, TransfusionEndDateTime) AS  TransfusionEndDateTime,
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, BedsideVerificationDate) AS  BedsideVerificationDate,
                        BedsideVerificationUnitManualEntryReason,
                        BloodUnitGuid,
                        Transfusionist1id,
                        Transfusionist2id,
                        TransfusedVolume,
                        InterruptionIndicator,
                        InterruptionComment,
                        ReactionIndicator,
                        ReactionSymptoms,
                        ApplicationOfRecordId,
                        DivisionCode,
                        LastUpdateUser,
                        LastUpdateFunctionId,
                        [RowVersion]
        
                FROM 
                        dbo.PatientTransfusion
                        
                WHERE

                        BloodUnitGuid = @bloodunitguid

                        AND RecordStatusCode = 'A'

                ORDER BY LastUpdateDate DESC

        END

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON 
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetPatientTransfusionRecordHistoryForPatient') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetPatientTransfusionRecordHistoryForPatient
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desct:        Get the transfusion history for a patient for Patient Record Report (Multi-divisonal)
**
**        Author: Cameron Taylor
**
**        Date:         08/18/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**         Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        09/16/04        C. Taylor        Added PooledUnitsCount
**        05/26/05        Lohse                PooledUnitsCount is now a function
**        07/06/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name, input/output from comment header, Added NOCOUNT, Specified table owners, spaced 
**                                        out SQL
**        09/09/05        D. Askew        Removed fnWherePatientGuid via sub-query using new PatientMergeGroup
**        01/17/06        C. Taylor        Added FullProductCode (UnitProductCode, DonationTypeCode, UnitDivisionId) to ProductShortName 
**                                        (DR 1729)
**        01/23/06        M Smith                ** Reviewed for compliance with database standards and recommendations **
**        03/29/11         D. Askew        Added InterruptionComment to PatientTransfusionCommentText (CR 2964)
**        03/31/11        D. Askew        Added CASE for LastUpdateUser to use 'Electronic Entry' for BCE_COTS inserts\updates; removed 
**                                        code for merged patient which was never implemented; cleaned up SQL (CR 2959)
**        04/11/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        08/04/11        D. Askew        Replaced LEFT JOIN to V_PatientTransfusionComment logic (CR 3103)
**        08/15/11        M Smith                ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetPatientTransfusionRecordHistoryForPatient
(        
        @patientguid AS UNIQUEIDENTIFIER,
        @divisioncode        AS CHAR(5)
)
AS

DECLARE @ERROR INT

SET @ERROR = 0


SET NOCOUNT ON

        SELECT 

                PT.PatientTransfusionGuid,
                PT.TransfusionLocation,
                PT.LocationIen,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PT.TransfusionStartDateTime)         AS TransfusionStartDateTime,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PT.TransfusionEndDateTime)         AS  TransfusionEndDateTime,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PT.BedsideVerificationDate)         AS  BedsideVerificationDate,
                PT.BloodUnitGuid,
                BU.EyeReadableUnitId,
                CASE BU.LabelTypeCode
                        WHEN 'I' THEN 
                                BP.ProductShortName + ', '+ BU.UnitProductCode 
                                + DT.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS 
                                + BU.UnitDivisionId 
                        ELSE 
                                BP.ProductShortName + ', '+ BU.UnitProductCode
                END                                                                                         AS ProductShortName,
                dbo.fnGetPooledUnitsCount(BU.BloodUnitGuid)                                                 AS PooledUnitsCount,
                PT.Transfusionist1id,
                PT.Transfusionist2id,
                PT.TransfusedVolume,
                PT.TransfusionPooledUnitsCount,
                PT.InterruptionIndicator,
                PT.InterruptionComment,
                PT.ReactionIndicator,
                PT.ReactionSymptoms,
                PTC.CannedCommentGuid,
                CASE WHEN InterruptionComment IS NOT NULL AND LEN(InterruptionComment) > 0
                THEN 
                        CAST((PTC.PatientTransfusionCommentText + '; ' + InterruptionComment) AS VARCHAR(335)) 
                ELSE
                        CAST(PTC.PatientTransfusionCommentText AS VARCHAR(335)) 
                END                                                                                                         AS PatientTransfusionCommentText,
                PT.DivisionCode,
                D.DivisionName,
                CASE WHEN AOR.ApplicationName IS NOT NULL AND AOR.ApplicationName = 'BCE_COTS'
                        THEN 
                                'Electronic Entry'
                ELSE 
                        ISNULL(VU.UserName, PT.LastUpdateUser) 
                END                                                                                         AS LastUpdateUser,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PT.LastUpdateDate)                 AS LastUpdateDate,
                PT.RecordStatusCode

        FROM 

                VBECS_V1_PROD_MIRROR.dbo.V_PatientTransfusion PT

                JOIN BloodUnit BU 
                        ON BU.BloodUnitGuid = PT.BloodUnitGuid

                JOIN BloodProduct BP 
                        ON BP.BloodProductGuid = BU.BloodProductGuid
        
                JOIN dbo.DonationType DT 
                        ON DT.DonationTypeId = BU.DonationTypeId

                JOIN VamcDivision D 
                        ON D.DivisionCode = PT.DivisionCode

                LEFT JOIN VbecsUser VU 
                        ON VU.VbecsUserId = PT.LastUpdateUser

                -- CR 3103
                LEFT JOIN VBECS_V1_PROD_MIRROR.dbo.V_PatientTransfusionComment PTC
                        ON PT.PatientTransfusionGuid = PTC.PatientTransfusionGuid
                        AND PTC.LastUpdateDate = 
                        (
                                SELECT 
                                        MAX (LastUpdateDate)  
                
                                FROM 
                                        VBECS_V1_PROD_MIRROR.dbo.V_PatientTransfusionComment MPTC
                
                                WHERE 
                                        PT.PatientTransfusionGuid = MPTC.PatientTransfusionGuid 
                                        AND PT.LastUpdateDate >= MPTC.LastUpdateDate 
                        )


                 LEFT JOIN dbo.ApplicationOfRecord AOR
                         ON PT.ApplicationOfRecordId = AOR.ApplicationOfRecordId

        WHERE

                PT.PatientGuid  = @patientguid

        ORDER BY

                TransfusionStartDateTime DESC,
                BU.EyeReadableUnitId,
                BP.ProductShortName,
                PT.PatientTransfusionGuid,
                PT.LastUpdateDate

SET @ERROR = @@ERROR

SET NOCOUNT OFF
                
RETURN (@ERROR)
GO

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetRackTestResult') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetPreviousUnitStatus
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Return the previous status of a unit based on TT_27.01
**
**        Author: Cameron Taylor
**
**        Date:         02/09/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        ----------        ---------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        07/07/2005        NPaterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name, input/output from comment header, Added NOCOUNT OFF, Specified table owners, spaced out SQL
**        01/04/2010        M. Smith        Changed to get the previous UnitStatusCode from the mirror BloodUnitStatusCodeCurrent table.  This 
**                                        also is ignoring final status for the blood unit.(CR 1174)
**        01/26/2010        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        05/09/2011        C. Van Stedum  CR 3010 reverted sproc functionality to what it was in build 1504 since we cannot rely on the mirror tables history of status
**        05/11/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetPreviousUnitStatus
(
        @bloodunitguid                UNIQUEIDENTIFIER
)

AS

DECLARE @ERROR INT

SET @ERROR = 0

SET NOCOUNT ON

        SELECT         
                        UnitStatusCode,
                        UnitStatusText

        FROM         dbo.UnitStatus

        WHERE        UnitStatusCode = dbo.fnUnitStatusCode(@bloodunitguid,1)


SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetRackTestResult') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetRackTestResult
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Get the ltest results for a rack lot
**
**        Author:         Krzysztof Dobranowski
**
**        Date:         01/09/2003
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        01/09/2003        Krzysztof Dobranowski        Initial creation.
**        04/21/2004        M. Jablonski                Call fnTimeZoneConversionDateTime function on all dates
**        07/07/2005        NPaterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name, input/output from comment header, Added NOCOUNT, Specified table owners, spaced out SQL
                                        Placed brackets around input parameters and rowversion
**        12/11/2009        K.Dobranowski        Added TestWithReagentGuid (CR 2696)
**        01/21/2010        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/

CREATE PROCEDURE dbo.spGetRackTestResult
(
        @divisioncode                        VARCHAR(5),
        @reagentguid                        UNIQUEIDENTIFIER,
        @rackguid                        UNIQUEIDENTIFIER,
        @dailyqcworklistguid                UNIQUEIDENTIFIER = NULL
)
 AS

DECLARE @ERROR INT

SET @ERROR = 0

SET NOCOUNT ON

DECLARE         @BeginDate         DATETIME,
                @EndDate        DATETIME,
                @TempDate        VARCHAR(12)

        SET @TempDate = GETUTCDATE()

        SET @BeginDate = @TempDate 

        SET @EndDate = DATEADD(d, 1, @BeginDate) 

        SET @ERROR = @@ERROR


        SELECT

                dbo.RackTest.RackTestGUID,
                dbo.RackLot.TestWithName,
                dbo.RackLot.TestWithID,
                dbo.RackLot.ExpectedMinimumReactions,
                dbo.ReactivityPhase.ReactivityPhaseText,
                dbo.RackLot.ReactivityPhaseCode,

                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, dbo.RackTest.TestDate) AS  TestDate,

                dbo.RackTest.RackTestResult,
                dbo.RackTest.RackTestResultTypeCode,
                dbo.RackTest.ReagentAmount,
                dbo.RackTest.[RowVersion],
                dbo.RackTest.TestWithReagentGuid,
                dbo.RackLot.SatisfactoryResultIndicator,
                dbo.RackLot.LotVialNumber,

                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, dbo.RackLot.LastUpdateDate) AS LastUpdateDate,

                dbo.RackLot.TestingMethodCode,
                dbo.RackLot.ReagentGuid
        
           FROM dbo.RackTest
        
        JOIN
                dbo.RackLot ON dbo.RackLot.RackLotGUID = dbo.RackTest.RackLotGUID
        JOIN
                dbo.Reagent ON dbo.Reagent.ReagentGUID = dbo.RackLot.ReagentGUID
        JOIN
                dbo.ReactivityPhase ON dbo.ReactivityPhase.ReactivityPhaseCode = dbo.RackLot.ReactivityPhaseCode
        
        WHERE

                dbo.RackTest.DivisionCode = @divisioncode

                AND
                        dbo.RackTest.RecordStatusCode = 'A'

                        AND
                                ((TestDate BETWEEN @BeginDate AND @EndDate) OR (@dailyqcworklistguid IS NOT NULL))

                                AND
                                        dbo.RackLot.RackGUID = @rackguid

                                        AND
                                                ((dbo.RackLot.DailyQcWorklistGuid = @dailyqcworklistguid) OR (@dailyqcworklistguid IS NULL))

                                                AND
                                                        dbo.Reagent.ReagentGUID = @reagentguid
        
        ORDER BY        dbo.RackLot.LastUpdateDate DESC

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN (@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetRecentlyDeceasedPatientDetails]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetRecentlyDeceasedPatientDetails]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

/*******************************************************************************************************************************************************************************
**        Desc:                 Returns information for recently deceased patients; implements BR_68.01
**
**        Use Case(s):        108
**
**        Author:                 David Askew
**
**        Date:                 09/27/2006
**
*******************************************************************************************************************************************************************************
**        Modified:
**         Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        10/03/06        D. Askew        Removed function call to fnGetPendingOrderCountForPatient in SELECT; added Pending Test Order 
**                                        Count to SELECT; added ORDER BY clause
**        10/12/06        D. Askew        Removed FromPatientIcn, FromPatientSexCode and FromSsnPseudoIndicator
**        10/23/06        D. Askew        Updated code in WHERE clause to check both FromPatientDeathDate and ToPatientDeathDate
**        11/20/06        D. Askew        Changed FromPatient to ToPatient (death events send patient death date as ToPatientDeathDate)
**        03/28/07        D. Askew        Added PC.PatientChangeStatusCode (CR 2165); removed FromPatientPendingOrdersCount subquery 
**                                        and added call to dbo.fnFromPatientPendingOrdersCount
**        03/30/07        D. Askew        Added AND PC.PatientChangeStatusCode <> 'X' in order to exclude updates for patients with expired 
**                                        orders
**        04/03/07        D. Askew        Added OrderReceivedDateTime to SELECT
**        06/10/11        D. Askew        Removed JOIN to PatientOrder and PatientTreatment tables; changed LastUpdateDate and ORDER BY 
**                                        to NotificationReceivedDate (CR 3043)
**        11/07/11        D. Askew        Added ActiveDivisionsAlertViewed and DivisionsWithActiveOrders to SELECT; removed OrderReceivedDateTime 
**                                        and FromPatientPendingOrdersCount (not used anymore)  (CR 3164).
**        12/01/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.spGetRecentlyDeceasedPatientDetails
(
        @divisioncode CHAR(5)
)

AS

SET NOCOUNT ON

DECLARE @CurrentDate        DATETIME
DECLARE @ERROR                 INT

SET @CurrentDate         = GETUTCDATE()
SET @ERROR                 = 0

        SELECT DISTINCT

                PC.PatientChangeGuid,
                PC.PatientChangeStatusCode,
                PC.ActiveDivisionsAlertViewed,
                -- *************************************************************************************************************************************************************************************************
                PC.FromPatientGuid,
                P.PatientLastName                                                                                                AS ToPatientLastName,
                P.PatientFirstName                                                                                                AS ToPatientFirstName,
                P.PatientMiddleName                                                                                                AS ToPatientMiddleName,
                SUBSTRING( P.PatientSsn, 1, 3 ) 
                        + '-' + SUBSTRING( P.PatientSsn, 4, 2 ) 
                        + '-' + SUBSTRING( P.PatientSsn, 6, 4 )                                                                        AS ToDisplayVistaPatientId,
                P.PatientDob                                                                                                        AS ToPatientDob,
                PC.ToPatientDeathDate,
                -- *************************************************************************************************************************************************************************************************
                dbo.fnDivisionsWithActiveOrders( PC.FromPatientGuid, @CurrentDate, PC.NotificationReceivedDate )                AS DivisionsWithActiveOrders,



                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PC.NotificationReceivedDate)                                 AS NotificationReceivedDate,
                PC.RowVersion        
        FROM         
                dbo.PatientChange AS PC 


                JOIN dbo.Patient AS P ON PC.FromPatientGuid = P.PatientGuid

        WHERE        
                -- ignore update notifications
                (PC.FromPatientDeathDate IS NOT NULL OR PC.ToPatientDeathDate IS NOT NULL)

                -- ignore merge notifications
                AND PC.ToPatientGuid = PC.FromPatientGuid

                -- ignore updates that have expired
                AND PC.PatientChangeStatusCode <> 'X'

        -- BR_68.01
        ORDER BY PC.NotificationReceivedDate

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN (@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetRecentlyDeceasedPatients]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetRecentlyDeceasedPatients]
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/*******************************************************************************************************************************************************************************
**        Desc:                 Returns list of patient guids and test order counts for recently deceased patients
**
**        Use Case(s):        84:                
**
**        Author:                 David Askew
**
**        Date:                 4/22/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**         Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        05/24/04        C. Taylor        Added LastUpdateDate to OrderReceiveddatetime comparison, otherwise we will alert about changes that 
**                                        happened eons ago every time that patient gets a new order.
**        05/24/04        C. Taylor        Added Patient demographic fields for UC_68.
**        07/09/04        D. Askew        Changed columns names back to defined values (for use in constructing Patient Change object)
**        07/16/04        D. Askew        Removed MergeFromVistaPatientId, MergeToVistaPatientId check and PatientChangeStatusCode; 
**                                        not relevant for deceased event
**        07/07/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name, input/output from comment header, Added NOCOUNT, Specified table owners, 
**                                        spaced out SQL
**        04/23/06        Lohse                Adding DateTimeConversion to LastUpdateDate
**        09/05/06        D. Askew        Changed code to use fnGetPendingOrderCountForPatient for checking patient's order count
**        09/21/06        D. Askew        Updated FROM and WHERE clauses; added fnGetPendingOrderCountForPatient to SELECT 
**                                        (removed from WHERE) to return patient's active test order count (we have to compute the active 
**                                        component order count later)
**        09/27/06        D. Askew        Removed most of the columns from SELECT for performance; we are only concerned if there are any new
**                                        rows in patient change, not the patient details so the actual updated information was moved to
**                                        spGetRecentlyDeceasedPatientDetails; updated header section
**        10/03/06        D. Askew        Removed function call to fnGetPendingOrderCountForPatient in SELECT; added Pending Test Order 
**                                        Count to SELECT; removed superfluous AND PC.FromPatientDeathDate IS NOT NULL
**        10/23/06        D. Askew        Updated code in WHERE clause to check both FromPatientDeathDate and ToPatientDeathDate;
**        11/20/06        D. Askew        Removed @lastchecked; removed AND PO.OrderReceivedDatetime < PC.LastUpdateDate from
**                                        WHERE clause
**        03/28/07        D. Askew        Removed FromPatientPendingOrdersCount subquery and added call to 
**                                        dbo.fnFromPatientPendingOrdersCount
**        03/30/07        D. Askew        Changed AND PC.PatientChangeStatusCode <>'S' TO NOT IN ( 'S', 'X' ) in order to exclude updates for
**                                        patients with expired orders; added PC.RowVersion, PC.PatientChangeGuid
**        04/03/07        D. Askew        Added OrderReceivedDateTime, LastUpdateDate to SELECT
**        06/10/11        D. Askew        Removed JOIN to Patient, PatientOrder and PatientTreatment tables; changed LastUpdateDate 
**                                        and ORDER BY to NotificationReceivedDate (CR 3043)
**        11/07/11        D. Askew        Added ActiveDivisionsAlertViewed and DivisionsWithActiveOrders to SELECT; removed OrderReceivedDateTime, 
**                                        NotificationReceivedDate and FromPatientPendingOrdersCount (not used anymore)  (CR 3164).
**        12/01/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.spGetRecentlyDeceasedPatients
(
        @divisioncode CHAR(5)
)

AS

SET NOCOUNT ON

DECLARE @CurrentDate        DATETIME
DECLARE @ERROR                 INT

SET @CurrentDate         = GETUTCDATE()
SET @ERROR                 = 0

        SELECT DISTINCT

                PC.PatientChangeGuid,
                PC.FromPatientGuid,
                PC.ActiveDivisionsAlertViewed,
                dbo.fnDivisionsWithActiveOrders( PC.FromPatientGuid, @CurrentDate, PC.NotificationReceivedDate )  AS DivisionsWithActiveOrders,




                PC.RowVersion
        FROM         
                dbo.PatientChange AS PC 

        WHERE        
                -- ignore update notifications
                (PC.FromPatientDeathDate IS NOT NULL OR PC.ToPatientDeathDate IS NOT NULL)

                -- ignore merge notifications
                AND PC.ToPatientGuid = PC.FromPatientGuid

                -- ignore updates that have been viewed and/or expired
                AND PC.PatientChangeStatusCode NOT IN ( 'S', 'X' ) 

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN (@ERROR)
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetRecentlyUpdatedPatientDetails]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetRecentlyUpdatedPatientDetails]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/************************************************************************************************************************************************************************************************************************************
**        Desc:                 Returns information for recently updated patients
**
**        Use Case(s):        108        
**
**        Author:                 David Askew
**
**        Date:                 09/27/2006
**
************************************************************************************************************************************************************************************************************************************
**        Modified:
**         Date                Name                Description
**        -------------------        -----------------------        ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        10/03/06        D. Askew        Removed function call to fnGetPendingOrderCountForPatient in SELECT; added Pending Test Order Count to SELECT; added ORDER BY clause; 
**                                        removed PC.FromPatientDeathDate IS NULL from WHERE
**        10/23/06        D. Askew        Added code to WHERE clause to ignore deceased patient updates
**        10/27/06        D. Askew        Removed code from WHERE clause to ignore deceased patient updates; any updates to deceased patients, however unlikely, should be shown here 
**        11/20/06        D. Askew        Added code to WHERE clause to ignore deceased patient updates yet again (if a patient's death date is removed, then that will show up under 
**                                        deceased updates); changed SELECT for SsnPseudoIndicator columns
**        03/28/07        D. Askew        Added PC.PatientChangeStatusCode (CR 2165); changed LastUpdateDate from FromPatient to PatientChange (PC) (CR 2165); removed 
**                                        FromPatientPendingOrdersCount subquery and added call to dbo.fnFromPatientPendingOrdersCount
**        03/30/07        D. Askew        Added AND PC.PatientChangeStatusCode <> 'X' in order to exclude updates for patients with expired orders
**        04/03/07        D. Askew        Added OrderReceivedDateTime to SELECT
**        06/08/09        D. Askew        Changed SELECT, FROM and WHERE clauses to handle insertion of NULL values in PatientChange for those patient demographics which were not 
**                                        updated (CR 2666).
**        06/22/09        M. Smith        ** Reviewed for compliance with database standards and recommendations **
**        06/10/11        D. Askew        Removed JOIN to PatientOrder and PatientTreatment tables; changed LastUpdateDate and ORDER BY to NotificationReceivedDate; 
**                                        removed ISNULL from ToPatientMiddleName since the middle name may be removed (CR 3043)
**        08/08/11        D. Askew        Added ISNULL check back to ToPatientMiddleName; updated JOIN to VBECS_V1_PROD_MIRROR.dbo.V_Patient:
**                                        (1) removed AND PC.LastUpdateDate > P.LastUpdateDate 
**                                        (2) changed PC.LastUpdateDate > MP.LastUpdateDate to PC.NotificationReceivedDate >= MP.LastUpdateDate. (CR 3090)
**        11/07/11        D. Askew        Added ActiveDivisionsAlertViewed and DivisionsWithActiveOrders to SELECT; removed OrderReceivedDateTime and FromPatientPendingOrdersCount
**                                         (not used anymore)  (CR 3164).
**        12/01/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        01/03/12        C. Van Stedum   Added additional join so that we join once for From and once for To Patient. Made sure the date querys were logical for each join (CR 3203).
**        01/04/12        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
************************************************************************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetRecentlyUpdatedPatientDetails
(
        @divisioncode         CHAR(5)
)
        
AS

SET NOCOUNT ON

DECLARE @CurrentDate        DATETIME
DECLARE @ERROR                 INT

SET @CurrentDate         = GETUTCDATE()
SET @ERROR                 = 0

        SELECT DISTINCT        

                PC.PatientChangeGuid,
                PC.PatientChangeStatusCode,
                PC.ActiveDivisionsAlertViewed,
                -- ********************************************************************************************************************************************************************************************
                PC.FromPatientGuid,

                ISNULL(PC.FromPatientLastName, PF.PatientLastName)                                                                AS FromPatientLastName,
                ISNULL(PC.FromPatientFirstName, PF.PatientFirstName)                                                                AS FromPatientFirstName,
                ISNULL(PC.FromPatientMiddleName, PF.PatientMiddleName)                                                        AS FromPatientMiddleName,
                CASE WHEN PC.FromPatientSsn IS NULL THEN
                        SUBSTRING( PF.PatientSsn, 1, 3 ) 
                                + '-' + SUBSTRING( PF.PatientSsn, 4, 2 ) 
                                + '-' + SUBSTRING( PF.PatientSsn, 6, 4 )
                ELSE
                        SUBSTRING( PC.FromPatientSsn, 1, 3 ) 
                                + '-' + SUBSTRING( PC.FromPatientSsn, 4, 2 ) 
                                + '-' + SUBSTRING( PC.FromPatientSsn, 6, 4 )
                END                                                                                                                 AS FromDisplayVistaPatientId,
                ISNULL(PC.FromPatientIcn, PF.PatientIcn)                                                                                AS FromPatientIcn,
                ISNULL(PC.FromPatientDob, PF.PatientDob)                                                                        AS FromPatientDob,
                ISNULL(PC.FromPatientSexCode, PF.PatientSexCode)                                                                AS FromPatientSexCode,
                ISNULL(PC.FromSsnPseudoIndicator, ISNULL(PF.SsnPseudoIndicator, 0))                                                AS FromSsnPseudoIndicator,
                -- ********************************************************************************************************************************************************************************************
                ISNULL(PC.ToPatientLastName, PT.PatientLastName)                                                                AS ToPatientLastName,
                ISNULL(PC.ToPatientFirstName, PT.PatientFirstName)                                                                AS ToPatientFirstName,
                ISNULL(PC.ToPatientMiddleName, PT.PatientMiddleName)                                                                AS ToPatientMiddleName, 
                CASE WHEN PC.ToPatientSsn IS NULL THEN
                        SUBSTRING( PT.PatientSsn, 1, 3 ) 
                                + '-' + SUBSTRING( PT.PatientSsn, 4, 2 ) 
                                + '-' + SUBSTRING( PT.PatientSsn, 6, 4 )
                ELSE
                        SUBSTRING( PC.ToPatientSsn, 1, 3 ) 
                                + '-' + SUBSTRING( PC.ToPatientSsn, 4, 2 ) 
                                + '-' + SUBSTRING( PC.ToPatientSsn, 6, 4 )
                END                                                                                                                 AS ToDisplayVistaPatientId,
                ISNULL(PC.ToPatientIcn, PT.PatientIcn)                                                                                AS ToPatientIcn,
                ISNULL(PC.ToPatientDob, PT.PatientDob)                                                                                AS ToPatientDob,
                ISNULL(PC.ToPatientSexCode, PT.PatientSexCode)                                                                AS ToPatientSexCode,
                ISNULL(PC.ToSsnPseudoIndicator, ISNULL(PT.SsnPseudoIndicator, 0))                                                AS ToSsnPseudoIndicator,
                -- ********************************************************************************************************************************************************************************************
                dbo.fnDivisionsWithActiveOrders( PC.FromPatientGuid, @CurrentDate, PC.NotificationReceivedDate )                AS DivisionsWithActiveOrders,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PC.NotificationReceivedDate)                                 AS NotificationReceivedDate,
                PC.RowVersion        

        FROM         dbo.PatientChange AS PC 
                         
                JOIN VBECS_V1_PROD_MIRROR.dbo.V_Patient PF
                        ON PC.FromPatientGuid = PF.PatientGuid
                        AND PF.LastUpdateDate = 
                        (
                                SELECT 
                                        MAX (LastUpdateDate)  

                                FROM 
                                        VBECS_V1_PROD_MIRROR.dbo.V_Patient MP 

                                WHERE 
                                        PC.FromPatientGuid = MP.PatientGuid 
                                        AND PC.NotificationReceivedDate > MP.LastUpdateDate -- CR 3090
                        )
                JOIN VBECS_V1_PROD_MIRROR.dbo.V_Patient PT
                        ON PC.ToPatientGuid = PT.PatientGuid
                        AND PT.LastUpdateDate = 
                        (
                                SELECT 
                                        MAX (LastUpdateDate)  
                                FROM 
                                        VBECS_V1_PROD_MIRROR.dbo.V_Patient MP 
                                WHERE 
                                        PC.ToPatientGuid = MP.PatientGuid 
                                        AND PC.NotificationReceivedDate >= MP.LastUpdateDate -- CR 3090
                         )
        
        WHERE        
                PC.ToPatientGuid = PC.FromPatientGuid
                AND PC.FromPatientDeathDate IS NULL 
                AND PC.ToPatientDeathDate IS NULL
                AND PC.PatientChangeStatusCode <> 'X'


        -- BR_68.01
        ORDER BY PC.NotificationReceivedDate

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN (@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetRecentlyUpdatedPatients]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetRecentlyUpdatedPatients]
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:                 Returns list of patient guids and test order counts for recently updated patients
**
**        Use Case(s):        84
**
**        Author:                 David Askew
**
**        Date:                 4/22/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**         Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        05/24/04        C. Taylor        Added LastUpdateDate to OrderReceiveddatetime comparison, otherwise we will alert about changes that 
**                                        happened eons ago every time that patient gets a new order.
**        05/24/04        C. Taylor        Added Patient demographic fields for UC_68.
**        07/16/04        D. Askew        Removed MergeFromVistaPatientId, MergeToVistaPatientId check and PatientChangeStatusCode; 
**                                        not relevant for update event
**        07/07/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name, input/output from comment header, Added NOCOUNT, Specified table owners, 
**                                        spaced out SQL
**        12/06/05        D. Askew        Added From and ToSsnPseudoIndicator
**        01/23/06        M. Smith        ** Reviewed for compliance with database standards and recommendations **
**        04/05/06        Lohse                Added DateTimeConversion to LastUpdateDate
**        09/05/06        D. Askew        Changed code to use the Patient table to fill in missing information from Patient Change; since VistA
**                                        only tells us what has changed, and the users would like to see the patient's existing information;
**                                        also use fnGetPendingOrderCountForPatient for checking patient's order count
**        09/21/06        D. Askew        Updated FROM and WHERE clauses; added fnGetPendingOrderCountForPatient to SELECT 
**                                        (removed from WHERE) to return patient's active test order count (we have to compute the active 
**                                        component order count later)
**        09/27/06        D. Askew        Removed most of the columns from SELECT for performance; we are only concerned if there are any new
**                                        rows in patient change, not the patient details so the actual updated information was moved to
**                                        spGetRecentlyUpdatedPatientDetails; updated header section
**        10/03/06        D. Askew        Removed function call to fnGetPendingOrderCountForPatient in SELECT; added Pending Test Order 
**                                        Count to SELECT; removed PC.FromPatientDeathDate IS NULL from WHERE
**        10/23/06        D. Askew        Added code to WHERE clause to ignore deceased patient updates
**        10/27/06        D. Askew        Removed code from WHERE clause to ignore deceased patient updates; any updates to deceased 
**                                        patients, however unlikely, should be shown here 
**        11/20/06        D. Askew        Added code to WHERE clause to ignore deceased patient updates yet again (if a patient's death date 
**                                        is removed, then that will show up under deceased updates); removed @lastchecked; 
**                                        removed AND PO.OrderReceivedDatetime < PC.LastUpdateDate from WHERE clause 
**        03/28/07        D. Askew        Removed FromPatientPendingOrdersCount subquery and added call to 
**                                        dbo.fnFromPatientPendingOrdersCount
**        03/30/07        D. Askew        Changed AND PC.PatientChangeStatusCode <>'S' TO NOT IN ( 'S', 'X' ) in order to exclude updates for
**                                        patients with expired orders; added PC.RowVersion, PC.PatientChangeGuid
**        04/03/07        D. Askew        Added OrderReceivedDateTime, LastUpdateDate to SELECT
**        06/10/11        D. Askew        Removed JOIN to Patient, PatientOrder and PatientTreatment tables; changed LastUpdateDate 
**                                        and ORDER BY to NotificationReceivedDate (CR 3043)
**        11/07/11        D. Askew        Added ActiveDivisionsAlertViewed and DivisionsWithActiveOrders to SELECT; removed OrderReceivedDateTime, 
**                                        and NotificationReceivedDate and FromPatientPendingOrdersCount (not used anymore)  (CR 3164).
**        12/01/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetRecentlyUpdatedPatients
(
        @divisioncode CHAR(5)
)

AS

SET NOCOUNT ON

DECLARE @CurrentDate        DATETIME
DECLARE @ERROR                 INT

SET @CurrentDate         = GETUTCDATE()
SET @ERROR                 = 0

        SELECT DISTINCT        

                PC.PatientChangeGuid,
                PC.FromPatientGuid,
                PC.ActiveDivisionsAlertViewed,
                dbo.fnDivisionsWithActiveOrders( PC.FromPatientGuid, @CurrentDate, PC.NotificationReceivedDate ) AS DivisionsWithActiveOrders,




                PC.RowVersion
        FROM         

                dbo.PatientChange AS PC 

        WHERE        
                -- ignore merge notifications
                PC.ToPatientGuid = PC.FromPatientGuid

                -- ignore deceased notifications
                AND (PC.FromPatientDeathDate IS NULL AND PC.ToPatientDeathDate IS NULL)

                -- ignore updates that have been viewed and/or expired
                AND PC.PatientChangeStatusCode NOT IN ( 'S', 'X' )

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN (@ERROR)
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetReportBloodUnitTransfusionHistory') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetReportBloodUnitTransfusionHistory
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:        Retunrs Patient and Transfusion historical data for a blood unit
**
**        Author:        David Askew
**
**        Date:         08/17/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        07/07/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name, input/output from comment header, Added NOCOUNT OFF, Specified table owners, spaced out SQL,
                                        Aliased Tables
**        08/22/05        N. Paterson        Implemented differences from REVIW-START DB
**        04/12/06        D. Askew        Removed commented-out code; changed Patient JOIN to INNER type, corrected JOIN to bring back
**                                        correct patient data in the event of one or more merges; removed JOIN to PatientOrder; added JOIN
**                                        to V_PatientTransfusionComment; added PatientTransfusionCommentText to SELECT; changed
**                                        ORDER BY from TransfusionEndDateTime to LastUpdateDate
**        03/18/11        D. Askew        Added CASE for LastUpdateUser to use 'Electronic Entry' for BCE_COTS inserts\updates; removed 
**                                        code for merged patient which was never implemented (CR 2959)
**        03/18/11         D. Askew        Added BedsideVerificationUnitManualEntryReason; added InterruptionComment to 
**                                        PatientTransfusionCommentText (CR 2964)
**        04/11/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        08/04/11        D. Askew        Replaced LEFT JOIN to V_PatientTransfusionComment logic (CR 3103)
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetReportBloodUnitTransfusionHistory
(
        @bloodunitguid        UNIQUEIDENTIFIER,
        @divisioncode        VARCHAR(5)
)
AS

DECLARE @ERROR INT

SET @ERROR = 0

SET NOCOUNT ON
        
        SELECT DISTINCT

                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PatientTransfusion.TransfusionStartDateTime)         AS TransfusionStartDateTime,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PatientTransfusion.TransfusionEndDateTime)         AS TransfusionEndDateTime,
                P.PatientLastName,
                P.PatientFirstName,
                P.PatientMiddleName,
                P.DisplayVistaPatientId,
                PatientTransfusion.Transfusionist1Id,
                PatientTransfusion.Transfusionist2Id,
                TS.TreatingSpecialtyName,
                CASE WHEN InterruptionComment IS NOT NULL AND LEN(InterruptionComment) > 0
                THEN 
                        PTC.PatientTransfusionCommentText + '; ' + InterruptionComment
                ELSE
                        PTC.PatientTransfusionCommentText
                END                                                                                                         AS PatientTransfusionCommentText,
                PatientTransfusion.BedsideVerificationUnitManualEntryReason,
                CASE WHEN AOR.ApplicationName IS NOT NULL AND AOR.ApplicationName = 'BCE_COTS'
                THEN 
                        'Electronic Entry'
                ELSE 
                        PatientTransfusion.LastUpdateUser
                END                                                                                                         AS LastUpdateUser,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PatientTransfusion.LastUpdateDate)                 AS LastUpdateDate

        FROM

                dbo.BloodUnit BU

                JOIN VBECS_V1_PROD_MIRROR.dbo.V_PatientTransfusion AS PatientTransfusion 
                        ON BU.BloodUnitGuid = PatientTransfusion.BloodUnitGuid

                JOIN dbo.Patient P 
                        ON P.PatientGuid = PatientTransfusion.PatientGuid

                LEFT JOIN dbo.PatientTreatment PT
                        ON P.PatientGuid = PT.PatientGuid

                LEFT JOIN dbo.TreatingSpecialty TS
                        ON PT.TreatingSpecialtyCode = TS.TreatingSpecialtyCode

                LEFT JOIN VBECS_V1_PROD_MIRROR.dbo.V_PatientTransfusionComment PTC
                        ON PatientTransfusion.PatientTransfusionGuid = PTC.PatientTransfusionGuid
                        AND PTC.LastUpdateDate = 
                        (
                                SELECT 
                                        MAX (LastUpdateDate)  
                
                                FROM 
                                        VBECS_V1_PROD_MIRROR.dbo.V_PatientTransfusionComment MPTC
                
                                WHERE 
                                        PatientTransfusion.PatientTransfusionGuid = MPTC.PatientTransfusionGuid 
                                        AND PatientTransfusion.LastUpdateDate >= MPTC.LastUpdateDate 
                        )


                LEFT JOIN dbo.ApplicationOfRecord AOR
                        ON PatientTransfusion.ApplicationOfRecordId = AOR.ApplicationOfRecordId

        WHERE         


                BU.BloodUnitGuid = @bloodunitguid

                AND BU.DivisionCode = @divisioncode

        ORDER BY PatientTransfusion.LastUpdateDate DESC

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetTargetProducts') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetTargetProducts
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:        Gets Target Products
**
**        Author:        Cameron Taylor
**
**        Date:         03/10/2003
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        11/20/2003        Lohse                Adding FromBloodProductGuid -- Codabar productcodes are shared across multiple bloodproduct, so we need
**                                                to eliminate returning a product of the same type AS the requesting.
**        03/01/2004        M.Jablonski        Added row version to SELECT,
**        10/20/2004        D. McHugh        Replaced the call to the BloodProductModification TABLE with a temp TABLE @BloodProductModification.
**                                                Added in all that junk to use the sproc spSingleBloodProductModification and its resulting CURSOR
**                                                to build the temp TABLE.
**        11/15/2004        D. McHugh        Added logic to handle pooling
**        03/23/2005        Lohse                Adding fnIsProductActive to replace DSP drop
**        07/11/2005        D. McHugh        Adding code to return ExpirationDateRule
**        07/07/2005        NPaterson        ** Reviewed for compliance with database standards and recommendations **
**                                                Removed name, input/output from comment header, Added NOCOUNT, Specified table owners, spaced out SQL
**        07/22/2005        D. McHugh        Added SET NOCOUNTs
**        08/22/2005        S. Antropov        ** Reviewed for compliance with database standards and recommendations **
**                                                        Performed secondary review during the code promotion - merged changes
**        10/18/2005        Lohse                Adding ModificationMethod to return set -- so Expiration Date Rules can be grabbed once -- performance gain
**        01/23/2006        M Smith                ** Reviewed for compliance with database standards and recommendations **
**        08/16/2010        M. Smith        Changed to use OriginalProductTypeCode in the WHERE clause from the BloodProduct table when determining target
**                                        products and modification expiration dates (CR 2735)
**        08/18/2010        M. Smith        Changed FromProductAttributeForm and ToProductAttributeForm to VARCHAR(40). (CR 2765)
**        08/18/2010        M. Smith        Rewritten to remove cursor logic and call the new spBloodProductModificationPool stored procedure for 
**                                        thaw/pooling and pooling modifications. (CR 2678)
**        05/16/2011        K Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        07/14/2011        M. Smith        Added logic to use the new BloodProductModification table for thawed modifications (CR 2691).
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetTargetProducts
(
        @FromBloodProductGuidList    VARCHAR(1014),   --Allowing for 26 copies of (38-character guid + 1-char delimiter)
        @ProductModificationCode        CHAR(1),
        @DivisionCode                            CHAR(5),
        @ModificationMethod                    INTEGER                --1 open, 0 closed
)

AS

DECLARE @ERROR INT

SET @ERROR = 0

SET NOCOUNT ON

DECLARE @FromBloodProductGuid UNIQUEIDENTIFIER

IF @ProductModificationCode = 'T'
BEGIN
        SET @FromBloodProductGuid = CAST(@FromBloodProductGuidList AS UNIQUEIDENTIFIER)

        SELECT DISTINCT
                BP.BloodProductGUID,
                PT.ComponentClassID,
                BP.ProductCode,
                BP.ProductShortName,
                BP.ProductName,
                BP.ProductTypeCode,
                PT.ProductTypeName,
                BP.ProductVolume,
                BP.MaximumStorageTime,
                BP.ProductCodeIndicator AS BarcodeType,
                dbo.fnIsProductActive(BP.BloodProductGuid, @divisioncode) AS ProductActiveIndicator,
                BP.ProductCode + ' - ' + BP.ProductShortName AS CodeAndShortName,
                @divisioncode AS DivisionCode,
                        BPM.ExpirationDateRule,
                BPM.MethodSelect
        FROM
                BloodProductModification BPM
        
        JOIN
                dbo.BloodProduct BP ON BPM.ToBloodProductGuid = BP.BloodProductGuid
                
        JOIN 
                dbo.ProductType PT ON PT.ProductTypeCode = BP.ProductTypeCode
        
        WHERE
                BPM.FromBloodProductGuid = @FromBloodProductGuid
          AND (MethodSelect = @ModificationMethod OR @ModificationMethod = -1)
        
END
ELSE
BEGIN
        CREATE TABLE #BloodProductModification 
                        (ProductModificationCode CHAR(1),
                        MethodSelect INTEGER,
                        AddTargetAttribute VARCHAR(20),
                        FromBloodProductGuid UNIQUEIDENTIFIER,
                        FromProductTypeCode VARCHAR(4),
                        FromProductCode VARCHAR(5),
                        FromCoreCondition VARCHAR(3),
                        FromProductAttributeForm VARCHAR(40),
                        ToBloodProductGuid UNIQUEIDENTIFIER,
                        ToProductTypeCode VARCHAR(4),
                        ToProductCode VARCHAR(5),
                        ToCoreCondition VARCHAR(3),
                        ToProductAttributeForm VARCHAR(40),
                        ExpirationDateRule INTEGER
                        )

        IF @ProductModificationCode IN ('P', 'U')
        BEGIN
        
                INSERT INTO #BloodProductModification
                EXEC dbo.spBloodProductModificationPool @FromBloodProductGuidList, @ProductModificationCode, @ModificationMethod
        
        END
        ELSE
        BEGIN
        
                SET @FromBloodProductGuid = CAST(@FromBloodProductGuidList AS UNIQUEIDENTIFIER)
        
                INSERT INTO #BloodProductModification
                EXEC dbo.spSingleBloodProductModification @FromBloodProductGuid, @ProductModificationCode, @ModificationMethod
        END

        SELECT DISTINCT
                BP.BloodProductGUID,
                PT.ComponentClassID,
                BP.ProductCode,
                BP.ProductShortName,
                BP.ProductName,
                BP.ProductTypeCode,
                PT.ProductTypeName,
                BP.ProductVolume,
                BP.MaximumStorageTime,
                BP.ProductCodeIndicator AS BarcodeType,
                dbo.fnIsProductActive(BP.BloodProductGuid, @divisioncode) AS ProductActiveIndicator,
                BP.ProductCode + ' - ' + BP.ProductShortName AS CodeAndShortName,
                @divisioncode AS DivisionCode,
                        BPM.ExpirationDateRule,
                BPM.MethodSelect
        FROM
                #BloodProductModification BPM
        
        JOIN
                dbo.BloodProduct BP ON BP.ProductCode = BPM.ToProductCode
                
        JOIN 
                dbo.ProductType PT ON PT.ProductTypeCode = BP.ProductTypeCode
        
        WHERE
                BP.OriginalProductTypeCode = BPM.ToProductTypeCode

        DROP TABLE #BloodProductModification
END

SET @ERROR = @@ERROR
        
SET NOCOUNT OFF

RETURN @ERROR

GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetTestingTaskList') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetTestingTaskList
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Get the list of pending tasks
**
**        Author:         Krzysztof Dobranowski
**
**        Date:         04/23/2003
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------                ---------                -----------------
**        04/23/2003        K. Dobranowski        Initial creation.
**        07/01/2003        M.Jablonski         Added 4 fields: PatientOrderGUID, OrderReceivedDatetime, OrderingProvideMiddleInitial & PatientLocation
**        01/13/2004        C Taylor                Added DisplayVistaPatientId
**        02/24/2004        M.Jablonski        Added PatientTreatment.PatientTreatmentGUID to SELECT        
**        02/25/04        C. Taylor        Removed ExtendedExpirationDate - no longer needed (use mirror tables to see original expiration date)
**        04/22/2004        M. Jablonski        Call fnTimeZoneConversionDateTime function on all dates
**        04/23/2004        C.Taylor                Added TaskStatus of 'R' to WHERE clause
**        05/05/2004        C. Taylor        Replaced SpecimenAccessionNumber with Specimenuid
**        06/15/2004        C. Taylor        Replaced PatientGuid join with function fnGetPatientGuid to ensure latest patient details returned
**        06/28/2004        C. Taylor        Added preSpecimenGuid for UC_21
**        07/01/2004        C. Jensen        Added SpecimenAccessionNumber and LabTestId
**        01/06/2004        C. Taylor        Added OrderGroupNumber
**        07/07/2005        NPaterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name, input/output from comment header, Added NOCOUNT, Specified table owners, 
**                                        spaced out SQL
**        09/09/2005        D. Askew        Changed JOIN on Patient to select either the FinalMergeToPatient if the patient has one or more
**                                        merges (choosing the final merge record) or simply the patient guid if there are none
**        09/29/2005        K. Dobranowski        Changed the expiration date to be 10 days not 3 days from Order Received date per CR 1164
**        01/18/2006        C. Taylor        Removed PreSpecimenGuid (CR 1462)
**        01/23/2006        M Smith                ** Reviewed for compliance with database standards and recommendations **
**        11/10/2009        K. Dobranowski        Removed check for expiration date from WHERE clause (CR 2368)
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetTestingTaskList
(
        @divisioncode                VARCHAR(5),
        @ordergroupnumber         VARCHAR(20) = NULL
)

AS

DECLARE @ERROR INT

SET @ERROR = 0

SET NOCOUNT ON

        SELECT
                
                dbo.OrderUrgency.OrderUrgencyText,
                dbo.OrderedTest.OrderedTestGUID,
                dbo.OrderedTest.OrderUrgencyCode,
                dbo.OrderedTest.OrderedTestComments,
                dbo.OrderedTest.CprsOrderNumber,
                dbo.OrderedTest.OrderableTestID,

                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, dbo.OrderedTest.RequiredResultsDate) AS  RequiredResultsDate,

                dbo.OrderedTest.TaskStatusCode,
                dbo.OrderedTest.RelatedTestGUID,
                dbo.OrderedTest.RelatedComponentGUID,
                dbo.OrderedTest.SpecimenAccessionNumber,
                dbo.OrderedTest.LabTestId,
                dbo.OrderedTest.LastUpdateUser,
                dbo.OrderedTest.[RowVersion],
                dbo.PatientTreatment.PatientGUID,
                dbo.Patient.PatientFirstName,
                dbo.Patient.PatientLastName,
                dbo.Patient.PatientMiddleName,
                dbo.Patient.VistaPatientID,
                dbo.Patient.PatientSSN,
                dbo.Patient.DisplayVistaPatientId,
                dbo.PatientTreatment.PatientLocation,
                dbo.PatientTreatment.PatientTreatmentGUID,
                dbo.Patient.BloodTypeCode,
                dbo.Patient.RhFactorCode,
                dbo.PatientOrder.PatientOrderGUID,
                dbo.PatientOrder.OrderingProviderFirstName,
                dbo.PatientOrder.OrderingProviderLastName,
                dbo.PatientOrder.OrderingProviderMiddleInitial,

                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0,  dbo.PatientOrder.OrderPlacedDateTime) AS OrderPlacedDateTime,

                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, dbo.PatientOrder.OrderReceivedDatetime) AS OrderReceivedDatetime ,

                dbo.PatientSpecimen.PatientSpecimenGUID,
                dbo.PatientSpecimen.Specimenuid,

                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, dbo.PatientSpecimen.SpecimenExpirationDate) AS SpecimenExpirationDate,

                dbo.OrderableTest.OrderableTestName,
                dbo.TaskStatus.TaskStatusText,
                dbo.OrderUrgency.SortColumn,
                dbo.PatientOrder.OrderGroupNumber
        
           FROM dbo.OrderedTest
        
                JOIN dbo.PatientOrder ON dbo.PatientOrder.PatientOrderGUID = dbo.OrderedTest.PatientOrderGUID
        
                LEFT JOIN dbo.OrderUrgency ON dbo.OrderUrgency.OrderUrgencyCode = dbo.OrderedTest.OrderUrgencyCode
        
                LEFT JOIN dbo.PatientTreatment ON dbo.PatientTreatment.PatientTreatmentGUID = dbo.PatientOrder.PatientTreatmentGUID
        
                LEFT JOIN dbo.Patient ON PatientTreatment.PatientGuid = COALESCE(dbo.Patient.FinalMergeToPatient, dbo.Patient.PatientGuid)
        
                LEFT JOIN dbo.PatientSpecimen ON dbo.PatientSpecimen.PatientSpecimenGUID = dbo.OrderedTest.PatientSpecimenGUID
        
                LEFT JOIN dbo.OrderableTest ON dbo.OrderableTest.OrderableTestID = dbo.OrderedTest.OrderableTestID
        
                LEFT JOIN dbo.TaskStatus ON dbo.TaskStatus.TaskStatusCode = dbo.OrderedTest.TaskStatusCode
        
        WHERE dbo.OrderedTest.DivisionCode = @divisioncode

                AND (@ordergroupnumber IS NOT NULL OR (dbo.OrderedTest.OrderStatusCode = 'A' AND dbo.OrderedTest.TaskStatusCode IN ('I','N','P','R')))

                /*if searching for ordergroupnumber include orders that are expired*/
                AND (@ordergroupnumber IS NULL OR (dbo.PatientOrder.OrderGroupNumber = @ordergroupnumber AND dbo.OrderedTest.TaskStatusCode IN ('I','N','P','R','E')))
        
           ORDER BY dbo.OrderUrgency.SortColumn,
                         dbo.Patient.PatientLastName

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN (@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetUserRolesList') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetUserRolesList
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Gets list of user roles lesser than or equal to that of the user role id passed in
**
**        Author:         Luke Meyer
**
**        Date:         8/12/2002
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                        Name                                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        07/05/2005        NPaterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name from comment header, added set nocount, space out SQL, specified table owner
**        01/08/2010        M. Smith        Updated the where clause to account for the new visually impaired users (CR 2726)
**        01/21/2010        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        03/08/2011        M. Smith        Updated the where clause to account for the removal of visually impaired users (CR 2929)
**        05/31/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
******************************************************************************************************************************************************************************/

CREATE PROCEDURE dbo.spGetUserRolesList
(
        @userroleid         INT
)

AS

DECLARE @ERROR INT

SET @ERROR = 0

SET NOCOUNT ON

        SELECT 
                UserRoleId, 
                UserRoleName 

        FROM         dbo.UserRole 
        
        WHERE  UserRoleId <= @userroleid
                
        ORDER BY UserRoleId ASC

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetVbecsDivisions') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetVbecsDivisions
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:        Selects division informtion from VAMCDivision table
**
**        Author:        Stas Antropov
**
**        Date:         03/23/2005
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        07/05/2005        NPaterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name from header comments, added set nocount, specified object owners, space out SQL
**        08/11/2005        J.Engstrom        Removed join on DaylightSavings table.  Removed selection of DaylightSavingsYear column.  
**                                        Changed to select DaylighSavingsStartDate & DaylighSavingsEndDate from VamcDivision table.
**        10/18/2007        C. Jensen        Added PrinterName field to accomodate retrieval of reports printer (CR 2320).
**        10/01/2009        K.Dobranowski        Added ReactivityPhaseCode (CR 2717)
**        08/18/2010        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/

CREATE PROCEDURE spGetVbecsDivisions
(
        @activeonly BIT
)

AS

DECLARE @ERROR INT

SET NOCOUNT ON

        SELECT                 VamcDivision.DivisionCode, 
                                DivisionGuid, 
                                DivisionName, 
                                ServiceTypeIndicator, 
                                VamcDivision.IccbbaRegistrationNumber, 
                                ElectronicCrossmatchIndicator, 
                                VamcDivision.FacilityGuid, 
                                AccessionAreaId,
                                Facility.FacilityName,
                                LocalSupplierGuid, 
                                AntibodyScreenDisplayCode, 
                                MaximumSpecimenExpirationDays, 
                                AutomatedInstrumentIndicator, 
                                LabelPrinterUseIndicator, 
                                LabelPrinterComPortNumber, 
                                LabelPrinterIPAddress, 
                                LabelPrinterTcpPortNumber,
                                PrinterName,
                                TimeZoneId, 
                                DaylightSavingsTypeId, 
                                DaylightSavingsStartDate, 
                                DaylightSavingsEndDate,
                                PrinterAlertsIndicator, 
                                PrinterAlertsPrinterName, 
                                PrinterOrderAlertTypeCode, 
                                PrinterOrdersNeededHours, 
                                IconAlertsIndicator, 
                                IconOrderAlertTypeCode, 
                                IconOrdersNeededHours, 
                                IconRefreshRate, 
                                LoginMessageText, 
                                InvoiceTemplateText, 
                                MedicalDirectorName, 
                                LockInactivityTimeoutMin, 
                                VamcDivision.RecordStatusCode,
                                VamcDivision.[RowVersion],
                                ReactivityPhaseCode

        FROM                 dbo.VamcDivision 

                        LEFT OUTER JOIN dbo.Facility 

                        ON dbo.Facility.FacilityGuid = dbo.VamcDivision.FacilityGuid

        WHERE                ( @activeonly = 1 AND dbo.VamcDivision.RecordStatusCode = 'A' ) OR ( @activeonly = 0 )

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetVbecsUserDivisionsAndRoles') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetVbecsUserDivisionsAndRoles
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Retrieves divisions with associated roles (including inactive) for a given user.
**
**        Author: Stas Antropov
**
**        Date:         11/15/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                        Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        02/14/2005        Stas Antropov        Added where clause to exclude system users. 
**        07/05/2005        NPaterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed name, input/output descriptions from header comment, added set nocount, capitalized AS,
**                                        placed rowcount in square brackets, spaced out SQL, specified object owners
**        08/15/2005        J. Engstrom        Removed join on DaylightSavings table.  Removed selection of DaylightSavingsYear column.  
**                                                Changed to select DaylighSavingsStartDate & DaylighSavingsEndDate from VamcDivision table.
**        10/18/2007        C. Jensen        Added PrinterName field to accomodate retrieval of reports printer (CR 2320).
**        10/01/2009        K. Dobranowski        Added ReactivityPhaseCode (CR 2717)
**        08/18/2010        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/

CREATE PROCEDURE dbo.spGetVbecsUserDivisionsAndRoles
(
        @vbecsuserid        VARCHAR (30)
)
AS 

DECLARE @ERROR INT

SET NOCOUNT ON

        SELECT                
                VamcDivision.DivisionCode, 
                VamcDivision.DivisionGuid, 
                VamcDivision.DivisionName, 
                VamcDivision.ServiceTypeIndicator, 
                VamcDivision.IccbbaRegistrationNumber, 
                VamcDivision.ElectronicCrossmatchIndicator, 
                VamcDivision.FacilityGuid, 
                VamcDivision.AccessionAreaId,
                VamcDivision.LocalSupplierGuid, 
                VamcDivision.AntibodyScreenDisplayCode, 
                VamcDivision.MaximumSpecimenExpirationDays, 
                VamcDivision.AutomatedInstrumentIndicator, 
                VamcDivision.LabelPrinterUseIndicator, 
                VamcDivision.LabelPrinterComPortNumber, 
                VamcDivision.LabelPrinterIPAddress, 
                VamcDivision.LabelPrinterTcpPortNumber,
                VamcDivision.PrinterName,
                VamcDivision.TimeZoneId, 
                VamcDivision.DaylightSavingsTypeId, 
                VamcDivision.DaylightSavingsStartDate, 
                VamcDivision.DaylightSavingsEndDate,
                VamcDivision.PrinterAlertsIndicator, 
                VamcDivision.PrinterAlertsPrinterName, 
                VamcDivision.PrinterOrderAlertTypeCode, 
                VamcDivision.PrinterOrdersNeededHours, 
                VamcDivision.IconAlertsIndicator, 
                VamcDivision.IconOrderAlertTypeCode, 
                VamcDivision.IconOrdersNeededHours, 
                VamcDivision.IconRefreshRate, 
                VamcDivision.LoginMessageText, 
                VamcDivision.InvoiceTemplateText, 
                VamcDivision.MedicalDirectorName, 
                VamcDivision.LockInactivityTimeoutMin, 
                VamcDivision.RecordStatusCode,
                VamcDivision.[RowVersion],
                VamcDivision.ReactivityPhaseCode,
                UserRole.UserRoleID,
                UserRole.UserRoleName, 
                VbecsUserDivisionRole.RecordStatusCode         AS UserDivisionRoleRecordStatusCode,
                VbecsUserDivisionRole.[RowVersion]                 AS UserDivisionRoleRowVersion

        FROM                dbo.VamcDivision 

        INNER JOIN         dbo.VbecsUserDivisionRole ON 

                dbo.VamcDivision.DivisionCode =dbo.VbecsUserDivisionRole.DivisionCode

                INNER JOIN         dbo.UserRole ON 
        
                        dbo.VbecsUserDivisionRole.UserRoleId = dbo.UserRole.UserRoleId
        
                        INNER JOIN        dbo.VbecsUser ON 
                
                                dbo.VbecsUser.VbecsUserId = dbo.VbecsUserDivisionRole.VbecsUserId

        WHERE                dbo.VbecsUserDivisionRole.VbecsUserId = @vbecsuserid

                AND         SystemUserIndicator <> 1;


SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spHL7GetInterfaceControlParameters') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spHL7GetInterfaceControlParameters
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Gets all interfaces defined in the InterfaceControl table.
**
**        Author: Brian Tomlin        
**
**        Date:         01/31/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        05/17/04        Stas Antropov        Changed * to list of columns, added VbecsIPAddress
**        01/10/05        Stas Antropov        Added [LogEventsIndicator]
**        06/29/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Comment Header Adjusted, Added NOCOUNT, Specified table owners, Spaced SQL
**        06/19/07        B.Tomlin        Added InterfaceDomainName (CR 2269)
**        10/21/08        M. Smith        The InterfaceControl was split into two tables.  Changed to join the new Interface reference table (CR 2516)
**        12/09/08        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        03/16/11        K. Dobranowski        Added InterfaceActiveIndicator (CR 2940)
**        04/04/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        11/15/11        D. Askew        Added @InterfaceApplicationId, @VbecsApplicationId and @InterfaceControlId as parameters (CR 3082)
**        12/01/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/

CREATE PROCEDURE dbo.spHL7GetInterfaceControlParameters
(
        @InterfaceName                 VARCHAR(50)         = NULL,
        @InterfaceApplicationId                VARCHAR(50)         = NULL,
        @VbecsApplicationId                VARCHAR(50)         = NULL,
        @InterfaceControlId                INT                 = NULL
)

AS

SET NOCOUNT ON

        SELECT                 
                        [InterfaceControlId], 
                        [InterfaceName], 
                        [FieldSeparator], 
                        [EncodingCharacters], 
                        [InterfaceApplicationId], 
                        [InterfaceFacilityId], 
                        [InterfacePortNumber], 
                        [InterfaceIPAddress],
                        [InterfaceDomainName], 
                        [VbecsApplicationId], 
                        [VbecsFacilityId], 
                        [ProcessingId], 
                        [VersionId], 
                        [ApplicationAckType], 
                        [VbecsPortNumber], 
                        [VbecsIPAddress], 
                        [AckTimeout], 
                        [ReTransmitAttempts], 
                        [InterfaceAdministratorName], 
                        [PurgeSuccessfulMessage], 
                        [PurgeUnSuccessfulMessage], 
                        [LogEventsIndicator],
                        [InterfaceActiveIndicator],
                        IC.LastUpdateDate, 
                        IC.LastUpdateUser, 
                        IC.[RowVersion], 
                        IC.LastUpdateFunctionId

        FROM                 dbo.Interface I

                        LEFT JOIN dbo.InterfaceControl IC ON I.InterfaceId = IC.InterfaceId

        WHERE         

                ( @InterfaceName IS NOT NULL AND InterfaceName = @InterfaceName )

                OR 

                ( @InterfaceApplicationId IS NOT NULL AND @VbecsApplicationId IS NOT NULL AND InterfaceApplicationId = @InterfaceApplicationId AND VbecsApplicationId = @VbecsApplicationId )

                OR

                ( @InterfaceControlId IS NOT NULL AND InterfaceControlId = @InterfaceControlId )

                OR

                ( @InterfaceControlId IS NULL AND @InterfaceName IS NULL AND @InterfaceApplicationId IS NULL AND @VbecsApplicationId IS NULL )


SET NOCOUNT OFF
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spHL7GetPatientLocation') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spHL7GetPatientLocation
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Returns the location data for a particular patient (CR 2986)
**
**        Author:        David Askew
**
**        Date:         3/16/2011
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        03/31/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spHL7GetPatientLocation
(
        @patientguid        UNIQUEIDENTIFIER
)

AS

DECLARE @ERROR        INT

SET NOCOUNT ON

        SELECT
                InPatientIndicator,
                LocationName,
                LocationRoomBed,
                PL.DivisionCode

        FROM        dbo.PatientLocation PL

        WHERE
                PatientGuid = @patientguid

SET NOCOUNT OFF

RETURN (@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spHL7GetPatientOrderbyOrderGroupNumber') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spHL7GetPatientOrderbyOrderGroupNumber
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Searches PatientOrder table for matching entries.  Used in sending VISTA information to/from VBECS.
**
**        Author:        Luke Meyer
**
**        Date:         5/8/2003
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        06/29/2005        NPaterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Comment Header Adjusted, Added NOCOUNT, Specified table owners, UPPERCASED SQL
**        01/20/2011        K. Dobranowski  Added ORDER BY to make sure that original order is always returned on top. (CR 1843 added code that will save
**                                        OrderGroupNumber for Reflex tests. It will result in this stored procedure returning more than 1 row for orders
**                                        that have Reflex tests associated with them. The original CPRS order needs to be returned as the first row 
**                                        otherwise VBECS code might throw exceptions).
**        06/01/2011        K.Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE   PROCEDURE dbo.spHL7GetPatientOrderbyOrderGroupNumber 
(
@OrderGroupNumber VARCHAR(20)
)
AS

        SET NOCOUNT ON
                
                SELECT         
                        PatientOrderGuid, 
                        PatientGuid, 
                        RequestReason,
                        DivisionCode

                FROM         dbo.PatientOrder 

                JOIN         dbo.PatientTreatment

                ON         dbo.PatientOrder.PatientTreatmentGuid = dbo.PatientTreatment.PatientTreatmentGuid

                WHERE         OrderGroupNumber = @OrderGroupNumber
                ORDER BY         OrderReceivedDateTime ASC

        SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spHL7GetPendingTransmissionMessages') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spHL7GetPendingTransmissionMessages
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Gets HL7 Messages with a PendingTransmission state and sets the 
**                MessageStatus to Awaiting Response.
**
**        Author: Brian Tomlin        
**
**        Date:         3/04/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        6/29/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Comment Header Adjusted,  Added NOCOUNT, Specified table owners
**        3/17/11        D. Askew        Removed commented-out code; added TansmitCount (CR 2962)
**         3/20/11        D. Askew        Added code to NOT return messages which have been re-sent ReTransmitAttempts + 1 (CR 2967)
**        04/18/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spHL7GetPendingTransmissionMessages

AS

SET NOCOUNT ON

DECLARE @DefaultMaxReTransmitAttempts        INT
DECLARE @MaxReTransmitAttempts                INT
DECLARE @MessageLogId                         INT
DECLARE @SUser                                VARCHAR(45)
DECLARE @TransmitCount                         TINYINT

SET @DefaultMaxReTransmitAttempts = 5
SET @SUser = (select suser_sname())

        SELECT TOP 1
                @MaxReTransmitAttempts = ISNULL(IC.ReTransmitAttempts, @DefaultMaxReTransmitAttempts),
                 @MessageLogId = MessageLogId,
                @TransmitCount = ISNULL(TransmitCount, 0)

        FROM         dbo.MessageLog ML

        JOIN dbo.InterfaceControl IC
                ON ML.InterfaceControlId = IC.InterfaceControlId
        
        WHERE MessageStatusCode = 1

        IF @MessageLogId > 0 AND @TransmitCount <= @MaxReTransmitAttempts
        BEGIN
                UPDATE 
                                dbo.MessageLog 
                SET 
                                MessageStatusCode =  8,
                                LastUpdateDate = GETUTCDATE(),
                                LastUpdateUser = RIGHT(@SUser, LEN(@SUser) - CHARINDEX('\', @SUser))
                WHERE        
                                MessageLogId = @MessageLogId

                SELECT         InterfaceControlId,
                                MessageControlId,
                                MessageStream,
                                ISNULL(TransmitCount, 0) AS TransmitCount

                FROM                dbo.MessageLog

                WHERE        MessageLogId = @MessageLogId
        END

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spHL7GetTransmitCountForMessage') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spHL7GetTransmitCountForMessage
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Returns the transmit count for a particular message (CR 2962)
**
**        Author:        David Askew
**
**        Date:         3/16/2011
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        04/18/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spHL7GetTransmitCountForMessage
(
        @MessageControlId        VARCHAR(20)
)

AS

DECLARE @TransmitCount         INT

SET NOCOUNT ON

        SET @TransmitCount = 
        (
                SELECT ISNULL(TransmitCount, 0 ) AS TransmitCount
        
                FROM         dbo.MessageLog 
                
                WHERE MessageControlId = @MessageControlId
        )

RETURN @TransmitCount

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spHL7InsertPatientLocation') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spHL7InsertPatientLocation
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Inserts a record in the PatientLocation table when a Patient Update event occurs in VistA (for location - CR 2960)
**
**        Author:        David Askew
**
**        Date:         3/16/2011
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        3/16/11        D. Askew        Room and Bed are now stored in one field; added default NULL values (CR 2970)
**        4/06/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spHL7InsertPatientLocation
(
        @PatientGuid                                  UNIQUEIDENTIFIER,
        @InPatientIndicator                BIT,
        @LocationName                           VARCHAR(30)                = NULL,
        @LocationRoomBed                VARCHAR(20)                = NULL, 
        @DivisionCode                             CHAR(5)                = NULL,
        @LastUpdateDate                DATETIME,
        @LastUpdateFunctionId                INT,
        @LastUpdateUser                VARCHAR(30)
)

AS

SET NOCOUNT ON

DECLARE @ERROR        INT,
        @ROWCOUNT        INT

INSERT INTO dbo.PatientLocation
(
        PatientLocationGuid,
        PatientGuid,
        InPatientIndicator,
        LocationName,
        LocationRoomBed,
        DivisionCode,
        LastUpdateDate,
        LastUpdateFunctionId, 
        LastUpdateUser
)
VALUES
(
        NEWID(),
        @PatientGuid,
        @InPatientIndicator,
        @LocationName,
        @LocationRoomBed,
        @DivisionCode,
        @LastUpdateDate,
        @LastUpdateFunctionId,
        @LastUpdateUser
)


SELECT @ERROR = @@ERROR, @ROWCOUNT = @@ROWCOUNT

IF (@ERROR = 0 AND @ROWCOUNT <> 1)        
        SET @ERROR = -1


SET NOCOUNT OFF

RETURN (@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spHL7IsVbecsPatient') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spHL7IsVbecsPatient
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:                Used to check if patient exists in VBECS (CR 2960)
**
**        Use Case(s):        Patient Update Interface
**
**        Author:                David Askew
**
**        Date:                 3/16/2011
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------
**        3/16/11        D. Askew        Removed patient ssn and icn parameters, changed vista patient id to BIGINT (CR 2971)
**        3/16/11        D. Askew         Renamed from spIsVbecsPatient to spHL7IsVbecsPatient (CR 2986)
**        3/31/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.spHL7IsVbecsPatient
(
        @vistapatientid        BIGINT
)

AS

DECLARE @returnvalue  BIT

SET NOCOUNT ON
        
        IF EXISTS ( SELECT 1 FROM dbo.Patient WHERE VistAPatientId = @vistapatientid  )
                SET @returnvalue = 1
        ELSE        
                SET @returnvalue = 0

SET NOCOUNT OFF

RETURN(@returnvalue )
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spHL7UpdateInterfaceControlStatus') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spHL7UpdateInterfaceControlStatus
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Updates HL7 interface control status (CR 2940)
**
**        Author: Krzysztof Dobranowski
**
**        Date:         03/16/2011
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        04/04/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.spHL7UpdateInterfaceControlStatus
(
        @InterfaceControlID                 INT,
        @InterfaceActiveIndicator        BIT,
        @LastUpdateUser                 VARCHAR(30),
        @LastUpdateDate                 DATETIME
)        
AS

SET NOCOUNT ON

DECLARE @rowcount INT

        UPDATE        dbo.InterfaceControl
        SET                InterfaceActiveIndicator = @InterfaceActiveIndicator,
                        LastUpdateUser = @LastUpdateUser,
                        LastUpdateDate = @LastUpdateDate
        WHERE        InterfaceControlID = @InterfaceControlID;

        SELECT @rowcount = @@ROWCOUNT;

        IF @rowcount <> 1 RAISERROR( 50002, 16, 1, 'InterfaceControl', @rowcount );

SET NOCOUNT OFF

        return 0;
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spHL7UpdateMessageStatus') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spHL7UpdateMessageStatus
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Updates the MessageStatus of a message in the MessageLog table
**
**        Author:        Brian Tomlin
**
**        Date:         03/04/2003
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        01/10/05        D. Askew                Added @lastupdatedate
**        06/29/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Comment Header Adjusted, Added NOCOUNT, Specified table owners
**        09/02/05        Lohse                Changed comments field length from 255 to 510
**        03/18/11        D. Askew        Added @TransmitCount (CR 2962)
**        04/18/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/

CREATE PROCEDURE dbo.spHL7UpdateMessageStatus
(
        @MessageControlID        VARCHAR(20),
        @MessageStatusCode        INT,
        @ErrorText                VARCHAR(510)        = NULL,
        @TransmitCount                INT                 = NULL,
        @LastUpdateUser        VARCHAR(30),
        @LastUpdateFunctionId        INT,
        @LastUpdateDate        DATETIME
)

AS

SET NOCOUNT ON

DECLARE @ERROR                INT
DECLARE @ROWCOUNT        INT

BEGIN

        UPDATE
                dbo.MessageLog
        
        SET
                MessageStatusCode =         @MessageStatusCode,
                LastUpdateDate =         @LastUpdateDate,
                ErrorText =                @ErrorText,
                TransmitCount =                @TransmitCount,
                LastUpdateUser =         @LastUpdateUser,
                LastUpdateFunctionId =        @LastUpdateFunctionId
        WHERE
                MessageControlID =         @MessageControlID


SELECT @ERROR = @@ERROR, @ROWCOUNT = @@ROWCOUNT
IF (@ERROR = 0)
        IF @ROWCOUNT <> 1
                SET @ERROR = -1

END

SET NOCOUNT OFF

RETURN (@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spHL7UpdatePatientLocation') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spHL7UpdatePatientLocation
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Inserts a record in the PatientLocation table when a Patient Update event occurs in VistA (for location - CR 2960)
**
**        Author:        David Askew
**
**        Date:         3/16/2011
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        3/16/11        D. Askew        Room and Bed are now stored in one field; added default NULL values (CR 2970)
**        4/06/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spHL7UpdatePatientLocation
(
        @PatientGuid                                  UNIQUEIDENTIFIER,
        @InPatientIndicator                BIT,
        @LocationName                           VARCHAR(30)                = NULL,
        @LocationRoomBed                VARCHAR(20)                = NULL, 
        @DivisionCode                              CHAR(5)                = NULL,
        @LastUpdateDate                DATETIME,
        @LastUpdateFunctionId                INT,
        @LastUpdateUser                VARCHAR(30)
)

AS

SET NOCOUNT ON

DECLARE @ERROR        INT,
        @ROWCOUNT        INT


        UPDATE dbo.PatientLocation
        
        SET        InPatientIndicator = @InPatientIndicator,
                LocationName = @LocationName,
                LocationRoomBed = @LocationRoomBed,
                DivisionCode = @DivisionCode,
                LastUpdateDate = @LastUpdateDate,
                LastUpdateFunctionId =  @LastUpdateFunctionId,
                LastUpdateUser = @LastUpdateUser

        WHERE
                 PatientGuid = @PatientGuid

        SELECT @ERROR = @@ERROR, @ROWCOUNT = @@ROWCOUNT
        
        IF (@ERROR = 0 AND @ROWCOUNT <> 1)        
                SET @ERROR = -1


SET NOCOUNT OFF

RETURN (@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spHL7PurgeMessageLog') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spHL7PurgeMessageLog
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Purges HL7 messages from the MessageLog table based on criteria defined in VBECS Administrator (CR 2519)
**
**        Author:        David Askew
**
**        Date:         11/22/08
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        7/28/11        D. Askew        Changed MessageStatusCode IN (2, 6) to MessageStatusCode IN (1, 2, 6, 7, 8) to handle purging
**                                        failed messages too. (CR 3059)
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spHL7PurgeMessageLog

AS

SET NOCOUNT ON

        DECLARE @RowCount INT
        
        DECLARE @Now DATETIME
        
        SET @RowCount = 0
        
        SET @Now = GETUTCDATE()
        
        DELETE ML
        
        FROM
                dbo.MessageLog ML
                
                JOIN dbo.InterfaceControl IC ON ML.InterfaceControlId = IC.InterfaceControlId
        
        WHERE 
        
                ( MessageStatusCode = 3 AND ML.LastUpdateDate <= DATEADD(DAY, -PurgeSuccessfulMessage, @Now ) )
        
                OR 

                ( MessageStatusCode IN (1, 2, 6, 7, 8) AND ML.LastUpdateDate <= DATEADD(DAY, -PurgeUnSuccessfulMessage, @Now ) )

        SET @RowCount = @@ROWCOUNT


SET NOCOUNT OFF

RETURN (@RowCount)
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spInsertDailyQcWorklist') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spInsertDailyQcWorklist
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**
**        Desc:         Insert a daily qc worklist
**
**        Author:         Krzysztof Dobranowski
**
**        Date:         01/21/2005
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        --------------        ---------                -----------------
**        06/21/2005         D. Askew        ** Reviewed for compliance with database standards and recommendations **
**                                        Minor changes to error handling; verified NO COUNT set ON/OFF
**        06/28/2005         D. Askew        Comments updated
**        11/04/2009        K.Dobranowski        Added QCOfflineIndicator (CR 2718)
**        08/18/2010        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spInsertDailyQcWorklist
(
        @dailyqcworklistguid                UNIQUEIDENTIFIER,
        @rackguid                        UNIQUEIDENTIFIER         = NULL,
        @partiallytestedindicator                BIT,
        @dailyuseindicator                BIT,
        @qcofflineindicator                BIT                        = 0,
        @dailyqcexpirationdate                DATETIME                 = NULL,
        @divisioncode                        CHAR(5),
        @recordstatuscode                CHAR(1)                 = 'A',
        @lastupdateuser                VARCHAR(30),
        @lastupdatefunctionid                INT,
        @lastupdatedate                DATETIME
)
 
AS

SET NOCOUNT ON

DECLARE @error        INT
DECLARE @rowcount        INT

        INSERT INTO         dbo.DailyQcWorklist
        (
                        DailyQcWorklistGuid,
                        RackGuid,
                        PartiallyTestedIndicator,
                        DailyUseIndicator,
                        QCOfflineIndicator,
                        DailyQcExpirationDate,
                        DivisionCode,
                        RecordStatusCode,
                        LastUpdateDate,
                        LastUpdateUser,
                        LastUpdateFunctionId
        )
        VALUES
        (
                        @dailyqcworklistguid,
                        @rackguid,
                        @partiallytestedindicator,
                        @dailyuseindicator,
                        @qcofflineindicator,
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @dailyqcexpirationdate),
                        @divisioncode,
                        @recordstatuscode,
                        @lastupdatedate,
                        @lastupdateuser,
                        @lastupdatefunctionid
        )

        SELECT @error = @@ERROR, @rowcount = @@ROWCOUNT

        IF @rowcount <> 1 RAISERROR( 50003, 16, 1, 'DailyQcWorklist', @rowcount )
        
SET NOCOUNT OFF

RETURN (@error)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spInsertExceptionElectronicTransfusion') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spInsertExceptionElectronicTransfusion
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**
**        Desc:         This inserts a ElectronicTransfusion exception (CR 2942)
**
**        Author: Krzysztof Dobranowski
**
**        Date:         03/10/2011
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        --------------------        ---------------------------------------------------------------------------------------------------------------------------------------------
**        04/13/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spInsertExceptionElectronicTransfusion
(
        @exceptionelectronictransfusionguid                        UNIQUEIDENTIFIER,
        @exceptiontypeid                                        INT,
        @bedsideverificationdate                                DATETIME = NULL,
        @transfusionstartdatetime                                DATETIME = NULL,
        @transfusionenddatetime                                DATETIME = NULL,
        @bedsideverificationunitmanualentryreason                VARCHAR(2000) = NULL,
        @interruptionindicator                                        BIT = NULL,
        @patienttransfusionguid                                        UNIQUEIDENTIFIER = NULL,
        @reactionindicator                                        BIT = NULL,
        @reactionsymptoms                                        VARCHAR(510) = NULL,
        @transfusedvolume                                        INT = NULL,
        @transfusionist1id                                        VARCHAR(30) = NULL,
        @transfusionist2id                                        VARCHAR(30) = NULL,
        @transfusionlocation                                        VARCHAR(30) = NULL,
        @patientname                                                VARCHAR(60) = NULL,
        @patientid                                                VARCHAR(30) = NULL,
        @unitid                                                        VARCHAR(13) = NULL,
        @unitproductcode                                        CHAR(5) = NULL,
        @patienttransfusioncomment                                VARCHAR(1000) = NULL,
        @exceptionuser                                                VARCHAR(30),
        @exceptiondate                                                DATETIME,
        @divisioncode                                                CHAR(5),
        @lastupdateuser                                        VARCHAR (30),
        @lastupdatedate                                        DATETIME
)
 
AS

SET NOCOUNT ON

DECLARE @error        INT
DECLARE @rowcount        INT

        INSERT INTO         dbo.ExceptionElectronicTransfusion
        (
                ExceptionElectronicTransfusionGuid,
                ExceptionTypeId,
                BedsideVerificationDate,
                TransfusionStartDateTime,
                TransfusionEndDateTime,
                BedsideVerificationUnitManualEntryReason,
                InterruptionIndicator,
                PatientTransfusionGuid,
                ReactionIndicator,
                ReactionSymptoms,
                TransfusedVolume,
                Transfusionist1Id,
                Transfusionist2Id,
                TransfusionLocation,
                PatientName,
                PatientId,
                UnitId,
                UnitProductCode,
                PatientTransfusionComment,
                ExceptionUser,
                ExceptionDate,
                DivisionCode,
                LastUpdateDate,
                LastUpdateUser
        )
        VALUES
        (
                        @exceptionelectronictransfusionguid,
                        @exceptiontypeid,
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @bedsideverificationdate),
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @transfusionstartdatetime),
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @transfusionenddatetime),
                        @bedsideverificationunitmanualentryreason,
                        @interruptionindicator,
                        @patienttransfusionguid,
                        @reactionindicator,
                        @reactionsymptoms,
                        @transfusedvolume,
                        @transfusionist1id,
                        @transfusionist2id,
                        @transfusionlocation,
                        @patientname,
                        @patientid,
                        @unitid,
                        @unitproductcode,
                        @patienttransfusioncomment,
                        @exceptionuser,
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @exceptiondate),
                        @divisioncode,
                        @lastupdatedate,
                        @lastupdateuser
        )
        
        SELECT @error = @@ERROR, @rowcount = @@ROWCOUNT

        IF @rowcount <> 1 RAISERROR( 50003, 16, 1, 'ExceptionElectronicTransfusion', @rowcount )

SET NOCOUNT OFF

RETURN(@error)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spInsertExceptionExpiredTask') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spInsertExceptionExpiredTask
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**
**        Desc:         This inserts a ExpiredTask exception
**
**        Author: Krzysztof Dobranowski        
**
**        Date:         01/20/2005
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        ------------                ---------                ------------------
**        05/26/2005         D. Askew        ** Reviewed for compliance with database standards and recommendations **
**                                        Added TimeZoneConversion for @datewanted
**                                        Minor changes made to error handling; verified NO COUNT is ON/OFF
**        06/28/05         D. Askew        Comments updated
**        07/07/05        Lohse                Chnaged input parm @quantity to SMALLINT from INT
**        09/02/05        Lohse                Changed comments field length from 255 to 510
**        06/04/10        D. Askew        Changed @datewanted to defaul to NULL. (CR 2784)
**        08/18/10         K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spInsertExceptionExpiredTask
(
        @exceptionexpiredtaskguid        UNIQUEIDENTIFIER,
        @exceptiontypeid                INT,
        @patientname                        VARCHAR(60),
        @patientid                        VARCHAR(30),
        @specimenuid                        VARCHAR(15),
        @cprsordernumber                VARCHAR(20),
        @componentclassordered        VARCHAR(35),
        @quantity                        SMALLINT,
        @datewanted                        DATETIME                = NULL,
        @exceptioncomment                VARCHAR(510),
        @exceptionuser                        VARCHAR(30),
        @exceptiondate                        DATETIME,
        @logintechname                VARCHAR(50),
        @divisioncode                        CHAR(5),
        @lastupdateuser                VARCHAR (30),
        @lastupdatedate                DATETIME
)
 
AS

SET NOCOUNT ON

DECLARE @error        INT
DECLARE @rowcount        INT

        INSERT INTO        dbo.ExceptionExpiredTask
        (
                        ExceptionExpiredTaskGuid,
                        ExceptionTypeId,
                        PatientName,
                        PatientId,
                        SpecimenUid,
                        CprsOrderNumber,
                        ComponentClassOrdered,
                        Quantity,
                        DateWanted,
                        ExceptionComment,
                        ExceptionUser,
                        ExceptionDate,
                        LoginTechName,
                        DivisionCode,
                        LastUpdateUser,
                        LastUpdateDate
        )
        VALUES
        (
                        @exceptionexpiredtaskguid,
                        @exceptiontypeid,
                        @patientname,
                        @patientid,
                        @specimenuid,
                        @cprsordernumber,
                        @componentclassordered,
                        @quantity,
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @datewanted),
                        @exceptioncomment,
                        @exceptionuser,
                        dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @exceptiondate),
                        @logintechname,
                        @divisioncode,
                        @lastupdateuser,
                        @lastupdatedate
        )
        
        SELECT @error = @@ERROR, @rowcount = @@ROWCOUNT

        IF @rowcount <> 1 RAISERROR( 50003, 16, 1, 'ExceptionExpiredTask', @rowcount )

SET NOCOUNT OFF

RETURN(@error)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spInsertPatientTransfusion') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spInsertPatientTransfusion
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**
**        Desc: 
**
**        Author:         Carl Jensen
**
**        Date:        4/2/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        2/23/04        C. Jensen        Added LastUpdateFunctionID
**        04/21/04        M. Jablonski        Call fnTimeZoneConversionDateTime function on all dates
**        07/01/04        D. Askew        Added columns corresponding to new properties of a PT: BagReturnedIndicator,
**                                        BagHemolysisInspectionCode, BagClericalChecksOkIndicator, PreClericalChecksOkIndicator,
**                                        PostClericalChecksOkIndicator
**        07/20/04        M.Jablonski        Deleted those records added by David (per changes to DB model)
**        01/10/05        D. Askew        Removed GetUtcDate(); require use of valid @lastupdatedate
**        06/06/05         D. Askew        ** Reviewed for compliance with database standards and recommendations **
**                                        Added error handling; verified NO COUNT is ON/OFF
**        06/28/05         D. Askew        Comments updated
**        07/18/05        Lohse                @transfusionlocation changed to varchar(30)
**        09/02/05        Lohse                Changed comments field length from 255 to 510
**        03/18/11        D. Askew        Added new col @bedsideverificationunitmanualentryreason and existing one @bedsideverificationdate;
**                                        both are optional; added @applicationofrecordid and @interruptioncomment (both optional); 
**                                        made @locationien optional (CR 2959)
**        4/11/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spInsertPatientTransfusion
(
        @patienttransfusionguid                                 UNIQUEIDENTIFIER, 
        @patientguid                                         UNIQUEIDENTIFIER, 
        @bedsideverificationdate                        DATETIME                = NULL, 
        @bedsideverificationunitmanualentryreason        VARCHAR(200)                = NULL, 
        @transfusionlocation                                VARCHAR(30),
        @locationien                                        CHAR(8)                = NULL,
        @transfusionstartdatetime                        DATETIME, 
        @transfusionenddatetime                        DATETIME, 
        @bloodunitguid                                        UNIQUEIDENTIFIER,
        @transfusionist1id                                VARCHAR(30)                 = NULL, 
        @transfusionist2id                                VARCHAR(30)                 = NULL,
        @transfusedvolume                                INT                         = NULL,
        @interruptionindicator                                BIT,
        @reactionindicator                                BIT,
        @reactionsymptoms                                VARCHAR(510)                 = NULL,
        @applicationofrecordid                                TINYINT                = NULL,
        @interruptioncomment                                VARCHAR(510)                = NULL,
        @divisioncode                                        CHAR(5),
        @lastupdateuser                                VARCHAR(30),
        @lastupdatefunctionid                                 INT,
        @lastupdatedate                                DATETIME
)

AS
        
SET NOCOUNT ON

DECLARE @error        INT
DECLARE @rowcount        INT


        INSERT INTO dbo.PatientTransfusion 
        (
                PatientTransfusionGuid,
                PatientGuid,
                BedsideVerificationDate,
                BedsideVerificationUnitManualEntryReason,
                TransfusionLocation,
                LocationIen,
                TransfusionStartDateTime,
                TransfusionEndDateTime,
                BloodUnitGuid,
                Transfusionist1id,
                Transfusionist2id,
                TransfusedVolume,
                InterruptionIndicator,
                ReactionIndicator,
                ReactionSymptoms,
                ApplicationOfRecordId,
                InterruptionComment,
                DivisionCode,
                LastUpdateDate,
                LastUpdateUser,
                LastUpdateFunctionId
        ) 
        VALUES(
                @patienttransfusionguid, 
                @patientguid, 
                @bedsideverificationdate,
                @bedsideverificationunitmanualentryreason,
                @transfusionlocation,
                @locationien,
                dbo.fntimezoneconversiondatetime(@divisioncode, 1, @transfusionstartdatetime), 
                dbo.fntimezoneconversiondatetime(@divisioncode, 1, @transfusionenddatetime), 
                @bloodunitguid,
                @transfusionist1id, 
                @transfusionist2id,
                @transfusedvolume,
                @interruptionindicator,
                @reactionindicator,
                @reactionsymptoms,
                @applicationofrecordid,
                @interruptioncomment,
                @divisioncode,
                @lastupdatedate,
                @lastupdateuser,
                @lastupdatefunctionid
        )

        SELECT @error = @@ERROR, @rowcount = @@ROWCOUNT

        IF @rowcount <> 1 RAISERROR( 50003, 16, 1, 'PatientTransfusion', @rowcount )

SET NOCOUNT OFF

RETURN(@error)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spInsertRackTest') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spInsertRackTest
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**
**        Desc:         Insert a rack test
**
**        Author:         Krzysztof Dobranowski
**
**        Date:         01/16/2003
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        01/16/2003        Krzysztof Dobranowski        Initial creation.
**        02/05/2004        Greg Lohse                Adding LastUpdateFunctionId
**        04/21/2004        M. Jablonski                Call fnTimeZoneConversionDateTime function on all dates
**        01/10/2005        D. Askew                Added @lastupdatedate
**        06/06/2005         D. Askew                ** Reviewed for compliance with database standards and recommendations **
**                                                Added error handling; verified NO COUNT is ON/OFF
**        06/28/2005         D. Askew                Comments updated
**        07/18/2005        Lohse                        Changed @racktestresulttypecode from Char(3) to Char(5), updated error description
**        12/11/2009        K.Dobranowski                Added TestWithReagentGuid (CR 2696)
**        01/21/2010         K. Adu-Poku                ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spInsertRackTest
(
        @racktestguid                        UNIQUEIDENTIFIER,
        @racklotguid                        UNIQUEIDENTIFIER,
        @testdate                        DATETIME,
        @testtechid                        VARCHAR(30),
        @racktestresult                        CHAR(3)                 = NULL,
        @racktestresulttypecode                CHAR(5),
        @divisioncode                        CHAR(5),
        @recordstatuscode                CHAR(1),
        @testwithreagentguid                UNIQUEIDENTIFIER        = NULL,
        @lastupdateuser                VARCHAR(30),
        @lastupdatefunctionid                INT,
        @lastupdatedate                DATETIME
)

AS

SET NOCOUNT ON

DECLARE @error        INT
DECLARE @rowcount        INT

        INSERT INTO dbo.RackTest 
        (
                RackTestGuid,
                RackLotGuid,
                TestDate,
                TestTechId,
                RackTestResult,
                RackTestResultTypeCode,
                DivisionCode,
                RecordStatusCode,
                TestWithReagentGuid,
                LastUpdateDate,
                LastUpdateUser,
                LastUpdateFunctionId
        )
        VALUES
        (
                @racktestguid,
                @racklotguid,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @testdate),
                @testtechid,
                @racktestresult,
                @racktestresulttypecode,
                @divisioncode,
                @recordstatuscode,
                @testwithreagentguid,
                @lastupdatedate,
                @lastupdateuser,
                @lastupdatefunctionid
        )

        SELECT @error = @@ERROR, @rowcount = @@ROWCOUNT

        IF @rowcount <> 1 RAISERROR( 50003, 16, 1, 'RackTest', @rowcount )

SET NOCOUNT OFF

RETURN(@error)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spInvalidateBloodUnitTestsForReleasedOrderedUnit') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spInvalidateBloodUnitTestsForReleasedOrderedUnit
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**
**        Desc:         Invalidates blood unit test(s) for a released ordered unit
**
**        Author: David Askew
**
**        Date:         09/22/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                 Name                                Description
**        ----------------------        ------------------------------------------------        --------------------------------------------------------------------------------------------
**        11/30/2004        R Heiberger                        Added @rowversion
**         12/12/2004        R Heiberger                        Removed @rowversion 
**        01/10/05        D. Askew                        Added @lastupdatedate
**        06/06/2005         D. Askew                        ** Reviewed for compliance with database standards and recommendations **
**                                                        Added error handling; verified NO COUNT is ON/OFF
**        06/28/2005         D. Askew                        Comments updated
**        10/13/2005        C. Taylor                        The addition of row version doesn't work, because there are multiple tests per bloodunitguid and orderedcomponentguid
**                                                                Changing the sproc to receive bloodunittestguid instead of bloodunitguid and orderedcomponentguid or orderedtestguid
**        01/23/2006        M Smith                                ** Reviewed for compliance with database standards and recommendations **
**        07/20/2011        K. Dobranowski                        Added 3 new parameters and set RecordStatusCode to E to fix invalidation of partial crossmatch (CR 2995)
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spInvalidateBloodUnitTestsForReleasedOrderedUnit
(
        @bloodunittestguid                UNIQUEIDENTIFIER,
        @inactivatedate                        DATETIME,
        @inactivateuser                        VARCHAR(30),
        @testcomments                        VARCHAR(510),
        @lastupdateuser                VARCHAR(30),
        @lastupdatefunctionid                INT,
        @rowversion                         TIMESTAMP,
        @lastupdatedate                DATETIME
)
 
AS

SET NOCOUNT ON

DECLARE @error        INT
DECLARE @rowcount        INT


                UPDATE 
                        dbo.BloodUnitTest 
                SET        
                        RecordStatusCode = 'E',
                        InactivateDate = @inactivatedate,
                        InactivateUser = @inactivateuser,
                        TestComments = @testcomments,
                        LastUpdateUser = @lastupdateuser,
                        LastUpdateDate = @lastupdatedate,
                        LastUpdateFunctionId = @lastupdatefunctionid
                WHERE
                        BloodUnitTestGuid = @bloodunittestguid
                AND        [RowVersion]=@rowversion


        IF @error = 0 AND @rowcount <> 1 AND ( SELECT COUNT(1) FROM dbo.BloodUnitTest WHERE [RowVersion] = @rowversion ) <> 1 
                RAISERROR(50001, 16, 127)
        ELSE
                IF (@error = 0 AND @rowcount <> 1)        
                        SET @error = -1

SET NOCOUNT OFF

RETURN(@error)
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spOutGoingInvoiceReport2') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spOutGoingInvoiceReport2
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:        Gets the outgoing invoice data, header and detail
**
**        Author:        John Vrooland
**
**        Date:         10/24/2002
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        --------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        9/25/2003        C. Jensen        Various updates
**        12/4/2003        C. Jensen        Changed JOIN on V_BloodUnit since a blood unit may not have an FDA registration number
**        04/29/2004        M. Jablonski        Call fnTimeZoneConversionDateTime function on all dates; Added divisioncode
**        06/15/2004        C. Taylor        Replaced PatientGuid join with function fnGetPatientGuid to ensure latest patient details returned
**        10/11/2004        C.VanStedum     Changed to jon bloodunitshipment table for outgoing, incoming shipmentguids 
**        12/1/2004        C. Jensen        Added LastUpdateUser, changed column names to conform to standards
**        12/2/2004        S.Antropov        Removed references to fnGetInvoiceText (the function is not needed anymore since the invoice 
**                                        text is moved to VamcDivision table).
**         1/3/05                R Heiberger        Removed the second select statement and inserted a shortened, faster one. 
**        06/17/2005        Npaterson        Changed to use new view to increase performance
**        07/22/2005        N.Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed Name/input/output from comment header, added SET NOCOUNT, formatted SQL, 
**                                        specified object owners, Chaned error trap to check both SQL Statements
**        09/09/2005        D. Askew        Changed JOIN on Patient to select either the FinalMergeToPatient if the patient has one or more
**                                        merges (choosing the final merge record) or simply the patient guid if there are none
**        11/03/2005        D. Askew        Added fnTimeZoneConversionDateTime for UnitExpirationDate
**        01/23/2006        M Smith                ** Reviewed for compliance with database standards and recommendations **
**        09/10/2010        C.Van Stedum        removed LEFT OUTER JOIN dbo.Facility F ON Faciliy GUID (CR2722)
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spOutGoingInvoiceReport2
(
        @shipmentguid         UNIQUEIDENTIFIER,
        @divisioncode        CHAR(5)
)
AS

DECLARE @ERROR INT

SET NOCOUNT ON

        SELECT 

                S.InvoiceNumber, 

                    dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, S.ShipmentDate)                 AS ShipmentDate, 

                    S.ShipmentGUID, 
                    S.ShipmentTypeCode, 
                    S.ShipmentTemperature, 
                S.LastUpdateUser,
                        LS.FacilityName, 
                   LS.FdaRegistrationNumber, 
                    LS.IccbbaRegistrationNumber,
                        A.AddressLine1,
                        A.AddressLine2,
                        A.AddressLine3,
                        ISNULL(A.AddressCity,'') + ', ' + 
                            ISNULL(A.StateCode,'') + ' ' + 
                            ISNULL(A.AddressZipCode,'')                                                         AS CityStateZip,
                        ST.ShipmentTypeText,
                        LS.PhoneNumber,
                        LS.FaxNumber,
                        V.DivisionName                                                                         AS [SenderFacilityName],
                        LocalSupplier_1.FdaRegistrationNumber                                                 AS [Sender FDA Reg. No],
                        Address_1.AddressLine1                                                         AS [SenderAddressLine1],
                        Address_1.AddressLine2                                                         AS [SenderAddressLine2],
                        Address_1.AddressLine3                                                         AS [SenderAddressLine3],
                        ISNULL(Address_1.AddressCity + ', ','') + 
                        ISNULL(Address_1.StateCode + ' ','') + 
                        ISNULL(Address_1.AddressZipCode,'')                                                 AS [SenderCityStateZip],
                        V.InvoiceTemplateText                                                                 AS InvoiceTemplateText

            FROM 


                dbo.Shipment S

                    INNER JOIN dbo.ShipmentType ST ON 

                                S.ShipmentTypeCode = ST.ShipmentTypeCode 

                INNER JOIN dbo.LocalSupplier LS ON 

                            S.LocalSupplierGUID = LS.LocalSupplierGUID 

                INNER JOIN dbo.VamcDivision V ON 

                            S.DivisionCode = V.DivisionCode 

                LEFT OUTER JOIN dbo.LocalSupplier LocalSupplier_1 ON 

                            V.LocalSupplierGUID = LocalSupplier_1.LocalSupplierGUID 

                    LEFT OUTER JOIN dbo.Address Address_1 ON 

                                LocalSupplier_1.AddressGUID = Address_1.AddressGUID 

                    LEFT OUTER JOIN dbo.Address A ON 

                                LS.AddressGUID = A.AddressGUID


                   

        WHERE 

                (S.ShipmentGUID = @shipmentguid) AND 

                        (S.ShipmentDirection = '0')

SET @ERROR = @@ERROR
        IF @ERROR !=0 GOTO SPROC_EXIT


SELECT DISTINCT 

                dbo.V_BloodUnit.BloodUnitGUID, 
                        dbo.V_BloodUnit.EyeReadableUnitID, 
                        RTRIM(dbo.V_BloodUnit.BloodTypeCode) + ' ' + dbo.V_BloodUnit.RhFactorText                                                                                         AS [ABORh], 

                        CASE dbo.V_BloodUnit.BiohazardousWarningIndicator 
                        WHEN '1' THEN 
                                'Yes' 
                        ELSE 
                                '' 
                END                                                                                                                                                                 AS BioHazardous, 

                        BloodProduct.ProductName,
                        BloodProduct.ProductShortName,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, dbo.V_BloodUnit.UnitExpirationDate)                                                                         AS UnitExpirationDate, 

                ISNULL('Tests: ' + dbo.fnBloodUnitTests(dbo.V_BloodUnit.BloodUnitGUID),'') + ISNULL(' Antigens: ' + dbo.fnBloodUnitAntigens(dbo.V_BloodUnit.BloodUnitGUID),'')         AS [Tests],

                        ISNULL(Patient.PatientMiddleName,'') + ' ' +ISNULL(Patient.PatientLastName,'')                                                                                         AS [PatientDisplayName]

        FROM dbo.V_BloodUnit 

                JOIN dbo.BloodProduct ON 

                        dbo.V_BloodUnit.BloodProductGUID = BloodProduct.BloodProductGUID

                JOIN dbo.BloodUnitStatus ON 

                        dbo.V_BloodUnit.BloodUnitGuid=BloodUnitStatus.BloodUnitGuid 

                LEFT OUTER JOIN dbo.Patient ON 

                        V_BloodUnit.DirectedPatientGUID = COALESCE(dbo.Patient.FinalMergeToPatient, dbo.Patient.PatientGuid)

            WHERE 

                (dbo.V_BloodUnit.OutgoingShipmentGuid = @shipmentguid) 

                AND 
                        (
                        BloodUnitStatus.LastUpdateDate = 
                                        (
                                        SELECT 
                                                MAX(BUS.LastUpdateDate)
                                        FROM 
                                                dbo.BloodUnitStatus BUS
                                                     WHERE 
                                                dbo.V_BloodUnit.BloodUnitGuid = BUS.BloodUnitGuid
                                        )
                )


SET @ERROR = @@ERROR

SPROC_EXIT:

        SET NOCOUNT OFF
        RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spReleaseRestriction') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spReleaseRestriction
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Release a patient restriction  in BloodUnitMedia
**
**        Author: Carrie Van Stedum
**
**        Date:         10/16/2009
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        --------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.spReleaseRestriction
(
        @bloodunitmediaguid                           UNIQUEIDENTIFIER,
        @removerestrictiontechid                     VARCHAR(30),
        @removerestrictiondate                             DATETIME,
        @comments                                          VARCHAR(30),
        @lastupdateuser                             VARCHAR(30),
        @lastupdatefunctionid                             INT,
        @rowversion                                     TIMESTAMP,
        @divisioncode                                      CHAR(5),
        @lastupdatedate                             DATETIME
)

AS

SET NOCOUNT ON

DECLARE         @ERROR                INT,
                @ROWCOUNT        INT
                
        UPDATE 

                dbo.BloodUnitMedia
        
        SET                
                DirectedPatientGuid                = null,
                RemoveRestrictionDate                = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @removerestrictiondate),
                RemoveRestrictionTechId        = @removerestrictiontechid,
                Comments                                   = @comments,
                LastUpdateUser                        = @LastUpdateUser,
                LastUpdateDate                        = @lastupdatedate,
                LastUpdateFunctionId                = @LastUpdateFunctionId

        WHERE        

                BloodUnitMediaGUID        = @bloodunitmediaguid

        AND        [RowVersion]                = @RowVersion
        
        SELECT @ERROR = @@ERROR, @ROWCOUNT = @@ROWCOUNT

        IF @ERROR = 0 AND @ROWCOUNT <> 1 AND ( SELECT COUNT(1) FROM dbo.OrderedUnit WHERE [RowVersion] = @rowversion ) <> 1 
                RAISERROR(50001, 16, 127)
        ELSE
                IF (@ERROR = 0 AND @ROWCOUNT <> 1)        
                        SET @ERROR = -1

SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spSingleBloodProductModification') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spSingleBloodProductModification
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Returns all possible target BloodProducts for a given modification
**
**        Author:        Dan McHugh
**
**        Date:         10/14/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        10/14/04        D. McHugh        Created
**        11/15/04        D. McHugh        Added logic to handle pooling
**        12/06/04        D. McHugh        Added logic for Codabar Thaw rule (explained below)
**        01/27/05        D. McHugh        Let's ignore some attributes when pooling
**        06/01/05        D. McHugh        Now choosing from BloodProduct only when RecordStatusCode = 'A'
**        07/13/05        D. McHugh        DR1430 - Allowing Leukoreduce to map to any D_ attribute (except D0, D1)
**        07/18/05        D. McHugh        DR1602 - Revised Truth table
**                                        Modified code to determine ISBT vs Codabar to use 'E' or 'F' as ISBT
**                                        Added SET NOCOUNTs
**        07/12/2005        N.Paterson        ** Secondary review for compliance with database standards and recommendations **
**                                        Modified comment header, specified object owners, formatted SQL
**        02/22/2006        D. McHugh        Fixed line 345 - Making the list of exclusions agree with the list in the preface to TT_26
**        04/19/2006        D. McHugh        CR1661  - allow blood products with a RecordStatusCode = 'L' to be modified
**                                                - allow the procedure to add more targets to match multiple D_ targets for Leukoreduce (using LIKE)
**        04/01/2009        D. McHugh        CR2621 - Changed how the product attribute forms are compared by removing the calls to function
**                                                fnRemoveAttributes and adding calls to function fnCompareProductAttributeForms
**                                                Commented out code for pooling/thawpooling that was handling C2/D_ attributes
**        08/05/10        M. Smith        Added logic to not allow "E" attributes on the original for Volume Reduce. (CR2612)
**        08/05/10        M. Smith        Checked the ModfiicationAllowedIndicator on the ProductAttribute table to exclude modifications
**                                        on blood products that have attributes that are not modifiable. (CR 2744)
**        08/05/10        M. Smith        Changed @FromProductAttributeForm, @ToProductAttributeForm, FromProductAttributeForm, and 
**                                        ToProductAttributeForm to VARCHAR(40). (CR2765)
**        08/16/10        M. Smith        Changed to use OriginalProductTypeCode from the BloodProduct table when determining target
**                                        products and modification expiration dates (CR 2735)        
**        08/03/11        M. Smith        Changed to add optional attribute on the target product without consideration of the from product. (CR 3109)
*******************************************************************************************************************************************************************************/

CREATE PROCEDURE dbo.spSingleBloodProductModification (
        @pBloodProductGuid                 UNIQUEIDENTIFIER,        
        @pProductModificationCode         CHAR(1),                -- The modification being done
        @pMethodSelect                 INTEGER = -1,                -- 1 = opened, 0 = closed, -1 = either
        @pReturnData                        BIT = 1
)

AS


SET NOCOUNT ON

/*******************************************************************************************************************************************************************************
**
**        The process of determining the correct ToProductCode is a fun one!!
**
**        1.  Find the ProductAttributeForm in BloodProduct matching the parameter BloodProductGuid
**                save this value as FromProductAttributeForm
**        2.  Use the truth table PermittedProductModification to determine the new ToProductAttributeForm(s)
**                (Since a single modification can map to multiple core conditions, it's possible to return
**                 more than one ToProductAttributeForm)
**        3.  Apply all special rules
**                - Rule 7 - ProductAttributeForm cannot contain A2, A3, or A4
**                - Rule 9 - Target ProductAttributeForm can't contain B2 when Method is closed
**                - Do not include where ProductModificationCode = 'I' and the FromProductAttributeForm has 'C2'
**                - Do not include where ProductModificationCode = 'L' and the FromProductAttributeForm has ' D_'
**                - If ProductModificationCode is 'P' or 'U', and there's a Pool going (parameters @pPooledProductTypeCode
**                        and @pPooledProductCode), then adjust the ToProductAttributeForm for the pool.
**                - Codabar Thaw rule - If thawing a Codabar unit of FFP or Cryo, the ToProductCode must = the FromProductCode
**        4.  Find the ProductCode(s) on BloodProduct matching the ToProductTypeCode(s) & ToProductAttributeForm(s)
**                The ToProductTypeCode(s) come directly from the truth table, based on the incoming data
**        5.  Remove any incomplete records.
**                The truth table lists all possible modifications.  Not every modification has actually been
**                performed, so not every possible ProductCode exists on BloodProduct
**        6.  Return all remaining records
**
*******************************************************************************************************************************************************************************/

DECLARE @ProductModificationCode CHAR(1)        --From TT
DECLARE @MethodSelect INTEGER                        --From TT
DECLARE @AddTargetAttribute VARCHAR(20)                --From TT, must be empty, or formatted like '__ __ __ __ ...etc...'
DECLARE @FromBloodProductGuid UNIQUEIDENTIFIER        --From BP
DECLARE @FromProductTypeCode VARCHAR(4)        --From TT
DECLARE @FromProductCode VARCHAR(5)                --From BP
DECLARE @FromCoreCondition VARCHAR(3)                --From TT
DECLARE @FromProductAttributeForm VARCHAR(40)        --From BP
DECLARE @ToProductTypeCode VARCHAR(4)                --From TT
DECLARE @ToProductCode VARCHAR(5)                --Calculated from TT/BP
DECLARE @ToCoreCondition VARCHAR(3)                --From TT
DECLARE @ToProductAttributeForm VARCHAR(40)        --Calculated from TT/BP
DECLARE @ExpirationDateRule INT                        -- From TT

DECLARE @Attribute CHAR(2)                        --calculated from @AddTargetAttribute
DECLARE @Counter INTEGER                        --simple counter

DECLARE @Rows INTEGER                                --Number of rows in resulting cursor
DECLARE @TargetLabelType VARCHAR(20)                --Shooting for a Codabar or ISBT?

--This was used to help debug things, only useful when you can see the Print statement (like from Query Analyzer)
DECLARE @ShowFilteredRecords INTEGER                --  1 = Showing records being filtered out, 0 = only show final result
DECLARE @ProductAttributeForm        VARCHAR(40)

SET @ShowFilteredRecords = 0

SET @Rows = 0

--Using this temp table to keep all ProductModificationCode, ProductTypeCode, ProductCode, ProductAttributeForm data (before & after mod'd)
DECLARE @BPMTemp TABLE (
        ProductModificationCode CHAR(1),        --From TT
        MethodSelect                 INTEGER,                --From TT
        AddTargetAttribute         VARCHAR(20),                --From TT
        FromBloodProductGuid         UNIQUEIDENTIFIER,        --From BP
        FromProductTypeCode         VARCHAR(4),                --From TT
        FromProductCode         VARCHAR(5),                --From BP
        FromCoreCondition         VARCHAR(3),                --From BP
        FromProductAttributeForm VARCHAR(40),                --From BP
        ToBloodProductGuid         UNIQUEIDENTIFIER,        --From BP
        ToProductTypeCode         VARCHAR(4),                --From TT
        ToProductCode                 VARCHAR(5),                --From BP based on ToProductAttributeForm
        ToCoreCondition         VARCHAR(3),                --From TT
        ToProductAttributeForm         VARCHAR(40),        --Calculated from FromProductAttributeForm, ToCoreCondition, AddTargetAttribute
        ExpirationDateRule         INTEGER                --From TT
)

DECLARE BP2Cursor CURSOR FAST_FORWARD
FOR SELECT TT.ProductModificationCode,
        TT.MethodSelect,
        ISNULL(TT.AddTargetAttribute, '') AddTargetAttribute, 
        BP.BloodProductGuid,
        TT.FromProductTypeCode,
        BP.ProductCode,
        Left(BP.ProductAttributeForm, 3),
        BP.ProductAttributeForm,
        --NULL, --still need more info before calculating ToBloodProductGuid
        TT.ToProductTypeCode,
        '', --still need more info before calculating ToProductCode
        CASE WHEN ToCoreCondition = 'Sam'
                THEN LEFT(BP.ProductAttributeForm, 3)
                ELSE TT.ToCoreCondition
        END AS ToCoreCondition,
        CASE WHEN ToCoreCondition = 'Sam'
                THEN BP.ProductAttributeForm
                   WHEN FromCoreCondition = 'Any'
                THEN ToCoreCondition + RIGHT(BP.ProductAttributeForm, LEN(BP.ProductAttributeForm) - 3)
                ELSE REPLACE(BP.ProductAttributeForm, FromCoreCondition, ToCoreCondition)
        END AS ToProductAttributeForm,
        TT.ExpirationDateRule

                FROM dbo.BloodProduct BP 
                        JOIN PermittedProductModification TT 
                                ON BP.OriginalProductTypeCode = TT.FromProductTypeCode
                WHERE (LEFT(BP.ProductAttributeForm, 3) = TT.FromCoreCondition OR TT.FromCoreCondition = 'Any')
                        AND TT.ProductModificationCode = @pProductModificationCode
                        AND (TT.MethodSelect = @pMethodSelect OR @pMethodSelect = -1)
                        AND BP.BloodProductGuid = @pBloodProductGuid                                 
                        AND BP.RecordStatusCode IN ('A', 'L')

OPEN BP2Cursor
FETCH NEXT FROM BP2Cursor INTO @ProductModificationCode, @MethodSelect, @AddTargetAttribute, @FromBloodProductGuid, @FromProductTypeCode, @FromProductCode, 
                                @FromCoreCondition, @FromProductAttributeForm, @ToProductTypeCode, @ToProductCode, @ToCoreCondition, 
                                @ToProductAttributeForm, @ExpirationDateRule
WHILE @@FETCH_STATUS = 0
BEGIN

        SET @Counter = 2

        WHILE @Counter <= LEN(RTRIM(@AddTargetAttribute))

        BEGIN        
                SET @Attribute = SUBSTRING(@AddTargetAttribute, @Counter - 1, 2)

                IF LEFT(@Attribute, 1) BETWEEN 'A' AND 'N'
                BEGIN
                        --Call function responsible for logic in adding attributes
                        SET @ToProductAttributeForm = dbo.fnAddAttributeToProductAttributeForm(@Attribute, @ToProductAttributeForm)
                END

                IF SUBSTRING(@AddTargetAttribute, @Counter + 1, 1) = '*'
                BEGIN
                        SET @Counter = @Counter + 4
                END
                ELSE
                BEGIN
                        SET @Counter = @Counter + 3
                END

        END

        SET @Counter = 0
        WHILE CHARINDEX('*', @AddTargetAttribute, @Counter) > 0
        BEGIN
                SET @Counter = CHARINDEX('*', @AddTargetAttribute, @Counter)
                SET @ToProductAttributeForm = REPLACE(@ToProductAttributeForm, SUBSTRING(@AddTargetAttribute, @Counter - 2, 2),  SUBSTRING(@AddTargetAttribute, @Counter - 2, 2) + '$')
                SET @Counter = @Counter + 1
        END

        -- Set optional attributes

        IF (@pProductModificationCode <> 'V' OR (@pProductModificationCode = 'V' AND @FromProductTypeCode = 'E002'))
        BEGIN

                DECLARE AttributeCursor CURSOR FAST_FORWARD
                FOR  SELECT OptionalAttribute
                  FROM ProductModificationAttribute
                        JOIN dbo.fnSplit(@FromProductAttributeForm, ' ') 
                                        ON LEFT(OptionalAttribute, 1) = LEFT(Item, 1)
                 WHERE ProductModificationCode = @pProductModificationCode
                
                OPEN AttributeCursor
                FETCH NEXT FROM AttributeCursor INTO @Attribute
                
                WHILE @@FETCH_STATUS = 0
                BEGIN
                
                        IF @ToProductAttributeForm like '% ' + LEFT(@Attribute, 1) + '_%'
                        BEGIN
                                SET @ToProductAttributeForm = LEFT(@ToProductAttributeForm, CHARINDEX(' ' + LEFT(@Attribute, 1), @ToProductAttributeForm) + 1) + '$' + RIGHT(@ToProductAttributeForm, LEN(@ToProductAttributeForm) - (CHARINDEX(' ' + LEFT(@Attribute, 1), @ToProductAttributeForm) + 2))
                        END
                        ELSE
                        BEGIN
                                SET @ToProductAttributeForm = dbo.fnAddAttributeToProductAttributeForm(@Attribute, @ToProductAttributeForm)
                        END
                        FETCH NEXT FROM AttributeCursor INTO @Attribute
                END
                
                CLOSE AttributeCursor
                DEALLOCATE AttributeCursor
        END

        IF NOT EXISTS (SELECT * FROM ProductAttribute 
                        JOIN dbo.fnSplit(@FromProductAttributeForm, ' ') 
                                ON ProductAttributeId = Item
                                  AND ModificationAllowedIndicator = 0)

           AND NOT EXISTS (SELECT * FROM ProductAttribute 
                        JOIN dbo.fnSplit(@ToProductAttributeForm, ' ') 
                                ON ProductAttributeId = Item
                                  AND ModificationAllowedIndicator = 0)
                   
        BEGIN

                INSERT INTO @BPMTemp
                        (ProductModificationCode, MethodSelect, AddTargetAttribute, FromBloodProductGuid, FromProductTypeCode, FromProductCode, 
                        FromCoreCondition, FromProductAttributeForm, ToProductTypeCode, ToProductCode, ToCoreCondition, ToProductAttributeForm, 
                        ExpirationDateRule)
                SELECT  @ProductModificationCode, @MethodSelect, @AddTargetAttribute, @FromBloodProductGuid, @FromProductTypeCode, @FromProductCode, 
                        @FromCoreCondition, @FromProductAttributeForm, @ToProductTypeCode, @ToProductCode, @ToCoreCondition, ProductAttributeForm, 
                        @ExpirationDateRule
                  FROM  dbo.fnExpandOptionalProductAttributes (@ToProductAttributeForm)
        END

        FETCH NEXT FROM BP2Cursor INTO @ProductModificationCode, @MethodSelect, @AddTargetAttribute, @FromBloodProductGuid, @FromProductTypeCode, 
                                @FromProductCode, @FromCoreCondition, @FromProductAttributeForm, @ToProductTypeCode, @ToProductCode, @ToCoreCondition, 
                                @ToProductAttributeForm, @ExpirationDateRule
END

CLOSE BP2Cursor
DEALLOCATE BP2Cursor

--Since on the truth table, a FromCoreCondition can map to more than one ToCoreCondition,
-- the table @BPMTemp may have more than one record
IF (SELECT COUNT(1) FROM @BPMTemp) = 0
BEGIN

        RETURN 0

END

--Section TT_26.02, Rule 9 - Target ProductAttributeForm can't contain B2 when Method is closed
IF EXISTS (SELECT * FROM @BPMTemp
        WHERE MethodSelect = 0 AND
                ToProductAttributeForm NOT LIKE ('% B2%') AND
                FromProductAttributeForm LIKE ('% B2%'))

        BEGIN
                IF @ShowFilteredRecords = 1                
                BEGIN
                        SELECT 'Not including for Rule 9 - Target ProductAttributeForm cannot have B2 when Method is closed' AS Reason, * 
                          FROM @BPMTemp
                         WHERE MethodSelect = 0 AND
                                ToProductAttributeForm LIKE ('% B2%')
                END
        
                DELETE FROM @BPMTemp WHERE MethodSelect = 0 AND
                        ToProductAttributeForm NOT LIKE ('% B2%') AND
                        FromProductAttributeForm LIKE ('% B2%')

        END


--Do not include where ProductModificationCode = 'I' and the FromProductAttributeForm has 'C2'
IF EXISTS (SELECT * FROM @BPMTemp

        WHERE ProductModificationCode = 'I' AND FromProductAttributeForm LIKE '% C2%')

        BEGIN
                IF @ShowFilteredRecords = 1
                BEGIN
                        SELECT 'Not including where ProductModificationCode = I and FromProductAttributeForm has C2' AS Reason, * 
                          FROM @BPMTemp
                         WHERE ProductModificationCode = 'I' And FromProductAttributeForm LIKE '% C2%'
                END

                DELETE FROM @BPMTemp WHERE ProductModificationCode = 'I' AND FromProductAttributeForm LIKE '% C2%'
        END


--Do not include where ProductModificationCode = 'L' and the FromProductAttributeForm has 'D_'
IF EXISTS (SELECT * FROM @BPMTemp 

        WHERE ProductModificationCode = 'L' AND FromProductAttributeForm LIKE '% D_%')

        BEGIN

                IF @ShowFilteredRecords = 1

                        SELECT 'Not including where ProductModificationCode = L and FromProductAttributeForm has D_' AS Reason, * FROM @BPMTemp 

                        WHERE ProductModificationCode = 'L' AND FromProductAttributeForm LIKE '% D_%'

                DELETE FROM @BPMTemp WHERE ProductModificationCode = 'L' AND FromProductAttributeForm LIKE '% D_%'

        END

--Do not include where ProductModificationCode = 'V' and the FromProductAttributeForm has 'E_'
IF EXISTS (SELECT * FROM @BPMTemp 

        WHERE ProductModificationCode = 'V' AND FromProductAttributeForm LIKE '% E_%')

        BEGIN

                IF @ShowFilteredRecords = 1

                        SELECT 'Not including where ProductModificationCode = V and FromProductAttributeForm has E_' AS Reason, * FROM @BPMTemp 

                        WHERE ProductModificationCode = 'V' AND FromProductAttributeForm LIKE '% E_%'

                DELETE FROM @BPMTemp WHERE ProductModificationCode = 'V' AND FromProductAttributeForm LIKE '% E_%'

        END

IF EXISTS (SELECT * FROM dbo.BloodProduct WHERE BloodProductGuid = @pBloodProductGuid AND ProductCodeIndicator = 1)
        SET @TargetLabelType = 'ISBT'

ELSE IF EXISTS (SELECT * FROM dbo.BloodProduct WHERE BloodProductGuid = @pBloodProductGuid AND ProductCodeIndicator = 0)
        SET @TargetLabelType = 'Codabar'
ELSE
        SET @TargetLabelType = 'Either'


--The ToProductAttributeForms should now all be calculated.  Time to look up the corresponding ProductCode
-- Only use a ProductCode that matches the Label type (ISBT vs. Codabar) - so don't go grabbing
-- a Codabar ToProductCode for an ISBT FromProductCode & vice versa

IF @pProductModificationCode = 'S' --AND @TargetLabelType = 'Codabar'
        
        UPDATE @BPMTemp
                SET ToProductCode = FromProductCode,
                        ToBloodProductGuid = FromBloodProductGuid

ELSE

        UPDATE @BPMTemp
                SET ToProductCode = BP.ProductCode,
                        ToBloodProductGuid = BP.BloodProductGuid

                FROM @BPMTemp TT JOIN dbo.BloodProduct BP
                ON         TT.ToProductTypeCode = BP.OriginalProductTypeCode
                WHERE BP.ProductAttributeForm  = TT.ToProductAttributeForm AND
                        ((ProductCodeIndicator = 0 AND @TargetLabelType = 'Codabar') OR
                         (ProductCodeIndicator = 1 AND @TargetLabelType = 'ISBT'))



--Are we doing Codabar?  Cuz if so, it's possible that there are multiple ProductCode's
-- for the given ProductAttributeForm + ProductTypeCode

IF @pProductModificationCode <> 'S'

        --Basically repeating that last Update statement, change it into Insert, and filter
        -- out the ProductCode that was already updated
        INSERT INTO @BPMTemp

                SELECT TT.ProductModificationCode, TT.MethodSelect, TT.AddTargetAttribute, 
                        TT.FromBloodProductGuid, TT.FromProductTypeCode, TT.FromProductCode, TT.FromCoreCondition, TT.FromProductAttributeForm,
                        BP.BloodProductGuid, TT.ToProductTypeCode, BP.ProductCode, TT.ToCoreCondition, TT.ToProductAttributeForm,
                        TT.ExpirationDateRule

                FROM @BPMTemp TT JOIN dbo.BloodProduct BP
                ON        TT.ToProductTypeCode = BP.OriginalProductTypeCode
                WHERE         BP.ProductAttributeForm LIKE TT.ToProductAttributeForm AND
                        ((@TargetLabelType <> 'ISBT' AND ProductCodeIndicator = 0) OR
                        (@TargetLabelType = 'ISBT' AND ProductCodeIndicator = 1)) AND
                        TT.ToProductCode <> BP.ProductCode

/*
-- Codabar Thaw rule - If thawing a Codabar unit of FFP or Cryo, the ToProductCode must = the FromProductCode
IF @pProductModificationCode = 'T'
        BEGIN
                DELETE FROM @BPMTemp

                WHERE FromProductTypeCode IN

                        (SELECT DISTINCT ProductTypeCode FROM dbo.ProductType WHERE ProductTypePrintName LIKE '%FFP%' OR ProductTypePrintName LIKE '%Cryo%') AND
                        LEFT(FromProductCode, 1) NOT LIKE ('[EF]') AND
                        FromProductCode <> ToProductCode                        
        END

*/

--Removing records with no matching ToProductCode
--This happens because the truth table allows for a particular modification, but there's no corresponding bloodproduct
IF (SELECT COUNT(1) FROM @BPMTemp WHERE ToProductCode = '') > 0

        BEGIN
                IF @ShowFilteredRecords = 1
                        SELECT 'Skipping records with no matching ToProductCode' AS Reason, * FROM @BPMTemp
                        WHERE ToProductCode = ''

                DELETE FROM @BPMTemp WHERE ToProductCode = ''
        END


--Remove records where the split modification doesn't match
DELETE FROM @BPMTemp WHERE ProductModificationCode = 'S' AND FromProductCode <> ToProductCode

THEEND:
--All right, let's end this thing already.

SELECT @Rows = COUNT(*) FROM @BPMTemp

IF @Rows > 0 AND @pReturnData = 1
BEGIN

                SELECT * FROM  @BPMTemp

                ORDER BY FromProductTypeCode, FromProductCode, ToProductTypeCode, ToProductCode

END

SET NOCOUNT OFF

RETURN @Rows

--And we're done!
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spUpdateAntibodyTypes') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spUpdateAntibodyTypes
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Updates Anitbody types
**
**        Author: Krzysztof Dobranowski        
**
**        Date:         12/09/2002
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        --------------        ---------                -----------------
**        01/24/2004        Greg Lohse        Adding LastUpdateFunctionID
**         03/08/2004        M.Jablonski        Added error handling
**        01/10/2005        D. Askew        Added @lastupdatedate
**        06/27/2005        M. Smith        Reviewed for compliance with database standards and recommendations.  Removed 
**                                        division code from where clause.  SET NOCOUNT on and off. Added dbo. to updated table.
**        08/07/2005        M. Smith        Capitalized reserved words
**        07/14/2011        C. Jensen        Added null to the compatibility percentage parameter per CR3054.
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spUpdateAntibodyTypes
(
        @antibodytypeid                        INT,
        @higherleveloverrideindicator        BIT,
        @compatibilitypercentage        TINYINT = null,
        @divisioncode                        CHAR(5),
        @rowversion                        TIMESTAMP,
        @lastupdateuser                VARCHAR(30),
        @lastupdatefunctionid                INT,
        @lastupdatedate                DATETIME
)

 AS

DECLARE        @ERROR        INT,
                @ROWCOUNT        INT

SET NOCOUNT ON

        UPDATE
                dbo.AntibodyParameter
        SET
                HigherLevelOverrideIndicator         = @higherleveloverrideindicator,
                CompatibilityPercentage                = @compatibilitypercentage,
                LastUpdateDate                        = @lastupdatedate,
                LastUpdateUser                 = @lastupdateuser,
                LastUpdateFunctionID                = @lastupdatefunctionid
        WHERE
                AntibodyTypeID = @antibodytypeid
        AND        [RowVersion] = @rowversion


        SELECT @ERROR = @@ERROR, @ROWCOUNT = @@ROWCOUNT

        IF @ERROR = 0 AND @ROWCOUNT <> 1 AND ( SELECT COUNT(1) FROM dbo.AntibodyParameter WHERE [RowVersion] = @rowversion ) <> 1 
                RAISERROR(50001, 16, 127)
        ELSE
                IF (@ERROR = 0 AND @ROWCOUNT <> 1)        
                        SET @ERROR = -1

SET NOCOUNT OFF

RETURN (@ERROR)
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spUpdateDivision') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spUpdateDivision
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Update the information in a row of the VamcDivision table.
**
**        Author:         Cameron Taylor        
**
**        Date:         10/30/2002
*********************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        4/8/2003        LMeyer                Added ServiceTypeIndicator,         
**                                                                        AntibodyScreenDisplayCode,
**                                                                        AutoInstrumentIndicator,
**                                                                        MaximumSpecimenExprationDays
**        5/13/2003        LMeyer                Took out row version check
**        1/14/2004        C. Jensen        Added fields related to Division alerts.        
**        1/15/2004        C. Taylor        Changed length of LoginMessageText to 255 to match New Data Fields table
**        01/28/2004        Greg Lohse        Adding LastUpdateFunctionId
**        03/04/2004        C. Taylor        Added MedicalDirectorName
**        04/08/2004        Greg Lohse        Adding DivisionGUID field
**        12/08/2004        Stas Antropov        Removed ServiceTypeIndicator (moved to MUC02)
**        01/10/2005        D. Askew        Added @lastupdatedate
**        06/27/2005        M. Smith        Reviewed for compliance with database standards and recommendations.  SET NOCOUNT on and off.
**                                        Added dbo. to updated table.
**        08/07/2005        M. Smith        Capitalized reserved words
**        09/02/2005        Lohse                Changed comments field length from 255 to 510
**        10/01/2009        K. Dobranowski Added ReactivityPhaseCode (CR 2717)
**        08/18/2010        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spUpdateDivision
        (
        @divisioncode                                CHAR(5),
        @divisionguid                                UNIQUEIDENTIFIER = NULL,
        @electroniccrossmatchindicator                BIT,
        @iccbbaregistrationnumber                CHAR(5), 
        @antibodyscreendisplaycode                 INT,
        @autoinstrumentindicator                 BIT,
        @maximumspecimenexpirationdays         INT,
        @medicaldirectorname                        VARCHAR(30),
        @iconalertsindicator                        BIT = NULL,
        @iconorderalerttypecode                        CHAR(1) = NULL,
        @iconordersneededhours                INT = NULL,
        @iconrefreshrate                        INT = NULL,
        @printeralertsindicator                        BIT = NULL,
        @printerorderalerttypecode                CHAR(1) = NULL,
        @printerordersneededhours                INT = NULL,
        @printeralertsprintername                VARCHAR(50) = NULL,
        @loginmessagetext                        VARCHAR(510) = NULL,
        @lastupdateuser                         VARCHAR(30), 
        @rowversion                                 TIMESTAMP,
        @lastupdatefunctionid                        INT,
        @lastupdatedate                        DATETIME,
        @reactivityphasecode                        CHAR
        )

AS

SET NOCOUNT ON

DECLARE        @ERROR        INT,
                @ROWCOUNT        INT

        UPDATE 
                dbo.VamcDivision 
        SET
                ElectronicCrossmatchIndicator = @electroniccrossmatchindicator,
                IccbbaRegistrationNumber = @iccbbaregistrationnumber,
                AntibodyScreenDisplayCode=@antibodyscreendisplaycode,
                AutomatedInstrumentIndicator=@autoinstrumentindicator,
                MaximumSpecimenExpirationDays=@maximumspecimenexpirationdays,
                MedicalDirectorName = @medicaldirectorname,
                --Division Alerts:
                IconAlertsIndicator=@iconalertsindicator,
                IconOrderAlertTypeCode=@iconorderalerttypecode,
                IconOrdersNeededHours=@iconordersneededhours,
                IconRefreshRate=@iconrefreshrate,
                PrinterAlertsIndicator=@printeralertsindicator,
                PrinterOrderAlertTypeCode=@printerorderalerttypecode,
                PrinterOrdersNeededHours=@printerordersneededhours,
                PrinterAlertsPrinterName=@printeralertsprintername,
                LoginMessageText=@loginmessagetext,
                LastUpdateDate = @lastupdatedate,
                LastUpdateUser = @lastupdateuser,
                LastUpdateFunctionId = @lastupdatefunctionid,
                ReactivityPhaseCode = @reactivityphasecode
        WHERE
                DivisionCode = @divisioncode
        AND        [RowVersion] = @rowversion


        SELECT @ERROR = @@ERROR, @ROWCOUNT = @@ROWCOUNT

        IF @ERROR = 0 AND @ROWCOUNT <> 1 AND ( SELECT COUNT(1) FROM dbo.VamcDivision WHERE [RowVersion] = @rowversion ) <> 1 
                RAISERROR(50001, 16, 127)
        ELSE
                IF (@ERROR = 0 AND @ROWCOUNT <> 1)        
                        SET @ERROR = -1

SET NOCOUNT OFF

RETURN (@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spUpdatePatientTransfusionRecord') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spUpdatePatientTransfusionRecord
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:        Saves patient transfusion record
**
**        Author:        Carl Jensen
**
**        Date:         03/31/2004
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        04/21/04        M. Jablonski        Call fnTimeZoneConversionDateTime function on all dates
**        07/01/04        D. Askew        Added columns corresponding to new properties of a PT: BagReturnedIndicator,
**                                        BagHemolysisInspectionCode, BagClericalChecksOkIndicator, PreClericalChecksOkIndicator,
**                                        PostClericalChecksOkIndicator
**        07/20/04        M.Jablonski        Deleted those records added by David (per changes to DB model)
**        01/10/05        D. Askew        Added @lastupdatedate
**        06/29/05        M. Smith        Reviewed for compliance with database standards and recommendations.  SET NOCOUNT on and off.
**                                        Removed update of primary key.  Added dbo. to updated table.
**        08/08/05        M. Smith        Capitalized reserved words, included error check on date function calls, modified dates outside
**                                        of update statement.
**        09/02/05        Lohse                Changed comments field length from 255 to 510
**        03/18/11        D. Askew        Added new col @bedsideverificationunitmanualentryreason and existing one @bedsideverificationdate;
**                                        both are optional; corrected capitalization irregularities; added @applicationofrecordid and 
**                                        @interruptioncomment (both optional) (CR 2959)
**        4/11/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE   PROCEDURE dbo.spUpdatePatientTransfusionRecord
(
        @patienttransfusionguid                                UNIQUEIDENTIFIER,
        @patientguid                                          UNIQUEIDENTIFIER,
        @bloodunitguid                                  UNIQUEIDENTIFIER         = NULL,        
        @bedsideverificationdate                        DATETIME                = NULL, 
        @bedsideverificationunitmanualentryreason        VARCHAR(200)                = NULL, 
        @transfusionlocation                                 VARCHAR(50)                 = NULL,
        @locationien                                          INT                         = NULL,
        @transfusionstartdatetime                          DATETIME                 = NULL,
        @transfusionenddatetime                          DATETIME                 = NULL,
        @transfusionist1id                                VARCHAR(30)                 = NULL,
        @transfusionist2id                                VARCHAR(30)                 = NULL,
        @interruptionindicator                                BIT                         = NULL,
        @interruptioncomment                                VARCHAR(510)                = NULL,
        @transfusedvolume                                INT                         = NULL,
        @reactionindicator                                BIT,
        @reactionsymptoms                                VARCHAR(510)                 = NULL,
        @applicationofrecordid                                TINYINT                = NULL,
        @divisioncode                                        CHAR(5),
        @lastupdateuser                                VARCHAR(30),
        @lastupdatefunctionid                                INT,
        @rowversion                                        TIMESTAMP,
        @lastupdatedate                                DATETIME
)
AS

SET NOCOUNT ON

DECLARE        @ERROR        INT,
                @ROWCOUNT        INT

SET @transfusionstartdatetime = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @transfusionstartdatetime)

SET @ERROR = @@ERROR
IF @ERROR <> 0 GOTO ERR_HANDLER

SET @transfusionenddatetime = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @transfusionenddatetime)

SET @ERROR = @@ERROR
IF @ERROR <> 0 GOTO ERR_HANDLER

        UPDATE dbo.PatientTransfusion

        SET        PatientGuid = @patientguid,
                BloodUnitGuid = @bloodunitguid,
                BedsideVerificationDate = @bedsideverificationdate,
                BedsideVerificationUnitManualEntryReason = @bedsideverificationunitmanualentryreason,
                TransfusionLocation = @transfusionlocation,
                LocationIen = @locationien,
                TransfusionStartDateTime = @transfusionstartdatetime,
                TransfusionEndDateTime = @transfusionenddatetime,
                Transfusionist1Id = @transfusionist1id,
                Transfusionist2Id = @transfusionist2id,
                InterruptionIndicator = @interruptionindicator,
                InterruptionComment = @interruptioncomment,
                TransfusedVolume = @transfusedvolume,
                ReactionIndicator = @reactionindicator,
                ReactionSymptoms = @reactionsymptoms,
                ApplicationOfRecordId = @applicationofrecordid,
                DivisionCode = @divisioncode,
                LastUpdateDate = @lastupdatedate,
                LastUpdateUser = @lastupdateuser,
                LastUpdateFunctionID = @lastupdatefunctionid
        WHERE
                PatientTransfusionGuid = @PatientTransfusionGuid
                AND [RowVersion] = @rowversion


        SELECT @ERROR = @@ERROR, @ROWCOUNT = @@ROWCOUNT

        IF @ERROR = 0 AND @ROWCOUNT <> 1 AND ( SELECT COUNT(1) FROM dbo.PatientTransfusion  WHERE [RowVersion] = @rowversion ) <> 1 
                RAISERROR(50001, 16, 127)
        ELSE
                IF (@ERROR = 0 AND @ROWCOUNT <> 1)        
                        SET @ERROR = -1

ERR_HANDLER:
SET NOCOUNT OFF
                
RETURN (@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spUpdateRackDailyUse') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spUpdateRackDailyUse
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Updates DailyUseIndicator
**
**        Author:         Krzysztof Dobranowski
**
**        Date:         01/31/2003
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        --------------        ----------                        ------------------
**        01/31/2003        K. Dobranowski        Initial creation.
**        01/30/2004        Greg Lohse        Adding LastUpdateFunctionId
**        01/30/2004        M.Jablonski        Added row version
**        01/25/2005        K. Dobranowski        Replaced RackGuid with DailyQcWorklistGuid
**        03/10/2005        R Heiberger        Added the RaiseError call.
**        06/30/2005        M. Smith        Reviewed for compliance with database standards and recommendations.  SET NOCOUNT
**                                        on and off.  Removed null default from @rowversion.  Used if exists instead of checking 
**                                        count to set @recordstatuscode.  Added dbo. to updated table.
**        08/08/2005        M. Smith        Capitalized reserved words, included error check on date function calls, modified dates outside
**                                        of update statement.
**        11/04/2009        K.Dobranowski  Added QCOfflineIndicator (CR 2718)
**        08/18/2010        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spUpdateRackDailyUse
(
        @dailyqcworklistguid        UNIQUEIDENTIFIER,
        @dailyuseindicator        BIT,
        @qcofflineindicator        BIT,
        @lastupdatefunctionid        INT,
        @dailyqcexpirationdate        DATETIME = NULL,
        @lastupdatedate        DATETIME,
        @lastupdateuser        VARCHAR(30),
        @rowversion                TIMESTAMP,
        @divisioncode                VARCHAR(5)
)
 AS

SET NOCOUNT ON

DECLARE        @ERROR        INT,
                @ROWCOUNT        INT,
                @recordstatuscode CHAR(1)

                SET @recordstatuscode = 'A'
        
--if there are no lot numbers associated with this rack then we do not need the daily qc worklist record anymore
IF @dailyuseindicator = 1
BEGIN
        IF NOT EXISTS (SELECT 1 FROM dbo.RackLot WHERE RackLot.DailyQcWorklistGuid = @dailyqcworklistguid)
        BEGIN
                SET @recordstatuscode = 'X'
        END
END

SET @dailyqcexpirationdate = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @dailyqcexpirationdate)

SET @ERROR = @@ERROR

IF @ERROR = 0
BEGIN
        UPDATE
                dbo.DailyQcWorklist
        SET
                DailyUseIndicator = @dailyuseindicator,
                QCOfflineIndicator = @qcofflineindicator,
                LastUpdateFunctionId = @lastupdatefunctionid,
                DailyQcExpirationDate = @dailyqcexpirationdate,
                LastUpdateDate = @lastupdatedate,
                LastUpdateUser = @lastupdateuser,
                RecordStatusCode = @recordstatuscode
        WHERE
                DailyQcWorklistGuid = @dailyqcworklistguid
        AND        [RowVersion] = @rowversion

        SELECT @ERROR = @@ERROR, @ROWCOUNT = @@ROWCOUNT

        IF @ERROR = 0 AND @ROWCOUNT <> 1 AND ( SELECT COUNT(1) FROM dbo.DailyQcWorklist WHERE [RowVersion] = @rowversion ) <> 1 
                RAISERROR(50001, 16, 127)
        ELSE
                IF (@ERROR = 0 AND @ROWCOUNT <> 1)        
                        SET @ERROR = -1
END

SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spUserPermissions') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spUserPermissions
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:        Gets user permissions based on VBECS user ID passed as parameter
**
**        Author:        John Vrooland
**
**        Date:         09/22/2002
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        --------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        06/21/05        Stas Antropov        Removed references to V_RolesAndFunctions and V_VbecsUsersAndRoles views, rewrote the SQL, 
**                                        added SET NOCOUNT ON/OFF
**        07/15/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Removed Name/input/output from comment header, added SET NOCOUNT OFF, formatted SQL
**                                        Aliased Views, specified object owners
**        08/16/05        N. Paterson        Revised to use new format created by Stas on 06/21/05, aliased tables
**        10/27/09        M. Smith        Added visually impaired users to JOIN (CR 2726)
**        05/31/11        M. Smith        Removed visually impaired users from JOIN (CR 2929)
**        05/31/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spUserPermissions
(
        @vbecsuserid VARCHAR(30)
)
AS

SET NOCOUNT ON

SELECT        

        U.VbecsUserId, 
        U.UserName,
        UDR.DivisionCode,
        UDR.RecordStatusCode,
        UR.UserRoleId,
        UR.UserRoleName,
        RF.RoleFunctionId,
        RF.RoleFunctionText

FROM        dbo.VbecsUser U

        JOIN        dbo.VbecsUserDivisionRole UDR 
                ON UDR.VbecsUserId = U.VbecsUserId

        JOIN        dbo.UserRole UR 
                ON UR.UserRoleId <= UDR.UserRoleId

        JOIN        dbo.UserRoleFunction URF 
                ON URF.UserRoleId = UR.UserRoleId

        JOIN        dbo.RoleFunction RF 
                ON RF.RoleFunctionId = URF.RoleFunctionId

WHERE        U.VbecsUserId = @vbecsuserid

ORDER BY        U.VbecsUserId, 
                UDR.DivisionCode, 
                UR.UserRoleID, 
                RF.RoleFunctionID        

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spVistaGetXmlAvailableUnits') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spVistaGetXmlAvailableUnits
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**
**        Desc:         Retrieves XML to submit to VistA containing available units information
**
**        Author:        Brian Tomlin / Stas Antropov
**
**        Date:         01/25/2005
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        --------        --------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        07/19/05        C. Taylor        Added call to fnOrderedUnitCrossmatchResultCode to ensure latest crossmatch result is used 
**                                        (there may be repeat XMs)
**        06/29/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Header added, Added NOCOUNT, Specified table owners, Removed comments, UPPERCASED SQL
**        08/21/05        S. Antropov        ** Reviewed for compliance with database standards and recommendations **
**                                        Performed secondary review during the code promotion - merged changes
**        08/24/05        C. Taylor        Fixed typo introduced during compliance: Bdbo.loodUnit and Bdbo.loodProduct
**        03/29/07        D. Askew        Made changes for DR 2594, see Assigned, crossmatched, autologous, and directed units: changed 
**                                        [Unit!4!location] to use dbo.fnCurrentUnitLocation (new function); removed JOIN to dbo.IssuedUnit
**        07/13/07        Lohse                Adding datetime conversion for CR2253.
**        03/06/08        Stedum                Added the return of the label unit id for CR 2399.
**        03/11/08        K Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        05/13/08        M. Smith        Changed @VistaPatientID to BIGINT datatype (CR 2431)
**        06/10/08        Stedum                Implemented proposed solution for CR 2237, 2130, removed  issued from the where clause 
**                                        of the unit status code, also removed the check for donation type within the same where clause
**        06/12/08        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        01/04/10        M. Smith        Changed to check UnitStatusCode from the BloodUnitStatusCodeCurrent table. (CR 1174)
**        01/25/10        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/24/10        D. Askew        Reformatted SQL; updated productCode use the full product code for ISBT units (CR 2806).
**        06/06/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        07/18/11        K. Dobranowski        Modified JOIN for PatientTransfusion record (CR 2901)
**        10/27/11        D. Askew        Changed Unit Rh to use RhFactorText rather than RhFactorCode (CR 3161)
**        11/14/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE  dbo.spVistaGetXmlAvailableUnits
(
        @VistAPatientId                BIGINT
)

AS
SET NOCOUNT ON

DECLARE @PatientFoundFlag AS BIT;

        SELECT @PatientFoundFlag = ISNULL((        SELECT TOP 1 1
                                                FROM         dbo.Patient
                                                WHERE        VistaPatientId = @VistaPatientId), 0 );

        --<BloodBank>
        SELECT        1                                        AS Tag,
                        NULL                                        AS Parent,
                        1                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!dob],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [Units!3],
                        NULL                                        AS [Unit!4!status],
                        NULL                                        AS [Unit!4!id],
                        NULL                                        AS [Unit!4!labelid],
                        NULL                                        AS [Unit!4!product],
                        NULL                                        AS [Unit!4!productCode],
                        NULL                                        AS [Unit!4!abo],
                        NULL                                        AS [Unit!4!rh],
                        NULL                                        AS [Unit!4!volume],
                        NULL                                        AS [Unit!4!dateAssigned],
                        NULL                                        AS [Unit!4!divisionCode],
                        NULL                                        AS [Unit!4!location],
                        NULL                                        AS [Unit!4!expDate]

        UNION ALL

        -- <Patient dfn="" firstName="" lastName="" ssn="" abo="" rh="">
        SELECT        2                                                AS Tag,
                        1                                                AS Parent,
                        2                                                AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                 AS [Bloodbank!1],
                        P.VistaPatientID                                        AS [Patient!2!dfn],
                        P.PatientFirstName                                AS [Patient!2!firstName],
                        P.PatientLastName                                AS [Patient!2!lastName],
                        dbo.fnPatientDobConversionToFileManDateTime(
                                P.PatientGuid)                                AS [Patient!2!dob],
                        P.PatientSSN                                        AS [Patient!2!ssn],
                        dbo.fnGetABO( P.PatientGUID )                        AS [Patient!2!abo],
                        dbo.fnGetRh( P.PatientGUID )                        AS [Patient!2!rh],
                        NULL                                                AS [Units!3],
                        NULL                                                AS [Unit!4!status],
                        NULL                                                AS [Unit!4!id],
                        NULL                                                AS [Unit!4!labelid],
                        NULL                                                AS [Unit!4!product],
                        NULL                                                AS [Unit!4!productCode],
                        NULL                                                AS [Unit!4!abo],
                        NULL                                                AS [Unit!4!rh],
                        NULL                                                AS [Unit!4!volume],
                        NULL                                                AS [Unit!4!dateAssigned],
                        NULL                                                AS [Unit!4!divisionCode],
                        NULL                                                AS [Unit!4!location],
                        NULL                                                AS [Unit!4!expDate]

        FROM                
                        dbo.Patient P
        WHERE                

                        P.VistaPatientID = @VistaPatientID

        UNION ALL

        -- <Units>
        SELECT        3                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!dob],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [Units!3],
                        NULL                                        AS [Unit!4!status],
                        NULL                                        AS [Unit!4!id],
                        NULL                                        AS [Unit!4!labelid],
                        NULL                                        AS [Unit!4!product],
                        NULL                                        AS [Unit!4!productCode],
                        NULL                                        AS [Unit!4!abo],
                        NULL                                        AS [Unit!4!rh],
                        NULL                                        AS [Unit!4!volume],
                        NULL                                        AS [Unit!4!dateAssigned],
                        NULL                                        AS [Unit!4!divisionCode],
                        NULL                                        AS [Unit!4!location],
                        NULL                                        AS [Unit!4!expDate]

        WHERE                
                        @PatientFoundFlag = 1

        UNION ALL

        -- Assigned, crossmatched, autologous, and directed units
        -- <Unit status="" id="" product="" productCode="" abo="" rh="" divisionCode="" location="" expDate="" />
        SELECT DISTINCT        
                        4                                                                                                AS Tag,
                        3                                                                                                AS Parent,
                        2                                                                                                AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                                 AS [Bloodbank!1],
                        NULL                                                                                                AS [Patient!2!dfn],
                        NULL                                                                                                AS [Patient!2!firstName],
                        NULL                                                                                                AS [Patient!2!lastName],
                        NULL                                                                                                AS [Patient!2!dob],
                        NULL                                                                                                AS [Patient!2!ssn],
                        NULL                                                                                                AS [Patient!2!abo],
                        NULL                                                                                                AS [Patient!2!rh],
                        NULL                                                                                                AS [Units!3],
                        -- ******************************************************************************************************************************************************************************************
                        CASE
                                WHEN        dbo.DonationType.RestrictionTypeCode IN ('A','D') THEN 
                                        dbo.DonationType.RestrictionTypeCode
                                ELSE         BUSCC.UnitStatusCode
                        END                                                                                                 AS [Unit!4!status],
                        -- ******************************************************************************************************************************************************************************************
                        dbo.BloodUnit.EyeReadableUnitId                                                                AS [Unit!4!id],
                        dbo.BloodUnit.LabelUnitId                                                                        AS [Unit!4!labelid],
                        dbo.ProductType.ProductTypeName                                                                AS [Unit!4!product],
                        -- ******************************************************************************************************************************************************************************************
                        CASE dbo.BloodUnit.LabelTypeCode
                        WHEN 'I' THEN 
                                dbo.BloodUnit.UnitProductCode 
                                + dbo.DonationType.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS 
                                + dbo.BloodUnit.UnitDivisionId 
                        ELSE 
                                dbo.BloodUnit.UnitProductCode
                        END                                                                                                 AS [Unit!4!productCode],
                        -- ******************************************************************************************************************************************************************************************
                        dbo.BloodUnitMedia.BloodTypeCode                                                                AS [Unit!4!abo],
                        dbo.RhFactor.RhFactorText                                                                        AS [Unit!8!rh],
                        dbo.BloodUnit.OriginalVolume                                                                        AS [Unit!4!volume],
                        dbo.fnDateTimeConversionToFileManDateTime(
                                dbo.fnTimeZoneConversionDateTime( 
                                OrderedUnit.DivisionCode, 0, OrderedUnit.SelectedDate ))                                        AS [Unit!4!dateAssigned],
                        dbo.VamcDivision.DivisionCode                                                                        AS [Unit!4!divisionCode],
                        dbo.fnCurrentUnitLocation(dbo.BloodUnit.BloodUnitGuid)                                                 AS [Unit!4!location],
                        dbo.fnDateTimeConversionToFileManDateTime(
                                dbo.fnTimeZoneConversionDateTime( 
                                        OrderedUnit.DivisionCode, 0, BloodUnitMedia.UnitExpirationDate ))                        AS [Unit!4!expDate]

        FROM                
                dbo.BloodUnitStatusCodeCurrent BUSCC

                INNER JOIN dbo.BloodUnit
                        ON BUSCC.BloodUnitGuid = dbo.BloodUnit.BloodUnitGuid

                LEFT OUTER JOIN dbo.PatientTransfusion
                        ON dbo.BloodUnit.BloodUnitGuid = dbo.PatientTransfusion.BloodUnitGuid AND dbo.PatientTransfusion.RecordStatusCode = 'A'

                INNER JOIN dbo.DonationType
                        ON dbo.BloodUnit.DonationTypeId = dbo.DonationType.DonationTypeId

                INNER JOIN dbo.OrderedUnit
                        ON dbo.BloodUnit.BloodUnitGuid = dbo.OrderedUnit.BloodUnitGuid

                INNER JOIN dbo.OrderedComponent
                        ON dbo.OrderedUnit.OrderedComponentGuid = dbo.OrderedComponent.OrderedComponentGuid

                INNER JOIN dbo.PatientOrder
                        ON dbo.OrderedComponent.PatientOrderGuid = dbo.PatientOrder.PatientOrderGuid

                INNER JOIN dbo.PatientTreatment
                        ON dbo.PatientOrder.PatientTreatmentGuid = dbo.PatientTreatment.PatientTreatmentGuid

                INNER JOIN dbo.Patient
                        ON dbo.PatientTreatment.PatientGuid = dbo.Patient.PatientGuid

                INNER JOIN dbo.BloodProduct
                        ON dbo.BloodUnit.BloodProductGuid =dbo.BloodProduct.BloodProductGuid

                INNER JOIN dbo.ProductType
                        ON dbo.BloodProduct.ProductTypeCode = dbo.ProductType.ProductTypeCode

                INNER JOIN dbo.VamcDivision
                        ON dbo.BloodUnit.DivisionCode = dbo.VamcDivision.DivisionCode

                INNER JOIN dbo.BloodUnitMedia
                        ON dbo.BloodUnit.BloodUnitGuid = dbo.BloodUnitMedia.BloodUnitGuid

                LEFT JOIN dbo.RhFactor 
                        ON dbo.BloodUnitMedia.RhFactorCode = dbo.RhFactor.RhFactorCode

        WHERE                

                dbo.Patient.VistaPatientID = @VistaPatientId

                AND BUSCC.UnitStatusCode IN ( 'S', 'C' , 'I')

                AND dbo.BloodUnitMedia.UnitExpirationDate > GETUTCDATE()

                AND dbo.PatientTransfusion.TransfusionStartDateTime IS NULL

                AND dbo.OrderedUnit.ReleaseDate IS NULL

                AND dbo.OrderedUnit.SelectedDate IS NOT NULL

                AND ((dbo.fnOrderedUnitCrossmatchResultCode(OrderedUnit.OrderedUnitGuid) IN ('C', 'E', 'G')) OR (OrderedUnit.CrossmatchResultCode IS NULL))

                AND @PatientFoundFlag = 1


FOR XML EXPLICIT

SET NOCOUNT OFF
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spVistaGetXmlBloodBankData') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spVistaGetXmlBloodBankData
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         Retrieves blood bank data XML to return to VistA
**
**        Author:        Brian Tomlin / Stas Antropov
**
**        Date:         01/25/2005
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------                ---------                -----------------
**        07/19/05        C. Taylor        Added call to fnOrderedUnitCrossmatchResultCode to ensure latest crossmatch result is used 
**                                        (there may be repeat XMs)
**        06/29/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Header added, Added NOCOUNT, Specified table owners, Removed comments, UPPERCASED SQL
**        08/21/05        S. Antropov        ** Reviewed for compliance with database standards and recommendations **
**                                        Performed secondary review during the code promotion - merged changes
**        08/24/05        C. Taylor        Fixed typo introduced during compliance: INNER JOIN 
**                                        dbo.PatientTransfusionRequirement.PatientTransReq
**        09/09/05        D. Askew        Changed JOIN on Patient to select either the FinalMergeToPatient if the patient has one or more
**                                        merges (choosing the final merge record) or simply the patient guid if there are none
**        10/27/05        C. Jensen        Added code to not get ABO/Rh if from Db conversion.
**        01/23/06        M. Smith        ** Reviewed for compliance with database standards and recommendations **
**        03/29/07        D. Askew        Made changes for DR 2595, see Assigned and crossmatched units: changed [Unit!10!expDate] to use 
**                                        BloodUnitMedia.UnitExpirationDate rather than PatientSpecimen.SpecimenExpirationDate; changed
**                                        INNER JOIN on dbo.PatientSpecimen to LEFT JOIN; added AND condition for 
**                                        dbo.PatientSpecimen.SpecimenExpirationDate, which will be NULL for certain blood product types
**        07/13/07        Lohse                Adding datetime conversion for CR2253.
**        05/13/08        M. Smith        Changed @VistaPatientID to BIGINT datatype (CR 2431)
**        06/04/08        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        01/04/10        M. Smith        Changed to get and check UnitStatusCode from the BloodUnitStatusCodeCurrent table. (CR 1174)
**        01/25/10        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        02/18/10        D. Askew         Added noBloodRequiredIndicator to SELECT (CR 2742).
**        06/24/10        D. Askew        Reformatted SQL; removed merge code; added productCode to SELECT (CR 2806).
**        07/18/11        K. Dobranowski  Modified JOIN statements for PatientTransfusion record (CR 2901)
**        07/28/11        D. Askew        Added AND Msbos.RecordStatusCode <> 'X' to WHERE clause for MSBOS entries. (CR 3078)
**        10/14/11        M. Smith        Added AND MsbosComponentClass.RecordStatusCode <> 'X' to WHERE clause for MSBOS entries
**                                        and  Msbos.DivisionCode = @DivisionCode for surgery names. (CR 3156)
**        11/14/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spVistaGetXmlBloodBankData
(
        @VistAPatientId         BIGINT,
        @DivisionCode                 CHAR(5)
)
AS

SET NOCOUNT ON

DECLARE @PatientFoundFlag AS BIT;
DECLARE @PatientGuid AS UNIQUEIDENTIFIER;
DECLARE @ABO AS VarChar(2);
DECLARE @Rh AS VarChar(2);

        SELECT @PatientFoundFlag = ISNULL((        SELECT TOP 1 1
                                                FROM         dbo.Patient
                                                WHERE        VistaPatientID = @VistaPatientID), 0 );

        SELECT @PatientGuid = (SELECT TOP 1 PatientGuid FROM dbo.Patient P WHERE P.VistaPatientID = @VistaPatientID);

        SELECT @ABO = (SELECT ABO FROM dbo.fnGetABORhTable(@PatientGuid) WHERE TestDivision IS NOT NULL);

        SELECT @Rh = (SELECT Rh FROM dbo.fnGetABORhTable(@PatientGuid) WHERE TestDivision IS NOT NULL);


        -- <BloodBank>
        SELECT        1                                        AS Tag,
                        NULL                                        AS Parent,
                        1                                         AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Component!13!GroupOrder!hide],
                        NULL                                          AS [Bloodbank!1],
                        NULL                                         AS [Patient!2!dfn],
                        NULL                                         AS [Patient!2!firstName],
                        NULL                                         AS [Patient!2!lastName],
                        NULL                                         AS [Patient!2!ssn],
                        NULL                                         AS [Patient!2!abo],
                        NULL                                         AS [Patient!2!rh],
                        NULL                                         AS [TransfusionReactions!3],
                        NULL                                         AS [TransfusionReaction!4!type],
                        NULL                                         AS [TransfusionReaction!4!date],
                        NULL                                         AS [TransfusionRequirements!5],
                        NULL                                         AS [TransfusionRequirement!6!modifier],
                        NULL                                         AS [Antibodies!7],
                        NULL                                         AS [Antibody!8!name],
                        NULL                                         AS [Units!9],
                        NULL                                         AS [Unit!10!status],
                        NULL                                         AS [Unit!10!id],
                        NULL                                         AS [Unit!10!product],
                        NULL                                         AS [Unit!10!productCode],
                        NULL                                         AS [Unit!10!location],
                        NULL                                         AS [Unit!10!expDate],
                        NULL                                         AS [Specimen!11!expDate],
                        NULL                                         AS [Specimen!11!uid],
                        NULL                                         AS [Components!12],
                        NULL                                         AS [Component!13!name],
                        NULL                                         AS [Component!13!id],
                        NULL                                         AS [Component!13!specimen],
                        NULL                                         AS [LabTests!14],
                        NULL                                         AS [LabTest!15!id],
                        NULL                                         AS [LabTest!15!name],
                        NULL                                         AS [MsbosList!16],
                        NULL                                         AS [Msbos!17!name],
                        NULL                                         AS [Msbos!17!threshold],
                        NULL                                         AS [Surgeries!18],
                        NULL                                         AS [Surgery!19!name],
                        NULL                                         AS [Surgery!19!noBloodRequiredIndicator]

        UNION ALL

        -- <Patient dfn="" firstName="" lastName="" ssn="" abo="" rh="">
        SELECT        2                                        AS Tag,
                        1                                        AS Parent,
                        2                                         AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Component!13!GroupOrder!hide],
                        NULL                                          AS [Bloodbank!1],
                        P.VistaPatientID                                 AS [Patient!2!dfn],
                        P.PatientFirstName                         AS [Patient!2!firstName],
                        P.PatientLastName                         AS [Patient!2!lastName],
                        P.PatientSSN                                 AS [Patient!2!ssn],
                        @ABO                                         AS [Patient!2!abo],
                        @Rh                                         AS [Patient!2!rh],
                        NULL                                         AS [TransfusionReactions!3],
                        NULL                                         AS [TransfusionReaction!4!type],
                        NULL                                         AS [TransfusionReaction!4!date],
                        NULL                                         AS [TransfusionRequirements!5],
                        NULL                                         AS [TransfusionRequirement!6!modifier],
                        NULL                                         AS [Antibodies!7],
                        NULL                                         AS [Antibody!8!name],
                        NULL                                         AS [Units!9],
                        NULL                                         AS [Unit!10!status],
                        NULL                                         AS [Unit!10!id],
                        NULL                                         AS [Unit!10!product],
                        NULL                                         AS [Unit!10!productCode],
                        NULL                                         AS [Unit!10!location],
                        NULL                                         AS [Unit!10!expDate],
                        NULL                                         AS [Specimen!11!expDate],
                        NULL                                         AS [Specimen!11!uid],
                        NULL                                         AS [Components!12],
                        NULL                                         AS [Component!13!name],
                        NULL                                         AS [Component!13!id],
                        NULL                                         AS [Component!13!specimen],
                        NULL                                         AS [LabTests!14],
                        NULL                                         AS [LabTest!15!id],
                        NULL                                         AS [LabTest!15!name],
                        NULL                                         AS [MsbosList!16],
                        NULL                                         AS [Msbos!17!name],
                        NULL                                         AS [Msbos!17!threshold],
                        NULL                                         AS [Surgeries!18],
                        NULL                                         AS [Surgery!19!name],
                        NULL                                         AS [Surgery!19!noBloodRequiredIndicator]

        FROM                
                dbo.Patient P

        WHERE                
                P.VistaPatientID = @VistaPatientID

        UNION ALL

        -- <TransfusionReactions>
        SELECT        3                                        AS Tag,
                        2                                        AS Parent,
                        2                                         AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Component!13!GroupOrder!hide],
                        NULL                                          AS [Bloodbank!1],
                        NULL                                         AS [Patient!2!dfn],
                        NULL                                         AS [Patient!2!firstName],
                        NULL                                         AS [Patient!2!lastName],
                        NULL                                         AS [Patient!2!ssn],
                        NULL                                         AS [Patient!2!abo],
                        NULL                                         AS [Patient!2!rh],
                        NULL                                         AS [TransfusionReactions!3],
                        NULL                                         AS [TransfusionReaction!4!type],
                        NULL                                         AS [TransfusionReaction!4!date],
                        NULL                                         AS [TransfusionRequirements!5],
                        NULL                                         AS [TransfusionRequirement!6!modifier],
                        NULL                                         AS [Antibodies!7],
                        NULL                                         AS [Antibody!8!name],
                        NULL                                         AS [Units!9],
                        NULL                                         AS [Unit!10!status],
                        NULL                                         AS [Unit!10!id],
                        NULL                                         AS [Unit!10!product],
                        NULL                                         AS [Unit!10!productCode],
                        NULL                                         AS [Unit!10!location],
                        NULL                                         AS [Unit!10!expDate],
                        NULL                                         AS [Specimen!11!expDate],
                        NULL                                         AS [Specimen!11!uid],
                        NULL                                         AS [Components!12],
                        NULL                                         AS [Component!13!name],
                        NULL                                         AS [Component!13!id],
                        NULL                                         AS [Component!13!specimen],
                        NULL                                         AS [LabTests!14],
                        NULL                                         AS [LabTest!15!id],
                        NULL                                         AS [LabTest!15!name],
                        NULL                                         AS [MsbosList!16],
                        NULL                                         AS [Msbos!17!name],
                        NULL                                         AS [Msbos!17!threshold],
                        NULL                                         AS [Surgeries!18],
                        NULL                                         AS [Surgery!19!name],
                        NULL                                         AS [Surgery!19!noBloodRequiredIndicator] 

        WHERE                
                @PatientFoundFlag = 1

        UNION ALL

        -- <TransfusionReaction type="" date="">
        SELECT DISTINCT        
                        4                                        AS Tag,
                        3                                        AS Parent,
                        2                                         AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Component!13!GroupOrder!hide],
                        NULL                                          AS [Bloodbank!1],
                        NULL                                         AS [Patient!2!dfn],
                        NULL                                         AS [Patient!2!firstName],
                        NULL                                         AS [Patient!2!lastName],
                        NULL                                         AS [Patient!2!ssn],
                        NULL                                         AS [Patient!2!abo],
                        NULL                                         AS [Patient!2!rh],
                        NULL                                         AS [TransfusionReactions!3],
                        TRT.TransfusionReactionTypeText         AS [TransfusionReaction!4!type],
                        dbo.fnDateTimeConversionToHL7DateTime(dbo.fnTimeZoneConversionDateTime( @DivisionCode, 0, PTR.NotedDateTime ))                 AS [TransfusionReaction!4!date],
                        NULL                                         AS [TransfusionRequirements!5],
                        NULL                                         AS [TransfusionRequirement!6!modifier],
                        NULL                                         AS [Antibodiess!7],
                        NULL                                         AS [Antibody!8!name],
                        NULL                                         AS [Units!9],
                        NULL                                         AS [Unit!10!status],
                        NULL                                         AS [Unit!10!id],
                        NULL                                         AS [Unit!10!product],
                        NULL                                         AS [Unit!10!productCode],
                        NULL                                         AS [Unit!10!location],
                        NULL                                         AS [Unit!10!expDate],
                        NULL                                         AS [Specimen!11!expDate],
                        NULL                                         AS [Specimen!11!uid],
                        NULL                                         AS [Components!12],
                        NULL                                         AS [Component!13!name],
                        NULL                                         AS [Component!13!id],
                        NULL                                         AS [Component!13!specimen],
                        NULL                                         AS [LabTests!14],
                        NULL                                         AS [LabTest!15!id],
                        NULL                                         AS [LabTest!15!name],
                        NULL                                         AS [MsbosList!16],
                        NULL                                         AS [Msbos!17!name],
                        NULL                                         AS [Msbos!17!threshold],
                        NULL                                         AS [Surgeries!18],
                        NULL                                         AS [Surgery!19!name],
                        NULL                                         AS [Surgery!19!noBloodRequiredIndicator] 

        FROM                
                dbo.PatientTransfusionReaction PTR

                JOIN dbo.Patient P 
                        ON P.PatientGuid = PTR.PatientGuid

                LEFT JOIN dbo.TransfusionReactionType TRT 
                        ON TRT.TransfusionReactionTypeCode = PTR.TransfusionReactionTypeCode

        WHERE                
                P.VistaPatientID = @VistaPatientID

                AND PTR.RecordStatusCode NOT IN ('X','I','E')

                AND @PatientFoundFlag = 1

        UNION ALL 

        -- <TransfusionRequirements>
        SELECT        5                                        AS Tag,
                        2                                        AS Parent,
                        2                                         AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Component!13!GroupOrder!hide],
                        NULL                                          AS [Bloodbank!1],
                        NULL                                         AS [Patient!2!dfn],
                        NULL                                         AS [Patient!2!firstName],
                        NULL                                         AS [Patient!2!lastName],
                        NULL                                         AS [Patient!2!ssn],
                        NULL                                         AS [Patient!2!abo],
                        NULL                                         AS [Patient!2!rh],
                        NULL                                         AS [TransfusionReactions!3],
                        NULL                                         AS [TransfusionReaction!4!type],
                        NULL                                         AS [TransfusionReaction!4!date],
                        NULL                                         AS [TransfusionRequirements!5],
                        NULL                                         AS [TransfusionRequirement!6!modifier],
                        NULL                                         AS [Antibodies!7],
                        NULL                                         AS [Antibody!8!name],
                        NULL                                         AS [Units!9],
                        NULL                                         AS [Unit!10!status],
                        NULL                                         AS [Unit!10!id],
                        NULL                                         AS [Unit!10!product],
                        NULL                                         AS [Unit!10!productCode],
                        NULL                                         AS [Unit!10!location],
                        NULL                                         AS [Unit!10!expDate],
                        NULL                                         AS [Specimen!11!expDate],
                        NULL                                         AS [Specimen!11!uid],
                        NULL                                         AS [Components!12],
                        NULL                                         AS [Component!13!name],
                        NULL                                         AS [Component!13!id],
                        NULL                                         AS [Component!13!specimen],
                        NULL                                         AS [LabTests!14],
                        NULL                                         AS [LabTest!15!id],
                        NULL                                         AS [LabTest!15!name],
                        NULL                                         AS [MsbosList!16],
                        NULL                                         AS [Msbos!17!name],
                        NULL                                         AS [Msbos!17!threshold],
                        NULL                                         AS [Surgeries!18],
                        NULL                                         AS [Surgery!19!name],
                        NULL                                         AS [Surgery!19!noBloodRequiredIndicator] 

        WHERE                
                @PatientFoundFlag = 1

        UNION ALL

        -- <TransfusionRequirement modifier="" >
        SELECT        6                                                                AS Tag,
                        5                                                                AS Parent,
                        2                                                                 AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                 AS [Component!13!GroupOrder!hide],
                        NULL                                                                  AS [Bloodbank!1],
                        NULL                                                                 AS [Patient!2!dfn],
                        NULL                                                                 AS [Patient!2!firstName],
                        NULL                                                                 AS [Patient!2!lastName],
                        NULL                                                                 AS [Patient!2!ssn],
                        NULL                                                                 AS [Patient!2!abo],
                        NULL                                                                 AS [Patient!2!rh],
                        NULL                                                                 AS [TransfusionReactions!3],
                        NULL                                                                 AS [TransfusionReaction!4!type],
                        NULL                                                                 AS [TransfusionReaction!4!date],
                        NULL                                                                 AS [TransfusionRequirements!5],
                        dbo.PatientTransfusionRequirement.TransfusionRequirementText        AS [TransfusionRequirement!6!modifier],
                        NULL                                                                 AS [Antibodies!7],
                        NULL                                                                 AS [Antibody!8!name],
                        NULL                                                                 AS [Units!9],
                        NULL                                                                 AS [Unit!10!status],
                        NULL                                                                 AS [Unit!10!id],
                        NULL                                                                 AS [Unit!10!product],
                        NULL                                                                 AS [Unit!10!productCode],
                        NULL                                                                AS [Unit!10!location],
                        NULL                                                                 AS [Unit!10!expDate],
                        NULL                                                                 AS [Specimen!11!expDate],
                        NULL                                                                 AS [Specimen!11!uid],
                        NULL                                                                 AS [Components!12],
                        NULL                                                                 AS [Component!13!name],
                        NULL                                                                 AS [Component!13!id],
                        NULL                                                                 AS [Component!13!specimen],
                        NULL                                                                AS [LabTests!14],
                        NULL                                                                 AS [LabTest!15!id],
                        NULL                                                                 AS [LabTest!15!name],
                        NULL                                                                 AS [MsbosList!16],
                        NULL                                                                 AS [Msbos!17!name],
                        NULL                                                                 AS [Msbos!17!threshold],
                        NULL                                                                 AS [Surgeries!18],
                        NULL                                                                 AS [Surgery!19!name],
                        NULL                                                                 AS [Surgery!19!noBloodRequiredIndicator]  


        FROM                
                dbo.Patient

                INNER JOIN dbo.PatientTransfusionRequirement
                        ON dbo.Patient.PatientGuid = dbo.PatientTransfusionRequirement.PatientGuid

        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID

                AND dbo.PatientTransfusionRequirement.PatientGUID = dbo.Patient.PatientGUID

                AND dbo.PatientTransfusionRequirement.RecordStatusCode IN ('A', 'C', 'H' )

                -- The following line Addresses CR 840
                AND dbo.PatientTransfusionRequirement.TransfusionRequirementCategoryCode IN ('AN', 'CR')

                AND @PatientFoundFlag = 1

        UNION ALL

        -- <Antibodies>
        SELECT        7                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!13!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [TransfusionRequirements!5],
                        NULL                                        AS [TransfusionRequirement!6!modifier],
                        NULL                                        AS [Antibodies!7],
                        NULL                                        AS [Antibody!8!name],
                        NULL                                        AS [Units!9],
                        NULL                                        AS [Unit!10!status],
                        NULL                                        AS [Unit!10!id],
                        NULL                                        AS [Unit!10!product],
                        NULL                                        AS [Unit!10!productCode],
                        NULL                                        AS [Unit!10!location],
                        NULL                                        AS [Unit!10!expDate],
                        NULL                                        AS [Specimen!11!expDate],
                        NULL                                        AS [Specimen!11!uid],
                        NULL                                        AS [Components!12],
                        NULL                                        AS [Component!13!name],
                        NULL                                        AS [Component!13!id],
                        NULL                                        AS [Component!13!specimen],
                        NULL                                        AS [LabTests!14],
                        NULL                                        AS [LabTest!15!id],
                        NULL                                        AS [LabTest!15!name],
                        NULL                                        AS [MsbosList!16],
                        NULL                                        AS [Msbos!17!name],
                        NULL                                        AS [Msbos!17!threshold],
                        NULL                                        AS [Surgeries!18],
                        NULL                                        AS [Surgery!19!name],
                        NULL                                        AS [Surgery!19!noBloodRequiredIndicator]  

        WHERE                
                @PatientFoundFlag = 1

        UNION ALL

        -- <Antibody name="">
        SELECT DISTINCT        
                        8                                        AS Tag,
                        7                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!13!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [TransfusionRequirements!5],
                        NULL                                        AS [TransfusionRequirement!6!modifier],
                        NULL                                        AS [Antibodies!7],
                        dbo.AntibodyType.AntibodyTypeName        AS [Antibody!8!name],
                        NULL                                        AS [Units!9],
                        NULL                                        AS [Unit!10!status],
                        NULL                                        AS [Unit!10!id],
                        NULL                                        AS [Unit!10!product],
                        NULL                                        AS [Unit!10!productCode],
                        NULL                                        AS [Unit!10!location],
                        NULL                                        AS [Unit!10!expDate],
                        NULL                                        AS [Specimen!11!expDate],
                        NULL                                        AS [Specimen!11!uid],
                        NULL                                        AS [Components!12],
                        NULL                                        AS [Component!13!name],
                        NULL                                        AS [Component!13!id],
                        NULL                                        AS [Component!13!specimen],
                        NULL                                        AS [LabTests!14],
                        NULL                                        AS [LabTest!15!id],
                        NULL                                        AS [LabTest!15!name],
                        NULL                                        AS [MsbosList!16],
                        NULL                                        AS [Msbos!17!name],
                        NULL                                        AS [Msbos!17!threshold],
                        NULL                                        AS [Surgeries!18],
                        NULL                                        AS [Surgery!19!name],
                        NULL                                        AS [Surgery!19!noBloodRequiredIndicator]  

        FROM                
                dbo.Patient

                INNER JOIN dbo.PatientTransfusionRequirement
                        ON dbo.PatientTransfusionRequirement.PatientGUID = dbo.Patient.PatientGUID                

                INNER JOIN dbo.AntibodyType
                        ON dbo.AntibodyType.AntibodyTypeID =dbo. PatientTransfusionRequirement.AntibodyTypeID

        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID

                AND @PatientFoundFlag = 1

                AND dbo.AntibodyType.AntibodyTypeId != 1

                AND dbo.AntibodyType.AntibodyTypeId != 4

                AND dbo.PatientTransfusionRequirement.RecordStatusCode IN ('A', 'C', 'H' )


        UNION ALL

        -- <Units>
        SELECT        9                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!13!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [TransfusionRequirements!5],
                        NULL                                        AS [TransfusionRequirement!6!modifier],
                        NULL                                        AS [Antibodies!7],
                        NULL                                        AS [Antibody!8!name],
                        NULL                                        AS [Units!9],
                        NULL                                        AS [Unit!10!status],
                        NULL                                        AS [Unit!10!id],
                        NULL                                        AS [Unit!10!product],
                        NULL                                        AS [Unit!10!productCode],
                        NULL                                        AS [Unit!10!location],
                        NULL                                        AS [Unit!10!expDate],
                        NULL                                        AS [Specimen!11!expDate],
                        NULL                                        AS [Specimen!11!uid],
                        NULL                                        AS [Components!12],
                        NULL                                        AS [Component!13!name],
                        NULL                                        AS [Component!13!id],
                        NULL                                        AS [Component!13!specimen],
                        NULL                                        AS [LabTests!14],
                        NULL                                        AS [LabTest!15!id],
                        NULL                                        AS [LabTest!15!name],
                        NULL                                        AS [MsbosList!16],
                        NULL                                        AS [Msbos!17!name],
                        NULL                                        AS [Msbos!17!threshold],
                        NULL                                        AS [Surgeries!18],
                        NULL                                        AS [Surgery!19!name],
                        NULL                                        AS [Surgery!19!noBloodRequiredIndicator]  

        WHERE                
                @PatientFoundFlag = 1

        UNION ALL

        -- Assigned and crossmatched units
        -- <Unit status="" id="" product="" location="" expDate="" />
        SELECT DISTINCT        
                        10                                                                                                AS Tag,
                        9                                                                                                AS Parent,
                        2                                                                                                 AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                                 AS [Component!13!GroupOrder!hide],
                        NULL                                                                                                  AS [Bloodbank!1],
                        NULL                                                                                                 AS [Patient!2!dfn],
                        NULL                                                                                                 AS [Patient!2!firstName],
                        NULL                                                                                                 AS [Patient!2!lastName],
                        NULL                                                                                                 AS [Patient!2!ssn],
                        NULL                                                                                                 AS [Patient!2!abo],
                        NULL                                                                                                 AS [Patient!2!rh],
                        NULL                                                                                                 AS [TransfusionReactions!3],
                        NULL                                                                                                 AS [TransfusionReaction!4!type],
                        NULL                                                                                                 AS [TransfusionReaction!4!date],
                        NULL                                                                                                 AS [TransfusionRequirements!5],
                        NULL                                                                                                 AS [TransfusionRequirement!6!modifier],
                        NULL                                                                                                 AS [Antibodies!7],
                        NULL                                                                                                 AS [Antibody!8!name],
                        NULL                                                                                                 AS [Units!9],
                        BUSCC.UnitStatusCode                                                                                 AS [Unit!10!status],
                        dbo.BloodUnit.EyeReadableUnitId                                                                 AS [Unit!10!id],
                        dbo.ProductType.ProductTypePrintName                                                                 AS [Unit!10!product],
                        -- ******************************************************************************************************************************************************************************************
                        CASE dbo.BloodUnit.LabelTypeCode
                        WHEN 'I' THEN 
                                dbo.BloodUnit.UnitProductCode 
                                + dbo.DonationType.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS 
                                + dbo.BloodUnit.UnitDivisionId 
                        ELSE 
                                dbo.BloodUnit.UnitProductCode
                        END                                                                                                 AS [Unit!10!productCode],
                        -- ******************************************************************************************************************************************************************************************
                        dbo.VamcDivision.DivisionName                                                                         AS [Unit!10!location],
                        dbo.fnDateTimeConversionToHL7DateTime(
                                dbo.fnTimeZoneConversionDateTime( 
                                        @divisioncode, 0, BloodUnitMedia.UnitExpirationDate ))                                AS [Unit!10!expDate],                                
                        NULL                                                                                                 AS [Specimen!11!expDate],
                        NULL                                                                                                 AS [Specimen!11!uid],
                        NULL                                                                                                 AS [Components!12],
                        NULL                                                                                                 AS [Component!13!name],
                        NULL                                                                                                 AS [Component!13!id],
                        NULL                                                                                                 AS [Component!13!specimen],
                        NULL                                                                                                 AS [LabTests!14],
                        NULL                                                                                                 AS [LabTest!15!id],
                        NULL                                                                                                 AS [LabTest!15!name],
                        NULL                                                                                                 AS [MsbosList!16],
                        NULL                                                                                                 AS [Msbos!17!name],
                        NULL                                                                                                 AS [Msbos!17!threshold],
                        NULL                                                                                                AS [Surgeries!18],
                        NULL                                                                                                 AS [Surgery!19!name],
                        NULL                                                                                                 AS [Surgery!19!noBloodRequiredIndicator]  

        FROM                
                dbo.BloodUnitStatusCodeCurrent BUSCC

                INNER JOIN dbo.BloodUnit
                        ON BUSCC.BloodUnitGUID = dbo.BloodUnit.BloodUnitGUID

                LEFT  JOIN dbo.PatientTransfusion
                        ON dbo.BloodUnit.BloodUnitGuid = dbo.PatientTransfusion.BloodUnitGuid AND dbo.PatientTransfusion.RecordStatusCode = 'A'

                INNER JOIN dbo.OrderedUnit
                        ON dbo.BloodUnit.BloodUnitGUID = dbo.OrderedUnit.BloodUnitGUID

                INNER JOIN dbo.OrderedComponent
                        ON dbo.OrderedUnit.OrderedComponentGUID = dbo.OrderedComponent.OrderedComponentGUID

                LEFT JOIN dbo.PatientSpecimen
                        ON dbo.OrderedComponent.PatientSpecimenGuid = dbo.PatientSpecimen.PatientSpecimenGuid

                INNER JOIN dbo.PatientOrder
                        ON dbo.OrderedComponent.PatientOrderGUID = dbo.PatientOrder.PatientOrderGUID

                INNER JOIN dbo.PatientTreatment
                        ON dbo.PatientOrder.PatientTreatmentGUID = dbo.PatientTreatment.PatientTreatmentGUID

                INNER JOIN dbo.Patient
                        ON dbo.PatientTreatment.PatientGUID = dbo.Patient.PatientGUID

                INNER JOIN dbo.BloodProduct
                        ON dbo.BloodUnit.BloodProductGUID = dbo.BloodProduct.BloodProductGUID

                INNER JOIN dbo.ProductType
                        ON  dbo.BloodProduct.ProductTypeCode = dbo.ProductType.ProductTypeCode

                INNER JOIN dbo.VamcDivision
                        ON  dbo.BloodUnit.DivisionCode = dbo.VamcDivision.DivisionCode

                INNER JOIN dbo.BloodUnitMedia
                        ON dbo.BloodUnit.BloodUnitGUID = dbo.BloodUnitMedia.BloodUnitGUID

                INNER JOIN dbo.DonationType 
                        ON dbo.BloodUnit.DonationTypeId = dbo.DonationType.DonationTypeId

        WHERE                

                dbo.Patient.VistaPatientID = @VistaPatientID

                AND BUSCC.UnitStatusCode IN ( 'S', 'C' )

                AND @PatientFoundFlag = 1

                AND dbo.PatientTransfusion.TransfusionStartDateTime IS NULL

                AND        
                (        
                        dbo.PatientSpecimen.SpecimenExpirationDate IS NULL 
                        OR dbo.PatientSpecimen.SpecimenExpirationDate IS NOT NULL AND dbo.PatientSpecimen.SpecimenExpirationDate > GETUTCDATE()
                )

                AND dbo.OrderedUnit.ReleaseDate IS NULL

                AND dbo.OrderedUnit.SelectedDate IS NOT NULL

                AND ((dbo.fnOrderedUnitCrossmatchResultCode(OrderedUnit.OrderedUnitGuid) IN ('C', 'E', 'G')) OR (OrderedUnit.CrossmatchResultCode IS NULL))

        UNION ALL

        -- Autologous units
        -- <Unit status="" id="" product="" location="" expDate="" />
        SELECT DISTINCT        
                        10                                                                                                AS Tag,
                        9                                                                                                AS Parent,
                        2                                                                                                 AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                                 AS [Component!13!GroupOrder!hide],
                        NULL                                                                                                  AS [Bloodbank!1],
                        NULL                                                                                                 AS [Patient!2!dfn],
                        NULL                                                                                                 AS [Patient!2!firstName],
                        NULL                                                                                                 AS [Patient!2!lastName],
                        NULL                                                                                                 AS [Patient!2!ssn],
                        NULL                                                                                                 AS [Patient!2!abo],
                        NULL                                                                                                 AS [Patient!2!rh],
                        NULL                                                                                                 AS [TransfusionReactions!3],
                        NULL                                                                                                 AS [TransfusionReaction!4!type],
                        NULL                                                                                                 AS [TransfusionReaction!4!date],
                        NULL                                                                                                 AS [TransfusionRequirements!5],
                        NULL                                                                                                 AS [TransfusionRequirement!6!modifier],
                        NULL                                                                                                 AS [Antibodies!7],
                        NULL                                                                                                 AS [Antibody!8!name],
                        NULL                                                                                                 AS [Units!9],
                        dbo.DonationType.RestrictionTypeCode                                                                 AS [Unit!10!status],
                        dbo.BloodUnit.EyeReadableUnitId                                                                AS [Unit!10!id],
                        dbo.ProductType.ProductTypePrintName                                                                 AS [Unit!10!product],
                        -- ******************************************************************************************************************************************************************************************
                        CASE dbo.BloodUnit.LabelTypeCode
                        WHEN 'I' THEN 
                                dbo.BloodUnit.UnitProductCode 
                                + dbo.DonationType.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS 
                                + dbo.BloodUnit.UnitDivisionId 
                        ELSE 
                                dbo.BloodUnit.UnitProductCode
                        END                                                                                                 AS [Unit!10!productCode],
                        -- ******************************************************************************************************************************************************************************************
                        dbo.VamcDivision.DivisionName                                                                         AS [Unit!10!location],
                        dbo.fnDateTimeConversionToHL7DateTime(
                                dbo.fnTimeZoneConversionDateTime( 
                                        @divisioncode, 0, BloodUnitMedia.UnitExpirationDate ))                                AS [Unit!10!expDate],
                        NULL                                                                                                 AS [Specimen!11!expDate],
                        NULL                                                                                                 AS [Specimen!11!uid],
                        NULL                                                                                                 AS [Components!12],
                        NULL                                                                                                 AS [Component!13!name],
                        NULL                                                                                                 AS [Component!13!id],
                        NULL                                                                                                 AS [Component!13!specimen],
                        NULL                                                                                                 AS [LabTests!14],
                        NULL                                                                                                 AS [LabTest!15!id],
                        NULL                                                                                                 AS [LabTest!15!name],
                        NULL                                                                                                 AS [MsbosList!16],
                        NULL                                                                                                 AS [Msbos!17!name],
                        NULL                                                                                                 AS [Msbos!17!threshold],
                        NULL                                                                                                 AS [Surgeries!18],
                        NULL                                                                                                 AS [Surgery!19!name],
                        NULL                                                                                                 AS [Surgery!19!noBloodRequiredIndicator]  

        FROM                
                dbo.DonationType

                INNER JOIN dbo.BloodUnit
                        ON dbo.DonationType.DonationTypeId = dbo.BloodUnit.DonationTypeId

                INNER JOIN dbo.BloodUnitMedia
                        ON dbo.BloodUnit.BloodUnitGUID = dbo.BloodUnitMedia.BloodUnitGUID

                LEFT OUTER JOIN dbo.PatientTransfusion
                        ON dbo.BloodUnit.BloodUnitGuid = dbo.PatientTransfusion.BloodUnitGuid AND dbo.PatientTransfusion.RecordStatusCode = 'A'

                INNER JOIN dbo.OrderedUnit
                        ON dbo.BloodUnit.BloodUnitGUID = dbo.OrderedUnit.BloodUnitGUID

                INNER JOIN dbo.Patient
                        ON dbo.BloodUnitMedia.DirectedPatientGUID = dbo.Patient.PatientGUID

                INNER JOIN dbo.BloodProduct
                        ON dbo.BloodUnit.BloodProductGUID = dbo.BloodProduct.BloodProductGUID

                INNER JOIN dbo.ProductType
                        ON dbo.BloodProduct.ProductTypeCode = dbo.ProductType.ProductTypeCode

                INNER JOIN dbo.VamcDivision
                        ON dbo.BloodUnit.DivisionCode = dbo.VamcDivision.DivisionCode

        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID

                AND dbo.DonationType.RestrictionTypeCode IN ('A', 'D')

                AND @PatientFoundFlag = 1

                AND dbo.BloodUnitMedia.UnitExpirationDate > GETUTCDATE()

                AND PatientTransfusion.TransfusionStartDateTime IS NULL

                AND dbo.OrderedUnit.ReleaseDate IS NULL

                AND dbo.OrderedUnit.SelectedDate IS NOT NULL

                AND ((dbo.OrderedUnit.CrossmatchResultCode IN ('C', 'G')) OR (dbo.OrderedUnit.CrossmatchResultCode IS NULL))

        UNION ALL

        -- <Specimen expDate="" uid="" />
        SELECT DISTINCT        
                        11                                                                                AS Tag,
                        2                                                                                AS Parent,
                        2                                                                                 AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                 AS [Component!13!GroupOrder!hide],
                        NULL                                                                                  AS [Bloodbank!1],
                        NULL                                                                                 AS [Patient!2!dfn],
                        NULL                                                                                 AS [Patient!2!firstName],
                        NULL                                                                                 AS [Patient!2!lastName],
                        NULL                                                                                 AS [Patient!2!ssn],
                        NULL                                                                                 AS [Patient!2!abo],
                        NULL                                                                                 AS [Patient!2!rh],
                        NULL                                                                                 AS [TransfusionReactions!3],
                        NULL                                                                                 AS [TransfusionReaction!4!type],
                        NULL                                                                                 AS [TransfusionReaction!4!date],
                        NULL                                                                                 AS [TransfusionRequirements!5],
                        NULL                                                                                 AS [TransfusionRequirement!6!modifier],
                        NULL                                                                                 AS [Antibodies!7],
                        NULL                                                                                 AS [Antibody!8!name],
                        NULL                                                                                 AS [Units!9],
                        NULL                                                                                 AS [Unit!10!status],
                        NULL                                                                                 AS [Unit!10!id],
                        NULL                                                                                 AS [Unit!10!product],
                        NULL                                                                                 AS [Unit!10!productCode],
                        NULL                                                                                 AS [Unit!10!location],
                        NULL                                                                                 AS [Unit!10!expDate],
                        dbo.fnDateTimeConversionToHL7DateTime(
                                dbo.fnTimeZoneConversionDateTime( 
                                        @divisioncode, 0, PatientSpecimen.SpecimenExpirationDate ))        AS [Specimen!11!expDate],
                        dbo.PatientSpecimen.SpecimenUID                                                 AS [Specimen!11!uid],
                        NULL                                                                                 AS [Components!12],
                        NULL                                                                                 AS [Component!13!name],
                        NULL                                                                                 AS [Component!13!id],
                        NULL                                                                                 AS [Component!13!specimen],
                        NULL                                                                                 AS [LabTests!14],
                        NULL                                                                                 AS [LabTest!15!id],
                        NULL                                                                                 AS [LabTest!15!name],
                        NULL                                                                                 AS [MsbosList!16],
                        NULL                                                                                 AS [Msbos!17!name],
                        NULL                                                                                 AS [Msbos!17!threshold],
                        NULL                                                                                 AS [Surgeries!18],
                        NULL                                                                                 AS [Surgery!19!name],
                        NULL                                                                                 AS [Surgery!19!noBloodRequiredIndicator]  

        FROM                
                dbo.PatientSpecimen

                INNER JOIN dbo.OrderedTest
                        ON dbo.PatientSpecimen.PatientSpecimenGUID = dbo.OrderedTest.PatientSpecimenGUID

                INNER JOIN dbo.OrderableTest
                        ON dbo.OrderedTest.OrderableTestID = dbo.OrderableTest.OrderableTestID

                INNER JOIN dbo.Patient
                        ON dbo.PatientSpecimen.PatientGUID =dbo. Patient.PatientGUID        

        WHERE        
                dbo.Patient.VistaPatientID = @VistaPatientID

                AND dbo.PatientSpecimen.UnacceptableSpecimenIndicator <> 1

                AND dbo.OrderableTest.CprsOrderableItemID = '1'

                AND dbo.PatientSpecimen.SpecimenExpirationDate > GETUTCDATE()

                AND @PatientFoundFlag = 1

        /****** Brian Tomlin:  Added Division check on PatientSpecimen 07-12-2004 *******/
                AND dbo.PatientSpecimen.DivisionCode = @DivisionCode


        UNION ALL

        -- <Components>
        SELECT                
                        12                                        AS Tag,
                        1                                        AS Parent,
                        3                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!13!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [TransfusionRequirements!5],
                        NULL                                        AS [TransfusionRequirement!6!modifier],
                        NULL                                        AS [Antibodies!7],
                        NULL                                        AS [Antibody!8!name],
                        NULL                                        AS [Units!9],
                        NULL                                        AS [Unit!10!status],
                        NULL                                        AS [Unit!10!id],
                        NULL                                        AS [Unit!10!product],
                        NULL                                        AS [Unit!10!productCode],
                        NULL                                        AS [Unit!10!location],
                        NULL                                        AS [Unit!10!expDate],
                        NULL                                        AS [Specimen!11!expDate],
                        NULL                                        AS [Specimen!11!uid],
                        NULL                                        AS [Components!12],
                        NULL                                        AS [Component!13!name],
                        NULL                                        AS [Component!13!id],
                        NULL                                        AS [Component!13!specimen],
                        NULL                                        AS [LabTests!14],
                        NULL                                        AS [LabTest!15!id],
                        NULL                                        AS [LabTest!15!name],
                        NULL                                        AS [MsbosList!16],
                        NULL                                        AS [Msbos!17!name],
                        NULL                                        AS [Msbos!17!threshold],
                        NULL                                        AS [Surgeries!18],
                        NULL                                        AS [Surgery!19!name],
                        NULL                                        AS [Surgery!19!noBloodRequiredIndicator]  

        UNION ALL

        -- <Component name="" id="" specimen="">
        SELECT DISTINCT        
                        13                                                AS Tag,
                        12                                                AS Parent,
                        3                                                 AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                 AS [Component!13!GroupOrder!hide],
                        NULL                                                  AS [Bloodbank!1],
                        NULL                                                 AS [Patient!2!dfn],
                        NULL                                                 AS [Patient!2!firstName],
                        NULL                                                 AS [Patient!2!lastName],
                        NULL                                                 AS [Patient!2!ssn],
                        NULL                                                 AS [Patient!2!abo],
                        NULL                                                 AS [Patient!2!rh],
                        NULL                                                 AS [TransfusionReactions!3],
                        NULL                                                 AS [TransfusionReaction!4!type],
                        NULL                                                 AS [TransfusionReaction!4!date],
                        NULL                                                 AS [TransfusionRequirements!5],
                        NULL                                                 AS [TransfusionRequirement!6!modifier],
                        NULL                                                 AS [Antibodies!7],
                        NULL                                                 AS [Antibody!8!name],
                        NULL                                                 AS [Units!9],
                        NULL                                                 AS [Unit!10!status],
                        NULL                                                 AS [Unit!10!id],
                        NULL                                                 AS [Unit!10!product],
                        NULL                                                 AS [Unit!10!productCode],
                        NULL                                                 AS [Unit!10!location],
                        NULL                                                 AS [Unit!10!expDate],
                        NULL                                                 AS [Specimen!11!expDate],
                        NULL                                                 AS [Specimen!11!uid],
                        NULL                                                 AS [Components!12],
                        CompCls.ComponentClassShortName                AS [Component!13!name],
                        RTRIM( CompCls.CprsOrderableItemID )                 AS [Component!13!id],
                        CompClsParam.SpecimenRequiredIndicator        AS [Component!13!specimen],
                        NULL                                                 AS [LabTests!14],
                        NULL                                                 AS [LabTest!15!id],
                        NULL                                                 AS [LabTest!15!name],
                        NULL                                                 AS [MsbosList!16],
                        NULL                                                 AS [Msbos!17!name],
                        NULL                                                 AS [Msbos!17!threshold],
                        NULL                                                 AS [Surgeries!18],
                        NULL                                                 AS [Surgery!19!name],
                        NULL                                                 AS [Surgery!19!noBloodRequiredIndicator]  

        FROM                
                dbo.ComponentClass CompCls

                INNER JOIN dbo.ComponentClassParameter CompClsParam
                        ON CompCls.ComponentClassID = CompClsParam.ComponentClassID

        WHERE                 
                CompCls.CprsOrderableItemID IS NOT NULL

                AND CompClsParam.DivisionCode = @DivisionCode

        UNION ALL

        -- <LabTests>
        SELECT                
                        14                                        AS Tag,
                        13                                        AS Parent,
                        3                                        AS [Bloodbank!1!GroupOrder!hide],
                        1                                        AS [Component!13!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [TransfusionRequirements!5],
                        NULL                                        AS [TransfusionRequirement!6!modifier],
                        NULL                                        AS [Antibodies!7],
                        NULL                                        AS [Antibody!8!name],
                        NULL                                        AS [Units!9],
                        NULL                                        AS [Unit!10!status],
                        NULL                                        AS [Unit!10!id],
                        NULL                                        AS [Unit!10!product],
                        NULL                                        AS [Unit!10!productCode],
                        NULL                                        AS [Unit!10!location],
                        NULL                                        AS [Unit!10!expDate],
                        NULL                                        AS [Specimen!11!expDate],
                        NULL                                        AS [Specimen!11!uid],
                        NULL                                        AS [Components!12],
                        NULL                                        AS [Component!13!name],
                        RTRIM( CompCls.CprsOrderableItemID )        AS [Component!13!id],
                        NULL                                        AS [Component!13!specimen],
                        NULL                                        AS [LabTests!14],
                        NULL                                        AS [LabTest!15!id],
                        NULL                                        AS [LabTest!15!name],
                        NULL                                        AS [MsbosList!16],
                        NULL                                        AS [Msbos!17!name],
                        NULL                                        AS [Msbos!17!threshold],
                        NULL                                        AS [Surgeries!18],
                        NULL                                        AS [Surgery!19!name],
                        NULL                                        AS [Surgery!19!noBloodRequiredIndicator]  

        FROM                
                dbo.ComponentClass CompCls

                INNER JOIN dbo.ComponentClassParameter CompClsParam
                        ON CompCls.ComponentClassID = CompClsParam.ComponentClassID

        WHERE                 
                CompCls.CprsOrderableItemID IS NOT NULL

                AND CompClsParam.DivisionCode = @DivisionCode

        UNION ALL

        -- <LabTest id="" name="">
        SELECT DISTINCT        
                        15                                         AS Tag,
                        14                                         AS Parent,
                        3                                         AS [Bloodbank!1!GroupOrder!hide],
                        1                                         AS [Component!13!GroupOrder!hide],
                        NULL                                          AS [Bloodbank!1],
                        NULL                                         AS [Patient!2!dfn],
                        NULL                                         AS [Patient!2!firstName],
                        NULL                                         AS [Patient!2!lastName],
                        NULL                                         AS [Patient!2!ssn],
                        NULL                                         AS [Patient!2!abo],
                        NULL                                         AS [Patient!2!rh],
                        NULL                                         AS [TransfusionReactions!3],
                        NULL                                         AS [TransfusionReaction!4!type],
                        NULL                                         AS [TransfusionReaction!4!date],
                        NULL                                         AS [TransfusionRequirements!5],
                        NULL                                         AS [TransfusionRequirement!6!modifier],
                        NULL                                         AS [Antibodies!7],
                        NULL                                         AS [Antibody!8!name],
                        NULL                                         AS [Units!9],
                        NULL                                         AS [Unit!10!status],
                        NULL                                         AS [Unit!10!id],
                        NULL                                         AS [Unit!10!product],
                        NULL                                         AS [Unit!10!productCode],
                        NULL                                         AS [Unit!10!location],
                        NULL                                         AS [Unit!10!expDate],
                        NULL                                         AS [Specimen!11!expDate],
                        NULL                                         AS [Specimen!11!uid],
                        NULL                                         AS [Components!12],
                        NULL                                         AS [Component!13!name],
                        RTRIM( CompCls.CprsOrderableItemID )         AS [Component!13!id],
                        NULL                                         AS [Component!13!specimen],
                        NULL                                         AS [LabTests!14],
                        RTRIM( SpecTestThrd.LabTestID )          AS [LabTest!15!id],
                        SpecTestThrd.VistALaboratoryTestName          AS [LabTest!15!name],
                        NULL                                         AS [MsbosList!16],
                        NULL                                         AS [Msbos!17!name],
                        NULL                                         AS [Msbos!17!threshold],
                        NULL                                         AS [Surgeries!18],
                        NULL                                         AS [Surgery!19!name],
                        NULL                                         AS [Surgery!19!noBloodRequiredIndicator]  

        FROM                
                dbo.ComponentClass CompCls

                INNER JOIN dbo.SpecimenTestThreshold SpecTestThrd
                        ON SpecTestThrd.ComponentClassID = CompCls.ComponentClassID                

        WHERE
                CompCls.CprsOrderableItemID IS NOT NULL

                AND SpecTestThrd.DivisionCode = @DivisionCode

        UNION ALL

        -- <MsbosList>
        SELECT                
                        16                                        AS Tag,
                        13                                        AS Parent,
                        3                                        AS [Bloodbank!1!GroupOrder],
                        2                                        AS [Component!13!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [TransfusionRequirements!5],
                        NULL                                        AS [TransfusionRequirement!6!modifier],
                        NULL                                        AS [Antibodies!7],
                        NULL                                        AS [Antibody!8!name],
                        NULL                                        AS [Units!9],
                        NULL                                        AS [Unit!10!status],
                        NULL                                        AS [Unit!10!id],
                        NULL                                        AS [Unit!10!product],
                        NULL                                        AS [Unit!10!productCode],
                        NULL                                        AS [Unit!10!location],
                        NULL                                        AS [Unit!10!expDate],
                        NULL                                        AS [Specimen!11!expDate],
                        NULL                                        AS [Specimen!11!uid],
                        NULL                                        AS [Components!12],
                        NULL                                        AS [Component!13!name],
                        RTRIM( CompCls.CprsOrderableItemID )        AS [Component!13!id],
                        NULL                                        AS [Component!13!specimen],
                        NULL                                        AS [LabTests!14],
                        NULL                                        AS [LabTest!15!id],
                        NULL                                        AS [LabTest!15!name],
                        NULL                                        AS [MsbosList!16],
                        NULL                                        AS [Msbos!17!name],
                        NULL                                        AS [Msbos!17!threshold],
                        NULL                                        AS [Surgeries!18],
                        NULL                                        AS [Surgery!19!name],
                        NULL                                        AS [Surgery!19!noBloodRequiredIndicator]  

        FROM                
                dbo.ComponentClass CompCls

                INNER JOIN dbo.ComponentClassParameter CompClsParam
                        ON CompCls.ComponentClassID = CompClsParam.ComponentClassID

        WHERE                 
                CompCls.CprsOrderableItemID IS NOT NULL

                AND CompClsParam.DivisionCode = @DivisionCode

        UNION ALL

        -- <Msbos name="" threshold="" />
        SELECT DISTINCT        
                        17                                                        AS Tag,
                        16                                                        AS Parent,
                        3                                                        AS [Bloodbank!1!GroupOrder!hide],
                        2                                                        AS [Component!13!GroupOrder!hide],
                        NULL                                                         AS [Bloodbank!1],
                        NULL                                                        AS [Patient!2!dfn],
                        NULL                                                        AS [Patient!2!firstName],
                        NULL                                                        AS [Patient!2!lastName],
                        NULL                                                        AS [Patient!2!ssn],
                        NULL                                                        AS [Patient!2!abo],
                        NULL                                                        AS [Patient!2!rh],
                        NULL                                                        AS [TransfusionReactions!3],
                        NULL                                                        AS [TransfusionReaction!4!type],
                        NULL                                                        AS [TransfusionReaction!4!date],
                        NULL                                                        AS [TransfusionRequirements!5],
                        NULL                                                        AS [TransfusionRequirement!6!modifier],
                        NULL                                                        AS [Antibodies!7],
                        NULL                                                        AS [Antibody!8!name],
                        NULL                                                        AS [Units!9],
                        NULL                                                        AS [Unit!10!status],
                        NULL                                                        AS [Unit!10!id],
                        NULL                                                        AS [Unit!10!product],
                        NULL                                                        AS [Unit!10!productCode],
                        NULL                                                        AS [Unit!10!location],
                        NULL                                                        AS [Unit!10!expDate],
                        NULL                                                        AS [Specimen!11!expDate],
                        NULL                                                        AS [Specimen!11!uid],
                        NULL                                                        AS [Components!12],
                        NULL                                                        AS [Component!13!name],
                        rtrim( CompCls.CprsOrderableItemID )                        AS [Component!13!id],
                        NULL                                                        AS [Component!13!specimen],
                        NULL                                                        AS [LabTests!14],
                        NULL                                                        AS [LabTest!15!id],
                        NULL                                                        AS [LabTest!15!name],
                        NULL                                                        AS [MsbosList!16],
                        Msbos.SurgeryName                                        AS [Msbos!17!name],
                        MsbosComponentClass.MaximumSetupUnitQuantity         AS [Msbos!17!threshold],
                        NULL                                                         AS [Surgeries!18],
                        NULL                                                         AS [Surgery!19!name],
                        NULL                                                         AS [Surgery!19!noBloodRequiredIndicator]  

        FROM                
                dbo.ComponentClass CompCls

                INNER JOIN dbo.MsbosComponentClass
                        ON CompCls.ComponentClassID = MsbosComponentClass.ComponentClassID                


                INNER JOIN dbo.Msbos
                        ON Msbos.MsbosGUID = MsbosComponentClass.MsbosGUID

                WHERE 
                        Msbos.DivisionCode = @DivisionCode

                        AND CompCls.CprsOrderableItemID IS NOT NULL

                        /****** CR 3078: filter out inactive MSBOS records *******/
                        AND Msbos.RecordStatusCode <> 'X'
                        /****** CR 3156: filter out inactive MsbosComponentClass records *******/
                        AND MsbosComponentClass.RecordStatusCode <> 'X'

        UNION ALL

        -- <Surgeries>
        SELECT                
                        18                                        AS Tag,
                        1                                        AS Parent,
                        4                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!13!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [TransfusionRequirements!5],
                        NULL                                        AS [TransfusionRequirement!6!modifier],
                        NULL                                        AS [Antibodies!7],
                        NULL                                        AS [Antibody!8!name],
                        NULL                                        AS [Units!9],
                        NULL                                        AS [Unit!10!status],
                        NULL                                        AS [Unit!10!id],
                        NULL                                        AS [Unit!10!product],
                        NULL                                        AS [Unit!10!productCode],
                        NULL                                        AS [Unit!10!location],
                        NULL                                        AS [Unit!10!expDate],
                        NULL                                        AS [Specimen!11!expDate],
                        NULL                                        AS [Specimen!11!uid],
                        NULL                                        AS [Components!12],
                        NULL                                        AS [Component!13!name],
                        NULL                                        AS [Component!13!id],
                        NULL                                        AS [Component!13!specimen],
                        NULL                                        AS [LabTests!14],
                        NULL                                        AS [LabTest!15!id],
                        NULL                                        AS [LabTest!15!name],
                        NULL                                        AS [MsbosList!16],
                        NULL                                        AS [Msbos!17!name],
                        NULL                                        AS [Msbos!17!threshold],
                        NULL                                        AS [Surgeries!18],
                        NULL                                        AS [Surgery!19!name],
                        NULL                                        AS [Surgery!19!noBloodRequiredIndicator] 

        UNION ALL

        -- <Surgery name="">
        SELECT DISTINCT        
                        19                                                                                AS Tag,
                        18                                                                                AS Parent,
                        4                                                                                 AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                 AS [Component!13!GroupOrder!hide],
                        NULL                                                                                  AS [Bloodbank!1],
                        NULL                                                                                 AS [Patient!2!dfn],
                        NULL                                                                                 AS [Patient!2!firstName],
                        NULL                                                                                 AS [Patient!2!lastName],
                        NULL                                                                                 AS [Patient!2!ssn],
                        NULL                                                                                 AS [Patient!2!abo],
                        NULL                                                                                 AS [Patient!2!rh],
                        NULL                                                                                 AS [TransfusionReactions!3],
                        NULL                                                                                 AS [TransfusionReaction!4!type],
                        NULL                                                                                 AS [TransfusionReaction!4!date],
                        NULL                                                                                 AS [TransfusionRequirements!5],
                        NULL                                                                                 AS [TransfusionRequirement!6!modifier],
                        NULL                                                                                 AS [Antibodies!7],
                        NULL                                                                                 AS [Antibody!8!name],
                        NULL                                                                                 AS [Units!9],
                        NULL                                                                                 AS [Unit!10!status],
                        NULL                                                                                 AS [Unit!10!id],
                        NULL                                                                                 AS [Unit!10!product],
                        NULL                                                                                 AS [Unit!10!productCode],
                        NULL                                                                                 AS [Unit!10!location],
                        NULL                                                                                 AS [Unit!10!expDate],
                        NULL                                                                                 AS [Specimen!11!expDate],
                        NULL                                                                                 AS [Specimen!11!uid],
                        NULL                                                                                 AS [Components!12],
                        NULL                                                                                 AS [Component!13!name],
                        NULL                                                                                 AS [Component!13!id],
                        NULL                                                                                 AS [Component!13!specimen],
                        NULL                                                                                 AS [LabTests!14],
                        NULL                                                                                 AS [LabTest!15!id],
                        NULL                                                                                 AS [LabTest!15!name],
                        NULL                                                                                 AS [MsbosList!16],
                        NULL                                                                                 AS [Msbos!17!name],
                        NULL                                                                                 AS [Msbos!17!threshold],
                        NULL                                                                                 AS [Surgeries!18],
                        dbo.Msbos.SurgeryName                                                                AS [Surgery!19!name],
                        CASE WHEN (TypeAndScreenIndicator = 1 OR NoBloodRequiredIndicator = 1)
                        THEN        1
                        ELSE         0
                        END                                                                                  AS [Surgery!19!noBloodRequiredIndicator]  

        FROM                dbo.Msbos

        WHERE                        
                        /****** CR 3156: filter out by division *******/
                                        Msbos.DivisionCode = @DivisionCode

                        /****** CR 3078: filter out inactive MSBOS records *******/
            AND                Msbos.RecordStatusCode <> 'X'

        ORDER BY        [Bloodbank!1!GroupOrder!hide], 
                        [Component!13!id], 
                        [Component!13!GroupOrder!hide], 
                        [LabTest!15!id], 
                        [Msbos!17!name], 
                        Tag

        FOR XML EXPLICIT

SET NOCOUNT OFF
GO


SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spVistaGetXmlPatientData') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spVistaGetXmlPatientData
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         
**
**        Author:        Brian Tomlin / Stas Antropov
**        Date:         01-25-2005
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------                ---------                -----------------
**        06/29/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Header added, Added NOCOUNT, Specified table owners, Removed comments, UPPERCASED SQL
**        05/13/08        M. Smith        Changed @VistaPatientID to BIGINT datatype (CR 2431)
**        06/04/08        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/16/08        M. Smith        Changed "SELECT" to "SET" for @PatientFoundFlag, changed JOIN to be ANSI 92 compliant, and
**                                        moved @PatientFoundFlag up for performance 
**        01/04/10        M. Smith        Changed to get and check UnitStatusCode from the BloodUnitStatusCodeCurrent table. (CR 1174)
**        01/25/10        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/24/10        D. Askew        Reformatted SQL; added productCode to SELECT (CR 2806).
**        06/06/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spVistaGetXmlPatientData
(
        @VistAPatientId                BIGINT
)

AS

SET NOCOUNT ON

DECLARE @PatientFoundFlag AS BIT
        
        SET @PatientFoundFlag = ISNULL((        SELECT         TOP 1 1
                                                FROM         dbo.Patient
                                                WHERE        VistaPatientId = @VistaPatientId), 0 )

        --<BloodBank>
        SELECT        1                                        AS Tag,
                        NULL                                        AS Parent,
                        1                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!11!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [Antibodies!5],
                        NULL                                        AS [Antibody!6!name],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        
        UNION ALL
        
        -- <Patient dfn="" firstName="" lastName="" ssn="" abo="" rh="">
        SELECT        2                                        AS Tag,
                        1                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!11!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        P.VistaPatientID                                 AS [Patient!2!dfn],
                        P.PatientFirstName                        AS [Patient!2!firstName],
                        P.PatientLastName                        AS [Patient!2!lastName],
                        P.PatientSSN                                AS [Patient!2!ssn],
                        dbo.fnGetABO( P.PatientGUID )                 AS [Patient!2!abo],
                        dbo.fnGetRh( P.PatientGUID )                AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [Antibodies!5],
                        NULL                                        AS [Antibody!6!name],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        FROM                
                dbo.Patient P
        
        WHERE                
                P.VistaPatientID = @VistaPatientID
        
        UNION ALL
        
        -- <TransfusionReactions>
        SELECT        3                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!11!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [Antibodies!5],
                        NULL                                        AS [Antibody!6!name],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        WHERE                
                @PatientFoundFlag = 1
        
        UNION ALL
        
        -- <TransfusionReaction type="" date="">
        SELECT DISTINCT        
                        4                                                AS Tag,
                        3                                                AS Parent,
                        2                                                 AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                 AS [Component!11!GroupOrder!hide],
                        NULL                                                  AS [Bloodbank!1],
                        NULL                                                 AS [Patient!2!dfn],
                        NULL                                                 AS [Patient!2!firstName],
                        NULL                                                 AS [Patient!2!lastName],
                        NULL                                                 AS [Patient!2!ssn],
                        NULL                                                 AS [Patient!2!abo],
                        NULL                                                 AS [Patient!2!rh],
                        NULL                                                 AS [TransfusionReactions!3],
                        TransReactType.TransfusionReactionTypeText        AS [TransfusionReaction!4!type],
                        PatTransReact.NotedDateTime                         AS [TransfusionReaction!4!date],
                        NULL                                                 AS [Antibodiess!5],
                        NULL                                                 AS [Antibody!6!name],
                        NULL                                                 AS [Units!7],
                        NULL                                                 AS [Unit!8!status],
                        NULL                                                 AS [Unit!8!id],
                        NULL                                                 AS [Unit!8!product],
                        NULL                                                 AS [Unit!8!productCode],
                        NULL                                                 AS [Unit!8!location],
                        NULL                                                 AS [Unit!8!expDate]
        
        FROM                
                dbo.Patient P
                
                JOIN dbo.PatientTransfusion PT
                        ON P.PatientGuid = PT.PatientGuid
                
                JOIN dbo.TransfusionReaction TR
                        ON PT.PatientTransfusionGuid = TR.PatientTransfusionGuid
                
                JOIN dbo.PatientTransfusionReaction PatTransReact
                        ON TR.PatientTransfusionReactionGuid = PatTransReact.PatientTransfusionReactionGuid
                
                JOIN dbo.TransfusionReactionType TransReactType         
                        ON PatTransReact.TransfusionReactionTypeCode = TransReactType.TransfusionReactionTypeCode
                
        WHERE        
                P.VistaPatientID = @VistaPatientID
                                
                AND @PatientFoundFlag = 1
                                
        UNION ALL 
        
        -- <Antibodies>
        SELECT        5                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!11!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [Antibodies!5],
                        NULL                                        AS [Antibody!6!name],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        WHERE                
                @PatientFoundFlag = 1
        
        UNION ALL
        
        -- <Antibody name="">
        SELECT DISTINCT        
                        6                                        AS Tag,
                        5                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!11!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [Antibodies!5],
                        dbo.AntibodyType.AntibodyTypeName        AS [Antibody!6!name],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
                
        FROM                
                dbo.Patient
        
                INNER JOIN dbo.PatientTransfusionRequirement
                        ON dbo.PatientTransfusionRequirement.PatientGUID = dbo.Patient.PatientGUID        
                        
                INNER JOIN dbo.AntibodyType
                        ON dbo.AntibodyType.AntibodyTypeID = dbo.PatientTransfusionRequirement.AntibodyTypeID

        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID
                
                AND @PatientFoundFlag = 1
        
        UNION ALL
        
        -- <Units>
        SELECT        7                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!11!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [Antibodies!5],
                        NULL                                        AS [Antibody!6!name],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        WHERE                
                @PatientFoundFlag = 1
        
        UNION ALL
        
        -- Assigned and crossmatched units
        -- <Unit status="" id="" product="" location="" expDate="" />
        SELECT DISTINCT        
                        8                                                                                                        AS Tag,
                        7                                                                                                        AS Parent,
                        2                                                                                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                                        AS [Component!11!GroupOrder!hide],
                        NULL                                                                                                         AS [Bloodbank!1],
                        NULL                                                                                                        AS [Patient!2!dfn],
                        NULL                                                                                                        AS [Patient!2!firstName],
                        NULL                                                                                                        AS [Patient!2!lastName],
                        NULL                                                                                                        AS [Patient!2!ssn],
                        NULL                                                                                                        AS [Patient!2!abo],
                        NULL                                                                                                        AS [Patient!2!rh],
                        NULL                                                                                                        AS [TransfusionReactions!3],
                        NULL                                                                                                        AS [TransfusionReaction!4!type],
                        NULL                                                                                                        AS [TransfusionReaction!4!date],
                        NULL                                                                                                        AS [Antibodies!5],
                        NULL                                                                                                        AS [Antibody!6!name],
                        NULL                                                                                                        AS [Units!7],
                        BUSCC.UnitStatusCode                                                                                        AS [Unit!8!status],
                        dbo.BloodUnit.EyeReadableUnitId                                                                        AS [Unit!8!id],
                        dbo.ProductType.ProductTypePrintName                                                                        AS [Unit!8!product],
                        -- ******************************************************************************************************************************************************************************************
                        CASE dbo.BloodUnit.LabelTypeCode
                                WHEN 'I' THEN 
                                        dbo.BloodUnit.UnitProductCode 
                                        + dbo.DonationType.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS 
                                        + dbo.BloodUnit.UnitDivisionId 
                                ELSE 
                                        dbo.BloodUnit.UnitProductCode
                                END                                                                                                 AS [Unit!8!productCode],
                        -- ******************************************************************************************************************************************************************************************
                        dbo.VamcDivision.DivisionName                                                                                 AS [Unit!8!location],
                        dbo.BloodUnitMedia.UnitExpirationDate                                                                         AS [Unit!8!expDate]
        
        FROM                dbo.BloodUnitStatusCodeCurrent BUSCC
        
                INNER JOIN dbo.BloodUnit
                        ON BUSCC.BloodUnitGUID = dbo.BloodUnit.BloodUnitGUID
        
                INNER JOIN dbo.OrderedUnit
                        ON dbo.BloodUnit.BloodUnitGUID = dbo.OrderedUnit.BloodUnitGUID
        
                INNER JOIN dbo.OrderedComponent
                        ON dbo.OrderedUnit.OrderedComponentGUID = dbo.OrderedComponent.OrderedComponentGUID
        
                INNER JOIN dbo.PatientOrder
                        ON dbo.OrderedComponent.PatientOrderGUID = dbo.PatientOrder.PatientOrderGUID
        
                INNER JOIN dbo.PatientTreatment
                        ON dbo.PatientOrder.PatientTreatmentGUID = dbo.PatientTreatment.PatientTreatmentGUID
        
                INNER JOIN dbo.Patient
                        ON dbo.PatientTreatment.PatientGUID = dbo.Patient.PatientGUID
        
                INNER JOIN dbo.BloodProduct
                        ON dbo.BloodUnit.BloodProductGUID = dbo.BloodProduct.BloodProductGUID
        
                INNER JOIN dbo.ProductType
                        ON BloodProduct.ProductTypeCode = ProductType.ProductTypeCode
        
                INNER JOIN dbo.VamcDivision
                        ON dbo.BloodUnit.DivisionCode = dbo.VamcDivision.DivisionCode
        
                INNER JOIN dbo.BloodUnitMedia
                        ON dbo.BloodUnit.BloodUnitGUID = dbo.BloodUnitMedia.BloodUnitGUID
        
                LEFT OUTER JOIN dbo.DonationType 
                        ON dbo.BloodUnit.DonationTypeId = dbo.DonationType.DonationTypeId
        
        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID
                
                AND @PatientFoundFlag = 1
                
                AND BUSCC.UnitStatusCode IN ( 'S', 'C' )
                
                AND dbo.BloodUnitMedia.UnitExpirationDate > GETUTCDATE()
        
        UNION ALL
        
        -- Autologous units
        -- <Unit status="" id="" product="" location="" expDate="" />
        SELECT DISTINCT        
                        8                                                                                                AS Tag,
                        7                                                                                                AS Parent,
                        2                                                                                                 AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                                 AS [Component!11!GroupOrder!hide],
                        NULL                                                                                                  AS [Bloodbank!1],
                        NULL                                                                                                 AS [Patient!2!dfn],
                        NULL                                                                                                 AS [Patient!2!firstName],
                        NULL                                                                                                 AS [Patient!2!lastName],
                        NULL                                                                                                 AS [Patient!2!ssn],
                        NULL                                                                                                 AS [Patient!2!abo],
                        NULL                                                                                                 AS [Patient!2!rh],
                        NULL                                                                                                 AS [TransfusionReactions!3],
                        NULL                                                                                                 AS [TransfusionReaction!4!type],
                        NULL                                                                                                 AS [TransfusionReaction!4!date],
                        NULL                                                                                                 AS [Antibodies!5],
                        NULL                                                                                                 AS [Antibody!6!name],
                        NULL                                                                                                 AS [Units!7],
                        dbo.DonationType.RestrictionTypeCode                                                                 AS [Unit!8!status],
                        dbo.BloodUnit.UnitProductCode                                                                         AS [Unit!8!id],
                        dbo.ProductType.ProductTypePrintName                                                                 AS [Unit!8!product],
                        -- ******************************************************************************************************************************************************************************************
                        CASE dbo.BloodUnit.LabelTypeCode
                        WHEN 'I' THEN 
                                dbo.BloodUnit.UnitProductCode 
                                + dbo.DonationType.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS 
                                + dbo.BloodUnit.UnitDivisionId 
                        ELSE 
                                dbo.BloodUnit.UnitProductCode
                        END                                                                                                 AS [Unit!8!productCode],
                        -- ******************************************************************************************************************************************************************************************
                        dbo.VamcDivision.DivisionName                                                                         AS [Unit!8!location],
                        dbo.BloodUnitMedia.UnitExpirationDate                                                                 AS [Unit!8!expDate]
        
        FROM                dbo.DonationType
        
                INNER JOIN dbo.BloodUnit
                        ON dbo.DonationType.DonationTypeId = dbo.BloodUnit.DonationTypeId
        
                INNER JOIN dbo.BloodUnitMedia
                        ON dbo.BloodUnit.BloodUnitGUID = dbo.BloodUnitMedia.BloodUnitGUID
        
                INNER JOIN dbo.Patient
                        ON dbo.BloodUnitMedia.DirectedPatientGUID = dbo.Patient.PatientGUID
        
                INNER JOIN dbo.BloodProduct
                        ON dbo.BloodUnit.BloodProductGUID = dbo.BloodProduct.BloodProductGUID
        
                INNER JOIN dbo.ProductType
                        ON dbo.BloodProduct.ProductTypeCode = dbo.ProductType.ProductTypeCode
        
                INNER JOIN dbo.VamcDivision
                        ON dbo.BloodUnit.DivisionCode = dbo.VamcDivision.DivisionCode
        
        
        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID
                
                AND @PatientFoundFlag = 1
                
                AND dbo.DonationType.RestrictionTypeCode IN ('A', 'D')
                
                AND dbo.BloodUnitMedia.UnitExpirationDate > GETUTCDATE()


FOR XML EXPLICIT

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spVistaGetXmlPatientReportData') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spVistaGetXmlPatientReportData
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         
**
**        Author:        Brian Tomlin / Stas Antropov
**        Date:         01-25-2005
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------                ---------                -----------------
**        06/29/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Header added, Added NOCOUNT, Specified table owners, Removed comments, UPPERCASED SQL
**                                        Removed Comments
**        07/19/05        C. Taylor        Added call to fnOrderedUnitCrossmatchResultCode to ensure latest crossmatch result is used (there may be 
**                                        repeat XMs)
**        08/21/05        S. Antropov        ** Reviewed for compliance with database standards and recommendations **
**                                        Performed secondary review during the code promotion - merged changes
**        07/13/07        Lohse                Adding datetime conversion for CR2253.
**        03/20/08        M. Smith        Modified SpecimenTest!4!comment to do checking for corrected records and records entered in error, added
**                                        cannedComment, and changed where condition for specimen test to include recordstatus = 'E' (Entered in 
**                                        Error).  (CR2403, CR2404)
**        03/25/08        K Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        05/13/08        M. Smith        Changed @VistaPatientID to BIGINT datatype (CR 2431)
**        06/04/08        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/16/08        M. Smith        Changed "SELECT" to "SET" for @PatientFoundFlag and moved @PatientFoundFlag up for performance 
**        01/04/10        M. Smith        Changed to get and check UnitStatusCode from the BloodUnitStatusCodeCurrent table. (CR 1174)
**        01/25/10        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/24/10        D. Askew        Reformatted SQL; added productCode to SELECT (CR 2806).
**        06/06/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        10/27/11        D. Askew        Changed Unit Rh to use RhFactorText rather than RhFactorCode (CR 3161)
**        11/14/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE   PROCEDURE dbo.spVistaGetXmlPatientReportData
(
        @VistAPatientId                BIGINT
)

AS

SET NOCOUNT ON

DECLARE @PatientFoundFlag AS BIT

        SET @PatientFoundFlag = ISNULL((        SELECT         TOP 1 1
                                                FROM         Patient
                                                WHERE        VistaPatientId = @VistaPatientId), 0 )

        --<BloodBank>
        SELECT        1                                        AS Tag,
                        NULL                                        AS Parent,
                        1                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!dob],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [SpecimenTests!3],
                        NULL                                        AS [SpecimenTest!4!printTestName],
                        NULL                                        AS [SpecimenTest!4!orderableTestName],
                        NULL                                        AS [SpecimenTest!4!result],
                        NULL                                        AS [SpecimenTest!4!testDate],
                        NULL                                        AS [SpecimenTest!4!cprsOrderId],
                        NULL                                        AS [SpecimenTest!4!divisionCode],
                        NULL                                        AS [SpecimenTest!4!enteringTechId],
                        NULL                                        AS [SpecimenTest!4!requestorId],
                        NULL                                        AS [SpecimenTest!4!comment],
                        NULL                                        AS [SpecimenTest!4!cannedComment],
                        NULL                                        AS [ComponentRequests!5],
                        NULL                                        AS [ComponentRequest!6!dateRequested],
                        NULL                                        AS [ComponentRequest!6!dateWanted],
                        NULL                                        AS [ComponentRequest!6!unitsRequested],
                        NULL                                        AS [ComponentRequest!6!cprsOrderId],
                        NULL                                        AS [ComponentRequest!6!componentClassName],
                        NULL                                        AS [ComponentRequest!6!componentClassShortName],
                        NULL                                        AS [ComponentRequest!6!requestorId],
                        NULL                                        AS [ComponentRequest!6!enteredById],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!abo],
                        NULL                                        AS [Unit!8!rh],
                        NULL                                        AS [Unit!8!divisionCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]

        UNION ALL

        -- <Patient dfn="" firstName="" lastName="" dob="" ssn="" abo="" rh="">
        SELECT        2                                                                AS Tag,
                        1                                                                AS Parent,
                        2                                                                AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                 AS [Bloodbank!1],
                        P.VistaPatientID                                                        AS [Patient!2!dfn],
                        P.PatientFirstName                                                AS [Patient!2!firstName],
                        P.PatientLastName                                                AS [Patient!2!lastName],
                        dbo.fnPatientDobConversionToFileManDateTime(P.PatientGuid)        AS [Patient!2!dob],
                        P.PatientSSN                                                        AS [Patient!2!ssn],
                        dbo.fnGetABO( P.PatientGUID )                                        AS [Patient!2!abo],
                        dbo.fnGetRh( P.PatientGUID )                                        AS [Patient!2!rh],
                        NULL                                                                AS [SpecimenTests!3],
                        NULL                                                                AS [SpecimenTest!4!printTestName],
                        NULL                                                                AS [SpecimenTest!4!orderableTestName],
                        NULL                                                                AS [SpecimenTest!4!result],
                        NULL                                                                AS [SpecimenTest!4!testDate],
                        NULL                                                                AS [SpecimenTest!4!cprsOrderId],
                        NULL                                                                AS [SpecimenTest!4!divisionCode],
                        NULL                                                                AS [SpecimenTest!4!enteringTechId],
                        NULL                                                                AS [SpecimenTest!4!requestorId],
                        NULL                                                                AS [SpecimenTest!4!comment],
                        NULL                                                                AS [SpecimenTest!4!cannedComment],
                        NULL                                                                AS [ComponentRequests!5],
                        NULL                                                                AS [ComponentRequest!6!dateRequested],
                        NULL                                                                AS [ComponentRequest!6!dateWanted],
                        NULL                                                                AS [ComponentRequest!6!unitsRequested],
                        NULL                                                                AS [ComponentRequest!6!cprsOrderId],
                        NULL                                                                AS [ComponentRequest!6!componentClassName],
                        NULL                                                                AS [ComponentRequest!6!componentClassShortName],
                        NULL                                                                AS [ComponentRequest!6!requestorId],
                        NULL                                                                AS [ComponentRequest!6!enteredById],
                        NULL                                                                AS [Units!7],
                        NULL                                                                AS [Unit!8!status],
                        NULL                                                                AS [Unit!8!id],
                        NULL                                                                AS [Unit!8!product],
                        NULL                                                                AS [Unit!8!productCode],
                        NULL                                                                AS [Unit!8!abo],
                        NULL                                                                AS [Unit!8!rh],
                        NULL                                                                AS [Unit!8!divisionCode],
                        NULL                                                                AS [Unit!8!location],
                        NULL                                                                AS [Unit!8!expDate]
        FROM                
                dbo.Patient P

        WHERE                
                P.VistaPatientID = @VistaPatientID

        UNION ALL

        -- <SpecimenTests>
        SELECT        3                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!dob],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [SpecimenTests!3],
                        NULL                                        AS [SpecimenTest!4!printTestName],
                        NULL                                        AS [SpecimenTest!4!orderableTestName],
                        NULL                                        AS [SpecimenTest!4!result],
                        NULL                                        AS [SpecimenTest!4!testDate],
                        NULL                                        AS [SpecimenTest!4!cprsOrderId],
                        NULL                                        AS [SpecimenTest!4!divisionCode],
                        NULL                                        AS [SpecimenTest!4!enteringTechId],
                        NULL                                        AS [SpecimenTest!4!requestorId],
                        NULL                                        AS [SpecimenTest!4!comment],
                        NULL                                        AS [SpecimenTest!4!cannedComment],
                        NULL                                        AS [ComponentRequests!5],
                        NULL                                        AS [ComponentRequest!6!dateRequested],
                        NULL                                        AS [ComponentRequest!6!dateWanted],
                        NULL                                        AS [ComponentRequest!6!unitsRequested],
                        NULL                                        AS [ComponentRequest!6!cprsOrderId],
                        NULL                                        AS [ComponentRequest!6!componentClassName],
                        NULL                                        AS [ComponentRequest!6!componentClassShortName],
                        NULL                                        AS [ComponentRequest!6!requestorId],
                        NULL                                        AS [ComponentRequest!6!enteredById],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!abo],
                        NULL                                        AS [Unit!8!rh],
                        NULL                                        AS [Unit!8!divisionCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        WHERE                
                @PatientFoundFlag = 1


        UNION ALL

        -- Specimen test results
        -- <SpecimenTest printTestName="" orderableTestName="" result="" testDate="" cprsOrderId="" 
        --        divisionCode="" enteringTechId="" requestorId="">
        SELECT DISTINCT        
                        4                                                                                                                                                AS Tag,
                        3                                                                                                                                                AS Parent,
                        2                                                                                                                                                AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                                                                                 AS [Bloodbank!1],
                        NULL                                                                                                                                                AS [Patient!2!dfn],
                        NULL                                                                                                                                                AS [Patient!2!firstName],
                        NULL                                                                                                                                                AS [Patient!2!lastName],
                        NULL                                                                                                                                                AS [Patient!2!dob],
                        NULL                                                                                                                                                AS [Patient!2!ssn],
                        NULL                                                                                                                                                AS [Patient!2!abo],
                        NULL                                                                                                                                                AS [Patient!2!rh],
                        NULL                                                                                                                                                AS [SpecimenTests!3],
                        dbo.BloodTestType.BloodTestName                                                                                                                AS [SpecimenTest!4!printTestName],
                        dbo.OrderableTest.OrderableTestName                                                                                                                AS [SpecimenTest!4!orderableTestName],
                        dbo.TestResult.TestResultText                                                                                                                        AS [SpecimenTest!4!result],
                        dbo.fnDateTimeConversionToFileManDateTime(dbo.fnTimeZoneConversionDateTime( SpecimenTest.DivisionCode, 0, SpecimenTest.TestDate))        AS [SpecimenTest!4!testDate],
                        dbo.PatientOrder.OrderGroupNumber                                                                                                                AS [SpecimenTest!4!cprsOrderId],
                        dbo.SpecimenTest.DivisionCode                                                                                                                        AS [SpecimenTest!4!divisionCode],
                        dbo.VbecsUser.UserDUZ                                                                                                                        AS [SpecimenTest!4!enteringTechId],
                        dbo.PatientOrder.OrderingProviderId                                                                                                                AS [SpecimenTest!4!requestorId],
                        -- ***************************************************************************************************************************************************************************************************************************************************************
                        CASE 
                        WHEN dbo.SpecimenTest.RecordStatusCode = 'E'
                                THEN        '** Entered in Error **     ' 
                                        + ISNULL(dbo.SpecimenTest.TestComments, '')  
                                        + '     ' 
                                        + CAST(dbo.fnTimeZoneConversionDateTime( dbo.SpecimenTest.DivisionCode, 0, dbo.SpecimenTest.TestDate) AS VARCHAR(20)) 
                                        + '     ' 
                                        + dbo.VbecsUser.UserName
                        WHEN CorrectedResultIndicator = 1
                                THEN        '** Corrected Result **     ' 
                                        + ISNULL(dbo.SpecimenTest.TestComments, '')  
                                        + '     ' 
                                        + CAST(dbo.fnTimeZoneConversionDateTime( dbo.SpecimenTest.DivisionCode, 0, dbo.SpecimenTest.TestDate) AS VARCHAR(20)) 
                                        + '     ' 
                                        + dbo.VbecsUser.UserName
                        ELSE ISNULL(dbo.SpecimenTest.TestComments, '')
                        END                                                                                                                                                 AS [SpecimenTest!4!comment],
                        -- ***************************************************************************************************************************************************************************************************************************************************************
                        InformationMessageText                                                                                                                                AS [SpecimenTest!4!cannedComment],
                        NULL                                                                                                                                                AS [ComponentRequests!5],
                        NULL                                                                                                                                                AS [ComponentRequest!6!dateRequested],
                        NULL                                                                                                                                                AS [ComponentRequest!6!dateWanted],
                        NULL                                                                                                                                                AS [ComponentRequest!6!unitsRequested],
                        NULL                                                                                                                                                AS [ComponentRequest!6!cprsOrderId],
                        NULL                                                                                                                                                AS [ComponentRequest!6!componentClassName],
                        NULL                                                                                                                                                AS [ComponentRequest!6!componentClassShortName],
                        NULL                                                                                                                                                AS [ComponentRequest!6!requestorId],
                        NULL                                                                                                                                                AS [ComponentRequest!6!enteredById],
                        NULL                                                                                                                                                AS [Units!7],
                        NULL                                                                                                                                                AS [Unit!8!status],
                        NULL                                                                                                                                                AS [Unit!8!id],
                        NULL                                                                                                                                                AS [Unit!8!product],
                        NULL                                                                                                                                                AS [Unit!8!productCode],
                        NULL                                                                                                                                                AS [Unit!8!abo],
                        NULL                                                                                                                                                AS [Unit!8!rh],
                        NULL                                                                                                                                                AS [Unit!8!divisionCode],
                        NULL                                                                                                                                                AS [Unit!8!location],
                        NULL                                                                                                                                                AS [Unit!8!expDate]

        FROM                dbo.BloodTestType

                INNER JOIN dbo.SpecimenTest
                        ON dbo.BloodTestType.BloodTestTypeId = dbo.SpecimenTest.BloodTestTypeId

                INNER JOIN dbo.VbecsUser
                        ON dbo.SpecimenTest.EntryTechId = dbo.VbecsUser.VbecsUserId

                INNER JOIN dbo.TestResult
                        ON dbo.SpecimenTest.TestResultId = dbo.TestResult.TestResultId

                INNER JOIN dbo.OrderedTest
                        ON dbo.SpecimenTest.OrderedTestGuid = dbo.OrderedTest.OrderedTestGuid

                INNER JOIN dbo.PatientOrder
                        ON dbo.OrderedTest.PatientOrderGuid = dbo.PatientOrder.PatientOrderGuid

                INNER JOIN dbo.PatientTreatment
                        ON dbo.PatientOrder.PatientTreatmentGuid = dbo.PatientTreatment.PatientTreatmentGuid

                INNER JOIN dbo.Patient
                        ON dbo.PatientTreatment.PatientGuid = dbo.Patient.PatientGuid

                INNER JOIN dbo.OrderableTest
                        ON dbo.BloodTestType.OrderableTestId = dbo.OrderableTest.OrderableTestId

                CROSS JOIN  dbo.InformationMessage


        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID

                AND @PatientFoundFlag = 1

                AND dbo.OrderedTest.OrderStatusCode = 'C'

                AND dbo.SpecimenTest.RecordStatusCode IN ('A', 'E')

                AND dbo.InformationMessage.InformationMessageId = 5407

                AND dbo.BloodTestType.BloodTestTypeId IN ( 18, 21, 52, 53, 54, 55, 56, 57, 58, 59, 61, 65, 68, 92, 93, 94, 95, 105, 106, 107, 108, 109, 110 )

        UNION ALL 

        -- Antibody test results
        -- <SpecimenTest printTestName="" orderableTestName="" result="" testDate="" cprsOrderId="" 
        --        divisionCode="" enteringTechId="" requestorId="">
        SELECT DISTINCT        
                        4                                                                                                                                                AS Tag,
                        3                                                                                                                                                AS Parent,
                        2                                                                                                                                                AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                                                                                 AS [Bloodbank!1],
                        NULL                                                                                                                                                AS [Patient!2!dfn],
                        NULL                                                                                                                                                AS [Patient!2!firstName],
                        NULL                                                                                                                                                AS [Patient!2!lastName],
                        NULL                                                                                                                                                AS [Patient!2!dob],
                        NULL                                                                                                                                                AS [Patient!2!ssn],
                        NULL                                                                                                                                                AS [Patient!2!abo],
                        NULL                                                                                                                                                AS [Patient!2!rh],
                        NULL                                                                                                                                                AS [SpecimenTests!3],
                        dbo.BloodTestType.BloodTestName                                                                                                                AS [SpecimenTest!4!printTestName],
                        dbo.OrderableTest.OrderableTestName                                                                                                                AS [SpecimenTest!4!orderableTestName],
                        dbo.TestResult.TestResultText                                                                                                                        AS [SpecimenTest!4!result],
                        dbo.fnDateTimeConversionToFileManDateTime(dbo.fnTimeZoneConversionDateTime( SpecimenTest.DivisionCode, 0, SpecimenTest.TestDate))        AS [SpecimenTest!4!testDate],
                        dbo.PatientOrder.OrderGroupNumber                                                                                                                AS [SpecimenTest!4!cprsOrderId],
                        dbo.SpecimenTest.DivisionCode                                                                                                                        AS [SpecimenTest!4!divisionCode],
                        dbo.VbecsUser.UserDUZ                                                                                                                        AS [SpecimenTest!4!enteringTechId],
                        dbo.PatientOrder.OrderingProviderId                                                                                                                AS [SpecimenTest!4!requestorId],
                        -- ***************************************************************************************************************************************************************************************************************************************************************
                        CASE 
                        WHEN dbo.SpecimenTest.RecordStatusCode = 'E'
                                THEN        '** Entered in Error **     ' 
                                        + ISNULL(dbo.SpecimenTest.TestComments, '')  
                                        + '     ' 
                                        + CAST(dbo.fnTimeZoneConversionDateTime( dbo.SpecimenTest.DivisionCode, 0, dbo.SpecimenTest.TestDate) AS VARCHAR(20)) 
                                        + '     ' 
                                        + dbo.VbecsUser.UserName
                        WHEN CorrectedResultIndicator = 1
                                THEN        '** Corrected Result **     ' 
                                        + ISNULL(dbo.SpecimenTest.TestComments, '')  
                                        + '     ' 
                                        + CAST(dbo.fnTimeZoneConversionDateTime( dbo.SpecimenTest.DivisionCode, 0, dbo.SpecimenTest.TestDate) AS VARCHAR(20)) 
                                        + '     ' 
                                        + dbo.VbecsUser.UserName
                        ELSE ISNULL(dbo.SpecimenTest.TestComments, '')
                        END                                                                                                                                                 AS [SpecimenTest!4!comment],
                        -- ***************************************************************************************************************************************************************************************************************************************************************
                        InformationMessageText                                                                                                                                AS [SpecimenTest!4!cannedComment],
                        NULL                                                                                                                                                AS [ComponentRequests!5],
                        NULL                                                                                                                                                AS [ComponentRequest!6!dateRequested],
                        NULL                                                                                                                                                AS [ComponentRequest!6!dateWanted],
                        NULL                                                                                                                                                AS [ComponentRequest!6!unitsRequested],
                        NULL                                                                                                                                                AS [ComponentRequest!6!cprsOrderId],
                        NULL                                                                                                                                                AS [ComponentRequest!6!componentClassName],
                        NULL                                                                                                                                                AS [ComponentRequest!6!componentClassShortName],
                        NULL                                                                                                                                                AS [ComponentRequest!6!requestorId],
                        NULL                                                                                                                                                AS [ComponentRequest!6!enteredById],
                        NULL                                                                                                                                                AS [Units!7],
                        NULL                                                                                                                                                AS [Unit!8!status],
                        NULL                                                                                                                                                AS [Unit!8!id],
                        NULL                                                                                                                                                AS [Unit!8!product],
                        NULL                                                                                                                                                AS [Unit!8!productCode],
                        NULL                                                                                                                                                AS [Unit!8!abo],
                        NULL                                                                                                                                                AS [Unit!8!rh],
                        NULL                                                                                                                                                AS [Unit!8!divisionCode],
                        NULL                                                                                                                                                AS [Unit!8!location],
                        NULL                                                                                                                                                AS [Unit!8!expDate]

        FROM                dbo.BloodTestType

                INNER JOIN dbo.SpecimenTest
                        ON dbo.BloodTestType.BloodTestTypeId = dbo.SpecimenTest.BloodTestTypeId

                INNER JOIN dbo.VbecsUser
                        ON dbo.SpecimenTest.EntryTechId = dbo.VbecsUser.VbecsUserId

                INNER JOIN dbo.TestResult
                        ON dbo.SpecimenTest.TestResultId = dbo.TestResult.TestResultId

                INNER JOIN dbo.OrderedTest
                        ON dbo.SpecimenTest.OrderedTestGuid = dbo.OrderedTest.OrderedTestGuid

                INNER JOIN dbo.PatientOrder
                        ON dbo.OrderedTest.PatientOrderGuid = dbo.PatientOrder.PatientOrderGuid

                INNER JOIN dbo.PatientTreatment
                        ON dbo.PatientOrder.PatientTreatmentGuid = dbo.PatientTreatment.PatientTreatmentGuid

                INNER JOIN dbo.Patient
                        ON dbo.PatientTreatment.PatientGuid = dbo.Patient.PatientGuid

                INNER JOIN dbo.OrderableTest
                        ON dbo.BloodTestType.OrderableTestId = dbo.OrderableTest.OrderableTestId

                CROSS JOIN  dbo.InformationMessage


        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID

                AND @PatientFoundFlag = 1

                AND dbo.OrderedTest.OrderStatusCode = 'C'

                AND dbo.SpecimenTest.RecordStatusCode IN ('A', 'E')

                AND dbo.InformationMessage.InformationMessageId = 2302

                AND dbo.BloodTestType.BloodTestTypeId IN ( 52, 92, 107 )

        UNION ALL

        -- <ComponentRequests>
        SELECT                 
                        5                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!dob],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [SpecimenTests!3],
                        NULL                                        AS [SpecimenTest!4!printTestName],
                        NULL                                        AS [SpecimenTest!4!orderableTestName],
                        NULL                                        AS [SpecimenTest!4!result],
                        NULL                                        AS [SpecimenTest!4!testDate],
                        NULL                                        AS [SpecimenTest!4!cprsOrderId],
                        NULL                                        AS [SpecimenTest!4!divisionCode],
                        NULL                                        AS [SpecimenTest!4!enteringTechId],
                        NULL                                        AS [SpecimenTest!4!requestorId],
                        NULL                                        AS [SpecimenTest!4!comment],
                        NULL                                        AS [SpecimenTest!4!cannedComment],
                        NULL                                        AS [ComponentRequests!5],
                        NULL                                        AS [ComponentRequest!6!dateRequested],
                        NULL                                        AS [ComponentRequest!6!dateWanted],
                        NULL                                        AS [ComponentRequest!6!unitsRequested],
                        NULL                                        AS [ComponentRequest!6!cprsOrderId],
                        NULL                                        AS [ComponentRequest!6!componentClassName],
                        NULL                                        AS [ComponentRequest!6!componentClassShortName],
                        NULL                                        AS [ComponentRequest!6!requestorId],
                        NULL                                        AS [ComponentRequest!6!enteredById],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!abo],
                        NULL                                        AS [Unit!8!rh],
                        NULL                                        AS [Unit!8!divisionCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        WHERE                
                @PatientFoundFlag = 1

        UNION ALL

        -- <ComponentRequest dateRequested="" dateWanted="" unitsRequested="" cprsOrderId="" componentClassName=""
        --        componentClassShortName="" requestorId="" enteredById=">
        SELECT DISTINCT        
                        6                                                                                                AS Tag,
                        5                                                                                                AS Parent,
                        2                                                                                                AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                                 AS [Bloodbank!1],
                        NULL                                                                                                AS [Patient!2!dfn],
                        NULL                                                                                                AS [Patient!2!firstName],
                        NULL                                                                                                AS [Patient!2!lastName],
                        NULL                                                                                                AS [Patient!2!dob],
                        NULL                                                                                                AS [Patient!2!ssn],
                        NULL                                                                                                AS [Patient!2!abo],
                        NULL                                                                                                AS [Patient!2!rh],
                        NULL                                                                                                AS [SpecimenTests!3],
                        NULL                                                                                                AS [SpecimenTest!4!printTestName],
                        NULL                                                                                                AS [SpecimenTest!4!orderableTestName],
                        NULL                                                                                                AS [SpecimenTest!4!result],
                        NULL                                                                                                AS [SpecimenTest!4!testDate],
                        NULL                                                                                                AS [SpecimenTest!4!cprsOrderId],
                        NULL                                                                                                AS [SpecimenTest!4!divisionCode],
                        NULL                                                                                                AS [SpecimenTest!4!enteringTechId],
                        NULL                                                                                                AS [SpecimenTest!4!requestorId],
                        NULL                                                                                                AS [SpecimenTest!4!comment],
                        NULL                                                                                                AS [SpecimenTest!4!cannedComment],
                        NULL                                                                                                AS [ComponentRequests!5],
                        -- ******************************************************************************************************************************************************************************************
                        dbo.fnDateTimeConversionToFileManDateTime(
                                dbo.fnTimeZoneConversionDateTime( 
                                        PatientOrder.DivisionCode, 0, PatientOrder.OrderPlacedDatetime ))                        AS [ComponentRequest!6!dateRequested],
                        -- ******************************************************************************************************************************************************************************************
                        dbo.fnDateTimeConversionToFileManDateTime(
                                dbo.fnTimeZoneConversionDateTime( 
                                        OrderedComponent.DivisionCode, 0, OrderedComponent.RequiredDatetime ))        AS [ComponentRequest!6!dateWanted],
                        -- ******************************************************************************************************************************************************************************************
                        dbo.OrderedComponent.RequiredUnitQuantity                                                        AS [ComponentRequest!6!unitsRequested],
                        dbo.PatientOrder.OrderGroupNumber                                                                AS [ComponentRequest!6!cprsOrderId],
                        dbo.ComponentClass.ComponentClassName                                                        AS [ComponentRequest!6!componentClassName],
                        dbo.ComponentClass.ComponentClassShortName                                                        AS [ComponentRequest!6!componentClassShortName],
                        dbo.PatientOrder.OrderingProviderId                                                                AS [ComponentRequest!6!requestorId],
                        dbo.PatientOrder.OrderEnteredById                                                                AS [ComponentRequest!6!enteredById],
                        NULL                                                                                                AS [Units!7],
                        NULL                                                                                                AS [Unit!8!status],
                        NULL                                                                                                AS [Unit!8!id],
                        NULL                                                                                                AS [Unit!8!product],
                        NULL                                                                                                AS [Unit!8!productCode],
                        NULL                                                                                                AS [Unit!8!abo],
                        NULL                                                                                                AS [Unit!8!rh],
                        NULL                                                                                                AS [Unit!8!divisionCode],
                        NULL                                                                                                AS [Unit!8!location],
                        NULL                                                                                                AS [Unit!8!expDate]
        FROM                
                dbo.PatientOrder

                INNER JOIN dbo.PatientTreatment
                        ON dbo.PatientOrder.PatientTreatmentGuid = dbo.PatientTreatment.PatientTreatmentGuid

                INNER JOIN dbo.Patient
                        ON dbo.PatientTreatment.PatientGuid = dbo.Patient.PatientGuid

                INNER JOIN dbo.OrderedComponent
                        ON dbo.PatientOrder.PatientOrderGuid = dbo.OrderedComponent.PatientOrderGuid

                INNER JOIN dbo.ComponentClass
                        ON dbo.OrderedComponent.ComponentClassId = dbo.ComponentClass.ComponentClassId

        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID

                AND @PatientFoundFlag = 1

        UNION ALL

        -- <Units>
        SELECT                 
                        7                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patien!2!lastName],
                        NULL                                        AS [Patient!2!dob],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [SpecimenTests!3],
                        NULL                                        AS [SpecimenTest!4!printTestName],
                        NULL                                        AS [SpecimenTest!4!orderableTestName],
                        NULL                                        AS [SpecimenTest!4!result],
                        NULL                                        AS [SpecimenTest!4!testDate],
                        NULL                                        AS [SpecimenTest!4!cprsOrderId],
                        NULL                                        AS [SpecimenTest!4!divisionCode],
                        NULL                                        AS [SpecimenTest!4!enteringTechId],
                        NULL                                        AS [SpecimenTest!4!requestorId],
                        NULL                                        AS [SpecimenTest!4!comment],
                        NULL                                        AS [SpecimenTest!4!cannedComment],
                        NULL                                        AS [ComponentRequests!5],
                        NULL                                        AS [ComponentRequest!6!dateRequested],
                        NULL                                        AS [ComponentRequest!6!dateWanted],
                        NULL                                        AS [ComponentRequest!6!unitsRequested],
                        NULL                                        AS [ComponentRequest!6!cprsOrderId],
                        NULL                                        AS [ComponentRequest!6!componentClassName],
                        NULL                                        AS [ComponentRequest!6!componentClassShortName],
                        NULL                                        AS [ComponentRequest!6!requestorId],
                        NULL                                        AS [ComponentRequest!6!enteredById],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!abo],
                        NULL                                        AS [Unit!8!rh],
                        NULL                                        AS [Unit!8!divisionCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        WHERE                
                @PatientFoundFlag = 1

        UNION ALL

        -- Assigned and crossmatched units
        -- <Unit status="" id="" product="" abo="" rh="" divisionCode="" location="" expDate="" />
        SELECT DISTINCT        
                        8                                                                                                        AS Tag,
                        7                                                                                                        AS Parent,
                        2                                                                                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                                         AS [Bloodbank!1],
                        NULL                                                                                                        AS [Patient!2!dfn],
                        NULL                                                                                                        AS [Patient!2!firstName],
                        NULL                                                                                                        AS [Patient!2!lastName],
                        NULL                                                                                                        AS [Patient!2!dob],
                        NULL                                                                                                        AS [Patient!2!ssn],
                        NULL                                                                                                        AS [Patient!2!abo],
                        NULL                                                                                                        AS [Patient!2!rh],
                        NULL                                                                                                        AS [SpecimenTests!3],
                        NULL                                                                                                        AS [SpecimenTest!4!printTestName],
                        NULL                                                                                                        AS [SpecimenTest!4!orderableTestName],
                        NULL                                                                                                        AS [SpecimenTest!4!result],
                        NULL                                                                                                        AS [SpecimenTest!4!testDate],
                        NULL                                                                                                        AS [SpecimenTest!4!cprsOrderId],
                        NULL                                                                                                        AS [SpecimenTest!4!divisionCode],
                        NULL                                                                                                        AS [SpecimenTest!4!enteringTechId],
                        NULL                                                                                                        AS [SpecimenTest!4!requestorId],
                        NULL                                                                                                        AS [SpecimenTest!4!comment],
                        NULL                                                                                                        AS [SpecimenTest!4!cannedComment],
                        NULL                                                                                                        AS [ComponentRequests!5],
                        NULL                                                                                                        AS [ComponentRequest!6!dateRequested],
                        NULL                                                                                                        AS [ComponentRequest!6!dateWanted],
                        NULL                                                                                                        AS [ComponentRequest!6!unitsRequested],
                        NULL                                                                                                        AS [ComponentRequest!6!cprsOrderId],
                        NULL                                                                                                        AS [ComponentRequest!6!componentClassName],
                        NULL                                                                                                        AS [ComponentRequest!6!componentClassShortName],
                        NULL                                                                                                        AS [ComponentRequest!6!requestorId],
                        NULL                                                                                                        AS [ComponentRequest!6!enteredById],
                        NULL                                                                                                        AS [Units!7],
                        BUSCC.UnitStatusCode                                                                                        AS [Unit!8!status],
                        dbo.BloodUnit.EyeReadableUnitId                                                                        AS [Unit!8!id],
                        dbo.ProductType.ProductTypePrintName                                                                        AS [Unit!8!product],
                        -- ******************************************************************************************************************************************************************************************
                        CASE dbo.BloodUnit.LabelTypeCode
                                WHEN 'I' THEN 
                                        dbo.BloodUnit.UnitProductCode 
                                        + dbo.DonationType.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS 
                                        + dbo.BloodUnit.UnitDivisionId 
                                ELSE 
                                        dbo.BloodUnit.UnitProductCode
                                END                                                                                                 AS [Unit!8!productCode],
                        -- ******************************************************************************************************************************************************************************************
                        dbo.BloodUnitMedia.BloodTypeCode                                                                        AS [Unit!8!abo],
                        dbo.RhFactor.RhFactorText                                                                                AS [Unit!8!rh],
                        dbo.BloodUnit.DivisionCode                                                                                AS [Unit!8!divisionCode],
                        dbo.IssuedUnit.LocationIen                                                                                AS [Unit!8!location],
                        dbo.fnDateTimeConversionToFileManDateTime(
                                dbo.fnTimeZoneConversionDateTime( 
                                        BloodUnit.DivisionCode, 0, BloodUnitMedia.UnitExpirationDate ))                                AS [Unit!8!expDate]

        FROM                
                dbo.BloodUnitStatusCodeCurrent BUSCC

                INNER JOIN dbo.BloodUnit
                        ON BUSCC.BloodUnitGUID = dbo.BloodUnit.BloodUnitGUID

                LEFT OUTER JOIN dbo.IssuedUnit
                        ON dbo.BloodUnit.BloodUnitGuid = dbo.IssuedUnit.BloodUnitGuid

                INNER JOIN dbo.OrderedUnit
                        ON dbo.BloodUnit.BloodUnitGUID = dbo.OrderedUnit.BloodUnitGUID

                INNER JOIN dbo.OrderedComponent
                        ON dbo.OrderedUnit.OrderedComponentGUID = dbo.OrderedComponent.OrderedComponentGUID

                INNER JOIN dbo.PatientOrder
                        ON dbo.OrderedComponent.PatientOrderGUID = dbo.PatientOrder.PatientOrderGUID

                INNER JOIN dbo.PatientTreatment
                        ON dbo.PatientOrder.PatientTreatmentGUID = dbo.PatientTreatment.PatientTreatmentGUID

                INNER JOIN dbo.Patient
                        ON dbo.PatientTreatment.PatientGUID = dbo.Patient.PatientGUID

                INNER JOIN dbo.BloodProduct
                        ON dbo.BloodUnit.BloodProductGUID = dbo.BloodProduct.BloodProductGUID

                INNER JOIN dbo.ProductType
                        ON dbo.BloodProduct.ProductTypeCode = dbo.ProductType.ProductTypeCode

                INNER JOIN dbo.VamcDivision
                        ON dbo.BloodUnit.DivisionCode = dbo.VamcDivision.DivisionCode

                INNER JOIN dbo.BloodUnitMedia
                        ON dbo.BloodUnit.BloodUnitGUID = dbo.BloodUnitMedia.BloodUnitGUID

                LEFT OUTER JOIN dbo.DonationType 
                        ON dbo.BloodUnit.DonationTypeId = dbo.DonationType.DonationTypeId

                LEFT JOIN dbo.RhFactor 
                        ON dbo.BloodUnitMedia.RhFactorCode = dbo.RhFactor.RhFactorCode

        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID

                AND @PatientFoundFlag = 1

                AND BUSCC.UnitStatusCode IN ( 'S', 'C' )

                AND dbo.BloodUnitMedia.UnitExpirationDate > GETUTCDATE()

                AND dbo.OrderedUnit.ReleaseDate IS NULL

                AND ((dbo.fnOrderedUnitCrossmatchResultCode(OrderedUnit.OrderedUnitGuid) IN ('C', 'E', 'G')) OR (OrderedUnit.CrossmatchResultCode IS NULL))

        ORDER BY        [Bloodbank!1!GroupOrder!hide],
                        Tag


FOR XML EXPLICIT

SET NOCOUNT OFF
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spVistaGetXmlSpecimenTestForPatient') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spVistaGetXmlSpecimenTestForPatient
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         
**
**        Author:        Brian Tomlin / Stas Antropov
**        Date:         01-25-2005
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------                ---------                -----------------
**        06/29/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Header added, Added NOCOUNT, Specified table owners, Removed comments, UPPERCASED SQL
**        05/13/08        M. Smith        Changed @VistaPatientID to BIGINT datatype (CR 2431)
**        06/04/08        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/16/08        M. Smith        Changed "SELECT" to "SET" for @PatientFoundFlag, changed JOIN to be ANSI 92 compliant, and
**                                        moved @PatientFoundFlag up for performance
**        01/04/10        M. Smith        Changed to get and check UnitStatusCode from the BloodUnitStatusCodeCurrent table. (CR 1174)
**        01/25/10        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/24/10        D. Askew        Reformatted SQL; added productCode to SELECT (CR 2806).
**        06/06/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spVistaGetXmlSpecimenTestForPatient
(
        @VistAPatientId                BIGINT
)

AS

SET NOCOUNT ON

DECLARE @PatientFoundFlag AS BIT
        
        SET @PatientFoundFlag = ISNULL((        SELECT         TOP 1 1
                                                FROM         dbo.Patient
                                                        WHERE        VistaPatientId = @VistaPatientId), 0 )
        
        --<BloodBank>
        SELECT        1                                        AS Tag,
                        NULL                                        AS Parent,
                        1                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!11!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [Antibodies!5],
                        NULL                                        AS [Antibody!6!name],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        
        UNION ALL
        
        -- <Patient dfn="" firstName="" lastName="" ssn="" abo="" rh="">
        SELECT        2                                        AS Tag,
                        1                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!11!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        P.VistaPatientID                                AS [Patient!2!dfn],
                        P.PatientFirstName                        AS [Patient!2!firstName],
                        P.PatientLastName                        AS [Patient!2!lastName],
                        P.PatientSSN                                AS [Patient!2!ssn],
                        dbo.fnGetABO( P.PatientGUID )                AS [Patient!2!abo],
                        dbo.fnGetRh( P.PatientGUID )                AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [Antibodies!5],
                        NULL                                        AS [Antibody!6!name],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        FROM                
                dbo.Patient P
        
        WHERE                
                P.VistaPatientID = @VistaPatientID
        
        UNION ALL
        
        -- <TransfusionReactions>
        SELECT        3                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!11!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [Antibodies!5],
                        NULL                                        AS [Antibody!6!name],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        WHERE                
                @PatientFoundFlag = 1
        
        UNION ALL
        
        -- <TransfusionReaction type="" date="">
        SELECT DISTINCT        
                        4                                                AS Tag,
                        3                                                AS Parent,
                        2                                                AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                AS [Component!11!GroupOrder!hide],
                        NULL                                                 AS [Bloodbank!1],
                        NULL                                                AS [Patient!2!dfn],
                        NULL                                                AS [Patient!2!firstName],
                        NULL                                                AS [Patient!2!lastName],
                        NULL                                                AS [Patient!2!ssn],
                        NULL                                                AS [Patient!2!abo],
                        NULL                                                AS [Patient!2!rh],
                        NULL                                                AS [TransfusionReactions!3],
                        TransReactType.TransfusionReactionTypeText        AS [TransfusionReaction!4!type],
                        PatTransReact.NotedDateTime                        AS [TransfusionReaction!4!date],
                        NULL                                                AS [Antibodiess!5],
                        NULL                                                AS [Antibody!6!name],
                        NULL                                                AS [Units!7],
                        NULL                                                AS [Unit!8!status],
                        NULL                                                AS [Unit!8!id],
                        NULL                                                AS [Unit!8!product],
                        NULL                                                AS [Unit!8!productCode],
                        NULL                                                AS [Unit!8!location],
                        NULL                                                AS [Unit!8!expDate]
        
        FROM                
                dbo.Patient P
                
                JOIN dbo.PatientTransfusion PT
                        ON P.PatientGuid = PT.PatientGuid
        
                JOIN dbo.TransfusionReaction TR
                        ON PT.PatientTransfusionGUID = TR.PatientTransfusionGUID
        
                JOIN dbo.PatientTransfusionReaction PatTransReact
                        ON TR.PatientTransfusionReactionGuid = PatTransReact.PatientTransfusionReactionGuid
                
                JOIN dbo.TransfusionReactionType  TransReactType
                        ON PatTransReact.TransfusionReactionTypeCode = TransReactType.TransfusionReactionTypeCode
                

        WHERE                
                P.VistaPatientID = @VistaPatientID
                
                AND @PatientFoundFlag = 1
                        
        UNION ALL 
        
        -- <Antibodies>
        SELECT        5                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!11!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [Antibodies!5],
                        NULL                                        AS [Antibody!6!name],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        WHERE                
                @PatientFoundFlag = 1
        
        UNION ALL
        
        -- <Antibody name="">
        SELECT DISTINCT        
                        6                                        AS Tag,
                        5                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!11!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [Antibodies!5],
                        dbo.AntibodyType.AntibodyTypeName        AS [Antibody!6!name],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
                
        FROM                
                dbo.Patient
        
                INNER JOIN dbo.PatientTransfusionRequirement
                        ON dbo.PatientTransfusionRequirement.PatientGUID = dbo.Patient.PatientGUID        
                        
                INNER JOIN dbo.AntibodyType
                        ON dbo.AntibodyType.AntibodyTypeID = dbo.PatientTransfusionRequirement.AntibodyTypeID
                
        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID

                AND @PatientFoundFlag = 1
        
        UNION ALL
        
        -- <Units>
        SELECT        7                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                        AS [Component!11!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [Antibodies!5],
                        NULL                                        AS [Antibody!6!name],
                        NULL                                        AS [Units!7],
                        NULL                                        AS [Unit!8!status],
                        NULL                                        AS [Unit!8!id],
                        NULL                                        AS [Unit!8!product],
                        NULL                                        AS [Unit!8!productCode],
                        NULL                                        AS [Unit!8!location],
                        NULL                                        AS [Unit!8!expDate]
        WHERE                
                @PatientFoundFlag = 1
        
        UNION ALL
        
        -- Assigned and crossmatched units
        -- <Unit status="" id="" product="" location="" expDate="" />
        SELECT DISTINCT        
                        8                                                                                                        AS Tag,
                        7                                                                                                        AS Parent,
                        2                                                                                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                                        AS [Component!11!GroupOrder!hide],
                        NULL                                                                                                         AS [Bloodbank!1],
                        NULL                                                                                                        AS [Patient!2!dfn],
                        NULL                                                                                                        AS [Patient!2!firstName],
                        NULL                                                                                                        AS [Patient!2!lastName],
                        NULL                                                                                                        AS [Patient!2!ssn],
                        NULL                                                                                                        AS [Patient!2!abo],
                        NULL                                                                                                        AS [Patient!2!rh],
                        NULL                                                                                                        AS [TransfusionReactions!3],
                        NULL                                                                                                        AS [TransfusionReaction!4!type],
                        NULL                                                                                                        AS [TransfusionReaction!4!date],
                        NULL                                                                                                        AS [Antibodies!5],
                        NULL                                                                                                        AS [Antibody!6!name],
                        NULL                                                                                                        AS [Units!7],
                        BUSCC.UnitStatusCode                                                                                        AS [Unit!8!status],
                        dbo.BloodUnit.EyeReadableUnitId                                                                        AS [Unit!8!id],
                        dbo.ProductType.ProductTypePrintName                                                                        AS [Unit!8!product],
                        -- ******************************************************************************************************************************************************************************************
                        CASE dbo.BloodUnit.LabelTypeCode
                                WHEN 'I' THEN 
                                        dbo.BloodUnit.UnitProductCode 
                                        + dbo.DonationType.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS 
                                        + dbo.BloodUnit.UnitDivisionId 
                                ELSE 
                                        dbo.BloodUnit.UnitProductCode
                                END                                                                                                 AS [Unit!8!productCode],
                        -- ******************************************************************************************************************************************************************************************
                        dbo.VamcDivision.DivisionName                                                                                AS [Unit!8!location],
                        dbo.BloodUnitMedia.UnitExpirationDate                                                                        AS [Unit!8!expDate]
        
        FROM                
                dbo.BloodUnitStatusCodeCurrent BUSCC
        
                INNER JOIN dbo.BloodUnit
                        ON BUSCC.BloodUnitGUID = dbo.BloodUnit.BloodUnitGUID
        
                INNER JOIN dbo.OrderedUnit
                        ON dbo.BloodUnit.BloodUnitGUID = dbo.OrderedUnit.BloodUnitGUID
        
                INNER JOIN dbo.OrderedComponent
                        ON dbo.OrderedUnit.OrderedComponentGUID = dbo.OrderedComponent.OrderedComponentGUID
        
                INNER JOIN dbo.PatientOrder
                        ON dbo.OrderedComponent.PatientOrderGUID = dbo.PatientOrder.PatientOrderGUID
        
                INNER JOIN dbo.PatientTreatment
                        ON dbo.PatientOrder.PatientTreatmentGUID = dbo.PatientTreatment.PatientTreatmentGUID
        
                INNER JOIN dbo.Patient
                        ON dbo.PatientTreatment.PatientGUID = dbo.Patient.PatientGUID
        
                INNER JOIN dbo.BloodProduct
                        ON dbo.BloodUnit.BloodProductGUID = dbo.BloodProduct.BloodProductGUID
        
                INNER JOIN dbo.ProductType
                        ON dbo.BloodProduct.ProductTypeCode = dbo.ProductType.ProductTypeCode
        
                INNER JOIN dbo.VamcDivision
                        ON dbo.BloodUnit.DivisionCode = dbo.VamcDivision.DivisionCode
        
                INNER JOIN dbo.BloodUnitMedia
                        ON dbo.BloodUnit.BloodUnitGUID = dbo.BloodUnitMedia.BloodUnitGUID

                LEFT OUTER JOIN dbo.DonationType 
                        ON dbo.BloodUnit.DonationTypeId = dbo.DonationType.DonationTypeId
        
        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID
                
                AND @PatientFoundFlag = 1
                
                AND BUSCC.UnitStatusCode IN ( 'S', 'C' )
                
                AND dbo.BloodUnitMedia.UnitExpirationDate > GETUTCDATE()
        
        UNION ALL
        
        -- Autologous units
        -- <Unit status="" id="" product="" location="" expDate="" />
        SELECT DISTINCT        
                        8                                                                                                        AS Tag,
                        7                                                                                                        AS Parent,
                        2                                                                                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                                        AS [Component!11!GroupOrder!hide],
                        NULL                                                                                                         AS [Bloodbank!1],
                        NULL                                                                                                        AS [Patient!2!dfn],
                        NULL                                                                                                        AS [Patient!2!firstName],
                        NULL                                                                                                        AS [Patient!2!lastName],
                        NULL                                                                                                        AS [Patient!2!ssn],
                        NULL                                                                                                        AS [Patient!2!abo],
                        NULL                                                                                                        AS [Patient!2!rh],
                        NULL                                                                                                        AS [TransfusionReactions!3],
                        NULL                                                                                                        AS [TransfusionReaction!4!type],
                        NULL                                                                                                        AS [TransfusionReaction!4!date],
                        NULL                                                                                                        AS [Antibodies!5],
                        NULL                                                                                                        AS [Antibody!6!name],
                        NULL                                                                                                        AS [Units!7],
                        dbo.DonationType.RestrictionTypeCode                                                                        AS [Unit!8!status],
                        dbo.BloodUnit.UnitProductCode                                                                                AS [Unit!8!id],
                        dbo.ProductType.ProductTypePrintName                                                                        AS [Unit!8!product],
                        -- ******************************************************************************************************************************************************************************************
                        CASE dbo.BloodUnit.LabelTypeCode
                                WHEN 'I' THEN 
                                        dbo.BloodUnit.UnitProductCode 
                                        + dbo.DonationType.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS 
                                        + dbo.BloodUnit.UnitDivisionId 
                                ELSE 
                                        dbo.BloodUnit.UnitProductCode
                                END                                                                                                 AS [Unit!8!productCode],
                        -- ******************************************************************************************************************************************************************************************
                        dbo.VamcDivision.DivisionName                                                                                AS [Unit!8!location],
                        dbo.BloodUnitMedia.UnitExpirationDate                                                                        AS [Unit!8!expDate]
        
        FROM                
                dbo.DonationType
        
                INNER JOIN dbo.BloodUnit
                        ON dbo.DonationType.DonationTypeId = dbo.BloodUnit.DonationTypeId
                
                INNER JOIN dbo.BloodUnitMedia
                        ON  dbo.BloodUnit.BloodUnitGUID = dbo.BloodUnitMedia.BloodUnitGUID
                
                INNER JOIN dbo.Patient
                        ON dbo.BloodUnitMedia.DirectedPatientGUID = dbo.Patient.PatientGUID
                
                INNER JOIN dbo.BloodProduct
                        ON dbo.BloodUnit.BloodProductGUID = dbo.BloodProduct.BloodProductGUID
                
                INNER JOIN dbo.ProductType
                        ON dbo.BloodProduct.ProductTypeCode = dbo.ProductType.ProductTypeCode
                
                INNER JOIN dbo.VamcDivision
                        ON dbo.BloodUnit.DivisionCode = dbo.VamcDivision.DivisionCode
                
        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID

                AND @PatientFoundFlag = 1

                AND  dbo.DonationType.RestrictionTypeCode IN ('A', 'D')

                AND dbo.BloodUnitMedia.UnitExpirationDate > GETUTCDATE()


FOR XML EXPLICIT

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spVistaGetXmlTransfusionHistory') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spVistaGetXmlTransfusionHistory
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:                 Returns transfusion history for a patient; used in CPRS report
**
**        Use Case(s):        N/A        
**
**        Author:                 Unknown
**
**        Date:                 Unknown
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        05/26/05        Lohse                PooledUnitsCount is now a function
**        06/29/05        N. Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Header added, Added NOCOUNT, Specified table owners, Removed comments, UPPERCASED SQL
**        04/05/07        D. Askew        Removed DISTINCT from last SELECT statement (CR 2206); DISTINCT caused multiple transfused units 
**                                        of the same prod type and having the same transfusion end date time (which is possible for presumed 
**                                        transfused units) to be filtered out, so only one of each type would show up; edited comment header to 
**                                        match current standards; reformatted SQL slightly for readability; changed @PatientFoundFlag from 
**                                        SELECT to SET
**        07/13/07        Lohse                Adding datetime conversion for CR2253.
**        05/13/08        M. Smith        Changed @VistaPatientId to BIGINT datatype (CR 2431)
**        06/04/08        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/16/08        M. Smith        Changed JOIN to be ANSI 92 compliant
**        06/24/10        D. Askew        Reformatted SQL; added productCode to SELECT (CR 2806).
**        06/06/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        07/18/11        K. Dobranowski        Modified JOIN clause for PatientTransfusion (CR 2901)
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spVistaGetXmlTransfusionHistory
(
        @VistAPatientId         BIGINT
)

AS

SET NOCOUNT ON

DECLARE @PatientFoundFlag AS BIT
        
SET @PatientFoundFlag = ISNULL(( SELECT TOP 1 1 FROM dbo.Patient WHERE VistaPatientId = @VistaPatientId), 0 )
        
        --<BloodBank>
        SELECT        
                        1                                        AS Tag,
                        NULL                                        AS Parent,
                        1                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!dob],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [Transfusions!3],
                        NULL                                        AS [Transfusion!4!date],
                        NULL                                        AS [Transfusion!4!unitsPooled],
                        NULL                                        AS [Transfusion!4!productTypeName],
                        NULL                                        AS [Transfusion!4!productTypePrintName],
                        NULL                                        AS [Transfusion!4!productCode]
        
        UNION ALL
        
        -- <Patient dfn="" firstName="" lastName="" dob="" ssn="" abo="" rh="">
        SELECT        
                        2                                                                AS Tag,
                        1                                                                AS Parent,
                        2                                                                AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                 AS [Bloodbank!1],
                        P.VistaPatientID                                                        AS [Patient!2!dfn],
                        P.PatientFirstName                                                AS [Patient!2!firstName],
                        P.PatientLastName                                                AS [Patient!2!lastName],
                        dbo.fnPatientDobConversionToFileManDateTime(P.PatientGuid)        AS [Patient!2!dob],
                        P.PatientSSN                                                        AS [Patient!2!ssn],
                        dbo.fnGetABO( P.PatientGUID )                                        AS [Patient!2!abo],
                        dbo.fnGetRh( P.PatientGUID )                                        AS [Patient!2!rh],
                        NULL                                                                AS [Transfusions!3],
                        NULL                                                                AS [Transfusion!4!date],
                        NULL                                                                AS [Transfusion!4!unitsPooled],
                        NULL                                                                AS [Transfusion!4!productTypeName],
                        NULL                                                                AS [Transfusion!4!productTypePrintName],
                        NULL                                                                AS [Transfusion!4!productCode]
        
        FROM                dbo.Patient P
        
        WHERE                
                        P.VistaPatientID = @VistaPatientID
        
        UNION ALL
        
        -- <Transfusions>
        SELECT        
                        3                                        AS Tag,
                        2                                        AS Parent,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!dob],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [Transfusions!3],
                        NULL                                        AS [Transfusion!4!date],
                        NULL                                        AS [Transfusion!4!unitsPooled],
                        NULL                                        AS [Transfusion!4!productTypeName],
                        NULL                                        AS [Transfusion!4!productTypePrintName],
                        NULL                                        AS [Transfusion!4!productCode]
        WHERE                
                        @PatientFoundFlag = 1
        
        UNION ALL
        
        -- <Transfusion date="" unitsPooled="" productTypeName="" productTypePrintName="">
        SELECT         
                        4                                                                                        AS Tag,
                        3                                                                                        AS Parent,
                        2                                                                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                         AS [Bloodbank!1],
                        NULL                                                                                        AS [Patient!2!dfn],
                        NULL                                                                                        AS [Patient!2!firstName],
                        NULL                                                                                        AS [Patient!2!lastName],
                        NULL                                                                                        AS [Patient!2!dob],
                        NULL                                                                                        AS [Patient!2!ssn],
                        NULL                                                                                        AS [Patient!2!abo],
                        NULL                                                                                        AS [Patient!2!rh],
                        NULL                                                                                        AS [Transfusions!3],
                        dbo.fnDateTimeConversionToFileManDateTime(dbo.fnTimeZoneConversionDateTime( 
                                PatTrans.DivisionCode, 0, PatTrans.TransfusionEndDateTime ))                        AS [Transfusion!4!date],
                        dbo.fnGetPooledUnitsCount(BloodUnit.BloodUnitGuid)                                         AS [Transfusion!4!unitsPooled],
                        dbo.ProductType.ProductTypeName                                                        AS [Transfusion!4!productTypeName],
                        dbo.ProductType.ProductTypePrintName                                                        AS [Transfusion!4!productTypePrintName],
                        -- ******************************************************************************************************************************************************************************************
                        CASE dbo.BloodUnit.LabelTypeCode
                        WHEN 'I' THEN 
                                dbo.BloodUnit.UnitProductCode 
                                + dbo.DonationType.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS 
                                + dbo.BloodUnit.UnitDivisionId 
                        ELSE 
                                dbo.BloodUnit.UnitProductCode
                        END                                                                                                 AS [Transfusion!4!productCode]
        
        FROM                
                dbo.Patient
                
                JOIN dbo.PatientTransfusion PatTrans
                        ON dbo.Patient.PatientGuid = PatTrans.PatientGuid AND PatTrans.RecordStatusCode = 'A'
        
                INNER JOIN dbo.BloodUnit
                        ON PatTrans.BloodUnitGuid = dbo.BloodUnit.BloodUnitGuid
                
                INNER JOIN dbo.BloodProduct
                        ON dbo.BloodUnit.BloodProductGuid = dbo.BloodProduct.BloodProductGuid
                
                INNER JOIN dbo.ProductType
                        ON dbo.BloodProduct.ProductTypeCode = dbo.ProductType.ProductTypeCode

                LEFT OUTER JOIN dbo.DonationType 
                        ON dbo.BloodUnit.DonationTypeId = dbo.DonationType.DonationTypeId
                
        WHERE                
                dbo.Patient.VistaPatientID = @VistaPatientID
                        
                AND        @PatientFoundFlag = 1
                        

FOR XML EXPLICIT

SET NOCOUNT OFF
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spVistaGetXmlTransfusionReactionHistory') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spVistaGetXmlTransfusionReactionHistory
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         
**
**        Author:        Brian Tomlin / Stas Antropov
**        Date:         01-25-2005
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        06/29/2005        NPaterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Header added, Added NOCOUNT, Specified table owners, Removed comments, UPPERCASED SQL
**        09/09/2005        D. Askew        Changed JOIN on Patient to select either the FinalMergeToPatient if the patient has one or more
**                                        merges (choosing the final merge record) or simply the patient guid if there are none
**        07/13/07        Lohse                Adding datetime conversion for CR2253.
**        05/13/08        M. Smith        Changed @VistaPatientID to BIGINT datatype (CR 2431)
**        06/04/08        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/16/08        M. Smith        Changed "SELECT" to "SET" for @PatientFoundFlag and moved @PatientFoundFlag up for performance 
**        06/24/10        D. Askew        Reformatted SQL; removed merge code; added productCode to SELECT (CR 2806).
**        08/05/10         D. Askew        Added @TransfusionReactionDivisionCode and supporting code in the TransfusionReaction section
**                                        so that a valid transfusion reaction date is returned (CR 2807).
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.spVistaGetXmlTransfusionReactionHistory
(
        @VistAPatientId        BIGINT
)

AS

SET NOCOUNT ON

DECLARE  @PatientFoundFlag                         BIT
DECLARE @TransfusionReactionDivisionCode         CHAR(5) -- used in cases where PatientTransfusionReaction.DivisionCode IS NULL so that the transfusion reaction date is converted properly
        

SET @PatientFoundFlag                 = ISNULL((        SELECT TOP 1 1
                                                        FROM         dbo.Patient
                                                        WHERE VistaPatientId = @VistaPatientId), 0         )

SET @TransfusionReactionDivisionCode        = (SELECT TOP 1 DivisionCode FROM VamcDivision) -- default to top division code
        

        --<BloodBank>
        SELECT        1                                        AS Tag,
                        NULL                                        AS PARENT,
                        1                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!dob],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [TransfusionReaction!4!unitId],
                        NULL                                        AS [TransfusionReaction!4!productTypeName],
                        NULL                                        AS [TransfusionReaction!4!productTypePrintName],
                        NULL                                        AS [TransfusionReaction!4!productCode],
                        NULL                                        AS [TransfusionReaction!4!comment],
                        NULL                                        AS [TransfusionReaction!4!lastUpdateDate!hide]
        
        
        UNION ALL
        
        -- <Patient dfn="" firstName="" lastName="" ssn="" abo="" rh="">
        SELECT        2                                        AS Tag,
                        1                                        AS PARENT,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        P.VistaPatientID                                AS [Patient!2!dfn],
                        P.PatientFirstName                        AS [Patient!2!firstName],
                        P.PatientLastName                        AS [Patient!2!lastName],
                        dbo.fnPatientDobConversionToFileManDateTime(P.PatientGuid)        AS [Patient!2!dob],
                        P.PatientSSN                                AS [Patient!2!ssn],
                        dbo.fnGetABO( P.PatientGUID )                AS [Patient!2!abo],
                        dbo.fnGetRh( P.PatientGUID )                AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [TransfusionReaction!4!unitId],
                        NULL                                        AS [TransfusionReaction!4!productTypeName],
                        NULL                                        AS [TransfusionReaction!4!productTypePrintName],
                        NULL                                        AS [TransfusionReaction!4!productCode],
                        NULL                                        AS [TransfusionReaction!4!comment],
                        NULL                                        AS [TransfusionReaction!4!lastUpdateDate!hide]
        
        FROM                
                dbo.Patient P

        WHERE                
                P.VistaPatientID = @VistaPatientID
        
        UNION ALL
        
        -- <TransfusionReactions>
        SELECT        3                                        AS Tag,
                        2                                        AS PARENT,
                        2                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                         AS [Bloodbank!1],
                        NULL                                        AS [Patient!2!dfn],
                        NULL                                        AS [Patient!2!firstName],
                        NULL                                        AS [Patient!2!lastName],
                        NULL                                        AS [Patient!2!dob],
                        NULL                                        AS [Patient!2!ssn],
                        NULL                                        AS [Patient!2!abo],
                        NULL                                        AS [Patient!2!rh],
                        NULL                                        AS [TransfusionReactions!3],
                        NULL                                        AS [TransfusionReaction!4!type],
                        NULL                                        AS [TransfusionReaction!4!date],
                        NULL                                        AS [TransfusionReaction!4!unitId],
                        NULL                                        AS [TransfusionReaction!4!productTypeName],
                        NULL                                        AS [TransfusionReaction!4!productTypePrintName],
                        NULL                                        AS [TransfusionReaction!4!productCode],
                        NULL                                        AS [TransfusionReaction!4!comment],
                        NULL                                        AS [TransfusionReaction!4!lastUpdateDate!hide]
        
        WHERE                
                @PatientFoundFlag = 1
        
        UNION ALL
        
        -- <TransfusionReaction type="" date="" unitId="" productTypeName="" productTypePrintName="" comment="">
        SELECT DISTINCT        
                        4                                                                                        AS Tag,
                        3                                                                                        AS PARENT,
                        2                                                                                        AS [Bloodbank!1!GroupOrder!hide],
                        NULL                                                                                         AS [Bloodbank!1],
                        NULL                                                                                        AS [Patient!2!dfn],
                        NULL                                                                                        AS [Patient!2!firstName],
                        NULL                                                                                        AS [Patient!2!lastName],
                        NULL                                                                                        AS [Patient!2!dob],
                        NULL                                                                                        AS [Patient!2!ssn],
                        NULL                                                                                        AS [Patient!2!abo],
                        NULL                                                                                        AS [Patient!2!rh],
                        NULL                                                                                        AS [TransfusionReactions!3],
                        TRT.TransfusionReactionTypeText                                                        AS [TransfusionReaction!4!type],
                        -- ******************************************************************************************************************************************************************************************
                        CASE WHEN PTR.DivisionCode IS NULL THEN
                                dbo.fnDateTimeConversionToFileManDateTime(
                                        dbo.fnTimeZoneConversionDateTime(
                                                @TransfusionReactionDivisionCode, 0, PTR.NotedDateTime))
                        ELSE
                                dbo.fnDateTimeConversionToFileManDateTime(
                                        dbo.fnTimeZoneConversionDateTime(
                                                PTR.DivisionCode, 0, PTR.NotedDateTime))
                        END                                                                                         AS [TransfusionReaction!4!date],
                        -- ******************************************************************************************************************************************************************************************
                        BU.EyeReadableUnitId                                                                        AS [TransfusionReaction!4!unitId],
                        PDT.ProductTypeName                                                                        AS [TransfusionReaction!4!productTypeName],
                        PDT.ProductTypePrintName                                                                AS [TransfusionReaction!4!productTypePrintName],
                        -- ******************************************************************************************************************************************************************************************
                        CASE BU.LabelTypeCode
                        WHEN 'I' THEN 
                                BU.UnitProductCode 
                                + DT.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS 
                                + BU.UnitDivisionId 
                        ELSE 
                                BU.UnitProductCode
                        END                                                                                         AS [TransfusionReaction!4!productCode],
                        -- ******************************************************************************************************************************************************************************************
                        Final.PatientTransfusionCommentText                                                        AS [TransfusionReaction!4!comment],
                        Final.LastUpdateDate                                                                        AS [TransfusionReaction!4!lastUpdateDate!hide]
        FROM 
                dbo.PatientTransfusionReaction PTR
                
                JOIN dbo.Patient P 
                        ON P.PatientGuid =  PTR.PatientGuid
        
                LEFT JOIN dbo.TransfusionReactionType TRT 
                        ON TRT.TransfusionReactionTypeCode = PTR.TransfusionReactionTypeCode
        
                LEFT JOIN dbo.PatientTransfusionComment Final 
                        ON Final.PatientTransfusionReactionGuid = PTR.PatientTransfusionReactionGuid AND Final.CommentCategoryCode = 'TW'
        
                LEFT JOIN dbo.TransfusionReaction TR 
                        ON TR.PatientTransfusionReactionGuid = PTR.PatientTransfusionReactionGuid
        
                LEFT JOIN dbo.PatientTransfusion PT 
                        ON PT.PatientTransfusionGUID = TR.PatientTransfusionGUID
        
                LEFT JOIN dbo.BloodUnit BU         
                        ON BU.BloodUnitGuid = PT.BloodUnitGuid
        
                LEFT JOIN dbo.BloodProduct BP 
                        ON BP.BloodProductGuid = BU.BloodProductGuid
        
                LEFT JOIN dbo.ProductType PDT 
                        ON PDT.ProductTypeCode = BP.ProductTypeCode

                LEFT OUTER JOIN dbo.DonationType DT
                        ON BU.DonationTypeId = DT.DonationTypeId
                
        WHERE 
                P.VistAPatientId = @VistaPatientId

                AND @PatientFoundFlag = 1

                AND PTR.RecordStatusCode NOT IN ('X','I','E')
                
        ORDER BY        [Bloodbank!1!GroupOrder!hide], 
                        Tag


FOR XML EXPLICIT

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spVistaGetXmlWorkloadData]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spVistaGetXmlWorkloadData]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:         
**
**        Author:        Brian Tomlin / Stas Antropov
**        Date:         01-25-2005
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        06/29/2005        NPaterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Header added, Added NOCOUNT, Specified table owners, Removed comments, UPPERCASED SQL
**        09/27/2005        NPaterson                                Line 32 Update statement added by Brian Tomlin, was removed in review by accident
**        07/13/07        Lohse                Adding datetime conversion for CR2253.
**        11/4/09                Van Stedum        Changed logic to parse out the method and code in XML, changed the default value of  
**                                        Workload!3!method from NULL to a valid value (CR 2737).
**        01/21/10        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        06/09/11        C.Van Stedum    implented changes for CR 3053, changed select statement for the --<VbecsUser duz="" /> section
*******************************************************************************************************************************************************************************/
CREATE        procedure dbo.spVistaGetXmlWorkloadData
(
        @WorkloadEventStatusCode        CHAR
)
AS

SET NOCOUNT ON

DECLARE @WorkloadEventGuid AS UNIQUEIDENTIFIER;

DECLARE @WorkloadFoundFlag AS BIT;

        SELECT         @WorkloadEventGuid =        (
                                        SELECT TOP 1         WorkloadEventGuid
                                        FROM        dbo.WorkloadEvent
                                        WHERE                WorkloadEventStatusCode = @WorkloadEventStatusCode
                                        )
        UPDATE         dbo.WorkloadEvent

                SET WorkloadEventStatusCode = 'I'

                        WHERE        WorkloadEventGuid = @WorkloadEventGuid

-- <WorkloadTransactions>
SELECT         1                                        AS Tag,
                NULL                                        AS Parent,
                1                                        AS [WorkloadTransactions!1!GroupOrder!hide],
                NULL                                        AS [WorkloadTransactions!1],
                NULL                                        AS [Transaction!2!id],
                NULL                                        AS [Transaction!2!type],
                NULL                                        AS [Transaction!2!division],
                NULL                                        AS [Transaction!2!accessionArea],
                NULL                                        AS [Transaction!2!dateTime],
                NULL                                        AS [Transaction!2!status],
                NULL                                        AS [Workload!3!code],
                NULL                                        AS [Workload!3!method],
                NULL                                        AS [Workload!3!multiplyFactor],
                NULL                                        AS [Patient!4!dfn],
                NULL                                        AS [VbecsUser!5!duz],
                NULL                                        AS [Lab!6!accessionNumber],
                NULL                                        AS [Lab!6!testPerformed],
                NULL                                        AS [Unit!7!id]

UNION ALL

-- <Transaction id="" type="" division="" accessionArea="" dateTime="" status="">
SELECT TOP 1        2                                        AS Tag,
                1                                        AS Parent,
                2                                        AS [WorkloadTransactions!1!GroupOrder!hide],
                NULL                                        AS [WorkloadTransactions!1],
                W.WorkloadEventGuid                        AS [Transaction!2!id],
                VbecsProcess.TransactionType                AS [Transaction!2!type],
                W.DivisionCode                                AS [Transaction!2!division],
                dbo.VamcDivision.AccessionAreaId                AS [Transaction!2!accessionArea],
                dbo.fnDateTimeConversionToFileManDateTime(dbo.fnTimeZoneConversionDateTime( W.DivisionCode, 0, W.WorkloadEventDate ))        AS [Transaction!2!dateTime],
                'P'                                        AS [Transaction!2!status],
                NULL                                        AS [Workload!3!code],
                NULL                                        AS [Workload!3!method],
                NULL                                        AS [Workload!3!multiplyFactor],
                NULL                                        AS [Patient!4!dfn],
                NULL                                        AS [VbecsUser!5!duz],
                NULL                                        AS [Lab!6!accessionNumber],
                NULL                                        AS [Lab!6!testPerformed],
                NULL                                        AS [Unit!7!id]
FROM                dbo.WorkloadEvent W

        INNER JOIN        dbo.VamcDivision
        
                ON        W.DivisionCode = VamcDivision.DivisionCode
        
                INNER JOIN        dbo.WorkloadProcess
                
                        ON        W.WorkloadProcessGuid = WorkloadProcess.WorkloadProcessGuid
        
                                INNER JOIN        dbo.VbecsProcess
                                
                                        ON        WorkloadProcess.VbecsProcessId = VbecsProcess.VbecsProcessId
        
                                                WHERE                W.WorkloadEventGuid = @WorkloadEventGuid


UNION ALL

-- <Workload code="" method="" multiplyFactor="" />
SELECT                3                                AS Tag,
                2                                        AS Parent,
                2                                        AS [WorkloadTransactions!1!GroupOrder!hide],
                NULL                                        AS [WorkloadTransactions!1],
                NULL                                        AS [Transaction!2!id],
                NULL                                        AS [Transaction!2!type],
                NULL                                        AS [Transaction!2!division],
                NULL                                        AS [Transaction!2!accessionArea],
                NULL                                        AS [Transaction!2!dateTime],
                NULL                                        AS [Transaction!2!status],
                WP.WorkloadCode                        AS [Workload!3!code],
                RIGHT(WP.WorkloadCode, LEN(WP.WorkloadCode) - CHARINDEX('.', WP.WorkloadCode))  AS [Workload!3!method],
                  W.WeightMultiplier                        AS [Workload!3!multiplyFactor],
                NULL                                        AS [Patient!4!dfn],
                NULL                                        AS [VbecsUser!5!duz],
                NULL                                        AS [Lab!6!accessionNumber],
                NULL                                        AS [Lab!6!testPerformed],
                NULL                                        AS [Unit!7!id]
FROM                dbo.WorkloadProcess WP

        INNER JOIN        dbo.WorkloadEvent W
        
                ON        WP.WorkloadProcessGuid = W.WorkloadProcessGuid
        
                        WHERE                W.WorkloadEventGuid = @WorkloadEventGuid

UNION ALL

--<Patient dfn="" />
SELECT        4                                        AS Tag,
                2                                        AS Parent,
                2                                        AS [WorkloadTransactions!1!GroupOrder!hide],
                NULL                                        AS [WorkloadTransactions!1],
                NULL                                        AS [Transaction!2!id],
                NULL                                        AS [Transaction!2!type],
                NULL                                        AS [Transaction!2!division],
                NULL                                        AS [Transaction!2!accessionArea],
                NULL                                        AS [Transaction!2!dateTime],
                NULL                                        AS [Transaction!2!status],
                NULL                                        AS [Workload!3!code],
                NULL                                        AS [Workload!3!method],
                NULL                                        AS [Workload!3!multiplyFactor],
                dbo.Patient.VistaPatientId                        AS [Patient!4!dfn],
                NULL                                        AS [VbecsUser!5!duz],
                NULL                                        AS [Lab!6!accessionNumber],
                NULL                                        AS [Lab!6!testPerformed],
                NULL                                        AS [Unit!7!id]
FROM                dbo.Patient

        INNER JOIN        dbo.WorkloadEvent W

                ON        dbo.Patient.PatientGuid = W.PatientGuid

                        WHERE                W.WorkloadEventGuid = @WorkloadEventGuid

UNION ALL

--<VbecsUser duz="" />
SELECT        5                                        AS Tag,
                2                                        AS Parent,
                2                                        AS [WorkloadTransactions!1!GroupOrder!hide],
                NULL                                        AS [WorkloadTransactions!1],
                NULL                                        AS [Transaction!2!id],
                NULL                                        AS [Transaction!2!type],
                NULL                                        AS [Transaction!2!division],
                NULL                                        AS [Transaction!2!accessionArea],
                NULL                                        AS [Transaction!2!dateTime],
                NULL                                        AS [Transaction!2!status],
                NULL                                        AS [Workload!3!code],
                NULL                                        AS [Workload!3!method],
                NULL                                        AS [Workload!3!multiplyFactor],
                NULL                                        AS [Patient!4!dfn],
                W.VistaTechID                                              AS [VbecsUser!5!duz],
                NULL                                        AS [Lab!6!accessionNumber],
                NULL                                        AS [Lab!6!testPerformed],
                NULL                                        AS [Unit!7!id]
FROM                dbo.WorkloadEvent W

        WHERE                W.WorkloadEventGuid = @WorkloadEventGuid


UNION ALL

-- Ordered Tests
--<Lab accessionNumber="" testPerformed="" />
SELECT         6                                        AS Tag,
                2                                        AS Parent,
                2                                        AS [WorkloadTransactions!1!GroupOrder!hide],
                NULL                                        AS [WorkloadTransactions!1],
                NULL                                        AS [Transaction!2!id],
                NULL                                        AS [Transaction!2!type],
                NULL                                        AS [Transaction!2!division],
                NULL                                        AS [Transaction!2!accessionArea],
                NULL                                        AS [Transaction!2!dateTime],
                NULL                                        AS [Transaction!2!status],
                NULL                                        AS [Workload!3!code],
                NULL                                        AS [Workload!3!method],
                NULL                                        AS [Workload!3!multiplyFactor],
                NULL                                        AS [Patient!4!dfn],
                NULL                                        AS [VbecsUser!5!duz],
                dbo.OrderedTest.SpecimenWorkloadUid                AS [Lab!6!accessionNumber],
                dbo.OrderedTest.LabTestId                        AS [Lab!6!testPerformed],
                NULL                                        AS [Unit!7!id]
FROM                dbo.OrderedTest

        INNER JOIN        dbo.WorkloadEvent

                ON        dbo.OrderedTest.OrderedTestGuid = dbo.WorkloadEvent.OrderedTestGuid

                        WHERE                dbo.WorkloadEvent.WorkloadEventGuid = @WorkloadEventGuid

UNION ALL

-- Ordered Components
--<Lab accessionNumber="" testPerformed="" />
SELECT         6                                        AS Tag,
                2                                        AS Parent,
                2                                        AS [WorkloadTransactions!1!GroupOrder!hide],
                NULL                                        AS [WorkloadTransactions!1],
                NULL                                        AS [Transaction!2!id],
                NULL                                        AS [Transaction!2!type],
                NULL                                        AS [Transaction!2!division],
                NULL                                        AS [Transaction!2!accessionArea],
                NULL                                        AS [Transaction!2!dateTime],
                NULL                                        AS [Transaction!2!status],
                NULL                                        AS [Workload!3!code],
                NULL                                        AS [Workload!3!method],
                NULL                                        AS [Workload!3!multiplyFactor],
                NULL                                        AS [Patient!4!dfn],
                NULL                                        AS [VbecsUser!5!duz],
                dbo.OrderedComponent.SpecimenWorkloadUid AS [Lab!6!accessionNumber],
                dbo.OrderedComponent.LabTestId                AS [Lab!6!testPerformed],
                NULL                                        AS [Unit!7!id]
FROM                dbo.OrderedComponent

        INNER JOIN        dbo.WorkloadEvent

                ON        dbo.OrderedComponent.OrderedComponentGuid =dbo.WorkloadEvent.OrderedComponentGuid

                        WHERE                dbo.WorkloadEvent.WorkloadEventGuid = @WorkloadEventGuid

UNION ALL

--<Unit id="" />
SELECT        7                                        AS Tag,
                2                                        AS Parent,
                2                                        AS [WorkloadTransactions!1!GroupOrder!hide],
                NULL                                        AS [WorkloadTransactions!1],
                NULL                                        AS [Transaction!2!id],
                NULL                                        AS [Transaction!2!type],
                NULL                                        AS [Transaction!2!division],
                NULL                                        AS [Transaction!2!accessionArea],
                NULL                                        AS [Transaction!2!dateTime],
                NULL                                        AS [Transaction!2!status],
                NULL                                        AS [Workload!3!code],
                NULL                                        AS [Workload!3!method],
                NULL                                        AS [Workload!3!multiplyFactor],
                NULL                                        AS [Patient!4!dfn],
                NULL                                        AS [VbecsUser!5!duz],
                NULL                                        AS [Lab!6!accessionNumber],
                NULL                                        AS [Lab!6!testPerformed],
                BloodUnit.UnitProductCode                AS [Unit!7!id]
FROM                dbo.BloodUnit

        INNER JOIN        dbo.WorkloadEvent

                ON        dbo.BloodUnit.BloodUnitGuid = dbo.WorkloadEvent.BloodUnitGuid

                        WHERE                dbo.WorkloadEvent.WorkloadEventGuid = @WorkloadEventGuid

                                ORDER BY        [WorkloadTransactions!1!GroupOrder!hide],
                                                        tag
                



FOR XML EXPLICIT

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spBloodUnitExists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spBloodUnitExists]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/*******************************************************************************************************************************************************************************
**        Desc:        Checks if supplied Blood Unit Guid exists in VBECS (CR 3006)
**
**        Use Case(s):        UC 69
**
**        Author:                David Askew
**
**        Date:                 11/14/2011
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------
**        12/28/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.spBloodUnitExists
(
        @BloodUnitGuid UNIQUEIDENTIFIER
)

AS

DECLARE @ReturnValue  BIT

SET NOCOUNT ON

        IF EXISTS ( SELECT 1 FROM dbo.BloodUnit WHERE BloodUnitGuid = @BloodUnitGuid AND RecordStatusCode <> 'X' )
                SET @ReturnValue = 1
        ELSE        
                SET @ReturnValue = 0

SET NOCOUNT OFF

RETURN(@ReturnValue )
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetMirrorBloodUnitMediaDirectedPatient]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetMirrorBloodUnitMediaDirectedPatient]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/*******************************************************************************************************************************************************************************
**        Desc:         Get the blood unit media mirror directed patient guid, CR 3180, This is to implement BR_11.21 and BR_13.03
**
**        Author: Carrie Van Stedum
**
**        Date:   10/10/2011
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        --------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        12/28/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetMirrorBloodUnitMediaDirectedPatient
(
        @bloodunitguid         UNIQUEIDENTIFIER
)
 AS

/*        @ERROR VARIABLE  USED BECAUSE SET NOCOUNT OFF RESETS THE @@ERROR TO ZERO         */
DECLARE @ERROR INT

SET NOCOUNT ON

SELECT

        VBECS_V1_PROD_MIRROR.dbo.V_BloodUnitMedia.DirectedPatientGuid,
        VBECS_V1_PROD_MIRROR.dbo.V_BloodUnitMedia.BloodUnitMediaGuid,
        VBECS_V1_PROD_MIRROR.dbo.V_BloodUnitMedia.RemoveRestrictionDate,
        VBECS_V1_PROD_MIRROR.dbo.V_BloodUnitMedia.RemoveRestrictionTechId,
        VBECS_V1_PROD_MIRROR.dbo.V_BloodUnitMedia.Comments,
        VBECS_V1_PROD_MIRROR.dbo.V_BloodUnitMedia.LastUpdateUser,
        VBECS_V1_PROD_MIRROR.dbo.V_BloodUnitMedia.LastUpdateFunctionID
FROM

        VBECS_V1_PROD_MIRROR.dbo.V_BloodUnitMedia

WHERE

        VBECS_V1_PROD_MIRROR.dbo.V_BloodUnitMedia.BloodUnitGuid = @bloodUnitGuid 


ORDER BY

        VBECS_V1_PROD_MIRROR.dbo.V_BloodUnitMedia.BloodUnitGuid,
        VBECS_V1_PROD_MIRROR.dbo.V_BloodUnitMedia.MirrorId DESC

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN (@ERROR)
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spRestoreRestriction]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spRestoreRestriction]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/*******************************************************************************************************************************************************************************
**        Desc:         Restore a patient restriction  in BloodUnitMedia, CR 3180, This is to implement BR_11.21 and BR_13.03
**
**        Author: Carrie Van Stedum
**
**        Date:         10/10/201
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        --------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        12/28/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.spRestoreRestriction
(
        @bloodunitmediaguid                           UNIQUEIDENTIFIER,
        @directedpatientguid                        UNIQUEIDENTIFIER,        
        @removerestrictiontechid                     VARCHAR(30),
        @removerestrictiondate                             DATETIME = NULL,
        @comments                                          VARCHAR(30),
        @lastupdateuser                             VARCHAR(30),
        @lastupdatefunctionid                             INT,
        @rowversion                                     TIMESTAMP,
        @divisioncode                                      CHAR(5),
        @lastupdatedate                             DATETIME
)

AS

SET NOCOUNT ON

DECLARE         @ERROR                INT,
                @ROWCOUNT                INT

        UPDATE dbo.BloodUnitMedia

        SET        DirectedPatientGuid                = @directedpatientguid,
                RemoveRestrictionDate                = dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @removerestrictiondate),
                RemoveRestrictionTechId        = @removerestrictiontechid,
                Comments                                   = @comments,
                LastUpdateUser                        = @LastUpdateUser,
                LastUpdateDate                        = @lastupdatedate,
                LastUpdateFunctionId                = @LastUpdateFunctionId

        WHERE BloodUnitMediaGUID        = @bloodunitmediaguid

        AND        [RowVersion]                = @RowVersion

        SELECT @ERROR = @@ERROR, @ROWCOUNT = @@ROWCOUNT

        IF @ERROR = 0 AND @ROWCOUNT <> 1 AND ( SELECT COUNT(1) FROM dbo.BloodUnitMedia WHERE [RowVersion] = @rowversion ) <> 1 
                RAISERROR(50001, 16, 127)
        ELSE
                IF (@ERROR = 0 AND @ROWCOUNT <> 1)        
                        SET @ERROR = -1

SET NOCOUNT OFF

RETURN(@ERROR)
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetEmergencyIssuedUnitsCountForOrderedTest') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetEmergencyIssuedUnitsCountForOrderedTest
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/*******************************************************************************************************************************************************************************
**        Desc:        Gets the number of issued units for specimen belonging to ordered test
**
**        Author:        Krzysztof Dobranowski
**
**        Date:         01/18/2005
**
*********************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        ----------        ---------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        06/29/2005        N.Paterson        ** Reviewed for compliance with database standards and recommendations **
**                                        Comment Header Adjusted, Aliased tables, Added NOCOUNT, Specified table owners
**                                        Applied join to replace subquery per request of Mike Smith:  JOIN dbo.OrderedTest OT ON OT.PatientOrderGuid = PO.PatientOrderGuid
**        01/04/2010        M. Smith        Changed to check UnitStatusCode from the BloodUnitStatusCodeCurrent table. (CR 1174)
**        01/22/2010        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        10/12/2011        K. Dobranowski        Added check for released unit (CR 3152)
**        12/01/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
********************************************************************************************************************************************************************************/

CREATE PROCEDURE dbo.spGetEmergencyIssuedUnitsCountForOrderedTest
(
        @orderedtestguid         UNIQUEIDENTIFIER 
)
AS

DECLARE @ERROR INT

SET @ERROR = 0

SET NOCOUNT ON
        SELECT 
                OU.BloodUnitGuid 
        FROM 
                dbo.OrderedUnit OU

        JOIN dbo.BloodUnitStatusCodeCurrent BUSCC ON BUSCC.BloodUnitGuid = OU.BloodUnitGuid

        JOIN dbo.OrderedComponent OC ON OC.OrderedComponentGuid = OU.OrderedComponentGuid

        JOIN dbo.PatientOrder PO ON PO.PatientOrderGuid = OC.PatientOrderGuid

         JOIN dbo.OrderedTest OT ON OT.PatientOrderGuid = PO.PatientOrderGuid

                WHERE 
                        BUSCC.UnitStatusCode IN ('I', 'T')

                AND
                        (OT.OrderedTestGuid = @orderedtestguid)
                AND
                        OU.ReleaseDate IS NULL


SET @ERROR = @@ERROR

SET NOCOUNT OFF


RETURN(@ERROR)

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spUpdatePatientChangeStatus') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spUpdatePatientChangeStatus
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/*******************************************************************************************************************************************************************************
**        Desc:         Updates the status code of a single patient change record
**
**        Author: Cameron Taylor 
**
**        Date:         06/03/2004
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        -------------                ---------                -----------------
**        01/10/05        D. Askew        Added @lastupdatedate
**        06/27/05        M. Smith        Reviewed for compliance with database standards and recommendations.  SET NOCOUNT on and off.
**                                        Removed if exists.  Added dbo. to updated table.
**        08/08/05        M. Smith        Capitalized reserved words
**        11/07/11        D. Askew        Added @ActiveDivisionsAlertViewed (CR 3164)
**        12/01/11        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/

CREATE PROCEDURE dbo.spUpdatePatientChangeStatus
(
        @PatientChangeGuid                UNIQUEIDENTIFIER,
        @PatientChangeStatusCode        CHAR(1),
        @ActiveDivisionsAlertViewed        VARCHAR(255)        = NULL,
        @LastUpdateUser                VARCHAR(30),
        @RowVersion                        TIMESTAMP,
        @LastUpdateFunctionId                INT,
        @LastUpdateDate                DATETIME
)

AS

SET NOCOUNT ON

DECLARE        @ERROR        INT,
                @ROWCOUNT        INT


        UPDATE
                dbo.PatientChange
        SET
                PatientChangeStatusCode = @PatientChangeStatusCode,
                ActiveDivisionsAlertViewed = @ActiveDivisionsAlertViewed,
                LastUpdateUser = @LastUpdateUser,
                LastUpdateDate = @LastUpdateDate,
                LastUpdateFunctionId = @LastUpdateFunctionId
        WHERE
                PatientChangeGuid = @PatientChangeGuid
        AND        [RowVersion] = @RowVersion

        SELECT @ERROR = @@ERROR, @ROWCOUNT = @@ROWCOUNT

        IF @ERROR = 0 AND @ROWCOUNT <> 1 AND ( SELECT COUNT(1) FROM dbo.PatientChange  WHERE [RowVersion] = @rowversion ) <> 1 
                RAISERROR(50001, 16, 127)
        ELSE
                IF (@ERROR = 0 AND @ROWCOUNT <> 1)        
                        SET @ERROR = -1

SET NOCOUNT OFF

RETURN (@ERROR)
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetBloodUnitFinanceByUnitGuid') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetBloodUnitFinanceByUnitGuid
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:        Gets Blood Unit Finance By Blood Unit Guid
**
**        Author:        John Vrooland
**
**        Date:         03/19/2003
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        --------------------        -----------------------        ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        07/14/2005        N.Paterson        ** Reviewed for compliance with database standards and recommendations **
                                        Removed Name/input/output from comment header, added SET NOCOUNT, formatted SQL, specified object owners
                                        Placed input parameter in brackets
**        12/08/2011        K. Dobranowski        Added LastUpdateDate (CR 3195)
**        12/28/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetBloodUnitFinanceByUnitGuid
(
        @bloodunitguid         UNIQUEIDENTIFIER,
        @divisioncode CHAR(5)
)
AS
/*        @ERROR VARIABLE  USED BECAUSE SET NOCOUNT OFF RESETS THE @@ERROR TO ZERO         */
DECLARE @ERROR INT

SET NOCOUNT ON

        SELECT

                BloodUnitFinanceGuid, 
                BUF.BloodUnitGuid, 
                UnitCost, 
                SpecialTestingCost, 
                ReturnCreditAmount, 

                (SELECT TOP 1 outgoingshipmentguid FROM dbo.BloodUnitShipment WHERE BloodUnitGuid = BUF.BloodUnitGUID AND recordstatuscode = 'A' 

                ORDER BY  lastupdatedate DESC)                                                                                         AS OutgoingShipmentGuid,

                BUF.LastUpdateUser, 
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, BUF.LastUpdateDate) AS LastUpdateDate,
                BUF.[RowVersion]


        FROM
                dbo.BloodUnitFinance BUF

        WHERE

                BUF.BloodUnitGuid = @bloodunitguid

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetBloodUnitStatusByGuid') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetBloodUnitStatusByGuid
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/*******************************************************************************************************************************************************************************
**
**        Desc:        Gets Blood Unit Status By Guid
**
**        Author:        John Vrooland
**
**        Date:         03/13/2003
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                        Description
**        ---------                ----                        -----------
**        8/15/03        Carrie Van Stedum        Removed the select of the BUS recordstatuscode
**        10/02/2003        Greg Lohse        Removed the select of BUS.DivisionCode (where'd it go?)
**        10/17/2003        Greg Lohse        Removed the UnitStatusText -- not needed
**        04/05/2004        C. Jensen        Added PresumedTransfusedIndicator
**        04/27/2004        M. Jablonski        Call fnTimeZoneConversionDateTime function on all dates; Added divisioncode
**        06/09/2004        C. Taylor        PresumedTranfusedIndicator typo
**        01/19/2005        D. Askew        Changed to DiscardDetailCode DiscardCannedCommentGuid, QuarantineDetailCode
**                                        to QuarantineCannedCommentGuid
**        07/15/2005         D. Askew        ** Reviewed for compliance with database standards and recommendations **
**                                        NO COUNT set ON/OFF; comments updated
**        08/19/2005        N.Paterson        Implemented differences between Review_Start and DEV before porting changes to DEV
**        04/11/2006        Lohse                Adding TestingLimitIndicator (needed for UC2/UnitStatusCode) (CR1730)
**        01/04/2010        M. Smith        Changed to get UnitStatusCode from the BloodUnitStatusCodeCurrent table. (CR 1174)
**        01/21/2010        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
**        12/08/2011        K. Dobranowski        Added LastUpdateDate for BloodUnitStatusCodeCurrent (CR 3195)
**        12/28/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetBloodUnitStatusByGuid
(
            @bloodunitguid                UNIQUEIDENTIFIER,
        @divisioncode                CHAR(5)
)

AS

DECLARE @ERROR INT

SET NOCOUNT ON

        SELECT 
                BUS.BloodUnitStatusGuid, 
                BUS.BloodUnitGuid, 
                BUSCC.UnitStatusCode,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, BUS.UnitStatusDate) AS UnitStatusDate, 
                BUS.UnitStatusComments, 
                BUS.DiscardCannedCommentGuid, 
                BUS.BiohazardousWarningIndicator, 
                BUS.QuarantineIndicator, 
                BUS.QuarantineCannedCommentGuid, 
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, BUS.LastUpdateDate) AS LastUpdateDate, 
                BUS.LastUpdateUser, 
                BUS.PresumedTransfusedIndicator,
                BUS.EmergencyIssueIndicator,
                BUS.[RowVersion],
                @divisioncode AS DivisionCode,
                BUS.TestingLimitIndicator,
                dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, BUSCC.LastUpdateDate) AS CurrentStatusLastUpdateDate

        FROM        dbo.BloodUnitStatus BUS
                JOIN dbo.BloodUnitStatusCodeCurrent BUSCC
                        ON BUS.BloodUnitGuid = BUSCC.BloodUnitGuid
        WHERE
                BUS.BloodUnitGuid = @bloodunitguid

SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'dbo.spGetBloodUnitOriginalShipper') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.spGetBloodUnitOriginalShipper
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*******************************************************************************************************************************************************************************
**        Desc:        Gets Blood Unit Original Shipper (CR3193)
**
**        Author:        Carrie Van Stedum
**
**        Date:         12/06/2011
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        ----------------        ----------                ------------------
**        12/28/2011        K. Adu-Poku        ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetBloodUnitOriginalShipper
(
        @bloodunitguid                UNIQUEIDENTIFIER,
        @divisioncode                CHAR(5)
)
AS

/*        @ERROR VARIABLE  USED BECAUSE SET NOCOUNT OFF RESETS THE @@ERROR TO ZERO         */
DECLARE @ERROR INT

        SET NOCOUNT ON


        SELECT TOP 1 LS.LocalSupplierGuid, LS.FacilityGuid, LS.FacilityName

             FROM dbo.BloodUnitShipment BUS 

        JOIN dbo.Shipment SH 

        ON BUS.IncomingShipmentGuid = SH.ShipmentGuid

              JOIN dbo.LocalSupplier LS ON

        SH.LocalSupplierGuid = LS.LocalSupplierGuid


        WHERE BUS.BloodUnitGuid = @bloodunitguid
        AND SH.DivisionCode = @divisioncode

              ORDER BY BUS.LastUpdateDate ASC


SET @ERROR = @@ERROR

SET NOCOUNT OFF

RETURN(@ERROR)
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/*****************************************************************************************
*         Deleted Stored Procedure
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetOrderedComponentGuidsForPatient]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetOrderedComponentGuidsForPatient]
GO

/*****************************************************************************************
*        Grant permissions on functions
*****************************************************************************************/
GRANT EXECUTE ON dbo.fnAddAttributeToProductAttributeForm TO VbecsAppUser
GRANT EXECUTE ON dbo.fnBloodUnitLogicalKey TO VbecsAppUser
GRANT SELECT ON dbo.fnExpandOptionalProductAttributes TO VbecsAppUser
GRANT EXECUTE ON dbo.fnGetAntibodyScreenTestResults TO VbecsAppUser
GRANT EXECUTE ON dbo.fnIsABORhTestComplete TO VbecsAppUser
GRANT EXECUTE ON dbo.fnRemoveAttributes TO VbecsAppUser
GRANT EXECUTE ON dbo.fnDivisionsWithActiveOrders TO VbecsAppUser
GO

/*****************************************************************************************
*        Grant permissions on tables and view
*****************************************************************************************/
GRANT SELECT ON dbo.vw_GetAdminReportBase TO VbecsAppUser
GRANT SELECT ON dbo.AntigenType TO VbecsAppUser
GRANT SELECT ON dbo.ApplicationOfRecord TO VbecsAppUser
GRANT SELECT ON dbo.BceStatus TO VbecsAppUser
GRANT SELECT ON dbo.BloodProduct TO VbecsAppUser
GRANT SELECT ON dbo.BloodProductModification TO VbecsAppUser
GRANT SELECT ON dbo.ComponentRequirement TO VbecsAppUser
GRANT SELECT ON dbo.DailyQcWorklist TO VbecsAppUser
GRANT SELECT ON dbo.ExceptionElectronicTransfusion TO VbecsAppUser
GRANT SELECT ON dbo.InterfaceControl TO VbecsAppUser
GRANT SELECT ON dbo.MessageLog TO VbecsAppUser
GRANT SELECT ON dbo.OrderedComponent TO VbecsAppUser
GRANT SELECT ON dbo.OrderedTest TO VbecsAppUser
GRANT SELECT ON dbo.PatientLocation TO VbecsAppUser
GRANT SELECT ON dbo.PatientTransfusion TO VbecsAppUser
GRANT SELECT ON dbo.ProductModificationAttribute TO VbecsAppUser
GRANT SELECT ON dbo.RackTest TO VbecsAppUser
GRANT SELECT ON dbo.VamcDivision TO VbecsAppUser
GRANT SELECT ON dbo.PatientChange TO VbecsAppUser
GO

/*****************************************************************************************
*        Grant permissions on stored procedures
*****************************************************************************************/
GRANT EXECUTE ON dbo.batchspRunExpireComponentOrders TO VbecsAppUser
GRANT EXECUTE ON dbo.batchspRunExpireTestOrders TO VbecsAppUser
GRANT EXECUTE ON dbo.spBloodProductModificationPool TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetAdminReportBloodUnitsReceived TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetAdminReportBloodUnitsShipped TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetAuditDivision TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetAuditInterfaceControl TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetBloodUnitAndPatientData TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetBloodUnitAndPatientGuids TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetBloodUnitIdAndProductCodeForBloodUnitGuid TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetComponentTaskList TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetCurrentPatientLocation TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetDailyQCRacks TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetDivision TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetExceptionReportElectronicTransfusion TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetInterfaceActiveIndicator TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetIssuedAndTransfusedUnitsForPatient TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetModifiableBloodUnits TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetPatientForOrderedUnit TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetPatientGuidForPatient TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetPatientOrderbyOrderGroupNumber TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetPatientTransfusionRecord TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetPatientTransfusionRecordHistoryForPatient TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetPreviousUnitStatus TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetRackTestResult TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetRecentlyDeceasedPatientDetails TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetRecentlyDeceasedPatients TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetRecentlyUpdatedPatientDetails TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetRecentlyUpdatedPatients TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetReportBloodUnitTransfusionHistory TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetTargetProducts TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetTestingTaskList TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetUserRolesList TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetVbecsDivisions TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetVbecsUserDivisionsAndRoles TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7GetInterfaceControlParameters TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7GetPatientLocation TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7GetPatientOrderbyOrderGroupNumber TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7GetPendingTransmissionMessages TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7GetTransmitCountForMessage TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7InsertPatientLocation TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7IsVbecsPatient TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7PurgeMessageLog TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7UpdateInterfaceControlStatus TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7UpdateMessageStatus TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7UpdatePatientLocation TO VbecsAppUser
GRANT EXECUTE ON dbo.spInsertDailyQcWorklist TO VbecsAppUser
GRANT EXECUTE ON dbo.spInsertExceptionElectronicTransfusion TO VbecsAppUser
GRANT EXECUTE ON dbo.spInsertExceptionExpiredTask TO VbecsAppUser
GRANT EXECUTE ON dbo.spInsertPatientTransfusion TO VbecsAppUser
GRANT EXECUTE ON dbo.spInsertRackTest TO VbecsAppUser
GRANT EXECUTE ON dbo.spInvalidateBloodUnitTestsForReleasedOrderedUnit TO VbecsAppUser
GRANT EXECUTE ON dbo.spOutGoingInvoiceReport2 TO VbecsAppUser
GRANT EXECUTE ON dbo.spReleaseRestriction TO VbecsAppUser
GRANT EXECUTE ON dbo.spSingleBloodProductModification TO VbecsAppUser
GRANT EXECUTE ON dbo.spUpdateAntibodyTypes TO VbecsAppUser
GRANT EXECUTE ON dbo.spUpdateDivision TO VbecsAppUser
GRANT EXECUTE ON dbo.spUpdatePatientTransfusionRecord TO VbecsAppUser
GRANT EXECUTE ON dbo.spUpdateRackDailyUse TO VbecsAppUser
GRANT EXECUTE ON dbo.spUserPermissions TO VbecsAppUser
GRANT EXECUTE ON dbo.spVistaGetXmlAvailableUnits TO VbecsAppUser
GRANT EXECUTE ON dbo.spVistaGetXmlBloodBankData TO VbecsAppUser
GRANT EXECUTE ON dbo.spVistaGetXmlPatientData TO VbecsAppUser
GRANT EXECUTE ON dbo.spVistaGetXmlPatientReportData TO VbecsAppUser
GRANT EXECUTE ON dbo.spVistaGetXmlSpecimenTestForPatient TO VbecsAppUser
GRANT EXECUTE ON dbo.spVistaGetXmlTransfusionHistory TO VbecsAppUser
GRANT EXECUTE ON dbo.spVistaGetXmlTransfusionReactionHistory TO VbecsAppUser
GRANT EXECUTE ON dbo.spVistaGetXmlWorkloadData TO VbecsAppUser
GRANT EXECUTE ON dbo.spBloodUnitExists TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetMirrorBloodUnitMediaDirectedPatient TO VbecsAppUser
GRANT EXECUTE ON dbo.spRestoreRestriction TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetEmergencyIssuedUnitsCountForOrderedTest TO VbecsAppUser
GRANT EXECUTE ON dbo.spUpdatePatientChangeStatus TO VbecsAppUser
GRANT EXECUTE ON  dbo.spGetBloodUnitStatusByGuid TO VbecsAppUser
GRANT EXECUTE ON  dbo.spGetBloodUnitFinanceByUnitGuid TO VbecsAppUser
GRANT EXECUTE ON  dbo.spGetBloodUnitOriginalShipper TO VbecsAppUser

GO

-- Delete 311 rows from dbo.PermittedProductModification
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'00779e29-dc1c-4b2f-9f19-c7795570445e'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'009d498a-078c-477a-ab34-68d4151d418b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'02ba2d46-0097-4884-9709-418a48b30e46'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'02ce08de-d57d-406c-aade-85011ed8952b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'0417fa39-b03b-49f9-9c4c-877b929ec143'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'046d36c6-4cd9-48cb-86f1-7912829c27be'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'0665fae5-8fe8-41ad-91d8-bfb619f58fe6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'084eac09-0836-4092-9caf-eb1649c43b18'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'08d7e97a-97fb-467c-a2d1-40100ff0006a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'08ee21f0-6ce6-4f42-a191-b7e3cc9799dc'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'0a18a84c-2814-4d5b-abdf-e8f73e5d7e6e'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'0f11770f-7d9c-4cc5-861a-68a6e47d81b0'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'0f9490c7-4735-41e6-b6af-b74d1613710d'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'10a2a982-2370-475a-be03-1e5c2db4413f'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'10e8265b-f7f8-416b-bf43-8fd5b77ae0c9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'11eddf6d-58bb-4d60-898b-46cee44a6eb9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'12380c25-7ad3-4d8b-8b0d-61b2c63ab24b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'12bb7058-76dd-4c1f-9d4f-8dbffa685175'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'148bba37-88d7-46e3-ae29-95fa37974279'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'1582fd4e-334d-4a93-afd6-4a1c20e121f2'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'15a5d9ea-d585-4a9f-9a56-2131cf2d15fe'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'15d8eb41-9ff7-4cde-97ab-3e443cac9d9c'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'1755937f-12a5-470f-a35c-83fc3b36e93a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'181ade37-c66b-4e7a-a2c3-d204ce572c77'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'182aedd9-4df8-454b-87e4-8d2c72f644c8'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'183ac901-8233-41bc-8609-bed586845356'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'19034e3f-ed3a-42b9-ba8e-377df9bd0ea3'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'1b0dd04a-6b21-4383-80dc-ad897a3fd718'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'1b98d469-7884-45ee-9f42-cd53c1b7b5c0'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'1c08a810-1870-4402-9303-ad2e903c224a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'1c3594f0-daaf-4a14-bdbc-240164da868d'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'1c97bbe0-0c50-4207-9606-f64a235a065e'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'1cb8c1ee-8fd8-4e93-b1a9-98f116d40307'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'1d90c11f-4552-4f61-b8cb-2ba72bf910de'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'1e4d49f3-ba45-401a-bf94-424c71c4a934'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'1ef08233-43f2-4643-9c07-b58a4c3e5664'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'1fe87b6b-8448-4e3d-8d5d-065d709b364a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'22747329-cc41-4991-8186-20559e3c7d60'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'22e1b83f-4442-48ce-a51a-8b0541d4857f'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'231ff041-7de5-44ce-81a0-70b6c4159deb'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'239f2520-b52b-44ab-bd62-643935297984'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'24171593-0c27-4b3e-af24-45bb08cf75d3'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'272ba0de-2ee0-4522-b8ed-dd3f66ae7e28'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2730fb5e-c667-4729-b94a-0cfd3b70b38a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'287af116-7881-4163-8ddd-5eb44438e341'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'28d77529-7671-449a-8f16-d86a60c30629'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2908e81c-2285-463a-8c1e-494a188f5a66'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2979eab4-39c1-4887-98fb-9cdd49053c3f'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2a4d6c13-7edb-4564-9d0c-77c186cf6d8a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2a7a846f-b16f-446d-8116-94fba8a0f392'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2ad97cc4-0138-4f71-9027-47e391598d1f'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2b1a8664-d665-49a5-8b1c-12b412cd71e2'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2b4fbdd0-4ce4-44cf-b977-46e9cc623ca3'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2b6f0a2c-097d-4ecf-8163-12f2bfbef586'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2ba18404-d56c-4a67-843f-423f47f111fd'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2c687735-3f07-4d11-918d-0000457d55df'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2e7d68cf-e057-4f0e-8df7-69257a451ccf'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2f5382c3-bb2d-4b67-998c-290080aa3229'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2f811467-4789-45cc-aeae-09a5787cf657'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'2fd80cf5-ce5b-44bc-b965-ea89223d2038'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'3060a5fb-d496-4855-a4de-85172b6f514d'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'31efdb54-9521-46f9-81af-16053b9a7996'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'3327982c-cca3-4545-8ab5-a2830482ca52'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'336fb9e3-83c0-41f9-b9dd-b9ca5eaabfcc'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'33cb38c6-c352-4477-9696-48f4b49b64a3'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'34a2043d-d2b1-45c1-bef4-6c54d6794894'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'34af0777-d300-4fd7-9f7a-86174516bb30'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'34d911a0-47e7-4326-88ed-bc4d9364b562'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'375ff1db-78dc-4aca-89a6-10a6c690b56e'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'3bad786c-cb8d-4fb0-823f-61de7b459bc3'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'3c272f8c-b5a2-4793-adf9-adf484cbe8ac'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'3eed16a6-8769-4710-a054-06687805bdea'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'3f7b1ae4-af8e-4d1d-913e-0855c5e59259'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'3fba8648-e5dc-4a73-a995-135dc7f19656'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'40786212-dc69-4d8f-8e67-ba93de743ba1'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'410d3d3b-c6f9-44c8-a95c-26b0198bd249'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'42c676bb-9146-4600-9ced-948fefd27dc9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'433e914b-5477-4a7a-ac22-b1e26b50dba6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'4388163b-1538-46e7-a64d-0e72ac8f3c07'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'44317ae9-6670-4cfb-8165-d158512785d1'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'45f1c5cb-b2bc-4c2e-be0b-5842180446a4'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'45f5535c-f273-4c8e-841e-10183a843550'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'4642f4c9-3883-4405-acdc-1a31ed0e51da'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'46ade7d2-a3b5-488b-a705-ebb2a1af696e'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'472a6709-c795-433e-8393-461ac8724c7d'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'490eecba-4226-41bc-9900-4b6e58c09ca3'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'492a02ef-33cb-456a-8cdd-4510dbaf5e60'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'49756ab4-58d6-497d-a6e4-f6a441d770a5'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'49fb0dc0-1959-4aa0-8638-0f0745e60eef'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'4a23b108-cf20-448d-b8bf-2ca0241b917a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'4a4efe07-e40c-4aee-83e8-36cc24f2684b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'4b2c7c94-55cd-4a71-830b-23146493ffde'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'4b37499e-295a-4444-b1fb-a9a8ac83cc3b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'4d6bd087-1965-410b-9dbf-9cd7d9fd4bde'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'4ecf3d8d-d5cf-4a02-9a6a-b6c3ff142de6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'4f143ed7-4df0-4ed2-aac4-598e9f728ed3'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'4f75476e-6e35-4c02-9f50-88e67b612db0'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'4f7f0521-0d3b-4c64-b43c-c38c943a7988'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'5216f6be-80dc-46ab-9ade-9495d5addb19'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'522b70ee-230c-44de-83a3-542b462109c9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'5576b60f-eafd-466a-96e5-941fdaecf1a6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'56fd90ca-e987-438f-b71e-bc1de10efa63'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'5a1fc412-118e-4487-8b55-0a05bb4dcb3e'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'5b83363a-5822-4833-b114-394f9439fee9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'5be58889-7f48-4545-9e61-41cd922e4563'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'5c8c6387-2136-400c-b22b-7137c19fe215'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'5f1d3290-c4ce-437c-8c18-0db723140df6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'5fa41269-35ab-47c3-8efe-a0d4be2fc3ef'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'6128b109-e8cc-46c3-a898-d13ee07428de'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'62934e82-dc49-4198-ba38-6a63bb9adca4'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'62fb484d-4554-40d9-b55a-8135ef06cf43'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'63dd69a2-f513-4367-bbe7-bca2fa0cb5d0'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'6454e2bd-ed9b-414e-911d-038f0f5d768c'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'64bf8ba8-225a-4670-831c-8c76017a5e2d'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'651cf33b-cd9f-4865-80c3-6b32e3e0593b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'65423dfe-3496-426c-ba52-ad12fca80643'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'69dba885-c0b2-4708-90b7-5448fa20b218'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'6a220f7f-34cc-4d26-8fde-8102f720a379'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'6b37eb86-00a4-4211-9a97-460360f3fe2c'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'6fbe2c80-868c-4494-9831-7163aeea86a0'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'6fc549de-996a-49fd-b09a-9bbcc0464e4e'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'719dd788-2a8c-4d54-89a5-0238fc9d8786'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'71a93748-91ec-45db-99b5-d6f9ec1231d4'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'72b8c5f6-071b-4030-afd8-37cf7f4fa12b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'72e326f5-53ce-4906-9bfe-51d9c6c3ed7b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'7375ac9f-c24b-4fa9-8280-8a72e50fcf8d'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'747b4eb1-0793-4c1f-b515-8397ee65a817'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'74af9c6c-50b3-4663-99cd-cb5a81118be8'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'75e8a9e9-c30b-4efe-875c-e78574190eb6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'76860149-d18e-4375-b39a-402a96993bd2'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'769bd097-2021-4637-b519-345a2ed6f0cc'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'76a37472-8547-4868-8f01-54ac58d418fa'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'7aaedd24-c8b5-4584-963f-3d9cc18f5111'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'7c1d168a-0acf-4d31-8063-585142760989'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'7e679ddb-fae9-49a6-a9e0-2ba25e62e440'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8042c439-15ac-4ed1-8e43-c67c08dccf5b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8162714d-6979-4f1c-85fb-2698797cafe0'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'82510501-7660-4a29-8943-e33df8768c92'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'82a0ba08-d2aa-4143-b12c-9ae18e19794c'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8476facc-b3ac-4df3-9b25-d89c2d7d00e8'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8555e50e-dc6e-414d-bbf5-141994fb370a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'85961f62-5d74-4d8d-bc90-71f794af2c50'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8683762a-a0cd-4f97-98bd-4d147423bdbc'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8694a790-bf72-4250-b74a-2ca9ae0bb3f1'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'88772379-ed4d-4229-a384-7f4a49ccba39'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'89a4abd8-f434-490b-9392-711fe3305516'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8b22995a-9d51-4e14-bd5b-f456582a4035'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8b8ba42b-b98f-4cc4-b0bc-8a6bc0143a06'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8c358976-ae85-47ed-80c5-64390c3e41fa'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8cd6cd31-433e-4c23-9383-f003a7de81d9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8cdb7206-8cf1-4365-8d0c-9ab6e73774fb'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8cf74aab-1eb6-435a-9b2c-683374b850a6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8d06b5be-79bd-4905-be4f-283d6c3b6217'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8d45aacf-5622-4aa5-9e3a-0fa805e3cdbd'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8d5dcd23-d8ab-417b-af05-3c008a8f6a9a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8e1802f7-3ae2-4ef5-84a4-e3e52fc74ff5'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8e8bb747-a9ad-4c89-9acd-190634ae6042'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8ea6de8f-ee51-4556-b27e-28d490868d96'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8f1286e5-cba8-4e87-94fd-40709cbcabe7'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'8fc02984-b575-4ff0-baea-705aee71cb91'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'90b138da-5afc-4ac1-9f1e-ec8551393b65'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'9110261a-cec5-4ded-b725-e28f69a96fa8'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'912fe82e-2b7f-4802-9ee2-48721c0d8227'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'916832de-88bb-4950-ab62-d907227b8786'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'926882cc-a422-4a46-a3ee-29626665a73a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'92d1594e-ca97-432f-a8e3-2e24524bfe0a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'9302e885-bb09-4c5c-b166-ee13a0f2d8f9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'934334ce-3006-4dee-8a82-2ed686846821'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'94094998-9bf7-41a3-be8d-20b63a3674f8'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'94152d19-6978-4ddd-ab22-ec8df2727bce'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'943d63a8-aba8-4d11-9c50-104a93eae46d'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'9466adb1-a21d-4284-bc2b-ae84f5ed9d9c'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'94c369c6-8d3e-4dd5-9074-f58980a8de96'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'94d1904e-9186-4fae-b6af-6bc62cd9c2c2'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'95e20ef5-b947-49b5-8d7a-7c02ecc7eea8'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'95fce0ba-1068-4bf6-9c7c-a12d0bf4f8f8'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'96cce340-fe47-40ee-a315-6be7870c0b19'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'97328ef2-9988-4230-bc46-59df465c6180'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'97c10c19-d922-48a0-ad76-b19208ead565'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'97c8e72f-5dc8-4869-ad49-82e856afb72a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'98dab0db-9543-4d7f-82de-e997518be81d'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'99902d68-355f-489a-8232-b23f7eca5b62'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'9a274a61-548f-4810-a004-d47b71f2be03'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'9c8d48fe-a1c5-4efa-ae3a-7106d312ec53'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'9d453497-1867-4c26-8148-f55b5cc36032'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'9e474ea7-35b2-4e90-b339-51c0082cbac8'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'9e6904c6-a94b-4070-bce5-8608f5463ca8'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'9e7dbf7e-9cfe-4902-aecf-a5edfff4b0f3'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'9f00a12e-cb40-407b-bb68-5644fb6b357e'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'9fa69518-067a-4f80-8b84-7a60aace8f3a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a022671d-3679-4b2e-89b0-164c10cc3e88'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a11849b6-ec93-43e5-9321-bc0ca13e3665'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a151482f-df69-494a-ac30-9afbe0dcda35'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a1d74274-bcae-408f-bbc3-806651e58444'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a275a7cf-bf63-4ae7-9283-55069d93b066'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a4655efe-7b8f-419a-aa66-9f3eadb7dfff'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a516ff6c-85f0-4d86-8bbf-8925fd51dd54'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a58c0c21-96d7-4114-9ea4-e64d4adcb4c1'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a5d04f93-e784-4d39-a612-78ac492138d3'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a6612608-6e87-4e61-afba-3030aeb88c51'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a738d1ae-872d-4a43-9587-b1e5f63c803f'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a85d93a2-4fec-4b38-94c7-04253455d1b6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'a9513dba-d5a3-4d61-b4c0-305a3fd44695'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'aa5052cd-5e93-4de4-be2c-ac4039464d42'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'aa866a23-38f5-434e-b65e-50b03fbe943f'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ade1019b-1cdb-4add-a645-c3cfccd42586'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ae1eb066-5b14-4542-a2de-2c7ce44e7823'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'af681905-0288-4669-96e5-903105448434'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b0d69302-2260-4141-859d-f7eee8b58040'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b0f0d5d0-46cd-47ce-9b70-b79d31a76739'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b0f2eb21-2911-42a7-a73a-f2c5db9a0e34'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b16646e0-41aa-4d9d-953c-2af9c02c16f9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b1b27595-cdfc-468b-a44d-b2250b2456dd'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b4117eab-a775-45ac-bcc9-799cc2465517'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b4b7d5d6-7ecc-4807-9437-ae1ae3017b1b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b4c1f87e-691c-4430-ba39-3b0d4d81bfd0'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b5dcfd88-f069-4f39-a639-53f310390fed'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b6384d1b-9f91-4808-b3b6-ceac0258f7ef'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b6863f00-ce0b-4ed6-af6f-cfbac07343ea'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b705a3b7-caca-4336-931f-b2e8aeaed588'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b7296a1f-a757-4858-bd5c-70fe8f9f4315'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b732a6f7-45c6-4076-b340-edbb980e03e6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b9029f69-32eb-4fdf-aead-2c2c4c574ee9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'b904ec37-86ee-4b46-95a3-a7ae813876c2'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ba21ac20-618e-40b0-959e-48ead05e182b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'bba43a4f-0245-4efb-9cc4-156f469d9127'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'bbf16619-948a-40bf-8fee-392c393eeaaa'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'be8e4348-2c60-4ef3-aaaa-2a429304e82c'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'bedf358c-0243-4773-9915-c03b5238dc00'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'bef052cb-f6cf-48ca-acdf-43f9d4fa420a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'bf0d76fb-0262-439f-8436-7347f9c1c975'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'bf51c2d7-6256-41bc-8cad-d06ad843a419'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'bfb8bc97-6559-45bc-b0da-d1207e888044'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'c0f45657-e7f8-4c1b-a3bf-d54392c0ccf7'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'c363726b-daf0-4644-90b3-080133f33fbd'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'c4181bdb-a1e9-432b-89f5-a496ca768693'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'c48207ae-fab4-4d3e-a4c5-9b0bf0912f9c'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'c4f84107-3dec-4571-a96f-5bfed22dbfb9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'c506d939-87d6-4a7e-8d62-070637aa48d8'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'c555276a-3071-4c64-b769-69b502455412'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'c80371dc-09c0-4432-9a79-192bb21210bc'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'c82be9d8-2558-4364-ba35-a8f91f3b0ba2'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'c8344605-e27d-4e44-ae58-a08d28570c77'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ca3341be-4197-4e49-90a3-67c75bfdb074'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ca5ca1b1-ca11-4d42-9f80-a69db71252f1'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'cb31e5a8-6c3a-4c19-991b-cb1d3520a26f'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'cb4ca3d2-4a19-4c99-b5ad-46a33bd68341'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'cc26b22e-f216-4198-b279-63f9c89f7137'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'cc75c29c-5c1a-4e67-8b7a-bb023fffb734'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'cd00a6ab-d880-47b0-adc6-18f5a907630a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'cd9e5859-ef74-4ac8-9294-b19889b37049'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ce067686-9805-40b9-a092-4dcc2c0fa3f3'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'd05298c9-b370-49cc-85fd-eda0c284ae57'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'd143e047-242d-472a-9198-8f3652c71d76'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'd3b07d5d-d983-4853-acfe-b5bde515ae5b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'd44ebd8e-3e6e-496d-86c2-6b0188be5c50'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'd4ab5d8b-3e0f-4dff-93c1-3664f718a8ed'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'd4dc0589-7ade-4616-955d-323943572076'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'd65245cb-d7f3-457c-845c-6acc89bf2208'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'd8e41b35-eb48-4a07-bd6e-ef8fc1784ae0'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'd979db9c-69cc-487e-9ae3-99e5612b3571'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'da3d5a71-0d4b-4723-9831-18283392abe1'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'dcf51582-551c-4d63-8477-693320af12fc'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'dd5c6049-750b-4d2f-ad6c-a867b3c0370b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'dec505db-42f9-447a-b0c4-6703e28e1130'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'df42da66-2643-4018-8102-448c8c2ff4f4'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'e027fbd8-21cd-4593-bed1-92d6571f9800'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'e0b0dd63-4f2c-4581-b437-7c315dca6509'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'e1f15a98-a98d-4d76-b2ae-56ab3f5b230d'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'e29dba09-0410-49b7-add6-9efee5cc0d1a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'e4c4b18f-f7ce-4d51-9524-4ba0ae8f8795'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'e519f874-209b-4646-8838-95e3dd29a7b6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'e6789a08-0bbf-4517-899d-a8e94218915f'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'e7f917ac-d162-4b9a-b953-1238d33b5ac7'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'e8c5d125-72c9-415c-9c1b-633f2b83a44b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'e8f7074f-1332-42bb-9c2a-3ccca98036e6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'e9d8a38d-7979-4c52-9e45-22d807b35606'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'e9dc8316-3fff-42be-b843-61901bdb2a6c'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'eb206c1c-90ec-4a26-b63a-f559454a7880'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'eb585bbf-6bc9-4bb6-b3c5-27d080b85125'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ec1b1594-558d-4dae-8620-6de463a9eba8'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'edb0fa60-3a36-41e3-845c-436b6f6b4d61'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'edbe8475-ab01-413b-9add-631488af8173'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ee00b06d-ca05-4406-a66d-9b770409c0f6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ee79335c-c947-4a17-9d25-9170072fb34a'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'eee05819-b6a0-45d2-84bb-ecfd1fe5cdd9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'eef4bd20-7a0f-431f-b331-bf8c34dab66c'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ef64657c-05ce-4579-8b1f-f3ab98b112ad'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ef76aadf-4eb5-42a5-b4af-b15a67d66941'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ef7b86b8-1f57-49c5-adc6-ee8270f2696c'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'efabb159-8f4d-4393-a8ec-0d1889041593'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'efbc7b98-b0bc-468c-9409-11f80de54483'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f06ded5f-484b-468d-b39b-25b4dff52ec2'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f0a19a2b-9a7d-4b14-9455-f687814b9244'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f0c1cf8d-1022-4054-b0d6-6809ac980157'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f215a175-ce46-47df-974e-734a963cc1f7'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f44f8c3f-6788-469a-b9ae-3ae0c8447021'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f77a4919-3b48-48ac-b1fe-33a690feb3a7'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f7a42b13-6475-4bb2-bace-7ff57ca6f5c9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f806af77-436d-44ca-ba6b-d3bc8f1e7949'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f877dfb7-671c-4029-aaf2-74a03b17e0a6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f9217192-db5f-458c-a10f-413dbb7ab660'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f94bc932-d94a-4e42-b4d6-fac5158572a9'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f96367e8-39ae-4c1d-b2a9-ee27c50b93f3'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'f9ec69ca-830b-404d-b5ea-8cb3cc2f9223'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'fa409dc7-d197-442e-84b5-1207d5046a8b'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'fa59ea5a-f296-43fa-b03a-e85f71b894b4'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'fc648cd4-ae27-4f3a-beeb-e50c7bf64d07'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'fe831a77-23c9-4c9d-bd59-ed61fe3cb4c6'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ff34eeda-0fd7-4960-b741-c7396d9503a2'
DELETE FROM dbo.PermittedProductModification WHERE PermittedProductModificationGuid=N'ff87c283-9faf-434d-ab5f-a0a8f808b7aa'

-- Update 4 rows in dbo.State
UPDATE dbo.State SET StateName=N'Alabama' WHERE StateCode=N'AL'
UPDATE dbo.State SET StateName=N'Arkansas' WHERE StateCode=N'AR'
UPDATE dbo.State SET StateName=N'Massachusetts' WHERE StateCode=N'MA'
UPDATE dbo.State SET StateName=N'Puerto Rico' WHERE StateCode=N'PR'

-- Update 30 rows in dbo.ProductAttribute
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@02'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@14'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@22'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@23'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@26'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@34'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@46'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@49'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@50'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@52'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@57'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@60'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@74'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@94'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@A0'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@BC'
UPDATE dbo.ProductAttribute SET ProductAttributeText=N'CPDA-1/350mL/refg', RetireDate='20101201 00:00:00.000', LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@BP'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@BV'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@BW'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@C4'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@C5'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@CA'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'@CB'
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110811 14:38:58.000' WHERE ProductAttributeId=N'I1 '
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'I2 '
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'I3 '
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'I4 '
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'I5 '
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'I6 '
UPDATE dbo.ProductAttribute SET ModificationAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductAttributeId=N'I7 '

-- Add 2 rows to [dbo].[ProductAttribute]
INSERT INTO [dbo].[ProductAttribute] ([ProductAttributeId], [ProductAttributeText], [ProductAttributePrintName], [ModificationAllowedIndicator], [RetireDate], [SortColumn], [LastUpdateDate], [LastUpdateUser], [LastUpdateFunctionId]) VALUES (N'@D8', N'CPD/XX/<=-5C', N'CPD', 1, NULL, 0, '20110802 10:31:20.000', N'vhaishsmithm', 0)
INSERT INTO [dbo].[ProductAttribute] ([ProductAttributeId], [ProductAttributeText], [ProductAttributePrintName], [ModificationAllowedIndicator], [RetireDate], [SortColumn], [LastUpdateDate], [LastUpdateUser], [LastUpdateFunctionId]) VALUES (N'@D9', N'CPDA-1/XX/<=-5C', N'CPDA-1', 1, NULL, 0, '20110802 10:31:20.000', N'vhaishsmithm', 0)

-- Update 1 row in dbo.ProductType
UPDATE dbo.ProductType SET SplitAllowedIndicator=0, LastUpdateDate='20110524 14:44:42.000' WHERE ProductTypeCode=N'E053'

-- Add 13 rows to dbo.ProductType
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E055', N'Thawed POOLED PLASMA', N'PLASMA Pool Thaw', 2, 8, 1, NULL, 55, '20110524 14:44:42.000', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E056', N'Thawed POOLED FRESH FROZEN PLASMA', N'FFP Pool Thaw', 2, 8, 1, NULL, 56, '20110524 14:44:42.000', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E057', N'Washed GRANULOCYTES', N'GRAN Wash', 5, 16, 1, NULL, 57, '20100602 15:41:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E058', N'Liquid POOLED PLASMA', N'PLASMA Liq Pool', 2, 8, 0, NULL, 58, '20100602 15:41:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E059', N'POOLED FRESH FROZEN PLASMA', N'FFP Pool', 2, 8, 0, NULL, 59, '20100602 15:41:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E060', N'Frozen POOLED PLATELETS', N'PLT Pool Froz', 4, 12, 0, NULL, 60, '20100602 15:41:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E061', N'Thawed POOLED PLATELETS', N'PLT Pool Thaw', 4, 12, 0, NULL, 61, '20100602 15:41:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E062', N'Thawed Apheresis POOLED FRESH FROZEN PLASMA', N'FFP AFR Pool Thaw', 2, 4, 0, NULL, 62, '20100602 15:41:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E063', N'Thawed Apheresis POOLED PLASMA', N'PLASMA AFR Pool Thaw', 2, 4, 0, NULL, 63, '20100602 15:41:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E064', N'Washed Thawed POOLED PLATELETS', N'PLT Pool Thaw Wash', 4, 12, 0, NULL, 64, '20110427 06:17:21.040', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E065', N'Washed Thawed Apheresis PLATELETS', N'PLT AFR Thaw Wash', 4, 10, 1, NULL, 65, '20110427 06:17:21.040', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E066', N'Lyophilized FRESH FROZEN PLASMA', N'FFP Lyfo', 2, 4, 0, NULL, 66, '20110519 06:35:54.980', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductType (ProductTypeCode, ProductTypeName, ProductTypePrintName, ComponentClassId, IccbbaComponentClassId, SplitAllowedIndicator, RetireDate, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'E067', N'Reconstituted FRESH FROZEN PLASMA', N'FFP Recon', 2, 4, 1, NULL, 67, '20110519 06:35:54.980', N'vhaishsmithm', 0)

-- Update 134 rows in dbo.PermittedProductModification
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'0107de76-03d3-43bb-b8e8-612de4557c9f'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'' WHERE PermittedProductModificationGuid=N'01711cea-43ed-4efe-895e-e50e26297268'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@A1', ToCoreCondition=N'@06', ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'02812ee7-5650-4b20-96fb-392171a6f749'
UPDATE dbo.PermittedProductModification SET FromProductTypeCode=N'E015', FromCoreCondition=N'@55', ToProductTypeCode=N'E063', ToCoreCondition=N'@55', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'02820fb9-9e77-420c-80ea-7c8264246cd8'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ExpirationDateRule=4, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'07fe1861-3498-44d6-a775-2e71227c822d'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=0, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'0e7ad6ef-e7a9-408a-b7ca-93764639ca49'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@BL', ToCoreCondition=N'@13', ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'0f7313ee-dde5-4784-bbb4-b2711a76d9fa'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=120, LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'1165e4e3-ef31-424c-ab08-7263cef3906f'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=120, LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'119c3cb1-2e4b-4416-8168-0c46e0bd8944'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'1639edc6-5f9e-4962-b0d0-e61fd1fa998f'
UPDATE dbo.PermittedProductModification SET FromProductTypeCode=N'E013', FromCoreCondition=N'@54', ToProductTypeCode=N'E062', ToCoreCondition=N'@54', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'199567fb-d231-4f08-8dc0-1f415313027a'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'B2', FromProductTypeCode=N'E014', FromCoreCondition=N'@AJ', ToProductTypeCode=N'E063', ToCoreCondition=N'@54', ExpirationDateRule=4, LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'1ceadaf3-55a6-411a-b081-5718cd291e9c'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=24, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'1e08ff84-0b65-43bc-9512-feaab2f07abd'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ToCoreCondition=N'@72', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'1ff5926a-2c4c-4bf7-a58c-bfb7f826fd75'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'B2', FromProductTypeCode=N'E013', FromCoreCondition=N'@54', ToProductTypeCode=N'E062', ToCoreCondition=N'@54', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'23296fd7-6a4e-46ff-85f3-480fc22619e8'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'23fa78e7-12c8-4d5f-b13a-3469fd424782'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'23fa9b82-3001-4bae-ae6e-ffe24c2e93e4'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=0, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'28e89bbf-2acb-41ff-b4f5-c5f062f51a2c'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'2a0f957d-2f47-4b1a-a4cb-348a2500dc19'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'B2', FromProductTypeCode=N'E014', FromCoreCondition=N'@47', ToProductTypeCode=N'E063', ToCoreCondition=N'@54', ExpirationDateRule=4, LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'2a6ac5ea-f2d0-4ae4-9d67-96014855e3e0'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@CQ', ToCoreCondition=N'@55', ExpirationDateRule=120, LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'2ab1099e-c718-440e-9410-20fab14d48b3'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'B2', FromProductTypeCode=N'E012', FromCoreCondition=N'@37', ToProductTypeCode=N'E062', ToCoreCondition=N'@13', ExpirationDateRule=4, LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'2d5db4b6-4d82-447a-af5f-5925fe51187e'
UPDATE dbo.PermittedProductModification SET ToCoreCondition=N'@06', LastUpdateDate='20100413 12:56:31.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'2eed350c-f6f4-4b08-ac6a-404e34e3f3d1'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'', FromCoreCondition=N'Any', ToCoreCondition=N'@72', ExpirationDateRule=0, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'2f68f97d-72f5-4b44-8b55-97630b2e48b8'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ToCoreCondition=N'@72', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'31246c0e-c56a-4773-9ffb-6a4389d310ee'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@BK', ToCoreCondition=N'@10', ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'3212b18b-f8f4-4d38-8e98-ff3423ac2a1d'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'33702278-0eb0-42c8-9dab-e3c72bc7b976'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@58', ToCoreCondition=N'@55', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'35fcbd53-03cc-4ea1-8bbb-e20307f9de40'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'37155edc-a3cd-4f7b-a9f9-0ba453f25f1e'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'3a86a4d7-3390-4d32-88e6-2bb4b5af7036'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'3c3d759c-dad0-4dea-9b1a-736b6a35be7f'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'' WHERE PermittedProductModificationGuid=N'3f860a61-1c37-4421-88fe-2f37239f474d'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'B2 E5*', LastUpdateDate='20110802 10:34:23.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'3fea7dd6-6c52-4d90-a518-de67fc5af10d'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=24, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'42071f29-66b7-4157-81ca-e04ed1dd49e5'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@AH', ToCoreCondition=N'@AS', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'43314cea-c2a2-4ca9-9e0b-2fe7e4489a78'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'B2', FromProductTypeCode=N'E014', FromCoreCondition=N'@56', ToProductTypeCode=N'E063', ToCoreCondition=N'@54', ExpirationDateRule=4, LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'46cd4829-eaae-4d50-9dab-ad64756af690'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=24, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'487bb40a-ee03-46c5-87a4-976a98697858'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'49eb8945-949d-48a4-a642-028abc2dac61'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'4b4667d5-d076-4287-b153-9c0c8b40eafa'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'', FromCoreCondition=N'Any', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'4d898218-e60e-4099-9a3e-623c6a543dee'
UPDATE dbo.PermittedProductModification SET MethodSelect=0, AddTargetAttribute=N'', FromCoreCondition=N'Any', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'4ea11bc5-d34e-4a3e-8b93-a56cdff47850'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=120, LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'4f778117-26a1-4f3f-b554-bbd4f470de20'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'532a0e36-4e02-47a7-b70e-41922a6d0d1b'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ToCoreCondition=N'@72', ExpirationDateRule=0, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'572d6a72-2fb8-48c3-a361-7b97d65b50f0'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@BN', ToCoreCondition=N'@06', ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'57514917-9ad7-4cc6-a820-85e7faf9f8db'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'B2 E5', LastUpdateDate='20110802 10:34:23.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'5a667470-aa09-481d-b2ce-7bb5cb911023'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=0, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'5b2a216a-7e2d-40de-bdb4-68cd78b3770c'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'5ffebeb4-ca7a-4ce8-9be2-9836a413cf7c'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ToProductTypeCode=N'E052', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'60691317-26ee-43b1-a59d-f9047c9ffb65'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@48', ToCoreCondition=N'@55', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'6078e1ef-b65c-43b8-9896-6a69853cb0d3'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'B2', FromProductTypeCode=N'E015', FromCoreCondition=N'@55', ToProductTypeCode=N'E063', ToCoreCondition=N'@55', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'673a534f-875c-40f4-b1ec-3e3ebd23467c'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=0, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'68088757-591a-4477-bd14-94a189cb7d16'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@AN', ToCoreCondition=N'@06', ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'698df4bf-c565-4df4-9c6c-f8b0d46f35aa'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'E5', LastUpdateDate='20110802 10:34:23.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'6a4b9c47-e596-4328-86f2-a14f950591bd'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@CQ', ToCoreCondition=N'@55', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'6aa3f364-8513-4ff3-80da-d9c1111bdbf7'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@CH', ToCoreCondition=N'@55', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'6c7f1e58-3af9-4437-8e0c-8e61cc9a7628'
UPDATE dbo.PermittedProductModification SET MethodSelect=0, AddTargetAttribute=N'', FromCoreCondition=N'Any', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'6eba82a0-c51c-4276-889d-d82fc4f09d02'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=4, LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'71ab23b9-9c84-43f6-829b-60d577a2af82'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'750d12ea-0353-4ffa-a569-7c672457322e'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=4, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'757f0105-6dd6-4111-9f58-7e4a54acab4d'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=0, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'77f10e7c-5954-4194-9aa8-5a113548c6ba'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@59', ToCoreCondition=N'@54', ExpirationDateRule=120, LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'784d63aa-8a50-40b2-9f9f-cbd768b4f380'
UPDATE dbo.PermittedProductModification SET FromProductTypeCode=N'E014', FromCoreCondition=N'@56', ToProductTypeCode=N'E063', ToCoreCondition=N'@54', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'7980c6dd-3248-4d32-ab70-2da998027e22'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=24, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'7b084ed4-4190-484d-b181-337861438c95'
UPDATE dbo.PermittedProductModification SET FromProductTypeCode=N'E009', FromCoreCondition=N'Any', ToCoreCondition=N'@B7', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'7c0d762e-644d-45f0-84c9-b79cef52fcb8'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'B2', FromProductTypeCode=N'E013', FromCoreCondition=N'@13', ToProductTypeCode=N'E062', ToCoreCondition=N'@13', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'7dc2a85d-95ff-4e4a-ad39-11410adf52ef'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'' WHERE PermittedProductModificationGuid=N'81d51e74-bef0-41b1-81ad-0739574dc608'
UPDATE dbo.PermittedProductModification SET LastUpdateDate='20110519 09:11:00.790', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'82fdcab7-33ae-4c4d-9ae9-30f5811d1fa2'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'8361a747-0761-4e3f-b503-c85e4e1dd85a'
UPDATE dbo.PermittedProductModification SET ToCoreCondition=N'@83', LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'84a8e353-19fc-4199-8c9a-b66cc79d3a87'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@AN', ToCoreCondition=N'@04', LastUpdateDate='20110519 09:11:00.790', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'89b72320-835e-4d6f-b836-a2c500e51ee5'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@37', ToCoreCondition=N'@13', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'89dce9bb-f61f-4276-8a38-26f3cd90a351'
UPDATE dbo.PermittedProductModification SET FromProductTypeCode=N'E014', FromCoreCondition=N'@47', ToProductTypeCode=N'E063', ToCoreCondition=N'@54', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'8af9b250-8f64-4cd5-935c-1d3a081490d6'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@BR', ToCoreCondition=N'@10', ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'8c1275c4-7c3e-4925-9c28-6a49ad222c6e'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=24, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'8c4331d3-80b3-482b-a3d6-43b4bca33fad'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ToCoreCondition=N'@72', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'9196a184-c1f0-4070-9341-5e74b8f95b12'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=0, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'91d77ec3-a8bd-4036-9b16-aeb17f6347d3'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ToCoreCondition=N'@71', LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'9213c44a-4b7b-494a-8ee1-e232e503fe05'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=0, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'9586a206-797d-4c44-ae4e-beef8154c50e'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'95d25dd5-b0c9-419e-95be-0c475bcd89c4'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=0, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'960f81cf-6b8b-432c-8c87-569b55ce9978'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ToCoreCondition=N'@72', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'96f3bf26-de4f-4c45-8794-fda1f9174350'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@48', ToCoreCondition=N'@55', ExpirationDateRule=120, LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'976cba9d-742b-49f0-8a61-7e6805ac3637'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'9d386ec2-2b86-43ae-a5fb-e48f8095a423'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'9e90ac53-2553-421b-8f4f-49a571b8d6de'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=0, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'a52a73a7-8fc2-43d7-b68d-7c7f67f3a36b'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'E5*', LastUpdateDate='20110802 10:34:23.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'a6cd3288-7638-488a-babf-23bfde1e8ed4'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@53', ToCoreCondition=N'@55', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'aa0c1f95-1eb6-45fc-9081-b1cbe84a5db5'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=24, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'af4141bb-5e08-45d3-b7b8-13e4b6cffcca'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@58', ToCoreCondition=N'@55', ExpirationDateRule=120, LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'af45c7ea-9858-497b-a87f-e61caade36b8'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'b04cdf50-d822-4858-a7a5-6e5e9ab83689'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@37', ToCoreCondition=N'@13', ExpirationDateRule=120, LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'b2fd5f68-5dfb-40ec-b9ba-619469e547c3'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@BQ', ToCoreCondition=N'@10', ExpirationDateRule=120, LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'b40e7d7a-d8a8-4412-be2b-1ea2342bca38'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'b474485c-b850-49a6-9301-9d305d6ef141'
UPDATE dbo.PermittedProductModification SET FromProductTypeCode=N'E051', FromCoreCondition=N'Any', ToProductTypeCode=N'E054', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'b6975bbf-1331-4409-ae17-d9bd23fca5b8'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'b9819d48-6c3b-4969-9576-047518dcb9ac'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'bc658c5c-c171-4fcd-aad9-21319332188c'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'bf0fd885-e9f3-4df2-8ab7-5953516d2633'
UPDATE dbo.PermittedProductModification SET FromProductTypeCode=N'E012', FromCoreCondition=N'@AI', ToProductTypeCode=N'E062', ToCoreCondition=N'@54', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'c129f139-5475-44b2-bbfd-46418b4d47a3'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'B2', FromProductTypeCode=N'E015', FromCoreCondition=N'@54', ToProductTypeCode=N'E063', ToCoreCondition=N'@54', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'c4d3c3b1-6325-4a22-bf15-4e810ac4d77d'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=120, LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'c4e03f13-a258-4f92-ab4f-86d1eb57eef5'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'c782015f-7214-4de0-8171-8348fb7c9fea'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@AM', ToCoreCondition=N'@06', ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'c7f183f2-a20f-40fc-a4a8-c8cab25e97c6'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'c7f24db4-50e6-4b5d-b65a-32ffcc7d41bd'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@A5', ToCoreCondition=N'@06', ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'cbd61dcf-f486-4424-b106-1dffe9c388d3'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'' WHERE PermittedProductModificationGuid=N'cc521f70-dc24-47a0-92eb-820c27fefee5'
UPDATE dbo.PermittedProductModification SET FromProductTypeCode=N'E013', FromCoreCondition=N'@13', ToProductTypeCode=N'E062', ToCoreCondition=N'@13', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'ce4f3f2d-e93e-443a-ba4d-74e76054cfc9'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@B4', ToCoreCondition=N'@10', LastUpdateDate='20100413 12:56:31.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'cf239595-e16c-4319-b997-5a58618d2a82'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@AH', ToCoreCondition=N'@AS', ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'cfe641c4-0cba-4ccb-95de-4dd296c9ff80'
UPDATE dbo.PermittedProductModification SET ToCoreCondition=N'@83', LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'd0161752-1afa-402a-8e2f-b98632677cfa'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'd1414bc8-d374-44b8-84d9-ec026ec814b9'
UPDATE dbo.PermittedProductModification SET ToProductTypeCode=N'E055', ToCoreCondition=N'@06', ExpirationDateRule=4, LastUpdateDate='20100512 12:00:40.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'd314cdda-6eb3-464f-8454-1f6bf143f2d9'
UPDATE dbo.PermittedProductModification SET FromProductTypeCode=N'E012', FromCoreCondition=N'@37', ToProductTypeCode=N'E062', ToCoreCondition=N'@13', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'd545dbbf-6707-4544-ade7-97d3e14c544a'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'd92e6cfd-6b3d-415d-b73f-9698833a02ac'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=0, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'dfab19d8-84ca-462a-87aa-cc64618bfa79'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'e081ac86-5da6-485c-a8e9-990bc8261d76'
UPDATE dbo.PermittedProductModification SET ToCoreCondition=N'@83', LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'e357315b-afd8-4c1a-99eb-b05c26f3838b'
UPDATE dbo.PermittedProductModification SET AddTargetAttribute=N'B2', FromProductTypeCode=N'E012', FromCoreCondition=N'@AI', ToProductTypeCode=N'E062', ToCoreCondition=N'@54', ExpirationDateRule=4, LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'e5d94414-638d-4481-afd0-5564d0155551'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=4, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'e62a470d-eb6d-46a5-a345-8cb50a62625c'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'e7c3d4df-a9b8-4173-84a2-7a61088422ef'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'e9811a10-5e66-44ec-b326-c6627202c95d'
UPDATE dbo.PermittedProductModification SET LastUpdateDate='20110519 09:11:00.790', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'ea3665b5-82d3-401b-b6cd-379392f38153'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@BJ', ToCoreCondition=N'@13', ExpirationDateRule=120, LastUpdateDate='20110802 14:25:51.180', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'ecb1eed8-b6fa-404f-943a-a776c6fcd3fe'
UPDATE dbo.PermittedProductModification SET FromProductTypeCode=N'E015', FromCoreCondition=N'@54', ToProductTypeCode=N'E063', ToCoreCondition=N'@54', ExpirationDateRule=4, LastUpdateDate='20100527 15:28:15.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'edead097-50a3-463f-a0c7-27544af4ebd5'
UPDATE dbo.PermittedProductModification SET LastUpdateDate='20110519 09:11:00.790', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'ee487f3d-fb8c-4b27-ad8e-5df27a2e107a'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'f44534d1-e886-4d21-9e19-525bc4ea00ce'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'f5072193-190e-4c30-b020-5273557b0386'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'f6232367-3ff1-411e-8b26-0b5f90934930'
UPDATE dbo.PermittedProductModification SET FromProductTypeCode=N'E014', FromCoreCondition=N'@AJ', ToProductTypeCode=N'E063', ToCoreCondition=N'@54', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'f83b7b63-a317-471c-b579-f786f85a158a'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'@B4', ToCoreCondition=N'@10', ExpirationDateRule=120, LastUpdateDate='20100510 12:57:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'f87363db-7f0b-4f57-b797-399a4a078309'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=24, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'f8c9f241-90ff-4683-b9d0-1f51db471f0b'
UPDATE dbo.PermittedProductModification SET ExpirationDateRule=24, LastUpdateDate='20100513 07:52:53.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'fa800626-adad-48b8-ae4e-f2b05f6d08ed'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'fafb14d2-6eb8-47e8-9453-52016bbf1e26'
UPDATE dbo.PermittedProductModification SET FromCoreCondition=N'Any', ToCoreCondition=N'@B7', LastUpdateDate='20100513 11:15:57.000', LastUpdateUser=N'vhaishsmithm' WHERE PermittedProductModificationGuid=N'fe4a9f9b-8fc8-4e2e-8681-0d2d7576b9b8'

-- Update 2 rows in dbo.Interface
UPDATE dbo.Interface SET InterfaceName=N'Patient_Update', ApplicationAckType=N'AL', LastUpdateDate='20110324 08:39:04.163' WHERE InterfaceId=2
UPDATE dbo.Interface SET InterfaceName=N'Patient_Merge', LastUpdateDate='20110324 08:39:04.163' WHERE InterfaceId=3

-- Update 2 rows in dbo.InformationMessage
UPDATE dbo.InformationMessage SET InformationMessageText=N'Preparation of red cell components for transfusion may be delayed due to serologic problems. Contact transfusion service for information on potential clinical significance and availability of blood components.', LastUpdateDate='20110510 10:29:22.200', LastUpdateUser=N'vhaishsmithm' WHERE InformationMessageId=2302
UPDATE dbo.InformationMessage SET InformationMessageText=N'Preparation of red cell components for transfusion may be delayed due to serologic problems. Contact transfusion service for information on potential clinical significance and availability of blood components.', LastUpdateDate='20110510 10:29:22.200', LastUpdateUser=N'vhaishsmithm' WHERE InformationMessageId=5407

-- Update 9572 rows in dbo.BloodProduct
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-25C|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'00025457-b774-4406-991b-2d6d4175abff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'00049d35-baea-4d83-85eb-23d133253281'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0016fd31-9ac0-409f-8448-ba5b5098d0dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'00188434-7ca3-4f0d-8ac1-f5b31af2d30e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'00294712-bbca-4b76-b929-9adff9c5e09c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'002b6ca1-3712-43fc-b4fa-6e0fe6c39bda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'00310236-bd1e-409d-b609-c2b5f959e558'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'0035c6c9-ee3d-4c84-96fe-31b87f42526d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0039fd51-e5cc-486b-ad5e-637f862f2e98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'00422b4b-de4f-4f8a-a2b0-eecd38f8c285'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'0043808d-3fab-4c4c-91c7-688c292b063b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'004517bf-1569-4301-afa7-b96e02314dc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'005481d6-569a-4efe-b7b5-ac49e7bb2a17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'0056454b-56aa-4315-875d-6f3b5e5bc614'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'0059ce70-aad2-48d9-a61d-0fdb6c5c7923'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'005e093c-1a1e-4c18-9e4c-cbe75bcb3da5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'005e3774-4499-4cfd-abb6-7a7cb7a45897'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0076d7ff-d832-4468-877d-16914b02baf5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'00799106-c30d-4305-aa01-bd3b9d95a49e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'007cb83c-91e5-4fb8-99bc-aac7b8865ad4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'007fc421-72b9-400d-885c-cdfaa90fb94e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'0080acca-cbdd-46a5-a61d-f0d7491a1937'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'008c81ca-390f-4396-bcfc-e17b253e6b10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'009fcac5-93c9-45b7-b166-a4e226f70c9c'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'00a20666-d95f-4eea-a0a6-08e93e9289f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'00a9169d-0e17-4764-a507-0e03cb86d243'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'00abc6f5-438b-482a-b335-2766ab1d2473'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'00ac9a13-b5cb-480d-a435-a9180e2a82ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'00b2aeb2-1f1a-4a32-be2e-f41e984c3a72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'00c7729c-668b-4b2f-ae81-67d6daf93e5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'00d18738-e62a-41e1-bc8c-43ce65228d27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'00e4b0b5-344b-44a7-a902-4e94a270993b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'00f1653b-bdd8-4a46-b342-65647f6781b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'00fd0d3e-9026-4d53-81b4-b3ab84ffcb6e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'00fd8cd7-ffdc-406b-ba6a-7786cbc962ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'011889be-1578-4428-a362-32a41cf61211'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0123cfab-7ef7-4729-a829-4849b3eef536'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'012b6852-6de3-441a-a0cb-a247e2a4ccbe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'013a3968-1f41-44fc-aebf-4741620a1800'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'013af1ec-f325-4772-aa68-571c24201455'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'013d66b5-cf80-40bf-9ce9-2d63a6ef9f3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'014016b1-3e3d-4812-b291-b2c6adf1def3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'01445b93-f2dd-40f4-ba1b-136328b147bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'014c1c1f-3d81-4b97-8435-c2547f1a4c42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'0150b4bd-bba2-4be5-be94-bdb3ead37ff9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'01543a95-ca4c-46b6-a3f0-1d8a25e9abed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'01684657-98d3-4125-a0b0-a2112fd1c54c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'01692e74-b541-491a-9342-9f705612cddf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'016b31bb-d246-426e-aca6-a1884875835e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'016f5b8d-8a16-4a7f-afdf-4ade5baf4774'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'01731fcd-80e1-42ad-bef7-0dc4d3ac1e72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'01755635-7e1e-486f-8317-4ec2d67885ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'0178eb66-21e4-4cd0-8268-749da5e29a69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'017e081d-a7c2-49a0-8415-e7e2754129e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'017ee09e-5184-41dc-92ab-e691fbbbb9cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'018aae74-f6e1-446f-85ac-a6552bb51126'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'018c1924-7017-406f-afe1-38500db61c1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0191485c-6993-41a5-91f4-f20d88e17b2a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'0191846a-380a-4f95-a8e0-d08a8195fec5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0194fe44-1300-44cd-8926-89a8e8caf9f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'019d7934-2a9a-4fa1-a449-cb81441d6f7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'019d8886-a01a-4508-812c-88786b85cb0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'01a08784-04fc-4d57-a496-987c98c26f25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'01a2a5da-1777-4240-b676-a153d22d9804'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'01a468f1-f3f2-4da5-96b2-d79fc1265067'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'01a70929-9d11-4648-9cd9-fbbfaefb2ec0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'01bab951-a1a7-4e24-bec5-472f20c2b658'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'01bc17c1-c1f6-48d3-859d-e99f2a098b9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'01c04cd7-0692-48cb-976b-860eb871dcfd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'01c09bac-60df-4d1f-b05d-3d1bfef203ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'01d253d6-b884-4f30-be64-0f71044bdf9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'01d2c607-32c3-483b-9ec5-0985e75ab7fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E058' WHERE BloodProductGuid=N'01dd8113-d0fd-483a-b3fa-c151380781cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'01e29fa4-286b-4b6d-b397-97582bc91eda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'01e4670c-ac40-4c8e-9d59-eac78db7e5a6'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'01f2a471-7ce3-4525-b111-8994f492dd17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'01f323b2-b87e-460f-a09e-633fd44d85fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'01f5e7b7-9ea9-40ec-8007-cc4c6440e57d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'01fb37f8-2b75-4e13-870d-df092bf29c21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'020913bc-9006-4772-b6e5-f46e87e01f98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'022ea6e8-b45b-4964-a46c-89d101214646'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'022eb88f-6109-48c0-9e46-667adb9cf524'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0235cc74-6dc1-4113-9569-9085b790fcda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0240f466-ea92-49b0-a129-7b2bb77cc59d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'024e0933-a9ca-4b7d-9cca-c0bbeaade9e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'02526682-3c1d-4240-bbfb-0d71e779818e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|Irradiated|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'025403cc-983e-4b4a-a45b-d6b35713cb44'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0257c68d-7d7c-4d94-8abc-7e4dfb7caeed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'025aea72-1ac1-40c4-a3d6-0ae052d1eb98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'025f2f5b-70d3-4a9b-9b86-cf81b5f25096'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'02680d9e-82d0-409e-a699-0f1cc1f4d31c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'02751ffa-6b02-4aff-9e84-fe51d13f1aba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0279432f-6f7b-40df-b046-9255e107ce2a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'027feb1d-fb47-4d09-a83a-d23e67ec7a3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0282cc83-4769-4056-ab5e-1af5148c03ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0284fb94-3a9f-4802-8ae0-e0fe1d7d9caf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'028997c4-bb3d-4123-b44c-e7edf21b313f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'028f5f05-14e2-46d6-9c52-d854c958c03b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'0293132f-ca64-41e5-bd93-435476de5f2f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'029d322b-7401-4af1-9d2d-d518f5068a96'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'029f11d6-2e5c-4222-84dd-e7943c28b1d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'02b43809-342a-430c-b205-36e82f5894fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'02c44b6e-9b8e-44a4-a88d-5ec3fb1fc3cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'02ce1e6d-0439-4001-bb61-68c826fd4c7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'02cfd55d-993b-4285-a2eb-1bf2493c4fad'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Irradiated|ResLeu:<1log6|Plasma reduced|Buffy coat plts prep|Approx 240 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'02d0ed90-11b6-4b4b-9cad-8fe73a5ed8e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'02d1c398-93da-403b-b014-8104a1b2f171'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'02de27c1-6168-4494-8bfa-0dfa600bda5f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'02dfb7c6-6fda-4789-842b-30e3d35234ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'02e1b106-c5c3-4fbc-8e56-2d1db5fb052b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'02e52764-8dc7-41f5-b818-df6044a8946d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'02e7e58a-cd93-4c06-8c08-aa4e4182e70d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'02ebadf8-3bd2-4ffc-9c42-c3de62757e64'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:injectable|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'02ed5a05-e993-4e6f-9c2a-81fe1e512f29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'02f51180-8890-4178-83f2-c3815c83d943'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Not for tx or mnf|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'02fafe1c-8f76-486c-925b-1d92f47b5a3e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'03040099-431c-4bc6-9979-3df512e6d161'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'030ce05a-d60a-49a6-bb63-1acf4e2e4535'
UPDATE dbo.BloodProduct SET ProductName=N'RED BLOOD CELLS|CPDA-1/450mL/refg|Irradiated|ResLeu:<5log6|>0.7', OriginalProductTypeCode=N'E002', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'031d6a56-f128-4163-a4e5-3f221a112b91'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'0324a679-06f6-489e-9e50-f80877ff92ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'032bba80-5e0a-4d74-a399-b989b4028ffb'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|Irradiated|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'032d1112-2160-49c6-b26a-6e9606fdb4e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'03368624-2b1d-4970-80fa-81f8ee0fef09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'03372924-7cc8-4fab-ac81-5bd732b568ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'0344590f-a6bf-4ee8-b7b6-cf9d1603bad1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'03543bbb-6570-4de4-ad77-a3503515bc70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'0357c2a7-7444-4c81-a77c-5b706ab1e635'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'035bae1f-bd61-4ff7-8325-faa820b24bf7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0364e181-27cd-40af-9a9f-008e1c526fb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'036841a1-4d71-4f6d-8e97-7fe24b1632dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0381a2f8-9a0e-4345-85fe-baf5cc236a06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'0388e487-8bff-4169-bb25-93692974a426'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'03898446-5a0c-48a2-aaa9-32f0639d84cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'038b68ca-fbd0-4bf9-b2cf-eac647f777a0'
UPDATE dbo.BloodProduct SET LastUpdateDate = '20110510 07:59:27.820', ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061' WHERE BloodProductGuid=N'03934de6-43d0-48e6-a345-4a3ab90d3562'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'03958448-a664-4a2a-b30d-19b8b7c1d2fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0397977b-a84d-4abe-aa0c-5b73d6afd830'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'03997a8e-a7a3-4804-9955-976a8a3e93b6'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'039d585d-c64d-4d5e-9c99-94ead03cc586'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'03a026d0-93b2-4e15-abe3-610cd64f235d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'03aa59c5-69b5-4b76-88e4-a59d180e1a7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'03bdd188-8c6c-405c-9ddb-9ccb1ecdc186'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'03c04e53-46a2-460d-830b-e238b7353357'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'03c44190-c427-4280-ba26-97ecd8c0670c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'03c6fc29-5bc6-45b3-bbdf-bf2e7f2375f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'03cb4417-3052-41b1-99d4-c904cbcd1151'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'03d22527-1af4-401e-a0a0-b46e0957f15b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'03db73d3-7c6f-4dbc-a449-ee4f6e33ece6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'03dc0ff6-c524-4262-920b-50b7a63fcad2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'03dea0fa-5fbb-4127-8bbd-78753296f181'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'03e186a9-e722-4297-8dff-d95c8de0f6d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'03e61659-2de0-428c-8c4c-cfd9a5908d25'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:injectable|>=200mL<400mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'03fafed1-9ae6-41e9-9567-5ed2affea344'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'03fc7c85-fffd-432e-ac06-602af22f12d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'03feabc4-24fe-4370-a81f-6f7e9fd90e21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'04062341-9f2f-4e16-a003-47e297a6a3d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'040e8ad3-2306-4a4c-8434-21f426423e60'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'04156061-d1c8-4f80-9525-a5a16a1cf20b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'042a5861-e6ba-402e-adbe-51eeb264fa7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'042dd3f1-310a-4c4e-bc30-28ac84c9a359'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0431f963-5b97-44ab-ae3a-f646ffa695af'
UPDATE dbo.BloodProduct SET ProductName=N'RED BLOOD CELLS|PAGGS-M/450mL/refg|Irradiated|ResLeu:<1log6', OriginalProductTypeCode=N'E002', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'04334df2-b855-4e77-9da1-62647963596c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'043a0d25-9dca-4adf-8470-dfe66e798f5f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0440d659-5057-450b-b710-4a8101dc8744'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'044e5423-e072-4509-90a5-da0e31d67dac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'04502597-4dde-4c06-bef9-f2c8c7b3b93a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'04597948-053b-48c6-9bfc-f4b7043b5f8e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'045b3f61-7dc5-4ab0-8018-f1f39b34a666'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'045e7881-3e31-46da-803b-8764a04997be'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0465fe3b-eee6-476a-a7ea-63e8ad1445ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0471397d-5e3b-4c51-b97a-60af26db13a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'047230da-88c9-4906-8c04-5f231f0059bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'047a2208-9261-4002-b0ee-8e11367c53a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'047d53b0-1445-4d43-8c08-d8b0b6aa64dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0480abb4-0b25-4dc8-9c0b-06f82061cc8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'04842478-bd39-4ebc-b181-0b3fb1423a2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'04893592-5e1d-47b1-87ad-a7ff1c2f9891'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'049592f4-9bcc-41a5-aac2-3b85abd3e6f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0496a077-534e-4787-8120-53ad4046f956'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'049906f8-8531-4aef-b90b-3a3ea41b889c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'049bf494-7cbf-4a6f-9179-8a1f18123410'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E059' WHERE BloodProductGuid=N'049dfb33-7f67-4cf5-9f9b-24b3f370551c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'04a0acb9-8c67-4720-a300-a5bd609368bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'04a74933-9a79-4da3-af46-e314b7fb5f5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'04b583e0-6527-4d82-97d0-a8d341f4c8e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'04bcbb56-349c-47b5-b36e-075728c11dae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'04bf80dc-6cd8-4ef8-a461-279b26f4a5ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'04c24c36-7971-4af1-a08e-1ed60c8be227'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'04c44538-04e0-4d30-99a8-a362a33fa880'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'04c6f87b-8495-417b-9058-a588d5227e7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'04c9e093-2145-451f-8cd4-a641cb8ae3c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'04cdef8e-4bcd-4b8b-9399-673f58fd8a19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'04d4d9b2-1f94-4231-b11c-5aa81448e744'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'04d9e78a-7682-4b18-9f9a-fd9132e9d3ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'04e180ec-5bdc-4435-8d2f-18dcf24afd55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'04e3688d-b99c-47a0-b78a-ba64820a45b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'04e3a96a-125a-4af4-93bd-5a3513593f84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'04e3b06e-b2cf-436f-bb93-4e472f26e513'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'04fcfe0c-6d0a-4333-93c1-a7ff8079d4c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'050684ad-f2c0-45a3-b48f-bc63816c307e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0507ba4c-45d1-4538-86d0-771cc8f5dfe6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'050d3ba1-d6b7-4980-90a8-fe0d1403cb06'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'050efe97-cc36-48a7-8428-aa6b125b48b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'051df4f3-023e-45a6-85b9-03866d05ef7e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'05244089-e384-4fb4-b6f7-8f68a2c1ece4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'053ab39f-bacb-4f9c-8f54-2cc3cf28d249'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0547ba3e-ef76-4860-9461-47b801c4d2fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'05528312-299a-49a4-a0ec-01c5057e247a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'0558dff1-9926-4b80-bbf4-d2c6f7b92a0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'055bc7f6-1337-4116-973a-c7377149510c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0566d76f-c15d-4124-9478-3e54fac96505'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'05699460-f532-4365-a4ce-30d24a9c2a33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'056d6a5f-0a3a-41f1-be6f-21960506ffd6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0579f283-c883-48bd-ad86-8a95ed0c73fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0588c6b9-7500-4bb9-91a9-8346a416b084'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'058b67e5-2bd9-49a4-bd00-75a5245260a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'059d99a7-6642-4b7d-a842-c71e92d00c6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'05a2e856-49c3-4a7e-b608-3018192f5637'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'05a455ab-b9c8-42ac-bb95-20cb67a69741'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'05a9c6c1-2f14-4ebe-8c83-805c87dc197f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'05b4a598-8af2-434b-b498-1cb48315fc4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'05bdf77e-0b67-47e4-8842-6b177a7e98f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'05c50772-210a-4730-b0c4-85a0af1a9680'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'05c8c694-4fd1-4975-b084-5530550f5cb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'05cf8dab-f27d-4a42-a1b6-7dbf9cbfc55e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'05db268f-6308-4f18-866a-89256db5774a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'05de88ef-6e8a-4922-97b0-6c3dc78371bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'05deadf5-3c9d-4a03-ac92-03e99fcdc250'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'05e3a4e2-cbfc-47e6-8656-99abdbd7fac5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'05f7d446-cd71-4937-b92c-6c0dca96dcdc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'05fc0037-d661-431b-bd21-4c72cc258e1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'060411cb-e09a-43d3-91c6-c6941c7640c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'060aeeb8-1ea4-4870-b6a0-1efb304c470b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'060d9201-333a-43d6-bfb5-be18e022e610'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'061adb62-5df5-43c2-a363-97fff46fc849'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'062cb67d-152b-4618-8f72-b773a4335e37'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0633b0d7-a713-4df3-98ae-a67850f7df02'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0641af84-0236-4180-8952-23208d244e32'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'0646abac-363b-4b61-9f2a-53e29ad3e3a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'06476fca-bc0d-44b8-a5fc-7026307370ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0649a1f5-52b7-4581-91c0-ae43163a7b48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'064af6e8-d16f-4fe0-ad62-1177b7e52e12'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0650eeff-2345-43ee-b1e8-c28d40866263'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'0659cb5b-3f14-49ae-b65d-8038fdc02cec'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<=-18C|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'065e907d-5edc-468b-92e1-886d287c0e42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0664e43c-0d49-4426-9a4a-de70775ea57f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'066ad462-89e8-475a-9c57-1dbd7f472956'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'066d9190-6b04-430c-bbec-61eeb2094fc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'06709155-fa60-46d9-8529-03f1d8783c1d'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'06756f09-258e-41a0-8061-735cfb4b21ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'0677bcbd-4aa8-496d-92e3-16837a28ed42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'067b0c49-50b6-4180-82a1-dfc8e592fe52'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'067d933c-9363-4691-8086-a2f9cb6c7986'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'06807afb-5a1f-44e2-8a4e-c2529ea32ad1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'069652fb-7071-4b63-8ef9-14e891e6e57b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'0699f526-e563-4399-8535-90f8e157eb23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'06a69853-cb51-4288-9f13-0874b4b10bd6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'06a909d0-df6e-491f-921b-22cfb9301a86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'06aee5b9-dd66-4e8b-9644-e77b7b5e25da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'06b21389-2977-4d71-bcac-0546a5c4526a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'06b9a8e8-70f9-4a13-8e5d-e50316c77156'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'06be1488-3731-42a2-84af-13015ad39f9d'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<-65C|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'06c43405-b375-4335-b587-59650e83b6c5'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Irradiated|ResLeu:<1log6|Plasma reduced|Buffy coat plts prep|Approx 180 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'06cd5211-b352-4b02-bb65-0be4e9be2b5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'06dc2cf3-9ab5-4b84-a855-b5eb1d1cc8e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'06dc39c6-0c65-4e3f-91c1-950294a7452e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'06e71e5f-2601-4170-8081-50f246268f0c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'06e7ffdc-9587-4644-b63a-7a2455e0722e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'06ec20d3-f381-4919-b5cb-dedb03ee9e8d'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|Not for tx or mnf|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'06f0977e-90e2-4d5b-97e3-a3677689641a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'06f1e348-d673-4f05-8f2d-bbcad5731286'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'06fc627e-da65-443f-a592-8c965b17e4fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'07028759-d488-4b3d-a0eb-a357aa357694'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'070708af-4559-4ab5-822d-31984ad96122'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'0707c392-1291-4068-91bb-159599b10423'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'070993ce-9947-4863-a987-5f47ebd8bb3a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'070a8b7b-8aac-4c4a-91ec-77393b302564'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'070c4a92-b0e2-4407-bac6-8eac2726539c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'070ff18c-3396-4dc2-bb5f-a98c982ab5da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'071a8025-84ae-40fa-9b92-cfccb29364ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'071c9183-124f-4956-84d5-0146dfc5538c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0720c6de-c18f-4aed-baaf-65c4d6f07459'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'072275d1-8157-4db9-bbd5-438c1fee5bca'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0729748e-864c-4392-99fe-93807c560762'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'0737eccd-082b-45ca-b2c5-c6a7cd334a84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'07456b83-79fa-45c2-ae09-6a5425bf2783'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'074a3401-b448-4ae5-a238-d85084cafd7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'074a6f21-d200-441b-9447-30fe4c34a6d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'074e1030-d2e2-4e21-b8bb-5b0d2e7b71f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'0755bc5c-de9e-45a8-a034-6912d790c8f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0778109c-efe1-44cb-8f1c-cd2ed884056e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'077e0471-1cbd-4b80-b6d3-7ff5d14f1f1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'077eb07d-bbf5-4258-a890-b79e36f09d43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0784bfeb-fed5-414a-bd6c-ed0f7da9a886'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0787f51f-bbce-4037-9eea-092a6608f1ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'078d738d-203e-41e9-8f96-a18a1c0d1563'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'078f43ad-fefb-42c1-90c9-0d093fa6a051'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'079a8b97-d00f-4f20-a72d-25cb19125f04'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'07a2014a-c448-4db2-a841-378d5d115bd8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'07a382f0-f424-4b21-ba50-7831ec3eee20'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'07a5c01d-5a30-4d36-8c6f-a37781a7eed8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'07bf6775-9029-4e57-9c81-ba4d84d48f02'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'07c10503-31da-4494-9e37-4a3c9e74d0c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'07cd868b-c06a-4f05-9a4c-58f6ddd02715'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'07d12d8a-5280-49a3-a826-8d0585bb920d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'07da4df5-0bd8-47d2-9bd0-bb81b8a492d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'07e87a0e-73fc-4465-9419-4b5bc88deda4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'07eb4624-8d68-4a78-92ae-fdeaeca9da11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'07ec1b1e-396e-4bbf-80ae-1077dc9d0db9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'07f07e4b-459a-4ab4-a4b6-cf204abdfa84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'0800c1ec-b228-4dcf-9bf6-1917be92175f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'08065650-fbee-4d67-9ca6-a84db600bfe5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'080a492f-e8dd-48d8-a57d-753be696f9a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'0817350b-6465-4c88-b842-2a143ac350e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'0820f043-fe8f-46e1-9a09-0c762cac1c98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'082c68ae-cbfd-47ba-9f6d-04da93e753e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'082f102c-1476-48a3-9ce8-5142e9f6038b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0831ca3f-202f-463d-8cdf-90a618ffbef5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'08324b9a-a8e4-4684-b239-78b0d0e6caa8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'08383d37-ca54-4697-87bf-3e3ec74bda83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'0839092b-df37-4e26-a203-e865f45d941f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'083e0734-9a18-433b-8394-851776dd04ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'084f0d33-5a0c-4436-a872-bf19354c0ccc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'085954db-7890-4c7e-aa74-56990a7cf7f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'085f9d60-d696-4300-be64-b29fd1ef733b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'086459e4-3970-4cf3-9f89-3d29f59e52ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'08666315-9ef0-46ae-8373-25c128fb0883'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'08679382-4564-4f38-8d8f-4cef2d04d102'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'086c3135-bd32-43b5-a886-c1e77526b1c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0873b755-063d-434f-a813-221b51753cfe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'08888411-b47f-4802-bf11-a32477c2a8f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'089b4aa9-3740-4c4a-9c5d-ac095de683dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'08af260f-e9bc-4c28-a3f8-c5fece19365f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'08b8ccbc-5f44-49d0-a98e-c2d20d5faf72'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-30C|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'08b963ae-448b-4739-a0d3-0a402e291954'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'08b97899-17a7-476b-a167-a4ae2cb4c03a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'08c1554a-353a-41a0-be6c-82a595107a13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'08c7cbc7-506c-4916-9e0c-0c1b6417e20b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'08d09cd5-5cc4-4696-a8b8-6689a50d9ebc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'08e9224f-7a64-40fb-8bfb-b78929caa5fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'08ec1096-c919-4634-b118-565628d4cf97'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'08eec6e3-19d2-4593-a5d9-4bcc090c7c23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'08f4556c-ae35-4c8e-8314-19a8619fea55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'08f9b402-e3d2-44ca-89f9-67f0b415ef7e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'08fa2cdb-40ec-4518-b292-8ab39eb1977a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'08fb91b6-2f08-4e44-a5bf-8aede0d16881'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'0907f9d1-9418-405e-9739-12a0f2789864'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'09099cb8-5e83-4d1c-aeeb-18699ae3e920'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'090a749c-b7e4-4973-86a9-0c25578b338e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'090bc9f4-9407-4efb-8ba1-23ec39fb650a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'090ed9d4-e663-4638-9791-290508537bcc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'0912064c-dc4d-4cf5-8955-fad348fed6e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0913c4a5-9fc6-4748-b8b7-5a7f969566e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'0921ac2c-a655-4cd1-ac04-f7964bbfd819'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'092289bd-1a6d-4fb9-a5a0-64da12b23b18'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'093194bc-f2e0-4cfd-a506-8a39b693dc9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'093724f6-ff49-424d-8e00-b2fd83ebd95d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'09405256-2fee-4f13-b748-e890123c15e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0942ff99-0b6e-4b0e-832c-7479cdae045d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0943ec68-3b14-4099-ba9d-9340ee5788c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0944ba27-0b68-4a12-9263-ea21d0c38fd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0944c792-cee9-4c09-9a59-89a29b22b96d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'094bb002-ba82-49c0-88df-ff66f24f91a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0950f63a-34fc-4698-bf71-c1b379484baf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'0955a448-d338-4f46-bf35-cc19f19aceaa'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Irradiated|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'095b460e-b3f8-4396-a371-72574e2ddbef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'097605c5-d534-4014-80a5-4e6a1502c15c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'09885ce8-30c7-4e12-bfe5-8eadddd91c1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'098a3133-e1cf-4c0e-9d69-015dc0e433eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'098b6078-d741-45a2-a418-b0a8ffc6ea33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'098f3ca1-ae7c-44b6-bacd-430245cb5a0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'09910835-ffe6-4915-9116-bef6e43e940b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'099208a6-e354-40c1-a33e-2ddeaacc8bf0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0992b3a8-1d51-4d54-b23c-95e61a36dc4b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'0996ac40-bece-401a-857f-b30448e20c52'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'0998ecbf-4377-47b3-9d95-41f88c8c9857'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'099c4c6d-3ea2-45d8-8585-3e8b6f27c8dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'09afa9be-b31f-4ede-976c-21a5cc5e3ef0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'09b89bd5-d327-420e-beac-4ba12350a395'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'09c41afc-9e83-4166-9020-681987bcdef1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'09c5654c-c5f3-4b00-921d-b16917826819'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'09cc3bbe-9fca-4540-8fa0-85b2789ef919'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'09d1e57f-027c-4527-b57c-2424464d743b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'09d4bde6-4fba-4fce-9408-9f9d15dbc2fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'09d53e0b-b01e-4edf-8e2a-c5ea2f2ed623'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'09d8fbd5-705a-4a8f-a3b7-da5950339679'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'09de9a0b-15c9-4d07-9382-4b1c111a1899'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'09eb1c25-e2fb-4158-ac9f-bfb0dfeebdc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'09f43035-9f9f-4b1c-a821-25b2affa2617'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'09f6571e-8ead-4696-9a11-d7692fe8df3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'09fb04d7-e24f-4d7b-a610-bf92b9008cd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'09fe0abd-bab5-4c73-9b87-5a6d9117ca49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0a08b062-303c-477e-a4b7-1e47772ba67b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'0a09afed-d63d-4d7a-84f5-b1a1b8e93d16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'0a0b8c55-d6c7-4b7c-bd50-fba79b620396'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0a0c0146-b992-41c6-81ec-c62d739f9208'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'0a132eec-ae01-44f0-a48b-810b60287ad0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0a16b675-31bf-4973-905f-ac1737ac6cd5'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0a2bc861-db6c-4629-b79b-b901abd69f28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0a33947c-5e6b-496c-ab24-450f1f6bdfb2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'0a35ad07-8166-4168-8bea-bee975e7b592'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0a391ccc-9fc6-4c91-b242-7c80a625acb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0a391ff2-26e2-4dd4-8a81-2aeb79648c1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'0a465329-8471-49e7-a78b-85eac67101b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'0a4beb15-cbf2-4765-a041-2aba89a4edcc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E033' WHERE BloodProductGuid=N'0a5f57fc-61f2-4b7c-86c9-9d6a02bf3e7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'0a67dd6e-30b3-41b5-b2f6-06d5e636293a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0a6cf86a-cfb4-439b-8090-3c215f38160e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'0a6f44ac-9137-44bf-be46-92c25006a0e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'0a7362b6-742c-41d0-aff2-3e16aed2e7b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0a756ab8-4f80-4a10-805b-2d7ae208e933'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0a86d39b-9300-491b-bd66-d30a2c90c1ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0a876b13-e4f4-4a11-901f-8f43d3ef915e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0a8fc800-3ac7-4d45-9e3b-fbe315258c9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'0a9c52d1-d876-4846-96c8-571e16d0e349'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0aae6502-c4d6-4839-93e5-f11a8d6d8b43'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|Not for tx or mnf|>=200mL<400mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0aaf75ab-94c3-4429-bf86-cf3d180662c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0abd651d-b13e-462e-b68f-706e962077a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0ac025fa-19c7-4115-bf03-9df6f9ad7b55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0ac742c7-a320-47e7-89e4-d989dfed1a45'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0ac90e4a-e917-4511-9f49-9ea38d3b7490'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'0ac96be3-fe6c-4b1e-9d28-5b6963e26a88'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-65C|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0ace6249-ffc3-41d0-8d57-4516108ac63c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0acf5b91-98ea-4ac7-9c96-a62cd3fa7ce4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0acfc159-7f0e-4bf6-9a01-67212e3b3b58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0ad1385f-565c-405f-91e8-087bfab87365'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'0ad2eaf5-9215-43b5-a721-8cb1484cf14d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0ae25063-4df1-4090-8c09-46a82e5cc3b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'0ae396fc-b48a-4d0f-91df-8063e49983a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0aeb19d2-0086-42c3-a4bc-343846361fa1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0af35230-ba93-45ec-803b-840e177c48ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'0af7641e-7aac-4f6b-b845-f76ce39e41d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0afa0efa-b256-4220-b485-8f83be054656'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0afb323f-dabc-4794-8177-f374889bbcba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'0b02803c-1578-4a45-b565-ed88bf3f1dfb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'0b0c664d-df1b-4436-9a57-e89656b5bf86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0b1b8000-da34-4b60-bdd1-a3da69e8ce5e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'0b1ba3b3-a2ac-4203-893a-b9e60d0082da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'0b1be1ec-9c48-4c8d-872a-56e273925ca9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0b1f1601-e296-41bf-aea5-22fcc70d72ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0b2538d6-a8d6-4841-978b-c77452ac709a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0b3038be-b72e-4878-9610-2d99572253c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0b3add9a-0477-4b28-88d5-f3d1fbc24a15'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'0b3e5388-5210-441c-9128-24faa24ebb4b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'0b42ce25-1a7c-4cd6-9518-29ffc12fa042'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0b534f4b-037f-4cef-a2e6-7b0e87c3190e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'0b697bce-84fa-4c6d-ac26-f6e8e9424160'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0b6f5561-5c58-4695-b092-66f73ecc91d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'0b76b16c-e31a-4fce-90e8-d859dbf1236c'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Irradiated|ResLeu:<1log6|Buffy coat plts prep|Approx 180 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0b7e3d3b-c107-4983-a111-38482eb1f0b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0b82239e-5cf1-434e-8771-3fc7331020e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'0b85dde0-9bba-48be-88e9-873e4a9d5c03'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-30C|ResLeu:<1log6|>=200mL<400mL|Methylene blue-treated', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0b869f4c-d6cd-41db-b5b9-2bf17c513931'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'0b9d6da5-57d9-4090-b01e-dfb249a7e544'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Not for tx or mnf|Open|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0b9faf1e-9413-43ad-9954-2e8a7cdf611e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'0ba3d2d2-2a08-4edd-a4c5-6b503e2a9889'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'0bab3635-5ad7-4d30-9de8-78363a508ad0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'0bb3e4f9-af43-43ef-ac08-203a324f8865'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'0bbe7109-89ac-41c9-9495-afc9b9b2889f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'0bd49ba3-0765-4df1-9063-cbaeea7acbb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0bd76b9a-2235-48fb-b3cc-6dd8941e04d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'0be3f88f-1d1d-409e-a556-bf00318e27ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0be5aed7-f3ec-4984-8425-832856a3c05d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0be66e35-93a6-46b5-881b-742d253db79d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0bec07bd-1a3c-4d28-a4d3-c176fa32c08f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0bedd7bb-6740-4e44-8ff5-6fbdf0360b52'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'0bf4d4fe-6431-4d33-9adf-a1d89229fa83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'0bfa350a-0ecb-4f12-9685-eb7a6f4133e7'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Irradiated|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0c00eac6-34eb-4638-b03b-f2fb7c8ce536'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'0c0605cd-edb9-42e2-96d4-9e7abf5af2de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0c08bb0b-8f14-4ee1-b8ad-4232e5a2b8b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0c0fccbf-a89f-424f-8dda-96298336c160'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'0c1089ec-2197-447f-8ef3-6da34b92175e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'0c109b4d-07e4-419f-ba82-b734843f9354'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0c16019a-7df4-444e-a446-3f8e79073c5e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0c1bdefb-75d0-4217-a0bf-a128a2726769'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0c1ebe77-6185-460f-812d-c43c3cb262dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0c22c83f-53dd-4727-bb6e-c27abba6a4f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0c28f203-6333-4ab7-b236-b0ed77c5088d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'0c2ed5bc-4780-4f14-afa3-07b2e06d24db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0c453a5a-dcb5-4cef-b328-74147d7e23b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'0c4617f9-60ce-4d81-9523-6f033162c6d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'0c46ff67-b7c0-4991-8957-572e550e259f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0c4f26e0-ee37-4ed8-87eb-71bf88e43485'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0c51a2de-c67c-4c91-b956-af173d4ab735'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Irradiated|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0c51c51f-0c4f-466b-a12b-57b09d63077b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0c556aec-ab90-4a4c-bb37-39b6d8a0d41e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0c579576-d121-4c28-b6a5-c7c057e84633'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'0c5d316c-a3f3-4a3a-93c9-b93b933fb5eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0c6afcae-4225-4e3c-8088-d3f9f11c772f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0c775437-1741-42fc-95b7-e0dd0fcc9868'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0c7ac9dd-513a-423e-af4c-83e2e134c5f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0c86ae55-4497-46e3-a94d-c157f4fff270'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0c8a7884-d41a-41fb-b421-b0a331cec185'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'0c8b02fd-64bd-4023-b25c-dacc1f1b6b9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0c9222c2-788f-496a-9c51-ecfd23fb6c03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0c99e7bb-d496-4b67-bee5-709de9e0b858'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'0c9ad998-390e-4ec2-a016-64cfdfb0a88a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0ca318d0-6de4-43ef-baaf-8fc46c368ea4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0cb088bd-a195-4b8e-bd5e-af716f5a41e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0cb2bb14-9248-4c96-9aa2-92f5fba02f35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'0cb3e004-e8ba-43ec-8b21-f54a2d99fa9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0cbe7b8e-bc58-4044-bd14-ee28a5b9013d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0cc068d0-fd99-4aff-bbc3-f64b12deafb2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0cc3d421-308b-44b8-9875-9ae23dd552b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0cc635f9-6f2b-4007-b735-3bb4fb87bc30'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0cd1bdd2-9af5-4727-b357-8c658fb42d9a'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|>=400mL<600mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0cd789f1-8a80-4ee4-9fb9-c28954c188da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'0cd8562a-7dd2-4fd1-a2fd-670abdd54d64'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0cdc6f2f-73f1-486a-baa1-426bba659b1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'0cde016b-de20-4cc3-9ddd-795addd57c61'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0ce4afcb-09b6-457c-a32f-368027f66553'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'0ce82e23-43ff-459a-8ef7-a5898b869876'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0ceca12e-30f0-4393-85bb-e757a4c0671b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0cfa6ddf-59ae-4a94-9789-63647e6728ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'0cfbe967-4007-45e0-b3f3-56c858410638'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0cfea8df-8c47-48b2-b8b1-b92f32090cf0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0d0168ef-8cd9-464d-a33a-9300619cbcb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'0d06c25c-538d-4330-83c6-571f75e9cab7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'0d140a4b-4d81-47b9-985d-67caf0227974'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0d1e8052-614e-4252-b169-e70f7cadd075'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'0d294df9-7867-45ce-9461-55ed99e1a475'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0d2f0924-1fc7-4f12-99bb-07562aea1ba6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'0d3aa596-af09-4167-89a5-43d4a6910f45'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'0d3ab82c-b6d5-4ee8-8829-c503515bb548'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'0d41dce1-9160-47e2-b1f6-325efdfcb1c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0d44ba24-d0b2-4625-be70-400b88b43ea0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0d5155b0-16b4-42c7-b5f8-4a441caf85a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'0d522fa6-6e0e-4295-91aa-7a870c879fdd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0d56cfd7-b2f8-4644-ace8-bb3173f26182'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0d5e2a34-4ea0-4fe9-9e81-990e117d5fb2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0d61466e-ad69-4471-88bd-30b1da76e16a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0d6263d5-e37a-4e34-be0c-b063ed21d987'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0d69d205-78f1-40e8-a8f3-296f4a918a1c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0d742a06-62f3-4ee2-a774-d80879beb70e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0d75cd4e-558e-44c4-8b9b-d6173a4e637d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'0d90115f-7e42-4f72-93ab-805bb5c07d51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0d93d8b2-9fc9-4b28-ba85-232832b4df1c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0d9a7c66-3d43-44fd-b54d-c9cee3e02f2f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'0d9faaa6-0b58-4fe7-bcea-f7bd9fc8fe61'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0da40803-8bc8-4eb4-ab3b-fbd63403e15f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0da9364a-74ac-4905-b10e-20be3db33bc8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'0daa94a6-c7bf-4466-a944-eb4a82e9d89e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'0db92d05-b83f-4062-a2ef-454c457ccafe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0dc80a2c-0849-47d8-9224-631d3264c04b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'0dced984-743c-4d00-a055-66d4c401c8e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0de86ed0-4fb7-40b7-8e76-a7b41de8871c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0de9ba23-96d1-4697-b0a7-c6db2023b897'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0deb9544-999d-491d-a674-e174f540bd10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0df8383a-f81f-4d9d-b019-06e272987e33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'0dfa11cb-2a4f-4d38-a4a9-0a74a97365ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E059' WHERE BloodProductGuid=N'0dfe3188-29ea-4689-ae9f-d1cd03105ee1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0e01f324-3981-4407-80e1-24d0b74805c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0e07cd19-f421-47c5-b58b-21c3e6a6e356'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0e0d5477-48a7-4a83-80d8-1b397982bacc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'0e1379db-4c01-4aba-8f20-c4727636f312'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0e1773d6-acd6-4625-8e80-7f6cd93b570f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0e1a822f-20d7-4032-840b-5d22b78c4eae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0e302ba7-176f-4567-982b-f994a7c75e4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'0e314fa7-b8dc-48e7-ad6b-8d8666b7a308'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'0e431d8c-2ce3-4664-b324-654c1dffdf78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0e45dfe4-1bb7-4e17-b371-143879a77eb9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0e4685df-df3b-42d4-a5c4-13b4013e09f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'0e486ea8-9753-4cfc-8951-5986f0ee9181'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'0e51f990-94c9-4e2f-b26b-e88bc11ae188'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0e5572ea-389d-4fb1-85cf-098ebc3a41db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'0e6af11c-db8c-4057-8ead-8249b78867fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'0e704672-1a70-4742-8ff0-ecf151696434'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'0e7398a8-c7a1-4dfc-bfa8-7c0d879ce9c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0e7d5b17-0eb0-40ac-bfc6-fa95fbe3d8fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0e7f3d70-e68e-4fa9-aa39-4c31917ad06c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0e8c2036-3fe3-4664-8c80-9f4c10af5358'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0e93da69-5f89-4e67-b129-739bfb7bc8c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0e9c65cc-30d3-468f-84d9-26c3501c24ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'0e9da76f-e5b2-4a81-a1cc-3baf0dd6660c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0e9e22cd-6bde-43ca-bda9-7a195d9a2e62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0ea2f43a-bfa6-44d4-9086-74180d5c1e0c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0ea4dfcb-3eaa-4d66-a989-1117b485ff2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0ea94c73-f4ad-48a6-9788-38975c633f8e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0eb17a9f-9a1c-4184-8685-2c0bec554f8a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'0eb5c32e-6861-4fae-85bf-df312f632630'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'0eb5f2a4-73f8-472e-b2e9-7372297e880b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'0ebc4cc9-9c24-484e-97de-dd4cafa3c403'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0ebf5df5-b730-4521-9aea-7d0509be02b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'0ec15260-8d96-493e-a3d0-733e193b32a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'0ed13a70-4ad2-420e-a1f6-fe9c8e8228d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0ed2711d-5ff8-4c9f-98d6-15c00a86ac67'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0eddc40d-e6e5-4c65-b085-febef1408c21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0ee71b7e-14ab-496d-be9b-e0aa6ee1bb94'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0f017c49-8605-410f-9f53-e17ae14ae948'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0f0d7505-50e1-4182-b776-be61edcb7728'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'0f16145e-5614-4ddf-b9e0-04b6fb5a0309'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0f163093-1154-45c5-a1b9-ab584749ddef'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-30C|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0f1c906b-97f8-4f34-97ba-fb507838ae24'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0f20e6d5-a096-4c3c-bbfb-1f66bb014c13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0f21f071-4bbc-4a20-a930-84e92e1dfda8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0f293526-fecf-4588-8fb5-e20f04e422b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'0f2b6684-060c-4ab3-b36e-2e6e9b0be71f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'0f2fdce1-fbf9-4201-8b1e-f49e6cd817fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0f3b66e8-3917-4e5a-a700-4e7c9a465adf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'0f3c7a33-0ec4-4b61-8c29-1fd16fe67d61'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0f41cacb-f129-4671-92f7-de8fbe663847'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0f428cd1-eee0-4abd-a2ba-8395b5c5ff2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0f4b303d-7718-42c1-ab77-900f392720bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'0f4f545d-40c5-4714-b0c4-e3aa3748238c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0f52a5c4-3f22-46c7-a691-44704de5fe25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0f623560-6670-4e4f-b5f4-022dc25ba194'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'0f62a3ea-7155-4ed2-a22b-58c99afdfa5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'0f62b616-3e73-4534-a554-872d6f01110b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'0f66b887-0d01-4cbc-ac8d-f4ac1fa49148'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0f6cd25d-0901-4f66-b38d-88a335f8f21c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0f717744-849f-4fdd-84aa-4ec1b34dcfb2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'0f72e970-e1f4-4779-991c-db8661cf5a4a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0f7831a9-9633-47ab-9da8-9b75c3f6287c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'0f7af412-f833-4f46-a0a2-9480721887f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'0f8bec49-8cc6-44d2-b8e7-142002f00eed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'0f8cc761-051d-4d49-b9b3-5ba2df7ce04b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'0f923d51-fa28-4456-a2ff-66d4769edc47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'0f92cfd9-fb7d-4a91-a73f-443f079b3be4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'0f92e35d-ec85-4ac1-9853-df4a96298120'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0f9dc254-4377-446b-af84-b006728f6e9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'0f9fc41d-b6d3-4dae-afa9-f6db2066db10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'0f9fed78-cb06-48d7-b4d4-9fe42a96ab49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'0fb1235e-20a6-492d-8357-87a2f54d0265'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0fb552fc-08d9-40a0-bfd3-b9689557ed38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'0fb7dbc2-d78d-4e4c-9fbd-1a8dee1b08b3'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<=-18C|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'0fc1e452-faee-4b80-94f1-63e718f49814'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0fd3d984-ca8f-419d-afcb-1a6d995fad84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'0fd91893-41db-4c5b-9f8d-0fe49ca26810'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0fda7510-f499-40c2-befe-7b298048b3b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'0fdfd7fc-6dff-4f9b-9799-1d685459b2bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'0fe51e9b-bf73-4191-87e9-eaab17c6af25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'0ff0d154-130d-49ba-85a7-df78df041909'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'0ff344f2-aee2-4dc1-998a-75d0c4b1f6de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'0ffc7b22-a88d-47c8-bdac-331bada066a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'1005cfca-26e5-49bb-b448-11d969640632'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'100b1f53-1bb4-4ac5-92f7-17a1d08fd7a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'100d6e4b-10a0-4ef3-b76d-74e21b5cccf7'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'101a4ee5-b215-48b3-a030-d66f2950cbee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'101f72bd-7661-4d65-b2ce-1c6a56861f1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1021acb8-e9a6-48a7-a886-25030b29eb9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'1029b180-8c26-49f2-803c-6fb4993c454f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'10570291-67fa-4abb-be86-e7153f596dfd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'105c0e5a-ace7-4178-9f05-0298845701ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'10662e01-3661-4297-bf70-134b4a269cf8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'10694d3c-92c8-4f96-a9fd-08a98489face'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'1069bda2-3abc-4030-b5a1-0d6f6ee44d56'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'106beffe-62ff-48b4-8048-dfb3e0248eed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'106dcd58-ecda-4b01-b0a5-cb4e2fc5edfa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'106dfdc6-0b07-4fe7-8e10-f76c977520fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'106e5d7f-b32a-4334-9d1f-863a72c0a6d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'107065fd-dd58-4f54-bf8e-5ec3be9d3fc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1074c283-04ed-4e1b-8b3b-4a1a9ee4d5f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'10770a38-f9d8-4a0c-8202-26dd54c2f825'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1084231c-3b46-49c4-955a-780abfb919e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'10a4bd22-de00-462d-bee9-3708071c5720'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'10a7f760-02e3-451b-93b8-38c13bf287ad'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'10a96980-6e9b-4e41-90fa-3c5074206f36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'10aee4ba-7b07-4eaf-bf77-6a4cbf0b9ca2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'10b45771-a8d8-44a9-95c4-589cd23d3eea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'10c03b50-d631-475e-af1d-08c218d4d796'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'10ca41e6-89f9-4aff-b597-80346c057acb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'10ceadda-948a-4476-9e26-7950fd655c03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'10d18b5f-dc4e-4765-9dd3-82a7b4a7e93e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'10d70eea-c0d5-40d3-a741-6b52b1479a67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'10da8778-8eb6-4679-a5f4-9e41d341ce50'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'10ddb326-5747-410e-a783-912f9b68b286'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'10eed16f-1cd4-4d25-802a-0af1d79887e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E042' WHERE BloodProductGuid=N'11021993-e49d-4c18-af3f-60ef3d2caa25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'110e9fad-810b-4027-91a1-cb52e6d27117'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'11203aa5-b52c-461c-96e0-25dd82a0fa13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1127d9f9-1197-410b-abaf-e4bd89a6cf6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'112eab53-ecdb-4453-af47-a592674f1e1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'113d5aef-435b-48be-a44e-417994e8156c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'11456e2d-bc94-48ef-9710-9aa6fc987386'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1153c645-e13e-4129-8354-0d4bb93436d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'116129f9-ffa7-4a6f-9840-bf8d8ea0e1ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1169610f-2f46-4180-974c-76c1c030b7bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'117368e9-e12e-49d9-9a36-143b10c670c5'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-30C|ResLeu:<1log6|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1180fc0b-de14-4995-bea7-3a6287c2a673'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1182d4dd-9203-4240-84c3-63c62371b847'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Open|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'118372cd-65e9-4992-89f7-c863286f7924'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1186cb05-f876-446f-b288-21e9bd70fdd8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'11880f51-3171-4c38-a0da-f7590bc2419c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'118c89ef-5584-430c-8311-f0b44848671f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'118fc767-a2c2-468f-9b10-b1f85ecf11a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'119e6af5-79ca-477f-b5d3-3b03f6e240c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'11a1fbff-6435-464e-831e-a4f91460f115'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'11a33d78-21a7-4664-8221-4e59de8a8ad9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'11adad87-b981-4151-bb3c-94e72ce66047'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'11b174e9-51e5-4934-85de-90f17f1b2b1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'11b2ad7a-8758-4bf7-a065-6ddd23a22577'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:injectable|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'11b71298-3ba5-4d6c-9001-3b6b688c3d0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'11b84e77-c9e7-4087-9a4e-3e920a87b605'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'11bb33ef-6a0d-46fa-b475-5869ba87ece6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'11c29961-fc12-4362-9a45-0b50e6ff7b47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'11da7f96-b786-4ffb-b363-14e85ab083ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'11dccb58-beb7-4234-8157-5ceff89d8d92'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'11e8a864-29fd-46c9-97af-3a6cfda93d09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'11ec0816-9bf3-4218-9475-81ed8f3dd5cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'12113fe1-c24e-4898-97d7-305d146f3bf9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'121b5dc1-ae15-4742-9887-30db1531cfde'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1228deac-1d8d-415a-8071-41b475cf85e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1231294f-f282-419d-be3a-b8dc2cb3f2e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1233b1ff-69ba-4893-b837-1e015a8a39f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'1236b1a7-e17c-471b-a903-ee10c2767fb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'124cde93-1dbd-4567-a134-f68a7d0f8991'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1256ee6d-5fb6-4f9c-b82d-7687de8307dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'125822f8-de9f-416c-bf0c-58c071e8ac65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'125938c7-48fe-482f-888e-37941521b72f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'12602933-01d4-4054-8313-641ab8b31f13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'12662cc6-c9fd-40f2-a374-53543c811565'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'12685691-6d32-4cee-8b7c-f34038783682'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1270de73-1056-4cb8-93a6-d6b347ecfe68'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'12748001-3571-439f-b545-e32d014cdfca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'12784e86-667d-4e60-8484-db2d20e2939d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'127b328c-0a03-4b80-87cf-a5ce47a56391'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'127fa837-932f-4fd8-a18a-099d7f7ab3bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'1282309b-99b2-4e6d-a70e-80371658213b'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Open|>=200mL<400mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1286007c-1c25-475b-bfec-30cca21037c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'128c3c27-c074-413b-a6bd-05a895fcc859'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'128c6546-f7c6-4d3c-ba55-2fbe6206f2f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'128fff9a-9887-4a4c-a7bc-1883ecb224f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'12937886-3b3e-4bdb-8e5b-c4886e6000fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'129dac10-5e62-45a8-b66b-54b14b89f451'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'129e675d-321f-43de-9d58-1dd6f3135646'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'12a04836-2e21-48c6-997f-18f3ea906c03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'12a2b1c6-b972-428d-a761-086c50aad3a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'12a84d9b-d70f-4001-8148-a5da9cf09200'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'12a941fc-8d48-499b-b886-ca375088faff'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'12b6f813-4562-4122-9a89-a0a8cb7bbd9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'12c0f2fc-01e1-4999-9a04-6d31829fb3e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'12c398f0-a74e-45a9-9b41-6b6ed8f99b31'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'12c47211-3748-4864-aa1e-88d2b45150ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'12c4f839-ea94-427a-9b82-9ad4c4e34e8a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'12c996c2-4f05-439d-b159-7d89143c5c33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'12cbe42c-0683-40e4-ade2-abbdaac24902'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'12d096f6-38ac-4eba-a6f9-778c39b83199'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'12d1c37f-2fca-46c5-bbe2-1c2fa30d066c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'12d83109-60de-4782-a2d1-4ebb0c48974f'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Open|Irradiated|>=200mL<400mL|Aphr not automated|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'12dc317a-6861-4ece-81fc-342273c1c192'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'12ed4920-33f5-436a-bcef-4103786f2f93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'12f0262b-837d-4f7e-a55e-1c01cf957db1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'12fa3539-8dde-4e5c-9961-866f3ee4a8ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'1306c9b1-feac-4074-b386-a1ded47d0949'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'130761d9-b4d7-4d26-adf0-102130211394'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'1316279e-7ec4-4a1a-8998-226f42c908fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'13177e20-72d1-4948-921d-1b9d1dd8213b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'131a84f9-aeb2-479a-bae8-d8df792e06d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'132e9cb3-6755-4d25-8b97-ff4b060b8f9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'13320291-4e07-495c-bbc1-080b69d0cb0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'13490ada-9f15-4899-b86c-83b85f95de3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'13497da0-9676-40cf-8217-5d474a99e515'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'134a8fb0-b996-48f5-9008-0f40ec940944'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'134d406d-a1a9-4f3c-bbcb-c671ae8fedc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1351032f-2f89-43f1-87e0-ace8c8265240'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'135da8d2-2ac9-4b0b-9531-87962f30c5c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'13660bdf-39dd-433e-9a04-a853fcc12856'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'1369293e-e39f-4a43-ae53-403eeb0a4672'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'136e7765-915f-4717-8246-db3069c464f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'13743654-83ef-496e-8741-37bc62510d92'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'13845ce8-3482-4f72-9fb5-db65baed9c7e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'138bc1b4-55a4-42a3-986f-1189e7b5db0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1394604d-90a6-4a30-b4e2-c4a6fc91bd37'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'139c76cd-60c2-4f70-993c-935e263ef774'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'13a50535-a8ee-4f82-84f4-4810bfacf89c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'13aaae53-bbb5-44e1-a70a-75ad092752bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'13b1b4f6-0a9a-4eda-a82d-d25ab1f1ab2b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'13b3791c-dda3-4c5f-ac97-b0d1a75b821b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'13b61f93-eab2-42db-94d9-364009636d4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'13b67ec8-6409-4f42-920b-8154461d3784'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'13dc22a6-3688-4452-9c67-d211575b7926'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'13dcf356-51b9-42e5-82a0-f436a9ac2c04'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'13e24cfa-03d3-4a7a-a3bb-1dfcc44bca51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'13f4bcca-2785-47b7-bca8-3f9997bbf369'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'13f910b3-ff97-4060-9024-7c03eae6fa7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'13f9475c-31d8-443a-84ef-47ed8c36a933'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'140482a8-b86e-4915-b07b-ce67bf8ac948'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'14085b86-7a72-4f94-b11c-66686f7fccdb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'140b757a-ae2d-4dc8-a73c-0d4b473e755f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'140d2357-e5a0-448d-b07f-54fb147afd33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'1412cbc9-696d-4b30-bd56-9f860130ef5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'14145c44-c723-4628-b70d-cc9ecb00e931'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'14182210-e040-4817-b534-33bdef54044b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'141b8688-7713-4d1c-a88a-648ee0778c8a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'141c88ff-d3fe-40d1-a7af-51566cfa4c05'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'141f86d4-dd4e-49d3-bfe5-81a6870ba114'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1423512e-993b-44b8-90e6-2f2db0f9f22f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'142b0bdf-aeeb-4a55-9092-663967bf0825'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'142b2100-b597-4836-8575-c4019934693d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'142e344e-10cd-44e6-8b92-7123ad5dd30f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'144358b8-5679-492b-baef-62a81cee8c52'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'144cff86-221f-49c2-8b4d-4bbe09923600'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'144f5054-b488-473c-b81d-efcb1b94bfaf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1451ade4-f03a-4ce9-9d3c-8d76905ddcd3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1453f4cb-186e-48c9-bbfe-6d8caff4b8a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1465749a-2e6c-4d23-a056-e63362f93d62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'1468527f-ae09-4ef5-af0b-7bbe405b0a17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'14709128-474c-4dcd-8921-59555c791f54'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'14712109-8165-4662-82f9-4e0f854fc062'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1477854e-e5d1-46cb-8a16-e23bbd066a2b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'147a8023-4b3f-4189-8b1d-1e9e760e97ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'14836aa0-8482-4f03-8b19-7fe8bb404d33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'148416c2-9fd2-4680-a1fc-9c6ae73e1fff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'149a0955-b74a-4152-93d9-dfe5fdf52f81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'14a0cfd5-0984-4996-babc-b37884459ced'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'14a18236-3dd1-4f39-a466-6de509961115'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'14a6c63f-fbe9-42c8-a3a9-ac54cbbc3209'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'14ad8704-b28c-48b7-8100-94679f0a520f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'14c0949f-36f1-4a55-b7d2-b22358003c6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'14c71561-6bfb-4a7c-84d7-f2029315f9d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'14c8405c-289e-4aba-9b84-201ba36863b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'14cfd2ea-175f-4dd2-af19-68bc3f8e4e05'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'14d7b56c-3950-47b3-b4ee-b14052039488'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'14e12946-970d-467d-bcd6-d26c901d1914'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'14e25e74-9072-4de2-bec8-0ce48d2a112d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'14ea9d61-8709-4483-bdd8-7888eaf398b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'14eb34b2-0b46-4b5f-8fb6-7d5b55f93b0e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'14ef23eb-7dc7-40b7-b694-3d5e3988bb6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'15019b6a-e81f-4b52-bc71-a5d0507acf0e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'1513facd-b916-4ba2-9d15-fa7de8a11eb6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'15203cd9-f8c3-41e3-8217-8b257410d89b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'1523ec67-808c-402d-bdb3-dad5f99cf558'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'15245415-6e28-469c-a099-aaa8f8fa620a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'15264baa-0131-406b-8d9f-090706733c9f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1527529a-c817-47c1-b078-27bb32cd64d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1530131f-28a6-4f6a-83d8-889347d645b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1534098f-1f73-45fe-b4f7-12ceed598c38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'15364fb7-1de5-40e1-9be8-1320d74f3e7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'153749db-e2d2-45d8-b69f-ef2c0d1ff85b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'153a3ad0-a746-430b-ab24-05ffda814e57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'153fac62-e379-4394-acbc-c8ff16ae5f41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1549ef0e-df5e-4c0b-bd6d-2c91c3386c95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'154a65c1-2b14-4aac-9f1a-0dbc1fc6f729'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1556c1da-1c63-4b00-b289-e05410ec6020'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'15595545-beea-4af8-ba34-ea1842608ddd'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Irradiated|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'155fd515-7c17-46ed-ad28-f4755b871528'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'1566e03d-dcf5-4104-af51-4ffb23ab7280'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'157416a3-a621-473c-8fbb-a2f282515e9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'157562f1-a41d-4671-a49e-ccef4d0f6ea6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'1576872e-6815-410a-8999-d6fbe9ea03b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'157a5a72-df41-4a33-bf86-593a3f69aa90'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'158e442f-f2de-4f5a-984b-545d3c20908b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'15a4574d-3bcf-496c-973c-3c4934633429'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'15a61afc-fa3c-407f-806e-a62838867e22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'15b0fc06-5d69-4311-9f75-5ed9ebb19bdb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'15b9f538-00ae-4458-976d-5dfd24a0a04c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'15ba9b18-8db3-4033-9381-250b664c3080'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'15c30eec-c013-4c19-8edc-0c17d2c54d81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'15c6c05e-bb42-4377-acd8-40ad90f8e8a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'15c940e3-3b3b-41e2-9774-a161937d2c7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'15cac4be-17a7-40d7-9a97-b6d0143c719a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'15caf660-d200-4632-b1f0-54586322f851'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'15ce561f-16b8-4479-b4f3-8a4a7d5866bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'15d2b2a0-6338-4cda-9d4b-14617307c689'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'15d92428-a035-43f5-b934-6031f6e1d94c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'15e099bb-c7d4-439d-bcb0-0945ae3bc894'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'15e64de6-1b6a-411a-9908-931f6dfa276f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'15e68013-6150-473a-bbad-ea22782818fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'15efec38-f1f6-4a18-bd32-69be1b83bdf5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'15fa5e3e-42a8-40db-9ccf-076a94694dd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'15fde0ca-1fea-4c8f-b651-8f4aa2044eea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'16005729-f9ed-458c-8a01-614632d339a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'16025c93-db0e-4fdc-a6c1-0f8dd3b79547'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1613278b-19cd-4bd2-b1a6-588194ed63f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'1613a542-3c9d-424a-bb4c-8f2f8b4c461f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'1617270a-384e-4fb4-86cb-c2228677c430'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'162135fe-945d-475e-a035-292d0d15159e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'1623591d-b1d6-4c07-b70f-6b30c4088be2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'162b86d6-7e1f-4696-8501-9717e7af3e99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1633c52e-fc08-40b0-8fe3-7659e6f5522a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'163f7ee1-0d2f-4648-9fcb-8abdffc53e9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'16532084-5a3b-4582-9556-85fcd73631b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'165ed9c1-30fc-4d9e-9448-6515d8b1b235'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'165ee53d-d6d8-4a75-848a-0ac7ca5ba240'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'166c7e31-2ef5-4976-afac-ecdf106eda02'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'1677b553-9b63-4d00-bd4b-06498c4d98f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'167edfe5-8bb8-4723-b315-bf6e38d6ced2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1683068f-d685-411e-93ae-d988e1458dd0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1686f075-54e7-4153-89df-0af3def3a7be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1695a9de-1287-4ee6-b769-91d83c8f25ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'169e9697-944c-4da7-8b9b-24cde965e66b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'16a2f7c9-ac4c-4629-9883-7f35188495a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'16b34bda-eafb-44a1-b487-f9e877360164'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'16c49236-f508-4758-a17a-164d7c7ce3a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'16d0cbf2-f22e-4b9b-b403-57fcfa60223c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'16d5ca2e-560d-4599-9e12-3d47cc9f020b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'16d74f5b-6e99-4bc4-a918-3cbb5034682e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'16e9e105-6069-40c2-9630-8c0ead8cd2af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'16f5f371-a010-4c4b-9f96-b0aa9543d3d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1701296a-7c0a-47ef-bae1-f946f8cc3d81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'1706bdad-c348-432f-98fd-01bf93098cf3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'170b70a3-eb66-495e-9f98-344015aed97b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'170ec478-3a74-478f-8413-801d270f9a42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'17150488-1e0f-4635-b55b-1d87a39f5df3'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<=-18C|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'17197e8f-14f3-4e7d-b21d-6921ce3ad31e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'1724cd05-e32e-4309-9771-e3cf5b7d38ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'172be15d-423b-40e4-949f-52f5ce77e290'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'174ff07f-19e1-4ee2-a0e5-a6033e0e90ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1757e914-d4ef-4595-ac76-02e05f6e0b56'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'175b6950-ee05-47a8-b1a6-0d26630fff6e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'175cffd7-b7eb-4d9a-b95a-1f74688a01e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'17618b58-088b-4dcc-9fe1-41fcf70c7584'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'176389f4-dbd1-4b68-b3d7-80e713dce584'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'17661417-1e43-4e77-ab0b-48aa6399468e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1778ab67-ade9-431a-9efe-27c3463e085d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'1780b055-a91d-4499-8173-7c58664d6c68'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'1781c6c6-a280-4ad1-b7a3-01aa1de349af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'17861d3d-172e-45b0-af14-7571c7e50782'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'17934872-29a4-4cd5-a723-541230a159a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'17965621-fcc3-4ba7-9119-56e8ed38a7c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'17a9d4ae-b361-4ca1-b7ba-727ff8bd2abf'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:noninjectable|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'17b2006a-e7d3-47ac-8aed-d5ae3c2a4dbc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'17b528fc-331c-4cfb-8b42-f2e47dd40116'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'17b57ef9-9c29-40f2-87bc-3b6ec543898b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'17b6632d-d964-4d6d-9beb-590c015e92fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'17bea483-61fb-461e-b361-13744a506ecd'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Not for tx or mnf|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'17c38809-9f76-4144-b40d-48b845be6178'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'17c52a68-bc55-47ab-b9ed-c08853672534'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'17d15417-5b0d-4f80-895c-2e169349ca74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'17db7a9b-63ef-44de-a1a1-0ac02ad5dc43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'17dba687-dec0-45d5-af28-2676c5b1b293'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'17dcf926-32f3-46e5-b4d3-f1f045397181'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'17e2d30b-45fd-476c-a05f-97dfcb3a6b80'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'17ee8ef1-5cba-4116-a499-8afcc0313748'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'18002e5f-a595-4f50-b0f7-0f086ce5b20b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'1801b881-7672-4262-9738-29bf2d845c40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'180279f3-cd82-4007-af97-282a07de3245'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'1802bff1-fd0c-4f86-897d-4398ce122967'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'18063190-1b8f-44e3-a478-cd166afc810c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1814bc7c-db29-4c17-8fc1-d51bc43a30bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'18155b78-1915-40af-9e44-2f854e3fe8c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'182333bb-d3b5-43bc-b931-ca42764840bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1824943e-5495-4408-b155-50e0341eb4c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1845103c-c1b7-406f-b6ee-90883d542aa6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1857167d-0a9b-4947-8f85-f03aaddac34b'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:injectable|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'185a7aee-11ef-4faf-8d91-cc0adafe18d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'185e4d28-6bfc-4a12-b387-ceb6251786f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'186fbc0a-b504-473c-9d88-d142736ef2cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'18707ffd-9f86-4c58-902a-28714c2e71d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1873731a-d162-4232-925b-0a2686ad0459'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'18748511-e9ae-4174-a061-3569378fd146'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'18776dbc-cce7-4c81-ba45-09fa4815f6f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'187de9d3-f034-4dbe-a4ac-a23410d19db0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'187f207d-ea36-4b76-960c-cd586ecf3868'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'187f5c23-b669-4daa-b31e-28a3f6073e4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'188042c1-614d-4778-9e34-314b004873f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1880ab92-0d77-46b2-a9ca-6f11c3db7df8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'18897727-3357-4de4-880f-3ebcfdad8813'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'188c0162-35a0-4e79-8998-0258bd6d5053'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'188f0149-794a-4468-a3ee-6fccf7cb62ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'18989835-bdc7-400f-ae4a-649ccb8bdf8d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'189951ac-b636-40d2-9e9b-c6f77e0661ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'189cbb8b-8af3-49b1-98c4-12049a2d2465'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'189dd813-e848-4590-a836-0722c89e824c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'18a00594-1d1c-44b8-933a-c0ad83f8224a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'18ac9930-e6a9-456f-a095-e595e96029f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'18b12f0a-9a97-459e-bb3b-1627c6c4fcb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'18ba6405-7cff-4c6d-998b-9cd2e6fb5832'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'18c0c935-b4b9-49db-83d9-095d42f89906'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'18c242c0-f629-4e26-a318-520d1f2feaed'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'18c6a4bb-c794-4c5c-8e9a-2281e177a525'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'18d33287-f04b-44fe-bd74-98efa0a82363'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'18d64d1d-4b49-4fd2-9d7a-025d0d38f771'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'18d989dc-62e6-4826-8be1-84abef46ab20'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'18dd8541-3f55-461b-bcca-157fcf52eba3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'18e27f36-917d-4fa8-820d-473afbd8ad7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'18e58726-81d4-4e75-8af4-5d7bd4513de2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'18e854dd-5b99-4617-b358-37e479e63803'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'18eadc43-64a2-47c3-bcbf-c9ab8b2296fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'18eb955c-5825-4bb3-b28a-eb276a05d2b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'18f1a6b1-b75b-4117-81f0-32416dcbd117'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'19053c2c-5d95-4cb0-a2f1-b525f097807d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'190dc063-7059-4394-8810-b99978097912'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'19168b9b-2b06-473a-9b3e-b628d15b2fe5'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1918a394-9558-4332-92c8-baa055d20605'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'191bdf33-520c-41fa-8112-f75230b1010a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'191f633a-f1dd-453f-8baa-b10f0fafcba8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1921b85b-59ee-49d1-b19a-f7cbba6d901f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1934d668-7562-4b01-ac02-dbe0ab1f562b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1934f194-86a1-4b42-a0e0-2de743c0cd39'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'193e1e77-0ece-4729-9e03-3a713edbf1dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'195c1032-be19-4459-9f59-00d639997b50'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'19608e36-b440-4576-92b1-12dae4076643'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'19759eea-31a1-46bb-a757-c382fc7c97cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1986d9cc-7b8d-4d5d-9f1c-cfc329a0c256'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'198d0929-2a42-46f7-b841-dd0b863329c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'19a5c5cd-c58b-4981-bc68-2c93422d67a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'19a8a7ad-6e36-4c8f-8a90-39c49cdb5511'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'19a8e320-a13d-4fa6-a821-7dc3bc2d081a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'19a94be8-0c7d-4266-b137-b5c70b44bf1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'19b34d33-ada9-41e0-b8ff-38d790a42238'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Buffy coat plts prep|Approx 120 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'19b6cc5b-4cca-4853-b9e9-67c7334ebb32'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'19b7b417-d315-4aba-ab33-a527a9c4a0dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'19bf0893-0468-4385-8c95-96a1f758b815'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'19c2084f-8b52-46fc-a77e-3284f47df59e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'19c49ace-c1bb-4edc-bc4b-01e653771bec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'19c80719-5397-4bee-9e05-607c79434127'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'19d19b7c-1114-4b08-8c13-22b934ddfac9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'19d23a91-718f-49a4-bd65-09700529481c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'19d642c6-9352-48cd-ac36-c482b66cbdbf'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'19d94820-0c21-4b72-920c-3b1bcda8cc82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'19d9b00c-1899-4026-b0e6-b699e0ff0fce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'19db2d42-b44b-4e56-9bf2-5e9b61631c7e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'19dba38c-ca46-422e-831e-4435d673cef0'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'19dc8bff-27b5-4307-9973-775379e443d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'19dde730-e01f-4299-9d2d-2ef13cae464d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'19ea31d8-a00b-4ceb-aecd-e123842fb167'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'19f5a7dc-eb59-4238-9cda-ed06618cc93a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'19f8f4c8-db58-4467-9aa0-f7a25a017e3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'19f96430-398b-449e-bd31-2466683e32f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1a00309c-10ae-40ab-806e-2b2fab7a2ddd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1a01f8a7-1623-436f-9700-fcefc5a518cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1a057c2d-55b0-4c58-9a7b-ac1cdee3ce0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1a0afa4d-b338-4538-a0ba-669c3920c044'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'1a0d467c-eaad-4c80-a002-92fd8944ddea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'1a0fce37-dc57-49f6-a01b-eb219df6a735'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1a0ff05f-c820-4c33-b80e-69e11361581b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1a11fa21-498c-4c89-b291-c98044bf52e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1a299e7e-3a8a-48fe-ac14-13e0f0bf2fc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1a2b8832-313e-4083-9a38-c2e71ff70cce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1a2c03ea-d2e9-4a74-a7b7-f398d2100cf5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1a47c66c-a8ee-4d4d-bf99-5e25b2a5f000'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'1a48c53a-1d39-4398-87f6-6a6ff2661561'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1a4f67f8-cc2c-4827-a7fb-ff7e79dae509'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'1a511302-f948-409a-a692-46d50f529dfe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1a54a4c5-6185-4657-994d-36c0a2abc989'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1a5ec54a-a544-47e7-87fa-bfd67c9fcd3d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1a689663-84b6-4db2-af59-c26c0fa8f0a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'1a6b2943-d2d2-4a8a-8d5e-ee0783d77abf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1a7afe2b-68e0-4c54-8c6d-67448720dc00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'1a8bd7c6-a9da-4f9e-9d9f-8774031a713a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1a94c496-e406-4f70-bae9-a3e0e00cef4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1a99ef48-d03b-4c96-aa93-d29ae6bab0ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'1a9f2fce-ee71-41e6-81c0-707b194d3dff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1aa385d1-8bbf-4c32-847e-ce5d256d215c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1aa46ea4-d721-4713-b08b-deaeb8b6007b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'1aac7056-42dd-41b7-ae10-dfad7bcf851f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1ac9c26e-a2ab-43a9-92e2-a378e39d71c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'1ad4e417-a684-47bc-8efa-f9e90f49959f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'1ad64285-6f21-4f32-bf0f-7575410408df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1ad8b1c1-3290-40f1-b238-c829cdc10c0c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'1ad8bb20-d3f2-442b-8248-07943467c3b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1ad8f5d4-66ad-435e-b533-4b1932618bf6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1ad9a12a-cabb-46f0-8c49-c319b1d030a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1aedab22-eaca-4cc6-9caf-4a0a246f05d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1af2564c-9c6f-48f9-a68b-26f5d18dec62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'1b06194d-e258-4eb8-8e10-8ef631232e89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1b07471a-8b08-4fad-9081-c315f4153e62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1b0c6bbc-2bc0-4208-b301-280b70bdafa5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1b0c76b0-1ecd-4028-891b-4257f7d535ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1b15c401-5fa1-4656-a392-32f1e5241dc0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'1b173789-1ac5-40af-8c39-cfbcbd564dc2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'1b31c430-30d6-4a73-bd78-b4f68714e291'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1b375171-819b-459a-b73e-04cb3eb0526f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'1b3a7a38-7065-44d8-8257-8abadbe971a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1b5a3355-17d8-4406-979c-e7293875538a'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Irradiated|ResLeu:<1log6|Plasma reduced|Buffy coat plts prep|Approx 120 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1b5edff7-c219-4737-bae4-3ba59b41481d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'1b62b663-9c74-4004-8427-5dc07c1d6e7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'1b74e432-800d-40dd-896d-96861dce53f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1b773c57-7f50-4c6a-8470-2b63a2d71fa8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1b777e04-2871-4f8e-a325-75cb2fc2779e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'1b7c98e2-dc9a-475f-8bf3-544df97dba27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1b895047-8656-43f3-9bdf-b43baa9a7af0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'1b8acc66-eada-4165-8edc-06eda8cff282'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1b8b3739-b013-4ad1-b418-674d1c1632dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1b925a6c-7a71-4438-9a99-3b717d301651'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'1b9d1bbb-fb85-468d-aa7e-8f6998ed8a00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1baa8f36-7e18-4e29-a739-fe6eccdc3731'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1bb4a9c3-118f-4d48-a020-78191277ca01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1bbe6c2c-d34e-47f2-a1af-f21faaf22341'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1bc064c4-2e55-43ac-986e-a164f61b2d5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1bcf9810-a128-441e-b5e6-880f5b18ab5c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1bd788b6-f0d8-4399-943c-5740f76dea1f'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Open|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1bd966c6-554d-4731-ac7b-42ef570a7035'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1be36d09-b8ef-4417-86b8-691f5d5a64fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1be3c602-ba30-43cf-bf3f-ee076b70fb73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'1bedcb65-35f2-478a-9624-36f55334d30d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1bfa0866-56b4-46ff-9392-3983a33c67e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'1c00cfa9-7d16-4660-a013-6c9b5fac524f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'1c02b117-d6a5-4853-850b-31b9328d5578'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1c07c676-97a2-412a-9ca1-ca8a01c9920b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'1c07ed49-fcbd-4495-8b1f-a50cacf79b7a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1c153172-9fe6-4942-b1fb-2eb0a3b9b11b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1c1b1cf7-d4b8-4ac1-a86b-d61f6319f822'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'1c22449c-a4a2-4338-a67c-156c822c0780'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1c2b9664-db31-4e07-ab10-6b0ffb6808ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'1c2c226b-da1b-4155-ab73-1f4c5f26bf51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1c2f9773-2b50-4c5c-bcde-5b9a1e4234d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'1c319017-8f94-480b-855b-23378537e9ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'1c3372ec-8ce8-4e52-80db-06161cc023ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1c403e17-c721-4e9f-bb05-d3dc8761c5cb'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1c46d305-2ece-4ab3-b195-9ae1a604d5a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1c4ab25e-6cf3-45a8-9b7f-acb265685685'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1c52a550-6703-48ed-8aa1-bd3c3a91ce96'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'1c552948-0c72-48bd-bf63-a065443556e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1c56d0ff-1859-4570-8e77-ee77de5c0d28'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Open|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1c638525-1ea1-43a7-a9a7-9039cadad954'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'1c6b0717-33b0-4acf-9a7e-1874728aa3f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1c743bec-73f5-4ffb-b9d4-5c1d048a06b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'1c7a3056-5e3a-4b52-b886-524e0b2b1e35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1c88bc82-73c7-4c25-b31c-334a72c0fbfd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'1c8eccab-27e8-4830-98f4-a5ef7ad1210d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1c94be0c-3a0b-49de-ad2e-c973b45e818a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1c99d9b9-cc9e-4cdb-b43f-5a7c2762cbb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'1c9c4244-d81b-42a4-8f26-d44f23ce96e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'1ca44259-a088-4be1-95e1-12794214065a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1ca7cabd-acf3-4847-ab41-7d41d9c757a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1cb1a4c6-66e1-467d-aca0-ceb866548f80'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'1cb2826d-8c55-461b-98e0-d4d61eac82e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1cb55c2e-02dc-41c1-aee1-1e620f5b1ca9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1cc3029a-571f-460c-86b5-cc0adc9fb887'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1cc384ed-52d2-43c9-92c5-49b95cf809a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1cd02088-0ba7-46c5-bd52-fef80ed93f7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1cd29dd4-d6c6-476b-bbbe-eb9a477af367'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1cd4d04b-cfde-4fa4-9a95-fbd2490fd477'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1cdce61d-e2de-4dab-a823-52f3a6268116'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'1cddb6f0-b830-4eba-8844-ff59748401d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1ce1ec0d-f53a-4cc4-8d5d-d8d8e13e424c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1ce680ec-290d-4a0f-b224-176daa50bd40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E056' WHERE BloodProductGuid=N'1ce86b88-361e-4fdb-b99e-601147e95f61'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1cf1e5d7-dc03-44ed-b72f-66a4ba4a2fdd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'1cfbd720-57c2-411b-8a85-4e227a667405'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'1d052c80-e0c6-43e2-8c21-27aac9c582fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1d1021b3-36d6-49e0-8164-8f47e9cdc3eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'1d12984e-1d76-467a-b8b5-0e69700de08e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1d170951-db9e-4b9c-b6ad-61e01076691b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1d19296b-cfad-4b55-a0dc-7806e07b8786'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1d1b2263-fc16-4258-b20e-108744a86386'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1d1f2c3b-2f2c-4545-9c92-537b3cf3bfb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1d2323cb-d78c-41e5-8295-e3d2a7059009'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1d28e28b-21e2-4558-b251-c61749941853'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'1d29c602-6073-4c4a-84c1-2b58099cea98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1d37bd16-083c-4ec6-9089-7405be1b783b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'1d3a485e-c89e-4ebd-ad4d-1d9e114533f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1d3ca635-9027-4e86-8354-40eeecb1b01e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1d3f6443-0f93-44f9-beb3-182526cc5778'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1d428224-ce79-4a53-8846-70ac61aec25d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1d49e35f-403d-4bb8-8c05-f000a0c556db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1d4bf086-ecb4-4c7b-a26a-cf54ba0fad17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1d4d76dd-2816-4a57-b1e4-b1906e6e7307'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'1d54f9e7-b104-462a-b437-c856830d018b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'1d661b24-cfaa-4750-ad59-af1109597462'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'1d704d13-1e01-4651-b919-81983a1f1b36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'1d70de6c-50bf-41af-99f2-6ad7734b010d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'1d71ac20-8946-42f0-88ae-904b586b5b28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1d71d92e-0e36-4d5d-ad6d-896c68b8d012'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1d875474-077f-441d-a262-0658820a6503'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1d8d7eb8-2314-48c7-b971-392f6ee1c1ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1d9124aa-356d-4b15-99d2-2a6358f8fbb9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'1d95880f-42ed-43a9-9375-c6b603a8cedb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1d961d1b-895b-4880-9754-ea8fc875c8d7'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Irradiated|Plasma reduced|Buffy coat plts prep|Approx 180 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1da05e6d-4b35-4323-a84e-889c60de98f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1da25fc3-c4ff-4b3a-8956-e35e0ceaabe2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1db316aa-670d-475a-950f-a45b4cc51faa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1dc0895d-4a00-4858-a9fd-c3daa3233415'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1dc43e38-d636-4bb3-9e2e-d5ef88b927d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E046' WHERE BloodProductGuid=N'1dc523b4-5306-4e58-abc2-5c2e8a5c23b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1dc60a8e-3b55-48a2-bbb6-c1062172c2bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'1dc7c9c5-572d-467d-9be6-e4296ee45bd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1dd0a140-3810-4860-ab03-eee4ee4ae965'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1dd377f9-2b33-4fc8-95ab-acab123ad519'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'1dd4a35e-971f-4e9a-b55f-66ad0ac2122c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1de1a884-9a90-4c27-b44b-13b94c90e05a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'1deaed29-91f2-47fd-a0fb-7c6c981d1ab7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1dec6bdc-d87b-4e85-ad23-78c67d7ffe36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1df2a294-04ef-48b0-8f6a-934200b2af26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1dfa73a8-c7fc-4598-8725-98352ddfe25f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1dfb7d75-21cb-4ed5-a5ec-9fc00999bbe2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1e044d5b-6c4b-46ae-b2b2-eb9b704947e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1e057ad3-10e8-4702-96ee-0ea4acc15075'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'1e0677cc-fcfd-41b4-8b5b-a70883c78e8d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1e06b18d-f9e9-4fcc-b21a-a7ff6c68e8ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'1e198730-e33f-4e98-8287-2c04d527a6f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'1e1cd46e-e827-421a-9c0e-415c9635f71c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1e1f5aa8-90f9-4d47-8101-b0941dd9e085'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'1e2a8f02-73ff-425b-a8e5-c92842fce3f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1e2f7670-8d02-4370-ac69-9669f0abecd3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1e707147-2dfc-4a4e-8064-fd640c5149ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'1e70f3be-84b6-44b3-81f8-20bd7c36170c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1e7219f5-0715-44fe-9081-588d8e22db82'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1e72708c-58ef-405f-a5e2-43b9c22a973b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1e819c13-062b-4299-859c-769001d26a8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1e895d2c-236f-47c5-a39d-62b0f3d013fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'1e90c2cd-3dd7-4b03-b51b-fc6e56ebaf78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'1e9aa382-15fc-41d4-ab75-b1c454debc30'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1e9b6f83-b66d-4a3e-877a-09e9180650e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1ea684d9-6036-4610-a6b1-9112cc87f67d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1ea97638-7572-42d7-803d-69bebe0d83f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1eac9efe-4887-4032-81a2-9aa54a114eaa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1eb3ca82-9d91-4933-a2df-f7705323734a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'1eb9091e-4b64-45cd-923c-5b7e7657bc9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'1eba7055-c448-4c18-b2ad-2c86c822ad15'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'1ec781d2-be49-44d2-8323-485fc7866fe0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1ed08951-e1bc-4936-afcc-de13e323d68d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1ee47702-f5d4-4c39-b652-f1502ecc8822'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'1ee651d4-e689-4d99-895d-63bf050caeb6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'1eeae06d-4661-4209-9049-41d2b583987d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'1ef36612-14c6-45f1-b5c9-ce25949524d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1ef6823a-4a89-4629-befc-1f38cf1d8cea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1efebe6d-3dd5-4907-a16d-a365d3d339b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1effcfb4-672a-4472-b7a4-34963d0682f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1f00433b-f1f8-49ca-8038-4e7deeea7423'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'1f0107ba-0e15-4f32-8bda-f2a76a20514d'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1f02bc07-616f-4257-a607-c50f648a2118'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1f033121-3109-4d28-8af6-446536936a13'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|>=400mL<600mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1f04fca0-4d4d-4fe9-9b29-ad6606686ef0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1f0c073e-be52-46af-b059-cf012ef8e0fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1f1418eb-c616-4ad5-9e4a-10efaf6a9995'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'1f16d211-c0f1-4f6f-bc6f-99e49446596d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1f18c1b1-5985-4a36-9f8f-cc25053a03ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'1f1a158c-a90c-412e-b820-75b6b6a5c1da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E032' WHERE BloodProductGuid=N'1f1f8df8-b6de-444e-a456-5fe1c666fa08'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'1f1fda47-186f-4702-920c-16cbd7443978'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1f257943-f5e8-414c-be7e-45d68a4ef467'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'1f2f4590-7952-42a1-bbd0-1273904b5790'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1f30cf34-aca3-4da5-bb02-406fd5c935c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1f315270-dc7e-42e5-9048-254872fe8a6c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'1f34aed4-ad04-4ec7-998c-6812542f37e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'1f469d90-758e-4815-a48a-b84a71ab0fa6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1f4eef07-4e00-4a90-843c-6086247aa2b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1f4ffa2b-e288-4148-925d-159bbbe3b358'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'1f5143d7-c111-4447-9114-6f618e62fe0c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1f5598de-5f30-4051-9a5d-6be2be4cb890'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1f592a2c-c21b-4f26-a7ab-3060e6232363'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'1f59c73f-df23-40d6-b508-e4a281db8ca9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1f5b0b08-a976-412f-954e-6523a726e8f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1f6a022c-c2a0-4b39-a8c7-5f8c26214dca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1f6b9781-1673-4bab-b8b5-bb88a1f10030'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'1f7074a0-07f4-404c-bbbd-fa1e6c8f7412'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1f761eda-cafc-4dfc-abec-3c5caddcba9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'1f76a1a6-aa67-400f-a532-9fadb30f2584'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'1f7f1344-b868-4afc-9c04-63c900d5f645'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1f8e93e4-5ad0-4d61-9968-e08e5ec937f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'1f95d882-48c0-4697-b3b2-9736894be7ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'1f9d2a98-965b-42b6-935c-9d62e311f396'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'1f9e39d7-e229-4882-b4e3-d58ee5a00ef1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'1f9ec33b-96b2-4045-a3be-560d0dc43df2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'1fd842a3-7aa6-4b50-b7b3-f528f2bd83bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'1fd99b1e-74cd-430e-8cb2-c3cd3b83ec7f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1fda0674-f85f-4b8b-879f-6dfc84cf55f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'1fda9449-1ef1-4624-aa4f-b6fd8d15fbe6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'1fe050b2-2415-458b-a096-ff92c829d876'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'1ff56862-03e9-491c-bc79-eeabb0868c70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'20003ffb-2cae-4b70-b479-d9512c28bd43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'2005cb12-112c-42e2-aebc-e4ae3fbc348e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'200ee710-5f9f-4518-8205-4af242bf7942'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'200f3f20-7b91-437b-951c-f553096a52b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'20158901-62dc-48bc-aa18-b0b63a0c4e19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'20268976-13ac-411a-b323-1bb998cbd237'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'2029b67a-def4-48c0-8c83-61823615f57c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'202f609f-0524-4624-b1ef-ce2842b5b5f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'202f6123-1fd9-4712-8df6-550cd4318325'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'2034b9b6-7024-416c-a978-5121479cfb7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2039ca59-7d53-4990-a1fa-386107017f19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'203d40d2-32cf-476c-b9ba-c0ed01033b93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'20426e41-7d6d-4314-8aab-1c555827f69d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'204377ed-86f6-4da6-a49d-f1bfb1b2f546'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'20481cf5-ad2a-45a5-8c65-8883a759165a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'204a1b13-d4a0-43ea-9390-7a403070c1c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'204b1bde-41a1-4a1f-9b15-56908ba2868a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'204bb781-a991-43db-9010-b5515af7d7c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'204c3f96-e956-4566-a083-fc9eebdfd189'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'204df20b-609b-4e74-ab9e-deaa6106bb51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'204f35f6-c692-4e6d-ba41-d06f4959b89c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'2055cd2e-1a75-4b1d-9c3e-b20811ec3b10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'205cb4ad-4d78-468e-b605-fa5b15592929'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'206b44d6-2029-4a97-8beb-990e9688941c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'207bbd4f-93b2-4219-8a0f-16d04a8cb6c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'207d4fe8-5958-4f8f-bac6-e5a3b0a8ca8e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'208b3f92-8957-4d5a-84f3-92038b1d5b26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'208fa042-b855-44dd-8213-a3eb2dc41af0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E032' WHERE BloodProductGuid=N'209b7310-a5b7-49fb-9bba-24f09bc03bc5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'20a7470d-a4c6-47d5-a84b-1577f03bc2a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'20ac84fa-d291-4d29-b8ff-6cee8e6714d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'20ba3260-c768-4fc5-8fd3-60e0b0e4b3ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'20c1a3de-1894-4944-a8ce-480d0da24ccf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'20c5ec55-0713-45c2-b572-afc2b41942d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'20db9d84-5c8d-406f-bf67-10891e997b1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'20e6cebf-78fb-4a5c-bd31-4e86b57c6c4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'20f734a7-6824-4c24-85b0-56a490c7e7f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'20f9c495-ce36-4237-8275-ab026682479e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'21053b6d-d86f-45da-b68b-fa7ac1cb3037'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2105d78b-912e-4d03-9f90-b07cae25f885'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2112ffa1-27be-408a-9286-c7031a33ed3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'21139cbf-39ec-4cd9-89fc-782e7283a6fb'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Irradiated|Plasma reduced|Buffy coat plts prep|Approx 240 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'211c064a-35a2-4658-933b-ce2737a6a871'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'211d5149-05fa-4152-b2cd-0296c9b7a7c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'2127c349-7337-4c22-b8ac-908d9cd14b7a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'212bfcbc-9643-4575-9363-448e14de13e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'2139f418-4393-4d28-aa2f-f6de4ee2a314'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2141c9eb-4288-40c3-920e-def4d99f7bbe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'214f911e-a79d-4562-b03b-184ead2cba0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'215817d1-f2f3-4f9d-801e-b0a76b349fd4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'2158e862-4a65-4aac-ad9c-de3fcca636f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'2161276c-7c96-4025-8cc5-432cc7dcc4d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'21666c19-1e14-4593-8547-96fd297a5064'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'216b5f32-1929-42cd-9c2f-7c9d5064909c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'21812ad6-6e83-4bbb-aea1-e5fde7180da0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'21816e2e-e75d-44d1-843c-ffda6e40dd1d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'218dd7c1-947a-482c-8787-e30f71e5b033'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'218e98a0-88c9-46e1-9f07-f3aa64df6d82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'21962841-a3cc-42de-a660-80be428ec281'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2199adc9-bfb8-44eb-a172-b58b2095a3a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'219bbea2-7c40-40d9-ab21-078a6071a62f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'219dec6d-af3a-4dee-9005-44f83d8f2c55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'21a23093-bbd8-4857-8144-b7e57b130508'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'21a51aa1-262d-49b0-9a03-304fe828dd21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'21a6eb5e-b3fc-4371-b842-ab5718e12e5b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'21b76716-0082-4183-8c3c-acc169697097'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'21c12a1a-8184-4d40-99ca-b2e0f81d4b1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'21d33205-41a9-4994-923e-6a886511378c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'21d56613-bfa6-445b-a675-d6263cac08b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'21e315d2-9241-41c9-9a77-7f592e4fff2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'21e33da9-c779-4d0b-9a2c-8e5390f3463e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2202242d-8f02-42a7-ac8c-de10b88a24ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'220238a4-67be-4faa-b4dd-f1af4181434b'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|Not for tx or mnf|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'22045022-4609-4e5b-b231-a429f64d08f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'22045074-3bee-4ef4-ae92-44c0ea93fba1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'22049554-7892-4f4b-bbf6-7791bd53ad57'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-25C|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2205992d-bf34-4a39-a2c2-9cea40208856'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'220d73f7-f248-4adf-9ef3-a67dd24bfae3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'220dc111-d52b-4dcd-a396-e38a855d7303'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'220f514e-e5b0-4b9a-988a-fe13884665fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'220f9b56-21fb-41de-b211-1bee298f0473'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2211fb45-3abe-4c3c-88a3-b41cda5e0ef1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'221868a8-2db3-4015-bcdb-4cf1492e8178'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'221992b7-b643-4610-bb69-34791b15955f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'221dc913-83ec-488b-9693-651b105d91a4'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Irradiated|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'221e7807-eb7d-4e7b-81d6-4102da71f59f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'2223add1-1272-4d23-ba1e-acb3d464e7fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'224003c9-7010-49ee-ad57-ecd3dbdb6226'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'2247349b-da6f-4b10-b80e-8818e62328bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'224801ac-4de9-4421-a4ff-2056afbf3976'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'224b7bf2-a80b-4a1b-854a-53d563972e66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'224fe3ae-066d-4c91-a565-4cfd60b05292'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'22577100-dd39-46b8-9360-458eb3a5a522'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'2262ab40-0e35-4675-8991-c746c85e0cde'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'22654020-f8ff-4467-bc74-a17cf0ca2f35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'22693e71-38a6-4b15-a450-d3d68e40e1ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'22744629-c568-409c-ad5f-308f730aca75'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'227f2bcd-fc92-4915-9473-9262af7d262a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2283e002-8334-4afd-a516-9c6fae334462'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2294fcf0-b170-4352-b681-d028cadaa7ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'229de8ed-39f6-460d-ba71-be0fc209218d'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<=-18C|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'229ea480-7a91-49cc-ae18-c683c7b464b3'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'229ead56-8692-4473-9b3e-cb2554efa02f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'22a35c3b-8f9c-4128-a62a-45b9b1f0f971'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'22b23c43-ebfb-43f3-b279-4c6571e3a1cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'22b2e089-e366-446b-89b9-a163b1006376'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'22b660bc-5621-4943-a2c7-3f55f4a2c1db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'22b6942b-8b19-4f3c-929d-7df0cf4a0941'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'22c4ad49-e7cf-4d04-b92d-a780ae0691be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'22cc270d-fb0d-45d5-966e-4d25754cd7b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'22cd9431-ccbe-43a3-b1cf-47d64fb8f1e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'22d400a0-609b-4624-8e47-6ece54e98ea7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'22de93fd-bf8f-40ec-bb26-cb8579227a76'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'22e5e51a-935e-483e-b5eb-b7721abe8340'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'22f3f0de-c36b-4370-8246-37eca9317204'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'23221036-c095-477b-95a7-9a6a398e29d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E042' WHERE BloodProductGuid=N'2322368d-4bc5-4b8f-93ea-17fd2f38ebc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'23269258-6abd-4856-92c1-a9b8cd89fa3e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'23296c40-b474-4103-b771-958e71c4dcca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'232c85cc-e8d2-4e1c-a46d-2c675c1bde29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'23308045-5461-4022-a466-219651c7a9e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'2332e536-8ced-4f23-a7fb-28a49c69567d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'2336d809-0efa-4f96-bf3b-b262c97e4609'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E033' WHERE BloodProductGuid=N'23385bc9-209d-4113-a128-7daea65e7d00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'23388d85-6971-4ee2-bacc-da3e4a3d0be7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E043' WHERE BloodProductGuid=N'2341670f-35ea-44c7-95d7-e509599be935'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'234e28cb-9854-4485-b273-6306a66c3e69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'23593a8f-6d9c-4cb3-aece-b0759570b192'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'2362a3d2-adfc-49ff-9f7a-ce63efd03518'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'23665156-5663-43df-9319-8d675bdfb05a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'236de902-16d0-4289-8cb2-8588e507b72e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'2373ab24-1932-4a4f-8e6e-c6817d845093'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'237734ce-d3f6-4484-8e28-ea3b70ca8f95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'238176ef-8cb3-4c05-9f98-e843d8dad318'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'23831017-0aad-4c08-8c8c-5dc219cc70b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'238e0673-1855-4dd4-9430-188cc914d9b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'23962b47-6837-41f6-96a3-19b4c181585c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'239ae23f-76d0-4238-97b1-879f7bd1e904'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'239f4679-d89c-428e-bd44-e8bec5cdfec1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'23a71ae1-7384-42b4-91f8-a5240b580a43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'23add771-b150-42de-a09a-143f80522daa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'23b345ff-8c28-4c39-a05d-a274a34d968e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'23be97ac-a34a-4f02-8ade-ac8f2f642d04'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'23cd5109-782b-4464-8246-485e0fc5c44a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'23df5bf6-3834-4a97-a202-5595f8097e19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'23ea3629-be0e-4cbb-81b8-c33bc04e472d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'23ed377c-917b-4458-b5d8-5034aeaf6a89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'23f2fcf3-dcf7-406a-9e64-832e6dffab4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'23f67ee5-9d60-4e50-9c40-d1eb0e134773'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'23fbecf2-f9f6-44dd-a053-ed2a4ac8a335'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'240a0d07-8535-4f6b-8ed6-a0390ba3f621'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'2413656d-b147-466c-b83f-0d2fae82b217'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'242a2f42-0858-4721-86a4-553ffcfababf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2437b15f-ae3b-48b1-bce7-78ffdb14c0f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'243d5cd4-ec8b-4ab7-8807-0e117f67cf86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'24506144-dc75-4a05-960b-6f271f85df16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2451fb9d-64e6-4c40-89e8-906a4348625d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'24538724-51dc-4601-b5cc-c0cf0daef4ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'24586a20-fb04-451e-aef2-5d3195a50cac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'245b75f2-6278-4ae6-bec9-0b1f86750e72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'245e2dda-4cea-403a-a38e-e3fd7a403118'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'245ea715-8697-4517-ab73-72ec69f271a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'247531c8-144c-4af6-aa54-1364cb499307'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'248890be-66e6-4dc9-a2d8-24033b2b1f86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'248ba832-1399-4a81-9ed4-eb3287e245c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'248be240-d744-4733-832c-06fa7b1930c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'24977301-7ebd-485a-af98-5426ba8b7c40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'249e1ded-8295-4485-9bc9-d8cf8d39cb69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'24a929f8-99a3-4f4b-a004-8743011ef04d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'24aca56e-dae0-4d60-8461-9b7cfdd2f3aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'24ae694f-9a26-40f7-9ea0-2e30a3305aa2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'24be75f4-d97e-4abf-9e5b-fdee3043b6b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'24c27fb1-ca9d-45a7-99c4-37992930659c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'24cdf95c-4c1e-468a-8e42-93dfccf47bff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'24da5a21-4fc9-45fd-9356-ce20768501a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'24f4daa8-62d8-46e4-bab6-2a5c02d6c3d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'24f56ba1-b2d2-4b7d-a4e1-72f6089f3258'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'25003ee1-c780-4ae7-aeb7-4ae65f8a90c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2517575a-4e53-4a1f-ba20-164aed367318'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'251b75ec-f30b-4106-943a-f6bb3fed55d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'25212ca8-9add-4765-a021-a35f29d231f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'252632de-877c-4991-80ed-9e628d42109d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'252d239b-67cc-4dd6-afda-afa56b5be229'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'253823ab-5cf9-484c-b5bc-8644be0e44bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'254d0eb0-6a56-429e-812a-cd98d78a1048'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'254f3ff1-950e-4c8f-9c72-774fb25b4969'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'255367d0-06ed-4670-9aa8-76199ddfcf86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2559cce5-ef75-4d96-9660-6824ff076504'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2560beef-e272-4e73-bb86-a0976e2ce12b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2568f8dc-725d-4b5d-a21a-a2cbbc92bd9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2572749d-5aa5-4eb8-976a-4f10f2acc86c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2574d576-265e-41e9-85aa-22552186a374'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'25aa977d-21fe-40c5-84a2-00d53e9bfbf3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'25b11f55-9c38-496c-aaa1-eeb134f772bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'25c88a5e-3638-4c2e-baee-013569f27eb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'25cdf56a-8688-416d-be48-f79253173d29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'25d2d292-a703-40be-a37f-a7647b5fc49b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'25d9a8b5-fe8c-4844-a45b-5be1b8bb71ba'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'25d9b867-87eb-47fb-8423-5eb880370da5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'25df313b-3954-4215-af92-2ddea207080e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'25e1fdf2-aa99-4633-b1a7-f15d7633f33a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'25e3233e-bc53-4ba2-b852-9d97a0a0857e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'25e85484-b804-40df-b481-44a57cbe37de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'25f56097-376f-457c-a74b-4204ea007864'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'261251f3-7f07-4a7f-bbeb-a5092b29dc23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'26144af9-e7a8-464b-b54e-6c936f37d77b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'261a8b49-bb2a-4bf3-bdab-e483e0109c09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2628311c-b1a2-4836-b7b6-cf051c732997'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'263aa245-2cc1-4c4f-99ea-db7f0965ea7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'263c56ce-a416-4750-be97-57f640ffac6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2642c0eb-36e4-41f8-955b-49d28242f718'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'264c3a26-8763-42e7-90ca-483dc7a0ddea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'264ce7c1-e2b1-4a38-b9bb-cadebe2c0466'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'264e5325-fcd0-4b85-8195-157c746c6051'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-65C|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'265475c0-7e11-4f85-a1ed-0f34a02e7d3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'2660aaa8-1d1b-4688-aad8-6c20a215fab3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'2665c1d0-4bdb-4704-9c04-8d4191f2e155'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2668938c-726d-41fd-b230-f40b2fb77ba0'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2673bcb6-e958-4fc8-ad3f-5cb7eeb334dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'26753e6b-559b-4395-86bb-8ea6978ba72f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'267a99dc-d61b-4d9d-9542-dc2c86e2e546'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'267b7cf5-d11c-48d5-9892-33bee5c269ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2684fb93-d4da-4dd1-b964-9aca64889a08'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'268bd72b-6f71-48e9-a41a-d49484d19715'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'26908508-2e18-4eab-b315-fd6581822ce3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2694c9a3-92f9-4f12-a35b-fee3f882113d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'26a01855-1470-4b35-9032-cb95eec25c6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006', RetireDate='20110401 00:00:00.000', LastUpdateDate='20110510 08:01:22.460' WHERE BloodProductGuid=N'26a3b44d-e7a0-4ca5-89e3-11aa90071aa3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'26b17275-8e01-4a41-b71c-9187b57c7d9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'26b87e3d-894b-4fbe-812e-4c7c943d8f84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'26c1f65d-c2bc-485a-8506-ee28b1f1488a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'26ccbba5-76d0-4c13-a07b-cb3b6cad7580'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'26cd846a-9384-4e0b-87fc-efb9f2486a43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'26d9c7f0-e752-4596-9bc9-c5191ca44dfd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'26f1823e-f613-40f7-92ce-0464944b660c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'26f58b4f-6527-4d5f-b087-8350418b84b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'26f63576-8948-455d-a669-3f32f2a975b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'26ff3aa1-b5ce-4015-a54a-c4002ef910f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'270eb14b-b143-472f-bd9b-7c3a05f29cd8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'27142c76-4314-421d-ad7a-975ff547f79f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'271a194c-7bcc-4567-8402-0a318ea19e59'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'272f2c08-3c3b-4762-8f67-9db8a85a6ee4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'27326a28-fe22-4e8f-8548-ed9c357666aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2744a47b-ce0a-45d5-af69-b99f5fcdc0fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'274ce8c8-d014-434d-b5a8-37cdac1832a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'27563dd6-1c77-42fc-b5ad-67c1eda89dbb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'276296ba-5ee0-47b2-bb11-4acb49d7886d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'27686e22-4c8f-44e3-aa5a-2a6e53cd2c6c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'276e87f1-9f14-4fbb-ba7c-a4d825684d5b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'277fe3ab-c037-4020-a8c9-2213c23e0cb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'278ad7ae-4cac-49ad-a275-4c892b339bc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'27ad39ea-5181-4908-991c-07eea9931680'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'27b123d9-35ce-401f-99ae-54b662aecdd6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'27c476f5-666b-467c-bd90-99069baad9fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'27c89c82-0f53-4633-a32b-9b9a8cd8bf06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'27cc91cd-ae3e-4b0d-a2e9-d94283c3382f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'27cdfe6c-b17e-416f-a23e-354f0d2f9cbc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'27cebb76-5306-4d31-878e-2e2e62dcdddd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'27d2a603-262b-4a45-9d1e-57df55402535'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'27d6efc5-7d64-41f3-8aa4-06836453cfca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'27d919b8-a58e-4094-a5e6-051fb7ff02be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'27dcae09-01df-46b2-a096-db17657b0c55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'27de5407-12de-4390-a260-c4daa3ee2e30'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'27e0d3fa-f3cd-4e22-a7b2-e6c1b0ab4fc3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'27e0f56a-0474-4547-babb-9fec5d587733'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'27e613f2-85af-445f-a5c7-ee869650758b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'27e72916-ba03-4ef9-954e-fac68579317c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'27fb861b-4f9a-4e9b-a9b0-e6e58b1046ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'28052ce2-c3c6-47bd-af66-16d66c9fee9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'282205e5-9aed-47e4-8149-70fd6373d9a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2822ae2a-232b-44a7-8760-897d6f5f7464'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'28253036-d084-474c-be29-45fc7492389c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'28268463-2edb-424c-b1e4-6c3cf101311c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'282b0805-c562-4792-9de7-18ae10b3be96'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'28374c7a-cf93-4689-b881-ef07d2799e1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'283e918b-cf13-4cb8-b5ae-19ee2d095491'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'2843048f-e5ca-4dea-8e80-fbecc68687e8'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Open|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2859c702-c8b7-4175-b9e3-40cfd7ba1b45'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2875be9b-2323-4433-a1a2-51e9af304ede'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'287dc6fe-2973-48a1-8944-b3c72da30c2a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'28915e8b-0fa0-4f5b-9784-7cbd3bffa78c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'289ea5dd-3623-430b-a819-b2a7658499dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'28adfc7b-10de-4016-83cd-a37c487f3825'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'28b13245-c82d-49f2-95ea-755ea66cdd19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'28b316fe-f204-4fd1-9c7d-1e4e48a69cb6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'28b9ea0a-c8e5-4522-b1cc-d45442b49fde'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'28bbf6cb-1974-4631-bfd2-b9da07e8eeff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'28c028eb-9b34-49c0-a427-6aa8be5e22c7'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'28c0b0a5-d1d4-4dcc-be39-c150389aa3b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'28c285e2-92cb-4a8e-a1ab-6b71a5effa42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'28c9d2ee-db63-4285-bded-333e72fd7d8d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'28cabc30-1e13-4d62-92fb-119704bf13bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'28d0ca0d-79f0-4ca6-a57a-62368c05f7b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'28dee929-2774-443e-b525-a8299afd7f9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'28deffd4-b158-4807-886d-1ecdab19cef1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'28f70c37-7354-407f-9576-6ae353a39d01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'28f82bfc-b752-49ed-9bcb-eeb62ed8c6f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'290998e0-17ec-4cb0-b8e5-9201aab97391'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'29251733-f799-4830-a1ff-df42abe29229'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'292c8bcd-5e5d-4d3c-9248-92de12f7c526'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'293972a2-a3d5-4983-b020-4b3c466f6ba0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'293b1903-8798-4ffa-a9c0-d664373e6e0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'293f4ead-a284-4fb3-a60a-d0012b9009c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'2941a2cf-84b9-4a43-b538-0fa06964e094'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'29474a29-22a7-4baf-8acc-e45f99e45a3d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'295ec0ef-ae98-490d-ab04-459484b9062a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'296535e9-92f2-475e-9884-aeb0c179dde9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'2965a7fb-4826-4a07-826f-58c97c97670c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'29669990-5970-4d43-9e48-b616b269a2f2'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|Not for tx or mnf|>=400mL<600mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'296a67c6-59dc-4ead-abfc-942051de2e57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'296af449-0b00-4d10-b53d-0fd4161e4e43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'296c565c-b14c-4f3f-8b3b-7799ff0daeae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2972da19-475f-4b1d-939b-af862d83348e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2974c528-5271-403b-b6d0-d9ddd0feae30'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2976fb4f-cb18-4ea9-ac22-bd60bff6e02b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'297c9e03-88f2-409b-b972-72d95ce87d4a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'29802d92-9e23-4c2e-9c0e-55c5f5c5e2e3'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'29832e50-d63f-46a0-8a93-3c705b416c40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2984c243-991e-4f20-a988-a779bfd97c58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2992ec17-40da-4711-9421-0a4e88528ef2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2994ac1e-10b8-464d-bb34-a32f030cac57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2996ca90-c390-4e2b-ac17-3444e42f05c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'299b59c9-00ea-4654-942b-0d2f54b3ff01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'29a04eb9-154f-4e8a-a271-37fdba6fe2d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'29aead00-01a8-4590-aaa3-e6c9c148c54d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'29b1ac58-983b-4b9e-9c73-891d55d8caa5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'29b31f36-86fd-4e6c-94d9-3ddd376c3925'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'29bb1f00-3d89-43d0-a4a4-85dd88bd40ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'29db2565-fdfe-4746-9770-c84cd520cd37'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'29e09539-b85b-4867-9ea4-97abfe987be8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'29e4e832-d981-4162-8d8c-80e651340497'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'29eda4de-1730-49a4-9ee8-4a04914d0ccd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'29f451cc-e31f-4e42-a7c5-e9069054f184'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'29f459f6-7595-4a65-99df-424ec368c5bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'29f55d41-465c-4382-adda-f083219e8b25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'29fb9742-fad6-4cfe-89fc-41b05fb29cc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'29ff6223-b9ce-4ab9-87ad-4b47433049e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2a0add34-af26-4c0a-bf02-ff72b8db87a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'2a10b502-9368-4da3-9229-d209a4996af2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2a193b44-d064-4052-b22c-43233cd9b576'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'2a1e1f39-2c43-42e3-94bd-a03f40e3ae89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2a2ab50d-8f98-494b-9f50-6f156540cb3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'2a2d3b25-c84a-41a6-8cb8-49fc317325a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2a435bd6-962f-4209-8a4e-077a7708c609'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2a48529e-5012-44c6-a34a-44b60063f307'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2a4c6b45-a0ac-4b8d-bbe6-c26e0f1f9d64'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2a4c7b97-7999-4192-a9b4-5c872f0c6210'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'2a4f8299-c17f-431d-9e00-f3b193680b14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'2a52fce9-93f0-457d-b040-802efab59e6e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2a54b7e9-3052-4c2c-b4a3-796b3d919d0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2a569276-3f03-480e-917c-6ecc27ee4873'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2a56dae1-5353-476f-a250-f35bc176196f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2a57374c-35e4-4d63-b453-c6449d78930d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'2a579ec7-8c5d-49bb-beea-9487d0212569'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2a581555-099a-4d6e-8a4d-7d59c95497b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2a58dc36-34ae-4951-b5e2-5bc1496a1ca3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2a5e9e0f-6a5f-4222-a2fb-78c93eeca050'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2a770faa-15df-40cd-a9a7-054631366598'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'2a88f8e3-079a-4c53-9756-2683233a7fc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2a895b2c-a10d-4b7c-9830-6368905c6f4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'2a89fb0d-9ba2-4863-b291-16f65fefc580'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2a8c3d35-311f-4fcd-999d-23aa3f31f522'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2a928198-280b-42c4-9bb5-38a7ca4dca54'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2a958b0e-2744-4807-9881-77a53da77ad9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'2a98bacb-d59e-4f38-8efb-a353c954448d'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2aa3dbe4-1235-47b0-8ad8-b030bc11010a'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2aa535de-56fa-443d-bc4b-324c5267582e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2aab5b1e-2bd0-4101-bfca-4e7bd47f40d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2aac641e-4044-4b5e-8628-cf359bce23f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'2ac652b8-3148-4d63-990b-dc309784c01c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2acf6764-a1e3-4f00-a0ae-9b7bac4f4d24'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2ad6bdf9-974f-42b4-a041-952ad1a4135e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2ad79c06-33f8-4e32-bfe4-385c5206c3c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2ad86e48-796b-40ae-8d18-f17ef75f4418'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2adff9b8-ee4e-4212-9627-ad9d08f75f9d'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2ae03f2b-1d0e-4aee-bd6c-dba96235bd49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'2aeb13aa-61a7-451a-ad22-ef3ec7d2c4c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2aec9e17-e566-4a5d-b2ea-6290cafae1e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2aef4a8b-86e6-4168-83e8-dc88f1fc9232'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2af0c3c2-cc1b-4204-9b7c-b6ae31983aa6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2af433d0-168c-4887-b102-b51843fd9bcc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2afbedf9-f56b-466e-a7dd-9c5e7884a0ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2afd69be-5f04-4f14-afaa-73dcb8ed620a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2b0744a0-14c3-459a-8dc4-411cf77f7058'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'2b0d2755-6d93-47d3-9178-2ba73c95252f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2b15669d-bebe-49c6-948f-8e401518524c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2b22b4eb-fb5b-4817-a012-d2da0072a094'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'2b40acdd-80bb-45f3-b45c-5f285bb22794'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2b478fe8-9513-4ee9-a9f8-ba2f01f7a627'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2b4eaff8-b166-4a36-8a7d-fe9d73994531'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'2b51af57-5089-460d-95e4-f842c4d77040'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2b5c14fc-1b91-46b0-bf46-2f3b86a61eb9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2b5d4fa6-f940-474f-b9d9-4e448950b5ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'2b5e5236-3fac-46ac-a1e4-9e1406aa93e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2b61b737-c1ce-4f26-b9ff-6e5b0e26423a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2b63d057-b37f-40f1-a7e9-be2b7fa62eda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2b65d5b3-463f-42f6-9a89-00ff458e5ff9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2b692847-b31c-4dcf-ac90-01e79eb4e1a8'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2b6e4b4e-4687-4f54-a2ba-e3848efc86dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'2b6eac79-7025-4166-b18e-b9eb795e86bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2b6f4e4a-cac6-4364-8afd-ba83340c1695'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2b71982b-375c-4967-88c9-99a4fdc1ed1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'2b7e92c5-c6e3-44dd-8754-a4494e2d397b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2b8e545b-5da7-4a26-9cee-11448d5db712'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'2b9160aa-807c-401d-8e59-fa0133b664ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'2b9472bf-01c8-4289-8333-38c1676ba813'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2ba9dbb5-4ba6-4bb5-b77e-4fcfca81de87'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Irradiated|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2bb528e3-ac7d-4d2e-a8d8-ac4033df2cc6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'2bb53ad5-31f2-4000-9a1f-13fb714746c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'2bb9c735-f481-47ad-8e68-0c3854b5b6da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2bc003d5-7e5d-48d7-9bb1-c70936e405fa'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2bca9206-881a-4d5e-ab80-02b6a17b34fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2bd168c3-d0a8-4b69-9616-003c5a24bae7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2bd40784-2e19-47d8-945c-0c717de73b74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'2be0d6f0-a111-4aae-8bb6-8b1c2e42e11f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2be959b4-b334-4b95-99aa-ccca9b3b8a09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2bfa7fe1-8884-4fd7-934f-639e3ee42849'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2bff0af9-d9f3-4882-903b-7bdbf0b74ff5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2c077b6e-89d3-4208-9150-c3473a0c39d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E056' WHERE BloodProductGuid=N'2c0c6e59-5adc-49fa-840c-d3455d852290'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2c0ef873-3a31-4ba3-b96d-1f74b75766ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2c12bed5-2388-4c6c-877b-67caa0745a50'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2c2565dc-f7cf-4fb9-b747-bc57b930874d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2c32ebce-3d55-4cde-b6b3-07cc0de8af49'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|>=200mL<400mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2c3e68da-2c3a-49da-b190-a017b353c67e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'2c3e99ab-c165-4e74-a012-84b4b752c81c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2c407b07-7923-4073-bcbe-8409c2121884'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2c48ef69-6120-4d4d-a6bb-94a4137527ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'2c497a23-bc18-4f4b-9407-dbdf3d4c33ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'2c4b9fc5-9f97-4e25-8487-f47983222f6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'2c508663-ed19-4891-a68f-b3a6a8c294a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2c5fbd4b-40b6-4e9a-83f6-c2c3515cf702'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'2c61c3f2-64ab-4acc-813f-c4817e0334fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2c6847c8-7d38-4215-aa80-3416461e1c99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2c7047a0-54c4-4986-9d6f-f00716260732'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2c709e7e-eef8-4bc3-a5a4-49e05243494d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2c855716-3aab-4129-bcec-640164fc33f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'2c8727db-c6e3-422e-bf13-a5164346eeee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2c8f6ac3-0475-40e8-becc-c2a1f4b85523'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2c95be11-d598-48b5-a3a7-b96bb2c9d073'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'2c9b31dd-1f53-4cfe-b80c-8f303e4a40e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'2c9e19f6-681f-47e1-afcd-3299b629b846'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2ca64757-a432-4952-b65f-2fe5c7dfef89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'2caa6b05-550a-4b8d-b513-3dd365d31de5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2caee226-7e71-40ac-8a8c-d930f72cc668'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2cb4ec8b-55bb-47e4-9c3e-3ab122f48da1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2cbafc9c-0328-41b9-835d-7d362534804b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2cc91ec3-350e-4783-afae-67930bf89a4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2cd3fc5e-c11f-4d21-95e8-fb6307d3e368'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'2cd4656d-b718-45d7-b340-73d419858b9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2cd71d3e-1148-4a7f-b6e7-c7acef30e2b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'2cdc43bc-9a6c-464c-9e5d-4aeb01421831'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2cdc51a6-0f6b-449e-aaf3-8a8b1e5838a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'2cddceb2-e259-4a15-a707-bc342b02dfd8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'2ce0d38e-464e-48b8-8d29-fb94f8539d8c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2ce9dfa4-a67d-4c49-9523-e1899b8e072c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2cec4c9c-40f4-4857-a4f7-31e351819424'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2cec8fad-440d-4be9-b851-dbcae43b9e6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'2cf213b4-2655-4cfc-b1e1-97dedf772ba1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'2cf64d04-ce9d-4972-b471-e743aa8c7478'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2d05e203-6a69-4145-9670-a1ea78bf60d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2d064eaa-2702-4638-9ee1-4093d833a963'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2d067263-b4de-4197-a11d-543dbd79af2d'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2d1c426a-94c7-4e68-aaef-5f3c56758bd2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2d1e5405-455a-4110-93b1-3af4d9942e00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2d1e6e43-1674-4232-8c68-f0517c901ce8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2d21d941-28ea-4560-885d-721f5bad2386'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'2d258ae8-5984-4d64-a329-7fde7677e1eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2d28426c-5bac-4a17-91d2-9e466ec422e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2d362873-cf2a-4b15-9656-7ace9cd516a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'2d363217-beed-403b-ad31-62e9ccba8fe1'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|Not for tx or mnf|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2d48156a-25e2-4d79-a175-95a87a6d9c5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2d48e345-a460-4dc9-b13e-01d19e29f532'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2d4b6b67-0e92-4a8d-a730-8733be6f15cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2d57a7f8-6431-4369-be6e-89e6772cfb03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2d5d0cd1-e28f-4d1d-9607-638ce7d69e38'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|Not for tx or mnf|>=400mL<600mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2d6223d2-e185-42c7-be4a-c3fb0cca3217'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2d74586a-4196-4996-9d0b-766a2746b059'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'2d796baa-d392-4b62-baf5-fb2afe7a6449'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'2d80b212-a604-46ff-a996-cba6b0465d14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2d813e55-2ce3-41e5-b6db-00129a6467b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2d8271ae-09c1-42ae-bb66-9486a7e3e205'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2d863a8d-8ace-44d9-b82f-10d3d8832504'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2d891511-d380-4ada-a591-6571fdd1e6f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'2d8af4dd-11d1-414a-8140-53200767f8de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2d9489f0-3027-49e8-bf52-2e77824e3b56'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2d96e941-de16-4941-a34f-c0d85d937775'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2d99659e-e298-4de2-b3ed-ee6217d05191'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2d9daa46-97fa-489c-88cc-8f6b4128c332'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2da08ad0-92da-4e80-ad5f-7aa535c86901'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2db7d154-f411-43b9-a33f-cc90b8f3777e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2dbbbfc8-6de8-4a28-8f53-928942328256'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2dc2f9f0-d64b-4f9d-b54d-10fdc5e0cbf0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2dc86982-aff8-47e5-930c-c4ff9cf7a6a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'2dcd1fc4-7d64-4699-8e7b-ac42dcd57004'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2dd83ee3-8e8d-44ec-979e-f0975cd1d93a'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2deb4d14-3fe0-48a0-b110-fb818c28f843'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'2df21edc-9dff-4e3e-b040-c1aa59e09ede'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2e02da9e-5e8f-4aa2-9dd8-13fab7ba9194'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E037' WHERE BloodProductGuid=N'2e04f633-3f7f-44bc-ac72-467318690a00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'2e06c428-5ccd-44b4-9f11-b6ffe4da973d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2e162291-d71c-4529-89ee-922422f56308'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2e2f000b-307b-4441-9264-e8d3083be5a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'2e324e48-1d23-4018-a122-8d9c0ddc2a13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2e32973b-c98e-4c7c-8186-da4c3c60f0e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2e365bfb-c318-49c4-a31d-749702fc936a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2e377e85-1f9b-4c0c-8b34-1c7cc4f30b77'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2e390961-0284-438e-984a-82963532fd71'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'2e41a9ca-cfb3-40fb-b83b-1c852cec89eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2e431765-71cc-4d3a-9ef6-9d2ae653e0a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2e431b77-de0e-40a5-a541-070000ab89a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2e55b2df-d273-4e6c-8e54-8afdc41cada9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2e5fc214-4b71-499b-a3f8-e8051159807c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2e66834b-a3ec-4999-a9ce-81eabcaa4167'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'2e6d51e5-9f28-496c-b6b7-2e89977efa75'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2e6d6a78-0b1c-43fe-9bac-c9ac23728153'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'2e6fee38-d231-40ac-bc2d-c1fd726abb8a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2e711b44-a578-4686-84a3-07f27fea6049'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'2e73ea47-0556-478c-8fc1-3804c1c959e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2e7d75d4-68f5-409a-9c44-5469d78c8bae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2e7e8ea5-7f36-40b3-831a-8046f353a4c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'2e878018-940d-447a-8c37-a89c396a8132'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2e88b206-59fc-480d-8ca5-65111cbf3c99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'2e8f0aac-7a4a-49b0-8d2a-bd52237d03f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2e906a86-211e-4e4d-afbb-b229a51831c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'2e91fdf8-fe95-4f67-9580-3385cb73f349'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2e950a12-921d-4f8d-8924-3c9a1dd0b0a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2e95d487-3cb2-47b6-995b-4f8f2e6c7a67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'2e98c0b8-eff9-4474-a522-1f58371683ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'2e9ebb30-c30a-44dc-a60e-5a755ed0d2b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2ea783b0-92a7-4627-877b-83be9f6f04e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'2eaecd73-c6a3-4ad7-a9b9-dc8c5edfa97c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2eb0e0dd-0ed3-4296-bcf3-ab59da3ffd99'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<=-18C|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2eb29654-b37a-47bb-b249-6f25fe972f25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2eb3bbf1-254f-4850-8d9b-52421dc78448'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'2eb727d1-4f27-4111-bf81-6250c8713ef8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'2ec1eb58-d0f3-409e-ac10-0fda3af510ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2ec50628-1ebc-438c-b278-0a260eb55a04'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'2ec935d9-d986-4be3-b277-dcd5682cf954'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2ec9674e-7e76-45ff-b3f7-c1cdcb29b4c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'2ecbe557-5a35-4d41-a0b2-e8d44bafc9e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2ecfd3c7-20fd-4a2b-94d9-3fbea0f52beb'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:noninjectable|>=200mL<400mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2ed7646b-83b2-4112-9f1d-bc021e79d3df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'2ed921ba-844a-4190-aa36-a882ef042621'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2edb531f-a44f-4da6-8b69-5288919b2696'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|>=200mL<400mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2eea71d7-8a69-4329-b1a5-9fc6f1ca8c88'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Not for tx or mnf|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2efd8127-2fe0-4b20-aa28-599e4185aaa6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'2efe7a06-2af8-49f9-94ec-74ccf1b39e90'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2efea195-9699-4aa5-b1ab-e69872e18e39'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'2f12baea-05ae-4f89-94a8-a9513081777e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2f163092-d080-4e28-a987-07feb40f40b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2f1e330d-45e2-4a0c-b26d-2d68a5ea9cde'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'2f1e4026-3e1f-497d-9ed4-0cf38cd71860'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'2f2a58cb-730a-40aa-9cfe-d6ebdf2fd483'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2f2d7375-9ce1-4dfe-908a-5eac1a79ccd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2f3015eb-3e1d-48bb-a798-140409b38367'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'2f32334b-188e-480c-a73d-05bb4765472b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2f334487-1c28-4698-a2e1-b186553ef65b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'2f397523-2966-44fc-85de-03c1a47007df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2f3b7ecf-675b-475a-a097-77f99d6710a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2f3daaf6-8e0e-42c3-91d9-7e2a9d52f497'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2f41d463-8e01-41b8-af7e-bb6747f8eeb5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'2f4f3bed-aa79-44de-814c-771441ec4bed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'2f5d55a3-da57-4127-b289-1c2a59521b2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'2f5e2a9e-0f56-40bf-a72e-bf59507b8686'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'2f6e56d5-7c6e-4e5e-bea0-198740c6507d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'2f76d8dc-33e9-40c8-990c-a40404acf5f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'2f7a1517-940f-4819-b94a-8628b06f54a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'2f8415f0-e4a2-4682-956f-9b046ad57667'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'2f85405c-54e7-4fb1-b1ea-4a6995a3a103'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2f8be5ec-9a4b-4af8-bba8-a06534bf8f70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'2f960b81-bbda-4c96-9eb4-3701a0e368d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'2f9835f2-86cb-4117-ae21-dd56e59bb390'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'2f9838c1-2432-4ada-88e0-cd25cb410185'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'2f985a58-6c1e-4972-8242-a24c7166dc67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2f9f7d5a-38b0-42e0-8d87-e653199edc01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'2fad6f6b-deda-40d0-aaa7-562f55b7161b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2fae562d-cd45-4802-a244-a53949f0c5d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2fc2383a-5699-454d-b1ab-48785e89e7b6'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2fc432c3-e5c7-4e6b-ad9b-1ab37d10c4c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'2fc7715d-a7eb-44ea-9b8f-1f9086e2b423'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'2fcdbffb-9ac9-4511-9dc4-3fa19de17280'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'2fce5302-90ec-4377-9c60-e328251f1b3d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'2fd3771a-c774-40a7-a29f-192e5c36be87'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'2fe14a2a-5147-456b-99ca-99e944c09a0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'2fe99f2f-493f-4399-90ce-7c7c02eda35b'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'2fef18d3-b0d4-4c32-a2c9-3c4767895d89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'30027d0c-5c7b-4c48-9e88-9eb00e2e891c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'30027f88-86e3-4d10-8252-d48dbbe3067b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'3004087b-0c4b-453a-b808-1aa1c15cbdb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'3006fd1e-bc91-40a8-b043-31a5fe4afb25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'30225682-0d52-44c2-a97c-302aeb5a5f8c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'302c38cb-a026-4c97-b89e-69d1ace5d85e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'3032e2b1-a780-4b1f-b531-b0a1112ae9bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'3035f499-0c70-4f19-81fb-8e128ae955aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'30483d1d-ca14-4b1c-818f-44e52cb68ca6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'304fc786-1907-45cd-9b0c-4f3e98911f5c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'30562b5a-0d22-4f5a-98bf-b3a42f63bef1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'3059bf0c-e109-4a32-a838-d184b42cb9e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'305a0dcc-58bd-4448-ac6b-d91eb7aa6736'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'305e8efd-e752-49dc-ad3a-36e0f8897bd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3062b068-b88d-4175-90cc-004d0c5fdf00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3074df72-0f66-4b35-9c79-91b42d4eab69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3075fd3b-9ed9-43e2-be6e-f960e07f8f5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'30779567-0823-4a12-9a7d-9797969174fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'307f66d4-acdb-4397-9e34-1890e3acf3de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'30889cb4-7609-42d2-a9b8-a064887f5d14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'308c362f-5a7d-413c-8824-3c6516b21a09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'30a49be8-b309-46a8-a3fe-b47431ce450f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'30ab7c8a-3658-4eca-ad92-7041d6faa9e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'30b857da-3728-40fc-8f4a-6640b989fb4c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'30e04e9f-6d8f-4ec6-9dfd-b84e80d33e6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'30f00efa-f6e1-49af-83cd-3c35c27c0a21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'30f8d008-dfc1-4a94-a2d4-5cfa36cc21f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'30fec2ef-298c-426c-b086-47a47d7f9d74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'31025e8d-707c-4d7a-b543-16fd21d2c70b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'31027751-c1ee-4bb2-85ad-dee3149466a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'31045a45-e563-470a-86c3-f228cf569374'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3106f7da-79eb-4e51-9594-04e8476a274c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'310dc721-bdd8-4f33-b9de-aa6ac6df4af5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'311fddd8-c742-403a-be0c-a21fd008a896'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'3122f238-b23d-4680-bd6a-76a247cdf2ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'31286b3f-b477-4618-83c9-e6b8db136add'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3132a85b-2abb-4ec9-88a9-e2adf6a1f822'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3135a34a-8562-4eec-930e-6d72b4343061'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'313aa9c6-fb94-4d9c-83a5-d62248f83f7a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'313d4f2a-a470-4ec3-9084-153cf87349ea'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:noninjectable|>=400mL<600mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3142be1b-b0e2-4619-91d0-248722903a93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'314584da-7388-4c56-99f4-d906d6a36db3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3145c516-4179-49cc-ab75-2a1997df2d98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'314c7586-a86a-40c4-8fb5-86ac02dc6a73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'315e6408-4fbd-4a7d-910f-f25082b9fbd4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'315f2c56-1020-45be-a221-5b425d26a40f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'316083ff-6b6b-428b-a6e7-a8e236d44111'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'31810906-edbe-4458-990d-888b86df2f1f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E063' WHERE BloodProductGuid=N'318ce356-986c-4b3b-bfaf-9ebb48c31c33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3193e4ff-d96f-40ee-96b4-108e82921bf1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'31a6833e-5da2-4f25-8a38-ae5873442d21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'31a817d3-080b-443d-84fa-3be8f77ad810'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'31a9715d-f7c0-4055-b599-9b7317b14619'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'31ac2750-6558-4e8a-b38a-45262029f405'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'31b24cf4-a86d-4c75-8080-db30e044b6f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'31beeca2-de23-4939-b536-7f0ee172936a'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|Irradiated|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'31c1c4fd-7ac5-4ea4-9c87-ba7163778bb5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'31ce4ad2-5988-403d-9d87-7c94c95e0b79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'31cf4bd1-b528-4270-83c3-3af95b8edd6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'31d27071-d426-4df4-b94e-cf4738670eb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'31d9aac7-9886-4997-b2e9-2e1c21820181'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'31e3a7bc-cb84-4584-9a9a-ef901dbdc4b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'31ecda18-e7f8-4741-b03b-7ad876243b31'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'31edff07-e143-492d-8256-d889642fa51d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'31efe057-9a80-4e45-972b-9593a51bc96f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'31f5c722-daec-41af-938d-07a80b3c861e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'31fd3440-3d19-459b-9c6c-5e55d42a87b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'32036c29-d854-4c6f-8b00-6064716fe9f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'32071c03-57a1-4d68-b29f-3b6808ca6146'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'320b18ab-a7ac-4eba-8e55-c4556c18bf16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'320ce080-6902-43df-bc7e-6cd47836bb89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'321cfea8-0394-4ac0-b924-d2a76090486a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'32223da0-b52d-470b-9756-7ce2ef508787'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'322241d0-4461-4393-823c-687154c3329f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'32230ad1-e64a-45a9-960a-6853c3f36bab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'32312174-f2d0-4447-ace7-6c969c236fe5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'32385685-6894-43b6-b1e4-f1eb81b0bcf1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'32396fa1-d38f-4c82-8f4a-559aa68ddf5d'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'324be73d-3d5b-4ce3-b056-83603c3e16f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'324dd403-6012-43ce-b510-2ee49a04be1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3257deca-6f55-4b31-a340-8ba4ddeee62f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'325c1808-39ff-416d-ac60-03f17e830448'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'32607a74-0802-4baa-a521-32da91723a17'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Not for tx or mnf|Open|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'32639b20-3ff4-4025-aa90-afb15fa1be22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'327029cf-42ea-4832-b2fb-5798c8a8e15f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'3272894f-b971-4aa9-919d-4b0b3fe7069d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'32786a04-2b16-4d16-a5d4-59fb775e6a2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'327d9a42-9943-47d1-b775-fb4d72de0767'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3286b870-0f16-42ce-964c-e3c5125ff7ce'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|Not for tx or mnf|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'32992e70-0ac6-4f58-86b3-f218fca9a3e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'329fcd8d-f2d4-4121-b57a-b05e48f2aab1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'32aa43d6-8ba9-412e-8fd2-7e2b0b92df27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'32adf882-6ad3-414a-96e5-d0786978da98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'32c33ed2-a36b-43d8-a13f-3abae7352f54'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'32cdad76-7afd-4550-891e-6820c2c203b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'32d7c23e-87a5-4cc9-ad46-c23581b96ecb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'32d814b5-2abc-4e68-9c4a-94747e2cd179'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'32da055d-469a-4333-b2e9-7f798cc81bc5'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:injectable|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'32e0cb4d-cd0c-4022-91ee-c367d36e3ee5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'32e3edb7-9d9f-45c5-ac0a-cdae2c56f0d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'32e429e1-bd08-4f87-91a7-935d663e7fcc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'32e8f7af-d765-4dbc-9fe4-8bb6db4bd741'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'32f49251-c8bf-4011-adbd-ca3455c4f7a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'33065d74-4790-43b8-8875-aa11e6d3d2bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'33066255-d03a-4d59-a993-70737452444b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'331bbec0-da17-48a4-9fe8-a77315a3b17c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'331bf566-646e-4b63-84e4-cf3d962f8348'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3321d571-2959-4db1-96c2-f8ebd81166ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'332279d9-fceb-4126-b6a4-40858e7231c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'3332a172-ebb2-4140-85f6-5a9865c9dc56'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'333b0fb1-080e-4bbc-8559-a72245f7f259'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'333db3e9-da5c-4cf7-87d9-4423cb025609'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Irradiated|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'333f725a-d062-424c-a38e-b746ef95cf5e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'33514860-9391-4cbe-88d9-2efc51dadadd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'335575c4-91a4-4d5f-8644-cc59c3ecdb50'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3355ac27-6a95-4254-85aa-4371180a9411'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'33568303-e837-4424-bf7c-c75a2d335caf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3369b33d-7ab9-4e1e-a248-9b3bfb4ed68e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'33705d89-bca2-4ba9-ae46-fd0d1c360fec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'33887d84-87f3-4544-b689-420c768b3ac7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'338b6a72-aa29-4710-b909-8cd9b66f0f17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'338e3fdb-c9c6-41aa-92dd-763ddee6f067'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'33a9f2de-8c0d-4192-a814-de37cb79c5c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'33ae431a-7cb4-4355-a1c1-a034ee54b537'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'33b4ffae-2dad-4a77-9558-7c8ceb6a1501'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'33bc83bf-03ab-4bb8-9ae8-95a01bbb6242'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'33bd606c-3626-49aa-82b3-7f7efae83e6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'33c41065-194f-4a58-80f4-ffa8629b56d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'33ccd329-420c-41a3-a1bc-b46a422952b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'33d0ef8b-33c7-4dec-bd60-693d41fe720b'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'33d6cf37-4501-41c5-ad6e-2d54621007ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'33de86a1-e01c-4b6a-8071-0b3bcdbe486a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'33e07775-017f-4953-baa0-98560af044b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'33f6e274-eec6-4c5e-8d6e-04e8d1678340'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'34026fda-8bf8-4f53-90e3-6f6ee912edc1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'340783c1-3e15-4e39-be90-ff1297123df7'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3407aa67-1ae3-423e-a4fb-4c9ebc8d7554'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'340ebcf6-424c-4f23-b492-8b8f80dc5a5b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3410397e-0b99-4954-8ab4-0d9b7d8a5101'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'342329bd-07c8-4c1d-944f-169fd0de6ce1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3424d713-407d-4d32-9e6a-e00b343aa9d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'342b1f3b-54c5-461e-ae00-28108d46b0bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'34301f1b-e71d-42a6-9303-b68f9b0e77e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3432b89c-9690-4a73-bfc4-7f61345a6f44'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3433f54a-ed90-4839-b348-48738d523ddf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3435f44a-b19f-4551-945d-64372e920ded'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'343f48bf-c131-47f3-8204-baac4ff8319a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3443021d-5e14-4a9a-8d2b-365458b4d0bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'3456bfc7-3a99-49e0-9254-72a4dac164c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3466afb9-c4c2-4b19-a519-f5b193024f2a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'3472b064-58a5-48aa-8f0c-be9a914663b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'347463af-edfe-4039-8c33-51db59a1ed63'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'34754073-9ba5-408f-94c4-29ee442c7cdd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'34777173-352b-452e-92a8-1bdb09fa410e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'34786c0e-2d71-4521-9818-8dc5f2a3e6e3'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|>=200mL<400mL|Aphr not automated|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'347a244d-4397-437b-bec6-10e86be6efc5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'347f3a92-97e2-4edb-844c-fd01a55fb17d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3481e5a9-1f57-4d60-beb8-6ee212cfa282'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'34823928-4782-4aa9-80bb-8ba0474ae36f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3484ff8c-22ee-454a-b730-f0cb01ce780b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3486836f-7626-4e4f-bfd6-7c7b4ebd8bef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'348943d8-9c9d-445e-9a7a-78205f466a4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'348cb10a-0bf4-4375-8edd-3f5d5dd5563d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'348ea3ce-8d15-49b9-9f0b-d4aa1b98a45c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'3491c4bd-027c-499b-b9a5-900a544e38a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'34a171f0-936d-45b3-b312-d10c2b42fd77'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'34b348a1-2501-45d6-80ea-a344e704f022'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'34b3ca0b-eaa7-48d5-8969-fc2b1be1e737'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'34bf2f0a-25a4-49b1-afaa-6525c09b2389'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'34c68c63-2e1e-4dc7-9f81-1c77ca004adf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'34c6dac2-d454-4e92-8e0d-638c2757ec41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'34ca7763-7307-4534-b829-ebd6f956dedc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'34cb1e09-ffba-43b7-bdc9-717a960f46bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'34d4e45b-a391-4f78-96bb-209c3d48b1be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'34dd011d-53ae-43f0-a88b-7ff076bb7aa5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'34dfae01-f1fb-4c8c-be58-9ba86b7b5d67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'34edf622-f4f7-4f75-b0df-d3a581b58681'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'350bc9f1-04f7-4ca3-a309-89e5cbd1fe1d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'3513d27e-5f4d-4ff2-a915-0f39e11e9d3d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3513e8ee-e3a4-4da7-9731-30563b5c2b49'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'351ee22a-9457-459d-b8dc-d1fc9dbc94d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'35229bcf-f33a-493b-a311-e5364d223694'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'352d8cd1-0eb2-4530-b355-683e365fdfff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'354305df-d758-4978-bc40-3643cf232786'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'354de31e-68ed-4bac-83af-e5ac3fcf1329'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'35584f92-98eb-43ad-90fe-38606673b08a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'355d2f0b-0d57-4292-bbb7-0ba931f0aafa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3562c298-f702-4704-aa6a-4b0f33f751cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'3562e5f8-f7d8-4546-a1a0-95d3274d3a9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'356af699-3b07-4bc9-bcbd-18fcf94aac8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'356c36bc-6ed5-482e-9d07-22c176180044'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'356cf127-7eb2-4130-a173-587b75deca08'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'356e2d3a-a2dd-46be-b50a-cb12a4db95d1'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3570cb0c-6600-4adf-92c9-638a6ca8ca45'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'35828280-e1d2-44d8-92ba-f2f487403837'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3588499e-907b-4e91-9112-b9a388bfafcb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'35898cd8-4a3c-48a9-9db8-a370e7e355ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'359fdd4e-f370-4d31-8005-a66bf0e786e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'35aa9cb5-846d-41be-b466-cd6f56a0b1aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'35aed880-8d18-4956-9393-97c4f59501af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'35b1bfb0-cce1-4bd4-9ea0-48984d2251d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'35bbad8e-4365-479a-b2a0-4b098b792323'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'35c91307-faf8-4a74-87a6-6a2840a075f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'35cde457-74d7-4c24-8723-faec23c913d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'35ce5d0f-d5ed-43a8-9be6-6641f4ec302d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'35d023d5-7524-4e3f-b4c2-5d2e74d94d3e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'35d2b26c-cb13-4984-84fb-0f7828afedf0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'35d7588a-8249-43ea-bc0c-abde4e919425'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'35da6e3c-dd5e-4fc5-b537-783a94cf2a6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'35e4e980-c8c7-49e7-98f4-07e33923b347'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'35e749ef-c166-4764-936a-2cefaabafc0e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'35e768fc-17d1-46ba-ad6e-430e5241c8d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3602859a-41c1-4728-a616-13eef65ff24f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'360b3120-0cd6-438c-b377-e734ecbfe28d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'3615970e-29ea-4e5d-9d92-c2bd3caca143'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'361ab527-3a1f-4e22-ae00-a278d68f1ebb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'361b08f3-0a47-454f-9fe6-776592114465'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Irradiated|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'361cbfbf-d3ad-4a10-8f36-3cd9f760a666'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'362265ca-bb77-4b72-a13a-787035f04d02'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3624fb9d-38ca-4c94-a887-3adcf6bb6fc7'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'362c7e13-6f0a-4f2a-a9d1-e019674f7fe7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'362f5218-af4d-4ca0-b364-91c10cd5b103'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3637a9cf-e394-4440-9241-553fb31ce21b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'36420e85-cfe3-41b1-aef5-8c2fd83db504'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'3643828a-7742-4898-b9ba-62a4939567c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'3643eac3-2911-46bb-84bb-ef1adef1c367'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'36456102-5529-42ee-9560-9ec617e734b7'
UPDATE dbo.BloodProduct SET ProductName=N'Washed Thawed POOLED PLATELETS|NS/XX/20-24C|Open|ResLeu:<1log6|Buffy coat plts prep|From 4 donors', ProductShortName=N'PLT Pool Thaw Wash NS OPN LUKOPR BUFCT 4DNR', ProductTypeCode=N'E023', ProductAttributeForm=N'@72 B2 D5 G2 J4', OriginalProductTypeCode=N'E064', LastUpdateDate='20110509 11:08:37.280' WHERE BloodProductGuid=N'364d22c6-9fb9-4a06-ab55-a9950566d86d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'3650dda4-7299-4119-836a-3a01ba3bb1bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3651f160-8753-4028-9629-2ecaa598a114'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'36649355-6810-47b6-8119-ac6b57ed8a58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'3664e118-47e6-492e-ac94-f99daac20f8c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'36668e05-789f-44e2-b89f-ec5c9d568c78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'36672499-9a8a-4834-8a63-f99cb959bf2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E032' WHERE BloodProductGuid=N'367834e9-8ebe-4fd7-ac94-ceeb7f7fb4bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'367cdd85-3f92-4b0b-b07a-e19d460242d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'367ddedb-c03b-4cd4-9dfb-1e1bae35a77f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'368f5d45-db9c-42e2-9c79-b11f62047306'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'3698c6a4-6e68-46f7-af33-3932cf3f5eb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'36a0ff79-8cd6-4627-ac7b-aeba47e58906'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'36a9651d-67ce-459c-830b-b4174373de5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'36aa811d-cd0d-4e2d-8253-aeb44c033206'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'36ad931b-d01f-4997-8b92-6a52dcd2faf4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'36b1446a-eaef-46a2-99f1-bc0d884a3673'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'36b8b83d-323d-4ba6-a179-f765d8fd90fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'36bb2f47-75be-41dd-87cf-0b4334f16f1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'36df9a97-a579-473f-a475-ec840dd8b666'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'36e3a399-d460-4ea6-83b3-800c62522da4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'36e6b16c-826d-48e4-9dcc-aaa388731ff4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'36eea089-4032-4a77-9121-dd8eb8444cda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'36fbe125-bc66-4185-a368-0d0e430b2f78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3706da1e-33ba-4f4c-96c6-fca09e37c53c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'37094f89-050a-4045-9cd0-5cfac57341fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'370a121f-403f-479d-9b06-cdb33b770e7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'370ee9ab-e1d5-4a13-85fe-adef3b4fa249'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'371074a8-c2f0-4cae-8ef5-10707e902d87'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3713d767-c03d-40b1-87d7-ffad27893e93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3724a81a-1d75-47bd-850f-7698d535e326'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'3726f905-daf6-4783-8b0d-8479ef948f3d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'37277309-d319-42ba-a63d-167d068178ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'372bcc45-b870-45d3-a1eb-8c962ac3f7af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'3737b0f3-7eb0-495d-b65b-35a2578f6e42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'373d11dd-dfb9-4aa1-a9e3-cb9d8a536178'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'3747cb82-e1c4-45c4-bbcb-c67f342fc0c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'374c1271-a6de-4f7c-819d-e0c62c4306e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'3755424c-faa0-4e25-aa24-37f5edbc2041'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'3764a09a-26c3-46f0-8c4c-e88879929308'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'376fd520-d8b4-48ab-b06a-3568870b3426'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'37770885-8336-4111-bdb7-8693e53e46b8'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'377b6c97-4337-4913-83d3-667a861385ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'379f237e-115d-41a8-a1f6-b12c17a78985'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'37a6c02b-330a-4892-b830-882bea8f7594'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'37a97906-c713-4a24-bc56-e848c6fc3c66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'37abf122-48f3-4255-996b-375d840ba76e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'37acdec8-0c20-4edf-a0d2-fe183ac2c308'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'37c361ca-bd93-4e42-8159-6c0f8d8fd57a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'37d1dc6e-1129-4528-ad84-8027570ce513'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'37d28181-b2f6-4265-b8ff-70a833e657c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'37e031ad-37a6-431b-bda8-a9ca78fde244'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'37e6d83f-80d5-4c63-b96d-07489bbaeff3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'37eaf440-df16-4d43-92c4-b60b161cebc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'37ef2b91-0e6b-4517-9fc0-2b9d84a0b870'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'37f2d02a-3b42-44a6-b934-0d795489061f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'37f4fc8c-e8ec-423c-afed-4be1bf21baa9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'37f8e400-eb87-4477-b474-74a3b2a91952'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'380acc8f-ea42-4e97-87c8-fc79408b3c29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'380bc79e-85a5-4bde-94eb-fa7b8a707eae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'38107b24-9bd0-4a55-9995-cccd903c3aa3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3827d212-cc76-4316-af22-d8141250732e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'382ae367-1f72-4c24-a02d-5d203887fca6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'382bbceb-ef0c-487d-9fdb-5b9fe701720c'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-65C|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'38414e6d-17e8-48a7-a6ee-ca1f682d1012'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'38525c45-600b-4384-a730-9fbb3e200a50'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'3853f39f-e853-4a3f-8adf-307b3e28c15b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'385d823e-7039-4447-a735-bd4bd4603022'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'38643514-2b25-485d-a482-070819602bae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'386eda0d-c2a8-4c38-b230-871b37adff21'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Not for tx or mnf|Open|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'386f2344-eab9-4d8d-b879-f3d4da67013d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3875debe-2d15-4f6f-a6ea-93618868c05f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3881eb27-0dcf-4224-9ef4-384a99bae342'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'3884d6ca-036d-4d72-bb20-ea547ce4a794'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'388f2b9f-5072-4ff3-a12b-d46a332be9f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3893896f-3b65-4898-bb20-325d9e47c705'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'38b05d78-f314-4069-ac50-48e03de149eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'38b2da12-0d6e-40c7-b31c-5d54cde251ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'38c1a8ca-c286-4b12-b234-0dc7517e8528'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'38c3c5dc-a186-4d8f-bbbc-2371b385ac99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'38cabcf4-7ffc-4177-8a5c-047143eec97a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'38d98104-b367-4122-a275-529bdd27fda7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'38da1efc-2ba1-4b07-a3ec-fff77aba82ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'38debd08-de2e-40b6-a845-a088e0c8bba7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'38e26340-8987-4b1b-892f-e36345ffe216'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'38e31278-5a2d-41da-8242-d669f0456158'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'38f3db0c-f563-4bf8-8e71-e0cb85c04c5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'38f9bf65-1863-483f-b5d2-8e969b186920'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'38ff8ab9-8e46-488d-9319-6aefcc94e7cc'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'39092792-ad98-4009-b9fb-610e47bfe1e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'390a1563-1a34-4b52-ba3f-f25313ec0a67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'390ce1d7-2c61-4c1f-9b82-d453a1e88c4a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'390f0eb8-c212-4c35-bc2a-5327926c98e2'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3918edad-c188-48c7-8e52-c41a4fdd7406'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'39199341-57c2-4e55-9365-a95654869fb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'391cfb8b-8029-4784-9e06-99dcac90dadf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'391ec102-3abc-44d6-af57-2b1fa3666252'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3921c4d8-937f-4e5c-9bb9-ccfc9ff849e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'39230702-bf45-4cee-a378-9cfe8c588fcd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'39255f80-5186-47a8-a7fd-f07dc0a81c2d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'392851cd-1227-4665-995b-6ece15fe3231'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'392a9cb7-baea-4f90-a798-6aa6bf7fa5f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'392f1e63-f80c-4cd1-8165-e13251bdc749'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'39340f8a-648f-48e0-8ecb-65262bafe69a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'393a3721-4cd4-4650-89a3-aaba7965d481'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Open|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'393affe8-7cf5-4941-844b-7ae1222fa490'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'393f999c-a171-4058-8e2d-de71a85ff455'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'39465891-9bc4-41be-a244-dd5afb728a20'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'394dc7cd-f758-4f5f-bf9a-a4b720eeed16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'39507886-95fc-4d99-ad5f-f688fe8f8f4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3954a3ee-ec84-4637-a516-fb27f2d5301f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'395648e3-654d-4d16-a696-b17a6fddf2d5'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<=-18C|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'395a8eed-5db7-4293-b5ea-bc58d8289e81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'395f50ae-f632-4601-867c-c76f1e57d2f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'39628508-b62f-48a8-b4f7-ccf7ee05feb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3981ddb0-0647-4cad-91a3-de5b00ee54cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3985ee0d-0ac1-436c-a94d-588a9cc1ed13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'39962025-275a-4a1b-889e-fc56a7e73ec8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'3996963d-ad36-44ef-ab61-fafe1db86f95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'39af71f7-ed04-43f5-8d3a-c6bbfd375c7a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'39b1349e-7bb5-4fca-8e3c-987fe97059c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'39b15078-895b-4a77-be05-cc69f7b67b0c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'39b7f594-e39f-475c-980a-77fd793fc0d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'39b83afd-d25e-4423-81b5-38447dc756e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'39bd5148-c581-4434-9698-1edfbb4bf215'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:noninjectable|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'39c4f586-597e-46e1-bece-5acc5e3d44a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'39cb1eb9-c530-47d4-84f2-89af7ce910f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'39d7c8f8-bbc1-471c-aa49-0347535f532a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'39e4e9f2-4b8c-4fa8-8032-d21bdc943f64'
UPDATE dbo.BloodProduct SET ProductName=N'RED BLOOD CELLS|CPD/450mL/refg|ResLeu:<5log6|0.5-0.6', OriginalProductTypeCode=N'E002', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'39ee3594-c18f-422c-864e-b9e494bb7e2d'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'39fbefa4-8974-4a75-8131-3cf0da3236c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'39fe817f-8771-4b90-b95f-3db5af0de720'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<=-18C|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3a008efd-75e2-40fa-a0da-9555393c3299'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3a0b8f0f-08af-4650-8758-5a04321babd8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3a128b61-53f5-45d6-b4a7-b5855c6e5ebb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3a12af27-418d-48f6-931e-a0ec391b042d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3a14197f-0741-41e9-a2d6-f59d600dbd57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'3a15ec67-42de-4aec-9bc1-a0c901bb980f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3a19e9ce-ba0f-4c00-b340-05833fbb7e10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3a1d9fb2-ce7f-4b3a-8580-d89f320b49e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3a1dc6f2-dedd-4367-8dc5-9260a35cca29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3a1f78e3-e1b9-48dc-921e-5efbabbfe472'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3a283665-84c1-4dff-b2b9-7de36ef38f61'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'3a30606a-33a2-46e3-a511-d1429c4b9b65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3a31f48c-861e-4a0a-8c34-3ebdd98f083e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3a3c3793-b1a6-48e1-a462-ca26e589371a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'3a414442-a710-40b4-9d22-57e0c308a048'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'3a518b9d-abaa-4ac6-ba01-9c71e419e92e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3a655f1a-15b2-4a30-88a7-26fe763860bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3a6da786-07cf-42d7-8e47-fdd79a32c224'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3a72c686-ac0d-4be2-99a0-9aa1aa2fca94'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3a747901-d88a-489f-a0c4-5177c627c3a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3a757c16-2ae7-49d1-b2d2-ffff3d56d922'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3a76d7ca-6f84-42d2-8649-cba971bbb27d'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3a7f63da-9095-46d0-9811-f8884f0ad0d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3a942cdb-2d55-41bf-851c-a559795f96ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3a9461b7-3d25-4d9c-87dd-06e07fd58f98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'3a9965d2-d6e4-4e3b-b998-3f0a2f3d374c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'3a9c4936-4c8b-43c3-a216-e4776e51ca13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3a9d0a1c-a857-4ab3-b452-6817ad963419'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3a9d955a-2fef-4942-be70-fe9292be4bf1'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Irradiated|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3aa74b6f-2324-4598-ba6b-e6fa96f118bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3ab5755d-3f8f-421f-9e99-d04eb33fe676'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3ab898b6-4475-409c-b142-6fc763f5df6c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3ab9dd68-ffc6-4d5f-93c7-52b7defa056b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'3ac19c66-15df-4efb-8526-b3d276a70ad9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3ac67d45-094d-4167-a297-206f16f3645c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3ace47aa-0775-4419-a68f-b2f56cd903e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'3ace7e2a-d1e5-4cb6-b6ce-df569e120898'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3ae94336-67a1-4676-9075-81f9f710b0f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3aef9538-e817-45a8-94e0-29f5ef49c6bb'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3afc5dc6-47d1-43f6-b4eb-045c381e0334'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'3aff0278-a75e-481d-8c87-d8cbb586f053'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3b01d3e0-c69a-474c-8f2d-8beedd1b8832'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'3b05248d-c73b-4700-b35e-ba4590bf36c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3b06ccfe-a5d0-41ad-9d7e-fb104ffcaabe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3b11a5a4-a165-4e34-9754-5b15ef02d54a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3b17c4f9-9a32-4424-8abb-812bba469608'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3b1927c4-5b38-4a7f-b673-f5d25e7054b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'3b20eb7c-b810-480a-8009-6380d1cfe506'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'3b2daa06-4d56-458a-be87-0d8a4975af56'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3b3158d5-d86e-4d27-be6f-4cb114ec56fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3b3806a2-e974-48ae-8f5b-c4db34b230c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'3b4e319a-a425-4bae-aac4-4be11b90bfe5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3b5488f4-f037-45e5-8561-66e85354efb5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'3b6d5d75-cda2-44e4-a7fb-82da72b09f52'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Cryo reduced|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3b71e033-71c2-4658-8e50-efd8a6ca1ddf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3b738bdd-f9bb-4743-a81d-2269eb5936ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3b73ea4f-caea-411a-bf1f-1e4b30618dd5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3b767e80-94cb-485f-85f4-19f720c39f88'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'3b7759cd-839e-44ad-9b01-13164f586934'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'3b8effc7-3631-4863-bb7d-14180c84e29b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'3b910da2-85f1-42ba-a184-4fde336d7800'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3b99a627-e85f-4897-9c7f-419a91f82de5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3b9d07f3-75bf-41b6-9b29-057f6ff6dd2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3ba16228-a9d4-43ba-b885-299bce216733'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3ba7930d-f23e-4cfc-95e0-d6d0f79cd5c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'3baab570-bf7c-4b63-8faa-8c8746e61401'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'3baab6d8-f846-4268-a758-9aea14d30d7f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3bb27522-17ae-4c7b-aae6-45f12050fe6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'3bb2b4f1-4ff3-4c78-a8a9-9464719228eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3bbb03fd-4621-4bbf-ba1c-312836d74025'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'3bbbb83e-c615-4d4f-aa7f-48deffb17ea2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3bc2c4d5-3f03-458b-9bb2-15e2894b9731'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'3bc93050-b8c7-4716-8929-964030893ec3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3bd09bc7-ecc5-473d-a413-796388336f65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'3bda9e16-aa99-4fd2-96f4-50068b051cf4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3bdbf080-1998-4eeb-a625-90c16df98401'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Not for tx or mnf|Open|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3bec6317-1aa3-48e9-824a-0c3c6b5ee681'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'3bee4b90-acc4-460b-9378-cf9d0f55b1d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3bf00516-3514-4541-b31a-200afe4f28f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3bf3bf07-4d65-465a-bf2a-f93b3d4e821d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'3bf8b415-cd48-48a4-8607-8887ddda1f0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3c014544-efe6-44c3-9d57-951b49903b78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3c03d975-e447-46be-acce-cfd0ea70bc8b'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3c07350c-8773-4ed4-8664-1995677ded5e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3c08e65e-2310-43ab-9588-2efa5b6ca204'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3c0c2373-36ec-4417-bebf-b2471ee6a835'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'3c0cec08-697a-4631-8abc-3d01aa55ee74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3c1d1f8e-14ba-48e2-b1e3-d6fb724a3b80'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3c1d5b44-b89d-4eeb-822a-7faa0ee3926b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'3c1e6078-5707-4346-aa7b-30f41fc89696'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'3c1ed1c5-e237-494d-9e9c-7ed62544c0a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3c2ddb5a-76c4-46a3-8c33-ed27bc04fa2d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'3c326cea-b961-401a-917e-c5dcdafa09a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3c348810-387e-470b-9907-0b23f91a1a73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'3c3a1a41-d97e-4683-8705-9b027ec88a5c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3c3c7077-3a5d-4cda-a657-9b84fa15d609'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'3c3e2dcf-8859-4860-9f2c-589a14e2a1e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'3c42dc86-915c-4a39-aeef-473d8c038fe6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3c4d6be9-e291-47bc-85a8-142f5c6a1af2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'3c52fcf4-a559-4618-bad6-20ae230dfc79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'3c545db8-52f9-499f-932a-67142ef2c190'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3c645895-f94b-43e5-9d61-d6a60783f97e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'3c6c9fda-598c-4a3e-bb86-579d048ec729'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3c6cc9d2-6b11-4bd9-8dae-48a6a06c309b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3c754938-3035-4126-89b4-8ef660295f75'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3c812610-48ee-482f-b9c3-4be535dc92a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3c82e58f-b79e-4178-b969-795080a98814'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'3c87563b-07ce-49a3-ba26-78266510d001'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3ca23cfa-f6e9-4d7b-9a4d-0446ac0599c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'3ca31adf-080b-4f8a-97de-2b9594263df6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'3caec97f-9265-4755-80d4-8d8c8f673856'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3cb6ff05-3f4c-4917-bab8-967a73a3adb5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'3cc30e54-2e18-4e3b-b8a1-7dcde97e5f57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3cc467c9-59fe-49c3-9cf9-d6f762d5a85d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3cc8830a-4669-4ec6-9d8a-c2fa5ca42815'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'3cd3b4d6-cea5-4941-8413-393b2a113bcd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3cdfc506-a803-4376-8e99-a15b96f5dab4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'3ce0e301-bf84-40df-955c-72c929ba26b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'3cf222e7-5f90-467b-9a9a-82208e240427'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'3cf30980-9141-4eff-b83d-f8848e6d1475'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'3cfd96e3-1c9f-4560-a58f-ec48d5d4f44f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3d055067-9513-4831-9d67-1749ae884f1c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'3d11d61d-2340-4216-9fc5-005717f2418a'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3d183c31-6e4a-4312-9db6-108fe33c5de3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3d2ae287-986d-4f2c-bcb8-98b8ffeb9f7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3d31de04-e922-4ccf-81e4-77fe5b334898'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'3d35bf23-1001-4d15-ae79-beb005ff5cb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'3d39bc60-6766-4dbf-b4a5-fa36b888dd5f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3d48ba1d-580a-4c18-9bcb-8210e3f17eba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3d4efbef-e290-47c0-a90a-0812cf5e86c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3d500879-85ba-4cae-bf78-5bb14d1f2277'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'3d50614f-3f9d-4536-a0cb-f0b64fe539fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3d5b48da-e624-4859-8fa1-092577dcee93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'3d5d1b10-8ddb-4b1e-820a-f4af6c30c0c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'3d6abfbe-657f-4427-bd31-d361c0a902f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3d703efc-18e2-484b-b580-e118465d9c34'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3d75d3a9-0869-4773-8f5f-f85da208d266'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'3d7a4a55-f7c0-4975-a5ef-da197546800a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3d8e65da-64b2-4ddb-a73f-964d9b1d8444'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-65C|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3d8f9df8-dd8a-43b6-bd21-181cbc5390c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3d9a084d-b77d-4648-924d-acfe242e5728'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3da147b5-8957-4b92-af41-98084084382e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'3da20ebb-e201-4a11-8e86-91560dc424a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3da523cd-69f8-485e-9fdf-b56fda490eeb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3dc78d12-a2ac-4cc6-a880-71cf73b52a84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3dcdfc40-f757-4021-b3f5-a8d32fa148c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'3ddbc39b-38cb-4ce0-b9e1-b6d0f24e4448'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3dde189e-f581-4eb0-bcb2-f44d3d7ff52b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3de50e94-d473-4b7b-a9f8-dcab6dc74372'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3de6debf-2a51-49b0-9a71-27b322840d97'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'3dec1afd-7f29-4b21-80f8-2a692b8f7987'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'3df3181d-d139-4a7a-889d-1df0b10e1ca6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E042' WHERE BloodProductGuid=N'3df49eec-0d81-4e39-85dd-9bb14ac23cc3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'3df4b734-c97a-4234-8242-46fa596e9dd8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3e01f254-a331-4c57-ae87-7af6aa69544b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3e09bad3-bbc5-4ff7-9e5c-068c405a1ae8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3e15d9f2-06a3-45c3-a028-5633bec1a9af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'3e1c6dd8-4963-4a56-af48-488c9c19634e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'3e1dc247-eafd-48cd-8c8c-22bb65939373'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3e208512-7043-4b7c-8ba1-69190096a267'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3e24e88d-12aa-4edd-a962-b439f22fd22e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'3e2d54dd-0f29-4e23-a7a6-733925a20879'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'3e3441c8-9aef-4ff1-b2c8-25d1ab5c54bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3e3acdd0-0c88-4431-91c9-87afe454bcd3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3e3b4d7a-31f5-4bdc-9102-28a93d435b5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3e3d2516-0a6d-405c-9f58-8a4c465af6fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'3e3d3a1a-3173-46a0-a9cc-083a20ffa516'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'3e49a2f2-c04f-4871-a87a-408b6a8d5b86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'3e4f0328-1b70-49b1-a25e-b75cd82bcc24'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3e5447ed-96f1-43e4-a6bd-bb58d47e203e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3e57428d-e789-41c9-8990-8efca23bae51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3e57e795-9c70-4276-a7b5-ed33421ddf9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'3e65f7f3-f179-4cbb-ad93-7493bc2ff7aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'3e67c1c8-1ac7-4405-a0a0-79955e601deb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3e79b399-4a78-45b5-8a2a-384486e1bad6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3e7a9127-f3fd-45c3-9265-a1b4de6b8ecb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3e7afa35-5e08-47d1-9583-3d6f75f3af1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3e7f25a1-139d-4795-83c6-a86b89a2e9a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3e853e92-9dec-41cf-a29e-03a189fbab06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3e95ffa2-ef67-43bd-96c3-d49f00e4e1da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3e9efd52-315a-47ab-af64-3abd91436f0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'3eb04169-11d1-47df-ab04-404e7f26b506'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3eb1c0a4-cd16-4770-a599-394f7b29f89f'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-65C|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3eb5a15f-26ba-44e7-8cc5-5054f2009257'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|>=200mL<400mL|Aphr not automated|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3ebc6bf0-db71-4eee-af61-c6953859c3f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'3ec6abb0-bf23-466a-af6f-75405ef2f31e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3ecf8ead-7b4e-461a-8864-3d8af391e72a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3ed31488-17a2-4cc7-bdbb-14da3f3cdd30'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3ed3f4c1-1a04-4ba5-b106-226925a010ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3ed6bdca-8bb2-476b-ad99-404526c77f1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'3ed87390-3a22-4a0b-b643-cda71d833553'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3edd6947-fda6-4c4d-95ca-02d3233bc595'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'3ede4435-ce16-4363-ac87-5d138e46512a'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3edef728-cf10-4f3d-bb83-68954d58701b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3edf6a37-5778-40c9-ab52-e04f8bff34b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3ee21e24-c4fd-4449-9814-ce460a3c1c39'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3ee7808e-75a1-478f-b60e-65b319446dcb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'3eeb70ff-85c7-402c-9f4a-3c3ab27f0f15'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3eef2675-5097-41c5-a9ff-f4903ad5e537'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3ef99c77-7167-4691-beca-b96fa4743e53'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3efd0732-6616-440d-b0e8-876d14480142'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'3efd67d3-9a1b-4e55-9904-093adf579bf8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3f0af384-de39-4069-ad78-7a6555764342'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3f0f654a-195e-4838-8053-9cb4773b07ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'3f1b15e7-b809-4860-8715-962eefaaa41a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'3f30f65e-f588-4c91-9210-43f9f2137b4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'3f3c7bfd-fca9-4d86-8e40-ba16bf46748d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3f3ce607-4410-49f8-a7ec-ad5443c5bc11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3f4ab255-2a1f-4b08-841e-ddddcc980e31'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3f5cd9e2-3584-42b4-98e1-6171d408a074'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3f6665f3-a044-41af-98f0-a4e3b5d836bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'3f72d394-598a-4fc0-a647-7392c1887fb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'3f7867de-3598-4d92-a9e0-e224cbc71361'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3f7cc88c-ff96-4b44-a639-c6aee054927a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3f84e459-5adc-4610-bea2-6c910534d808'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E048' WHERE BloodProductGuid=N'3f873c3a-e477-486d-9941-9bb213417186'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'3f8fb11d-5a65-447b-b82d-aa68231758b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'3f92d441-b864-4c3d-8829-861fbefec54b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'3f944d58-2202-45d8-88ad-d0527cf08b7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3f9881ec-dc14-452a-a447-77e0682df6e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3fa08980-1faf-491e-9cd7-fc5d33bea369'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3fa4b3d4-381d-4eb2-82a0-08a008cdb185'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'3fac34bd-b215-4d5d-b93f-821685ffb078'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'3fac80b4-2816-4b95-844e-811494b8c92e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'3fb2121b-7d19-484e-9521-49b50bf0739a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'3fb68c2c-12d7-46d8-95e4-37fcc3e5cb84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3fbd327a-5e99-499e-bb1b-f9dcec3d23f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'3fcf92e4-bd16-4313-bd93-2086b36536d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'3fd53df2-7f7b-4028-861d-3f5c88081db8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'3fd75a2d-08ee-40fd-9831-912f11ffcb9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'3ff816ca-af4f-4339-b247-6958728bf6e8'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:injectable|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'3ffb0a1b-f382-4a82-9ab6-1f2e789e21c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'3ffe8d6e-0879-4242-8c34-5b4befdc53fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'40077217-e908-4cc7-9d28-2596def840fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'40077458-119b-4b5e-b356-1ae8b7af315d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'400c3f4e-21cb-47ab-bddf-2affc2077ff5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'4019e9f6-0cfe-4cb3-8a60-156ab092a89f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'401a17e6-b346-452c-b2d6-a3a7c9a28c09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'401be781-3b69-469f-bf63-c39fd084c16a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'402384a6-c219-4609-b7d4-a1732c5701bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'402cfba2-0516-464f-88ac-be2e72047e53'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'402e54d6-d110-408a-b84c-2b9834e11012'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'40301dd3-2858-4005-b3ba-17614552107f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'4030e7ed-76ec-45aa-819f-aae1b203a8f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'403c9ec1-f0d1-4c52-b3f7-12ba1565b8dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'404050f7-b7cb-46f2-ae92-00a9727ed76c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'404314c3-f672-4b21-aa16-d86710d21fb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'40528d7b-7d6e-4c4a-946b-90fea38dffb9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'40532472-3cd5-4e12-89af-53e27014a296'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4054a915-7151-431f-aecb-ab304b163d30'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'40587c5a-db3c-46f4-a502-c117924b91a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'405eae20-6f52-4fc0-a641-a75bd8d98579'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'405fb34f-07c2-468d-9291-0323bff76475'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'406a4922-9623-4314-9c04-a24346985516'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'406ef830-0fd9-4f8f-ba01-5345ac1b253b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'4078b56b-4de5-46cd-afb1-fe0212027e6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'40815711-9857-4779-a88c-3fd1742ce619'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'40819107-5617-4932-ab44-59b6eb1b6507'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'408344ec-ac2e-45db-a6a8-d54326fc6a32'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'4098c277-3994-42e6-9750-b75b6c568002'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'409f278c-f862-49b1-a032-a4c5b89c1bfc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'40a045ef-11e8-45fd-9b0a-06c7fdb58f2d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'40a483c9-9d44-454c-844f-13a22b9c5673'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'40b0937a-557c-4115-99cb-61702159e816'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'40cc27ff-b33e-49a7-9af2-b79ea86385fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'40e2bceb-be3f-40ee-96a0-b79bc2dc0cd3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'40eced93-e586-4887-b57e-6f2a291020dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'4108f7ed-af4c-412f-afaf-c78f77943dba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'411128a1-1f7a-48dc-a426-eb35de30931b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'4114f3af-b7d9-400e-ac88-3e976e2d223b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'412651c4-0a68-488f-a16d-173bdb002040'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4127fba0-5abd-41ec-bd89-9c903a3aed4c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'41285d4e-7c14-40ee-b242-e97a1f989293'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E056' WHERE BloodProductGuid=N'4134b81b-d5df-4886-bb64-a218c663a79a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'41357784-4be4-4f79-b4d7-3d8528f23c0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4139adea-f82e-4fd1-b8ed-d6eba6af5de2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'413c8514-fa95-4455-94b6-e240aab546fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'4141029b-7d35-4989-b2d8-4320fee5a666'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'414a7e92-430c-4aaf-a5e0-f3e036dec2ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'414c6d0c-2211-4cf7-8d6f-9e0b44d4a172'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'415c75b6-fdd9-4caf-928b-ac0d1ac1adc3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'415c9bea-df39-40d1-8d9b-833110bccbb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4163a367-7abb-427b-9d55-56fbabec9cbf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'417381e3-02f1-40e0-8e00-44a9fc4ec88c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'417bb220-edda-4ced-963e-d0ad314c3ff6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'417bec4c-1ba6-435a-9d4a-e955ccdbee46'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'417cf047-87c2-4c02-a6cf-0ef0b1648327'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'418485ab-9ff9-487c-9469-8ffb15b54abb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'4187b787-7881-4f32-8b5f-35255a09a7db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'41888622-6f2f-4996-8e8a-c51bc75071bf'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:noninjectable|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'41a55963-5aa5-4dc0-924b-fef97e8711ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'41afa37a-e87e-43b1-a7d1-4d0b4da2064f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'41afc28f-1a9b-4ed6-90ee-255fb695492e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'41b77610-bf6a-4294-a457-cc5a59d10c16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'41b968d2-b0cc-4193-a09f-adafd9507bfc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'41bd4a9a-681f-4cfe-88c2-79d9ef984223'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'41c1ee9d-68c2-4926-81d3-c9506bae4ae8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'41ca1a94-888e-4037-a32b-8fa60d54e66a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'41cde27e-195d-4ba6-a022-d8ce335a29af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'41cfda4f-fe14-4961-9e95-73aeefb424d8'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-30C|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'41d57687-dded-41bc-933f-ee257ac0f989'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'41e33aeb-d1e4-4c6f-9f58-376c95f10966'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'41e35e26-773b-44e0-9a7a-d276636abcf1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'41ecc2ee-2441-4c4a-a363-0a07c17c493c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'41ed1fde-15cd-4e3c-9c4d-30b6c34cadb3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'41f2afdb-09cc-4454-b1ce-bde36ba7faeb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'41f85d0a-fb7f-4068-a38e-a36e450aa3d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'41fcd77d-ea65-4313-8cb0-7644dacdb858'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'41ff3394-1266-4bb0-86e3-be0edaf18a50'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'420d4302-47d1-484b-a4dc-00b409e20b9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'42161c37-fbed-45c4-a77e-1c49581fdaf8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'42168024-9fac-4109-84de-40b78de2aca6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'42182058-dbe2-4f3d-b850-e3909ea90bf4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'421abb50-a34c-4bf5-9e86-667eeaf1280a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'421c9668-3599-4a22-a182-a745f3114d39'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'422484ef-7769-4859-9807-6c6ceed2ea07'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'42370899-2998-4745-9ac9-fbead67b4d2b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'423c6694-0211-42f2-b430-23b91bcd6fba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'423e3fa6-1ba1-4ace-aaee-c236b94afaa4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'424eae06-18b5-4851-923e-c8b0474482a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'424f1f27-ec47-4ba4-af0a-c2a1ecaf2c7c'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'42549e7b-1ec9-48fa-873d-c40eae7f0ebb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'42577b5e-3c93-4e92-883d-4b97cfb1fb89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'42578a5e-3b7e-4c5b-a297-ac2fe4884c80'
UPDATE dbo.BloodProduct SET ProductName=N'FRESH FROZEN PLASMA|CPDA-1/450mL/<=-18C|Irradiated|ResLeu:<1log6', OriginalProductTypeCode=N'E010', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'426a103c-8e10-49ad-a1cc-3675c77bc3cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'426b8dce-2265-436a-a520-f30867c7afc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'42737b8e-07c0-4c5e-a822-8e4f1637d5a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E037' WHERE BloodProductGuid=N'4275c9d7-4a3e-440c-8aac-292c4238aa97'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'4282bfba-de31-4240-9210-b7c6838393fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'42920d66-4654-4566-9881-8dbbf033eec2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4296af12-7915-4a08-93b5-03d48f57d791'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4299de09-4d45-4718-9da7-6b31dc8e101b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'42a8d362-8fa3-466a-b808-4e480bc0e309'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'42aa818c-0698-401f-b13a-59bc6e0e318a'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Irradiated|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'42ad3044-8e8b-4944-847d-a685b0d249c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'42b67176-0fd8-4cbd-ab34-eb9a73dac9b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'42b87355-32f0-474a-bc68-aae549f13f29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'42bb9952-7221-4910-8fd1-2a5502fd8090'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'42c056b2-b28a-484d-b70b-c6b029119d6e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'42c318a5-94e4-4c58-bffc-b129f3373f04'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'42c95e45-cbbf-4d14-9a6a-afc1dd7dcba3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'42d2d69c-6841-4716-a874-80a98cfbbc33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'42d667f0-e51f-4f39-8264-6b7cc487e808'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'42e4c7ee-f86b-41e3-b9fd-e40185b55739'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'42f0dddb-f2cb-4dcd-a257-ac2a2a083777'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'42f53b8c-5df7-4450-8177-5d52a95e5d10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'42fa3a8a-870c-440b-b0d7-c45ce2873241'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'430a288f-b69b-4e48-a21d-1d0f41c9c5b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4317fe01-af0d-4b8b-88d9-c702ab17e9cb'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Irradiated|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'431bbd61-cf7c-44c2-beff-81595cb7d148'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'431d2e1a-b1ed-4983-971e-b0f88f245dc7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4327948c-7ede-48b3-9e5f-9c9cb7d07d91'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'432a0fad-6935-48ae-a856-a62a54e2703e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'432dadb0-8146-4296-9e48-87541672d07a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'432f6de5-c4ea-4f39-81a8-26259afe5257'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'433059cd-f746-441a-9926-7cc82d3e4985'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'43424619-f6fe-42fd-8b07-dce0fdfcf160'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'4345dc19-99c1-4c96-b997-40a43fd1ed54'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'434ba413-e0ce-444e-b490-c3578ecac3d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4355242b-8dfa-4487-be59-1ebb317db05a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4356242d-86bf-4930-8858-d7b56b5e212b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'435912c1-e75b-4584-90d2-7b3583d00d05'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'4365162d-3f22-4abf-9ce0-01ef8a64ea11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'436779e0-5f74-41be-9d00-50ea8a5cc5bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'436aac2f-a0f3-45df-b8db-a9cbb7b37c7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'436c3da3-9f68-4e60-b6b7-a7fc63caedc7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'43707a87-cb78-4591-bf37-69b7bfb419c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'437aa176-eff4-49ab-ada2-fc29bd5ddaeb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4381a136-2e3c-43bf-9286-416643a2669f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4384e934-7b74-4b70-8ce5-357dfc31da89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'438e1883-7265-4752-a8c9-6529ba6c1c96'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'439762aa-133e-46a0-9fa5-39e13a5d40e6'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'439d2e02-1626-464c-8a28-9a88d8248efe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'43a02027-028c-4e1f-9044-a6cbbc416c01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'43a11276-c106-42b7-bc83-5ebce42603d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'43a64514-e6fc-4ef0-84b9-7375ea62e19c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'43abb1e8-6a9b-4291-a9ec-b744f02f5223'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'43ac0a5c-3529-457d-8374-cc2e141c5adc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'43b7993d-1c3d-4cf5-9d90-bee6601ed1a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'43c17dab-57a9-4d0f-87e2-179e99de2c47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'43c42b91-a675-41bd-b190-4792d4642f88'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'43c7d099-4427-4e2f-ae18-0e8da78575c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'43d11a10-04d4-4ea5-8200-5a9198362fb2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'43d8fb72-5418-4411-8646-26f7b7888f05'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'43e0fc7e-6def-4607-afcc-1c530a005612'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'43e3728b-f86e-4da0-9eeb-8aede3c0c594'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'43eac84b-a900-4009-8c0c-6d152a1c6ed6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'43efdab1-708f-4227-96ce-eb9de824c1fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'43f0c3c6-c190-498e-b3be-ae72635e50c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'43fbebcd-6ded-4c88-89cd-1e5a56afee4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'43fe8568-c2f9-45cb-b243-5876f9db4807'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'4407b919-86b2-4a37-96b1-05ba5d82dfaf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'44095c21-6f2b-4797-b2c4-8a57622ae2b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'4414a97e-9cde-47b3-8943-4b868fdb66cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'442da798-eb6b-4581-adcc-1583a1a2d66c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'4437bd11-d322-4b05-b8c3-da72c504b6b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'4447bb8d-cd4d-496e-9517-45eafa057b81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4447e7e3-5629-4657-90e7-c9bf8d22f330'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'44516a3c-6f0b-449a-be0b-394eca59f154'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=200mL<400mL|Aphr not automated|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'44549de0-6f50-4449-a81a-484977906277'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'4464b54c-88be-4c2d-af73-214bc7366ce5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'446ab5be-94a6-4ee3-b703-e543780cd5fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'448ba819-f150-4d9d-97dd-f6b30badba5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'4495d2d0-7432-4cdf-ad67-fcf4bd2777f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4498a44b-0ef5-4fae-adc1-d455de1171c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'44a31411-76f8-4dc9-a9ae-66759d01d446'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'44a91eb3-63a5-49dc-9daf-bbf5429450e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'44b2f3f6-1379-4797-badd-065873b7118b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'44b51c8e-4ffc-4862-9e35-91badc6beea5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'44b56902-4718-40bb-b323-1310f0d646df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'44b5e02f-a73d-4474-9ab6-41036b960f3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'44bb136f-d268-4c0e-a6f1-37becd5858f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'44bdba38-7c5f-4149-a74d-462b6a17ce2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'44c26114-fb0b-46d6-8efe-56f967c99e59'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'44cff7a5-d2dc-43d2-8590-a1cf0174939e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'44e2cfc8-41bf-4a60-8e8c-d48e6ea13146'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'44edd6a5-a8bd-4a36-bfc9-6ba5f8711b2f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'44ee6709-367c-4f59-bf2d-a6cfe06e1ebb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'44f39195-b4f1-4a8f-ba16-01390a61e42b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'44f3d7f0-266e-435c-9414-793459d9e96d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'44fb8389-3752-4b29-be04-eb791332119b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'45024d57-82cc-4d5e-82a4-2d6740800c48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'45081308-5e51-405a-8330-d13bb4f2c529'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'450f7c05-1d88-4eda-9982-d8cc9401e4d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'45145b93-8eab-4b60-aeb0-025604039a24'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'451a00fe-7ad6-4a27-8d07-4628a2d44136'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'451f2e23-c5d1-4d56-8199-476c7d502442'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E032' WHERE BloodProductGuid=N'4535bf75-34d3-4869-8d70-37aea70d7733'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'454a2c12-0ea7-48a9-baf2-3e3987d7215c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'455c21cd-031b-4765-a278-e2a9eb3b4e8b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4561e0f1-1106-45cd-a6bd-0d30c239e816'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E059' WHERE BloodProductGuid=N'45620c60-a4be-4191-a6a4-998498822dbd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'456a36fa-be34-4eeb-bcc6-9448313d770c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'456ab147-1a68-403e-bcd7-ecc8f7763df4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4577c73a-a253-4e02-8e12-177f9f25fd84'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Not for tx or mnf|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'457ce649-b6d3-424d-aac0-4fafef37c4b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'457d67fc-3204-4f1c-a842-9bbde0aa2536'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'4582a2d6-a073-4dc2-aa28-b0557b4399f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4582c535-6914-4b2d-8838-2095b2f8b6d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'4583965f-2763-4941-b36a-18072c56ef13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4584b764-82f0-4268-9ebe-49eb4acfc87d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'458a3901-fcac-4ebe-9d8a-efa671b8c8f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'458cc536-e7bf-4978-8d3d-7650d93ac334'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'45986b58-4056-4b98-aa84-98da00a7f643'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'4599a584-e490-42e9-b8b6-a1cea2a2eace'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'459cb6fa-349b-46f6-91d5-0a6115123f02'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate = '20110510 07:59:27.820' WHERE BloodProductGuid=N'45a53429-3b01-41b1-b15c-0c165c6600de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'45b7af8f-1758-4798-8c85-b5460d33cefc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'45ba2465-55fe-4292-a07c-eb3c7fe81d57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'45bc2066-51a3-4492-8736-bd14907df0c8'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'45ca564f-98bd-4b30-993b-415d4abf5082'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'45d0036d-67da-4a7a-83cd-877ef7da3007'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'45d643f8-ec29-4ecf-8eb3-0e5241f9fecb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'45ea865e-a8f0-4f37-9088-1b81ad47739e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'45ebb88c-9b70-4f60-a083-aa2ba6f38ef2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'45ec02cb-5a20-4522-997a-6a7cdc58b02f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'45fb993d-5fb5-4948-8f33-02808a5ff057'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4607291b-4d63-435d-a3d5-f89b25552643'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'460dff6a-bc84-47c8-bec3-9d193bc33941'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'46112c71-a3a1-481a-a7fb-7f772d7554a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'461382c7-a3de-47d6-ae2f-1afb3fbacda8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'461b1167-b838-4a36-bfba-a47aad362520'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'461d4219-a3b9-4124-b7f6-1cd490e10daf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'461f32cf-2327-4abe-b2ff-f01d7c63117d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'462c9483-b68b-4db8-aae8-2b0b5608090c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'462fd622-c6f2-4880-8ba7-9a293d547928'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'462fe04e-f9b7-4e5d-b6c5-de7671d5fffa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'4638f8bc-5694-4ee6-8eae-67145a065b7a'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'463e5fc5-e4a6-44bc-9653-820121a85ca7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4645843a-a708-4554-b589-a329408493e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4645eee8-ce50-4c1a-acb3-aff79b2c6bf3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'464795ce-81b2-471b-a564-9099fea5ff34'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'464b189a-a928-4895-952b-33b1c6c9b0a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'465263ba-86ce-4fde-8223-66846b5bb2bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'4659340a-9743-413f-817b-a45358e649d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'465d2e08-22c1-4d70-ba0a-a7a609acfb1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'466bbb57-8ebe-418f-90d4-67230680201e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'4671abf1-77f9-49c5-b7c1-d23aa8d3de19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'4672ddef-bea4-418b-bf8a-2433c920dec7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'467efe86-4459-4457-8c64-0e9ab9be7bec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'4688ff8b-1b2f-4082-8210-311d2a577e42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'4693f661-0a15-4f09-a13a-783bc0aa3282'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'46980d02-02f3-48e7-89cf-12594850ba51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'46a146f3-98ae-4462-af3d-25a4921b85ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'46a148c9-3c01-4a1e-9522-3468615db57c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'46a19a31-3c52-4be5-aa1b-1827ae8115af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'46a30cee-9b04-4e12-853e-3588d70da130'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'46a94c0b-fb3a-411d-bbe3-54603098f524'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLATELETS|DMSO/XX/20-24C|Open|ResLeu:<1log6', OriginalProductTypeCode=N'E026', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'46b1d866-593d-4071-8abc-09fca3419868'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'46b430bd-a5e6-4e4a-9de6-4872bd5f7029'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'46b7d6ab-8d19-4b27-8fd3-2072255f38aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'46bc01c6-5c9e-4cb2-b90b-4c1ff5eda4ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'46beff0d-9af2-49fb-bcbf-3dd56594e10f'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:noninjectable|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'46d40072-8b6b-46fd-b53e-426ab055e8db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'46d4fcb5-dc3f-4058-bcd4-45c8e920b89a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'46d6fd0a-7fbc-4983-9f99-7fdbb3b9565f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'46e96e03-9e4b-4f7c-a733-0f034230c6a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'46f3d994-67bc-4336-8847-8253735929b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'46f49cce-319c-4249-b800-6d54406d87d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'46f905d6-5852-470c-abec-ad57b384507d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'46face77-1e2b-4557-8319-bb9e246ce81b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4706e09d-4422-4bd2-9380-5800ae3bdc7e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'47078ada-48e8-46e1-9d76-bae70d0ed4d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'471139e8-6c08-4f7d-a053-f9b5a53ce529'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'471c351d-e99e-42e1-8e42-31e9f1954020'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'472b3eda-bd0c-4d70-9984-128ae0cfc0e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'472fd5b1-1a81-4402-ae9f-3fd681e69b65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'473c1e4f-bcfa-4714-a3bf-995b4a632398'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'474a90c8-5945-4317-9678-bea7f600e0ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'47515e5b-4419-4cbb-918c-f324722d0985'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'475694f1-c0a6-475d-9801-3e2e4473b362'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'4787dc67-9e00-47c3-acb5-63caf1fd42e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'478cd783-aa91-49c3-a07e-67ad4269d3e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'478d7db8-f205-4fab-acf3-94c7a8cc0aba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'47901fda-1f0f-472a-ac71-f6e796f7203b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'4797b761-093f-4967-a261-39945fbb5e99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'479becdd-248a-4d9d-88a9-e62a4688ac55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'47a37d36-63a2-40b7-aa55-ea8d7b75c90e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'47c40413-9d46-4892-b469-693e697b1cdb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'47c51794-efd9-4539-b0c1-806e5747d26f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'47cbe092-3780-4a9c-9f8f-e9edabc687f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'47d0593b-cf72-4c31-a96a-0275d808134c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'47d6d1ae-664a-4c2a-8fac-516e0f08ab4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'47d9b89f-bb33-44bd-ac57-69599874599e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'47dd012f-bc33-48d5-a39f-3e17c40ee4ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'47e06159-a73e-4c66-a98d-7cc1180d0f57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'47e4d2fe-3d71-4e92-8606-5081a46d2fd4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'47e4d46c-522f-451f-bfff-aef02629281b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4800f16d-cdd9-449b-991b-4a814b2ab80a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'480e44f6-c930-47cd-a594-72033f5da812'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'48110eaf-6267-46c7-a91c-b2d2c26ee3c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'48194490-82c2-4b2d-847b-26030647d818'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'481dd0a3-7430-40f9-a2a7-1e7426ac5481'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'4825f31f-73b0-497a-8d3d-d47d80b1b011'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'482a5f3b-055f-4efc-a76a-6661bcf95988'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'482d51bf-ca8b-49f8-b3e8-32bdd104975d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'48301000-b4d8-452f-aaa1-145c7e73cd26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'483d77d5-1765-4dae-be3f-0f2aafe7495e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'484f2f2e-c620-4969-be29-db4dc4df7fc5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'48552ad5-4071-4272-bf58-bced3017029b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'485e75f1-06ba-4e5b-ac24-ad10a3e7aa11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'4860425a-3ae7-4ab8-abcd-629302dc446f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'48631dc8-79ad-43ed-ba01-6e61a2e7a286'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4872b3ff-33ad-4d5c-ba92-09959bbe32af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'48745f31-24a8-478c-a058-c34d229e4948'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'487a845f-dd24-4aae-817a-c95d006fcef7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'487e551e-ba79-4883-9d3a-dd6fbd041cb6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'48839022-c3c5-43db-922d-67202dad70e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4886dadc-d438-41aa-9e90-c9e433a7d06d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'488f008a-2991-4d88-98b2-180c76b4544b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'489df6c4-c8ba-4f61-9e29-0515b9551be9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'489dff1a-1eec-456a-a63c-a20edab0ff2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'48a3494a-8334-4c0a-9874-a6fee4e2c518'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'48ac3c06-508a-4c78-854f-3ee4efc89204'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'48b19185-7525-4aba-a570-58e199f140d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'48be3170-83c6-4caa-bcc6-7a17a57ba722'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'48ce2daa-1cd8-4395-9e13-e1f1f4fbe386'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'48ddc778-2f42-4b81-b5d1-a8b61175ff50'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'48e6dce0-89cb-41b4-bff7-514629a1629e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'48e8f67d-8dc6-4ebc-8d23-cc6fc8d72d51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'48e98823-6edf-4b63-8660-d2a5285bcb88'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'48ec399a-1812-4fc3-9aeb-85d82a1dee54'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'48f62174-3b4a-4ef6-aa82-c233f2d14276'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4911163e-5062-416b-be22-7a435a0db49a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'49151a2d-3676-4d33-8081-18506e6b3e3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4922b12b-6d99-45ea-918c-ede2b7a120bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'49419d70-a25e-4d6c-8735-1590f7006a3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'494d18be-f9a5-48c1-bbe0-c66799da2e3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'495357ac-8120-41dc-9287-616fd5920d1d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'495709b4-3316-4c5d-9844-799e20ab8ce2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'4962e900-e1cc-4f0f-9de7-c269bfdfa228'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'49635356-4200-4990-8ee4-cb90d78370d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'496bf7f3-df40-4eee-ab1c-7e2161e27582'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4972f452-775c-4198-8ccd-b6ad435e973f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'4975e3e9-30e1-4ae1-93e8-833142bbf8d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'497ca44d-aac8-4046-9628-562a966e1d40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'497fe249-f9f6-422f-89b7-cdcb66d3772e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'49820f7e-a772-41ab-9c2e-83ef6d188436'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'498ec715-4da3-4784-8999-aa23eb66e90c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'498fa681-86de-4354-a699-84db6ec22679'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'49962165-a383-4135-87b3-e408ed7219ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4996696d-8ed8-4f93-9608-59520b09ad81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'49a703bd-d3db-4264-a0aa-c1874ff54d0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'49a9a493-b000-4c20-8e00-6d0ac28ca6dc'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<-65C|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'49ac7763-975e-4ab3-bbe0-7bc173f0cde5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'49aee7c7-95b3-474b-ba76-85f861b84164'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'49b23ded-2f7e-4b14-956c-2ac5022e0024'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'49b43135-1c11-4351-8843-3ae6d5965193'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'49c7fb94-1771-4e85-82b6-5e50678da5c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'49e1ffe1-7dfd-46da-a782-8deb9c724df3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'49f09a05-e597-43da-ac2b-0f5b818e37d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'49f33087-1486-40c2-8235-84f5e039d9f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4a0b90f7-9bb1-4e52-a4dd-d8d8ed46c303'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'4a0d6dcc-39dd-4983-b72d-cb7f4adbe2df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'4a135c97-c05a-45fb-aa97-d3b2ab33f4a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'4a15ae10-9aa6-4e4d-befb-0f25b3460f64'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'4a2812ae-3e1f-437f-8e27-a46c5593bd48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'4a2ac25b-4a34-4aa9-b083-41ab600f58f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'4a477929-0d66-4df8-aa55-696f95c17c3a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4a497c6c-7b8a-4870-9aec-46c21c9dc8f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'4a5135d8-3077-4313-a1ad-d3a6e19c6e92'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4a5b9f3f-60c2-4189-97c7-7f78d0d1c55e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4a5e82d4-ad74-416b-9f51-3970cda8d3fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4a5ea85f-fa9b-4f74-bfec-f0c010de69cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4a6568f7-2a67-4071-8bec-80d85ab7c93e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'4a6ab317-b00b-47e2-956d-d8ef8ec31950'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4a6cc8c8-99e9-497f-bd3e-cf8aef4a03ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4a6ec8a5-e8f2-4212-87ce-c36a59e1376b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'4a6f262d-ec49-4cef-a2a3-9999751176c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4a731c18-d6dc-489c-aef3-638072045e13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4a860526-1b58-4f57-a2bc-c656eb16edd3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4a8e3a48-ffc7-412d-96c4-87595f283ba5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4aa4de66-508b-4688-941d-06768995d96e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4aa62e2d-d783-46d7-bf42-43d4eae54f8b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'4aaaeae4-9ca9-4ee5-aa50-d827f2ce6d03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'4aab9f42-9850-4447-a613-d2396dcf2442'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4aaf25e0-429b-4a08-9bd2-8751f0bc84b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4ab05e66-238e-408a-bf4e-df8a0f16bb73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4ab44071-6607-4bcb-8d7d-f6851b89a935'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'4ab5a83d-f5af-43a4-bb64-76bbe99660da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'4ab81596-52f3-43c2-bb47-844be137d046'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4ac0c333-c596-4c7a-b5cc-a54e4639a882'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'4ac2076f-cb8d-4a97-bd93-0b2977fffea3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'4ac4ccf2-6063-423b-80a1-613440b25fd1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'4acb02cb-9a95-45d6-aa94-45e27c2e5150'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:noninjectable|>=200mL<400mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4acd6f8c-7989-4a8c-84e4-887a8d7333c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4acf0b28-efd6-4a3c-821e-12ac42fa9495'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4ad8e61e-3ee0-4fe5-9bd8-fa2951805a48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'4adaccd2-0afd-4327-8f72-29c0a8af068b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'4ae4bf71-636a-4a78-b3b0-e16d1997c4fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'4ae4f094-eb8a-4585-b01c-c28400040348'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4ae62bcf-5f56-4bce-983c-4373e870f8f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'4ae73b13-cd09-4d54-8e09-c450c44f96eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4aed736d-272f-4e8b-8727-7ea994f6e851'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4aee6e3a-f309-44cf-8c37-9060d7e4d8a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'4af44482-ce0a-49d0-9d44-0b92e740c3cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'4af80350-ff93-4349-8924-98d8d4dfb0af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'4afa5faf-80e2-4ec4-ad1e-a1ce2c0fb867'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4b03c7ac-15eb-4215-bad3-a08b7b6e4380'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4b0bddeb-d5a7-4c84-b7dd-550baf4c9cbc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4b200c27-a012-4d4e-aaea-69e8aff7b288'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'4b223fd8-84c3-450d-9826-24fcb4b469d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4b333983-0ac5-489b-b962-e1772ddd6b86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'4b3b3b85-9848-49e8-b5bc-ccfc02c80661'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4b3e0435-aea6-40ef-a140-d022db99d903'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4b407d6a-1676-40ba-8907-4d1bfe6cfae5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4b4484be-3e51-4d59-836f-b0dbd028ca27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4b45fe69-8829-4a4b-9499-19b085824c3a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4b4f840a-783a-448f-ab7d-471868933f69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'4b61ad95-126f-40a6-bcac-1b004300336e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'4b62d36f-c1c1-4513-b543-2f8488bb38dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4b62f44c-1d88-4573-98aa-fc6391174c6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'4b636778-4daa-4c77-a5a5-f08b2c33b83a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'4b6b0a47-efb5-4ee9-aba0-8f46c5b7c044'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4b6bcd04-0a4a-48c3-ad9c-605548ecc7b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4b701fa0-9601-4683-8a70-88b13586ce24'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'4b750afd-6858-4b92-8e65-18fdad0f317b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4b7812da-5a33-4eca-bc3f-2fa5b48c77f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'4b7b0f88-16b1-4aff-8296-93474e1d9f99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4b820582-5979-4757-9b03-584387d7b2b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'4b835cc7-dad0-4696-875f-8818af6e3397'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4b87e4c7-dd3f-4dcc-a148-f6ba6006c8ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'4b883bdc-3827-4f26-8954-3970b155d9cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4b977498-f8c1-483d-be37-855a671fd1e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'4b98ad24-268a-4e4c-aa14-e774d3bb6c42'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4b991fe0-5647-47d1-ae50-4bf5c596664a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4bb3705b-54d2-4456-be6d-89edf1f24ac5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4bb4c8aa-67eb-490d-bfd2-bf94c778ff7f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'4bb4e660-80ee-4be6-b65e-155f2a4410cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4bb9cbe1-9ed6-4663-839e-4a48868b11dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4bc2d9f6-81fd-48bc-9ea5-eba56e9d3bee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4bc990f3-0738-4207-9dea-bb677ec20dd2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'4bcd6eec-bf9c-4cb9-8527-4ad80460337b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'4bd51b93-b91e-4130-9f64-a882c95a7606'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4bd8c53f-3826-44ec-b921-84876810f432'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4becdd7b-6961-400a-82c4-5437c8689224'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'4bf224d1-ce38-4680-9f72-d38b87efe770'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'4c026fd8-93f6-45e2-bf4d-1efb62472aa6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4c04ca70-08a2-4aa1-9601-b4b33de61198'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4c0b9d34-8e39-435b-a957-bb8bd23aa245'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4c12e796-856d-44a2-98af-24efb71f948e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'4c140c09-11a8-4342-b51e-54e4882badea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4c174702-8043-4822-bfa7-f0ea78b7e785'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Not for tx or mnf|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4c192ac6-f21e-45e4-b81f-062baeead28f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'4c1beb4e-e4e8-4a8b-a6c2-8ee5c18530ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4c1de5c1-32dc-412b-8b89-c2e145d2169f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4c332f18-9aee-455a-ba45-5ebe4aa1932b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4c33c7cd-59d1-4e40-8417-e97a75bf86ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4c354ad5-09bd-48b0-864a-6273b7ef3db3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4c486cc2-e8d8-4198-9c87-7044f6a775b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4c499fda-27d1-4ebb-9eac-ae707ddbf578'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4c506557-7ff3-4d1a-a65b-d6bf6bbe4fce'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4c56cd1c-0c4f-434b-8b4c-b306db578dfe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4c5adc92-de17-4a5d-9a69-ce92bce09aaa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4c5e7045-7715-460a-8795-e691e94e3bf1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'4c5eb64d-99f7-4a46-b18f-b6ec026f6f3c'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-65C|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4c62108d-b311-4f04-9e05-733cf8f52976'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'4c6a4600-7016-4671-af54-6cdf85d10fde'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'4c6b62b9-74aa-41cf-8050-417aacff1f4a'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<=-18C|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4c6d4502-f1f4-4d6e-a318-f10d6c6d5006'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4c6e7bdc-b9cd-4825-99ea-2b8ef671ee54'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'4c7328ac-b6ea-4d11-9827-244ed76126b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4c810b72-5f8d-4ed2-a5ef-8d4afb2e1b7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4c859e2c-678f-4644-9731-0575074f6afb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4c86d4ca-de48-4517-a561-c66bb3e29cc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4c89b253-3db4-441d-9211-c673297ae8f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4c93324e-2903-4feb-9527-a674768f5366'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'4c95931a-c6aa-42fb-83d9-9f8660a38a69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4c9c0ae4-5c7b-40ae-b5b6-5f721fba20df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4ca0eb53-30d4-46ee-873a-4de3876f19c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'4ca0f6bb-ab5e-4061-9452-e0cc41d330b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4ca14047-966e-4c75-b3b7-dc975b71b624'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4ca486f1-6ac3-495b-9ad6-56a6a12b46bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4ca4fe3c-ad68-4953-a074-7cab31929df7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4cac3f44-8347-4328-9faf-606373ed389e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4cb497c4-9ded-42e2-8f54-5092b7f11cb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'4cb4b85a-ca56-480a-a3bf-28f3f566f167'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4cb4f9b3-72e9-44eb-90df-bb5cfe8100d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4cbc5013-f0bd-48f1-85d9-a8cffcbb7c03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'4cbfce73-6bf2-4dfc-8237-5f2361e7bac6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'4cc075d7-144b-42c7-9bc1-2ee17cd3e0f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4cc35711-60f7-47d3-9163-2aa936174414'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4ccd9696-459f-4da9-8204-470c36f03baa'
UPDATE dbo.BloodProduct SET ProductName=N'RED BLOOD CELLS|CPDA-1/450mL/refg|ResLeu:<5log6|>0.7', OriginalProductTypeCode=N'E002', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4cd0482c-ef69-4458-b340-9b4efb385a93'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Open|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4cd1594f-c1cb-4a21-8c39-32102ad052f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'4cd46c12-7f95-45bf-9d03-196c2534fb6f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4cd8892e-457a-4529-8824-c3fefbc31441'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'4cde1081-9f4d-487d-ac40-26f87ab18665'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4ce1ad4d-4e4a-490a-af98-0269e1c6131a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'4ce2bdca-e640-4b4b-8454-cc7c6407e631'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4ce9b2df-689a-4bfc-b18c-ad8acd106849'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'4cfe9a37-ef7c-49a2-9e28-27a8edf17c1c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'4d0dc827-67d0-4667-aebd-0a1b2918bbf4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'4d0e2f25-09a2-4402-9653-631241a141b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'4d1444ea-ee30-494f-8a4b-5eb43b9f726a'
UPDATE dbo.BloodProduct SET ProductName=N'RED BLOOD CELLS|CPD/450mL/refg|ResLeu:<5log6|>0.7', OriginalProductTypeCode=N'E002', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4d1569fe-1f22-4766-b9bc-3b555bc83336'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'4d1c2265-464b-4832-a9b7-91393f9a1605'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'4d20aa09-4d0f-46b9-953d-358c0ef36a80'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4d2421ac-161b-4477-a0a9-ade0c053a0e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4d250cc5-267c-4e25-a16a-ebacb9db102f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'4d284252-4048-4be6-bb43-2fdc31bf2aa4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'4d3906a8-0fa5-41b6-9f48-937523a03848'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4d3cdec0-932d-4214-8583-aae95a45fb31'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'4d433b80-6964-43b8-b1b6-e05472e9ea38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'4d4de2b0-924a-4c63-bed5-4d3c760453cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4d503c75-86e8-4c68-8226-f36638c2058b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4d53a334-667b-475c-a334-c9c961ed9edb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'4d564687-07ba-4d03-bdb4-3a38a2800f4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4d687de0-dac6-481e-a184-32b34f6111aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4d6e806d-b258-4a9a-a8a0-a1e255b49272'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4d72e117-f1a5-446e-b80f-ae280467a168'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4d778b20-3d0f-4050-ac41-f71b01e70baf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4d7f9381-d147-40ed-b083-2f6cd5595f6e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'4d815085-aca9-487d-8da4-cde42569ae3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'4d8b3cc6-0383-48a1-8a47-a8dcad7c773a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'4da66487-1dfc-4adc-8dbc-92020b71c3ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'4db5e1e0-7aba-462f-a56e-4494c8bfcd65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4db99aed-5555-42bf-a595-485ebf6c1b1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4dcf35bd-72ac-405b-b8db-626d55ec31a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'4dd55af9-c0fe-421a-ac3f-25df8752e39d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4ddbd331-1293-4f1d-8197-5ad5cd172031'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'4ddd61ab-319a-412b-9a3b-9fb174644f0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'4de9733d-cdb6-47a0-906c-793f95d8b1d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4dee5307-fa00-4416-9c72-6cbdbb8106da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'4def735c-2625-4456-8b8a-c698fcd40fe7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'4df436c6-1484-4765-b5b1-0cd578aece94'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4df77b98-88aa-4ddf-87d1-105af6b9e0e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4dfb215e-0c49-456c-a1cc-6c688ce6d5d1'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4dfe247f-b0fe-44f9-8fa9-db786138dcd0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'4e090380-0909-4490-8d01-691e7de4cebc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4e0da6d2-5601-40ae-b72e-bcb67f87fb21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4e29e1dc-b81e-4c2c-974b-60362f46095b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'4e376526-82c3-4f1b-888a-0a0bb5a19940'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'4e3c9ba8-6a73-4dda-a7ef-a3eddff77348'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'4e446ac8-5b57-45d4-bb2d-630ad39ecbfe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4e4beef6-3882-4275-94db-50519ab737ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4e4d817a-3f51-4290-af0a-4d1ce7aeee48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4e4e1406-e619-4337-b9bf-d1c868c82fb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'4e4fe7ca-2cc0-4fc2-aa84-7d45683286b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4e588d2b-9564-44a8-9aea-4338600f4040'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4e5f7cf7-a4bc-4e1f-b91a-219780eaad32'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4e614a0d-a045-4676-9037-9b05f295a889'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4e70f79a-4594-490b-a4e8-3987fee2dbc0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'4e7970cb-d863-4b4f-9acc-9bec76ef1ee3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4e7991b0-bbad-4a50-9559-aece0da04a9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'4e7b85a0-1210-43b2-8a34-09fe48afa9ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'4e8ae4db-fcab-41ed-8145-81bfea478413'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4e9051f1-b85c-4454-b194-a85b1f74dca6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'4e9605b3-f46f-444b-96a4-0be1219c373d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4e96ad9a-56d4-428f-b99a-13af50850ad6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'4ea4f106-734e-4256-b6ba-8cafcdb00efe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4eba6620-b15f-4ad9-af0f-7343f207672f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4ebf8b74-b207-44b5-b03c-96d6115dd084'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4ecbb442-ea47-4b75-a027-6be6d826bcbe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4edbcdc8-0270-44bd-97de-1c1db71e2f2d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4edec9f9-b91c-4a0a-96ce-05aa83c096bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4edf00bd-8267-4ab1-ba6b-ab983649d249'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4edf38e6-9911-4ded-8498-fa68c764b18b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4eeb8dad-f2bd-42cb-b25a-a9f7fe18b464'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'4ef12faf-15e8-4dab-8766-65a17ab99395'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'4ef25e19-9ef8-42cd-82c2-90f5cd31f953'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'4ef30369-9505-40db-abf0-fd156e06b2e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4ef726b0-69f5-4142-966c-f96d0548ae00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'4ef86afc-4c8d-4f9b-840d-c839fc319152'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:injectable|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4efee2bf-52e9-4cbd-baf8-f6666ede326f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4f06ce08-cdc1-4374-9091-40d132cd2d43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4f07b2e7-a570-4a5b-a8ac-425e5686cf0e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'4f0b42ed-a019-436e-9d1a-71377cf54982'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4f0cadb6-b070-4192-8fbe-29f6f0887c3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'4f0cfcfb-fbc0-41de-9156-bd403385c39b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4f0e9e7a-219e-43e2-ba04-748be110261d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4f160414-b603-419b-866b-12c24aa88262'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'4f1a32f0-b76d-4636-9a5f-7cafd8bdb4aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'4f1f5d42-65ea-4427-b409-6605e7f7f401'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'4f21e295-7245-41c5-886e-a9c1f7d7af82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4f24c69e-dc1d-4cc8-8f50-79ec83e89b4a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'4f2decae-7cf8-4ac3-ae0c-4526e3279d85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'4f3b740c-619a-4700-96ef-798db2a19e61'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4f3b7a02-bbcf-4cb6-b79a-6a667029f09a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4f411ce7-b54b-4409-a91d-6ff7978a0105'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4f431cb7-aa73-45ef-8e43-d9c8ca504fe4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'4f49714b-7a84-4efd-b50f-de65726f4903'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4f4cfd52-f4ed-4d15-9f17-fdf88bba6ae1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4f512fe7-f423-460b-a2c4-4a532fb93f2b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'4f514ea7-9325-44a9-8076-a7ca9fc045d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'4f546995-d7ea-4860-8fe2-aaac9e10b7da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'4f573cc9-5ade-4780-bb85-cf709ba37291'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4f5e011f-ba52-4aaf-9e70-f9973686fd30'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4f609bce-1994-43c0-abc5-00797f5ecb87'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'4f67d392-2962-45af-a4ad-24c6331c41a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'4f7f276b-65a6-4614-ac13-2bac4c8ea5f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4f80ed82-d4f2-48ae-a2ee-de24ab601c1d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4f84b828-b974-47dc-bc17-257bad482ca0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4f856957-578d-4a9b-9dc0-8c439d7044b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4f97c474-2fef-41a3-b154-a26ea1e79756'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4fa78d9e-6ce9-45f6-8e84-fe494501177e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'4fb7e2b2-49e3-414b-b4d8-6ba14d029635'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'4fbdaa0f-0a9b-4c3a-9310-414586e76ea2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4fc990cb-4ed2-4796-acb3-848b61906eb1'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Not for tx or mnf|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4fcbcd10-9811-48ae-9685-726c78542128'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'4fd22a2d-9df4-4bc6-a9dc-e19a95b34e71'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'4fd3ddea-423c-4049-af92-44b68f437d1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4fda635f-eddc-4415-878f-7d19df846388'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'4fe0416f-30b1-49fa-a9ff-a0272f7448d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'4fe295ff-9c76-4f74-8b68-8aae53554468'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'4fee17ce-81f1-44fe-9af5-ac37def9d717'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'4ff36c51-91ad-4556-913f-8a99df3fc2d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'4ffe5ba0-9c14-4dad-81a8-9157e2f2ea44'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'500397b0-2777-4fd9-8a19-006a7fa3d543'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5008556e-91e5-48ab-8662-d018fa85bd62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'5014a256-0223-4991-9d9b-809636042796'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'50191f0c-f407-4a62-8872-9c6bfa8d2920'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'502ae0dc-277f-4c0c-b741-eac3c6c4769c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'502ed116-bff3-4f5b-a797-d9abc03cc179'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'502f24bf-1c9e-49dd-9893-df37277343e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'503347ee-51ae-4b02-9dac-6840ea33edf5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'503772ce-963e-4b6b-b315-a5fadf7e4613'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'50414cb3-564a-4b2f-bb95-0df9f0093926'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'5041684d-f5d8-4240-beb2-4e6cc4d78090'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'5044a1bf-53ee-4fd1-9a74-18188d0eab10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'504988fe-2ed9-4a3f-90b1-d5c3c110497a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'504f9c4d-ae38-4030-916e-156016ab5a93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'50510f87-af12-4300-a9db-a76d71c99bb2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'50530d6a-6ef7-4e96-9f04-208ae2a6ab84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'50542f78-ad6c-4cb4-92b4-79d08f653adc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'50548ece-396e-4a1e-beec-28c7f0f7d180'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'50565f6e-6fc3-4513-8633-1a00b8491c35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5070c7f3-9058-4fc5-b076-8980c12a14f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'50715757-6332-4bee-b293-96939c2be343'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5073a38a-4ae0-4a4c-8e41-29f38ce137d8'
UPDATE dbo.BloodProduct SET ProductName=N'PLASMA|CPDA-1/450mL/<=-18C', OriginalProductTypeCode=N'E017', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5074833c-6cf8-4800-8050-a87de320979d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'507c50b7-f513-4ce3-84ca-d074f924d2d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'507cbc05-6a50-4cde-b8a5-0a352ea4c523'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'508bb37b-8e36-4af4-aae0-f58407f76182'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'509d040f-62cd-4cbf-968b-c1c195b2b1e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'50a9b49c-696b-42f0-a93d-4934f3f3d0a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'50b4a9d6-2394-4a05-b4ef-438e6e8188dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'50ba45aa-10dd-43d5-86c7-0cf9c8f07519'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'50c028fb-26e6-4c43-99fd-612721a4bcc7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'50ca038b-ab63-4a14-971d-c1236340b288'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'50cbfbc9-d6b5-4a04-9e73-7ba1b88f25fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'50cd3eaf-b4a4-48cd-a2b3-98ca30aa34c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'50d1a2b6-c1e2-4de8-9498-e50a603572c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'50e57b44-7c02-4191-9173-91cac1a1dcdb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'50e6fb03-c842-46c1-b91c-928eb6e2b183'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'50f12786-8c7f-4385-861e-c55fd56e1eaf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'50f34050-c43d-4b0e-b93b-33145c77bc4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'50f39e24-2da1-4b53-beb0-b2937b6c8563'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'50f78f7d-8a0d-4b84-a031-06845a3e4fbc'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'50fdd78a-0574-498c-ab12-56007ff01f54'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'51087d39-c0b3-4b34-975f-3c5949fc5005'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'51105d8d-fee9-43d9-83db-50a9ab5ab2e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'51163942-bd6c-49c1-a71c-d55e3401372c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'51242b29-8355-4d0b-abfc-cff707a07de5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'51245be0-d1bf-4cfb-baa7-f46b788051f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'51307382-8880-4505-9882-398bb961bdb6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'514803be-fc01-43b6-ac5c-c8e05b03cbca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'514a9616-db2a-4048-a05d-44e0cc5a0496'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5150eece-8f41-496c-893c-5037560f173b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'51511b0c-a19b-4baf-ba73-5595e255bb90'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'51576c28-1c5b-4cd9-a0ca-05321922ad1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5157a8fb-a6fc-4c43-92d9-91e56d37e744'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5159e325-fcd2-442e-9ae9-46bd8f4119d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'515ec447-faa9-4484-a382-aa517b9cf75c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'515eda3b-78bb-4a6c-98c1-0ae2069f0d1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'516eb5de-e885-44ae-92e4-22d9b7ca4b84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'517245e2-1a53-469d-b121-7a37e74edd5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'51726ffd-6477-4764-bb44-c1c2e2e61992'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5172e848-6897-4c08-9f55-3b664dcc1866'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'517abf09-2038-465a-b3fd-0593aa8b4e9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'517c6581-6870-4a9a-a887-d4fef43fe578'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'518c8732-82bb-4d4b-a1c0-24a3441a74ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'518d55f9-1f22-4820-9cbd-a6b0d0224dc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'519c9b63-18d4-454f-b432-d37219d4ec4c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'51a58867-8a0b-454c-a0e9-44994f06f94f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'51aa6207-f1cd-493b-839a-d65254d949e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'51b88715-8cd7-4eaf-8ac8-0b495224c0fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'51b971e3-a492-45da-99d0-b075cbd806d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'51c6be48-eb73-4e3c-82df-5d06122f7559'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<=-18C|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'51c83ccf-ad59-4c94-a616-fd3c4c032e4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'51e4d226-b61a-4208-9c9b-3ad6eb896e31'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'51edc7cb-84e1-4b4d-87b4-3e64f1e87d8c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'51f51242-0a36-41ba-8072-139a07f30b3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'51f90eeb-b5da-4f89-ae0c-7609703c87b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'51fd2a37-e15b-4a43-861a-ceb93b3f8f71'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'5204f5bd-7eaf-43e9-a78c-154b46cb2af7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'520ca0a9-4097-459c-a2f9-9d808ca8a300'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'52165cff-20ca-4e76-a074-0dc378a0d86e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5222b688-5bf9-441a-bf6f-30f9d6975dcd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5241ca26-4d65-405e-9dd0-dd8e6629757b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'52456288-4caf-49d8-b7fe-9e6180934823'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'52525e96-50bc-43c8-a859-4bd369f3f539'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'52572b43-1039-4e93-b123-dd2fefbdabfb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5259610e-b12f-496e-afe3-b64197117319'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5268cf49-6e3d-4bd5-ab63-72628c4f16f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E037' WHERE BloodProductGuid=N'526ca46e-4d65-44eb-9481-f95ad0e21ad4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'526fc96a-0806-4bb9-8655-dfe16eaad166'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Not for tx or mnf|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'52786332-5eb6-4a3d-8813-4a718a1f8dff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'528afb95-3d1b-4f87-8e88-516f81fd3737'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'528d87d7-d109-4bc1-a45d-34c71ad9bd09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'528f22f7-995d-454e-ba60-42d842581278'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'529170f0-93ca-4545-a7af-2670226ae260'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'5291a930-f4c9-457a-bee5-804d4f2e4033'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'529f54ea-c758-4474-84a7-72a0921d0be8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'52a27b1b-b9be-4619-bde7-2383eebf7c77'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'52a6bd70-aecd-4933-a2b4-e40ac21ce196'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'52abbc99-0210-47f0-978b-8191893be34f'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Irradiated|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'52b71650-fc98-4d3f-b8e7-1008eff40988'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'52b8fdf6-a5c0-4490-b309-2e62415e78e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'52c26247-f433-411a-bb1d-f17b56e3eb2f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'52c56d8c-5f88-4311-9112-d1b71894b504'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'52c9e9b3-c7ff-4dae-8806-41a9e72d69d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'52cba171-8377-456b-ab15-8915d6c55fec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'52cef603-d3d6-424e-b57d-d951ca83bf66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'52ec8622-7271-46d5-9967-01d6732ea52c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'52fe2aac-d9dc-42f6-ba90-bebc232e8ef3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'53101ca6-99ce-4a6a-a01d-1bfeb89f6416'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'531bbfc9-4c34-481e-8639-1bebf09d2815'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'531c8a76-74c2-4c9b-963d-75fd0868380b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'531eccd1-d240-44ee-a324-4cfa610381db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'53247182-30e5-4521-a32a-32acae544342'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'532b6051-5209-491f-b148-3287802eeb27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5332a014-c81e-45eb-a1e4-7fa35d2c9359'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'5340cb0d-85f6-48c8-887c-8005ffd9cf0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'534c0bfd-3d69-447d-95b3-55ede3a2e4f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'535a1af3-6795-42de-a379-5a1dc6ceb170'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'535ab155-e2ac-4736-ad65-3660b599234d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'535ea2b7-a84b-40c6-8c03-3c62a1ccb8e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'536da362-8e5d-4fe0-bb41-de38fcb5eebd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'53717aeb-ef39-4e31-a813-33f8f14c2287'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5371bfe5-4027-42dd-97f8-dd49ff31ee36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'5373b912-0e5c-4367-9ef2-d6a941bc43a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'537a9c89-59ae-4a5e-80f9-162d9ef07116'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'537aa016-e77a-456f-ba65-9b2d90bb8319'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'537e0402-19c6-447d-8827-621192afe2c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'5381e24e-cb45-4fe0-93d5-d6c2e93c521c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'5389278b-1105-45ce-bb0c-2f0df1aed236'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E037' WHERE BloodProductGuid=N'53a4a1df-c04e-4f0c-8fd1-838cfa34519c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'53aa4a86-d561-49aa-80cd-a131d269c136'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'53b24ed2-5bbc-4e80-916c-924c3ce92af4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'53b732df-a1bd-409c-8f70-87814851b168'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'53b92072-0290-469b-93e8-f67a872081f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'53c0b4f2-3b2c-4180-b414-dbf832a53124'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'53c303a4-a21f-49f5-8fe8-19ffbc203313'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'53c6d384-c7ce-437f-addb-c8e0ec9baab1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'53c74234-af6e-454f-a0d6-6d3620d0daa8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'53ce0a4e-49f0-441b-b486-b02e438ad2a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'53d6d1e6-fc1e-4e17-aa43-d12e7f991281'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'53dde6b7-207a-451a-826c-e9de6c987f11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'53e02c32-dc97-45e9-a4fd-07546948e9d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'53e0b737-f03d-4b9c-964d-38467057b569'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'53e557a5-6cd5-4894-bb57-14b28de56c4c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'53e8a9c8-c1ca-4d75-81c1-af850b94e900'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'53f025fa-6028-4680-b370-57f860b5b21a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'53fe7d9d-9e08-46c8-9da0-0c8b1e6d301d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'53ff38d9-969f-43f6-9e8d-48df7c609b8d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'54002841-8daa-4be9-884a-e47d0c0839ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'54075713-4466-4607-bc16-0b34a5d31b0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5409760d-8592-4e56-828b-b1c0f0cf660d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'54102f07-bcf4-40d9-bfea-21fbfa4ce33d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'541a5793-8fb0-4836-9ab4-984c8ebea224'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5429b2ac-1c89-4fb3-aa98-a41e5296fc8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'542db89d-621b-464c-acf3-efb5bfec2d92'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'542dec5d-fcd6-412b-b0fc-97d35b39b732'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'542e414f-bd77-4728-8cf7-7d6f76071e21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'5430f17d-03c2-4f4f-8a35-46febeba495d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'543b9e1e-e4f1-478e-8eda-ec9fa42a221f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'543dedec-5c3f-47c2-b6ec-c927a8ea07df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'54404c32-dcb9-4f69-8997-41fd17ba5123'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5449345e-6f78-4f72-aa37-fc9c79690954'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'544cba9e-d136-4fa6-81a8-2f46081c46e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'544edaa8-d549-420b-94ab-526c91342d13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'5452e337-99aa-4609-aff2-a00091c9cfa6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'5456899c-462c-4e74-932b-1f5479cca572'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'545bc98d-d8fa-4d8b-b3ff-f6de1dfa5132'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'54688201-0f7f-4075-bc51-8940b8189ed0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'546b7617-2038-47f5-882f-e26fb9db98a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'5471878c-1275-4643-9109-2547b512e7fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'54720c3f-d8db-4960-9560-c99be9428687'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5473e61b-7b8f-4acc-90cc-77cac2508f7a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'54759437-b600-452e-ba58-a34b891ab07d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'54792a62-9773-4317-82cd-5124a7ef1f6f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'547a043f-5ef5-437c-89b4-69c05f9e0743'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'5481eae5-8ee5-454f-877b-8a632b455a2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5489d11d-78dd-4b84-b1b3-f38a4db6768c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'549dfe8e-4195-4448-9f03-145e10e67384'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'54a02163-73d9-4a8e-8b41-955f40dadc66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'54b01901-b839-4eeb-b2bc-9deb6f8a17c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'54bd378f-079f-4024-8ae5-fec06f06dded'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'54c8c9ce-c67e-420b-b3eb-12ce8674bb4c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'54d7a051-0cac-4f01-9308-84f05051700f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E056' WHERE BloodProductGuid=N'54dd8741-54fd-47cf-b77b-cc8c2c4a6b14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'54e3d5ba-8351-4927-9dbf-036bb1282a4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'54f39c97-c72f-4fb6-b85d-fe4c8bb5c27b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'54f4c09e-1547-4fe9-bbfa-17cf40f6a596'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'54f57f0c-3925-4365-ab28-83cd92c35ea3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'55058223-e9c4-40dd-94c2-6784d2eeb642'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'550a5fd1-436b-4606-a479-c06e6b724b68'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5512895e-a9ae-4d38-8120-cce553d5d91d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'551c1144-fa9b-482e-9210-b8c532673f5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'552a1be4-c375-432c-84ae-f75c8e58fdd4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'552b414d-e892-4573-9f50-c4a65573d738'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'552ca0b0-cc4b-44a5-9d8e-de37a4f5b456'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'553ca92c-6bba-4085-b682-10f4b47c5172'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'55422c48-c3e4-45b7-a24e-8ca77539d2de'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<=-18C|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'555c9685-f73d-48d9-be7b-628f6cda4570'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'555d6e09-f74e-4085-b83b-86f5c915714e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'55692c2a-7fe6-484e-adfd-8d8e6f91bf73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'556c6848-14a8-48ec-b2e8-ff59e04b6a23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'55736ba3-1ef2-42ad-a7ac-7ebebdfe3bfe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'557c69ca-10be-46e1-a331-fa130763d96d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'557cf045-be7c-4751-99d2-d1525018fefc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'55826e89-b3f4-4ea8-a614-b00aeb034981'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'55896b79-c984-4013-ae43-675c0052f68b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'55897b11-7a4f-4c45-a204-17580b71cebb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'558ac514-a74d-4c39-9dea-5c66c680b41e'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5593c188-6515-445e-a48e-1624e035f596'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5594c550-e72a-4943-9399-edd87a4810c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'559657e3-155e-4d50-91aa-43c4013aea74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'559fd29e-676f-4b62-9a43-e1d213d95c2a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'55ab314b-bf60-4ed8-98d0-3160ff0a08c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'55c94a59-553f-4876-a811-30f161c6802a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'55d0d421-8295-40f1-90c7-5cff402cd7de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'55d25126-171e-4706-903d-3f239e168bae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'55db4ba0-e37e-4aa7-a89d-fb4a724bff51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'55dc3591-7b96-4acc-a337-7e193c3c1365'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'55e12681-1108-4796-a43f-26f68a8dd88b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'55ef4ee7-dd39-4019-94aa-74ac9ef385c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'55f65d87-c66b-41a0-a099-238da7abd52f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'55f94575-5160-4557-a309-d4a280c97a4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'55fbdb82-88ee-4855-bf44-270d06ca8766'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'56001b6a-8575-4f59-a046-42652668db88'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'56046a28-3b80-40ed-bdd0-e832967e6f7f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'560873a4-937b-4694-ba67-20831edbd2e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'560dd184-0010-4189-aa07-253478c7840c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'56144b6a-5bc1-4ff0-8f80-0d213fd5aa0e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'56161580-fe11-4081-be8d-51b82a246444'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'561961cf-975c-421b-ba55-38a7cd381782'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5619ecb1-4769-4584-96c9-4ce3dfa3f894'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'561aa190-f8c0-422d-8a99-a8bfde312f2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'561bffd7-eca4-4935-8a16-69e580b1be00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'561fcab9-074d-43f2-930d-7176c557a57a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'5620bf7c-8dd5-430d-9b14-173c24408356'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5622b9fb-3ca1-432f-9c00-54ef0271e30e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'56298c36-fcbb-4fa8-83c0-57755c1f7fc3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5637969d-8510-498b-b1df-9f45a414c276'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'56457c48-9c31-443e-97cf-1f4a673828e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'56479fac-59d4-4200-b1f9-eedebf5c8b64'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<-65C|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'565cd2d1-a2ac-4d31-916a-1c4015573b2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'56676e1b-86af-4e6f-923b-4007013efea6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'567aee49-b127-4e2e-a635-45c545c09daa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'567b34d0-fabe-43fb-a9f2-f7cd352966e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'5686477a-2514-4665-81fb-c9978cc276d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5687bde7-bc3e-4b2b-9edb-ecfbc9316dec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'569cdd87-2bfa-46c0-b52a-fcbf65a7d266'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'56a0aeb0-7099-465c-9613-92d2d50cb788'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'56aa796f-3cfe-4013-a599-c7e0649efcc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'56b5d083-4164-4c02-bf24-cf2efc679e0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'56b9cef5-3969-4d5b-b39d-4cb81e7a8aab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'56beb3bf-1175-4e81-ac77-ea3928f7f394'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'56c77213-da62-4beb-b149-47f985df6978'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'56d83e45-230b-4d6b-85f7-f452808ce7ad'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:noninjectable|>=400mL<600mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'56d84a25-e497-43cb-ad57-04fcf629b636'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'56e08225-260f-4017-aaf8-b352fc8c3369'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'56f5377a-a090-4d3b-896d-2eb6daed51df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'57233239-f820-4d2a-b1fc-9485f3019e11'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'57280ed4-feb2-4c01-a713-304d28229162'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'572e1503-7e71-4cbc-808d-fbe7e1226913'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'57327824-abd7-4137-aed9-770e16068951'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'573407e5-15f1-47de-a72a-cb87c907c21f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'573c55d3-c780-43ab-90d7-810ed9f48511'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'57451d50-9b1d-4cd1-b47e-7a9d599e7115'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'575c0025-fd08-4499-9077-6866a37f3374'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'575dbf9a-e775-44eb-99f0-62f83f06d8dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'57643325-53ed-4cb3-af45-7a0202e238ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'5767d786-1231-4971-9342-60e3bbd0f82b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5768cd62-997c-4e00-92d1-60715d0f20be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'5769e438-8fa0-436e-bed2-ede658d633ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5780845f-8131-4638-a869-692dce2c1aa5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'5785564b-7bc8-466a-ab39-4f33f25c2260'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'579efd08-6aa0-4b47-9218-fd51894299b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'579fa1b4-469b-4dfb-be5c-e43339ddfa6f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'57a2ca8a-533a-4479-9292-7fd42d620d36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'57b78cc0-0cb6-481f-aeb4-7dd6b09bb637'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'57bb5731-e9eb-4ba2-a013-2005286ebb70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'57c9c494-f3e2-47a7-a5ce-fbffbd7af415'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'57d8f341-b352-464e-8cc7-b49c03298d00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'57e0a8f6-8a8a-407a-9286-135f861b352c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'57e59c5c-ba59-41d0-9cb5-c5e2b307a2b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'57ea31b3-2ed5-4c6c-b82c-3c031e447b6e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'57f23570-f7be-49b2-b9c2-63f9f93cf1bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'57fa72a1-aef0-452e-9339-cf3fed0c476f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'57fbf0f9-2401-4ecc-9f99-c49389da1508'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'57ff14b7-bfff-4925-b2f4-1cbf128cb016'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'5800feb3-2c90-4b88-bd5b-3509ee88b814'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'58067761-ad64-4d2b-966b-277224bb019d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'58104fea-7345-417c-a014-e2e7ce99a01c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'58179783-4cc1-4e1f-8dfe-ddabd439b856'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'58204fb7-7edb-41be-bb36-c4dc22f28490'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'58294186-9937-4096-951e-1f6ad86b284e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'582b083c-5347-4cb5-be2c-806a486e3e97'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'58327b27-c617-4c39-abdc-321ef4e7c192'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'58378419-bb30-4bc4-9a52-2d4c8315a7cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'583cde55-def1-4fcd-9e28-e85881c6c431'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'583d0f67-65ba-48eb-851f-0053840688ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5844a186-2410-40ec-bd1b-90ab35c5c4cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'58552537-d2ce-426a-92ce-14e495837254'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'58564a7b-2aed-4c6e-b07b-40ee9a420e34'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5859911c-ad00-4b48-9896-84b1988a44d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'585aa77f-7e10-499a-88e0-ec54d9ec4cc2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'585bdf2f-418f-4075-8b9f-764e839f6781'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5866844b-cff6-4cd9-accc-a89c44f2ba6e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'586952c0-5fdb-4443-91c2-2355e58c48a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5869f28a-a50f-4cb8-839b-20d09d89ba5f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5879e2d1-6e55-4e74-924d-63d93f1dff31'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'587b1f03-5bba-449d-b2c6-e812daf7b42c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'587ed4e4-769e-4488-aca1-cd72a4e0dd6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5882aa53-6eec-4eac-8b3b-2d0d7a5a5a98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5887a7d8-5019-4af8-800f-968938e4cfb9'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'589a23c0-d4c1-441b-b3ea-cf9ae2c7f587'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'58a578ca-a66b-4dcd-a8b5-f5b25a11567b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'58a5df9a-3a3a-414c-976b-85a69a1f464f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'58a8ada3-5644-49f0-8dbe-539177824f44'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'58b56027-6a77-458b-8f72-9a11e435827b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'58b8e5be-3a5f-479d-b849-cf9515bdbfb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'58da7805-96af-4775-9877-e94a46b1ae2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'58de1729-3be6-4797-9d78-748e4079cf73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'58e3d859-4f3b-4a0f-b6b5-335b53d2be8a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'58e3ddd5-ec0a-49bc-8de5-07174db40efe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'58ebbd53-1e04-4519-914f-d70726d02f16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'58f27cdf-79f2-4b46-8af9-323a93f7e1db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5901a19d-01fb-420d-ac7c-7f199574ef0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'59049522-c066-4e02-b9fa-9ffa8a1f3cf2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'590533b1-bac0-4a77-9e51-9af394599a54'
UPDATE dbo.BloodProduct SET ProductName=N'Washed Thawed Apheresis PLATELETS|NS/XX/20-24C|Open|ResLeu:<1log6', ProductShortName=N'PLT AFR Thaw Wash NS OPN LUKOPR', ProductAttributeForm=N'@72 B2 D5', OriginalProductTypeCode=N'E065', LastUpdateDate='20110509 11:08:37.280' WHERE BloodProductGuid=N'590a7c75-6796-4145-bb4f-5542f4200cdc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'590ab89c-3e4f-4690-9fb4-b37d6d68383a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'590bae47-7079-433e-a64f-327d2958f9c5'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'59122650-7a89-4b00-8ea1-bc277a0a8014'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'59132905-77a6-4db1-85bd-940e15d0c7a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5913f76c-5e60-4000-95a8-c8ddf1d59d11'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5915d868-c3dd-49f4-86b8-85f64e4010c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'592ddc97-1af5-4a73-b1cd-ce7b14ef9c69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'59377097-44bb-4235-9756-832369b4e673'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'59455cf3-fb54-49b9-8a7c-6befe2dfff53'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'5946ed86-fc99-43dc-9edb-76be0c247f76'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'595449af-1eda-4a4e-baac-462275895e57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'5963331a-d11b-4ebc-88d7-696e08df0919'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'59655719-e535-458e-97b6-a290e234f4da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'596e9e2c-8ace-44ed-a572-939329d941d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5976c759-9257-4bda-a46f-8b109f7029ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'5988fed8-2fb2-430d-9d66-d2c06574dc68'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'59907475-59cf-432b-9087-01523ce74582'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'59915c55-3ca3-4429-9f33-9fe91e784a68'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'599e27e2-9cad-40fb-8140-7e867aed5913'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'59a60483-dbca-4747-ac4b-7419be544f1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'59ac0695-dffd-49a0-b0da-395692721940'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'59addc5a-54c8-4e24-8c8c-cd4c2b552f62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'59b62be6-4f63-4862-912a-68298beaa382'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'59ce083c-88a7-453a-8037-7f5142a05d58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'59d6985c-b413-401b-9bfd-d6c0517bc5ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'59de2b1b-b96e-4075-87f5-164dbe0410d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'59df50b5-bed8-448a-807d-15a7445d7dc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'59e74c66-e4c5-44c9-9e9b-cbc1fe526906'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'59e7f3ba-dd1e-42f2-8b95-22a30dec84b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'59f1dc78-70f4-4c00-a217-3a169f9289c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'59fac7ee-45dc-4d9e-a4bc-aeb644789cf9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5a03a62d-fcbc-43df-89b1-270772b7c8bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5a0d91ff-bc4a-4d6f-ba3c-eee463a6a481'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Open|>=200mL<400mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5a0de9e7-0b98-4e92-8a7c-d666b51ead84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5a12bca5-ea77-4509-9637-96bc49616a35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5a1c24d7-fcc2-4b5e-83c0-69ae4f432204'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5a20452f-3f5e-4706-853a-3efa470b0195'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'5a214f1a-a062-4fd5-aa2f-84f836ef8b7d'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5a2d397c-382e-4bb0-8a3f-77a98113d87e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5a31b9e2-e14f-424b-975a-e1ee4306f299'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'5a36f0f9-8da7-4972-ae8a-09d2cd8c8ccf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5a3df60d-be0a-47b8-9dfb-8d942f59e32e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5a40515b-aee0-4371-a624-179009ef6941'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'5a4d3905-f384-480c-9925-a0211303fddb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'5a6637ad-9832-421e-afc4-ab707e38c407'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'5a7e31c1-0fd3-4479-8a76-443e88e280d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5a7f667c-58a7-4d96-bf90-d4309aa4dfcb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5a876de1-baf0-4fe4-bae1-7af9bb7c02aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5a9200f7-c4a8-4e7f-af31-3324b3f2d1a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5a9f38db-7f07-4fe9-b421-14ce3935d2fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'5aa615e1-d9b3-4002-9fef-cff1d26d7f01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5ab45191-4725-483c-96fe-bd91df24a771'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5abdcbe8-6ed9-4e3a-8e03-45da32b3c209'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5ac37696-e6ca-46c0-aa2d-ba39bb26d9f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'5ad9b71a-c1d6-4bb0-a7fe-5db909b7e8f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'5adc555b-8aa8-4aa9-bc77-17ab178b07dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'5ae60855-c819-40ac-9ec9-57c9ba6a2fe1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5ae93d72-6587-4c8b-8545-7920386a3295'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'5aebcfbb-4f90-496e-a018-e60599b4cdb6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'5af0b66a-37b5-4d49-854f-41688e04e9da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5af6d421-4812-4ab7-a48d-f0845806c5c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5af742e1-a84c-4bf2-90e3-8faab08b81d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5afbbeeb-0eb4-4b95-a606-131d6cc916c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5b00a23e-d589-422b-aa2a-b5dce274a7be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5b13a99d-124d-433e-8cee-c9a813e37631'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5b1642db-3e92-4d51-a9c0-ed32a01bae74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'5b167d66-f7ec-4056-984a-a272b5d7dfce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'5b1a4cad-c866-46fa-be7e-5ec0a3ffcccf'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5b1e5238-ef0d-4bd2-b3c5-dad5e9b693db'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Not for tx or mnf|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5b2379ab-2f74-4e24-a960-fa5c4d2ee381'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5b2604de-c409-469b-a3d2-18ae57866dd4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5b343124-53f7-4466-9749-045a2a90446f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5b35e75b-2448-47c5-a767-541b0b087a62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5b3bf9a5-0607-4ec3-888c-ca690eab55c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5b3cdf78-8d18-4439-93df-bb1709eed03a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E056' WHERE BloodProductGuid=N'5b443d11-e1f8-466c-9159-962afeefabc0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5b465b09-438b-46ff-9056-c37ff553ae44'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5b54c213-d405-4ef4-903f-e570239879bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'5b608937-6a38-4f29-a9f7-8c3dd391d499'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'5b63397b-cc9a-45db-be5c-214a2750edfd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5b6479ef-87e2-4165-b448-e703596dcf65'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:noninjectable|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5b6599a7-b5ac-4578-91ba-8141d2f2e22e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5b75a177-f5cf-40cc-9263-c060e122f658'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'5b76a56a-2751-4c1b-8326-49e31290c383'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5b79ee6d-58a4-4bc1-850b-e7f9762f138f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5b959b0b-b44a-49f4-8237-90623d4af7dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5ba43481-faa2-4295-aebc-9c32d3612356'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5ba47932-a0b1-49c9-aae6-befa6e13da2b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5bb2c461-6b3a-4d41-9744-2cd81963c9cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'5bb9ced8-24fc-4bbd-8341-1fe94c6f0062'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5bcaa267-a124-4d87-a9e7-fd3744303592'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5bcbc8a5-6fa5-4554-9f80-52d8b5db8810'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5bcc79ad-37d1-40ac-802f-9cefae99a4bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'5be30d35-d93e-4077-af89-552757b71b72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'5be8346d-57b1-44f3-8696-047dadfaef3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'5bebe127-05c1-4a80-b132-b35177cdacf1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5bf03f8f-cdf6-4d87-ab16-d387698cbf58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'5bf1c214-615f-43ec-8597-4ea9010a1764'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5bf2e2d0-2afc-4b27-b064-6544ad9f63c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5bf5e650-99d2-4dce-942a-f0cfdb8c5759'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5bff222d-90ee-4822-ba52-67bb2ffc8bcc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5c000aee-0d44-43cf-a0b8-07991ac6600e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'5c00703a-9da6-4eb6-86fb-9e09e44731a6'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5c01c36e-94fe-4922-8ac0-c147d3ebf460'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'5c0bb9a4-6b0e-4e79-b836-6606c81a7c01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5c0cb10e-1a82-4978-abaa-d31035a5d406'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'5c18be1b-e163-4717-b0c7-3f9b9f71e200'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'5c22d5f1-cd3f-43bd-b314-1c7b09d0147a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'5c2538f8-8324-46c8-81ec-4f665853bd9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5c2829d9-f0bc-4a51-b889-e2b9cf244030'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'5c41d5cf-9af7-4552-9cc5-9a7795705c60'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'5c4300cd-4d95-4cff-9f92-45e8a8e18193'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'5c441153-220d-4811-b259-e50c9a9768a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5c492083-8afe-4b8c-ac80-e8b8f3c0c2b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E043' WHERE BloodProductGuid=N'5c4ec475-bd19-4e92-9e1e-4bf097eb4fca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5c5b2deb-1e49-4cdb-b3e3-0aa4019781a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'5c6c8b19-9384-4091-b749-669158b69025'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'5c6e2c11-3c13-4dad-b61b-e15ef5490b13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'5c708aa9-1879-4b8d-b814-dd076a6bb504'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5c7983c6-50ea-4a2f-8a4d-7cb54c144f89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5c7d3cc9-383e-4e4e-abd4-3fdc691fa069'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'5c7e2bfe-be7f-4f82-97fd-605234dffc3d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'5c871769-1867-43bb-b5d3-c72f4d532cdf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5c876ce2-cd18-433e-9cb1-5c71c6558c6f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5c97a440-d98c-4a5c-a7cf-d1c22a34cab0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5c9fb45f-b3c5-4a4a-87de-a899d02566f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'5cadbb64-d539-4a7c-8386-f97ab4a47020'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'5cb05ccc-b751-437a-96c8-fa51200c072a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'5cb7f952-08df-4db3-a520-32f7e1f385ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5cbf1ae1-08c9-4ede-a0b1-7375338ccc45'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5cc16b33-2dec-4b3a-b76c-d98ddef81055'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5cd4dc51-8652-4a3d-943f-e873cc7eafc7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'5cd5bfb3-42d3-4501-85f3-5be56ebc16b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5cdee97c-a8cd-49f3-956d-4112318948da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'5ce051ad-10ff-4d16-8b67-45b1b848e257'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5ce3a337-0456-4b63-a074-9054eb6e2d99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5ceac1b8-5dae-4bac-84fc-853791666506'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'5cee476a-6d1d-476c-93b4-deb61ccd2c00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'5d0bed4d-51b1-40ec-810f-e302be43d556'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5d0c3b4d-6289-47fc-9b91-cba16008d629'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'5d0f7aa8-fbf8-4b8c-982f-749c57a2edc6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'5d131dda-bcc9-479f-9744-c94cae231b89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'5d1370b4-ed27-499b-a316-b9c7b99a303e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5d14fcf4-7046-4895-9c9d-927144f4735e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'5d1a18e9-93c0-4082-8cef-296babfa78d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5d21e6ba-39eb-44e6-9c1e-26bd508ea176'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5d2703eb-ffb9-40cd-9924-0b0c6aa19455'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5d27d969-0b73-49a1-a53e-606765a24c0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5d294fe0-b4a8-4522-9175-97d8b2de9304'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'5d34a7c6-70ea-487e-9870-6b59dcca0c66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'5d34d208-e8fd-4509-93df-821e49766278'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5d3cb176-9c0a-49f1-a657-be1398b4235e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'5d47a899-002c-44de-bce1-d6dc41147a78'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Open|Irradiated|>=200mL<400mL|Aphr not automated|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5d4a2520-28f2-4fa4-8e45-7ce8cde49f42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5d5b188a-0ddd-4918-a2cf-d9d15659739d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5d5bf573-6c35-4d0c-9ef6-ab0a95a81fa2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'5d61a9e1-6489-40e8-b9b3-e4faa0dacfb6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5d6255a6-937e-427a-bf2b-50fa9397be61'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5d716384-1e0e-4fdf-8ebf-8c6b0e66e49b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'5d7b12c4-e201-4079-a007-6e2d587c60eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'5d8268eb-4b57-4f3c-8104-033499299fb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'5d91c42b-1cd8-4c4e-9cb9-da2fd6a60f26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5d9d3efe-edde-44b3-934d-5df329608808'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'5d9ee142-9368-4c0c-9582-e5b4b06cea2b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'5da1f5f4-e878-466b-ba5c-fc7d94ee3439'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5da6e583-f677-4e0e-aec2-c120309b555f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5da6efeb-8eaa-4b69-a43c-7801597f98a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5db4322e-d84c-46a6-b064-682d9c50472d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'5db8370e-3135-4c32-a247-5f627dac9e1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5dbbbf65-129f-41ea-94af-29dc8071c1cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'5dbc9278-9a46-4474-91c3-d8b4597c497a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'5dc135cc-4cba-4de8-aae2-7ed4bab90e73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5dc5b8e9-7079-4b65-acd8-4a9af64ab4c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'5ddb283f-212b-4a20-a44b-40681d385c58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5de038b3-87dd-4128-b7f8-a5368db31714'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'5df61658-c53b-4d66-b9b2-d248d3d71b62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5dfae1b0-0647-4ae6-b5d1-768fe4e6f777'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5e042425-e6dd-4a29-9701-3b48d8e00d9c'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5e099c14-7d06-4952-9544-20aea10a0fa8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5e137f5f-f025-4ac1-a40b-80bebee709f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5e202363-004e-4c06-a24c-32b388be6216'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'5e2d5f93-c955-4375-b3eb-9e3d7f90457d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5e2f398d-8c11-448e-84f5-5e930ca01561'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate = '20110510 07:59:27.820' WHERE BloodProductGuid=N'5e34e3fa-3c13-4351-a984-2b9e7e64e0cb'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5e3710cc-1d11-4fe8-ad71-833cc31f8790'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5e3d4092-1d4c-4f78-8a92-8873dc48b2cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'5e3db72d-da2a-495f-932b-fe0ebdaa0011'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5e4843b0-04fc-4e08-9471-2c2b517fb58e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'5e4910c2-3131-4a6a-9326-2231c8d9e6b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5e5289c0-a279-43e2-a475-4011cbc78bb6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5e555040-b493-4d3c-b89e-2cd72821c36f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5e5850ec-0354-43e6-b47c-c8aedfe57162'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5e5f6a8d-cb44-4795-ab6b-33369aeeccc1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5e5fb7e4-e310-460f-81ae-1c6de1a74062'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5e72801f-e44b-4aac-85eb-ba4bee9d38b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'5e8af5f0-d3a9-4349-8900-b31eeb42c554'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5e910f70-494f-458b-9079-088bb1cf8acd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5e992266-3938-4d22-ab36-cc91b6de4e19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'5ea59b61-4882-4b09-bbe3-6811efc9dd3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'5ea8f42b-18d5-472e-9416-73bdf406bdc3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'5ea91963-e149-4454-9c0b-8507da00c207'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'5eac86b8-7127-4e22-8f44-0264a40a5795'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5eb6fd71-aabc-4de9-b72e-af010e9da8d5'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5ebafebc-bbff-4b0d-88c6-efbc7428a0ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'5ec6e434-3012-4425-97d6-6b013a749475'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'5ed0eb99-d32d-4a95-bf18-f0d74f5096cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'5ed7b324-fe14-481b-aaf7-b84e5f3365c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5eddfeb7-615f-4d48-86b8-e257d6d043bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5ede15b8-1cb0-4f84-9374-7ded621038f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'5ee0bab4-3833-4e73-bffe-139ae563e580'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5ee29480-0852-4637-be53-e0c40dd104f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'5eec17f6-0a26-4baa-bbdc-12e23f20dae0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5ef7706f-3659-455c-84a9-3a64bf5a5463'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'5ef91216-7f4d-4e2d-b929-5d3fbbe01a53'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5efaa772-ba7c-42be-b3fd-d7351ccf81c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'5efb4d73-52dd-45de-9368-ca9456617d62'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Irradiated|>=200mL<400mL|Aphr not automated|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5efdb7aa-6377-468b-a03d-e6ba77c500e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5f004499-bea4-419f-81ee-56be4c5aab62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5f029b2b-96a0-4748-a084-a2a9f51a7b3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5f057950-3590-4bfe-a932-12c72cb5556e'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'5f0ef3a0-790d-4531-b3f5-0b87a71fdc2d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5f14a5fc-f532-4d60-a7ee-09e9eb213010'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5f1a964d-652f-496e-9e76-e0b67cf22882'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'5f29dcb2-be23-4465-93c5-0b2fe80c6f5f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5f3ad4e0-74fc-4254-a06b-7a4351f94e91'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'5f44d1cc-8696-4b4e-a0bc-8b6222a4e0ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'5f47b3ec-3bbd-4f38-bc85-97284f573f75'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5f4ae902-82b3-4bbb-970c-edec6e801cf3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5f4f5429-ffe7-44f9-a1dc-02b7a768f72b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'5f57cd07-0ed8-4181-8204-65b83df365cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'5f5f4844-48cc-44ce-b117-080a1272246a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'5f671934-1e0d-4268-993e-36467236a67d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5f6ed5ea-2e8f-4b7b-be46-70eceea22de0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'5f6ff6ca-7bd5-47dc-b2e0-7688e7cd5f0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'5f72e33e-c42e-443e-9f15-962eaffc9482'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5f744803-a8c7-4be8-b57b-000dc9f262b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'5f76098e-119d-4b25-a9b9-e30fc3e72e42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'5f785f48-10c7-47e0-8d7d-563119c4bfbc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5f8598e0-9c92-42fb-8333-bcbdac4c4ed5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5f8bd221-c431-4b6a-b837-0f8edaea0429'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5f8d9af9-be32-4584-a7ab-3226910e8b26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'5f915961-5f3f-4374-b5aa-a4d940032382'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'5f966720-41a5-4fd6-ade8-66a6501555b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5f9ed39b-b95d-4ef4-8692-ea6f12aed96b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'5fa2023a-bba6-41cb-beb5-111f2bcfb6c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5fc2617a-5bed-40d9-b357-a295c61aa54c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5fca2c2f-b83b-47dd-878a-d2f8e8417aec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'5fcacfcb-a402-4f1e-9654-4c2e58b1b7c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'5fcfca0a-df0e-43a8-a2f2-06ff8195ada0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'5fd8cabf-49cb-407c-bcd0-b2da5503097f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'5fd9ff3f-ab44-478b-90d9-4676e4a2f18e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'5fdb9b12-7eb9-4843-a5fd-0c6590f42b48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'5feccda9-7337-4339-b145-67b418e01c7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'5ff41fb5-a5cf-4a46-bbdb-b996f5d5045b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'5ff9dd7c-9d19-4dac-8efd-bce83d4495a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'5ffe9459-4499-4bc8-981d-6d84efdd376b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'5fff13bd-0723-4b43-bbc2-031d2b5dd83e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'6001d5cf-89d4-441a-823a-6da600a4df3a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'600a3774-75dd-4b17-b581-2f03fb0a75fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'600b8bca-e53e-440d-94ac-497b90c980f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'600d3693-030e-47d9-b1fd-8da3b6c9fa41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'601f774e-6138-4e63-83ee-0a9944d24ea9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'602ada89-c03b-4961-b125-89c48f546dde'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'60384ba0-27cd-486f-a69a-b0c80ed3c45f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'6038d765-48f2-44ef-a180-8cb503637b78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6039562a-e54a-46f3-9f88-e51c787e37f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6039ec7a-69ba-4abb-93ae-58a224735428'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'6039ff86-36ae-4bed-8947-e36f71bf5cf8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'603a0e73-9b95-41b4-b99b-426ee9ed0825'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'604e6f70-61e4-4d83-b474-974287a91b8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'60539950-9efd-4cf0-ba61-5680c8513dbe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'605e0158-0d04-4877-90ac-76343125a09b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6068bac1-25c3-4085-83a4-62b124e3f1ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'606cec4e-cc00-4291-b8c3-31b0551d6947'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'60771f22-c2f5-4008-a026-28e8adbe0047'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'608fb4fb-2454-4da2-be25-0ff88cd10fb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'609db824-bb89-43f1-a714-42b6ea77c109'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'60a0a7ea-d335-4b8a-a6ff-d39cae8582d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'60b96202-cdf9-4044-9bc3-8640b1ad4a04'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'60bb2eeb-65ff-4bb9-8279-a475c838176c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'60c0298a-f9f7-4ab2-8ec3-5cc8d6f948f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'60d57b88-a178-4a1d-802b-bb3ce6f4d1a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'60d776e4-a3f9-482f-af7a-54a7a0044caf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'60db1456-5107-4704-b48b-70f04da0d93f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'60de0b0d-b2f4-4444-807d-52914bd67727'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'60e06132-ae56-47de-b5c9-22d318a85410'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-25C|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'60ea3e4a-f025-40eb-b503-3562bddaa691'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'60f1d127-5097-4ab5-8bbb-272138bb66e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'60f8bae5-1cf9-4db0-8089-0979a4c6f430'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'61079668-1ecb-43cd-9256-d574022801e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6108c4f4-ca79-41a2-8d1e-0442e041a22f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'610952ed-0f96-489d-a557-eb0b1f26c5ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'610c8bbc-3896-4f4d-bd13-93f526ad72bf'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|Not for tx or mnf|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'611ceabb-ecdf-47a6-8cff-7ab5c8fad6e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'61222169-45b2-499c-b8c9-d21a157ba88c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'6123b1d9-8047-4897-a77f-7be44d4f5fba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'6125da4d-48a0-4b8d-84d9-d99377172c91'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'61315be7-8401-45b7-846c-d18a474728a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'6134090f-9418-48f8-a729-195effb6af0c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'6136bc20-2cb1-40ad-9b8b-9a3771e6c457'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'614465e6-340a-4df6-a1a9-b3f27194cba0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'61466f1f-f84a-4efe-aebd-60b6ce5c79fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'615ddef7-ca5d-4e97-aa43-f9868b759138'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:noninjectable|>=400mL<600mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'61638d77-ab0e-4966-a76e-63fe7c8fcb93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'617942fb-b7bb-4385-8a78-700ed0864473'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'617aa30c-45c3-4c87-ad7a-ca1e24c222b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'618a4015-0700-45a5-87ab-71d59f6911e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'61986408-1463-4ba4-9f9d-c4574a90bedc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'619cbc86-34c8-40e5-b0b7-950a7e4863cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'619f9cda-c631-43ef-9104-fa1671b03ea2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'619fa05e-e374-43e7-b5dc-3d7894fe55da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'61a0f2b5-9f5c-4449-9371-767b70042904'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'61a9439c-2623-453e-8a92-891282cae895'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<-65C|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'61aa55c6-d137-4d4e-922c-2302a76fe66a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'61ab2176-fb97-437c-b1a4-0171db4f0f86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'61b0213b-742e-4783-9c3b-525251d197c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'61ba4ed9-6041-433b-ab96-e11b829b79a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'61c9f02e-3068-470f-b01f-ae0cafe60730'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'61cc0e12-e56e-440b-b242-4fdb93fadc87'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'61d7b81b-b45e-4938-baa3-b178d6831acb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'61d916f9-47f0-4567-86d8-075e34aff273'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'61dd8ad3-8fe9-4fb4-8d5f-40913ec7b36b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'61e01a98-a840-4996-adfb-92fca097b7f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'61e557a2-2e66-4228-b3c0-62c7bd8d5c88'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'61ecb831-5487-4e7a-a93e-42ac8a3a0be3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'6203e2ed-ff49-4ab6-8879-c48da0c421a6'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'620b8e65-2fd0-41db-af37-35cc64efda91'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'6211c82e-35fb-4e10-9c81-d3f4faa08413'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'6213cb92-8a46-4a5c-9ca3-718041da8205'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'621dee8b-d883-4996-b9ff-8da29cb6164d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'62211d5a-b45b-47b8-bd59-09af2d96ddb6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'62217889-5e58-4ca0-a428-56bceacf8285'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'6223668a-ebc4-4275-acb4-f9657401f023'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'622b252d-4f14-432b-9515-80fa05476e6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'62320d5e-859c-4311-afd9-281677507638'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6236aa69-7adb-46f6-85d7-7ab7bf39236a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'623cfce3-0d77-41e3-b1cd-d2e0ccc9fe13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'62426225-ef73-463a-bafa-bc8daf23527c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6242f94b-dd55-4a87-bb77-520eb573a230'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6251129e-6980-4b52-bbc0-423a535daf0e'
UPDATE dbo.BloodProduct SET ProductShortName=N'PLT Pool Wash None LUKOPR SUPRed BUFCT', ProductAttributeForm=N'@71 D5 EA G2', OriginalProductTypeCode=N'E023', LastUpdateDate='20110510 08:03:28.693' WHERE BloodProductGuid=N'6255c237-ce0e-427f-b98f-102ee50e79e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'625e3a53-db79-43ab-80d6-2e79a2c9f90f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6262534f-e535-49f1-8b2d-f7727b0384d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6266e99f-ebf2-45db-b1b3-5a28853e3831'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'62679262-8193-4021-ae03-2f1d75e29038'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'626ff696-773b-44b3-9913-cf1699a23320'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'6272d8c1-181a-490a-8b8b-e3acb9e79095'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'627621d0-9d0b-40fc-9854-52baabf7a052'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'627a24a1-2e71-4932-a69a-06c02f85a6a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'627ac4cb-7be9-4edb-80d9-27d07ad80e48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'627cf93b-30ec-4b45-b288-db1e052e35fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'627eaf10-0051-45df-9d92-3b45efd4d424'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'6284128d-b52b-4828-95e0-96056fa2078f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'62908bbe-2385-4c4b-8e1a-c48bb9090940'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6293b421-52b8-4fbf-984e-582236d6f3a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'6297e0a7-0716-433c-8846-53d713785f73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'629ed9c0-7ad0-4705-80be-58c3ca8d0f57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'62a76363-c321-4a12-ac07-3574861ab99e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'62aaaf08-af1a-4eda-b965-9110c1a3c425'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'62adc20b-47fe-4f64-962c-6cd733b3deb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'62b77679-a13c-4b76-96ba-593d2c83f283'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'62c86293-cf5a-482a-a01b-2291e8148335'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'62d0177a-5099-4a42-842e-f73928f04079'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'62d3b321-4029-452c-9221-bc8abeb31b6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'62d88cf6-f27a-4a0d-bddb-0785b723e880'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'62e1fac6-bad5-4020-9e4c-a520c74d5934'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'62efa443-b480-4b71-8d44-79d1474393cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'62f824c7-9f10-453b-95b9-1a76c2378c7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'62fcc3f0-dfe5-4eaf-8323-83647f578c16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'6300df8e-807b-43b1-b32a-98b4b417ad78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'63032cf2-b092-4c0e-9d61-7d50b3d43d92'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'63058e75-5420-488f-8eb6-7fba0682fc6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'63069187-cc45-401f-834d-05952a4e7636'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'630ae365-1893-4513-957c-83a2b4fb1754'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'630e0d11-a8ae-4373-bcac-7d1ada65d436'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'6314ad52-b4f0-46a1-a5c0-1fcaeb3a2c83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'631bc5af-83c3-44fa-ab35-c4ecc2346544'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'631fd0db-446a-47bf-b798-45a5aa886861'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'632abc72-2422-4dbe-bd8d-b45300a7d294'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'632c9aa1-4371-421b-a712-5ad499202557'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'6331ea13-bcc4-4b03-ac91-dcb09f543835'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'6334baa6-a7d6-4458-a4d5-fdf60d8a4829'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'633ff56f-9896-46aa-ab60-2e4382d5d29a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'63403c61-368d-4e62-bfc2-7df382b5f9ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6340b21d-a005-4c94-9567-09c7bb02d4d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'6341e3d4-1830-467c-bd72-4386c8d7e9eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6344c15b-bec6-4e9e-8ddb-38928f051779'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'634acd71-fc4f-447f-8a65-1d89bc0a4249'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'63508f39-08ca-46d6-bd5f-c586176c4978'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'635b7690-88b8-4740-8625-d7d816efddd6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'6360b009-2092-418b-a1e9-b549ae89f601'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'636179c9-ec15-4187-baa9-955c084ae066'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6369398e-1507-47da-8b24-030dd3c9843e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'6369979e-9344-4818-8ddf-70fec7aa74c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'636e0e7e-3348-4a77-981f-023cad1ad338'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'63731a81-bee5-47b7-a608-1646baefc594'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'6374a9bb-6749-47ee-a1e6-9714491d02f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'637b84df-e1a5-462c-9c57-6a2e3582d14d'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|ResLeu:<1log6|Buffy coat plts prep|Approx 180 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6385e170-fd51-4bdd-babb-2f8643508d4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6389ff00-fca0-4500-8937-7034a603fe7a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6394685a-083c-43a9-b207-c2c2334bf295'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'639677df-0cad-4984-9cb1-85f4575c6969'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'639735a3-8561-46a3-8577-e5eca9bdfa37'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'63a4d3c8-870d-4694-ae8b-f62b7ea4eb23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'63ad35e1-36b1-4def-8831-ec3985240ce3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'63bb167c-1205-44ac-91ad-ae6dbf98b6ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'63be6f32-d134-427c-9977-10422e40b185'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'63c24d42-e33c-4b34-8e0d-10e7bc4a35ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'63c9c650-829f-4215-b6a2-82ea0c8d6f65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'63d189fd-936e-44a2-b6ec-5f4cc3053238'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'63d3b4dc-59c1-45f1-839f-c9a39e2f4024'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'63d4e7e8-8499-42fa-84da-5aa2e09d9815'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'63d86e4a-c693-4f5d-a18d-a395e65c3688'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Open|>=200mL<400mL|Aphr not automated|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'63debe80-b956-4e66-9187-0ae0e356eea1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'63e458ee-58b1-48fb-a36a-233129233d12'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'63e8fb71-64b2-4d09-8948-66ccece069e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'63ec407c-2988-4fab-9e9f-c6ee3d8d913e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'63f0177f-8bb2-492a-9585-a9600ae8dc9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'63f9c68d-b252-4e0c-8ea2-1d63ddfab333'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'63fab6f6-b440-4f45-a067-6c95982fa1c2'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'64038777-6388-4c18-9e7d-380502ddd027'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6407559c-fbd1-4d10-8930-19d5e7cabda6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'640b8052-d41c-4cd4-8b19-ed7db214d21d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'64161403-d650-494e-a3a2-6f9f9bfc116c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'641afce4-0cd6-47a5-a827-ce36c17a79a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6420ee62-f024-4e11-9123-f0a900b938ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'642e511a-8dd2-4dd3-9529-b06eb9934de6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'64309538-9c98-4076-a750-325ccb819d8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'643363f1-b807-4ebd-84f1-2e44d3601c78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'64398376-0e63-4b7d-a58d-6d6de1e43ec7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'6449e3fe-fd62-43bb-bb30-e561b4e2aa61'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'644d489c-4655-43ac-a4e8-da18fa45fd09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'644f82ce-a5ad-40f6-aeaa-21fc45633d7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'64562dba-754e-4126-b8a4-7d2686d70988'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6465183f-84ea-405d-b2cd-52ad4fae2af9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'647362c3-2359-4655-8be8-a7abf1555553'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'648cee55-8129-4658-8185-52f4dffc8389'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'64969fb4-0d92-414b-953d-621abd221707'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'64a1f283-0d33-4278-a3ad-9fa3dfa5e6bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'64aa2daf-755c-4035-952d-5b4fe6c2fc73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'64ad2874-1efd-4a56-ae47-ae756790d178'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'64ae2340-f61b-4912-98bf-1e0d95128c6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'64c2f7b2-ab9f-421d-b932-9a74ba4b278f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'64ca9f23-dba8-4454-8c59-a61cd739847b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'64d6f9cf-89d9-4e96-ab9a-d483f2f92e87'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'64d7fc0e-6bf9-4c35-9abb-b3537b3c9d96'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'64de95e0-d228-4c01-8ece-2054c0fb2d23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'64f4da09-39ae-4fad-a92e-d8e23686f6fa'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'650075f6-d80a-449f-ac11-f8c9007c262e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E032' WHERE BloodProductGuid=N'650248d2-d6fc-46d2-9ac8-6d3628997237'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6505c4de-95fb-4b46-969d-cc5855344a3a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'651b3d10-1c32-4e2a-80c0-43b7b95a4461'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'651c3c57-7724-46b1-aceb-c124c4c29f95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'651dce1d-716a-4cb1-b026-04e0a018d069'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'65220a01-494b-4854-866b-7297f1331f40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'652b39df-a75b-4fa1-8c22-3be82c5edc91'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'652ba6ce-69a2-4685-ba65-a486f96b1b2f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'653808de-331f-43a6-9e73-5cf53342c27e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'653a5925-7b2f-4d57-8dc6-72881c7a1296'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6540a49d-8563-4eec-8778-fe035a06198d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'654e0bdf-9222-4eac-a851-0c5ad4f64782'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'654f7037-20eb-4f07-a313-6835be655308'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'655188ef-856a-4498-a824-08f489a47fe1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'655367e8-cedb-40a6-b2d0-f690866c7f08'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'655cdc7f-5e68-497d-b468-c2a5719e3974'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'655e0c3a-c9f9-4c7a-a944-e7d8232f2489'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'65689709-804c-48a2-ab0b-be785c3ad3cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'6568b45a-053b-458e-8318-5233033d0dd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'6569ef20-0f5f-4307-adc1-4c961f380f84'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'656cbf17-173e-4ae6-b194-266f817fc91c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'656ec57d-e4ce-4906-9234-0e02e96bab46'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'65700213-b47f-498e-ba7c-2dcc89a9a87a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6579be85-769d-49a8-b1d3-35621590e49c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'657de378-550f-4fb7-b3c4-df09df13e0ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'657e202b-3322-4c08-9617-5c260dcc673c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'65818514-1c3e-43ca-b7d2-984800fb8a56'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'65854a9d-4d6c-4db9-a01a-6ebe79f656e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'65a0de47-659f-4ec9-9282-60efa3f9eaa8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'65a1764f-88f2-4934-b497-1197f7582ebe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'65a3f03e-b73d-4ba7-948d-8756a519a770'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'65a59edf-bb51-46a1-b0fb-fe3aa3ffda7f'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|Not for tx or mnf|>=400mL<600mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'65a8e048-9729-460f-8dc7-68e09f5b609d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'65ad374e-35b6-4084-b220-328dec1e3855'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'65ad5254-177b-43ec-b7a3-0ad1d278e474'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'65b63c62-1361-4498-9552-095a5e81901f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'65c0647a-530c-42b9-ad4a-ae5f93ec72b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'65c747ae-02df-4c31-a8d7-730c2426fafd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'65ceecd9-3cd7-40af-8d34-ad84c275c672'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'65cf916c-7736-4de3-9963-3952c9145d21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'65d75d05-0fda-428e-adfd-afd23f902f7f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'65dad306-ebbc-48bf-9462-88e32c0f910b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'65de1a31-6115-4e58-950e-a2186bd671be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'65e29181-f516-450c-bda8-875b8046b932'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'65e66ff2-945e-4224-bf34-eac16da7b5f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'65e9dd09-ecd9-4ef9-a2d0-e5834687c463'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'65eaf3e8-c0bb-42e6-81db-84d00492f6b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E062' WHERE BloodProductGuid=N'65eb00af-869a-482e-9a8c-a98a894fd3fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'65f2df5a-4b4a-454a-9288-3b03cbf75120'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'65f3a4a0-aa8c-4892-9e79-5ac8886641d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'65f91bf0-bb48-41d3-8a7d-a9bf737f0dd4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'65fa7a08-cca2-4890-b95b-964f0e7c35a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'6607372a-5f95-40a9-b9ea-2bda444d6089'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'660c6b29-e187-471d-ad15-6b89f4e0f099'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'66118cec-a840-4dac-92fd-a27b3f1b62f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'661ffb72-a75a-40e2-9967-9f60441eda70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6622adf7-fa2c-4334-8cac-f8c32f8c1359'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'662938e0-6816-4a85-b2c4-0c982da270ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'66365098-6983-40a0-badf-fa588025faf5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6661db72-eaaa-4e90-b58e-9a008532f3d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6662b5df-1ad9-42c1-9a15-5d4d0f84ce30'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'66637877-7ef9-418f-be97-6702f0e634d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'666755de-7267-4719-8ba7-cce59b660d9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'666d836a-e6f4-499b-9e99-f23120bb3b96'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'666f156c-ee6a-49d7-9654-a83a6e936f38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6677be0a-88c8-4739-9058-52e696de8ddd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'668b3674-ca6a-4b18-8428-2a3a41352bd7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'668c6063-787b-4de8-939d-06ddc66b3069'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'668e786f-8ebd-4825-ae6b-82f4fb3e392b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'668e8656-2f29-4fe3-b440-bcf30b46698b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'66964d3f-a653-4ede-b700-3e53b5835b73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'66966ff7-f512-497d-b4b4-23fefdaf67e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'66a9097b-a364-47df-90ef-e84a20e7a46c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'66a9da61-a9a6-4a50-9d37-831c94f49196'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'66a9df87-19ac-4f9a-aba0-021c5ddc58d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'66ab7ef6-9ddd-4958-87e2-02b85ac78325'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'66ad6499-af51-410a-a10a-53eec266396c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E042' WHERE BloodProductGuid=N'66ae0b64-e76e-4060-bc80-493c7d1a7ddc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'66b577b3-3e93-4d00-9d27-a93ab98e77fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'66b9085a-9e98-47b8-beae-4ccf5127dd6f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'66c74af6-a332-4576-ba65-7ef499cf61e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'66c780f6-641a-42e5-b73f-e792d099a078'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'66d12f75-1616-41d7-8ad3-13fc309038be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'66d5ff67-682f-42d0-8dac-d51830a029a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'66d93106-a159-40cf-a70f-4f77213b00d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'66db1a91-7955-4c4f-9f52-cd2c753f21bc'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'66db1d7c-a125-4ead-a4ab-7b8c5193312d'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Not for tx or mnf|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'66e566f3-43b9-4c8d-a112-a17dedbe37cc'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'66e89e78-464b-43fb-831c-3027d4f26cd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'66eedbe9-4e46-4602-82bb-f531a82c1dff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'66f1cb66-b44a-4a81-8f1e-14a5ff6ff3f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'670e872f-a40d-45ac-95f9-7720af965744'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'67163398-b8c6-470a-8a59-3bc8e4e8ac0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'671b70de-229e-4247-bcfe-aae738db7fc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'67271341-1694-4172-becf-0ad5b38e9b95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'672ed709-551a-4cb0-a04f-37b2c49a0abb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6762bdbe-32fe-4abe-9625-3c15492c0bd3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'676bd975-8daf-4270-ab8b-3b727e5283d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'676e8945-2804-4e90-b672-536d684135bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6770dae1-6c23-4811-9f67-09a1c6921443'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'67740f78-1c72-4578-9454-80f6629a1aab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'6777d281-8298-4da8-afe9-0ef2444d0743'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'677a5b4f-889d-462f-89b2-6afe5ac6f750'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'677d1e1d-5858-45d8-8430-df88bc7e3dba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6784fd54-84bb-4ac5-9a9f-7b79469794dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'678f006b-c42c-45b0-b5df-16e2ddf06757'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'678f37dd-34db-40f9-b6a7-8b4e1433dae1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'679eac81-1cac-4716-8372-5434b0c093a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'67a632b1-cb05-4f6b-aa1e-efcb98b5e5aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'67a79259-0dcb-49b5-9caf-06e8602be226'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'67a8ec96-0a9b-41d6-8917-6bd792a812c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'67afcf7e-6b0c-4ed2-984f-ea6e1fdad143'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'67b974b6-586b-45f4-ae57-a54c4ede1516'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'67bac524-05f8-49ad-a0bb-eeecb276f516'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'67bc2e6b-9fba-4308-8d95-21b6921a2f02'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'67c05062-2814-4a00-8eb1-62cf37055543'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'67c970ef-f143-4a74-b28a-9454683ea309'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'67cb89cb-383e-4650-a3ad-1b75c142c81f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'67d0224f-c2b8-40ee-ba82-9c33871f03af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'67d0f366-4e11-420e-bf9a-c721bd8f7845'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'67d1309f-6c51-45f1-9826-d3e98bd2075d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'67daf714-0c09-4bea-b2d1-c188cf096491'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'67dde31c-02f0-47a7-a034-9457db993a58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'67defa5b-a280-4e61-81ec-acabde850946'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'67e4bd7a-1873-4d51-bdb1-8a63be9badad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'67ef5d88-69c4-4798-98e6-dfc0bbb85cfa'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:noninjectable|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'67f1730f-a865-4b17-a671-280b4d6f480c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'67f5f872-62d6-4115-a31f-fc2efcde74f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'6809cb72-556e-40ca-9967-09a1995f87e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'68170a26-c174-48d5-b0f4-18824b587a66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'681ab84a-d17e-405e-bc17-f949f1748aab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'681d287c-fb57-4d51-aa10-e1c28c2dc438'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'681f50d6-544e-4186-b223-4ee283ad7c34'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6829724d-fa8b-442a-9149-ca7f573935e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'682984cc-98b3-49ba-8dba-061fb4eec53c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'683644e3-dae2-41d6-b113-35fcd29bd12b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'6836a277-a82e-4eb3-9a72-7a8eda0e5d09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'683891b8-0084-4f6f-a22b-cd47428c7379'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6841ffde-de99-4cad-a3fd-0d3a325e75f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'6847d814-363f-43b8-bae4-6a599483a7ec'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-30C|ResLeu:<1log6|>=200mL<400mL|Quar:>=62d/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'684f9451-8dd4-4445-a68e-ff310325000d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'68570f5b-2714-48c4-b0d9-85d70cf6bac3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6857b774-7322-4d6f-89b2-a9bc44091762'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'685bd699-141c-45f0-aa63-bf602412278a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'685c66cb-2987-46f5-863c-2c0bf4568a45'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'68649281-2782-42c3-bad8-4df654aa945c'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6865b584-ca5a-4cae-aab8-e2b14e425c9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6871f574-a6fd-48ff-a854-6fe1f3c3fe27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'687805ac-9a13-46c6-8fa1-c51327b80ab4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'687981c6-dd27-4b15-a392-414bcf7147ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'688c2250-8071-4de3-921d-59fc0f8f23fa'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Not for tx or mnf|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'688f63ce-2078-4fab-b60d-c496b16b93e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'689af45a-0009-4638-9b42-360f33c25f8e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'68a29f83-a433-4a86-8e04-301673a0b0eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'68a89272-4754-4da6-9ef3-fe4e28cb4bad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'68a9e0d6-bba9-4438-ba7d-350e3c9c3a74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'68ad3d99-f87e-44e0-a306-df7cdf65311c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'68ad78a5-6596-4110-9b0a-1a8b0af98aa5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'68ba8b8f-8066-4a50-b97a-53f288d2ea4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'68f0fde9-c954-4650-95b2-f67b8cb42bf7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'690608b1-bccf-4429-8488-7eb2b15d8b82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'69142e32-e51b-4815-b104-a52312c8485d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'691d8626-8e5b-44e2-a453-4799c881eb1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'692883e6-e1b1-4081-bc3e-ac276d290c41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'69354d0d-b975-4422-90a5-fe8be0a8ed87'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'69376e87-3d65-4688-b731-5f627268875d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'6937b18c-ec32-46bc-91a7-560c4e156cf6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'6941bb80-1190-4fc9-8ce7-dd838b4a7c2d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'694b4b05-abb4-40f9-91fd-38a371ead151'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-25C|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6950a3a7-c6b6-4d88-ba0b-e67a06c7a041'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'69562e77-67de-4c16-9f76-b9e7a865a03e'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6963921d-ceeb-4202-affa-9eb0fa607dfd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6969a673-af0a-4953-8ef7-360eecf0c452'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'69889167-81ed-4a91-963e-93031b0f9b76'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate = '20110510 07:59:27.820' WHERE BloodProductGuid=N'698ab7b5-9ab9-4fc3-91df-ad18f9125bfc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'698cc815-2501-4170-b556-3a7395273b22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'699826c6-cdde-4610-8ec8-93b2988c11c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'69a05ad2-ba35-4229-80e8-7ea7db740fc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'69a4eab3-6aa6-4191-9310-71962e2852b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'69abeb79-146f-4d56-a96e-8e0ec0f67d6f'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Irradiated|>=200mL<400mL|Aphr not automated|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'69bb0e1e-6f62-4f59-b482-ea4c3226022b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'69c8ff5f-d3a9-4aa1-81f7-992a439921c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'69ca0b35-a06b-4e09-8709-409cacc1a028'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'69d38ed5-732a-4b27-9d10-db51f415a2c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'69d41b2a-5d35-4924-9125-ce5731718e35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'69d4fe97-aafc-4fe9-8739-2b241f74c45f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'69e49754-9c36-42e9-9400-0b5ad6933dd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'69f938fa-4b39-4a6a-b4ad-d125a847e954'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6a18f9c9-5b9f-4c51-8c6a-65224958986e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'6a19637f-4fad-4663-b7d2-af5149430846'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'6a1b59ba-93fc-4b50-9534-6fa795b95db2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'6a27fcdf-fdeb-4433-9c93-6c5f9f28fa4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'6a2a885b-e4bf-4526-b0a1-29ec9750aeb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6a30ef82-924f-4083-8c75-7556ef7d24b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'6a367d09-96dd-4947-9f6e-8b1c3c5b981c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6a3768eb-6f9b-4324-abf7-859b2e4b3f98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'6a4c5a10-94b4-4014-bb13-9d43be8e6432'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'6a4d1249-a1f7-4d14-b3e9-8c2687efe851'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'6a554650-6897-44eb-bf40-3e490bb42e1f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6a607245-1f36-45c5-9c2a-aaa01ddcd3b1'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6a6f345e-eacb-4c8e-827c-ec2c11229870'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'6a71f836-9f4c-4a24-9844-61307bfc688f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6a73d3ad-9fb4-4a19-8939-7396c159792e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'6a75c85e-21b6-42c5-9686-57348e8adbb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6a795fb6-6c58-4544-89e1-6aeaddec8687'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6a7ff2eb-795f-401b-97ff-33dabd12d52f'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<=-18C|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6a8b2b36-2985-4c17-9aaf-80173a5061cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6a8d9ad1-a590-4484-ae38-7ad66376447c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E063' WHERE BloodProductGuid=N'6a8ef913-4db9-4ff1-bbd9-44cf4de97eea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6a929560-f5a1-4034-a907-dc11f82cf821'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6a99f119-9505-4193-9ab7-bb5bd004f8c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6aa15239-9b54-455a-ba86-d944a970abe1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6aac6248-a112-4628-928a-64c1d849acdf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'6aac8ddf-31ed-41d6-bc6f-8985833d5d1f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'6ab141d9-acf8-4976-81ab-4b0cae00db89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6ab14314-79c8-4af0-8d55-f2ac74c688a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6ab304fb-5400-4529-af0d-207f63b0c7dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6abd18b0-5b09-420e-9973-6c16d41331ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6abf237c-ab20-4fa8-acde-4aec54640d7e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'6ac37a98-c67a-4e86-8423-844b68382516'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6ac6dead-197a-4340-8dee-9d3ae21d65c9'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:noninjectable|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6ac83609-9fc3-4614-99e8-e1c376a02075'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6adb8373-cd01-4281-9b81-75e015769aa5'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Irradiated|Plasma reduced|Buffy coat plts prep|Approx 120 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6ae6b2e7-e03d-446f-abf4-5912618f8fe7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'6aecb334-53c4-49f6-ad52-f9939250bf76'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'6af5dfaa-dda3-4511-85bf-af16b31c20d3'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6b062169-7bea-4e65-97ee-e691a0726dc6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6b0c9c2e-7e64-46d0-a926-4762a459d9ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6b0e3f33-7927-4687-9a28-31cbab58c7a2'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-30C|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6b1cbe38-82f8-444a-a9b3-09f396253e9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'6b2a6998-246b-4e27-ab60-57aea7c3cf65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'6b2b774f-4e54-438e-96d1-f7a6b8dd84a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'6b2cddcd-c48d-4ad8-bf8c-2c80c5362ce5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'6b2d6f76-7d3c-4532-92f4-6b4e3689f76d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'6b3ad796-2b22-4e6d-99c9-171e055219bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'6b3ee992-9117-4045-921d-3ca51503bbe7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6b462fa9-f46f-474e-819d-44021a4d9299'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6b480a2a-367f-410f-8c9b-eb2ba6525c3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'6b5804f9-df03-45f3-b904-c14bca03c402'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'6b692148-b35e-4aec-b518-fd97927e821a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6b752dc4-5d95-45bd-b8de-50aa086f7d3e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6b78a6bd-f8da-45e0-9a4a-3e060f7dbbe0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6b7b349f-ee99-498d-a4fb-6a25f12ece06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'6b7c04c3-3300-43f6-a058-3a864002a483'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6b7f0d70-d24f-4273-96c0-0db054abefc5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'6b816a42-8cf1-403f-955a-881f8b5c6a6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'6b8ac5d6-38ab-4ed6-a34b-f63be625264e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6b917cae-efa2-4668-a50a-d468b20dd789'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6b96df48-5037-4ada-bed7-28e4636e186f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'6ba86f3c-83c5-4bcd-a30b-6eab0f907059'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6bb2f70c-6b58-43a6-b00b-4c96ddce2c47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'6bb53cae-f96b-46b9-85c2-1a69901a6755'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:noninjectable|>=200mL<400mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6bb595d5-06ec-4746-9b47-8013cd2c5ddc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'6bb979c1-3bed-409f-b965-7057cf41aa8e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Open|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6bc31c2b-9125-489b-989d-7286cfec1701'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'6bc9cef4-e5e8-4495-9dea-014096a75b3a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6bcd3738-619e-4dc4-8f46-140ef23c90fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6bd1003d-436f-42fb-9648-5a536edb0807'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6bd76b41-4adb-4da9-bad9-90e1cd67f97e'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6be1d1c0-0be7-4ff8-8e61-9fea59047f78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6bed79d3-0b91-49d1-87a8-ff9960f33993'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6c011861-b878-4d81-8fcf-5bb5668a2b5b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'6c04ca6b-5400-4729-85b7-8804d28b0675'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6c05a4ec-aeb9-4ae8-8cd7-9ccd2bac1c56'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6c1cf632-86b0-4b8a-aa56-cad762a947b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'6c25c7e6-4a3d-4162-806f-c73349a7e75f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'6c325ac9-871d-4cc8-8dc6-f59888c5b4de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'6c468d50-46ac-4746-bc65-c7bd7edc06f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6c4aa020-4dcc-414d-8594-494fd17ac417'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'6c582aee-0ea8-444d-b27b-6568ef4fa113'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6c5b08da-9bb6-4996-9c95-b10c7fb630b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6c5c63d1-8391-4849-ae3e-21502d0b2a62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6c60f87a-068e-4876-a0b1-8514aa490c24'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6c6955b1-197c-4940-9738-f2f9c7deed6c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'6c6adf68-c51d-491a-a66c-75799d1a2d5c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'6c7c4845-e535-4308-8e24-8ba6ad8aaf3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6c7f1b5f-7006-4975-9850-84d9e7add83e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'6c838688-4659-4517-b402-a421824a61f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6c83ac4a-4985-475d-bd01-5e2a8da0bc38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6c84a7e5-fe81-40bb-8516-8098a52eeaa3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6c966c1d-6c6e-41a7-9432-a31d78db733f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'6c970f17-c97b-4ea5-9dde-35be7f3c9790'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6c9e9858-fa7e-432a-a1c0-3f5e486e4dd1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'6ca0038a-e55b-43ea-8f83-94a7f4569c04'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6cb34228-4587-49f7-a51e-26be493802f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6cbae4a3-733f-478c-85ad-11d7eaedf021'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'6cc9d730-ad39-4c4b-9505-161ef62fd21a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'6ccac928-e199-4097-bbe7-0faa5362d5c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6cd00817-0ecf-4ab9-bf22-855006be6a78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6cd56ce8-e13d-45b3-a386-9594b501db99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'6cd73a0f-2d3d-49d7-9b24-186c69519462'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'6cdfa3c0-8bc1-4ecc-bd49-00ba5619a3dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6ce99d06-01c4-4a03-9f34-34fc165136f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6cec12cc-4d74-4bb3-9028-f8eb0467c74f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'6cf2a53b-31ee-40ab-8e4a-91462c41e49c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'6d17cd58-ed03-4c18-a764-a60c58df86ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6d1e7933-53a6-410e-8ce2-d2a87096786c'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Not for tx or mnf|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6d1f1a6a-7ce6-4947-91fc-f1274c45f274'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'6d293dc3-ec53-4998-86d8-99dc01c30101'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6d2d2917-b9c6-4651-a586-52de1bf89e97'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'6d32102e-57e0-4e99-8ad4-b5e7a03558f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'6d32a4f9-1c7b-4890-87cb-3879f35a6c37'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Open|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6d3b6241-bbf8-4dff-8d8d-5ed99b01f06b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'6d4e4f88-e0e2-4349-a7fd-d4ce39849dc6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6d545345-77a5-47fa-ac89-b341f955eb23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6d61383e-7358-42d1-a054-db33d67e98e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'6d6e02f2-c3f4-47ae-b1fd-05a6aa3413f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6d6fd7a7-0dfe-402e-a329-aee88514bdc7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'6d824a40-1bfe-408b-9336-f186eedfc84c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'6d8363f7-d674-4357-88ee-c03ac9d17082'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'6d85f6c3-4de1-412b-b912-d28687273551'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6d8d2cea-3e48-4108-ba23-4bf51adf79c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6d9638eb-bd09-4f6b-a899-946fcfca1144'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6d9a44bd-4c5a-4ba0-95bc-e28885d4caa1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'6d9adf88-7b05-48cd-93c9-f2ecfd46f9d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6d9fa47d-1d15-4643-9909-5423ba4610c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'6da0ab06-7fd6-4469-881e-83f3acbc0bea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'6da3085b-5a8a-4493-8d1b-578dcfc96daa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'6da45ff2-c185-468c-87fa-836cadac1cf0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6db2b023-db78-4438-aac7-f2ac58b9c6a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6db73469-5608-44c0-aa9d-bd3d585e653b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6dbddb44-e8e8-4bb2-8cb8-b1e110547b9c'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6dbfb6cd-b101-4cc6-9dbd-42e8d691b563'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6dc72f37-238b-414f-8fe9-fe3bf2f5a843'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'6ddf13b2-a56f-4aed-8cbd-0f7ae8ad2c4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'6de44e69-4ae7-444a-8a51-013d7a16e254'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'6de63a59-c573-43a1-b51a-eb3b5ee6c9eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6df4246e-fb6f-484a-9be1-31bac4465e6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'6df51e1e-6029-4b78-9053-b276bfb96b14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6df98cef-205a-4d83-9cde-3d19cd59894c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'6dfc5e18-95fe-49d6-bd83-be6de87e6e3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6dfcfdb2-00bc-4fc7-95f4-c1aeacfb6e88'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6e03cf02-e30b-439b-80cd-05e1ec8567c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6e062ab6-d2c5-4227-9c5f-ad133d90fa69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'6e08530a-b0b9-4a30-aed0-438f19dea067'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6e0bafae-6a20-4c09-a5d0-52f78983a8f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'6e0f564b-8a12-425d-aaa8-2556388159cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6e14fca5-6367-4082-8a94-e527a542b541'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6e166dc1-f8cd-4a3a-b7c5-947c86b646c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6e1c5f62-d465-4d10-bc5b-4226f8ebf04f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6e217514-a122-4791-b056-3c8561fd53ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6e289d62-2302-4921-b59a-252b2ec294e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6e2c3e16-8897-4ec4-a515-11134c13306a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'6e43d868-5963-4a36-9276-01dd0a4aac03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6e464e8d-6814-4ebe-8c0d-70b6362f9cf9'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6e47eda2-d112-410a-9398-41afd8024b0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6e4bf38d-7924-424b-bff9-5924ad66bfb2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6e5b61e4-61fb-4461-bd11-c1a47ae68967'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'6e638202-2465-425c-9c20-3bfd02c48e18'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6e6bb25b-39e9-4894-a44b-a7d5ae7f430f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6e81e305-5afb-4807-8d17-1720fb22e6d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'6e88b851-cb14-4b15-8495-3c12403dca7f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'6e8cbda2-2bfa-4a10-87ac-82a53b7ed1ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'6e9b85ba-a4d2-4ad6-9657-b754cdda7da0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'6ea1b245-0884-48d2-bd45-c10e684ed96b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6ea81db1-3e89-4cb9-9250-c56f7adc3a02'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:noninjectable|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6ea95b68-ff5b-494b-a211-598b4b37f313'
UPDATE dbo.BloodProduct SET RecordStatusCode='A', OriginalProductTypeCode=N'E014', LastUpdateDate='2011-07-27 10:54:08.050' WHERE BloodProductGuid=N'6eb0b436-15c4-4567-8e72-1b2dc8229e86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6eb655c3-8336-4d88-8d67-ae66b0699de4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6eb684e3-a1fa-48b3-9526-e36e404daa27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'6eb6b422-3696-4aed-8cf0-868c24c89e44'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6eb800e2-7260-49eb-9833-6696b4542180'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6eb85deb-4149-4131-a895-7384ab937503'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:injectable|>=200mL<400mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6ebe62a0-3445-4080-bc9d-b22e98ec24e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6ecc21a3-677c-49b5-ac1b-a57d89b27509'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6ed3998a-ce4b-4485-b9bc-d91768fa8d9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6ee8ec26-b742-4f6c-b004-d3e71005dd73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6eeb0fdf-098e-4602-bc0e-046f23c77d08'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'6ef0c858-3f32-4559-ac65-3af924cefcba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'6ef43806-c30f-481c-a0fd-5d1ad237b7c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'6efac154-ee5c-4e76-bcd0-eb58cf1f8572'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6efaf088-a380-40fb-9dda-6438f97edee2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6eff401b-6279-409a-8587-4be8e5c52898'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'6f027af2-dba8-41ea-b325-8daef225feee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'6f035084-8197-4530-85c0-59f0104576cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6f17224d-ae09-4aaf-a0f0-e673dbf90a62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'6f1ff58e-23f3-4ee8-9194-90cf90b7609f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'6f26f529-e7a7-441d-bff8-80348737b1ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6f2aefe0-5bc8-4185-b3d3-512c8ce388be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'6f2d7acd-4388-4db8-99a8-5d650f06dbc2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6f32d163-44f3-4a26-a3be-7b82d8bf0f81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6f456858-cf05-4c2c-86df-c25b69d3a290'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6f47d1bf-7493-40ba-be02-c66104596846'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6f48c9f1-ceaf-4f94-9973-85b8c5890904'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'6f51eef5-0570-448d-935d-bc11d6ce0dda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6f5385be-7ea9-4309-a857-22625a4fab71'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'6f541c3d-7f1c-45ac-9ee8-2ae96bbbac15'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'6f58bde2-b550-4edb-8e3a-7a8fb9467d00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'6f5cc7de-22af-476e-b870-a13e8c705468'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6f6aab91-a4b4-468d-9707-305102d2b938'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6f7ae162-5c80-4987-bbdc-3de99a190dd7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'6f7d05e6-4d2c-4d26-bea9-121bf44753af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'6f8a4e0e-2563-47c1-a2cc-3bc0b1fcd17b'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-65C|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6f9757f6-71e2-479c-9bc2-3a815f50de46'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'6fc26218-67eb-49b1-a894-27f694516673'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6fca4b5b-51a5-406f-8a3d-9f3853677bdd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6fccc55f-3614-4a05-926c-9d3406769828'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'6fd58741-8a93-4a48-ae10-5dbf72d91a0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6fd6c1aa-0727-4bf2-aa57-a61215beae41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'6fd8048e-296e-4067-8640-e1c74aaa8920'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6fd8decd-f1f6-4b1a-8f00-c6d050562548'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'6fdd735e-8c80-4a5f-840a-7ebf7713be58'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'6ff468d6-747c-4587-9788-dcd355256cc2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'6ffc11c2-17a0-426e-ad55-5fe8bb6ee932'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6ffd8011-58e7-46b2-86fa-8c9aa20d48fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'6ffee490-e6f6-43d3-b069-26e01ac7bc09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'700e0623-7bfb-40a8-b4eb-7d38e9b14caf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'70157800-0851-4dfd-9f28-298cfd97e7cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'701d5ea5-8917-4e5b-b1af-795862b7ebb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'70207a2d-e0e6-422c-a4cf-71b91a10a6c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'702c1a56-50d8-450b-a4fb-36bc0165361a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'70326d17-08fe-4579-971c-e248a133013c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'7040b9e7-4fd9-4bcd-842c-cdd468d2b482'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'7046f86d-46de-465f-89c3-c261930a1f18'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'70498679-0e2f-435f-beac-b782a0d9ff18'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'70576807-5893-4dc6-aaba-c3e5529e585b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'70579117-28bc-440d-b056-a3863aaa811e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'705ebdc8-fe5d-4a1b-9767-c6910719077e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'706144a6-cd50-4f92-8a8d-01f9b6db5212'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7062eb3a-f0d0-4819-affe-591496ad5f4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'7066cccb-6c20-402c-a510-6c6069947fb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'70679e35-5c35-43e8-9281-9f5475fb6b49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'706fcb8a-1262-4b58-a959-da3eba272701'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'70730f4d-5579-4192-94a8-1d908ab48ed3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'707a1125-dbb5-41b1-be2a-6f449600def1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'707c64f9-b0b8-4fbf-b52c-1e486eafd8bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'707c873d-ccce-49e8-8460-65930f409587'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'707ca1f9-b075-4808-b96e-2964857b78ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'708ca055-b0c2-4d44-81b4-5e27648c8724'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'70941920-1840-47e3-bca9-9b0015fa48b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'709dc264-e3e3-4676-b1ab-07e1f4d64225'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'709ea564-2e75-44aa-ae7f-917346e426a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'70ab7927-914f-40e6-b897-6df302376826'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|Not for tx or mnf|>=400mL<600mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'70af08b8-399b-40d5-bd1b-508bf03082b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'70b2a85e-ebcb-4062-803b-ec02d15f8ddf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'70bf0def-f6e5-428e-8e90-d289f2278711'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'70c438fc-b24f-4a71-8e2a-61aece40590a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'70c7750d-3056-44aa-8158-3e6233aef538'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'70cb9e4c-6386-4b0c-9064-4a9172088758'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'70cef5ca-31d9-4300-aef9-78e9b79aeeaa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'70d35f34-308f-4e4c-8644-5ebbd69005bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'70daf241-82fa-485f-a834-1a1f53a28dd3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'70df6913-f782-4204-a5b9-aae74d6285b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'70e30723-6a80-48c0-a330-9201d92864fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'70f09ae1-11bc-4ae3-baf0-034cde02878c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'70f18bed-fa15-439c-aa79-efcd7290612f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'70f44788-8d56-4c68-8f4b-9f89a0f8154f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'70fdb496-9f5c-4b26-8b8a-800e02efbc83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'71152094-52a0-4037-b3ae-ae29fa8028f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'7121572a-6f76-4942-a13f-904b80b10690'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'7121853e-5f00-491e-8950-0e4907cc318a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'71322598-6b1d-40e5-944c-9828873b6e26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'713b3b1f-23c9-4c2e-a83d-43b2610e1095'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7143cd98-6de0-4796-8b32-a28652526821'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'714773d1-4936-4f0f-bbeb-da462124e2e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'714eb1ac-af47-485b-9974-13c7bea51689'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'71550e11-a75a-4e59-b742-2108892db8e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'715c85d9-9f88-4a5c-90a5-d84ca3355482'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'71660555-7e60-46bb-a672-0503066a7f4c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'716ab800-94b2-4319-94d6-8f6b417159d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'716d9c69-9805-4d14-8d70-9831eea3d2c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'7171257f-73e3-4ba0-be24-4ba8326f743e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'717932b8-4109-488a-96c0-7a45c2e0a2aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7186758c-3043-4689-b9c3-1ccfedb7acdf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'71890ac5-5c17-4351-8e5a-98846029adb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'719cd020-dffd-49c9-b1d0-1346f064de67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'71a3d077-bd7b-485d-b47d-3ed508b95d42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'71b18a30-8dcc-4a39-8012-48116c92853a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'71b3e0f4-d718-4293-84ce-158a53be92c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'71bd90a3-b315-4adf-b404-33ea58a61e58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'71c35744-118f-4043-a74d-02a49b4d2e79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'71d1e040-e468-4dc1-9253-88831cd0433e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'71d4067c-b8bb-488e-aaf9-3019a25b0944'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'71d64386-5792-49b4-9526-2bcba4f00905'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'71d9158a-946f-4097-8a25-d3559abfabec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'71db150b-5877-444e-99d2-1186b83f21a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'71dfd170-bede-43e8-876d-7ac99ce0f0cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'71e1af9d-edab-42a0-9f83-2cff64b337c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'71f55004-9139-4ab6-81f5-25574a6e7372'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'71fb98f9-af79-4aa6-975a-b92ff2aba250'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'71fc669a-97f7-492f-8a6e-39b529f7327d'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'71ff1c52-f8c7-4773-b908-732e3efdbde4'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'71ffdaa7-3313-43fe-a3ca-d6abb16cb06f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7202d54a-6ee8-46db-b841-d9455e74bcaf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'72069650-b54f-40b8-9e13-2cb8ffc0ec37'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'72088eab-6840-42f2-9c6f-a5ad4eead94e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'721994bb-b45c-453e-b1a5-4c629e7c522b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'72211aae-6631-498e-8624-d3b27cc27adf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'722ccd7b-df92-4a33-b4e7-a3f1ecd110d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'722de1ed-e6ef-4227-87b0-d25207f1f9e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'72498521-10a6-44be-bd22-7ad5ed34baba'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|Not for tx or mnf|>=200mL<400mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'724b7db1-2fff-45bc-8f23-9ce2f9e4656a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'724c08d4-1f51-4ae4-8601-2dbcde44c850'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'725542e4-c1dc-4242-85c7-f9ceb4640d34'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'725ba79b-3138-4629-a843-7612223ed3c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E037' WHERE BloodProductGuid=N'725c0764-36be-419b-ad88-1fb1a2c11ebb'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Open|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'725f22e7-6cc7-4eae-81ee-f763067ec328'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7261e040-9d59-481f-956f-b188f68ec3bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'7263993c-12c0-4897-9785-48cd370a0afb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7268c0e1-2c21-42e9-a245-0b8b51a77b79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7272d3b4-3ac0-4cd2-9525-e7d21da0f3c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'72791b64-adb1-4b64-870b-c1fbf7396d3d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'727b275d-d30f-462a-a5d5-0dbee8a52b14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'727bcfd9-2b64-41ac-a69a-07bb2633ae22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'728ab935-bc42-4788-9f4e-ff6cc8e80d31'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Open|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'72961c02-24f4-4127-92d9-be5a193d539d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7297e2a7-f6c1-467a-8565-804c703955e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'72a87f90-c333-409e-b416-f0b331680f28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'72ac8592-84c3-4846-92f9-caad036fa570'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'72b1457c-ab18-4923-974f-fb4fa1d7e540'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'72b7b724-8457-4b81-838c-5976244be8fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'72be0bef-1bab-45ab-a9ef-cd30328048ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'72d62690-0943-4eb8-9ebc-14349ced4d6e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'72e35d2d-7ad9-4fb0-98f5-3844df7d57e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'72e40b02-b14d-4421-bb83-1b9a686f323b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'72e9bdba-bf16-475d-b0ff-4bf689038216'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'72e9d14f-e528-4ab3-8b2e-cfe1a3903ff0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'72eb107f-e066-4f32-8db9-cb2eb4237d43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'72f060d1-0db4-4382-8897-3c1dfe7fe31d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'72f4115c-3aad-4a73-b933-c6cf765d7425'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Open|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7304e1db-b73d-488c-9fb8-3dc86da04828'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'730e9f3b-def3-48aa-b2d9-1a0e7d895fac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'731169c8-d50f-4bc9-8364-7800f18a79b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'73277db4-f25d-46c4-be59-3acbc4d13114'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'732eaa31-bba5-41ef-bfdf-a26b3ad78db2'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:injectable|>=400mL<600mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7334438b-a503-4906-8f14-bdaa9e3ea369'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'733ac0a4-929b-4d5f-8c45-22db368b8440'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'733d9fcf-1883-4e7f-8499-f3c30d2f02b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'733e78a7-b663-4106-b0fb-8fcc86c201d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'73450290-2f04-4d7a-9435-3e50e97692e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'7347a524-82db-4448-98cf-ec1ba59a7cab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'734937db-827e-488b-82e4-19271fc75456'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'734ac4ad-d4e9-4ae2-b44c-332c44715504'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'734ff711-8054-4255-99c1-1b27b0bdf3fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'73513bd0-f3c7-43d7-b326-4863a6c7b63e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7354e2e4-24ea-41c3-8c54-b606a7419913'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'7359b334-8f5d-47d7-bf86-23ffbc897cd0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'73630e46-0c17-4524-985f-078303774035'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'737eaf84-37c5-4da7-acc1-7f0b85ec3b03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'73880700-b048-41d3-9399-97cca3e3a1ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'738aaa6c-224b-4346-8404-817e6ab5770d'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7393267b-4b55-4e99-a648-bc31dcd78da4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'739a16d1-2a4d-4189-8d90-395bbf6f8921'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'73a832d5-8f96-4323-a374-1ebd73f7e3a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'73afbbcd-f73b-4ec4-acbe-e51e32060b40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'73b4a70f-af29-4596-b70d-674397a06623'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'73c28ed8-774e-4251-99b7-7a137a16b7bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'73c2b2e3-ef44-47dc-8dd4-60339db9b8e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'73c4dcb9-aeee-4e00-b087-04f0283f3601'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'73c9f5b2-dc2a-4a64-b31b-0fb581adb1f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'73cc021a-ed4f-44c6-95a4-ae2330add909'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'73cfeae5-aae7-493f-bb92-ff2b34b75a80'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'73d40617-28dd-48ab-82bd-40f836b26949'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'73d64176-4ebe-4041-babb-9ebd27127a90'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'73dc7df3-9ae1-4d6b-987c-714a7172d8a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'73e1d4e7-427f-4bee-9a74-64c6503d07f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'73e9bde3-f56a-471f-8992-530dd66bfe58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'73ea7f01-64ab-4354-864c-2994f5af7bac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'73edc68a-5ca1-484f-9dfb-dab2fefb1e9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'73eebb74-aeab-4dbc-9149-dc17299ef3a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'73f7c0f3-ff21-4670-a7b7-7590aa1b3d89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'73fa9455-ebef-4c37-8c9c-b6d041e8f128'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E032' WHERE BloodProductGuid=N'73fc306b-7d95-4a3b-a2c2-18cf4e5ce6a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'73fe452f-d3c5-47ce-9e84-2d5e0b6091c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'740b79dc-2814-4556-9332-18309adcaeb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'741b094f-e2e6-4c8f-9d23-c8ee471102a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'741b6474-69f3-44f9-9df8-52a3e492de65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'741de46b-ab9c-4846-8382-4df401c2f95b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'741ead08-58c0-4e30-9442-5e23a4b8268c'
UPDATE dbo.BloodProduct SET ProductName=N'Washed Thawed POOLED PLATELETS|NS/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Buffy coat plts prep|From 4 donors', ProductShortName=N'PLT Pool Thaw Wash NS OPN IRD LUKOPR BUFCT 4DNR', ProductTypeCode=N'E023', ProductAttributeForm=N'@72 B2 C2 D5 G2 J4', OriginalProductTypeCode=N'E064', LastUpdateDate='20110509 11:08:37.280' WHERE BloodProductGuid=N'742f7e65-9dcc-4f4d-9302-628ccaf4af1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'74306ddf-8e4f-4b85-9ff8-da2228acb36a'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<-65C|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'743cc1e8-4525-4288-ae9c-18e99127a73e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'7447fbbe-7565-4d48-8888-f83284a6d2c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'744acf3f-8f93-4e20-b48e-0f5fbc956e10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'744efe9f-137d-41a2-a714-944be5ef9ef0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7456a940-331c-4c24-803d-e1de486c0de3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'745757a1-de1f-44bf-93a2-70bd84227915'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'746ee0b6-2ef1-4e44-9413-ff481ec85c5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'74779a12-4a34-4c4e-84f2-fc4504d5e867'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'74791fc3-87d8-4eba-bbbe-36ed2c4d44fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'747f28a3-119e-45e9-8209-f309e15757cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'747f9d11-c154-4892-8659-52f35ff5dc38'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'74816556-3fdc-4472-8b48-9a9e214da3fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'74863ac0-1257-4c23-a653-88576aaef14d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'74865135-76d3-47fa-874a-f1c8c55f9a1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7487d7e1-a2e7-4b52-829d-eec3506c650d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'748d9fb3-f69e-41ae-ad5b-5dc6d33a3473'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'74911a84-8437-44ee-971e-009d23280b03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7491af83-97fb-418d-a077-d0bbd8acc672'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'74929a18-0ab9-48c6-9061-2d33d592c887'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'74a2f5d5-81ec-4434-8a08-a3088971c8a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'74af68a0-d2eb-4e86-8d66-37baf244f15a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'74b21b76-e12c-4b29-aa78-288eadc81a55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'74bf255c-807e-442d-b843-2c349cd7288c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'74c6f844-a166-44d5-a99c-c0c9cfbb614f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'74c9e0ea-0146-4924-a94e-10a330e62d95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'74cb4145-3f47-43f0-885e-2807d5c26aeb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'74d4e28c-306a-496e-9e9d-7fcfe5c0bd47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'74da009f-45ab-4341-a54a-9c888a1a9333'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'74dc7aac-deaa-4164-9246-6ea0b77520d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'74e878fc-0625-4d90-9982-62256985a457'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'74eb30a0-4bda-4984-bc64-4c24f4d1737b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'74ec4040-0ca4-47c7-b3fe-32a2b8f35994'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'75076e89-e24d-400d-9a68-3df34e7a510a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'75096097-1f00-45e5-a33a-e04805be7d13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E042' WHERE BloodProductGuid=N'750a29b3-dc59-488e-bdab-87312f493cd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'750f23e8-59e7-4c1b-876d-517e53fb0d5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'7511450e-2bec-4ed2-8423-dc3ea6ca8ad0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'75148f2e-3e44-4e1c-bede-633707d03068'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'751ad44a-b6fd-477b-a828-3b419033dcfe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'751c8ec2-14ff-45b9-8ec5-dea2cd18dc3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'75214975-681c-4639-83eb-d008ebb7b21e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7523a296-ffc2-44c3-848f-2149be432a6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'75390bb1-f609-4523-bdb2-c3cbeb0f6e25'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'754946aa-4828-495b-af71-bcd0416d3573'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'754b90a9-4b52-4b1c-8913-d95df2a5bdba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'7554d48f-3cb9-4019-85dd-8bdacc25f92e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'75746a8a-6a15-4daf-992a-b8f5f29b7a36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'7575b016-2d0d-4414-ad8a-5de2a863234b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'757b08ff-3f37-41d4-9f7d-fb43beb7520f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'757fb2d5-c0f1-4fa6-9247-58ef00c1ce11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7587415f-1e75-4ffd-838b-1db1b15c0116'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'75899255-732d-49ea-b9fa-bc8652092481'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'75989ddf-6d53-44c1-a490-088fe8ed7e46'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'759b231b-539b-48f0-8e72-ca79723711c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'759dc056-477c-4233-9e53-079466d6a067'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'75a131f2-85cb-4ea0-96f0-b741cbd7519d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'75adaaf6-c7aa-49ea-a7b6-d3f00ac528f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'75adf39d-213d-488f-86b0-33589eb71f09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'75b303ba-d10d-4eff-ad03-1f8ba9220c41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'75bd2a9c-b2a2-46ca-8f03-1ffcecac84be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'75c07b0d-2f1d-476d-9429-e23a440fface'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'75c4145f-85bf-4d13-9f15-64bc17046eca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'75c92bf0-7529-4312-803b-235706e426cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'75ceb639-7785-4a65-8805-ef45375c503a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'75cedcca-e11c-44cf-b13d-960923752182'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'75d05816-2fe0-486a-96d1-57aa8367799e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'75d7a734-c8f4-4a2e-bfa8-b47d23a08308'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'75e3e8f1-667c-47fc-94ec-b2474c754e80'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'75e4c79f-7360-494c-b71a-7ee7b3fd11c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'75e6523f-b8bb-46c7-b2e7-e581a0b7daa3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'75e6cc56-dcee-411a-a758-37810d3fac5e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'75f9e0d8-ef5f-4254-a3f4-a73c6256b831'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'75f9e739-a716-4237-99f2-4957c67ee3d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'760906d1-6e67-4a8d-8905-22ede22682cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'760f24cc-36da-4a67-860f-6e42dbadf764'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7620f99e-8817-42f3-803a-dbb29e7aaad0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7626e11f-9585-4bab-9b67-51c32b39524c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7628b75b-a398-41b6-be6b-0be35589a1af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'762ad9b7-ef3c-450d-bb89-aa460eb4578e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'762e4048-9d51-47bd-b704-3168b1090be2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'762f0656-d64b-4eaa-bd6f-61da73afd353'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'763a1d4c-2681-4c98-b6ce-b84699db985e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'763d29b0-a2d2-488e-972f-2fe5e2759a49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'76426655-318d-4ba9-a9d4-b85ace6e392e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'76484e0d-62a2-4c7e-91ae-5e53cb8ade6f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'765158b6-bb3b-411b-b254-ca4a3e0d4cb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'76529fad-b3ac-4d79-a08e-ffeee077a56e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'7665bb5b-3a15-4f62-9052-27bade8681dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'7668fd6f-116f-4aae-a961-0942e0c9b99b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7672774f-a896-4eb3-b51e-9984ad0729c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'76744f25-bda6-40c1-922a-d1a672c5ebd8'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7681e461-c24d-45da-a2eb-9790d1bcbf82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'76851312-e85a-406b-a2a8-d5247aa05b3e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'768b5a39-9afa-4835-940b-23aa5360a558'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'768b7537-3d74-4321-81f3-e8fd335bc134'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'768d2f2b-9ada-466f-820c-42b78c6dbe9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'768dfe1e-cb90-4f02-a538-ebfb43eced7a'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-30C|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7691ab2a-7fb3-4c3d-b861-bcb89c09106a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'7697daca-99a2-440c-9cf5-694e3ee87a86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'769a01bb-a931-4221-8d8a-71c7b6ad220c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'769ec36f-4d63-4f40-b3c8-a2d64c9b6757'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'76ad931a-b96e-4382-be8b-d904f3d786ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'76b25348-19da-4e56-ae9b-b40bcd4f3dde'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'76b36678-ae98-4ff8-94f4-1151ed686780'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'76b8e306-744a-48f2-a5f6-1bd06428ccbf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'76bb036c-29fa-46f4-9dc8-5f982225dd6e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'76bc9483-5c31-4043-9361-f05fbcd577f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'76c35eb9-6baf-44dc-a7ae-789a6856ff42'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'76cec99f-5689-4e80-a60d-bbe9aab643e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'76d022ba-c7e2-4489-abc8-379eab533908'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'76d53eb9-2f08-434e-8b79-31363dc7e63a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'76de740f-bfa1-44f2-b6f0-f774be86f523'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'76e85690-1bd6-43bc-9202-8117dd41712a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'76f37e6e-dac2-4923-8298-d6998a48e080'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'76f63987-533f-4aec-8be5-4e2d59d12820'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'76f6eb30-02ac-4470-a696-7d1132467c83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7701ee6d-9f57-4d7a-aef9-3ce10e3ff3a4'
UPDATE dbo.BloodProduct SET ProductName=N'Washed Thawed POOLED PLATELETS|NS/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Buffy coat plts prep|From 5 donors', ProductShortName=N'PLT Pool Thaw Wash NS OPN IRD LUKOPR BUFCT 5DNR', ProductTypeCode=N'E023', ProductAttributeForm=N'@72 B2 C2 D5 G2 J5', OriginalProductTypeCode=N'E064', LastUpdateDate='20110509 11:08:37.280' WHERE BloodProductGuid=N'7706156c-79c9-47e5-8b68-74e8e0ab1c71'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'77176b3b-1c8b-4ebd-85d3-e64c0b796167'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'771b139d-5b63-4fab-bc8e-0a026a9ee62f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7735198d-7e9b-480d-8e99-8620a38f89cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'7743486e-9802-479f-b5c3-7847eddc7d7a'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'77445147-0ed1-4d61-8d10-baf92b119a33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'77497f39-6d6b-4b4c-8872-d24d895a2465'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7752da29-269a-4c56-9ee4-219109e709aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'775a9a13-73c2-4706-b363-fe602f5fd373'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7761b106-8df5-4769-a922-776705162b8b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'776a5d77-e383-49f4-a7fc-e55c5c5b5809'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'776c4830-a0e7-401d-8575-706ba98573b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'776f5f12-546b-4c01-a96c-b9f217d2e20b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'7771ad80-b1e7-4b9e-93a8-826ae1e8ccf9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7771deb7-5382-4e6f-82e4-edaa8810c9d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'7775b7b5-1841-46e3-90cd-92da67810c9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'7782ac14-45aa-44ae-b034-a1cf04a44489'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'778627ec-1f6c-44b5-b550-e3ff306693c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'77887dfa-029d-4e3f-a3ba-fa9bc254c5d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7788957f-64dd-4c6f-b522-d259b4c1e4ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'778ee9ab-5ce8-4cbe-a2ba-e3cec2df28eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7795d740-ed7f-45ad-9bd7-9aca65127bae'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7799d988-814c-4e4f-9648-bbb4ce0e9c03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'779ab27c-06a9-4ba3-9a53-d5c4bce3313f'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|ResLeu:<1log6|Plasma reduced|Buffy coat plts prep|Approx 180 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'779b2c48-b613-4f40-997c-832493fb9e0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'779f6976-d71c-4d40-9c7e-5544273d9fc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'77a0c696-0ee5-45cc-b2a9-89a52250a270'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'77a44e41-7b0d-4878-ad4f-847520dbd5a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'77aa7e25-b4ba-4e8f-beaa-92fa92baaa33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'77b19854-f281-41c1-9616-5f682c10164b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'77b2a2a3-a52a-451e-81af-9a54a02c15f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'77b8e177-daf7-4fa0-8a98-d139e92daa41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'77ba6835-5e8d-46c5-93e3-e1a70023b89f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'77c2d559-3874-4acf-ad01-ae8759ba8540'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'77c70c6e-d1b3-453d-b21a-fcf3388b16ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'77c9a6d7-63a6-440b-bec4-e4a2f5a9afc7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'77ded786-ce30-4706-a075-531309440dce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'77e64265-cd73-4090-86ed-da611bd35d65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'77ee702b-1bb6-42f7-87bc-47dae1ee67c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'77f05932-a6de-4808-a68e-2494b61f9bc3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'77f69eca-9256-4141-9a07-25e481a9b5a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'77f9efe2-e04b-477e-b7f6-13e5dcebb5cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'7805a3ce-754c-4df4-a2cf-7de7fa5cc817'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'7805bee3-4448-463f-90d2-c4af798a097c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'780bc3e2-ac37-43f0-82f5-c80f44c829a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'78102cbf-80aa-464d-9e64-43f7ddaac4f1'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Irradiated|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7811cf22-0100-47b6-bd2e-e10e2e4e2859'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'781245fa-efac-480a-ab4c-1a9377e87873'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'7821af1f-145e-4c8b-91aa-75187306ba8c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'78311f3a-9725-4ffa-893f-b1af845f0bbc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'78322589-d78f-4c97-8dfb-9ed39f83ff9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'783456e3-473e-4586-b431-925a33543ac4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'784a6ea8-670c-440a-965a-2b47f82094d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'785ed71c-1be4-47d0-8ee8-39e51a0ba609'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'78728826-20fe-4db0-abcc-6d3a36e89b09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'787722ef-1d57-4781-b783-5a812b5ea9ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7880249e-2be1-49a1-8a5d-9c2432df644c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7881656a-ddfa-4d87-ab4b-177ffda4adb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'788355bb-99a0-4d8a-8899-8527e4970747'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'7891cb23-4941-44eb-bb09-a56792d83cc8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'78a7c48e-03c8-4ef9-99d2-97b22fb3ec21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'78bd6274-255e-432e-8926-1dfe1b41277e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'78bf99e9-e3d1-45e2-9bc7-02578767eb28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'78c6a553-ded1-44f2-809f-5fa3b84f95bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'78c956f7-e800-44bd-8b23-b1f96dfb1972'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'78cbde0d-422e-4df6-a907-9a89db992d6c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'78df3972-0919-4ae3-9da4-c9b56365fa73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'78e0cd25-89ce-401c-b19f-5b8b407bc1da'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'78e90670-8716-4ea6-9699-8ffe8b9da0d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'78f9c3f6-9236-4b69-9965-cd41fb25598b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'79062dee-5b36-4c13-b276-4b08f448fd41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'790a3dc8-3f06-402e-b910-6d9abade5ac7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'7914474c-5be0-4ece-a4b2-ae1d12453592'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7914d0d7-0eb3-45f9-b7a6-6f316b18da8c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'79163ee9-9b0a-4a57-a5b9-d09268336edf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'791e7060-fd07-426f-8e35-92562cfd1bf7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'792382a4-d6f6-41a8-8fc8-ab2371608487'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7923a969-0976-43e3-9122-0ddb3675e290'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'7926136b-c245-459b-8b01-127638a5fa98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'792793e2-523a-4128-b793-0645fd293e77'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'792a0d60-dd3e-49a5-91e1-c45bd3bc3984'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7937098f-f22b-4ead-a664-de59c723731e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'793813f4-3b8a-495f-b9f4-1ea8e299ec20'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'794efbf4-2cd6-49fe-b6d4-578e1647f33e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'79535082-a044-402c-99e4-3c9ae93de44d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7953eaf4-cc83-46fb-ac09-5c1828643bb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'795456c9-094c-477b-85d5-d9361747a3b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'795532d2-63ee-41e8-8ae4-2d33c0f1086a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'795e894b-967f-4c6d-8022-510221c41e72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'79640789-05b3-47c6-86b2-3eeee2675630'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'7976eff8-5a98-46bc-914e-2966bcf77146'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'797b13a8-d96b-447d-a425-c905c31269c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'799c0d85-9009-49cc-a9cf-17d0156a5aa5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'79b80518-8498-49e1-9241-cf1d772bf7f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'79bb078b-cf23-4b95-8dec-67df0062a940'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'79be0944-677b-483f-b849-d5657eabebdb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'79cb096d-f838-463f-9d81-a1545ea7398e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'79cf6c22-d558-4276-af21-e36e76818e5e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'79d82b66-2d9d-4ea1-a550-749cf371c1ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'79e068c7-4fb7-48b1-b6be-9bd7815b6799'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'79e13ba6-63f2-4e65-b38c-d26dfba056af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'79ec1ad3-fcfa-47c6-bb41-39bdc4b8ba36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'79f2764e-62d0-4671-9ad1-014b972e5969'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'79fe3ef8-1b83-478b-a8d7-764ac9e05550'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'7a09035d-eeb4-4766-9dc5-31b6a39f23ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'7a0b68b1-f8e6-4629-9631-dcaf618f598e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'7a0db706-329e-4041-bbef-536de5987039'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7a168b44-90e9-4859-ab6c-76686323fbf8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7a1bd1ea-5034-4632-9a70-c0d8e44d246e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'7a26d34d-1c4e-4ef9-9672-99444025cd2a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7a375479-abe7-4218-8a2d-ccd795b98fb3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'7a3b28ad-e14c-4c2b-804b-314576380035'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7a3b591b-de46-4c27-8dc0-e04f8b866e95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7a3ec10a-7aec-4e19-8a3b-da02bf802462'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'7a4a4e79-b62b-4f43-94cc-87a3a867bc83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'7a56d698-a37f-4562-aa4a-6a059e8ce2a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'7a5d4a0d-39b3-42af-92a9-f0d0fdbd3a57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'7a6092b9-5a38-4ea1-8f3d-f472db2b41b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'7a61c1ed-ebd7-4823-892a-52c22e19ac29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7a6ad998-afd5-42b1-a97e-0700d2595eaf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7a6e96c6-8e93-46cf-88a6-c2aa9124a6c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7a74f83a-1bf5-4567-a411-01305f7b703a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7a75346f-19f9-4d10-8d84-7957ef642a99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'7a8015e8-625d-4945-bc38-a28450ffcea0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7a81cd35-0cf4-49cb-956d-33f9ff57dafc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7a919a9a-757e-41fa-b80c-3111bafc9bae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'7a993cfc-93bf-4e07-a69b-bb234ad9ecee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'7aa5d34e-cf7b-4957-a7f2-b00c1b47d801'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7aa910f2-34e8-42a4-9566-1bfe0d636fe5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7aaabfa2-d548-4e79-a074-757dbec2fb8a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7aac9ce4-123f-4d7d-96ea-91739d7d986c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7ab9010e-101e-485c-9adc-618cc67a03a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7aba70f7-5a6f-4ce2-b5de-16b99f21335a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E048' WHERE BloodProductGuid=N'7ad4023c-9d29-43af-a6f0-8f7b6a2d63ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'7ae3116a-052d-402f-9953-366b88cf1d93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'7aee092b-5d5c-43e4-8db8-7d00d5c61e05'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'7afb1d01-3157-471e-9dd2-21a7272412e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'7b185376-5ef9-413b-aaf7-a85e904963b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7b24b30c-b628-4e5b-a795-010694720a6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'7b292c64-e6ec-4f2b-9380-7c3729582efe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7b2e2a03-bbca-4427-92bd-03da8358292c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'7b31013e-d057-4046-8487-530fef18c5cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'7b3570cb-269a-4402-8206-00cfaf62a367'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7b37d531-ccfe-4db2-83e1-d2cea84fef5f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'7b57fa3b-f69f-4b73-b536-ef4b19fc3ef3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'7b642e0f-81cd-4375-b66c-4ab8f6948905'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E062' WHERE BloodProductGuid=N'7b67ae2c-0bff-4fdc-aa5e-920734483f2f'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<=-18C|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7b83cd72-b943-4aad-98e5-098ab60a1f3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'7b89b260-5fd1-40a2-ae33-abeaa1434609'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7b8c0fe5-90e6-4616-9a31-5c923d8f3df6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7b8f9171-d7f5-4c5e-bc9f-58e2cf089c68'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7b91422e-8aad-4d75-87d6-9f16ed3351e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'7b924792-c179-4e35-8175-4936b0bad4bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'7b949d8c-6535-4e07-a73e-12be5c86a008'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'7b95584f-d002-4cd2-ae75-034e278a18f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'7ba41706-8a33-4906-9551-10b80e10e304'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'7ba5dde8-4a59-4cc7-b924-9a5e2cdf0f03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7baacf82-e114-498d-b389-012e8b8cbef3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7bab8baa-3bf5-4895-ab4c-e12957143705'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7bb11159-0f83-4b0a-a301-4255d62c8d83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'7bcc572e-1b1b-4811-8778-dac66cfffaaa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'7bcce853-aa70-4be5-b29e-ebdb2193a4cc'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7bd2b34c-99e5-49b8-b614-1203b1d16709'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'7bd3c48c-ef5d-4ec4-9cab-b6fd62e7594c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7bd7bb5c-2e3e-472f-8f1e-0eadc4766775'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'7bda43e4-8587-4446-8a5b-bf94cd5179e3'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7bdb959d-771b-4bba-94e4-cad01a0a67d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7be56c5d-0770-4b43-a37f-b8c01b0566b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7be5d8df-5057-4246-b6fa-d9d444253a7a'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7bff0bf9-8066-4692-ae6d-eb87e05b0608'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7bff34a8-de16-4bee-9768-d8812ad81aed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7c0448c9-bc1a-4c36-ae48-f37abd5b157d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'7c1597bb-0db3-4f50-9d4b-d29786245a97'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7c270a19-c6c3-48a6-9c08-b50b1ebe3e37'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'7c29671d-de19-416f-82e7-332b560e0bd8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7c43f6b9-e336-4a09-98ec-1a8ce6db7b5f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'7c466828-b522-4dc4-9610-01045a3d6257'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7c4a289e-173e-446d-a3a9-1ea3c41ab98d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7c4fecec-50a0-4f04-aafb-004c453c9337'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7c51dff0-d34e-4283-9024-82a5e4fe0244'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'7c52838d-b54e-4b76-9e22-bd291e5450ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'7c5bc92c-6c0b-4cd8-b786-c60a41f2a0b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'7c5c2e66-0c3f-4ef0-b380-d9a242ac7ce8'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7c5d67cf-9ae9-4f10-83c8-92af72153368'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'7c62d875-0caa-4921-8d70-9db79d4f115c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7c6558f0-2565-4e21-ad59-760f0329f507'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'7c6bc3b3-1027-4e15-8d86-c55489d94852'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7c6c4bd2-f673-47f9-802b-e9a22dd5e96c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'7c71e80c-01d0-44f6-bbcf-c54b72b9f3b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7c73af5c-d8e7-487e-851a-90ea0115f74d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'7c73df6d-f191-4361-8f0c-7f2957592a89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7c7a2eb8-0cfe-4430-8384-15df86cf1384'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'7c7dbfe8-0bf0-42de-80b5-450a80119403'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7c83d34e-16e3-461d-80c9-4a7600172d73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7c856321-4147-480b-8c87-f0ab542e49bb'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7c868cbb-6ffc-428c-a468-32364ff8da5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'7c8b5196-44dd-48e0-9c6f-3a617623ad11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7c901e2d-e953-4c64-b3df-9616756408a8'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7c920360-1b1f-45f6-bb4f-c2439d985a1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'7c9a8926-1b50-4dfb-b795-ce4748c2c43e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7c9e04ff-bb50-4c3d-b6d1-9b33c1cb0504'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7cb38fee-2682-4df9-8b77-eeb9569a98ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'7cb7ab29-f09f-428c-9c44-be32841e53e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'7cb83ff5-0ea1-44d4-8a78-8efb759134b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'7cbfe74b-eb6a-49cf-951c-10c1dc1ad1fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7cc49bbc-04a5-4aae-af9f-e0e38e455383'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7ccc1d48-210d-4b0e-aa6c-daae5932c438'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7cdb40ac-ad61-4048-95aa-7ce6e321db70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7cdd3225-1170-44af-8fea-f0f7b59ead8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7cde7143-e43e-4fac-bee5-29c31dbc6fb9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'7cdf1459-ea09-476f-a18a-8fef941b8d5e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7ce09559-1cc3-4bd5-901c-f546c1cbc845'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'7ce28fa7-6442-4e0f-b5e7-857ad3080329'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'7cefdbdb-5faf-4e8b-ba6b-b4c1c84d6c39'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7d03e1bd-5b96-4e14-b712-4d78c71d499e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'7d072d2d-9c3c-4bf9-bf45-d3b2a9e4b927'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7d0e7b85-69cf-495b-9b4b-8311269b2cc3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7d12a058-15a1-4eca-a421-9be40c5b3bf7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'7d171d30-0ac3-42c8-b2dc-504d3278015d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7d19742b-9b52-4484-9c03-e2c36a73979b'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Open|>=200mL<400mL|Aphr not automated|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7d331be9-861a-4e50-89b9-394aecc7f97f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'7d33fc52-1d44-48d3-b018-977ac3a41809'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:injectable|>=200mL<400mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7d358fa4-18bc-4464-b0ef-03e6f77b1178'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7d38a378-0515-4a77-8a09-5b49e4c78b67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'7d44a879-0db6-4013-a054-d1603a84abcb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'7d48c69e-0519-4fa6-bcae-885b107945b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'7d4ccd1a-df6e-4140-8902-b9ffca13332e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'7d546752-7afb-437e-83c3-c4e9ee06c9b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'7d56f1e5-f1da-4100-acd4-82dffa10aacd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'7d597946-ce69-41e5-b4a7-954942f856b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'7d5fcfce-cb87-40fc-bfef-fed61bebd20e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'7d67500a-77d9-4ff8-a8de-6f988e8e2d32'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7d6b0a41-6f81-488b-af5d-cf20f8ba505e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7d70f7be-64cb-4468-ba65-4157d80af2a3'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7d771c15-c2d0-45fb-97f5-a53f3d183284'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'7d84c9b8-9c08-4d9f-9956-c86fcdcfafa9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'7d84d017-23af-4edd-a422-cfb52ccceac2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7d857a2c-bf5f-4737-a1ca-b81c14bf68f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7d871f9e-f3a4-4d70-9ebc-59b6d6337728'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'7d8d0a56-182e-4816-928f-4b2cdd03163c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'7d8d6854-ffda-40a3-81b9-19caf7bf9d3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7d91b49f-353c-4e20-ad16-758074c65051'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7d95d4cb-9bc5-4146-9518-ba88c26c8f55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'7d96cf11-416a-46ae-9905-5c298bb37f01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7d9dd145-c7b5-46b0-b898-69d9deac34c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7d9ec611-8469-4579-8695-127554f185c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7da81da6-b09f-4b27-811f-3dfebd43a3c7'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7dc7d789-8702-4d53-b1ef-7baa983bf86b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'7dc87539-e17a-4a1f-b358-a667f5a7c83d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E037' WHERE BloodProductGuid=N'7dca1a0b-25cc-420b-a843-e6650255f5f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7ddb3530-c198-433c-bf09-8b366d7edf10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'7ddefe5a-c809-4fda-840a-b4269c5a0509'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'7dec3eb9-86ea-46eb-b460-3241b14242af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7df002f1-a969-476e-a95f-715dcd585144'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7df7be99-192f-432f-a7b1-351507a36215'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'7dfa8aa3-1f4e-4aa5-9d37-9284518ce6d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'7dfeff03-f0d4-402d-9a25-0ac2efff85be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7e11075a-6dd4-4d96-a342-8c024d5295b0'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:noninjectable|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7e347d7b-812a-4da2-bc83-419b802a098d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7e362181-0953-4e72-8179-791257a0a252'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'7e3b5406-e336-4b4f-bd4b-e79992f58b28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7e3ce649-090a-4fbc-9385-fee88818f263'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7e41ae74-30c3-4a9d-96b7-9b84112c4451'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7e41fcf0-9403-4d7e-9441-54f304d991d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'7e46d48d-8e27-43d0-9d9c-8a9c79ac707c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7e5037f8-110e-4045-b6c9-8d64339cf408'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'7e5dc0f5-96ea-440b-bb00-fbd351cc1f2a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7e62ca60-7160-4069-9463-a1fd5c8fecac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7e6d7e96-9c80-49c9-8306-4e94143df668'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'7e761d8a-5019-489c-b8e4-5bd407b8d7f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7e7afa5b-851c-4b9b-96e4-a68ab0a2cc14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7e7c83bc-0360-41c3-9427-10b986b64274'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7e845e05-b5e1-41ef-81e1-d898a7442fec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7e8ac5c0-e88f-4976-949d-e3d9d924df4b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'7e90d100-8169-4b35-a750-ff5c422c0b85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7e978acd-561a-4c8a-bf8e-ed0c75626c16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'7e9e5810-bd18-4107-9ad4-4407798ce144'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'7e9fb19b-607f-48fc-96b1-73b7255c3d01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'7ea097ed-d75e-4a48-811f-d53a6c50dd85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7ea3070a-edfb-4c51-8312-5540df6fd671'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'7eaad411-2d5c-4dbf-b7ac-814c8f99653d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7eae9b76-e3d2-4fb8-821f-dc9d3e561e2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7eb3cec6-5886-4860-a981-462e96fc9528'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'7ec2a692-5947-4c3f-b77c-0b24c5cae89f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'7ec81b68-c9d7-43d6-91f8-76440d15d7cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7edda184-8bf9-4ff2-9174-2115cdb1eaa9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7ee58c1a-e925-4020-b568-52164247ae9a'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7ef4fdb0-242c-428d-8ce9-0e5a0a72cfe2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7ef51e5b-21ff-425e-9e0f-410ae713e399'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7ef54aa6-2d76-4256-8759-1237c9eae808'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'7efe9a6f-6080-456f-b85a-dfa9fcad53f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7eff8dbd-e6ab-40cb-ad2b-cf98191a74fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'7f09998b-6a8e-4a1f-87eb-bcb530b8f668'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7f0c051b-42ad-4867-be17-d9a3f826c650'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'7f161aff-c2bf-4749-bffb-18a9cd68b384'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'7f17db7e-bd25-411b-9d65-c14fe8edc335'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'7f2b7ffb-c844-4000-9681-4243cd6231c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7f2f5f03-4ebb-4ffb-a678-a05e02ba66c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7f3d21a1-ed5c-4809-aa12-c986662093e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7f40e3b5-2404-4714-8a62-85599dd55fe1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7f4cd791-a780-4c41-b011-1f2e63fb5048'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7f4d1be7-1426-4668-b84c-afff667058b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7f507519-6d0d-495f-ad95-7317318cbae9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7f5088ed-7595-483a-a27f-29b0ccfccf2f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'7f521cc4-f7fa-4950-b8ca-7ad787014e1f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'7f5a647e-40a0-4bf4-a3f0-047721aaef39'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7f5d959f-987a-4b8c-8122-92000a8c850a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'7f5e6c6d-cd8b-4d9e-89c3-7d2356fd331a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7f5fb5ff-eab9-4348-9094-4be3c25f5854'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7f635d3c-8f2d-4d16-8065-759d473a6b67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'7f654bdb-86ae-4095-a271-4be24a24717e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7f67b30d-f8bb-40cd-a93b-094ff999b207'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'7f6e1782-dd29-486c-b0b7-d3cb506cefc6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'7f74dee5-e553-483e-87f0-6cc1eb0bdaf3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'7f833292-79e1-4029-a89e-c9ec4fa6716a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7f839b6f-4bf2-4d3b-a933-5256d627fe9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'7f83fce8-06af-4e95-b2c7-ce80dea66798'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7f883f9a-dad1-4698-81a4-a3b6292b51a6'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|CP2D/XX/<=-18C|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'7f9273e4-32a6-49ea-afb9-f8cfa570512a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'7f94a2dd-ae4f-4d2a-9a27-4ff75a9c83c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'7f957e45-2c74-4d8d-949c-b189f13e83ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'7f9aa8f4-6093-4469-80ae-c8a2fd3e816e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'7fa85586-48a1-423e-9bdd-bd39c009ce04'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'7fb143b2-05df-4311-a7e4-6e35d60c437e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7fb80621-f86d-4d75-8565-9d21b6ef36a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'7fb83d83-c0af-41fd-ad86-998c9eacaaa6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'7fbb355a-77ec-4b1a-8662-af97086e42db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7fcfecd0-3248-4cad-be69-f7d67fbba1d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'7fd3a6c5-9ff4-4949-8b4a-7c295bc29ea8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'7fdcaba0-85be-4184-b8af-20bdd27d5a5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'7fe26723-3412-4028-a3b7-bae19cb59484'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'7fe7a209-fb57-4a0a-a5f8-0eb706308cad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8000efb0-bcfa-4bb4-8e51-d37a8d5c57d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8006be6a-116b-4d63-bc65-369e6d847a12'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'80097c83-a6f0-4570-94e0-370f1eebf4a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'8013b449-b918-4a8b-b8a8-a20efb6d6857'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8018ed95-ab79-4885-8181-5a556f8c5701'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'801cdcb9-7698-4c78-9db7-88babb51f0da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'80209022-7db1-40b0-b978-38068e2f1cc3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8023ada0-7af0-4d1b-ac25-e6906c2fdd4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'80359482-2109-4bd5-a3b9-7c6692b8fac1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'80388b0a-b879-460f-a89a-0279779d72df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'8046f1b2-a63f-498a-8d8e-4be2661488f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'804bb545-3c48-4204-a07d-16d5447ed476'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'8051cdb3-3c53-4078-88e3-9ff137d03c06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'80526153-cd64-478c-9878-75f26ebe51d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8053e90d-a55f-4cd2-857d-b6f522b85b2a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'805c312d-cfa8-48f5-9081-8e51f484f76a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'806905a8-4bf6-45a9-86ce-5972f8490332'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'806e22e3-1a6e-4f47-bbcd-a236157d8d7f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'80729c0d-12e4-41bc-8811-3445b9eb9342'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8087fc1b-43e9-45aa-b6d5-637ff3db6268'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'808a01d1-9a98-46bd-88f0-82b2b86d263b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'808c17c2-3ea4-47c7-8ab2-4cf97c11fbeb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'808cc7cc-ebcb-437d-82d9-921b6e40f66c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'808f052f-7a82-4744-ac99-8f73272d6c33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'8093ebf7-c9da-44e7-a242-b75eb2a3723b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'80981e82-43cb-41a3-9f56-1de33040e5d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'809912bb-e839-4b84-8891-92a6ec37e2d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'80aac576-47df-4c60-8703-890b0fcd74cc'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'80ae1fea-f0d1-42e6-9110-a188db115217'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'80afb254-4199-4e7f-ae37-2105ef912cf0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'80afc768-6153-4f80-8335-2eec319c94cc'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'80b4abf0-6b5e-4c6a-a6f2-77decd40c25d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'80b5b39a-bbf7-4fc3-b722-0c6a381d995c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'80d68cec-ce90-423e-9b27-44ede28ddd73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'80d9e3ba-ac57-43d6-bd11-a3a7c3f9086f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'80da3176-5b25-4694-a302-8a85b4578381'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'80eacf91-09cf-4d34-b9ac-3b79b0e33db3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'80ec1b75-a12e-46fc-81a1-9d585a737a03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'80f172e7-b701-4488-abe6-3a820444fd21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'80ffff2e-cba0-4835-8c73-1ae80bfa6efb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'81035114-b5de-402f-ab01-c7d577d1a35b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'810c2685-719d-4bfb-aa74-cbc3bda84c49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'81133366-5750-434e-b34e-01fadafa7e95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'812191ce-5a47-45c9-8f13-34d9a560e668'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8137aabf-7449-48ca-967d-60149389e04f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'813cda0d-31d8-484f-a002-8c4721877599'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'814576e0-01c5-4ca4-9de6-dd510d4d898d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'814d6a09-43d9-466c-93dc-16ff66bc9aff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'814f029b-4ca9-41ef-b735-22b5e45ca6a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'8156d82b-c7fd-4cb1-9db0-95db39831f60'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'81587248-33b4-4bb5-a75a-4dd169ff54af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'815bb490-6fe5-4895-97d3-15b06d3ae819'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'815f3cd1-15de-4bb2-b06a-2b3073dfb590'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'81609445-bd24-412d-a307-8215d58155b8'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-25C|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'816129c6-a0bc-440d-bc31-7349ee3934da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'816d8787-fcf0-44f1-894b-316cc9997265'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'816eeb8a-4f28-461f-9881-8d6b308e48df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8170be5f-7c31-4ed6-9a15-9267f078d0dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'81732b74-2b1d-43b4-9eb0-a6a4d784a13f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'81786805-7c5f-4e5a-8254-4e3d49b13ead'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8178dbc8-becb-460b-97e7-a2fe1d991865'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'817c961e-aa30-477a-9e66-d46e700b1821'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'817edf32-f74a-45d5-8899-fa36b14f26d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8182144f-f380-4bee-9a41-a9a971cb20b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'81880b6f-6751-4c3e-8c8e-74b1ff22ed85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'818cfb1a-cbf7-4ffc-829e-1d2e7ba019f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'818eee66-444e-4556-a37b-3ad2c6ae1d89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'81922c8e-fc82-4f2a-8639-13d4c27f8b59'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'8199a9f6-fe0b-44f1-93f1-330927c0dddb'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Not for tx or mnf|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'819b585d-12f2-4f6d-a96a-35f0fffacc29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'819f0733-3170-4931-b63e-fdc97d77d850'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'81a2c4ce-c27e-4aa3-8c58-faeefa03c8f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'81a6a2f0-bece-4d0d-84c7-1b2a1da059f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'81acf1d0-7098-49dd-abf3-15de428eb5eb'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Open|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'81b0bd04-9256-46ef-86b2-8268b3ea3ce4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'81b3c073-64b4-46fd-acdd-053f94e43df3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'81b42184-f890-4402-b49b-0ea3297be7a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'81b7e93e-5dc1-471d-a16f-6d69ab495e9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'81bb3040-4e3b-41fc-850d-0f66bd9ef799'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'81c6b233-24ff-4047-b468-0aa8073624b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'81c9afa9-4690-4239-8074-60b5ff913f9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'81d0365d-311e-4c89-8884-30d2964968f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'81e84477-9305-487d-a159-354888e65299'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'82025620-7814-4a3b-aada-9d57e28a5338'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'82091158-fef6-45dd-af4c-7c690b0e3d04'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'820f688d-bfd6-477e-8173-a7d636eae95a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'82138d9c-7c23-48c7-86d7-c542df3cdf82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'82205922-7e0b-48c8-b1b6-31dd224fb4a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'822d40bf-d827-4cc0-9c64-539c5762451e'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:injectable|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8235a351-61fb-4f62-8c72-3c3ded34f217'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'824b7edd-7113-4bb0-a654-022a635ddcd6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'824bdf4f-925e-4c3b-a22f-3a9f0994527d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'82587f4b-aa45-43e2-9aac-84b7ef80433f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'825889ac-2a69-4b3b-a944-09f39c715647'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'825a7420-327c-4b9b-88ed-2ded1b1f4f6f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'825bfcd0-42be-40e3-b3fd-c8ebffc3f959'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'8262050d-1467-4620-8c88-efe5db3bf1d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'826e87cd-933b-4dc5-82dd-552313aeda26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'827efa9f-5a91-41f9-a581-faf78f029202'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8281afdb-d88b-49ad-b49e-ca8c97c6a336'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'8287c8eb-2506-4870-93b4-7727db1f34ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'828acee1-56f8-4b88-b931-266078d777b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8296524d-b40a-4462-b8db-5ccb40b7e8ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'82ae7161-a4f5-4f29-aa85-b946ce3fcf2b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'82b617f4-a373-4215-b130-2885961c6a3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'82b6a601-5763-4ce7-ba1f-d753d71e0f10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'82b7ff2b-60e8-4443-9c58-32d87f2f0770'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'82bce095-f976-48b0-a026-38dfeaad63d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'82c67c6f-9887-4509-b18e-016b454e4d06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'82c86dd0-b6a4-4653-b83b-5a0b36010052'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'82cb72f9-3aed-4123-b58d-a5b961d02e6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'82d1b7e6-2d8a-433e-a53d-b5d07ef5f017'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'82da58b0-facb-49a8-8860-1af591f283df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'82db4fbf-17b2-4005-b248-b3a35de6c2d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'82e639b1-0baa-40d9-9e24-96f2241d4014'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'82f1de88-4b38-4b66-8eb5-22a1cea94026'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'82fa38fe-380b-4440-8cf6-c8cbc83f2f1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'82fe85d6-a1f4-49c1-aadb-557a1931cb30'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'8304311e-b016-441a-8eff-ae088af48d77'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'8320ee86-f2a2-4470-83c2-f0f434d31279'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8321380d-3c56-4954-9864-11326a302538'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'832232ff-53a9-4150-a5eb-1020fcc85543'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8333b428-0bb0-48c9-aa5a-2ac4b43f55a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'8337e7fc-37b0-429d-b4ff-b8359b23228f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'833887fe-1018-431b-b990-9200cfbad13f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'8353842e-2287-420c-bc41-e02cfa76377c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8360bee2-f51a-4e11-bca6-f2c3a90a8d3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'83666c53-ea17-478e-8512-b493d309a374'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'836b4000-2eaa-4775-b7c9-61db767638e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'836b7180-7737-4837-a761-7d6850867f07'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'8383ad6c-e0c5-4a38-8b2b-eb405912f826'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8384428f-9f29-44cd-8990-7fead210fdad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'838a3ca8-6d4c-479d-8e32-a9bcb26895c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'83928661-051c-4b4d-9c56-1baa21764dd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'8392d289-6207-4e05-914c-f0cc19968fe8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'8392f0ae-10eb-4338-ad30-c0b6f722ef69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'839bc668-fd11-4215-889a-2bbf18880c30'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'83a22e42-f444-487e-bd7d-23de01af2363'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'83a61059-b970-4671-a390-c6ddf72b6352'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-65C|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'83a9db89-df11-4f8c-a9c7-b02c15b436b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'83abead1-0fef-4b54-aa98-99e1456c3d56'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'83ad6362-6b45-4711-b14a-46f7e71adabe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'83ba6518-da29-4de6-9bd1-9d0a9459b15d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'83c15194-6ff4-47b5-a300-e803acfb3f39'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'83c86767-7698-495a-b57e-1b56a347d957'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'83d34938-5033-41eb-ac10-e9cbc73d3b7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'83d754b6-f3d7-4841-9318-a57fc2957743'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'83db8c2a-1bf3-4e1c-8ca1-1fa943a4c1ed'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Not for tx or mnf|Open|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'83dcc1fe-9ac1-40c7-b6d4-0afc9e717e6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'83e06543-8a17-4203-b0d4-1fe3b34bdc3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'83e1f886-e1d8-4c40-a02a-f9dcee93c7b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'83f6dfdb-a293-4245-8a16-739cb886aaa3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'840b41ea-7dfb-436c-ab90-ab89ca5d6930'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'840ea45f-e1bb-41cc-aabd-84a8e7b379e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'841f597f-670b-4e34-aa9e-71adc4a08be9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'841fcf4b-b592-4a65-aa4b-5b0ea8d84ab5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8421d403-37d4-4e48-918c-ef9ed0b1aeda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'8432388c-d483-4b58-beca-dcd9897f26e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'84336d64-9b1a-444d-afe6-3a0548c2e7da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'843c98fd-5be7-41ac-a752-6a187a9fc258'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'844129e6-3196-4615-b509-0bff7d311265'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8459f908-3517-42e3-b686-a4d4cde06f42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8476c0ff-264c-4f14-b1ca-a2ab80ce95f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'84a04238-8eba-4651-bd08-c0392bd88b5f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'84ab3e91-7cc9-448e-87a3-5c11a048e02d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'84b6a57f-ed2a-4929-b66e-b1987f737256'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'84c637ef-96a4-4a7d-990a-6a75a37ecdb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'84c856f3-d148-48fc-8a99-c1f09f6d1a6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'84d37d83-91bd-4697-8f0b-c0359d81adfe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'84d820ea-96ce-42b0-9a67-dc342523843c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'84d9d5d4-f005-4d9a-9481-258a832f8cb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'84e9bcca-1ab2-4f8e-a316-121861d7829f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'84ec31e6-94ef-4e07-9f04-b8ffda261d43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'84efbb51-77b5-4979-b109-2addfe2b9653'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'84f35c52-b920-4741-8a33-afd2dce4bc4a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'84f7bab6-95bd-4597-a662-52e2cd17d587'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'84fc85ef-d906-4be8-9157-2b43f3b844d5'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8504b9cd-0efc-45a6-865b-59ef9ca1ced9'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'850632dd-929e-4a98-8774-fa1ace637f10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'85092b55-12c7-4674-881d-aae4ce93178c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'8509e24c-a3e9-46d9-9d76-46caeba7bd09'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|Not for tx or mnf|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'850a7f78-377a-4323-ba1c-84e85eea0cf3'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'850c89f1-8d50-4ed3-aabc-6d9637aa8b9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'851175fc-5fea-4926-a6af-a86f9c459776'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8513a2a3-6bde-4af7-88ad-f1bcd31fdada'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'85207d25-3e65-4861-87d6-42f8209a57b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8520c344-b89f-452b-945e-f3344331ed62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'85250f5c-1f2a-4e58-9e0b-67920146061d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'852a9171-e572-4871-b2be-dc1f450d168a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8543802e-caae-4a41-9b8d-28d96fafd43d'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8544b75f-8277-44a8-bee9-e0ff3baae24f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'854a4be3-1c13-46be-b8b5-fcaa4ac984b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E057' WHERE BloodProductGuid=N'854a632d-6919-4e6a-8c64-0609fb8e34e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'854e9054-87cc-42fe-a372-a62979c1f423'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'855a7166-de36-4f92-a0c9-da4d92ac02db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'855f2295-09c1-4a7d-b95c-04edb3d5fa11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'857e5633-da00-41db-a6e3-188ad86d250e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'8589a819-edb9-4fbb-8382-20584684297b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'85962fa6-1f4b-43a6-a751-97e1177296cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'859ecb9b-2a75-4026-bad2-6e81ecc5bac7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'85a00247-559d-498f-a657-d28066a91a31'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'85ae96c5-184b-4b06-8785-a79335a80811'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'85afc7c2-cbca-407f-8f79-46d3443781d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'85c0f35d-6bf5-41c7-bb84-ebe1cdf4b7b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'85c37cf1-43de-47ef-b64a-88a5a89efd0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'85c6f4bd-8017-43ad-b20b-f3f4df41c370'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'85c99366-0ca6-4fc1-b110-480a2f4f24db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'85d38ebe-c937-48ef-ae15-272e7295079f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'85d3b3e0-3e17-4d37-b769-b1317a720c1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'85d5b31e-3a96-4cd1-87d9-3903532e31d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'85e975f8-5b1f-44f9-8075-8857f46e4a27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'85e9927f-f9b8-45ac-80af-9a39ae64bfca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'85f152a7-1c23-4879-9e8b-d2fea4358be2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'85f1e745-4dfe-47f0-83cd-600852572304'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'85f28c30-36cf-4f5b-b6a0-f9dc9dc83794'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'85fc9d5a-5e50-4476-81cd-fb301dcca0a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'85fff2a2-75c3-4eb4-9288-48256b13fc58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'860138b2-c87f-4f2a-8e73-992301c3a9d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8606f5b8-7349-45d8-9f0f-827d5d6f21da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'860c6e12-5190-44c5-a20f-368893ce45a5'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Buffy coat plts prep|Approx 240 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8610075e-0f19-4235-9d98-afd10fa3c728'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'86108c87-a876-4020-a8bd-bbb3332bde15'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'86119cc2-a661-48eb-8c78-6c05be21bc53'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'86146d09-40b9-4c55-a610-8df7bb3c0855'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'86179d68-ef63-439a-8cef-5314c8b69991'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'861ad6e5-640f-4352-9d54-c2d66c337b13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'862389da-4786-44e1-ac9b-0f130ce07086'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'86255112-f4d9-44eb-9d01-e549b99bc112'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'8625664c-2188-4774-9982-7d5259b0a80b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'862651c0-afb8-4d04-86bc-d01769ee7bb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'86295cca-9332-4b79-8361-858d5d308f2b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'863388c8-6550-4c8a-b0b6-69bb4de1975c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'86352c3b-b7f6-46de-b9d7-014eb3e4f937'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'863b1eab-4e65-4a5b-b1f3-ca51fd8a00d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'86400163-e30b-48b0-8d6c-2bae2e247412'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8650397f-c983-4b6a-be1a-4cfe4c0dc1d5'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|Not for tx or mnf|>=200mL<400mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8657b94b-9356-4eff-804c-6c696edb79b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'865db562-3212-487f-b4ce-b9438551c74e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'866b00d6-7e25-4600-8d86-f046483b2b5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'866b5ac5-0cf8-4af5-98fd-91027095117e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'86712844-729e-42d8-8be5-51c7e32320ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'867966e8-2777-47c0-877f-014a1b0bd3df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'86813557-2713-4835-affb-c4fdf7f5c0fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'869685fb-8de7-4d2e-a3fa-6d3e1948ff78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'86a7c326-804d-4e6a-851e-220595d566a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'86ac928d-5b31-4652-ace3-898efb30446e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'86ad4840-35a2-43c4-8314-21a081f4a296'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'86b42ab4-d5b6-448e-8eba-99cf1046b540'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'86ba713f-bc95-403c-bfd0-7c373011737e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'86bc7450-2098-49a3-a7fb-defb9aca29ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'86c6198e-8f6b-458a-b67a-dee035c4d22f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'86c74ea7-d287-4f94-a380-41db0c44c4e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'86cb6b30-f921-42a1-83ad-a4045bd61732'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'86d082c7-b813-4200-8f38-ef1545035570'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'86d89593-cffa-48fe-b7ec-419685cd92e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'86da531d-4ad1-47ec-bb13-a12d0694c7ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'86de7a6e-2d51-45b7-9e4b-a801e17a449c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'86ef6bc9-ef4f-4359-9424-c1138c5742ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'86f6a460-c399-414f-83a3-97614a7ec990'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'87021b66-0753-40d6-87ad-03c25f713a81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'870968b0-f034-4c11-8b10-e6a8633ee9bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'87124af4-88e1-4fbd-96b9-587958c91f43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'8716ae12-6de6-4ccb-810f-fdba2f511d4a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'87170cda-af70-422a-8af4-0b17a114ef47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'87243b02-1e3c-475b-8093-084adcc3a540'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'87352973-d1c1-4e78-b098-e9d6dc0de0c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'873a40f2-e2b9-4e64-9573-3c07cb636cb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'874038a7-a69b-471b-b580-a624f2f230f2'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:injectable|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'874ab8b7-d78a-457d-a4cc-742a75ec2467'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'87541f10-9c59-43c2-babb-987b32582b68'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'8756fc5d-b184-4da4-840d-ddb9befc2b7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'876027f8-1fea-4045-a0aa-c4a152ef4406'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'876492fa-fb7d-4359-b599-35503c96f6f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'87787968-0c7d-4c91-b99b-0c8435df6c5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'877b5668-06a9-40c4-b26b-678b764911e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8782e631-cff3-4fa7-b067-e5cf5f6ed8d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8785eef7-41f2-4ad4-9d2f-4f0354702439'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'878afdfb-7465-433c-b31f-53977835e945'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'878db69e-205b-406e-b356-5a0698824c13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'8794d9df-e79e-4765-b7a4-d27bf61b3ad7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'8797fc90-39e4-4793-ad16-b522fdacc2a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'879b36f3-9d7d-4ccc-b28e-243d8ba6950b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'87a00742-5d9c-4e4f-8301-f447f3529a72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'87a12af3-8c7b-4da8-a109-940ae8cabb7e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'87a6aa63-824d-4918-b26b-01960469100f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'87ad4d5c-ef92-47d0-9132-ba2b69fc98ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'87b10764-9a26-4909-9be1-96f17495cf85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'87b3c814-852d-44be-86f3-9d09a26f4edc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'87b662c9-9616-4171-bac7-4e666357289c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'87bcc3ae-c6db-45df-86c8-383f4bbc6f43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'87c17203-7d00-4b9e-9bf6-19cf9371d4db'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'87c3fc89-3088-42a7-8adc-5c6efd2d3db2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'87c9e999-56ab-4fb0-a6fc-929d736ac1c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'87cec13c-d1de-49c7-983d-1662a6fd3910'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'87cf0f50-c5f2-42ce-b0b2-b3f3cfe9b683'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Open|>=400mL<600mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'87cfb57b-4b22-4676-8d4a-3ba45a18a238'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'87d5b893-0c5e-49a0-b571-ed8e172a8834'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'87d6ab20-0f6a-40ce-9ab1-173140609062'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'87df5e4b-51ea-4f5a-aa10-626e922a3350'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Open|>=400mL<600mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'87e5fa33-0a13-4d88-bd12-6a3e68e390f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'87ec0c25-fd29-44d4-a66d-219a79c35f90'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'87ec523a-36e6-45b2-89aa-29d55fbec94c'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'87f08eab-65d5-451c-9e04-6fb7ea4e5568'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'87ff1bf5-993d-4bcf-bf0a-f02d9eb91443'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'88062a23-db83-411e-91f0-c02f26808f5c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'8807be58-c754-49ab-b614-6caa4a05ffc1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8808aff8-c3ae-4fc2-b443-db2a0bd8b0d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'880ee9b7-13e5-4fbe-aae8-813749d42814'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'882b6fc6-1bcc-42ec-9b10-fe171bfb33b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'882d51b0-37bf-4d29-b64b-032a249c7b34'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'882d7e24-953e-4f94-92c0-4c9e5f6b92d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'88478402-016a-4cba-a821-be34cd0279b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'885217bb-3213-44f3-a60b-d64d327d7fd4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'885ca279-cd94-4d74-9f86-995db84a2915'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'88606351-5a3b-4dc9-b8fe-ee37eecac619'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8879f690-4a93-4829-ace4-beff0f433126'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'88830852-ba2f-4e44-bae4-7e0fdefc861f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'888efd92-3f38-464d-bdba-7bee223ba35b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'8890f4a7-fd45-4b9b-ab68-a902e7e4828a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8894cb3d-74ef-43f8-a16c-1a9e8ec38c06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'889a1a68-2b9d-4975-831b-e0b66e271874'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'889b9daa-25a9-4f05-bc6c-58158b64d045'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-25C|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'88af9231-a89c-4456-9e17-5bdf49df9866'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'88afd288-733e-469a-9e89-80ff8c089b77'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'88b1d330-5d73-4285-b971-edde2258e7d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'88b917bf-38f5-44db-a460-f898a2cc3f29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'88bb507c-fdc4-4ed5-8306-79a1011e0362'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'88be4f54-3123-4e7d-a7d6-66a4072b658b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'88cbfb6a-5c06-42ab-bffd-ddb6de0c1310'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'88d012ec-d656-4698-aa97-850c28325af3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'88d447e5-7f91-4182-a41b-ec5ad9a388a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'88e0535f-fe77-4e9e-9a30-9f946f56082b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'88e55dfd-4c8e-4e30-9942-e87ebfea34b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'88e5f292-6a9f-44f0-bac0-ff85374975bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'88eb46f4-8459-4b52-aa26-e75e55108a03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'88f25528-c3ef-4e8a-bc33-ccea2937ff58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'88fbd6b7-7cb9-403b-9934-28e08f98e62f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'88fc38c2-00e9-4116-b494-2b8787f5593e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'8900e46f-25ff-4ce3-8269-9198670a1662'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8902fdb5-4d39-4d25-8170-1ea261dc4545'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'890547b0-e6d9-4a57-b668-94428990a571'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'89062129-409c-4eb4-8b48-e6fdecbcab28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'89089aa7-6ab4-4ef9-bcd0-3f73b1ca5020'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'890ab82b-223a-4aa8-9e2f-f62337a07351'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'8920d585-060a-4952-8e8c-1024757c90be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8925ada6-c7c6-4c7d-9259-291b7013a305'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'8926e70b-9572-435e-a656-d965ac8cfa25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'89270a99-7010-4130-a2dd-144ecf05f228'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'892829b1-4ddc-4b30-8298-f4a4fd9a38ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'892f13be-e1e3-4fee-ada3-9a484fb99563'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'89344d67-b2cc-4647-858e-40d87aee0c2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'8934fca7-d496-4a73-81ae-45a37bcf4d0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'893588ae-938d-4e9c-b88e-9066a4ab3117'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'894b30e5-c76c-470c-b621-88cabfa3f0de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8952c799-7c65-4df2-bde8-acf92226e49d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'89534f95-df46-401a-a869-44cdb0ab01b6'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Irradiated|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'89552161-f2c0-4e87-a2ec-e2ccab57aa9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8966b90b-896c-4de5-9048-45e318e0f449'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'896c0a7f-49ff-4d74-a502-54dacc1d258c'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'897cbea0-e411-4bac-8329-46d32e2b31b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'897f0da9-78ef-4793-8df6-fbf267ce8142'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'89826014-130e-465e-a4fe-0e619d2d9759'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8989c84c-74bc-4982-a258-97a40783847f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'8993118f-e6cf-495a-8090-0b9f2e704020'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'89a6c5f8-88c4-4223-9fc8-993cd8658b55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'89af9665-0df3-4a8b-bb4b-a677a6374c9f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'89b22ff6-e361-43fb-8899-85ebffceee56'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'89bdaee5-f34a-41b7-8b26-ab8941924b9f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'89d977bb-9cc4-4d76-9912-f2fd96e6aaec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'89e72dd4-4170-452d-aa1c-bf6c2487a909'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E037' WHERE BloodProductGuid=N'89e92265-04b1-4a8c-9918-0f16e61f2437'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'89ec4190-9704-4cea-9354-d5cb57f6226a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'89ec5c65-2943-421c-b26b-2d20372aa77b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'89f20ae0-57bb-45c0-adab-e059a606edbb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8a051bf3-7f73-4a2e-bfcd-1b1928b7717d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8a0b370a-08eb-4bb3-97ce-91a039b9225f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8a0c4751-5803-4be9-8e41-6c9a1d2bccb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8a1983a1-c2d9-48b2-8692-2b485f9795fc'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Not for tx or mnf|Open|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8a213698-6df8-41e5-a921-8d3395c7acf1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'8a256ed1-7e1f-419d-b6e8-5a72892368e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8a26683e-a3d0-4d78-8819-bbdffb4da59a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'8a30be92-b636-44ff-ae23-bbd1d7720acc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8a3447e3-dbea-4259-a6b3-5252dbc5d55e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8a356896-f4a3-4e6e-bb79-0937b9b70add'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8a3e3195-b802-4bf3-bea5-e9a4c6eda31d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8a42555c-f6c9-4ff6-992a-e1549e5468ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8a4b67ab-305b-4c26-99f3-44ebd5454b7a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8a5b4a90-e5fa-4c70-920c-ee82b184f712'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8a5ba4da-c67e-44bc-bddc-97d2e0a1e78c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'8a605f82-b91d-478c-85ab-d39a95fc06b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'8a62015f-60a0-4f8a-834f-803cfd7744ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8a65d3d2-e6eb-4eab-88ca-a2e89c77e53c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8a68483f-adfc-44a3-9cc9-44209e3b4bc7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8a7c8f68-5dad-458a-b878-1735de4900b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8a7d766f-37ea-4702-b56b-fe23d9160442'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Irradiated|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8a85e614-d20a-4cea-bb26-4697b77bd9fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8a8adb97-818d-455d-9852-48c3222d66ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8a923df8-86c4-4355-af9f-e6b1ca2339e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8a9f7a77-947d-420b-8d3e-074e642af213'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'8aaac15e-88b6-49b8-a0fc-e43b397b8215'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8aaeaaf5-1d34-4f18-bb21-363c594f11bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8ab18371-0acc-4671-a77e-2568ab3eca53'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8ab43a11-dd0a-45e3-a112-9395d6895a14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8ab9281a-b706-4f2b-a6a3-3924cca61543'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8ab9f6b3-2da7-40fb-81e0-a0227959d11e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'8abe4492-487c-4c2b-b08d-84963ad28387'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8ac6c354-1b49-4e1f-b158-02c6e60c62aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8ad4cb01-9711-4049-b8a4-2538fa294c9f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8adc88e4-d5e4-4400-9911-d2a298e0f0e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'8add7826-fd14-45f7-a83f-fdaeaff797f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'8ae2e24a-b258-41eb-aad6-2286508fa292'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'8aee1bfb-b3f9-49a3-9a4d-a0e789605c65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8afcdf1c-2e92-43d4-93c6-65404c0ff748'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8b020238-5520-471f-8fb8-7d35ab595a72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8b0322be-1058-46c9-bafc-e4fa30f2a369'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8b035051-6406-4a5a-a6f6-a31fcbd8428f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8b10355e-bddb-46f4-aa94-3c872cc4eb9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8b15c0e2-598e-4a22-8f8d-8dd0f8f70392'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8b16197e-d829-45fd-8393-cd40621eca2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8b164d20-190a-470a-a8a4-9b60f43f3f31'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8b1b26dc-d9da-4aaa-a1ab-4b8ab9d35045'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'8b268afc-7467-4c44-8b8b-aa99521c2e7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8b27836d-4859-4898-ac7c-0160858b08a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8b4511ac-c494-491d-8688-38a1ed9bec42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'8b4bbb2f-0a06-49bd-9584-a8b56e91f595'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8b6287c9-c738-4c53-8d8d-f0f4dc4904b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8b642955-2d86-4b0a-af6b-cfd198b00def'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8b64863d-5c82-476c-9df6-730d76c2d047'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'8b6bf26b-0353-4573-80b8-da83d3b84487'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8b6c30dd-da24-4541-8179-953da1806204'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'8b78972a-586d-4b77-9676-d7daf03233fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8b7c7dc3-36c7-48b7-8283-77fa987fdb37'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'8b7f7821-fdc8-4481-8fb8-6ccb8d87d844'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Open|>=200mL<400mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8b819f4b-0d64-4830-88a9-7d3ea3ed316f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8b8940cd-19b7-4c9f-9739-5b96fd94fe0e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'8b89fa6c-4516-4c29-b844-26aa8cd6c5cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8b8c66a2-4878-4d6f-81f7-1cfe574565b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8b943525-b704-4412-8bcf-665bcbe7a90b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8b97f8cc-6283-44ad-9d2e-cef25e56c5bb'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8bab43de-8af9-408f-aa19-f1c4532bf51d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8bb3ac49-a9dc-4f94-a907-76c591d7a860'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'8bb5ad3d-ce27-4130-8b3e-42c872e6e3dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8bb7a081-7f27-43eb-a6f9-9e3653465ab3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'8bb93b9c-a8ac-4940-bee4-e68fa0c4b363'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Irradiated|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8bba2af5-c912-4db0-b5d2-cb8ba86085bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'8bc25b97-b0c0-4f9f-b518-84554b3c6ef4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8bc4eda9-879f-42a9-9caa-1519b13a7031'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8bcd209f-c507-4548-b3bf-5bfbe628b696'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8bcf8e8f-c91c-4d1c-918a-739f5a61bc0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8bd1463c-c253-4a23-9e0a-8757cd3bfbd7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'8bd234ae-2ac0-428f-bda9-5ad622d55060'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'8bd5ef60-9513-4800-9913-672195d1bf11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8bd7c970-14be-43fb-8482-7edaaf49a99b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8bd8dfac-de40-4966-8b75-72d6f80ce043'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8be2aa26-c325-452a-b8ea-a79b6b1c580c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8bea2fb1-a179-4799-a5af-68be972e15b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'8bf0da49-b937-4ee9-bea0-3a2071e81b93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'8bf7eb38-3245-4d89-a465-045ece87a0f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8bfb4d6a-735f-43b2-9a81-d9aeac61cf5b'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8bfcdab0-e6fd-4c37-9027-bad5a3275998'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8bfd46c5-0b80-46db-8b53-5f360dfd1f35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8c03e27a-24fb-4cb8-999d-acbefdabb027'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8c100dec-cd0b-4689-b072-85e54b9f07e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8c10683a-14dc-4ee7-a77f-340edf1a3fa1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8c13e589-5642-40da-8a63-ba96d0d5cc8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8c28163b-e635-4251-9fcc-fe4dde79eaa5'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|Not for tx or mnf|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8c35a106-93d3-40b2-9ed5-551e8614c7fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8c3949b3-cc55-4ccb-82d6-04e3fb759101'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8c433ec0-ad66-4b48-b85b-f8e5ac13ee34'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'8c437051-187b-4be1-bb10-d40432ab5403'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8c52401c-2b0a-4ac3-82b9-7c68495928b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8c55ca53-c1f2-4630-a151-f79e4737cadc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'8c61331f-2f0f-4502-9908-6d905b6c63bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8c63cfea-8d09-4788-a4de-ef0d802e600b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8c697881-66cb-4010-bcaa-2e9181e13f7a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8c6c5876-c747-4f97-8ea4-3bbdef8f936b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8c7d83d6-5b53-4fde-af8e-ceb1e51d9065'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8c84bc25-06c9-4bd4-81b6-00e3b8857610'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8c8d85e9-1913-4e8a-a2dc-0b5738e3beea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8c8dc64e-8032-4981-9637-de3482c0c260'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8cb01063-b5cf-4571-b1b3-c88be2e31743'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'8cb84262-2a32-4ddd-9e2b-61b2ed7b232e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8cbbd037-6b91-4913-b769-2472d58ec292'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'8cc15691-b951-4721-ad01-56e491818a06'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Open|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8cc2e322-18eb-400f-b1e7-5efd4af4d40a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'8cd43b27-b7da-4af9-862b-e69133032342'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'8cd7347a-7508-4f33-b258-80ac61f9b3ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'8cde0d0f-6730-4cf3-ac86-8ca35502361c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8cdfbde1-dc75-43a1-9dfe-d0c29ffb9d0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'8cf23db1-e5e5-494d-ba6c-ad887c483f50'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'8cf46fbc-4d3f-4a57-b219-bd37b0858d1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8d01125e-d155-4e74-af96-fd68d5a80b49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8d07731d-e975-457f-a4fb-82d8ee1b79b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8d098183-8f5f-4139-9764-79550bd9180c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8d0d86b9-3795-4854-9297-1c3bf4180bb3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8d12c082-6caf-494a-80be-e03b515f26bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8d145ea1-64fe-4792-b1cd-5f0343315347'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8d149892-df6b-47c5-bd91-c0476e0f837b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'8d150a00-25d0-4417-9254-eae42ac67509'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'8d277d92-486c-4962-b643-6a4fe6bc3672'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8d2cf5c3-6935-4ff8-b545-72aafcb4f1d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'8d324b96-3d63-4edd-994a-9b3d558dbd96'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'8d3685d7-c935-4cac-9ae8-3a0b064a4873'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'8d379270-9889-4896-b2ef-1e3403034dc8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'8d3ed716-6e7e-4062-b8ed-b695b78eac97'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8d3fdf65-dc05-40cd-b181-46d206ca23b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8d4c9c08-91bf-41a9-9b02-83e9da061be6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8d53dee4-8f81-4f7c-9803-0c9bd82fbc0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'8d5bcc96-9c8b-476d-91e5-54b7768d024e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'8d5ed881-f6fb-47f0-871e-05238afa02ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'8d5eee64-73c2-495d-8e60-3555641d5981'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'8d61e422-2ce6-402a-8a15-d1fce709c861'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8d65082a-7816-448a-8f7f-fbbf13caeb82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8d672738-1803-4263-8f54-0a4a36752096'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'8d75f90a-10f6-47fe-9461-32a2687e450b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8d86bee0-f342-45f3-9a84-d079614e4d7e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8d87722c-0e76-4ae1-b7e8-43da3a51e460'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8d9aeb37-3955-40e8-8fc7-774bca4f460b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8d9bca2a-6885-45b8-ab6d-c38b68df8ed3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8da1e134-e0f7-461f-8b11-d97ed8b25e48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'8da539de-9861-44bd-82e3-401441f21deb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'8db15164-4587-4790-96d1-b17650cd4a0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'8db6aa4a-31f3-4010-bead-c5440450cc49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'8db9f46c-8b1a-4c08-b6d8-653f105922bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8dbe3c2f-e640-42c4-90ce-d651bdcecd8c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'8dd404b8-1254-4e34-8221-6d4d5d1bbcb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8dd7c506-30e9-435f-a36c-3096691e3234'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8ddde28e-cacb-4823-900c-ebb7501bd2fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'8de6dca9-3523-49b7-8ba5-d91c23008524'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8df1a0ed-75c8-40c3-b6d9-538e9e9cdfb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'8e050d4d-4df9-4e6f-8b96-eb9c6365f7a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'8e14b64b-0a94-43e7-9fc6-2097aac62a10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8e16a052-9647-445a-825a-c0de5638f9a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8e16a892-1285-484e-a4e8-989590e3abb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'8e1e7d56-cf86-4aca-bab0-2e51765530ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8e26d3a5-e47a-479e-ad57-6d5f69f47759'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'8e2a0858-c3cf-4a7b-a6c1-9ed103090ad2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'8e37d830-fb0e-4920-99b6-4c1ef5f78ec5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'8e39f78a-1a43-4d8c-ba4f-d1923625c9f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8e40b4a5-589d-4c6c-a823-e5e6055b9b38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8e4ccc9b-f6a1-4499-8346-41a491fbfda4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8e52bd4b-e0ac-4505-80ff-3cc8d3b71b43'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Irradiated|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8e570e47-b30a-4e32-8bf2-a8aa4e556e97'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8e57aba7-b879-4bc5-8434-7b8d0d57ac94'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8e5c9c98-32c2-4809-8649-eb60678e13c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'8e67bbce-e938-4c63-891f-8824be524bde'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'8e6aa279-ceda-4890-81a9-f98e5740176c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8e6f34e9-f374-4fb0-b7b6-65bc75df84f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8e70d2ca-f18b-4e34-9292-54a980290eed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8e79ed73-2848-4b5f-8fdd-0eaccd498fc1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'8e7ac692-7b2d-45ee-ac7a-2f79670fbeea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'8e7c2f27-a4f2-4f89-9244-c2b170434114'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8e863898-8261-458a-abb0-446f2d0a778e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'8e880dba-02f6-4168-aaa8-e6200fae9d99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8e88150c-5445-420a-9e29-e3ef5ea84aa5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8e8dad98-7341-4dc5-b1d9-ce0082eede50'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8e93b9aa-fcc0-4e9f-9f6d-abbc885461ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8e9b2980-f73a-4abd-85ee-5b31b1646478'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'8ea1325c-f488-43d3-99c8-9ea9f230d4ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8ea9242f-ade0-49d9-a93f-4347ce994960'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8ea9fcef-8277-4cca-9b00-7107665d3a4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8ebc8eef-3a84-4500-ab4e-9e766ac8cef1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'8ed27017-83dd-46b5-834b-9766a1c3e930'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8ed59f2d-6d5a-4b35-91af-ffb7727d377b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8edb89a8-9120-4bb8-beeb-64678c1b76cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8ee982b3-7786-4378-a248-73b23f0362a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8eed3f42-9882-4976-9456-95bd55967f35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'8ef8e48a-367d-4f5c-b0b2-4c6d9ee82672'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'8efed44d-2e44-4052-b147-bcdd7130863c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8f0209d3-021a-47ed-bfe1-d8cfe8d1c5b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8f08ba53-cb3c-4098-a2c1-cfd79e850bb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'8f0a4fb1-d682-4a74-8f96-633a62d2b703'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'8f0c0700-66e4-4298-9d90-38787f036cba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8f11992d-0771-4668-91b4-967ddf4ababa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'8f193aef-704c-490a-8937-68ef2e0d3e29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'8f1e5f99-97c2-48cd-9bf0-ed86c10dbd72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8f233221-a9e3-4e96-b28b-c30b35cbdfc6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8f290a43-1291-4f07-b07e-5bbdbe2efe69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'8f2c9cb7-fdeb-4af9-b233-0823c00356c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'8f2fda9d-8421-4255-a6a3-ba237cb6daa4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'8f3fff60-5736-405b-a55e-3582b7f42f06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8f408279-c5a3-4e2e-9dbd-22b5ba300143'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'8f408f1e-12b1-4671-b723-376d109b8e3e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8f44c22f-1465-4b9a-af8c-6a82573ea82a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'8f4b769e-8b1c-4425-a240-b75c45e52b4c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'8f4f11a7-3b28-4e44-8bc1-1bafac98f45f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8f5057fa-d75a-48c1-846e-de0ac3422b62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8f521fe8-2a55-44c4-b8ee-486a40fc14ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8f5a7f3e-5253-4ef6-a31c-4376979a18c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'8f605215-6e53-4220-9bed-44ca12c8786d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'8f613485-fbbf-4c32-8104-fbbfe58f1487'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8f64c387-bc6c-4b9d-ae10-05cb45a39811'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'8f6c3c1e-bda5-452b-b25d-8ecc9d3bca46'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8f6f9db1-d6cb-4254-9c8b-1432608b2f70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'8f7d1981-044f-4319-bb20-2d5955bace94'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'8f80c9d1-7bec-4a3e-9f4c-695f5f13fa87'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8f883679-5910-44ac-ac68-ff78a579722d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'8f924e4f-6269-4e3a-af99-deed9bf0a9b8'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8f979d8e-acd1-4bd5-a551-ea69f3c34f82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8f9abd33-6327-4e8a-8921-615e08eee2c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'8fabb059-4664-4375-95ea-b6334f39901a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8fb04e98-71ff-41bd-80aa-387781fd97cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'8fb97118-7d60-491a-8e69-a1c81ec92829'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'8fba04ac-be70-4b3b-8092-6d16ac30861e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8fc0d17a-8846-4676-b18b-8a6972ac142a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'8fc28234-55c9-4a1a-a95f-af238d529ffc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'8fc4f1d4-72ad-4c86-b808-b9f263a91666'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'8fc830c8-3f61-4967-99e9-8192195668a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8fc8e4a1-0a5b-4e50-b9e1-b0f417d71433'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8fcb26e7-6d07-489f-9be1-7f3d943b7d2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'8fcbf13e-c681-4557-854f-14f58451692b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'8fcc100d-48dc-4bbe-8a23-dee5464884a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'8fe02304-cda2-487f-b498-85ac4ff815ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'8fe43139-884a-4f02-bbe8-659031eee575'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'8fe79f5c-b6aa-4af0-beb7-3074d1ac3658'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'8ff1cd4c-584c-4b03-b2ee-19a234b342ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'8ff30b06-41a0-4790-9af0-f291e2b0e500'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'90023164-3353-4eef-a02f-f32beee9fbc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E059' WHERE BloodProductGuid=N'9004481f-fe03-44d0-83a7-5caf03257da6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'90061372-da8f-4f55-911a-dcc858192c3d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9006181a-02a5-4125-b999-60ea37db021f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'90078947-5656-4583-a421-c5e07aa982be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'900a4865-bc2f-4cca-826f-edd3104cee2f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'900ede66-650c-40a4-9282-0d2fe3d05284'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'90103c5c-0e22-482c-b63a-d180c36c2d2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'901bf8a6-2656-4967-8bcb-35d99d46fec5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9022c9f9-6f02-47f8-862b-d12dc2e34223'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'90350d32-99ce-428d-a793-c2003a7cd26e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'903dab46-afb5-451f-8b7d-4b560f468964'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'903dc4c9-50a0-4b3d-840e-385a7b2f0cf2'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'90410b59-fe4f-4426-ae9f-d26bbbbf1e26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'905685fb-a9b7-461a-a17f-6f47b0d8a34b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'90695fb2-92bf-4c34-b724-91e13a0ea4f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'906c24c9-4f25-4ca3-bab0-10d8f17301f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'906f9336-0d90-47c9-b649-5553f96b8b8c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'906fdb69-744c-4d5d-a891-ee35eb149741'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'90746fbc-5822-4599-b81b-6a450330d396'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'90799eee-86fe-4409-bb52-70f3fae1756d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'907edb9d-2127-4dc8-b347-2c4551115fb9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'90828614-4894-46d3-947e-3c144de55cfb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'908a0eef-1936-4f15-84b3-d405dcbc7935'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'908a3a51-62aa-4093-865b-fc6f6f9cc00f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'90b049ab-c7f1-46fc-9c3a-c0c209443f02'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'90b8c3d0-7388-476f-9259-afa0427435ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'90bf97f7-db06-417a-8acd-5da19f3933e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'90c02bbe-884b-4c59-908a-83711a81eecc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'90cfed04-dc75-492d-8a06-3f39b03d9897'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'90d74415-9ff7-4bcc-859d-0552da159767'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'90e7b074-765b-41e9-88ae-18c5cc90c485'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'90edf8f5-3676-4a33-ab62-72c58da4550d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'90ef88a8-b551-47a4-9e1d-8af680448288'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'90f6aced-d842-475c-b863-811beeca1767'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'90f72ebc-cce9-40a7-9b19-978b1d67cf50'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'90fde711-297c-4f37-907d-e7155322082a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9103069a-7bab-4a61-bc3a-255b2fa271db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9103e352-36d2-4caa-b7f1-4b929cbec640'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'91206be4-2fcd-4799-8d5a-10994266590a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'91265fd7-a501-4793-9248-bda80ff8e3ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'912af517-7fab-42e4-8282-f6cfb6eb7717'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'91305cd2-6405-490a-a6ad-43c999a7ad36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'9138a23d-6bdd-4bbb-86a9-93ea4155bb20'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'913e0798-c5d0-40eb-89d6-7f821dcea26f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9149b1ec-28c1-4ef2-b529-efda65792b1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'914a3e43-f476-42f0-89b7-99fe54557899'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'915e71fd-048b-444c-b996-26448e2d7f04'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'91830e91-e801-4052-9aa1-bd3248481c7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'918c143a-f27d-43b8-9e3a-80c01a1845af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'918e7cf5-4c1a-4c6c-b51b-0bf14da833b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'918e8c7c-210d-41f1-96f5-fe380e1a3890'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'919231bd-803a-43c8-854f-0dbc0491a537'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9192654c-b7ba-49b8-b4c0-9e7615818517'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'91979c3d-de86-4a4b-ad62-9c21bf24a6c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'91a0996a-00a3-4c36-a8ed-9aeb06b71bf9'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'91a310d3-b3e3-4e42-ba5c-c9ddf34b94cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'91a63e52-b3dc-4f5a-8780-5c266636301a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'91ab3a63-7e98-473a-afef-c13cb1fde648'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'91ab53bb-e60d-4b26-b814-22cf8fdb6354'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'91c16248-7a8c-4cc6-8eeb-ed490506e418'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'91c53f8c-bec7-4588-b1dd-fc1b2f445caa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'91e2e159-a1ed-4842-bf26-03c675c282db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'91f7566e-158c-4bb9-950d-bfe144e62a55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'91f8e285-9bcc-450d-9540-a0a708fc7434'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'91ff817d-759f-4fc0-8cfb-6f28d2c88b47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'92055ade-7dee-4733-bd51-565fba08691b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'9208221c-ad4e-48af-b6d0-f56be6744a3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'920afb47-c86c-425a-9f8a-dd4434153138'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'920f0871-c594-4a9b-b230-a42d3de3abe7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9214e10a-3a1a-449f-824d-6924cf177ae4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9216d1b6-9168-4295-8ae8-53001042d772'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'92245400-13a9-4f4d-96e8-fd84061fc013'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9239761e-b195-4d88-a660-b2446e4464fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'9248b600-46eb-4895-a980-56d68a13f0ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'924a1bba-8017-49ba-a3ba-d4dcdf48a76f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'925ca9f5-13be-415b-a0bd-60bc53dd95a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'925cf063-f890-4b38-9113-215b216fd063'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'925e8b80-8915-4bf5-99f6-a26257b951c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9262bcef-0f4d-43fe-a881-4ae5723b6843'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'9262c7d0-dcfc-45d3-8a14-df11c6f77fdb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9267f493-bb06-4c6e-bb35-a6bb84753830'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'926bdd82-45b0-40b4-a2dd-1f7b4717a859'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'926f9332-3e6a-47de-b3d4-955a24193cb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'92700eb3-4ec2-4569-81c9-e42783120996'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'927a88d7-abab-4686-abc5-87b4c9ee7e9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'929d4ea6-71ab-486e-a633-447fd5cc9f40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'92a875a5-28f2-45f4-9142-31c3c80c07d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'92ad5cff-4959-4095-8f2a-ace17f557fe2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'92b2aaeb-7b61-4370-aace-5cb9ce046588'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-30C|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'92be95a6-6954-428b-af6a-ae705c8d73f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'92c4283f-24a0-4d1e-9086-3cea1fbbfbf1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'92c4d5cd-d2a1-48ec-a5df-102c36a1abdb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'92c66188-2321-4fea-b1fd-34b56ef1d11c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'92c78ab6-75ec-4ff1-87ca-5ef62a30bfc1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'92cd17c9-4fd5-4f41-99a8-f737ad5480f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'92db6fe4-a9e3-43f2-ace4-e5120b5e6389'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'92dcfe24-735b-4df3-93b7-40ab50c4c9f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'92e0755e-1bf2-47ca-b238-af43f1e1dc4a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'92f7c668-a684-45f1-909a-520ad32310d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'9303d2d1-e48c-4cff-9b92-36878adaf15d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'931c230f-b020-4149-b25b-9459e7ee44b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'9326e5c2-bbb4-44da-932c-1d1534b5aea5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'933240b8-98de-48ac-996c-21b4b78cb264'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'9341805a-38ea-479e-a8dc-8df06e2b68a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'934809f7-6287-4184-8b91-60e531dc7617'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'934b45dc-5d4c-4d56-81ae-3e7bb0a22906'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9350c9ce-fbf1-4233-8334-858c77937f02'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'93547e7b-18b5-4c18-988f-a69ac40bde73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'935c2053-db64-4e6b-89ba-709f09ea8602'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'935ef03c-c766-4394-b798-5c18eafb4de0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'936529d7-ca77-4921-be9e-5395e9847aa1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'937319a4-b7ea-474b-bfb8-18ff06f2f6c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'9374afed-ef7b-45bf-9cb5-5e582a19b1ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'93865c59-ea65-46ab-ad7b-a6654122e87c'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'938d64d3-5722-49f4-947b-b8952fee632b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'938f0e12-9582-41b7-8ada-6246f58dbad6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'939235aa-ca38-47bb-8b99-94f6cee68e7e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'9393c727-8b3c-4e18-b6ff-8aa64f199f71'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9394bd60-b41e-4f7e-9052-fb8acade0aef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'9399f325-b443-4917-b871-ab326fc36bfd'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|ResLeu:<1log6|Buffy coat plts prep|Approx 120 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'939fe15c-00b0-4ba5-a379-04741dd760c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'93b15a57-4965-4224-ac32-60fb5ac97ac2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'93b30a01-5e2c-4384-a0f3-48e847604f75'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'93b3650e-d652-42fb-9a27-f70af6b446d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'93bcc7ec-5883-4540-bbfb-60c3e53f070a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'93be4194-973f-4d72-8c6a-2616f72ab41d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'93cc2b45-eedf-45b4-bcb0-0a0e7755f359'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'93d34fb2-20b3-4426-926a-1e6c1fd9abc6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'93d5c8ca-2904-45ab-b880-8d7aad71050e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'93e21d84-6f75-4f30-9192-866019a6900c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'93ee270d-4743-4358-9ee9-620edc503e26'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-30C|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'93f65cfa-c3d9-4708-ade6-52ad26a0a54e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'93fa8176-ae1f-4bdf-825d-b04fe7927241'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'93fbcb12-6774-4f8c-8ba7-ef8a68f1ebc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'93fd2f3f-60ea-4bf0-b55b-a9c6dabc6a78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'93fd945a-9f55-4739-8b10-f0e872a382fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'93fd96ce-3b02-463d-8331-dd78ec37fd76'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'94043af0-765f-46bf-a0da-5ea62ad8d242'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'9416bec4-92c0-415a-9ead-221b7ec483db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'94180fbf-6a1c-4d54-9bbb-33a04a1e3c1d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'941d5d12-35cc-4649-80c5-c80375403760'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'9420c4c8-5157-43cf-acab-4703c917731a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'94291732-2f33-4d77-8292-21882757b532'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Not for tx or mnf|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9438cadc-c861-4c12-8ed3-6ab453f1892d'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'943f3f56-12cf-4e84-8dfc-e31c8fec84d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'94463eab-90f6-45bc-88e6-d5d3792df773'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'944b8765-cbb3-4ed5-b9e5-ddc43b0eee4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'945456f4-7b00-487f-bd27-4d4047828e90'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9460d0b8-6bad-4b35-b353-1bf144aa60cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'9462813f-d60e-41fc-9d1e-f7c85f787e28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'9471ef93-2b7d-4e8d-8ff5-103d31c9d996'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'947fda5c-d283-4a41-89ec-ec9a510f60ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9482efa6-60cc-452f-8f41-545ebf386102'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'94848583-5f2d-4dea-94df-fdf27e950b78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'948c070b-21a4-411c-ac30-234997d91559'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'948c0fbf-011b-42db-b7df-0c40a9ff626d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'94901133-cb7b-4686-87ae-ab8a82088385'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'9495e71d-7856-454b-853b-20741aeb9031'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'949707f4-5aa5-4106-af24-797ff919bb57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'949f7a41-c8d3-4b34-b8e9-7727a65e8c74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'94aa1381-4c78-47b8-8c6b-817d5b776c19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'94afdb9f-0942-462e-9724-5f639d1de1e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'94b4e32f-60a4-4790-82f2-f309848a0fcb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'94bcfda7-4e53-47ff-86f6-fcb752c369b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'94be9cb4-fd3a-4ffd-a71a-a56fed4c5ff6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'94ce4e46-2802-4cdf-84bb-f868ba26de67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'94d0f304-ef26-409b-a54d-2d8eb001f112'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'94d5dce2-5070-41e8-a89c-5da8ffd381bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'94d6d155-9606-46e0-9cfd-7c4caeba81cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'94d78f69-4b1e-429d-882f-937d7065bc14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'94d9fad5-ed91-433f-8026-8fce7c56c6c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'94defd50-63d0-4175-812f-9667ddb7e6bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'94e5017a-0eb6-4895-a63a-b45e25b0a12d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'94f01caf-e72d-4055-81a8-38a6cdba2db5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'94f481f5-96ba-4ae7-baca-bab164dc78de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'94f709f3-f00e-4a07-9f53-4f4d450f548c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'950109ff-1dba-4bb6-a77e-2869f2f4924c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'95154028-f10c-4336-a367-378e956d12e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'9519b87a-48d7-48e8-860b-a4f3b870d754'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'952c0531-1104-4a33-9456-f2e1f0a2a6f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9533a4ac-e469-4291-ae00-819b0fac5ee8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'95379122-9cde-4175-a178-ad61b0e2d5cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'9537c485-e720-48bc-b569-61e453e2f635'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'953c4b00-08a5-48ca-b4c7-947b6effb3a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'95449a46-02a6-413c-87c5-6e12844f51b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'9546b878-5477-416f-b50c-7bcace5d3dad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9547fd16-e275-4b42-97a7-91182fe6a609'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'954a8a91-11cd-4964-9d2f-8d0db8a0c281'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'955ca778-a117-4d26-91b5-55249fa9bfe8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'955db0a2-e3ed-448a-b82a-d42df7b648e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9561a175-fc52-4c96-8d9e-981f434d2cb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'95688c8e-1b8b-48b0-9bc0-d152284e9a3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'95776ada-4ce9-4f95-bdf8-c043ab1d456f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'957b86a5-9d0d-4c74-bffc-d1c146925f90'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'957d972f-ba89-4d11-ba13-94b212ec3aef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'9580c60d-07a3-450b-9b72-46d8131a8e01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'958911db-d9ee-4847-a94d-8fc07d5a6da7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'958d423e-3d30-4738-9ed8-103a68bf0869'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'95954369-ad69-4ba7-bf22-5fb91bd007e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'95960398-9244-4848-80ff-084a5a40b042'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'959dced3-1ee3-4c24-ae44-426b332e984a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E032' WHERE BloodProductGuid=N'95a1a86b-355e-45d4-ac05-f2115a119227'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'95a32dc7-4220-4120-8575-1312a5908363'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'95a50161-0365-485c-b9b9-b8a3f1ab3131'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'95a6c2fe-b5d5-457e-a659-3347543a01dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'95aed581-00f2-469b-93b0-02490867afe2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'95b159a0-9d49-427f-8a17-2b1174573d8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'95b6de51-b8c4-4d54-aa4b-6743337e871e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'95b714d7-3cb2-4a00-940c-58dc93c59c9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'95c42aa9-7e54-487b-b56b-f09ca836fa3e'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'95d83ba1-0f6f-41ab-bdaf-5b730a38be62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'95e824d8-6f6f-4366-a662-877695f5008a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'95f8d1a3-da3c-4534-a4cd-5148097e61d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'960f10da-b3db-486a-9c36-e13509a8d26a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9617d91c-db5f-49aa-83c9-035d1f74598e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'96200b16-ea21-4733-8139-f06673073460'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'96251366-9935-46d1-b8b7-cf9331d9dea4'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9631e952-bfdb-4c35-ab6e-e4bc33ecac78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'9637fb55-6e71-449d-95c3-6b6f1f57d361'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'9638907a-f796-4782-98f5-242193ac295c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'964b58a2-28ca-4184-bde5-e4fe59cfaa85'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Plasma reduced|Buffy coat plts prep|Approx 180 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'964c4a54-0b0a-4417-8068-6ba7395fb720'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'964db408-c95d-4589-b021-ed68b2f2cf63'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'964fe28d-33b1-4fa0-9e63-265dbc89a454'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:injectable|>=400mL<600mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'966c7134-76a0-4ca6-a9f6-915d6ff68712'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'967016ee-5b09-4782-95b2-e407557d9e28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'967115f6-423d-4064-90c7-9f7103e139c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'96744e5a-6e6f-4b09-9c76-2846a015b3cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'967aba28-cfd9-4665-989a-6d1554b45cb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'967b1618-d5e9-44b5-a1c8-889b01ad0be6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9689b8ff-8a00-41de-a46d-ffcee08025b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9693f210-df95-4bfc-8f9d-70c2c3950ce9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'96959bd4-f140-4f62-acaf-6d0bf67e18c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'969db5de-d5af-4ba3-b216-54650f20fc05'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'96a0f087-6673-4d13-9be4-9f9f8cb7690d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'96a25321-8fcc-4d92-bfa3-82a9d6b90545'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'96a28fab-4438-496d-a178-3f4b06b45f4c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'96ab4ad0-4074-4f8f-bc1f-c1fd4a10b5e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'96b142c8-b265-4e48-9718-a63e1da32b90'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'96ca83d0-5405-4a34-aed1-62ee12d2cc90'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'96cd6307-170d-4615-a73d-493b72e640c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'96d0abea-4731-4277-b39c-3e27cf570d77'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'96d17c36-c426-4d9d-b524-fed328e87308'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'96dd3020-6b31-4282-8910-cebec02c9e65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'96dd4efe-974f-4d96-a3f1-dadd8def9390'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'96df78d1-ed96-4b8d-83b1-22e08ac6011d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'96e028e9-3b96-4a61-b7ee-3525f5734ccf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'96eb953a-76fd-4e94-a674-c0a585170999'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'96ec13e8-ee99-4321-9f09-746fcdd4c128'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'96ed8833-09da-4d2a-82ff-9947a4cf6356'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'96efdbec-0946-4453-9eef-7380aa544951'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'96f36be2-7b2b-4a89-838e-b8951eddadd3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'96f941a9-2f15-404b-b2c8-db6b0a7737f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'96fe0b88-5d4d-41d9-8313-27076bae2c3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'97086736-e9fa-4368-b3a2-48483d929cd6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'970d656e-0f5d-4b55-a860-8d6d1447838e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'97114df0-ed1a-4af3-b84e-54d81c4639e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9717eeeb-92fb-48ac-8263-0af17cfa5a81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'9719cffe-b8f9-4633-86dc-25714baa9ed4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'9725764a-3840-4b1b-b2f0-3e431a4b0fe8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'972740fd-2ad3-403e-b226-035de1eaf45b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'97324c29-5b98-418c-ab67-b5b9ec0ec24d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'9735bbde-5c0d-4dd3-8229-725d70822792'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'974992ff-34f1-4389-a854-fe34d8290767'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'974b5916-1344-4aa0-9ec9-6244486a6621'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'974b93a3-cf5f-41aa-b952-82ad3eeb6962'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'974d11ab-5599-4fed-8db8-4d9c17de06bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9754f6da-739f-4833-a306-9a4a8911f5a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'975aecda-18b9-4580-9c27-00d23f0998ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9763424c-7dfb-45ca-8cfc-1f51b6e73f60'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'976a9363-f251-4174-ac45-14300f5098ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'977271f2-346c-405e-b054-dd8f1670b765'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'977cf507-1d25-49c0-8a00-42fb7b63dde6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'97849743-1d2a-45d2-879f-ad2252886f4c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'978bb278-8d93-4b21-981e-873c2c48a53e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'978e16e8-597a-4d2d-86c0-d29ed81f8790'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'979214f5-4021-4500-9876-d7caa1951d17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'979da221-8348-498b-919b-caa678462c57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'979ec52e-e126-430a-88e2-8d5644c2aa53'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'979ed533-53e3-4e1a-8874-56000fef8f81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'97a75c0b-e5c4-4490-83f6-14c49c235b8d'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'97b4c180-5631-4bd9-abf7-1b7069283c4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'97c35d3a-efaa-4b0f-a875-64e829f25a81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'97ce1eab-0491-481d-8252-bf3e6d518a91'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'97d6b1f4-13d4-4e0d-bcc9-71bb000f9d3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'97dbe63c-169f-4a7b-bd2a-84a751a641e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'97dc12df-d8f9-4801-bdd2-b88605b9dc3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'97dcc505-7eac-4952-9b93-b912b028409d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'97de0a0f-987a-4fc3-8ab1-9a4868255637'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'97e7c70f-703f-4eee-85da-06d914d0dd7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'97e7d8d4-68e1-4138-afad-8fa1446fcaae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'97f4d9dc-af46-4a28-9aa5-6b23c737a8c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'97f7c5e0-46a1-4247-a38a-a0a8ba081cae'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'97f7ea03-14f6-4284-8170-07b7e403b39c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'97f8189e-443e-4dc7-89d0-fbb8bb714b14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'97fc27e9-9148-43cd-8e40-946b0c8d3445'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'98074582-7f6e-4d6e-8651-6f0808b7f19e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'980a4242-06e9-4975-b3b4-bbd8be84c72a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'981350bd-20d9-46ed-ad43-e2d13d57e0d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9815b1e1-2719-4a82-9e98-6782421642aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'981f00eb-a43d-4144-b90d-ae8e376c6986'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9823b601-4b21-45d1-9778-480252d64a6f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9824f537-5908-496d-85e3-585ae4feb13b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'982b665f-a329-4b12-b4ae-ba85c3d23fb5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'983002cf-dee7-434b-b0dc-72b13face293'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9833ceb5-f93b-4ff1-aacb-6a242b347c8a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'983840cc-e135-4d86-96df-0df6cd79283b'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9857f2fe-a82f-43e9-8dab-770bc9fa6807'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'985c9e5d-eebb-4215-9229-e6aaeb425508'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'98655776-78dc-4410-817d-d5fcb28536f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'986acafd-7752-449e-bb55-3414814c9dea'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9881ce9f-deea-4230-9a50-d5421f30bd81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'988a6622-7066-4f9c-b480-570783ba8697'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'988b877c-1e41-4475-83aa-b5eaee1f0977'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'988f5d19-9653-4441-ad5f-88b2ddfcfea1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'9890de3f-f605-403f-a6f6-5949e42373ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'989850f1-1e80-4dda-962d-28bf10991765'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'98a2fca7-db92-44e4-8d26-786c98189e60'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'98a34bb6-cac0-4909-99ed-b7daf448cb8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'98a37549-354c-4835-b64d-1f4eb14188cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'98a38144-2750-4754-8728-623e4b6d24ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'98aa4c0d-ae10-4faa-8527-6ef1b7df179c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'98b37b66-973a-4067-a290-a98f481710df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'98b5f42b-f98a-45d4-b183-427ea0b7c12a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'98c5b914-6c23-4c51-b6bd-2ce47a9866bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'98c6679f-0e8a-4585-81c3-6d405e42658b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'98e06cc5-c90d-4a01-b47a-355080fec083'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'98e16a74-25f4-4d56-8ffe-a070ad978876'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'98e7e5d3-3bec-4ed2-81d1-d4f8af2847ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'98eb891c-3ac5-461b-b2ff-6540e7008f0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'990545be-7578-4a3b-ad18-e9d5ed5411d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'99114b03-0b5a-469d-9d1f-fc27918c0b4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'991605c5-3140-4a8d-9fce-2e779dbb1e70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'991679c9-9935-4a40-a96d-4c017ac8732a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9919397b-ad6e-4299-8331-2d671b0420cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'993a7e63-53e0-44b3-adda-c8a00d3bb759'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'9940919b-ceb6-4ca6-bcf2-c428b4c774d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'99479587-569f-433a-bb69-e05e45b2a84d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'99481d45-b322-4243-b37c-3b4dd4a1f415'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Open|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'994b5a64-d58c-414b-8685-e0bdbbb20bc8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'994f43d4-2435-458f-a43e-a36cdd9b4f58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'99550f86-bfec-427a-88c3-53e2914d3ca8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'99572fab-35fd-4881-a868-11e0b0d3224c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'995e0c57-2f2d-4729-88e1-f6ce71ea475c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'995e9d39-8ecf-40fd-b58f-af62d2d62439'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'9964485f-e9f4-4768-9e61-4ebffb63a4d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'996630d5-b50e-4f05-a249-6acb5f20371d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'996d7043-ce9c-47d9-a63f-20bcfea13e23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'996e60e8-c5b2-4adb-9d6c-a126d871e90f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'99728708-bbf6-4c75-a404-513df83a4610'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'99845bcc-fbca-4b2a-86e6-e793174c3538'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'99852735-1003-4b6a-bdae-7a4ec3329171'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'99859dfd-3bfe-44d0-bf9f-ed711412a5fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'999c79e2-c1f9-4107-bfa2-333e10578193'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'99a97941-6827-486d-ad7f-103d9ab49c82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'99b653e1-f5d5-425a-836e-9687849b0f6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'99b84e9d-1ad9-4156-94ce-77468c86ccdd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'99b8ce5b-70ed-4381-ac76-3636e8ed7688'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'99c35b3f-bab0-4089-8de0-f1beaa9b1ffe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'99cfe380-15f2-4a58-90bc-50fa69aa594e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'99d20d68-5cc9-47b8-9d0d-bcffdb3c612b'
UPDATE dbo.BloodProduct SET RecordStatusCode='A', OriginalProductTypeCode=N'E015', LastUpdateDate='2011-07-27 10:54:08.050' WHERE BloodProductGuid=N'99da7903-9969-48e1-96da-4a5cd735d07e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'99deaa37-ddff-4101-b206-6df1228aa62e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'99f26e31-7c9d-43ca-9e1a-46e7963f45ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'99f28938-ff83-4ed8-9950-45c9520310f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'99ff5ca3-93df-40bb-9384-00b0e1d0cca9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9a0db2dd-7db3-4e7c-a540-46159ebee986'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9a0ecd80-44a5-4963-8972-4b58763f0271'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9a12370c-63d2-4d11-8ae5-1b6178ccda6f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'9a143677-a368-43cc-b364-dd2cf42b733c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9a1ad8e8-3c4c-44e8-90ec-2931db83eda5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9a1cd263-cbe4-4e42-ab6d-4070725ffc9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'9a254b3c-12ed-4fdb-b7c9-2f96711c71ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'9a27e956-557d-44ad-bf2b-79a4b66d42f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'9a3a4d9f-b90a-472e-80b9-d693afec0725'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9a4a60d9-07c6-46d3-bde7-445e7d8b6dd4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9a4ed130-eabf-4465-a52a-63a9035dcba2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9a5fd5f8-90e3-484f-a099-20ec803af45a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9a6076f5-0864-4c9f-83d9-e624d92c86e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9a68603f-c40e-4bd9-a441-bbde9236dea8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9a7124af-cd71-42f6-a8bd-4a8a53784c6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'9a73b545-4d92-4bfe-8f1a-651bf9d81ef4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'9a8506e2-db36-413a-9ab4-39439c8715ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9a930be0-1e0f-4784-bc70-ca8bf9b18560'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9a94a1bc-1583-4b71-a34a-0e3e400fb18f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9a98def8-db86-4d9f-b510-fdc3e1e276d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9a9e43ac-eea5-4169-b88e-a01208287e12'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'9aa03e44-bfe7-41ad-8036-f6c7f3c5ce2b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'9aa707f3-3591-4080-a81d-fffc38a4fe45'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9aa9e1f1-9059-4e85-beda-d9c8981b4682'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Irradiated|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9aadc3f7-9470-43d7-8008-01e276d269ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9ab6fc5c-196f-412a-b2c4-36b95b0d648c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'9acbddd3-2f5b-450d-8095-265678f21668'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9acd55f6-32ee-4bf9-bc75-92b9408266d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'9ad19782-3531-4a09-99c8-df1e56328c39'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'9ad4c100-d818-4f6b-b2d4-ee55032e5459'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9ad82e85-4693-424a-80b1-bbfcb1723489'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'9adc3f77-6607-4d0b-bfe1-18af94ea2e13'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9ae0955f-c932-4bda-bda3-67b2c4a2ff4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9ae472d5-7c43-4f2b-b786-e3d42f2d3e57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9ae98b08-0024-4d58-9bd2-89c472c90e4c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9af92869-3c6e-4c9c-9ce8-2d8194a2a642'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'9b0237ac-f4a4-473b-bec0-d0c256f4bee9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'9b0b7ffd-dfef-4191-93c8-660bf67822b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9b128339-aae1-4f12-816e-7e55a098e449'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:injectable|>=200mL<400mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9b1a2408-ecae-44ff-b478-4a7861e835d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'9b1af311-7ac2-4444-919c-1d782c0a619a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'9b1d1016-6046-4c74-b1bc-b425d8c91f85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9b267ce0-ca22-4671-b951-97a83daa1cc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9b3c20d3-6ded-4bb7-9ece-7e1460ac46f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'9b3d535d-58ca-40ca-b959-6e461d8d8a40'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9b5bbc23-71df-4736-bb9a-256bc1a4c27e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'9b5c0f3a-1682-4466-81eb-03f4faeb65ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'9b63b08a-87c8-4730-948e-3254c67eac0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'9b693f74-9c78-4ebe-b24d-91070eddbb19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'9b6983df-500c-415f-ac21-4e6166fe70af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9b708b3f-bf2c-42c8-b74c-b1cb9a4fd549'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-65C|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9b713d38-7da8-4761-b975-4e81b47336f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9b77e22d-dd82-4fe3-a836-511ff8c91805'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9b7980f2-db9f-4519-b928-25a5d00f810e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9b79f44f-f6b8-4ab2-b5ca-070a40e28bda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9b87d23b-b1c4-477a-804a-f54a070743f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9b8cbe89-fed0-4994-9fdd-50833644b254'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'9b9011c3-add2-4be0-9837-28975a20df5e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9baa87d3-e38c-4cdb-873c-9eb3fccd6711'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9bbb8b0e-c935-4671-a1cd-66dd6780f429'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9bbfade5-2343-46fa-8c6d-a5d634c850fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'9bc42cec-5eee-48a6-9387-227202c61a62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'9bd2b6b3-53f5-4892-97ac-e35bd7cbe6a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9be15b29-5e61-4734-9bf6-ab7955ea0a6b'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Irradiated|Buffy coat plts prep|Approx 120 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9be922d9-cbe6-4b12-bd11-49ade02ddc1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'9be9b8ca-4287-4edc-b785-ef29d8d8ea8f'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|Not for tx or mnf|>=400mL<600mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9bf47bdd-fe65-4479-a1b1-88af27ec9dc7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9bf54aac-4c32-4750-83c5-adede76a988d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9c071df0-3f34-49b8-a53a-9ea001cc7e84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9c0adae5-7259-426d-9de8-f442ca410062'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-65C|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9c0b9411-27c7-4133-8746-d66f9238a1ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'9c1bc5d7-47f6-49fa-ba26-2bea941b99bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9c26a686-b0ad-4050-8aa5-2e78a442ab84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'9c2dc98d-539b-472a-a329-6599b09f71aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9c46b83a-41a4-4628-b9ca-7fdc51db0625'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9c4b0bcb-9a12-4ce8-b20c-f54aef6e21bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9c4b907d-38ec-4445-afe6-b8716db9b461'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'9c524a59-3732-4003-b3d6-d3d67ed3c3b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9c5abcd6-6529-4a90-9ec6-6b7d5d1a488e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9c5f1fc5-81b0-45f8-a2a0-834fe8e6e1f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'9c616eaa-e280-4d3d-8cca-a473633aaacd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9c617d04-097c-42fe-a76f-3cb79bd90820'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9c6337de-fc6f-40a4-bdb6-b283823ee47f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'9c7e4553-bf91-46fa-98ff-48b5eb34d623'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'9c7e7016-6215-4cda-b394-b05f741aeeea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9c837182-93f2-4464-bd7d-6038133ba47c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9c8a09c8-ca07-4e3e-b1d2-554f50aeac2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9c8d190f-334b-4e73-b9fa-805318acfd54'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'9c9c977b-3b27-40cb-81bc-6b19dc65ffb7'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Open|>=400mL<600mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9ca011d7-a07f-4b13-9002-cf28f9ebfb39'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'9ca10d52-9cf1-4feb-bba4-d34b63957f8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9ca53666-4990-4e61-ac24-3f6bb7d48087'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9ca67802-61c2-4113-a235-7a083731cd8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'9cb0284e-c372-41a7-b593-2486dbe485b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9cb6a610-9867-467e-a573-50f6e55f3f0c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'9cba94e0-fb5d-44ac-85aa-e60fe7100ffd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'9cbe008c-b2cc-4227-a1b3-f36777e2ac10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9ccfbfb6-3dc4-4370-b2eb-50ab7224756a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9cd1e806-70d5-470b-84e8-10716e46eb69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9cd476d2-6241-4222-bf7f-ae6f8b017038'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9cd9c59f-5670-4e73-958f-fa6a8997923e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9cdca9db-3977-4923-b137-57b9845151fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9cddd0b8-64a4-450e-9ee0-2f77e29361e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9cef2f3e-55c7-4c77-a9ca-7d2cf2cdb2e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9cf5a74d-8425-45bb-a7e6-7a4979d1f435'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'9cf6444f-244e-4dba-a144-c19076c0d7dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'9d03d52e-f391-4b51-ac28-22e3dded81ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'9d08ced6-5505-4f18-8446-20f5ed1ec842'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9d0d3642-ae4c-476d-a011-41ab9e8aa15e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9d1275a9-38ba-4a3b-b79a-789513e6e24e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9d1615be-a5ef-4a8e-aba6-b8feb9aa6fc3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'9d1a6142-cec0-4e94-908b-0c15f596ef0c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9d1d5832-bc44-4d3f-b954-d0d8ddc642ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9d1db4c0-ea19-4499-9129-487efbc3cd69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9d292add-0fa3-4b53-a284-8ba908b4b61a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9d3062b7-a706-4f0c-a4df-93be12b962ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E062' WHERE BloodProductGuid=N'9d319603-d2c0-4f92-8285-efe9e52cc15f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9d34ce90-8505-40e0-bb93-843fbb68879e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'9d39e20d-54fd-4cf7-8470-57e71a2b2322'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9d3bf5c1-d4d6-44a8-ac83-9d998c8a07c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'9d3f1b92-ba7a-4977-a2d7-011b3a3f2ed5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'9d485335-b2e0-4e4a-b9b6-28770fe8e8c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9d4b6e46-0d6a-47b8-b0db-212976cdda80'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9d4e98c4-6e1f-4573-a0f2-7ca9306c4a7c'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Irradiated|ResLeu:<1log6|Buffy coat plts prep|Approx 240 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9d51b0f6-d308-4e13-8c2e-7c87c5f82ce7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'9d53843b-6078-4c90-b8c7-9cad16cb80b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9d539fb4-2219-469c-b3cd-808e7858c30c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'9d54fd17-df5e-49d0-a9d3-6d2bd5f9f464'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'9d5da853-c083-4803-9980-011709f4c905'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'9d66a32c-a5ce-4b16-b674-0ba7e3caaca1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9d6ecc1c-7070-4667-858b-ac99fa3287d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9d7544a4-430b-4d85-aeaa-d183633ed839'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9d781d99-94da-4a66-88ac-0bbe49982739'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|Cryo reduced|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9d79fbfd-71ce-4035-ba6e-b063cbbdf694'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9d7b9bb8-6ba4-4715-acd5-d92adbfcfab8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'9d802b6c-d731-45b7-8c48-7ebcd845c955'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'9d80c4b7-a38b-427a-acf6-c59ec439bfcc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9d902379-4d73-43a4-8f8f-32e1467b73e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9d9c1371-66b3-48ec-81b9-a2a51377d50b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9d9f4372-a9c0-48ed-8961-5f4b700336a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9d9fb3f6-b2fb-4273-a479-43ad449fb89c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9da302e1-5aa0-476d-a24a-ef5301f9640d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'9da8aef9-e31d-4421-9eee-e2da3cef5ad0'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9dad85e8-8ba9-4f04-97e3-bfa6ce00e9ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'9db7c905-879b-443e-b7db-e238f3f2ae42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9db82812-a402-40fd-aec8-dd8f1e7ccfbb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'9dbf11dc-58f2-4f9c-97ac-18a1de774d49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9dc632dd-5e31-43b0-8d3b-00dbaee14a9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9ddac777-88cb-401b-b34a-12eb593456cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9ddcd7c6-812b-4616-af27-85d0f28b2c2f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9dddd102-15f8-476d-b8cb-08ec2553eb9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9de5c711-906f-4a40-a661-ec176ce75c21'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9de862c0-f0f0-45d3-b863-ec969edfee11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9df5c84c-31c1-4722-aba9-7198f3fdb009'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9dfa676b-25df-4bd5-b67c-0d24c5c7a0b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'9dfab409-dab1-419f-961e-9e15f91c51c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9dfbac83-38f4-48c0-9350-1e463713ae6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9dfedf29-c325-44f9-b862-97b847d75045'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9e02b84d-d628-4d13-8f6c-6583a6912eb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9e0339f4-2c0e-4b6d-a0ad-9ee1ce965d7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9e06aa26-279d-47df-9c88-47a596b3e6ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'9e100b1d-b4b7-4024-ba62-d9e511924e99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'9e1fcfc7-fadf-45a8-9411-651dffdc1867'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'9e226204-b146-4209-ab2f-a94e79b63998'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'9e328648-3e3a-4a38-864e-aec863a76079'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9e33298e-2b3c-4e41-84a2-d392375f3168'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:noninjectable|>=400mL<600mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9e33b9b5-d90f-4397-bf0d-c4990e04b97b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'9e411a95-f86a-4f17-960f-72281ae18e60'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9e4371a9-2be4-404c-8bb8-35382de0df34'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9e480fb3-8c39-436a-b5c4-bb54a67dd3b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'9e4965f9-23df-468d-81bb-b92c2126b287'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'9e5f408a-109f-4b9f-b27a-e7f4d9c17e7a'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9e5fc2e0-d191-42b6-9937-844891e75bcf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'9e637ab2-a7a2-4521-ab6d-db740a8cb30b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9e668c35-b765-4018-9c0b-d5361a55746a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'9e678813-fc7a-4a1c-83c7-8074dcea40a2'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate = '20110510 07:59:27.820' WHERE BloodProductGuid=N'9e6a27aa-7cca-4e9e-b8f9-ee3de512890b'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Irradiated|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9e837dac-a0cc-4e93-a5ab-bb2d6780ed41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9e8ba18f-2de6-48c3-b40f-4560b78e18f8'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate = '20110510 07:59:27.820' WHERE BloodProductGuid=N'9e931359-575b-4096-bc60-e2095c6a9fdf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'9e988e3b-9fb4-43ef-99c5-c365a425de4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9ea1a82d-deb1-4510-901e-8505190b009f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'9ea757a5-6cb5-420f-ae53-babd76887b0a'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9eadd300-400a-41cf-9b2c-08192148a177'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'9eaff252-e9b3-4a69-8088-2948864c8e38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9eb99ccc-26a0-47b4-8f87-84b43e58e638'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9ebd0699-f7c0-4812-8f58-d7f651290fb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9ec5cbad-7172-4b8f-ab78-8bc759909db5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9ec9f256-b3d1-4e12-9d05-bbdbb47966f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9ecb87a2-81bf-4027-a126-2e3333898f2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9edca461-c907-44c8-bf6e-b72d2f2d4318'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9ee201d2-76b5-4c78-bf23-7d65ee73c586'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9ee39617-b86d-41f5-a223-e725d341cd90'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9ee8a2a1-8a84-472f-99d5-9bb74c7adb1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9ef0afcc-233f-49d8-8704-ccb9cc4aee23'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<=-18C|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9ef3d17f-689b-4378-9e5c-ca8c93d78570'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9ef74e2b-d608-4c41-b6c5-fafeaa43cd4a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9efce8d7-9663-47e9-aa77-2bafc75fe1f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'9f047898-7e0f-4a5e-a4b4-109ba2a76da4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'9f05e4c2-8294-4e55-8c1c-f59480b48ba0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'9f099ec2-0873-4814-8e1a-225888c3f079'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|Not for tx or mnf|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9f0cbe2e-c588-4773-b92f-cb10ee3af8f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'9f0d534d-ce3b-43e5-910b-e6e47c7a28f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9f17038c-5752-4a3a-ac03-acf7b09dd07f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9f1b71eb-a5e5-488d-9676-b25cdabbbcc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9f308f0c-1bde-4c79-8283-a9ae90d389ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'9f31cd22-c3e2-4726-8721-8998e7767cde'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'9f32ef6f-a631-4ba6-85cd-0189301dcc29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9f3582b0-e6d2-4d6a-9e1e-01fdd0254240'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9f41e79b-760d-440d-b1a6-6b0f2dc155b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9f434205-a023-466f-ae9a-f90b26b72dcd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'9f46008b-48b7-4678-8ba6-1164f8600041'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'9f4b0674-d02d-488e-af61-8d29a152c0e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'9f4f9d3e-b2dd-4f9e-8e3a-35066f086d43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9f5eea0e-604c-485f-9a15-1832c93c516e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'9f6b7ab8-b542-4cb5-b1ae-ff11a4e90e26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'9f6d1520-b2b6-43c7-9071-cd4ede604e44'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9f7655a1-0315-4e32-a764-09a4cbbe5edc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'9f79400f-d90c-434f-926f-854601d2f144'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'9f80e863-96e3-4a8d-956f-80ad9cfc992a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9f8a1d07-d385-4731-bd14-962d760af1cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9f92e55c-ab26-4d02-93a0-6e22fa90bee0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'9fa24d9f-2623-488c-9eac-66fc43471f92'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'9fa73ab0-f28c-4815-966c-9377e60bc1d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'9fa9dc40-de0e-4cb2-be24-feabe304bbe6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'9fb4519a-11e9-4909-a138-38c275ab658d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'9fc5a2c0-407c-4400-85c0-2cd304546172'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Irradiated|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'9fd14dec-b64b-46a2-a32a-482c63e16c05'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'9fe241f6-deb8-4a1f-bcfa-c09c3f8967eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'9fe9ef18-e02f-4e2f-8cf0-4ccf9fa627c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9ff79d07-ef3d-411f-a2f4-2601f7e09cae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'9ff87b82-349e-407c-8329-1eba0ca3d98b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'9ffab403-70c0-48f9-a16a-8be5be4c8b0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'a00912b6-a622-4d6d-a1ec-dfe9d04714e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a00acc09-60a8-477e-94c0-b100b84ee11c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'a0104217-de84-43fd-a295-8bf1c3c95fae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a012bf9d-1ae1-4d10-af32-a5ff4c2c1afa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'a01e4621-deb6-4fbc-8818-f3dabd252324'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a0200b4a-749d-4779-a080-b49bb36e4806'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'a0314968-6185-41df-aaaa-e36bc6fcd05c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'a040c7af-b3a6-4705-9719-371cb5da2218'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a04b365c-3839-4d58-848b-27bdcdf052ed'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a04b7569-3b2b-4ce9-89a3-56865842f376'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a054808a-4c35-4da2-af89-ddc34db65a65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'a0565f47-0275-48f7-ba59-9b60a3e4c024'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'a057d45f-c710-4f27-8239-19557f2a60ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a0662d9b-32bd-4c11-8a8a-77fbec53053a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a06e3d0d-d709-49f3-b606-99c8b3c8ebfc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a075978c-f7c1-4551-85d5-7116fe3f896e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a0833f7b-455b-4f79-885e-f42451a4ec85'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a087a7cb-d251-4f2c-98e9-17a52456f946'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a092c50f-481e-451e-ac52-3f1e0de9c4d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'a097cde7-59c0-4f11-b0cc-35fe913a99fc'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:noninjectable|>=200mL<400mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a09b8886-2998-4d26-ae48-e4751a12991d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a09c53f4-8931-4aae-9bc0-378644e56612'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'a0a14d69-e6db-45ee-8645-a04fe7002d60'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a0ac0f8a-bbf2-46ad-9015-829bb6073a53'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'a0b2e420-2f70-4905-bb83-b0c24a9dd719'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'a0c74c8d-cd88-481f-9d5a-769990f98709'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a0d25c8d-13be-47ee-a65c-aa7601295610'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a0e50d45-9be3-46c2-9c65-a56da5260978'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'a0f103e4-1364-4701-a120-5028bad8d31d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a0f71c09-fe1a-4d4a-84d8-3c9ca74bea85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'a0f825d1-d58d-41f3-86d5-071d50a56212'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'a0f8481b-5462-4251-b796-894b2138f7a5'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:noninjectable|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a100aeb0-3148-432e-bb0e-cdbbef8e62bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a103bb45-3b91-45e7-87d4-e203286ad60f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a10f09f5-d707-493b-8564-b28a60d4f298'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'a1163a24-e68c-49aa-a98f-5c4ab7c89f81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a127d38f-0cf7-4af6-af60-34e612b8a9c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a12c7783-c328-4e86-907b-35698d68f7a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a12e2d39-0650-4aa5-980d-dba62bb3e680'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'a134a74f-2227-463a-abb2-ce267320debe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a14c23f5-351a-4c22-9100-585719f0fa25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a153a819-42d8-4259-95b8-2c4c5cc825a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'a158c129-3bc9-487e-a9db-3851ad79d026'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'a1608ad9-52d6-4a11-9196-4a88c6b00ceb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a1613f09-e570-4bc5-8a68-9d0ff5a4c306'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a16fac51-4cec-4375-82a5-8440c3fc53a3'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a17015c4-2722-4284-a9d6-b6e4a328feb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'a171e7e1-d86c-4fef-a760-29588bb2df47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'a17e7843-c2d1-44e1-8fe7-31c016d9ae6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a182a6f0-71d9-4bcf-8096-64ccee0ad216'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a184dbca-fae5-4035-8445-028db3a5a370'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a188c903-5064-405c-887b-763b28d37133'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'a1aef2a2-592a-475d-88aa-ee360a5bcb48'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Irradiated|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a1b2feaa-701a-48e5-8457-bf5e6a1d4d41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'a1b3675e-cd2d-4d58-9c95-66ea74ac3774'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a1b5d8d4-b411-4a2d-95f7-c905c935ab33'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a1bb087c-de1c-4b7d-aac5-d2bbcc965c7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a1c142b3-f537-4eb0-bb1c-b78cf09bf1b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a1c6bd7f-4236-44e4-b218-8ed8a6fef2a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'a1d2cd01-d7d3-458e-82b7-aeea20851978'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a1dcacad-d8f3-455c-9d5e-67635df32dda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'a1f08bbe-ee18-4c00-8438-3fd9cdc0e0f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'a204727c-854e-4327-ab78-474cf862816b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a207a144-511d-4e39-bad8-fb38a16ca035'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'a219e220-ef5c-477f-86e8-8c011f881d93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a21ce106-b7e9-45ec-8858-397c195e6473'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a21ef749-721e-40f4-803d-c099e6ef5c71'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a2235eac-7e29-49eb-956a-1005b1fdf1d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a22b5b19-f066-445f-8ba0-7d7e20588bb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'a22de3e0-d33a-4ff6-86d9-279c09de004c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a238e591-cbcc-4266-99e0-52d7157593f2'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|Not for tx or mnf|>=200mL<400mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a23c273d-8d93-4d34-be1b-2ed40203f2f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'a23ca676-5121-4a9a-97d0-250d0a3bcb9f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'a2436f48-9d46-4170-96d9-7a29aa28ad72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'a255215c-c1bb-4c04-b762-cf9a208148c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a25ad28b-167c-4d5c-a289-99fdf9e5dcb4'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Open|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a2674b63-47b7-40f6-bbc8-0002da6666d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a2703045-3f9c-4f3d-ac98-fd58bd4634f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'a2703f75-6b25-4719-9b3a-cc6aedb017c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'a28ecd99-0ec4-4cec-b641-ec3b4cfbe0cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a296aea9-be07-41c0-bac1-ff0d41d5d24c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a29ad18d-341f-41fa-a5d2-a3b6ae8c9ff4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a29c959b-2028-4478-a198-25cf1996168d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'a29cd396-8a60-4395-8f02-53e06e3117e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'a2a6c774-685d-4ee1-9d58-99af49da7bc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a2aa3cc8-9169-4381-96f0-9147503840f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'a2b44050-2498-4923-aed2-3dd47608a82c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a2b8db14-1332-4b20-aebf-5bd744328863'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'a2b9cf78-4657-4b56-996f-760c39d914f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'a2be475f-b243-4b2a-8bc4-a94dcc024e22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a2c0c516-37b4-4f8a-9a1e-b75768791ceb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'a2cc3f88-b18b-4af3-929b-de21259af649'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a2d8f3f7-2b2f-4c13-a4d2-561b08382e77'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'a2e1d817-1f28-4866-83ed-bc8b82df6945'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'a2fc104e-3395-4d1b-84da-8a16255c48cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a2fffa5b-9892-4af4-b279-a0194b2a1477'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a3111c36-ebd8-4a6c-bad7-dd58ced2a619'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a3133975-6f36-47ad-a325-d66200c9708f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a3169d8b-62e8-40a4-b14f-d346e9c7c7d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a316ec7a-d813-4c46-adba-16041a3b31c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'a31ed8fc-8aad-4901-810a-9f47e6450672'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'a327fc59-3ccf-4d1e-b7e4-42457b525c83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a32863cf-561d-4cf5-80ef-106495705deb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a3292720-b3ae-433f-9313-e0620c4b3fc5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a32da0e3-6dc6-4bdc-b3ef-ef9c950aa1bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'a342992f-329e-49b1-87a4-3810c2f3b264'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'a3461abb-ea83-4de1-b5ea-c07c14945a85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a349ce5d-fe75-45c1-b0f5-114900edc81f'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a34c97dc-13d1-43c6-b9bd-4f6f0c70a67e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a3647f4f-4e1f-446e-997d-640d82b423d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a36672e0-c889-4bd8-bb55-46c83403dfb7'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|Not for tx or mnf|>=400mL<600mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a36e9f5e-b3a7-4d65-85e6-6c997146c2c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a370385d-8c46-45f5-b126-60ebce0d8070'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a37c3b31-83b5-427e-8db6-e4fe79059467'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a383258e-5d3a-4974-840d-06f70b2d8f36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'a3850d38-d818-4e6d-88c4-cf3a7a18c199'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a38a928d-6334-4b74-a471-928c033e7c59'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a3aeda62-5f8d-49bf-b409-a2a7b8e21cc8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a3b12392-4f01-453f-8874-aacef13363f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'a3b66eb1-3eef-4851-b2ca-658a2347d66a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'a3b74322-3350-4685-905a-b50117e0be7a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a3cb5855-38be-4788-85b2-bbb1813c8e88'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'a3d5643a-f102-4cfb-ba05-d8fcd9bc1d4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'a3d62dcb-a0de-4017-b1a9-3213c9c596c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a3d6398a-5cab-4b4a-9d2e-0288effcf01e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'a3d6f2b4-675f-4e28-ba6f-b03f431364b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a3d85968-3e29-4639-b8c9-3aeab481e94a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a3d8e580-f20d-4ac9-9612-1742b75cb68a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a3d92ae3-a2d0-4a96-a42f-c609d9feefe3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a3df5f68-cd01-4beb-8069-f552cac3e371'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'a3e0cc1d-64f9-4b12-9cb3-d81797f9a15a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a3e3182d-a92a-465d-9a08-dbf6360c7776'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a3e58541-9859-4b4c-bd27-28de04d5b886'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a403547f-b794-4d28-9550-a44ddf0a2181'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a4046c32-19fb-4281-8a46-36f3c1a8d877'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|Not for tx or mnf|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a408e2cd-0680-409e-a7d0-6c13218cbe3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'a40bed79-2e69-405a-93f8-31fc267f331d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a40de53f-aa71-4beb-ae4c-4a9b8cf93e66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a40f0ff9-7641-4fc8-83de-cd7e1678274a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a40fdc81-1195-40ad-9fea-e008f23137cf'
UPDATE dbo.BloodProduct SET ProductName=N'Washed Thawed POOLED PLATELETS|NS/XX/20-24C|Open|Buffy coat plts prep|From 4 donors', ProductShortName=N'PLT Pool Thaw Wash NS OPN BUFCT 4DNR', ProductTypeCode=N'E023', ProductAttributeForm=N'@72 B2 G2 J4', OriginalProductTypeCode=N'E064', LastUpdateDate='20110509 11:08:37.280' WHERE BloodProductGuid=N'a41a2f76-fe22-4384-952b-131d409121fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a42517e5-472b-433e-ac76-93f2e8e51fad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a42df799-cf2d-4259-b4fb-bd271f2469c4'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|>=200mL<400mL|Aphr not automated|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a42f4033-3ec4-4689-8fb1-b070c15fcb63'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a4392141-10e6-4b7f-8c38-2a039d57f2dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a43f3851-c003-43f4-a407-fc196d9c6122'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a440d79d-0b18-42bd-a1ae-c15fec6851f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'a451ff8b-549c-460e-9f17-6228474a18cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a4540412-3b2e-432f-b93e-d902822329c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'a4569456-cb51-4895-b8e7-4dcbdfc3683e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'a46dcab2-ea0e-4f25-bf2a-378a4fa58c74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a46f9607-2d8b-4093-ad88-4cf3eb4db398'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a4734b0d-1052-4a51-9df7-fa9fd7b70114'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a474c015-20d3-44ee-bb66-f2eb0d94dc44'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Irradiated|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a47c8e52-836b-4fce-94eb-b67be1c1dcbf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a47ea0f9-9b73-4b02-9784-6ad15084e88c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a48acd4e-49bb-4294-98a1-9676ee64c106'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a48d74c5-6733-461c-9aa1-b152c7f46a21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'a49125d6-89af-4a05-a37a-3896bc37ab6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'a4929c9d-7d34-47fa-91a3-31cd692bd497'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a4943235-b365-4ff4-93af-17df9bb4ac21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E043' WHERE BloodProductGuid=N'a49ff3f1-09f7-467d-95ff-b918ecfebc3e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a4a116d4-89b5-4c52-9a1e-772359d566e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a4a1dc83-b265-420e-848a-a69983c2754f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E037' WHERE BloodProductGuid=N'a4a758f0-f0c1-49ff-903e-68c3d57f6080'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'a4b167e9-3cf9-4b46-a8b5-a867bda4566c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a4d06c13-b689-4847-b05c-0dc52cee60dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'a4d2fcc5-da88-405a-97c5-ea908d9cd530'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a4d8d215-1a39-4a34-b837-b9ed59118b9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a4e08046-7849-49e8-aaff-837787537b83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'a4e16531-890d-469c-8d3e-9af73419a0f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a4e67db1-17ab-4908-babf-1ab1460820d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'a4ea5847-2232-4ca0-b3e2-6cffa4496dee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a4eca54f-c84a-48de-9621-9106f3a6c448'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a4f20256-7fb5-4ff6-8064-778e0f80dec0'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:injectable|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a500aa10-b727-4167-a0c9-f5d825f6b5f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a513bf8d-380e-431c-89e0-13dfdf4d0371'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'a5146b39-d249-4c03-ab56-16601a8a2753'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a528b80f-9b8b-4a62-9f68-6a3ce31de57d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a53d9aa1-a9ba-4f94-9e5a-6abf388c7c17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'a5436947-2e8d-43d2-8d66-a78635a53906'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a5467b61-30df-41e6-a1cd-346c476b506c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'a55003ca-bb23-4fc4-a1a0-ba68236e00d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a5595b64-424b-486e-996e-43959707730e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'a55f84ee-9a10-4a15-932d-f5a9e19c47b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a5614e6f-41ff-4709-aca5-a86cbba899a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'a56d4808-38ef-4d03-b78c-20cb54a56bb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a574be03-7ee1-422d-8eae-6f66d12033f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a576b85d-3ec7-4ec9-8090-d2a059ff3624'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a57b901a-f3bb-4e9d-ad57-d58f57ce127c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a57eefbd-d6b4-4c87-a0d3-b7523038c81f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a5851340-cca1-418e-a095-5d04e487dead'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a58538d4-75b3-4ea8-85cc-7faa7252c54a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'a58bef5d-8b6a-49c7-be28-a40ea898e2bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'a58c9cea-23ff-45a0-ac2c-c160dd26518a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'a5907acf-7f5a-4f1a-9a7c-82b6aaf61059'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'a593ef26-a8ca-40a0-8ee7-4d15fca4eb49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a594a1f4-5539-402b-88a9-1a04c7f3e0a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'a599a5f7-1ba9-4b4f-a9ac-18ffe3f991a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'a59bca63-39c7-4ce5-b12e-9c98a850b2be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a59ffaef-a8fc-4f4b-8f89-02899aedf7dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'a5a4772e-f585-4d15-96e0-47b6dea59eee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'a5b16d14-a33b-4890-8696-05c59caeb166'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a5b501e3-d821-4563-973c-7ee84c7535f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'a5cf081b-69f4-43b1-946b-977c88aab491'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a5f422f7-b2cb-4220-9ab7-065bb5585261'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'a5f614b6-d168-4389-bd1b-c29a17d2fed6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a5f9f5ac-6fd8-439e-a18d-8cd22fbe3671'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a60235fc-d7d2-4d2c-a4c9-1c29a3b755a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'a60e16bc-df15-410b-af2a-02f7be51455b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a60f91ba-94bf-44ea-bb1e-23df55d84d42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a6227317-9c65-4d5d-8247-9da301d359c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a624e1f1-1d6e-44c4-9c15-5b33fbabbf55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a62db46b-0506-40b0-bb03-5f1cf691fbcc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'a62e83da-3e7c-4f2f-82d4-9d35c49ef540'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a62eaafd-dc37-49cd-a595-8af7c3c6e639'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a633b43a-ac27-4df5-9f50-a29987268579'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a6353264-0679-4330-a30d-d74a3edb1103'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'a63ed53d-1ea3-4057-a0b9-563cdcce9007'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a64875d3-65ba-4a3f-a89b-1d564d76ce23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a64ba3d6-35be-4308-92b6-65fbd8e2c449'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a64ff084-41d8-4cdd-8c8a-fbd57da8c314'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a650709f-8e81-4c01-a8fb-9b240768a8d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a657d4e3-e94e-44ed-9096-4d1333c9ab4b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'a65a4aa9-ab94-46a9-9dea-cb4f776396bf'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a663ce07-07f5-49e6-be7c-fca61c273b01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'a664b952-6024-4af3-b901-63da6c4284ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a6666923-d975-4c5a-9faf-d1d2b04861d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'a6689c39-02a8-4078-92ef-2b249b163f35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a669b3ed-d55e-41e4-80f9-468d6d65e499'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'a67d41fa-8eb7-4fdb-9252-777189cbf00c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a68154cb-10e1-43f7-87d2-ae8573c43663'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'a686426b-a157-403d-bbf7-d8eee92fe093'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'a687889c-9ec4-4089-9d91-40bcabb7654c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a696feb7-5560-47ac-b86d-a107bab0a2e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a699a604-3599-4ed3-8f29-d22f73799d5b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a6a96a62-c458-4a6d-9f6e-618cb819ad56'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a6aa90bb-ba87-4083-9394-0cb04490d2c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a6adc422-5717-4268-a2de-3c2783af9ec6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a6aee923-c778-4571-b201-f0feeffc2e35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a6b8489f-dea1-42e2-87ec-6d09d1b01133'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a6bec947-93e4-444b-ae3b-0eee17c65e61'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a6c4042d-d17a-4fdd-8687-bd55f7e6edce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'a6c61e01-6d38-40c5-ab26-5e7c7a1674c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a6d37884-0993-4ed6-8f3d-9c93c57d8928'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'a6d4f5dd-dc41-432f-b4f5-f32a13efb1ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'a6db0b48-eacc-4278-9256-cfb6a22debf9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a6e1ea4d-ff18-4029-9683-5282074250cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'a6e7cf5c-8de5-4a97-874e-ef744bdd5a72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a6ea87ca-8ac7-4405-90bd-6478468e30b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a6f23d0d-085b-4489-a37e-8c7799ea38e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a6f28004-4088-4f75-b754-98539779b170'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a6f38629-4ec3-47db-b51c-bc0bfdd59004'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a6fbca27-0106-4350-accf-3b63fd078e33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'a6fcfae2-00b5-4e0e-a2a7-5ebc277ffcfe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'a6fd35fa-93ed-44e7-9f92-7ce1106ce98b'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a70f4723-127c-4f7f-be82-e476d0716a5b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a70f6c27-2463-4ac3-a6a7-f5db97a21626'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'a716c867-40c2-4d0d-90c6-7f9018b6327a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'a7273086-d448-41a8-b58c-6d4f64b18f3e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a738b202-ad58-4f08-9e7a-0c3c1af2946b'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Not for tx or mnf|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a739e42f-fb25-4f46-b126-87212de92df1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'a74790e1-f212-4253-b61d-5165a8437f12'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a7511d52-8ca4-44a3-ba23-d0901971bee9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a7512ce3-63aa-4b9f-a38c-258048f46d1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'a7582789-5b7e-40ac-8bf8-0e9b82246927'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'a759992c-9eee-44c8-813b-3d34487dd86d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a75c6fe4-d6bf-4322-9011-d562b4ffb020'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a761399b-56b4-46b3-b241-79c50aefddf6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a769c1a0-38b8-4449-a7fc-05a4cebf69e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'a77273d1-a6d4-436a-bb0e-8394d256d77c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'a7738d1b-3a36-441c-8b7c-5f0474afa497'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'a773eb60-7e69-4086-8c98-9eb0f24bf3f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a78870a7-44c8-4793-9363-3a0225997a9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a78b56f5-06a8-4b5a-9c14-e5de0d8309bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a78c6048-3113-4d75-af2a-31bd7a4f2235'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'a7974a8b-f3a2-41bb-9025-3d197c1c070c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a7aede0e-813c-4654-b491-ea79fa36f43e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a7b9478e-9947-49c2-a4e5-6ce71baa14e9'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a7b9668e-28de-48e6-b439-f0af63f4661c'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a7b9be7c-e284-428b-9bfe-19e7db69ed2f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a7c28ed5-92ee-4821-ac89-1f88afce2bbb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a7cf57ce-47e0-479d-8a2e-44bf4f3d5241'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a7d294ed-11c7-42d7-8eff-7794571d57e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a7e02f9f-cbdb-463c-a789-668c87621748'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a7e487e0-f059-48e3-b20f-7940f9869a74'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a7f8a12d-2750-4a81-a244-fa19d2e9131a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a7f90895-4102-4874-a211-295fb09146ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a7fa67b9-028a-4092-a23e-27f91b7efe19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a804056d-fbc1-49ca-9323-537f6449bb96'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a8094b24-edbc-4ec5-92bc-cca92965bf47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'a80baa69-38b0-4c13-b947-e443f9c99138'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'a80dc102-93c0-4384-a54b-caaa495d6807'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'a80fa620-a787-463d-97ce-4bbcba9aedc8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a8138486-9e96-42b4-b617-9679fd7857cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a81445bb-49d3-42ea-b3d8-68933325cb93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a81e3021-2615-4624-860e-47c064c28fd0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a828d00c-ba77-419a-83c9-4dd718e93c59'
UPDATE dbo.BloodProduct SET ProductName=N'RED BLOOD CELLS|SAGM/450mL/refg|ResLeu:<1.2log9|Supernat rem/Plasma added', OriginalProductTypeCode=N'E002', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a8294b90-b042-4820-abf3-b4c715ea4161'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'a84c954c-6427-4d54-9270-5df55ba1c886'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'a84ded86-7721-42ad-af29-007d475e4896'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'a86282f2-590c-467c-bc79-b721174c3f05'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a871981f-b8ce-493d-9ec1-420519fe76d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a879a7b6-4eca-4624-87e7-8fa3cdb94826'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'a87c80ee-493a-42ce-9109-17a9bb73f65f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a87e4962-ede5-48a3-af9d-bc36bcca2a8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'a87f0df9-d7f8-4951-9506-03384413e8b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'a87f75a1-1366-4d15-915e-2b4fc2bb0540'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a8883ce8-8c1e-41d1-9a07-d52a8cf07ab7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'a88d9a22-6ea1-4733-aab5-dd0698286a9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a8928f1c-684c-41a9-901f-a1a769f93c54'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a8930e67-c624-443f-a3a4-3ef961151433'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'a89694b4-7b1f-472f-9820-b094d5fd37ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a8ba147a-c157-4da4-87ec-c58c9ca998cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a8da2730-226c-44c1-88da-f8fe076f34ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a8e07af5-e945-4172-97c9-14af3a4da37b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'a8e56668-7e97-469a-bb44-8c1a53e2e8b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'a8f2fbf8-5220-4a7f-8fda-dc69d9cb187d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a909ce04-7677-4f85-96bb-e611e67a845a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a912ecf2-0c1d-429b-b038-4e71a095b720'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a914944d-5bbb-42f3-a5e7-9d3ac6e22f57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a915b863-7606-4e1e-b692-efad7f73dd8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'a9180c5e-f8d1-4a92-a105-0c1e32c7de1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a91e9e5b-b4a8-4b48-88f4-b1d554b87011'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a927183f-7510-4fc1-9c0b-22c8e58b4a0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a92c41b4-3622-42fd-95a0-2ce010d99dc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'a932b1ef-14ee-4abf-9cd2-13b57eaed945'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'a93de30c-bde4-4f58-9a16-bb070491262b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a93ea18b-ce7f-495d-98fb-b2287090330c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a944999b-f4ef-41d8-b3d8-d9a0a89f4a82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a95127fb-cb35-49cd-af69-88fcd3743a62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'a95841f5-c498-45d6-a0f1-8c40bb8a8a5c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a95c7ef5-ccdf-4c65-9476-51c27c37ad82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a9664c5c-7fd6-4bd0-bced-13834047401a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a969ff2c-6868-4219-9943-cca567e8c2f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'a9755f30-220d-4391-8b27-1614c98d2f1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a9793f19-6199-4e90-8cb2-8237342cb586'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Irradiated|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'a98084b2-7565-45c7-993b-4bdf057d997f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a98396eb-a8e5-4532-97f1-e774f6d037d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a989cf90-d5c9-4ef8-9efc-3dea602c25f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a9989c07-f190-4cc5-9aca-097da3b13f2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a99c68ce-82dd-469c-bdd4-32f43334989e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'a99ca001-3fb8-4753-bfb0-8801584e626b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'a99cfb53-5ef8-46ce-9e00-a4d7e0d7fb9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'a9a0df68-fd96-41ea-9f20-c5afc8cda770'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'a9aec0f1-d128-4b0a-9b97-23873e08d8f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'a9b0df40-6604-4a5d-b8b1-45b6ac2f13b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'a9bf7aab-a275-4810-840c-be5534f00592'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'a9c255c8-ee9c-49e8-95ad-3918895b4b2d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'a9c363a7-b814-4cd6-b41b-1fd70860c7ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'a9cc8803-e32c-41cd-8af5-7b879f2778a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'a9ceab73-bee6-4356-9bba-10b1aa0e370e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'a9e72844-8444-4f68-bcc8-087ab1c3cc72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'a9eacebf-ceae-4ce3-bd7a-7c9c25b3e944'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'a9f0f123-9746-4965-8eb2-28e3137198eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'a9f7ab04-4b6e-4537-aedf-8c0f7365c937'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'a9fb5f78-3aa7-4e08-b4c6-94a4df0129d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'aa03c396-8f75-450f-8ddf-8dd1668f886f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa03ec24-9a85-4cf6-b2e3-e5ac79cfe401'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'aa045b21-c40a-4e7c-a7c9-8642802b3259'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa055f0f-6e13-46c7-97c2-9761541de2b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'aa09279e-40a5-4686-8c33-834d6b4637fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'aa0be3e6-71c7-4069-aa6d-2674a517af89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa0c86ca-56b5-4083-a0a0-f082e6590cee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'aa110c06-a428-4424-bc4d-96b39b2f7c8b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'aa11ee45-cddb-41c9-b3d6-6ad9c2d32afd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'aa16983b-4f01-4b68-8ce5-81dc60fb69f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa1ef2a4-3605-490c-aaea-0c73c2576071'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa281147-d8e1-4169-b3e9-10a4403c8a91'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa2b73ad-c83e-4777-ae28-90b9c09a9541'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'aa39ac11-08a5-4c30-b69c-fbac11097e7f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'aa432d44-1b93-461d-8a2d-aa6b3ecfd224'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'aa49b601-0b68-40ac-a860-7d1229c71232'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'aa513a64-48f2-4202-b441-6ec31f9dfe91'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'aa526de5-c6c8-4ed2-9302-2e65f5dd6a35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa5fd412-37a1-4982-8bac-d7465c4b35fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'aa64b31d-49fd-4039-81be-d82bd6302eec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'aa66b7e3-f174-4d94-a070-042eb7265cc1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'aa671965-58d4-4742-a414-69b7b8e0dd60'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa68a4a9-5af6-49bc-9dc6-360daaec3ec4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa6a1056-c43c-4a29-9cc1-383df4ac2943'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa7476ee-734c-4ff6-9b5f-f4b1cadb9f74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'aa7ab5c9-b1e2-4bf8-a81c-cae9c0f5456d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa7ce910-04bc-4795-b825-ad4c94850497'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa810d1c-b26a-48b2-8709-75cf946fd54b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'aa8b4b94-6c02-4045-8256-00b9ef263701'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'aa90a7bf-20bb-418e-88e2-2d5d89003e9f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aa9489a9-9c42-41b3-9bcd-d1d0d5535e15'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'aa958eb2-7abb-4cdd-8930-b5c8ca8a5934'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'aa975df1-b998-46a0-a6a6-e96e44f4839b'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'aa9c94bb-5caf-4c40-92b8-f998442a50f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'aaa1686a-a6da-401b-a390-a5d4dd372cec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'aaa1aae0-88df-4601-a1a7-a5a0eb08d452'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'aab80f8d-4552-49c6-8dc3-f98083a2dc32'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aac3b917-0a53-465c-bf83-ffd5a2f27f42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'aacc0032-49e7-4f2c-8149-463ad13db0ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aacf51a7-0ff3-475a-a670-a716dd86bf19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'aad91957-fa04-4fab-8410-af3b843b9d7c'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|CPD>AS5/450mL/refg|Plasma reduced|Buffy coat plts prep|Approx 120 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'aad9a6dc-e0f2-474b-bf27-041633aab962'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'aada0e3a-f98f-4191-9eb4-dea5d61bea99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'aadf343c-eb9a-47da-b9b6-f13190533aae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ab10af18-fa18-4fbd-969c-78c7c90d2007'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:noninjectable|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ab2b6622-b500-46b0-92e4-b031fc595927'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ab2deef9-6c4b-40a5-bca6-878738401ebd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ab57e1f3-71c7-4b11-a085-41223576f344'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ab68a9e6-d0af-4a36-9bac-d2e0631ba91b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ab714d00-a02d-4785-b070-d630ce504c8a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'ab74ca22-ebdb-41bb-8d83-16582fb61981'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'ab81fbdd-3f1a-40a2-a5da-a02786287b46'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'aba2f0f2-3bd9-4185-adc3-24af501a4f66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'aba6a992-60f5-45fb-b043-909d5b270e24'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'abadcd5b-6ab6-476c-85c7-954d7ed6c132'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'abb473d9-b9c9-4730-93d1-e0d134a71389'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'abbcbe6d-43a6-462a-a541-fef5d7be41e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'abc66837-041d-4f34-8495-3a54a5caf530'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E057' WHERE BloodProductGuid=N'abd53cb8-10a6-4726-9879-e84bbff625a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'abdafdcc-521a-4519-8b08-791d29df6f3b'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Not for tx or mnf|Open|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'abdd0322-5759-4373-8050-f4c15cf3a41d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'abe1ad03-3b56-43a7-8626-4f8dc980d4d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'abed5ddb-54b7-46d7-95b9-347bc02749f6'
UPDATE dbo.BloodProduct SET ProductName=N'RED BLOOD CELLS|CPDA-1/450mL/refg|Irradiated|ResLeu:<5log6|0.5-0.6', OriginalProductTypeCode=N'E002', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'abf2c19c-64da-43ba-b4e7-b306806cdc2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'abf4014f-d498-4429-a3bb-c9ba5cdc77b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'abf9d994-6fa9-4807-992d-073e862ea026'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'ac016872-feeb-48ce-b44d-37dcc9429162'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ac05d880-ed01-475b-a755-566669ac4b6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ac11ca61-16db-45f1-bd00-e234dc82eebd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ac1681ea-ceda-4b1a-b899-de64a6d4e66b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ac33e10c-685c-4e9a-9564-660c43801cb5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ac34fd39-7b6d-45ca-8d0d-7ecfc8dd7781'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ac37b7e4-b1bd-4c1e-b012-52d4dff6ad86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ac48c4da-bf05-40b5-86cf-1d2780b72cf2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'ac499331-3a93-4978-83c4-65c0c4ad3fda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'ac4eb8cb-695b-4b76-a065-893d307d4015'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ac53f3de-2efc-425a-a110-69ca7c31e684'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'ac61ab2b-893c-41d6-a168-0a53e864c77a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ac61bf84-45bd-4f86-9fab-63439a58cc3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'ac6800c0-c780-4a35-b175-b4c843f353d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ac76c528-9382-4d9f-b521-4ba60f849d96'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ac826d0f-f966-447d-bf5b-2d7caff74d32'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ac854129-d2b6-4d28-af16-a921fb86014e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ac8a260d-f479-445e-ab86-86a83f38cde0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ac8f3c1c-f173-4485-880e-9795a8338a49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'aca43992-6c44-422f-85d2-780f79ee9713'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'aca6eb49-309e-4a73-91db-cdbb1b1a3330'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'acba69a6-acb0-4f39-ac9f-7cc7068a65ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'acbf11e7-7d78-4970-b342-dcc826881510'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'acbfef99-c430-4328-8fac-fa26ce18d9e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'acc131e6-e925-490d-8ecd-5ce54dd3a19f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'acc30840-5056-4d81-96d6-7c856094d5fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'acdb0daa-11a1-4342-bb9c-7f89ef7864b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'acdc3b00-da80-49e6-bb8c-62d44eff4b24'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'acef1253-b50c-49f3-8b4e-2c2e04cf3d8d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'acf3ae2a-cd51-4a66-b34c-8822b0d54d39'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'acfa283c-ac37-44e0-afef-9e3a6c6857a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ad03762d-c037-4ae7-85ce-4c92ebf927e8'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ad0700d9-b1ae-4419-b8f2-359729a92144'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ad3a0500-a50e-434c-8be2-df27b20e9bea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'ad3c9f70-6f5f-4e8a-a18d-25e944082390'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ad3dd923-2c80-48a1-b483-413fcf2cbc1f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ad42e69e-9d1e-4d25-a369-3a628831b358'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ad4ce9f2-65c4-42b7-8e5c-ae0b9e30a2a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ad4d4b37-8b9a-4d71-8a9d-fe4c227019cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ad56b518-90fd-4932-b937-834c50fd9fdb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'ad5f5718-93b9-4313-a2dd-69c7ff95c273'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'ad652829-d541-41c5-aa49-028ff30ff981'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ad67c83c-2daf-4a7c-b462-3daee3e80b81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ad76fe7a-dc1a-4f6c-ae19-288dce3d8415'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'ad798004-07cb-4eec-b75d-9747a32f92a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'ad8206d2-1557-47fc-a117-305456a82453'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'ad88fafc-93e5-4256-85e2-aa14fe2a05fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ad9739d7-6fa6-4c5c-8b9f-bb2f2ea96599'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ad9fc5a8-aa0a-4d6c-8594-d914de76476d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'ada01b97-8a7b-48a8-9cd8-f32cade293ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ada5198d-080f-48fc-a479-569d55a2bbfc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ada51e9c-ccfb-4549-b881-11e3bac8781e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'adb43fa5-2eec-4c4a-986c-11a590013f75'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'adc6deca-172e-44af-a7c4-cadb7bb8df48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ade47b22-f427-4e16-800c-0e9203b5e91b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ade49671-430e-41b8-985e-6dc65da94cb5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ade7ae9e-ddee-4832-b9eb-312b93e95a3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'adf10467-e74d-41f9-b5ac-5ebc705b5c08'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'adf38f46-dcd7-4608-8de2-bf35346a83ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'adfec4d7-3ff2-4a52-ab00-98a1b058db86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ae01f33c-77d0-4873-8a72-e9aae58a0096'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ae061e48-2b45-4beb-ab4e-3ec547feac70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'ae0976a0-8785-48c1-baa9-b682744a0a48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'ae1ccf82-816c-4f89-bfb1-596a5d20bca3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ae1e3bc0-a7df-48e7-83a2-d17f5cf7e4ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ae227866-0ce4-4ce8-b2af-5436cf831f9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'ae288e7e-2fea-40b1-b3b8-b5364ebc6da1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ae3121f2-70a8-449f-87e0-47ecd3f0def4'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|Not for tx or mnf|>=200mL<400mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ae457ca7-fcfc-4386-935e-f929dea40af0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'ae6242c4-88cc-4bec-9aab-b966c0868b2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ae65ec70-697c-486b-be46-9493039b355e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'ae662f9f-7298-4ee6-894d-170458e265b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ae66ddf4-e272-4df7-89f6-8163ec1864ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ae6919c3-e92f-4c75-9ea8-a585b63fe074'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'ae693884-cc54-45c1-bffd-77db9b9a9a18'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ae6c5496-b75f-432e-a0d4-2379998db73f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'ae721b66-08ed-4b3f-a80e-55c0f3b2c439'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ae74547d-9dce-479b-9c13-cfdce20bb3b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'ae7c43e7-b749-4802-bb2f-e656396cd39d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ae8c98c0-4252-42f4-9e7f-221919473fac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'ae8dcb14-d58c-40e6-ade4-7dcc97a14002'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ae8f9cf9-4629-4ada-927d-859d77ab19c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ae9420a8-f807-49cb-a108-3ef00be4c6aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ae973f70-0d05-4dc2-a91b-6a32ccbcfc14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ae98eafd-3c3b-47fd-ae57-56289e0577dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'aead13a3-68dc-4bb4-8b22-ed04fee5e7cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'aeaf2261-351c-4b8c-8fba-84d41ef4dbb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'aeb5a5ae-d3b4-4d17-99d7-3d5da63af007'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Irradiated|Buffy coat plts prep|Approx 180 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'aebdfc4c-04f4-4528-aa85-f3104d471817'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'aec05ec1-3c02-40b8-8e7f-3ea34e674e2a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'aec1a52e-6750-4cbb-9ba3-45356dbeebf2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'aecfa1f1-8ea5-4441-bb21-0c56506811d1'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Open|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'aed31213-c44e-4c3a-bdf1-fde279faef09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'aed49465-8410-4968-88c6-78635ca63a6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'aee3b2a0-e968-4042-a9c0-675bf05628be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'af025d89-ef62-40ae-80e2-e6995a3076ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'af0bcdad-36c1-4ae9-87c7-422826325303'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'af1bf99c-3333-4d4c-8045-2c1dfc554032'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'af240236-b882-4f74-85eb-3e8225512d42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'af272438-372a-43f9-98a5-b32ead66b607'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'af31795e-795f-4ff5-808f-e262d528c68e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'af3600b3-eaed-4adb-bebe-0aa8cedb7e2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'af39ddd1-2c38-4e69-928a-8e8457f2e580'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'af3eb202-8471-4b90-bc5c-e8d4ab1a8131'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'af451020-becf-4578-87a7-84bfd47c90df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'af51996a-c66f-41e4-8793-8a6f6f710a2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'af52811b-736f-4b02-bfaf-8bc3e293db33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'af579068-9d61-49e2-9f0e-3267bcc133a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'af5ea588-0de5-474d-b00f-72f6f0336047'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'af63749f-619e-4b8d-adb0-7adc1b512c5f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'af66db6d-8d02-46fb-bc20-8eec29af3981'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'af6955e3-f26e-471f-b899-a41addf89088'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'af6a72f5-6e7c-4223-8432-14c249966cda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'af72d752-0f51-424f-b90e-a2b3bdfe51be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'af761a56-cfd1-4845-b75d-b97634d531ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'af76ef82-7e00-4790-887f-efdec6378367'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'af7d5a11-2649-4e8f-9050-fda394206122'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'af88ede5-f30e-4068-af40-95e4053eb7ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'af94dad2-006c-47ca-befa-a08faaf536cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'af94de91-7dd2-43e3-b058-a635b9ce9d58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'af9c2eb2-5264-47d0-b5f3-fc9353d83471'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'afa338b8-9c58-4937-b43d-ede022f547e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'afb8da63-4e1a-4cda-8501-7468c4887207'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'afc5c91e-a2ac-4fb1-b22e-43ccc9bad9f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'afc7de67-96b9-4104-b1c2-5fb941974b3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'afc8585d-96cd-47b2-a9e7-dd9c60088f1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'afca9749-29bf-4dff-998c-013967b97ea1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'afcb83e1-f3b3-46e8-83e3-e3582d1c2ce7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'afd269fa-cafc-47cd-b2b1-7a3abf564701'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'afd4f126-193c-4756-a5b2-405fb6ddb4f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'afd7b799-26fc-44de-b0b3-cd0e70edf283'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'afd9036e-3b2f-45f1-b7bf-b6ac455d6e82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'afd90a91-3df9-4c05-a4c4-de33c001f8b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'afde8d40-e3ff-4bc7-a5f4-5988164da4ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'afe86f25-a1f1-49ae-b31f-1a0cc5a04d1c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'afea7dee-48db-4733-8573-4efe2eb10e18'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'affab2ac-cb0c-4e17-87eb-46c931209efa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b002e6ca-1cc3-4594-af80-bedfea524fc8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b003bdeb-26e1-4112-a59f-e7fc25421953'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b004820b-0dcf-47a8-acb3-887278fba726'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'b00576f6-360a-442a-bc4d-e46b4ea0dedc'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Irradiated|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b00f3891-2e78-400b-aa59-2f70303e615b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b019ae86-e304-46fb-895d-7885e3b2b30b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b02908d3-456f-464e-844d-81888e3d4b31'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'b02caa73-2d39-4454-9361-a84870678431'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'b02cd116-38ee-4bc4-8721-f5eaa72c8a95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b0355af3-f0cd-4118-aafa-aa02c73bc1d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b0383547-54c3-4a22-a2f3-86c392a39221'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b0495922-3526-44e7-ac04-acd802d59b82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'b04a97f9-845b-4160-9096-fa9f3ce5a8c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b04b7d63-6074-4bfe-906a-77d6a546c6f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b04f7ab0-ca82-4bc0-8b2b-f286e79164f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b056c52f-205f-4822-bc65-1cd51dfb4c1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'b05793ce-5130-43e2-a7d0-48e8b1060473'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b06b3bd1-edaa-4757-89da-b6a3668334fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b07a7a0b-65c9-419a-a292-4e5b93d63c47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b07bbd81-a5c8-409c-a380-70be7659ca52'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b07edf47-b339-47e2-8dd9-f156fd20ad19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b08183a7-0881-4c31-943e-964054244a79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b084e424-492f-4dce-a901-d8aab637e552'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b08a1623-e66b-41be-aebf-7facb8410197'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b08c5a34-c12b-47f2-88bd-18c9cddbc6c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b09e6012-289b-4d71-87f2-bfec6393ace1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'b09ebdcb-2e3a-427e-9a3b-5c9f48c63ea7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'b0b03ee0-c1e3-4904-8650-29263236cfb3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'b0b18aa0-f321-46c7-a76d-4e847c4f8666'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'b0b8dc35-be11-4dee-8040-7fdfc580f035'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'b0bedad1-90f7-46a5-99d2-d871b238dcdd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b0c81383-ae83-432e-a026-f8ca5727fffa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'b0d77159-7672-405c-9d3d-de24dd073d0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b0da80e0-b6c4-44e9-b8cb-c230e551e1f0'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<=-18C|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b0ddf3e6-98d5-4559-9b64-e69ef3dd0a38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b0e3bbfc-e1d3-4aa3-bdc2-26fb66900e1b'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b0f0b2b1-fae8-47f8-acf9-2635286e4060'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b0f50092-f58f-4969-ac3d-79f221f46bb5'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b0f59cbe-ba1a-4d8c-8de4-ca1234f15bf3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b0f78e34-63f8-45ce-b2bf-d32b000ca641'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'b10810fe-7b43-4864-b6b2-cbf33cb1500c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'b10a47c7-a0e3-47a5-8790-71be97fe6c58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b10d982f-8784-4079-ad81-01841e9aee32'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b1156e58-3027-4809-baaf-41fcfd9fe79f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b1269a74-e949-4007-97ed-f4fa29806886'
UPDATE dbo.BloodProduct SET ProductName=N'Washed Thawed POOLED PLATELETS|NS/XX/20-24C|Open|ResLeu:<1log6|Buffy coat plts prep|From 5 donors', ProductShortName=N'PLT Pool Thaw Wash NS OPN LUKOPR BUFCT 5DNR', ProductTypeCode=N'E023', ProductAttributeForm=N'@72 B2 D5 G2 J5', OriginalProductTypeCode=N'E064', LastUpdateDate='20110509 11:08:37.280' WHERE BloodProductGuid=N'b12ff0bd-268d-4385-a240-1f8b1e72a181'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'b1309465-9c52-41d8-8633-392f8cd7bfd1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b13f2da8-9ef1-47c2-aaf1-b10de698b107'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b1420b61-6f19-4d0f-8eef-4e54cb97d38c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'b144f230-99a4-40a3-9995-e7b0a4123129'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b1462fb5-16bc-486f-a3d9-92159bc8968e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'b14e2e43-c9b1-4872-bdc2-8f658fec02b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'b15a68db-ba7a-4feb-bcd8-9cd29f86c76c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b1604c21-63b6-410b-a9f0-e5703a1ce18f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b1649f17-f670-4c3d-8f62-4579daae014c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b166cd8c-bc24-4b29-93f2-15321f744cd7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'b169efe4-2088-4028-bc48-96ae70b63169'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b16eafb7-dd00-44d9-a57e-4592bd14cb57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b16fae06-a2e1-4ad1-9e90-afebe05eaef9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'b17b0564-f824-47a4-aa72-4836b8a8c6f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b1833a84-b3c2-4193-86cc-005d47b3119f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b1843340-733a-4a65-bc57-dc814c055088'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'b18436a0-b67e-4cae-8476-e98f721715e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b18db563-04cc-4d00-a6fb-e7b001b4f85f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b190a1ce-2a07-48f8-9dcc-cf92bd8e8553'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'b19430d9-3085-4393-9e23-00b08a653166'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b1961ed7-d390-4c9d-8cf3-de3893872ebc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b19df7dc-6676-48a8-afa9-7ec67dedcbee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'b1a75124-936f-430e-a121-7008253e2dc5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'b1afb387-0b54-4e56-b91e-b30c6248c662'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'b1b94bd1-8db2-4650-b495-2d9bc41972f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'b1bbf2f1-a52f-4496-9541-6a80dccdbc66'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b1d2afed-9bd2-43d7-9398-1e92ad7d91a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b1d639ad-377e-48f5-b482-9a81e55c1d2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'b1d7fc85-1c15-4acb-be22-986a32f51f50'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'b1daaca7-949c-42b0-bd21-306358a14c83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b1dbff09-24c2-416b-9c6c-2e990516e295'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'b1df6ac6-f908-4582-8139-1360d2f10064'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b1f26a42-a8d3-4d6b-9a17-6c53291fafdc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'b1f6a5db-33f1-4189-bd4b-dad1c105285c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b1f9f326-0ad2-45ba-927f-ca33fd678d1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b1fa65e4-3aeb-4ce6-b66d-90151aedbadd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b200a0b5-ecf9-429e-bee4-3e683556a2c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b21de0d6-4422-40c9-8fc0-5e1d1f9228de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'b223da30-2879-4f1c-a73b-ac3ddc7a997d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b22dba62-3c78-494a-aba7-dfed5e3f3f35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b23185b7-b49c-4318-abe9-f556a4c18019'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'b238f4e3-8a34-45cc-975c-47fa598ad054'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b23c13d4-5f33-4638-8434-656f1effc953'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b256663e-617c-4481-ad20-cb03fa70fff3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'b258684b-4ff6-40a4-a277-d5d692b2388c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'b259a3ac-3dcb-45c3-a66b-de9ee6a83f50'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b2609bd1-c5f6-472f-9ed9-af20f89275d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'b2687f17-5bf4-402b-863d-3dafd650e4fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b26b5285-6dfe-4239-9b72-91b5940d8dd7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b26bb620-cbbf-4618-9212-64101499055c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'b277063f-ed0d-4ec2-9d55-dabbbbafdd93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b2809fa2-39f2-4349-b235-1f5cac1104b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b281420e-c0df-4ee6-9157-e776e093c073'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'b2853fbb-eb41-4c16-8df6-8aafa9361ff1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'b28734a6-ccc3-4aed-a5d3-b9a34cd8bb0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'b28839c5-93ae-47b8-a833-ccf9637d4afe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b291dbf6-17cc-4ebf-8679-346171be1a00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b2936ade-293b-4512-9bb5-0166b80bcc91'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'b2985c3a-1eca-436b-bbd5-59de21714645'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'b29d7a8d-4a1e-4fe9-ac3b-8b02f0703f48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b2b341b2-bbf7-42a7-942f-7a7d1734a6ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b2bfa7fa-7269-4319-beaf-5b6590249cf1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b2c2890a-bc58-4340-a811-878955c4e1e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b2c4b691-af23-4f08-94b3-c510b401663e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'b2c67266-2d78-4789-9f3e-14079ad76e19'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b2c8891d-0603-4310-a9d7-70de83441d6c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b2d83bed-0390-467a-9faa-0eab816dadfa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b2f5b023-c577-4d45-888c-8f40b68bc838'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'b2f72adb-56d1-442e-a9f5-424d1a6d7226'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'b2f81d57-e78c-4b54-be51-33968c969d50'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b2ff2d7e-fb86-41d4-aea6-5accc974adbe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b2ff40fc-b7e4-4cba-b3f5-9066e89b9304'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'b3064096-0253-457a-9819-301f72cdf8d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b314262b-abef-47d3-9e5d-1bfa103fa02b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b32cf506-a0a0-4799-9257-2cc1ed707390'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b3351a3d-a6b9-4331-857f-963e0f3ba2e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b3378bc0-4d29-4475-b76d-365f12fc8627'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b342097b-a12c-43c7-8bfa-e951991486bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'b347f9cb-5900-4d34-a16f-cad1b5e0e35a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'b34f1722-dc3f-4f0d-98ec-d66e9ce476db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'b35a144b-78ff-4273-a8fe-ff75d30d8d4a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b35aad53-6695-41cd-bdb2-77a3855b0d62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b35f4d04-95ad-4228-a1f7-37337cf6b80b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b360929c-0345-400d-938f-9e28d5ae2674'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'b3612d0e-8036-4b4c-99ea-af90e0c7b5ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b368b25b-7c7e-45fe-b6f3-a366f38a1c18'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b376d978-3059-4173-97a4-5753063d2496'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b37ce3c3-575a-449c-affb-4a88e1239b21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b3823c25-de16-4bb6-900a-2de48074fe3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'b385d7ab-6cf4-4879-9338-19f8af33ecaa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b3878283-a225-4d82-87a6-3d195aa5fcdc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b39235ad-9e32-4382-b959-c9c630d2f46d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b39c75a9-507a-4efe-82d4-a5eac5ff4dd7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b3a3868e-a796-43e7-930d-8da975dc68b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b3a48de9-d365-4a61-a6de-d6c5faf4b921'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b3a4cb98-8445-42b5-9761-e352167ad55d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b3afc3c6-305f-4eb9-8505-59e7f60234eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b3afe139-989f-4720-a837-92417b059170'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-25C|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b3b6cff8-bf3c-41f0-9dbd-a9b9ef75d484'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b3bc9249-10e5-4d9c-93a0-d240ea529b6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b3c0b141-c229-425f-9b1a-f3134f270b64'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b3ddbb16-0257-4d6d-a8f3-0b1fbaec3225'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'b3e82da0-3cd5-4426-8be1-7c4f47298be9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b3e99835-0794-4883-b6a4-3b398f950a38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'b4069f16-d8f8-4a38-882d-a3d710b19d47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b40ee16d-1534-4123-8685-2c9cd56a2029'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'b42264bc-d720-42e3-8881-8af29745720f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b424211e-4558-451c-b2df-b2b2f7d8bfa6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'b425c93b-776c-4acf-b369-91aa551dabfe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b425d99a-a84f-4f32-bf29-283c7d1dd541'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b428e9fc-448a-4b26-b781-6c5af159ee6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b43a6ea6-8334-4fb1-8151-61333325544a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'b43c7f5e-148e-4f61-8f04-28c5aafcaff4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'b440f923-9249-4643-9645-2eb30f7bb1e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'b4414b4c-9eab-4ac8-b667-aaf94b3fcea9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'b44ebf1a-d3a6-4791-bbe9-bced6a28233b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'b4500698-90ae-4e1e-97d1-1e252e5946a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'b46072c3-c9d0-4238-a765-4a458b6a8e21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b4634117-f9e5-4719-9ead-c85bcc515c3a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'b4663c01-a0ea-429f-8136-8223754c6d35'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Irradiated|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b470b179-07ac-479e-8b14-0e5b677f46b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b4795dba-a262-4fc7-b023-6f9c318332fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b48282a1-8c43-4072-847f-46c7cc145a9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b4844c4b-2186-4649-946f-908a99cf3a81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'b48638a8-920c-46be-a85a-fc81b877c30a'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b48a957a-0d06-4a64-816d-ccb862a92aa8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b48aa814-8004-4e52-9a47-fb3b1c6adf54'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b48fd89c-f402-4ab9-ab04-75ab5b02a345'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b492d256-897d-49ca-8aed-8d941d0d97e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b492d2b5-9826-4af5-ba7d-7e09c527c43b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b494c231-3aed-49bb-9587-36e56b61d3d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'b496dc82-c12f-4d0e-a8cd-5a450ffea0c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'b4981999-9dbe-49c4-9584-437407543915'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b4a0f8b3-ce1a-4625-b4e5-a1277678890c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'b4a75526-3bff-47d4-ada2-918b2fea299e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'b4b2b7fa-441b-4ea9-904b-ebfd7361b731'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'b4b6f94e-8183-4ea7-80ce-82b5074b4772'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E056' WHERE BloodProductGuid=N'b4bb3ed2-4876-4aa9-a4b0-c624bc63d274'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b4bf5cbe-3ab5-469c-8594-a6f09e54c8f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b4c8632f-8455-470b-9654-ba692a29f749'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b4ca1bcf-61ae-4ac1-aab0-b3750feee769'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b4caf7b1-98d6-49de-a53a-facac6c66218'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b4cf3e2c-c0f8-4631-9167-a9f044fa82e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'b4cfd635-cb2c-443c-b5be-a41cb2b4bcf4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b4d26920-73e3-4dfc-92f0-ec3362c5d5a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'b4d51ddd-5b59-4ac2-867a-2bf3062be7d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b4e3ae0a-aac4-4870-a60f-d06bc20d5fbe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b4e63a87-7842-4920-b4b4-408e1f7fac6e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'b4ef7591-19ef-4612-81d7-5c713dac79e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'b5028619-be05-4083-80f6-5b957a124c42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b506bdf6-142f-4eaf-803d-9b5386b38075'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b50cea2d-a6ef-4f80-bda6-0840f6447a25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b5148ba4-330c-450e-bdac-f71e43653665'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'b527a245-907f-47a3-a31c-e48cb7a3e6d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'b528c01f-d65b-4146-a347-e8b8e31d36d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b52c4ff3-81f7-4706-a3ce-ca5723745f76'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b53c8a9f-e3da-4567-a2d7-cd13a89eb0c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b53d63e2-b964-4b6a-973e-e97d0f4665b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b546c144-e3ed-410f-9ec0-228db5132adc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'b553e4b2-9e73-4c8e-a19b-40ba04f51bb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'b5634580-7c8c-4e7c-9d2d-b34d42173689'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b5673c4e-e051-4c03-ba90-0758e1b08279'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b5734517-475c-4516-9d8e-5c569af04fbb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'b58e9086-7968-4a86-b040-83b60829c933'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'b5ae9a72-2847-486b-9b5e-94f48e0af5a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'b5aec08b-1b13-4075-b47b-d9d8008783c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b5b73b3f-5ce5-405b-bd46-c18f00c1daf9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'b5ba11a0-7880-4782-9597-557101f3ed4c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b5bbfd24-4b33-46e4-b140-34c4e4e4d46e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b5c18e00-0ffa-4469-abe0-273a274a60b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b5d27aa5-8d72-44d8-b230-8743068bee5c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b5d2d566-269f-42dd-9d0a-815797e383bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b5ddecdd-5c91-47e4-b6b0-14346d3927ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b5f899d6-024c-435b-91f1-f63bcca93f18'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b609b2b9-580a-4c77-8a9b-52ff13140e00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b619330d-a128-425c-8711-555e5c0e10b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'b6207df4-5510-4f49-9a63-d71283d5bee6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b620aec8-91fc-421c-a77b-9cace8dc0695'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'b6331150-090b-465f-aeab-509e6fbb3af8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b636cd06-e1df-4d17-92a8-aa4fbf01ca10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'b642c96d-e652-46b7-a2a5-171835939b99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'b642feef-a26c-4ba0-b846-ca3314a8fc1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b65103db-9ef8-4aad-b884-c468cdd2cfcb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b6517583-e492-487c-a9fb-cab33b25161c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b6519942-6400-45df-8c8a-df1003e287d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b652e23e-7d8e-4947-9f2b-69b5a05b50fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'b653544d-4441-498a-9638-9237041b3359'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'b65634be-8d67-49b9-a455-efc04cc424a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b656dc06-4024-4330-a73b-cd95dd832a85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'b660842a-15fe-4107-91cc-f30fe8194139'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b6656b35-dc40-4053-96b0-0b6d2f04ff37'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b66f3e4d-81ac-49bd-8cf4-fff1923e821d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'b671d59e-6a72-4e62-b02a-ca00455b154d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b6735782-bfdc-493c-8a6f-af24dd4c3881'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b67461fc-f8cb-4f49-b890-1260e72795a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b6798449-31b6-435a-b03e-6dfd992655be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'b67a22db-f486-4ba0-9340-3322b90a58cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'b683d6fb-24b9-447c-8809-0c6489aa1380'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'b68a4dfe-4f0a-4c1b-82f5-bc1b9fba95e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'b68a9477-2e38-4314-a07c-f17a4b1cbf30'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'b6922311-d192-4573-a7f0-f8546b90f09a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b6988f3b-e28e-4aa6-b9ac-42d38615db79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b69ae40f-13dd-4611-8aa4-be0a6a2b5021'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'b69f408f-d21c-4fb0-bcc0-89b835a497da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b6a72faf-b4c8-49c8-b343-86f2aa1d6627'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b6a73940-78d1-4fa5-8ffa-e523c7e7a143'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b6a806da-4a51-4539-82ba-117ad90a0b4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b6c3558e-94d3-4694-9cf1-9d7d56f73a3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b6c5c2eb-4c58-4e10-bde4-c074a789765d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b6c7dcd8-8548-4b2b-916c-305be5741cb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'b6cfc7a9-0642-41db-aad4-c61340b15e19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b6d4afb6-ebab-4b7f-808c-24a2b1a8957d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b6dd8e34-3f9f-4e3b-b9b5-2782bb2f03aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b6e250d4-6c9c-4763-98e4-1161c2fd929c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b6e9c554-3f2d-4000-9552-c2bc1430185b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b6ee3dbe-dfdd-4e3c-9711-0f4d06a30997'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b6f00165-1c25-4338-a6e7-f080908196b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b7104bdf-c779-4574-b543-5ed3244507b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'b716e8cc-fcab-4ae4-92e3-c98e3e731f69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b716eb96-3000-46fa-9bac-359254eee3e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b7178921-4a58-477b-a1b1-b21dde9b9e9a'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b718f791-5c94-4743-b657-385e06a267d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b7212469-4233-4783-9e68-0c49897f5592'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b7236f8a-6c7d-4f17-a1a2-0a1d4ab63880'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b72efb2d-3011-4581-be13-d52219456ae9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'b7364106-dffd-45cc-8e1c-50dd77c354c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b739ccc4-55a3-4d5d-a056-7192ec13975c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b73aff3f-2750-4661-9df1-3207b230b8bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b744fd73-93ba-42c5-8c99-30dded18c1b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b754f7bb-20b1-462c-b07d-62d3d61ec7c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'b7558344-c2b5-408b-8dab-3cc5f6df1bd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'b764b0a4-7850-4fa0-9fe9-05b733d2354b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'b7704516-2a55-410f-8521-179e7b5ba6ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b7726a4c-fb89-4432-a3b2-976344552898'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'b779091f-a4d9-450e-a88a-e045ad97afa2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'b77ab35d-cf9e-4d99-85d7-bf478bc2ddfa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'b7910bd9-7cc0-4811-9e75-68972b330eba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b79317c6-7537-4270-8a49-a634d8e5585b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'b7ae0029-5a45-4377-9678-930d4328d65d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b7b05ff5-d242-4920-b9eb-54feb55b3092'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b7b1d470-f753-4036-a14f-5ac61c75079c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b7b3b319-70d3-4826-9855-6e8ff7de3a90'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b7b41ac3-1736-4bdb-ba06-6bc0b7de57a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b7b82f4b-2c42-4e06-8a6d-aedff3390c93'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'b7bf34f5-b50d-456f-8035-6fb4389e94c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b7bf6b1f-2695-4566-8507-33aadfed34c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'b7c263df-45f9-4336-bbda-a1bd17470733'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b7c9f1fa-b746-487c-a34b-1c63162b91cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b7cc7958-06a5-4a16-9416-da3599228e09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'b7e59b1b-c51b-4ed6-aed5-478596d6232c'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b7e67167-395e-4a24-94c3-2af5fa7dcf37'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'b7e84c31-92b6-4882-a749-c24b1057cbbb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b7e9f6ba-d745-47a2-bdb8-6c4a03a96f18'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b8094a0d-8990-4cfd-8b10-08d04e5408b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'b82a7fe4-ddaf-4bc4-a81e-587f25446b8f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'b83a5719-3376-43c6-b52a-e1ab494102cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b8410a4d-13ed-4871-a082-dd86771f8322'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b8449908-fd68-4876-b0ef-57fd864e8977'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b847d3f5-3f22-4b8e-8f25-f9ebd416f28b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b84d1341-79a0-42b0-b951-d4255fd58661'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'b8527198-f267-4b7a-b3b3-2037647e90c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'b85ed0ed-0942-4d93-b1ca-fc055d42853d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b86dd204-73fa-4a65-8da2-d3bb548fbe89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b87b0291-7939-469a-ac14-87bf7c858757'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b87ef841-6098-4834-8dc6-039337506dcf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b8861457-92ed-4f87-979b-57137882ce43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b8910215-bba0-41f1-b279-2808e9b6c9f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b8929f1a-ece8-4014-9440-f41992a44698'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b8a4ef4e-0fa4-4e34-b067-4d83f150cac1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'b8a7dd93-c929-4a0a-b008-9b1175bfab92'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b8ae4e5f-f0df-4d64-aabb-b06a31ca50e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b8b7b97b-9dd8-4661-a93c-dd85bb6ac32a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b8ccb9f1-b56b-4eb2-ba02-57df39efff8c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'b8ce8cb9-24db-4c21-8587-d7419900a38b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'b8d333f0-5ef9-41a9-a83a-8e848ae22e38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b8e04eff-4a9e-4fac-b6ab-f45fc89b7168'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b8e990a0-5dc8-491d-bd0a-9ae97d796ecf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b8f8a95f-a77a-47ff-ae7e-99be594be743'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b8fcff41-55f3-4f54-b8dc-3a205ef7a2b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b928b2e4-e51e-44c7-b4f0-543e3c29514d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b92afa3b-21b2-4e2c-aa15-9adf24eb381f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b92b44b8-7c75-46cd-9376-7407c43a9bd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b931cfa6-de42-46b9-9f37-89f78e0d2caa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b9380e93-7c88-4c53-a24d-5ad6735f63db'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'b940be40-0295-4e02-8064-ecbfb92c4088'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b94334d4-2847-40f1-8e13-09658199dc78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b94e8cc3-9dbc-424f-b024-0563d3c49e40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b94fce78-4412-47f7-8e1d-2f73d22f1bd7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b953c23d-5894-4622-b6de-48210fc986c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b963b50e-3d56-45a4-8dae-4d53d247ab23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'b96f0980-96dc-4a55-a531-ed758de2efd0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'b9702387-d7ba-4d0f-b0f2-ac5170828d0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'b972ef7f-14fa-4e45-81ef-7bf69b4f06a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b97ff4ec-565e-4ffe-805d-fe5e8902f783'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'b9816195-3860-4042-9856-1080df66694a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b9825717-ca09-4408-b9a8-045f0e4de9bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'b99094c7-f011-48cd-9926-918223abb418'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'b996552e-23cf-4968-8eda-b186c879fb26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b9975af1-9462-4260-9c4c-0507ab78c5f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'b9a72106-992c-4ff6-834e-4745960ed5b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'b9ade354-5fbf-4b32-9d89-a210f185beba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b9b57ac0-c689-43e4-b387-611faf884d15'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b9b914c2-cde9-4c7c-9ba5-e11fac948b44'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'b9b9cbef-79b1-4538-9993-abaab3fbd1bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'b9c7e7f1-3b16-483a-b7a9-e3b592f20855'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b9d549aa-f47f-4a1b-964a-dc323cd65651'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'b9d7f364-2b34-4af1-8323-4bf9053d9e17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'b9ddc610-c4bc-4b99-b09d-c558f7cbb53e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'b9dfcb17-ed4f-4e5d-8b03-a58c18759b76'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'b9e72d48-4957-48dd-867d-0c0b323d19d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'b9f160bf-fe03-47cc-bc37-e24c5f071ada'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b9f73a88-1c89-4176-9bdf-4128c8cce58e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'b9f90562-9707-4d75-8370-b3f2485243d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'b9fbf7fa-add4-4b37-9184-0771dcaf0be0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ba0a8c4d-c5cc-4284-81fb-59f95fed77de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ba0b299a-e838-4cfd-b63c-159607b4a0b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'ba0cdadb-ce0b-48db-a9f8-fc2c81b986db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ba11079a-5674-45ba-a079-664eac2b751c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ba11e29c-0776-4b98-b54b-07dc01431bcc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'ba1f85f5-3b2d-4bd1-b020-fc7fe53cbfc0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ba2b28bd-351c-446e-953a-24cc2daccd1f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ba314d06-39c9-48d1-887d-8008d8d5c70e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ba34d8b4-8f0c-445e-89eb-91feab6a8396'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:injectable|>=400mL<600mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ba37dc62-3dcd-4631-b28f-76fe6c0aea53'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'ba3d8877-63e1-4251-a8e2-806ba832d88f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ba465f2c-c434-4365-9a5c-75aa9ce5a15e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ba49f7ca-aea5-4f37-9bdb-c90e2200b318'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ba53ca22-c00c-4ec9-a00e-359e1244d8b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ba549f7f-b193-49d2-ba8c-cb6a9e2d7ea8'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Irradiated|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ba57ee8c-5e12-4ba9-a601-b518fde6aac0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'ba5b51e4-83ed-4969-98b4-2c458a28ccdf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'ba5fdbc0-dad1-46f0-827f-ee40d19ad88b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ba63468d-7aab-41bb-bac4-fce0678854a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ba64ffa1-4455-4dc2-a22b-79869d37ad39'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'ba71d261-a2e9-40b1-af6f-28620bb2530c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ba78aa26-b5a5-4e18-8e2c-a62d4096a6a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'ba7b909e-d350-4926-ab26-7b78a54f2654'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ba7dd334-d7f2-446e-ac3f-604a465bf710'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'ba97e403-7b57-4e18-8257-65e8a4d2cb6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'ba987be3-6db9-41cc-9afc-b00961a7b7e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'baa57c80-8ed1-40f9-a488-ab051f28ab0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'baa9572e-f137-46f6-8050-8276d87c20a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'baade18a-b638-409e-894c-fa1d6062fbd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bab3020b-c21f-44c8-9b7e-767b87e378d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bab5ef30-7241-4de5-b732-fa546f5be214'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bab8913f-abed-4576-8122-9b6418014499'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'bac421ab-5a5e-42b0-8cdb-360d2d32b96d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bac47307-3745-447f-b917-ddfe3c9de520'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'bac81905-64d6-451a-9d67-4b4be852ae16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'bac8429d-6877-43c1-9069-8113662f8d78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'bacad020-1408-47c8-9245-9b076d766837'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bacf6c7e-140c-4316-81e0-b6fa5300d4c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bad4893b-ab73-4824-be39-84b097420bd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bad49838-d4ed-4778-8879-3ba290039f8c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bae2e080-cc50-4248-adbe-ef71381c2549'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'bae5f152-4cdb-40c8-a50d-eb451e0b2e47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'baed4b47-6746-4342-8dca-eb4328469b08'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'baed917d-5f98-48bf-b2d1-61767d9fba83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'baf266c8-47e3-4d82-8b16-af7220f6f665'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'baf77ac5-06db-4cab-a329-ad1ecd803c06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'bb07671c-ba20-45af-812c-e765fc935b12'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'bb0e65c9-15ce-4bc7-a3e9-6ae3d20ea97b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'bb1569e3-8984-4a80-b0ae-c06a0c75773c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'bb18e268-cec3-4d06-b301-f799ccab833c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bb31ed3f-3bec-4c99-be69-b71d394f29ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'bb32e6f4-be25-42f4-b015-c3aa4d81a8b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'bb4cf0ea-a066-4d53-8fab-421acc4d2049'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bb4f717a-d9b8-45c0-97a7-a041fce98313'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'bb5384cd-de60-46e3-aca5-6547af293ce7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bb573e0b-f890-433f-bc83-60238b017ccd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bb596afb-1ba8-4015-b0f7-a28fa0f5560b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bb5a0e4d-01a8-4d15-95cd-511e0f5c795c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bb655f4d-8cd4-4350-9cca-975b0b4e2b3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bb6a6e80-c405-4a93-845a-be0165beb7b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'bb72a5e0-d8fd-4a0e-8e24-3a28b2f4b39c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'bb737d04-5831-41f8-a729-24bc695ce9d4'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'bb76c632-f7eb-4552-9b82-413100f08e85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'bb7b28b2-7c1d-43bb-a7f8-23144e291ddf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bb8bc438-0339-4070-b41a-d0e7b24e1d25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'bb8bfce3-9bef-4b2c-90e7-ea3fd0450220'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'bb92d448-406b-4ab4-97af-1603fd9994ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bb99a1dc-0d9c-4f4e-b4c0-90920674495a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bba86f43-08eb-40e7-8673-88cae29673b8'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:injectable|>=200mL<400mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'bba91000-ba4e-4208-8061-e9fafd3d2fe0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'bba9543c-334a-4fbe-a74c-fb2450374848'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bbaf3a97-b93a-436c-b28e-ed0467d60ce6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'bbb0b45f-9fe2-4faf-ace8-0cae62e4fede'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:injectable|>=400mL<600mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'bbb0ea95-b393-4a05-89af-791fb66ccde9'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Irradiated|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'bbb56cbd-09f2-4b08-a6bc-591a2a6509aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'bbd3c27a-a9dd-45a1-916f-495d645904d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bbd4dbe9-4ea0-4bcf-8fdb-94b7f2ea249c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'bbf5dd95-9e68-4e54-b95c-a7932984f335'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bbf9baae-0b74-41ca-92ca-f0d3453b8063'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'bbfa6e73-c436-4b97-b109-527c4dc3d0d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'bc0386e5-7370-42ff-8689-192ba45e1537'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'bc090980-4eb2-4006-9761-f3d48a8b3e0c'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|Irradiated|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'bc0c05db-de5b-49f9-9169-538d93bfcb40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'bc1218ea-38a8-4069-b292-fcb265827dc7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'bc16e993-af08-424d-abde-8e999ef47a7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bc18aea1-f9a2-41f7-9f1e-ef85abf2fc01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bc1f997f-2d84-48f5-ab89-29fa11de1d14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'bc2106ac-d6da-4f68-b88d-bc92460f8716'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bc24040d-fda7-4a2e-b404-dfe6dbdaeb09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bc300839-6852-44fa-b3c8-eb03b54ccfa2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bc31f924-d747-432a-8e70-5c4b064c0b5c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'bc324f73-bc5a-4661-b136-0c19b7ba53cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'bc36b1ee-eb0e-4e45-a38f-37dbef456c8c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'bc3d09ab-c682-4080-ac4e-b594e450b3b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bc483fea-56f5-44cb-b775-58acbcfa2ee2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'bc4e4600-5f57-4ca8-a41c-8b05e838d91b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'bc593599-bb9e-4e86-a2cd-6fc11b0c81ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bc5a7d84-3353-4bc7-822c-db72af7257a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'bc5ce8f2-2351-4de2-8e70-859e769d5dbd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'bc707dcb-98be-4bd5-84a6-e375681d87e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bc88ee08-451b-4c16-864f-1eebf567ccfa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bc977374-fffb-4024-a3c4-65f34faa0e31'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bc9e1fa9-2eaf-4a6a-afef-af380c969500'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Irradiated|>=200mL<400mL|Aphr not automated|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'bcac14f5-7883-430f-a047-a969d69f908c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bcc1ea1a-ed55-4b86-98b1-056be8fca64c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bcc2891b-59ba-4ba4-bf78-b0ac3348c379'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'bccf2864-7743-4181-b592-1ccf18bf6576'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<=-18C|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'bcd35da3-a961-473c-92b5-dcda4ddd5766'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'bce25264-74f1-48c1-899a-72308e507901'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'bce4a9c1-7957-43c6-b92b-7f4058ce5962'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'bced81ad-f4d3-48e4-9933-bf6c2823db3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'bcef76b1-613a-449d-ad18-01e0efd8b493'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bcf127f0-d844-49f2-a839-1790772fc57f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bcf42a26-f01f-489f-a43a-5e007696c4f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'bcf5b025-d2b7-49ee-a3ac-7d4612f3e92b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bcf618bb-3ce3-4078-8918-c2cd40e44be1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'bcf9e5ae-4e3b-4297-a411-6c8a18ee8672'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bcfe8cd1-0717-4ae2-8e4a-8bfaee1d05a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'bcfee2a8-d6fc-4af8-aae7-3b6aebb7d138'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'bd08a9e2-a083-4bdb-9c94-cd1fe9fb492c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'bd10a6f4-541f-4b8a-b8ed-f855008a760f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bd12229a-761e-4810-a07b-78fbc47bace0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bd13bfc7-5f5c-4d33-a6f7-7d95589de287'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'bd2130f9-fa8a-4315-9dc4-aea8772f8584'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'bd22de49-8255-4607-b5ad-7bc3f74bc15a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'bd28eeeb-0d5a-4bf7-9075-6d816b7238ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'bd28fb18-9824-4d17-a020-2cea534dcfd6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bd2c12f2-443a-44cb-b8ee-4aba07358151'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'bd38cf4c-6054-4b14-a74b-11b595c08cbd'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:injectable|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'bd3ecf9a-9455-4a7d-aa7f-6c6667ef943d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bd45accc-3410-4040-99ee-5246ad078a75'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bd5c63ba-ea0b-4bd6-b1d5-35f799fa85a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bd612e6a-a21d-43b0-9ee3-9d68cd374a0e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'bd6a5039-354f-4729-aeea-c3a1e1de4c6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'bd787d76-5ed5-4445-a32a-5da06720f799'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'bd7abfc5-b04f-4ab8-bbad-4507291efff0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bd8f80be-32b1-4934-a22a-3716b5e36c98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bd96de1e-c974-41e8-b3ef-78eed3beea79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'bdb3c0ec-6b3c-49dc-8ec5-b8b0c123afd9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'bdb67d46-c6d8-4962-9dd5-158b3cd02ac8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'bdb6bb76-3c46-444d-90a5-4198573990b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'bdbed804-11cc-405d-888e-52a7c875a5f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bdc4bd6a-5c38-44a6-9415-d4f47d4d45ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bdd1d697-d58a-4979-a58a-c776a1e6e0d0'
UPDATE dbo.BloodProduct SET ProductName=N'RED BLOOD CELLS|CPD/450mL/refg|Irradiated|ResLeu:<5log6|>0.7', OriginalProductTypeCode=N'E002', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'bddbe52a-8aaa-482b-abd8-400a2b5e670a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bddeb24e-a0c0-443a-9480-2db3785fd1f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'bde2fe6a-c432-41da-851f-21a400eec015'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'be025e8d-e75b-479d-bdc6-4d28ad82af59'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'be0e259b-07da-4653-872d-09a866128eb9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'be123839-27c0-4bce-9df0-bf8c4c23474a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'be26d807-bbfe-409f-ada2-4e8193703170'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'be2a7648-1c64-4e59-8a54-84eea1bb284c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'be2d2d71-f2cb-493d-8354-7755a775c384'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'be303a39-5a8d-44f5-b850-8b9451496615'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'be4a988e-f8e3-4f46-bc31-6224edee493e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'be4ac940-9102-46d9-939b-16e3966626a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'be6cb7d7-0bd0-41da-bc0c-6dba8e09baf0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'be6fffaf-3c97-41dd-92ff-31c390b50e73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'be72dc98-87f5-4ecd-b9f2-21e183d1a27f'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'be77b065-fd88-4ddb-900f-ddc25d72dd6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'be7df365-3431-4dc4-8e1c-8a85e104e7e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'be7eae1b-ad72-4dee-bdc6-5823bf4d3338'
UPDATE dbo.BloodProduct SET ProductName=N'Washed Thawed Apheresis PLATELETS|NS/XX/20-24C|Open|Irradiated|ResLeu:<1log6', ProductShortName=N'PLT AFR Thaw Wash NS OPN IRD LUKOPR', ProductAttributeForm=N'@72 B2 C2 D5', OriginalProductTypeCode=N'E065', LastUpdateDate='20110509 11:08:37.280' WHERE BloodProductGuid=N'be81a37b-b4b9-4c19-a428-500ee525140a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'be852f17-0020-4afc-a800-5c00c4a52d20'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'be8ae03a-b86f-4a27-b207-21993338db8c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'be8b5548-30e2-4ec6-b614-5a2ecaf3c7c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'be8e8961-e02d-4512-8d9a-5b12c11c7d74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'be922ae3-c2fe-427a-86bd-47b04ded5d27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'bea63b00-e248-431e-8742-534fca667eb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'bea89edd-0793-4441-bd02-96032626a77a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'beb5a2ac-e75e-41d1-9ca3-29488b14bf0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'beb9a33d-28a5-49b0-a7ee-ba23d5b20125'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'bebfa1b6-fd1e-49b7-b35b-9a25c3489212'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'bec50adb-cf53-4e32-a26f-b020a1e3aa66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'bec7abc7-62e1-4636-8d0a-043055b94e66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'bed09427-51ab-4748-b937-2607a3113f9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'bed18717-b5b6-4e65-aa9e-83824cbe2694'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bed4af8d-11b4-490b-9c29-f2071a35d76d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bed6b636-be7b-44d8-80e6-b903d2ea51a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'bedaca51-3674-4115-ab91-d39c32a5a964'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'bee88039-d14b-44f7-91a2-0c265fc2dcd1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bef07d2b-fe1e-4105-a153-8be5f28bd5db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bef2b158-0b8c-48ff-9a5c-59d7d0d0bb16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'bef5a795-c397-45aa-aa9e-e616b0db58ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bef5cd20-55e9-4309-b52a-d9473feeb713'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bef6ace1-8a46-4fcd-ba97-a0a9542f9d7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'bef97dd9-3149-48b2-9b69-661ca0d0ac2f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'befabd6a-f14e-449d-96dc-6b1450adabc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'befb59e8-c580-43d9-b0ff-6c3939964e3e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'befbda0e-164d-4f35-92d6-a689f4366ddb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'bf023cd6-4749-4683-bb76-7886d8a638f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bf06095d-65e7-4765-ba1a-b2713cb78a66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'bf0661e2-484e-4e1b-80f8-ed6b70423509'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'bf0a5ead-b5a7-4b94-bc68-05e33fe71356'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bf0e5c2a-862a-4a0b-8094-a463dcdd5660'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'bf1aa8ea-2649-4147-bf93-a66df2c7d1d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bf1d28dd-3e7a-4913-b6ed-d87902525f9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'bf218304-0985-446e-890e-50d1756fab5e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bf243df0-ca4f-4190-a742-baf39a6926c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'bf269664-4231-4dc0-81f1-9713d8c5ce9f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bf2936ac-fa0e-4d4b-ba57-1d67a573d9a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'bf2dcc54-f572-4f55-b3e5-be43b948ab74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bf2f4ba2-8702-4b90-a67c-b08259adc893'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'bf2fda79-de9d-4cc0-8554-731a238d4762'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'bf335844-25d0-4aee-83fe-d97142cbf23a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bf34afa4-a65e-4dc5-9320-08f560672781'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'bf3976fe-b4cc-4ca5-b4ce-5d292ea8209d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bf3b559e-7278-4153-ba84-497af0e0a529'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bf3baf3d-f1b4-4644-9663-08049fb28de2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'bf3f2d94-08fc-4583-b11e-43d71309cdc5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'bf3fc22b-3cca-4ae5-9deb-6c7ec9f84252'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bf5975c7-0ba6-428b-bb0d-236724d7243a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'bf5af1d8-eab1-40c5-a637-093e6ea83792'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'bf6fcac5-bb15-416c-b009-82cd1ba5f25a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'bf76e9dc-d30c-4fb1-b801-6e956d326788'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'bf775131-5f45-4431-b15d-3f78e133f1d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'bf7ccf8d-5afd-40e7-a987-a9c3336eeca6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bf815d3c-ef73-46b1-9fd6-95ecce978144'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'bf81ed95-290d-4213-a4ef-c7aa7af17b1c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bf84ecb2-79ba-44e6-b895-2b6f7c2e05eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bf8a641b-14b9-48c6-a4de-b416a3938885'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'bf962f05-b825-43cc-9f8e-f2360470aa28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'bfa9fa91-7405-4569-82b0-9b40796432ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bfaab3b9-27b7-48c5-8139-ff8f42d56b0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'bfabf68c-a0c5-4c08-844e-4580dda8d92f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'bfb11ad2-1c65-4c62-9736-87991ee81395'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'bfb2bf86-883d-4fa1-8f0d-ad1fddd5c645'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'bfbb7b50-8a31-45ab-9e5b-26281390123f'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<=-18C|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'bfc01f75-9bbd-4e7f-bbd8-bb46a51f3c2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'bfc53845-4693-4528-a584-c7ef7cdfbc69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bfcbcfc1-c4f8-4a6d-ac71-a25de3cc6be4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'bfcd7a98-38cd-4d4c-8126-0cce57d2c2b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bfd07c6e-9a47-4ba4-b0fd-c7f56b6a4208'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'bfd703f7-95ac-4f64-a074-3e7a5c4b9510'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'bfd7a58f-ece4-4717-bffa-79c8c41ebe58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bfe834db-94d8-41b3-bc32-413d1c2dfbf7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bfecf99a-5f8c-441d-9774-9d69415b9fe1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'bfed680a-3ecc-424d-b3a6-fa65c58238f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'bff24ec0-a965-434b-b548-460ed34176a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'bff6119c-5101-4521-b6e3-991ea587c579'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'bffad210-f917-43e9-bb44-cf66fb7484ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'bffb5eac-7ca1-4f87-b82f-cfb3b4f2dc65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c01d1b95-af58-4d84-819c-a1e436fe22bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'c03070a7-4023-47b5-bb32-67bbfaaadac9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'c040909b-80c3-434e-ad2f-74230519b84f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c040dec9-92ce-4dad-a7af-fb2b3f8c6052'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c0454595-7f60-4d4d-932f-9ad6770260f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c0464b9a-bd4d-40f3-bedc-e1b8441a53f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c0534e9e-3d96-4cfc-8a0d-df922ecfb08e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c0564749-6a6d-4e6c-9ffc-b08a4f32f26c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c05a2e85-3735-4afe-b28c-5116295e6858'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'c061be7a-be99-494a-afeb-3f0984c0ddd4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c065f8f0-098c-4d24-b19a-bb3f8b3031de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'c079e63a-7885-4aa9-bd21-cbc050688607'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c07a2d8e-4be6-4b57-a182-5105714c62be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c07f1484-81c5-4b0b-811a-c03fa455e663'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c07f7db5-38c0-4b9b-bb52-356eaa398dd5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c087ddfb-4ed2-44ae-8a23-f74891e3b11f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'c08fb7f1-c2e0-4f6c-a502-ea5260db4f15'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c0901b92-4417-4b1c-abd5-a69ee0168b4d'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Irradiated|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c095b482-33af-4a4b-8f82-95d1cfa51b7b'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-65C|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c0960a9a-d99a-4cec-ad63-c614061583f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c0972fad-94ce-47cf-b3cf-6296d2eede06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'c098b989-ccff-4044-8ccd-abb50d8014d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c09a7f8a-ca87-4194-9258-e04ec05cf77b'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<=-18C|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c09ba01f-7969-4409-9906-f718d498ed9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c0a2d0a7-0071-4671-b861-30f113c93c4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'c0a3a73f-3d63-4e54-9842-4ff7671d7ba7'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c0b3430f-6b5d-431e-bd5a-51cfd6d9d1f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c0bad035-68cf-4912-a667-eaa43f93219e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'c0c01d11-9d4a-48f9-b00e-5712ad98b967'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c0c24f67-9ef9-4b93-9fb5-b9006f9e51e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'c0c42d6d-0961-46eb-bb58-c9b18894f2fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c0c60da3-d00d-4e49-9a9b-150b19537be2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c0cfc91a-2fcf-4e9c-a57f-38a420794efd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c0d8cf37-d6a4-4e74-afb9-094534627abd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'c0e21577-c238-4c25-a06c-5cad85d81603'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'c0e89202-a1c0-41f8-8252-1a74c3dc48b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'c0ed1c55-4b01-4ae5-ab80-35d3b837c224'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'c0f8e8cc-fcf5-4811-b58f-d932f7a53892'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c1044242-565b-4910-8270-57421bf6e0d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c107d210-2a97-438c-b5b9-dc8a33a30787'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c1088776-c60b-4eb7-830d-dd93fdefbc81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c1164507-6de7-4b79-bab7-7e64c5472197'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c116ffbc-2503-469d-940c-72d13ad6569c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c11740a4-0be2-458a-aa1b-ada3125256db'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c120959c-7154-45a9-ac6d-35be798bb0e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'c1257b28-1600-4326-b7a7-c035f7c19e38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'c1259dce-b465-4fbc-bd17-9a8d89ae379b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c12909f2-f5a6-4327-b341-eac3baec91dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c12b66f1-fcd9-4594-9108-035d6871efb0'
UPDATE dbo.BloodProduct SET ProductName=N'Washed Thawed POOLED PLATELETS|NS/XX/20-24C|Irradiated|Buffy coat plts prep|From 5 donors', ProductShortName=N'PLT Pool Thaw Wash NS IRD BUFCT 5DNR', ProductTypeCode=N'E023', ProductAttributeForm=N'@72 C2 G2 J5', OriginalProductTypeCode=N'E064', LastUpdateDate='20110509 11:08:37.280' WHERE BloodProductGuid=N'c1302255-ebc8-46eb-8b2a-638ae32b944f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'c141e52a-8eeb-4f28-b5ac-8a71aa189fef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'c14a2008-1bbf-47df-9c3c-c16cb13fde03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c14a2250-45fd-4eee-9710-bb2b27a45aef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c15de35c-0958-4058-931a-0ec014c1faab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c16016ba-28dd-41f0-a711-455c5922b02b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c1603e97-7d4a-4dda-86b2-1e76f151b58f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c17f6252-7ad9-49d5-b2d1-7d8efd681822'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'c1842fbc-7350-4da7-a70e-8070be2803e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'c188e043-d87f-4fc8-a98f-0798fc2dddbe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'c18d9efb-8e55-4fd3-9662-2b10e355f5be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'c19a9b17-cf1e-48c0-b679-5df680bd0c13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c19c84c0-ab1c-4a5e-a8ad-2e54993546a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'c1a0ff76-67dd-4b82-b51e-31a65bb816a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'c1a2a4b4-c46b-4a8d-b68b-0ae4faa2f125'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'c1a7aa6e-9b89-49e5-9302-a20a5d822539'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'c1b017fe-9818-472a-95c7-86b6bfaa5f3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'c1baa698-6462-413f-b9a5-8883c8080d54'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'c1bb8eca-a9fa-4787-83a3-03ad2f4c933e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c1bcdc4f-ca68-401f-a3bd-10042ca9e41c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c1c2019c-1d61-4e6a-9770-16760bf77391'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c1c69f7a-2abb-4766-8e3e-4e13f049c384'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c1cefe64-2957-46c7-acf4-2eaf1bf9a37c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'c1d11744-9590-4cba-bccd-f64ed6bd5889'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c1da973f-8cd4-4a51-949c-bd7fbd676cd5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'c1de5f4f-7f4b-4440-9266-54aacd642ef0'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c1e09f6b-6d2f-41dc-a34b-125581015017'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c1e67998-9d0f-4f57-826c-e904ecde56b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'c1e8edc5-744e-4943-859e-5e93ea556d09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c1ea67fa-8e68-4274-8e12-2e54d6f90ac6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'c200fb1f-904c-45a9-8014-89e6111279e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c20b14a2-146c-44fc-b484-b93f03372e79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'c20da269-f1df-44e3-b04a-d5da63c23077'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c20dff55-c856-4eba-8b91-235afe700b51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'c20f4feb-9a04-494a-827f-c6f6e9793483'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'c2111852-cab6-400d-9723-fa3d455f9e85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c21e08ea-a99e-47ed-807e-e9c8b3389452'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c221fa07-3715-4bb6-bc8d-18d66dea7871'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c23108ea-5532-4957-a468-0ddab6040450'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'c2320e10-18ea-4d95-b954-12bcd5d1c93f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'c23f69a8-ed78-40d6-a505-bc7121a922b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c24828f7-42fa-41b3-b9c2-6907b1902d8a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'c24a0558-c022-4490-a3c9-90286f3b94e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'c24eb925-6647-4c20-a1b1-e5153d082c50'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c250ecb1-33ae-4258-b04c-a561efe90a51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c25e984e-5ee1-471c-be27-87e10b44351a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E046' WHERE BloodProductGuid=N'c260ef12-536e-489d-92e2-24d95117e78d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'c2692b42-a2af-442f-a42a-2ee326874415'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'c269342f-d00f-4860-b36f-05103caf24f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c276c0c4-ed69-4da4-ae36-1e41950bcac0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'c2770ea2-f4c0-4c37-86cd-eedf2d4fc10c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c27d12c8-ea3e-4cc0-8c92-38123e2aa5d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'c2807677-07e0-4a51-aa2e-dc81843a08a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c2813625-0097-4027-9ae1-069449f56e91'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'c2838b43-a9e3-42a2-9c7a-bf9d432cd81a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'c2925078-bb17-435d-81ba-f480bb3aea96'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED GRANULOCYTES|CPD/450mL/rt|Irradiated|From 7 donors', OriginalProductTypeCode=N'E036', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c295f8d3-57ae-42f9-92a7-6c972fe8735b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'c29d48a5-92c9-4558-bc4f-a095564688e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'c2c838a4-8a91-447c-9e07-eb1fecfd6f5c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'c2d34647-76c9-4ac2-8766-e5033760a321'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c2d5080d-c596-435b-96a2-79c560e5b30c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c2d625b7-0713-47bc-9430-cb438cf60925'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'c2dc29c2-1da3-444f-abdd-0c09b8a31e3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'c2e25594-8db2-4cf8-9b26-67e5792f9a35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'c2ebf0e6-1fec-4e27-96d3-26a1ca727efc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'c2f18122-3931-434e-8d3d-62585a791538'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'c2fe93c3-cea4-4dde-8b09-cbcef44feeb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c3013efd-5eeb-4718-a9d7-ba404c150778'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'c3069684-c2ef-46a1-89d4-de886e07fffa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c309b8eb-dfe3-4995-a9ca-cdb7d75ebb6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'c31298f5-047e-4d7c-826e-619336266529'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c314ace0-68d5-4df9-b227-d4c202578758'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c32d8fc4-c966-4d78-88f6-3d6d95766139'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'c32f7129-1c37-48c9-8220-348f13d08c94'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'c330cd23-0a70-4660-a709-e8ddb371e1ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c3362029-32c8-4076-84d0-dd63c9244aef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'c35ab501-d605-43a8-b79f-a13d55c729d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'c361a1ec-5b77-43d4-80b4-b150ddab3b54'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c36492a3-87dd-4918-a635-4601482f27c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c3761b1c-1817-4721-9240-81d69a550aa0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c37d5970-2259-467a-bb4d-3394c9cc9e7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c38c3c56-00f5-432b-b46a-7d820fb0e2b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c3940b8d-a4a4-4ffa-a199-edaf67aed681'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c394cb8e-f4c8-40a5-8ace-f965c71cd4e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c3a419bb-24f9-4628-8811-c8737472159f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c3a86b64-5b76-497f-8834-a2f3077627ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c3c495cf-39ad-46d7-a9de-4bf33d8ac657'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'c3e84b0a-f23d-4041-8d90-8dabe6fdc3b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c3f25eb0-59dc-42c8-b47b-a7665f7aaaa6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'c3f7cf41-c038-480e-969c-6828eeef3873'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'c3fcd359-8684-4519-93e4-09d875c841b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'c403b836-a23f-4f5d-999c-5da3165c3925'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c408cbbe-dbff-4c4e-85b5-d3281727726a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c4134bf9-d782-4ef0-8b72-0bb51507bff5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'c41e24de-2f98-4552-b09f-f47efc68d29c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c4218885-ee82-4b77-9ecb-9368572ab565'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'c425dd42-3ceb-4755-82fc-6f0c7c5ad48c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c426cbb9-1e61-4492-8cab-2b34c7a54cfa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'c42c7004-bf08-4e73-b682-636734387dab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'c4363759-6ce5-4a94-bd83-c77763d63ed9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c438a489-ac2a-4ef2-908f-c930b5385c35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'c4410a0f-373b-4c77-b1d1-beb3c3f5d4f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'c4456b82-4b85-421a-b8b8-eb332f0e3aa9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'c451a162-4bb7-4165-ae64-a034d1f9dd36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c45662a7-b59d-48ef-8905-33bc68bad6c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c456d412-cf41-415c-8862-097ac61285a2'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|Not for tx or mnf|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c457e0c0-7e0e-4240-a392-e389eb671ae1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c45873c6-534b-4d60-a56f-b1cf6e6be061'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'c45ab7fc-d868-45c9-82a7-250a049e998e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c45f8990-5e01-45ae-b0dc-5c5e373e4988'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c4610247-7ca6-442b-8904-f512371adae1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c4636c57-2b60-4fa3-803e-66476e76eac2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c46aab5d-613d-400a-8663-4804ca878476'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c46c2732-9961-407a-977b-c00fb55a2d5f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c46d112a-02fd-4636-8499-1bea42e99f0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c479f766-8d18-4ccb-97da-609f6fa263f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'c47c7cc2-6c6b-4366-860c-9ac0b297e208'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'c47f502a-279d-4cb4-affd-6813b81bde40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'c492f894-e86b-4f95-a1fa-a097934567ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E047' WHERE BloodProductGuid=N'c496f5c9-ebdb-40d0-96bb-f40ab1f0a076'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c4ac6354-e893-4a71-a508-ac1057976e72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c4b6de48-d975-4aa9-b0e2-74e26bee8c92'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c4c54914-8f5e-4991-a36b-b104a53e5201'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'c4cad229-a188-4744-9b65-6fb96cc4718b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c4dd7803-70fd-4d7a-bbdb-597630ec7e9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c4e01215-48e3-4867-8fcd-3e931e482e9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c4e1a309-b2d3-44b7-bdd9-000dfd4cd380'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c4f8e6ce-3db7-4af5-927c-d5cc016c4580'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c4fa00a4-a5e7-48f9-ba48-f6384ebbed23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c4fd7d24-915a-4c1b-bc6c-8c500589b7fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c5053122-bb91-4dfa-b724-9321556f174e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'c50a7d7a-bec4-4ea8-bb78-8f84066abe14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'c50fb81a-79b0-4db9-813b-af4aee1e5027'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'c5161c74-4cf0-4ebc-b31d-dce45c74264f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'c5171735-baae-4be9-80aa-a1f23a6e3f88'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c51a4221-9166-43bd-8e82-88c967b3d79b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c52288a6-4ab6-4d57-b4c2-2c3eb45b1df6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c526f842-db9e-4037-8330-ecf8e99faefd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'c52c5d94-7fa2-4c61-8685-7f0f5c03fda1'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c52e2717-0a4a-4b68-959b-8bbfa9be3fb4'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Open|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c535dd3d-e014-4d5f-ae42-1ec6195c305f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c5419a9c-5559-4959-9864-0ff92120202c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c542f915-7062-4663-8eb7-d500e70e3ace'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c558376d-aad7-4b7d-8ff9-e82cfc2f1c96'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'c55f398a-9e54-41c9-a433-137818d31a9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c55f71b8-68e8-4c72-adb8-e2497cdd2a9f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c5625a07-c3b1-4c6f-aeea-f0b1a6846fe3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c56c296b-b5c6-4c3f-8208-cfc0aff7b20c'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c56d00ab-c593-4f09-89f0-c5085f79bcb2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'c57f3f9a-7521-41e1-a55c-9607f5f0584b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'c5923ab0-5f35-4e81-b7c8-ce6f73bd9e11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c599261f-bacc-4afd-8f4b-ee271c21923b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'c5a5a96d-10d1-4b58-8040-e06772404c25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c5aa4300-9550-4538-85b9-d1fe5b0bbaf1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'c5ad6675-aea7-4286-a487-626f0a01c8a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c5b7620a-0d88-4843-8547-e9cff5f860a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'c5ba5382-9919-47d6-bc8d-1008f070c0e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'c5bde682-f16b-47dd-9f82-6c24d262388c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'c5c14fe4-cb37-4454-9ccb-92b7c4a10fd0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c5c30adb-fadd-42d1-baee-73a263bc6414'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c5ce0513-f12b-4bb3-9c17-78ed9803b186'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c5d7d0b1-768a-4332-b93a-e9d9c51a18c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c5ecc4aa-5e7a-4d96-8abc-c5f4e088b8cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'c5fad44b-e67c-443f-b3ed-43a3859555cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c5fd004c-2d9e-45ca-8ca6-59666387e766'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'c603c5f3-2150-4429-a57e-5f56d5d5bc85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'c61db89a-a9fb-410e-8d0a-2022ccd2771a'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c61f7624-af4c-472e-93d7-8bfe5d441297'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c6205d28-7881-43e4-a382-67f95e5252ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c629ef39-590f-4354-9c6e-ca28f990cfa6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'c6329973-71ae-493b-a772-aa326c8aa1fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'c640a302-339f-46a2-9b4e-ec734baa2e43'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Irradiated|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c644117a-2922-4e76-b021-bda4a5f30aa7'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c644c0f1-335f-4bc7-bb84-e1369c98c100'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c644e8c1-6c4f-407e-b902-c2b49fdbf405'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c6469d4c-1bb5-42b2-86ef-4959cb7b3055'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'c64db419-7208-4c08-bdaf-b744509cf5c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'c655e87c-bb95-4b53-a1a1-a15dc5154727'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c65c872f-12a6-4376-9b75-6bccf6bbdaed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c6674c80-47d6-41cb-a651-4036be0cafdc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c6848424-8c13-408c-bbe4-9f63cbf0eb3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c6913964-b676-4ee5-8373-b37365198a20'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'c69d7cb8-387d-49a8-bd6a-a2f08f358e56'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|Irradiated|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c69f42fb-c296-42a7-b404-0740519711f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'c6a1e396-fba3-493c-86ad-2b9629e58c7e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'c6b04034-83bb-441d-9f43-45d159cad760'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c6b83f5f-48da-4167-a3e7-0e743b7a4f3e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'c6d728c8-06f3-498c-8b57-6b727806be43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'c6dac27c-3774-4d90-b9a6-b6ba7a95b4f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'c6dd8349-e99e-4f0c-82fa-d6dc29985fbf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c70b616c-d668-4017-b448-7c152560a747'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c70f8942-bbae-4f0b-8236-4821f6a4997f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'c7103c2f-122e-4572-aa6a-ccd3d19c82f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c71f6908-1031-4ed9-9119-2effd0a305f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'c723b4b8-4ced-4bc2-a94b-3ead9558836c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c759d21a-6b0e-495b-818f-0a2066f6c068'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'c77666d8-978d-4c62-9841-b9755e3ba7ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c7854522-480c-4f17-aa3d-c0bf8821dee5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'c7917373-f099-4930-809c-c218bcf84a17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'c794893f-0af6-47e1-914a-33335a18cc38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c794f0f8-ca62-4bf4-986d-de9d2cab0adf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c79566a9-33c8-4862-9a1c-ea585a9ec3bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c79ecd7d-d158-4753-801c-9d519288c33d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c7a036eb-d599-4ce5-bbef-c453db0b462e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'c7a04ac4-7a43-45a2-bea7-afe2d06a7d25'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'c7ac4d31-4004-4197-9d4d-6784dde0c55b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c7b032c7-4cd8-4560-9aeb-2596abc1cb9b'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-65C|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c7bda07d-b8a3-4b85-9fb8-877e65300cba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'c7c10099-ddcd-495a-af29-ab82d3d720c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c7c3a567-db85-4950-821f-08956431b604'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c7c6b068-a1d4-412d-a653-73eb49e41835'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'c7d478ff-88e4-4d4c-823e-691100f19785'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c7d56e3d-3665-47c5-882d-92b9150101a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'c7d7eccb-72f8-481f-a600-c0d1f7ee7837'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'c7e6246d-fef7-4855-ad28-1aa11c1dea5e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c7f9fa32-185d-40d7-b108-84fa4d22f195'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c8011fd5-225c-4328-8c62-ae891ad9679e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'c8113f72-4d93-404f-a056-ea95721e1651'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'c8159167-fda1-4d4f-a100-a75042cba413'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'c81987c7-4563-4dd8-8f40-9d3c5f8a4125'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c8247654-c8d0-4885-9140-78a417e6a514'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c828fa0e-7991-44b0-84c8-4f17745989a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'c82a1d4f-2dd9-458f-a285-c82b33b9a255'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c82dfc50-8cb5-4a95-a5a8-babb9f36c7f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'c833980c-65c1-4164-a481-eeee9745612e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'c83afacd-64ca-4a3b-aeea-592cb9be1458'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c83e0fe6-4e66-4ef8-af24-faf3082797c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'c8484ee6-e0ce-4a38-b7b8-c151715ad17a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'c861113a-4bea-4766-8758-3fe0ffe37eea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c8638eee-12bb-47f6-a6f1-a8d09f8dc914'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'c8813860-7748-4394-848d-d918272a9c55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'c88b1c62-eed5-480d-8a40-f7dd1f16ce0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c8908930-2201-4c43-a64c-c99c32cc0524'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'c8950a31-bc6e-437b-a35b-a562847824b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c897d35b-37d1-40b0-b24f-2cc5a561e007'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c8a296ac-43a2-4726-ba5f-45c0ee0a2b01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'c8a5fea1-01cc-4d26-badc-3b7e1eb1c930'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'c8aa935a-dd57-4bed-bc95-917c08730244'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'c8b54df7-3018-40e4-bbd4-10318c4a977d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c8b96355-46f6-44bf-b643-5530bdbc8fbd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c8c07f8b-f0ba-48ea-8114-435f6cc8198c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c8c3a640-f8b8-4194-a253-e7d8f42d5334'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c8c9f308-1d53-4f1b-b17a-148c5877d9d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c8d6c90f-7d91-4995-9f34-cbbcc570967b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'c8d706cb-51c8-41ef-9188-cf0b189da510'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:injectable|>=200mL<400mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c8dbb9e3-542f-4e88-8bc7-7d6370f98bb3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c8e75aed-f9c1-4ae4-9303-9c77f68b7e53'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'c8f56cbf-26dc-488c-8811-c7e1775eb53a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'c8fbe457-831e-4958-851f-9bdd77de610f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c8fd2a08-166a-4e9c-881e-b0045b9c148c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c90e5701-836d-4a49-9c11-eb76b45b0f2f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c9116d3b-470f-43fb-a989-10840c7b3e7e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c920cc2a-c939-4f77-ad69-97a6e37cfe13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c925edd5-bbeb-4356-b491-7547e85e75b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'c929141a-154b-4dc2-9e6f-9538ed7b070b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'c92a078c-5ec1-4abd-ba53-947de93c0c42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c92e59b7-f0b1-485e-b90c-e954ba098e6a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'c9302e77-e2ff-4030-af28-7ac62a9d98db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c93778c7-182e-403b-a7d9-1c87f2ac731d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'c9408d94-5e6d-433f-9083-0b455d29dcf6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c95f0f58-63eb-472b-ac70-b1814fa32053'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'c963c069-5bae-408d-93ed-e3dc4feda5af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'c96fc002-1e65-4473-bc66-2aac5b5a6b31'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'c9731ca1-3b37-43a2-9004-0e189b2aa9e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'c979c251-0885-4408-8cba-0cc087dc3fc8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'c97ce3b8-fbcf-4029-80e9-69a9b3dd3386'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'c98829ed-965c-43e9-ab4b-8d3bb5cdfc10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c989be85-92f8-4e3e-b36f-93fa902807a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c99597e1-408f-4095-8671-fb85e5de16c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'c9a28fd7-6bce-4e29-91d8-3b4965fb9ffb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c9a74e0a-2dc8-4d51-a4a4-59ae429bf110'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c9a9aedd-12cd-496f-9c1f-6db3be6b4998'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'c9afe37d-d60f-41f2-a252-cdf8cb2f5651'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'c9bc1aff-a356-46c7-b283-f0cb28c63147'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'c9be32a1-8fe7-48f8-a11d-59ef72cb106b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c9c10833-e2b9-4253-8d29-6aa3c9b9c958'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'c9c8dd60-6d53-441e-a2cf-66d4c3b0bf9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'c9e1f9a4-c4ab-4bbd-b08b-c8ee2475b50e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'c9e6f522-f753-4f30-a0ca-d97c4cc46088'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'c9eb0bfd-fc44-4b48-9e00-e74c743a9fd7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'c9eb54dd-8782-4f55-9d6c-2e9c92e6184d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'c9eeee1c-add2-4ce5-80a6-6ffb1962f30f'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'c9f25694-9e44-4beb-8c91-53aa45606ac7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ca063853-bafd-4b55-9df0-d32f1b7fb71c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ca06eb64-5f4c-4549-853b-0d5463790842'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ca1ad963-2eca-4767-97a2-5ca9a4986b06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'ca211458-ed8f-4c39-a526-9e0997fffa12'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'ca21d05c-2c3a-476f-ae4d-b57abc5f6f75'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ca259a4c-b8e1-4fdb-aedb-26e14e53c693'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ca2cb37c-969c-44f9-b45f-fb54d4a39535'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'ca2ef2fc-c8f2-4ecc-993a-e374745b7561'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ca3dcd5e-424e-4d94-a765-c889528122fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ca41163c-26b1-438e-a974-d693556a8240'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ca4652fa-5748-4c55-b21c-47d5ed85b52c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ca4c6bb8-58b4-43a5-8309-990367483a05'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'ca50f8ed-ee4a-4928-b7d1-a0539199c5a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ca520500-62d6-4271-958a-d62bb6cf82aa'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ca53e8fd-ddfb-4139-86f0-c14fcbf0f5ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ca593f51-e189-4e25-a3f1-8212d209a26b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ca5c0f64-8551-45f1-bfc6-c53ad3ca1d74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ca5f9497-84a7-4bc8-84e3-fddae7774b89'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ca6368b7-abbb-4515-a5ec-e590ab4f266f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ca663fe2-925b-41e4-ac38-bd7af45aaf35'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Irradiated|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ca6a9425-4a25-4f19-9d65-529dc9ffc92c'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Irradiated|Buffy coat plts prep|Approx 240 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ca6fa683-55bd-4415-8b62-04607205973a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ca778ce5-ebbc-4203-8290-7ce5fa5731ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ca780d74-a69d-4d90-b439-894f894f80d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'ca78ae75-bc83-465c-a6d4-3ed45d798c7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ca796be0-75ab-45c5-b8aa-f17755505c2b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ca7b2d2a-eefe-44a4-8fdb-1c66312b4557'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ca7e127a-cdb2-493a-b4e3-53064f1c5f00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ca83d3dc-13ea-4e4e-8757-a0e3c4867a7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ca844eef-fec8-4512-8c60-ada28012b1b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ca84a53d-9b34-4ceb-bc80-387ce875f729'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ca85a220-50c3-41a4-bbb2-4ecadf2fb160'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ca893d44-283e-430d-b329-3de7421ef43e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ca936df5-a9ab-4a3a-b089-cb221f6a4672'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'cab3ee57-501b-4ba2-9309-b587988843c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'cab545c1-c678-4c53-8787-140a53cd8258'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cabbbf88-db97-42db-8feb-b8638d6e3bc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'cabbea73-0ee9-413a-9200-2953d21c9b94'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cacc9ebc-b650-4a19-8e63-a1df82aed7eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'caccbb7f-0e7d-40ca-bf96-38258404e69d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cad5f9e7-865b-456d-bcfa-fc11b527ca57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'cad6c316-9d6b-4fc8-ab13-862e8cacf951'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'cad80b39-2728-40ae-93e3-5152f7b95509'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'cadbaec3-7848-4265-914b-2ab35e229a22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'cadd9151-a70a-4b85-8208-a8fba349a6a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cadfef5e-7e21-4c7b-86b2-d35558f9627b'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|>=200mL<400mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'cae6da5f-99a7-4823-8d5f-b21d52e32f4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'cae6f0f3-bd36-41ec-8a0f-0f49d7ce5a65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'caf8c12e-7dde-495b-8c03-8cbb88dbe67f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'caf921e1-19ef-4b48-ba60-b0ed58efa925'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cafd3cee-bdb1-4a38-90ae-77eb5af6aaa5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'cb0bde4f-bd48-4e0a-b502-125e932e4daf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'cb16d7d6-c15e-4c47-b99f-754b7fbe10fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'cb18a0f4-9f79-40bd-9ed2-aa767adcf3ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cb19221e-8408-4922-aa0e-0a7d15dafeb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'cb27205e-34f8-44d4-bee5-ed7a8cf89c7e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'cb42e861-2d7a-4d1e-8ab2-9b525dce1d42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cb48e972-41dd-45e2-b7cf-933ee24834c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'cb4f840f-e12a-437b-b507-3c63e86a1638'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cb56b7a7-c664-4491-b368-fa1217a7291e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cb653835-8cee-447b-bb50-8a8bfbbe32ec'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'cb69acd3-dcad-4c66-bdf9-1d6e3b9904be'
UPDATE dbo.BloodProduct SET ProductName=N'FRESH FROZEN PLASMA|CPDA-1/450mL/<=-18C', OriginalProductTypeCode=N'E010', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'cb6e0bdd-d77e-4e74-b7da-f19e5b139444'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'cb72c9de-a488-4351-bd6b-efe1e2cb6f20'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cb7482f6-05a5-4d8a-867e-2ec6f8e7ba66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'cb762690-cfd4-4aba-8a8e-03d889ac7394'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cb79c708-3c1c-49d1-b6fa-b423a9f0a1dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cb7bc3d5-c9ed-4d2b-9d64-e775025aabb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cb7ca925-5e77-49e2-a709-eaf3ae659159'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'cb80211e-e808-4e4e-b54f-be5ae0a23924'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cb81d7f1-7207-47fc-b943-51dbf75ebd21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'cb87be2a-1ef6-4ff3-a830-7fa6fda6b025'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cb884e9c-a434-4913-b62e-e2bba6810e9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cb8984af-8a70-4c48-9865-655dac8e712c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cb91ae1a-cdff-4517-af26-3510e2f5a6a5'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|>=400mL<600mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'cb9256cf-267f-405a-8769-a9c55300d696'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'cb976418-7086-48e2-8bd3-2eeded6da71e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|Irradiated|>=400mL<600mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'cb9b99ea-9be4-4b47-b90f-47ce874f7006'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'cba0e28c-fbe3-4140-b5a1-580a9a5c33bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'cba83359-df82-4f15-8882-e680f7ce17d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'cbb1f262-d57d-4478-af51-d450574739f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cbb2b9e6-0ed8-45e5-9aa3-178f42d25f36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'cbbb8b00-ea6b-4f52-a462-b97a5d258fbb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'cbc53053-9c3f-4424-9ac7-c763ca98c619'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cbca5fde-fe2c-4be1-8bc6-59d7b2a82ef6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cbccb67e-8ed0-4c13-bfdb-1f5dd8395134'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'cbce87ba-9b5f-4c7f-86cf-56e5bb8d22c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'cbd27016-2fb9-463f-a52d-5b4b0a6a141e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cbd33164-7dfb-4270-aefc-d2b051649712'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cbe2727a-adac-424d-affd-ed5688ccbf34'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cbe5fb6d-b7c6-44bc-a887-f9f50c3d2e14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cbe799cc-0d21-481d-b53f-d89ced9c88d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'cbe9f5d5-a8d3-4546-b488-4c37890ea842'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cbf1046e-759d-4a67-80d8-2b8cc51f72f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'cc034344-9c18-44b1-9a5d-3eeb823db998'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'cc04d855-0533-43e8-9aa0-50290a21dbc3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'cc06144f-2af6-42cd-9e42-e19596c5d719'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cc088de1-526f-446a-be5f-8028b40241ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'cc0ed791-5767-4f2e-b6e7-398b0ccf20e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cc1255b0-9c7f-4da8-8485-13af07635f44'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'cc1bbe7e-6e5e-4575-8e80-691de88b5d5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'cc1c2eff-9db8-4cfb-bf96-1d7bef087f52'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'cc204cad-a8ce-452f-ae7d-44be5a6bf308'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'cc250336-8202-40ba-83ab-e1b5afc77309'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cc39bdfd-2c6a-4a19-8432-61bb1886a674'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'cc3f0c5e-92e2-45ea-b4a7-d59a7746a2dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cc5b3e79-1fd2-4218-ae2b-8fab97048f7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cc66e25e-cddd-446b-9ad0-48ee6ebc9274'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'cc66f8e5-a4ef-4259-a9f6-7df41a236424'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cc68a689-b79c-4c3e-809e-a4c834781355'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cc6a7a6c-973f-428a-9f45-c0fc292ee19f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cc6c8a93-4fba-406d-ace8-3339e9137cb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'cc6cd527-d9e8-4d43-b8b3-d85dd6a286d5'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Not for tx or mnf|Open|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'cc747738-9bbc-40fa-ba5b-ab4de172ad04'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'cc7f6ff7-8503-4d15-9748-474cc2ea7917'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cc88cccf-c1dd-4b2d-a172-a28a770414bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cc8b6554-f05e-406b-a831-82f95b06efb9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'cc939073-82ac-4bb8-a2fc-0dc74562c5c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'cc97afc9-39ca-449f-a283-0da363e6dfde'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'cc9ee733-8480-41eb-b49d-70370b9df3ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'cca0ea3e-46b1-4f58-b3cb-33a846d8bec4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cca3fad7-54fc-47a9-91cc-6974a7502285'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cca6e8ee-583d-4802-9802-8999e84b9ec3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'ccbc0ffd-4fa2-44b3-8a62-765f1bc385b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'ccbc1598-1b3f-43f1-98ec-db2af9c41bdc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'cccbdce7-0578-4a07-882c-9c7d9852c204'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ccd07366-90d9-4bff-bb6c-55aa159d1359'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ccd56fc8-0c86-4b3c-be2b-60b489c823fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ccdb854e-2bc5-4339-8ba4-8fd9d4a93dda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ccdbc5e4-bc4c-423f-9be3-182591d7bfe7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'cce0edc2-f557-4a2a-a3e4-5844d6f9218e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cce4b601-7ed7-4e99-af96-994b093bf582'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ccebc678-d38d-4406-bb47-4ff1f75800b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'ccf99f72-1fc5-4e60-9df7-c1462519d565'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'ccfb5c4f-4b99-4f66-852d-7c4138afbb20'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ccfbb195-853c-4867-8acb-6dfb5e1dd499'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'cd1078b9-13d6-4639-b809-6f50beb7f1b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cd11b9c4-7795-4ea0-8335-9ec73f61ab92'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'cd1374d6-31e7-4dbc-9e39-571fe1902ddf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cd186bd3-d434-4108-9655-6d9f92c70011'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'cd204ff8-9908-44f0-8128-f8edfff8a15f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'cd2249ac-8b7e-46e2-97ff-56f6a649c0a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cd2a38ef-7e96-4011-a098-2bd1c8ea2f92'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<-65C|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'cd3164b6-1dae-4a71-9071-b512ea5f23f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'cd345817-3568-4e7c-873e-5a86c9bbd9c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cd354118-f845-46c3-9a57-ebc2dd0567c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'cd35f475-946e-47e2-89c6-336c31f725be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'cd456fbf-eca3-48c8-a885-d782c39235fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cd4df15c-30d2-4b19-bfe3-41d17de93ce0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cd57b7a8-3a40-4226-b2bb-189308bc9215'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'cd5ac32b-f668-4918-887c-52efc72d18e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'cd62a120-913e-4704-8626-f2edd8213bc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cd640bae-db4d-4d72-9fe4-c002ac6719d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'cd6df627-a8b8-40b1-83b1-2e8bc9f6bf52'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'cd70712c-74cd-4861-baf9-4ca24baed26d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'cd71a9e0-e26b-43be-b720-c1dc2250927c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cd7612d6-fb44-4503-bb53-46eea59249a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'cd7c3769-c213-46db-92c5-5ab4c09a0389'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'cd914317-567e-4318-99bb-3c6a155ea502'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'cd919ed6-28c7-4f41-9185-ad52b5da10d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'cd9e4f68-ee32-4c60-a8bd-54f1d884ff0e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cd9ff45e-7a06-4379-b00c-c9a5771073c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'cda1ed3a-2340-49ac-9ba0-ffe1e54c7a73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'cda57cc7-dc5d-4e22-a866-2803dea0acb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'cda7b464-ee27-40a7-bacc-cf26dae40578'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'cdac81da-cd77-4e13-8c47-4c03ab1a12ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cdbb653a-d17b-4208-b968-a8b9aa5fdbc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'cdc700fa-1b72-4031-a0db-55a8f585bdb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cdd7261b-4965-4812-a338-11009b07f3c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'cddb33ea-812f-4f26-911f-bdea4cdca30c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cddd2a67-98fd-4789-b24a-6fc93647b2a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cddd7598-ca58-43f3-8c25-11ab0c691624'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'cdee7fc1-4dcb-48cf-92ff-3d9126374111'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cdf0271b-45fd-4243-9e1b-d344217c30e4'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ce02cd11-6bbe-4271-89c1-fb008acad45d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ce077d8f-848f-472e-87e7-b81ce8d8ce36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ce07f066-b5ad-4d26-b858-10a19d3b1a42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'ce0df3de-66ee-4014-9833-b8e48730a6a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ce1cc5a2-b3fd-47d3-a9b8-c35827bdb2fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ce1f8198-fc21-486e-a3e2-f7f4e9aad9c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ce2b8ffb-7f13-4d87-939f-0ce9b54ee5ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ce2c9418-a1fb-4143-92d3-4bab4e3dc053'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ce2d908f-ae37-4484-9d46-869c5ebbc4a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ce394799-291e-4c8f-9ccc-f95b6fc71c15'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'ce3b170e-f83f-4602-849b-7d16d78c4e22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ce4be0a7-7e10-4d84-91fb-768a2b098121'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ce4f25a6-e77a-4755-87e7-0bf2ba0b2b1f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ce50e957-1410-4deb-8f25-cea66a2695ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'ce543a03-082c-4c6d-a520-f94cd92bc48b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ce55b6c7-d994-4ce9-927f-a91fcdc89e65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ce5a28f4-b658-4828-a2b5-9ea0db3f2121'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ce5b930a-7f58-440d-a06b-01c2c71e4831'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|Not for tx or mnf|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ce69e0f5-6ab5-4722-ad2c-2ec5ca45c14f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'ce6b20ab-0b84-4579-8a1f-896469f22388'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ce6e79fb-84e7-438b-bda6-cb8bb9f5e5fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'ce75e0b5-cd9c-4ca5-832a-605f336f6e0c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'ce76256a-be0e-4660-8efb-258c5e4e979b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'ce86806d-87de-422b-a073-f8a84817e7f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ce88d8cd-fa6d-488e-bc50-8a99e94692c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ce8a45fc-4349-4c6f-b09b-f5c85b4c1cbb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'ce8f3c15-3761-44d7-a4eb-8ec22aafefb1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ce909619-088f-4ab4-a426-751dc01d6c70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ce9352e2-5f56-4239-a2a9-ff11445cd8c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ce95d202-9d84-40cb-8b19-73001ff855d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ce9c7b0c-7d17-4f71-8540-9064715c3ea1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cea4f3b9-3625-4ffb-9fb9-2a9ff2d0273e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ceb231db-d921-48be-8347-80f2e5b48eba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'ceb6ab67-baa4-4bcc-9c34-3e45e9ebe59b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cebd8c49-d484-4a04-9212-efa2db066be2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cec52cc0-04a0-4a80-aecd-586b2a3e0339'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cecff4cc-370a-4009-96ed-e95d409281d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'cee3dac6-2b4e-4fb5-84d8-e0bde940d047'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cee6b276-4473-4016-b138-741c69da881c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cf12d814-ce94-43d6-97fb-cd5919a568ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cf1dc61f-9a1d-4a1e-8ad3-18662b26f939'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'cf25a787-1e0b-4371-9012-ee6bf6348e12'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'cf2df929-621d-4cd6-90a1-8c875534515a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'cf3bd62c-06ec-4d9a-9cc6-647424e7f45b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cf480dc4-f6ef-4d67-928c-6cef5a9e7ef9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'cf4a6589-b8ab-44a0-9018-18224d746080'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'cf4b84cd-d0a8-40cc-9a9c-1feefeebc8ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'cf5477a7-6fad-4b32-a859-ab9b3e8102a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'cf5c593b-64cb-40a0-864a-3061d2ec6325'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'cf6bff26-e660-4258-84ef-e0c3cac5141e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cf6ff905-0ec6-4e8e-bead-674638b9cebd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'cf7adbb0-99c6-4588-9f63-ceaac4daebf6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cf804e9c-df7b-4861-9203-5a08777509db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cf871ac8-152c-4f8f-9c67-d49846068931'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cf9ba0cb-7766-4f78-aa33-9b48d0a9a7f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cf9e0cb3-c2b4-4149-851f-3dbb35ad1dbe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'cfa90187-a44b-4bee-b8b3-cf0e2e41c153'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'cfacf611-2af2-47a3-9cd1-ce4728bdb327'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'cfb16d87-3cc2-417c-87bb-3474ac792e5e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLATELETS|DMSO/XX/20-24C|Open|Irradiated|ResLeu:<1log6', OriginalProductTypeCode=N'E026', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'cfb20853-5493-4062-9de1-c1e54a3f64e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'cfbd6309-1fe1-4837-be3c-897d253c39b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'cfc0d582-a277-4e1c-a4ae-d46bd95cf5b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cfc2922b-9975-4ab8-8f03-9da04bb08b44'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'cfd4cd2a-2e75-4c76-99cf-a636549f8a0e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'cfddfd2e-d14e-4846-98a8-a856f133c35b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'cfdee4f0-0c7f-461c-8c41-8fa52d6c251e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'cfea00c2-94cf-4361-a850-380aedfb1449'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Irradiated|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'cfeb4953-c1f5-4241-9db4-e2843f13b0da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'cffba452-e80b-4671-ac70-605b4340fe5c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'cffc1e40-9642-4443-89cc-e06b9e924fa0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'd00056d3-3428-43f3-a5c4-2229571242f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd0039aec-a22b-4a11-83d6-04d31caa03fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd005eb3f-3836-4628-b1c2-7d20e3329501'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd008631d-d980-4307-84d6-bf0a975c9aa3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd00b695f-5a84-4c54-adc8-eb692a87aa5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd00cfd5f-a642-45b5-b05b-5fbbb1e664d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd00f3522-bc86-497a-8dd5-0f2f41e2840f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd01f263c-9b3f-40e8-97a5-4094f47a5a9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd02249b9-316b-4d24-98eb-559367927989'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd03d46cb-94c3-4b13-b432-3d1bb9025530'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd03d5eca-33f9-4144-8102-b841f689b4e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd0441a6d-3d05-42d5-b77c-3cc7fdc9eb8a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd04bdc1d-ec34-48fb-be89-edd249af6efe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'd04c08ce-22eb-4f49-8773-d2b07bb2c76e'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd04c5d63-1489-4e6f-ba85-1d025625c5a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'd0603d7c-b205-4ad5-b947-884605b082cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd065541b-5800-4746-8d39-5132411833ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'd06bd8a8-15c6-4195-8d6c-7946fd9deaea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd07a4696-e43f-49c2-8ba3-a7e269fbd153'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'd07aa64c-e1a5-42ee-9288-4ebe06a250af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd0866eb2-7051-4102-aad7-df6c461b5bf5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd088c387-167f-4dcf-9a40-e6278c4fee8d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd0899f56-044b-4f52-a889-d4a1645a32e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'd08c4510-66de-4ec2-959f-288b2b1515f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd092e18c-b289-439d-bf14-874bf60d0efb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd09a741c-9f6b-43d4-895c-be0f7a813181'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd09cd63d-e7a0-40f0-930e-07e76c5fb09c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd0a050b5-4e20-4632-bc24-285c8c34655f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'd0a1de87-a2ad-4da3-81e2-1d61dee9e231'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd0a3e4e2-c9e1-4fde-9894-4b38d6125215'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd0b2f8b7-d080-4e3d-8127-560dbbc21bc2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd0bf5288-be1c-4e04-abff-8a7eda12c7b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd0c17c9a-8dfa-429b-82fa-69dd38b1558d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'd0cc1783-ed8c-45e1-bfd5-8b51261216c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd0cf4f28-9706-4873-82a6-2bfea625b179'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd0d11abe-dae2-416f-9d95-9c866221b984'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-30C|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd0e6308c-8d8f-41ea-98e9-facd18517605'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd0f9b442-cf31-4aeb-8eb8-e403ae53c5dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd0fdfca6-fe42-42ef-b16c-852704245304'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd106d315-f91a-4bbc-a36b-3e9d24c22715'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'd10ca37e-8d6e-4171-938b-44139c2ffbb4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd10dd248-309c-43bd-b33e-6ad9bc389cd7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd10e7886-9f22-4083-b32c-db06ed6711be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'd11f1be3-ef66-43dd-9f23-dbd9b97e3c08'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd11f2b63-2ebd-4b96-8bce-26cdbccfd924'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'd1235e8c-6ecd-48ae-ad79-d7052fee3fd6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd124f170-fd96-49aa-a91a-155f599577af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd12586a4-43b0-4c96-9252-9c824b40a42f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd1353044-df22-458a-8037-acfa9bb77fef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd1379c92-4a00-4f1c-9b58-69fdb8ad7a2d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd137e3dc-2858-475c-bd87-58e04887a7ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd138cdd0-b184-4abf-99f5-9b000f439c3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'd14eb95b-2c23-4997-a571-a37097bdce67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd14f9851-5805-4978-bb92-ed57835f3e85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'd1567338-21e7-4bab-b86b-9dc82670915b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd161b0e9-b5ce-4588-b410-e16616c18024'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'd16fcb88-ad7b-4d6c-881b-21f356814ae7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd1723e73-1dfa-4b35-a11a-8ef516a9754b'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<-65C|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd175366f-9775-477b-ba70-dcf7d1a84922'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd17f2dce-cb99-4ae9-a588-227b589b5ba3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd1864320-514f-4ea9-a013-e9eb13fbea9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'd1886ac8-3239-45fd-bc7b-73442b26e716'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd18db491-2e8a-4578-b108-463e693cd0d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'd18f432d-983e-4314-9ecb-62b6f5344e13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd19d1fd1-f813-4c6b-8b75-b28265337d70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd19dee85-b8b5-44cc-879e-268ad74f3433'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd1a1b2c5-5b4c-4a8b-a70b-f2181f2ab050'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd1a4d6c0-7c22-4187-ba2b-337227a0ddd4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd1a5f3ad-29a1-4479-bec1-26a06e9bad23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd1b68519-7b8d-4944-b2e6-ab778c0714f0'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd1b7c9dc-5632-4aa6-a2b3-51dbad08f6f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'd1c94431-ba52-4538-9e7d-0dbad5f27ec7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd1ca4ce8-cabb-4c79-94cd-bc6ce268f835'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd1e89fe1-3ad5-47c5-8843-f3f580a2b565'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd1ea31b4-a998-41f4-88bc-41324e838c36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'd1edf988-8d00-48fd-ba49-8e3885a38506'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd1f1de75-7f53-4037-96c1-b882bf1dd380'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd1f4d7a8-d672-435e-b2c1-8836d847e0c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd1f67e64-0d40-4574-95a4-d130998dcd95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd1f83bd9-914e-4845-a6af-3b80aecc7c68'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd1fa5bce-1755-477d-9668-6d17cbc44db0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'd1ff0df5-792a-4d95-91b2-4d172a1ca827'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd20fed82-b718-481b-a7c7-fd9f912c77fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd2171462-e5d0-4ae0-b6b0-0f33cd7a8e59'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd221a7dc-c62c-44c1-9a02-cee40a05c3ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd23203fd-b671-4cba-9462-0d4af5378749'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd234b7f8-c5b8-42d2-8b1d-7607977f5789'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd2400313-5da6-400c-8d50-c618a15ff442'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|Irradiated|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd25d3d54-f03a-4d7d-b98f-832144895755'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd2670dd0-f79f-4789-9006-0b7709800319'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd269bcae-bade-41db-b051-695f227e90fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'd26b9fd2-7daa-4bd7-b767-ba2e30553bc5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd2840ba8-9b78-4c98-adab-198f01790d4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'd2857236-94b4-4663-9e14-ab61d61ed794'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd28b1c61-3c53-4eb8-a7b5-6aab9c21d5d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd2ab03e9-9382-46e4-95e2-4bc7fff6de1c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd2ac8a5d-d618-44fb-b0a7-a19e9ea2fd09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'd2c4f232-092f-437a-91a8-ca75a1dccdab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd2c54586-21d2-496e-bc48-22198b5ceb79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd2c9e08f-7d6c-4a8b-a4d5-b581123e386f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd2cc1423-04bf-4a77-bdd6-8deb748957ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd2cc42ba-8c4f-4706-85fc-841b1453381b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd2cfea7f-3cf2-41bb-85fe-67e4fe388337'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'd2e24f66-9843-4dc4-ac3e-4c68490be7ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'd2e6f707-0d20-4414-a0d4-e06e57bb44b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'd2e99117-4663-4152-b52e-8fe39f68677c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd2efc87e-0329-4387-a6b6-4bea0c0a8d37'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd2fb7ee3-4e5a-4053-9405-afd9433d3771'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd3008f2d-60d1-4818-9f46-96e3a22c00e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd30558af-3380-4bde-8251-60ba3fc958e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd306d78f-1475-4e07-9093-354ecbb6d77b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd31474cc-ce9b-4dde-bdf3-a957f1186fed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd3149fec-81f3-4d4c-8932-e84761192613'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd3195c69-7902-4e38-9339-4b36c997d6b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd31c7872-9c27-406c-bb91-0fd1db861255'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd3209577-9082-4047-8f65-9ecd4493389b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'd322576e-e6ba-4ffa-b54d-9023f8ad0d4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd32e6da9-16b3-4802-a5f8-2cff20c0af20'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'd33d0a00-7265-4751-b82c-dd16c1015a9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'd3403675-750f-48f1-a36f-cb3fe5a8c9f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'd34f3913-f7e4-488c-9593-c6e15f81458f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd350cfd1-cac6-43c1-86df-270eddc1f59c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd3665e80-be74-4f97-ab71-1d4dc169abe3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd36dcf5d-aff6-4bfd-8c66-a6d3e4b7378e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd371af48-b024-4ab8-b707-3e983e44100e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd374b578-40e0-4266-a80b-8209843b6a7c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd375364f-f198-49d0-82aa-8db779cfb81c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd377a97a-a8c3-4c35-bb29-994273258945'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd378ec43-9820-46a7-80f7-ace3515502aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd38252e5-32eb-4b28-9e71-7020d1079d41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd38a0e08-3dcc-4754-85e3-44a5b16ec011'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd38a4dd1-893d-4cb3-949e-91cbba944845'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd39ef13c-7739-4aee-84f6-04824bd7d5ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'd3a301b0-47c4-4091-91b8-a62a2a266d00'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<=-18C|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd3a76b31-7960-46c1-a6ac-f83904585e68'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd3aa16ba-7bf2-4f86-ad79-f31ec56abc02'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd3b990b6-8de0-4367-ac08-bcd8568f90fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd3ba843a-6d76-4735-85aa-3bae8b2f2907'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'd3c3311f-fb52-4990-81dc-cac2ab22f97b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd3c939b7-75f1-4cd0-ba4d-e9e24880b08d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd3cbd05a-3dbc-46aa-8f6b-58ed374f44c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'd3d6710d-eaac-4e4a-b3b9-359a02721b6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd3d809fc-9904-4ca7-a863-019b2892ec9f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'd3e15e14-e918-4e2a-aa45-74dd9ccb3d26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd3e77f6c-a2fb-4514-96ac-3c540bf187b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd3eaa796-8e59-4308-979d-74045d814725'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd3f4ce6f-0702-4cdf-8801-12bbe37a00c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd3f5b6b0-41a5-4bd7-b22c-919157506d1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'd3f92eef-2e7f-44d9-9bc2-9d18e0d9de0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd3fdaec2-7a8f-42d4-b25c-b7dc3a849e86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd3fe2198-c8c5-4e16-ac93-d79849213e11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'd3fe8eb0-7df7-4b85-8fc6-549941c631c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd4091cbe-4e21-436c-9cd1-8773623058e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd40d87e9-1be9-42e2-afce-5ae39956ce3b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'd41b01f3-f214-4583-a717-2ffd6264bd71'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd424daa5-a3f2-44fb-92eb-ca28a5c7f267'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<-65C|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd42eeb5c-429b-47af-bc4a-49184db1ec0c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'd439c0f8-0693-4b3b-9d41-e1ddde8b50b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd44048d5-a561-436e-917f-dcaf1b925bb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'd44320d8-b56a-410f-9bf8-3942ddb4e0f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E046' WHERE BloodProductGuid=N'd444290b-bf32-4d93-a9a5-33383e31be4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd44491e5-ee83-4120-8d63-ca36c5cbd1de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd455558e-1472-415e-bc36-cbd09a474421'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd4575c01-4943-4633-b835-9b05f5cc64af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'd45afd09-ab44-4a0a-a4a8-b27f6affae8e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd45b10c0-3aab-4849-b1c1-9e5e52019390'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd45fdc53-a0bb-474f-bcca-afcf23e40867'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd460b64b-48c9-485d-9b53-d4eb8ed2d8ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'd461bed0-70cb-417b-875b-646c6f57c56a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd46783fd-3e08-43dc-a348-5a9ff4fcfad7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'd46af1a3-67cb-4d6f-8ef7-61cd7eaaec97'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd4704289-b537-4983-8c33-a482fb281aa9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'd47550e2-2bfc-4150-971b-04f2ad64e8da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd4770e87-c046-4d2a-8555-8bf54d1cce32'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'd4875426-88a4-4ff1-b855-12b478d9334a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd4911cea-7b3a-48e3-ba30-92fb922ae067'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd4a3ebfe-218c-49ff-b163-d0980afa9f4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'd4a4e557-0bbb-489b-a981-3e84e5d3cb94'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'd4ac99a9-7f3a-4847-a831-4348306e9ebd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'd4b5659f-b0c1-4345-b74d-a51a447d9b42'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd4b639e8-3637-45af-8f65-c0d882f95d76'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd4bfa622-ad7f-4e1e-bccf-bac7cef22f72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd4c2b25b-7316-46d9-b96c-88a215281371'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd4c77626-98c8-499d-8e1e-886a24246c61'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd4d0e1de-5807-4f13-9541-0854f43f3dab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd4dad94c-003e-431d-9408-47f6d8d552d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'd4de56d5-e9b1-4e11-9460-431b31431a0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd4dfe030-d4d5-4682-857b-a689328071e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd4e8fcb4-b7af-4db4-87e7-1ee598a17d6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'd4ef594f-f6e1-4b5c-81d7-b53837954a85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'd4f61908-a7e7-4749-a4b7-3f9e462d9a83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd4f703d8-3169-4f76-89fe-4fb3d6e10a5c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd4f71d31-a292-4c41-afc6-55745719e83c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd4fcf3cc-36f3-4915-b1ab-bb49bfd9929b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'd4fe6d98-7958-4d23-a2d7-a97432b3d3d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'd5091f43-78ab-4d2b-a3cc-0e20e6e28f1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd50a9b62-197c-4e5c-80b1-f1a728fb98b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd50e2c47-26f5-40fa-a497-b8db0a86d70d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd51b58ad-62ac-4cf0-876f-d8ab209c9f16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'd51bfa2f-5313-488e-ad15-902feeca2a9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd51d3b01-d860-4d85-8439-0a626e789d95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd51ebc70-ed1f-47d9-94d8-b2ead86701de'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|ResLeu:<1log6|Plasma reduced|Buffy coat plts prep|Approx 120 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd5240773-bb02-4f57-a48d-2c91c150844c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd52cb57c-4946-4864-a68b-4c71a5535721'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd5311abc-5c31-43cf-901e-c747ca5db5ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd53887a5-ba12-49db-adf8-b7981b5bea06'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd542eb2f-2d7d-48a8-9d33-8f0a1aed53cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd54f2638-c29d-4b65-a2b9-8cf9202449e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd552aae7-279c-41ff-a335-9d745cba2393'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd55414cf-9879-442b-90d0-609416a6a695'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd5570cbc-09d5-4213-9eeb-cf5a8620c8e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'd55f2f64-c91b-4f28-8550-ff3ab015d778'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd56c18c1-e3bf-4435-ac29-8ee8bdb13a87'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd5732e31-fcc7-4d36-8f46-bbebdcbb923c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'd580f216-55b0-439d-a282-c4093c7a4c4a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd582faa2-4527-48a9-858a-c9fbb4cfeb78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'd58432c9-0cd4-4879-a9b7-c50ccb91817d'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd58b12f2-3ff7-41b4-9dfb-8d74d5bd4f0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'd5aab6ac-e491-45f6-9a81-21832c1e6816'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd5abc95f-a03e-4e6d-810b-934be5b5b5ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'd5b1deb2-0573-48e0-ad7f-6c9fd24daed5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd5b77853-2c05-4d98-9480-0f2e9a961f6f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'd5b7fc37-4147-47e2-81f3-65ad642a3203'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'd5ba9c1c-e5e5-4cd3-b24b-8b82c2ef211b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd5ccb6eb-43ac-47b0-850e-91ef2f165f1f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd5cf0f0f-a8d5-42d1-9479-2a55e8160d42'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Buffy coat plts prep|Approx 180 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd5cfc547-94bb-4778-b2ef-33f64a4402c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd5d6d730-7087-475a-a68f-03fffe868c56'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|Irradiated|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd5ed8188-86f9-4a8d-bfd8-ff816b14ac9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd5f1aa2a-9205-4b5c-a5ac-62862d55fe60'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd600068a-a1b7-4719-8b14-0bc483f299b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd6110fcb-5719-4055-931b-2de062c8274b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd612334b-a3b2-4e27-8184-755780d4e666'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd613e45d-aa4b-4c37-9591-031e8d89c299'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'd61ea9ac-db51-41f7-9916-689a36444721'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd6202da7-a29f-4cd0-8be1-830b19e5441c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd62e38e0-83be-4bef-bafb-5f33c64debca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd631f52d-6361-4042-88b5-de4b956a1479'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd6385a56-83cb-4f78-8bda-440413b6207d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd64560a2-2592-4f17-965a-edd1513f8bea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'd64902a8-623d-45c6-96e5-cfc459a1de85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd64d56f0-c9a5-4ad7-bf04-f0aba4b595ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'd6551bbb-d0c2-4e70-a64b-e29faa13bce2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd6576bdf-8de9-45a7-8db0-aedbcee370e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd660bc27-9db7-4ed8-bfda-622994354019'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'd6671e37-6323-4c79-97d0-1e64ba8ebbec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'd678fe70-04d8-48c3-8469-a41fabf7f3f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd67baf71-2b0f-4ba9-9cf8-a3a4176ed139'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd67be5c8-106d-4d73-9b47-29e1ad82be3d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E053' WHERE BloodProductGuid=N'd68c9b28-54a1-459d-b991-37b87a107b80'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd68ceb7c-e048-4d1b-99a5-1ac54f134161'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'd68ddc0a-a325-41a8-8891-9623789fae85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'd694276a-c16f-4784-a76a-0cbb34d2a646'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd69b90ff-c0c2-4798-8665-0a3246231c4f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'd69cfd6c-ed62-463a-a55e-dd68fb2b23dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'd6ac756a-60ad-4a5f-8d46-a5d15633c84e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd6c35aec-85c7-4aac-be30-15fb4a6906e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd6c76dec-db8c-49e0-baa6-32b8af502d0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'd6db16df-a04d-423c-b96d-d9fd41e186c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd6dc3dbf-8230-437c-944b-f09f93a06c7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd6f0d621-29aa-4d5c-bce5-aa13a67bbbc1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'd6f4feaf-2267-4d0f-808c-7c9ad4a59551'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd6f5c50f-e3d5-4e36-af19-b71331beea24'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd70465ac-3e52-46f0-b56a-fad7dcd38593'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'd70ae5a3-bbbd-4b5f-8875-571198f10357'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd70c2e8e-cd10-4fd6-99fb-c96c1e761fba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'd71c1b09-f54a-44c6-957c-eb018b130a16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd71d60e4-6596-4b06-921a-6bcdc5d1e3c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd7228a57-bffc-4021-91da-d59f0843272f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd72c3a3f-3c54-4c54-aa91-cec30a9e5474'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Not for tx or mnf|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd73b2d28-7aab-4f18-b7d4-86fb06a891b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd7425d13-b480-4e67-9f2b-96c196a46fdd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd75041a8-ae2f-4355-991e-7d55efd8229a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd758ce49-e018-4e45-8391-ee836044f8dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'd75a5553-6ec9-4f67-88dc-0611fcfbf479'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'd75ff5c5-0fab-48c2-b007-1334409234b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd76369c5-f666-4d83-b120-7897f9a97c49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd7692d54-0dea-403e-979f-f4e9a6afbe15'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'd76fb06c-15f8-419d-9a73-24577bae4a34'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd77c07a1-2e98-4030-b5d7-1e3604a7e810'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd7839b1d-4b4d-4004-9498-1eccf8d80eec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd7845c76-3341-40e0-8fc2-7430c3f0cc29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E042' WHERE BloodProductGuid=N'd7858ec8-2e73-4d8b-ad50-38e0e51327a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd791614d-91ec-45eb-838e-e32a69fa26c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'd795ed1d-2140-4b43-9e55-af258fde295b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd797beca-ed4f-45fb-b8bc-d55828936ac2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E042' WHERE BloodProductGuid=N'd79c67da-61a0-4fe6-ac18-af09c9abf443'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'd79f0a91-807c-4711-8d03-3c77694b6008'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd7bc9fb4-77c9-4b06-8640-c66440afa4e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'd7c10129-61e9-4167-acaa-25521ad07361'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'd7c23d53-c943-40d6-ba06-79ea315680a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd7cfb5dc-b64f-44b8-88c4-d560f54a7935'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd7d4ff37-6c70-4d3a-a30f-1c0de3ec20e0'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|ResLeu:<1log6|Buffy coat plts prep|Approx 240 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd7dc133c-3cc3-447d-b47f-c94fce904b84'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd7deb65d-8234-4fef-8747-cde55f124f2f'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate = '20110510 07:59:27.820' WHERE BloodProductGuid=N'd7e4343d-19f3-421c-be7e-68c29013be8e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd7eb1d3d-e268-4d0b-9693-a173c2fc1bcc'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd80110c2-1cb9-4b17-9f2e-0b1a317e6a82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd8056fec-09b2-42d6-a234-5223ed68ef44'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd809296b-87d1-4e77-896d-6b02f3562b18'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd80a2f0c-afbb-4f6a-8a05-e97f34d4f254'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd812ceb0-89e5-473c-87e5-5f891f85db85'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd813c57a-b823-4e1f-9d06-d66ec6f797dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd8147fbc-ad7d-4209-8b23-0db038317a38'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|Irradiated|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd834acea-59ae-407a-85ae-a70d225255d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd83ed327-df79-4150-af45-7e4cfab729cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd842d277-9ab2-49fd-ac02-732277ce2e63'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd844039c-4d59-49c7-9ebe-d6710dd5d281'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'd84654e9-edca-4938-a8b2-7e4a3836efc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd8466f14-a8cc-4d64-9dc3-b21aa3ec8ede'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd8481200-657c-4f97-9b08-ad756967ba4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd849d272-5231-4915-aa20-58c2542e5ac7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'd85133da-1c0d-45e3-9f3a-3335baa613fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd8526722-d318-4db6-bc0e-f9db21402fdd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'd861379c-4e10-47bb-a28d-0f6fbe3a64a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'd86cc1bd-8329-439f-acfc-377fba20c57a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd8749f79-ab4b-4a3c-a654-f10250cca3bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd87b7f7b-979e-4c39-a070-1334a94aea59'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd8853fdf-4195-401c-8dba-14ff7ec7dfed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd8869f80-8bbf-4027-bf39-f19be256b2f9'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd88cfc4d-9d62-45ce-9829-ba61c405010c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd899707b-5a6e-4e82-ac11-683a294b8f13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd8add11c-bff5-4937-98e1-a5e3cb5334e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd8add2dd-d155-4bd8-9253-eef972c2076e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd8c3a988-fb49-416f-8636-5aeb7edc9ca4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'd8c95450-f089-4409-a192-9494ce693f86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'd8ce73f9-58b5-4a7f-9477-5023834b3aba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd8cf6a85-90f0-42c5-8ff9-a3ef03b704ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd8d5ffe0-7a84-4e25-afb7-459e1616d1da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'd8d80527-800b-4d3d-b5e6-ea7743510ddc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'd8dac708-19ab-44d1-a2c7-17833e9b6110'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd8e8b2dd-3f4e-49db-bcfc-416152b99092'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd8efe4f3-7ee8-48c7-9f84-90625799263d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd8f5e51b-72f9-4c80-9b92-37a8add213de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd9149045-1aba-4493-8b02-9cf2264fc244'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd91bf091-b248-451d-969d-2acc9d140d6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd928b71a-2444-4a3d-9f10-d84a9dd907b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'd9298ee9-f05a-4791-8d6c-2b2f1a9cc902'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd930f2ee-6ba2-4e47-b186-838a2243d37a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'd93c5670-1058-4071-969e-5077517550a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd93eb753-1bf0-4f91-980d-eca602563101'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd94f6ebd-53fd-4a12-bcd3-612366c27349'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd94f705c-d629-413d-8db5-9c779be59cf7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd955811a-f068-4b1f-aca7-d1fe0da1f69b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd956ada1-cce6-4c0b-b8e6-4f00af351901'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd959e543-e8b6-4cfd-9909-297bee9cf236'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'd96836a1-715c-427a-83af-3014a55367a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'd9692d40-26bc-4610-93a9-b9be5d92027b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'd972ccd8-f9df-4b6c-b87e-45ce93e43cfb'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd97357f1-be40-4de2-a05b-27bc83cd6927'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'd97b4094-d1e5-48a7-9cd8-b6e48420fc75'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd97dd534-b739-421e-9591-92fde1989cfb'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'd97e55f2-d384-4792-b648-442edae3e7bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'd9897056-f304-4187-b8f3-327d3bacaaf5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'd9898cd5-faa1-464c-931c-f2ba094d7246'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'd989ecbc-5a1c-4f72-baf0-d7da867e3778'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'd98a62bc-de60-48cc-a974-c4b3846ade8d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd9bd96dd-99bb-4c70-b616-258e1109d0fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd9c592a9-e4b2-4bbf-b293-b9db9a1debac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'd9cc4d09-87ae-4e0b-becf-adb7a09c6614'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd9ddae2e-3003-4222-bd31-bd562138e422'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'd9e2737f-196d-46f0-acd4-c9a8ba2d75d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'd9eed85e-b5cc-4730-83c4-c5c5f359a1cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'd9f2e137-353b-43ca-8215-cd469e713ce2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'd9f3ad96-320e-405c-9ebb-9714fbbd607a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'd9f52aee-862b-4d27-a478-a68cecd91974'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'd9f74eb1-79a4-4949-acf6-48bb62223524'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E044' WHERE BloodProductGuid=N'd9fc98ca-2bc0-4dec-a196-d4bd028360d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'da01cc9a-ed5d-4c08-8d2b-43bf69c7b566'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'da05c735-fb24-4525-9eb4-d03f59a97ff3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'da121927-2345-4f29-98e3-5571bf002062'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'da133446-af61-464b-bb1f-1996530e9431'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'da1a7d7c-e1e5-4da4-aada-1e1e4f7f8f7a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'da1bbe56-235d-47ca-94bd-e38163d1cc78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'da228981-31a0-45f5-9e2c-b92ccf1b22c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'da23f3e8-e7a0-495c-883c-2561cba8b752'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'da2a0c89-f968-4ddd-97e7-dde99eaaf411'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'da35ea21-af67-4b5a-95da-a0f28ea59481'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'da37bb33-a0ec-48b8-8f00-74723ac67fdc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'da38744f-3209-4afb-9015-2220eabec8d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'da3e076e-55cc-4fce-8df6-0ea4b1fd78dc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'da3e245a-8d33-46be-84be-6d349b52934c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'da4bfa20-9f9b-4595-ad37-1ba6a95a8dd4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'da5a572a-b056-4cf3-933d-3131866c66e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'da6064c6-e1bb-4f7a-a464-807e2ec4866d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'da64205d-4f65-4c2a-98cc-a57981274885'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'da69b792-fd2f-465a-a6a0-2c0322ce5578'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'da6c6863-7ec3-4ff2-9488-3308bfc1aa28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'da6e6f5e-8431-45b1-8190-57ff2db13a8b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'da7639f6-f867-435f-a447-43a66555a610'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'da7d7001-276d-42ec-9c7d-df63f723a82a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'da80a69e-1877-4c19-b4d8-02167dd3fa3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'da8ba88a-c4d2-4fa3-bbd2-727c288de1c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'da8ed84b-354a-4756-9e26-9e34628c0451'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E056' WHERE BloodProductGuid=N'da92ce40-c385-4590-9765-1d8a71ac58ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'da961b4b-e2e1-40d7-8c84-25e439460d81'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'da9766b1-157e-4453-adbc-501dc99d3b10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'da981cfc-5fea-4885-bd35-c8172952d93a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'daaa519a-82a8-4dd6-b818-f458998664e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'daad0f60-e83e-43ee-b814-684a42caa930'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'dab3fb43-721c-4a36-8f78-22ae72379529'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'dac527e9-8d6d-4dd7-8469-841ac57d1098'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'daca76c4-343e-4c9d-93c5-f14414156c82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'dad0cfaa-9d93-4696-8ca6-808349d345af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'dad4f466-4835-4838-b851-2560504a7548'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'dad9fd6e-94b7-4f57-a36c-e103bb152bbb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'dadd04a4-9787-4eee-8738-f126667c9d70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'daef18ad-4ef3-4a64-b65c-f79350c34741'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'daf8097c-cf60-47e9-acd3-934fba595e88'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'db175fc6-6b44-4d17-a6b3-1fe29dda9ff6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'db1ab59c-4a6e-405d-b2d0-8e5b0b7dd851'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'db1cefa8-d62e-4c8e-ae7f-f3c1fa0f2a21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'db20c658-b3c1-4b03-ab1d-17abf2c32017'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'db21c4cf-5a01-411f-92f8-b936ac314516'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'db2595a6-a9a5-481b-89e0-8a61019f697d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'db30cace-2e42-4da4-a2f6-c9b52720b6c3'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'db40e0a8-d692-4646-8ac0-5cea77135072'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'db484828-26df-4555-af08-f04a39f93a9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'db49023f-7211-48a5-8497-7988562404d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'db4a070f-63c8-453e-bb51-7ffdcfe8751d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'db4cea5b-c8f7-4d18-b79c-da16b32c1c6e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'db55f237-74bd-4387-8588-37d70ccf9adb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'db5bb915-b4d2-44fe-8eca-6d97a9148a1d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'db660c58-c4b3-4be4-9d57-e60fb62a41dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'db66e889-f0bf-4a03-abc6-52346ee48fdd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'db6aa0fe-3ac4-48a8-b5dc-ecdb5d2b54ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'db7ac81d-6088-4eff-89d6-e61eed9294d6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'db7fde6c-6425-41f2-9054-e6965ff0b758'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'db7ffdc0-5ae2-4119-b374-20f6a5df3173'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'db81f2c2-4c35-4feb-8c47-9cf8fc329d5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'db8266e3-d8f6-436e-b036-8120039ed13a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'db844b86-69f0-4e7b-a024-16bea98a62d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'db8491fb-1eb3-4ecd-901f-1e40985e21c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'db89e1c6-1d66-42d8-be35-24890fdcdc10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'db8ff156-1f55-42fc-b5eb-9bf61729eb2a'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'db957a22-b61b-40f5-8d67-95dc2aa9c796'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'db9cdfe0-8816-450f-bf9e-090ace230611'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'dba02e44-539f-46ff-bc9d-ddb7fcfec12c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'dba1bd8e-bb72-4324-a9f6-7a63a3fd480b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'dba40789-dc9e-446f-ba5e-6ab6e32bb052'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'dba5d15e-c220-44ae-b782-9995d97541bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'dba665f6-bd72-43a8-873c-db0b0feaf7a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'dba9012d-1da3-482b-9583-38e79d4d12a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'dbac4afa-4a2c-4651-9960-458be8fbd870'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'dbb0c353-c0e0-416d-988c-eac765025e86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'dbbacc76-5859-4d20-9237-668c34ac3bbd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'dbbbcc07-701b-40b2-960a-06771b6b2aa1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'dbdf0c94-371d-4766-897d-5ae75b47ad29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'dbe88b1a-42e4-4b2e-becd-57f61b43bb87'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'dbea63ce-b550-4a7d-977e-19b261322aaa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'dbf652fc-caad-42bb-994a-f7f6da7eb7a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'dbfbf38e-5641-47d8-b467-24b74cef7d7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'dbfeefef-b296-4045-b498-1cf598be0c1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'dc1039f6-7c26-425f-961e-cc35f4020653'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'dc12eb75-060e-48b3-aba5-74606e1f8917'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'dc17396e-a8fc-43a5-951b-7c87fab4b3dd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'dc17b148-ac73-4bfc-9af3-644adb137842'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'dc1de370-523e-4322-9a35-77bb1b54d487'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'dc1edbce-5e0c-4fe3-81df-f966bf61444d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'dc215023-3219-4de9-9d48-0931bfced422'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'dc2853b6-4c7c-4456-8653-5031c1165284'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'dc2b04e5-3a4c-4460-82be-7c59de67e3b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'dc2d320e-3444-49b0-bf80-109cc4962b75'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'dc2d90ab-5f46-4452-a3e8-8007c18f34f1'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:noninjectable|>=400mL<600mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'dc3799b0-70dc-423d-a9a0-eb444851d7cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'dc455325-5e83-4a15-8a01-44be36502659'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'dc45eb2a-7a14-45d5-abd1-65effd49d1ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'dc49ef02-b638-43b1-889f-20ee58900620'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'dc52c627-a7b5-4421-8816-e740b399381a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'dc683b42-d659-499c-a181-8d6117217056'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'dc783f74-dab1-4045-bd16-1385711978b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'dc797511-ac35-4b86-8b92-ff690f92e7d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'dc799c21-ba00-4983-9543-03cc4c3ea9f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'dc7c208c-0f4e-466d-ab5e-87df34184a17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'dc7fbad1-ce34-4573-b7df-27049d2875c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'dc8af030-2119-4b89-94b3-92eaeb1f710f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'dc8d5664-7bbc-407b-b6c2-155cf6c4c314'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'dcb02279-9b01-4a79-8a49-c8edafca3062'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'dcbac751-35bd-45dc-bc90-d30fdcb657cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'dcbdf1d7-7549-4fe1-9663-d7eedb682662'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'dcc8b607-c2df-4911-89c4-554541e0af57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'dcca380a-0279-4627-8cf4-3b3b2194fc1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'dcdbdd69-4311-4e03-ac7b-995d916e9d47'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'dceeb1db-7b3c-4ec9-bdae-a9200b0c76b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'dcf58410-822a-4be6-bd8c-49b5dc1ad9bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'dcff10d9-a82c-4b48-8433-8e1aa3a7589b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'dd00aed0-53f5-4f3b-b5cb-4f7b1d358740'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'dd020a18-6544-456f-81ac-3b22cefccadc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'dd040f00-9380-465b-95b3-27052654c720'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'dd1825cd-268c-41f3-af66-82a0d10b3e00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'dd1e983e-46e1-409a-a6a7-73ebdbbaf191'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'dd1fac0c-0999-4486-9ab2-bc07d3cb7620'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'dd278194-e3d2-4eb7-9fe2-8bbabe78951e'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NS/XX/<-30C|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'dd337ae6-2e19-4bc4-adf7-3e5a696d6fa2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'dd40bca0-a29d-461f-8b85-80904e93355b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'dd43bc3f-f976-476a-a763-f319e33860ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'dd4810d5-6008-4da9-8496-191f4a2f7a65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'dd4e4dea-14e8-49b5-b17b-621ce283d972'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'dd4f4e6f-1ec0-499f-8bdf-cccf0c8622df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'dd52cb0d-9c51-4a8b-b915-3869ddf55ec2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'dd5ca20a-9614-4627-9fca-440f2111701b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'dd5e1fa1-fac5-4758-8a8a-4ac64be10b00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'dd5fbccb-564d-4d35-9a27-7786d8112f2b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'dd619783-0657-4440-87b4-3399fa2da5e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'dd6d52aa-296e-434a-a143-a1009269121c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'dd7ec254-b96c-41d8-9cce-b9078e630993'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'dd82c5e7-239d-4a1a-a8a1-59c3510fc69b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'dd86adfb-f5f1-490b-833b-b4718d08377e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'dd9e5375-00dd-40b2-8220-dbeac6e263e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'ddabf276-9b2b-4b2d-94b5-60f4dd564e72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'ddac8c35-c7ba-40e4-8e96-755ba78d9173'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ddb1dde2-e3df-47bb-8675-02456060b088'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'ddb1e6f8-98df-48f9-a007-8a55d4f21498'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ddcd3ff9-9988-40a3-b3ee-78b8825cc66e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ddd5e534-b7fc-473a-ba7e-2ee0a98a7ed4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'dddcc285-e8ae-4659-9414-9fc8f74c9030'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ddfc16fc-c621-456f-bb28-1cd50022b8b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'de071807-9640-4357-81ee-53a01a0aab38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'de1c4d0c-2eaf-45a0-9f75-61823f2af174'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'de26216d-2afb-4bdb-b6e0-835f685f737b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'de2d2628-8a38-4085-b90f-5201390471b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'de2f2307-20db-4d91-b53f-998741e666f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'de3897be-6853-44b7-9d89-ffa36c261550'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'de3d9103-dd2d-4b7d-9ebd-f8782a2f93d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'de4ddbe8-4800-42da-9aae-ab0a2e21f0c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'de4ee120-be5c-432b-8f00-17fcb862567b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'de516049-c748-4249-9c7a-ec3dab0ce0d8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'de5a87ad-38de-4237-92be-b1f2dab0b575'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'de5c9ea9-b5fd-4821-9c09-92cce8ed27ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'de5eb70f-82c9-442d-91f9-ebfa38380705'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'de6d13d9-99a5-4060-8802-2994d3d1a57d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'de6f7c39-36c9-4560-833d-09f55fe86988'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-65C|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'de714c35-6912-4153-9d72-81951b43d28a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'de752c40-d789-4ba5-8fde-af6177c775e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'de7b3ffb-5768-4137-a448-8f76959a24af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'de8121d2-2ca3-40c6-ab23-4fa78fc78b16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'de89270c-550e-4c95-92db-f1adb01eb104'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'dea08d2c-3bb5-4961-99c4-aa6a015b3204'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'deaef843-9b9a-4196-ae5e-fbc5db6f3892'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'deb5fc85-6c86-498f-89c9-d9bc59a85e33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'debf9088-db9a-49d1-b331-f69c7011e63e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'dec12f91-4bcd-405b-ab5c-2b06256ffaaf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'dec26bdb-4c0c-42f6-823d-ac28c80576f3'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Not for tx or mnf|Open|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'dec2fab4-2618-46b0-8f25-61b6a54ce0bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'dec8cb24-a7b9-4f97-812f-04d10e5205a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'decb38ba-e006-4d17-8c3e-187062d0024b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'ded0ba85-94d2-4e95-810e-84d2bf0bf511'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'ded26ad1-ce93-4214-bf3c-2f67311784c9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'dedf0595-81ce-44b9-914a-560a6dab7ece'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'dedf8470-3a02-45cc-9257-c0e8f44db49c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'def5db64-4b78-4f7b-b142-521af8cb87a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'def7d3c1-ac1e-4b81-8e29-ce3efbe7cdb8'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|Not for tx or mnf|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'defdb9d4-5190-4dd0-9f7b-0acf23f0edc6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'df01b3ea-ffa3-4515-833d-2e0d93864975'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'df050fd2-bea0-4fe0-bb8c-2cf6234160db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'df0d01cd-6a54-4e4a-b2b6-7aba34ed1393'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'df0d253d-3aaf-43a1-bdc7-56465ea402a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'df0dc164-c0b6-49ad-a374-1a47b5ea034d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'df1f0b06-f4dc-467a-9f67-cf906cd738df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'df2227d5-db0f-4c50-bf4c-5a3b58a2be22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'df2402dd-ee86-4a15-a64a-d632f0fdde5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'df253936-490e-4bf9-80b1-f15f25dbe0af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'df290450-40b1-4940-a3a1-ac55711ed917'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'df2dc877-3bdd-46ed-9293-8b73945c5d1a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'df2e388f-fe89-46de-87cc-8b0f4511542b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'df2ecab9-1f31-4fc0-a8b8-3e1c80e44ad7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'df3353c8-e260-4278-9471-c50027155296'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'df3b7754-9c07-4abc-9458-a49d5ba2e942'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'df3c69c7-8458-4c5c-92d2-02af68631d53'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'df47e307-3be6-4ee6-9e5a-fecd5f3fafb6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'df4ef575-3037-4e2c-8a63-1b796e704827'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'df57c2fe-e50c-4ee7-b459-a908879461c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'df5ba4de-5abe-433a-a223-704708521641'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'df65c566-6d51-4955-8843-db86ec05cf6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'df65c8e9-4042-40d1-95fb-0f7d4a112e21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'df7ecd17-cf79-40df-b8df-7d0a763bcb35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'df83ec3f-c811-4366-8076-593ff22190e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'df8fba1c-2ff9-4ac4-8599-a41971ce534d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'df95e759-e309-4098-94a6-33200a1b5ce1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'df98f365-fa10-4a84-b9b1-e353e5c609e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'dfa508d2-0762-4ebc-b535-78b456f60bcc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'dfa9e3f1-1d88-4eeb-b4aa-b57f3f8ad0a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'dfaeba4a-8e9c-4deb-9240-51997af3b69f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'dfbee4c9-02cf-4885-9530-c568301e7780'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'dfbf8995-3992-4fe0-9fc8-ec8a493fec33'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'dfc25e64-5eee-44cb-98de-fa7af4f1c6f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'dfc80620-e8fc-44fa-9702-2b8b5564889e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'dfc9b6f8-a259-4181-9396-708f6b168f27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'dfd5b59d-6522-403a-a971-65133add5aaf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'dfd930ed-e933-4d1e-8521-0df77c7eed2f'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Not for tx or mnf|Open|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e00d34b0-529a-4c23-aacb-b109d9a7cb46'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'e025852a-1180-49e7-91b7-aacb5f2af51c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'e0258f0e-55e8-4097-bcb1-756477947574'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'e030ad8a-800f-4ea7-87dd-e4c6a97b5ead'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e0361b4f-e168-45f7-9ece-190dbad82da3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e0369c70-68a3-4aa9-9501-6bf08932a860'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e03a84cf-28df-4d28-beb9-65e5ea203efd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'e03c088e-d7fb-4111-acfa-2492efe12adf'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e044d8d5-4754-468c-92a4-2a0af0652cb2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'e04a61a2-05ec-4cbf-babf-24eed003463a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e052ef26-d4c8-49ee-a250-0c45b29f8037'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'e056ad4e-8257-409d-9cc0-83363b52708b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e05826ca-9fce-459f-a3b0-22eec8e372ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e0669ed9-a4dd-45fc-990f-4238d4e6b015'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e070ac68-73df-44a9-a75e-97bec910245b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e0716104-5e4e-44a1-bf8d-fc2341de8c88'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'e072df26-884e-4126-9c88-78df2e54fe46'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e07437a1-f8f8-479c-a79b-5a969f44eba9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e0785ddc-76d2-4a15-b0df-f8a7d10cb4a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'e07b036b-573d-4246-af49-f5e5085985d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e07b30ca-250f-468a-97e3-48046ee32534'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'e08994a6-a32d-45cb-b504-f6fadae10f87'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'e08bcb96-2a94-43d5-a0dd-26dfbd3656b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e0918e9d-4c49-4c06-8569-a77c8a539b26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e091e8e4-efd0-4801-8164-9bf4cd3c9c97'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'e09ad06a-4729-4fb2-bd95-7045dd0de804'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e0a2b2d2-8d04-4e0a-8323-83403a2cb09b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'e0aa2bcb-6a63-4ab4-a96c-805c3285e778'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e0b0f75c-c776-4b87-bb4d-cd6c5eaeaaa8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'e0b3f782-18ae-4419-9135-a586751dfdf2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e0bd2a9f-e04d-4ff0-9c17-442cf5ef4d49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e0d0770f-c880-4323-8c2f-1f3c53554e70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'e0def8a4-ee19-4683-bf53-523a333821ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e0e4ab2b-5e1c-4181-85dd-77c83b07944c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e0ed8308-b825-40b1-b1a2-ac77b5a33fad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'e104364e-587d-4f17-bde0-13c566c6f633'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e111dcd4-d16d-4d4c-a14e-f2706c4a6ef4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e113b064-ec79-4bbd-ab59-f62285b88aea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e11a6e1e-53ff-442f-84cf-5e9234c462fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'e11c5778-ee6c-48d0-a322-e9d5af89d145'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'e13044e2-1ed9-4a36-ae7f-8d414dfecbe6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e1306006-1cdf-48ca-8ae0-bee9708dae61'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:injectable|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e13aa1cf-eee0-4e96-be23-6ca40b739918'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e13c5f57-ad7e-43fc-8f77-c9feb9372d51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'e1436fab-8e3d-4c72-a8c8-446d46a3efc8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'e1574731-74e5-424d-b80f-50175418bab7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e1675861-6c4b-4472-908e-69fe7d027665'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e16fe8b7-fbbe-4c21-9578-0bac909a25ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e17002a2-6d3e-46e7-bc0d-ce064b8ceaa7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'e171612c-3cdc-43fb-b4db-0ee3eb781063'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e1807780-ab4e-4b3e-ba63-0e109d1bdf97'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e18203fe-d6e1-461e-b530-57cc29200d22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e18593ab-83a7-4a20-937a-947b437a5144'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e189ac7a-fe45-4951-ab70-1719b53a1aab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e18a4d85-5a70-4bb1-8926-9985e67cbda6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e18ab3c2-d22c-421c-b3cc-83175343938a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'e18cc34f-26aa-4424-bf0e-3860543e43ff'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e18e0722-31a1-455c-a072-8cffcd2f4c98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'e190373b-4cc2-4b79-874b-eb2926f6d8e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e1914df8-4e9c-4a57-9f28-2301f8cbc378'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e192450c-0eeb-4e25-b411-5fed544b5093'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'e19ce0b1-5324-4948-b927-38ca0f2d1e86'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e1a3ee16-520c-49bd-834e-e77957ecc2ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e1aeab5a-0dd5-4417-a630-e83bd86c5f06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e1b8b81e-10b3-470e-8bb9-c00e4e82f7fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e1bcdc82-1d2b-41f0-9535-1d673d2678f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e1c2a79f-715f-4ca9-bd92-9b3915bea930'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e1c55174-917a-485c-aea9-1f25bc6889d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e1c6f1d3-aabe-49da-b125-85c1665cf577'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e1ce0cd2-fce4-4ab6-8aaf-5d76c5e47eee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'e1cf3e9f-149a-4cde-9b2c-2165170a6b23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e1cf6159-1ffc-4ea1-bdb2-803991978d59'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e1d2cf92-f474-4d26-a3bc-14b91b41c738'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e1e1cd03-1cf3-4e65-87c5-aca951d2266a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e1e6ca56-eaad-446b-92e5-077f4fbf374c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'e1e742f7-2aac-446d-a14d-c7469b6d6063'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:noninjectable|>=200mL<400mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e1e98ee8-fc76-4011-89f6-a4b4e37f4a6c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e1ea3c47-90e0-4d47-9ab3-50dac78597d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'e1f1733e-0abc-4b62-a897-533eee3c3a53'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e1f6c6c2-6705-4b34-87a6-4197d4f62471'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e1fad4b6-2a52-40d3-9bb3-6bdddce73d99'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'e206b99d-a844-4fff-9d29-c81836c176c5'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e20af921-bddb-4536-ba36-887b52123f33'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-65C|Irradiated|>=400mL<600mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e20e860c-888b-4dd5-be55-7d2d67d1769d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e21dec58-bb24-494e-a89a-32d11a481e31'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'e2249747-2acf-4fd2-8b47-6f1973fc07b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e24312a8-4521-434e-a484-e3c74f2c8bc8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e247b85f-fe38-4978-b206-afcaaeb6ae48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'e24cbb3b-5931-48b0-9ca2-f2a6a5e2ee67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'e24d11e3-4412-4aef-aace-dfef671144f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e25bfbdd-f4ce-4d38-8630-1b5544ebfe62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e272ed86-3d1f-44e3-a61f-0ef87be09b79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e274df6c-3897-4963-86ef-d0dc1b5eda56'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e275f025-4fe8-41d7-9e1d-8d77d103b574'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'e277b0c0-ac8a-4ff7-ad46-a88bfec90186'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'e279e4f7-3fb1-47a9-a77c-966f254a1113'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e296b6df-330e-4249-9ce3-31934418a568'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e29f780b-809b-455e-8025-1a1188170997'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e2a31a85-bab0-4c09-819e-32fd44ed829f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e2ab182f-7ab3-4f34-b2bb-7f99570951f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e2b3d742-2be5-421b-bd10-405c856d1311'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'e2cf9c50-ef2b-4308-864a-2b7558bae135'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e2d9b554-f7f2-4f40-a8d5-451c6f8f7324'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e2dc2a83-68bf-4289-a3e8-d18db4475729'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e2eedaa1-3aff-4fca-b802-15a8be8d9608'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'e2f70d47-367b-4f84-895c-a0f6d83a7851'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e2f94ecf-029a-45e3-aed4-ed5b53c2a538'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e2fb1c51-7c2f-4238-b975-6780c56dc3b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'e2fc8780-7659-4250-bd39-9dc47d48743e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e2fd8f38-52fb-4f18-9ad6-1dc374307d90'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'e31361e5-182a-4ac6-b54e-21207da8120b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'e313a734-3967-4be1-995e-8436f86fbf9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e316759f-f3d0-4a64-b012-e936d4da64e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'e31bd70e-47ca-49df-823f-a3f543b21fbd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e326dccc-1807-4843-90fd-5842679e94bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'e35001b0-e08e-4aa8-a7f1-a457edb5c17a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e3505c79-cf2d-4bfe-9066-5ef2b8c449cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e35f164d-b2bc-4a0e-b01b-ac11ac92e828'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e36404c3-8313-4bf8-9e96-a280272467d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'e36653cc-390d-47d7-8db1-846b719cddf7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e3823771-6101-4d64-834f-e0171236f5e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e38b463c-3f0f-4fff-8735-54fa7786087f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'e3941136-6e77-4954-b719-4e821b6464b4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e39e2736-6869-49e5-98e4-453c991f51cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e39e3689-4b45-486c-b2bc-3250417f8df9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e3a0d784-b2aa-4000-be93-7280b6835f1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e3af6a30-3023-49e5-92f1-fb6acb6c8567'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'e3b02abd-4d38-4094-aca4-dce744b1f8a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'e3b42afe-65f3-4f45-b1fd-e7143161e970'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'e3b5bc94-1f4d-465b-81ed-ae89c684d81e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e3b76e9b-d8ea-47ee-a1be-d10af0bc7c51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e3beed79-3557-466c-b2c1-bf7bf917a9b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e3c6306a-6ae6-4793-88fe-791aac80b692'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e3ca3fef-215b-4dcd-b5dc-9380b228433f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'e3d1139c-510f-4071-956d-178feb7132e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e3dfa37c-ef4e-46db-a876-d407a5472d98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e3e0d245-95a3-4ac4-8596-78bb48b0d965'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e3e633f8-7f76-4600-9d2d-0f139f992761'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e3eb0b60-06c6-4859-993c-043af8e61c97'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e3ebda82-373e-4d7c-9322-fd937019fc82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e3ed2e48-cdbd-471c-8e7e-679e8b93d54f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e3ee523a-560b-4cba-99d8-5a5268f86d00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'e3ee831f-021d-4ceb-a857-14f73c77fac4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e3f41fb3-8887-44fd-b5c4-8ecc44ff1c72'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'e3fbcd3e-e1f3-4def-8b1e-d569bcbbf0eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'e4041e48-6cba-4f60-a3ed-2ee3d24bbb5e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e41349ca-d3d6-494b-9faf-d45b9c558d2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'e415dcaa-af0d-4258-b918-be2177287b07'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e42485dc-6c26-4f95-b61a-8ce49ec1fb82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e426128f-99be-4fd5-bf58-566f3971d16d'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e42dac78-7a13-49fd-b2ff-ca57167c3043'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e435d44c-6149-4be6-a212-b55cdcf82b19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e4368771-4ed2-45c6-a70a-412db16915f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e436c306-e691-41bb-9d37-70725b8e6082'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e43aae52-c1ba-4445-a688-1c0818f60791'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'e43e905a-5633-4e2d-b725-cd4d7dfe86fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'e4453f77-4b86-47ef-9303-370e3f8c4e44'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'e44a944b-58d4-46a0-bebc-e03991f073a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e44ec11e-5aa7-4542-90d1-4f4ab7ad69de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e45953e0-50ab-4504-93bf-f714575667c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'e47016b8-14d2-494b-9be6-94cc0ffa8af7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'e477b4ec-6910-4875-9743-3158b37ba9ac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e4793320-91ab-4ba1-8739-31c67d31f6f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'e4815924-ed0b-4dd2-b222-f1a0d412caf4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e48a1ae4-b15b-4c0c-bf5e-cf453f09cd0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e4936163-1d41-4292-a3e9-d95498321e9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e496e8b1-dca2-49d0-b811-ea1726ab3e38'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|Irradiated|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e49ed73e-e6be-4a4d-a7b3-b613596e84e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e4a04f8e-e2fa-407d-b887-5b0e9f4defe8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e4a77e0b-f16b-45ef-9fc4-749ef2df4f79'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e4a89a72-5693-4216-aa97-4fe7862d2342'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'e4b5b516-28eb-4d2d-912e-42852db09641'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e4b88236-c086-4714-8df9-9c9f1e89c975'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'e4bc8294-02a4-438f-92b3-5ab3bdebc7da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e4befcb1-4cf8-44f0-b32d-8123c5a6812b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e4c0171a-ffad-42cc-8d92-5d0cc3ff57a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e4c5b75c-b5ac-4829-b4ef-3961197fbd73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e4ceb0e4-a6bd-45f1-83ee-eb8609981c0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e4d7c335-84f9-4099-b568-4e85a7824cf6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e4decb60-9c7f-4d16-bb61-918da32f7cf1'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e4e3b50a-1c55-43e9-880f-a5ec5f160911'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'e4efa036-a78f-4735-a8d4-0cb08fc2e784'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e4f26ed7-7364-4f4e-8fc5-19fcbf401c01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e4f34097-6eb6-4d5c-85dd-493448da687a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e4fd4fcf-ed76-4f06-91e6-a8ffde33f5d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e50df5a4-7664-40ef-8138-97037cb91d67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'e51471ef-4621-47eb-826d-c16dc48e7a7f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e516ffaa-7232-4a29-b581-fc33e2d9c724'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e517ffe4-f803-40bb-9a50-8f32df9a71d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e51fffcb-6dd9-4685-8b00-f4b194cc69cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e526a010-f304-42e1-ba10-4e351ef22fd8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'e5280c7a-29a3-46d8-b732-9ba787e1ed96'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e52882da-5f87-471c-aebd-210485654cf1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e52f0609-d86e-4550-a551-09e035e7ded2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e53060ec-51d1-4366-bf8a-1c333a9d7564'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e530c1ec-d5b9-48f2-9c52-4ec566c85512'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'e532287f-1c5d-4749-8eb0-a07e9df99304'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e535d02f-b71b-4285-b20e-61e49c08cd96'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'e54351fc-8c27-43a9-be52-0c75d5343fa1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e5548a42-5f75-41a1-82d7-849d2df31725'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'e55c2a15-b9a0-4bce-9fb9-ece501459f32'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e55cf62f-6f92-411b-b102-a11510e12032'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'e55e71c9-9d64-439e-b537-c4600f55f5cf'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|NS/XX/<-30C|ResLeu:<5log6|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e5613c48-d296-4cf2-8c85-92465d484a29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e56b14d4-7413-4b45-a28f-907d343dcb6e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e577be38-38f6-4dab-9112-92249745f68b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e57c38c0-02bb-4038-9c29-3a93b14bd4a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e59e8000-c64a-476e-b330-456fcbdae198'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e5a0e829-3c5c-4b5a-9b80-b036e255a83e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'e5a41306-f773-4eb8-8607-8f8481b9d55f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e5a7bd59-584e-4c72-93d2-a56dd90bf3e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e5b096ad-e8a1-461f-b7af-7e058eee204b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e5bb5058-f7fd-482e-9773-842c39557a9e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e5caca9a-3f33-4c30-b8d5-ec2cbb2910e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e5cbf6be-315a-42bc-9d2a-f8d381dbf50f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'e5cd0e48-8b00-4ccd-a69b-143ed238ef29'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e5cfc332-71a5-4694-93c4-2e59a8764859'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'e5d7d794-2af1-47f5-84c4-e10569a9e58d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'e5e62b63-0a35-4205-9303-76d9675b3b9f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e5e938cb-b1fb-47f2-ae91-92e74a85dc5f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e5e9cc7a-3149-407d-847e-38c0ba7a6fe0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'e5f1f80e-d209-4d0f-8d52-1ce2e379718d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e5fbbaf9-782f-4f2b-8992-0ef4baefaa7d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e5fe459c-f524-441d-a45c-d1a758a8168c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e610fcab-17b9-443c-8976-737b1bf42e2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e6119f72-2bbe-481c-b27e-8869f2a7c681'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'e6258cd1-f447-447e-9d66-a1825ca69953'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'e629fb11-5e8e-4db9-8a02-9ec4ae21d564'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e62c548f-431a-4817-94fe-f2abb4a9281c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e63042ce-1c9b-45a9-b87f-64abc7f6050a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e6327c35-77db-4cee-af22-794439060091'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e6338fdc-5c02-4f10-b6ef-9039a32b5d10'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e63b53ba-4b9d-43d2-a38d-30a8e2a9fe80'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e641ec78-c14c-434f-b57a-fbb50174c29b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e6478e2a-fb6e-4338-ab3d-72bd9f4d1b74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e64a1a55-100f-443a-bc5b-9fbc0a502f5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e652a42d-6cd4-4e61-aa7d-45e6e5394607'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E037' WHERE BloodProductGuid=N'e653080b-87a9-4c73-b7a1-8c31db466d9f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e65322b8-9eb1-4eca-b15f-a22ffe9c755f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'e65d29c2-f64e-4739-90dc-baa0862d25b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e6612747-475d-4cb9-adf8-3252fcf02489'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e66ad7b1-89c3-4834-a665-1fbc7a8ec2f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e66e01e1-c35b-4760-b504-c45f055bd1d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'e670b040-8655-442d-b459-8ca98aa77dec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'e67bd78a-b407-41a7-ad00-9d2b820a6ca0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'e67cb953-460c-49dc-9d2d-0f33c4d9e2a3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e69af77e-63c7-486a-958d-1a8e55824a7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e69fa0c2-84b5-4922-9d07-229f39788164'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e6aeb811-b64f-42d7-8674-835ecd5bcee0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'e6b53e5d-6186-48a4-a073-ef3cd31d47f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e6b8c1e1-fa47-40c8-8dc6-ce12eec2527f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'e6bf7192-e321-443b-a163-21c58196a287'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'e6cba251-d899-45b5-8027-f4f16de0fe00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e6dc4475-e000-4993-919c-6e0ba9900c2d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'e6f525f9-63d5-4a3e-a53e-037cbcde5454'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e6fdf87e-3c4e-4186-a2d4-7a12c2f87886'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'e701aaff-3812-4833-ae7d-552bd82927d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'e701e6fe-e98e-48c0-b3d0-2f213a50a10c'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e709c080-450f-455c-b47b-635ebb5ad895'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e7253f81-cda7-442e-b45c-9e64402c3145'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e729488e-ab2a-45f1-b176-61c195bd1803'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'e72bfe58-e21e-4a7f-8d4b-eec1d7bae7ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e72d380c-94e2-40e8-b43a-8a187f222d48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'e72d8d29-e1e7-4f9d-af39-04c12c5c0763'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'e7499836-3bec-4bb1-8654-3654c381375d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'e75a3097-654a-4ed6-bbfb-f557e5d55953'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e75d67e7-8397-4c79-9660-33bcf9998ce0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'e75f6d6f-4426-4483-8453-89f95ef90647'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e761f6a8-28ea-47ef-ae61-3cc503b38cd1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'e762d43d-68af-40c8-b2e0-9ebaeb97291a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'e7634318-08d0-4e92-9e74-0557c9e915ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e764573b-3e5b-46ac-b796-242e2b39bf79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e76f90cb-4bf1-493c-b8e0-165f6d758583'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'e7747a12-7431-4f0c-b611-6d3bfde8104f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'e7778374-904c-46bf-91dd-69afff7c25ad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'e778b5b6-0ca1-4a04-ad6b-47703a09c856'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e78049dd-141f-4779-8b6d-d97c50905990'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'e7819e51-4991-4bb5-8cd3-285369b70820'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e78ca5fc-e692-4419-bf56-f361fed72c0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'e78e445e-2b50-4197-81b1-921dc141691d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e78fd8be-2d1b-46af-b729-20da09d23674'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'e797156d-74ba-4b2d-a99e-d97343e839fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'e79ad56c-301a-4564-9728-0e6950990b02'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e7a73446-db5b-444c-afa6-06b3aa3327e4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'e7b4b4dd-75cc-4235-b270-f0a8c9a01860'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED GRANULOCYTES|CPD/450mL/rt|Irradiated|From 8 donors', OriginalProductTypeCode=N'E036', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e7c132d9-824d-44bc-a97b-8e69650d00cb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e7c4404d-cb97-4781-b7b2-af0f6ecc353e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'e7c5f3bd-d80d-4041-9995-899b08c678ec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e7d73445-84f4-49b6-b90a-ce29dbe5bbde'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e7df13a8-ca7d-4488-9062-75e0692eceef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e7df202f-4f39-4711-be4b-c574553c6dea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'e7df8ac9-45c6-4b3d-9792-4f3e793d05da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e7e16d9e-a8c1-4b2a-89e2-8aa3580a5669'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e7e1bbe5-ee7a-4e11-a03b-71ff76632309'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e7e23dad-651c-4a05-920b-d072ba996d55'
UPDATE dbo.BloodProduct SET ProductName=N'Frozen Apheresis RED BLOOD CELLS|Gly40%/XX/<-65C|Open', OriginalProductTypeCode=N'E050', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e7e6f174-48ba-4cac-8fba-23800ba5cac1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e7f7a44e-be91-4bff-9fc0-9796a7328f22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'e8004382-89c3-47f6-8cc1-f0143c456820'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'e80d9a6f-93e7-42e5-a5c3-0c88db90f237'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e80ed6ca-53ea-422b-9815-123b2c69f427'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Plasma reduced|Buffy coat plts prep|Approx 240 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e814a484-db45-4599-9acd-7a2fd26c4db0'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e81710d8-7947-4680-9f3d-5eebd3bfea35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e817a8fb-325a-43ed-bd05-eee596292994'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e81b780c-33ff-4291-b70f-d3cad2e1a24c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e824c684-451b-40ef-961d-b703fc672e80'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e827e083-6409-4960-9f26-01187b5bbe8b'
UPDATE dbo.BloodProduct SET ProductName=N'RED BLOOD CELLS|SAGM/450mL/refg|Irradiated|ResLeu:<1.2log9|Supernat rem/Plasma added', OriginalProductTypeCode=N'E002', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e83862b9-436a-4734-a940-40445317717d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e839c5f8-391f-48e7-a24e-9e9697d0b6a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e83b2f9f-389b-4b07-bbee-aba2c8924431'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e84504f9-7bff-4ecc-844a-381fc65d8ef2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'e8484e9d-be00-4cde-8ada-43709886e50c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e84922bc-d5bf-4c03-bd54-c6f4e6339dc3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e84b9a66-bd74-44cd-912e-6cb2d578c3b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e84fd7f2-44b5-4c49-8afb-9c86a5f19265'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e85b44a4-6138-4b51-a54d-2eea0846c26b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e85c7837-85c5-44d5-a5ba-523ed9937908'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'e860e4f6-b735-438a-ac2b-eef1a4d7603c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e866252d-d1bd-435a-9ecb-27843b58812b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e86f677b-9b07-4e83-bb66-6cd6e868c429'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e874028e-e2ce-43d4-bd40-73ad01f51d51'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'e8859cad-3e9c-4e9b-8845-7ebdbc2dd27e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e89014fd-c93b-4f35-91a2-d877879e842e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e89b6a8a-2fae-467b-a506-6508e8d0bea1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'e8acdb23-af7a-43ef-81dd-21d6f31b5744'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e8b132f7-6e01-4bf1-ad50-974afeab153c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'e8bfcf6e-92e1-4742-b8b2-d9c15ac5af82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'e8c5f842-5440-4c8d-92b8-c64de6a63e27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e8cb9c45-c321-4edf-892d-e78fcf9a1cef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e8cdfde8-aea5-43c6-af81-d09a4d8d578a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'e8df1dfb-d009-4338-a23a-32de73847457'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e8e19e10-571a-40a5-bfc4-59da0f730db5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'e8e21b35-ec9c-4cae-8f22-098846efdfae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e8e394c1-94fe-41ee-8330-f7bce5312f17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e8e72e0a-f3a0-4733-add3-971fda644b05'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e8eea9eb-a993-4f75-a2f7-99c4a949606d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e8f620c8-d342-4ce1-99c4-4a99521e3c8e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e8ff2c46-b211-4e00-8cd8-a50186cf5144'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'e8ffbc37-21f4-43cd-8df9-93765188f2d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'e8ffc0bc-0aac-4b4b-bf00-13d3bd51c207'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e918bc06-8c0b-4eab-86e8-e9ea4231c455'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e91c53e0-425f-4381-8ecb-1a45ed3cfafc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e92873e9-0653-4f66-ab65-413ccb9eb864'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e92ce76b-c806-4193-896d-1d657be5abec'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e9334f7e-57c9-4838-88d1-f49538224a27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e934b552-b38f-463e-a0f4-0b12a8b5c749'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Irradiated|>=200mL<400mL|Frozen <=24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e93d9376-7a92-4f17-be70-03af610cbc95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e93dc7e6-8893-4c0d-bcce-45ebaa4a39b8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e93e553a-99d2-447f-8756-b4380c06b687'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e93f8b57-8592-491a-a44d-8f92037d37d2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e9456980-a270-4742-abfc-bb2e57b990e7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'e94734da-a054-4bc0-a0e0-579918a9943a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e9553cbe-9098-4a30-ae9d-30c7579baf58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e95a08fe-5a17-4053-908d-4b7a600c8780'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'e95ecb89-ab1c-4281-b116-003599453ee1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'e96c33c1-6b87-44f4-801e-82291d317927'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'e9739c30-2e30-42d1-8f0f-e3afc67c6f48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e973ef61-3478-48b9-8855-64d5eea1c49d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'e974dd62-ff1f-4e5c-ae64-2b7464596b82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'e9790fbd-0a12-4744-a09e-0dc3888e9393'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'e97977a8-b93b-4922-bc7e-b9a207e0a882'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e97ac05b-a29a-4aad-82f6-4cb483cc43f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e97d88c6-5c11-4d4d-a44d-f3e42a4456c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'e98084a0-94e6-4e02-bf3c-308290acdd06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'e9862f4b-2248-4c37-bf88-3e93948710b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'e98e2dee-ff4a-4ad6-8942-1e7799fcaef5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e98e847e-13c6-48c3-b494-a2ab457d1222'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'e98ff397-d7c6-4da5-86e0-5df2ccc07eae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'e99fd941-5ce6-421b-bd58-3ce3202eb87b'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-65C|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e9a25268-365d-43af-b920-ae8970a8504f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'e9abe521-6bd7-4654-83e7-49540c294aa1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e9b044ed-0f4c-44d0-a224-db940c81d38b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'e9b2458d-3efc-404e-a9d9-11da1267d654'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'e9b2adff-7c62-497d-b560-37d5cf867a16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'e9b3c122-c8d8-40d2-b4fe-c76af4d9d368'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'e9b6c3a2-ec65-4b94-b978-fbcb3a13cf1f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'e9c8d788-f319-4714-bbc7-c24d2194e83e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Not for tx or mnf|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e9e27e7b-26fc-46c3-a025-2c85eba556b2'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:injectable|>=400mL<600mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'e9e2adf9-f41a-467c-826a-f70e6e71d705'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'e9e3cfd9-9473-477b-9a23-a5fedef02545'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'e9e44395-9ae5-4800-9e56-74c92d69c82d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'e9ec4370-dacd-49f7-9e85-d6dbb7175ada'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'e9f05919-aec4-4791-acc7-56ec60d47fb5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'e9f28e68-d83d-486a-a5b8-4cec567aca46'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'e9fc0168-94d9-48f9-8069-cb0d58d46f4e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'e9ff7890-1b76-4f34-bed6-ca5116ad7819'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ea00554d-5abe-4fad-86a0-37405c6e9fa0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'ea00c8a7-a691-490b-ab25-dd813e6205cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'ea09b039-2d34-4fc1-b834-85056d0fbbc9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'ea123c95-ea17-478a-9c5d-6e1b1da19959'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:noninjectable|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ea14b146-9fc1-413a-91c3-089f4a33f07f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ea14c650-3d07-4a27-b54d-ee790ce4fcba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'ea19df1f-ec1e-4311-a597-fc1aa10413e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E042' WHERE BloodProductGuid=N'ea1b4a65-5662-460d-8015-e1631cf04ea8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ea22c041-523c-4de0-8aad-04d05502f064'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ea26a726-6429-4af2-bbbc-0a027f705db9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ea29d2d6-343c-4b47-b801-99a584666d48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ea2cb398-7c66-4e33-87d6-60b0e8e7eccf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'ea345480-5f8a-4f1d-88bc-fc9b7764ec66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ea41bab8-9897-4944-aaa1-518a487ae2ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ea49ec8a-01d7-48cd-a155-6a605f9ce5a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ea4e7812-7f15-46c1-a80b-7f8984e7d2b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ea5dcb7d-a170-461a-ae4b-2cf0a747da68'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'ea6074fe-0a25-42a9-89e7-7aadc532cb77'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ea61cbea-cae9-4d55-8d10-5b9627d2d2ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'ea6232cf-4032-4d12-9feb-a6159c4a2eb3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ea6cf053-155e-45b7-8dbb-efdb72cbf6bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ea74e646-aa1e-442a-b5e1-134433c735fd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'ea8286c5-0cc2-4abd-9a65-76304c38619c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ea82acca-d317-416f-9630-4560dc2c97b7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ea887a74-8ff4-4508-9c29-7c840910d11e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'ea88dba6-b7b9-4114-89fe-e52ab033cf5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ea8b8abf-16e0-4aa8-be3f-d59f7b23ef88'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'ea8d8f94-a0f5-4f7b-8d25-4fbdd9ee4cb3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ea8ecf80-91dd-4435-b452-1cae68f993c8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ea93c208-2b72-44f8-85a3-967d6b15eebc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'ea9ae0ab-f4e4-4f29-8220-de19135a6437'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ea9ae6bf-dbc9-4aad-aea2-1fd92e033cbe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'eaa7bc92-2bb6-471d-9aa3-a2acc45ef509'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'eabd0dbd-e7c6-4ae8-811d-99e627befa79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'eabe1783-8b5f-4ef3-80e5-08b0a0ce007c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'eabfd231-324c-4764-b785-c8c62e120bcc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'eac3a424-c92d-4cae-b85e-637faead8f26'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|CP2D/XX/<=-18C|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'eac40ecc-42c3-41f3-8a2c-ea059f1541d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'eaca87e1-a4f2-48b0-932d-ac36a027b5a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'eacd8d4e-d672-4c19-aa32-4f43091acae1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ead13efd-1a9f-4857-9d1c-8003b1a279b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ead89291-548d-4a22-b25f-8a76053120b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'eae0e7ef-58b3-4806-9bfe-3458d8fa2d57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'eae1b739-697d-419c-98cc-8e39b18edd23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'eae4eab4-2661-46db-821d-1ab0d937d4e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'eafb904c-c816-4878-b5f4-97057e813794'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'eb0a85bb-ce8e-4565-addf-8f80c93c3fba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'eb0abc35-7232-4b17-a283-d218f77359d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'eb0cec9b-4e6c-4699-a9ca-3900f5a7385a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'eb19f4fd-1450-422c-982f-c0a21eda009a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E035' WHERE BloodProductGuid=N'eb1bf295-991b-494b-a9f6-d9ad140faf22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'eb213380-9dba-49c9-aabb-f1b82860774c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'eb23d726-cfaa-4209-a291-83c3b6b56ecc'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|For mnf:injectable|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'eb255f9c-6ac3-4ed3-86eb-fe5b8828aecc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'eb270f7a-398b-41c4-b683-fbc596acd4fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'eb27c0dc-4931-4ba7-87e8-ce2a7a2b2180'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'eb396b76-1de2-4b5c-b472-9d6498623ca9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'eb3ac287-6fd5-4b65-b83d-77ba391b40ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'eb503b47-9da2-4521-9a1b-e98195d184b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'eb508b41-8fec-4748-8ffc-f34d20ec22a9'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Open|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'eb520a2a-8781-4859-96d3-c4a0f2bd4a21'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'eb551f14-7bba-4efe-9fa5-c07ebea97399'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'eb57fcf1-a056-4065-b460-a6340a37745c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'eb5a9003-6469-4098-9c95-d1b8b2b17942'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|Irradiated|ResLeu:<1log6|Buffy coat plts prep|Approx 120 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'eb685ab1-ded5-485a-a838-6c8537d98906'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'eb6e3375-2803-4434-bccb-388e6240e7ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'eb6e9f20-c560-480c-940a-31a5c72e75e1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'eb748a03-faf6-459b-9689-b326364e029b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'eb7dc56a-9e94-4ebe-b9d1-99065816d7ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'eb8933a3-3203-4f7c-927f-46b0d6155744'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'eb9429c4-9898-41ad-bc14-bf65c1515788'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'eb987ac7-5192-476e-9204-515ef1229f9d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'eba6d93c-d7c7-4123-8248-d68e0e8e4720'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ebac12a9-4cc9-4e8e-aef8-eb73aafb4881'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ebb3e7f4-afb9-40a9-a31b-97d8fc4b86eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ebbdd478-505b-4c58-bb74-928190295d6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ebcc651e-7193-4dc5-bcc7-96a797f69b0b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ebd3c353-9079-40c5-813c-486c46f0477a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ebdd5824-8eb6-4001-9597-269faec0c6c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ebe2d846-9f38-4495-a61e-87ed3cd95cd3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ebf909ff-52c6-4707-9740-a106df183cc6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'ebfb222d-56bf-4ce8-a3db-a82103b8105b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ec02a7ab-02d3-4110-941e-ef9f6ac6614d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'ec0513a6-b8ee-498b-8551-05766f01974c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ec0af8b7-711f-4078-ad11-f214580c92b3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ec0bba6b-ffb2-4dcb-8bc0-48c77b22b9f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'ec0d588f-335f-4d7a-b501-5fa91e96cafa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'ec0e17f2-a2df-441e-abcb-a21a107e2860'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'ec18d6a9-b692-4104-8d1a-597514ebc1f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ec21d982-e0ea-4a60-b793-a57efd89ec43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'ec2ed091-e209-4daf-97a6-b59fd7d5c42f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'ec2f2373-e5ac-4116-9c5c-6ffdb275ca1c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E056' WHERE BloodProductGuid=N'ec2f9d73-7ed0-4031-a358-02868e0ef257'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ec4e956f-4462-476d-8d9b-e3127e57b86a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ec51a054-5d36-4df4-b39d-28ce089a6bfb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ec54a5e8-7669-42de-9df9-045153d760a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'ec59efa2-fb9d-4786-b4e6-633089e8a4c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ec6026d5-a25e-492a-82b2-dd251d9d3db8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ec68a1fe-9c8b-4a56-b481-c4830767bb06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ec6b8127-3318-4ebc-81cf-04810db05ba4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ec7498c6-6e38-41e4-a627-8c388f3a8a65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'ec76eafa-8d3f-490d-bb16-dbbf018fa94c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'ec7fd935-bfd4-4211-9841-17cbab89153c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ec8222b3-8a7e-49f4-9efa-2fd934fadf58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ec918aa4-248d-4772-8fe2-e98e1da2f608'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ec91b30c-9459-4d9c-928a-e4a2d41d1b49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'ec97c46d-7c5e-4248-9f52-a075d1268789'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'ec9a319e-7fe4-4591-8f7e-f0ec619cd350'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ec9dce3a-159f-4f8a-a2fb-d8239f598372'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'eca0caa4-b5ca-4173-a9ae-27f112cd0a6f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'ecb3e884-f92c-441c-a524-ebd139e17615'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'ecb6df3f-570e-4add-8b56-b063394e3588'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ecbe64a5-bd81-4453-bb24-bf1a1ebafa62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ecbe7581-4178-4d26-b153-fdb43039161c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ecc722ea-c6c8-468e-baa2-9f0316c74744'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ecd3bec0-a5d6-4334-ba3f-4131bbd92753'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'ecd9149e-71f7-4d75-a703-8549eff4873f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ecda4240-aac2-4a08-a86b-6914619fa43b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'ecf05e7d-337b-4867-b9b8-beac59e03efd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ecf3a45d-6f24-42d4-a4d5-655a93aa2d13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E039' WHERE BloodProductGuid=N'ecf524d6-c52d-4426-9d02-38f98b1bae82'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'ecf538e8-da49-4f2c-ac07-d641609daef8'
UPDATE dbo.BloodProduct SET ProductName=N'POOLED PLATELETS|PAS-B/XX/20-24C|ResLeu:<1log6|Plasma reduced|Buffy coat plts prep|Approx 240 log9 plts', OriginalProductTypeCode=N'E022', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ecf68c75-1224-4004-8f6b-56cb3bb8943d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ed0057a1-9a3e-410a-a996-7d1db311d99c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ed150191-9c4f-4321-959c-f23b726dad4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ed1a789d-1e6c-4b9f-a732-17d5a217c1f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ed1a8332-d217-4c78-904c-674818390152'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ed32f500-4b84-490c-949f-e5febc09ad36'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ed37cba0-413a-42ab-8207-324d68ea0ff0'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ed398902-253c-4345-86fe-5757d8e8ced7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ed3b746c-0a38-4459-a862-b1ca43dd90db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ed47add9-6533-4a99-a98c-08f666eb21f8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ed543ebf-3448-4679-be59-e600926739e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'ed578b25-7d3b-41d4-a24c-a91ad8b46b72'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|For mnf:noninjectable|>=400mL<600mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ed5c4a9d-c7bd-4c0a-b4bb-81bc045972ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E033' WHERE BloodProductGuid=N'ed6486c9-1e48-40a4-ae19-4c55d3288560'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ed6af9c1-fbbd-4565-82b8-a8711185070d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ed6d6c59-354c-4ef4-aef9-78c2f66c96c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ed6f7748-a269-4ebb-a3cd-7239c3f012ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ed700890-6743-4063-94ac-17c0d92453a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'ed71d383-4b81-48d4-b1ce-be42122326e8'
UPDATE dbo.BloodProduct SET ProductName=N'Washed Thawed POOLED PLATELETS|NS/XX/20-24C|Open|Irradiated|Buffy coat plts prep|From 4 donors', ProductShortName=N'PLT Pool Thaw Wash NS OPN IRD BUFCT 4DNR', ProductTypeCode=N'E023', ProductAttributeForm=N'@72 B2 C2 G2 J4', OriginalProductTypeCode=N'E064', LastUpdateDate='20110509 11:08:37.280' WHERE BloodProductGuid=N'ed76f7e9-09bd-4712-bad3-9710ec85a7ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ed7c38f3-645c-49ef-913d-93871ac5176c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ed7ddc67-e130-45d7-8a78-31d556d52923'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ed7ef446-f4c4-463e-815d-ffb6fe3b0f48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ed8d52d0-919a-4bb7-80b9-92a96e08831c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'ed93a3ce-7fbe-4f7d-95b7-9ce04d60fb0d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'eda1caf9-8e6f-4e95-a3d5-58e870669513'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'eda86712-d37b-4b8f-bb20-c9f95671d48f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'edb351d1-22de-4c12-baa7-8e272b33a8ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'edb53585-7ae8-409f-892f-61c80fbc7e26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'edbe3875-a15d-47c1-8e3b-8f52e81e9a17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'edcd7f05-93ed-4ed2-9831-464d91afc40b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'edcf3382-71a9-45e0-a3f3-4e5a7dcf0545'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'edd57f25-e2ff-480f-b749-8a75de17790c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'edd997cd-cad3-499d-85c8-41f4ab223335'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'eddd5ac4-78fb-48f1-9161-b2a7f40d4954'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'edea1207-bca1-4ade-ad3d-659365362264'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'edf3d1a7-e10c-4a50-b1ea-05ae2bee375a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ee032aee-ba45-4332-bc94-bba3a02c2ce9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ee088263-cd71-498c-aaf3-9e6ba9667201'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'ee0fe0b2-1ba1-497b-b3c3-9094c163c20e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ee18ba1f-ff73-442b-8dc4-cf628b499b6d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'ee2384a8-5a26-4762-8706-3e94bf81439c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ee318c38-dda3-470d-b674-799ab598cd55'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ee3cfd43-ed33-4614-b90c-197780fe9527'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ee410618-49f9-4ab1-a0b9-419055f0db83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ee42f753-9a48-46b4-8bab-e749aaacafa8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ee457878-d1c5-4a29-a403-19d3d2683069'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ee46367a-5765-4cd7-a920-5aad44fb90ce'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-30C|For mnf:noninjectable|Frozen <=6h', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ee464842-8ac1-4554-a6c7-218070018fe7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ee5639af-c049-493f-bc22-401a4ce22f5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ee5f8029-2d2b-44fe-9b0d-12babfaae559'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Irradiated|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ee6361f3-d522-4a73-b479-de28c564c173'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'ee63f9a8-62b5-425c-bb66-1b2952524344'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'ee6ba36b-7036-4fc5-b474-16f58dedc14e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'ee7203cb-b9d6-4232-bcac-62a40d75e106'
UPDATE dbo.BloodProduct SET ProductName=N'Washed Thawed POOLED PLATELETS|NS/XX/20-24C|Open|Irradiated|Buffy coat plts prep|From 5 donors', ProductShortName=N'PLT Pool Thaw Wash NS OPN IRD BUFCT 5DNR', ProductTypeCode=N'E023', ProductAttributeForm=N'@72 B2 C2 G2 J5', OriginalProductTypeCode=N'E064', LastUpdateDate='20110509 11:08:37.280' WHERE BloodProductGuid=N'ee75cfa4-39cd-4b7d-badf-57ef2ce5745b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ee80bb09-9897-42ad-9368-c119572daf40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ee81b8c9-4f1d-44b6-9cd5-48b6abcab805'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<=-18C|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ee848648-0a4f-4108-b506-16d3a9fe9865'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ee8c755f-90af-495a-abee-2d7c270a2412'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ee8e4769-0ef7-43cb-9955-993cd92263e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'ee9039c5-69ed-4849-a3ed-676cd37d4395'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'ee99607e-e6a1-4641-869a-4ce5941f4b79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'eea4fab6-2022-49f2-b53b-5c918ed4c09b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'eeaaf4b4-0513-4733-b80c-acaffb1cb455'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'eeac0321-41f4-431a-8bc6-be0449805ad8'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'eeacd5b2-6cb7-4b77-a6cb-5b08e698cc61'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'eead3c58-7f48-41c1-8d58-f66cde9fe339'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'eebd3fa6-f113-4173-9d1b-6c822a2cdcdb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'eecdbd05-caa6-4fb2-b56e-948cd3cfb198'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'eed0db83-d772-4707-80f4-bfdd7d988f5e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'eed60c30-214e-4842-a4d8-65f1755d718c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'eedebb1e-ffcc-4bb6-a711-2420e9ba77c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'eeee8882-f32a-4cea-bd11-5f5e1339e388'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'eeef06c1-cf5a-4e2f-be51-374eb7360658'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'eef0210b-ed02-413a-938b-81952ff91d00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'eef0c10e-c48e-4e81-aba4-60de68923267'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'eef2f3dd-6a09-4ad6-bdba-48a5f39b99e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'ef008e09-89f9-4d02-8adc-297078bf959d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ef00b131-e55a-4a4f-9397-ee83bb2a5a70'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ef0a4f4c-4ad1-47cf-ab0b-0641b5040911'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ef0b896d-ea93-438e-960e-546a7e4e3526'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ef13923b-c5a0-4354-a26c-d0c76f7012a4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'ef17e2c6-f31e-4c2d-bbde-b7ddcedd3fb8'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ef18e9fe-25b1-4053-8450-4ed6834c95ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ef19105a-5852-4227-b260-acf0a9c403c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ef197bb0-d99c-4c5f-a7c4-64d1fb345d73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ef1a15b6-518a-4e16-9ec3-668f12f5ffe1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ef1faa87-bcbd-48ba-aef9-460a7457f577'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ef2669d0-c750-41c2-b94c-43752d015930'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'ef2c8a47-c2c0-4afc-a727-4542219bad7a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ef309354-a59a-4043-b482-e13f0c2b9169'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ef30e1c8-7553-4347-b0d7-0df5d5b6ce9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ef3f9381-8a59-4eef-bbe1-d015cb735f4b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ef406166-e93a-4d8d-a172-97716a5e78ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'ef40acb8-9bb2-42e3-86ed-5749ae1b635c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ef41b0e2-3039-410c-894e-91190f9d268d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'ef4819ee-c6be-4a83-af65-60ce4e7d68a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'ef4e90e5-79a5-4a6b-82c6-84d7b64a34ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ef5d345b-eb6c-4d3d-81f4-d7051a6366b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'ef5f0594-02aa-491e-8913-75d66c0be2f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ef619d4f-a4eb-4be4-886b-552eb05663ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ef740f12-cd02-4444-ac2c-9ede4fc62977'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'ef76c9df-6770-476c-950b-dce5a08113c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'ef782151-9f44-443a-819b-83bfaec233c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ef7bca2b-58e0-4db2-8fcd-ce0f4f4e3491'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ef7e03c8-df92-4d32-988d-7f4c9e986349'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ef860b72-ae98-4d37-8a6b-89dc8beca269'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'ef8d03cd-28d5-420c-8c06-269a8190a463'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ef956baf-5df6-4681-a96b-b0ea6ac924ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'efa1439d-dc28-4494-a752-6dedae03f1bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'efad28b2-27b2-4d96-abb2-20080ee69178'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'efb1851a-b217-4218-91b7-2d41020679f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'efd46370-003b-4714-b5d6-2c12c3f95e41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'efd47c86-5a3f-46cf-8679-6475c31745ea'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'efd86db2-fede-4747-8f99-b2e9b17bb989'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'efe72339-3fbe-4d75-9e51-c8ed8c304700'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'eff659cf-f445-46fc-b4ba-6fc6df267065'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'eff93f9f-9dc0-4119-99f6-339aebdf216d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'f00a3fb8-b68c-4d3b-a8ca-d1a06f830f66'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f0154ee1-c198-4a98-86ea-1253d4d75c3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f01b64b1-593f-4f29-979e-11fea9fb9c22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'f0215772-7608-4cc3-9dc3-fe69cd2654c4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E021' WHERE BloodProductGuid=N'f025d7c7-b69c-4083-89ad-d8710250ded8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f02606e7-1bd4-460e-89e9-97dd301fa844'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f0260a0c-f25a-40ae-9d36-41fd8c174125'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f0279f3d-819a-4285-8d5d-20590d45d19c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'f02d0796-2248-42cf-9dcf-b1fbd596acd7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f0337d5d-e140-4991-bbd0-125ebb1be241'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'f035cb96-a7e1-4b9b-87a8-7d4f8fb3fc48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'f03a7f5e-3d57-452e-b668-24fede8f0ceb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f04bbc94-2d59-4d23-bbc5-1d99e29d01cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'f0520546-e3fa-4d6e-9cd7-be98eb6c701e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f054993f-9279-40ca-8d44-6ba8b395f36a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'f05afe82-cc8b-420f-ad4e-dcdd0508bc4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'f061c36e-8562-4685-aa16-7eee4cf6e333'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f06606bb-30f7-4b5b-b991-cff4803e0d12'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f06ffee9-63ad-49dd-8227-4b947065ac8a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f077c129-cf70-4aea-afe8-c6d88d27f59f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'f08b62f9-6651-44d6-aafb-b7d0930dd652'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'f0976975-4f99-4e95-bc1f-e0c8fa6461a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'f0a481ac-dbd2-46f1-8882-8dbeed46cca0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'f0a745d3-a843-47d1-8a46-778947e3fe35'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f0af45f4-0dea-4b99-8c6a-61582f295529'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f0b24af0-1ff0-4907-b490-9dfbffdcdebd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'f0b9a999-49e4-4b3e-80bc-266b6057ac85'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f0bcdf57-1d17-4cfb-baa4-3c8799946ca6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f0bd0f62-80de-4012-b45f-23c48cc20334'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f0bf932f-a68f-45e9-b18a-174261bd1567'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f0c77bb1-e6e1-4deb-9588-3bd978867ef4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E056' WHERE BloodProductGuid=N'f0c8367b-58ac-449a-8c42-750c78d9817b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'f0cb5659-f44d-4553-ac22-669e048d4cda'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f0d9d2c9-cbb9-46e3-b89c-a0ffb3e241de'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'f0dc2af8-b874-4876-b0f9-af88e967a910'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f0dd0f1d-ad8d-4e0a-8be9-a4926a54df83'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f0e21130-fec0-469f-9d1b-5faef222a722'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f0e9f395-577f-45bd-9828-83bf29b38717'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f0f2c394-bc7b-46e0-a48f-0725d3f6f0e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f0fc3bd7-60fa-4082-bcd6-4d6ae537773e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f0fe1f11-041d-422b-868e-9b81203909f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f102838f-e869-4748-a88a-e83556bf69a2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f105338d-dd6a-4b8a-94a8-2eabab5abf5d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f10cdae2-c426-41e5-8a3b-b20c5cc55497'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f10f2b14-8cea-424f-9e3f-48a2489badf8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f116a022-956b-4c4b-bbb0-247b124f43ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f122b570-cb4d-4d72-ad91-bfba2396f670'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f125f84a-97dc-4ab1-8877-6c38d6bf087e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'f1267c2f-6a38-4a7d-8dd9-9590f245fc0c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f12c6397-24b4-477d-ae44-8ea7bd90742c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f12f185d-de87-444e-ae06-c3d072bb49f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f13462a9-39c4-49bd-b997-1f0ce1d0a17c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'f1349dcd-4392-4f9b-8865-63c94584cdef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E056' WHERE BloodProductGuid=N'f138466e-0e35-46ee-b3e4-5ca6fb49f8d0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f13ab787-505e-4fdf-ac3e-6bec74cff1ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'f14a6416-ffa5-4153-a030-5c5b5a4dbe8a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f1589788-acdd-4f81-b9ce-2c6b0ef7033c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'f15e3565-e50f-4536-8a0e-1c3fd616d205'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'f15fd61f-2c86-41e7-bc24-2b4ef0768692'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'f1605b3f-ef1e-46f3-91b8-7d4460f17b35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f163b672-623e-48b2-8550-739c2e6cbc13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'f17277ea-826d-4238-92b1-0e366a352c5a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f174576c-8603-46be-a515-7c45adaa7a19'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f1754789-9c64-4c13-9f90-9475c1af0b9a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f1786400-05e1-4087-955d-181a2a579474'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f17f9a5a-e3c6-4041-a99b-9f9dfcdbbed6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f187265e-6a86-4887-8a17-1ec96893c38e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f18aafcc-778c-44fa-8270-20e7304ff516'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f19e2e3a-4b28-44b2-869d-459f2840f803'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f1a89d09-9cc3-4579-ae97-fc00e43698ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E032' WHERE BloodProductGuid=N'f1ad5191-75bf-4efb-a5dd-15bf8f91c06c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f1b20a14-00f7-4e3f-bb0a-5d69c47ae23c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f1b219c0-a46f-448d-a571-f82760cb6c18'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'f1b3809a-3b60-4e0f-8773-6eb262ac3799'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'f1c718ec-a050-477d-b441-1b716e86531d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f1cac67a-f8bc-405c-80b4-c83bef14d8f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'f1cc2e8f-10e3-49ae-a9c2-608152b65566'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'f1cdacfa-186b-40a8-b113-1f8594891835'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'f1d03c5a-e822-4310-8a7f-317e193aa893'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f1d7f00c-a1f1-40a7-8168-2484f5a34ebd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f1da18c9-b2b3-43d4-aef0-0c5e6d1e2ab9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'f1e25236-1fd4-4cb9-a079-6ecdb61db395'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'f1eda8ae-e0fb-4d54-bdbf-7fab3eebad2a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f1eea9ac-f3e4-416b-8c29-ac3770df641c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'f1ef65ae-ec2d-43e7-8a89-88cc97917a0e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f1f5ce96-0b2a-4346-b3d5-3905e3a9f056'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f1f83226-f4f5-459b-b615-a71b7b2fcd7f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f201d625-0bb4-456d-b389-0a041b3e7199'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f206b1f1-5538-4faa-898a-ae971072da79'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f2293ceb-c145-4612-8c45-4eea04ec29a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'f23b38cd-d5a3-46aa-8425-1d6072a205f5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f23ef3a7-c125-496d-a377-5ba78e9c7c65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f25859c4-0672-410a-8b9a-2c6b3e54ce22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'f25a8c8e-5c1b-4dd9-9a38-c248f4a7623c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f26f4fe3-ef68-45a4-92fc-7e804df42330'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f2721def-b5ab-4a6d-a240-68fded2e921e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f273d6cf-ac94-464b-b220-d3226e5b4995'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f27e175f-db15-4463-8afc-2d2eb2fcd60d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f284ee48-015a-4756-b097-0c1d9ffc54e8'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-20C|Not for tx or mnf|>=200mL<400mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f2927735-1a64-4c39-a3c3-9a028e5220b2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'f2971dcf-9dee-4859-a785-8bc7ba83b99e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f29a0418-1c9d-4b24-8bf2-bdacc3a37701'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f29f50ad-0484-4cf9-bef3-abf6c26dee28'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Not for tx or mnf|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f2a3032b-d882-4258-a6bf-3c5983b9dd01'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'f2b1f431-c674-4aa5-8402-e1f7f1b34ae4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'f2b81873-1edf-4f5a-9e4d-f6c53b926c91'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f2b8df38-730b-4511-a516-c882e44ef6f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f2b9b055-0b98-4777-88c5-af7b2bee8762'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'f2baa642-d032-4583-98df-9cc9e5a47d2d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f2bd18cf-8e89-48de-9043-f7ed196bf3bf'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f2c81cc0-6c28-461c-bd67-3b01fd587367'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'f2d1af7c-7a8f-4c52-9563-fb3feafe9224'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'f2da28ed-b309-4593-914f-549fadd4d492'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Not for tx or mnf|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f2f12a12-ab5e-4d23-8f2e-124a6ce5802c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f2fc6fec-7eb2-44d9-a07d-e368d5e80e28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f300d237-c5a5-4364-9ac5-6ba03b84007d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f301acae-c1e0-423f-b028-db20cff729cf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f303c978-e37d-4a74-a113-46a1c039d512'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f31dab7e-ca99-47c7-910f-a4ba0d1de77b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f32897ca-8bdb-4532-a296-c1a597565312'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f32a53e1-7132-4991-9caf-694d1ef7c829'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-20C|Not for tx or mnf|>=400mL<600mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f3404584-2d8b-44da-b4cd-9d2e117de066'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-25C|>=200mL<400mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f3408a57-4ae5-451b-9bab-ffc1e8eaeeaa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f345b024-f123-4344-b4bf-9ebef5daa5d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'f35bf76c-e234-40a1-858b-554a20bd9fd2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f35ea7fe-dadc-4963-96fe-fbc5d844b1ab'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f37c92cb-24d6-44ee-b834-a49406627358'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'f37d550b-99f7-4e95-9b6f-e4b544c2dabe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f385b2fd-4d20-405e-b992-ac5da6cae9c0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f3965cae-bb6d-4298-be72-2bd3c833c12e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'f399bf1e-f0a3-4d31-8f21-ac7d57dc28f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'f3a05dcb-ca43-46f8-8488-97f4a97785f1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f3a0c583-b7bd-4d34-8bb8-d4f0533a5308'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f3a83f90-6889-452a-a077-be0610061745'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-B/XX/refg|Open|Irradiated|>=200mL<400mL|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f3b6c470-97f4-49c7-a5cd-e89f354db81b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f3bbf1ba-29f4-4035-865a-8f022cd3a485'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|Irradiated|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f3bc53ec-8647-494d-9c27-c894cf6e8c6b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'f3bf3812-be87-44b9-981c-124b04135c2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'f3cd7229-6917-4871-adb3-aebd13a4866f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'f3e94c8a-4534-4126-b117-b7dcd77e2f9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f3f70d3b-b43f-4db6-beb3-fec363601acd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f3fcb738-fe9d-4d7d-8416-6a70f8d6dd58'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f40a15fd-10b2-4c13-a8f9-7d1dcc166113'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f40bed02-876a-463e-aea3-5a87d8b40717'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f416c57e-4755-4eca-841f-01db3f704f92'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f416c9e1-dfd8-4a7f-a71c-a99d78fdf29f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f41df4a1-46fb-4134-8bea-69aebc58b32a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f424f0c2-91d3-4824-a395-43f80e163ee0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f42b1342-8546-48ee-9134-3f260ee46096'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f42d3298-4a5c-4459-8d02-84828c3f36d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'f42decf2-9383-4d8a-a0ab-388026f1bfdd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f4349b32-b244-4d2b-9517-1752ab5b8a0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'f447f73e-0e12-44b9-9ca8-3d64991745d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f44980a1-5413-4715-8fd8-f4b1ab842fa4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f44bf118-f896-4f90-90d2-8153d8eba854'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'f455e1ac-acd4-4456-b357-3477530dcd0f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'f45a2983-59b1-497e-9e3e-04129e63f639'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f45e6b7a-2b13-445a-9c3d-a12471ec4322'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f45f5c6a-5023-43b7-a878-d9b1c355e908'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'f461ae73-1619-4cec-b33e-706d5c4e513c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f46214bf-e8b9-4a94-a605-1493430566be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'f4626ceb-7b3c-45f5-b227-f0188252c42a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f46709ba-8712-4187-827a-68b34075b58e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f4684295-1a77-4bc7-8a43-fb60ebb09d53'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f468d1d5-bd94-4333-a6ce-f8b4c4611b9f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f469a0c9-65f4-49da-a20f-5d4b69df6087'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f46a43dc-1ce0-4c78-8836-69538bedcdb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f47690cd-be04-4c5d-865b-0a81e002e88c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f4848705-1883-4e85-852c-38900f8110f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f4867fd0-0ad5-40df-908f-e17abb0319fc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f48a416f-d1fa-4575-bd94-01f759d358f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f493b51a-555d-4c24-bdec-65c70b492b07'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f49d7f2d-54a0-4be9-9ded-81b63e0b840b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f4afa9c7-120a-4477-8c7a-32b2cf8e878b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f4b3a0b8-ce3b-4937-a268-8828b168d0a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f4b4d1c0-32b3-4689-bc0b-e79d1b185a1c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'f4b61132-de34-4bde-9a65-543a65aded77'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f4b9cfb4-1015-4317-b02d-ef757c8d7e62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f4cd1aac-413c-4642-81de-3041ef6d6fd5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f4cd3333-f6eb-40a8-ae77-ff20969d71b5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E055' WHERE BloodProductGuid=N'f4d6ada9-ce26-4fe2-a8d4-773f542e5797'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f4e71357-be44-4477-a8a7-c532696fde40'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Irradiated|>=200mL<400mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f4e784c8-c255-4b4c-9fec-05769510397a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f4ea78ee-e9be-4a15-93e6-5ad2783b68c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f4eaf31c-5747-40c5-a09f-9e3f5d361584'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f4ee0907-c56d-407b-b1c9-417346536f77'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f4ee9e96-d244-42d8-bd70-c02cb758871f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f4f2e5bd-76ba-48de-a646-d8c98cc377ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f4f66935-70d7-40e4-87a9-6e0249fdb71f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'f506b583-93d6-436b-b44b-11c4a480b4da'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'f506cc78-9c33-4838-803e-a6daa91abfff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f5141040-338c-4ba4-a76e-ac29422877f1'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f51a508d-04b9-41f2-880d-f43ff940a717'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|NaCitrate/XX/<=-18C|>=400mL<600mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f5226ac1-af22-4761-9a3c-daedcb423d3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'f523348c-f22c-44f1-89c3-587416e94b32'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-B/XX/<-65C|Irradiated|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f526acd0-db6f-45c3-8050-6ff376d5c534'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f52737cd-9e9e-4917-93cc-c50796587637'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f5318ed4-42f2-46e7-af75-5577f0355282'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f53e222e-9a69-4ee0-828a-66e69841ec13'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f5404bc8-793c-456d-93ec-f87393888b11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f5413783-f932-40b6-9e4c-13e35723f00b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'f5492c72-0d6a-43b5-8aab-bffd171bc80e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f54f6718-5698-438d-a595-dcdc96cfdf26'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f553563f-5016-40a6-bd46-23a8cc7c58f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f5552270-bd35-4161-b878-a917d0a9878a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'f5570a22-f198-4b6d-a0bc-dc4f3244386f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f56664c6-373d-4a2b-8913-b15df13790f1'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f568cf02-eb96-47d3-a1b6-f7b6efd1016a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'f56bbc5f-e30c-493b-8af6-fdcc0bfa64e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f5700311-32e1-4901-a0e0-ae69d3099432'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f5708dc3-ab7c-413e-8e26-22f029d732f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f57687e9-8814-4414-afd3-0b137be32249'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'f5809f5e-abe1-4a6b-93f8-54b48db19113'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'f58a041a-3cf6-4712-8f43-62700af5e3e6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'f59aeac6-65c1-4948-bc78-cadf365d82cd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f59d8cc2-fc24-4ce4-b5d5-832ac3999e40'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f59eecd6-6984-4a70-b1c8-1f91acad361f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f5a7b299-7f67-4b36-a8df-28e4c45b4d18'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f5aa481e-2c49-4853-a1df-f23bd4fd1508'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f5ad71a5-2ed8-41ac-baf2-310a0ec3e7ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f5b30f21-03ca-43ad-a430-564ae7282301'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f5b9c2e8-4951-4a1b-90e2-b2f47806c3e5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f5c589eb-9986-4809-b60e-3dd4a3dd7a62'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f5cbf8d3-45ae-42c1-b0f8-4a2e4b8ed7d3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f5d505fd-bd6e-4954-bd29-3fbbbd89b9d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'f5d660e9-eeb7-4370-8b9b-78e491af985c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'f5e4f322-8b46-4dec-a92c-d1610e7f8ef5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f5e8d6ea-b7ef-45cc-a96a-af291800a55a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f5f0742c-3ab9-4a1b-8def-c3c22ac8db2e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f6018ecd-2705-4ac0-9c5a-98920cbc8d6c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f60da0cd-8a70-4133-a919-fd08fd14769c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'f6102d0f-9690-4400-9f75-baa5bd8ab771'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f61b3709-0c93-403e-b375-5bd4d0a334ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f6269a67-e36f-4f4a-8491-a4ef86172648'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f6299eb4-4ea7-404d-b168-fdbc2d9c7251'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f62d001c-b104-4c12-9f97-32f0b7af7305'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f633c1c4-560f-48fa-9c37-f2d5df9bcd11'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f63406d6-3bc5-4aa5-9e4c-2cb98cf7d742'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f63ab5cd-9c1c-4966-baf2-2598a38c5768'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f63c0a87-1b8d-4b6c-8970-c7235520c1fa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f63fdcc5-688a-482f-b230-d3d1445e0dcf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f646c562-eaa8-47cf-b6d4-d08ca81a0164'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f64ce0ca-9c5a-4bc8-873c-e6ee65c9bd94'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f652542f-bf73-4959-8287-e45025a7727f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'f657edbf-c9fe-4fb7-8620-7d1e79d52c16'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f6589d35-94b1-4827-804b-7442079168eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f6605c2d-8178-4240-8edf-5682e0f0da69'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f6651068-afa3-42ad-a34d-b4ea42652ef4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f6659bd5-51f3-4762-bf0e-457ccef4bbfd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f669b7f2-a817-4e0e-9955-a4d4b4d4a815'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f66b56a2-6fe0-4360-9e46-5b381e43b2af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f66ca02c-2324-4164-8efe-0f4ba451a257'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f6792a00-9818-473a-a4d6-5c72f215a892'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'f67b84dc-359e-4259-a1bb-d2ec4a29fa15'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'f6801ee1-d2b5-414c-b2b8-86283e24f844'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f685f78a-fe7e-4760-8ab1-13c9832480a6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f6868bdd-78b4-495a-88ec-4249472676d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'f68ef4c1-9bc4-4f67-b375-1a90a65e4a98'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f6983478-4420-44d5-86a4-8b2515538069'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E042' WHERE BloodProductGuid=N'f6a05e4b-9dfc-4d8b-9d0e-39cb13b5f019'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f6a19b16-3190-400c-936d-6844c364fdb3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'f6ae8c76-f213-434c-a43a-1c1f9edd845f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'f6ba9fc9-99fc-4e60-a142-f7e74962f1c2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f6bb58c6-fac3-4450-8085-5856f630b93b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f6bc5d13-b869-4b08-99e0-75581d126b08'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f6bedcf8-6d6a-4d78-a98f-704721d6fe1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f6cd083e-0500-4708-9aaf-138fd75effe2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f6e57ee5-2faf-46a3-9efb-c49b3095039c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f6fb2132-52b4-41f4-9ca6-cc363e2a0c9c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f6fbff90-cba0-454b-b4f9-2d3726d5534b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'f701b203-5f25-4af6-9889-9f6cc6405ee3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f70a21ce-c3fa-4b20-b08e-ab015b5a94ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f70ffa17-0422-45d6-b471-a02b29020845'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Not for tx or mnf|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f711519f-a879-4076-af92-9b068c6814ff'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f7283136-c0ce-4ff3-889c-f777ceb7d3fb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'f7391ca6-3e60-4165-86e4-60e0cb01e755'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f73db52b-c153-4d5c-ae44-c86f69d8601d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'f741d0df-6869-480d-b632-a83b214ba786'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f7442148-54d3-4f6c-88c4-7437bbad20a7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'f7467155-8e3b-472b-82af-4f652194ea28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f749f046-9d66-44c0-a5d5-36db5e4b9c2a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f7511bf5-3136-46c6-8048-0002d234403c'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-B/XX/<=-18C|>=400mL<600mL|Frozen <=24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f75133e6-b14a-4cf1-ab22-b2d8e13e18fe'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f7593345-ddfb-419d-9e81-0e9ed7c71778'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f759a180-196f-42e3-97de-2f12120d67d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f773170b-efa1-4dd2-8091-96c20a60fa57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f783f694-7d9f-4f3b-927f-55cdd6e9271c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f7897504-4ac2-4c72-ac84-eda2256701e3'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Irradiated|>=400mL<600mL|Frozen <=24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f790e7cc-7f34-4cca-97ff-a7486d0345f3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f7a80419-ef33-49ef-b579-a875ec731f95'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'f7b76312-bf91-4081-a14f-6acfa08322c3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f7bbb84d-9439-47dd-b65b-26cbb385d72f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'f7c83c50-ccd7-4adb-8069-0c130d148964'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f7d5d1ec-867f-4d6d-b8e5-f5417ef2139b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f7d7fc39-a0b5-46fd-95cc-f1a4326a909c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'f7daf862-f85c-4a67-b426-e4e1723887aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'f7ddd839-e204-4528-9661-8c65efa50015'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f7ef361d-3f64-4640-9e24-e5ac436fb651'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'f7f542e9-021e-4bed-9780-d95242218681'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f7f9a917-8043-48b1-b8c5-7f8731546e71'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f7fd0f3b-0491-4902-b742-d8e3a4c6af2b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'f8212a47-7006-4f6c-95d7-969f266cbecf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'f8214db0-e42a-4b29-9ae1-86135fc0a5be'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'f82d292d-63a8-49ef-8a2f-63e3362a37bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f832523a-4694-43b4-9d18-8fa0b9f40b08'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E032' WHERE BloodProductGuid=N'f8360009-70cd-4db4-9545-e8d023afa65e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f83ac8d8-1769-474d-a8a3-9bf1e0e8f2a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f841114d-5161-4f33-86cd-538c20a03a0e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f842e894-9989-451f-ad5f-dd48b5a2f8f2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f84578e3-1305-4786-b531-8149c8ff793c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f847c47c-38a3-4db2-90ec-915a25e7c545'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'f853f113-660d-4efa-93d3-2382cbe9827f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f858dbb0-2e84-41f2-9cbe-e9e41d464a1b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f859fe95-9295-443d-8804-0dd21b6c91b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f85f4bcd-8101-488d-83f7-37f4c38b8728'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f85ffe0b-51d5-408d-901a-fc3522832648'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f867f23d-9f0e-416c-9837-03117f5fd97b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f8688c31-68a0-4d87-9acf-b01ae776dbc8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f8744c2d-3bb1-4c13-a22b-4551ac41d9f7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f87cbf4d-bde8-499c-b2c6-4984479da587'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f884740c-031b-404b-9186-c7e2fb36af74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f891673f-0c38-41bb-8df6-a39953023b27'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f897d7ea-af7c-4f6f-b631-7efca6645949'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f89fb596-e011-430f-b0cf-d9e1f61294e2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f8a3caff-a7f9-4fa8-94ff-fd2d5b46f15e'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|>=200mL<400mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f8a536fe-da76-43aa-858e-4b0f912fc0a5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f8a804e2-6544-41bf-a362-46de48174107'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f8abe607-12e4-4268-88a5-f4475d0d379c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f8afe733-e4c6-4384-a500-4dd073375da2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'f8b674e6-8b16-45e9-9088-92ca4a125373'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f8d7bf8a-84c3-4c0f-ab3c-0102025c396a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f8e6cf9d-3e9b-4f44-989b-8e6adecb1381'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f8ecd1a3-fa6e-450c-b243-1857c0deba74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'f8f091b8-7b05-4328-9b4a-e723c6e2f716'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f8fb625f-0fdb-4551-8bf7-a09144728f3f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f8fe9719-6969-4954-b888-ed3e79cd99a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'f906a7a3-6479-4275-8867-4681fb22dc78'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f90e681b-4ab6-4226-b8c5-d945c8716399'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'f91d8091-ac78-4fe6-8dfb-2e3098f196a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E031' WHERE BloodProductGuid=N'f937649a-ee3f-44cb-b008-7c1ba9d67e3c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'f945c4e3-4c1b-408d-a8f2-abdedeea59aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f947c4ce-f035-431a-94cf-dc68d2f257ee'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f958f4ad-88df-46a6-a293-6d0181e295d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f95b036a-0180-4b47-9d89-9bb8558b23c9'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Open|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f95b4108-713c-4779-8323-e7e67e18119d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f95c0621-dc17-4cac-b7f0-7bc6306db952'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f95cc2f3-c264-4817-a4dd-de11f48f4b41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f95e05f5-ebc0-47a7-9587-8695b82a6271'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f95fd3de-a252-44fb-937c-0569c0db7266'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:noninjectable|>=200mL<400mL|Frozen <=15h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'f973833a-c69b-4694-ba64-6783d2d5c484'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'f9777db2-8f0f-4706-b2a0-b66670d9799c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f979dbb3-5342-48e3-91d1-abb0f56c1a00'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'f97e0c7b-e73b-4711-8e59-c12bf2357910'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f980490c-07f2-48dc-a9c6-ef31f6aee519'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'f9819088-ba54-4c19-b4f0-5401981d43ba'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f9892aad-c3f1-4972-a8f1-20ff20ef3344'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f9947ba4-2f94-4ddb-a1d9-3acd0442912a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'f9995263-2d44-4d12-b34b-8a01717bf515'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'f99b7544-5720-4917-b464-c398ca1dd75e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'f9b27c0d-3496-4b72-8dc1-47ebe0d9d7c6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'f9b46ae4-4e73-4acf-95c0-0a8a34b98a28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f9b46fe5-0f98-4ec2-90b8-c6f7d8f59837'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'f9b64979-b407-4081-84ed-6451f2b6e534'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'f9bc60bf-ff94-4a63-96cd-6d3e48445ed1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E054' WHERE BloodProductGuid=N'f9cb0f9c-7c53-4407-a953-2077dba6b5a9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'f9cd3c34-9d8a-4e1e-a441-0a2239266a2c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'f9d4b0a9-b926-4b9e-aa48-b7f845bff2d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'f9da739d-903d-46e5-b128-16c3b5e9220a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'f9e17782-c2fa-4375-a685-82614524badb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'f9e91229-6398-4545-ad7f-e23da6c20c87'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'f9ee0693-a6e9-4438-a0a0-333295b0d4e3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E028' WHERE BloodProductGuid=N'f9f4370b-02be-4f9b-8773-ce7ae61fde92'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'f9f5fed9-56f9-43d8-9c86-8bf92dc538e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E011' WHERE BloodProductGuid=N'f9fce48c-db26-4a03-b74c-b98ab3f29f09'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'fa0a2445-9356-452b-9ba4-1c9d71676f37'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'fa0fbbca-1c8e-4d1c-a799-ca8575b8712f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E030' WHERE BloodProductGuid=N'fa131407-dd3c-4979-8416-72bb74f712a6'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Open|>=200mL<400mL|Aphr not automated|Quar:>=6m/retested', OriginalProductTypeCode=N'E013', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'fa1b5395-fac9-44b6-b4f5-0d70daacc0db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'fa1bc7b4-9e5b-4397-97aa-e7bcaea6e4f5'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Irradiated|>=200mL<400mL|Frozen >24h', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'fa1bf434-90d6-43a6-a03e-4dfa0e2d0dc7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'fa1d1dd7-9d9c-460c-bba0-7ec7fd71a7f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'fa2a8a40-f90e-413d-b857-45f75bb619d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fa3aba14-2aac-4df3-a6dc-c848ab168bf0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fa494d96-5efd-4d85-87ae-392d175532c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fa498ab5-6127-492b-9d14-b64a97a01c67'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fa57afe6-bba2-4a79-8599-611f641e24a8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'fa5ceaae-aed9-414a-ab75-ce9c46789147'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'fa5ede6f-d42c-4f6f-9abb-5e47cfab5272'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-18C|Irradiated|>=200mL<400mL', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'fa60610e-db80-46e5-a1d5-34ead12a1b61'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'fa6453a8-2f88-48d4-9efd-2933ca146dc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'fa6516c4-3b37-44ac-a7d4-1d54dbee4ac8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fa6bfe1f-a75d-4759-8bae-53f9634ddcc6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'fa70b96f-15e4-433f-a8c5-65662ac406ce'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'fa757f41-5748-45e7-9bdb-7ce64f5686f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fa760d0e-20d7-4be2-a03c-bfd0ffafdf57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'fa77341b-fbe5-484c-99b2-c6dc4b6e7bb8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'fa7bd40d-fc35-48f6-8bab-7e7d53806739'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E019' WHERE BloodProductGuid=N'fa7c2325-a8a8-4ae4-a8ee-71873ad7b465'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'fa7decea-f88c-4f05-91b0-e15ffe7ab73f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'fa84735e-264a-46c9-9406-5c754639f646'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'fa8a0eaf-3c09-4b01-bfc9-ebc90ad6be44'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'fa8c4443-3d1d-4fc2-acf7-74f75d760f06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'fa8cea76-fc8a-4fe6-9f84-d6056fcba2ef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'fa931e84-4d09-452c-84c2-769a056b138c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'faafd4bb-9da0-44dc-b186-2f8f9d68ecf7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E038' WHERE BloodProductGuid=N'fab02e08-5404-4982-b0de-64239c74cbd2'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'fabf205d-f13d-490c-a89e-5893b94ed86b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E029' WHERE BloodProductGuid=N'fac35294-1b99-4531-9494-1ef2e8898c38'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'facb493f-28eb-49f5-b5ad-d6377a32ea28'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'facd3c29-1a18-4790-8058-4ed5a073ad73'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'facdb859-c0fb-4dfa-b644-d5791ac050f0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'fad319c7-764d-4a60-b226-2861614be8d5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E005' WHERE BloodProductGuid=N'fad3b8b4-571c-48c2-b19c-6e666dc76071'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fad60bee-422e-4424-8de7-d8ea7b2b49b1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fadfed0b-fb7e-4ed6-ac16-d99dc9012136'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Irradiated|>=200mL<400mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'faeb0a92-0f18-43c8-8f29-1a7eec3c230c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'faebf997-9d7a-497f-891a-2c0c4a89e6a0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'faf0bec7-9a8e-4d67-8a17-003edd518e1c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'faf114f6-b87c-4342-b186-37a01f5a055e'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis PLASMA|ACD-A/XX/<=-20C|For mnf:injectable|>=400mL<600mL|Frozen <=15h|Aphr not automated', OriginalProductTypeCode=N'E014', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'fb176624-4ac0-4022-9f5c-ab2204ceb6b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fb17f9a8-0246-45f2-a571-2257c28c4b1f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'fb1b0c4a-1fa5-47e1-a2cd-74b180cedcc4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'fb28a957-18fa-4939-992e-240b17a6dbf3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'fb3b622a-e271-4c2a-a8b1-48577ef6b570'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fb52bd60-6870-4af9-b318-162fed99770e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'fb658605-d43b-42b2-8339-99e8373f7457'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fb6e4baf-64ca-4aba-8943-d08406410bdf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'fb7d42fc-c450-4e55-91a4-567647918f14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'fb873b72-fba6-4482-9e7d-93207c91ae28'
UPDATE dbo.BloodProduct SET ProductName=N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<=-18C|>=400mL<600mL', OriginalProductTypeCode=N'E012', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'fb881282-460c-4802-99a5-90b0036dfb4b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'fb88f4c0-b7d2-45ff-8b43-a00ae3d97852'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'fb89f11d-778f-409e-8f59-0aa6ec8ae395'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'fb9ae9ff-60dc-4528-9b55-156501202151'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'fba10161-55ca-43c9-83c7-d43ed65b8a94'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'fba8ad32-4a80-4399-ae8c-8060c781aab7'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Not for tx or mnf|Open|>=400mL<600mL|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'fbbfcc10-b2c8-41f6-b146-4a266e14bb43'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fbbfdc87-b4f0-4199-96d0-06ad449fa101'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fbc0c356-d113-4ff0-afaf-6b32a93b4c57'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'fbcfcec2-d66d-42b4-94e8-7dafab2e9943'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'fbd91ed7-87c9-4af6-9d26-d0b9c3915f5f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fbe33b4b-2fb6-4fd5-81f6-900c39bc9a4d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'fbf90cca-f2da-46be-895f-4fec90f5e661'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'fbfa6ef2-f58b-40c1-8711-92acf3247836'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'fc05b463-bc5a-41cf-a0b9-9cf8f08c4de0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'fc0dad1e-865b-451b-a54d-cbe4b7dec8e0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'fc1a090c-94e5-476a-ab15-c82be8bb29bd'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'fc2588c0-8fe9-429c-b82d-76d1401a0c35'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fc3cf28f-1e81-4cca-87d5-6a3416ead923'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E043' WHERE BloodProductGuid=N'fc404169-2368-4881-a987-608cfeb19f34'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E049' WHERE BloodProductGuid=N'fc4325e5-4eb7-444a-a9d2-31f059d645d4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fc577192-f49d-4280-8f5d-eb9e4bd7fe03'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'fc5e6ce7-638b-4cda-ae86-3fc1c2655f49'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fc6e06da-573b-4b43-a8a6-7cc677891cbb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'fc7f8bde-5a86-411b-9fb2-f81dbc0a4edc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'fc850d0b-5ab4-4b43-a163-86fbf9f9d71a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E018' WHERE BloodProductGuid=N'fc877391-9241-44e9-a7b3-87ba400b6d41'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'fca0eeca-2eac-4ab5-8d46-03c9979f5c3e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'fcadfe2f-a777-4cdc-83e4-7c6102c5ce1e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E026' WHERE BloodProductGuid=N'fcbbc5ce-e366-4216-b04a-0f74a99af100'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'fcbbfcb2-8e6d-47b9-934a-f69ec5d7872b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'fcc0ecc2-dad5-42d4-98e1-34fd50e6c7e9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E040' WHERE BloodProductGuid=N'fcc7226a-1a60-4b3b-b056-39b35521fbde'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'fcdc28e3-49a6-481c-9b7d-70a49ae55b45'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'fce16035-52f7-48cd-a5d9-2e0d787c2b2f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'fce2eca7-f3c5-438b-a72e-84a7f9a2856f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'fce442ec-f56d-4b35-bd83-a1fe6c3aa6eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fce822a7-6029-4396-8ac9-9626c3016aad'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'fce9051d-71c3-4d60-84b2-6ba3b701355e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'fceb5ad0-fd1f-4cec-a78f-99cd058d80f6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'fcec290c-27a1-4d3c-ba61-840c261793c1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'fcf59eb5-8ed3-46eb-badd-87cb0a80556d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'fd077403-c207-4c49-ac7c-d78c3916a04c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'fd0a9468-90bb-4ad2-a10c-f44de0e3fc2d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fd16aa21-c692-401f-a155-be9e9f7c6cc7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E036' WHERE BloodProductGuid=N'fd182553-cbd0-4ca9-b7b7-5250ef2c7584'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fd1a8e3e-a0e9-424c-bee4-7ec570e9121d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'fd229296-0e0e-44fd-be9c-1e010c0393ae'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fd2a2048-1ced-4f0c-b739-2d94db9e33af'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E016' WHERE BloodProductGuid=N'fd365490-ea24-4496-b270-9070874331b0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E050' WHERE BloodProductGuid=N'fd47ed09-4c94-4f19-88a8-556031c542bc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'fd4dbd3f-3c91-4316-b0ce-d0b9fc5924bb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'fd5ddc9b-cbfd-4b20-89ed-0011af4030d9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'fd6d084f-f7de-4b67-b32f-89dc2f6cb5df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E060' WHERE BloodProductGuid=N'fd73f4fd-afd3-41c4-80f6-ce777fa814bf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'fd79accd-caef-47f0-9487-d45354ffeb0a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E027' WHERE BloodProductGuid=N'fd8c9a4e-a215-47c0-9f92-81ccd2061c76'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E034' WHERE BloodProductGuid=N'fd95ff8f-3ff6-42b8-b832-a9439a387222'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fda192e3-8045-4254-872a-ba51ab7784b6'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'fda4ac7d-f0a0-4d0e-8f35-646817b547b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'fdaba984-836a-49b6-b0d3-2bdb05698f74'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E051' WHERE BloodProductGuid=N'fdb46d66-6d98-4a79-b6fa-930afb3e34db'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E008' WHERE BloodProductGuid=N'fdb7dc0b-9e88-432c-8854-57d740670982'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E023' WHERE BloodProductGuid=N'fdbcc82e-327c-4dc6-9cb3-42ed3ab9f2ed'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E041' WHERE BloodProductGuid=N'fdc9fe69-315b-4362-afd3-bbdfe187b8a1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E003' WHERE BloodProductGuid=N'fdeb82a9-ff55-4231-bb19-517bd56ffe45'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'fdff2283-87a0-4de6-b66b-360035bf3836'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fe03c8a8-7714-49b2-95e7-85fd95b0781f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fe047e0a-e36a-4d49-aa61-f6783784ea06'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fe0aa3c5-35a2-40a6-ba03-0971a9eb3547'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'fe101794-a0e3-4505-b106-4d311b7c579c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'fe127ab0-da69-443a-9b56-127d0580c12a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fe26e586-c356-4d55-9dad-334942fa054a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'fe28fd73-e34a-4715-b4c0-7578c9e7f781'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'fe2a075e-22b8-43e3-8180-98cb926d530c'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'fe2a79fa-090c-40a2-9c1b-a7736a0702f4'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'fe321944-d3ef-44db-bb97-0b8ecdf844c5'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'fe3de465-bde8-4ac1-81f6-b8d987dd2561'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'fe3e5451-03d8-4097-ad5e-ef9923d4fdc1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'fe402cce-ffc2-4bd7-ba22-24855d10b9b9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fe476eb6-1739-46fb-9f84-643e4bc5c00f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'fe4c1af0-2430-4858-9bfc-046c6cc8c51a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'fe5cd257-07bc-4cb3-91d8-8e6d3a24ed23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'fe600f58-48d3-42e8-b9ed-484786f122e8'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'fe61e5d9-a277-40da-9024-06db826f63db'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Not for tx or mnf|Open|>=400mL<600mL', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'fe670c21-bf0f-49fa-ac3b-0bd82985e908'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'fe6c6068-f555-449b-9db9-929dfc818d14'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'fe760a79-da1d-4f52-a967-fbd5b908fbfb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'fe7ce130-0c5e-4efd-aad7-9723da18b541'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'fe813de3-92e6-4788-8ede-3b06f34bd665'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fe8cd70e-79a7-4d60-a003-c8ae2c811fb7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'fe8ddff4-8470-4966-97ee-850650660aac'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fe940185-1e3a-47a9-ace2-ccb620b8400f'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E052' WHERE BloodProductGuid=N'fe9a7a2d-cc95-4b89-9740-89f3b3d55e17'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'feb7c4ef-b23b-4eda-81cc-b28e9c4cd956'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'fec854a5-54d5-43d1-b5fc-39ba1c0f72aa'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'feca6a26-dce9-4cd3-bb00-ca7eabee3d65'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E042' WHERE BloodProductGuid=N'feda121d-522e-403e-94ef-d1c4963ccf7b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'fedbf2c2-81d8-479f-8a76-fb432959acf9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E006' WHERE BloodProductGuid=N'fedec55e-5e25-45b7-9cff-57d804c56120'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'fee6c847-8509-4cbd-a05a-7fabb34e6282'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'fee86696-0bc4-48f3-b719-27b2ce1637df'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fee9a25e-4ed6-4e40-8964-91a5392b2ced'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'fee9aa93-56c0-4b0e-946e-53204a17dfdc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'feeaf47f-1b55-435c-913a-069ce3e56d22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E004' WHERE BloodProductGuid=N'fefd4e12-fbe4-4117-b029-fa072ff5a92d'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'fefd88b7-e6c6-481b-84e3-5042e9fc20ca'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ff054075-a68b-41d9-a416-10b70937edda'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E007' WHERE BloodProductGuid=N'ff195955-8109-413f-b075-150883b7d208'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E012' WHERE BloodProductGuid=N'ff1fc422-d917-4654-a15a-642556ae70cc'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ff211bda-3afb-4193-9e66-bf7dc1d15eef'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E001' WHERE BloodProductGuid=N'ff2eeb87-8976-4e8b-9850-63de043ed012'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ff30828d-0378-4c5e-80b8-ca5a194c60d1'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ff375825-7ead-4fe5-9b5d-039a1e07e6f9'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ff3e6a96-e172-4ad3-a095-21dc2cea1bb0'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ff6ef693-1f2b-4a1f-b7ec-e8b796fa83c7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E058' WHERE BloodProductGuid=N'ff74cad9-52e9-4924-81a7-e01861c53527'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ff788458-2c05-4835-a3bd-2c8c86c84c9b'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E020' WHERE BloodProductGuid=N'ff7c68fb-6347-4baa-8f70-ce6277c467eb'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E013' WHERE BloodProductGuid=N'ff889b81-2ef9-411d-82d1-9ba2474b3b22'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ff98f251-d148-4089-aa31-d91be323d1d7'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ff9b0280-34a2-4323-be25-402597c5cbcf'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ff9d0325-1068-43af-ba88-d928cd6ed695'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E025' WHERE BloodProductGuid=N'ffa7a1be-d64e-42c4-a79e-749a3838485a'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E017' WHERE BloodProductGuid=N'ffb30f4c-cfd3-432d-b5cf-41a734ad269e'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E015' WHERE BloodProductGuid=N'ffc04628-4562-405b-bfe6-26bd0d3ad026'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E010' WHERE BloodProductGuid=N'ffc508c3-3b12-4188-9cd7-0ea3b0426817'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'ffc93ea9-353b-4e8c-966c-be100588ac15'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E009' WHERE BloodProductGuid=N'ffcdfbbe-fba4-4d8a-bfda-3c396e3c51f1'
UPDATE dbo.BloodProduct SET ProductTypeCode=N'E022', OriginalProductTypeCode=N'E061', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ffe06f1e-3ca1-4f7b-80b9-f667f4c52001'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E014' WHERE BloodProductGuid=N'ffe1f1cc-7979-450c-8350-9c1aecd79b62'
UPDATE dbo.BloodProduct SET ProductName=N'Thawed Apheresis PLASMA|ACD-B/XX/refg|Open|>=200mL<400mL|Frozen >24h|Aphr not automated', OriginalProductTypeCode=N'E015', LastUpdateDate='20110510 07:59:27.820' WHERE BloodProductGuid=N'ffe3fb1e-db75-4067-8e49-6cffd76aad23'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E024' WHERE BloodProductGuid=N'ffe9f496-71ce-4ff9-acdf-8d101e15cdd3'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E022' WHERE BloodProductGuid=N'fff2bde3-7a9c-4574-bc5f-839a8528af48'
UPDATE dbo.BloodProduct SET OriginalProductTypeCode=N'E002' WHERE BloodProductGuid=N'fff3a052-75cc-4c83-9612-8a4382e57a81'

-- Update 3 rows in dbo.Address
UPDATE dbo.Address SET AddressLine1=N'1730 S. Woodland Blvd.' WHERE AddressGuid=N'1a7911f2-c722-400d-980b-06e1f36029ae'
UPDATE dbo.Address SET AddressLine1=N'4430 Highway 90 E', AddressLine2=N'Suite B' WHERE AddressGuid=N'b01459e6-99a5-401d-a214-439ffdc3e19c'
UPDATE dbo.Address SET AddressLine1=N'5201 South Green Street' WHERE AddressGuid=N'e30e8490-ba24-45c5-8bd1-64e50b415f26'

-- Update 6 rows in dbo.ComponentRequirement
UPDATE dbo.ComponentRequirement SET ComponentRequirementAbbreviation=N'IRR ', BceSortColumn=1, LastUpdateDate='20110401 08:27:52.420', LastUpdateUser=N'vhaishsmithm' WHERE ComponentRequirementId=1
UPDATE dbo.ComponentRequirement SET ComponentRequirementAbbreviation=N'LKRD', BceSortColumn=3, LastUpdateDate='20110401 08:27:52.450', LastUpdateUser=N'vhaishsmithm' WHERE ComponentRequirementId=2
UPDATE dbo.ComponentRequirement SET ComponentRequirementAbbreviation=N'WSH ', BceSortColumn=5, LastUpdateDate='20110401 08:27:52.450', LastUpdateUser=N'vhaishsmithm' WHERE ComponentRequirementId=3
UPDATE dbo.ComponentRequirement SET ComponentRequirementAbbreviation=N'WSH ', BceSortColumn=6, LastUpdateDate='20110401 08:27:52.450', LastUpdateUser=N'vhaishsmithm' WHERE ComponentRequirementId=4
UPDATE dbo.ComponentRequirement SET ComponentRequirementAbbreviation=N'SC= ', BceSortColumn=4, LastUpdateDate='20110401 08:27:52.467', LastUpdateUser=N'vhaishsmithm' WHERE ComponentRequirementId=5
UPDATE dbo.ComponentRequirement SET ComponentRequirementAbbreviation=N'CMV=', BceSortColumn=2, LastUpdateDate='20110401 08:27:52.467', LastUpdateUser=N'vhaishsmithm' WHERE ComponentRequirementId=6

-- Update 57 rows in dbo.AntigenType
UPDATE dbo.AntigenType SET BceSortColumn=40, LastUpdateDate='20110401 08:27:52.483', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=2
UPDATE dbo.AntigenType SET BceSortColumn=53, LastUpdateDate='20110401 08:27:52.483', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=3
UPDATE dbo.AntigenType SET BceSortColumn=54, LastUpdateDate='20110401 08:27:52.483', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=4
UPDATE dbo.AntigenType SET BceSortColumn=8, LastUpdateDate='20110401 08:27:52.500', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=6
UPDATE dbo.AntigenType SET BceSortColumn=10, LastUpdateDate='20110401 08:27:52.500', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=7
UPDATE dbo.AntigenType SET BceSortColumn=55, LastUpdateDate='20110401 08:27:52.513', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=9
UPDATE dbo.AntigenType SET BceSortColumn=46, LastUpdateDate='20110401 08:27:52.513', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=10
UPDATE dbo.AntigenType SET BceSortColumn=47, LastUpdateDate='20110401 08:27:52.513', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=11
UPDATE dbo.AntigenType SET BceSortColumn=57, LastUpdateDate='20110401 08:27:52.530', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=12
UPDATE dbo.AntigenType SET BceSortColumn=32, LastUpdateDate='20110401 08:27:52.530', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=13
UPDATE dbo.AntigenType SET BceSortColumn=33, LastUpdateDate='20110401 08:27:52.530', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=14
UPDATE dbo.AntigenType SET BceSortColumn=7, LastUpdateDate='20110401 08:27:52.547', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=15
UPDATE dbo.AntigenType SET BceSortColumn=42, LastUpdateDate='20110401 08:27:52.547', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=16
UPDATE dbo.AntigenType SET BceSortColumn=43, LastUpdateDate='20110401 08:27:52.560', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=17
UPDATE dbo.AntigenType SET BceSortColumn=44, LastUpdateDate='20110401 08:27:52.560', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=18
UPDATE dbo.AntigenType SET BceSortColumn=45, LastUpdateDate='20110401 08:27:52.560', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=19
UPDATE dbo.AntigenType SET BceSortColumn=9, LastUpdateDate='20110401 08:27:52.577', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=20
UPDATE dbo.AntigenType SET BceSortColumn=11, LastUpdateDate='20110401 08:27:52.577', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=21
UPDATE dbo.AntigenType SET BceSortColumn=34, LastUpdateDate='20110401 08:27:52.593', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=22
UPDATE dbo.AntigenType SET BceSortColumn=18, LastUpdateDate='20110401 08:27:52.593', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=23
UPDATE dbo.AntigenType SET BceSortColumn=19, LastUpdateDate='20110401 08:27:52.593', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=24
UPDATE dbo.AntigenType SET BceSortColumn=41, LastUpdateDate='20110401 08:27:52.607', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=25
UPDATE dbo.AntigenType SET BceSortColumn=16, LastUpdateDate='20110401 08:27:52.607', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=29
UPDATE dbo.AntigenType SET BceSortColumn=17, LastUpdateDate='20110401 08:27:52.607', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=30
UPDATE dbo.AntigenType SET BceSortColumn=61, LastUpdateDate='20110401 08:27:52.623', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=32
UPDATE dbo.AntigenType SET BceSortColumn=28, LastUpdateDate='20110401 08:27:52.623', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=33
UPDATE dbo.AntigenType SET BceSortColumn=29, LastUpdateDate='20110401 08:27:52.640', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=34
UPDATE dbo.AntigenType SET BceSortColumn=13, LastUpdateDate='20110401 08:27:52.640', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=35
UPDATE dbo.AntigenType SET BceSortColumn=59, LastUpdateDate='20110401 08:27:52.640', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=36
UPDATE dbo.AntigenType SET BceSortColumn=12, LastUpdateDate='20110401 08:27:52.653', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=37
UPDATE dbo.AntigenType SET BceSortColumn=14, LastUpdateDate='20110401 08:27:52.653', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=38
UPDATE dbo.AntigenType SET BceSortColumn=15, LastUpdateDate='20110401 08:27:52.670', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=39
UPDATE dbo.AntigenType SET BceSortColumn=26, LastUpdateDate='20110401 08:27:52.670', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=40
UPDATE dbo.AntigenType SET BceSortColumn=27, LastUpdateDate='20110401 08:27:52.670', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=42
UPDATE dbo.AntigenType SET BceSortColumn=30, LastUpdateDate='20110401 08:27:52.687', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=46
UPDATE dbo.AntigenType SET BceSortColumn=31, LastUpdateDate='20110401 08:27:52.687', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=47
UPDATE dbo.AntigenType SET BceSortColumn=48, LastUpdateDate='20110401 08:27:52.687', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=49
UPDATE dbo.AntigenType SET BceSortColumn=49, LastUpdateDate='20110401 08:27:52.700', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=50
UPDATE dbo.AntigenType SET BceSortColumn=20, LastUpdateDate='20110401 08:27:52.700', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=51
UPDATE dbo.AntigenType SET BceSortColumn=60, LastUpdateDate='20110401 08:27:52.717', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=52
UPDATE dbo.AntigenType SET BceSortColumn=37, LastUpdateDate='20110401 08:27:52.717', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=53
UPDATE dbo.AntigenType SET BceSortColumn=38, LastUpdateDate='20110401 08:27:52.717', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=54
UPDATE dbo.AntigenType SET BceSortColumn=21, LastUpdateDate='20110401 08:27:52.733', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=55
UPDATE dbo.AntigenType SET BceSortColumn=39, LastUpdateDate='20110401 08:27:52.733', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=56
UPDATE dbo.AntigenType SET BceSortColumn=25, LastUpdateDate='20110401 08:27:52.750', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=57
UPDATE dbo.AntigenType SET BceSortColumn=56, LastUpdateDate='20110401 08:27:52.750', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=60
UPDATE dbo.AntigenType SET BceSortColumn=23, LastUpdateDate='20110401 08:27:52.750', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=61
UPDATE dbo.AntigenType SET BceSortColumn=50, LastUpdateDate='20110401 08:27:52.763', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=62
UPDATE dbo.AntigenType SET BceSortColumn=22, LastUpdateDate='20110401 08:27:52.763', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=63
UPDATE dbo.AntigenType SET BceSortColumn=51, LastUpdateDate='20110401 08:27:52.763', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=64
UPDATE dbo.AntigenType SET BceSortColumn=52, LastUpdateDate='20110401 08:27:52.780', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=65
UPDATE dbo.AntigenType SET BceSortColumn=24, LastUpdateDate='20110401 08:27:52.780', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=66
UPDATE dbo.AntigenType SET BceSortColumn=35, LastUpdateDate='20110401 08:27:52.797', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=67
UPDATE dbo.AntigenType SET BceSortColumn=36, LastUpdateDate='20110401 08:27:52.797', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=68
UPDATE dbo.AntigenType SET BceSortColumn=58, LastUpdateDate='20110401 08:27:52.797', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=69
UPDATE dbo.AntigenType SET BceSortColumn=62, LastUpdateDate='20110401 08:27:52.810', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=70
UPDATE dbo.AntigenType SET BceSortColumn=63, LastUpdateDate='20110401 08:27:52.810', LastUpdateUser=N'vhaishsmithm' WHERE AntigenTypeId=71

-- Update 4 rows in dbo.BrokenRule
UPDATE dbo.BrokenRule SET ValidationMessage=N'Transfusion cannot end before issue or start date/time. Correct entry of issue or start date/time.', LastUpdateDate='20110407 16:12:52.397', LastUpdateUser=N'vhaishsmithm' WHERE FormName=N'FrmEnterPostTransfusionInfo' AND FieldName=N'TransfusionEndDateTime'
UPDATE dbo.BrokenRule SET ValidationMessage=N'Interface IP address or Domain name must be specified.', LastUpdateDate='20110307 09:32:05.757', LastUpdateUser=N'vhaishsmithm' WHERE FormName=N'HL7InterfaceConfig' AND FieldName=N'InterfaceIPAddressAndDomainNameNotSpecified'
UPDATE dbo.BrokenRule SET ValidationMessage=N'Interface IP address must be specified.', LastUpdateDate='20110307 09:32:05.757', LastUpdateUser=N'vhaishsmithm' WHERE FormName=N'HL7InterfaceConfig' AND FieldName=N'InterfaceIPAddressNotSet'
UPDATE dbo.BrokenRule SET ValidationMessage=N'Interface port number must be specified.', LastUpdateDate='20110307 09:32:05.757', LastUpdateUser=N'vhaishsmithm' WHERE FormName=N'HL7InterfaceConfig' AND FieldName=N'InterfacePortNumberNotSet'

-- Update 10 rows in dbo.TransfusionReactionType
UPDATE dbo.TransfusionReactionType SET SortColumn=3, LastUpdateDate='20110526 15:23:32.000', LastUpdateUser=N'vhaishsmithm' WHERE TransfusionReactionTypeCode=N'A'
UPDATE dbo.TransfusionReactionType SET TransfusionReactionTypeText=N'Transfusion Associated Circulatory Overload (TACO)', SortColumn=9, LastUpdateDate='20110526 15:23:32.000', LastUpdateUser=N'vhaishsmithm' WHERE TransfusionReactionTypeCode=N'C'
UPDATE dbo.TransfusionReactionType SET SortColumn=5, LastUpdateDate='20110526 15:23:32.000', LastUpdateUser=N'vhaishsmithm' WHERE TransfusionReactionTypeCode=N'D'
UPDATE dbo.TransfusionReactionType SET SortColumn=6, LastUpdateDate='20110526 15:23:32.000', LastUpdateUser=N'vhaishsmithm' WHERE TransfusionReactionTypeCode=N'F'
UPDATE dbo.TransfusionReactionType SET SortColumn=7, LastUpdateDate='20110526 15:23:32.000', LastUpdateUser=N'vhaishsmithm' WHERE TransfusionReactionTypeCode=N'G'
UPDATE dbo.TransfusionReactionType SET TransfusionReactionTypeText=N'Acute Hemolysis (ABO Incompatibility)', SortColumn=1, LastUpdateDate='20110526 15:23:32.000', LastUpdateUser=N'vhaishsmithm' WHERE TransfusionReactionTypeCode=N'H'
UPDATE dbo.TransfusionReactionType SET TransfusionReactionTypeText=N'Transfusion Related Acute Lung Injury (TRALI)', SortColumn=10, LastUpdateDate='20110526 15:23:32.000', LastUpdateUser=N'vhaishsmithm' WHERE TransfusionReactionTypeCode=N'L'
UPDATE dbo.TransfusionReactionType SET SortColumn=14, LastUpdateDate='20110526 15:23:32.000', LastUpdateUser=N'vhaishsmithm' WHERE TransfusionReactionTypeCode=N'O'
UPDATE dbo.TransfusionReactionType SET TransfusionReactionTypeText=N'Post-Transfusion: Associated Disease', LastUpdateDate='20110526 15:23:32.000', LastUpdateUser=N'vhaishsmithm' WHERE TransfusionReactionTypeCode=N'P'
UPDATE dbo.TransfusionReactionType SET SortColumn=13, LastUpdateDate='20110526 15:23:32.000', LastUpdateUser=N'vhaishsmithm' WHERE TransfusionReactionTypeCode=N'U'

-- Add 276 rows to dbo.BloodProduct
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'021d44a7-dc83-49b0-a339-1b19acf66f3b', N'RED BLOOD CELLS|CPDA-1/500mL/refg|For mnf:injectable|Irradiated|ResLeu:<5log6', N'RBC CPDA-1 MNFI IRD LUKOPR', N'E002', N'@08 A2 C2 D4', 250, N'E7189', 672, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'022b6972-b948-4089-b874-c47860bd7c73', N'Washed Apheresis PLATELETS|None/XX/20-24C|Irradiated|ResLeu:<5log6|1st container', N'PLT AFR Wash None IRD LUKOPR', N'E027', N'@71 C2 D4 H3', 200, N'E7390', 4, 0, 0, 1, N'E027', NULL, N'A', '20110727 10:54:18.817', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'04797e78-1dec-49d7-b088-19319e6bf5bc', N'Thawed Apheresis PLASMA|CP2D/XX/refg|Open|Cryo reduced', N'PLASMA AFR Thaw CP2D OPN CRYORed', N'E013', N'@13 B2 E3', 225, N'E7306', 24, 0, 0, 1, N'E015', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'04d4290c-fc98-4d9a-a135-ddf55e4fb96f', N'POOLED PLATELETS|CPDA-1/XX/20-24C|Open|Plasma reduced', N'PLT Pool CPDA-1 OPN PLS Red', N'E022', N'@B8 B2 E5', 200, N'E7338', 4, 0, 0, 1, N'E022', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'04dc7465-9f68-4b8d-b773-c128b307f491', N'Liquid Apheresis PLASMA|ACD-A/XX/refg|Fin Con:NS|2nd container', N'PLASMA AFR Liq ACD-A', N'E011', N'@54 F2 H4', 225, N'E7359', 120, 0, 0, 1, N'E041', NULL, N'A', '20110727 10:54:18.537', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0619624b-4949-4543-84c3-36ef9c39f442', N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-25C|For mnf:noninjectable|Frozen <=24h', N'FFP AFR ACD-A MNFNI', N'E012', N'@AI A3 G7', 225, N'E7283', 8760, 0, 0, 1, N'E012', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'08615afe-a903-41bb-acf3-e6d5062da25b', N'RED BLOOD CELLS|CPD/XX/refg|Not for tx or mnf|LowVol:anticoag not adj', N'RBC CPD NMT LowVol', N'E002', N'@06 A4 F3', 250, N'E7199', 504, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'092c5385-3ab2-4f66-8f8a-62ee048f6219', N'Thawed Apheresis FRESH FROZEN PLASMA|CPD-50/XX/refg|Frozen <=24h', N'FFP AFR Thaw CPD-50', N'E013', N'@AX G7', 225, N'E7294', 24, 0, 0, 1, N'E013', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'09b744b7-f477-43bc-917b-955a0732b756', N'Thawed CRYOPRECIPITATE|CPDA-1/450mL/rt', N'CRYO Thaw CPDA-1', N'E029', N'@87', 15, N'E7335', 6, 0, 0, 1, N'E029', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'09ca4788-5094-4110-ba01-b5aba7a46165', N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|6th container', N'PLASMA AFR Thaw NaCit', N'E013', N'@55 HA', 225, N'E7411', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.723', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0afbf503-0049-428a-84af-78acd999a295', N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|3rd container', N'PLASMA AFR Thaw NaCit', N'E013', N'@55 H5', 225, N'E7408', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.690', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0afc858a-3e7f-4757-b53d-0b36d10d7fa7', N'Washed POOLED PLATELETS|None/XX/20-24C|Open|Buffy coat plts prep|From 4 donors', N'PLT Pool Wash None OPN BUFCT 4DNR', N'E023', N'@71 B2 G2 J4', 200, N'E7226', 4, 0, 0, 1, N'E023', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0cd72a1d-4c3f-49fd-a1a0-31f5a6acf56f', N'POOLED PLATELETS|PAS-E/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Supernat rem/Plasma added|Buffy coat plts prep|From 6 donors', N'PLT Pool PAS-E OPN IRD LUKOPR SR/PA BUFCT 6DNR', N'E022', N'@D5 B2 C2 D5 E8 G2 J6', 200, N'E6969', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0d51d553-3036-4d79-a4a0-a8f0153b5265', N'Apheresis RED BLOOD CELLS|ACD-A>AS1/XX/refg|Not for tx or mnf|ResLeu:<5log6', N'RBC AFR ACD-A>AS1 NMT LUKOPR', N'E009', N'@AY A4 D4', 350, N'E7183', 1008, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0daa46cc-eb58-4c07-b7ab-ec60efb03f33', N'RED BLOOD CELLS|CPD>AS5/450mL/refg|Open|Irradiated|ResLeu:<5log6|Albumin added', N'RBC CPD>AS5 OPN IRD LUKOPR ALB Add', N'E002', N'@22 B2 C2 D4 E2', 350, N'E7291', 24, 0, 0, 1, N'E002', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0e21e205-b785-4d0f-a96d-d8073b9c93e2', N'Thawed Apheresis FRESH FROZEN PLASMA|CP2D/XX/refg|<200 mL', N'FFP AFR Thaw CP2D LowVol', N'E013', N'@13 F4', 225, N'E7302', 24, 0, 0, 1, N'E013', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0e50a24e-3bd1-4cf6-842a-edd5bb3e2fb9', N'Washed POOLED PLATELETS|None/XX/20-24C|Open|Buffy coat plts prep|From 5 donors', N'PLT Pool Wash None OPN BUFCT 5DNR', N'E023', N'@71 B2 G2 J5', 200, N'E7227', 4, 0, 0, 1, N'E023', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0ea937d3-2779-4cb7-a9b1-957c21163edb', N'Thawed POOLED CRYOPRECIPITATE|NS/XX/rt|Open|Quar:>=112d/retested|From 2 donors', N'CRYO Pool Thaw NS OPN QUAR 2DNR', N'E031', N'@92 B2 I4 J2', 100, N'E7347', 4, 0, 0, 1, N'E031', NULL, N'A', '20110727 10:54:18.833', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0f77e612-93df-42ba-bc51-845d00a62380', N'Lyophilized FRESH FROZEN PLASMA|CPD/XX/refg', N'FFP Lyfo CPD', N'E010', N'@06', 1, N'E7284', 8760, 0, 0, 1, N'E066', NULL, N'A', '20110513 13:59:03.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1139dff5-8d74-472f-a47e-9f14dc156e2d', N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|3rd container', N'PLASMA AFR Thaw NaCit IRD', N'E013', N'@55 C2 H5', 225, N'E7414', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.740', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'125017f2-a4ce-4cac-a6ca-404c4679c2d4', N'PLASMA|CPDA-1/XX/<=-5C|For mnf:injectable restr use|Frozen <=120h', N'PLASMA CPDA-1 MNFRI', N'E010', N'@D9 A6 G9', 225, N'E7379', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.457', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'13a3028b-4579-4937-9a73-2189eb4c9a02', N'PLATELETS|CP2D/500mL/20-24C|Irradiated|ResLeu:<8.3log5|Bacterial monitoring', N'PLT CP2D IRD LUKOPR BacMtr', N'E020', N'@69 C2 D6 N2', 50, N'E7341', 120, 0, 0, 1, N'E020', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'145127fa-5147-471f-8c39-c43b2213b2f6', N'Thawed Apheresis PLASMA|CP2D/XX/refg|<200 mL', N'PLASMA AFR Thaw CP2D LowVol', N'E013', N'@13 F4', 225, N'E7308', 120, 0, 0, 1, N'E015', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'14a106a5-37f4-423a-aedf-47eee4fe3340', N'Washed POOLED PLATELETS|None/XX/20-24C|Open|Buffy coat plts prep|From 6 donors', N'PLT Pool Wash None OPN BUFCT 6DNR', N'E023', N'@71 B2 G2 J6', 200, N'E7228', 4, 0, 0, 1, N'E023', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'159e96f3-6eaf-49f2-bc49-870b12eb435c', N'Apheresis PLATELETS|ACD-A/XX/20-24C|Open|Irradiated|ResLeu:<5log6|Plasma reduced|1st container|<3log11 plts', N'PLT AFR ACD-A OPN IRD LUKOPR PLS Red', N'E024', N'@73 B2 C2 D4 E5 H3 JI', 200, N'E6376', 4, 0, 0, 1, N'E024', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'15c57383-cbd5-423e-9add-1f75b184973d', N'Thawed Apheresis PLASMA|CP2D/XX/refg|Irradiated|ResLeu:NS|>=400mL<600mL', N'PLASMA AFR Thaw CP2D IRD LUKOPR LowVol', N'E013', N'@13 C2 D2 F6', 225, N'E7395', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.613', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'16f9671d-4652-4fa1-bfa1-fcbcc894f3b7', N'FRESH FROZEN PLASMA|CPD/XX/<-25C|Frozen <=15h|Riboflavin-treated', N'FFP CPD Ribo', N'E010', N'@A1 G5 K6', 225, N'E7344', 8760, 0, 0, 1, N'E010', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'17173b52-39f7-46df-92ec-a504a7117888', N'FRESH FROZEN PLASMA|CPDA-1/XX/<-25C|Frozen <=15h|Riboflavin-treated', N'FFP CPDA-1 Ribo', N'E010', N'@38 G5 K6', 225, N'E7343', 8760, 0, 0, 1, N'E010', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'17238fe9-06dc-400f-90f0-4fcbf27ad221', N'PLASMA|CPD/XX/<=-5C|For mnf:injectable restr use|Cryo reduced', N'PLASMA CPD MNFRI CRYORed', N'E010', N'@D8 A6 E3', 225, N'E7372', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.397', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'17bab35b-dd77-4c35-9593-a324d4ab38ba', N'POOLED PLATELETS|CPD/XX/20-24C|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 6 donors', N'PLT Pool CPD LUKOPR PLS Red/PA BUFCT 6DNR', N'E022', N'@A7 D5 EE G2 J6', 200, N'E7256', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1848240d-72c6-4940-8816-6154dba383f2', N'POOLED PLATELETS|CPD/XX/20-24C|Open|ResLeu:<1log6|Plasma reduced/Plasma added|From 5 donors', N'PLT Pool CPD OPN LUKOPR PLS Red/PA 5DNR', N'E022', N'@A7 B2 D5 EE J5', 200, N'E7241', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1849947d-9f4b-49e6-8b31-2168671d7edc', N'PLASMA|CPD/XX/<=-5C|For mnf:injectable|Frozen <=72h', N'PLASMA CPD MNFI', N'E010', N'@D8 A2 GD', 225, N'E7366', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.350', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'18e1eace-da5c-41ac-a901-9f9dab6589d6', N'Liquid PLASMA|CPD/XX/<37C|For mnf:noninjectable|Cryo reduced', N'PLASMA Liq CPD MNFNI CRYORed', N'E011', N'@61 A3 E3', 225, N'E7217', 624, 0, 0, 1, N'E016', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'19212f25-444c-4362-ba5d-6da47fcf499b', N'Thawed CRYOPRECIPITATE|CPDA-1/450mL/rt|Quar:>=112d/retested', N'CRYO Thaw CPDA-1 QUAR', N'E029', N'@87 I4', 15, N'E7333', 6, 0, 0, 1, N'E029', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1a149eb0-0b83-49c7-b0ad-5f8d8a44d5e0', N'Thawed FRESH FROZEN PLASMA|CPD/450mL/refg|Quar:>=112d/retested', N'FFP Thaw CPD QUAR', N'E011', N'@03 I4', 225, N'E7232', 24, 0, 0, 1, N'E011', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1a202f30-2f1c-4b97-949d-6f4d60984073', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|From 4 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red/PA 4DNR', N'E022', N'@A7 B2 C2 D5 EE J4', 200, N'E7245', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1a99ebca-5991-46ef-9d3d-8eaa92b5948d', N'Washed POOLED PLATELETS|None/XX/20-24C|Open|Buffy coat plts prep|From 7 donors', N'PLT Pool Wash None OPN BUFCT 7DNR', N'E023', N'@71 B2 G2 J7', 200, N'E7229', 4, 0, 0, 1, N'E023', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1b0fa424-6294-42ac-b96d-ca2d49437479', N'Thawed POOLED CRYOPRECIPITATE|NS/XX/rt|Open|Quar:>=112d/retested|From 4 donors', N'CRYO Pool Thaw NS OPN QUAR 4DNR', N'E031', N'@92 B2 I4 J4', 100, N'E7349', 4, 0, 0, 1, N'E031', NULL, N'A', '20110727 10:54:18.850', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1b51d733-3dcc-40b4-9f95-4a9490d3900d', N'Thawed Apheresis PLASMA|CP2D/XX/refg|2nd container', N'PLASMA AFR Thaw CP2D', N'E013', N'@13 H4', 225, N'E7311', 120, 0, 0, 1, N'E015', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1b5580c6-a9ed-4509-b898-4b8f217e4a6b', N'WHOLE BLOOD|CPDA-1/XX/refg|Not for tx or mnf|LowVol:anticoag not adj', N'WB CPDA-1 NMT LowVol', N'E001', N'@10 A4 F3', 250, N'E7175', 840, 0, 0, 1, N'E001', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1bb8b528-fef7-4eb3-a567-8e3c65d1e3b2', N'Washed Thawed POOLED PLATELETS|NS/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Buffy coat plts prep|From 3 donors', N'PLT Pool Thaw Wash NS OPN IRD LUKOPR BUFCT 3DNR', N'E023', N'@72 B2 C2 D5 G2 J3', 200, N'E7337', 4, 0, 0, 1, N'E064', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1be0b552-6225-465a-989d-f2d3dc0de4a7', N'RED BLOOD CELLS|CPD>AS5/500mL/refg|For mnf:injectable|ResLeu:<5log6', N'RBC CPD>AS5 MNFI LUKOPR', N'E002', N'@23 A2 D4', 350, N'E7216', 1008, 0, 0, 1, N'E002', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1c8deba2-e780-41eb-9747-947a967c1b10', N'Thawed PLASMA|CP2D/XX/refg|ResLeu:NS|Frozen <=24h', N'PLASMA Thaw CP2D LUKOPR', N'E011', N'@13 D2 G7', 225, N'E7317', 120, 0, 0, 1, N'E018', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1eb34f57-4dc3-489c-9e60-3073e2782890', N'RED BLOOD CELLS|CP2D/500mL/refg|For mnf:injectable|ResLeu:<5log6', N'RBC CP2D MNFI LUKOPR', N'E002', N'@12 A2 D4', 250, N'E7215', 504, 0, 0, 1, N'E002', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1f6da9ef-2388-424f-857c-23db61052fa8', N'Thawed PLASMA|CPD/XX/refg|ResLeu:<5log6', N'PLASMA Thaw CPD LUKOPR', N'E011', N'@06 D4', 225, N'E7315', 120, 0, 0, 1, N'E018', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'20d6d01f-dcbc-4e0e-853b-94648ee0bd51', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|Plasma reduced/Plasma added|From 4 donors', N'PLT Pool CPD OPN IRD PLS Red/PA 4DNR', N'E022', N'@A7 B2 C2 EE J4', 200, N'E7250', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'21ead686-5175-4ec5-8471-3c6152e74359', N'Apheresis PLATELETS|ACD-A/XX/20-24C|Open|Irradiated|ResLeu:<5log6|Plasma reduced|3rd container|<3log11 plts', N'PLT AFR ACD-A OPN IRD LUKOPR PLS Red', N'E024', N'@73 B2 C2 D4 E5 H5 JI', 200, N'E6846', 4, 0, 0, 1, N'E024', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'22fb3050-a3dd-4b64-a2bf-706b09d77b76', N'Thawed Apheresis FRESH FROZEN PLASMA|CP2D/XX/refg|Irradiated|ResLeu:NS|>=400mL<600mL', N'FFP AFR Thaw CP2D IRD LUKOPR LowVol', N'E013', N'@13 C2 D2 F6', 225, N'E7393', 24, 0, 0, 1, N'E013', NULL, N'A', '20110727 10:54:18.600', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'24209f80-7611-4689-bc92-7367bbcd48dc', N'Thawed POOLED PLASMA|CPD/XX/refg', N'PLASMA Pool Thaw CPD', N'E011', N'@06 ', 500, N'E7402', 4, 0, 0, 1, N'E055', NULL, N'A', '20110727 10:54:18.567', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'24f573a0-8468-49f0-9977-31b19e20fd63', N'POOLED PLATELETS|CPD/XX/20-24C|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 5 donors', N'PLT Pool CPD LUKOPR PLS Red/PA BUFCT 5DNR', N'E022', N'@A7 D5 EE G2 J5', 200, N'E7255', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'260cc15d-e6e2-4b45-916d-fd0f60db1a2c', N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<-25C', N'FFP AFR NaCit', N'E012', N'@CQ ', 225, N'E7222', 8760, 0, 0, 1, N'E012', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'26749bb8-d8e0-4591-8461-e19b9a41bede', N'RED BLOOD CELLS|CPD>AS1/XX/refg|Not for tx or mnf|ResLeu:<5log6|LowVol:anticoag not adj', N'RBC CPD>AS1 NMT LUKOPR LowVol', N'E002', N'@98 A4 D4 F3', 350, N'E7191', 1008, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2826b172-40a6-4d95-a7d0-29fe9c24909c', N'Thawed PLASMA|CPD/XX/refg|ResLeu:NS|Frozen <=24h', N'PLASMA Thaw CPD LUKOPR', N'E011', N'@06 D2 G7', 225, N'E7314', 120, 0, 0, 1, N'E018', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'28dc9a44-66a3-4040-8a07-f89592dac551', N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|5th container', N'PLASMA AFR Thaw NaCit', N'E013', N'@55 H9', 225, N'E7410', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.723', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2a665483-358a-4c81-b6a0-ff26a697220c', N'PLASMA|CPD/XX/<=-5C|For mnf:noninjectable', N'PLASMA CPD MNFNI', N'E010', N'@D8 A3', 225, N'E7380', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.473', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2ad97d3c-293f-4524-8224-ebc56fac825f', N'POOLED PLATELETS|PAS-E/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Supernat rem/Plasma added|Buffy coat plts prep|From 5 donors', N'PLT Pool PAS-E OPN IRD LUKOPR SR/PA BUFCT 5DNR', N'E022', N'@D5 B2 C2 D5 E8 G2 J5', 200, N'E6968', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2c64bd58-4a62-41e7-9c77-f56729adf4ec', N'PLASMA|CPD/XX/<=-5C|For mnf:injectable|Frozen <=120h', N'PLASMA CPD MNFI', N'E010', N'@D8 A2 G9', 225, N'E7367', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.363', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2efedf29-1ddc-4b45-a067-a130f82951c6', N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Open|Cryo reduced', N'PLASMA AFR Thaw ACD-A OPN CRYORed', N'E013', N'@54 B2 E3', 225, N'E7407', 24, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.690', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'302731dd-95e0-4174-94c5-0660722b7030', N'Washed POOLED PLATELETS|PAS-E/XX/20-24C|ResLeu:<1log6|Buffy coat plts prep|Riboflavin-treated', N'PLT Pool Wash PAS-E LUKOPR BUFCT Ribo', N'E023', N'@D5 D5 G2 K6', 200, N'E7356', 4, 0, 0, 1, N'E023', NULL, N'A', '20110727 10:54:18.770', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'304a3810-bd82-4672-af5e-6ebc550d0e1c', N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Quar:>=112d/retested', N'FFP AFR Thaw NaCit QUAR', N'E013', N'@55 I4', 225, N'E7231', 24, 0, 0, 1, N'E013', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'30ea7634-b0f8-49c2-8309-08367c9d120b', N'Apheresis RED BLOOD CELLS|ACD-A>AS1/XX/refg|For mnf:injectable|Irradiated|ResLeu:<5log6', N'RBC AFR ACD-A>AS1 MNFI IRD LUKOPR', N'E009', N'@AY A2 C2 D4', 350, N'E7210', 672, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'31b6cb7b-5078-4c05-848b-61ee1bee156a', N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|4th container', N'PLASMA AFR Thaw NaCit IRD', N'E013', N'@55 C2 H6', 225, N'E7415', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.753', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'322cfaab-ce42-44b3-aa09-8b77737c9c19', N'POOLED PLATELETS|PAS-E/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Supernat rem/Plasma added|Buffy coat plts prep|From 7 donors', N'PLT Pool PAS-E OPN IRD LUKOPR SR/PA BUFCT 7DNR', N'E022', N'@D5 B2 C2 D5 E8 G2 J7', 200, N'E6970', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3436ce8f-30c7-4da4-bcb5-a9a367902a02', N'WHOLE BLOOD|CPDA-1/XX/refg|Not for tx or mnf|ResLeu:<5log6|LowVol:anticoag not adj', N'WB CPDA-1 NMT LUKOPR LowVol', N'E001', N'@10 A4 D4 F3', 250, N'E7173', 840, 0, 0, 1, N'E001', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'347fdff6-9fbd-4683-9331-38ed277d92f8', N'Thawed Apheresis PLASMA|ACD-A/XX/refg|ResLeu:<5log6', N'PLASMA AFR Thaw ACD-A LUKOPR', N'E013', N'@54 D4', 225, N'E7404', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.660', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'36a1d208-58af-4339-b5fa-6d29c2faee2a', N'Frozen Apheresis RED BLOOD CELLS|Gly40%/XX/<-65C|Open|ResLeu:<1log6|1st container', N'RBC AFR Froz Gly40% OPN LUKOPR', N'E050', N'@B3 B2 D5 H3', 200, N'E7168', 87600, 0, 0, 1, N'E050', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'36efe105-631a-4445-9a30-c7fea057fa40', N'RED BLOOD CELLS|CPD/XX/refg|Not for tx or mnf|ResLeu:<5log6|LowVol:anticoag adj', N'RBC CPD NMT LUKOPR LowVol', N'E002', N'@06 A4 D4 F8', 250, N'E7198', 504, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'371f3c24-f203-48df-9676-35b5135348e3', N'POOLED PLATELETS|CPD/XX/20-24C|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 4 donors', N'PLT Pool CPD LUKOPR PLS Red/PA BUFCT 4DNR', N'E022', N'@A7 D5 EE G2 J4', 200, N'E7254', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'381822e1-ee2f-4e5e-97e4-22c5028cde18', N'RED BLOOD CELLS|CPD>SAGM/500mL/refg|ResLeu:<5log6|Plasma reduced', N'RBC CPD>SAGM LUKOPR PLS Red', N'E002', N'@CM D4 E5', 350, N'E7289', 1008, 0, 0, 1, N'E002', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'38f0af83-68e5-45cd-a8fa-bbd42ffb5f01', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Plasma reduced/Plasma added|From 4 donors', N'PLT Pool CPD OPN PLS Red/PA 4DNR', N'E022', N'@A7 B2 EE J4', 200, N'E7235', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3901a6b6-7c12-4188-b121-50d29da6d97a', N'Thawed POOLED CRYOPRECIPITATE|NS/XX/rt|Open|Quar:>=112d/retested|From 6 donors', N'CRYO Pool Thaw NS OPN QUAR 6DNR', N'E031', N'@92 B2 I4 J6', 100, N'E7351', 4, 0, 0, 1, N'E031', NULL, N'A', '20110727 10:54:18.863', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'395c8cfa-7223-496b-b342-b8ced9b2bcbe', N'FRESH FROZEN PLASMA|CPD/450mL/<-25C|Frozen <=24h', N'FFP CPD', N'E010', N'@A2 G7', 225, N'E7293', 8760, 0, 0, 1, N'E010', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3bb3f454-c23e-4723-a23a-8137246cda40', N'Thawed FRESH FROZEN PLASMA|CPD/450mL/refg|Frozen <=24h', N'FFP Thaw CPD', N'E011', N'@03 G7', 225, N'E7292', 24, 0, 0, 1, N'E011', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3d116aff-43ed-49a9-b483-4fccf853b652', N'Apheresis RED BLOOD CELLS|ACD-A>AS1/XX/refg|Open|Irradiated|ResLeu:<5log6|Plasma added|1st container', N'RBC AFR ACD-A>AS1 OPN IRD LUKOPR PA', N'E009', N'@AY B2 C2 D4 E4 H3', 350, N'E7267', 24, 0, 0, 1, N'E009', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3e48a72e-ac91-40a8-8254-7a12aecbb636', N'Thawed FRESH FROZEN PLASMA|CP2D/XX/refg|ResLeu:NS', N'FFP Thaw CP2D LUKOPR', N'E011', N'@13 D2', 225, N'E7301', 24, 0, 0, 1, N'E011', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3e77369a-739d-43f7-bad1-8a7b2b596d69', N'POOLED PLATELETS|CPD/XX/20-24C|Open|ResLeu:<1log6|Plasma reduced/Plasma added|From 3 donors', N'PLT Pool CPD OPN LUKOPR PLS Red/PA 3DNR', N'E022', N'@A7 B2 D5 EE J3', 200, N'E7239', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3eba5350-8b2d-4256-929e-fe4a26363968', N'Apheresis RED BLOOD CELLS|ACD-A/XX/refg|Not for tx or mnf|ResLeu:<5log6|1st container', N'RBC AFR ACD-A NMT LUKOPR', N'E009', N'@54 A4 D4 H3', 350, N'E7212', 504, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3f164747-e529-4783-b4bf-96dedda8503d', N'Washed POOLED PLATELETS|None/XX/20-24C|Open|Buffy coat plts prep|From 2 donors', N'PLT Pool Wash None OPN BUFCT 2DNR', N'E023', N'@71 B2 G2 J2', 200, N'E7224', 4, 0, 0, 1, N'E023', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3f8ea6bd-9b9f-46a4-a347-8010fe32c8a6', N'Washed Apheresis PLATELETS|None/XX/20-24C|Irradiated|ResLeu:<5log6|2nd container', N'PLT AFR Wash None IRD LUKOPR', N'E027', N'@71 C2 D4 H4', 200, N'E7391', 4, 0, 0, 1, N'E027', NULL, N'A', '20110727 10:54:18.817', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'40cb83eb-b7ed-4bce-97ae-b18c8325ef74', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|Plasma reduced/Plasma added|From 7 donors', N'PLT Pool CPD OPN IRD PLS Red/PA 7DNR', N'E022', N'@A7 B2 C2 EE J7', 200, N'E7253', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'41b5e41e-6762-4f22-8106-58d93cc5c3bd', N'Thawed CRYOPRECIPITATE|CPD/450mL/rt', N'CRYO Thaw CPD', N'E029', N'@85', 15, N'E7332', 6, 0, 0, 1, N'E029', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'41c627c8-e6dc-47e2-900a-9cc826fedd6c', N'PLASMA|CPD/XX/<=-5C|For mnf:injectable restr use|Frozen <=24h', N'PLASMA CPD MNFRI', N'E010', N'@D8 A6 G7', 225, N'E7373', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.410', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'42aea05c-48f1-4545-a0e3-25a1e5223f79', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|Plasma reduced/Plasma added|From 6 donors', N'PLT Pool CPD OPN IRD PLS Red/PA 6DNR', N'E022', N'@A7 B2 C2 EE J6', 200, N'E7252', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4314595a-6922-4966-865e-ecd8a7e32e07', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|Plasma reduced/Plasma added|From 3 donors', N'PLT Pool CPD OPN IRD PLS Red/PA 3DNR', N'E022', N'@A7 B2 C2 EE J3', 200, N'E7249', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'44188a60-6b35-4e17-9197-e9a80fc29a92', N'PLASMA|CPD/XX/<=-5C|For mnf:noninjectable restr use', N'PLASMA CPD MNFRNI', N'E010', N'@D8 A5', 225, N'E7384', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.503', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4440b9ce-ee6d-4d2a-bd31-0671f72c1ef8', N'Washed POOLED PLATELETS|None/XX/20-24C|Open|Buffy coat plts prep|From 8 donors', N'PLT Pool Wash None OPN BUFCT 8DNR', N'E023', N'@71 B2 G2 J8', 200, N'E7230', 4, 0, 0, 1, N'E023', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4490e9bf-5c47-425e-9917-d02ec9032271', N'PLATELETS|CPD/500mL/20-24C|Open|ResLeu:<8.3log5|Plasma reduced/Plasma added', N'PLT CPD OPN LUKOPR PLS Red/PA', N'E020', N'@65 B2 D6 EE', 50, N'E7321', 4, 0, 0, 1, N'E020', NULL, N'A', '20110510 08:04:22.083', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'44dfc29f-230b-42a1-b24c-5d7e4de7ec78', N'PLATELETS|CPD/500mL/20-24C|Irradiated|Bacterial test', N'PLT CPD IRD BacTest', N'E020', N'@65 C2 N3', 50, N'E7220', 120, 0, 0, 1, N'E020', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'44e56da2-08fc-46c3-9368-9697545886ed', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 3 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red/PA BUFCT 3DNR', N'E022', N'@A7 B2 C2 D5 EE G2 J3', 200, N'E6529', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'452d62ba-43dc-4cde-91f8-7b4e380a7683', N'RED BLOOD CELLS|CPD>AS1/XX/refg|Not for tx or mnf|LowVol:anticoag not adj', N'RBC CPD>AS1 NMT LowVol', N'E002', N'@98 A4 F3', 350, N'E7193', 1008, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'45ea5306-b05d-48a6-9a17-8e7265980bf3', N'Thawed Apheresis PLASMA|ACD-A/XX/refg|ResLeu:<5log6|>=200mL<400mL', N'PLASMA AFR Thaw ACD-A LUKOPR LowVol', N'E013', N'@54 D4 F5', 225, N'E7406', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.677', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'48cff8be-f23c-43ea-82cb-958f8efc3574', N'Washed Apheresis PLATELETS|PAS-E/XX/20-24C|ResLeu:<1log6|Riboflavin-treated', N'PLT AFR Wash PAS-E LUKOPR Ribo', N'E027', N'@D5 D5 K6', 200, N'E7357', 4, 0, 0, 1, N'E027', NULL, N'A', '20110727 10:54:18.800', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'493ca5ec-c11d-4d38-9bff-581398d2dd0c', N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|2nd container', N'PLASMA AFR Thaw ACD-A IRD', N'E013', N'@54 C2 H4', 225, N'E7397', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.630', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'49bd8c34-624f-4f33-b8e7-83739b03ee99', N'Frozen Apheresis RED BLOOD CELLS|Gly40%/XX/<-65C|Open|ResLeu:<1log6|2nd container', N'RBC AFR Froz Gly40% OPN LUKOPR', N'E050', N'@B3 B2 D5 H4', 200, N'E7169', 87600, 0, 0, 1, N'E050', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4ba069ab-b4bb-4bac-b494-fafe312c83ce', N'Thawed POOLED CRYOPRECIPITATE|NS/XX/rt|Open|Quar:>=112d/retested|From 3 donors', N'CRYO Pool Thaw NS OPN QUAR 3DNR', N'E031', N'@92 B2 I4 J3', 100, N'E7348', 4, 0, 0, 1, N'E031', NULL, N'A', '20110727 10:54:18.850', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4bc41e32-29c0-4edc-b0f5-0017277f30bf', N'Thawed FRESH FROZEN PLASMA|CPDA-1/450mL/refg|Riboflavin-treated', N'FFP Thaw CPDA-1 Ribo', N'E011', N'@07 K6', 225, N'E7362', 24, 0, 0, 1, N'E011', NULL, N'A', '20110727 10:54:18.550', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4ca9027f-1406-4149-bc5c-71756b2cf209', N'Liquid Apheresis PLASMA|ACD-A/XX/refg|Fin Con:NS|1st container', N'PLASMA AFR Liq ACD-A', N'E011', N'@54 F2 H3', 225, N'E7358', 120, 0, 0, 1, N'E041', NULL, N'A', '20110727 10:54:18.520', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4d9a9e5e-5ef2-42ec-ac06-da5747e4657e', N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|1st container', N'PLASMA AFR Thaw ACD-A IRD', N'E013', N'@54 C2 H3', 225, N'E7396', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.613', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4e0ddff0-1d63-4e26-bc46-367b70fb2d54', N'Thawed Apheresis PLATELETS|DMSO/XX/20-24C|Irradiated|ResLeu:<5log6|1st container', N'PLT AFR Thaw DMSO IRD LUKOPR', N'E026', N'@77 C2 D4 H3', 200, N'E7329', 4, 0, 0, 1, N'E026', NULL, N'A', '20110510 08:04:22.083', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4e3f3e3a-e6e7-4890-a098-130cddfd2455', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 6 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red/PA BUFCT 6DNR', N'E022', N'@A7 B2 C2 D5 EE G2 J6', 200, N'E6532', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'501b6833-c4a2-4971-bb62-d3fd16a63bc6', N'Liquid Apheresis PLASMA|ACD-A/XX/refg|Irradiated', N'PLASMA AFR Liq ACD-A IRD', N'E011', N'@54 C2', 225, N'E7172', 120, 0, 0, 1, N'E041', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'502adfa0-981c-4f47-a156-699e602353bd', N'PLATELETS|CP2D/500mL/20-24C|ResLeu:<8.3log5|Bacterial monitoring', N'PLT CP2D LUKOPR BacMtr', N'E020', N'@69 D6 N2', 50, N'E7340', 120, 0, 0, 1, N'E020', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'524511ac-0c81-43e0-a5c7-b264733975a0', N'RED BLOOD CELLS|CP2D>AS3/500mL/refg|For mnf:injectable|Irradiated|ResLeu:<5log6', N'RBC CP2D>AS3 MNFI IRD LUKOPR', N'E002', N'@21 A2 C2 D4', 350, N'E7290', 672, 0, 0, 1, N'E002', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'55335e7e-38bf-44f6-98fb-1e9f1d300812', N'Thawed POOLED PLATELETS|DMSO/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Buffy coat plts prep|From 4 donors|Riboflavin-treated', N'PLT Pool Thaw DMSO OPN IRD LUKOPR BUFCT 4DNR Ribo', N'E022', N'@77 B2 C2 D5 G2 J4 K6', 200, N'E7070', 4, 0, 0, 1, N'E061', NULL, N'A', '20110510 07:59:27.820', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'554d5f00-8ef9-4b50-9a56-71736a406317', N'Apheresis PLATELETS|ACD-A/XX/20-24C|Open|Irradiated|ResLeu:<5log6|Plasma reduced|1st container|Approx 300 log9 plts', N'PLT AFR ACD-A OPN IRD LUKOPR PLS Red', N'E024', N'@73 B2 C2 D4 E5 H3 JC', 200, N'E6421', 4, 0, 0, 1, N'E024', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'559c1e17-818f-4466-a6bf-30fa0469aa21', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 2 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red/PA BUFCT 2DNR', N'E022', N'@A7 B2 C2 D5 EE G2 J2', 200, N'E6528', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'56496d31-bfa0-44a0-ab1a-b341410fa159', N'RED BLOOD CELLS|CPDA-1/XX/refg|Not for tx or mnf|ResLeu:<5log6|LowVol:anticoag adj', N'RBC CPDA-1 NMT LUKOPR LowVol', N'E002', N'@10 A4 D4 F8', 250, N'E7185', 840, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'56f8cd53-8e52-49fc-a174-4e59019ceb26', N'Apheresis RED BLOOD CELLS|CP2D>AS3/XX/refg|Open|ResLeu:<5log6|Albumin added|1st container', N'RBC AFR CP2D>AS3 OPN LUKOPR ALB Add', N'E009', N'@33 B2 D4 E2 H3', 350, N'E7273', 24, 0, 0, 1, N'E009', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5722b60d-4a47-4e2f-8348-cab60d075abd', N'Apheresis RED BLOOD CELLS|CP2D>AS3/XX/refg|Open|Irradiated|ResLeu:<5log6|Albumin added', N'RBC AFR CP2D>AS3 OPN IRD LUKOPR ALB Add', N'E009', N'@33 B2 C2 D4 E2', 350, N'E7274', 24, 0, 0, 1, N'E009', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'58c88e06-a2c9-4064-a39a-62b185f424ea', N'RED BLOOD CELLS|CP2D>AS3/500mL/refg|For mnf:injectable|ResLeu:<5log6', N'RBC CP2D>AS3 MNFI LUKOPR', N'E002', N'@21 A2 D4', 350, N'E7214', 1008, 0, 0, 1, N'E002', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'591a2970-5808-4bd6-bcb2-d22da2226874', N'RED BLOOD CELLS|CPD/XX/refg|Not for tx or mnf|ResLeu:<5log6|LowVol:anticoag not adj', N'RBC CPD NMT LUKOPR LowVol', N'E002', N'@06 A4 D4 F3', 250, N'E7197', 504, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5a6a1876-509e-4f47-af90-d559cc3e9547', N'PLASMA|CPDA-1/XX/<=-5C|For mnf:injectable|Frozen <=24h', N'PLASMA CPDA-1 MNFI', N'E010', N'@D9 A2 G7', 225, N'E7369', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.380', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5b30881d-1573-478c-a14c-067d7d3ed817', N'POOLED PLATELETS|CPDA-1/XX/20-24C|Irradiated|ResLeu:<5log6', N'PLT Pool CPDA-1 IRD LUKOPR', N'E022', N'@B8 C2 D4', 200, N'E7261', 4, 0, 0, 1, N'E022', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'606c0e97-d39d-4b44-afe5-5f5cb36a5969', N'Washed Thawed POOLED PLATELETS|None/XX/20-24C|Open|ResLeu:<1log6|Buffy coat plts prep|From 3 donors', N'PLT Pool Thaw Wash None OPN LUKOPR BUFCT 3DNR', N'E023', N'@71 B2 D5 G2 J3', 200, N'E7280', 4, 0, 0, 1, N'E064', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'62544624-9ade-4c01-bd1d-af8a03250663', N'PLASMA|CPDA-1/XX/<=-5C|For mnf:injectable restr use|Frozen <=72h', N'PLASMA CPDA-1 MNFRI', N'E010', N'@D9 A6 GD', 225, N'E7378', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.457', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'63a612ab-c7c4-4df9-be0d-9c6607ba28a3', N'Thawed POOLED CRYOPRECIPITATE|NS/XX/rt|Open|Quar:>=112d/retested|From 10 Donors', N'CRYO Pool Thaw NS OPN QUAR 10DNR', N'E031', N'@92 B2 I4 JN', 100, N'E7355', 4, 0, 0, 1, N'E031', NULL, N'A', '20110727 10:54:18.897', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'640d4425-c775-4cfe-b4c1-15fcfaf3f3ba', N'Washed Thawed POOLED PLATELETS|None/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Buffy coat plts prep|From 3 donors', N'PLT Pool Thaw Wash None OPN IRD LUKOPR BUFCT 3DNR', N'E023', N'@71 B2 C2 D5 G2 J3', 200, N'E7281', 4, 0, 0, 1, N'E064', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'64d152cd-5df5-4c1b-8bb7-cfe2c2d9697e', N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|ResLeu:<5log6', N'PLASMA AFR Thaw ACD-A IRD LUKOPR', N'E013', N'@54 C2 D4', 225, N'E7405', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.677', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6576d3dc-9a67-4afe-a90c-ff2bd370767d', N'PLASMA|CPDA-1/XX/<=-5C|For mnf:noninjectable restr use|Cryo reduced', N'PLASMA CPDA-1 MNFRNI CRYORed', N'E010', N'@D9 A5 E3', 225, N'E7387', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.520', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'65c9c3b5-3d5e-4359-bae6-bdf080ccbc2d', N'Thawed CRYOPRECIPITATE|CPD/450mL/rt|Quar:>=112d/retested', N'CRYO Thaw CPD QUAR', N'E029', N'@85 I4', 15, N'E7334', 6, 0, 0, 1, N'E029', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'680e4773-d038-41f7-aefa-9ac7818e8489', N'POOLED PLATELETS|CPD/XX/20-24C|Open|ResLeu:<1log6|Plasma reduced/Plasma added|From 4 donors', N'PLT Pool CPD OPN LUKOPR PLS Red/PA 4DNR', N'E022', N'@A7 B2 D5 EE J4', 200, N'E7240', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'681d8136-055f-4373-9643-fde4e4af1071', N'Thawed Apheresis PLASMA|CP2D/XX/refg|1st container', N'PLASMA AFR Thaw CP2D', N'E013', N'@13 H3', 225, N'E7310', 120, 0, 0, 1, N'E015', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'692402a2-8692-4417-a3c7-87ebbbb4d02c', N'PLATELETS|CPD/450mL/20-24C|Irradiated|ResLeu:<2log5', N'PLT CPD IRD LUKOPR', N'E020', N'@64 C2 D8', 50, N'E7282', 120, 0, 0, 1, N'E020', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6b0b0f61-3fa3-4a19-960a-66bd12b107eb', N'PLASMA|CPDA-1/XX/<=-5C|For mnf:injectable restr use|Frozen <=24h', N'PLASMA CPDA-1 MNFRI', N'E010', N'@D9 A6 G7', 225, N'E7377', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.440', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6f72ba33-e1b3-43bc-9242-84d8e7317606', N'RED BLOOD CELLS|CPD/500mL/refg|For mnf:injectable|ResLeu:<5log6', N'RBC CPD MNFI LUKOPR', N'E002', N'@04 A2 D4', 250, N'E7201', 504, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6fb27665-f432-4dcd-9394-df54301581a1', N'Thawed POOLED PLATELETS|DMSO/XX/20-24C|Open|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 4 donors', N'PLT Pool Thw DMSO OPN LKPR PLS R/PA BFCT 4DNR', N'E022', N'@77 B2 D5 EE G2 J4', 200, N'E7094', 4, 0, 0, 1, N'E061', NULL, N'A', '20110727 10:54:08.050', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6fd81e01-587c-4f90-9ebd-758b4dd8a800', N'Frozen Apheresis PLATELETS|DMSO/XX/<-65C|Irradiated|ResLeu:<5log6', N'PLT AFR Froz DMSO IRD LUKOPR', N'E025', N'@76 C2 D4', 200, N'E7324', 8760, 0, 0, 1, N'E025', NULL, N'A', '20110510 08:04:22.083', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'739aeb3a-e431-46fa-9874-0db4b686163a', N'WHOLE BLOOD|CPD/XX/refg|Not for tx or mnf|LowVol:anticoag adj', N'WB CPD NMT LowVol', N'E001', N'@06 A4 F8', 250, N'E7180', 504, 0, 0, 1, N'E001', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'73e4f95c-4d78-429e-afc8-09811ce0712c', N'RED BLOOD CELLS|CPD/350mL/refg|Irradiated|ResLeu:<1log6', N'RBC CPD IRD LUKOPR', N'E002', N'@D1 C2 D5', 250, N'E7264', 504, 0, 0, 1, N'E002', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7a0e512d-d181-4f73-9322-71a8b004ecca', N'Apheresis RED BLOOD CELLS|ACD-A>AS1/XX/refg|For mnf:injectable|Irradiated|ResLeu:<5log6|1st container', N'RBC AFR ACD-A>AS1 MNFI IRD LUKOPR', N'E009', N'@AY A2 C2 D4 H3', 350, N'E7209', 672, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7a284879-7330-450d-b74f-a2478b8ef553', N'Washed POOLED PLATELETS|None/XX/20-24C|Open|Buffy coat plts prep|From 3 donors', N'PLT Pool Wash None OPN BUFCT 3DNR', N'E023', N'@71 B2 G2 J3', 200, N'E7225', 4, 0, 0, 1, N'E023', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7c28560f-5dd2-48f4-aec8-ee386590e719', N'Thawed POOLED CRYOPRECIPITATE|NS/XX/rt|Open|Quar:>=112d/retested|From 7 donors', N'CRYO Pool Thaw NS OPN QUAR 7DNR', N'E031', N'@92 B2 I4 J7', 100, N'E7352', 4, 0, 0, 1, N'E031', NULL, N'A', '20110727 10:54:18.880', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7e2df06c-e7eb-46ce-bd23-f298ac72c2d9', N'RED BLOOD CELLS|CPD>AS1/500mL/refg|For mnf:injectable|Irradiated|ResLeu:<5log6', N'RBC CPD>AS1 MNFI IRD LUKOPR', N'E002', N'@19 A2 C2 D4', 350, N'E7195', 672, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7f74a751-754a-4cbb-bc32-f56d2f647f08', N'Thawed Apheresis FRESH FROZEN PLASMA|CP2D/XX/refg|2nd container', N'FFP AFR Thaw CP2D', N'E013', N'@13 H4', 225, N'E7305', 24, 0, 0, 1, N'E013', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'80120598-3949-4488-98d8-5c40a86e5cae', N'Frozen Apheresis PLATELETS|DMSO/XX/<-65C|Irradiated|ResLeu:<5log6|2nd container', N'PLT AFR Froz DMSO IRD LUKOPR', N'E025', N'@76 C2 D4 H4', 200, N'E7326', 8760, 0, 0, 1, N'E025', NULL, N'A', '20110510 08:04:22.083', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8261d9f6-ac68-451e-9d10-3042b4fbc333', N'Thawed POOLED CRYOPRECIPITATE|NS/XX/rt|Open|Quar:>=112d/retested|From 9 donors', N'CRYO Pool Thaw NS OPN QUAR 9DNR', N'E031', N'@92 B2 I4 JG', 100, N'E7354', 4, 0, 0, 1, N'E031', NULL, N'A', '20110727 10:54:18.897', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'82db5964-11be-4d47-8f5f-9aa68ebf3644', N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Irradiated|ResLeu:<5log6', N'FFP AFR Thaw ACD-A IRD LUKOPR', N'E013', N'@54 C2 D4', 225, N'E7394', 24, 0, 0, 1, N'E013', NULL, N'A', '20110727 10:54:18.600', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'832d89bd-7eee-4b64-ba6a-c796245bdbcd', N'Thawed POOLED PLASMA|CPD/XX/refg|Cryo reduced|From 2 donors', N'PLASMA Pool Thaw CPD CRYORed 2DNR', N'E011', N'@06 E3 J2', 500, N'E7403', 4, 0, 0, 1, N'E055', NULL, N'A', '20110727 10:54:18.567', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'83d04964-6504-4235-9ffb-cbfc9034f278', N'PLASMA|CPD/XX/<=-5C|For mnf:noninjectable restr use|Cryo reduced', N'PLASMA CPD MNFRNI CRYORed', N'E010', N'@D8 A5 E3', 225, N'E7385', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.503', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'842709c0-253c-4767-890e-d9ae6d5ed99d', N'Thawed Apheresis PLATELETS|DMSO/XX/20-24C|Irradiated|ResLeu:<5log6', N'PLT AFR Thaw DMSO IRD LUKOPR', N'E026', N'@77 C2 D4', 200, N'E7328', 4, 0, 0, 1, N'E026', NULL, N'A', '20110510 08:04:22.083', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'855fafff-8280-4413-8e3b-84114eddc33d', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|From 5 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red/PA 5DNR', N'E022', N'@A7 B2 C2 D5 EE J5', 200, N'E7246', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'856842f9-8626-460c-8a4f-aa80493b2683', N'Apheresis RED BLOOD CELLS|ACD-A>AS3/XX/refg|Open|Irradiated|ResLeu:<5log6|Albumin added|1st container', N'RBC AFR ACD-A>AS3 OPN IRD LUKOPR ALB Add', N'E009', N'@AZ B2 C2 D4 E2 H3', 350, N'E7271', 24, 0, 0, 1, N'E009', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8600fa03-0b2b-4794-8f1b-02fed5281c7a', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 8 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red/PA BUFCT 8DNR', N'E022', N'@A7 B2 C2 D5 EE G2 J8', 200, N'E6534', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'866903ef-1623-4612-a28e-2a54af9546f8', N'Apheresis RED BLOOD CELLS|ACD-A>AS3/XX/refg|Not for tx or mnf|ResLeu:<5log6', N'RBC AFR ACD-A>AS3 NMT LUKOPR', N'E009', N'@AZ A4 D4', 350, N'E7181', 1008, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8705a417-528b-467e-8137-e05de6265e8b', N'Apheresis RED BLOOD CELLS|ACD-A>AS1/XX/refg|Open|Irradiated|ResLeu:<5log6|Plasma added|2nd container', N'RBC AFR ACD-A>AS1 OPN IRD LUKOPR PA', N'E009', N'@AY B2 C2 D4 E4 H4', 350, N'E7268', 24, 0, 0, 1, N'E009', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'87e5a440-c054-4051-b068-86cbd57cc8b8', N'PLASMA|CPD/XX/<=-5C|For mnf:injectable|Frozen <=24h', N'PLASMA CPD MNFI', N'E010', N'@D8 A2 G7', 225, N'E7365', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.350', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8b4c7909-114b-416c-90f9-6f014b33e26e', N'Washed Apheresis RED BLOOD CELLS|None/XX/refg|Open|Irradiated|ResLeu:<5log6|Albumin added', N'RBC AFR Wash None OPN IRD LUKOPR ALB Add', N'E049', N'@AS B2 C2 D4 E2', 200, N'E7277', 24, 0, 0, 1, N'E049', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8bb1d950-ed95-4682-9e0b-c18af530f675', N'Thawed POOLED PLATELETS|DMSO/XX/20-24C|Open|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 5 donors', N'PLT Pool Thw DMSO OPN LKPR PLS R/PA BFCT 5DNR', N'E022', N'@77 B2 D5 EE G2 J5', 200, N'E7095', 4, 0, 0, 1, N'E061', NULL, N'A', '20110727 10:54:08.050', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8ca052b0-d8e5-478d-8e34-677754b7b818', N'Liquid PLASMA|CP2D/XX/<37C|For mnf:noninjectable restr use', N'PLASMA Liq CP2D MNFRNI', N'E011', N'@63 A5', 225, N'E7218', 624, 0, 0, 1, N'E016', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8d4f85a4-7f42-4d10-9467-8a03002c04db', N'PLASMA|CPDA-1/XX/<=-5C|For mnf:noninjectable restr use', N'PLASMA CPDA-1 MNFRNI', N'E010', N'@D9 A5', 225, N'E7386', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.520', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8d6289af-7855-4b40-99a1-429dcfc0d70d', N'PLASMA|CPDA-1/XX/<=-5C|For mnf:injectable|Cryo reduced', N'PLASMA CPDA-1 MNFI CRYORed', N'E010', N'@D9 A2 E3', 225, N'E7368', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.363', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8d96366b-e0fa-4c02-9bcb-de4e2a871cdf', N'Apheresis RED BLOOD CELLS|ACD-A>AS1/XX/refg|Open|Irradiated|ResLeu:<5log6|Albumin added|2nd container', N'RBC AFR ACD-A>AS1 OPN IRD LUKOPR ALB Add', N'E009', N'@AY B2 C2 D4 E2 H4', 350, N'E7270', 24, 0, 0, 1, N'E009', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8dbf4e80-74e3-4c7e-b011-839ec08dff59', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|From 3 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red/PA 3DNR', N'E022', N'@A7 B2 C2 D5 EE J3', 200, N'E7244', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8f37bec5-efde-4bc0-95a5-06f8638f6313', N'Liquid PLASMA|CPDA-1/XX/<37C|For mnf:noninjectable restr use', N'PLASMA Liq CPDA-1 MNFRNI', N'E011', N'@62 A5', 225, N'E7219', 960, 0, 0, 1, N'E016', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9155ee20-b2b9-4c9d-9bf6-96601d8a356e', N'Thawed PLASMA|CPD/XX/refg|ResLeu:NS|Cryo reduced', N'PLASMA Thaw CPD LUKOPR CRYORed', N'E011', N'@06 D2 E3', 225, N'E7313', 120, 0, 0, 1, N'E018', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9208dd8c-09a7-404c-a8ec-e0f428fbae8b', N'Frozen Apheresis PLATELETS|DMSO/XX/<-65C|Irradiated|ResLeu:<5log6|3rd container', N'PLT AFR Froz DMSO IRD LUKOPR', N'E025', N'@76 C2 D4 H5', 200, N'E7327', 8760, 0, 0, 1, N'E025', NULL, N'A', '20110510 08:04:22.083', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'920a9b84-318a-4736-9d06-481f072e9b5b', N'RED BLOOD CELLS|CPD>SAGM/450mL/refg|Irradiated|ResLeu:<5log6|Supernat rem/Plasma added', N'RBC CPD>SAGM IRD LUKOPR SR/PA', N'E002', N'@CY C2 D4 E8', 350, N'E7266', 672, 0, 0, 1, N'E002', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'924d76a1-f421-4625-a2bb-b4544a726878', N'RED BLOOD CELLS|CPD>AS1/XX/refg|Not for tx or mnf|ResLeu:<5log6|LowVol:anticoag adj', N'RBC CPD>AS1 NMT LUKOPR LowVol', N'E002', N'@98 A4 D4 F8', 350, N'E7192', 1008, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'93b7cb1d-715e-40f5-bfa8-dbebe1fcccc6', N'Apheresis RED BLOOD CELLS|ACD-A>AS3/XX/refg|Not for tx or mnf', N'RBC AFR ACD-A>AS3 NMT', N'E009', N'@AZ A4', 350, N'E7182', 1008, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'94f9883a-e309-4b45-abe8-16fd449cc5ec', N'Thawed POOLED PLATELETS|DMSO/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 4 donors', N'PLT Pool Thw DMSO OPN IRD LKPR PLS R/PA BFCT 4DNR', N'E022', N'@77 B2 C2 D5 EE G2 J4', 200, N'E7096', 4, 0, 0, 1, N'E061', NULL, N'A', '20110727 10:54:08.050', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'950d85e7-3d22-4fe8-a61a-efa6d8123719', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 7 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red/PA BUFCT 7DNR', N'E022', N'@A7 B2 C2 D5 EE G2 J7', 200, N'E6533', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'951dd55e-ef00-4601-b1bf-81390b851fb7', N'Thawed Apheresis FRESH FROZEN PLASMA|CP2D/XX/refg|1st container', N'FFP AFR Thaw CP2D', N'E013', N'@13 H3', 225, N'E7304', 24, 0, 0, 1, N'E013', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9545838b-ba6b-472d-8e23-0f3f8ddec00a', N'Deglycerolized Apheresis RED BLOOD CELLS|None/XX/refg|Open|ResLeu:<1log6|1st container', N'RBC AFR Deg None OPN LUKOPR', N'E051', N'@AS B2 D5 H3', 200, N'E7170', 24, 0, 0, 1, N'E051', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9546f3f6-5388-42ef-b933-bf9f0c5ba6c2', N'POOLED PLATELETS|PAS-E/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Supernat rem/Plasma added|Buffy coat plts prep|From 4 donors', N'PLT Pool PAS-E OPN IRD LUKOPR SR/PA BUFCT 4DNR', N'E022', N'@D5 B2 C2 D5 E8 G2 J4', 200, N'E6967', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'965d2e94-64a6-4f66-bde1-bc0a41bd4733', N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|6th container', N'PLASMA AFR Thaw ACD-A IRD', N'E013', N'@54 C2 HA', 225, N'E7401', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.660', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'96a89c4e-19bb-47cd-a2ce-46ed98326780', N'POOLED PLATELETS|PAS-E/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Supernat rem/Plasma added|Buffy coat plts prep|From 2 donors', N'PLT Pool PAS-E OPN IRD LUKOPR SR/PA BUFCT 2DNR', N'E022', N'@D5 B2 C2 D5 E8 G2 J2', 200, N'E6965', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9709749c-d3b7-4c12-b386-1260580328e4', N'Thawed Apheresis PLASMA|CP2D/XX/refg|Cryo reduced', N'PLASMA AFR Thaw CP2D CRYORed', N'E013', N'@13 E3', 225, N'E7307', 120, 0, 0, 1, N'E015', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'99cd2589-8d37-43cd-ade8-83d80846fac8', N'Washed Apheresis PLATELETS|None/XX/20-24C|Irradiated|ResLeu:<5log6|3rd container', N'PLT AFR Wash None IRD LUKOPR', N'E027', N'@71 C2 D4 H5', 200, N'E7392', 4, 0, 0, 1, N'E027', NULL, N'A', '20110727 10:54:18.833', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'99df746a-a553-4192-bf8a-a6cec3ca3895', N'Apheresis RED BLOOD CELLS|ACD-A>AS1/XX/refg|Open|Irradiated|ResLeu:<5log6|Albumin added|1st container', N'RBC AFR ACD-A>AS1 OPN IRD LUKOPR ALB Add', N'E009', N'@AY B2 C2 D4 E2 H3', 350, N'E7269', 24, 0, 0, 1, N'E009', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9a2ff93f-4dd3-4720-8bd7-4dac819e0a53', N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-30C|ResLeu:<1log6|>=400mL<600mL|Psoralen-treated', N'FFP AFR ACD-A LUKOPR LowVol Psoraln', N'E012', N'@AJ D5 F6 K5', 225, N'E7320', 8760, 0, 0, 1, N'E012', NULL, N'A', '20110510 08:04:22.083', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9a428622-1f4d-4980-a745-b81d948a9965', N'RED BLOOD CELLS|CPDA-1/XX/refg|Not for tx or mnf|ResLeu:<5log6|LowVol:anticoag not adj', N'RBC CPDA-1 NMT LUKOPR LowVol', N'E002', N'@10 A4 D4 F3', 250, N'E7184', 840, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9b9dc62c-3806-4a9f-b25a-ba951c7b3c7e', N'PLATELETS|CPD/500mL/20-24C|Bacterial test', N'PLT CPD BacTest', N'E020', N'@65 N3', 50, N'E7221', 120, 0, 0, 1, N'E020', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9dbfef8a-dfce-4fa8-ae20-67e3d528215e', N'RED BLOOD CELLS|CPDA-1/500mL/refg|For mnf:injectable|ResLeu:<5log6', N'RBC CPDA-1 MNFI LUKOPR', N'E002', N'@08 A2 D4', 250, N'E7188', 840, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9dcb6239-56ed-4991-b305-3b25394ef3e4', N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|3rd container', N'PLASMA AFR Thaw ACD-A IRD', N'E013', N'@54 C2 H5', 225, N'E7398', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.630', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9fdec72f-56fc-47a3-abb0-d37ec66ab712', N'Thawed Apheresis PLATELETS|DMSO/XX/20-24C|Irradiated|ResLeu:<5log6|3rd container', N'PLT AFR Thaw DMSO IRD LUKOPR', N'E026', N'@77 C2 D4 H5', 200, N'E7331', 4, 0, 0, 1, N'E026', NULL, N'A', '20110510 08:04:22.083', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a0d1f5f4-2f19-4446-9b83-2a8430a67452', N'Apheresis FRESH FROZEN PLASMA|CPD-50/XX/<-25 C|Frozen <=24h', N'FFP AFR CPD-50', N'E012', N'@AP G7', 225, N'E7295', 8760, 0, 0, 1, N'E012', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a19df5fe-a190-4f85-b664-0c8a49aa749a', N'PLASMA|CPD/XX/<=-5C|For mnf:injectable|Cryo reduced', N'PLASMA CPD MNFI CRYORed', N'E010', N'@D8 A2 E3', 225, N'E7364', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:08.050', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a3bd4fb2-50f8-41de-af7e-a5b07a0a06e5', N'WHOLE BLOOD|CPD/XX/refg|Not for tx or mnf|LowVol:anticoag not adj', N'WB CPD NMT LowVol', N'E001', N'@06 A4 F3', 250, N'E7179', 504, 0, 0, 1, N'E001', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a4372923-b715-4148-85f5-21b9eaaf818e', N'PLASMA|CPDA-1/XX/<=-5C|For mnf:injectable|Frozen <=120h', N'PLASMA CPDA-1 MNFI', N'E010', N'@D9 A2 G9', 225, N'E7371', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.397', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a5b60242-6bb0-43bd-9532-1e28f7f36667', N'Frozen Apheresis PLATELETS|DMSO/XX/<-65C|Irradiated|ResLeu:<5log6|1st container', N'PLT AFR Froz DMSO IRD LUKOPR', N'E025', N'@76 C2 D4 H3', 200, N'E7325', 8760, 0, 0, 1, N'E025', NULL, N'A', '20110510 08:04:22.083', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a766abf4-80f4-4451-8103-2b85429250b5', N'Thawed Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/refg|Riboflavin-treated', N'FFP AFR Thaw NaCit Ribo', N'E013', N'@55 K6', 225, N'E7360', 24, 0, 0, 1, N'E013', NULL, N'A', '20110727 10:54:18.567', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a7c7f030-1f70-4c2e-9f28-4a83e43dce72', N'Thawed Apheresis PLATELETS|DMSO/XX/20-24C|Irradiated|ResLeu:<5log6|2nd container', N'PLT AFR Thaw DMSO IRD LUKOPR', N'E026', N'@77 C2 D4 H4', 200, N'E7330', 4, 0, 0, 1, N'E026', NULL, N'A', '20110510 08:04:22.083', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a7f5ea92-f1af-4411-8820-8be60f985669', N'POOLED PLATELETS|CPD/XX/20-24C|Plasma reduced/Plasma added|Buffy coat plts prep|From 6 donors', N'PLT Pool CPD PLS Red/PA BUFCT 6DNR', N'E022', N'@A7 EE G2 J6', 200, N'E7259', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a96be047-9ca0-4442-a858-b6d5dcd970c2', N'PLATELETS|CPD/500mL/20-24C|Open|Irradiated|ResLeu:<8.3log5|Plasma reduced/Plasma added', N'PLT CPD OPN IRD LUKOPR PLS Red/PA', N'E020', N'@65 B2 C2 D6 EE', 50, N'E7339', 4, 0, 0, 1, N'E020', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a9f4a065-35d5-4976-a82a-c11dd66ccdef', N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|4th container', N'PLASMA AFR Thaw ACD-A IRD', N'E013', N'@54 C2 H6', 225, N'E7399', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.647', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'aabceade-6205-44f1-91f6-addbc3fb5ed2', N'FRESH FROZEN PLASMA|CPD/XX/<-25C|Frozen <=15h|Methylene blue-treated', N'FFP CPD Methyl Blue', N'E010', N'@A1 G5 K3', 225, N'E7346', 8760, 0, 0, 1, N'E010', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ab68ebee-73ba-476d-81a8-a851e9a15cdf', N'Thawed POOLED CRYOPRECIPITATE|NS/XX/rt|Open|Quar:>=112d/retested|From 5 donors', N'CRYO Pool Thaw NS OPN QUAR 5DNR', N'E031', N'@92 B2 I4 J5', 100, N'E7350', 4, 0, 0, 1, N'E031', NULL, N'A', '20110727 10:54:18.863', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ad497091-b0f0-49dd-8a61-c3522219dde2', N'PLASMA|CPDA-1/XX/<=-5C|For mnf:injectable|Frozen <=72h', N'PLASMA CPDA-1 MNFI', N'E010', N'@D9 A2 GD', 225, N'E7370', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.380', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'adaa1ff8-bd26-4e43-82d7-b0e8412bbf32', N'RED BLOOD CELLS|CPD>AS1/500mL/refg|For mnf:injectable|Irradiated', N'RBC CPD>AS1 MNFI IRD', N'E002', N'@19 A2 C2', 350, N'E7196', 672, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ae891bbe-1b29-483b-9b97-e428a1c7f223', N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|4th container', N'PLASMA AFR Thaw NaCit', N'E013', N'@55 H6', 225, N'E7409', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.707', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'af5f7b4d-99d9-4b42-872d-5dc7be7702c8', N'Thawed POOLED CRYOPRECIPITATE|NS/XX/rt|From 10 Donors', N'CRYO Pool Thaw NS 10DNR', N'E031', N'@92 JN', 100, N'E7319', 4, 0, 0, 1, N'E031', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b01d47c8-9a2f-4233-a78d-5ee458de1956', N'Washed Apheresis RED BLOOD CELLS|None/XX/refg|Open|Irradiated|ResLeu:<5log6|Albumin added|2nd container', N'RBC AFR Wash None OPN IRD LUKOPR ALB Add', N'E049', N'@AS B2 C2 D4 E2 H4', 200, N'E7279', 24, 0, 0, 1, N'E049', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b18ffcd0-0f8f-4423-977d-fad94c172aee', N'POOLED PLATELETS|PAS-E/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Supernat rem/Plasma added|Buffy coat plts prep|From 8 donors', N'PLT Pool PAS-E OPN IRD LUKOPR SR/PA BUFCT 8DNR', N'E022', N'@D5 B2 C2 D5 E8 G2 J8', 200, N'E6971', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b3ccf2db-582a-4d8c-a72c-c52c7fea5529', N'WHOLE BLOOD|CPDA-1/XX/refg|Not for tx or mnf|ResLeu:<5log6|LowVol:anticoag adj', N'WB CPDA-1 NMT LUKOPR LowVol', N'E001', N'@10 A4 D4 F8', 250, N'E7174', 840, 0, 0, 1, N'E001', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b40d96f0-d150-4574-b297-06acc3ec6715', N'Thawed POOLED CRYOPRECIPITATE|NS/XX/rt|Open|Quar:>=112d/retested|From 8 donors', N'CRYO Pool Thaw NS OPN QUAR 8DNR', N'E031', N'@92 B2 I4 J8', 100, N'E7353', 4, 0, 0, 1, N'E031', NULL, N'A', '20110727 10:54:18.880', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b4520564-17fe-4d8c-9d8a-a8c9eafd0335', N'RED BLOOD CELLS|CPD/350mL/refg|ResLeu:<1log6', N'RBC CPD LUKOPR', N'E002', N'@D1 D5', 250, N'E7263', 504, 0, 0, 1, N'E002', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b4b21c2b-0f64-4122-8f3d-930c81688dc6', N'Thawed FRESH FROZEN PLASMA|CPD/450mL/refg|Riboflavin-treated', N'FFP Thaw CPD Ribo', N'E011', N'@03 K6', 225, N'E7361', 24, 0, 0, 1, N'E011', NULL, N'A', '20110727 10:54:18.537', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b5184e8b-2eff-4584-9364-264eaa3d1113', N'RED BLOOD CELLS|CPD>SAGM/450mL/refg|ResLeu:<5log6|Supernat rem/Plasma added', N'RBC CPD>SAGM LUKOPR SR/PA', N'E002', N'@CY D4 E8', 350, N'E7265', 1008, 0, 0, 1, N'E002', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b6116775-21ca-4a92-b09c-52e4a12b04a1', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Plasma reduced/Plasma added|From 3 donors', N'PLT Pool CPD OPN PLS Red/PA 3DNR', N'E022', N'@A7 B2 EE J3', 200, N'E7234', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b688b513-76b8-408d-aabf-70d2276db319', N'Apheresis RED BLOOD CELLS|CP2D>AS3/XX/refg|Open|Irradiated|ResLeu:<5log6|Albumin added|2nd container', N'RBC AFR CP2D>AS3 OPN IRD LUKOPR ALB Add', N'E009', N'@33 B2 C2 D4 E2 H4', 350, N'E7276', 24, 0, 0, 1, N'E009', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b6da2839-b586-4a15-bc30-9622a4569d32', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|Plasma reduced/Plasma added|From 5 donors', N'PLT Pool CPD OPN IRD PLS Red/PA 5DNR', N'E022', N'@A7 B2 C2 EE J5', 200, N'E7251', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b72f8e92-0cd4-4be2-9672-727fe7b57e86', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Plasma reduced/Plasma added|From 6 donors', N'PLT Pool CPD OPN PLS Red/PA 6DNR', N'E022', N'@A7 B2 EE J6', 200, N'E7237', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ba46c47c-67c8-4c25-90cb-7146dabf8d13', N'PLASMA|CPDA-1/XX/<=-5C|For mnf:noninjectable', N'PLASMA CPDA-1 MNFNI', N'E010', N'@D9 A3', 225, N'E7382', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.490', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ba482c85-44e4-404c-a210-9a08cd996b58', N'POOLED PLATELET-RICH BUFFY COAT|CPD/XX/20-24C|ResLeu:<1log6', N'BUFFY PltRch Pool CPD LUKOPR', N'E043', N'@A7 D5', 200, N'E7342', 4, 0, 0, 1, N'E043', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bb028fc3-a6f6-4977-98c8-37654502016a', N'PLASMA|CPDA-1/XX/<=-5C|For mnf:noninjectable|Cryo reduced', N'PLASMA CPDA-1 MNFNI CRYORed', N'E010', N'@D9 A3 E3', 225, N'E7383', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.490', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bb4be68d-e9dd-4173-b51a-b8ba10b5fcc1', N'WHOLE BLOOD|CPDA-1/XX/refg|Not for tx or mnf|LowVol:anticoag adj', N'WB CPDA-1 NMT LowVol', N'E001', N'@10 A4 F8', 250, N'E7176', 840, 0, 0, 1, N'E001', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bb7f2c53-b388-462e-b695-01746b4d8795', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<5log6|Plasma reduced|Buffy coat plts prep|From 4 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red BUFCT 4DNR', N'E022', N'@A7 B2 C2 D4 E5 G2 J4', 200, N'E6366', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bbc804d5-54ec-4f6c-bf69-1a029759ca03', N'Reconstituted FRESH FROZEN PLASMA|CPD/XX/refg', N'FFP Recon CPD', N'E011', N'@06', 225, N'E7285', 24, 0, 0, 1, N'E067', NULL, N'A', '20110513 13:59:03.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bd04afb9-f485-4e57-95f2-3e06344277bd', N'PLASMA|CPD/XX/<=-5C|For mnf:injectable restr use|Frozen <=72h', N'PLASMA CPD MNFRI', N'E010', N'@D8 A6 GD', 225, N'E7374', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.410', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bf22eee9-ce17-443c-8298-6bdc0703d7de', N'WHOLE BLOOD|CPD/XX/refg|Not for tx or mnf|ResLeu:<5log6|LowVol:anticoag adj', N'WB CPD NMT LUKOPR LowVol', N'E001', N'@06 A4 D4 F8', 250, N'E7178', 504, 0, 0, 1, N'E001', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bf3cebf7-fa99-4941-8251-d3a48ebaf429', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 5 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red/PA BUFCT 5DNR', N'E022', N'@A7 B2 C2 D5 EE G2 J5', 200, N'E6531', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bf89c44b-8ea1-4d23-943f-9b312bab2651', N'Thawed PLASMA|CP2D/XX/refg|ResLeu:NS|Cryo reduced', N'PLASMA Thaw CP2D LUKOPR CRYORed', N'E011', N'@13 D2 E3', 225, N'E7316', 120, 0, 0, 1, N'E018', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c00dd3be-493a-4f0f-ada3-67a3f8aad2f7', N'Apheresis PLATELETS|ACD-A/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Albumin added', N'PLT AFR ACD-A OPN IRD LUKOPR PLS Red/ALB Add', N'E024', N'@73 B2 C2 D5 EB', 200, N'E7298', 4, 0, 0, 1, N'E024', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c06fec47-6a64-4ae7-9163-1d4153b62854', N'Thawed Apheresis PLASMA|CP2D/XX/refg|>=600mL', N'PLASMA AFR Thaw CP2D LowVol', N'E013', N'@13 F7', 225, N'E7309', 120, 0, 0, 1, N'E015', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c0cb7eaa-4544-41bb-8e58-82717f5b7994', N'PLATELETS|CPD/450mL/20-24C|Open|Irradiated|ResLeu:<2log5|Plasma reduced/Albumin added', N'PLT CPD OPN IRD LUKOPR PLS Red/ALB Add', N'E020', N'@64 B2 C2 D8 EB', 50, N'E7297', 4, 0, 0, 1, N'E020', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c224bb3e-11f9-4353-81a0-905865c5ee87', N'Apheresis FRESH FROZEN PLASMA|NaCitrate/XX/<-25C|ResLeu:<1log6|Frozen <=6h', N'FFP AFR NaCit LUKOPR', N'E012', N'@CQ D5 G4', 225, N'E7299', 8760, 0, 0, 1, N'E012', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c2d7e853-3c68-41f0-975b-c0c362ec169a', N'PLASMA|CPDA-1/XX/<=-5C|For mnf:injectable restr use|Cryo reduced', N'PLASMA CPDA-1 MNFRI CRYORed', N'E010', N'@D9 A6 E3', 225, N'E7376', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.440', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c2f51176-394d-4999-a38b-37312dfc9dc7', N'PLATELETS|CPD/450mL/20-24C|Open|Irradiated|ResLeu:<2log5|Plasma reduced/Plasma added', N'PLT CPD OPN IRD LUKOPR PLS Red/PA', N'E020', N'@64 B2 C2 D8 EE', 50, N'E7296', 4, 0, 0, 1, N'E020', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c45489c5-4530-4d53-b00a-ae69e57be91a', N'Washed Apheresis RED BLOOD CELLS|None/XX/refg|Open|Irradiated|ResLeu:<5log6|Albumin added|1st container', N'RBC AFR Wash None OPN IRD LUKOPR ALB Add', N'E049', N'@AS B2 C2 D4 E2 H3', 200, N'E7278', 24, 0, 0, 1, N'E049', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c72923e2-dc5f-4108-a449-1f174c1174cf', N'RED BLOOD CELLS|CPDA-1/500mL/refg|For mnf:injectable|Irradiated', N'RBC CPDA-1 MNFI IRD', N'E002', N'@08 A2 C2', 250, N'E7190', 672, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c7385db7-970c-44f3-9d7d-86dfe4335752', N'Apheresis PLATELETS|ACD-A>PAS-C/XX/20-24C|ResLeu:<5log6|4th container', N'PLT AFR ACD-A>PAS-C LUKOPR', N'E024', N'@BH D4 H6', 200, N'E7388', 120, 0, 0, 1, N'E024', NULL, N'A', '20110727 10:54:18.787', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c772d08a-eec2-4e6e-8510-2f4c902e6e38', N'Thawed POOLED PLATELETS|DMSO/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Buffy coat plts prep|From 5 donors|Riboflavin-treated', N'PLT Pool Thaw DMSO OPN IRD LUKOPR BUFCT 5DNR Ribo', N'E022', N'@77 B2 C2 D5 G2 J5 K6', 200, N'E7071', 4, 0, 0, 1, N'E061', NULL, N'A', '20110510 07:59:27.820', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c7b4087d-f6c5-462f-9d03-fc90fb9ab7dc', N'Apheresis PLATELETS|ACD-A>PAS-C/XX/20-24C|Irradiated|ResLeu:<5log6|4th container', N'PLT AFR ACD-A>PAS-C IRD LUKOPR', N'E024', N'@BH C2 D4 H6', 200, N'E7389', 120, 0, 0, 1, N'E024', NULL, N'A', '20110727 10:54:18.800', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c7b41506-c191-4e68-8aea-64646f86c6cc', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Plasma reduced/Plasma added|From 7 donors', N'PLT Pool CPD OPN PLS Red/PA 7DNR', N'E022', N'@A7 B2 EE J7', 200, N'E7238', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cbbec732-94d1-4b5d-bba1-0315ffc5bdd1', N'PLASMA|CPDA-1/XX/<=-20C|For mnf:injectable restr use|Cryo reduced', N'PLASMA CPDA-1 MNFRI CRYORed', N'E010', N'@BR A6 E3', 225, N'E7323', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110510 08:04:22.083', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cd2043e8-6387-403e-ba21-3f265028a507', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 4 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red/PA BUFCT 4DNR', N'E022', N'@A7 B2 C2 D5 EE G2 J4', 200, N'E6530', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cdd23a13-fa40-4a6f-be64-7f9b53a7c4c5', N'RED BLOOD CELLS|CPDA-1/XX/refg|Not for tx or mnf|LowVol:anticoag not adj', N'RBC CPDA-1 NMT LowVol', N'E002', N'@10 A4 F3', 250, N'E7186', 840, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd0c28239-af4d-4df9-9aa1-0ca8641eefd2', N'Apheresis PLATELETS|ACD-A/XX/20-24C|Open|Irradiated|ResLeu:<5log6|Plasma reduced|2nd container|<3log11 plts', N'PLT AFR ACD-A OPN IRD LUKOPR PLS Red', N'E024', N'@73 B2 C2 D4 E5 H4 JI', 200, N'E6377', 4, 0, 0, 1, N'E024', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd0c40b8e-1ee8-460f-b5ca-9be7e3345f7e', N'Apheresis RED BLOOD CELLS|ACD-A>AS1/XX/refg|For mnf:injectable|ResLeu:<5log6|1st container', N'RBC AFR ACD-A>AS1 MNFI LUKOPR', N'E009', N'@AY A2 D4 H3', 350, N'E7207', 1008, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd0d278a8-10f4-4e94-b467-897252a847fc', N'WHOLE BLOOD|CPD/XX/refg|Not for tx or mnf|ResLeu:<5log6|LowVol:anticoag not adj', N'WB CPD NMT LUKOPR LowVol', N'E001', N'@06 A4 D4 F3', 250, N'E7177', 504, 0, 0, 1, N'E001', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd17c9657-4068-4ead-a9ac-55eb74b8546c', N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|5th container', N'PLASMA AFR Thaw NaCit IRD', N'E013', N'@55 C2 H9', 225, N'E7416', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.753', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd4e73e62-381d-451a-99f4-ffbcfba115b4', N'Apheresis RED BLOOD CELLS|ACD-A/XX/refg|Not for tx or mnf|ResLeu:<5log6|2nd container', N'RBC AFR ACD-A NMT LUKOPR', N'E009', N'@54 A4 D4 H4', 350, N'E7211', 504, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd66a92cb-3107-4858-b4d6-751ca91b6c59', N'Apheresis RED BLOOD CELLS|CP2D>AS3/XX/refg|Open|ResLeu:<5log6|Albumin added', N'RBC AFR CP2D>AS3 OPN LUKOPR ALB Add', N'E009', N'@33 B2 D4 E2', 350, N'E7272', 24, 0, 0, 1, N'E009', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd6f5b110-e5a1-4fa0-9378-c3624dafd525', N'POOLED PLATELETS|CPD/XX/20-24C|Open|ResLeu:<1log6|Plasma reduced/Plasma added|From 7 donors', N'PLT Pool CPD OPN LUKOPR PLS Red/PA 7DNR', N'E022', N'@A7 B2 D5 EE J7', 200, N'E7243', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd70a26dc-9bab-4eaa-9ce3-45e91874f6e8', N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|6th container', N'PLASMA AFR Thaw NaCit IRD', N'E013', N'@55 C2 HA', 225, N'E7417', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.770', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd86dd0b8-4138-432b-a238-5f0bc1194aa8', N'Apheresis RED BLOOD CELLS|ACD-A>AS1/XX/refg|For mnf:injectable|ResLeu:<5log6|2nd container', N'RBC AFR ACD-A>AS1 MNFI LUKOPR', N'E009', N'@AY A2 D4 H4', 350, N'E7206', 1008, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd8ebdaca-ee6b-4ea2-a0fb-7329c88da9fd', N'RED BLOOD CELLS|CPDA-1/XX/refg|Not for tx or mnf|LowVol:anticoag adj', N'RBC CPDA-1 NMT LowVol', N'E002', N'@10 A4 F8', 250, N'E7187', 840, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'da75df37-c960-472c-b7ff-15aaedab80a8', N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Quar:>=112d/retested', N'FFP AFR Thaw ACD-A QUAR', N'E013', N'@54 I4', 225, N'E7260', 24, 0, 0, 1, N'E013', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'daea6e78-5c49-4fc0-878a-dc815c1f60f9', N'RED BLOOD CELLS|CPD>AS1/XX/refg|Not for tx or mnf|LowVol:anticoag adj', N'RBC CPD>AS1 NMT LowVol', N'E002', N'@98 A4 F8', 350, N'E7194', 1008, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dca9a5ea-abfa-4ea8-be3b-b224bfbd6998', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|From 6 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red/PA 6DNR', N'E022', N'@A7 B2 C2 D5 EE J6', 200, N'E7247', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dd961def-848c-4ecb-8441-e57ab1f2aa40', N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|2nd container', N'PLASMA AFR Thaw NaCit IRD', N'E013', N'@55 C2 H4', 225, N'E7413', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.740', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ddbbe0fc-ddf0-46df-9f37-20e1aa9848a2', N'Apheresis PLATELETS|ACD-A/XX/20-24C|Open|Irradiated|ResLeu:<5log6|Plasma reduced|2nd container|Approx 300 log9 plts', N'PLT AFR ACD-A OPN IRD LUKOPR PLS Red', N'E024', N'@73 B2 C2 D4 E5 H4 JC', 200, N'E6422', 4, 0, 0, 1, N'E024', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dfb959f2-c801-4977-80c1-13a084f29df3', N'RED BLOOD CELLS|CPD/500mL/refg|For mnf:injectable|Irradiated|ResLeu:<5log6', N'RBC CPD MNFI IRD LUKOPR', N'E002', N'@04 A2 C2 D4', 250, N'E7202', 504, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e070669e-15e7-4207-832c-18b014d0b1ae', N'PLASMA|CPD/XX/<=-20C|For mnf:injectable restr use|Cryo reduced', N'PLASMA CPD MNFRI CRYORed', N'E010', N'@BN A6 E3', 225, N'E7322', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110510 08:04:22.083', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e255affd-04a5-4831-adba-7e09da306567', N'Thawed Apheresis FRESH FROZEN PLASMA|ACD-A/XX/refg|Riboflavin-treated', N'FFP AFR Thaw ACD-A Ribo', N'E013', N'@54 K6', 225, N'E7363', 24, 0, 0, 1, N'E013', NULL, N'A', '20110727 10:54:18.583', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e47bc9a0-ede5-48cc-9496-d4632c30e217', N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Cryo reduced', N'PLASMA AFR Thaw NaCit CRYORed', N'E013', N'@55 E3', 225, N'E7312', 120, 0, 0, 1, N'E015', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e515713a-e125-47d8-9725-64021dcc2773', N'FRESH FROZEN PLASMA|CPDA-1/XX/<-25C|Frozen <=15h|Methylene blue-treated', N'FFP CPDA-1 Methyl Blue', N'E010', N'@38 G5 K3', 225, N'E7345', 8760, 0, 0, 1, N'E010', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e54a35d2-566d-4ccc-b048-43c6ed28a462', N'POOLED PLATELETS|PAS-E/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Supernat rem/Plasma added|Buffy coat plts prep|From 3 donors', N'PLT Pool PAS-E OPN IRD LUKOPR SR/PA BUFCT 3DNR', N'E022', N'@D5 B2 C2 D5 E8 G2 J3', 200, N'E6966', 4, 0, 0, 1, N'E022', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e55b74d5-d66e-49ef-b34d-1cc5e8537f42', N'RED BLOOD CELLS|CPD/XX/refg|Not for tx or mnf|LowVol:anticoag adj', N'RBC CPD NMT LowVol', N'E002', N'@06 A4 F8', 250, N'E7200', 504, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e7120793-4b90-42e1-9ad6-081700a29008', N'Apheresis RED BLOOD CELLS|ACD-A>AS3/XX/refg|For mnf:injectable|Irradiated', N'RBC AFR ACD-A>AS3 MNFI IRD', N'E009', N'@AZ A2 C2', 350, N'E7205', 672, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e778f2bc-6f94-488d-8c22-1d2aaae95859', N'RED BLOOD CELLS|CPD/500mL/refg|For mnf:injectable|Irradiated', N'RBC CPD MNFI IRD', N'E002', N'@04 A2 C2', 250, N'E7203', 504, 0, 0, 1, N'E002', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e888db68-f643-422a-a52e-6c66718c809f', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Plasma reduced/Plasma added|From 5 donors', N'PLT Pool CPD OPN PLS Red/PA 5DNR', N'E022', N'@A7 B2 EE J5', 200, N'E7236', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e96dc13a-d140-407f-a17c-23666253c323', N'Deglycerolized Apheresis RED BLOOD CELLS|None/XX/refg|Open|ResLeu:<1log6|2nd container', N'RBC AFR Deg None OPN LUKOPR', N'E051', N'@AS B2 D5 H4', 200, N'E7171', 24, 0, 0, 1, N'E051', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'eb0083f9-c9c6-415a-82c7-2b7d76da1756', N'Apheresis RED BLOOD CELLS|ACD-A>AS3/XX/refg|For mnf:injectable|Irradiated|ResLeu:<5log6', N'RBC AFR ACD-A>AS3 MNFI IRD LUKOPR', N'E009', N'@AZ A2 C2 D4', 350, N'E7204', 672, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ebf2b11c-6f26-4ed0-aede-efa50a436bfe', N'POOLED PLATELETS|CPD/XX/20-24C|Plasma reduced/Plasma added|Buffy coat plts prep|From 5 donors', N'PLT Pool CPD PLS Red/PA BUFCT 5DNR', N'E022', N'@A7 EE G2 J5', 200, N'E7258', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ec455519-da07-4a96-82dd-4775c139d937', N'Thawed Apheresis FRESH FROZEN PLASMA|CP2D/XX/refg|>=600mL', N'FFP AFR Thaw CP2D LowVol', N'E013', N'@13 F7', 225, N'E7303', 24, 0, 0, 1, N'E013', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ecf3e0bf-4713-44a1-ba30-246720984c25', N'Thawed FRESH FROZEN PLASMA|CPDA-1/450mL/refg|Quar:>=112d/retested', N'FFP Thaw CPDA-1 QUAR', N'E011', N'@07 I4', 225, N'E7233', 24, 0, 0, 1, N'E011', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ed137780-1d01-4edb-bf10-4ac54f953451', N'Washed Thawed POOLED PLATELETS|NS/XX/20-24C|Open|ResLeu:<1log6|Buffy coat plts prep|From 3 donors', N'PLT Pool Thaw Wash NS OPN LUKOPR BUFCT 3DNR', N'E023', N'@72 B2 D5 G2 J3', 200, N'E7336', 4, 0, 0, 1, N'E064', NULL, N'A', '20110519 11:30:30.107', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ed7b599d-0712-4369-97e8-8050adabcb8a', N'Apheresis RED BLOOD CELLS|ACD-A/XX/refg|Not for tx or mnf|ResLeu:<5log6', N'RBC AFR ACD-A NMT LUKOPR', N'E009', N'@54 A4 D4', 350, N'E7213', 504, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'edfbbca6-fc53-4576-81e2-a4837e08ebce', N'Thawed Apheresis PLASMA|NaCitrate/XX/refg|Irradiated|1st container', N'PLASMA AFR Thaw NaCit IRD', N'E013', N'@55 C2 H3', 225, N'E7412', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.723', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ef0e34db-bccb-4c16-a488-f9d6cc9e03d2', N'POOLED PLATELETS|CPD/XX/20-24C|Plasma reduced/Plasma added|Buffy coat plts prep|From 4 donors', N'PLT Pool CPD PLS Red/PA BUFCT 4DNR', N'E022', N'@A7 EE G2 J4', 200, N'E7257', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f08d0eb2-b85f-4abc-8599-e2afc8781002', N'Apheresis RED BLOOD CELLS|ACD-A>AS1/XX/refg|For mnf:injectable|Irradiated|ResLeu:<5log6|2nd container', N'RBC AFR ACD-A>AS1 MNFI IRD LUKOPR', N'E009', N'@AY A2 C2 D4 H4', 350, N'E7208', 672, 0, 0, 1, N'E009', NULL, N'A', '20110503 15:35:14.387', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f27dea45-7c42-44a9-b88d-6b2914babc4b', N'Thawed Apheresis PLASMA|ACD-A/XX/refg|Irradiated|5th container', N'PLASMA AFR Thaw ACD-A IRD', N'E013', N'@54 C2 H9', 225, N'E7400', 120, 0, 0, 1, N'E015', NULL, N'A', '20110727 10:54:18.647', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f668781c-d6ad-4452-b7f9-c99cfda15c85', N'Thawed CRYOPRECIPITATE|None/XX/rt|ResLeu:NS', N'CRYO Thaw None LUKOPR', N'E029', N'@83 D2', 15, N'E7318', 6, 0, 0, 1, N'E029', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f7a6f180-c47b-4eca-b3c9-5d338655f983', N'POOLED PLATELETS|CPD/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|From 7 donors', N'PLT Pool CPD OPN IRD LUKOPR PLS Red/PA 7DNR', N'E022', N'@A7 B2 C2 D5 EE J7', 200, N'E7248', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f7f50287-264d-4b19-a4c5-df0775e3a407', N'RED BLOOD CELLS|CPD/350mL/refg', N'RBC CPD', N'E002', N'@D1', 250, N'E7262', 504, 0, 0, 1, N'E002', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f866db9e-f9a5-483f-b4b4-4e2e331d7e4c', N'PLASMA|CPD/XX/<=-5C|For mnf:injectable restr use|Frozen <=120h', N'PLASMA CPD MNFRI', N'E010', N'@D8 A6 G9', 225, N'E7375', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.427', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f892600f-a3a3-4094-a405-62f9d694882f', N'RED BLOOD CELLS|CPD>SAGM/500mL/refg|Irradiated|ResLeu:<5log6|Plasma reduced', N'RBC CPD>SAGM IRD LUKOPR PLS Red', N'E002', N'@CM C2 D4 E5', 350, N'E7288', 672, 0, 0, 1, N'E002', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f97d4033-8b91-4f87-a940-d7b9fd15c6c4', N'Lyophilized FRESH FROZEN PLASMA|CPD/XX/rt', N'FFP Lyfo CPD', N'E010', N'@BT', 1, N'E7286', 8760, 0, 0, 1, N'E066', NULL, N'A', '20110513 13:59:03.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fa10d2f8-c4d2-46ba-bcec-34b85e0287ec', N'Thawed POOLED PLATELETS|DMSO/XX/20-24C|Open|Irradiated|ResLeu:<1log6|Plasma reduced/Plasma added|Buffy coat plts prep|From 5 donors', N'PLT Pool Thw DMSO OPN IRD LKPR PLS R/PA BFCT 5DNR', N'E022', N'@77 B2 C2 D5 EE G2 J5', 200, N'E7097', 4, 0, 0, 1, N'E061', NULL, N'A', '20110727 10:54:08.050', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fbd6f05f-03aa-4933-b897-005d13ebbd92', N'Apheresis RED BLOOD CELLS|CP2D>AS3/XX/refg|Open|Irradiated|ResLeu:<5log6|Albumin added|1st container', N'RBC AFR CP2D>AS3 OPN IRD LUKOPR ALB Add', N'E009', N'@33 B2 C2 D4 E2 H3', 350, N'E7275', 24, 0, 0, 1, N'E009', NULL, N'A', '20110506 12:48:31.303', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fbf72c2c-38e1-42d6-91b8-904f7f81784d', N'PLASMA|CPD/XX/<=-5C|For mnf:noninjectable|Cryo reduced', N'PLASMA CPD MNFNI CRYORed', N'E010', N'@D8 A3 E3', 225, N'E7381', 8760, 0, 0, 1, N'E017', NULL, N'A', '20110727 10:54:18.473', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fcc46788-e663-4086-bc82-e4d21c3ed1e5', N'Reconstituted FRESH FROZEN PLASMA|CPD/XX/rt', N'FFP Recon CPD', N'E011', N'@BT', 225, N'E7287', 24, 0, 0, 1, N'E067', NULL, N'A', '20110513 13:59:03.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fcd88c1e-5c68-4e38-aec6-3c2231c4a8b5', N'POOLED PLATELETS|CPD/XX/20-24C|Open|ResLeu:<1log6|Plasma reduced/Plasma added|From 6 donors', N'PLT Pool CPD OPN LUKOPR PLS Red/PA 6DNR', N'E022', N'@A7 B2 D5 EE J6', 200, N'E7242', 4, 0, 0, 1, N'E022', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fd592919-6bad-421c-9766-d4370d4eeb0f', N'Thawed FRESH FROZEN PLASMA|CPD/XX/refg|ResLeu:<5log6', N'FFP Thaw CPD LUKOPR', N'E011', N'@06 D4', 225, N'E7300', 24, 0, 0, 1, N'E011', NULL, N'A', '20110509 10:42:03.640', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProduct (BloodProductGuid, ProductName, ProductShortName, ProductTypeCode, ProductAttributeForm, ProductVolume, ProductCode, MaximumStorageTime, CrossmatchRequiredIndicator, ProductModificationIndicator, ProductCodeIndicator, OriginalProductTypeCode, RetireDate, RecordStatusCode, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fd5ac2f2-5a9f-446e-a293-3378255920f5', N'Apheresis FRESH FROZEN PLASMA|ACD-A/XX/<-25C|For mnf:noninjectable', N'FFP AFR ACD-A MNFNI', N'E012', N'@AI A3', 225, N'E7223', 8760, 0, 0, 1, N'E012', NULL, N'A', '20110505 13:00:39.143', N'vhaishsmithm', 0)

-- Add 948 rows to dbo.BloodProductModification
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'005e1832-ecac-4d72-8346-bf866179e9f7', N'T', N'e4ceb0e4-a6bd-45f1-83ee-eb8609981c0b', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'007b6fc5-ad19-47b9-9e4e-4b546fb45921', N'T', N'ebf909ff-52c6-4707-9740-a106df183cc6', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0097685f-a066-4686-ac10-12ba8d8ac78d', N'T', N'9ffab403-70c0-48f9-a16a-8be5be4c8b0f', N'e3dfa37c-ef4e-46db-a876-d407a5472d98', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'00d2feed-7b63-4439-b6b5-d1b71c36a6ef', N'T', N'274ce8c8-d014-434d-b5a8-37cdac1832a2', N'8c55ca53-c1f2-4630-a151-f79e4737cadc', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0127f004-21d1-4837-a1d1-7b81af2f1d9b', N'T', N'219bbea2-7c40-40d9-ab21-078a6071a62f', N'464795ce-81b2-471b-a564-9099fea5ff34', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'01293553-2428-4bc6-bd80-0cb4032826b3', N'T', N'1b895047-8656-43f3-9bdf-b43baa9a7af0', N'cc1c2eff-9db8-4cfb-bf96-1d7bef087f52', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'012dd956-99d7-4bf1-b7ae-17022e2be25a', N'T', N'4d1c2265-464b-4832-a9b7-91393f9a1605', N'8807be58-c754-49ab-b614-6caa4a05ffc1', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'014488b4-7082-47e4-b991-6fa40b3fd35f', N'T', N'2373ab24-1932-4a4f-8e6e-c6817d845093', N'bf0661e2-484e-4e1b-80f8-ed6b70423509', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'014763d1-bdcb-4c74-a185-ca2b8f1b1aeb', N'T', N'd175366f-9775-477b-ba70-dcf7d1a84922', N'0cd789f1-8a80-4ee4-9fb9-c28954c188da', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0178d9e8-5e3d-41f7-a9d0-eb1b3c9bc58e', N'T', N'8a356896-f4a3-4e6e-bb79-0937b9b70add', N'3c326cea-b961-401a-917e-c5dcdafa09a2', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'01b2b875-8c5e-4ca2-9ad2-ae2347f081e8', N'T', N'11adad87-b981-4151-bb3c-94e72ce66047', N'd1f83bd9-914e-4845-a6af-3b80aecc7c68', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'01f9875f-eba2-461f-96b9-b8b5f3e84588', N'T', N'd62e38e0-83be-4bef-bafb-5f33c64debca', N'e47bc9a0-ede5-48cc-9496-d4632c30e217', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'01fa0a70-ba9e-442e-afff-e8b29023a83a', N'T', N'a9ceab73-bee6-4356-9bba-10b1aa0e370e', N'b05793ce-5130-43e2-a7d0-48e8b1060473', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0244a9b8-9374-42b9-80fa-6b311fe3d2dc', N'T', N'6bd76b41-4adb-4da9-bad9-90e1cd67f97e', N'72069650-b54f-40b8-9e13-2cb8ffc0ec37', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'02500799-fe01-4b59-8e93-86e4d3fd57e0', N'T', N'52a27b1b-b9be-4619-bde7-2383eebf7c77', N'c7103c2f-122e-4572-aa6a-ccd3d19c82f3', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'02737720-3763-43b0-92db-e4ea53e4fc1d', N'T', N'8a62015f-60a0-4f8a-834f-803cfd7744ee', N'cfb16d87-3cc2-417c-87bb-3474ac792e5e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'02e131c9-3963-4ecd-963b-fdf32a836dec', N'T', N'dfaeba4a-8e9c-4deb-9240-51997af3b69f', N'e072df26-884e-4126-9c88-78df2e54fe46', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'02f133d5-9562-441a-886b-a7593d6b7da9', N'T', N'd899707b-5a6e-4e82-ac11-683a294b8f13', N'de1c4d0c-2eaf-45a0-9f75-61823f2af174', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'033505ed-b216-4ff8-b4a3-93ff1849e80f', N'T', N'141b8688-7713-4d1c-a88a-648ee0778c8a', N'b553e4b2-9e73-4c8e-a19b-40ba04f51bb7', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'035061b5-5172-4bda-8080-8bb57e134323', N'T', N'33de86a1-e01c-4b6a-8071-0b3bcdbe486a', N'8d9aeb37-3955-40e8-8fc7-774bca4f460b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0385cc43-3ac5-4504-b11c-a6a38c86d88c', N'T', N'ffb30f4c-cfd3-432d-b5cf-41a734ad269e', N'061adb62-5df5-43c2-a363-97fff46fc849', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'03c54c14-86f5-4931-a61b-28844ba4c31a', N'T', N'19b7b417-d315-4aba-ab33-a527a9c4a0dd', N'0c7ac9dd-513a-423e-af4c-83e2e134c5f9', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'047ef324-f0c8-408e-9e40-d7e568771aa5', N'T', N'5c9fb45f-b3c5-4a4a-87de-a899d02566f8', N'347fdff6-9fbd-4683-9331-38ed277d92f8', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'04ab041b-0227-476a-ab6a-ce3f41ced0a2', N'T', N'b65103db-9ef8-4aad-b884-c468cdd2cfcb', N'9f46008b-48b7-4678-8ba6-1164f8600041', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0558640b-7d55-4f5d-9b65-80953236d547', N'T', N'0f9dc254-4377-446b-af84-b006728f6e9d', N'b0f50092-f58f-4969-ac3d-79f221f46bb5', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'058d3808-942a-4dba-a87a-79ff4a142dd8', N'T', N'9ebd0699-f7c0-4812-8f58-d7f651290fb7', N'134a8fb0-b996-48f5-9008-0f40ec940944', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'058f8ece-69ca-4b0b-9c05-318dbf790a95', N'T', N'5389278b-1105-45ce-bb0c-2f0df1aed236', N'4317fe01-af0d-4b8b-88d9-c702ab17e9cb', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'05d93d86-1898-4d97-93c7-841934ca5977', N'T', N'8abe4492-487c-4c2b-b08d-84963ad28387', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'061208d6-da67-4f16-8dbf-c1f55da94951', N'T', N'8f193aef-704c-490a-8937-68ef2e0d3e29', N'91206be4-2fcd-4799-8d5a-10994266590a', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'067a3eb3-005d-45e6-b52c-337a000b3230', N'T', N'254d0eb0-6a56-429e-812a-cd98d78a1048', N'4582a2d6-a073-4dc2-aa28-b0557b4399f3', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'07243797-fbf1-43fb-99f8-9cf588989625', N'T', N'6bd76b41-4adb-4da9-bad9-90e1cd67f97e', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'077a0e6c-e49d-4cd6-a17c-fe4f5bcb1924', N'T', N'454a2c12-0ea7-48a9-baf2-3e3987d7215c', N'b528c01f-d65b-4146-a347-e8b8e31d36d2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'078be243-5f6d-48bb-80b3-dccfaf2e466e', N'T', N'ca211458-ed8f-4c39-a526-9e0997fffa12', N'73cfeae5-aae7-493f-bb92-ff2b34b75a80', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'083f0dfd-1a3b-454c-bf51-db8fac2cdb3b', N'T', N'c9408d94-5e6d-433f-9083-0b455d29dcf6', N'a327fc59-3ccf-4d1e-b7e4-42457b525c83', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'09254274-a377-4d84-9973-465a535d7f4d', N'T', N'c361a1ec-5b77-43d4-80b4-b150ddab3b54', N'bfed680a-3ecc-424d-b3a6-fa65c58238f0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'09321da3-f501-4c87-bb67-4ade7e094361', N'T', N'1d71d92e-0e36-4d5d-ad6d-896c68b8d012', N'bfa9fa91-7405-4569-82b0-9b40796432ad', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'09431bc6-3b74-4dcd-a74d-9d11701b6e2f', N'T', N'29bb1f00-3d89-43d0-a4a4-85dd88bd40ef', N'e0d0770f-c880-4323-8c2f-1f3c53554e70', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0956da45-7f2b-4845-b905-75895b6388d2', N'T', N'd1fa5bce-1755-477d-9668-6d17cbc44db0', N'18f1a6b1-b75b-4117-81f0-32416dcbd117', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0993b903-cb37-4fa4-9e54-2170ca66d48d', N'T', N'38c1a8ca-c286-4b12-b234-0dc7517e8528', N'4d284252-4048-4be6-bb43-2fdc31bf2aa4', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'09d8ca8c-1a27-4107-b16e-1c2a0a7f36c3', N'T', N'6bd1003d-436f-42fb-9648-5a536edb0807', N'73c28ed8-774e-4251-99b7-7a137a16b7bb', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'09e02bc4-df76-4c12-a81c-52036004ef73', N'T', N'967aba28-cfd9-4665-989a-6d1554b45cb8', N'935ef03c-c766-4394-b798-5c18eafb4de0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0a04cb7f-87b2-415a-aad1-dd12d214dd15', N'T', N'a5a4772e-f585-4d15-96e0-47b6dea59eee', N'28f70c37-7354-407f-9576-6ae353a39d01', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0a072225-b167-48b0-bd84-7cb667d4a2a9', N'T', N'5d34a7c6-70ea-487e-9870-6b59dcca0c66', N'2e9ebb30-c30a-44dc-a60e-5a755ed0d2b1', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0ad43f7b-2cc1-41f6-8217-0d26edd796a4', N'T', N'110e9fad-810b-4027-91a1-cb52e6d27117', N'bd6a5039-354f-4729-aeea-c3a1e1de4c6b', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0b6a718f-e9c2-4ac5-b404-074e41ea1775', N'T', N'a2235eac-7e29-49eb-956a-1005b1fdf1d1', N'22fb3050-a3dd-4b64-a2bf-706b09d77b76', 0, 24, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0c48b0cc-3027-4ff4-ad03-10cfce525e16', N'T', N'20e6cebf-78fb-4a5c-bd31-4e86b57c6c4d', N'ef30e1c8-7553-4347-b0d7-0df5d5b6ce9a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0c97b192-f7f7-47ed-84cd-5dc8e9ce72b4', N'T', N'd2c54586-21d2-496e-bc48-22198b5ceb79', N'f9da739d-903d-46e5-b128-16c3b5e9220a', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0cc83d69-ba0b-43cc-89b1-36e124a0b699', N'T', N'64ae2340-f61b-4912-98bf-1e0d95128c6a', N'4af44482-ce0a-49d0-9d44-0b92e740c3cf', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0d4af715-b1aa-4457-9165-c34ab7bbd3be', N'T', N'2b5e5236-3fac-46ac-a1e4-9e1406aa93e8', N'cb87be2a-1ef6-4ff3-a830-7fa6fda6b025', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0d532bb0-867c-44cd-81b5-51300633bb2f', N'T', N'97d6b1f4-13d4-4e0d-bcc9-71bb000f9d3f', N'670e872f-a40d-45ac-95f9-7720af965744', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0da9f919-43cf-4958-8613-92988d13f2cd', N'T', N'7ccc1d48-210d-4b0e-aa6c-daae5932c438', N'7c5bc92c-6c0b-4cd8-b786-c60a41f2a0b9', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0db17606-89e3-4310-8205-0fd5943474bf', N'T', N'220d73f7-f248-4adf-9ef3-a67dd24bfae3', N'0b1b8000-da34-4b60-bdd1-a3da69e8ce5e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0de241b8-dfa1-4542-8a94-6e56f4364fba', N'T', N'fa5ede6f-d42c-4f6f-9abb-5e47cfab5272', N'1c2c226b-da1b-4155-ab73-1f4c5f26bf51', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0e11f5f1-56c9-44b5-89df-b6f38ec8d94e', N'T', N'e6fdf87e-3c4e-4186-a2d4-7a12c2f87886', N'8d9aeb37-3955-40e8-8fc7-774bca4f460b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0e1dd838-4685-4aba-96c9-4cf516166646', N'T', N'08383d37-ca54-4697-87bf-3e3ec74bda83', N'11dccb58-beb7-4234-8157-5ceff89d8d92', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0e4700e9-7a41-4d9b-b80a-c461ea277293', N'T', N'6f7d05e6-4d2c-4d26-bea9-121bf44753af', N'7ba41706-8a33-4906-9551-10b80e10e304', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0e59ef5f-27c0-48a5-9331-3ade7833a3e7', N'T', N'6c9e9858-fa7e-432a-a1c0-3f5e486e4dd1', N'7263993c-12c0-4897-9785-48cd370a0afb', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0e9068e7-4221-4cbb-ba12-130ee950c4a5', N'T', N'eeee8882-f32a-4cea-bd11-5f5e1339e388', N'7805a3ce-754c-4df4-a2cf-7de7fa5cc817', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0ea5b057-33c4-4480-9c68-d7dd64315f0a', N'T', N'29eda4de-1730-49a4-9ee8-4a04914d0ccd', N'7f94a2dd-ae4f-4d2a-9a27-4ff75a9c83c9', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0ecb92b8-bb80-40b4-8cff-37a32e05ac29', N'T', N'7202d54a-6ee8-46db-b841-d9455e74bcaf', N'5f029b2b-96a0-4748-a084-a2a9f51a7b3f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0f86f1c1-7130-4b0b-8983-1ca5755d4166', N'T', N'd3b990b6-8de0-4367-ac08-bcd8568f90fa', N'1eba7055-c448-4c18-b2ad-2c86c822ad15', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0f8ef075-8f56-47f6-b846-407899b7be58', N'T', N'6b816a42-8cf1-403f-955a-881f8b5c6a6b', N'a0f103e4-1364-4701-a120-5028bad8d31d', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1041ea39-f8e7-4d02-adea-1238bd11b992', N'T', N'844129e6-3196-4615-b509-0bff7d311265', N'b4cf3e2c-c0f8-4631-9167-a9f044fa82e0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'10823756-3d9a-4986-a079-7eba439f432c', N'T', N'013a3968-1f41-44fc-aebf-4741620a1800', N'024e0933-a9ca-4b7d-9cca-c0bbeaade9e6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'10be5aac-12a5-480a-abc6-af1dd855f13a', N'T', N'954a8a91-11cd-4964-9d2f-8d0db8a0c281', N'b32cf506-a0a0-4799-9257-2cc1ed707390', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'11d0ea55-846a-41a7-9deb-14a16bc09b13', N'T', N'15caf660-d200-4632-b1f0-54586322f851', N'128fff9a-9887-4a4c-a7bc-1883ecb224f1', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'11dfa1e5-b779-4d05-a5c1-2856ea111067', N'T', N'555d6e09-f74e-4085-b83b-86f5c915714e', N'4f0cadb6-b070-4192-8fbe-29f6f0887c3f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'122c1c87-e351-4a96-9b05-a614035b8934', N'T', N'96d0abea-4731-4277-b39c-3e27cf570d77', N'91206be4-2fcd-4799-8d5a-10994266590a', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'12700e86-8559-4665-ae24-7a112e7ff203', N'T', N'c361a1ec-5b77-43d4-80b4-b150ddab3b54', N'9f0d534d-ce3b-43e5-910b-e6e47c7a28f7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1295ca91-7cc8-4654-aa05-8043e4705873', N'T', N'203d40d2-32cf-476c-b9ba-c0ed01033b93', N'd797beca-ed4f-45fb-b8bc-d55828936ac2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'13093922-19b5-4fd5-bedb-ba3b9195c809', N'T', N'9c5abcd6-6529-4a90-9ec6-6b7d5d1a488e', N'e7747a12-7431-4f0c-b611-6d3bfde8104f', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'13e21b77-4555-4481-8bbc-69fd29acb4d4', N'T', N'260cc15d-e6e2-4b45-916d-fd0f60db1a2c', N'b424211e-4558-451c-b2df-b2b2f7d8bfa6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'14871120-97e2-4cd9-8c3f-4e9d2ebe63fe', N'T', N'e7f7a44e-be91-4bff-9fc0-9796a7328f22', N'dbe88b1a-42e4-4b2e-becd-57f61b43bb87', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'14af7c53-4ecf-4163-b922-bdbd4e06be84', N'T', N'def7d3c1-ac1e-4b81-8e29-ce3efbe7cdb8', N'9bbfade5-2343-46fa-8c6d-a5d634c850fe', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'14fb33a1-2885-41eb-9e68-ee432f06436e', N'T', N'a7b9be7c-e284-428b-9bfe-19e7db69ed2f', N'9857f2fe-a82f-43e9-8dab-770bc9fa6807', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'151da8ca-aa2d-46ab-b0d1-9ad6d73710b7', N'T', N'648cee55-8129-4658-8185-52f4dffc8389', N'c4410a0f-373b-4c77-b1d1-beb3c3f5d4f5', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'15c0f1fe-1b76-4fe7-afd1-4d32e2d7fbf6', N'T', N'754946aa-4828-495b-af71-bcd0416d3573', N'57280ed4-feb2-4c01-a713-304d28229162', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'16d6b42d-20db-4eef-9c04-8341b7642398', N'T', N'10ceadda-948a-4476-9e26-7950fd655c03', N'ce75e0b5-cd9c-4ca5-832a-605f336f6e0c', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'170f40bc-0634-4415-9403-c01c7c3d7ecd', N'T', N'38414e6d-17e8-48a7-a6ee-ca1f682d1012', N'c1e09f6b-6d2f-41dc-a34b-125581015017', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1784d99d-c203-4fb3-aed1-59f4520ecaa4', N'T', N'2673bcb6-e958-4fc8-ad3f-5cb7eeb334dc', N'75989ddf-6d53-44c1-a490-088fe8ed7e46', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1839a6f0-2d97-45dc-a2fb-1ee01a5a4796', N'T', N'5eac86b8-7127-4e22-8f44-0264a40a5795', N'eb9429c4-9898-41ad-bc14-bf65c1515788', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1839a999-f7c9-4fbb-952f-8bee4b185097', N'T', N'592ddc97-1af5-4a73-b1cd-ce7b14ef9c69', N'0e9e22cd-6bde-43ca-bda9-7a195d9a2e62', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'18bd2c34-8a10-4061-aeb6-c06fef1b105c', N'T', N'4688ff8b-1b2f-4082-8210-311d2a577e42', N'099c4c6d-3ea2-45d8-8585-3e8b6f27c8dd', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1934ecf5-91b5-4336-b29e-6a3bae06d863', N'T', N'20158901-62dc-48bc-aa18-b0b63a0c4e19', N'1c1b1cf7-d4b8-4ac1-a86b-d61f6319f822', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'196f6e60-83b0-42e0-a792-8d8c22f589fa', N'T', N'55fbdb82-88ee-4855-bf44-270d06ca8766', N'4f7f276b-65a6-4614-ac13-2bac4c8ea5f5', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'19761da4-266e-4fa7-ad8a-9ba1af798d30', N'T', N'debf9088-db9a-49d1-b331-f69c7011e63e', N'3b2daa06-4d56-458a-be87-0d8a4975af56', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'19974e1d-262f-4555-9b46-388b56d2d84c', N'T', N'227f2bcd-fc92-4915-9473-9262af7d262a', N'56676e1b-86af-4e6f-923b-4007013efea6', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'19b8cd66-9282-4d86-8a81-9f1998d686c1', N'T', N'a28ecd99-0ec4-4cec-b641-ec3b4cfbe0cd', N'2c497a23-bc18-4f4b-9407-dbdf3d4c33ab', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1a07d978-4d4b-4424-bca5-cde358715c9a', N'T', N'04e3688d-b99c-47a0-b78a-ba64820a45b6', N'99d20d68-5cc9-47b8-9d0d-bcffdb3c612b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1a143ebc-b4d5-464f-9d63-344aeeac873d', N'T', N'65de1a31-6115-4e58-950e-a2186bd671be', N'fc877391-9241-44e9-a7b3-87ba400b6d41', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1a1a55b4-a888-4128-ab5c-ddc198327935', N'T', N'a2703f75-6b25-4719-9b3a-cc6aedb017c4', N'6cd73a0f-2d3d-49d7-9b24-186c69519462', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1a2265aa-e1ff-45c9-a285-d39e33754921', N'T', N'c2d625b7-0713-47bc-9430-cb438cf60925', N'f5809f5e-abe1-4a6b-93f8-54b48db19113', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1a43f3cf-4927-464c-890b-898ab486acbb', N'T', N'760906d1-6e67-4a8d-8905-22ede22682cd', N'87a12af3-8c7b-4da8-a109-940ae8cabb7e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1a69198f-fdac-4cbc-8637-654d8acd1795', N'T', N'9267f493-bb06-4c6e-bb35-a6bb84753830', N'd14eb95b-2c23-4997-a571-a37097bdce67', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1a6dfd21-02ba-4160-b6e0-9c0698e09552', N'T', N'b609b2b9-580a-4c77-8a9b-52ff13140e00', N'c1e09f6b-6d2f-41dc-a34b-125581015017', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1ac7772a-ded8-45f5-9aaa-dee990df4648', N'T', N'4f546995-d7ea-4860-8fe2-aaac9e10b7da', N'6d85f6c3-4de1-412b-b912-d28687273551', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1aed531f-15a8-43be-8b9c-7d111e67c5a7', N'T', N'098a3133-e1cf-4c0e-9d69-015dc0e433eb', N'03bdd188-8c6c-405c-9ddb-9ccb1ecdc186', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1af91910-62b6-4c4a-bc1d-ffd36ee05407', N'T', N'028997c4-bb3d-4123-b44c-e7edf21b313f', N'239f4679-d89c-428e-bd44-e8bec5cdfec1', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1b49b444-4020-4d65-8996-25c47813db5c', N'T', N'a5b60242-6bb0-43bd-9532-1e28f7f36667', N'4e0ddff0-1d63-4e26-bc46-367b70fb2d54', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1b87b0c6-84f0-48f2-9d77-859f6c561350', N'T', N'1f761eda-cafc-4dfc-abec-3c5caddcba9d', N'fc877391-9241-44e9-a7b3-87ba400b6d41', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1bf25e05-f4a4-41a5-9654-707b78641f2c', N'T', N'8a7c8f68-5dad-458a-b878-1735de4900b3', N'a14c23f5-351a-4c22-9100-585719f0fa25', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1c1359aa-8909-46ee-b3e2-674cf87959e4', N'T', N'6d9a44bd-4c5a-4ba0-95bc-e28885d4caa1', N'b424211e-4558-451c-b2df-b2b2f7d8bfa6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1c6d9352-167a-405e-9fec-427c759ceceb', N'T', N'32396fa1-d38f-4c82-8f4a-559aa68ddf5d', N'ba314d06-39c9-48d1-887d-8008d8d5c70e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1cb83f00-47e9-45da-b918-4ece25c72638', N'T', N'8cbbd037-6b91-4913-b769-2472d58ec292', N'145127fa-5147-471f-8c39-c43b2213b2f6', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1ce39aa6-2a03-40ca-957f-a63d46498c84', N'T', N'e670b040-8655-442d-b459-8ca98aa77dec', N'464795ce-81b2-471b-a564-9099fea5ff34', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1d2fc851-2042-46f6-8b8d-f334bf0cd0ed', N'T', N'a9f7ab04-4b6e-4537-aedf-8c0f7365c937', N'94be9cb4-fd3a-4ffd-a71a-a56fed4c5ff6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1d412663-fea7-444e-b36e-23af06b089ed', N'T', N'b4caf7b1-98d6-49de-a53a-facac6c66218', N'3c326cea-b961-401a-917e-c5dcdafa09a2', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1d5cfe11-4aed-469a-a395-3e96b0511c19', N'T', N'7f9aa8f4-6093-4469-80ae-c8a2fd3e816e', N'44a91eb3-63a5-49dc-9daf-bbf5429450e1', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1d7b11f6-0281-4c62-81c7-817802460673', N'T', N'5ab45191-4725-483c-96fe-bd91df24a771', N'418485ab-9ff9-487c-9469-8ffb15b54abb', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1e288c33-82df-41eb-bc7c-34b4f14d77cd', N'T', N'ca50f8ed-ee4a-4928-b7d1-a0539199c5a7', N'41b5e41e-6762-4f22-8106-58d93cc5c3bd', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1e68cdd4-e724-4008-9610-37dde4cc28a3', N'T', N'e8c5f842-5440-4c8d-92b8-c64de6a63e27', N'd612334b-a3b2-4e27-8184-755780d4e666', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1e7f92e9-ff29-4de2-8e00-bbb2df1f74fe', N'T', N'191bdf33-520c-41fa-8112-f75230b1010a', N'05de88ef-6e8a-4922-97b0-6c3dc78371bb', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1ebe5bcd-cf9a-492f-bbd1-3d5c086d44c8', N'T', N'6d1e7933-53a6-410e-8ce2-d2a87096786c', N'342329bd-07c8-4c1d-944f-169fd0de6ce1', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1f44c1ce-50ad-4c5b-be28-2f699b2c9ca3', N'T', N'1f1418eb-c616-4ad5-9e4a-10efaf6a9995', N'99da7903-9969-48e1-96da-4a5cd735d07e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1f462389-fcbd-459c-8b1c-a26748de377c', N'T', N'd989ecbc-5a1c-4f72-baf0-d7da867e3778', N'b424211e-4558-451c-b2df-b2b2f7d8bfa6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1f592fd3-5145-49d7-b122-49e5c3ebfaf9', N'T', N'c330cd23-0a70-4660-a709-e8ddb371e1ec', N'03934de6-43d0-48e6-a345-4a3ab90d3562', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1f793ef9-ee96-4f3d-abb1-4de2879f62b4', N'T', N'38414e6d-17e8-48a7-a6ee-ca1f682d1012', N'cae6da5f-99a7-4823-8d5f-b21d52e32f4f', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'203b1cf8-53f7-4dfd-80b3-a21abb272537', N'T', N'308c362f-5a7d-413c-8824-3c6516b21a09', N'1eba7055-c448-4c18-b2ad-2c86c822ad15', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'203d5ace-475c-4ca7-a536-8d77c033cc32', N'T', N'ba1f85f5-3b2d-4bd1-b020-fc7fe53cbfc0', N'71550e11-a75a-4e59-b742-2108892db8e2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'20924feb-8f3f-4176-bc56-3000e2d5236f', N'T', N'934809f7-6287-4184-8b91-60e531dc7617', N'bf962f05-b825-43cc-9f8e-f2360470aa28', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'20f29445-5db7-4180-b7d0-49b53d8ae182', N'T', N'7f9273e4-32a6-49ea-afb9-f8cfa570512a', N'e0a2b2d2-8d04-4e0a-8323-83403a2cb09b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'214d46eb-e4cf-4d5f-8e3e-5d638941259d', N'T', N'7821af1f-145e-4c8b-91aa-75187306ba8c', N'f937649a-ee3f-44cb-b008-7c1ba9d67e3c', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'21eed46f-d723-4fb3-a170-ae6b2a1e5d06', N'T', N'18d64d1d-4b49-4fd2-9d7a-025d0d38f771', N'808cc7cc-ebcb-437d-82d9-921b6e40f66c', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'21fd80c2-d4d1-47d7-a288-aa1563842e5d', N'T', N'd11f2b63-2ebd-4b96-8bce-26cdbccfd924', N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'234f7c50-3cb5-4036-aef4-98cc54a395b5', N'T', N'53c6d384-c7ce-437f-addb-c8e0ec9baab1', N'8d9aeb37-3955-40e8-8fc7-774bca4f460b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'23641397-80ca-4058-a77d-091466e87638', N'T', N'1f7074a0-07f4-404c-bbbd-fa1e6c8f7412', N'3b8effc7-3631-4863-bb7d-14180c84e29b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'23c98103-e28d-41ae-b6e1-4f7c78441e05', N'T', N'45fb993d-5fb5-4948-8f33-02808a5ff057', N'ccdb854e-2bc5-4339-8ba4-8fd9d4a93dda', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'248975fc-8a9e-4e55-bc25-131c35717249', N'T', N'd065541b-5800-4746-8d39-5132411833ba', N'e313a734-3967-4be1-995e-8436f86fbf9c', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'24c06524-45d5-4691-99c5-c89b1ae02242', N'T', N'eafb904c-c816-4878-b5f4-97057e813794', N'080a492f-e8dd-48d8-a57d-753be696f9a2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'24f06565-951d-41a5-80a2-489bfbaebb8c', N'T', N'25e3233e-bc53-4ba2-b852-9d97a0a0857e', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2543b66b-5aca-408c-bcb7-967b154589cf', N'T', N'ee0fe0b2-1ba1-497b-b3c3-9094c163c20e', N'f99b7544-5720-4917-b464-c398ca1dd75e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'256876fc-aa3e-463f-a126-477e7028b6fc', N'T', N'52ec8622-7271-46d5-9967-01d6732ea52c', N'80afc768-6153-4f80-8335-2eec319c94cc', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2602f5fa-02dc-4908-a06b-e65a01fdf57b', N'T', N'91f7566e-158c-4bb9-950d-bfe144e62a55', N'a9c363a7-b814-4cd6-b41b-1fd70860c7ed', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2629e053-2437-4139-99b9-f37064c43511', N'T', N'a77273d1-a6d4-436a-bb0e-8394d256d77c', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2634cf35-9c68-48e9-83f2-ae14f5db54fb', N'T', N'c8e75aed-f9c1-4ae4-9303-9c77f68b7e53', N'3b71e033-71c2-4658-8e50-efd8a6ca1ddf', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'26b76955-4b66-4c97-81f1-3adad4deeab7', N'T', N'8934fca7-d496-4a73-81ae-45a37bcf4d0f', N'0996ac40-bece-401a-857f-b30448e20c52', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'27472c1f-3eb9-41a0-9fb2-d22344e98168', N'T', N'95776ada-4ce9-4f95-bdf8-c043ab1d456f', N'd68ddc0a-a325-41a8-8891-9623789fae85', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'27ba28f1-fdc0-45b4-abca-ae36e6d223d4', N'T', N'06c43405-b375-4335-b587-59650e83b6c5', N'9857f2fe-a82f-43e9-8dab-770bc9fa6807', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'27bc7f27-028c-4ffe-b45d-9c6b9480fd70', N'T', N'608fb4fb-2454-4da2-be25-0ff88cd10fb7', N'2fc7715d-a7eb-44ea-9b8f-1f9086e2b423', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'27eccc42-fb9c-414e-8a43-39c2bc2fd626', N'T', N'beb5a2ac-e75e-41d1-9ca3-29488b14bf0d', N'f23b38cd-d5a3-46aa-8425-1d6072a205f5', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'28107cf6-246d-46f4-8cfc-fc966431644d', N'T', N'7a09035d-eeb4-4766-9dc5-31b6a39f23ec', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2844641f-bb06-4e2c-bfa4-def4a354aea4', N'T', N'f553563f-5016-40a6-bd46-23a8cc7c58f0', N'ff211bda-3afb-4193-9e66-bf7dc1d15eef', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'285494ca-f17f-4212-a4a1-e2685ba43329', N'T', N'd065541b-5800-4746-8d39-5132411833ba', N'464795ce-81b2-471b-a564-9099fea5ff34', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'28582b21-da68-45a9-967c-268047ce1f39', N'T', N'd41b01f3-f214-4583-a717-2ffd6264bd71', N'1dd4a35e-971f-4e9a-b55f-66ad0ac2122c', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2886d8a1-ad6f-41cb-afdc-53d31bb95222', N'T', N'268bd72b-6f71-48e9-a41a-d49484d19715', N'b1649f17-f670-4c3d-8f62-4579daae014c', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2921c805-9ca5-4927-b5e0-557ac17490bb', N'T', N'209b7310-a5b7-49fb-9bba-24f09bc03bc5', N'ed6486c9-1e48-40a4-ae19-4c55d3288560', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2987519e-9129-41d1-99e1-d559ef8b5ef5', N'T', N'b7e59b1b-c51b-4ed6-aed5-478596d6232c', N'2ed921ba-844a-4190-aa36-a882ef042621', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'299e720d-1715-4430-bc53-0996bf7e6859', N'T', N'45ca564f-98bd-4b30-993b-415d4abf5082', N'a663ce07-07f5-49e6-be7c-fca61c273b01', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2a2aa297-d541-43a0-a459-4dcf21219734', N'T', N'0729748e-864c-4392-99fe-93807c560762', N'ca259a4c-b8e1-4fdb-aedb-26e14e53c693', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2a2ed06a-d5ee-45e4-84fb-53a4d36b1c59', N'T', N'661ffb72-a75a-40e2-9967-9f60441eda70', N'0043808d-3fab-4c4c-91c7-688c292b063b', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2a6679f3-4c21-4353-b913-61c6bbdd7920', N'T', N'cb6e0bdd-d77e-4e74-b7da-f19e5b139444', N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2ae40dad-7793-4bad-a6ad-bc527df0c1ea', N'T', N'bb76c632-f7eb-4552-9b82-413100f08e85', N'66e89e78-464b-43fb-831c-3027d4f26cd9', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2af2d2a6-352e-42ba-8da7-f3498a0a60c4', N'T', N'eac40ecc-42c3-41f3-8a2c-ea059f1541d5', N'f87cbf4d-bde8-499c-b2c6-4984479da587', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2b140133-9eb2-4be7-a8e3-02c15a97b570', N'T', N'12c0f2fc-01e1-4999-9a04-6d31829fb3e1', N'85d5b31e-3a96-4cd1-87d9-3903532e31d3', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2c464ee8-40ca-4efa-8629-22cedd207772', N'T', N'1d71d92e-0e36-4d5d-ad6d-896c68b8d012', N'03a026d0-93b2-4e15-abe3-610cd64f235d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2c7214c2-6eee-47dc-a5fc-9220391306e7', N'T', N'b53d63e2-b964-4b6a-973e-e97d0f4665b6', N'128fff9a-9887-4a4c-a7bc-1883ecb224f1', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2cbe5159-f212-466d-8fa1-c40c987eb017', N'T', N'fa1bf434-90d6-43a6-a03e-4dfa0e2d0dc7', N'3355ac27-6a95-4254-85aa-4371180a9411', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2ccb3e8f-7db5-486d-ba9a-46e44004a90c', N'T', N'855f2295-09c1-4a7d-b95c-04edb3d5fa11', N'464795ce-81b2-471b-a564-9099fea5ff34', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2cde6ec0-6c31-429d-9f53-bea8c0501bd3', N'T', N'24538724-51dc-4601-b5cc-c0cf0daef4ef', N'b528c01f-d65b-4146-a347-e8b8e31d36d2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2e29495e-293b-4c3b-b16d-eaccbacab863', N'T', N'2f76d8dc-33e9-40c8-990c-a40404acf5f4', N'8f883679-5910-44ac-ac68-ff78a579722d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2e4c201f-e69c-4f0e-b904-42dd4bdcbfa4', N'T', N'20e6cebf-78fb-4a5c-bd31-4e86b57c6c4d', N'ff211bda-3afb-4193-9e66-bf7dc1d15eef', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2e77dd58-9acc-43d0-a082-b03aa1051449', N'T', N'c4cad229-a188-4744-9b65-6fb96cc4718b', N'2fc7715d-a7eb-44ea-9b8f-1f9086e2b423', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2e7f1e26-5450-4e8e-8a93-4c611fc2796e', N'T', N'106beffe-62ff-48b4-8048-dfb3e0248eed', N'9b5bbc23-71df-4736-bb9a-256bc1a4c27e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2e89e0b4-bc78-48ca-a53f-0e7e8058044e', N'T', N'8e57aba7-b879-4bc5-8434-7b8d0d57ac94', N'c8aa935a-dd57-4bed-bc95-917c08730244', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2e920d19-1ff4-45b6-9cf5-59db05e74d83', N'T', N'ccd56fc8-0c86-4b3c-be2b-60b489c823fd', N'cbc53053-9c3f-4424-9ac7-c763ca98c619', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2ec37cd3-3bf9-4036-a064-a09829026590', N'T', N'a64ba3d6-35be-4308-92b6-65fbd8e2c449', N'87f08eab-65d5-451c-9e04-6fb7ea4e5568', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2ee4518f-4289-470c-8fc2-7851a7ffd4a6', N'T', N'ca6a9425-4a25-4f19-9d65-529dc9ffc92c', N'7bd2b34c-99e5-49b8-b614-1203b1d16709', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3041764b-aa36-4965-a6dc-9750dd2a9e3d', N'T', N'085954db-7890-4c7e-aa74-56990a7cf7f8', N'cc6cd527-d9e8-4d43-b8b3-d85dd6a286d5', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3080d3f5-0684-4cca-be4a-5311c58e144c', N'T', N'd989ecbc-5a1c-4f72-baf0-d7da867e3778', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'30e49b54-982d-4cdf-9484-af0dadb02f5e', N'T', N'8cdfbde1-dc75-43a1-9dfe-d0c29ffb9d0a', N'b4cf3e2c-c0f8-4631-9167-a9f044fa82e0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'31176dbf-e261-45f5-b90a-54a2fd4a03b2', N'T', N'a9e72844-8444-4f68-bcc8-087ab1c3cc72', N'c2692b42-a2af-442f-a42a-2ee326874415', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'32081014-434a-44b9-8e91-8b50362931a3', N'T', N'967aba28-cfd9-4665-989a-6d1554b45cb8', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'321a6d2c-97d1-488e-bab9-c79aef7a87a1', N'T', N'a804056d-fbc1-49ca-9323-537f6449bb96', N'd3195c69-7902-4e38-9339-4b36c997d6b0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'321f43ad-fa50-4d5b-80ab-1c8fd401088c', N'T', N'4535bf75-34d3-4869-8d70-37aea70d7733', N'23385bc9-209d-4113-a128-7daea65e7d00', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'327789bd-943d-4ace-8513-fa29a3a236e0', N'T', N'9fa24d9f-2623-488c-9eac-66fc43471f92', N'2d258ae8-5984-4d64-a329-7fde7677e1eb', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'32c8a453-408f-42ec-bfbc-48da5cac2483', N'T', N'c456d412-cf41-415c-8862-097ac61285a2', N'b1f26a42-a8d3-4d6b-9a17-6c53291fafdc', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'32cfbb8f-8dd4-4401-b4cc-e259ab94e17e', N'T', N'ad0700d9-b1ae-4419-b8f2-359729a92144', N'6ff468d6-747c-4587-9788-dcd355256cc2', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'32e16d48-64c8-4d42-8212-974319786ab3', N'T', N'ac6800c0-c780-4a35-b175-b4c843f353d5', N'27dcae09-01df-46b2-a096-db17657b0c55', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'32ea28e0-d2e7-4db0-ad63-064921e2d343', N'T', N'a087a7cb-d251-4f2c-98e9-17a52456f946', N'c644c0f1-335f-4bc7-bb84-e1369c98c100', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'33d264d7-30f5-4046-abe9-5b47ed90862c', N'T', N'95a1a86b-355e-45d4-ac05-f2115a119227', N'ed6486c9-1e48-40a4-ae19-4c55d3288560', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'33e98da2-2699-4a19-b006-b4dfa50b55f0', N'T', N'3d5b48da-e624-4859-8fa1-092577dcee93', N'dfd5b59d-6522-403a-a971-65133add5aaf', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'343a40b6-912b-46f9-b25f-08c112c1a00d', N'T', N'99845bcc-fbca-4b2a-86e6-e793174c3538', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3453677d-c11e-48d5-b749-574ead2e42a3', N'T', N'aa7ab5c9-b1e2-4bf8-a81c-cae9c0f5456d', N'2fc7715d-a7eb-44ea-9b8f-1f9086e2b423', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'348b41cf-7930-4296-9c3c-d0ef779a56cc', N'T', N'a42df799-cf2d-4259-b4fb-bd271f2469c4', N'40e2bceb-be3f-40ee-96a0-b79bc2dc0cd3', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'349f6426-f3ec-45fa-b743-926c59c67d21', N'T', N'e670b040-8655-442d-b459-8ca98aa77dec', N'6777d281-8298-4da8-afe9-0ef2444d0743', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3566d1e3-bb6a-4a3a-ab69-26c8226571f1', N'T', N'd03d5eca-33f9-4144-8102-b841f689b4e2', N'fe813de3-92e6-4788-8ede-3b06f34bd665', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'35979100-c36a-4bc1-ae30-34ca9575cce2', N'T', N'78bd6274-255e-432e-8926-1dfe1b41277e', N'94aa1381-4c78-47b8-8c6b-817d5b776c19', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'35c19335-a353-4604-9c49-bfaf78fb484f', N'T', N'5c0cb10e-1a82-4978-abaa-d31035a5d406', N'94463eab-90f6-45bc-88e6-d5d3792df773', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'363e5b99-1e29-4d40-ba35-752e8793b418', N'T', N'e2fb1c51-7c2f-4238-b975-6780c56dc3b9', N'94463eab-90f6-45bc-88e6-d5d3792df773', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'36637d03-7936-4915-85bb-8ee3f43ea093', N'T', N'1b06194d-e258-4eb8-8e10-8ef631232e89', N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3692e630-aea7-4003-a630-50825e86e3ca', N'T', N'7dc7d789-8702-4d53-b1ef-7baa983bf86b', N'5b1e5238-ef0d-4bd2-b3c5-dad5e9b693db', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'36f4fcbb-02fb-4703-a44f-4a2ca0ba7954', N'T', N'0f9dc254-4377-446b-af84-b006728f6e9d', N'13b61f93-eab2-42db-94d9-364009636d4e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'375e6521-32af-4bf8-8a02-70f3d73d92f4', N'T', N'2c2565dc-f7cf-4fb9-b747-bc57b930874d', N'5f029b2b-96a0-4748-a084-a2a9f51a7b3f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'37b38db5-571b-43c1-8d94-abcba350a2dc', N'T', N'33de86a1-e01c-4b6a-8071-0b3bcdbe486a', N'fe402cce-ffc2-4bd7-ba22-24855d10b9b9', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'37f9382f-e17b-458b-8573-73d66f6825b4', N'T', N'ba11e29c-0776-4b98-b54b-07dc01431bcc', N'7ba5dde8-4a59-4cc7-b924-9a5e2cdf0f03', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'38342964-1e78-42b8-af36-5282bd75a595', N'T', N'38c1a8ca-c286-4b12-b234-0dc7517e8528', N'72f4115c-3aad-4a73-b933-c6cf765d7425', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'38ab2c94-4c96-4f11-92a1-f68523426ae8', N'T', N'a915b863-7606-4e1e-b692-efad7f73dd8f', N'65f91bf0-bb48-41d3-8a7d-a9bf737f0dd4', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'38e52301-48f7-4c20-881f-86077140d982', N'T', N'd4c77626-98c8-499d-8e1e-886a24246c61', N'7a993cfc-93bf-4e07-a69b-bb234ad9ecee', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3910c656-176f-47b6-805a-4856f3cfbfeb', N'T', N'ccf99f72-1fc5-4e60-9df7-c1462519d565', N'e7747a12-7431-4f0c-b611-6d3bfde8104f', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'39eb0f03-00d6-4d99-8eac-f2e6fdf3bd53', N'T', N'56457c48-9c31-443e-97cf-1f4a673828e5', N'950109ff-1dba-4bb6-a77e-2869f2f4924c', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3a2210f7-211b-438a-99ef-12b89395879d', N'T', N'555c9685-f73d-48d9-be7b-628f6cda4570', N'ef30e1c8-7553-4347-b0d7-0df5d5b6ce9a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3ae7af55-3a90-4f60-ae3c-81ec3b9647c4', N'T', N'65de1a31-6115-4e58-950e-a2186bd671be', N'3b4e319a-a425-4bae-aac4-4be11b90bfe5', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3b19bfe2-7ed0-4395-8b94-978c6cddf490', N'T', N'119e6af5-79ca-477f-b5d3-3b03f6e240c9', N'fc877391-9241-44e9-a7b3-87ba400b6d41', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3b317c27-f1ea-4313-97bd-9f5d697b4e3f', N'T', N'2ea783b0-92a7-4627-877b-83be9f6f04e1', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3c8942c1-ecca-4817-8ee7-fdad218feafa', N'T', N'4e614a0d-a045-4676-9037-9b05f295a889', N'418485ab-9ff9-487c-9469-8ffb15b54abb', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3d2cf623-13d9-4055-af94-77f6a6f8ae76', N'T', N'fe5cd257-07bc-4cb3-91d8-8e6d3a24ed23', N'a2fc104e-3395-4d1b-84da-8a16255c48cc', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3de4548b-454a-4cb5-ab11-e63a6d5aa287', N'T', N'7afb1d01-3157-471e-9dd2-21a7272412e7', N'b642c96d-e652-46b7-a2a5-171835939b99', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3df04ae6-13aa-46ed-bc89-7206189ecf80', N'T', N'd11f2b63-2ebd-4b96-8bce-26cdbccfd924', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3e2127cf-a332-4c5b-9974-17dc4c7484fc', N'T', N'36672499-9a8a-4834-8a63-f99cb959bf2e', N'0f20e6d5-a096-4c3c-bbfb-1f66bb014c13', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3e241334-7a4f-4f70-8e4b-d31c6a800f70', N'T', N'310dc721-bdd8-4f33-b9de-aa6ac6df4af5', N'6b2d6f76-7d3c-4532-92f4-6b4e3689f76d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3e5866cb-9590-4bb4-9f8a-4ef0f201ca1a', N'T', N'700e0623-7bfb-40a8-b4eb-7d38e9b14caf', N'b32cf506-a0a0-4799-9257-2cc1ed707390', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3ec28a89-b9ba-44ea-b95a-1adafea3e8bc', N'T', N'd17f2dce-cb99-4ae9-a588-227b589b5ba3', N'9631e952-bfdb-4c35-ab6e-e4bc33ecac78', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3f7d8279-df41-43ce-acbb-0a57ec57f9ef', N'T', N'7186758c-3043-4689-b9c3-1ccfedb7acdf', N'd2ac8a5d-d618-44fb-b0a7-a19e9ea2fd09', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3faa6676-be3d-4ef7-b425-4edc512ba8f7', N'T', N'fce9051d-71c3-4d60-84b2-6ba3b701355e', N'4ac2076f-cb8d-4a97-bd93-0b2977fffea3', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3fca4ca2-655b-4174-b9fd-fbbee3592689', N'T', N'67defa5b-a280-4e61-81ec-acabde850946', N'9dddd102-15f8-476d-b8cb-08ec2553eb9a', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3fe0da38-1fbd-46ae-804e-f9af325b569e', N'T', N'f5cbf8d3-45ae-42c1-b0f8-4a2e4b8ed7d3', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3ffec3d6-2940-4cd3-903c-8684b63ea9ec', N'T', N'6f7d05e6-4d2c-4d26-bea9-121bf44753af', N'0235cc74-6dc1-4113-9569-9085b790fcda', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4063fba7-23a7-4f1d-b2f6-5bbe55be8089', N'T', N'878db69e-205b-406e-b356-5a0698824c13', N'0397977b-a84d-4abe-aa0c-5b73d6afd830', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'408252c9-4a24-4530-849b-3771daa9e241', N'T', N'b1269a74-e949-4007-97ed-f4fa29806886', N'9dddd102-15f8-476d-b8cb-08ec2553eb9a', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4138d520-f488-41f1-87cf-9232c5a032b3', N'T', N'9fa24d9f-2623-488c-9eac-66fc43471f92', N'b1df6ac6-f908-4582-8139-1360d2f10064', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'417a7f7f-d4f1-4d9b-86f5-186daf494b65', N'T', N'01543a95-ca4c-46b6-a3f0-1d8a25e9abed', N'5e5f6a8d-cb44-4795-ab6b-33369aeeccc1', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'422e3859-2a1f-4f3f-a728-191dd33b9d2d', N'T', N'0db92d05-b83f-4062-a2ef-454c457ccafe', N'd4de56d5-e9b1-4e11-9460-431b31431a0f', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'42bd4b06-abcb-480e-9e3e-7d001f364af9', N'T', N'1baa8f36-7e18-4e29-a739-fe6eccdc3731', N'7805a3ce-754c-4df4-a2cf-7de7fa5cc817', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'42cf53a3-a13e-4ea1-9a34-7a23785fb22f', N'T', N'a95841f5-c498-45d6-a0f1-8c40bb8a8a5c', N'2fc7715d-a7eb-44ea-9b8f-1f9086e2b423', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'435d3e00-8265-4376-ad73-d07a82c4efd3', N'T', N'2b65d5b3-463f-42f6-9a89-00ff458e5ff9', N'da69b792-fd2f-465a-a6a0-2c0322ce5578', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4370cf7a-f392-43d1-97f4-b17515f209e2', N'T', N'e874028e-e2ce-43d4-bd40-73ad01f51d51', N'69354d0d-b975-4422-90a5-fe8be0a8ed87', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4379bb69-f9aa-4857-b131-8e1c4d691acb', N'T', N'59049522-c066-4e02-b9fa-9ffa8a1f3cf2', N'f399bf1e-f0a3-4d31-8f21-ac7d57dc28f9', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4392b496-fc0e-4c2b-9e61-b52bf89b4187', N'T', N'2ecfd3c7-20fd-4a2b-94d9-3fbea0f52beb', N'478cd783-aa91-49c3-a07e-67ad4269d3e7', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'439317fc-b121-4488-b1ec-fbb4b0e07dba', N'T', N'9af92869-3c6e-4c9c-9ce8-2d8194a2a642', N'87170cda-af70-422a-8af4-0b17a114ef47', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'441cc9cd-a305-4a2d-b254-904ff5a69b5b', N'T', N'0acf5b91-98ea-4ac7-9c96-a62cd3fa7ce4', N'fe813de3-92e6-4788-8ede-3b06f34bd665', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'44694b57-9190-42ba-91f6-a9ddc54bb144', N'T', N'bd38cf4c-6054-4b14-a74b-11b595c08cbd', N'b3a3868e-a796-43e7-930d-8da975dc68b6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'44a706b3-39b8-4575-b9eb-d3d49117770a', N'T', N'71db150b-5877-444e-99d2-1186b83f21a3', N'8cc15691-b951-4721-ad01-56e491818a06', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'44ac5591-b478-4b25-b078-2bec7588a2de', N'T', N'6314ad52-b4f0-46a1-a5c0-1fcaeb3a2c83', N'c603c5f3-2150-4429-a57e-5f56d5d5bc85', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'44c77009-ff82-4dbc-891e-7a6d7c95eb63', N'T', N'68f0fde9-c954-4650-95b2-f67b8cb42bf7', N'58327b27-c617-4c39-abdc-321ef4e7c192', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'45140bc7-6733-491d-bcb3-827cf70ac729', N'T', N'4e8ae4db-fcab-41ed-8145-81bfea478413', N'7f94a2dd-ae4f-4d2a-9a27-4ff75a9c83c9', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'45273749-c26a-456b-b1fc-dfeeaaf07f1c', N'T', N'8a5b4a90-e5fa-4c70-920c-ee82b184f712', N'a594a1f4-5539-402b-88a9-1a04c7f3e0a9', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4567283b-d642-4099-83ad-d2884c6307bb', N'T', N'f8abe607-12e4-4268-88a5-f4475d0d379c', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4570bfad-d3c7-4322-8da9-003381453ba3', N'T', N'264ce7c1-e2b1-4a38-b9bb-cadebe2c0466', N'd8d5ffe0-7a84-4e25-afb7-459e1616d1da', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'46f90c29-f2fe-47be-b712-68f603f81ab5', N'T', N'311fddd8-c742-403a-be0c-a21fd008a896', N'84ab3e91-7cc9-448e-87a3-5c11a048e02d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4700ef5b-9e78-4afc-b8cf-9b3afc66747b', N'T', N'f32a53e1-7132-4991-9caf-694d1ef7c829', N'56b5d083-4164-4c02-bf24-cf2efc679e0a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'47285a7e-61da-41b1-8fd2-8939c807dafb', N'T', N'fb881282-460c-4802-99a5-90b0036dfb4b', N'6e47eda2-d112-410a-9398-41afd8024b0b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'477ae861-27ab-4816-af46-2366dbdcd7bc', N'T', N'5767d786-1231-4971-9342-60e3bbd0f82b', N'54f57f0c-3925-4365-ab28-83cd92c35ea3', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'47e2ab05-4053-4fa9-b1df-1ffc516b23a7', N'T', N'e83b2f9f-389b-4b07-bbee-aba2c8924431', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'489fe07c-2511-455a-82eb-463600c0695b', N'T', N'be6fffaf-3c97-41dd-92ff-31c390b50e73', N'23df5bf6-3834-4a97-a202-5595f8097e19', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4a21b229-0888-43a7-a716-fdbad9553ff3', N'T', N'b6798449-31b6-435a-b03e-6dfd992655be', N'8cc15691-b951-4721-ad01-56e491818a06', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4a96233a-73df-4adc-bdb7-8e53f4b2ca20', N'T', N'855f2295-09c1-4a7d-b95c-04edb3d5fa11', N'2cd4656d-b718-45d7-b340-73d419858b9d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4ac02f5f-3800-45c8-9a6b-a09e80b2f6a4', N'T', N'63403c61-368d-4e62-bfc2-7df382b5f9ae', N'f91d8091-ac78-4fe6-8dfb-2e3098f196a8', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4b1da761-e7b9-496a-a530-bf4d133262bb', N'T', N'cffc1e40-9642-4443-89cc-e06b9e924fa0', N'f7593345-ddfb-419d-9e81-0e9ed7c71778', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4b430473-9cbd-4672-96fd-fb77c1146d42', N'T', N'a00acc09-60a8-477e-94c0-b100b84ee11c', N'1d3ca635-9027-4e86-8354-40eeecb1b01e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4bae138b-593b-4b06-a02f-7089d66869ac', N'T', N'95d83ba1-0f6f-41ab-bdaf-5b730a38be62', N'7c5d67cf-9ae9-4f10-83c8-92af72153368', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4c0d74d5-8122-4239-a625-a0373e46e950', N'T', N'a5a4772e-f585-4d15-96e0-47b6dea59eee', N'b671d59e-6a72-4e62-b02a-ca00455b154d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4c658a55-efe9-42d2-84c2-f07d3c4cd57a', N'T', N'c5ce0513-f12b-4bb3-9c17-78ed9803b186', N'03a026d0-93b2-4e15-abe3-610cd64f235d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4ca912be-6cab-410f-b201-9fd2047f780c', N'T', N'd8add11c-bff5-4937-98e1-a5e3cb5334e1', N'1139dff5-8d74-472f-a47e-9f14dc156e2d', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4ca94e57-b802-479c-979a-8a1565e3b7c7', N'T', N'5452e337-99aa-4609-aff2-a00091c9cfa6', N'04a0acb9-8c67-4720-a300-a5bd609368bf', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4cd7fdaa-1216-42f5-8832-4ae324538a3e', N'T', N'4f97c474-2fef-41a3-b154-a26ea1e79756', N'a95c7ef5-ccdf-4c65-9476-51c27c37ad82', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4cdafe13-fcb3-4551-9693-2ca780b95198', N'T', N'a53d9aa1-a9ba-4f94-9e5a-6abf388c7c17', N'478cd783-aa91-49c3-a07e-67ad4269d3e7', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4cf6df25-7ffb-47b2-9b8e-31664f7fa2b2', N'T', N'2f163092-d080-4e28-a987-07feb40f40b8', N'ca5c0f64-8551-45f1-bfc6-c53ad3ca1d74', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4d13a449-f202-4bda-bd77-11e9bca6bd24', N'T', N'eb8933a3-3203-4f7c-927f-46b0d6155744', N'342329bd-07c8-4c1d-944f-169fd0de6ce1', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4d67e59f-30df-42fc-b26e-a7a2d51c270f', N'T', N'9be9b8ca-4287-4edc-b785-ef29d8d8ea8f', N'cd5ac32b-f668-4918-887c-52efc72d18e1', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4d75f589-ac37-4463-b7a1-7ec98d86ef1a', N'T', N'fd73f4fd-afd3-41c4-80f6-ce777fa814bf', N'50fdd78a-0574-498c-ab12-56007ff01f54', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4d7a31eb-5eb3-418e-a197-e451a2366327', N'T', N'c0e21577-c238-4c25-a06c-5cad85d81603', N'f2b81873-1edf-4f5a-9e4d-f6c53b926c91', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4d7ef051-555d-4cd3-b4df-867e01e1082a', N'T', N'558ac514-a74d-4c39-9dea-5c66c680b41e', N'bd6a5039-354f-4729-aeea-c3a1e1de4c6b', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4dd75f36-71bd-442b-8a07-e52ee93008ab', N'T', N'8756fc5d-b184-4da4-840d-ddb9befc2b7d', N'c794893f-0af6-47e1-914a-33335a18cc38', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4dfc8184-48bd-4d5c-b685-be9128893019', N'T', N'f858dbb0-2e84-41f2-9cbe-e9e41d464a1b', N'5259610e-b12f-496e-afe3-b64197117319', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4e88d3eb-f142-40b9-b8f1-79208fbeb969', N'T', N'75c92bf0-7529-4312-803b-235706e426cb', N'd5aab6ac-e491-45f6-9a81-21832c1e6816', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4e8d6c10-661d-495a-8f49-1b69fa37f427', N'T', N'50f39e24-2da1-4b53-beb0-b2937b6c8563', N'f5413783-f932-40b6-9e4c-13e35723f00b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4e9d9829-61a6-41b3-903b-6c877ff322db', N'T', N'4583965f-2763-4941-b36a-18072c56ef13', N'ed7ddc67-e130-45d7-8a78-31d556d52923', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4f38fdb7-1c3f-4c26-81cf-58b395884914', N'T', N'8f4f11a7-3b28-4e44-8bc1-1bafac98f45f', N'fc877391-9241-44e9-a7b3-87ba400b6d41', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4f6b65f9-7808-4c79-8364-e7d50393e1a0', N'T', N'62c86293-cf5a-482a-a01b-2291e8148335', N'cbb1f262-d57d-4478-af51-d450574739f6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4fa4dec4-b307-4cdf-823b-5763be33c94a', N'T', N'b00f3891-2e78-400b-aa59-2f70303e615b', N'75d7a734-c8f4-4a2e-bfa8-b47d23a08308', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4fdd9705-e242-48b2-8fdc-baf267647f1b', N'T', N'7dfeff03-f0d4-402d-9a25-0ac2efff85be', N'f9b27c0d-3496-4b72-8dc1-47ebe0d9d7c6', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5045e131-6eb3-45aa-8419-f777ddfc1927', N'T', N'fb881282-460c-4802-99a5-90b0036dfb4b', N'cb9256cf-267f-405a-8769-a9c55300d696', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5051ea91-7b2a-436e-8283-45fc9ee462b9', N'T', N'a81445bb-49d3-42ea-b3d8-68933325cb93', N'a7582789-5b7e-40ac-8bf8-0e9b82246927', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'509dded2-72d5-4fac-bcc9-ce0da913f36f', N'T', N'2ec9674e-7e76-45ff-b3f7-c1cdcb29b4c8', N'128fff9a-9887-4a4c-a7bc-1883ecb224f1', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'50b0581b-3330-49d7-9d47-8b280d326483', N'T', N'27d919b8-a58e-4094-a5e6-051fb7ff02be', N'02751ffa-6b02-4aff-9e84-fe51d13f1aba', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'50ca5827-e0ed-43f8-b525-610d7ea19a2a', N'T', N'119e6af5-79ca-477f-b5d3-3b03f6e240c9', N'ed71d383-4b81-48d4-b1ce-be42122326e8', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5127eb37-1eba-4153-a6bc-7972dafc03fa', N'T', N'e496e8b1-dca2-49d0-b811-ea1726ab3e38', N'fe4c1af0-2430-4858-9bfc-046c6cc8c51a', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5132dac5-9104-44d5-b1b2-39d8e796af62', N'T', N'8f4f11a7-3b28-4e44-8bc1-1bafac98f45f', N'b44ebf1a-d3a6-4791-bbe9-bced6a28233b', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'51525386-2a1a-4ea0-9628-51fbb72c03f6', N'T', N'8f1e5f99-97c2-48cd-9bf0-ed86c10dbd72', N'28f70c37-7354-407f-9576-6ae353a39d01', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'51859b5d-add9-4497-bb1d-476c9bacc719', N'T', N'92e0755e-1bf2-47ca-b238-af43f1e1dc4a', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'51867a5d-965b-4cb7-91d3-7f31deb4e1d1', N'T', N'0b76b16c-e31a-4fce-90e8-d859dbf1236c', N'464795ce-81b2-471b-a564-9099fea5ff34', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'519e2105-a0a0-438b-8d20-4f315463d0d7', N'T', N'e69af77e-63c7-486a-958d-1a8e55824a7b', N'42c318a5-94e4-4c58-bffc-b129f3373f04', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'521b2b45-af30-405d-9e55-2456c79df5fe', N'T', N'e6612747-475d-4cb9-adf8-3252fcf02489', N'13b3791c-dda3-4c5f-ac97-b0d1a75b821b', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'524ceee6-dd2a-49f5-98f9-02c99bf73912', N'T', N'5594c550-e72a-4943-9399-edd87a4810c3', N'00a20666-d95f-4eea-a0a6-08e93e9289f5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'52515cf5-05ee-426c-84cb-d86828a3dfd0', N'T', N'38525c45-600b-4384-a730-9fbb3e200a50', N'69354d0d-b975-4422-90a5-fe8be0a8ed87', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'52b32564-a56d-48b1-98cf-e9b96641610a', N'T', N'7bd7bb5c-2e3e-472f-8f1e-0eadc4766775', N'6c25c7e6-4a3d-4162-806f-c73349a7e75f', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'52b371ef-5458-46f4-8b7e-d5c11f011a72', N'T', N'bfbb7b50-8a31-45ab-9e5b-26281390123f', N'b671d59e-6a72-4e62-b02a-ca00455b154d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'52f846a2-98c8-4e66-b2f1-458606bfa5be', N'T', N'555c9685-f73d-48d9-be7b-628f6cda4570', N'7752da29-269a-4c56-9ee4-219109e709aa', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'535ce4e5-82d6-4fd4-9d27-6618f3c09e48', N'T', N'd3a76b31-7960-46c1-a6ac-f83904585e68', N'5b1e5238-ef0d-4bd2-b3c5-dad5e9b693db', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'53754e4e-3020-4a79-a324-fb6fe721eab1', N'T', N'1b06194d-e258-4eb8-8e10-8ef631232e89', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5379b547-8ac8-4084-a167-fce8a788393c', N'T', N'0907f9d1-9418-405e-9739-12a0f2789864', N'f937649a-ee3f-44cb-b008-7c1ba9d67e3c', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'53af952d-4df7-4048-bb97-f9388be019b0', N'T', N'14d7b56c-3950-47b3-b4ee-b14052039488', N'd28b1c61-3c53-4eb8-a7b5-6aab9c21d5d0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'53bf8b29-ef0b-4022-a881-2b8dcea35d15', N'T', N'ee5639af-c049-493f-bc22-401a4ce22f5d', N'd1f83bd9-914e-4845-a6af-3b80aecc7c68', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'53e4551c-76ac-44aa-96bb-02cb1f353aab', N'T', N'cf5477a7-6fad-4b32-a859-ab9b3e8102a1', N'a6bec947-93e4-444b-ae3b-0eee17c65e61', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'540fb2b8-728b-47f7-81c3-3f85964f97a9', N'T', N'd10dd248-309c-43bd-b33e-6ad9bc389cd7', N'0afbf503-0049-428a-84af-78acd999a295', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'546098f0-5836-4a37-b3b6-ae198d6a384e', N'T', N'57e0a8f6-8a8a-407a-9286-135f861b352c', N'd8481200-657c-4f97-9b08-ad756967ba4e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'546c419c-1396-4838-9a00-9ccf008b4cb4', N'T', N'f8360009-70cd-4db4-9545-e8d023afa65e', N'ed6486c9-1e48-40a4-ae19-4c55d3288560', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'54a0f829-6e8e-46b6-9bf9-4af28a8ab54d', N'T', N'f15e3565-e50f-4536-8a0e-1c3fd616d205', N'2fc7715d-a7eb-44ea-9b8f-1f9086e2b423', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'550ee2c6-5f5a-47e9-b337-e8cd3eb5b6da', N'T', N'5ab45191-4725-483c-96fe-bd91df24a771', N'18d33287-f04b-44fe-bd74-98efa0a82363', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'56180d5a-8b8b-4f0c-9175-31df9b451cfd', N'T', N'eca0caa4-b5ca-4173-a9ae-27f112cd0a6f', N'a3d8e580-f20d-4ac9-9612-1742b75cb68a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'56688032-0f3b-4b83-a12e-394ae438289c', N'T', N'b019ae86-e304-46fb-895d-7885e3b2b30b', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'568d6871-3697-43fc-a231-c9fe3aea0374', N'T', N'806905a8-4bf6-45a9-86ce-5972f8490332', N'64398376-0e63-4b7d-a58d-6d6de1e43ec7', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'56d3209c-f28e-4aa2-b0ad-ba3d0e84af32', N'T', N'7e978acd-561a-4c8a-bf8e-ed0c75626c16', N'282b0805-c562-4792-9de7-18ae10b3be96', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'56d91fd6-3eea-4b02-aa96-05c1f5ba5a25', N'T', N'c45662a7-b59d-48ef-8905-33bc68bad6c8', N'8ac6c354-1b49-4e1f-b158-02c6e60c62aa', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'56e1db88-b871-4042-8ea7-82dd1a5bf08a', N'T', N'2afbedf9-f56b-466e-a7dd-9c5e7884a0ea', N'7efe9a6f-6080-456f-b85a-dfa9fcad53f2', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'56f4252a-726c-4e57-a4c7-3a2208484a5a', N'T', N'd46783fd-3e08-43dc-a348-5a9ff4fcfad7', N'3b8effc7-3631-4863-bb7d-14180c84e29b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'57d6b8e5-2b54-4278-8199-47f66d1a316a', N'T', N'f7a80419-ef33-49ef-b579-a875ec731f95', N'fee6c847-8509-4cbd-a05a-7fabb34e6282', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'58c6046b-0839-4138-89b0-8bf1634c777e', N'T', N'd4c77626-98c8-499d-8e1e-886a24246c61', N'5f029b2b-96a0-4748-a084-a2a9f51a7b3f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'58efe187-987f-45a8-a3b1-f727a7d594da', N'T', N'70f44788-8d56-4c68-8f4b-9f89a0f8154f', N'b671d59e-6a72-4e62-b02a-ca00455b154d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5916f086-72eb-449c-bf12-e2adc3518ba0', N'T', N'fe101794-a0e3-4505-b106-4d311b7c579c', N'03dc0ff6-c524-4262-920b-50b7a63fcad2', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5a280610-37dc-4b49-8d32-fff589ce7b23', N'T', N'eda86712-d37b-4b8f-bb20-c9f95671d48f', N'7a993cfc-93bf-4e07-a69b-bb234ad9ecee', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5a39965c-d520-4851-b881-385e853ad062', N'T', N'd3b990b6-8de0-4367-ac08-bcd8568f90fa', N'617aa30c-45c3-4c87-ad7a-ca1e24c222b5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5a4a41e6-4c03-44a4-b9b2-f9e06dac3298', N'T', N'776c4830-a0e7-401d-8575-706ba98573b1', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5a6b4a40-dd2d-436b-b804-7043e5bebfc9', N'T', N'7e62ca60-7160-4069-9463-a1fd5c8fecac', N'e1a3ee16-520c-49bd-834e-e77957ecc2ee', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5a6f33ac-5319-4280-9e58-843489f5fcc6', N'T', N'69a4eab3-6aa6-4191-9310-71962e2852b5', N'64d152cd-5df5-4c1b-8bb7-cfe2c2d9697e', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5ae75e36-19ec-43c4-9bf7-c5622a7512a6', N'T', N'd42eeb5c-429b-47af-bc4a-49184db1ec0c', N'3b01d3e0-c69a-474c-8f2d-8beedd1b8832', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5aee5913-a29c-4201-9a45-821bbb1d1567', N'T', N'dd43bc3f-f976-476a-a763-f319e33860ac', N'529170f0-93ca-4545-a7af-2670226ae260', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5b70907e-f14b-4993-a2f5-38527ec1254a', N'T', N'ce077d8f-848f-472e-87e7-b81ce8d8ce36', N'f5413783-f932-40b6-9e4c-13e35723f00b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5bb8e8e3-a62a-48aa-b3bc-dde7dddf145b', N'T', N'395a8eed-5db7-4293-b5ea-bc58d8289e81', N'ef30e1c8-7553-4347-b0d7-0df5d5b6ce9a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5c2dce8b-7dcf-47af-b48a-c9898afc2ac1', N'T', N'4e614a0d-a045-4676-9037-9b05f295a889', N'18d33287-f04b-44fe-bd74-98efa0a82363', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5c502aa1-efa9-4e00-b624-237c4078694e', N'T', N'60a0a7ea-d335-4b8a-a6ff-d39cae8582d7', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5c854660-6061-4cd9-a717-3c83f55d6522', N'T', N'86ba713f-bc95-403c-bfd0-7c373011737e', N'c2ebf0e6-1fec-4e27-96d3-26a1ca727efc', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5ca24f85-38a9-499b-ae5e-116d910c0c07', N'T', N'6344c15b-bec6-4e9e-8ddb-38928f051779', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5cd632b7-c674-45c1-b365-8d3bf715a161', N'T', N'82da58b0-facb-49a8-8860-1af591f283df', N'c2320e10-18ea-4d95-b954-12bcd5d1c93f', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5cf29a44-f64e-4f32-b1a5-a36ec9fd4fd5', N'T', N'2b478fe8-9513-4ee9-a9f8-ba2f01f7a627', N'd9f2e137-353b-43ca-8215-cd469e713ce2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5d738d25-0678-44a5-9d74-fe3576ba919a', N'T', N'260cc15d-e6e2-4b45-916d-fd0f60db1a2c', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5d7d99dd-7fbe-4b1a-8d0d-e2e7feb5b91f', N'T', N'd8add11c-bff5-4937-98e1-a5e3cb5334e1', N'3d39bc60-6766-4dbf-b4a5-fa36b888dd5f', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5e02a627-14fc-4e9e-a8ac-d9cbafdb152d', N'T', N'c15de35c-0958-4058-931a-0ec014c1faab', N'935ef03c-c766-4394-b798-5c18eafb4de0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5e20a657-c397-461a-8964-0819f0d1da46', N'T', N'f97d4033-8b91-4f87-a940-d7b9fd15c6c4', N'fcc46788-e663-4086-bc82-e4d21c3ed1e5', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5e992778-65b5-4446-8ced-7cdfefc0ad38', N'T', N'5204f5bd-7eaf-43e9-a78c-154b46cb2af7', N'59122650-7a89-4b00-8ea1-bc277a0a8014', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5eeb0b96-0157-4d92-9914-b7b07f05d8f8', N'T', N'a9e72844-8444-4f68-bcc8-087ab1c3cc72', N'27dcae09-01df-46b2-a096-db17657b0c55', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5f61a4b6-c6be-461c-9d52-04e498860157', N'T', N'c7bda07d-b8a3-4b85-9fb8-877e65300cba', N'7304e1db-b73d-488c-9fb8-3dc86da04828', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5f77e836-bf3d-4c4b-b2ab-04c65d4c6dae', N'T', N'0bd49ba3-0765-4df1-9063-cbaeea7acbb1', N'b972ef7f-14fa-4e45-81ef-7bf69b4f06a3', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5f8f6a60-427f-4f08-80c8-19e9b68f3552', N'T', N'8f979d8e-acd1-4bd5-a551-ea69f3c34f82', N'1c2b9664-db31-4e07-ab10-6b0ffb6808ff', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5fa8a77b-5ce7-44a4-9a79-8e7ce789eea8', N'T', N'cb6e0bdd-d77e-4e74-b7da-f19e5b139444', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5fbf0a39-fae5-46e2-adca-bb8058854ac4', N'T', N'd7692d54-0dea-403e-979f-f4e9a6afbe15', N'478cd783-aa91-49c3-a07e-67ad4269d3e7', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'603a15a7-8adc-46d2-a78b-3d9fa652d2c5', N'T', N'64c2f7b2-ab9f-421d-b932-9a74ba4b278f', N'b424211e-4558-451c-b2df-b2b2f7d8bfa6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'604551cb-2e57-4955-a271-4fbc23e62803', N'T', N'454a2c12-0ea7-48a9-baf2-3e3987d7215c', N'2055cd2e-1a75-4b1d-9c3e-b20811ec3b10', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'60532fae-e40b-4c07-b775-dcf4f01b4dd1', N'T', N'df2402dd-ee86-4a15-a64a-d632f0fdde5d', N'54a02163-73d9-4a8e-8b41-955f40dadc66', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'606cf61a-b1f5-4075-8c75-ee6afa6515a9', N'T', N'f9f4370b-02be-4f9b-8773-ce7ae61fde92', N'95c42aa9-7e54-487b-b56b-f09ca836fa3e', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'60b5ce25-e67f-49bd-a298-e37b84757c54', N'T', N'f2293ceb-c145-4612-8c45-4eea04ec29a1', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'60b9c13e-8c81-4a66-aaf0-40e137d70fe2', N'T', N'ccd56fc8-0c86-4b3c-be2b-60b489c823fd', N'c31298f5-047e-4d7c-826e-619336266529', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'61157179-b47b-4a81-916a-b1f62f94221d', N'T', N'110e9fad-810b-4027-91a1-cb52e6d27117', N'd17c9657-4068-4ead-a9ac-55eb74b8546c', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'61166f84-68a8-4445-82f9-f8286203baa7', N'T', N'fce16035-52f7-48cd-a5d9-2e0d787c2b2f', N'cf4b84cd-d0a8-40cc-9a9c-1feefeebc8ab', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'616e3b92-bd05-4200-9cf0-cf3295980d0d', N'T', N'0817350b-6465-4c88-b842-2a143ac350e9', N'5a03a62d-fcbc-43df-89b1-270772b7c8bb', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'61ae61f5-49b9-45dd-bb1d-5616a964e03e', N'T', N'eff659cf-f445-46fc-b4ba-6fc6df267065', N'13b3791c-dda3-4c5f-ac97-b0d1a75b821b', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'61d44728-18c0-41f4-a653-9c779830b967', N'T', N'dd020a18-6544-456f-81ac-3b22cefccadc', N'ec97c46d-7c5e-4248-9f52-a075d1268789', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6232bce6-08a1-43f3-925f-c9e0e1bc1db6', N'T', N'4962e900-e1cc-4f0f-9de7-c269bfdfa228', N'925ca9f5-13be-415b-a0bd-60bc53dd95a4', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'62e5206f-e494-45bc-9494-f9579dff21e8', N'T', N'67f5f872-62d6-4115-a31f-fc2efcde74f5', N'ef30e1c8-7553-4347-b0d7-0df5d5b6ce9a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'63372131-67ee-440b-8a02-3d02024ca130', N'T', N'7c270a19-c6c3-48a6-9c08-b50b1ebe3e37', N'03958448-a664-4a2a-b30d-19b8b7c1d2fe', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'637b8b7e-3913-45f5-a120-662cab7f1aea', N'T', N'0950f63a-34fc-4698-bf71-c1b379484baf', N'935ef03c-c766-4394-b798-5c18eafb4de0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6382347e-7c4a-4e9b-bdd1-15bd2678c1a6', N'T', N'd455558e-1472-415e-bc36-cbd09a474421', N'b07edf47-b339-47e2-8dd9-f156fd20ad19', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'638db8c4-8d22-4b4f-8cdd-66d81698d45d', N'T', N'94b4e32f-60a4-4790-82f2-f309848a0fcb', N'03958448-a664-4a2a-b30d-19b8b7c1d2fe', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'63ba598e-501f-4522-b4b4-961b258ae24f', N'T', N'fad319c7-764d-4a60-b226-2861614be8d5', N'50b4a9d6-2394-4a05-b4ef-438e6e8188dc', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'63c9659f-6734-4795-8ed1-d8d873b0f2a6', N'T', N'7186758c-3043-4689-b9c3-1ccfedb7acdf', N'5f029b2b-96a0-4748-a084-a2a9f51a7b3f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'63f859c5-21b5-4572-8ed9-de557fdfb8fd', N'T', N'2fd3771a-c774-40a7-a29f-192e5c36be87', N'1e198730-e33f-4e98-8287-2c04d527a6f2', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6456485f-17ca-49c7-9c35-44ea8fa49a69', N'T', N'61e01a98-a840-4996-adfb-92fca097b7f3', N'5f0ef3a0-790d-4531-b3f5-0b87a71fdc2d', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'64c4bf54-db33-445a-9c24-50d84ec7c575', N'T', N'd424daa5-a3f2-44fb-92eb-ca28a5c7f267', N'f61b3709-0c93-403e-b375-5bd4d0a334ff', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'64ec8876-8d40-44c6-a46b-c1ddfe42c2ff', N'T', N'beb5a2ac-e75e-41d1-9ca3-29488b14bf0d', N'8cc15691-b951-4721-ad01-56e491818a06', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'64ee2940-8f34-4dcd-b802-be62401f9fda', N'T', N'26f58b4f-6527-4d5f-b087-8350418b84b0', N'd8d5ffe0-7a84-4e25-afb7-459e1616d1da', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6518a083-a83c-4b44-a66a-5306b93307a5', N'T', N'289ea5dd-3623-430b-a819-b2a7658499dc', N'204a1b13-d4a0-43ea-9390-7a403070c1c7', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'652a3ceb-a333-48ff-ae74-07ee963f4123', N'T', N'daca76c4-343e-4c9d-93c5-f14414156c82', N'fc877391-9241-44e9-a7b3-87ba400b6d41', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'65615917-8507-497b-8808-eddf3e2997c3', N'T', N'8c697881-66cb-4010-bcaa-2e9181e13f7a', N'03a026d0-93b2-4e15-abe3-610cd64f235d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6586ee42-11ab-40b3-918a-0fa39aa74161', N'T', N'ac6800c0-c780-4a35-b175-b4c843f353d5', N'c2692b42-a2af-442f-a42a-2ee326874415', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'65caec0f-04bc-4a60-a6cd-572c47f14499', N'T', N'1aedab22-eaca-4cc6-9caf-4a0a246f05d0', N'da2a0c89-f968-4ddd-97e7-dde99eaaf411', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6612bb8a-6669-46e1-8b84-a151dfaf5c9b', N'T', N'd46783fd-3e08-43dc-a348-5a9ff4fcfad7', N'eac3a424-c92d-4cae-b85e-637faead8f26', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'664281e0-9cc9-4e2c-872e-da587b3d8c4e', N'T', N'80209022-7db1-40b0-b978-38068e2f1cc3', N'03bdd188-8c6c-405c-9ddb-9ccb1ecdc186', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'66b0c01f-f7fa-445e-b4ea-3439c0e7e86d', N'T', N'45986b58-4056-4b98-aa84-98da00a7f643', N'b9825717-ca09-4408-b9a8-045f0e4de9bd', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6767820a-4914-4160-a550-ebda74ab5f9d', N'T', N'd10dd248-309c-43bd-b33e-6ad9bc389cd7', N'54a02163-73d9-4a8e-8b41-955f40dadc66', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'67e8d16c-cb4b-4af6-ba73-546b5338da32', N'T', N'32312174-f2d0-4447-ace7-6c969c236fe5', N'8137aabf-7449-48ca-967d-60149389e04f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'67ff246e-f235-47d9-983d-3d3f2bd770e4', N'T', N'b14e2e43-c9b1-4872-bdc2-8f658fec02b1', N'ec2f2373-e5ac-4116-9c5c-6ffdb275ca1c', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6856b916-62f5-4bff-9f36-4828e3cc4c8e', N'T', N'395a8eed-5db7-4293-b5ea-bc58d8289e81', N'57280ed4-feb2-4c01-a713-304d28229162', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6856f6e7-184a-4a03-b7c3-ead3eb7a0747', N'T', N'ab2deef9-6c4b-40a5-bca6-878738401ebd', N'c120959c-7154-45a9-ac6d-35be798bb0e9', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'68809c02-5fd4-4145-8d9c-29a06e8d639d', N'T', N'e532287f-1c5d-4749-8eb0-a07e9df99304', N'7e9fb19b-607f-48fc-96b1-73b7255c3d01', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'68fb4cb5-0b68-4e80-980b-61d53407b61c', N'T', N'cd1374d6-31e7-4dbc-9e39-571fe1902ddf', N'2a579ec7-8c5d-49bb-beea-9487d0212569', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'691805fc-b07e-401e-8e90-b40ebbd9083f', N'T', N'20158901-62dc-48bc-aa18-b0b63a0c4e19', N'99da7903-9969-48e1-96da-4a5cd735d07e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'695f1432-fc34-4e9b-9cf4-0e69269f7e45', N'T', N'1724cd05-e32e-4309-9771-e3cf5b7d38ec', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'69d42b44-959a-4924-9bc5-cd72826a02d0', N'T', N'f29f50ad-0484-4cf9-bef3-abf6c26dee28', N'52c9e9b3-c7ff-4dae-8806-41a9e72d69d6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'69d9248a-21e6-41c7-b41c-58cdc2f8d7ca', N'T', N'f0e9f395-577f-45bd-9828-83bf29b38717', N'c3f7cf41-c038-480e-969c-6828eeef3873', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'69e88415-9b17-47cc-8850-5d5a6a855892', N'T', N'4b991fe0-5647-47d1-ae50-4bf5c596664a', N'9857f2fe-a82f-43e9-8dab-770bc9fa6807', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6a02f12c-0de2-494b-96ba-661310ed9a50', N'T', N'a6f23d0d-085b-4489-a37e-8c7799ea38e4', N'596e9e2c-8ace-44ed-a572-939329d941d6', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6a0e96ec-61d5-43af-a3ac-7f7caccc8ac2', N'T', N'a77273d1-a6d4-436a-bb0e-8394d256d77c', N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6a6c1658-2839-495f-bbd2-c924e30940b6', N'T', N'3f9881ec-dc14-452a-a447-77e0682df6e2', N'621dee8b-d883-4996-b9ff-8da29cb6164d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6ad8e644-897f-4055-bb5f-e37f037ad0be', N'T', N'028997c4-bb3d-4123-b44c-e7edf21b313f', N'56b5d083-4164-4c02-bf24-cf2efc679e0a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6ada7492-9e02-4126-9758-bb4e00d9aa69', N'T', N'ec918aa4-248d-4772-8fe2-e98e1da2f608', N'82db5964-11be-4d47-8f5f-9aa68ebf3644', 0, 24, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6ae453e6-5ec0-4d4b-8bad-689bc4555100', N'T', N'f0d9d2c9-cbb9-46e3-b89c-a0ffb3e241de', N'3d183c31-6e4a-4312-9db6-108fe33c5de3', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6b0617f5-a17e-4e61-9b41-5466967e1457', N'T', N'e20af921-bddb-4536-ba36-887b52123f33', N'589a23c0-d4c1-441b-b3ea-cf9ae2c7f587', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6b2ec194-f3ba-4679-916d-8f77ad1e9a9c', N'T', N'9208dd8c-09a7-404c-a8ec-e0f428fbae8b', N'9fdec72f-56fc-47a3-abb0-d37ec66ab712', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6b80ecc6-8831-4ff1-b204-51086c17b4e5', N'T', N'f4867fd0-0ad5-40df-908f-e17abb0319fc', N'475694f1-c0a6-475d-9801-3e2e4473b362', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6bd44ab4-4a2c-4c21-b6d6-d9308c153506', N'T', N'b002e6ca-1cc3-4594-af80-bedfea524fc8', N'b528c01f-d65b-4146-a347-e8b8e31d36d2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6c6fb49d-206c-44a9-a00d-2c6f333d06e6', N'T', N'2b6e4b4e-4687-4f54-a2ba-e3848efc86dc', N'a17015c4-2722-4284-a9d6-b6e4a328feb4', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6cdfc304-caa4-4588-8f26-004a114f2e04', N'T', N'6568b45a-053b-458e-8318-5233033d0dd9', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6cf8ecac-df2a-48ca-8fb3-b368a8b9c350', N'T', N'a0c74c8d-cd88-481f-9d5a-769990f98709', N'1c46d305-2ece-4ab3-b195-9ae1a604d5a5', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6dc01b69-d202-4f5f-a47f-b2c3d535df7b', N'T', N'57a2ca8a-533a-4479-9292-7fd42d620d36', N'b671d59e-6a72-4e62-b02a-ca00455b154d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6e00e69c-d66f-4e98-85b5-aa7a4a3eca9d', N'T', N'889b9daa-25a9-4f05-bc6c-58158b64d045', N'a14c23f5-351a-4c22-9100-585719f0fa25', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6e2b31c3-0b24-4734-b1e2-cf9c2044e38e', N'T', N'7afb1d01-3157-471e-9dd2-21a7272412e7', N'b671d59e-6a72-4e62-b02a-ca00455b154d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6e4efa3f-5533-4c19-a632-b40c15667362', N'T', N'1b8acc66-eada-4165-8edc-06eda8cff282', N'b277063f-ed0d-4ec2-9d55-dabbbbafdd93', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6e5be441-3d5b-41ba-9f3f-bd16efd87ee0', N'T', N'b1daaca7-949c-42b0-bd21-306358a14c83', N'19168b9b-2b06-473a-9b3e-b628d15b2fe5', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6e5c6105-ca26-4434-b969-683176d77c3b', N'T', N'017e081d-a7c2-49a0-8415-e7e2754129e6', N'493ca5ec-c11d-4d38-9bff-581398d2dd0c', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6e5d996d-a126-468f-9e67-6ef47cdfc72d', N'T', N'ea5dcb7d-a170-461a-ae4b-2cf0a747da68', N'982b665f-a329-4b12-b4ae-ba85c3d23fb5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6ebb84c9-11ed-4078-8eed-8e6467b363e8', N'T', N'edcd7f05-93ed-4ed2-9831-464d91afc40b', N'58b56027-6a77-458b-8f72-9a11e435827b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6ee9b058-1dec-4451-a71d-7d7f60bd3dc4', N'T', N'b385d7ab-6cf4-4879-9338-19f8af33ecaa', N'4d284252-4048-4be6-bb43-2fdc31bf2aa4', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6f245532-938f-4955-8a7b-edddb28af301', N'T', N'3713d767-c03d-40b1-87d7-ffad27893e93', N'b642c96d-e652-46b7-a2a5-171835939b99', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6f60ebec-2b6a-410e-8fe2-b25831039a09', N'T', N'5593c188-6515-445e-a48e-1624e035f596', N'7799d988-814c-4e4f-9648-bbb4ce0e9c03', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6f68e3ea-c2c9-452b-a89c-6ad33f4d0fec', N'T', N'6abf237c-ab20-4fa8-acde-4aec54640d7e', N'bfed680a-3ecc-424d-b3a6-fa65c58238f0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6fc048a5-2f43-4845-b36a-f03f27a1c10d', N'T', N'2ea783b0-92a7-4627-877b-83be9f6f04e1', N'72069650-b54f-40b8-9e13-2cb8ffc0ec37', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6fcbcc4b-3cb5-43b8-bca9-8b40fe7d03a9', N'T', N'53c6d384-c7ce-437f-addb-c8e0ec9baab1', N'fe402cce-ffc2-4bd7-ba22-24855d10b9b9', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6fe7d995-d793-4de0-bf4d-c8ba8662c3c0', N'T', N'f10cdae2-c426-41e5-8a3b-b20c5cc55497', N'9b77e22d-dd82-4fe3-a836-511ff8c91805', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'70153cb0-0fc2-4c72-97bb-3e8c72a16215', N'T', N'2d05e203-6a69-4145-9670-a1ea78bf60d5', N'351ee22a-9457-459d-b8dc-d1fc9dbc94d0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'71f030f7-5f45-49e7-b769-1fb601593800', N'T', N'035bae1f-bd61-4ff7-8325-faa820b24bf7', N'ea00554d-5abe-4fad-86a0-37405c6e9fa0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'72434bc1-6205-4de8-af90-c38c93988a20', N'T', N'86ba713f-bc95-403c-bfd0-7c373011737e', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7261fd62-f9d1-42ca-83c3-c3a08220c9b7', N'T', N'261251f3-7f07-4a7f-bbeb-a5092b29dc23', N'182333bb-d3b5-43bc-b931-ca42764840bb', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7276432e-94c6-4a55-8991-cbef4d5fd0d5', N'T', N'31cf4bd1-b528-4270-83c3-3af95b8edd6a', N'7bcce853-aa70-4be5-b29e-ebdb2193a4cc', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'72f289f8-3154-4ba1-90e3-05e1fc923a71', N'T', N'238176ef-8cb3-4c05-9f98-e843d8dad318', N'fa0fbbca-1c8e-4d1c-a799-ca8575b8712f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'733d1b87-f99e-4895-b7c4-85f37876c40d', N'T', N'75f9e0d8-ef5f-4254-a3f4-a73c6256b831', N'bc16e993-af08-424d-abde-8e999ef47a7d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'735c3b80-c1ba-4d80-9613-afcf36867961', N'T', N'c979c251-0885-4408-8cba-0cc087dc3fc8', N'1eba7055-c448-4c18-b2ad-2c86c822ad15', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'737a2c39-389c-4309-966a-d7c4a03647ca', N'T', N'0bd49ba3-0765-4df1-9063-cbaeea7acbb1', N'f2b81873-1edf-4f5a-9e4d-f6c53b926c91', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'737b57d3-d673-4231-83da-ae95cad2aa44', N'T', N'650248d2-d6fc-46d2-9ac8-6d3628997237', N'ed6486c9-1e48-40a4-ae19-4c55d3288560', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'73be174f-4f3f-49ce-9217-de2c95174ebd', N'T', N'fe5cd257-07bc-4cb3-91d8-8e6d3a24ed23', N'ca21d05c-2c3a-476f-ae4d-b57abc5f6f75', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'73f5da82-8e43-491b-be7d-20f8425c13ac', N'T', N'5eac86b8-7127-4e22-8f44-0264a40a5795', N'b68a9477-2e38-4314-a07c-f17a4b1cbf30', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'740b271c-1937-4a98-838d-37e6e378ba18', N'T', N'30027f88-86e3-4d10-8252-d48dbbe3067b', N'ef30e1c8-7553-4347-b0d7-0df5d5b6ce9a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'740c1609-b0e0-47c7-873a-3b3c6d001640', N'T', N'b02908d3-456f-464e-844d-81888e3d4b31', N'0cb088bd-a195-4b8e-bd5e-af716f5a41e0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7457cc0a-d614-44d3-9446-f3fd46a78896', N'T', N'83ba6518-da29-4de6-9bd1-9d0a9459b15d', N'bebfa1b6-fd1e-49b7-b35b-9a25c3489212', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'74bbd8a8-9f09-456f-b388-57a819806cf4', N'T', N'f62d001c-b104-4c12-9f97-32f0b7af7305', N'd14eb95b-2c23-4997-a571-a37097bdce67', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'74e2a4e4-9c91-4f2b-ad94-7ecb292dd517', N'T', N'a932b1ef-14ee-4abf-9cd2-13b57eaed945', N'b6331150-090b-465f-aeab-509e6fbb3af8', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'75350ad4-3e46-45ac-85f1-8d273a5b0377', N'T', N'7e5037f8-110e-4045-b6c9-8d64339cf408', N'b0f50092-f58f-4969-ac3d-79f221f46bb5', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7554b42e-b7e5-4d66-84ce-2bcc4d144174', N'T', N'78c956f7-e800-44bd-8b23-b1f96dfb1972', N'b6c3558e-94d3-4694-9cf1-9d7d56f73a3b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'755ce4a7-f4fd-478b-91c3-5226752574e2', N'T', N'5a31b9e2-e14f-424b-975a-e1ee4306f299', N'995e9d39-8ecf-40fd-b58f-af62d2d62439', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7560a993-36de-485b-be3c-1009661ccfe7', N'T', N'1b07471a-8b08-4fad-9081-c315f4153e62', N'2eaecd73-c6a3-4ad7-a9b9-dc8c5edfa97c', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'756408de-b72d-48fd-859a-1d62cd8bac0e', N'T', N'a16fac51-4cec-4375-82a5-8440c3fc53a3', N'a669b3ed-d55e-41e4-80f9-468d6d65e499', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'75e1411d-eaf5-4418-96cc-73e681ae6509', N'T', N'd5ccb6eb-43ac-47b0-850e-91ef2f165f1f', N'76bc9483-5c31-4043-9361-f05fbcd577f9', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7641496c-7a58-440a-8dd9-937b7660d55d', N'T', N'a53d9aa1-a9ba-4f94-9e5a-6abf388c7c17', N'98074582-7f6e-4d6e-8651-6f0808b7f19e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7649f879-fcdd-435f-951d-5b6c8908d8f6', N'T', N'db21c4cf-5a01-411f-92f8-b936ac314516', N'be8ae03a-b86f-4a27-b207-21993338db8c', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'76501ffd-7cee-4005-a6d9-b3206a4712a1', N'T', N'02526682-3c1d-4240-bbfb-0d71e779818e', N'3491c4bd-027c-499b-b9a5-900a544e38a5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7660e0ce-4d58-4708-b25c-3cd51b6f811f', N'T', N'3fb2121b-7d19-484e-9521-49b50bf0739a', N'ef30e1c8-7553-4347-b0d7-0df5d5b6ce9a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7691a0dc-b685-4106-9266-701dfd234cb8', N'T', N'f0bd0f62-80de-4012-b45f-23c48cc20334', N'e1a3ee16-520c-49bd-834e-e77957ecc2ee', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'76a9121b-4b27-4e98-baae-9b8c226888cf', N'T', N'2b65d5b3-463f-42f6-9a89-00ff458e5ff9', N'd80110c2-1cb9-4b17-9f2e-0b1a317e6a82', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'76ad0678-e385-4064-8c74-c07a8dea7f35', N'T', N'ee848648-0a4f-4108-b506-16d3a9fe9865', N'c1e09f6b-6d2f-41dc-a34b-125581015017', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'77454499-d0e3-43e2-b85e-d93824ede81c', N'T', N'c8e75aed-f9c1-4ae4-9303-9c77f68b7e53', N'b94334d4-2847-40f1-8e13-09658199dc78', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'77834338-d2f2-441c-b17f-5f4d163ad96b', N'T', N'0d06c25c-538d-4330-83c6-571f75e9cab7', N'5f029b2b-96a0-4748-a084-a2a9f51a7b3f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7789b489-b023-48f8-9e5e-578eeaf1ba97', N'T', N'd61ea9ac-db51-41f7-9916-689a36444721', N'a2be475f-b243-4b2a-8bc4-a94dcc024e22', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'77e0c9fd-847a-4d31-9277-6b9068628c07', N'T', N'0912064c-dc4d-4cf5-8955-fad348fed6e8', N'c5fad44b-e67c-443f-b3ed-43a3859555cd', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'782c5ab2-5e06-4cb9-814d-4046e4514471', N'T', N'd175366f-9775-477b-ba70-dcf7d1a84922', N'5b1e5238-ef0d-4bd2-b3c5-dad5e9b693db', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'78e0ddb3-4b96-4208-9bb4-9a9eb9aaf4bc', N'T', N'57a2ca8a-533a-4479-9292-7fd42d620d36', N'28f70c37-7354-407f-9576-6ae353a39d01', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'79333145-2a0f-4318-9b32-f454c317dad6', N'T', N'1d428224-ce79-4a53-8846-70ac61aec25d', N'61ecb831-5487-4e7a-a93e-42ac8a3a0be3', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'79c7d07c-636b-4047-a8d3-29aa65e5955d', N'T', N'a3e3182d-a92a-465d-9a08-dbf6360c7776', N'a80dc102-93c0-4384-a54b-caaa495d6807', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'79d87bf3-74d5-4b9f-b40d-a9caf194b284', N'T', N'a16fac51-4cec-4375-82a5-8440c3fc53a3', N'77ba6835-5e8d-46c5-93e3-e1a70023b89f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7a75f095-9e51-4dac-978d-a1ab0848df77', N'T', N'544cba9e-d136-4fa6-81a8-2f46081c46e7', N'26b87e3d-894b-4fbe-812e-4c7c943d8f84', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7ab73b3e-fec6-4143-a011-dbd0b31875a5', N'T', N'42168024-9fac-4109-84de-40b78de2aca6', N'd26b9fd2-7daa-4bd7-b767-ba2e30553bc5', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7b06e6c6-58ff-4cd7-bc2f-62a7e0639633', N'T', N'5e4910c2-3131-4a6a-9326-2231c8d9e6b3', N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7b8b1f5a-2e53-4f15-9261-8aee51858c67', N'T', N'4c1beb4e-e4e8-4a8b-a6c2-8ee5c18530ea', N'464795ce-81b2-471b-a564-9099fea5ff34', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7bceead5-3237-444c-ab68-ce7ec6813589', N'T', N'412651c4-0a68-488f-a16d-173bdb002040', N'134a8fb0-b996-48f5-9008-0f40ec940944', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7bed45eb-1ab1-4d96-8701-e0e72dc4b5fa', N'T', N'd306d78f-1475-4e07-9093-354ecbb6d77b', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7c5d740f-518c-455f-a65b-c308b3ad5c18', N'T', N'7347a524-82db-4448-98cf-ec1ba59a7cab', N'3122f238-b23d-4680-bd6a-76a247cdf2ef', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7d05501c-f509-4437-be89-3c1746da4d74', N'T', N'3132a85b-2abb-4ec9-88a9-e2adf6a1f822', N'56b5d083-4164-4c02-bf24-cf2efc679e0a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7d10d77e-c9c3-4fe0-b76f-7612fa3fec12', N'T', N'22744629-c568-409c-ad5f-308f730aca75', N'5a0de9e7-0b98-4e92-8a7c-d666b51ead84', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7d6d9cb0-98d4-4ab9-9f8c-6ddeda94ac81', N'T', N'9b713d38-7da8-4761-b975-4e81b47336f7', N'6e47eda2-d112-410a-9398-41afd8024b0b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7daf936f-8b53-474f-9c69-c730e623875c', N'T', N'5074833c-6cf8-4800-8050-a87de320979d', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7dc7858b-02a1-4831-97af-b1b4dca2c03f', N'T', N'bde2fe6a-c432-41da-851f-21a400eec015', N'621dee8b-d883-4996-b9ff-8da29cb6164d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7e183268-e086-47ef-8c57-99ef6f2e878a', N'T', N'8a1983a1-c2d9-48b2-8692-2b485f9795fc', N'933240b8-98de-48ac-996c-21b4b78cb264', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7e5ba527-0661-41b0-9c61-9a24a34fc124', N'T', N'442da798-eb6b-4581-adcc-1583a1a2d66c', N'f9777db2-8f0f-4706-b2a0-b66670d9799c', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7e6ec834-ff5f-47de-9e45-3cca6948f92d', N'T', N'2c2565dc-f7cf-4fb9-b747-bc57b930874d', N'c2dc29c2-1da3-444f-abdd-0c09b8a31e3b', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7f03d7bc-dd2d-47e3-abb1-5d0b08a41b17', N'T', N'91e2e159-a1ed-4842-bf26-03c675c282db', N'a6db0b48-eacc-4278-9256-cfb6a22debf9', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7f3f630a-530d-4674-bfef-42c40ee06ad1', N'T', N'50e6fb03-c842-46c1-b91c-928eb6e2b183', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7f508283-ab02-4bde-80a4-a7dbeb094307', N'T', N'b35a144b-78ff-4273-a8fe-ff75d30d8d4a', N'e80d9a6f-93e7-42e5-a5c3-0c88db90f237', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7f76ef2e-65a3-451d-a437-73a65ed8f315', N'T', N'1bfa0866-56b4-46ff-9392-3983a33c67e0', N'11dccb58-beb7-4234-8157-5ceff89d8d92', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7f84049f-5e6b-4595-9e19-5e0bef8cfb6d', N'T', N'cb762690-cfd4-4aba-8a8e-03d889ac7394', N'50b4a9d6-2394-4a05-b4ef-438e6e8188dc', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7fa1710f-47b4-4296-bd3f-2c261b52563c', N'T', N'f9e17782-c2fa-4375-a685-82614524badb', N'617aa30c-45c3-4c87-ad7a-ca1e24c222b5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7fd66035-a375-4053-b0d8-4e0e8cd28e1f', N'T', N'edcf3382-71a9-45e0-a3f3-4e5a7dcf0545', N'a86282f2-590c-467c-bc79-b721174c3f05', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'80828048-5c82-473b-b5ed-2c83e93880cd', N'T', N'c5625a07-c3b1-4c6f-aeea-f0b1a6846fe3', N'7a0db706-329e-4041-bbef-536de5987039', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'80a278f7-8181-420d-b9ae-cab77ea9e4fd', N'T', N'e3e0d245-95a3-4ac4-8596-78bb48b0d965', N'c2dc29c2-1da3-444f-abdd-0c09b8a31e3b', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'80d3859b-c39c-410d-ac69-965ff8e91f86', N'T', N'd09cd63d-e7a0-40f0-930e-07e76c5fb09c', N'4d9a9e5e-5ef2-42ec-ac06-da5747e4657e', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'81352435-be58-4ccb-9e08-44e4d59e2495', N'T', N'b7c9f1fa-b746-487c-a34b-1c63162b91cf', N'5a12bca5-ea77-4509-9637-96bc49616a35', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'81aa57a2-03bf-4f1e-b6d2-5a20c1ce39c5', N'T', N'e7f7a44e-be91-4bff-9fc0-9796a7328f22', N'fbfa6ef2-f58b-40c1-8711-92acf3247836', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'821d5e85-ed6d-45a4-96d7-c75e2659b825', N'T', N'd5311abc-5c31-43cf-901e-c747ca5db5ec', N'5fff13bd-0723-4b43-bbc2-031d2b5dd83e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'824dc66b-e0d2-41d6-9557-aa9ac15b11d4', N'T', N'b739ccc4-55a3-4d5d-a056-7192ec13975c', N'3b8effc7-3631-4863-bb7d-14180c84e29b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'82b33993-fbfb-4262-ab3a-94fdb79f5cc2', N'T', N'f0bd0f62-80de-4012-b45f-23c48cc20334', N'390f0eb8-c212-4c35-bc2a-5327926c98e2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'82ba2f1b-ce85-4c5c-a822-83e88429b82f', N'T', N'35ce5d0f-d5ed-43a8-9be6-6641f4ec302d', N'a669b3ed-d55e-41e4-80f9-468d6d65e499', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'83e934c1-30cc-4563-9cf9-4946cfcd00ba', N'T', N'e0669ed9-a4dd-45fc-990f-4238d4e6b015', N'1286007c-1c25-475b-bfec-30cca21037c8', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'84067c9e-5628-4bc6-8475-3bb3c5c96aeb', N'T', N'f493b51a-555d-4c24-bdec-65c70b492b07', N'024e0933-a9ca-4b7d-9cca-c0bbeaade9e6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8410330f-6886-448c-bf05-7dce46698dd0', N'T', N'a38a928d-6334-4b74-a471-928c033e7c59', N'6b2b774f-4e54-438e-96d1-f7a6b8dd84a7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'841c3de5-7a97-49ed-8eb2-e3786384ee98', N'T', N'e3e633f8-7f76-4600-9d2d-0f139f992761', N'ca21d05c-2c3a-476f-ae4d-b57abc5f6f75', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'841f0f73-6eb6-47ab-b0f6-e1c6840612b3', N'T', N'ffa7a1be-d64e-42c4-a79e-749a3838485a', N'4bcd6eec-bf9c-4cb9-8527-4ad80460337b', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8466efc8-3fd2-48c9-b879-f24419865f7a', N'T', N'd7d4ff37-6c70-4d3a-a30f-1c0de3ec20e0', N'464795ce-81b2-471b-a564-9099fea5ff34', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'854fbedd-de8f-4f68-ba67-f80b5d7852fe', N'T', N'88afd288-733e-469a-9e89-80ff8c089b77', N'e13044e2-1ed9-4a36-ae7f-8d414dfecbe6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'85aa8480-c2ec-410d-99e5-eb1a64065f35', N'T', N'ec54a5e8-7669-42de-9df9-045153d760a8', N'0a09afed-d63d-4d7a-84f5-b1a1b8e93d16', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8631307f-8939-444f-b4af-daaa3386a0bf', N'T', N'1724cd05-e32e-4309-9771-e3cf5b7d38ec', N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'873a5910-f3f2-41ad-98ac-8caf26c2e0f6', N'T', N'31a817d3-080b-443d-84fa-3be8f77ad810', N'496bf7f3-df40-4eee-ab1c-7e2161e27582', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'87673710-48f2-4839-be51-53a567a86d03', N'T', N'38525c45-600b-4384-a730-9fbb3e200a50', N'f27dea45-7c42-44a9-b88d-6b2914babc4b', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'87d8f79f-5631-4dd5-b193-dbba83b01e45', N'T', N'fe321944-d3ef-44db-bb97-0b8ecdf844c5', N'121b5dc1-ae15-4742-9887-30db1531cfde', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8819710d-7b39-4edc-83ea-57d65b44995b', N'T', N'3410397e-0b99-4954-8ab4-0d9b7d8a5101', N'03bdd188-8c6c-405c-9ddb-9ccb1ecdc186', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'881a1aaf-4692-4c0a-b7c4-89bf8f995329', N'T', N'5a214f1a-a062-4fd5-aa2f-84f836ef8b7d', N'af5ea588-0de5-474d-b00f-72f6f0336047', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'886343da-c56f-420e-8747-3e54ea3541b2', N'T', N'c77666d8-978d-4c62-9841-b9755e3ba7ec', N'239f4679-d89c-428e-bd44-e8bec5cdfec1', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'88a4ec95-d859-4619-8e19-ae21da344063', N'T', N'8f193aef-704c-490a-8937-68ef2e0d3e29', N'55f94575-5160-4557-a309-d4a280c97a4e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'88c749e5-cafb-4360-a3f1-0da7164e3113', N'T', N'bfbb7b50-8a31-45ab-9e5b-26281390123f', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8925c39d-5782-4d64-8277-2645eae36a11', N'T', N'1a2b8832-313e-4083-9a38-c2e71ff70cce', N'bb32e6f4-be25-42f4-b015-c3aa4d81a8b8', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'89814f3e-8e28-465d-9423-5dcbe1aa47c2', N'T', N'aa66b7e3-f174-4d94-a070-042eb7265cc1', N'2c497a23-bc18-4f4b-9407-dbdf3d4c33ab', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8a3fe3b4-8699-4caf-a669-f11ed224a3a6', N'T', N'aa526de5-c6c8-4ed2-9302-2e65f5dd6a35', N'4ac2076f-cb8d-4a97-bd93-0b2977fffea3', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8a7d8dda-4664-40f7-bd9d-58d425732a60', N'T', N'22744629-c568-409c-ad5f-308f730aca75', N'4fd22a2d-9df4-4bc6-a9dc-e19a95b34e71', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8aa455bc-efd7-4bdf-a381-5d8a782c3772', N'T', N'd42eeb5c-429b-47af-bc4a-49184db1ec0c', N'9631e952-bfdb-4c35-ab6e-e4bc33ecac78', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8aeb5d23-8ca0-4dae-9421-65fbbfd84cfc', N'T', N'889b9daa-25a9-4f05-bc6c-58158b64d045', N'e93f8b57-8592-491a-a44d-8f92037d37d2', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8be8d462-b16d-428c-b657-e77ecc32f7b6', N'T', N'27e0f56a-0474-4547-babb-9fec5d587733', N'cb87be2a-1ef6-4ff3-a830-7fa6fda6b025', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8becf3cd-76ad-4bff-8a4b-8a626dec96d7', N'T', N'fe127ab0-da69-443a-9b56-127d0580c12a', N'b8929f1a-ece8-4014-9440-f41992a44698', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8c0a6f9c-f473-494e-94eb-68d56f36b911', N'T', N'6ee8ec26-b742-4f6c-b004-d3e71005dd73', N'1e057ad3-10e8-4702-96ee-0ea4acc15075', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8c848e6e-9c4c-455c-a6ee-02856314566a', N'T', N'c5625a07-c3b1-4c6f-aeea-f0b1a6846fe3', N'c603c5f3-2150-4429-a57e-5f56d5d5bc85', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8d8de02b-9cc8-4f83-bd79-16dc71e279b5', N'T', N'fa131407-dd3c-4979-8416-72bb74f712a6', N'86a7c326-804d-4e6a-851e-220595d566a8', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8da43d7a-41a1-415f-8b5d-959cda311381', N'T', N'6d9a44bd-4c5a-4ba0-95bc-e28885d4caa1', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8dd976e4-ea83-4006-8bcd-d2cb48e178b9', N'T', N'2574d576-265e-41e9-85aa-22552186a374', N'6e43d868-5963-4a36-9276-01dd0a4aac03', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8e34d977-39c7-4882-a15a-f90c618dcb59', N'T', N'29a04eb9-154f-4e8a-a271-37fdba6fe2d2', N'ad9fc5a8-aa0a-4d6c-8594-d914de76476d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8e74eb28-9312-49f2-8e88-f0f6c231b818', N'T', N'644d489c-4655-43ac-a4e8-da18fa45fd09', N'17965621-fcc3-4ba7-9119-56e8ed38a7c8', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8ea2416c-e386-4b9d-84b6-6eaf36926872', N'T', N'92e0755e-1bf2-47ca-b238-af43f1e1dc4a', N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8f761c6a-6f78-4625-9e05-9236ee6515c3', N'T', N'e4ceb0e4-a6bd-45f1-83ee-eb8609981c0b', N'935ef03c-c766-4394-b798-5c18eafb4de0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8fa8ae4a-7fce-49b1-a3da-9eced78b838f', N'T', N'546b7617-2038-47f5-882f-e26fb9db98a9', N'3643828a-7742-4898-b9ba-62a4939567c4', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'903cffab-b437-4de0-b9dc-aa8e6f8a1fad', N'T', N'f553563f-5016-40a6-bd46-23a8cc7c58f0', N'ef30e1c8-7553-4347-b0d7-0df5d5b6ce9a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'90bc674a-1427-4cda-91fe-dfa0b31db4c0', N'T', N'0912064c-dc4d-4cf5-8955-fad348fed6e8', N'8cc15691-b951-4721-ad01-56e491818a06', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'90de9019-dcc6-4b40-a24d-b3536cedc09d', N'T', N'b739ccc4-55a3-4d5d-a056-7192ec13975c', N'eac3a424-c92d-4cae-b85e-637faead8f26', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'90eb6fb3-c71d-4ad5-a1c9-2b45356efa84', N'T', N'1f1f8df8-b6de-444e-a456-5fe1c666fa08', N'23385bc9-209d-4113-a128-7daea65e7d00', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'91445013-ff6d-4080-b178-6bc4bf34ce61', N'T', N'fb3b622a-e271-4c2a-a8b1-48577ef6b570', N'7a0db706-329e-4041-bbef-536de5987039', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'91c073b6-7250-4594-aee2-199220ac6d70', N'T', N'fb658605-d43b-42b2-8339-99e8373f7457', N'727b275d-d30f-462a-a5d5-0dbee8a52b14', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'91c2d553-9baf-4280-89b4-340fbb2057a5', N'T', N'762f0656-d64b-4eaa-bd6f-61da73afd353', N'3650dda4-7299-4119-836a-3a01ba3bb1bc', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'91cd8e89-20a2-409e-9fa4-b6a7af40341b', N'T', N'954a8a91-11cd-4964-9d2f-8d0db8a0c281', N'cfb16d87-3cc2-417c-87bb-3474ac792e5e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'91e14e82-0cda-46a8-8511-2bd296a15698', N'T', N'7d84d017-23af-4edd-a422-cfb52ccceac2', N'380acc8f-ea42-4e97-87c8-fc79408b3c29', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'92213057-8c97-46f0-8115-100289be48b3', N'T', N'65689709-804c-48a2-ab0b-be785c3ad3cd', N'b528c01f-d65b-4146-a347-e8b8e31d36d2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'93e38217-5f0f-41ab-84c2-3d7a8b8c0aa0', N'T', N'bbb56cbd-09f2-4b08-a6bc-591a2a6509aa', N'9dad85e8-8ba9-4f04-97e3-bfa6ce00e9ec', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'93fde8d3-6fb9-4a77-bdc3-b41ddcd37e75', N'T', N'f32a53e1-7132-4991-9caf-694d1ef7c829', N'239f4679-d89c-428e-bd44-e8bec5cdfec1', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'93ff091f-64ff-4cfc-a58b-7cfb069806ac', N'T', N'759b231b-539b-48f0-8e72-ca79723711c4', N'86146d09-40b9-4c55-a610-8df7bb3c0855', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'94054e01-6ab3-4e7a-ab37-241854eefcc1', N'T', N'ae721b66-08ed-4b3f-a80e-55c0f3b2c439', N'09b744b7-f477-43bc-917b-955a0732b756', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'94784500-9846-4dc4-ad04-49822f4ccd99', N'T', N'743cc1e8-4525-4288-ae9c-18e99127a73e', N'2eea71d7-8a69-4329-b1a5-9fc6f1ca8c88', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'94b45e1e-9583-4d06-8ac9-f3cb6ed96794', N'T', N'3410397e-0b99-4954-8ab4-0d9b7d8a5101', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'95aa5a19-c04f-4dc7-a1b6-d587b7103324', N'T', N'10ceadda-948a-4476-9e26-7950fd655c03', N'464795ce-81b2-471b-a564-9099fea5ff34', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'95f8a69d-f296-4480-87a1-9772ba6a3455', N'T', N'8d379270-9889-4896-b2ef-1e3403034dc8', N'2f6e56d5-7c6e-4e5e-bea0-198740c6507d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'960790f1-5bb4-4cab-a353-d608e15ddb56', N'T', N'71d9158a-946f-4097-8a25-d3559abfabec', N'8dd404b8-1254-4e34-8221-6d4d5d1bbcb1', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9696cddf-92ba-4d6f-a60a-cfa1358f35be', N'T', N'2b5c14fc-1b91-46b0-bf46-2f3b86a61eb9', N'b18db563-04cc-4d00-a6fb-e7b001b4f85f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'97027f19-beca-475c-8e56-709e82b26d1e', N'T', N'a2cc3f88-b18b-4af3-929b-de21259af649', N'464795ce-81b2-471b-a564-9099fea5ff34', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'97374aa0-4bed-4d1b-b9ee-f7390b628c67', N'T', N'8f0209d3-021a-47ed-bfe1-d8cfe8d1c5b2', N'50530d6a-6ef7-4e96-9f04-208ae2a6ab84', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9752a313-6d80-4c8d-a1eb-cde6a3cc3941', N'T', N'252d239b-67cc-4dd6-afda-afa56b5be229', N'f46a43dc-1ce0-4c78-8836-69538bedcdb7', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'976a0257-4b30-49f4-a428-7850b9a07e2e', N'T', N'5a876de1-baf0-4fe4-bae1-7af9bb7c02aa', N'897f0da9-78ef-4793-8df6-fbf267ce8142', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9812005f-7e33-4cc4-bd47-7cfc9d5563ac', N'T', N'57b78cc0-0cb6-481f-aeb4-7dd6b09bb637', N'40a045ef-11e8-45fd-9b0a-06c7fdb58f2d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'983e2032-d1ec-4d99-ae9f-04318572aa44', N'T', N'b1462fb5-16bc-486f-a3d9-92159bc8968e', N'481dd0a3-7430-40f9-a2a7-1e7426ac5481', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'98a8bcb3-44b4-436d-9afe-8f60a71b24d3', N'T', N'c7c6b068-a1d4-412d-a653-73eb49e41835', N'3b01d3e0-c69a-474c-8f2d-8beedd1b8832', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'98c7fa9d-6b79-4234-9199-d2419d846e42', N'T', N'610952ed-0f96-489d-a557-eb0b1f26c5ee', N'6eb6b422-3696-4aed-8cf0-868c24c89e44', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9916915d-fd82-4aac-9142-62cef2114c73', N'T', N'ec2ed091-e209-4daf-97a6-b59fd7d5c42f', N'55f94575-5160-4557-a309-d4a280c97a4e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9922c887-2d1b-4117-9ded-efc8c8e3a84e', N'T', N'eda86712-d37b-4b8f-bb20-c9f95671d48f', N'd70a26dc-9bab-4eaa-9ce3-45e91874f6e8', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9943ec10-27dd-4292-aa73-f9d67419ca16', N'T', N'f652542f-bf73-4959-8287-e45025a7727f', N'8ac6c354-1b49-4e1f-b158-02c6e60c62aa', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'99ca3a75-5bcf-4535-8c22-a822379ca69e', N'T', N'12113fe1-c24e-4898-97d7-305d146f3bf9', N'a9c363a7-b814-4cd6-b41b-1fd70860c7ed', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'99ed163f-77c8-4e6e-b4d9-bf70ed50d8f7', N'T', N'a70f6c27-2463-4ac3-a6a7-f5db97a21626', N'72a87f90-c333-409e-b416-f0b331680f28', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9a48dbb4-5ed0-4c0f-9846-5075b42f2abb', N'T', N'e874028e-e2ce-43d4-bd40-73ad01f51d51', N'f27dea45-7c42-44a9-b88d-6b2914babc4b', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9a6503be-c7d9-4e45-a8e0-90797d2bc1b8', N'T', N'79be0944-677b-483f-b849-d5657eabebdb', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9a6f6a84-34df-4427-b1b0-c76736554e48', N'T', N'fb3b622a-e271-4c2a-a8b1-48577ef6b570', N'c603c5f3-2150-4429-a57e-5f56d5d5bc85', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9aa0273b-3bec-47e4-9a60-63cabd8e4c84', N'T', N'eafb904c-c816-4878-b5f4-97057e813794', N'9dcb6239-56ed-4991-b305-3b25394ef3e4', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9ae44c0b-6b8e-4354-ad39-e4b9641be8d0', N'T', N'264ce7c1-e2b1-4a38-b9bb-cadebe2c0466', N'fe4c1af0-2430-4858-9bfc-046c6cc8c51a', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9b109bb7-fbd6-4f13-87b9-df2af3c1a2fa', N'T', N'086c3135-bd32-43b5-a886-c1e77526b1c1', N'f163b672-623e-48b2-8550-739c2e6cbc13', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9b3d0103-a3b8-4f75-9994-424ba6c22109', N'T', N'be123839-27c0-4bce-9df0-bf8c4c23474a', N'bfed680a-3ecc-424d-b3a6-fa65c58238f0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9b8477e8-9184-4607-a9b9-655b4a87cf67', N'T', N'e6aeb811-b64f-42d7-8674-835ecd5bcee0', N'044e5423-e072-4509-90a5-da0e31d67dac', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9bc54fca-7124-495f-93b1-0ef83d2dc851', N'T', N'46112c71-a3a1-481a-a7fb-7f772d7554a7', N'893588ae-938d-4e9c-b88e-9066a4ab3117', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9bfef04c-1f33-415e-a91f-88a76a9e6ec2', N'T', N'57327824-abd7-4137-aed9-770e16068951', N'c06fec47-6a64-4ae7-9163-1d4153b62854', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9cb47c8a-e85b-4c3d-8b64-0cd1c74b6246', N'T', N'f63406d6-3bc5-4aa5-9e4c-2cb98cf7d742', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9d0c71b2-76fb-4b1f-989e-3962f174ae42', N'T', N'0707c392-1291-4068-91bb-159599b10423', N'808cc7cc-ebcb-437d-82d9-921b6e40f66c', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9d43906b-1cdd-4405-bebc-dc7ab9bceb4e', N'T', N'f652542f-bf73-4959-8287-e45025a7727f', N'c8aa935a-dd57-4bed-bc95-917c08730244', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9dd99cce-d5d9-4880-80fa-4a0be6416934', N'T', N'50e6fb03-c842-46c1-b91c-928eb6e2b183', N'b424211e-4558-451c-b2df-b2b2f7d8bfa6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9dde63c0-d7c6-4c5a-ab92-ad4524fdc236', N'T', N'e113b064-ec79-4bbd-ab59-f62285b88aea', N'1f6da9ef-2388-424f-857c-23db61052fa8', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9df596b3-896e-4601-b4be-e5d70064c914', N'T', N'dbfbf38e-5641-47d8-b467-24b74cef7d7d', N'75d05816-2fe0-486a-96d1-57aa8367799e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9e3add9c-b5aa-44eb-9cee-f2727a5671ea', N'T', N'edcf3382-71a9-45e0-a3f3-4e5a7dcf0545', N'464795ce-81b2-471b-a564-9099fea5ff34', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9fdacb6f-f1e9-4c00-8216-a65e7d1cd9b8', N'T', N'1695a9de-1287-4ee6-b769-91d83c8f25ed', N'1069bda2-3abc-4030-b5a1-0d6f6ee44d56', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9fe30328-cc05-4aee-8db5-6e8fb8d40732', N'T', N'988f5d19-9653-4441-ad5f-88b2ddfcfea1', N'347fdff6-9fbd-4683-9331-38ed277d92f8', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a0207a46-f3e4-4620-ae3a-6ebc7029665e', N'T', N'f3bc53ec-8647-494d-9c27-c894cf6e8c6b', N'f0af45f4-0dea-4b99-8c6a-61582f295529', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a0b25516-dba7-4430-87a8-868506c78974', N'T', N'56161580-fe11-4081-be8d-51b82a246444', N'05b4a598-8af2-434b-b498-1cb48315fc4f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a0c5f7af-658b-4868-8361-2e6f21264e02', N'T', N'9f3582b0-e6d2-4d6a-9e1e-01fdd0254240', N'ae74547d-9dce-479b-9c13-cfdce20bb3b9', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a10c53c7-4e56-424b-b51a-ecdc3dc8dd7f', N'T', N'52fe2aac-d9dc-42f6-ba90-bebc232e8ef3', N'f9fce48c-db26-4a03-b74c-b98ab3f29f09', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a12435ed-6e76-4980-a77b-4f0e87d441e9', N'T', N'203d40d2-32cf-476c-b9ba-c0ed01033b93', N'0f20e6d5-a096-4c3c-bbfb-1f66bb014c13', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a1b8207b-49a4-43dc-a4bc-1a0ce3160932', N'T', N'e9f05919-aec4-4791-acc7-56ec60d47fb5', N'09d8fbd5-705a-4a8f-a3b7-da5950339679', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a1d33070-18e8-4267-ab75-6288d962d392', N'T', N'098a3133-e1cf-4c0e-9d69-015dc0e433eb', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a1e48aa7-2cff-4264-bf4e-321b0804fffc', N'T', N'220d73f7-f248-4adf-9ef3-a67dd24bfae3', N'd28b1c61-3c53-4eb8-a7b5-6aab9c21d5d0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a21d81b8-5481-4a2e-a179-fc742b12543a', N'T', N'c12909f2-f5a6-4327-b341-eac3baec91dc', N'2f85405c-54e7-4fb1-b1ea-4a6995a3a103', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a27e655c-8879-4ece-8ad8-a725ec46eafb', N'T', N'8f64c387-bc6c-4b9d-ae10-05cb45a39811', N'd612334b-a3b2-4e27-8184-755780d4e666', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a31e854d-138e-4bd1-b18e-a1524f5d37a7', N'T', N'9638907a-f796-4782-98f5-242193ac295c', N'edf3d1a7-e10c-4a50-b1ea-05ae2bee375a', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a388c30d-7b10-48fe-b1da-a6c85d606209', N'T', N'943f3f56-12cf-4e84-8dfc-e31c8fec84d1', N'07a2014a-c448-4db2-a841-378d5d115bd8', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a3b919e1-4048-4ef6-a32f-9d27982a7fdb', N'T', N'1f00433b-f1f8-49ca-8038-4e7deeea7423', N'2f2a58cb-730a-40aa-9cfe-d6ebdf2fd483', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a3d00259-e3c8-45eb-aaf6-9cd0633a8fef', N'T', N'60f1d127-5097-4ab5-8bbb-272138bb66e7', N'58327b27-c617-4c39-abdc-321ef4e7c192', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a3dc813b-ab6f-4312-b817-f289a51c3de7', N'T', N'8fc830c8-3f61-4967-99e9-8192195668a6', N'bce4a9c1-7957-43c6-b92b-7f4058ce5962', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a42d4aac-7d6f-445f-bf38-f88e2c6b32b6', N'T', N'76d022ba-c7e2-4489-abc8-379eab533908', N'10d70eea-c0d5-40d3-a741-6b52b1479a67', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a47006ec-e406-4cad-9917-734e144aa6af', N'T', N'7aa5d34e-cf7b-4957-a7f2-b00c1b47d801', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a47ad89b-6f42-4ee5-9756-62ffd5869644', N'T', N'8cdfbde1-dc75-43a1-9dfe-d0c29ffb9d0a', N'31b6cb7b-5078-4c05-848b-61ee1bee156a', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a4d23e8e-eab0-46df-9001-4b74a023126b', N'T', N'9ad4c100-d818-4f6b-b2d4-ee55032e5459', N'af5f7b4d-99d9-4b42-872d-5dc7be7702c8', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a5102d98-80c3-4b8e-94c7-51e83d6a0ee8', N'T', N'62908bbe-2385-4c4b-8e1a-c48bb9090940', N'93e21d84-6f75-4f30-9192-866019a6900c', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a537401e-112c-4eb3-9a21-40c25a9b247d', N'T', N'f5708dc3-ab7c-413e-8e26-22f029d732f4', N'b671d59e-6a72-4e62-b02a-ca00455b154d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a5545d78-4858-4c81-beca-fe2490edc107', N'T', N'dd40bca0-a29d-461f-8b85-80904e93355b', N'418485ab-9ff9-487c-9469-8ffb15b54abb', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a55cb523-e036-497f-b4a6-8e040ce22e0d', N'T', N'817c961e-aa30-477a-9e66-d46e700b1821', N'9e931359-575b-4096-bc60-e2095c6a9fdf', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a5902e3c-7ee7-4697-9884-64bb3b015e2a', N'T', N'3d75d3a9-0869-4773-8f5f-f85da208d266', N'a9eacebf-ceae-4ce3-bd7a-7c9c25b3e944', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a689684e-29e4-4987-8e12-2a823127ea19', N'T', N'd3a76b31-7960-46c1-a6ac-f83904585e68', N'0cd789f1-8a80-4ee4-9fb9-c28954c188da', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a6c51d92-f702-4d00-b2a4-77b0e6ed9915', N'T', N'd3aa16ba-7bf2-4f86-ad79-f31ec56abc02', N'80eacf91-09cf-4d34-b9ac-3b79b0e33db3', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a6c6edac-e27f-4e6f-bd85-0d85cebf0d4c', N'T', N'c8011fd5-225c-4328-8c62-ae891ad9679e', N'97114df0-ed1a-4af3-b84e-54d81c4639e9', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a73cf8d8-c422-4646-8a23-f1a335ef18c6', N'T', N'37e6d83f-80d5-4c63-b96d-07489bbaeff3', N'9d9f4372-a9c0-48ed-8961-5f4b700336a3', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a784d0ab-4152-43cf-a56c-8a4484e6613c', N'T', N'24f56ba1-b2d2-4b7d-a4e1-72f6089f3258', N'1468527f-ae09-4ef5-af0b-7bbe405b0a17', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a7cb8c3e-1816-4c8c-804d-663d343f5ac6', N'T', N'ebf909ff-52c6-4707-9740-a106df183cc6', N'6e43d868-5963-4a36-9276-01dd0a4aac03', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a7e0a807-42aa-4ef9-b90e-c42bcc21b8ae', N'T', N'892f13be-e1e3-4fee-ada3-9a484fb99563', N'8137aabf-7449-48ca-967d-60149389e04f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a8d7fe57-d146-473d-967a-df91ce51e614', N'T', N'2574d576-265e-41e9-85aa-22552186a374', N'09ca4788-5094-4110-ba01-b5aba7a46165', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a9075e54-5e1d-4f96-99a3-251b1bf1c31d', N'T', N'543b9e1e-e4f1-478e-8eda-ec9fa42a221f', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a942b831-300c-449a-9933-1da1e2bbd303', N'T', N'0465fe3b-eee6-476a-a7ea-63e8ad1445ab', N'162135fe-945d-475e-a035-292d0d15159e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a960622e-c2c5-49be-86d6-d300e7f833ac', N'T', N'80120598-3949-4488-98d8-5c40a86e5cae', N'a7c7f030-1f70-4c2e-9f28-4a83e43dce72', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a96f37c2-7e26-485c-876f-9de7a5c38a46', N'T', N'8de6dca9-3523-49b7-8ba5-d91c23008524', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a970dfde-d0d0-4936-98ca-d7c6bf9b0b38', N'T', N'f2293ceb-c145-4612-8c45-4eea04ec29a1', N'935ef03c-c766-4394-b798-5c18eafb4de0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a9804624-6d19-429d-910c-4694544fa2d4', N'T', N'558ac514-a74d-4c39-9dea-5c66c680b41e', N'5f029b2b-96a0-4748-a084-a2a9f51a7b3f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a9fe5e65-f8bd-4916-9ea8-5ed4eaa5250d', N'T', N'debf9088-db9a-49d1-b331-f69c7011e63e', N'2d258ae8-5984-4d64-a329-7fde7677e1eb', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'aa170ed4-4eb0-420c-9635-75b4bc37547d', N'T', N'f8abe607-12e4-4268-88a5-f4475d0d379c', N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'aa32cb89-5a6e-4314-86d7-8bb833e13d2e', N'T', N'3d5b48da-e624-4859-8fa1-092577dcee93', N'ef17e2c6-f31e-4c2d-bbde-b7ddcedd3fb8', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'aa812905-a2b2-4620-bd8b-4319f0006820', N'T', N'8cbbd037-6b91-4913-b769-2472d58ec292', N'0e21e205-b785-4d0f-a96d-d8073b9c93e2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'aaabe54f-e3fc-44ae-a215-21c08d8964e0', N'T', N'65689709-804c-48a2-ab0b-be785c3ad3cd', N'239f4679-d89c-428e-bd44-e8bec5cdfec1', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'aac2feba-2ba7-4f1c-a473-e168ce4c6d7a', N'T', N'2b61b737-c1ce-4f26-b9ff-6e5b0e26423a', N'478cd783-aa91-49c3-a07e-67ad4269d3e7', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ab068bf4-1d10-4c4e-b992-8600e526cb26', N'T', N'52c26247-f433-411a-bb1d-f17b56e3eb2f', N'18776dbc-cce7-4c81-ba45-09fa4815f6f0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ab1022da-e3bf-4675-9b63-7f2dc8abba38', N'T', N'd8c3a988-fb49-416f-8636-5aeb7edc9ca4', N'bec50adb-cf53-4e32-a26f-b020a1e3aa66', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ab9216a9-1c4b-4c00-a9c0-aff0edbab4d2', N'T', N'df47e307-3be6-4ee6-9e5a-fecd5f3fafb6', N'406ef830-0fd9-4f8f-ba01-5345ac1b253b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'abc8f6a6-7f74-4a3b-b8a4-846b2fc0f2b5', N'T', N'edd57f25-e2ff-480f-b749-8a75de17790c', N'fac35294-1b99-4531-9494-1ef2e8898c38', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'acd67a14-203e-449f-a167-a2bf034e460d', N'T', N'eca0caa4-b5ca-4173-a9ae-27f112cd0a6f', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'acdcddc8-8fb0-4445-a879-e60cadf0894e', N'T', N'3637a9cf-e394-4440-9241-553fb31ce21b', N'2f960b81-bbda-4c96-9eb4-3701a0e368d8', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ad44cd81-d5ea-4ad3-ae02-9a8f83435973', N'T', N'0f77e612-93df-42ba-bc51-845d00a62380', N'bbc804d5-54ec-4f6c-bf69-1a029759ca03', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ad4dcc72-d277-4432-94af-b369ad608dcf', N'T', N'ac1681ea-ceda-4b1a-b899-de64a6d4e66b', N'a7582789-5b7e-40ac-8bf8-0e9b82246927', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ad563ac4-5d0d-46e3-87f6-b158c4a9c2d4', N'T', N'631bc5af-83c3-44fa-ab35-c4ecc2346544', N'c24a0558-c022-4490-a3c9-90286f3b94e0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'adbe403c-05f2-4187-a091-01e1e60e1dac', N'T', N'cbce87ba-9b5f-4c7f-86cf-56e5bb8d22c1', N'0a09afed-d63d-4d7a-84f5-b1a1b8e93d16', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'aed0c213-19e9-4c47-aa17-18826c773470', N'T', N'90350d32-99ce-428d-a793-c2003a7cd26e', N'71550e11-a75a-4e59-b742-2108892db8e2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'af6553e5-5ae3-4b12-912a-cb58f89af312', N'T', N'00c7729c-668b-4b2f-ae81-67d6daf93e5a', N'a9eacebf-ceae-4ce3-bd7a-7c9c25b3e944', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'af6d2e6e-5f3f-41a8-a313-5094fb8b318c', N'T', N'3caec97f-9265-4755-80d4-8d8c8f673856', N'1dd4a35e-971f-4e9a-b55f-66ad0ac2122c', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'afcbea82-9ba7-40b2-acd0-688e5c5f62d0', N'T', N'a40de53f-aa71-4beb-ae4c-4a9b8cf93e66', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'afd75e76-2f36-4bc6-9918-d1b919c4eb6b', N'T', N'254d0eb0-6a56-429e-812a-cd98d78a1048', N'965d2e94-64a6-4f66-bde1-bc0a41bd4733', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b025b89f-a723-483d-a16c-8ed41b37a9a9', N'T', N'f187265e-6a86-4887-8a17-1ec96893c38e', N'dbe88b1a-42e4-4b2e-becd-57f61b43bb87', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b025f1b8-1115-4657-933a-aa67bf8f14b3', N'T', N'9df5c84c-31c1-4722-aba9-7198f3fdb009', N'1ec781d2-be49-44d2-8323-485fc7866fe0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b076bebe-2af0-4251-95ca-3d485eaf5400', N'T', N'a9f7ab04-4b6e-4537-aedf-8c0f7365c937', N'464795ce-81b2-471b-a564-9099fea5ff34', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b0ad71c6-dc66-4ab3-83fd-e207e26a02fb', N'T', N'0950f63a-34fc-4698-bf71-c1b379484baf', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b0da2291-0af9-4941-83e5-b991ddd74e12', N'T', N'cd345817-3568-4e7c-873e-5a86c9bbd9c1', N'2bb9c735-f481-47ad-8e68-0c3854b5b6da', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b0ea98f5-e1dc-4a97-9649-82ff74ae0f8f', N'T', N'8a356896-f4a3-4e6e-bb79-0937b9b70add', N'9d802b6c-d731-45b7-8c48-7ebcd845c955', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b0feb71b-d3f7-429f-a4f6-3a97228e3e46', N'T', N'd17f2dce-cb99-4ae9-a588-227b589b5ba3', N'3b01d3e0-c69a-474c-8f2d-8beedd1b8832', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b1101de3-b014-48fa-bc10-d737adeddc49', N'T', N'd5ccb6eb-43ac-47b0-850e-91ef2f165f1f', N'4282bfba-de31-4240-9210-b7c6838393fb', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b14affff-af24-4a5c-b507-8b5d4af5898a', N'T', N'ee848648-0a4f-4108-b506-16d3a9fe9865', N'cae6da5f-99a7-4823-8d5f-b21d52e32f4f', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b1c3c6b2-a35f-47f9-bef8-c25a5f613a43', N'T', N'c979c251-0885-4408-8cba-0cc087dc3fc8', N'617aa30c-45c3-4c87-ad7a-ca1e24c222b5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b1f5039c-c70b-4d7d-9357-a15ccf63ad1b', N'T', N'5dfae1b0-0647-4ae6-b5d1-768fe4e6f777', N'080a492f-e8dd-48d8-a57d-753be696f9a2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b20ec1d4-dc25-4ebd-8daf-7a99108f33db', N'T', N'4975e3e9-30e1-4ae1-93e8-833142bbf8d9', N'ec2f2373-e5ac-4116-9c5c-6ffdb275ca1c', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b2171bf0-726a-421f-9232-baed5d7faeaf', N'T', N'8337e7fc-37b0-429d-b4ff-b8359b23228f', N'c08fb7f1-c2e0-4f6c-a502-ea5260db4f15', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b2489b0f-8dd0-46c7-8f8f-3e823cea7c73', N'T', N'e824c684-451b-40ef-961d-b703fc672e80', N'98c5b914-6c23-4c51-b6bd-2ce47a9866bf', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b280d4e3-a3d0-45ff-a777-50cdfde1e14e', N'T', N'329fcd8d-f2d4-4121-b57a-b05e48f2aab1', N'24209f80-7611-4689-bc92-7367bbcd48dc', 0, 4, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b295c553-0a76-4084-98eb-63877e228076', N'T', N'4fda635f-eddc-4415-878f-7d19df846388', N'4282bfba-de31-4240-9210-b7c6838393fb', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b2b1f5c1-3687-491b-9199-e040be400904', N'T', N'daca76c4-343e-4c9d-93c5-f14414156c82', N'66637877-7ef9-418f-be97-6702f0e634d0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b313ebb0-9d24-4c22-b39f-113d6d7e0536', N'T', N'ee5639af-c049-493f-bc22-401a4ce22f5d', N'dd961def-848c-4ecb-8441-e57ab1f2aa40', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b37062e9-e7a4-4c3c-9264-33ebddf29a6b', N'T', N'49b43135-1c11-4351-8843-3ae6d5965193', N'97f7ea03-14f6-4284-8170-07b7e403b39c', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b38d0ae1-6e64-4718-a667-bf3c18e089e8', N'T', N'fe321944-d3ef-44db-bb97-0b8ecdf844c5', N'ca21d05c-2c3a-476f-ae4d-b57abc5f6f75', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b3eb6431-8197-4158-baec-9e83f99244ed', N'T', N'f10cdae2-c426-41e5-8a3b-b20c5cc55497', N'a58538d4-75b3-4ea8-85cc-7faa7252c54a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b4090969-22fd-4e5a-8023-5dd1ecccfaf9', N'T', N'b7104bdf-c779-4574-b543-5ed3244507b5', N'a75c6fe4-d6bf-4322-9011-d562b4ffb020', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b46cc7af-d3bc-445f-8011-5754572bf3e4', N'T', N'085f9d60-d696-4300-be64-b29fd1ef733b', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b4afc365-ee62-42b4-98b6-ae9e51563f90', N'T', N'41afc28f-1a9b-4ed6-90ee-255fb695492e', N'7f521cc4-f7fa-4950-b8ca-7ad787014e1f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b4b41912-b1ed-4927-805f-719cc0af7bee', N'T', N'25df313b-3954-4215-af92-2ddea207080e', N'91206be4-2fcd-4799-8d5a-10994266590a', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b4faa2a5-0bc0-4e06-ac39-fdf1c6ad07b3', N'T', N'8c697881-66cb-4010-bcaa-2e9181e13f7a', N'bfa9fa91-7405-4569-82b0-9b40796432ad', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b552bdba-fab5-47e1-bf30-dd5a34af12f7', N'T', N'1fd99b1e-74cd-430e-8cb2-c3cd3b83ec7f', N'03bdd188-8c6c-405c-9ddb-9ccb1ecdc186', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b5c5697c-0081-4cb4-b6da-2e184b5f072a', N'T', N'74816556-3fdc-4472-8b48-9a9e214da3fb', N'b940be40-0295-4e02-8064-ecbfb92c4088', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b621ce24-69cc-4001-b047-445e036f840d', N'T', N'e6aeb811-b64f-42d7-8674-835ecd5bcee0', N'f87cbf4d-bde8-499c-b2c6-4984479da587', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b646e56d-b460-4648-9540-ac6ff71b7f6f', N'T', N'c0960a9a-d99a-4cec-ad63-c614061583f2', N'57280ed4-feb2-4c01-a713-304d28229162', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b6770e82-3331-4df3-ae01-9c9bca483498', N'T', N'7782ac14-45aa-44ae-b034-a1cf04a44489', N'4ac2076f-cb8d-4a97-bd93-0b2977fffea3', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b68b10a3-35c5-450d-9d79-c70fbb43a4e7', N'T', N'eac40ecc-42c3-41f3-8a2c-ea059f1541d5', N'044e5423-e072-4509-90a5-da0e31d67dac', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b68eb0df-bef1-4810-85fc-af9d99e429b0', N'T', N'4f546995-d7ea-4860-8fe2-aaac9e10b7da', N'8cc15691-b951-4721-ad01-56e491818a06', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b6def858-7317-4d39-8b48-252054eeefc9', N'T', N'7d84c9b8-9c08-4d9f-9956-c86fcdcfafa9', N'e025852a-1180-49e7-91b7-aacb5f2af51c', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b6f4fca5-e3f2-4351-9dbb-173550b625f4', N'T', N'6344c15b-bec6-4e9e-8ddb-38928f051779', N'03bdd188-8c6c-405c-9ddb-9ccb1ecdc186', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b7099b4b-8416-4891-8d51-ece3e260a21d', N'T', N'6bcd3738-619e-4dc4-8f46-140ef23c90fe', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b736627b-bc23-4d46-8e77-d3978bc7d4b4', N'T', N'9af92869-3c6e-4c9c-9ce8-2d8194a2a642', N'c42c7004-bf08-4e73-b682-636734387dab', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b74028f6-dc96-4576-b35f-c1da29cb0102', N'T', N'b019ae86-e304-46fb-895d-7885e3b2b30b', N'03bdd188-8c6c-405c-9ddb-9ccb1ecdc186', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b7496a98-e958-41bd-9bb9-82286daf8461', N'T', N'26f1823e-f613-40f7-92ce-0464944b660c', N'1ce1ec0d-f53a-4cc4-8d5d-d8d8e13e424c', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b79699f0-632e-421f-a8ff-5ad8210787ac', N'T', N'd9c592a9-e4b2-4bbf-b293-b9db9a1debac', N'f6605c2d-8178-4240-8edf-5682e0f0da69', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b7d87e80-9a8f-4ea6-93a2-6d9664326083', N'T', N'b2c67266-2d78-4789-9f3e-14079ad76e19', N'ed398902-253c-4345-86fe-5757d8e8ced7', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b7f8687e-61d2-49ac-b525-1083b79c7165', N'T', N'26f58b4f-6527-4d5f-b087-8350418b84b0', N'fe4c1af0-2430-4858-9bfc-046c6cc8c51a', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b830f228-5910-418f-9e33-d284bfdd4e18', N'T', N'7cdd3225-1170-44af-8fea-f0f7b59ead8f', N'685bd699-141c-45f0-aa63-bf602412278a', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b84769bc-8e89-4f15-8813-c5527097804e', N'T', N'35ce5d0f-d5ed-43a8-9be6-6641f4ec302d', N'77ba6835-5e8d-46c5-93e3-e1a70023b89f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b84a10b2-90ac-447a-a6bd-6c3f84e12cc3', N'T', N'14d7b56c-3950-47b3-b4ee-b14052039488', N'0b1b8000-da34-4b60-bdd1-a3da69e8ce5e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b850c0b2-b790-4092-8aa4-8c62d6b08fe3', N'T', N'70f44788-8d56-4c68-8f4b-9f89a0f8154f', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b8887c57-7172-4e49-8133-8acd24e96fa1', N'T', N'c9a74e0a-2dc8-4d51-a4a4-59ae429bf110', N'7f74a751-754a-4cbb-bc32-f56d2f647f08', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b89f4ed5-ae71-4c55-9f3b-051f23850361', N'T', N'bcd35da3-a961-473c-92b5-dcda4ddd5766', N'f8a536fe-da76-43aa-858e-4b0f912fc0a5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b9197329-306b-43e0-8fc6-85c780ce523a', N'T', N'2ad79c06-33f8-4e32-bfe4-385c5206c3c5', N'5f029b2b-96a0-4748-a084-a2a9f51a7b3f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b940f566-f554-4c30-b2ab-80d13fc8350a', N'T', N'c15de35c-0958-4058-931a-0ec014c1faab', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b94a4892-6542-4e13-b14e-d84786140e29', N'T', N'ae7c43e7-b749-4802-bb2f-e656396cd39d', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b94b4a36-17c0-4f64-82c6-7bd5c6b0d761', N'T', N'b6798449-31b6-435a-b03e-6dfd992655be', N'cad6c316-9d6b-4fc8-ab13-862e8cacf951', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b971418f-b6c3-4c08-91b8-d36d01276ece', N'T', N'e6258cd1-f447-447e-9d66-a1825ca69953', N'f7daf862-f85c-4a67-b426-e4e1723887aa', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b9b5d25c-9736-4e31-85a6-cfe663744619', N'T', N'6aac6248-a112-4628-928a-64c1d849acdf', N'617aa30c-45c3-4c87-ad7a-ca1e24c222b5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b9c90f77-3c6d-4e90-8fed-e333b314865f', N'T', N'011889be-1578-4428-a362-32a41cf61211', N'4098c277-3994-42e6-9750-b75b6c568002', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b9dfc6ce-96c8-4bc1-9eb5-580ece2f0843', N'T', N'ee0fe0b2-1ba1-497b-b3c3-9094c163c20e', N'fc877391-9241-44e9-a7b3-87ba400b6d41', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ba83c2fb-a679-40f4-97ff-a23473f19b2e', N'T', N'a7b9be7c-e284-428b-9bfe-19e7db69ed2f', N'40301dd3-2858-4005-b3ba-17614552107f', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bb689202-fd68-4bcb-9983-a5988b78e773', N'T', N'7e62ca60-7160-4069-9463-a1fd5c8fecac', N'390f0eb8-c212-4c35-bc2a-5327926c98e2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bbdc6b6d-0176-42d7-a03f-770dcf65b676', N'T', N'700e0623-7bfb-40a8-b4eb-7d38e9b14caf', N'cfb16d87-3cc2-417c-87bb-3474ac792e5e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bc21a44b-f7ca-4741-9399-730a1f8c4dce', N'T', N'f4e71357-be44-4477-a8a7-c532696fde40', N'03bdd188-8c6c-405c-9ddb-9ccb1ecdc186', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bc5488e4-b77a-47ad-818e-86576d26bb40', N'T', N'5bebe127-05c1-4a80-b132-b35177cdacf1', N'c2d34647-76c9-4ac2-8766-e5033760a321', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bc5b24b6-c879-4efd-a087-8b3fb226ac33', N'T', N'5dfae1b0-0647-4ae6-b5d1-768fe4e6f777', N'9dcb6239-56ed-4991-b305-3b25394ef3e4', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bcfa8ee1-739f-4f2e-90e3-ffe439c3fd52', N'T', N'6aac6248-a112-4628-928a-64c1d849acdf', N'1eba7055-c448-4c18-b2ad-2c86c822ad15', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bcfb9f4a-cde7-450c-b0d9-91447e56ee5e', N'T', N'dd40bca0-a29d-461f-8b85-80904e93355b', N'18d33287-f04b-44fe-bd74-98efa0a82363', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bd63a8b6-ca78-457e-9066-37e9243b24dc', N'T', N'f5226ac1-af22-4761-9a3c-daedcb423d3c', N'f2c81cc0-6c28-461c-bd67-3b01fd587367', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bda0e0e6-c770-48e2-8e1f-f72931d6bf26', N'T', N'a8883ce8-8c1e-41d1-9a07-d52a8cf07ab7', N'534c0bfd-3d69-447d-95b3-55ede3a2e4f4', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bde65e00-9a1a-4ecb-a9a3-478b73d204b3', N'T', N'8fe02304-cda2-487f-b498-85ac4ff815ef', N'91979c3d-de86-4a4b-ad62-9c21bf24a6c4', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'be0dec27-ae25-4732-87fa-377de3c9d1a7', N'T', N'30483d1d-ca14-4b1c-818f-44e52cb68ca6', N'3006fd1e-bc91-40a8-b043-31a5fe4afb25', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'be5244fc-05d8-49ef-a77e-b8e9153476b5', N'T', N'45fb993d-5fb5-4948-8f33-02808a5ff057', N'627cf93b-30ec-4b45-b288-db1e052e35fd', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'be7b1fa9-c604-4bfb-ba81-9c787801cdfb', N'T', N'dd5fbccb-564d-4d35-9a27-7786d8112f2b', N'ec4e956f-4462-476d-8d9b-e3127e57b86a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bf227c91-a726-4ab4-a561-2203229a9b7c', N'T', N'e6f525f9-63d5-4a3e-a53e-037cbcde5454', N'832d89bd-7eee-4b64-ba6a-c796245bdbcd', 0, 4, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bf3e8ba8-b89e-4889-b48d-f14e0917ff8e', N'T', N'f5aa481e-2c49-4853-a1df-f23bd4fd1508', N'18776dbc-cce7-4c81-ba45-09fa4815f6f0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bf51da0a-ffca-4038-8079-be0e8ac26060', N'T', N'a2235eac-7e29-49eb-956a-1005b1fdf1d1', N'15c57383-cbd5-423e-9add-1f75b184973d', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bf7d31a2-7dd1-49e5-a272-b340dfaf82d0', N'T', N'12113fe1-c24e-4898-97d7-305d146f3bf9', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bf8c1e41-0ed5-4279-ab11-9bb2611cc6fa', N'T', N'25e3233e-bc53-4ba2-b852-9d97a0a0857e', N'88b917bf-38f5-44db-a460-f898a2cc3f29', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bfdcf066-a1f6-44ce-9605-6b7db9c30925', N'T', N'7d48c69e-0519-4fa6-bcae-885b107945b9', N'e97977a8-b93b-4922-bc7e-b9a207e0a882', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c10de987-9d6c-48ce-b619-5482e58d1087', N'T', N'4f97c474-2fef-41a3-b154-a26ea1e79756', N'681d8136-055f-4373-9643-fde4e4af1071', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c10fb29f-5fcf-4822-ae5f-fffba12148d4', N'T', N'69a4eab3-6aa6-4191-9310-71962e2852b5', N'82db5964-11be-4d47-8f5f-9aa68ebf3644', 0, 24, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c13b0d6b-ed36-4b73-88d0-b6d390486947', N'T', N'7f9aa8f4-6093-4469-80ae-c8a2fd3e816e', N'bfed680a-3ecc-424d-b3a6-fa65c58238f0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c198e1c1-3504-4433-aac9-4713aa60f284', N'T', N'9ccfbfb6-3dc4-4370-b2eb-50ab7224756a', N'ff211bda-3afb-4193-9e66-bf7dc1d15eef', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c1fcdc21-5fc2-400a-a145-0f4796aa38ed', N'T', N'6fd81e01-587c-4f90-9ebd-758b4dd8a800', N'842709c0-253c-4767-890e-d9ae6d5ed99d', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c2ff25fc-e224-41f9-b99a-c07328beb784', N'T', N'06e7ffdc-9587-4644-b63a-7a2455e0722e', N'885ca279-cd94-4d74-9f86-995db84a2915', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c38dee39-3c16-4630-a28d-360abb37dbe8', N'T', N'9c8d190f-334b-4e73-b9fa-805318acfd54', N'2f960b81-bbda-4c96-9eb4-3701a0e368d8', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c3a705f2-9fe5-4e70-8dcd-77963a2a78f4', N'T', N'7f17db7e-bd25-411b-9d65-c14fe8edc335', N'a327fc59-3ccf-4d1e-b7e4-42457b525c83', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c3f2f090-b928-40a7-8e69-661fe4be404c', N'T', N'ae7c43e7-b749-4802-bb2f-e656396cd39d', N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c3f914f9-246d-4e0d-954d-0c500b73af84', N'T', N'f187265e-6a86-4887-8a17-1ec96893c38e', N'fbfa6ef2-f58b-40c1-8711-92acf3247836', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c4021584-58b2-465c-beaf-3f355330ee36', N'T', N'996d7043-ce9c-47d9-a63f-20bcfea13e23', N'2f32334b-188e-480c-a73d-05bb4765472b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c4166732-94f0-40e7-b932-5277b7388f5d', N'T', N'31a817d3-080b-443d-84fa-3be8f77ad810', N'b2936ade-293b-4512-9bb5-0166b80bcc91', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c418684c-9287-4d0b-a1b6-c4a3b1ccc08c', N'T', N'a8094b24-edbc-4ec5-92bc-cca92965bf47', N'76bc9483-5c31-4043-9361-f05fbcd577f9', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c41cf392-67e9-4014-b722-d60bff94402d', N'T', N'949707f4-5aa5-4106-af24-797ff919bb57', N'5bcbc8a5-6fa5-4554-9f80-52d8b5db8810', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c45dc5a0-202f-47e0-86af-83283602088e', N'T', N'b470b179-07ac-479e-8b14-0e5b677f46b5', N'b48fd89c-f402-4ab9-ab04-75ab5b02a345', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c46f06ea-0b01-487f-a76b-70905ec7fc38', N'T', N'862651c0-afb8-4d04-86bc-d01769ee7bb1', N'fd592919-6bad-421c-9766-d4370d4eeb0f', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c47c79ce-3a56-4132-b1bb-b3cf5df574dd', N'T', N'ee6361f3-d522-4a73-b479-de28c564c173', N'5ebafebc-bbff-4b0d-88c6-efbc7428a0ad', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c4f7b725-4f3a-435b-99e6-d618d2ab167b', N'T', N'7e978acd-561a-4c8a-bf8e-ed0c75626c16', N'99da7903-9969-48e1-96da-4a5cd735d07e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c4fb4e13-58ee-4f21-8b8a-3c865059dae3', N'T', N'd552aae7-279c-41ff-a335-9d745cba2393', N'b553e4b2-9e73-4c8e-a19b-40ba04f51bb7', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c5223677-c0f9-4ed1-b727-1c04ed837d23', N'T', N'0b76b16c-e31a-4fce-90e8-d859dbf1236c', N'153fac62-e379-4394-acbc-c8ff16ae5f41', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c526ccb3-f482-410d-9235-17b03b3aa383', N'T', N'1f315270-dc7e-42e5-9048-254872fe8a6c', N'99d20d68-5cc9-47b8-9d0d-bcffdb3c612b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c63c3caa-bfc5-4880-acd6-75d2f8fbd1e7', N'T', N'ba11e29c-0776-4b98-b54b-07dc01431bcc', N'e13c5f57-ad7e-43fc-8f77-c9feb9372d51', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c64a696f-ff6d-4de5-a495-72523b192262', N'T', N'8abe4492-487c-4c2b-b08d-84963ad28387', N'b671d59e-6a72-4e62-b02a-ca00455b154d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c655589f-af2b-471b-a37c-bb03add32a0e', N'T', N'8f0209d3-021a-47ed-bfe1-d8cfe8d1c5b2', N'c2ebf0e6-1fec-4e27-96d3-26a1ca727efc', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c6bdd323-d773-4a4a-ad14-675ca2945422', N'T', N'2d813e55-2ce3-41e5-b6db-00129a6467b2', N'7c9a8926-1b50-4dfb-b795-ce4748c2c43e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c6ced69b-1b41-492e-b602-c67fc015a4fa', N'T', N'df2402dd-ee86-4a15-a64a-d632f0fdde5d', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c71d0641-ecf2-4752-929f-43843c492383', N'T', N'd3aa16ba-7bf2-4f86-ad79-f31ec56abc02', N'fc877391-9241-44e9-a7b3-87ba400b6d41', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c738605b-a892-412e-8d4a-382b0ccb02df', N'T', N'68f0fde9-c954-4650-95b2-f67b8cb42bf7', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c7e4c0a3-34aa-4522-9652-66095828fc26', N'T', N'b43c7f5e-148e-4f61-8f04-28c5aafcaff4', N'dfd5b59d-6522-403a-a971-65133add5aaf', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c815e755-74de-45a1-a72a-31daf996eed6', N'T', N'c7bda07d-b8a3-4b85-9fb8-877e65300cba', N'7752da29-269a-4c56-9ee4-219109e709aa', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c836f5f4-3802-4a53-b0e9-be4f6b980190', N'T', N'e761f6a8-28ea-47ef-ae61-3cc503b38cd1', N'7d5fcfce-cb87-40fc-bfef-fed61bebd20e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c8ed38eb-593c-45a7-a925-e3531a8de2e8', N'T', N'f4e71357-be44-4477-a8a7-c532696fde40', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c936dd5e-6f46-462a-b3d9-8f677c85a20c', N'T', N'71db150b-5877-444e-99d2-1186b83f21a3', N'4d4de2b0-924a-4c63-bed5-4d3c760453cd', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c9414dec-1b7f-4798-8f81-0052518a04b9', N'T', N'0f4f545d-40c5-4714-b0c4-e3aa3748238c', N'3baab570-bf7c-4b63-8faa-8c8746e61401', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c977dd3e-2f57-40e6-a8cc-911d33ac87d3', N'T', N'2f76d8dc-33e9-40c8-990c-a40404acf5f4', N'ed6af9c1-fbbd-4565-82b8-a8711185070d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c99d9dc1-bb7e-4367-b05f-ac51b6cf656d', N'T', N'219dec6d-af3a-4dee-9005-44f83d8f2c55', N'9f6d1520-b2b6-43c7-9071-cd4ede604e44', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c9b7cbc8-92e0-4548-93d6-a136eaa49778', N'T', N'219bbea2-7c40-40d9-ab21-078a6071a62f', N'392851cd-1227-4665-995b-6ece15fe3231', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ca0df516-4d98-432e-ac74-fab3d53aab8e', N'T', N'3fb2121b-7d19-484e-9521-49b50bf0739a', N'ff211bda-3afb-4193-9e66-bf7dc1d15eef', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ca0f78fd-e6af-400a-94d5-9408f514ce90', N'T', N'd97e55f2-d384-4792-b648-442edae3e7bb', N'c9f25694-9e44-4beb-8c91-53aa45606ac7', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ca1444b7-fb55-4013-9de6-244ddee23526', N'T', N'e8c5f842-5440-4c8d-92b8-c64de6a63e27', N'87cfb57b-4b22-4676-8d4a-3ba45a18a238', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cab2eb0e-f4d3-4656-b668-3b33f04d7c45', N'T', N'a3b74322-3350-4685-905a-b50117e0be7a', N'b46072c3-c9d0-4238-a765-4a458b6a8e21', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cb1c4844-b1d3-4124-bb52-50ae59695877', N'T', N'5e4910c2-3131-4a6a-9326-2231c8d9e6b3', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cb38e454-7687-413a-af11-07dbb449e20c', N'T', N'b43a6ea6-8334-4fb1-8151-61333325544a', N'5aebcfbb-4f90-496e-a018-e60599b4cdb6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cbc06519-c25a-469b-9ab8-c4f73e620380', N'T', N'4e3c9ba8-6a73-4dda-a7ef-a3eddff77348', N'912af517-7fab-42e4-8282-f6cfb6eb7717', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cbdcf0ae-6ba3-462d-aca4-66d0dc041d91', N'T', N'55692c2a-7fe6-484e-adfd-8d8e6f91bf73', N'03dc0ff6-c524-4262-920b-50b7a63fcad2', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cbf81b39-e66e-42ab-bde4-48cbc22fa7cc', N'T', N'7f9273e4-32a6-49ea-afb9-f8cfa570512a', N'b08c5a34-c12b-47f2-88bd-18c9cddbc6c5', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cc8c53f8-3132-42ba-a3f2-d65b70483307', N'T', N'24538724-51dc-4601-b5cc-c0cf0daef4ef', N'2055cd2e-1a75-4b1d-9c3e-b20811ec3b10', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ccb50045-f2fa-4c88-85c7-72e680b0ddd9', N'T', N'8a7c8f68-5dad-458a-b878-1735de4900b3', N'e93f8b57-8592-491a-a44d-8f92037d37d2', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ccc84988-d435-430a-866b-81415d3d80a2', N'T', N'e3823771-6101-4d64-834f-e0171236f5e5', N'a2d8f3f7-2b2f-4c13-a4d2-561b08382e77', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cd69ba6f-14c9-479e-afe4-f717d1408354', N'T', N'a9bf7aab-a275-4810-840c-be5534f00592', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cd7cd968-c651-42d5-a9d6-668e3e0d06a4', N'T', N'2ad79c06-33f8-4e32-bfe4-385c5206c3c5', N'3d39bc60-6766-4dbf-b4a5-fa36b888dd5f', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cd9a7f57-5fc2-45b9-8dcf-153980d0b9cc', N'T', N'ec2ed091-e209-4daf-97a6-b59fd7d5c42f', N'91206be4-2fcd-4799-8d5a-10994266590a', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cda05322-6e02-4ec4-858b-73293f3e1e65', N'T', N'4bd51b93-b91e-4130-9f64-a882c95a7606', N'9155ee20-b2b9-4c9d-9bf6-96601d8a356e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cdddda88-436a-410b-9bbf-fa65cdd4b695', N'T', N'8f64c387-bc6c-4b9d-ae10-05cb45a39811', N'7665bb5b-3a15-4f62-9052-27bade8681dd', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ce48c9ea-9b65-4917-bf80-318a18b65350', N'T', N'7202d54a-6ee8-46db-b841-d9455e74bcaf', N'd2ac8a5d-d618-44fb-b0a7-a19e9ea2fd09', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ce6a6cbc-9608-4fa8-8735-1b526f218145', N'T', N'6242f94b-dd55-4a87-bb77-520eb573a230', N'17dba687-dec0-45d5-af28-2676c5b1b293', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cf00c807-82fc-49b5-9534-df2c13cdb7a0', N'T', N'cc939073-82ac-4bb8-a2fc-0dc74562c5c2', N'060411cb-e09a-43d3-91c6-c6941c7640c3', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cf13196d-8960-47a9-9db5-96e3c2a7daba', N'T', N'841f597f-670b-4e34-aa9e-71adc4a08be9', N'ad76fe7a-dc1a-4f6c-ae19-288dce3d8415', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cf30fe02-9996-4c45-a1e1-7b7b09fbe914', N'T', N'e42dac78-7a13-49fd-b2ff-ca57167c3043', N'69889167-81ed-4a91-963e-93031b0f9b76', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cf3c2085-8873-4d8c-8a37-e2e3dbaf48a5', N'T', N'f95cc2f3-c264-4817-a4dd-de11f48f4b41', N'ca21d05c-2c3a-476f-ae4d-b57abc5f6f75', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cf5df348-5c13-48f6-81c0-6c8555159811', N'T', N'11adad87-b981-4151-bb3c-94e72ce66047', N'5f029b2b-96a0-4748-a084-a2a9f51a7b3f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cf63fe6d-4d9a-4ce7-b764-0cde2bc10e84', N'T', N'f125f84a-97dc-4ab1-8877-6c38d6bf087e', N'9d802b6c-d731-45b7-8c48-7ebcd845c955', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cf7013b7-35ee-4cf9-aa26-ebfd80ba2046', N'T', N'b4ca1bcf-61ae-4ac1-aab0-b3750feee769', N'cbe9f5d5-a8d3-4546-b488-4c37890ea842', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cf73974d-8350-48a5-8594-33a9efd363d5', N'T', N'1b8acc66-eada-4165-8edc-06eda8cff282', N'464795ce-81b2-471b-a564-9099fea5ff34', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cfcfcd62-9d99-45d8-af6e-084ae7c457f1', N'T', N'1baa8f36-7e18-4e29-a739-fe6eccdc3731', N'bf6fcac5-bb15-416c-b009-82cd1ba5f25a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd0062ec5-3069-465b-bf0e-ff0e70df0cb7', N'T', N'5ba43481-faa2-4295-aebc-9c32d3612356', N'1127d9f9-1197-410b-abaf-e4bd89a6cf6d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd04f0fa6-b165-448e-9f07-9c508c5382ad', N'T', N'9103069a-7bab-4a61-bc3a-255b2fa271db', N'4e4beef6-3882-4275-94db-50519ab737ea', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd0667461-5691-41ab-9f06-c1ef25ede6e5', N'T', N'2c4b9fc5-9f97-4e25-8487-f47983222f6a', N'86352c3b-b7f6-46de-b9d7-014eb3e4f937', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd09a4f36-7cf4-4257-877d-f59d0c4ff265', N'T', N'988f5d19-9653-4441-ad5f-88b2ddfcfea1', N'b6e9c554-3f2d-4000-9552-c2bc1430185b', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd0e67254-0b8b-41bc-8251-70b2726f61f7', N'T', N'4996696d-8ed8-4f93-9608-59520b09ad81', N'd0c17c9a-8dfa-429b-82fa-69dd38b1558d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd11169b4-127b-4ccb-a659-5493175f5070', N'T', N'af39ddd1-2c38-4e69-928a-8e8457f2e580', N'4054a915-7151-431f-aecb-ab304b163d30', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd1445fd7-3be8-4986-92b0-f6f5d4de1ec5', N'T', N'a65a4aa9-ab94-46a9-9dea-cb4f776396bf', N'86cb6b30-f921-42a1-83ad-a4045bd61732', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd1e0ab36-1bfa-4f8c-b42c-789f423e0818', N'T', N'e2b3d742-2be5-421b-bd10-405c856d1311', N'05c8c694-4fd1-4975-b084-5530550f5cb8', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd1f02b32-669c-461a-b412-35212933787a', N'T', N'6d545345-77a5-47fa-ac89-b341f955eb23', N'0c0fccbf-a89f-424f-8dda-96298336c160', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd2eedc19-bbf6-4f67-97c2-9523d4426f22', N'T', N'743cc1e8-4525-4288-ae9c-18e99127a73e', N'f8a536fe-da76-43aa-858e-4b0f912fc0a5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd2f77441-cebd-4665-bcf6-5cfbe27fdeae', N'T', N'751c8ec2-14ff-45b9-8ec5-dea2cd18dc3f', N'0b1b8000-da34-4b60-bdd1-a3da69e8ce5e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd3050d8b-d1f3-4067-a93b-79da72232314', N'T', N'627eaf10-0051-45df-9d92-3b45efd4d424', N'f51a508d-04b9-41f2-880d-f43ff940a717', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd3514fa9-db1d-4dc2-832e-acac71e3c31d', N'T', N'30027f88-86e3-4d10-8252-d48dbbe3067b', N'ff211bda-3afb-4193-9e66-bf7dc1d15eef', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd35d4bf1-70df-47be-88db-99b5a3dcbf0c', N'T', N'1cdce61d-e2de-4dab-a823-52f3a6268116', N'05244089-e384-4fb4-b6f7-8f68a2c1ece4', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd39e39b3-cdb6-4c5f-9ba0-35b8aafcc6b3', N'T', N'c6dd8349-e99e-4f0c-82fa-d6dc29985fbf', N'926bdd82-45b0-40b4-a2dd-1f7b4717a859', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd431cbf7-cc81-4ad9-9d68-3fb3fe149114', N'T', N'b7e84c31-92b6-4882-a749-c24b1057cbbb', N'72f060d1-0db4-4382-8897-3c1dfe7fe31d', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd4b2b8be-8a2e-40f0-9ea4-ef685876e466', N'T', N'06c43405-b375-4335-b587-59650e83b6c5', N'40301dd3-2858-4005-b3ba-17614552107f', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd4c1bf83-ff57-4b49-bb6f-91485ebd88ec', N'T', N'ff9d0325-1068-43af-ba88-d928cd6ed695', N'2efedf29-1ddc-4b45-a067-a130f82951c6', 0, 120, '20110804 16:09:32.703', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd54c3c8f-6369-44e4-a3c7-8261adc9e592', N'T', N'0150b4bd-bba2-4be5-be94-bdb3ead37ff9', N'e762d43d-68af-40c8-b2e0-9ebaeb97291a', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd55bf24d-dda3-476c-9ae9-6feccf71fc09', N'T', N'426b8dce-2265-436a-a520-f30867c7afc9', N'b671d59e-6a72-4e62-b02a-ca00455b154d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd56fa88e-5393-4d3d-b117-177957531044', N'T', N'f5708dc3-ab7c-413e-8e26-22f029d732f4', N'b642c96d-e652-46b7-a2a5-171835939b99', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd5766c95-9bea-4739-b9b4-1d1c6606f9f5', N'T', N'a7f8a12d-2750-4a81-a244-fa19d2e9131a', N'f8a536fe-da76-43aa-858e-4b0f912fc0a5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd5f12135-1ba5-4994-b805-a7df04251c5f', N'T', N'ca53e8fd-ddfb-4139-86f0-c14fcbf0f5ab', N'6e47eda2-d112-410a-9398-41afd8024b0b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd5f15b95-1584-46c1-ba3a-6c69f2abf36d', N'T', N'31025e8d-707c-4d7a-b543-16fd21d2c70b', N'5db8370e-3135-4c32-a247-5f627dac9e1b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd628f9ac-a3da-4af1-906f-3595c724fb09', N'T', N'f5d505fd-bd6e-4954-bd29-3fbbbd89b9d5', N'08065650-fbee-4d67-9ca6-a84db600bfe5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd63a7ea9-f97b-45af-9c06-1fb2cf34e246', N'T', N'4996696d-8ed8-4f93-9608-59520b09ad81', N'2caa6b05-550a-4b8d-b513-3dd365d31de5', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd6ad77dc-7bfd-4216-87f2-dca73bb5267b', N'T', N'9a143677-a368-43cc-b364-dd2cf42b733c', N'808cc7cc-ebcb-437d-82d9-921b6e40f66c', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd6d7a5de-a32a-41b6-b9d6-ab8d401311dd', N'T', N'02cfd55d-993b-4285-a2eb-1bf2493c4fad', N'c69d7cb8-387d-49a8-bd6a-a2f08f358e56', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd6e3d5dc-9875-47f8-9f93-a0767462c811', N'T', N'01f2a471-7ce3-4525-b111-8994f492dd17', N'dd82c5e7-239d-4a1a-a8a1-59c3510fc69b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd7618c73-2f61-44f0-b2bb-7588bf9a74c5', N'T', N'3d50614f-3f9d-4536-a0cb-f0b64fe539fd', N'3edef728-cf10-4f3d-bb83-68954d58701b', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd892de27-9a46-4153-b19f-c5b8f38779ee', N'T', N'87cec13c-d1de-49c7-983d-1662a6fd3910', N'7f2b7ffb-c844-4000-9681-4243cd6231c8', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd8f2ca8a-45fd-45d9-a5d5-f6ef86b62380', N'T', N'1fd99b1e-74cd-430e-8cb2-c3cd3b83ec7f', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd914f678-b80e-42b7-8257-c9c7503bcfc1', N'T', N'dfa9e3f1-1d88-4eeb-b4aa-b57f3f8ad0a7', N'b05793ce-5130-43e2-a7d0-48e8b1060473', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd9ca4a57-13b9-4f3d-adc7-8badb3d75230', N'T', N'32396fa1-d38f-4c82-8f4a-559aa68ddf5d', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'da33e341-ac2b-40ff-b4bd-01caa7226ce0', N'T', N'bffad210-f917-43e9-bb44-cf66fb7484ed', N'5dc5b8e9-7079-4b65-acd8-4a9af64ab4c8', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'da473ff8-00bb-45eb-8249-743f1ae2b687', N'T', N'7fb80621-f86d-4d75-8565-9d21b6ef36a2', N'd09a741c-9f6b-43d4-895c-be0f7a813181', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'daf23975-6a69-4a10-9b5b-7d18d9d6ba4d', N'T', N'850c89f1-8d50-4ed3-aabc-6d9637aa8b9b', N'1f02bc07-616f-4257-a607-c50f648a2118', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'daf9a6f7-93ef-4fb1-9a38-f443802f496e', N'T', N'7b292c64-e6ec-4f2b-9380-7c3729582efe', N'730e9f3b-def3-48aa-b2d9-1a0e7d895fac', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'db15e31b-4a60-4147-b510-8658a5d8224a', N'T', N'4327948c-7ede-48b3-9e5f-9c9cb7d07d91', N'82fa38fe-380b-4440-8cf6-c8cbc83f2f1e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'db295b7f-64eb-4295-90b7-b505cb355359', N'T', N'70941920-1840-47e3-bca9-9b0015fa48b4', N'dfc25e64-5eee-44cb-98de-fa7af4f1c6f4', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'db6df958-d8c6-462b-a6eb-2a5bf3a3f4d6', N'T', N'9aadc3f7-9470-43d7-8008-01e276d269ad', N'9ee201d2-76b5-4c78-bf23-7d65ee73c586', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'db9143a0-9f2c-4771-bf9a-a85b012e4a91', N'T', N'dba9012d-1da3-482b-9583-38e79d4d12a4', N'2d258ae8-5984-4d64-a329-7fde7677e1eb', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dba89392-2cde-410a-9f07-4ddbe1f79c58', N'T', N'9b713d38-7da8-4761-b975-4e81b47336f7', N'cb9256cf-267f-405a-8769-a9c55300d696', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dbfb3a62-2269-43c7-8e44-4d5081f60f21', N'T', N'f493b51a-555d-4c24-bdec-65c70b492b07', N'a9f4a065-35d5-4976-a82a-c11dd66ccdef', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dc0bf8c3-9ec8-499f-b032-59df41f196f7', N'T', N'7e5037f8-110e-4045-b6c9-8d64339cf408', N'13b61f93-eab2-42db-94d9-364009636d4e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dc33aedc-dcbe-47c6-8433-4055c6aaae2c', N'T', N'082c68ae-cbfd-47ba-9f6d-04da93e753e7', N'5b959b0b-b44a-49f4-8237-90623d4af7dc', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dc3737e8-104d-46c8-bc45-b31d315e93b8', N'T', N'ff3e6a96-e172-4ad3-a095-21dc2cea1bb0', N'da2a0c89-f968-4ddd-97e7-dde99eaaf411', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dc831b4a-685b-4269-a66e-04d15cbf94bf', N'T', N'64c2f7b2-ab9f-421d-b932-9a74ba4b278f', N'9fcd2123-36d9-48bf-8b7c-896a8f47fc86', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dc8e15aa-24ed-4f58-9268-7730dfbadc46', N'T', N'91f7566e-158c-4bb9-950d-bfe144e62a55', N'54d7a051-0cac-4f01-9308-84f05051700f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dc93e5ae-59eb-4c8a-a891-96ba5beaa736', N'T', N'd552aae7-279c-41ff-a335-9d745cba2393', N'925ca9f5-13be-415b-a0bd-60bc53dd95a4', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dc9bb472-a54c-445e-9f84-7eda5d3b7aa4', N'T', N'70d35f34-308f-4e4c-8644-5ebbd69005bc', N'239f4679-d89c-428e-bd44-e8bec5cdfec1', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dcfe25b4-7059-482c-a4a4-61e3b7b1dc3f', N'T', N'36672499-9a8a-4834-8a63-f99cb959bf2e', N'd797beca-ed4f-45fb-b8bc-d55828936ac2', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ddb5d17e-eac9-47c3-8745-e1001916c2db', N'T', N'6bcd3738-619e-4dc4-8f46-140ef23c90fe', N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dddc06b7-f93c-4602-a242-958a14c98068', N'T', N'ba7dd334-d7f2-446e-ac3f-604a465bf710', N'464b189a-a928-4895-952b-33b1c6c9b0a0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ddef7735-a7b8-447a-9a50-d7de240b34a9', N'T', N'aa7ab5c9-b1e2-4bf8-a81c-cae9c0f5456d', N'41b5e41e-6762-4f22-8106-58d93cc5c3bd', 0, 6, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ddfe70b9-4829-4a08-9dfd-47b83b7b4894', N'T', N'dba9012d-1da3-482b-9583-38e79d4d12a4', N'33705d89-bca2-4ba9-ae46-fd0d1c360fec', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ddfff00b-382b-4e22-8f92-a964e3e4c476', N'T', N'e3e0d245-95a3-4ac4-8596-78bb48b0d965', N'edfbbca6-fc53-4576-81e2-a4837e08ebce', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'de5c4bc4-a933-46b3-87f8-be401016cef8', N'T', N'b4ca1bcf-61ae-4ac1-aab0-b3750feee769', N'8137aabf-7449-48ca-967d-60149389e04f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'de9f57de-5960-412f-9f73-bb264fe17e35', N'T', N'776c4830-a0e7-401d-8575-706ba98573b1', N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'debc621b-fce2-40d3-a541-eb7bf36a6bdb', N'T', N'8e93b9aa-fcc0-4e9f-9f6d-abbc885461ad', N'a04b365c-3839-4d58-848b-27bdcdf052ed', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'decb09e0-ac3c-492f-8313-b1c2d10236b0', N'T', N'06b21389-2977-4d71-bcac-0546a5c4526a', N'f02d0796-2248-42cf-9dcf-b1fbd596acd7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'decf4df2-ce0e-456d-8b6f-e967fbadf966', N'T', N'b342097b-a12c-43c7-8bfa-e951991486bb', N'e93f8b57-8592-491a-a44d-8f92037d37d2', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'deeee412-4200-422a-af31-5526e346dd83', N'T', N'625e3a53-db79-43ab-80d6-2e79a2c9f90f', N'd8dac708-19ab-44d1-a2c7-17833e9b6110', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'df607a0c-9d47-4056-8666-adf5719ce7e4', N'T', N'085954db-7890-4c7e-aa74-56990a7cf7f8', N'4d9a9e5e-5ef2-42ec-ac06-da5747e4657e', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'df8943c9-9b65-4735-820c-364c7c54268f', N'T', N'a40de53f-aa71-4beb-ae4c-4a9b8cf93e66', N'935ef03c-c766-4394-b798-5c18eafb4de0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dfaf42ff-209e-4657-b7a2-1f98f6fb373b', N'T', N'ce077d8f-848f-472e-87e7-b81ce8d8ce36', N'44f39195-b4f1-4a8f-ba16-01390a61e42b', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dfe339f6-aac3-4ed2-9504-8ef6a8ece231', N'T', N'a8e07af5-e945-4172-97c9-14af3a4da37b', N'ba314d06-39c9-48d1-887d-8008d8d5c70e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dff755f1-ff8a-4dea-8341-8e7a19fa3425', N'T', N'8e050d4d-4df9-4e6f-8b96-eb9c6365f7a3', N'bfd703f7-95ac-4f64-a074-3e7a5c4b9510', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e0071298-4f53-43bf-af67-be833fde31fc', N'T', N'5d27d969-0b73-49a1-a53e-606765a24c0f', N'7ea097ed-d75e-4a48-811f-d53a6c50dd85', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e0253710-e765-49f9-8388-2503580d9c60', N'T', N'67defa5b-a280-4e61-81ec-acabde850946', N'0cb088bd-a195-4b8e-bd5e-af716f5a41e0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e180bb33-2535-4c72-abcf-ad7560e4d01d', N'T', N'3a9c4936-4c8b-43c3-a216-e4776e51ca13', N'4561e0f1-1106-45cd-a6bd-0d30c239e816', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e1ac5bd3-b651-476d-a24c-b77e80f89f23', N'T', N'79f2764e-62d0-4671-9ad1-014b972e5969', N'4bcd6eec-bf9c-4cb9-8527-4ad80460337b', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e1df66ae-7c83-46d0-958e-c985c6ea812c', N'T', N'2f985a58-6c1e-4972-8242-a24c7166dc67', N'28c0b0a5-d1d4-4dcc-be39-c150389aa3b1', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e20525d4-2d06-4f85-aa3c-2a077d85ed3c', N'T', N'60f1d127-5097-4ab5-8bbb-272138bb66e7', N'ae891bbe-1b29-483b-9b97-e428a1c7f223', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e24bd720-ff16-44d7-846f-13bd6696a6a4', N'T', N'3dec1afd-7f29-4b21-80f8-2a692b8f7987', N'13320291-4e07-495c-bbc1-080b69d0cb0f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e25e0f8b-3bd5-4b3a-9049-7946e90a7a15', N'T', N'e6612747-475d-4cb9-adf8-3252fcf02489', N'596e9e2c-8ace-44ed-a572-939329d941d6', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e347c543-1158-4e74-89ee-4c2a9d0cfd56', N'T', N'cd35f475-946e-47e2-89c6-336c31f725be', N'c1bb8eca-a9fa-4787-83a3-03ad2f4c933e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e38f38e1-d61d-4ac9-b91d-1d48ab7a8bd1', N'T', N'e5548a42-5f75-41a1-82d7-849d2df31725', N'15c940e3-3b3b-41e2-9774-a161937d2c7d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e48cacda-de8e-4b1b-b521-b0bd84daa4cf', N'T', N'f95cc2f3-c264-4817-a4dd-de11f48f4b41', N'121b5dc1-ae15-4742-9887-30db1531cfde', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e4d29421-20fa-4f55-b782-df10c3080bb1', N'T', N'198d0929-2a42-46f7-b841-dd0b863329c6', N'240a0d07-8535-4f6b-8ed6-a0390ba3f621', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e4f6ef3b-5e2b-44b1-8f22-64da29559d34', N'T', N'89062129-409c-4eb4-8b48-e6fdecbcab28', N'0ca318d0-6de4-43ef-baaf-8fc46c368ea4', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e52a4190-7ef7-4d5f-9f67-1485af3fd1bd', N'T', N'd2e6f707-0d20-4414-a0d4-e06e57bb44b8', N'3122f238-b23d-4680-bd6a-76a247cdf2ef', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e5681c57-a6de-4b4f-b25c-0424b7c75246', N'T', N'af0bcdad-36c1-4ae9-87c7-422826325303', N'6847d814-363f-43b8-bae4-6a599483a7ec', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e5964218-be83-4a9f-a481-782d6fa14ff9', N'T', N'eba6d93c-d7c7-4123-8248-d68e0e8e4720', N'70fdb496-9f5c-4b26-8b8a-800e02efbc83', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e6d99cf6-41d8-4a8d-b50f-2a9807f254d7', N'T', N'8bd234ae-2ac0-428f-bda9-5ad622d55060', N'012b6852-6de3-441a-a0cb-a247e2a4ccbe', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e6f16046-a0b3-4509-88e1-cd649eb78881', N'T', N'4fda635f-eddc-4415-878f-7d19df846388', N'76bc9483-5c31-4043-9361-f05fbcd577f9', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e70b33e2-f0e7-4724-a35d-45886f22be02', N'T', N'892f13be-e1e3-4fee-ada3-9a484fb99563', N'cbe9f5d5-a8d3-4546-b488-4c37890ea842', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e74bd188-3614-47be-9624-2ac348a7408b', N'T', N'29e09539-b85b-4867-9ea4-97abfe987be8', N'0996ac40-bece-401a-857f-b30448e20c52', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e77cc752-7146-4036-b95c-4912eee27af5', N'T', N'cd919ed6-28c7-4f41-9185-ad52b5da10d1', N'd26b9fd2-7daa-4bd7-b767-ba2e30553bc5', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e78dea3c-5cd3-4e48-856f-8deb5bfd1bab', N'T', N'6eb0b436-15c4-4567-8e72-1b2dc8229e86', N'99da7903-9969-48e1-96da-4a5cd735d07e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e872a5ee-30f6-4f83-98df-ef030aa6ea7c', N'T', N'ce2d908f-ae37-4484-9d46-869c5ebbc4a1', N'b3878283-a225-4d82-87a6-3d195aa5fcdc', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e8cda512-7736-4b67-905f-c66bb057c356', N'T', N'362c7e13-6f0a-4f2a-a9d1-e019674f7fe7', N'19c49ace-c1bb-4edc-bc4b-01e653771bec', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e92eb03b-401d-4727-874f-5139eb217be0', N'T', N'08383d37-ca54-4697-87bf-3e3ec74bda83', N'76ad931a-b96e-4382-be8b-d904f3d786ee', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e9ef7cab-f1dd-4835-8e22-0780e8984c76', N'T', N'0ff0d154-130d-49ba-85a7-df78df041909', N'44f39195-b4f1-4a8f-ba16-01390a61e42b', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ea405d54-c522-463e-8b54-a7d3d28ae98d', N'T', N'0c00eac6-34eb-4638-b03b-f2fb7c8ce536', N'35e768fc-17d1-46ba-ad6e-430e5241c8d5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'eaae5757-312d-46e4-b121-c6a0accb9a87', N'T', N'0a6f44ac-9137-44bf-be46-92c25006a0e7', N'98e16a74-25f4-4d56-8ffe-a070ad978876', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'eab31b2b-1ed7-48da-9b6f-65c8e35ec1b4', N'T', N'fec854a5-54d5-43d1-b5fc-39ba1c0f72aa', N'18776dbc-cce7-4c81-ba45-09fa4815f6f0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'eb095ebd-f2e2-4f65-bf6a-7c70460e63dc', N'T', N'c9a74e0a-2dc8-4d51-a4a4-59ae429bf110', N'1b51d733-3dcc-40b4-9f95-4a9490d3900d', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'eb7e4d4b-6194-435d-9480-4783a13c7bfb', N'T', N'21a6eb5e-b3fc-4371-b842-ab5718e12e5b', N'0b3add9a-0477-4b28-88d5-f3d1fbc24a15', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ebc6b595-1278-43da-93f5-0cb3357f3b61', N'T', N'085f9d60-d696-4300-be64-b29fd1ef733b', N'935ef03c-c766-4394-b798-5c18eafb4de0', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ec395596-7b2c-4092-a14b-af94123b3fcc', N'T', N'017e081d-a7c2-49a0-8415-e7e2754129e6', N'182333bb-d3b5-43bc-b931-ca42764840bb', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ec4d3a9d-976e-415a-9aac-805c22c73be0', N'T', N'a64ba3d6-35be-4308-92b6-65fbd8e2c449', N'3afc5dc6-47d1-43f6-b4eb-045c381e0334', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'eccc4afc-150c-4b57-82d2-3adccb86da08', N'T', N'7eff8dbd-e6ab-40cb-ad2b-cf98191a74fd', N'1f5143d7-c111-4447-9114-6f618e62fe0c', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ecdf40fa-8e4a-49d9-a852-1ac86caad4b8', N'T', N'd09cd63d-e7a0-40f0-930e-07e76c5fb09c', N'cc6cd527-d9e8-4d43-b8b3-d85dd6a286d5', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ed11b687-7bff-43a9-adab-8d126be8a5e3', N'T', N'ba549f7f-b193-49d2-ba8c-cb6a9e2d7ea8', N'f701b203-5f25-4af6-9889-9f6cc6405ee3', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ed142390-c820-461d-821f-48cd7db92f28', N'T', N'5ee0bab4-3833-4e73-bffe-139ae563e580', N'153749db-e2d2-45d8-b69f-ef2c0d1ff85b', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ed4f10f9-81ff-444a-b737-18e3b3f46ef0', N'T', N'3407aa67-1ae3-423e-a4fb-4c9ebc8d7554', N'462fe04e-f9b7-4e5d-b6c5-de7671d5fffa', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ed5185fd-784b-4135-9f9e-0aaf685c57aa', N'T', N'99845bcc-fbca-4b2a-86e6-e793174c3538', N'a3d8e580-f20d-4ac9-9612-1742b75cb68a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ed750a1c-a574-422a-8176-c6da79cc4049', N'T', N'6abf237c-ab20-4fa8-acde-4aec54640d7e', N'f1349dcd-4392-4f9b-8865-63c94584cdef', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ed8316dc-698d-4c1b-b1a5-522802869af5', N'T', N'31cf4bd1-b528-4270-83c3-3af95b8edd6a', N'7f94a2dd-ae4f-4d2a-9a27-4ff75a9c83c9', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'edc76ecb-4763-4082-81b5-ab06850f1e36', N'T', N'9399f325-b443-4917-b871-ab326fc36bfd', N'2fc7715d-a7eb-44ea-9b8f-1f9086e2b423', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ee13e711-745e-46c8-b9c0-c8ab40c3e2ea', N'T', N'0357c2a7-7444-4c81-a77c-5b706ab1e635', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ee72d630-ab40-4e50-9998-aedd81232511', N'T', N'585bdf2f-418f-4075-8b9f-764e839f6781', N'617aa30c-45c3-4c87-ad7a-ca1e24c222b5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ee7801cd-a09a-430d-929a-1d5324c8584c', N'T', N'15caf660-d200-4632-b1f0-54586322f851', N'75076e89-e24d-400d-9a68-3df34e7a510a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ee780d38-3b0b-49c5-bc08-fe6db4ae8eaf', N'T', N'aa09279e-40a5-4686-8c33-834d6b4637fc', N'75e6cc56-dcee-411a-a758-37810d3fac5e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ef0688fb-df05-4684-ac2b-fae165e9a4f4', N'T', N'374c1271-a6de-4f7c-819d-e0c62c4306e4', N'2826b172-40a6-4d95-a7d0-29fe9c24909c', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ef4d3fac-aac9-4e4b-9eff-9c79b0f29357', N'T', N'fa60610e-db80-46e5-a1d5-34ead12a1b61', N'7752da29-269a-4c56-9ee4-219109e709aa', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'eff596bd-8a71-484d-80fd-9d70081c0e65', N'T', N'9e226204-b146-4209-ab2f-a94e79b63998', N'8cc15691-b951-4721-ad01-56e491818a06', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f0147cbc-fa21-4dab-b16c-b0f80800a7dd', N'T', N'426b8dce-2265-436a-a520-f30867c7afc9', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f01c0894-e4fd-4f73-a9f8-c4bf85d9e4a6', N'T', N'e0669ed9-a4dd-45fc-990f-4238d4e6b015', N'd612334b-a3b2-4e27-8184-755780d4e666', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f036a3c9-9d88-4d8a-a050-173b7cb2ad75', N'T', N'959dced3-1ee3-4c24-ae44-426b332e984a', N'a4e67db1-17ab-4908-babf-1ab1460820d8', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f0660be8-86d5-4b04-8bf0-1ffd01205306', N'T', N'c3069684-c2ef-46a1-89d4-de886e07fffa', N'65e66ff2-945e-4224-bf34-eac16da7b5f3', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f102ff07-72ac-4a91-b283-59c392f93f1d', N'T', N'f19e2e3a-4b28-44b2-869d-459f2840f803', N'b9fbf7fa-add4-4b37-9184-0771dcaf0be0', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f1b48f4f-c0fa-4b33-be86-4cd50edf7f22', N'T', N'c77666d8-978d-4c62-9841-b9755e3ba7ec', N'56b5d083-4164-4c02-bf24-cf2efc679e0a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f1b8841c-804f-45a5-9a47-0fd09cafba7d', N'T', N'308c362f-5a7d-413c-8824-3c6516b21a09', N'617aa30c-45c3-4c87-ad7a-ca1e24c222b5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f1c8414a-6801-4bf7-8170-930ba09bffc8', N'T', N'5c9fb45f-b3c5-4a4a-87de-a899d02566f8', N'b6e9c554-3f2d-4000-9552-c2bc1430185b', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f24be7e0-1dfd-4fe2-be4d-3291b4130a28', N'T', N'f646c562-eaa8-47cf-b6d4-d08ca81a0164', N'13b61f93-eab2-42db-94d9-364009636d4e', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f286ecbd-26e5-4d38-83b9-fcdb68d9c61c', N'T', N'fec854a5-54d5-43d1-b5fc-39ba1c0f72aa', N'8287c8eb-2506-4870-93b4-7727db1f34ff', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f289e105-afd7-4671-8398-ff714bfa63cf', N'T', N'261251f3-7f07-4a7f-bbeb-a5092b29dc23', N'493ca5ec-c11d-4d38-9bff-581398d2dd0c', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f2939a38-dac4-4b24-b947-a7f06cc1c0dc', N'T', N'c0960a9a-d99a-4cec-ad63-c614061583f2', N'393affe8-7cf5-4941-844b-7ae1222fa490', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f4012723-9863-4a16-9e81-333248860008', N'T', N'a5146b39-d249-4c03-ab56-16601a8a2753', N'6ef43806-c30f-481c-a0fd-5d1ad237b7c5', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f4164dcb-38f6-4dbb-9e50-40c01d8d4dc5', N'T', N'dc17b148-ac73-4bfc-9af3-644adb137842', N'f061c36e-8562-4685-aa16-7eee4cf6e333', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f4659439-8214-44eb-aa77-515f6147e549', N'T', N'9ffab403-70c0-48f9-a16a-8be5be4c8b0f', N'a95c7ef5-ccdf-4c65-9476-51c27c37ad82', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f480f0f0-228e-4c20-a1df-9075a16dee21', N'T', N'eff659cf-f445-46fc-b4ba-6fc6df267065', N'596e9e2c-8ace-44ed-a572-939329d941d6', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f4811ce9-ffe5-4d73-9d3d-bdefea30b944', N'T', N'4299de09-4d45-4718-9da7-6b31dc8e101b', N'515eda3b-78bb-4a6c-98c1-0ae2069f0d1b', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f4ad7048-75e2-4490-938e-7f3ae4cdc16f', N'T', N'844129e6-3196-4615-b509-0bff7d311265', N'5f029b2b-96a0-4748-a084-a2a9f51a7b3f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f4baea18-3add-4572-a255-55c9c234f525', N'T', N'013a3968-1f41-44fc-aebf-4741620a1800', N'a9f4a065-35d5-4976-a82a-c11dd66ccdef', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f53d08f0-63e1-4dc0-bf6b-ba42f692941b', N'T', N'80209022-7db1-40b0-b978-38068e2f1cc3', N'1f415bba-b3d3-49c6-ac9f-cef8ec6c1806', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f65eb331-ce22-4538-b9b4-564c8e57c773', N'T', N'57327824-abd7-4137-aed9-770e16068951', N'ec455519-da07-4a96-82dd-4775c139d937', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f673f59b-c8a9-4d91-8883-df84a6d1bac1', N'T', N'43c7d099-4427-4e2f-ae18-0e8da78575c3', N'63069187-cc45-401f-834d-05952a4e7636', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f6da9975-b629-4a5c-b510-61c4025ae329', N'T', N'4962e900-e1cc-4f0f-9de7-c269bfdfa228', N'b553e4b2-9e73-4c8e-a19b-40ba04f51bb7', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f71113c0-5735-4d72-9e00-812719aad01d', N'T', N'585bdf2f-418f-4075-8b9f-764e839f6781', N'1eba7055-c448-4c18-b2ad-2c86c822ad15', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f75c0a04-7137-45ed-bc8f-658702123f30', N'T', N'431bbd61-cf7c-44c2-beff-81595cb7d148', N'e18e0722-31a1-455c-a072-8cffcd2f4c98', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f7750594-cdd3-4492-ba4b-cae0c6365381', N'T', N'efe72339-3fbe-4d75-9e51-c8ed8c304700', N'f447f73e-0e12-44b9-9ca8-3d64991745d1', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f7cfd736-6aea-463f-9b34-7bfaf5b09116', N'T', N'3132a85b-2abb-4ec9-88a9-e2adf6a1f822', N'239f4679-d89c-428e-bd44-e8bec5cdfec1', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f83f7526-ef27-4f52-8ea5-f3cab84add5f', N'T', N'340ebcf6-424c-4f23-b492-8b8f80dc5a5b', N'808cc7cc-ebcb-437d-82d9-921b6e40f66c', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f872430c-52e2-45bb-87f6-af7c9e3dcf3a', N'T', N'7e3ce649-090a-4fbc-9385-fee88818f263', N'8d3ed716-6e7e-4062-b8ed-b695b78eac97', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f896ea6e-0e30-470d-b93d-5407db899a5c', N'T', N'0ff0d154-130d-49ba-85a7-df78df041909', N'f5413783-f932-40b6-9e4c-13e35723f00b', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f8990410-f76a-4b38-99ab-574a41b21ef6', N'T', N'f125f84a-97dc-4ab1-8877-6c38d6bf087e', N'3c326cea-b961-401a-917e-c5dcdafa09a2', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f8a06a89-8d3c-4fff-a14b-4050a26881ca', N'T', N'd7c23d53-c943-40d6-ba06-79ea315680a0', N'da05c735-fb24-4525-9eb4-d03f59a97ff3', 0, 4, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f8eafa30-a9a7-4fd6-a49c-80dd8eec7f9d', N'T', N'a8e07af5-e945-4172-97c9-14af3a4da37b', N'28dc9a44-66a3-4040-8a07-f89592dac551', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f92d7004-2029-4810-a346-a1f0a6d13d26', N'T', N'24aca56e-dae0-4d60-8461-9b7cfdd2f3aa', N'61e557a2-2e66-4228-b3c0-62c7bd8d5c88', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f988b8ba-b07c-4e50-9671-330734ace79c', N'T', N'bcd35da3-a961-473c-92b5-dcda4ddd5766', N'2eea71d7-8a69-4329-b1a5-9fc6f1ca8c88', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fa7f6669-23a9-4989-b107-4d04833e709d', N'T', N'a349ce5d-fe75-45c1-b0f5-114900edc81f', N'b3a3868e-a796-43e7-930d-8da975dc68b6', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fa806c55-95d3-4d57-97ad-6d0f0bbad133', N'T', N'a2cc3f88-b18b-4af3-929b-de21259af649', N'2034b9b6-7024-416c-a978-5121479cfb7c', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fbb9fa8e-a4e8-4d5f-879a-6834889489c8', N'T', N'8e57aba7-b879-4bc5-8434-7b8d0d57ac94', N'8ac6c354-1b49-4e1f-b158-02c6e60c62aa', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fbd05de7-93dc-4dbd-b93d-67d6321a5745', N'T', N'cd345817-3568-4e7c-873e-5a86c9bbd9c1', N'3e48a72e-ac91-40a8-8254-7a12aecbb636', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fbe80774-c332-4f3a-9aa0-fc5a327e5c7c', N'T', N'1f1418eb-c616-4ad5-9e4a-10efaf6a9995', N'30f8d008-dfc1-4a94-a2d4-5cfa36cc21f4', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fc1d78ec-528b-4876-9f19-7e20040fdc52', N'T', N'990545be-7578-4a3b-ad18-e9d5ed5411d3', N'c794893f-0af6-47e1-914a-33335a18cc38', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fc1e33d3-1c94-4b2e-b45d-94bd6f5a1d4e', N'T', N'e85c7837-85c5-44d5-a5ba-523ed9937908', N'3b6d5d75-cda2-44e4-a7fb-82da72b09f52', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fc266290-0e94-4d6f-8aae-c9d90fd4b567', N'T', N'bb1569e3-8984-4a80-b0ae-c06a0c75773c', N'ea14c650-3d07-4a27-b54d-ee790ce4fcba', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fc2c57bc-3e34-4497-ac2d-63ffd3198aed', N'T', N'a28ecd99-0ec4-4cec-b641-ec3b4cfbe0cd', N'78e0cd25-89ce-401c-b19f-5b8b407bc1da', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fc36e526-00e9-4111-b8c2-7903086989d5', N'T', N'67f5f872-62d6-4115-a31f-fc2efcde74f5', N'ff211bda-3afb-4193-9e66-bf7dc1d15eef', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fc8e5309-c0b9-49b9-8996-28016d3d9041', N'T', N'87cec13c-d1de-49c7-983d-1662a6fd3910', N'45ea5306-b05d-48a6-9a17-8e7265980bf3', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fc9bd892-628c-4f99-b1d3-8527d4304835', N'T', N'0d41dce1-9160-47e2-b1f6-325efdfcb1c0', N'77ba6835-5e8d-46c5-93e3-e1a70023b89f', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fd217f23-94aa-4094-99dd-30399bd973ad', N'T', N'8716ae12-6de6-4ccb-810f-fdba2f511d4a', N'2fc7715d-a7eb-44ea-9b8f-1f9086e2b423', 0, 6, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fd3b77c0-b20d-4998-b3ec-0520d5007dfa', N'T', N'b53d63e2-b964-4b6a-973e-e97d0f4665b6', N'75076e89-e24d-400d-9a68-3df34e7a510a', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fd811e8c-52dc-4c69-95f6-e9691fd06b3c', N'T', N'd1379c92-4a00-4f1c-9b58-69fdb8ad7a2d', N'bf3976fe-b4cc-4ca5-b4ce-5d292ea8209d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fd90bf56-bea5-492f-a913-2d94f0113658', N'T', N'f5cbf8d3-45ae-42c1-b0f8-4a2e4b8ed7d3', N'e12cc97b-eeb3-4697-b84d-15e5971d6fc7', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fdc4fb99-9b8b-4a95-893a-7c53bc94939d', N'T', N'52c26247-f433-411a-bb1d-f17b56e3eb2f', N'8287c8eb-2506-4870-93b4-7727db1f34ff', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fdd155b1-c213-4ed6-bc75-f7382f0514b4', N'T', N'd7d4ff37-6c70-4d3a-a30f-1c0de3ec20e0', N'88eb46f4-8459-4b52-aa26-e75e55108a03', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fdd2c126-32dd-4933-8ff5-64550da69fb1', N'T', N'414a7e92-430c-4aaf-a5e0-f3e036dec2ee', N'4582a2d6-a073-4dc2-aa28-b0557b4399f3', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fe36301d-0679-492e-8336-5ca166804ee1', N'T', N'934809f7-6287-4184-8b91-60e531dc7617', N'fc877391-9241-44e9-a7b3-87ba400b6d41', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fe3f612d-d991-4e8b-94f2-e81ebe6f4d05', N'T', N'52fe2aac-d9dc-42f6-ba90-bebc232e8ef3', N'fc877391-9241-44e9-a7b3-87ba400b6d41', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fe40e909-c7d4-4482-900b-4a872bf28ee4', N'T', N'2b7e92c5-c6e3-44dd-8754-a4494e2d397b', N'2d258ae8-5984-4d64-a329-7fde7677e1eb', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fe7cb124-9079-47ac-bb2f-0654ad8738a2', N'T', N'65dad306-ebbc-48bf-9462-88e32c0f910b', N'b10d982f-8784-4079-ad81-01841e9aee32', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fe833cd7-acbc-4108-9d5d-224b6de88f5b', N'T', N'e66ad7b1-89c3-4834-a665-1fbc7a8ec2f1', N'c2807677-07e0-4a51-aa2e-dc81843a08a2', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fe937485-33e0-4934-81b6-f848c6993840', N'T', N'b002e6ca-1cc3-4594-af80-bedfea524fc8', N'2055cd2e-1a75-4b1d-9c3e-b20811ec3b10', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fea100c8-c38a-4c6d-b0e8-0bb3a9abe017', N'T', N'2b61b737-c1ce-4f26-b9ff-6e5b0e26423a', N'98074582-7f6e-4d6e-8651-6f0808b7f19e', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'feb8995b-b5f6-488b-996a-e84fb0d3d185', N'T', N'73a832d5-8f96-4323-a374-1ebd73f7e3a3', N'402e54d6-d110-408a-b84c-2b9834e11012', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ff180110-679d-4c58-b023-1c9609a28b69', N'T', N'ec918aa4-248d-4772-8fe2-e98e1da2f608', N'64d152cd-5df5-4c1b-8bb7-cfe2c2d9697e', 0, 120, '20110804 16:09:33.000', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ff5a608a-3056-4434-ab37-14b2f16b639e', N'T', N'b02908d3-456f-464e-844d-81888e3d4b31', N'9dddd102-15f8-476d-b8cb-08ec2553eb9a', 0, 120, '20110712 13:30:13.867', N'vhaishsmithm', 0)
INSERT INTO dbo.BloodProductModification (BloodProductModificationGuid, ProductModificationCode, FromBloodProductGuid, ToBloodProductGuid, MethodSelect, ExpirationDateRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ffd81081-6327-4ed1-82fd-0d3fa056e684', N'T', N'3713d767-c03d-40b1-87d7-ffad27893e93', N'b671d59e-6a72-4e62-b02a-ca00455b154d', 0, 24, '20110712 13:30:13.867', N'vhaishsmithm', 0)

-- Add 3 rows to dbo.BceStatus
INSERT INTO dbo.BceStatus (BceStatusCode, BceStatusText, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'DS', N'Dispensed to patient location', '20110309 14:38:05.653', N'vhaishsmithm', 0)
INSERT INTO dbo.BceStatus (BceStatusCode, BceStatusText, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'RE', N'Released - no longer allocated to patient', '20110309 14:38:05.653', N'vhaishsmithm', 0)
INSERT INTO dbo.BceStatus (BceStatusCode, BceStatusText, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'RS', N'Reserved - ordered and product allocated for patient', '20110309 14:38:05.653', N'vhaishsmithm', 0)

-- Add 2 rows to dbo.ApplicationOfRecord
SET IDENTITY_INSERT dbo.ApplicationOfRecord ON
INSERT INTO dbo.ApplicationOfRecord (ApplicationOfRecordId, ApplicationName, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (1, N'VBECS', '20110307 10:17:09.377', N'vhaishsmithm', 0)
INSERT INTO dbo.ApplicationOfRecord (ApplicationOfRecordId, ApplicationName, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (2, N'BCE_COTS', '20110307 10:17:09.410', N'vhaishsmithm', 0)
SET IDENTITY_INSERT dbo.ApplicationOfRecord OFF

-- Add 1 row to dbo.ExceptionType
INSERT INTO dbo.ExceptionType (ExceptionTypeId, ExceptionTypeName, BusinessRule, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (64, N'Electronic Transfusion Record Update', N'69.21', '20110311 09:06:49.697', N'vhaishsmithm', 0)

-- Add 1 row to dbo.Interface
SET IDENTITY_INSERT dbo.Interface ON
INSERT INTO dbo.Interface (InterfaceId, InterfaceName, FieldSeparator, EncodingCharacters, InterfaceApplicationId, VbecsApplicationId, VersionId, ApplicationAckType, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (4, N'BCE_COTS', N'^', N'~|\&', N'WBC', N'VBECS', N'2.5', N'AL', '20110310 13:18:46.000', N'vhaishsmithm', 0)
SET IDENTITY_INSERT dbo.Interface OFF

-- Add 1 row to dbo.InterfaceControl
INSERT INTO dbo.InterfaceControl (InterfaceControlId, InterfaceId, InterfaceFacilityId, InterfacePortNumber, InterfaceIPAddress, InterfaceDomainName, VbecsFacilityId, ProcessingId, VbecsPortNumber, VbecsIPAddress, AckTimeout, ReTransmitAttempts, InterfaceAdministratorName, PurgeSuccessfulMessage, PurgeUnSuccessfulMessage, LogEventsIndicator, InterfaceActiveIndicator, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (4, 4, NULL, NULL, NULL, NULL, NULL, N'P', NULL, NULL, 10, 5, N'Enter valid email address', 7, 7, 0, 0, '20110425 09:16:10.790', N'vhaishsmithm', 0)

-- Add 152 rows to dbo.PermittedProductModification
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'044dbf20-7b46-41f0-8706-8839a477ca59', N'T', 0, N'', N'E010', N'@40', N'E018', N'@06', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'075d440a-deba-4c23-bbd1-6f5c97733121', N'S', 0, N'', N'E063', N'Any', N'E063', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'08034bbc-2b6b-4243-a792-1a3fec0ca8dc', N'T', 0, N'', N'E010', N'@BQ', N'E018', N'@10', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0cf28f08-f654-49c1-bfb9-f46e1e04f8db', N'S', 1, N'', N'E055', N'Any', N'E055', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0cfaf35b-f2a3-490e-bc10-9b7b9c9dcfe5', N'T', 0, N'', N'E010', N'@A5', N'E018', N'@03', 120, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0d1e14dc-1e47-40c8-a98b-8a3df3ff03dd', N'T', 0, N'', N'E040', N'@37', N'E055', N'@13', 4, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0e92a612-560a-46b2-b26c-5085a535a861', N'T', 0, N'', N'E059', N'@A4', N'E056', N'@06', 4, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'0f958b37-99bf-45f0-a70b-ffe1b28b8a8a', N'S', 0, N'', N'E043', N'Any', N'E043', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'11563b68-6b7b-4dcf-b424-461a01417d2d', N'T', 0, N'', N'E017', N'@BS', N'E018', N'@13', 120, 0, '20110802 14:25:51.180', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'135f3e47-bd53-4919-afeb-544d3ffcb3b2', N'T', 0, N'', N'E010', N'@36', N'E018', N'@10', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'13bec97d-e589-4407-884c-747ecb25481d', N'T', 0, N'', N'E010', N'@BJ', N'E011', N'@13', 24, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'14436b13-4560-4521-ab4b-a53a9b021ec3', N'T', 0, N'', N'E028', N'@A2', N'E029', N'@06', 6, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1607ba57-5e17-4dac-9c42-12e65c9eab26', N'T', 0, N'', N'E040', N'@36', N'E055', N'@10', 4, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'18a97b55-b7dc-497b-824d-0eee5a6cddf8', N'T', 0, N'', N'E012', N'@84', N'E015', N'@AS', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1a42ee6c-ab82-427c-83b6-7aa2c2cfb036', N'S', 0, N'', N'E036', N'Any', N'E036', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1aa4420e-7ebb-4c33-afb0-4220a0cf5f47', N'T', 0, N'', N'E012', N'@AJ', N'E015', N'@54', 120, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1ab322f8-2b9f-4de6-81e5-c81bd5913d82', N'T', 0, N'', N'E010', N'@BJ', N'E018', N'@11', 120, 0, '20110802 13:16:56.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1cb51293-8c52-43c2-9499-8a7622d3f462', N'S', 1, N'', N'E022', N'Any', N'E022', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'1dc7554b-7af1-448c-8916-dc520990ca13', N'L', 0, N'D_', N'E055', N'Any', N'E055', N'Sam', 0, 0, '20100513 07:52:53.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'21ecfa0a-43e2-4e54-9e18-fa1bc973af28', N'L', 1, N'B2 D_', N'E055', N'Any', N'E055', N'Sam', 0, 0, '20100513 07:52:53.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'27aed5e1-05ed-401c-8359-9058565d61af', N'T', 0, N'', N'E028', N'@CV', N'E029', N'@87', 6, 0, '20110802 14:31:45.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'28b68d20-71b8-4808-9778-957b0cb357a1', N'T', 0, N'', N'E017', N'@CV', N'E018', N'@10', 120, 0, '20110802 14:25:51.180', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'28f9c92c-1ca2-4e7b-b093-c80e508387c8', N'S', 0, N'', N'E055', N'Any', N'E055', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'29051ad0-8d60-4dac-8c65-b4fd4dd450bf', N'T', 0, N'', N'E010', N'@CV', N'E011', N'@10', 24, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'29287542-b68c-4604-abbe-13a31d634153', N'T', 0, N'', N'E028', N'@AM', N'E029', N'@85', 6, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'299f4aa2-f8b0-4a44-a950-b39cefd3413e', N'S', 1, N'', N'E056', N'Any', N'E056', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2c3a29fc-8baf-4620-bfc1-6c1ba4ff1f00', N'S', 0, N'', N'E022', N'Any', N'E022', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2df2b12a-6a77-413f-9c93-be2f0bc29c72', N'T', 0, N'', N'E025', N'@CP', N'E026', N'@72', 4, 0, '20110802 14:31:45.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'2f5e45ae-d6d1-4574-8582-2f7aea86be59', N'T', 0, N'', N'E017', N'@CW', N'E018', N'@13', 120, 0, '20110802 14:25:51.180', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'31da62b4-94f6-47e0-bbde-da412ce44d7a', N'T', 0, N'', N'E030', N'@80', N'E031', N'@92', 4, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'36f0e7f6-b563-4fd4-a16f-93ab687a58a4', N'T', 0, N'', N'E028', N'@AK', N'E029', N'@83', 6, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'37d52727-cc83-47df-b7bb-20ed0976983f', N'T', 0, N'', N'E032', N'@80', N'E033', N'@83', 6, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'38603b07-225e-4b18-800b-dc03eea2ab8d', N'T', 0, N'', N'E012', N'@56', N'E015', N'@54', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3b5c3950-8133-4d73-820b-2390bb4bb378', N'T', 0, N'', N'E010', N'@42', N'E018', N'@13', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3dddbc5a-c6cb-4818-996d-a7ddd8d773ee', N'T', 0, N'', N'E017', N'@AN', N'E018', N'@04', 120, 0, '20110802 14:14:00.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3f036f93-f147-4d80-b391-3f8c266eb957', N'T', 0, N'', N'E010', N'@AU', N'E018', N'@06', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3f7497b7-b49b-45f7-ae3e-597d70c1bf08', N'S', 1, N'', N'E031', N'Any', N'E031', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'3fb3cdf5-2258-403f-af98-d1a3ce014cb8', N'T', 0, N'', N'E012', N'@CQ', N'E015', N'@55', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'406321f6-7e4e-4c33-ac7e-40f085f9a36d', N'L', 1, N'B2 D_', N'E062', N'Any', N'E062', N'Sam', 0, 0, '20100513 07:52:53.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'41395291-3c2f-4119-aa87-1f436ecf9766', N'T', 0, N'', N'E028', N'@A5', N'E029', N'@06', 6, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'420a0b32-d510-48b9-a18a-f9c0bd534600', N'T', 0, N'', N'E040', N'@35', N'E055', N'@06', 4, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'43a45c25-0b69-407f-b9f4-4d0bde36bd52', N'T', 0, N'', N'E060', N'@CP', N'E061', N'@77', 4, 0, '20110802 14:43:44.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'43e508e2-e8f9-459e-918b-5efefbcbbfef', N'T', 0, N'', N'E032', N'@78', N'E033', N'@83', 6, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'447b419d-6671-421e-af26-b444fa3e0eb7', N'T', 0, N'', N'E010', N'@B4', N'E018', N'@10', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'44af6aa7-f333-4807-97d4-6dc6354f1c01', N'T', 0, N'', N'E010', N'@BK', N'E018', N'@10', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'44f3e1e9-f526-48b8-ad21-a992c768c3d1', N'L', 1, N'B2 D_', N'E058', N'Any', N'E058', N'Sam', 0, 0, '20100513 07:52:53.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'45990bac-e021-41d3-a601-8b8b71f728cf', N'T', 0, N'', N'E040', N'@06', N'E055', N'@06', 4, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'45aaeaff-f7a5-44c2-a7bc-70e2d527d062', N'T', 0, N'', N'E028', N'@AN', N'E029', N'@06', 6, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'48a40349-4d2e-46f9-9078-14360c5936f4', N'S', 1, N'', N'E023', N'Any', N'E023', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4b6ce92f-52b2-4a4c-8151-a93763acd90b', N'S', 1, N'', N'E062', N'Any', N'E062', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4bc97a94-ca06-4d71-8d29-88182f8e0831', N'T', 0, N'', N'E017', N'@AM', N'E018', N'@04', 120, 0, '20110802 14:14:00.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4c1d866a-b712-4e5c-aebc-565fd36bc17a', N'I', 0, N'C2', N'E055', N'Any', N'E055', N'Sam', 0, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4c371309-f689-4e01-bb11-2dd8bada9252', N'T', 0, N'', N'E060', N'@CJ', N'E061', N'@72', 4, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4d3cfdc8-10b3-4b04-8da9-16daa74a6353', N'T', 0, N'', N'E012', N'@53', N'E015', N'@55', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4f00d11c-cc97-47d3-94d8-9c13a8180e4b', N'T', 0, N'', N'E010', N'@A4', N'E018', N'@06', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'4ff0c919-28ad-4b39-a50b-0c8556b7e7e2', N'T', 0, N'', N'E010', N'@AH', N'E018', N'@AS', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'513e0473-c1ac-40a3-ab26-97d53da20d56', N'T', 0, N'', N'E010', N'@37', N'E018', N'@13', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'51c7d76c-447e-490d-9659-a60db62462c1', N'S', 1, N'', N'E058', N'Any', N'E058', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'528217e9-afa0-4225-9eb3-7dafa8576d29', N'T', 0, N'', N'E017', N'@CZ', N'E018', N'@06', 120, 0, '20110802 14:25:51.180', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'54041c24-5e49-4b80-8e2b-c2d5cf57316c', N'T', 0, N'', N'E032', N'@AI', N'E033', N'@83', 6, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'54da5514-c9d1-45e4-bfa1-f749506699e0', N'S', 0, N'', N'E031', N'Any', N'E031', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'55e52c62-d09d-4b7a-bfea-69e343d7fabf', N'T', 0, N'', N'E010', N'@41', N'E018', N'@10', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'592093fd-df9a-4e6c-a7f5-a88a07eb8fa6', N'T', 0, N'', N'E040', N'@10', N'E055', N'@10', 4, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'59a7b1ae-c066-4b59-a7b0-c50d8e4b24c5', N'T', 0, N'', N'E028', N'@BJ', N'E029', N'@13', 6, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5b09370f-c4d7-4f8f-bb58-782d380d9f92', N'T', 0, N'', N'E066', N'@06', N'E067', N'@06', 4, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5ccdb0bd-a7ef-4a64-b574-de3a385da63a', N'T', 0, N'', N'E017', N'@CT', N'E018', N'@10', 120, 0, '20110802 14:25:51.180', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5d2c66e7-9442-423a-ace0-425953913124', N'T', 0, N'', N'E010', N'@39', N'E018', N'@10', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'5d90e036-7eaa-48e5-89a2-1b63a02e3b67', N'T', 0, N'', N'E017', N'@CE', N'E018', N'@06', 120, 0, '20110802 14:25:51.180', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'63b175e5-2530-43b8-9cec-4deb7dcbf880', N'T', 0, N'', N'E012', N'@47', N'E015', N'@54', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'64518fa5-1dbe-40c2-8a10-fd3b20c633a3', N'S', 1, N'', N'E063', N'Any', N'E063', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'66830031-40d4-417a-b630-44cb734be527', N'T', 0, N'', N'E028', N'@CZ', N'E029', N'@83', 6, 0, '20110802 14:41:18.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'68c677b1-84aa-45b1-a381-ac913300cbe7', N'T', 0, N'', N'E010', N'@CV', N'E018', N'@10', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'68ca92cc-1f96-4018-aeeb-1c29eb497a62', N'T', 0, N'', N'E028', N'@80', N'E029', N'@83', 6, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6b46fe2c-1fe8-4958-bcfc-0f50de95a491', N'T', 0, N'', N'E012', N'@AH', N'E015', N'@AS', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6cff9fb7-b4a5-45d9-a515-03786e1118ad', N'T', 0, N'', N'E010', N'@BO', N'E011', N'@10', 24, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6d43f6db-7eb1-4a83-9cb3-d2b1f41cddf5', N'T', 0, N'', N'E012', N'@CH', N'E015', N'@55', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6f45ef4c-c705-4e26-b310-79ec2bcdc2ec', N'T', 0, N'', N'E025', N'@CJ', N'E026', N'@77', 4, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'6f7ed199-7eed-4d0b-825e-d0015938e46a', N'S', 0, N'', N'E057', N'Any', N'E057', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'700db87f-dfda-4793-8098-6b37964006a0', N'T', 0, N'', N'E017', N'@A2', N'E018', N'@06', 120, 0, '20110802 14:25:51.180', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'777d5753-40fb-434d-a647-56d0973e89cb', N'T', 0, N'', N'E010', N'@A8', N'E011', N'@AS', 24, 0, '20100413 12:56:31.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7ae8fd79-f73c-41e0-a64e-8445c8263aed', N'T', 0, N'', N'E028', N'@A2', N'E029', N'@85', 6, 0, '20110802 14:31:45.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7bcabf07-84e6-4530-8130-2ca2b833164a', N'T', 0, N'', N'E010', N'@84', N'E018', N'@AS', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7ca36acb-7cc8-4904-8f1c-01a5c064a32a', N'T', 0, N'', N'E012', N'@48', N'E015', N'@55', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7d06859e-92d4-48ca-995c-b966f57127b4', N'T', 0, N'', N'E012', N'@51', N'E015', N'@54', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7d7bbe1f-b20f-4a25-9744-1e22904d77eb', N'T', 0, N'', N'E017', N'@CR', N'E018', N'@06', 120, 0, '20110802 14:25:51.180', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'7e7f131b-26d0-4500-bb44-342e6ca8735c', N'I', 0, N'C2', N'E062', N'Any', N'E062', N'Sam', 0, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'830227b6-8e50-482a-a03e-f74bbc97938f', N'T', 0, N'', N'E028', N'@BD', N'E029', N'@83', 6, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8345ff23-9bc1-4eb0-aacf-38e8582d14b7', N'L', 0, N'D_', N'E062', N'Any', N'E062', N'Sam', 0, 0, '20100513 07:52:53.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'83c369c8-1d05-48cf-9a19-f1981654eb4b', N'T', 0, N'', N'E028', N'@CV', N'E029', N'@10', 6, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8453af35-768d-432f-a4c9-1114dd1a1195', N'T', 0, N'', N'E010', N'@BO', N'E018', N'@10', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'856aa8d2-cf0e-45a8-92c0-431403dbae8b', N'T', 0, N'', N'E010', N'@BK', N'E018', N'@07', 120, 0, '20110802 13:16:56.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'85cae54e-86d8-40fc-96e0-775600c1dd06', N'T', 0, N'', N'E060', N'@CP', N'E061', N'@72', 4, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'897d7208-2b32-40bf-9379-50f0fa68e9c2', N'S', 0, N'', N'E062', N'Any', N'E062', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8df87b68-a63c-4fb2-a804-fe0bcd96e53e', N'T', 0, N'', N'E028', N'@A5', N'E029', N'@83', 6, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8ea1eb8d-ac4f-4b77-ae07-cb3cc6c3c3fd', N'T', 0, N'', N'E012', N'@58', N'E015', N'@55', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'8f5ee7a6-a1d4-44c7-a162-007fb5e2ea80', N'T', 0, N'', N'E010', N'@A4', N'E011', N'@06', 24, 0, '20100413 12:56:31.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'98d01083-0174-4b57-ba94-e443bf6d4e21', N'S', 0, N'', N'E056', N'Any', N'E056', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9b0de39d-f0d1-4e2d-ad4b-9e2dc655e1cb', N'L', 1, N'B2 D_', N'E061', N'Any', N'E061', N'Sam', 0, 0, '20100513 07:52:53.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9d1c4bcd-149b-4845-83c9-abde1266c62c', N'T', 0, N'', N'E040', N'@A2', N'E055', N'@06', 4, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9d380db7-c648-4bdb-b700-ed09a8d5efa3', N'T', 0, N'', N'E010', N'@BJ', N'E018', N'@13', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'9f21c89d-2f25-4d0f-8b18-6b0b8dfd56b5', N'T', 0, N'', N'E010', N'@35', N'E018', N'@06', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a1144e86-f171-44e2-a4f7-7017c5359795', N'T', 0, N'', N'E017', N'@48', N'E018', N'@55', 120, 0, '20110802 14:14:00.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a4540139-0333-4fe1-95ce-70d1ffd99056', N'T', 0, N'', N'E066', N'@BT', N'E067', N'@BT', 4, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'a699feb2-b262-405a-8be0-30f0ab1a2f51', N'T', 0, N'', N'E010', N'@30', N'E018', N'@AS', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'abe8d6e0-2bbe-4faf-9a92-7c68188cee1d', N'T', 0, N'', N'E017', N'@CS', N'E018', N'@13', 120, 0, '20110802 14:25:51.180', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b2f757c8-1bb1-4758-a50e-6f999c993231', N'T', 0, N'', N'E010', N'@AN', N'E018', N'@04', 120, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b3c183f6-4452-44c2-89e3-6ab714416433', N'T', 0, N'', N'E028', N'@A2', N'E029', N'@83', 6, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b67c8a04-4e64-4022-aebc-96cec91128df', N'I', 0, N'C2', N'E063', N'Any', N'E063', N'Sam', 0, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b6e3787d-088a-4e45-89e6-5d639b97b981', N'S', 0, N'', N'E058', N'Any', N'E058', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'b723a8dd-5875-46eb-9d3c-4abb7ed09ab0', N'T', 0, N'', N'E032', N'@CQ', N'E033', N'@83', 6, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ba5303ab-6a1b-4a19-b612-6aaeaeb2f79d', N'S', 1, N'', N'E061', N'Any', N'E061', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bb4dbd05-1c56-4a9d-89c0-f94b0a1a8035', N'T', 0, N'', N'E010', N'@BQ', N'E011', N'@10', 24, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'bcddd970-bdef-4b61-8dba-e26685d2c6b6', N'T', 0, N'', N'E010', N'@47', N'E018', N'@54', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c08b4e52-deed-4b59-aeb0-3a8e287a63a8', N'S', 1, N'', N'E043', N'Any', N'E043', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c0abfcc9-5344-464d-83f7-0641d0363d1e', N'L', 1, N'B2 D_', N'E063', N'Any', N'E063', N'Sam', 0, 0, '20100513 07:52:53.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c286418e-3e3e-4a8b-bf2c-687342ce46c0', N'I', 0, N'C2', N'E057', N'Any', N'E057', N'Sam', 0, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c45fc2a5-1d10-4877-894f-be99806f1223', N'T', 0, N'', N'E010', N'@48', N'E018', N'@06', 120, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c4cd4441-c8bf-4872-b2c2-a2de6b9973d9', N'T', 0, N'', N'E030', N'@80', N'E031', N'@83', 4, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c52fb4e2-95a1-480a-9523-d52889998a20', N'T', 0, N'', N'E010', N'@48', N'E011', N'@06', 24, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c7bb60fb-4cb1-453b-994b-85467a95adf5', N'T', 0, N'', N'E010', N'@A2', N'E018', N'@A2', 120, 0, '20110802 13:16:56.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c86590f1-18b7-45e9-8bae-a5916a0cfa0c', N'T', 0, N'', N'E010', N'@CZ', N'E018', N'@06', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'c9ac68a7-08ed-4957-8191-eb7abd68c007', N'T', 0, N'', N'E012', N'@37', N'E015', N'@13', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ca53bfe6-7be0-4cce-8143-c714262572b8', N'I', 0, N'C2', N'E058', N'Any', N'E058', N'Sam', 0, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'caa818e0-48f9-42ee-81a0-8f440f353d7f', N'T', 0, N'', N'E010', N'@AH', N'E011', N'@AS', 24, 0, '20100413 12:56:31.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'cc611299-28c0-417b-8af7-85f09baa3df4', N'L', 0, N'D_', N'E063', N'Any', N'E063', N'Sam', 0, 0, '20100513 07:52:53.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd0aa1965-92e8-4f7f-882b-4dd1d8a53850', N'I', 0, N'C2', N'E056', N'Any', N'E056', N'Sam', 0, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd372b50f-2649-40db-8685-930141a96957', N'S', 1, N'', N'E036', N'Any', N'E036', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd3c39ebe-d97e-4b6a-8b8c-30b43414c35e', N'T', 0, N'', N'E010', N'@BK', N'E011', N'@10', 24, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd3f1a911-1b1d-4fd1-a4a3-a259eb24251f', N'I', 0, N'C2', N'E061', N'Any', N'E061', N'Sam', 0, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd83fc61e-7f40-4bc1-8434-f9996a367f94', N'S', 0, N'', N'E061', N'Any', N'E061', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd8d1bfdd-18cc-4161-96a4-31cf04a518cc', N'T', 0, N'', N'E012', N'@AI', N'E015', N'@54', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'd8d81464-33ea-43b6-8314-eb3b429c70d2', N'S', 0, N'', N'E023', N'Any', N'E023', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'da484c4d-e825-4e16-a388-941415ea383b', N'T', 0, N'', N'E010', N'@A5', N'E018', N'@A2', 120, 0, '20110802 13:16:56.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'db5b116a-fc2e-47e8-815a-c2aefc492923', N'T', 0, N'', N'E028', N'@AN', N'E029', N'@83', 6, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dbad3df5-143c-47c3-86c6-2e78460c6e69', N'L', 0, N'D_', N'E061', N'Any', N'E061', N'Sam', 0, 0, '20100513 07:52:53.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'dc19fc0e-4c93-48f6-b5ff-ee9e4e9990c2', N'L', 0, N'D_', N'E056', N'Any', N'E056', N'Sam', 0, 0, '20100513 07:52:53.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'de138309-89d1-4eaa-975f-1aeef052339b', N'T', 0, N'', N'E010', N'@AM', N'E018', N'@A2', 120, 0, '20110802 13:16:56.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e12061d8-85f4-49f9-a102-303555fe70c4', N'T', 0, N'', N'E059', N'@A1', N'E056', N'@06', 4, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e46dab77-eff2-4178-a388-0dbf97f8a7bd', N'T', 0, N'', N'E010', N'@AM', N'E018', N'@03', 120, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e4894631-d6e5-40fe-96bf-7fea48a3108d', N'T', 0, N'', N'E028', N'@CV', N'E029', N'@83', 6, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e67b2fb7-c8a1-4db9-922d-3e9e1f87d6cc', N'T', 0, N'', N'E010', N'@CZ', N'E011', N'@06', 24, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e67cbf9d-8b83-487b-88ee-3926fe82572e', N'L', 0, N'D_', N'E058', N'Any', N'E058', N'Sam', 0, 0, '20100513 07:52:53.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e7527f8c-2f8a-4b78-88bc-4ec11f26c89e', N'T', 0, N'', N'E012', N'@30', N'E015', N'@AS', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'e90c202c-fdba-4d23-8a1c-3d5ed1b916f1', N'T', 0, N'', N'E028', N'@BJ', N'E029', N'@83', 6, 0, '20100512 12:00:40.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'eadc37c6-b9c4-48d1-bfeb-f95e6f6267a6', N'T', 0, N'', N'E010', N'@A8', N'E018', N'@AS', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'ec37a7ab-e3a1-4801-b231-467f5cd49ea6', N'T', 0, N'', N'E010', N'@38', N'E018', N'@10', 120, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f2464bf0-781e-467f-99d2-263c2021f950', N'T', 0, N'', N'E010', N'@A2', N'E018', N'@03', 120, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f2913722-3180-4dd7-a7fc-334515a081a4', N'T', 0, N'', N'E025', N'@CP', N'E026', N'@77', 4, 0, '20100510 12:57:57.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f2eb7be1-b338-4cee-b439-51bc1881c204', N'T', 0, N'', N'E017', N'@BJ', N'E018', N'@11', 120, 0, '20110802 14:14:00.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f3a51074-7d61-4572-a557-c7394a66f2c2', N'L', 1, N'B2 D_', N'E056', N'Any', N'E056', N'Sam', 0, 0, '20100513 07:52:53.000', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'f626074c-ffeb-4925-aad4-178ecafec165', N'T', 0, N'', N'E040', N'@AH', N'E055', N'@13', 4, 0, '20110519 09:11:00.790', N'vhaishsmithm', 0)
INSERT INTO dbo.PermittedProductModification (PermittedProductModificationGuid, ProductModificationCode, MethodSelect, AddTargetAttribute, FromProductTypeCode, FromCoreCondition, ToProductTypeCode, ToCoreCondition, ExpirationDateRule, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'fc985e69-b20b-4c4b-9bb7-bc6668f029ee', N'S', 1, N'', N'E057', N'Any', N'E057', N'Sam', 0, 0, '20101005 07:58:51.000', N'vhaishsmithm', 0)

-- Add 40 rows to dbo.ProductModificationAttribute
SET IDENTITY_INSERT dbo.ProductModificationAttribute ON
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (1, N'L', N'E$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (2, N'L', N'F$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (3, N'L', N'G$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (4, N'L', N'H$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (5, N'L', N'J$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (6, N'L', N'K$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (7, N'I', N'E$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (8, N'I', N'F$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (9, N'I', N'G$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (10, N'I', N'H$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (11, N'I', N'J$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (12, N'I', N'K$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (13, N'V', N'F$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (14, N'V', N'G$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (16, N'V', N'J$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (17, N'V', N'K$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (18, N'W', N'E$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (19, N'W', N'F$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (20, N'W', N'G$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (21, N'W', N'H$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (22, N'W', N'J$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (23, N'W', N'K$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (24, N'D', N'E$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (25, N'D', N'F$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (26, N'D', N'G$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (27, N'D', N'H$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (28, N'D', N'J$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (29, N'D', N'K$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (30, N'F', N'E$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (31, N'F', N'F$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (32, N'F', N'G$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (33, N'F', N'H$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (34, N'F', N'J$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (35, N'F', N'K$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (36, N'R', N'E$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (37, N'R', N'F$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (38, N'R', N'G$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (39, N'R', N'H$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (40, N'R', N'J$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
INSERT INTO dbo.ProductModificationAttribute (ProductModificationAttributeId, ProductModificationCode, OptionalAttribute, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (41, N'R', N'K$', '20100908 15:24:08.213', N'vhaishsmithm', 0)
SET IDENTITY_INSERT dbo.ProductModificationAttribute OFF

-- Add 4 rows to dbo.TransfusionReactionType
INSERT INTO dbo.TransfusionReactionType (TransfusionReactionTypeCode, TransfusionReactionTypeText, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'J', N'Acute Hemolysis (non ABO)', 2, '20110526 15:23:32.000', N'vhaishsmithm', 0)
INSERT INTO dbo.TransfusionReactionType (TransfusionReactionTypeCode, TransfusionReactionTypeText, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'Q', N'Citrate Toxicity', 4, '20110526 15:23:32.000', N'vhaishsmithm', 0)
INSERT INTO dbo.TransfusionReactionType (TransfusionReactionTypeCode, TransfusionReactionTypeText, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'R', N'Unrelated to Transfusion', 12, '20110526 15:23:32.000', N'vhaishsmithm', 0)
INSERT INTO dbo.TransfusionReactionType (TransfusionReactionTypeCode, TransfusionReactionTypeText, SortColumn, LastUpdateDate, LastUpdateUser, LastUpdateFunctionId) VALUES (N'Z', N'Transfusion Related Microbial Infection', 11, '20110526 15:23:32.000', N'vhaishsmithm', 0)


USE msdb
GO

/**********************************************************************************************
**        Update the trigger tr_EmailIntegrityJobOutput.
**********************************************************************************************/

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tr_EmailIntegrityJobOutput]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[tr_EmailIntegrityJobOutput]
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO
/****************************************************************************************************************************************
**        Desc:        Adding a trigger(tr_EmailIntegrityJobOutput)to the sysjobhistory that will 
**                send a mail when a Database weekly Integrity 
**                check succeeds. (CR 2569)
**
**        Author: Kwame Adu-Poku
**
**        Date: 03/10/09
*****************************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        --------        ------------        -------------------------------------------------------
**        01/10/10        Mike Smith        Changed to check the DatabaseIntegrityReport.log for errors
**                                                        before sending email alerts (CR 2808).
**        06/01/11        K. Adu-Poku        Changed to retrieve the email recipients address from the InterfaceControl
**                                                        where InterfaceId =1 (CR 2732).
**        01/04/12        K. Adu-Poku        Changed @subject value from "Job Succeeded" to "Immediate Attention required! 
**                                                        Database Integrity errors reported". In the @emailbody SELECT statement changed
**                                                        E-mail to Attention,revised the message, changed the Action message and deleted the where clause(CR 3178). 
******************************************************************************************************************************************/

CREATE   TRIGGER [dbo].[tr_EmailIntegrityJobOutput]

ON [dbo].[sysjobhistory]

FOR INSERT

AS 

DECLARE @OutputFileName        VARCHAR(150)
DECLARE @emailbody         VARCHAR(4000)
DECLARE @attachment         VARCHAR(4000)
DECLARE @runstatus         INT
DECLARE @ErrorLine        VARCHAR(150)

IF EXISTS (SELECT * FROM inserted JOIN dbo.sysjobs ON inserted.job_id = dbo.sysjobs.job_id where inserted.step_name like '%DailyIntegrityCheck')

BEGIN

        SET @OutputFileName = (SELECT SJS.output_file_name FROM inserted SJH
                                         JOIN dbo.sysjobsteps SJS ON SJH.job_id = SJS.job_id AND SJH.step_id = SJS.step_id)

        CREATE TABLE  #TempXML 
        (LineText        VARCHAR(255),
         Junk        INT)

        INSERT INTO #TempXML (LineText, Junk)
        EXEC sp_readerrorlog 1, @OutputFileName
            
        SELECT @ErrorLine = LineText 
          FROM #TempXML
         WHERE LineText LIKE 'CHECKDB found %' -- 0 allocation errors and 0 consistency errors in database 'VBECS_V1_PROD'. [SQLSTATE 01000]%'

        IF LEFT(@ErrorLine, 70) <> 'CHECKDB found 0 allocation errors and 0 consistency errors in database'
        BEGIN

                SELECT @runstatus = run_status, @emailbody = 
                
                        CONVERT(CHAR(15),'Attention:') + CHAR(9)+ '*** VBECS database integrity check detected errors that needs to be fixed immediately. ***' + CHAR(10) +
                
                        CONVERT(CHAR(15),'Server:') + CHAR(9)+ ISNULL(@@servername, '') + CHAR(10) +
        
                        CONVERT(CHAR(15),'Job:') + CHAR(9)+ ISNULL(CONVERT(VARCHAR(50), dbo.sysjobs.name), '') + CHAR(10) +
        
                        CONVERT(CHAR(15),'Step:') + CHAR(9)+ ISNULL(CONVERT(VARCHAR(50), inserted.step_name), '') + CHAR(10) +
        
                        CONVERT(CHAR(15),'Message:') + CHAR(9)+ ISNULL(CONVERT(VARCHAR(150), @ErrorLine), '') + CHAR(10) + CHAR(13)+ CHAR(13)+
                        
                        CONVERT(CHAR(15),'Action:') + CHAR(9)+ 'Contact the National Service Desk 1-888-596-HELP(4357) or file a Remedy Ticket.' + CHAR(10) +
        
                        CONVERT(CHAR(15),'Attachment:') + CHAR(9)+ ISNULL(CONVERT(VARCHAR(150), dbo.sysjobsteps.output_file_name),''),
        
                        @attachment = dbo.sysjobsteps.output_file_name 
                        
                FROM inserted 
        
                JOIN dbo.sysjobs
                        ON inserted.job_id = dbo.sysjobs.job_id
        
                JOIN dbo.sysjobsteps
                        ON inserted.job_id = dbo.sysjobsteps.job_id
                        AND inserted.step_id = dbo.sysjobsteps.step_id
                
                
                DECLARE @emailto varchar(1000)
                DECLARE @emailfrom varchar(1000)
                DECLARE @subject varchar(100)
                
                SET @subject = 'Immediate Attention required! VBECS Database integrity errors detected!'
                SET @emailfrom = (select '"No Replies" ' + ISNULL(@@servername, '') + '@' +'va.gov')
                     SET @emailto = (Select InterfaceAdministratorName from VBECS_V1_PROD.dbo.InterfaceControl where InterfaceId=1)
                
                EXEC master.dbo.spSendVBECSJobMail @emailfrom, @emailto, @subject, @emailbody, @attachment
        END

        DROP TABLE #TempXML
END



GO

/**********************************************************************************************
**        Update the trigger tr_EmailBackgroundJobsFailures.
**********************************************************************************************/

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tr_EmailBackgroundJobsFailures]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[tr_EmailBackgroundJobsFailures]
GO

SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS OFF
GO
/********************************************************************************************************************************
**        Desc:         Adding a trigger (tr_EmailBackgroundJobsFailures) to the sysjobhistory that
**                will send a mail when any of the VBECS Background jobs fails.(CR 2569)
**
**        Author: Kwame Adu-Poku
**
**        Date:         03/10/09
*********************************************************************************************************************************
**        Modified:
**        Date                Name                Description
**        06/01/11        K. Adu-Poku        Changed to retrieve the email recipients address from the InterfaceControl
**                                                        where InterfaceId =1 (CR 2732).
**        01/04/12        K. Adu-Poku        In the @emailbody SELECT statement changed E-mail to Attention, revised the message and 
**                                                        changed the Action message (CR 3178). 
*********************************************************************************************************************************/
CREATE  TRIGGER [dbo].[tr_EmailBackgroundJobsFailures]

ON [dbo].[sysjobhistory]

FOR INSERT

AS 

DECLARE @emailbody varchar(4000)
DECLARE @attachment varchar(4000)

IF EXISTS (SELECT * FROM inserted WHERE run_status IN (0,3) AND step_name <> '(job outcome)')
BEGIN

        SELECT @emailbody = 

                CONVERT(CHAR(15),'Attention:') + CHAR(9)+ '*** VBECS database job failure, the failure needs to be investigated and fixed immediately. ***' + CHAR(10) +

                CONVERT(char(15),'Server:') + CHAR(9)+ ISNULL(@@servername, '') + char(10) +

                CONVERT(char(15),'Job:') + CHAR(9)+ ISNULL(CONVERT(VARCHAR(50), dbo.sysjobs.name), '') + char(10) +

                CONVERT(char(15),'Step:') + CHAR(9)+ ISNULL(CONVERT(VARCHAR(50), inserted.step_name), '')+ char(10) +

                CONVERT(char(15),'Message:') + CHAR(9)+ ISNULL(CONVERT(VARCHAR(150), inserted.message), '')+ char(10) + CHAR(13)+ CHAR(13)+
                
                CONVERT(char(15),'Action:') + CHAR(9)+ 'Contact the National Service Desk 1-888-596-HELP(4357) or file a Remedy Ticket.' + char(10) +

                CONVERT(char(15),'Attachment:') + CHAR(9)+ ISNULL(CONVERT(VARCHAR(150), dbo.sysjobsteps.output_file_name),''),

                @attachment = dbo.sysjobsteps.output_file_name

        FROM inserted 

        JOIN dbo.sysjobs
                ON inserted.job_id = dbo.sysjobs.job_id
        JOIN dbo.sysjobsteps
                ON inserted.job_id = dbo.sysjobsteps.job_id
                AND inserted.step_id = dbo.sysjobsteps.step_id

        WHERE inserted.run_status IN (0,3)



        DECLARE @emailto varchar(1000)
        DECLARE @emailfrom varchar(1000)
        DECLARE @subject varchar(100)

        SET @subject = 'VBECS Database Job Failed'
        SET @emailfrom = (Select '"No Replies" ' + ISNULL(@@servername, '') + '@' +'va.gov')
        SET @emailto = (Select InterfaceAdministratorName from VBECS_V1_PROD.dbo.InterfaceControl where InterfaceId=1)

        EXEC master.dbo.spSendVBECSJobMail @emailfrom, @emailto, @subject, @emailbody, @attachment

END

GO


/**********************************************************************************************
**        Delete the weekly integrity check jobs.
**********************************************************************************************/
BEGIN TRANSACTION

DECLARE @JobID BINARY(16)  

-- Delete the master_WeeklyIntegrityCheck job (if it exists)
SELECT @JobID = job_id     
FROM   msdb.dbo.sysjobs    
WHERE (name = N'master_WeeklyIntegrityCheck')
       
IF (@JobID IS NOT NULL)    
BEGIN  
        -- Check if the job is a multi-server job  
        IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
        BEGIN 
                -- There is, so abort the script 
                RAISERROR (N'Unable to import job ''master_WeeklyIntegrityCheck'' since there is already a multi-server job with this name.', 16, 1) 
                GOTO QuitWithRollback  
        END 
        ELSE 
                -- Delete the [local] job 
                EXECUTE msdb.dbo.sp_delete_job @job_name = N'master_WeeklyIntegrityCheck' 
        SET @JobID = NULL
END 
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 

GO

BEGIN TRANSACTION

DECLARE @JobID BINARY(16) 

-- Delete the msdb_WeeklyIntegrityCheck job (if it exists)
SELECT @JobID = job_id     
FROM   msdb.dbo.sysjobs    
WHERE (name = N'msdb_WeeklyIntegrityCheck') 
      
IF (@JobID IS NOT NULL)    
BEGIN  
        -- Check if the job is a multi-server job  
        IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
        BEGIN 
                -- There is, so abort the script 
                RAISERROR (N'Unable to import job ''msdb_WeeklyIntegrityCheck'' since there is already a multi-server job with this name.', 16, 1) 
                GOTO QuitWithRollback  
        END 
        ELSE 
                -- Delete the [local] job 
                EXECUTE msdb.dbo.sp_delete_job @job_name = N'msdb_WeeklyIntegrityCheck' 
        SET @JobID = NULL
END 
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 

GO

BEGIN TRANSACTION

DECLARE @JobID BINARY(16) 

-- Delete the VBECS_V1_PROD_WeeklyIntegrityCheck job (if it exists)
SELECT @JobID = job_id     
FROM   msdb.dbo.sysjobs    
WHERE (name = N'VBECS_V1_PROD_WeeklyIntegrityCheck') 
      
IF (@JobID IS NOT NULL)    
BEGIN  
        -- Check if the job is a multi-server job  
        IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
        BEGIN 
                -- There is, so abort the script 
                RAISERROR (N'Unable to import job ''VBECS_V1_PROD_WeeklyIntegrityCheck'' since there is already a multi-server job with this name.', 16, 1) 
                GOTO QuitWithRollback  
        END 
        ELSE 
                -- Delete the [local] job 
                EXECUTE msdb.dbo.sp_delete_job @job_name = N'VBECS_V1_PROD_WeeklyIntegrityCheck' 
        SET @JobID = NULL
END 
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 

GO

BEGIN TRANSACTION

DECLARE @JobID BINARY(16) 

-- Delete the VBECS_V1_PROD_MIRROR_WeeklyIntegrityCheck job (if it exists)
SELECT @JobID = job_id     
FROM   msdb.dbo.sysjobs    
WHERE (name = N'VBECS_V1_PROD_MIRROR_WeeklyIntegrityCheck') 
      
IF (@JobID IS NOT NULL)    
BEGIN  
        -- Check if the job is a multi-server job  
        IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
        BEGIN 
                -- There is, so abort the script 
                RAISERROR (N'Unable to import job ''VBECS_V1_PROD_MIRROR_WeeklyIntegrityCheck'' since there is already a multi-server job with this name.', 16, 1) 
                GOTO QuitWithRollback  
        END 
        ELSE 
                -- Delete the [local] job 
                EXECUTE msdb.dbo.sp_delete_job @job_name = N'VBECS_V1_PROD_MIRROR_WeeklyIntegrityCheck' 
        SET @JobID = NULL
END 
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 

GO

/**********************************************************************************************
**        Add the new daily integrity check jobs.
**********************************************************************************************/
BEGIN TRANSACTION  
         
  DECLARE @JobID BINARY(16)  
  DECLARE @ReturnCode INT    
  SELECT @ReturnCode = 0     
IF (SELECT COUNT(*) FROM msdb.dbo.syscategories WHERE name = N'[Uncategorized (Local)]') < 1 
        EXECUTE msdb.dbo.sp_add_category @name = N'[Uncategorized (Local)]'

-- Delete the master_DailyIntegrityCheck job (if it exists)
SELECT @JobID = job_id     
FROM   msdb.dbo.sysjobs    
WHERE (name = N'master_DailyIntegrityCheck')
       
IF (@JobID IS NOT NULL)    
BEGIN  
        -- Check if the job is a multi-server job  
        IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
        BEGIN 
                -- There is, so abort the script 
                RAISERROR (N'Unable to import job ''master_DailyIntegrityCheck'' since there is already a multi-server job with this name.', 16, 1) 
                GOTO QuitWithRollback  
        END 
        ELSE 
                -- Delete the [local] job 
                EXECUTE msdb.dbo.sp_delete_job @job_name = N'master_DailyIntegrityCheck' 
        SET @JobID = NULL
END 

BEGIN 

  -- Add the job
  EXECUTE @ReturnCode = msdb.dbo.sp_add_job @job_id = @JobID OUTPUT , @job_name = N'master_DailyIntegrityCheck', @owner_login_name = N'sa', @description = N'Checks integrity of database - resource intensive operation!', @category_name = N'[Uncategorized (Local)]', @enabled = 1, @notify_level_email = 0, @notify_level_page = 0, @notify_level_netsend = 0, @notify_level_eventlog = 2, @delete_level= 0
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job steps
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobstep @job_id = @JobID, @step_id = 1, @step_name = N'Run master_DailyIntegrityCheck', @command = N'DBCC CHECKDB(''master'', NOINDEX)  ', @database_name = N'master', @server = N'', @database_user_name = N'', @subsystem = N'TSQL', @cmdexec_success_code = 0, @flags = 0, @retry_attempts = 0, @retry_interval = 1, @output_file_name = N'd:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\master\DatabaseIntegrityReport.log', @on_success_step_id = 0, @on_success_action = 1, @on_fail_step_id = 0, @on_fail_action = 2
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
  EXECUTE @ReturnCode = msdb.dbo.sp_update_job @job_id = @JobID, @start_step_id = 1 

  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job schedules
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id = @JobID, @name = N'master_DailyIntegrityCheck Schedule', @enabled = 1, @freq_type = 4, @active_start_date = 20101215, @active_start_time = 1150, @freq_interval = 1, @freq_subday_type = 1, @freq_subday_interval = 0, @freq_relative_interval = 0, @freq_recurrence_factor = 0, @active_end_date = 99991231, @active_end_time = 235959
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the Target Servers
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @JobID, @server_name = N'(local)' 
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

END
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 

GO

BEGIN TRANSACTION
          
  DECLARE @JobID BINARY(16)  
  DECLARE @ReturnCode INT    
  SELECT @ReturnCode = 0     
IF (SELECT COUNT(*) FROM msdb.dbo.syscategories WHERE name = N'[Uncategorized (Local)]') < 1 
        EXECUTE msdb.dbo.sp_add_category @name = N'[Uncategorized (Local)]'

-- Delete the msdb_DailyIntegrityCheck job (if it exists) 
SELECT @JobID = job_id     
FROM   msdb.dbo.sysjobs    
WHERE (name = N'msdb_DailyIntegrityCheck')  
     
IF (@JobID IS NOT NULL)    
BEGIN  
        -- Check if the job is a multi-server job  
        IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
        BEGIN 
                -- There is, so abort the script 
                RAISERROR (N'Unable to import job ''msdb_DailyIntegrityCheck'' since there is already a multi-server job with this name.', 16, 1) 
                GOTO QuitWithRollback  
        END 
        ELSE 
                -- Delete the [local] job 
                EXECUTE msdb.dbo.sp_delete_job @job_name = N'msdb_DailyIntegrityCheck' 
        SET @JobID = NULL
END 

BEGIN 

  -- Add the job
  EXECUTE @ReturnCode = msdb.dbo.sp_add_job @job_id = @JobID OUTPUT , @job_name = N'msdb_DailyIntegrityCheck', @owner_login_name = N'sa', @description = N'Checks integrity of database - resource intensive operation!', @category_name = N'[Uncategorized (Local)]', @enabled = 1, @notify_level_email = 0, @notify_level_page = 0, @notify_level_netsend = 0, @notify_level_eventlog = 2, @delete_level= 0
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job steps
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobstep @job_id = @JobID, @step_id = 1, @step_name = N'Run msdb_DailyIntegrityCheck', @command = N'DBCC CHECKDB(''msdb'', NOINDEX)  ', @database_name = N'msdb', @server = N'', @database_user_name = N'', @subsystem = N'TSQL', @cmdexec_success_code = 0, @flags = 0, @retry_attempts = 0, @retry_interval = 1, @output_file_name = N'd:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\msdb\DatabaseIntegrityReport.log', @on_success_step_id = 0, @on_success_action = 1, @on_fail_step_id = 0, @on_fail_action = 2
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
  EXECUTE @ReturnCode = msdb.dbo.sp_update_job @job_id = @JobID, @start_step_id = 1 

  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job schedules
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id = @JobID, @name = N'msdb_DailyIntegrityCheck Schedule', @enabled = 1, @freq_type = 4, @active_start_date = 20101215, @active_start_time = 1150, @freq_interval = 1, @freq_subday_type = 1, @freq_subday_interval = 0, @freq_relative_interval = 0, @freq_recurrence_factor = 0, @active_end_date = 99991231, @active_end_time = 235959
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the Target Servers
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @JobID, @server_name = N'(local)' 
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

END
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 

GO

BEGIN TRANSACTION  
           
  DECLARE @JobID BINARY(16)  
  DECLARE @ReturnCode INT    
  SELECT @ReturnCode = 0     
IF (SELECT COUNT(*) FROM msdb.dbo.syscategories WHERE name = N'[Uncategorized (Local)]') < 1 
        EXECUTE msdb.dbo.sp_add_category @name = N'[Uncategorized (Local)]'

-- Delete the VBECS_V1_PROD_DailyIntegrityCheck job (if it exists) 
SELECT @JobID = job_id     
FROM   msdb.dbo.sysjobs    
WHERE (name = N'VBECS_V1_PROD_DailyIntegrityCheck') 
      
IF (@JobID IS NOT NULL)    
BEGIN  
        -- Check if the job is a multi-server job  
        IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
        BEGIN 
                -- There is, so abort the script 
                RAISERROR (N'Unable to import job ''VBECS_V1_PROD_DailyIntegrityCheck'' since there is already a multi-server job with this name.', 16, 1) 
                GOTO QuitWithRollback  
        END 
        ELSE 
                -- Delete the [local] job 
                EXECUTE msdb.dbo.sp_delete_job @job_name = N'VBECS_V1_PROD_DailyIntegrityCheck' 
        SET @JobID = NULL
END 

BEGIN 

  -- Add the job
  EXECUTE @ReturnCode = msdb.dbo.sp_add_job @job_id = @JobID OUTPUT , @job_name = N'VBECS_V1_PROD_DailyIntegrityCheck', @owner_login_name = N'sa', @description = N'Checks integrity of database - resource intensive operation!', @category_name = N'[Uncategorized (Local)]', @enabled = 1, @notify_level_email = 0, @notify_level_page = 0, @notify_level_netsend = 0, @notify_level_eventlog = 2, @delete_level= 0
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job steps
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobstep @job_id = @JobID, @step_id = 1, @step_name = N'Run VBECS_V1_PROD_DailyIntegrityCheck', @command = N'DBCC CHECKDB(''VBECS_V1_PROD'', NOINDEX)  ', @database_name = N'VBECS_V1_PROD', @server = N'', @database_user_name = N'', @subsystem = N'TSQL', @cmdexec_success_code = 0, @flags = 0, @retry_attempts = 0, @retry_interval = 1, @output_file_name = N'd:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\VBECS_V1_PROD\DatabaseIntegrityReport.log', @on_success_step_id = 0, @on_success_action = 1, @on_fail_step_id = 0, @on_fail_action = 2
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
  EXECUTE @ReturnCode = msdb.dbo.sp_update_job @job_id = @JobID, @start_step_id = 1 

  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job schedules
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id = @JobID, @name = N'VBECS_V1_PROD_DailyIntegrityCheck Schedule', @enabled = 1, @freq_type = 4, @active_start_date = 20101215, @active_start_time = 1150, @freq_interval = 1, @freq_subday_type = 1, @freq_subday_interval = 0, @freq_relative_interval = 0, @freq_recurrence_factor = 0, @active_end_date = 99991231, @active_end_time = 235959
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the Target Servers
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @JobID, @server_name = N'(local)' 
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

END
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 

GO

BEGIN TRANSACTION            
  DECLARE @JobID BINARY(16)  
  DECLARE @ReturnCode INT    
  SELECT @ReturnCode = 0     
IF (SELECT COUNT(*) FROM msdb.dbo.syscategories WHERE name = N'[Uncategorized (Local)]') < 1 
        EXECUTE msdb.dbo.sp_add_category @name = N'[Uncategorized (Local)]'

-- Delete the VBECS_V1_PROD_MIRROR_DailyIntegrityCheck job (if it exists)
SELECT @JobID = job_id     
FROM   msdb.dbo.sysjobs    
WHERE (name = N'VBECS_V1_PROD_MIRROR_DailyIntegrityCheck') 
      
IF (@JobID IS NOT NULL)    
BEGIN  
        -- Check if the job is a multi-server job  
        IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
        BEGIN 
                -- There is, so abort the script 
                RAISERROR (N'Unable to import job ''VBECS_V1_PROD_MIRROR_DailyIntegrityCheck'' since there is already a multi-server job with this name.', 16, 1) 
                GOTO QuitWithRollback  
        END 
        ELSE 
                -- Delete the [local] job 
                EXECUTE msdb.dbo.sp_delete_job @job_name = N'VBECS_V1_PROD_MIRROR_DailyIntegrityCheck' 
        SET @JobID = NULL
END 

BEGIN 

  -- Add the job
  EXECUTE @ReturnCode = msdb.dbo.sp_add_job @job_id = @JobID OUTPUT , @job_name = N'VBECS_V1_PROD_MIRROR_DailyIntegrityCheck', @owner_login_name = N'sa', @description = N'Checks integrity of database - resource intensive operation!', @category_name = N'[Uncategorized (Local)]', @enabled = 1, @notify_level_email = 0, @notify_level_page = 0, @notify_level_netsend = 0, @notify_level_eventlog = 2, @delete_level= 0
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job steps
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobstep @job_id = @JobID, @step_id = 1, @step_name = N'Run VBECS_V1_PROD_MIRROR_DailyIntegrityCheck', @command = N'DBCC CHECKDB(''VBECS_V1_PROD_MIRROR'', NOINDEX)  ', @database_name = N'VBECS_V1_PROD_MIRROR', @server = N'', @database_user_name = N'', @subsystem = N'TSQL', @cmdexec_success_code = 0, @flags = 0, @retry_attempts = 0, @retry_interval = 1, @output_file_name = N'd:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\VBECS_V1_PROD_MIRROR\DatabaseIntegrityReport.log', @on_success_step_id = 0, @on_success_action = 1, @on_fail_step_id = 0, @on_fail_action = 2
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
  EXECUTE @ReturnCode = msdb.dbo.sp_update_job @job_id = @JobID, @start_step_id = 1 

  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job schedules
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id = @JobID, @name = N'VBECS_V1_PROD_MIRROR_DailyIntegrityCheck Schedule', @enabled = 1, @freq_type = 4, @active_start_date = 20101215, @active_start_time = 1150, @freq_interval = 1, @freq_subday_type = 1, @freq_subday_interval = 0, @freq_relative_interval = 0, @freq_recurrence_factor = 0, @active_end_date = 99991231, @active_end_time = 235959
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the Target Servers
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @JobID, @server_name = N'(local)' 
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

END
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 

GO

BEGIN TRANSACTION
           
  DECLARE @JobID BINARY(16)  
  DECLARE @ReturnCode INT    
  SET @ReturnCode = 0
   
IF (SELECT COUNT(*) FROM msdb.dbo.syscategories WHERE name = N'[Uncategorized (Local)]') < 1 
  EXECUTE msdb.dbo.sp_add_category @name = N'[Uncategorized (Local)]'

-- Delete the Copy VBECS DB Backups to L Drive job (if it exists)
SELECT @JobID = job_id     
FROM   msdb.dbo.sysjobs    
WHERE (name = N'Copy VBECS DB Backups to L Drive')   

IF (@JobID IS NOT NULL)    
BEGIN  
        -- Check if the job is a multi-server job  
        IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
        BEGIN 
                -- There is, so abort the script 
                RAISERROR (N'Unable to import job ''Copy VBECS DB Backups to L Drive'' since there is already a multi-server job with this name.', 16, 1) 
                GOTO QuitWithRollback  
        END 
        ELSE 
                -- Delete the [local] job 
                EXECUTE msdb.dbo.sp_delete_job @job_name = N'Copy VBECS DB Backups to L Drive' 
        SET @JobID = NULL
END 

BEGIN 

  -- Add the job
  EXECUTE @ReturnCode = msdb.dbo.sp_add_job @job_id = @JobID OUTPUT , @job_name = N'Copy VBECS DB Backups to L Drive', @owner_login_name = N'sa', @description = N'Copy VBECS DB Backups and integrity logs from D Drive to the L Drive and renames the files to include date time.', @category_name = N'[Uncategorized (Local)]', @enabled = 1, @notify_level_email = 0, @notify_level_page = 0, @notify_level_netsend = 0, @notify_level_eventlog = 2, @delete_level= 0
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job steps
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobstep @job_id = @JobID, @step_id = 1, @step_name = N'Copy Backups to L Drive', @command = N'DECLARE @FileType        BIT,
        @DatabaseName        VARCHAR(100),
        @FileName        VARCHAR(250),
        @SQL                VARCHAR(2000),
        @CurrentDate        VARCHAR(8),
        @LDrive                VARCHAR(155),
        @DestError        VARCHAR(155)

SET @DestError = ''''
SET @CurrentDate = CAST(DATEPART(YEAR,GETDATE()) AS VARCHAR(4)) + RIGHT(''0'' + CAST(DATEPART(MONTH,GETDATE()) AS VARCHAR(2)), 2) +  RIGHT(''0'' + CAST(DATEPART(DAY,GETDATE()) AS VARCHAR(2)),2)
SET @LDrive = ''L:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\''


CREATE TABLE #FolderExists 
        (IsFile SMALLINT,  IsDir SMALLINT,  HasParentDir SMALLINT)

INSERT INTO #FolderExists
EXEC master.dbo.xp_fileexist @LDrive

IF NOT EXISTS (SELECT * FROM #FolderExists WHERE IsDir = 1)
BEGIN
        SET @DestError = ''Destination Folder does not exist, No Backup files were copied ''
        GOTO CopyError        
END

DROP TABLE #FolderExists

DECLARE CopyCursor CURSOR FAST_FORWARD
FOR           SELECT 1 AS FileType, database_name, physical_device_name
          FROM msdb.dbo.backupfile BF
                JOIN msdb.dbo.backupset BS
                        ON BF.backup_set_id = BS.backup_set_id
                JOIN msdb.dbo.backupmediafamily BMF
                        ON BS.media_set_id = BMF.media_set_id
         WHERE file_type = ''D''
           AND LEFT(physical_device_name, 1) = ''D''
           AND backup_finish_date > CONVERT(VARCHAR(8), GETDATE(), 112)
        UNION
        SELECT 0, database_name, output_file_name
          FROM msdb.dbo.sysjobhistory JH
                JOIN msdb.dbo.sysjobsteps JS
                        ON JH.job_id = JS.job_id
         WHERE JH.step_name like ''%DailyIntegrityCheck''
           AND run_status = 1
           AND run_date  > CONVERT(VARCHAR(8), DATEADD(DAY, -1, GETDATE()), 112)

OPEN CopyCursor
FETCH NEXT FROM CopyCursor into @FileType, @DatabaseName, @FileName
WHILE (@@fetch_status = 0)
BEGIN
        IF @FileType = 1
        BEGIN
                SET @SQL = ''COPY "'' + @FileName + ''" "'' + @LDrive + @DatabaseName + ''\'' + @DatabaseName + ''_'' + @CurrentDate + ''.BAK"''
        END
        ELSE
        BEGIN
                SET @SQL = ''COPY "'' + @FileName + ''" "'' + @LDrive + @DatabaseName + ''\DatabaseIntegrityReport_'' + @CurrentDate + ''.log"''
        END

        EXEC master.dbo.xp_cmdshell @SQL

        FETCH NEXT FROM CopyCursor INTO @FileType, @DatabaseName, @FileName
END
CLOSE CopyCursor
DEALLOCATE CopyCursor

CopyError:
         IF @DestError <> ''''
        BEGIN
                RAISERROR (@DestError, 16, 1)
        END', @database_name = N'master', @server = N'', @database_user_name = N'', @subsystem = N'TSQL', @cmdexec_success_code = 0, @flags = 0, @retry_attempts = 0, @retry_interval = 1, @output_file_name = N'', @on_success_step_id = 0, @on_success_action = 1, @on_fail_step_id = 0, @on_fail_action = 2
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
  EXECUTE @ReturnCode = msdb.dbo.sp_update_job @job_id = @JobID, @start_step_id = 1 

  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job schedules
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id = @JobID, @name = N'Copy Backup Schedule', @enabled = 1, @freq_type = 4, @active_start_date = 20090205, @active_start_time = 24000, @freq_interval = 1, @freq_subday_type = 1, @freq_subday_interval = 0, @freq_relative_interval = 0, @freq_recurrence_factor = 0, @active_end_date = 99991231, @active_end_time = 235959
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the Target Servers
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @JobID, @server_name = N'(local)' 
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

END
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 

GO

BEGIN TRANSACTION            
  DECLARE @JobID BINARY(16)  
  DECLARE @ReturnCode INT    
  SET @ReturnCode = 0
    
IF (SELECT COUNT(*) FROM msdb.dbo.syscategories WHERE name = N'[Uncategorized (Local)]') < 1 
        EXECUTE msdb.dbo.sp_add_category @name = N'[Uncategorized (Local)]'

-- Delete the Copy VBECS DB Backups to L Drive job (if it exists)
SELECT @JobID = job_id     
FROM   msdb.dbo.sysjobs    
WHERE (name = N'L Drive Delete old Backup files')
      
IF (@JobID IS NOT NULL)    
        BEGIN  
        -- Check if the job is a multi-server job  
        IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
        BEGIN 
                -- There is, so abort the script 
                RAISERROR (N'Unable to import job ''L Drive Delete old Backup files'' since there is already a multi-server job with this name.', 16, 1) 
                GOTO QuitWithRollback  
        END 
        ELSE 
                -- Delete the [local] job 
                EXECUTE msdb.dbo.sp_delete_job @job_name = N'L Drive Delete old Backup files' 
        SET @JobID = NULL
END 

BEGIN 

  -- Add the job
  EXECUTE @ReturnCode = msdb.dbo.sp_add_job @job_id = @JobID OUTPUT , @job_name = N'L Drive Delete old Backup files', @owner_login_name = N'sa', @description = N'Delete old backup files that are more than 7 days old', @category_name = N'[Uncategorized (Local)]', @enabled = 1, @notify_level_email = 0, @notify_level_page = 0, @notify_level_netsend = 0, @notify_level_eventlog = 2, @delete_level= 0
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job steps
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobstep @job_id = @JobID, @step_id = 1, @step_name = N'delete old files', @command = N'Use Master

CREATE TABLE #BackupFiles 
(FullPathName NVARCHAR(256)) 


DECLARE @Command NVARCHAR(256) 


SET @Command = ''master.dbo.xp_cmdshell ''''DIR ''
   + ''"L:\Program Files\Microsoft SQL Server\MSSQL\Backup\'' + ''*.*" /B /S''''''

INSERT INTO #BackupFiles EXEC (@Command) 


DECLARE @DeleteFiles NVARCHAR(4000) 

DECLARE file_cursor CURSOR FAST_FORWARD FOR 

SELECT  '' exec xp_cmdshell ''''DEL "'' 
       + FullPathName + ''"'''''' +CHAR(13)+CHAR(10) 
FROM #BackupFiles 
WHERE (FullPathName LIKE ''%_%.%'') 
   -- Trims punctuation and space from date time string 
     
  AND RIGHT(FullPathName, 12) <
      CONVERT(VARCHAR(8),
      DATEADD(DAY, -6, GETDATE()), 112)


OPEN file_cursor 
FETCH NEXT FROM file_cursor INTO @DeleteFiles 


WHILE @@FETCH_STATUS = 0 
BEGIN 
   EXEC (@DeleteFiles) 
   FETCH NEXT FROM file_cursor INTO @DeleteFiles 
END 


CLOSE file_cursor 
DEALLOCATE file_cursor 

DROP TABLE #BackupFiles', @database_name = N'master', @server = N'', @database_user_name = N'', @subsystem = N'TSQL', @cmdexec_success_code = 0, @flags = 0, @retry_attempts = 0, @retry_interval = 1, @output_file_name = N'', @on_success_step_id = 0, @on_success_action = 1, @on_fail_step_id = 0, @on_fail_action = 2
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
  EXECUTE @ReturnCode = msdb.dbo.sp_update_job @job_id = @JobID, @start_step_id = 1 

  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job schedules
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id = @JobID, @name = N'L Drive Delete old Backup files', @enabled = 1, @freq_type = 4, @active_start_date = 20081201, @active_start_time = 25000, @freq_interval = 1, @freq_subday_type = 1, @freq_subday_interval = 0, @freq_relative_interval = 0, @freq_recurrence_factor = 0, @active_end_date = 99991231, @active_end_time = 235959
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the Target Servers
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @JobID, @server_name = N'(local)' 
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

END
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 

GO

-- Script generated on 8/15/2011 1:29 PM
-- By: VHAMASTER\VHAISHSmithM
-- Server: VHAISHFPC7\V1605

BEGIN TRANSACTION            
  DECLARE @JobID BINARY(16)  
  DECLARE @ReturnCode INT    
  SELECT @ReturnCode = 0     
IF (SELECT COUNT(*) FROM msdb.dbo.syscategories WHERE name = N'[Uncategorized (Local)]') < 1 
  EXECUTE msdb.dbo.sp_add_category @name = N'[Uncategorized (Local)]'

  -- Delete the job with the same name (if it exists)
  SELECT @JobID = job_id     
  FROM   msdb.dbo.sysjobs    
  WHERE (name = N'VBECS_V1_PROD_ExpireTestOrders')       
  IF (@JobID IS NOT NULL)    
  BEGIN  
  -- Check if the job is a multi-server job  
  IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
  BEGIN 
    -- There is, so abort the script 
    RAISERROR (N'Unable to import job ''VBECS_V1_PROD_ExpireTestOrders'' since there is already a multi-server job with this name.', 16, 1) 
    GOTO QuitWithRollback  
  END 
  ELSE 
    -- Delete the [local] job 
    EXECUTE msdb.dbo.sp_delete_job @job_name = N'VBECS_V1_PROD_ExpireTestOrders' 
    SELECT @JobID = NULL
  END 

BEGIN 

  -- Add the job
  EXECUTE @ReturnCode = msdb.dbo.sp_add_job @job_id = @JobID OUTPUT , @job_name = N'VBECS_V1_PROD_ExpireTestOrders', @owner_login_name = N'sa', @description = N'
Background job used to expire TAS orders, it is part of Expire Orders background job
', @category_name = N'[Uncategorized (Local)]', @enabled = 1, @notify_level_email = 0, @notify_level_page = 0, @notify_level_netsend = 0, @notify_level_eventlog = 2, @delete_level= 0
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job steps
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobstep @job_id = @JobID, @step_id = 1, @step_name = N'Run VBECS_V1_PROD_ExpireTestOrders', @command = N'EXECUTE VBECS_V1_PROD.dbo.batchspRunExpireTestOrders
', @database_name = N'VBECS_V1_PROD', @server = N'', @database_user_name = N'', @subsystem = N'TSQL', @cmdexec_success_code = 0, @flags = 0, @retry_attempts = 0, @retry_interval = 1, @output_file_name = N'', @on_success_step_id = 0, @on_success_action = 1, @on_fail_step_id = 0, @on_fail_action = 2
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
  EXECUTE @ReturnCode = msdb.dbo.sp_update_job @job_id = @JobID, @start_step_id = 1 

  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job schedules
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id = @JobID, @name = N'VBECS_V1_PROD_ExpireTestOrders Schedule', @enabled = 1, @freq_type = 4, @active_start_date = 20110728, @active_start_time = 10000, @freq_interval = 1, @freq_subday_type = 1, @freq_subday_interval = 0, @freq_relative_interval = 0, @freq_recurrence_factor = 0, @active_end_date = 99991231, @active_end_time = 235959
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the Target Servers
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @JobID, @server_name = N'(local)' 
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

END
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 


/*****************************************************************************************
* VBECS Patch	(Build 1.6.0.7 02 - from 1.6.0.6 to 1.6.0.7)
*****************************************************************************************/


USE VBECS_V1_PROD
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnGetInappropriateNonSurgicalRequests]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnGetInappropriateNonSurgicalRequests]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/*****************************************************************************************************************
**
**  Desc:	Gets inappropriate non-surgical transfusion requests in a division within a specified datetime range. 
**
**  Author:	Stas Antropov
**
**  Date: 	02/27/2005
**
******************************************************************************************************************
**  	Modified:
**  	Date		Name		Description
**  	---------		----------		-----------------------------------------------------
**  	07/07/2005  	S. Antropov 	** Reviewed for compliance with database standards and recommendations **
**                         			 reformatted SQL, updated the comment header, added dbo prefix to table names
**
**	04/22/2006	Lohse		Adding TimZone Conversion for OrderPlacedDateTime
**	06/15/2012	K. Dobranowski	Removed filtering of orders based on OrderStatus. Now expired and cancelled orders will be included (CR 3231)
**	06/22/2012	Lohse		** Reviewed for compliance with database standards and recommendations **
******************************************************************************************************************/
CREATE FUNCTION dbo.fnGetInappropriateNonSurgicalRequests
(
    @startdate DATETIME,
    @enddate DATETIME,
    @divisioncode CHAR(5)
)
RETURNS TABLE AS  

RETURN

SELECT					
            dbo.TreatingSpecialty.TreatingSpecialtyName 		AS TreatingSpecialtyName, -- nullable
            dbo.PatientOrder.OrderingProviderLastName + ', ' + dbo.PatientOrder.OrderingProviderFirstName AS RequestingProvider, -- nullable
            dbo.Patient.PatientLastName + ', ' + dbo.Patient.PatientFirstName + ISNULL( ', ' + dbo.Patient.PatientMiddleName, '' ) 	AS PatientFullName,
            dbo.Patient.DisplayVistAPatientId, -- nullable
            dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, dbo.OrderedComponent.RequiredDateTime ) 			AS RequiredDateTime, -- nullable
            dbo.ComponentClass.ComponentClassShortName,
            dbo.OrderedComponent.RequiredUnitQuantity,
            dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, dbo.PatientSpecimen.SpecimenCollectionDate ) 		AS SpecimenCollectionDate, -- nullable
            dbo.SpecimenTestThreshold.VistaLaboratoryTestName,
            dbo.PatientTest.TestResult,
            dbo.VbecsUser.VbecsUserId 			AS AcceptedByLoginName, -- nullable
            dbo.VbecsUser.UserName 			AS AcceptedByUserName,  -- nullable
            dbo.ComponentClass.SortColumn 			AS ComponentClassSortColumn,
            dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, dbo.PatientOrder.OrderPlacedDateTime)	        		AS PatientOrderPlacedDateTime
FROM		
            dbo.OrderedComponent
INNER JOIN
            dbo.PatientOrder ON dbo.PatientOrder.PatientOrderGuid = dbo.OrderedComponent.PatientOrderGuid
INNER JOIN	
            dbo.PatientTreatment ON dbo.PatientOrder.PatientTreatmentGuid = dbo.PatientTreatment.PatientTreatmentGuid
INNER JOIN	
            dbo.Patient ON dbo.Patient.PatientGuid = dbo.PatientTreatment.PatientGuid
INNER JOIN	
            dbo.ComponentClass ON dbo.ComponentClass.ComponentClassId = dbo.OrderedComponent.ComponentClassId
LEFT OUTER JOIN
            dbo.TreatingSpecialty ON dbo.TreatingSpecialty.TreatingSpecialtyCode = dbo.PatientTreatment.TreatingSpecialtyCode
LEFT OUTER JOIN		
            dbo.PatientSpecimen ON dbo.PatientSpecimen.PatientSpecimenGuid = dbo.OrderedComponent.PatientSpecimenGuid
LEFT OUTER JOIN
           dbo.PatientTest ON dbo.PatientTest.PatientOrderGuid = dbo.OrderedComponent.PatientOrderGuid 
       AND dbo.PatientTest.DivisionCode = dbo.OrderedComponent.DivisionCode
       AND dbo.PatientTest.RecordStatusCode <> 'X'
LEFT OUTER JOIN 
           dbo.SpecimenTestThreshold ON dbo.SpecimenTestThreshold.LabTestId = dbo.PatientTest.LabTestId 
       AND dbo.SpecimenTestThreshold.ComponentClassId = dbo.OrderedComponent.ComponentClassId
       AND dbo.SpecimenTestThreshold.DivisionCode = dbo.OrderedComponent.DivisionCode
       AND dbo.SpecimenTestThreshold.RecordStatusCode = 'A'
       AND dbo.SpecimenTestThreshold.ReportTypeId = 9 		
LEFT OUTER JOIN 
           VBECS_V1_PROD_MIRROR..V_OrderedComponent OCMirror ON OCMirror.OrderedComponentGuid = dbo.OrderedComponent.OrderedComponentGuid
       AND OCMirror.OrderStatusCode = 'A'
       AND OCMirror.MirrorId = 
           ( SELECT  MIN( OCMirror.MirrorId )
             FROM    VBECS_V1_PROD_MIRROR..V_OrderedComponent OCMirror 
             WHERE   OCMirror.OrderedComponentGuid = OrderedComponent.OrderedComponentGuid
                 AND OCMirror.OrderStatusCode = 'A'
                 AND OCMirror.MirrorDate = ( SELECT MIN( OCMirror.MirrorDate )
                                             FROM   VBECS_V1_PROD_MIRROR..V_OrderedComponent OCMirror 
                                             WHERE  OCMirror.OrderedComponentGuid = dbo.OrderedComponent.OrderedComponentGuid 
                                                AND OCMirror.OrderStatusCode = 'A' ) ) 
LEFT OUTER JOIN
          dbo.VbecsUser ON dbo.VbecsUser.VbecsUserId = OCMirror.LastUpdateUser 	
WHERE     dbo.OrderedComponent.InappropriateRequestIndicator = 1
      AND dbo.OrderedComponent.DivisionCode = @divisionCode
      AND dbo.PatientOrder.OrderPlacedDateTime BETWEEN dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @startdate) AND dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @enddate)
      AND dbo.OrderedComponent.PreopIndicator = 0 
      AND EXISTS ( SELECT TOP 1 1
                   FROM	  VBECS_V1_PROD_MIRROR..V_OrderedComponent OCMirror 
                   WHERE  OCMirror.OrderedComponentGuid = OrderedComponent.OrderedComponentGuid 
                      AND OCMirror.OrderStatusCode = 'A' )



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnGetInappropriateSurgicalRequests]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnGetInappropriateSurgicalRequests]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/*****************************************************************************************************************
**
**	Desc:	Gets inappropriate surgicaltransfusion requests in a division within a specified datetime range. 
**
**	Author:	Stas Antropov
**
**	Date: 	02/27/2005
**
******************************************************************************************************************
**	Modified:
**	Date		Name		Description
** 	---------		----------		-----------------------------------------------------
**  	07/07/2005  	S. Antropov 	** Reviewed for compliance with database standards and recommendations **
**                          			reformatted SQL, updated the comment header, added dbo prefix to table names
**	04/22/2006	Lohse		Adding TimeZoneConversion to OrderPlacedDateTime
**	06/15/2012	K. Dobranowski	Removed filtering of orders based on OrderStatus. Now expired and cancelled orders will be included (CR 3231)
**	06/22/2012	Lohse		** Reviewed for compliance with database standards and recommendations **
******************************************************************************************************************/
CREATE FUNCTION dbo.fnGetInappropriateSurgicalRequests
(
	@startdate DATETIME,
	@enddate DATETIME,
	@divisioncode CHAR(5)
)
RETURNS TABLE AS  

RETURN

SELECT					
            dbo.TreatingSpecialty.TreatingSpecialtyName, -- nullable
            dbo.PatientOrder.OrderingProviderLastName + ', ' + dbo.PatientOrder.OrderingProviderFirstName 			AS RequestingProvider, -- nullable
            dbo.MsBos.SurgeryName, -- nullable
            dbo.Patient.PatientLastName + ', ' + dbo.Patient.PatientFirstName + ISNULL( ', ' + dbo.Patient.PatientMiddleName, '' ) 	AS PatientFullName,
            dbo.Patient.DisplayVistAPatientId, -- nullable
            dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, dbo.OrderedComponent.RequiredDateTime) 			AS RequiredDateTime, -- nullable
            dbo.ComponentClass.ComponentClassShortName,			
            dbo.OrderedComponent.RequiredUnitQuantity,
            dbo.VbecsUser.VbecsUserId 		AS AcceptedByLoginName, -- nullable
            dbo.VbecsUser.UserName 		AS AcceptedByUserName,  -- nullable
            dbo.ComponentClass.SortColumn 		AS ComponentClassSortColumn,
            dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, dbo.PatientOrder.OrderPlacedDateTime)  			AS PatientOrderPlacedDateTime
FROM		
            dbo.OrderedComponent
INNER JOIN	
            dbo.PatientOrder ON dbo.PatientOrder.PatientOrderGuid = dbo.OrderedComponent.PatientOrderGuid
INNER JOIN	
            dbo.PatientTreatment ON dbo.PatientOrder.PatientTreatmentGuid = dbo.PatientTreatment.PatientTreatmentGuid
INNER JOIN	
            dbo.Patient ON dbo.Patient.PatientGuid = dbo.PatientTreatment.PatientGuid
INNER JOIN	
            dbo.ComponentClass ON dbo.ComponentClass.ComponentClassId = dbo.OrderedComponent.ComponentClassId
LEFT OUTER JOIN
            dbo.TreatingSpecialty ON dbo.TreatingSpecialty.TreatingSpecialtyCode = dbo.PatientTreatment.TreatingSpecialtyCode
LEFT OUTER JOIN
            dbo.Msbos ON dbo.Msbos.SurgeryName = dbo.PatientOrder.SurgeryName 
        AND dbo.Msbos.DivisionCode = dbo.OrderedComponent.DivisionCode 
        AND dbo.Msbos.RecordStatusCode = 'A'
LEFT OUTER JOIN 
            VBECS_V1_PROD_MIRROR..V_OrderedComponent OCMirror ON OCMirror.OrderedComponentGuid = OrderedComponent.OrderedComponentGuid AND
            OCMirror.OrderStatusCode = 'A' AND 
            OCMirror.MirrorId = 
              ( SELECT  MIN( OCMirror.MirrorId )
                FROM    VBECS_V1_PROD_MIRROR..V_OrderedComponent OCMirror 
                WHERE   OCMirror.OrderedComponentGuid = dbo.OrderedComponent.OrderedComponentGuid
                    AND OCMirror.OrderStatusCode = 'A' 
                    AND OCMirror.MirrorDate =  
                      ( SELECT  MIN( OCMirror.MirrorDate )
                        FROM    VBECS_V1_PROD_MIRROR..V_OrderedComponent OCMirror 
                        WHERE   OCMirror.OrderedComponentGuid = dbo.OrderedComponent.OrderedComponentGuid 
                            AND OCMirror.OrderStatusCode = 'A' ) ) 
LEFT OUTER JOIN
            VbecsUser ON VbecsUser.VbecsUserId = OCMirror.LastUpdateUser 	
WHERE		
            dbo.OrderedComponent.InappropriateRequestIndicator = 1
        AND dbo.OrderedComponent.DivisionCode = @divisionCode
        AND dbo.PatientOrder.OrderPlacedDateTime BETWEEN dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @startdate) AND dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @enddate) 
        AND dbo.OrderedComponent.PreopIndicator = 1
        AND EXISTS 
              ( SELECT  TOP 1 1
                FROM    VBECS_V1_PROD_MIRROR..V_OrderedComponent OCMirror 
                WHERE   OCMirror.OrderedComponentGuid = dbo.OrderedComponent.OrderedComponentGuid 
                    AND OCMirror.OrderStatusCode = 'A' )



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetRecentComponentOrdersForPatient]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetRecentComponentOrdersForPatient]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

/*******************************************************************************************************************************************************************************
**	Desc: 	Returns pending or active component order details (including assigned units) for display (multi-divisional)
**
**	Author: Cameron Taylor
**
**	Date: 	06/10/2004
**
*******************************************************************************************************************************************************************************
**	Modified:
**	Date				Name			Description
**	-------------------	-----------------------	------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**	06/17/2005	Npaterson	Changed to use new view to increase performance
**	07/07/2005	NPaterson	** Reviewed for compliance with database standards and recommendations **
**					Removed name, input/output from comment header, Added NOCOUNT, Specified table owners, spaced out SQL
**	09/09/2005	D. Askew	Removed fnWherePatientGuid via sub-query using new PatientMergeGroup
**	01/11/2006	C. Taylor	Added DonationTypeCode & UnitDivisionId (DR 1729)
**	01/23/2006	M Smith		** Reviewed for compliance with database standards and recommendations **
**	06/15/2012	K. Dobranowski	Modified WHERE clause to include expired orders and component orders (CR 3231)
**	06/22/2012	Lohse		** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetRecentComponentOrdersForPatient
(
	@patientguid		UNIQUEIDENTIFIER,
	@divisioncode		CHAR(5),
	@timespan		INT = 14
)

AS

SET NOCOUNT ON

	SELECT DISTINCT

		OC.OrderedComponentGuid,
		OC.PatientOrderGuid,

		dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PO.OrderReceivedDatetime) AS OrderReceivedDatetime,

		OC.ComponentClassId,
		CC.ComponentClassShortName,
		CC.ComponentClassName,
		OC.RequiredUnitQuantity,

		dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, OC.RequiredDateTime) 	AS RequiredDateTime,

		OC.CprsOrderNumber,
		OC.OrderSpecialInstructions,
		OC.OrderStatusCode,
		OS.OrderStatusText,

		ISNULL(OC.TaskStatusCode,'N') 							AS TaskStatusCode,

		TS.TaskStatusText,
		OC.OrderedComponentComments,
		OC.DivisionCode,
		VD.DivisionName,
		PS.PatientSpecimenGuid,
		PS.SpecimenUid
		
	FROM
		dbo.OrderedComponent OC

		JOIN
			dbo.ComponentClass CC ON OC.ComponentClassId = CC.ComponentClassId

		LEFT JOIN
			dbo.PatientSpecimen PS ON OC.PatientSpecimenGuid = PS.PatientSpecimenGuid

		JOIN
			dbo.PatientOrder PO ON OC.PatientOrderGuid = PO.PatientOrderGuid
		JOIN
			dbo.PatientTreatment PT ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid
		JOIN
			dbo.OrderStatus OS ON OS.OrderStatusCode = OC.OrderStatusCode
		JOIN
			dbo.VamcDivision VD ON VD.DivisionCode = OC.DivisionCode
		JOIN
			dbo.TaskStatus TS ON TS.TaskStatusCode = ISNULL(OC.TaskStatusCode,'N')

		LEFT JOIN
			dbo.OrderedUnit OU ON OU.OrderedComponentGuid = OC.OrderedComponentGuid

	WHERE

		PT.PatientGuid IN
		(
			SELECT 
				P.PatientGuid
			FROM
				dbo.Patient P
			JOIN 
			    	dbo.Patient LinkPatient ON  P.PatientMergeGroup = LinkPatient.PatientMergeGroup OR P.PatientGuid = LinkPatient.PatientGuid
			WHERE
				LinkPatient.PatientGuid = @patientguid
		)

		AND

		(
			OC.OrderStatusCode IN ('A','P','V')  OR
			(OC.OrderStatusCode = 'X' AND OC.TaskStatusCode = 'E') OR
			(OU.SelectedDate > (GETUTCDATE() - DAY(@timespan))) OR (OU.CrossmatchDate > (GETUTCDATE() - DAY(@timespan)))
		)

	SELECT 

		OU.OrderedUnitGuid,

		dbo.fnTimeZoneConversionDateTime(@divisioncode, 0,  OU.CrossmatchDate) AS CrossmatchDate,

		OU.CrossmatchResultCode,
		OC.OrderedComponentGuid,
		VW.BloodUnitGUID,
		VW.EyeReadableUnitID,
		VW.UnitProductCode,
		VW.BloodProductGuid,
		VW.ProductShortName,
		VW.BloodTypeCode,
		VW.RhFactorCode, 

		dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, VW.UnitExpirationDate) AS UnitExpirationDate,

		VW.DonationTypeId,
		VW.DonationTypeText,
		VW.UnitStatusCode,
		VW.QuarantineIndicator,
		VW.BiohazardousWarningIndicator,
		VW.DivisionCode,
		VW.LabelTypeCode,
		IU.IssueToLocationName,
		VW.DonationTypeCode,
		VW.UnitDivisionId

	FROM 

		dbo.OrderedUnit OU
	    
		JOIN 
			dbo.OrderedComponent OC ON OC.OrderedComponentGUID = OU.OrderedComponentGUID
		JOIN 
			dbo.vw_BloodShipAllCurrent VW ON OU.BloodUnitGUID = VW.BloodUnitGUID
	
		LEFT JOIN
			dbo.IssuedUnit IU ON IU.BloodUnitGuid = VW.BloodUnitGuid AND IU.ReturnDateTime IS NULL
	
		JOIN
			dbo.PatientOrder PO ON OC.PatientOrderGuid = PO.PatientOrderGuid
		JOIN
			dbo.PatientTreatment PT ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid

	WHERE 

		PT.PatientGuid IN
		(
			SELECT 
				P.PatientGuid
			FROM
				dbo.Patient P
			JOIN 
			    	dbo.Patient LinkPatient ON  P.PatientMergeGroup = LinkPatient.PatientMergeGroup OR P.PatientGuid = LinkPatient.PatientGuid
			WHERE
				LinkPatient.PatientGuid = @patientguid
		)

		AND 
	
			OU.RecordStatusCode = 'A'
	
		AND
		
			VW.UnitStatusCode IN ('C','I','S','T')
	
		AND 
			OU.ReleaseDate IS NULL


SET NOCOUNT OFF

RETURN
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetRecentComponentOrdersForPatientCount]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetRecentComponentOrdersForPatientCount]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/*******************************************************************************************************************************************************************************
**	Desc: 	Returns count of pending or active component order details (including assigned units) for display (multi-divisional)
**
**		Note: 	if changes are made to this stored procedure, please also update FromPatientPendingOrdersCount in 
**			spGetPendingPatientMerges
**
**	Author: Cameron Taylor
**
**	Date: 	09/09/2005
**
*******************************************************************************************************************************************************************************
**	Modified:
**	Date				Name			Description
**	-------------------	-----------------------	------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**	09/09/2005	D. Askew	Removed fnWherePatientGuid via sub-query using new PatientMergeGroup
**	02/14/2006 	D. Askew	Added note to description
**	04/05/2006	Lohse		Changed Count(*) to comply with database standards
**	06/15/2012	K. Dobranowski	Modified WHERE clause to include expired orders and component orders (CR 3231)
**	06/22/2012	Lohse		** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetRecentComponentOrdersForPatientCount
(
	@patientguid		UNIQUEIDENTIFIER,
	@divisioncode		CHAR(5),
	@timespan		INT = 14
)

AS

SET NOCOUNT ON

	SELECT
		COUNT(1) AS Total
	FROM
		dbo.OrderedComponent OC

		JOIN
			dbo.PatientOrder PO ON OC.PatientOrderGuid = PO.PatientOrderGuid
		JOIN
			dbo.PatientTreatment PT ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid
		LEFT JOIN
			dbo.OrderedUnit OU ON OU.OrderedComponentGuid = OC.OrderedComponentGuid

	WHERE

		PT.PatientGuid IN
		(
			SELECT 
				P.PatientGuid
			FROM
				dbo.Patient P
			JOIN 
			    	dbo.Patient LinkPatient ON  P.PatientMergeGroup = LinkPatient.PatientMergeGroup OR P.PatientGuid = LinkPatient.PatientGuid
			WHERE
				LinkPatient.PatientGuid = @patientguid
		)

		AND

		(
			OC.OrderStatusCode IN ('A','P','V') OR
			(OC.OrderStatusCode = 'X' AND OC.TaskStatusCode = 'E') OR
			(OU.SelectedDate > (GETUTCDATE() - DAY(@timespan))) OR (OU.CrossmatchDate > (GETUTCDATE() - DAY(@timespan)))
		)

SET NOCOUNT OFF

RETURN
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetRecentTestOrdersForPatient]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetRecentTestOrdersForPatient]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


/*******************************************************************************************************************************************************************************
**
**	Desc: 	Returns pending or active test order details for display (multi-divisional)
**
**	Author: Cameron Taylor
**
**	Date: 	06/10/2004
**
*******************************************************************************************************************************************************************************
**	Modified:
**	Date		Name		Description
**	-----------	---------	-----------------
**	07/07/2005	NPaterson	** Reviewed for compliance with database standards and recommendations **
**							Removed name, input/output from comment header, Added NOCOUNT, Specified table owners, 
**							spaced out SQL
**	08/21/2005	S. Antropov	** Reviewed for compliance with database standards and recommendations **
**							Performed secondary review during the code promotion - merged changes
**	09/09/2005	D. Askew	Removed fnWherePatientGuid via sub-query using new PatientMergeGroup
**	01/11/2006	C. Taylor	Added UnitProductCode, DonationTypeCode and UnitDivisionId to XM and Repeat XM OrderableTestText (DR 1729)
**	01/23/2006	M Smith		** Reviewed for compliance with database standards and recommendations **
**	06/15/2012	K. Dobranowski Modfied all WHERE clauses to include component orders and expired orders (CR 3231)
**	06/22/2012	Lohse		** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/


CREATE PROCEDURE dbo.spGetRecentTestOrdersForPatient
(
	@patientguid		UNIQUEIDENTIFIER,
	@divisioncode		CHAR(5),
	@timespan			INT = 14
)

AS
SET NOCOUNT ON

SELECT DISTINCT
	OT.OrderedTestGuid,
	OT.PatientOrderGuid,
	dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PO.OrderReceivedDatetime) AS OrderReceivedDatetime,
	OT.OrderableTestId,
	ORT.OrderableTestText,
	dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, OT.RequiredResultsDate) AS RequiredResultsDate,
	OT.CprsOrderNumber,
	OT.OrderStatusCode,
	OS.OrderStatusText,
	ISNULL(OT.TaskStatusCode,'N') AS TaskStatusCode,
	TS.TaskStatusText,
	OT.OrderedTestComments,
	OT.DivisionCode,
	VD.DivisionName,
	PS.PatientSpecimenGuid,
	PS.SpecimenUid
	
FROM
	dbo.OrderedTest OT
JOIN
	dbo.OrderableTest ORT ON OT.OrderableTestId = ORT.OrderableTestId
LEFT JOIN
	dbo.PatientSpecimen PS ON OT.PatientSpecimenGuid = PS.PatientSpecimenGuid
JOIN
	dbo.PatientOrder PO ON OT.PatientOrderGuid = PO.PatientOrderGuid
JOIN
	dbo.PatientTreatment PT ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid
JOIN
	dbo.OrderStatus OS ON OS.OrderStatusCode = OT.OrderStatusCode
JOIN
	dbo.VamcDivision VD ON VD.DivisionCode = OT.DivisionCode
JOIN
	dbo.TaskStatus TS ON TS.TaskStatusCode = ISNULL(OT.TaskStatusCode,'N')
LEFT JOIN
	dbo.SpecimenTest ST ON ST.OrderedTestGuid = OT.OrderedTestGuid
LEFT JOIN
	dbo.BloodUnitTest BUT ON BUT.OrderedTestGuid = OT.OrderedTestGuid
WHERE
	PT.PatientGuid IN 
	(
		SELECT 
			P.PatientGuid
		FROM
			dbo.Patient P
		JOIN 
		    	dbo.Patient LinkPatient ON  P.PatientMergeGroup = LinkPatient.PatientMergeGroup OR P.PatientGuid = LinkPatient.PatientGuid
		WHERE
			LinkPatient.PatientGuid = @patientguid
	)
AND
	( (OT.OrderStatusCode IN ('A','P','V') AND OT.TaskStatusCode IN ('I','N','P','R') ) OR
	(OT.OrderStatusCode = 'X' AND OT.TaskStatusCode = 'E') OR
	(ST.TestDate > (GETUTCDATE() - DAY(@timespan))) OR (BUT.TestDate > (GETUTCDATE() - DAY(@timespan))))

UNION

SELECT DISTINCT
	OC.OrderedComponentGuid AS OrderedTestGuid,
	OC.PatientOrderGuid,
	dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, PO.OrderReceivedDatetime) AS OrderReceivedDatetime,
	ORT.OrderableTestId,
	ORT.OrderableTestText,
	dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, OC.RequiredDateTime) AS RequiredResultsDate,
	OC.CprsOrderNumber,
	OC.OrderStatusCode,
	OS.OrderStatusText,
	ISNULL(OC.TaskStatusCode,'N') AS TaskStatusCode,
	TS.TaskStatusText,
	OC.OrderedComponentComments as OrderedTestComments,
	OC.DivisionCode,
	VD.DivisionName,
	PS.PatientSpecimenGuid,
	PS.SpecimenUid
	
FROM
	dbo.OrderedComponent OC
LEFT JOIN
	dbo.PatientSpecimen PS ON OC.PatientSpecimenGuid = PS.PatientSpecimenGuid
JOIN
	dbo.PatientOrder PO ON OC.PatientOrderGuid = PO.PatientOrderGuid
JOIN
	dbo.PatientTreatment PT ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid
JOIN
	dbo.OrderStatus OS ON OS.OrderStatusCode = OC.OrderStatusCode
JOIN
	dbo.VamcDivision VD ON VD.DivisionCode = OC.DivisionCode
JOIN
	dbo.TaskStatus TS ON TS.TaskStatusCode = ISNULL(OC.TaskStatusCode,'N')
JOIN
	dbo.BloodUnitTest BUT ON BUT.OrderedComponentGuid = OC.OrderedComponentGuid
JOIN
	dbo.BloodTestType BTT ON BTT.BloodTestTypeID = BUT.BloodTestTypeID
JOIN
	dbo.OrderableTest ORT ON ORT.OrderableTestId = BTT.OrderableTestId
WHERE
	PT.PatientGuid IN 
	(
		SELECT 
			P.PatientGuid
		FROM
			dbo.Patient P
		JOIN 
		    	dbo.Patient LinkPatient ON  P.PatientMergeGroup = LinkPatient.PatientMergeGroup OR P.PatientGuid = LinkPatient.PatientGuid
		WHERE
			LinkPatient.PatientGuid = @patientguid
	)
AND
	ORT.OrderableTestId = '9'
AND
	(OC.OrderStatusCode IN ('A','P','V') OR
	(OC.OrderStatusCode = 'X' AND OC.TaskStatusCode = 'E') OR
	 (BUT.TestDate > (GETUTCDATE() - DAY(@timespan))))

-- Patient Testing from Specimen Test

SELECT DISTINCT
	OT.OrderedTestGUID,
	OT.PatientOrderGUID,
--Test Performed
	OT.OrderableTestID,
	BTT.ReportableTestID,
	dbo.fnGetPatientTestName(OT.OrderableTestID,BTT.ReportableTestID) AS OrderableTestText,
--Interp
	dbo.fnGetPatientTestInterp(OT.OrderedTestGUID,OT.OrderableTestID,BTT.ReportableTestID) AS Interp,
--Date Tested
	dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, ST.TestDate) AS TestDate,
--Comments
	dbo.fnGetPatientTestComments(OT.OrderedTestGUID,OT.OrderableTestID,BTT.ReportableTestID) AS TestComments
	
FROM	
	dbo.SpecimenTest ST

JOIN	
	dbo.OrderedTest OT ON OT.OrderedTestGUID = ST.OrderedTestGUID
JOIN	
	dbo.BloodTestType BTT ON BTT.BloodTestTypeID = ST.BloodTestTypeID
JOIN	
	dbo.TestResult TR ON TR.TestResultID = ST.TestResultID
JOIN
	dbo.PatientOrder PO ON OT.PatientOrderGuid = PO.PatientOrderGuid
JOIN
	dbo.PatientTreatment PT ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid
WHERE
	PT.PatientGuid IN 
	(
		SELECT 
			P.PatientGuid
		FROM
			dbo.Patient P
		JOIN 
		    	dbo.Patient LinkPatient ON  P.PatientMergeGroup = LinkPatient.PatientMergeGroup OR P.PatientGuid = LinkPatient.PatientGuid
		WHERE
			LinkPatient.PatientGuid = @patientguid
	)
AND
	(OT.OrderStatusCode IN ('A','P','V') OR
	(OT.OrderStatusCode = 'X' AND OT.TaskStatusCode = 'E') OR
	 (ST.TestDate > (GETUTCDATE() - DAY(@timespan))))
AND		
	ST.RecordStatusCode = 'A'

UNION

-- XM Testing from Blood Unit Test

SELECT DISTINCT
	OC.OrderedComponentGUID AS OrderedTestGuid,
	OC.PatientOrderGUID,
--Test Performed
	ORT.OrderableTestID,
	BTT.ReportableTestID,
	(CASE 
		BU.LabelTypeCode
		WHEN 'I' THEN
			ORT.OrderableTestText + '  (' + BU.EyeReadableUnitId + ', ' + BU.UnitProductCode + DT.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS + BU.UnitDivisionId + ')'
		ELSE 
			ORT.OrderableTestText + '  (' + BU.EyeReadableUnitId + ', ' + BU.UnitProductCode + ')'
		END
	) as OrderableTestText,
--Interp
	TR.TestResultText COLLATE SQL_Latin1_General_CP1_CS_AS as Interp,
--Date Tested
	dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, BUT.TestDate) AS TestDate,
--Comments
	BUT.TestComments
	
FROM	
	dbo.BloodUnitTest BUT

JOIN	
	dbo.BloodUnit BU ON BU.BloodUnitGuid = BUT.BloodUnitGuid
JOIN
	dbo.DonationType DT ON DT.DonationTypeId = BU.DonationTypeId
JOIN	
	dbo.OrderedComponent OC ON OC.OrderedComponentGUID = BUT.OrderedComponentGUID
JOIN	
	dbo.BloodTestType BTT ON BTT.BloodTestTypeID = BUT.BloodTestTypeID
JOIN	
	dbo.OrderableTest ORT ON ORT.OrderableTestId = BTT.OrderableTestId
JOIN	
	dbo.TestResult TR ON TR.TestResultID = BUT.TestResultID
JOIN
	dbo.PatientOrder PO ON OC.PatientOrderGuid = PO.PatientOrderGuid
JOIN
	dbo.PatientTreatment PT ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid
WHERE
	PT.PatientGuid IN
	(
		SELECT 
			P.PatientGuid
		FROM
			dbo.Patient P
		JOIN 
		    	dbo.Patient LinkPatient ON  P.PatientMergeGroup = LinkPatient.PatientMergeGroup OR P.PatientGuid = LinkPatient.PatientGuid
		WHERE
			LinkPatient.PatientGuid = @patientguid
	)
AND
	(OC.OrderStatusCode IN ('A','P','V') OR
	(OC.OrderStatusCode = 'X' AND OC.TaskStatusCode = 'E') OR
	 (BUT.TestDate > (GETUTCDATE() - DAY(@timespan))))
AND
	BTT.BloodTestName LIKE '%Interp'
AND
	ORT.OrderableTestId = 9
AND		
	BUT.RecordStatusCode = 'A'
	
UNION

-- Repeat XM Testing from Blood Unit Test

SELECT DISTINCT
	OT.OrderedTestGUID,
	OT.PatientOrderGUID,
--Test Performed
	OT.OrderableTestID,
	BTT.ReportableTestID,
	(CASE 
		BU.LabelTypeCode
		WHEN 'I' THEN
			ORT.OrderableTestText + '  (' + BU.EyeReadableUnitId + ', ' + BU.UnitProductCode + DT.DonationTypeCode COLLATE SQL_Latin1_General_CP1_CS_AS + BU.UnitDivisionId + ')'
		ELSE 
			ORT.OrderableTestText + '  (' + BU.EyeReadableUnitId + ', ' + BU.UnitProductCode + ')'
		END
	) as OrderableTestText,
--Interp
	TR.TestResultText COLLATE SQL_Latin1_General_CP1_CS_AS as Interp,
--Date Tested
	dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, BUT.TestDate) AS TestDate,
--Comments
	BUT.TestComments
	
FROM	
	dbo.BloodUnitTest BUT

JOIN	
	dbo.BloodUnit BU ON BU.BloodUnitGuid = BUT.BloodUnitGuid
JOIN
	dbo.DonationType DT ON DT.DonationTypeId = BU.DonationTypeId
JOIN	
	dbo.OrderedTest OT ON OT.OrderedTestGUID = BUT.OrderedTestGUID
JOIN	
	dbo.BloodTestType BTT ON BTT.BloodTestTypeID = BUT.BloodTestTypeID
JOIN	
	dbo.OrderableTest ORT ON ORT.OrderableTestId = OT.OrderableTestId
JOIN	
	dbo.TestResult TR ON TR.TestResultID = BUT.TestResultID
JOIN	
	dbo.PatientOrder PO ON OT.PatientOrderGuid = PO.PatientOrderGuid
JOIN
	dbo.PatientTreatment PT ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid
WHERE
	PT.PatientGuid IN
	(
		SELECT 
			P.PatientGuid
		FROM
			dbo.Patient P
		JOIN 
		    	dbo.Patient LinkPatient ON  P.PatientMergeGroup = LinkPatient.PatientMergeGroup OR P.PatientGuid = LinkPatient.PatientGuid
		WHERE
			LinkPatient.PatientGuid = @patientguid
	)
AND
	(OT.OrderStatusCode IN ('A','P','V') OR 
	(OT.OrderStatusCode = 'X' AND OT.TaskStatusCode = 'E') OR
	(BUT.TestDate > (GETUTCDATE() - DAY(@timespan))))
AND
	BTT.BloodTestName LIKE '%Interp'
AND
	OT.OrderableTestId = 119
AND		
	BUT.RecordStatusCode = 'A'

UNION

-- Antibody IDs from Specimen Test
SELECT DISTINCT
	OT.OrderedTestGUID,
	OT.PatientOrderGUID,
--Test Performed
	OT.OrderableTestID,
	BTT.ReportableTestID,
	dbo.fnGetPatientTestName(OT.OrderableTestID,BTT.ReportableTestID) as OrderableTestText,
--Interp
	ANTI.AntibodyTypeName as Interp,
--Date Tested
	dbo.fnTimeZoneConversionDateTime(@divisioncode, 0, ST.TestDate) AS TestDate,
--Comments
	ST.TestComments
	
FROM	
	dbo.SpecimenTest ST

JOIN	
	dbo.OrderedTest OT ON OT.OrderedTestGUID = ST.OrderedTestGUID
JOIN	
	dbo.BloodTestType BTT ON BTT.BloodTestTypeID = ST.BloodTestTypeID
JOIN	
	dbo.AntibodyType ANTI ON ANTI.AntibodyTypeID = ST.AntibodyTypeID
JOIN
	dbo.PatientOrder PO ON OT.PatientOrderGuid = PO.PatientOrderGuid
JOIN
	dbo.PatientTreatment PT ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid
WHERE
	PT.PatientGuid IN 
	(
		SELECT 
			P.PatientGuid
		FROM
			dbo.Patient P
		JOIN 
		    	dbo.Patient LinkPatient ON  P.PatientMergeGroup = LinkPatient.PatientMergeGroup OR P.PatientGuid = LinkPatient.PatientGuid
		WHERE
			LinkPatient.PatientGuid = @patientguid
	)
AND
	(OT.OrderStatusCode IN ('A','P','V') OR 
	(OT.OrderStatusCode = 'X' AND OT.TaskStatusCode = 'E') OR
	(ST.TestDate > (GETUTCDATE() - DAY(@timespan))))
AND		
	ST.RecordStatusCode = 'A'

SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spGetRecentTestOrdersForPatientCount]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spGetRecentTestOrdersForPatientCount]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/*******************************************************************************************************************************************************************************
**
**	Desc: 	Returns count of pending or active test order details for patient (multi-divisional)
**
**		Note: 	if changes are made to this stored procedure, please also update FromPatientPendingOrdersCount in 
**			spGetPendingPatientMerges
**
**	Author: Cameron Taylor
**
**	Date: 	09/09/2005
**
*******************************************************************************************************************************************************************************
**	Modified:
**	Date		Name		Description
**	-----------		---------		-----------------
**	09/09/2005	D. Askew	Removed fnWherePatientGuid via sub-query using new PatientMergeGroup
**	02/14/2006	D. Askew	Added note to description
**	04/05/2006	Lohse		Changed Count(*) to comply with database standards
**	06/15/2012	K. Dobranowski	Modified WHERE clauses to include expired orders and component orders (CR 3231)
**	06/22/2012	Lohse		** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE PROCEDURE dbo.spGetRecentTestOrdersForPatientCount
(
	@patientguid		UNIQUEIDENTIFIER,
	@divisioncode		CHAR(5),
	@timespan		INT = 14
)

AS

SET NOCOUNT ON

-- Ordered Tests
SELECT 	
		COUNT(1) AS Total
FROM
	dbo.OrderedTest OT
JOIN
	dbo.OrderableTest ORT ON OT.OrderableTestId = ORT.OrderableTestId
JOIN
	dbo.PatientOrder PO ON OT.PatientOrderGuid = PO.PatientOrderGuid
JOIN
	dbo.PatientTreatment PT ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid
LEFT JOIN
	dbo.SpecimenTest ST ON ST.OrderedTestGuid = OT.OrderedTestGuid
LEFT JOIN
	dbo.BloodUnitTest BUT ON BUT.OrderedTestGuid = OT.OrderedTestGuid
WHERE
	PT.PatientGuid IN 
	(
		SELECT 
			P.PatientGuid
		FROM
			dbo.Patient P
		JOIN 
		    	dbo.Patient LinkPatient ON  P.PatientMergeGroup = LinkPatient.PatientMergeGroup OR P.PatientGuid = LinkPatient.PatientGuid
		WHERE
			LinkPatient.PatientGuid = @patientguid
	)
AND
	( (OT.OrderStatusCode IN ('A','P','V') AND OT.TaskStatusCode IN ('I','N','P','R') ) OR
	(OT.OrderStatusCode = 'X' AND OT.TaskStatusCode = 'E') OR
	 (ST.TestDate > (GETUTCDATE() - DAY(@timespan))) OR (BUT.TestDate > (GETUTCDATE() - DAY(@timespan))))

-- Ordered Components (XMs)
SELECT	
		COUNT(1) AS Total
FROM
	dbo.OrderedComponent OC
JOIN
	dbo.PatientOrder PO ON OC.PatientOrderGuid = PO.PatientOrderGuid
JOIN
	dbo.PatientTreatment PT ON PT.PatientTreatmentGuid = PO.PatientTreatmentGuid
JOIN
	dbo.BloodUnitTest BUT ON BUT.OrderedComponentGuid = OC.OrderedComponentGuid
JOIN
	dbo.BloodTestType BTT ON BTT.BloodTestTypeID = BUT.BloodTestTypeID
WHERE
	PT.PatientGuid IN 
	(
		SELECT 
			P.PatientGuid
		FROM
			dbo.Patient P
		JOIN 
		    	dbo.Patient LinkPatient ON  P.PatientMergeGroup = LinkPatient.PatientMergeGroup OR P.PatientGuid = LinkPatient.PatientGuid
		WHERE
			LinkPatient.PatientGuid = @patientguid
	)
AND
	BTT.OrderableTestId = '9'
AND
	(OC.OrderStatusCode IN ('A','P','V') OR 
	(OC.OrderStatusCode = 'X' AND OC.TaskStatusCode = 'E') OR
	(BUT.TestDate > (GETUTCDATE() - DAY(@timespan))))

SET NOCOUNT OFF 

RETURN
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spHL7GetPendingTransmissionMessages]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spHL7GetPendingTransmissionMessages]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO




/*******************************************************************************************************************************************************************************
**        Desc:         Gets HL7 Messages with a PendingTransmission state and sets the 
**                MessageStatus to Awaiting Response.
**
**        Author: Brian Tomlin        
**
**        Date:         3/04/2004
**
*******************************************************************************************************************************************************************************
**        Modified:
**        Date          Name                Description
**        -----------   -------------       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**        6/29/05        N. Paterson      ** Reviewed for compliance with database standards and recommendations **
**                                        Comment Header Adjusted,  Added NOCOUNT, Specified table owners
**        3/17/11	D. Askew          Removed commented-out code; added TansmitCount (CR 2962)
**         3/20/11     	D. Askew          Added code to NOT return messages which have been re-sent ReTransmitAttempts + 1 (CR 2967)
**        04/18/11	K. Adu-Poku       ** Reviewed for compliance with database standards and recommendations **
**        06/19/12	C. Van Stedum     Changed the where clause of the first update statement so that it could grab the first row with a status of 1 and has not exceeded its retry attempts CR 3233
**	  06/26/12	K. Adu-Poku	  ** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE    PROCEDURE dbo.spHL7GetPendingTransmissionMessages

AS 

SET NOCOUNT ON

DECLARE @pendingMessageLogId      INT
DECLARE @messageStream                   VARCHAR(3500)
DECLARE @interfaceControlId   INT
DECLARE @messageControlId   VARCHAR(20)
DECLARE @transmitCount                      TINYINT

        UPDATE 
                        dbo.MessageLog 
        SET
                        @pendingMessageLogId = MessageLogId,
                        @interfaceControlId = InterfaceControlId,
                        @messageControlId = MessageControlId,
                        @messageStream = MessageStream,
                        @transmitCount = TransmitCount,
                        MessageStatusCode =  8,
                        LastUpdateDate = GETUTCDATE(),
                        LastUpdateUser = RIGHT(current_user, LEN(current_user) - CHARINDEX('\', current_user))
        WHERE
                        MessageLogId = (
                                            SELECT TOP 1 MessageLogId
                                            FROM dbo.MessageLog ML
                                                            JOIN dbo.InterfaceControl IC ON ML.InterfaceControlId = IC.InterfaceControlId
                                            WHERE 
                                                            MessageStatusCode = 1
                                                AND   ISNULL(TransmitCount, 0) <= IC.ReTransmitAttempts
                                                )

            --If there's a message to process, send back the fields 
            IF @pendingMessageLogId IS NOT NULL
                    BEGIN
                            SELECT    @interfaceControlId AS InterfaceControlId, 
                                                @messageControlId AS MessageControlId,
                                                @messageStream AS MessageStream,
                                                ISNULL(@transmitCount, 0) AS TransmitCount
                    END


SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spHL7PurgeMessageLog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spHL7PurgeMessageLog]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


/*******************************************************************************************************************************************************************************
**	Desc: 	Purges HL7 messages from the MessageLog table based on criteria defined in VBECS Administrator (CR 2519)
**
**	Author:	David Askew
**
**	Date: 	11/22/08
*******************************************************************************************************************************************************************************
**	Modified:
**	Date		Name			Description
**	-------------------	-----------------------	------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**	7/28/11	D. Askew	Changed MessageStatusCode IN (2, 6) to MessageStatusCode IN (1, 2, 6, 7, 8) to handle purging
**					failed messages too. (CR 3059)
**	6/26/12	Lohse		Removed 2nd WHERE clause so that only processed messages are purged (MessageStatusCode = 3) CR 3233
**	6/26/12	K. Adu-Poku	** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.spHL7PurgeMessageLog

AS

SET NOCOUNT ON

	DECLARE @RowCount INT
	
	DECLARE @Now DATETIME
	
	SET @RowCount = 0
	
	SET @Now = GETUTCDATE()
	
	DELETE ML
	
	FROM
		dbo.MessageLog ML
		
		JOIN dbo.InterfaceControl IC ON ML.InterfaceControlId = IC.InterfaceControlId
	
	WHERE 
	
		( MessageStatusCode = 3 AND ML.LastUpdateDate <= DATEADD(DAY, -PurgeSuccessfulMessage, @Now ) )
	

	SET @RowCount = @@ROWCOUNT


SET NOCOUNT OFF

RETURN (@RowCount)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spRestoreRestriction]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spRestoreRestriction]
GO

SET QUOTED_IDENTIFIER OFF 
GO

/*******************************************************************************************************************************************************************************
**	Desc: 	Restore a patient restriction  in BloodUnitMedia, CR 3180, This is to implement BR_11.21 and BR_13.03
**
**	Author: Carrie Van Stedum
**
**	Date: 	10/10/201
**
*******************************************************************************************************************************************************************************
**	Modified:
**	Date		Name			Description
**	--------------------	-----------------------	------------------------------------------------------------------------------------------------------------------------------------------------------------------------
**	12/28/2011	K. Adu-Poku	** Reviewed for compliance with database standards and recommendations **	
**	06/21/2012       C.Van Stedum   ""Allowed for a blank restriction if it is full service. Changed @directedpatientguid to allow NULL (CR 3242)
**	06/26/2012	K. Adu-Poku	** Reviewed for compliance with database standards and recommendations **
*******************************************************************************************************************************************************************************/
CREATE  PROCEDURE dbo.spRestoreRestriction
(
	@bloodunitmediaguid                           UNIQUEIDENTIFIER,
	@directedpatientguid		        UNIQUEIDENTIFIER = NULL,	
	@removerestrictiontechid                     VARCHAR(30),
	@removerestrictiondate	                     DATETIME = NULL,
	@comments                                          VARCHAR(30),
	@lastupdateuser	                     VARCHAR(30),
	@lastupdatefunctionid	                     INT,
	@rowversion		                     TIMESTAMP,
	@divisioncode	 	                     CHAR(5),
	@lastupdatedate	                     DATETIME
)

AS

SET NOCOUNT ON

DECLARE 	@ERROR		INT,
		@ROWCOUNT		INT
	        
	UPDATE dbo.BloodUnitMedia
	
	SET	DirectedPatientGuid		= @directedpatientguid,
		RemoveRestrictionDate		= dbo.fnTimeZoneConversionDateTime(@divisioncode, 1, @removerestrictiondate),
		RemoveRestrictionTechId	= @removerestrictiontechid,
		Comments	                           = @comments,
		LastUpdateUser			= @LastUpdateUser,
		LastUpdateDate			= @lastupdatedate,
		LastUpdateFunctionId		= @LastUpdateFunctionId

	WHERE BloodUnitMediaGUID	= @bloodunitmediaguid

	AND	[RowVersion]		= @RowVersion
	
	SELECT @ERROR = @@ERROR, @ROWCOUNT = @@ROWCOUNT

	IF @ERROR = 0 AND @ROWCOUNT <> 1 AND ( SELECT COUNT(1) FROM dbo.BloodUnitMedia WHERE [RowVersion] = @rowversion ) <> 1 
		RAISERROR(50001, 16, 127)
	ELSE
		IF (@ERROR = 0 AND @ROWCOUNT <> 1)	
			SET @ERROR = -1

SET NOCOUNT OFF

RETURN(@ERROR)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/*****************************************************************************************
*         Deleted Stored Procedure
*****************************************************************************************/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spHL7GetMessagesReadyForPurge]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spHL7GetMessagesReadyForPurge]
GO


/*****************************************************************************************
*        Grant permissions on functions
*****************************************************************************************/
GRANT SELECT ON dbo.fnGetInappropriateNonSurgicalRequests TO VbecsAppUser
GRANT SELECT ON dbo.fnGetInappropriateSurgicalRequests TO VbecsAppUser

/*****************************************************************************************
*        Grant permissions on stored procedures
*****************************************************************************************/
GRANT EXECUTE ON dbo.spGetRecentComponentOrdersForPatientCount TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetRecentComponentOrdersForPatient TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetRecentTestOrdersForPatientCount TO VbecsAppUser
GRANT EXECUTE ON dbo.spGetRecentTestOrdersForPatient TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7GetPendingTransmissionMessages TO VbecsAppUser
GRANT EXECUTE ON dbo.spHL7PurgeMessageLog TO VbecsAppUser
GRANT EXECUTE ON dbo.spRestoreRestriction TO VbecsAppUser


-- Update 5 rows in [dbo].[ProductAttribute]
UPDATE [dbo].[ProductAttribute] SET [ModificationAllowedIndicator]=1, [LastUpdateDate]='20120613 00:00:00.000', [LastUpdateUser]=N'VHAISHLOHSEG' WHERE [ProductAttributeId]=N'@22'
UPDATE [dbo].[ProductAttribute] SET [ModificationAllowedIndicator]=1, [LastUpdateDate]='20120613 00:00:00.000', [LastUpdateUser]=N'VHAISHLOHSEG' WHERE [ProductAttributeId]=N'@23'
UPDATE [dbo].[ProductAttribute] SET [ModificationAllowedIndicator]=1, [LastUpdateDate]='20120613 00:00:00.000', [LastUpdateUser]=N'VHAISHLOHSEG' WHERE [ProductAttributeId]=N'@A0'
UPDATE [dbo].[ProductAttribute] SET [ModificationAllowedIndicator]=1, [LastUpdateDate]='20120613 00:00:00.000', [LastUpdateUser]=N'VHAISHLOHSEG' WHERE [ProductAttributeId]=N'@B0'
UPDATE [dbo].[ProductAttribute] SET [ModificationAllowedIndicator]=1, [LastUpdateDate]='20120613 00:00:00.000', [LastUpdateUser]=N'VHAISHLOHSEG' WHERE [ProductAttributeId]=N'@BC'



/*******************************************************************************************************
CR 3245 (Removed Split from the PermittedProductModification table for the following
 Product Codes: E022, E023, E031, E036, E043, E055, E056, E058, E061, E062 and E063)to match TT_26.02(A)
*********************************************************************************************************/

-- Delete 22 rows from [dbo].[PermittedProductModification]
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'075d440a-deba-4c23-bbd1-6f5c97733121'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'0cf28f08-f654-49c1-bfb9-f46e1e04f8db'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'0f958b37-99bf-45f0-a70b-ffe1b28b8a8a'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'1a42ee6c-ab82-427c-83b6-7aa2c2cfb036'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'1cb51293-8c52-43c2-9499-8a7622d3f462'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'28f9c92c-1ca2-4e7b-b093-c80e508387c8'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'299f4aa2-f8b0-4a44-a950-b39cefd3413e'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'2c3a29fc-8baf-4620-bfc1-6c1ba4ff1f00'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'3f7497b7-b49b-45f7-ae3e-597d70c1bf08'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'48a40349-4d2e-46f9-9078-14360c5936f4'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'4b6ce92f-52b2-4a4c-8151-a93763acd90b'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'51c7d76c-447e-490d-9659-a60db62462c1'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'54da5514-c9d1-45e4-bfa1-f749506699e0'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'64518fa5-1dbe-40c2-8a10-fd3b20c633a3'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'897d7208-2b32-40bf-9379-50f0fa68e9c2'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'98d01083-0174-4b57-ba94-e443bf6d4e21'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'b6e3787d-088a-4e45-89e6-5d639b97b981'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'ba5303ab-6a1b-4a19-b612-6aaeaeb2f79d'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'c08b4e52-deed-4b59-aeb0-3a8e287a63a8'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'd372b50f-2649-40db-8685-930141a96957'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'd83fc61e-7f40-4bc1-8434-f9996a367f94'
DELETE FROM [dbo].[PermittedProductModification] WHERE [PermittedProductModificationGuid]=N'd8d81464-33ea-43b6-8314-eb3b429c70d2'


USE VBECS_V1_PROD
GO

/*****************************************************
**	Update VbecsVersion
*****************************************************/
DECLARE @SUser	VARCHAR(45)

SET @SUser = (SELECT SUSER_SNAME())

INSERT INTO dbo.VbecsVersion
(Version, PatchSuccessfulIndicator, LastUpdateDate, LastUpdateUser)
VALUES('1.6.0.7', 0, GETUTCDATE(), RIGHT(@SUser, LEN(@SUser) - CHARINDEX('\', @SUser)))

